--
-- PostgreSQL database dump
--

-- Dumped from database version 9.4.4
-- Dumped by pg_dump version 9.4.4
-- Started on 2015-12-01 08:47:02 CET

SET statement_timeout = 0;
SET lock_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

--
-- TOC entry 6 (class 2615 OID 22723)
-- Name: objets; Type: SCHEMA; Schema: -; Owner: -
--

CREATE SCHEMA objets;


SET search_path = objets, pg_catalog;

--
-- TOC entry 206 (class 1255 OID 22726)
-- Name: update_created_column(); Type: FUNCTION; Schema: objets; Owner: -
--

CREATE FUNCTION update_created_column() RETURNS trigger
    LANGUAGE plpgsql
    AS $$

BEGIN

	   NEW.date_creation = now(); 

	   RETURN NEW;

	END;

$$;


--
-- TOC entry 219 (class 1255 OID 22727)
-- Name: update_updated_column(); Type: FUNCTION; Schema: objets; Owner: -
--

CREATE FUNCTION update_updated_column() RETURNS trigger
    LANGUAGE plpgsql
    AS $$

BEGIN

	   NEW.date_modification = now(); 

	   RETURN NEW;

	END;

$$;


SET default_tablespace = '';

SET default_with_oids = false;

--
-- TOC entry 177 (class 1259 OID 22729)
-- Name: association_objets; Type: TABLE; Schema: objets; Owner: -; Tablespace: 
--

CREATE TABLE association_objets (
    pk_association_objets integer NOT NULL,
    fk_objet_source integer,
    fk_objet_cible integer,
    fk_type_association_param integer,
    reference_precise_objet_source text,
    url_objet_source text,
    descriptif text,
    notes text,
    date_creation timestamp with time zone,
    date_modification timestamp with time zone,
    fk_qualificatif_objet_source integer,
    fk_role_objet_source integer,
    libelle_original_objet_source text,
    valeur_objet_source double precision,
    fk_unite_de_mesure integer
);


--
-- TOC entry 178 (class 1259 OID 22735)
-- Name: associer_objets_pk_associer_objets_seq; Type: SEQUENCE; Schema: objets; Owner: -
--

CREATE SEQUENCE associer_objets_pk_associer_objets_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 2406 (class 0 OID 0)
-- Dependencies: 178
-- Name: associer_objets_pk_associer_objets_seq; Type: SEQUENCE OWNED BY; Schema: objets; Owner: -
--

ALTER SEQUENCE associer_objets_pk_associer_objets_seq OWNED BY association_objets.pk_association_objets;


--
-- TOC entry 188 (class 1259 OID 22815)
-- Name: date_objet; Type: TABLE; Schema: objets; Owner: -; Tablespace: 
--

CREATE TABLE date_objet (
    pk_date_objet integer NOT NULL,
    date_iso character varying(59),
    fk_type_date_param integer,
    libelle_original_date text,
    notes text,
    descriptif text,
    fk_objet integer,
    date_creation timestamp with time zone,
    date_modification timestamp with time zone,
    certitude character(1)
);


--
-- TOC entry 187 (class 1259 OID 22813)
-- Name: date_objet_pk_date_objet_seq; Type: SEQUENCE; Schema: objets; Owner: -
--

CREATE SEQUENCE date_objet_pk_date_objet_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 2407 (class 0 OID 0)
-- Dependencies: 187
-- Name: date_objet_pk_date_objet_seq; Type: SEQUENCE OWNED BY; Schema: objets; Owner: -
--

ALTER SEQUENCE date_objet_pk_date_objet_seq OWNED BY date_objet.pk_date_objet;


--
-- TOC entry 179 (class 1259 OID 22737)
-- Name: nom_objet; Type: TABLE; Schema: objets; Owner: -; Tablespace: 
--

CREATE TABLE nom_objet (
    pk_nom_objet integer NOT NULL,
    nom text DEFAULT 'Nom'::text,
    langue character varying(255),
    notes text,
    fk_objet integer,
    est_standard boolean DEFAULT true,
    date_creation timestamp with time zone,
    date_modification timestamp with time zone,
    fk_type_nom_param integer,
    date_debut character varying(10),
    date_fin character varying(10)
);


--
-- TOC entry 180 (class 1259 OID 22744)
-- Name: nom_objet_cle_nom_objet_seq; Type: SEQUENCE; Schema: objets; Owner: -
--

CREATE SEQUENCE nom_objet_cle_nom_objet_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 2408 (class 0 OID 0)
-- Dependencies: 180
-- Name: nom_objet_cle_nom_objet_seq; Type: SEQUENCE OWNED BY; Schema: objets; Owner: -
--

ALTER SEQUENCE nom_objet_cle_nom_objet_seq OWNED BY nom_objet.pk_nom_objet;


--
-- TOC entry 181 (class 1259 OID 22746)
-- Name: objet; Type: TABLE; Schema: objets; Owner: -; Tablespace: 
--

CREATE TABLE objet (
    pk_objet integer NOT NULL,
    definition text,
    notes text,
    date_creation timestamp with time zone,
    date_modification timestamp with time zone,
    cle_importation integer,
    cle_importation_txt text,
    longitude double precision,
    latitude double precision,
    texte_xml xml,
    fk_type_objet_param integer NOT NULL,
    genre character(1),
    texte text,
    langue_texte character varying(255)
);


--
-- TOC entry 2409 (class 0 OID 0)
-- Dependencies: 181
-- Name: COLUMN objet.longitude; Type: COMMENT; Schema: objets; Owner: -
--

COMMENT ON COLUMN objet.longitude IS 'ALTER TABLE objets.objet

   ALTER COLUMN longitude TYPE double precision;

';


--
-- TOC entry 2410 (class 0 OID 0)
-- Dependencies: 181
-- Name: COLUMN objet.latitude; Type: COMMENT; Schema: objets; Owner: -
--

COMMENT ON COLUMN objet.latitude IS 'ALTER TABLE objets.objet

   ALTER COLUMN latitude TYPE double precision;

';


--
-- TOC entry 182 (class 1259 OID 22752)
-- Name: objet_cle_objet_seq; Type: SEQUENCE; Schema: objets; Owner: -
--

CREATE SEQUENCE objet_cle_objet_seq
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


--
-- TOC entry 2411 (class 0 OID 0)
-- Dependencies: 182
-- Name: objet_cle_objet_seq; Type: SEQUENCE OWNED BY; Schema: objets; Owner: -
--

ALTER SEQUENCE objet_cle_objet_seq OWNED BY objet.pk_objet;


--
-- TOC entry 2244 (class 2604 OID 22778)
-- Name: pk_association_objets; Type: DEFAULT; Schema: objets; Owner: -
--

ALTER TABLE ONLY association_objets ALTER COLUMN pk_association_objets SET DEFAULT nextval('associer_objets_pk_associer_objets_seq'::regclass);


--
-- TOC entry 2249 (class 2604 OID 22818)
-- Name: pk_date_objet; Type: DEFAULT; Schema: objets; Owner: -
--

ALTER TABLE ONLY date_objet ALTER COLUMN pk_date_objet SET DEFAULT nextval('date_objet_pk_date_objet_seq'::regclass);


--
-- TOC entry 2246 (class 2604 OID 22779)
-- Name: pk_nom_objet; Type: DEFAULT; Schema: objets; Owner: -
--

ALTER TABLE ONLY nom_objet ALTER COLUMN pk_nom_objet SET DEFAULT nextval('nom_objet_cle_nom_objet_seq'::regclass);


--
-- TOC entry 2248 (class 2604 OID 22780)
-- Name: pk_objet; Type: DEFAULT; Schema: objets; Owner: -
--

ALTER TABLE ONLY objet ALTER COLUMN pk_objet SET DEFAULT nextval('objet_cle_objet_seq'::regclass);


--
-- TOC entry 2394 (class 0 OID 22729)
-- Dependencies: 177
-- Data for Name: association_objets; Type: TABLE DATA; Schema: objets; Owner: -
--

INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (1, 3, 2, 17, NULL, NULL, NULL, NULL, '2015-10-04 12:11:31.143556+02', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (3, 16, 15, 21, NULL, NULL, NULL, NULL, '2015-10-05 07:35:37.300968+02', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (4, 13, 3, 35, NULL, NULL, NULL, NULL, '2015-10-05 08:04:00.486892+02', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (5, 2, 13, 34, NULL, NULL, NULL, NULL, '2015-10-05 08:53:49.238243+02', '2015-10-05 08:59:57.794138+02', NULL, 23, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (6, 21, 13, 34, NULL, NULL, NULL, NULL, '2015-10-05 08:57:49.49488+02', '2015-10-05 09:14:00.426949+02', NULL, 22, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (2, 5, 2, 17, NULL, NULL, NULL, NULL, '2015-10-04 14:44:10.664694+02', '2015-10-12 07:50:52.426352+02', NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (7, 32, 2, 17, 'p.35-45', NULL, NULL, NULL, '2015-10-13 15:38:54.27321+02', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (9, 35, 34, 18, NULL, NULL, NULL, NULL, '2015-10-13 17:52:05.874491+02', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (8, 33, 32, 18, NULL, NULL, 'aélsdkfjasdlék fjasélkdfja', NULL, '2015-10-13 15:44:28.866347+02', '2015-10-13 21:12:14.79035+02', NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (11, 1101, 2, 17, NULL, NULL, NULL, NULL, '2015-11-09 14:32:02.822392+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (12, 22, 11, 39, NULL, NULL, 'Associe le lieu qui localise la naissance', NULL, '2015-11-09 21:06:59.518424+01', '2015-11-09 21:07:49.296544+01', NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (10, 23, 11, 39, NULL, NULL, 'Associe la personne qui naît', NULL, '2015-11-03 11:18:36.870722+01', '2015-11-09 21:08:30.341712+01', NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (13, 1624, 1621, 39, NULL, NULL, 'Associe l''enseignant.', NULL, '2015-11-09 22:59:04.670766+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (15, 1622, 1621, 39, NULL, NULL, 'La matière enseignée (un objet abstrait). On peut en associer plusieurs si on enseigne en même temps plusieurs matières. En revanche, il faut créer plusieurs informations si les enseignements des différentes matières se succèdent ou si le contexte institutionnel est différent ', NULL, '2015-11-09 23:06:24.947314+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (14, 1623, 1621, 39, NULL, NULL, 'Qualification de l''enseignement : professeur, chargé de cours, etc. Ce rôle a été gardé pour être l''équivalent du TyIn7 : Exercice d''une fonction. ', NULL, '2015-11-09 23:05:15.693556+01', '2015-11-09 23:07:20.743396+01', NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (16, 10, 1621, 39, NULL, NULL, 'Institution auprès de laquelle s''exerce l''enseignement.', NULL, '2015-11-09 23:09:54.125574+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (17, 1627, 1626, 39, NULL, NULL, 'Associe un objet abstrait qui indique de quel type de caractéristique il s''agit (expertise, intérêt, etc.) ', NULL, '2015-11-10 08:48:56.833631+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (18, 10, 1626, 39, NULL, NULL, 'Associe l''objet qui est caractérisé, auquel on associe les caractéristiques', NULL, '2015-11-10 08:49:58.516422+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (19, 1628, 1626, 39, NULL, NULL, 'Associe une caractéristique de l''objet. Ajouter un rôle par caractéristique', NULL, '2015-11-10 09:01:21.010316+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (20, 959, 7, 17, NULL, NULL, NULL, NULL, '2015-11-11 11:39:40.26718+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (21, 1618, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (22, 1617, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (23, 1616, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (24, 1615, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (25, 1614, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (26, 1613, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (27, 1612, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (28, 1611, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (29, 1610, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (30, 1609, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (31, 1608, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (32, 1607, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (33, 1606, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (34, 1605, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (35, 1604, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (36, 1603, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (37, 1602, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (38, 1601, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (39, 1600, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (40, 1599, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (41, 1598, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (42, 1597, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (43, 1596, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (44, 1595, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (45, 1594, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (46, 1593, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (47, 1592, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (48, 1591, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (49, 1590, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (50, 1589, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (51, 1588, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (52, 1587, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (53, 1586, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (54, 1585, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (55, 1584, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (56, 1583, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (57, 1582, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (58, 1581, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (59, 1580, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (60, 1579, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (61, 1578, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (62, 1577, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (63, 1576, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (64, 1575, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (65, 1574, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (66, 1573, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (67, 1572, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (68, 1571, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (69, 1570, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (70, 1569, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (71, 1568, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (72, 1567, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (73, 1566, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (74, 1565, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (75, 1564, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (76, 1563, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (77, 1562, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (78, 1561, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (79, 1560, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (80, 1559, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (81, 1558, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (82, 1557, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (83, 1556, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (84, 1555, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (85, 1554, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (86, 1553, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (87, 1552, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (88, 1551, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (89, 1550, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (90, 1549, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (91, 1548, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (92, 1547, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (93, 1546, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (94, 1545, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (95, 1544, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (96, 1543, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (97, 1542, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (98, 1541, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (99, 1540, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (100, 1539, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (101, 1538, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (102, 1537, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (103, 1536, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (104, 1535, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (105, 1534, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (106, 1533, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (107, 1532, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (108, 1531, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (109, 1530, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (110, 1529, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (111, 1528, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (112, 1527, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (113, 1526, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (114, 1525, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (115, 1524, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (116, 1523, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (117, 1522, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (118, 1521, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (119, 1520, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (120, 1519, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (121, 1518, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (122, 1517, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (123, 1516, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (124, 1515, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (125, 1514, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (126, 1513, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (127, 1512, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (128, 1511, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (129, 1510, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (130, 1509, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (131, 1508, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (132, 1507, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (133, 1506, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (134, 1505, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (135, 1504, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (136, 1503, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (137, 1502, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (138, 1501, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (139, 1500, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (140, 1499, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (141, 1498, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (142, 1497, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (143, 1496, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (144, 1495, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (145, 1494, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (146, 1493, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (147, 1492, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (148, 1491, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (149, 1490, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (150, 1489, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (151, 1488, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (152, 1487, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (153, 1486, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (154, 1485, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (155, 1484, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (156, 1483, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (157, 1482, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (158, 1481, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (159, 1480, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (160, 1479, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (161, 1478, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (162, 1477, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (163, 1476, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (164, 1475, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (165, 1474, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (166, 1473, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (167, 1472, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (168, 1471, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (169, 1470, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (170, 1469, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (171, 1468, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (172, 1467, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (173, 1466, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (174, 1465, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (175, 1464, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (176, 1463, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (177, 1462, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (178, 1461, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (179, 1460, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (180, 1459, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (181, 1458, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (182, 1457, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (183, 1456, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (184, 1455, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (185, 1454, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (186, 1453, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (187, 1452, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (188, 1451, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (189, 1450, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (190, 1449, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (191, 1448, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (192, 1447, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (193, 1446, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (194, 1445, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (195, 1444, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (196, 1443, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (197, 1442, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (198, 1441, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (199, 1440, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (200, 1439, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (201, 1438, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (202, 1437, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (203, 1436, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (204, 1435, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (205, 1434, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (206, 1433, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (207, 1432, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (208, 1431, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (209, 1430, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (210, 1429, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (211, 1428, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (212, 1427, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (213, 1426, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (214, 1425, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (215, 1424, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (216, 1423, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (217, 1422, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (218, 1421, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (219, 1420, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (220, 1419, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (221, 1418, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (222, 1417, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (223, 1416, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (224, 1415, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (225, 1414, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (226, 1413, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (227, 1412, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (228, 1411, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (229, 1410, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (230, 1409, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (231, 1408, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (232, 1407, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (233, 1406, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (234, 1405, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (235, 1404, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (236, 1403, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (237, 1402, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (238, 1401, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (239, 1400, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (240, 1399, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (241, 1398, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (242, 1397, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (243, 1396, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (244, 1395, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (245, 1394, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (246, 1393, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (247, 1392, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (248, 1391, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (249, 1390, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (250, 1389, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (251, 1388, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (252, 1387, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (253, 1386, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (254, 1385, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (255, 1384, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (256, 1383, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (257, 1382, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (258, 1381, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (259, 1380, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (260, 1379, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (261, 1378, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (262, 1377, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (263, 1376, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (264, 1375, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (265, 1374, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (266, 1373, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (267, 1372, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (268, 1371, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (269, 1370, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (270, 1369, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (271, 1368, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (272, 1367, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (273, 1366, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (274, 1365, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (275, 1364, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (276, 1363, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (277, 1362, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (278, 1361, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (279, 1360, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (280, 1359, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (281, 1358, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (282, 1357, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (283, 1356, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (284, 1355, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (285, 1354, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (286, 1353, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (287, 1352, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (288, 1351, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (289, 1350, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (290, 1349, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (291, 1348, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (292, 1347, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (293, 1346, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (294, 1345, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (295, 1344, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (296, 1343, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (297, 1342, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (298, 1341, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (299, 1340, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (300, 1339, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (301, 1338, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (302, 1337, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (303, 1336, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (304, 1335, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (305, 1334, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (306, 1333, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (307, 1332, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (308, 1331, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (309, 1330, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (310, 1329, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (311, 1328, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (312, 1327, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (313, 1326, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (314, 1325, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (315, 1324, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (316, 1323, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (317, 1322, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (318, 1321, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (319, 1320, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (320, 1319, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (321, 1318, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (322, 1317, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (323, 1316, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (324, 1315, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (325, 1314, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (326, 1313, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (327, 1312, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (328, 1311, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (329, 1310, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (330, 1309, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (331, 1308, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (332, 1307, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (333, 1306, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (334, 1305, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (335, 1304, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (336, 1303, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (337, 1302, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (338, 1301, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (339, 1300, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (340, 1299, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (341, 1298, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (342, 1297, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (343, 1296, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (344, 1295, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (345, 1294, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (346, 1293, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (347, 1292, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (348, 1291, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (349, 1290, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (350, 1289, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (351, 1288, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (352, 1287, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (353, 1286, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (354, 1285, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (355, 1284, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (356, 1283, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (357, 1282, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (358, 1281, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (359, 1280, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (360, 1279, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (361, 1278, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (362, 1277, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (363, 1276, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (364, 1275, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (365, 1274, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (366, 1273, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (367, 1272, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (368, 1271, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (369, 1270, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (370, 1269, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (371, 1268, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (372, 1267, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (373, 1266, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (374, 1265, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (375, 1264, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (376, 1263, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (377, 1262, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (378, 1261, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (379, 1260, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (380, 1259, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (381, 1258, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (382, 1257, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (383, 1256, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (384, 1255, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (385, 1254, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (386, 1253, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (387, 1252, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (388, 1251, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (389, 1250, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (390, 1249, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (391, 1248, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (392, 1247, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (393, 1246, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (394, 1245, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (395, 1244, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (396, 1243, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (397, 1242, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (398, 1241, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (399, 1240, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (400, 1239, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (401, 1238, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (402, 1237, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (403, 1236, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (404, 1235, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (405, 1234, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (406, 1233, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (407, 1232, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (408, 1231, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (409, 1230, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (410, 1229, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (411, 1228, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (412, 1227, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (413, 1226, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (414, 1225, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (415, 1224, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (416, 1223, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (417, 1222, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (418, 1221, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (419, 1220, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (420, 1219, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (421, 1218, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (422, 1217, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (423, 1216, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (424, 1215, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (425, 1214, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (426, 1213, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (427, 1212, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (428, 1211, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (429, 1210, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (430, 1209, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (431, 1208, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (432, 1207, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (433, 1206, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (434, 1205, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (435, 1204, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (436, 1203, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (437, 1202, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (438, 1201, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (439, 1200, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (440, 1199, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (441, 1198, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (442, 1197, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (443, 1196, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (444, 1195, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (445, 1194, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (446, 1193, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (447, 1192, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (448, 1191, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (449, 1190, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (450, 1189, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (451, 1188, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (452, 1187, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (453, 1186, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (454, 1185, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (455, 1184, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (456, 1183, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (457, 1182, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (458, 1181, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (459, 1180, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (460, 1179, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (461, 1178, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (462, 1177, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (463, 1176, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (464, 1175, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (465, 1174, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (466, 1173, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (467, 1172, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (468, 1171, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (469, 1170, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (470, 1169, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (471, 1168, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (472, 1167, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (473, 1166, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (474, 1165, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (475, 1164, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (476, 1163, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (477, 1162, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (478, 1161, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (479, 1160, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (480, 1159, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (481, 1158, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (482, 1157, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (483, 1156, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (484, 1155, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (485, 1154, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (486, 1153, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (487, 1152, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (488, 1151, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (489, 1150, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (490, 1149, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (491, 1148, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (492, 1147, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (493, 1146, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (494, 1145, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (495, 1144, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (496, 1143, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (497, 1142, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (498, 1141, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (499, 1140, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (500, 1139, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (501, 1138, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (502, 1137, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (503, 1136, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (504, 1135, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (505, 1134, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (506, 1133, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (507, 1132, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (508, 1131, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (509, 1130, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (510, 1129, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (511, 1128, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (512, 1127, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (513, 1126, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (514, 1125, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (515, 1124, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (516, 1123, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (517, 1122, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (518, 1121, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (519, 1120, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (520, 1119, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (521, 1118, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (522, 1117, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (523, 1116, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (524, 1115, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (525, 1114, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (526, 1113, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (527, 1112, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (528, 1111, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (529, 1110, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (530, 1109, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (531, 1108, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (532, 1107, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (533, 1106, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (534, 1105, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (535, 1104, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (536, 1103, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (537, 1102, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (538, 1101, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (539, 1100, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (540, 1099, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (541, 1098, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (542, 1097, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (543, 1096, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (544, 1095, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (545, 1094, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (546, 1093, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (547, 1092, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (548, 1091, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (549, 1090, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (550, 1089, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (551, 1088, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (552, 1087, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (553, 1086, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (554, 1085, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (555, 1084, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (556, 1083, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (557, 1082, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (558, 1081, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (559, 1080, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (560, 1079, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (561, 1078, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (562, 1077, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (563, 1076, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (564, 1075, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (565, 1074, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (566, 1073, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (567, 1072, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (568, 1071, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (569, 1070, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (570, 1069, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (571, 1068, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (572, 1067, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (573, 1066, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (574, 1065, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (575, 1064, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (576, 1063, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (577, 1062, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (578, 1061, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (579, 1060, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (580, 1059, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (581, 1058, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (582, 1057, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (583, 1056, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (584, 1055, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (585, 1054, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (586, 1053, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (587, 1052, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (588, 1051, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (589, 1050, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (590, 1049, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (591, 1048, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (592, 1047, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (593, 1046, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (594, 1045, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (595, 1044, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (596, 1043, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (597, 1042, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (598, 1041, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (599, 1040, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (600, 1039, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (601, 1038, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (602, 1037, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (603, 1036, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (604, 1035, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (605, 1034, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (606, 1033, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (607, 1032, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (608, 1031, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (609, 1030, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (610, 1029, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (611, 1028, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (612, 1027, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (613, 1026, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (614, 1025, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (615, 1024, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (616, 1023, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (617, 1022, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (618, 1021, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (619, 1020, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (620, 1019, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (621, 1018, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (622, 1017, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (623, 1016, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (624, 1015, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (625, 1014, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (626, 1013, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (627, 1012, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (628, 1011, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (629, 1010, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (630, 1009, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (631, 1008, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (632, 1007, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (633, 1006, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (634, 1005, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (635, 1004, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (636, 1003, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (637, 1002, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (638, 1001, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (639, 1000, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (640, 999, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (641, 998, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (642, 997, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (643, 996, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (644, 995, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (645, 994, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (646, 993, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (647, 992, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (648, 991, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (649, 990, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (650, 989, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (651, 988, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (652, 987, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (653, 986, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (654, 985, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (655, 984, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (656, 983, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (657, 982, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (658, 981, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (659, 980, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (660, 979, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (661, 978, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (662, 977, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (663, 976, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (664, 975, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (665, 974, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (666, 973, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (667, 972, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (668, 971, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (669, 970, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (670, 969, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (671, 968, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (672, 967, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (673, 966, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (674, 965, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (675, 964, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (676, 963, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (677, 962, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (678, 961, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (679, 960, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (680, 959, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (681, 958, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (682, 957, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (683, 956, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (684, 955, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (685, 954, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (686, 953, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (687, 952, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (688, 951, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (689, 950, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (690, 949, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (691, 948, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (692, 947, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (693, 946, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (694, 945, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (695, 944, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (696, 943, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (697, 942, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (698, 941, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (699, 940, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (700, 939, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (701, 938, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (702, 937, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (703, 936, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (704, 935, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (705, 934, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (706, 933, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (707, 932, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (708, 931, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (709, 930, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (710, 929, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (711, 928, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (712, 927, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (713, 926, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (714, 925, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (715, 924, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (716, 923, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (717, 922, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (718, 921, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (719, 920, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (720, 919, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (721, 918, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (722, 917, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (723, 916, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (724, 915, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (725, 914, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (726, 913, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (727, 912, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (728, 911, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (729, 910, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (730, 909, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (731, 908, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (732, 907, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (733, 906, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (734, 905, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (735, 904, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (736, 903, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (737, 902, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (738, 901, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (739, 900, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (740, 899, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (741, 898, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (742, 897, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (743, 896, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (744, 895, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (745, 894, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (746, 893, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (747, 892, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (748, 891, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (749, 890, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (750, 889, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (751, 888, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (752, 887, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (753, 886, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (754, 885, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (755, 884, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (756, 883, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (757, 882, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (758, 881, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (759, 880, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (760, 879, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (761, 878, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (762, 877, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (763, 876, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (764, 875, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (765, 874, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (766, 873, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (767, 872, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (768, 871, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (769, 870, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (770, 869, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (771, 868, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (772, 867, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (773, 866, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (774, 865, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (775, 864, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (776, 863, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (777, 862, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (778, 861, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (779, 860, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (780, 859, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (781, 858, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (782, 857, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (783, 856, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (784, 855, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (785, 854, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (786, 853, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (787, 852, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (788, 851, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (789, 850, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (790, 849, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (791, 848, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (792, 847, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (793, 846, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (794, 845, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (795, 844, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (796, 843, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (797, 842, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (798, 841, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (799, 840, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (800, 839, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (801, 838, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (802, 837, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (803, 836, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (804, 835, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (805, 834, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (806, 833, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (807, 832, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (808, 831, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (809, 830, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO association_objets (pk_association_objets, fk_objet_source, fk_objet_cible, fk_type_association_param, reference_precise_objet_source, url_objet_source, descriptif, notes, date_creation, date_modification, fk_qualificatif_objet_source, fk_role_objet_source, libelle_original_objet_source, valeur_objet_source, fk_unite_de_mesure) VALUES (810, 829, 37, 19, NULL, NULL, NULL, NULL, '2015-11-11 23:13:37.694065+01', NULL, NULL, NULL, NULL, NULL, NULL);


--
-- TOC entry 2412 (class 0 OID 0)
-- Dependencies: 178
-- Name: associer_objets_pk_associer_objets_seq; Type: SEQUENCE SET; Schema: objets; Owner: -
--

SELECT pg_catalog.setval('associer_objets_pk_associer_objets_seq', 810, true);


--
-- TOC entry 2401 (class 0 OID 22815)
-- Dependencies: 188
-- Data for Name: date_objet; Type: TABLE DATA; Schema: objets; Owner: -
--

INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (2, '1630', 27, NULL, NULL, NULL, 2, '2015-10-02 14:17:45.118701+02', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (4, '1642', 27, NULL, NULL, NULL, 7, '2015-10-02 22:28:35.936273+02', NULL, NULL);
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (7, '20151027', 25, NULL, NULL, NULL, 3, '2015-10-04 12:16:24.653578+02', '2015-11-10 15:29:26.376954+01', NULL);
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (8, '1637', 27, NULL, NULL, NULL, 17, '2015-10-04 21:15:16.650704+02', NULL, NULL);
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (1, '1571', 25, NULL, NULL, NULL, 2, '2015-10-01 20:17:45+02', '2015-10-04 22:52:57.837407+02', NULL);
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (3, '1564', 25, NULL, NULL, NULL, 7, '2015-10-02 22:28:04.59748+02', '2015-10-04 23:06:33.201954+02', NULL);
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (9, '1571', 25, NULL, NULL, NULL, 13, '2015-10-05 08:44:24.207099+02', NULL, NULL);
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (6, '1580', 25, NULL, NULL, NULL, 17, '2015-10-03 10:56:25.356309+02', '2015-10-05 13:51:05.754774+02', NULL);
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (10, '1473', 25, NULL, NULL, NULL, 30, '2015-10-13 15:01:29.86825+02', NULL, NULL);
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (11, '1543', 27, NULL, NULL, NULL, 30, '2015-10-13 15:03:57.613771+02', NULL, NULL);
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (13, '1644', 27, NULL, NULL, NULL, 31, '2015-10-13 15:10:55.45077+02', NULL, NULL);
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (14, '2011', 26, NULL, NULL, NULL, 32, '2015-10-13 15:37:11.24158+02', NULL, NULL);
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (15, '2015-10-13', 25, NULL, NULL, NULL, 33, '2015-10-13 15:43:05.942249+02', NULL, NULL);
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (16, '1860', 26, NULL, NULL, NULL, 35, '2015-10-13 17:46:12.942494+02', NULL, NULL);
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (12, '1568', 25, NULL, NULL, NULL, 31, '2015-10-13 15:09:58.391533+02', '2015-11-06 17:36:06.103893+01', NULL);
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (17, '1604', 25, NULL, NULL, NULL, 851, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (18, '1105', 25, NULL, NULL, NULL, 1053, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (19, '1623', 25, NULL, NULL, NULL, 833, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (20, '1640', 25, NULL, NULL, NULL, 1371, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (21, '1110', 25, NULL, NULL, NULL, 1560, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (22, '1114', 25, NULL, NULL, NULL, 924, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (23, '1151', 25, NULL, NULL, NULL, 852, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (24, '1151', 25, NULL, NULL, NULL, 1144, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (25, '1170', 25, NULL, NULL, NULL, 1214, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (26, '1170', 25, NULL, NULL, NULL, 1361, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (27, '1201', 25, NULL, NULL, NULL, 1197, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (28, '1220', 25, NULL, NULL, NULL, 1122, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (29, '1220', 25, NULL, NULL, NULL, 987, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (30, '1236', 25, NULL, NULL, NULL, 846, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (31, '1238', 25, NULL, NULL, NULL, 1369, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (32, '1240', 25, NULL, NULL, NULL, 904, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (33, '1246', 25, NULL, NULL, NULL, 1126, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (34, '1251', 25, NULL, NULL, NULL, 1306, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (35, '1251', 25, NULL, NULL, NULL, 1339, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (36, '1251', 25, NULL, NULL, NULL, 1551, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (37, '1251', 25, NULL, NULL, NULL, 1509, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (38, '1251', 25, NULL, NULL, NULL, 912, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (39, '1251', 25, NULL, NULL, NULL, 1131, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (40, '1251', 25, NULL, NULL, NULL, 895, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (41, '1251', 25, NULL, NULL, NULL, 1553, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (42, '1251', 25, NULL, NULL, NULL, 1114, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (43, '1251', 25, NULL, NULL, NULL, 877, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (44, '1251', 25, NULL, NULL, NULL, 849, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (45, '1251', 25, NULL, NULL, NULL, 1436, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (46, '1260', 25, NULL, NULL, NULL, 923, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (47, '1260', 25, NULL, NULL, NULL, 1239, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (48, '1290', 25, NULL, NULL, NULL, 1205, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (49, '1290', 25, NULL, NULL, NULL, 1118, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (50, '1290', 25, NULL, NULL, NULL, 1086, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (51, '1292', 25, NULL, NULL, NULL, 1324, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (52, '1300', 25, NULL, NULL, NULL, 845, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (53, '1318', 25, NULL, NULL, NULL, 1185, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (54, '1325', 25, NULL, NULL, NULL, 1555, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (55, '1347', 25, NULL, NULL, NULL, 1418, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (56, '1351', 25, NULL, NULL, NULL, 1449, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (57, '1351', 25, NULL, NULL, NULL, 883, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (58, '1351', 25, NULL, NULL, NULL, 1047, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (59, '1351', 25, NULL, NULL, NULL, 1530, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (60, '1351', 25, NULL, NULL, NULL, 1127, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (61, '1351', 25, NULL, NULL, NULL, 1484, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (62, '1351', 25, NULL, NULL, NULL, 1320, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (63, '1397', 25, NULL, NULL, NULL, 1425, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (64, '1405', 25, NULL, NULL, NULL, 1249, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (65, '1411', 25, NULL, NULL, NULL, 1111, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (66, '1412', 25, NULL, NULL, NULL, 1188, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (67, '1416', 25, NULL, NULL, NULL, 1535, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (68, '1422', 25, NULL, NULL, NULL, 963, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (69, '1423', 25, NULL, NULL, NULL, 1529, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (70, '1423', 25, NULL, NULL, NULL, 1017, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (71, '1426', 25, NULL, NULL, NULL, 1283, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (72, '1436', 25, NULL, NULL, NULL, 1134, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (73, '1443', 25, NULL, NULL, NULL, 1210, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (74, '1445', 25, NULL, NULL, NULL, 1037, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (75, '1450', 25, NULL, NULL, NULL, 1181, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (76, '1451', 25, NULL, NULL, NULL, 1077, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (77, '1451', 25, NULL, NULL, NULL, 1450, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (78, '1451', 25, NULL, NULL, NULL, 1580, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (79, '1451', 25, NULL, NULL, NULL, 1565, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (80, '1451', 25, NULL, NULL, NULL, 1326, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (81, '1451', 25, NULL, NULL, NULL, 892, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (82, '1451', 25, NULL, NULL, NULL, 1235, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (83, '1451', 25, NULL, NULL, NULL, 835, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (84, '1451', 25, NULL, NULL, NULL, 1169, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (85, '1451', 25, NULL, NULL, NULL, 905, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (86, '1451', 25, NULL, NULL, NULL, 1066, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (87, '1451', 25, NULL, NULL, NULL, 1333, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (88, '1451', 25, NULL, NULL, NULL, 1067, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (89, '1451', 25, NULL, NULL, NULL, 1173, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (90, '1451', 25, NULL, NULL, NULL, 934, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (91, '1454', 25, NULL, NULL, NULL, 887, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (92, '1460', 25, NULL, NULL, NULL, 984, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (93, '1467', 25, NULL, NULL, NULL, 1522, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (94, '1468', 25, NULL, NULL, NULL, 1191, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (95, '1470', 25, NULL, NULL, NULL, 1128, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (96, '1470', 25, NULL, NULL, NULL, 1141, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (97, '1472', 25, NULL, NULL, NULL, 1005, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (98, '1472', 25, NULL, NULL, NULL, 945, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (99, '1473', 25, NULL, NULL, NULL, 1572, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (100, '1473', 25, NULL, NULL, NULL, 1207, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (101, '1476', 25, NULL, NULL, NULL, 1536, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (102, '1477', 25, NULL, NULL, NULL, 919, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (103, '1478', 25, NULL, NULL, NULL, 1115, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (104, '1478', 25, NULL, NULL, NULL, 961, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (105, '1479', 25, NULL, NULL, NULL, 1100, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (106, '1479', 25, NULL, NULL, NULL, 1007, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (107, '1480', 25, NULL, NULL, NULL, 942, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (108, '1480', 25, NULL, NULL, NULL, 1149, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (109, '1487', 25, NULL, NULL, NULL, 1072, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (110, '1489', 25, NULL, NULL, NULL, 1451, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (111, '1490', 25, NULL, NULL, NULL, 1241, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (112, '1492', 25, NULL, NULL, NULL, 1477, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (113, '1492', 25, NULL, NULL, NULL, 888, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (114, '1492', 25, NULL, NULL, NULL, 1255, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (115, '1494', 25, NULL, NULL, NULL, 1222, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (116, '1495', 25, NULL, NULL, NULL, 901, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (117, '1692', 25, NULL, NULL, NULL, 1493, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (118, '1498', 25, NULL, NULL, NULL, 909, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (119, '1499', 25, NULL, NULL, NULL, 969, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (120, '1499', 25, NULL, NULL, NULL, 897, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (121, '1499', 25, NULL, NULL, NULL, 1469, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (122, '1499', 25, NULL, NULL, NULL, 1317, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (123, '1500', 25, NULL, NULL, NULL, 999, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (124, '1500', 25, NULL, NULL, NULL, 1576, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (125, '1500', 25, NULL, NULL, NULL, 1392, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (126, '1501', 25, NULL, NULL, NULL, 1431, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (127, '1502', 25, NULL, NULL, NULL, 1278, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (128, '1503', 25, NULL, NULL, NULL, 1455, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (129, '1503', 25, NULL, NULL, NULL, 1374, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (130, '1504', 25, NULL, NULL, NULL, 1404, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (131, '1504', 25, NULL, NULL, NULL, 1443, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (132, '1505', 25, NULL, NULL, NULL, 1440, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (133, '1505', 25, NULL, NULL, NULL, 1142, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (134, '1674', 25, NULL, NULL, NULL, 1548, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (135, '1508', 25, NULL, NULL, NULL, 1080, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (136, '1508', 25, NULL, NULL, NULL, 1373, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (137, '1509', 25, NULL, NULL, NULL, 1303, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (138, '1510', 25, NULL, NULL, NULL, 1194, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (139, '1510', 25, NULL, NULL, NULL, 1094, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (140, '1511', 25, NULL, NULL, NULL, 1531, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (141, '1511', 25, NULL, NULL, NULL, 1244, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (142, '1511', 25, NULL, NULL, NULL, 936, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (143, '1512', 25, NULL, NULL, NULL, 1432, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (144, '1512', 25, NULL, NULL, NULL, 1231, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (145, '1513', 25, NULL, NULL, NULL, 1150, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (146, '1514', 25, NULL, NULL, NULL, 1208, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (147, '1515', 25, NULL, NULL, NULL, 1516, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (148, '1515', 25, NULL, NULL, NULL, 1154, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (149, '1516', 25, NULL, NULL, NULL, 1164, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (150, '1517', 25, NULL, NULL, NULL, 981, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (151, '1520', 25, NULL, NULL, NULL, 1356, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (152, '1520', 25, NULL, NULL, NULL, 1152, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (153, '1521', 25, NULL, NULL, NULL, 1171, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (154, '1521', 25, NULL, NULL, NULL, 1254, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (155, '1522', 25, NULL, NULL, NULL, 988, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (156, '1523', 25, NULL, NULL, NULL, 840, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (157, '1523', 25, NULL, NULL, NULL, 1106, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (158, '1707', 25, NULL, NULL, NULL, 921, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (159, '1525', 25, NULL, NULL, NULL, 889, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (160, '1525', 25, NULL, NULL, NULL, 1514, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (161, '1526', 25, NULL, NULL, NULL, 1176, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (162, '1527', 25, NULL, NULL, NULL, 1247, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (163, '1528', 25, NULL, NULL, NULL, 886, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (164, '1530', 25, NULL, NULL, NULL, 1343, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (165, '1530', 25, NULL, NULL, NULL, 1357, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (166, '1530', 25, NULL, NULL, NULL, 850, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (167, '1531', 25, NULL, NULL, NULL, 1174, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (168, '1531', 25, NULL, NULL, NULL, 1069, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (169, '1531', 25, NULL, NULL, NULL, 1382, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (170, '1531', 25, NULL, NULL, NULL, 1473, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (171, '1532', 25, NULL, NULL, NULL, 1189, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (172, '1536', 25, NULL, NULL, NULL, 1245, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (173, '1537', 25, NULL, NULL, NULL, 977, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (174, '1537', 25, NULL, NULL, NULL, 1170, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (175, '1538', 25, NULL, NULL, NULL, 989, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (176, '1539', 25, NULL, NULL, NULL, 1265, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (177, '1540', 25, NULL, NULL, NULL, 1340, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (178, '1541', 25, NULL, NULL, NULL, 1351, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (179, '1544', 25, NULL, NULL, NULL, 1190, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (180, '1545', 25, NULL, NULL, NULL, 1153, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (181, '1545', 25, NULL, NULL, NULL, 1084, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (182, '1546', 25, NULL, NULL, NULL, 1175, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (183, '1547', 25, NULL, NULL, NULL, 1271, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (184, '1547', 25, NULL, NULL, NULL, 1004, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (185, '1548', 25, NULL, NULL, NULL, 1561, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (186, '1548', 25, NULL, NULL, NULL, 953, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (187, '1549', 25, NULL, NULL, NULL, 1281, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (188, '1550', 25, NULL, NULL, NULL, 949, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (189, '1550', 25, NULL, NULL, NULL, 965, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (190, '1550', 25, NULL, NULL, NULL, 1412, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (191, '1550', 25, NULL, NULL, NULL, 1532, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (192, '1550', 25, NULL, NULL, NULL, 1524, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (193, '1651', 25, NULL, NULL, NULL, 1540, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (194, '1551', 25, NULL, NULL, NULL, 1458, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (195, '1551', 25, NULL, NULL, NULL, 951, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (196, '1551', 25, NULL, NULL, NULL, 1457, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (197, '1551', 25, NULL, NULL, NULL, 1139, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (198, '1551', 25, NULL, NULL, NULL, 1123, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (199, '1551', 25, NULL, NULL, NULL, 1497, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (200, '1551', 25, NULL, NULL, NULL, 1286, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (201, '1551', 25, NULL, NULL, NULL, 1215, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (202, '1551', 25, NULL, NULL, NULL, 1311, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (203, '1551', 25, NULL, NULL, NULL, 865, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (204, '1551', 25, NULL, NULL, NULL, 1470, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (205, '1551', 25, NULL, NULL, NULL, 855, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (206, '1551', 25, NULL, NULL, NULL, 900, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (207, '1551', 25, NULL, NULL, NULL, 1232, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (208, '1551', 25, NULL, NULL, NULL, 1129, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (209, '1551', 25, NULL, NULL, NULL, 1193, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (210, '1650', 25, NULL, NULL, NULL, 944, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (211, '1551', 25, NULL, NULL, NULL, 1463, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (212, '1551', 25, NULL, NULL, NULL, 1464, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (213, '1551', 25, NULL, NULL, NULL, 970, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (214, '1551', 25, NULL, NULL, NULL, 1293, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (215, '1551', 25, NULL, NULL, NULL, 1330, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (216, '1551', 25, NULL, NULL, NULL, 1584, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (217, '1551', 25, NULL, NULL, NULL, 957, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (218, '1551', 25, NULL, NULL, NULL, 1327, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (219, '1551', 25, NULL, NULL, NULL, 1413, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (220, '1551', 25, NULL, NULL, NULL, 1043, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (221, '1551', 25, NULL, NULL, NULL, 1182, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (222, '1551', 25, NULL, NULL, NULL, 1044, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (223, '1551', 25, NULL, NULL, NULL, 1482, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (224, '1551', 25, NULL, NULL, NULL, 1358, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (225, '1551', 25, NULL, NULL, NULL, 1284, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (226, '1551', 25, NULL, NULL, NULL, 1400, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (227, '1551', 25, NULL, NULL, NULL, 1566, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (228, '1551', 25, NULL, NULL, NULL, 1410, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (229, '1551', 25, NULL, NULL, NULL, 982, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (230, '1551', 25, NULL, NULL, NULL, 1478, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (231, '1551', 25, NULL, NULL, NULL, 1288, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (232, '1551', 25, NULL, NULL, NULL, 1058, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (233, '1552', 25, NULL, NULL, NULL, 1402, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (234, '1553', 25, NULL, NULL, NULL, 1145, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (235, '1554', 25, NULL, NULL, NULL, 1423, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (236, '1570', 25, NULL, NULL, NULL, 971, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (237, '1555', 25, NULL, NULL, NULL, 920, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (238, '1555', 25, NULL, NULL, NULL, 1257, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (239, '1556', 25, NULL, NULL, NULL, 1437, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (240, '1724', 25, NULL, NULL, NULL, 1539, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (241, '1557', 25, NULL, NULL, NULL, 917, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (242, '1558', 25, NULL, NULL, NULL, 1285, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (243, '1559', 25, NULL, NULL, NULL, 1038, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (244, '1560', 25, NULL, NULL, NULL, 1307, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (245, '1560', 25, NULL, NULL, NULL, 1456, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (246, '1561', 25, NULL, NULL, NULL, 1381, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (247, '1561', 25, NULL, NULL, NULL, 1095, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (248, '1561', 25, NULL, NULL, NULL, 1547, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (249, '1561', 25, NULL, NULL, NULL, 1362, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (250, '1561', 25, NULL, NULL, NULL, 853, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (251, '1561', 25, NULL, NULL, NULL, 1342, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (252, '1561', 25, NULL, NULL, NULL, 873, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (253, '1562', 25, NULL, NULL, NULL, 1360, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (254, '1562', 25, NULL, NULL, NULL, 1272, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (255, '1564', 25, NULL, NULL, NULL, 959, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (256, '1564', 25, NULL, NULL, NULL, 1167, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (257, '1565', 25, NULL, NULL, NULL, 993, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (258, '1565', 25, NULL, NULL, NULL, 1389, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (259, '1565', 25, NULL, NULL, NULL, 1028, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (260, '1565', 25, NULL, NULL, NULL, 1137, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (261, '1735', 25, NULL, NULL, NULL, 1237, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (262, '1566', 25, NULL, NULL, NULL, 1461, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (263, '1566', 25, NULL, NULL, NULL, 1471, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (264, '1566', 25, NULL, NULL, NULL, 1295, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (265, '1566', 25, NULL, NULL, NULL, 847, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (266, '1567', 25, NULL, NULL, NULL, 1064, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (267, '1568', 25, NULL, NULL, NULL, 1345, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (268, '1568', 25, NULL, NULL, NULL, 890, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (269, '1569', 25, NULL, NULL, NULL, 1384, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (270, '1570', 25, NULL, NULL, NULL, 1070, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (271, '1571', 25, NULL, NULL, NULL, 1248, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (272, '1571', 25, NULL, NULL, NULL, 1308, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (273, '1571', 25, NULL, NULL, NULL, 1355, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (274, '1571', 25, NULL, NULL, NULL, 1101, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (275, '1571', 25, NULL, NULL, NULL, 1379, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (276, '1572', 25, NULL, NULL, NULL, 1510, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (277, '1572', 25, NULL, NULL, NULL, 1224, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (278, '1575', 25, NULL, NULL, NULL, 1352, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (279, '1575', 25, NULL, NULL, NULL, 1074, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (280, '1578', 25, NULL, NULL, NULL, 1575, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (281, '1578', 25, NULL, NULL, NULL, 848, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (282, '1580', 25, NULL, NULL, NULL, 1136, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (283, '1580', 25, NULL, NULL, NULL, 1202, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (284, '1580', 25, NULL, NULL, NULL, 1577, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (285, '1580', 25, NULL, NULL, NULL, 861, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (286, '1580', 25, NULL, NULL, NULL, 1454, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (287, '1580', 25, NULL, NULL, NULL, 1223, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (288, '1581', 25, NULL, NULL, NULL, 1312, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (289, '1582', 25, NULL, NULL, NULL, 1506, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (290, '1582', 25, NULL, NULL, NULL, 1550, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (291, '1582', 25, NULL, NULL, NULL, 1279, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (292, '1582', 25, NULL, NULL, NULL, 1270, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (293, '1583', 25, NULL, NULL, NULL, 1421, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (294, '1583', 25, NULL, NULL, NULL, 1294, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (295, '1584', 25, NULL, NULL, NULL, 1395, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (296, '1584', 25, NULL, NULL, NULL, 1490, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (297, '1584', 25, NULL, NULL, NULL, 1216, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (298, '1585', 25, NULL, NULL, NULL, 1300, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (299, '1585', 25, NULL, NULL, NULL, 1201, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (300, '1585', 25, NULL, NULL, NULL, 1063, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (301, '1585', 25, NULL, NULL, NULL, 1008, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (302, '1586', 25, NULL, NULL, NULL, 1583, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (303, '1586', 25, NULL, NULL, NULL, 1183, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (304, '1587', 25, NULL, NULL, NULL, 867, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (305, '1587', 25, NULL, NULL, NULL, 1158, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (306, '1587', 25, NULL, NULL, NULL, 1567, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (307, '1588', 25, NULL, NULL, NULL, 1112, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (308, '1588', 25, NULL, NULL, NULL, 1513, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (309, '1650', 25, NULL, NULL, NULL, 1057, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (310, '1651', 25, NULL, NULL, NULL, 1073, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (311, '1651', 25, NULL, NULL, NULL, 1491, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (312, '1651', 25, NULL, NULL, NULL, 856, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (313, '1590', 25, NULL, NULL, NULL, 1140, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (314, '1590', 25, NULL, NULL, NULL, 1242, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (315, '1591', 25, NULL, NULL, NULL, 1353, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (316, '1591', 25, NULL, NULL, NULL, 1256, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (317, '1592', 25, NULL, NULL, NULL, 1211, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (318, '1592', 25, NULL, NULL, NULL, 1376, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (319, '1592', 25, NULL, NULL, NULL, 866, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (320, '1592', 25, NULL, NULL, NULL, 1405, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (321, '1595', 25, NULL, NULL, NULL, 1092, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (322, '1595', 25, NULL, NULL, NULL, 926, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (323, '1595', 25, NULL, NULL, NULL, 983, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (324, '1596', 25, NULL, NULL, NULL, 857, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (325, '1596', 25, NULL, NULL, NULL, 943, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (326, '1596', 25, NULL, NULL, NULL, 1219, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (327, '1597', 25, NULL, NULL, NULL, 1314, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (328, '1598', 25, NULL, NULL, NULL, 1062, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (329, '1598', 25, NULL, NULL, NULL, 1465, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (330, '1598', 25, NULL, NULL, NULL, 859, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (331, '1599', 25, NULL, NULL, NULL, 1050, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (332, '1599', 25, NULL, NULL, NULL, 1177, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (333, '1600', 25, NULL, NULL, NULL, 1012, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (334, '1600', 25, NULL, NULL, NULL, 1078, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (335, '1600', 25, NULL, NULL, NULL, 1430, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (336, '1600', 25, NULL, NULL, NULL, 1259, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (337, '1601', 25, NULL, NULL, NULL, 1148, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (338, '1601', 25, NULL, NULL, NULL, 902, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (339, '1651', 25, NULL, NULL, NULL, 1275, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (340, '1651', 25, NULL, NULL, NULL, 992, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (341, '1651', 25, NULL, NULL, NULL, 1570, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (342, '1601', 25, NULL, NULL, NULL, 1291, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (343, '1601', 25, NULL, NULL, NULL, 872, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (344, '1602', 25, NULL, NULL, NULL, 1393, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (345, '1602', 25, NULL, NULL, NULL, 964, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (346, '1602', 25, NULL, NULL, NULL, 1298, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (347, '1602', 25, NULL, NULL, NULL, 1552, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (348, '1602', 25, NULL, NULL, NULL, 1574, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (349, '1604', 25, NULL, NULL, NULL, 1511, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (350, '1605', 25, NULL, NULL, NULL, 1563, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (351, '1605', 25, NULL, NULL, NULL, 1269, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (352, '1606', 25, NULL, NULL, NULL, 1246, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (353, '1608', 25, NULL, NULL, NULL, 1414, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (354, '1608', 25, NULL, NULL, NULL, 1411, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (355, '1608', 25, NULL, NULL, NULL, 1557, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (356, '1610', 25, NULL, NULL, NULL, 1467, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (357, '1610', 25, NULL, NULL, NULL, 1507, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (358, '1611', 25, NULL, NULL, NULL, 1365, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (359, '1611', 25, NULL, NULL, NULL, 1526, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (360, '1612', 25, NULL, NULL, NULL, 1441, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (361, '1613', 25, NULL, NULL, NULL, 995, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (362, '1613', 25, NULL, NULL, NULL, 1429, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (363, '1613', 25, NULL, NULL, NULL, 1103, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (364, '1614', 25, NULL, NULL, NULL, 860, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (365, '1615', 25, NULL, NULL, NULL, 1523, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (366, '1616', 25, NULL, NULL, NULL, 910, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (367, '1617', 25, NULL, NULL, NULL, 954, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (368, '1617', 25, NULL, NULL, NULL, 1156, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (369, '1618', 25, NULL, NULL, NULL, 1318, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (370, '1620', 25, NULL, NULL, NULL, 1267, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (371, '1620', 25, NULL, NULL, NULL, 1155, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (372, '1621', 25, NULL, NULL, NULL, 1178, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (373, '1622', 25, NULL, NULL, NULL, 1485, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (374, '1622', 25, NULL, NULL, NULL, 946, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (375, '1622', 25, NULL, NULL, NULL, 1612, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (376, '1622', 25, NULL, NULL, NULL, 1366, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (377, '1623', 25, NULL, NULL, NULL, 1587, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (378, '1624', 25, NULL, NULL, NULL, 1110, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (379, '1625', 25, NULL, NULL, NULL, 1337, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (380, '1625', 25, NULL, NULL, NULL, 1268, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (381, '1625', 25, NULL, NULL, NULL, 1130, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (382, '1625', 25, NULL, NULL, NULL, 1009, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (383, '1625', 25, NULL, NULL, NULL, 1055, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (384, '1625', 25, NULL, NULL, NULL, 1370, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (385, '1625', 25, NULL, NULL, NULL, 1280, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (386, '1626', 25, NULL, NULL, NULL, 1289, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (387, '1627', 25, NULL, NULL, NULL, 1096, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (388, '1628', 25, NULL, NULL, NULL, 1377, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (389, '1628', 25, NULL, NULL, NULL, 869, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (390, '1629', 25, NULL, NULL, NULL, 938, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (391, '1630', 25, NULL, NULL, NULL, 1059, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (392, '1630', 25, NULL, NULL, NULL, 1124, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (393, '1630', 25, NULL, NULL, NULL, 1544, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (394, '1631', 25, NULL, NULL, NULL, 941, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (395, '1631', 25, NULL, NULL, NULL, 1093, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (396, '1632', 25, NULL, NULL, NULL, 1545, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (397, '1633', 25, NULL, NULL, NULL, 933, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (398, '1633', 25, NULL, NULL, NULL, 1475, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (399, '1633', 25, NULL, NULL, NULL, 1108, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (400, '1633', 25, NULL, NULL, NULL, 1274, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (401, '1633', 25, NULL, NULL, NULL, 1217, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (402, '1633', 25, NULL, NULL, NULL, 1559, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (403, '1635', 25, NULL, NULL, NULL, 1556, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (404, '1636', 25, NULL, NULL, NULL, 939, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (405, '1637', 25, NULL, NULL, NULL, 1041, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (406, '1637', 25, NULL, NULL, NULL, 1000, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (407, '1638', 25, NULL, NULL, NULL, 1143, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (408, '1638', 25, NULL, NULL, NULL, 1338, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (409, '1638', 25, NULL, NULL, NULL, 1406, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (410, '1655', 25, NULL, NULL, NULL, 1097, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (411, '1638', 25, NULL, NULL, NULL, 1581, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (412, '1640', 25, NULL, NULL, NULL, 1052, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (413, '1640', 25, NULL, NULL, NULL, 1290, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (414, '1642', 25, NULL, NULL, NULL, 1010, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (415, '1642', 25, NULL, NULL, NULL, 1502, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (416, '1642', 25, NULL, NULL, NULL, 1538, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (417, '1642', 25, NULL, NULL, NULL, 928, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (418, '1643', 25, NULL, NULL, NULL, 1445, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (419, '1644', 25, NULL, NULL, NULL, 893, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (420, '1644', 25, NULL, NULL, NULL, 975, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (421, '1644', 25, NULL, NULL, NULL, 1401, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (422, '1645', 25, NULL, NULL, NULL, 854, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (423, '1645', 25, NULL, NULL, NULL, 1321, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (424, '1645', 25, NULL, NULL, NULL, 882, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (425, '1646', 25, NULL, NULL, NULL, 1042, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (426, '1646', 25, NULL, NULL, NULL, 1615, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (427, '1646', 25, NULL, NULL, NULL, 1446, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (428, '1646', 25, NULL, NULL, NULL, 841, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (429, '1646', 25, NULL, NULL, NULL, 927, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (430, '1648', 25, NULL, NULL, NULL, 1172, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (431, '1648', 25, NULL, NULL, NULL, 1079, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (432, '1151', 25, NULL, NULL, NULL, 1589, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (433, '1288', 25, NULL, NULL, NULL, 1603, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (434, '1351', 25, NULL, NULL, NULL, 1590, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (435, '1451', 25, NULL, NULL, NULL, 1604, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (436, '1491', 25, NULL, NULL, NULL, 1608, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (437, '1520', 25, NULL, NULL, NULL, 1618, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (438, '1524', 25, NULL, NULL, NULL, 1588, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (439, '1536', 25, NULL, NULL, NULL, 1601, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (440, '1546', 25, NULL, NULL, NULL, 1596, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (441, '1551', 25, NULL, NULL, NULL, 1613, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (442, '1656', 25, NULL, NULL, NULL, 1296, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (443, '1675', 25, NULL, NULL, NULL, 1026, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (444, '1551', 25, NULL, NULL, NULL, 1592, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (445, '1551', 25, NULL, NULL, NULL, 1609, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (446, '1718', 25, NULL, NULL, NULL, 1350, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (447, '1651', 25, NULL, NULL, NULL, 1203, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (448, '1572', 25, NULL, NULL, NULL, 1602, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (449, '1572', 25, NULL, NULL, NULL, 1597, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (450, '1575', 25, NULL, NULL, NULL, 1599, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (451, '1588', 25, NULL, NULL, NULL, 1586, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (452, '1610', 25, NULL, NULL, NULL, 1593, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (453, '1642', 25, NULL, NULL, NULL, 1606, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (454, '1651', 25, NULL, NULL, NULL, 1372, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (455, '1651', 25, NULL, NULL, NULL, 1082, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (456, '1651', 25, NULL, NULL, NULL, 1032, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (457, '1651', 25, NULL, NULL, NULL, 1087, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (458, '1651', 25, NULL, NULL, NULL, 1378, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (459, '1651', 25, NULL, NULL, NULL, 1419, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (460, '1651', 25, NULL, NULL, NULL, 1088, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (461, '1651', 25, NULL, NULL, NULL, 1107, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (462, '1651', 25, NULL, NULL, NULL, 1013, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (463, '1651', 25, NULL, NULL, NULL, 894, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (464, '1651', 25, NULL, NULL, NULL, 1282, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (465, '1651', 25, NULL, NULL, NULL, 1319, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (466, '1651', 25, NULL, NULL, NULL, 1258, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (467, '1651', 25, NULL, NULL, NULL, 1508, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (468, '1651', 25, NULL, NULL, NULL, 1132, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (469, '1651', 25, NULL, NULL, NULL, 874, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (470, '1651', 25, NULL, NULL, NULL, 1385, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (471, '1651', 25, NULL, NULL, NULL, 1048, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (472, '1652', 25, NULL, NULL, NULL, 1390, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (473, '1652', 25, NULL, NULL, NULL, 1292, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (474, '1652', 25, NULL, NULL, NULL, 1192, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (475, '1653', 25, NULL, NULL, NULL, 1304, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (476, '1654', 25, NULL, NULL, NULL, 1520, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (477, '1654', 25, NULL, NULL, NULL, 1426, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (478, '1654', 25, NULL, NULL, NULL, 1578, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (479, '1654', 25, NULL, NULL, NULL, 1089, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (480, '1654', 25, NULL, NULL, NULL, 974, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (481, '1654', 25, NULL, NULL, NULL, 1083, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (482, '1654', 25, NULL, NULL, NULL, 1045, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (483, '1655', 25, NULL, NULL, NULL, 1024, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (484, '1656', 25, NULL, NULL, NULL, 1462, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (485, '1656', 25, NULL, NULL, NULL, 842, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (486, '1656', 25, NULL, NULL, NULL, 1521, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (487, '1657', 25, NULL, NULL, NULL, 1049, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (488, '1657', 25, NULL, NULL, NULL, 1018, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (489, '1659', 25, NULL, NULL, NULL, 1021, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (490, '1659', 25, NULL, NULL, NULL, 966, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (491, '1660', 25, NULL, NULL, NULL, 1466, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (492, '1660', 25, NULL, NULL, NULL, 979, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (493, '1661', 25, NULL, NULL, NULL, 1380, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (494, '1662', 25, NULL, NULL, NULL, 1363, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (495, '1662', 25, NULL, NULL, NULL, 878, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (496, '1663', 25, NULL, NULL, NULL, 1029, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (497, '1663', 25, NULL, NULL, NULL, 1309, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (498, '1663', 25, NULL, NULL, NULL, 1165, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (499, '1664', 25, NULL, NULL, NULL, 1260, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (500, '1664', 25, NULL, NULL, NULL, 1486, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (501, '1667', 25, NULL, NULL, NULL, 1287, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (502, '1667', 25, NULL, NULL, NULL, 1250, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (503, '1667', 25, NULL, NULL, NULL, 1610, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (504, '1667', 25, NULL, NULL, NULL, 1099, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (505, '1669', 25, NULL, NULL, NULL, 1600, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (506, '1669', 25, NULL, NULL, NULL, 955, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (507, '1670', 25, NULL, NULL, NULL, 1408, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (508, '1671', 25, NULL, NULL, NULL, 1056, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (509, '1671', 25, NULL, NULL, NULL, 1297, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (511, '1671', 25, NULL, NULL, NULL, 1116, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (512, '1671', 25, NULL, NULL, NULL, 1527, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (513, '1671', 25, NULL, NULL, NULL, 940, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (514, '1672', 25, NULL, NULL, NULL, 950, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (515, '1672', 25, NULL, NULL, NULL, 879, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (516, '1674', 25, NULL, NULL, NULL, 898, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (517, '1675', 25, NULL, NULL, NULL, 1011, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (518, '1675', 25, NULL, NULL, NULL, 1277, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (519, '1676', 25, NULL, NULL, NULL, 1569, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (520, '1677', 25, NULL, NULL, NULL, 1487, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (521, '1735', 25, NULL, NULL, NULL, 1243, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (522, '1677', 25, NULL, NULL, NULL, 1546, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (523, '1677', 25, NULL, NULL, NULL, 1512, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (524, '1678', 25, NULL, NULL, NULL, 838, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (525, '1678', 25, NULL, NULL, NULL, 1422, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (526, '1678', 25, NULL, NULL, NULL, 875, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (527, '1678', 25, NULL, NULL, NULL, 1472, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (528, '1678', 25, NULL, NULL, NULL, 1329, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (529, '1679', 25, NULL, NULL, NULL, 1209, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (530, '1679', 25, NULL, NULL, NULL, 932, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (531, '1679', 25, NULL, NULL, NULL, 1138, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (532, '1680', 25, NULL, NULL, NULL, 1068, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (533, '1680', 25, NULL, NULL, NULL, 1253, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (534, '1681', 25, NULL, NULL, NULL, 1023, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (535, '1682', 25, NULL, NULL, NULL, 1407, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (536, '1683', 25, NULL, NULL, NULL, 1206, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (537, '1684', 25, NULL, NULL, NULL, 1225, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (538, '1685', 25, NULL, NULL, NULL, 863, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (539, '1685', 25, NULL, NULL, NULL, 1227, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (540, '1685', 25, NULL, NULL, NULL, 1444, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (541, '1686', 25, NULL, NULL, NULL, 1251, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (542, '1687', 25, NULL, NULL, NULL, 1034, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (543, '1687', 25, NULL, NULL, NULL, 1503, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (544, '1703', 25, NULL, NULL, NULL, 1199, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (545, '1688', 25, NULL, NULL, NULL, 884, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (546, '1688', 25, NULL, NULL, NULL, 1228, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (547, '1688', 25, NULL, NULL, NULL, 1198, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (548, '1688', 25, NULL, NULL, NULL, 829, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (549, '1689', 25, NULL, NULL, NULL, 972, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (550, '1689', 25, NULL, NULL, NULL, 1479, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (551, '1689', 25, NULL, NULL, NULL, 1195, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (552, '1690', 25, NULL, NULL, NULL, 1261, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (553, '1691', 25, NULL, NULL, NULL, 1433, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (554, '1692', 25, NULL, NULL, NULL, 1117, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (555, '1692', 25, NULL, NULL, NULL, 913, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (556, '1693', 25, NULL, NULL, NULL, 1558, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (557, '1693', 25, NULL, NULL, NULL, 916, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (558, '1694', 25, NULL, NULL, NULL, 1226, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (559, '1697', 25, NULL, NULL, NULL, 880, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (560, '1698', 25, NULL, NULL, NULL, 1495, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (561, '1698', 25, NULL, NULL, NULL, 1492, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (562, '1698', 25, NULL, NULL, NULL, 1305, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (563, '1699', 25, NULL, NULL, NULL, 1367, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (564, '1699', 25, NULL, NULL, NULL, 903, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (565, '1700', 25, NULL, NULL, NULL, 1494, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (566, '1700', 25, NULL, NULL, NULL, 1434, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (567, '1701', 25, NULL, NULL, NULL, 1146, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (568, '1701', 25, NULL, NULL, NULL, 922, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (569, '1701', 25, NULL, NULL, NULL, 978, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (570, '1701', 25, NULL, NULL, NULL, 836, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (571, '1701', 25, NULL, NULL, NULL, 1233, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (572, '1702', 25, NULL, NULL, NULL, 1564, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (573, '1703', 25, NULL, NULL, NULL, 1316, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (574, '1703', 25, NULL, NULL, NULL, 1435, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (575, '1704', 25, NULL, NULL, NULL, 1039, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (576, '1704', 25, NULL, NULL, NULL, 1001, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (577, '1704', 25, NULL, NULL, NULL, 1537, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (578, '1704', 25, NULL, NULL, NULL, 996, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (579, '1704', 25, NULL, NULL, NULL, 1030, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (580, '1704', 25, NULL, NULL, NULL, 1200, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (581, '1705', 25, NULL, NULL, NULL, 1014, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (582, '1706', 25, NULL, NULL, NULL, 876, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (583, '1706', 25, NULL, NULL, NULL, 1501, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (584, '1706', 25, NULL, NULL, NULL, 1562, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (585, '1707', 25, NULL, NULL, NULL, 1585, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (586, '1707', 25, NULL, NULL, NULL, 1571, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (587, '1707', 25, NULL, NULL, NULL, 1403, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (588, '1707', 25, NULL, NULL, NULL, 1186, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (589, '1708', 25, NULL, NULL, NULL, 870, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (590, '1709', 25, NULL, NULL, NULL, 1236, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (591, '1709', 25, NULL, NULL, NULL, 985, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (592, '1710', 25, NULL, NULL, NULL, 832, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (593, '1710', 25, NULL, NULL, NULL, 990, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (594, '1710', 25, NULL, NULL, NULL, 1452, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (595, '1710', 25, NULL, NULL, NULL, 1616, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (596, '1711', 25, NULL, NULL, NULL, 1104, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (597, '1711', 25, NULL, NULL, NULL, 837, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (598, '1711', 25, NULL, NULL, NULL, 968, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (599, '1711', 25, NULL, NULL, NULL, 1582, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (600, '1711', 25, NULL, NULL, NULL, 935, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (601, '1711', 25, NULL, NULL, NULL, 1388, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (602, '1712', 25, NULL, NULL, NULL, 1135, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (603, '1712', 25, NULL, NULL, NULL, 1102, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (604, '1713', 25, NULL, NULL, NULL, 918, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (605, '1713', 25, NULL, NULL, NULL, 844, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (606, '1713', 25, NULL, NULL, NULL, 1591, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (607, '1714', 25, NULL, NULL, NULL, 1554, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (608, '1724', 25, NULL, NULL, NULL, 1533, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (609, '1714', 25, NULL, NULL, NULL, 1159, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (610, '1714', 25, NULL, NULL, NULL, 1349, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (611, '1714', 25, NULL, NULL, NULL, 1611, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (612, '1715', 25, NULL, NULL, NULL, 915, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (613, '1715', 25, NULL, NULL, NULL, 962, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (614, '1716', 25, NULL, NULL, NULL, 1617, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (615, '1716', 25, NULL, NULL, NULL, 1160, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (616, '1716', 25, NULL, NULL, NULL, 1483, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (617, '1716', 25, NULL, NULL, NULL, 1549, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (618, '1717', 25, NULL, NULL, NULL, 1394, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (619, '1717', 25, NULL, NULL, NULL, 1179, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (620, '1718', 25, NULL, NULL, NULL, 1525, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (621, '1718', 25, NULL, NULL, NULL, 906, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (622, '1718', 25, NULL, NULL, NULL, 1310, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (623, '1718', 25, NULL, NULL, NULL, 1427, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (624, '1718', 25, NULL, NULL, NULL, 1346, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (625, '1718', 25, NULL, NULL, NULL, 1500, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (626, '1718', 25, NULL, NULL, NULL, 1594, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (627, '1719', 25, NULL, NULL, NULL, 1168, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (628, '1719', 25, NULL, NULL, NULL, 1315, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (629, '1720', 25, NULL, NULL, NULL, 1027, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (630, '1722', 25, NULL, NULL, NULL, 868, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (631, '1722', 25, NULL, NULL, NULL, 834, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (632, '1722', 25, NULL, NULL, NULL, 1213, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (633, '1722', 25, NULL, NULL, NULL, 1448, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (634, '1723', 25, NULL, NULL, NULL, 881, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (635, '1723', 25, NULL, NULL, NULL, 1163, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (636, '1723', 25, NULL, NULL, NULL, 1541, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (637, '1723', 25, NULL, NULL, NULL, 937, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (638, '1723', 25, NULL, NULL, NULL, 1229, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (639, '1723', 25, NULL, NULL, NULL, 1035, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (640, '1723', 25, NULL, NULL, NULL, 967, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (641, '1724', 25, NULL, NULL, NULL, 1505, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (642, '1724', 25, NULL, NULL, NULL, 1568, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (643, '1725', 25, NULL, NULL, NULL, 1328, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (644, '1725', 25, NULL, NULL, NULL, 1344, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (645, '1725', 25, NULL, NULL, NULL, 1517, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (646, '1735', 25, NULL, NULL, NULL, 1006, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (647, '1727', 25, NULL, NULL, NULL, 1325, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (648, '1728', 25, NULL, NULL, NULL, 830, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (649, '1728', 25, NULL, NULL, NULL, 1335, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (650, '1728', 25, NULL, NULL, NULL, 1468, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (651, '1728', 25, NULL, NULL, NULL, 1036, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (652, '1729', 25, NULL, NULL, NULL, 952, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (653, '1730', 25, NULL, NULL, NULL, 947, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (654, '1730', 25, NULL, NULL, NULL, 1184, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (655, '1730', 25, NULL, NULL, NULL, 1157, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (656, '1730', 25, NULL, NULL, NULL, 1499, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (657, '1730', 25, NULL, NULL, NULL, 1409, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (658, '1730', 25, NULL, NULL, NULL, 1220, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (659, '1730', 25, NULL, NULL, NULL, 1481, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (660, '1731', 25, NULL, NULL, NULL, 1607, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (661, '1731', 25, NULL, NULL, NULL, 896, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (662, '1731', 25, NULL, NULL, NULL, 1416, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (663, '1732', 25, NULL, NULL, NULL, 1046, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (664, '1732', 25, NULL, NULL, NULL, 885, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (665, '1732', 25, NULL, NULL, NULL, 1240, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (666, '1732', 25, NULL, NULL, NULL, 1573, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (667, '1733', 25, NULL, NULL, NULL, 1383, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (668, '1733', 25, NULL, NULL, NULL, 1196, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (669, '1733', 25, NULL, NULL, NULL, 1147, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (670, '1733', 25, NULL, NULL, NULL, 1331, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (671, '1734', 25, NULL, NULL, NULL, 1051, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (672, '1734', 25, NULL, NULL, NULL, 1180, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (673, '1734', 25, NULL, NULL, NULL, 1263, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (674, '1734', 25, NULL, NULL, NULL, 1386, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (675, '1736', 25, NULL, NULL, NULL, 1341, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (676, '1736', 25, NULL, NULL, NULL, 1420, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (677, '1736', 25, NULL, NULL, NULL, 1033, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (678, '1736', 25, NULL, NULL, NULL, 998, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (679, '1737', 25, NULL, NULL, NULL, 1071, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (680, '1737', 25, NULL, NULL, NULL, 1476, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (681, '1737', 25, NULL, NULL, NULL, 1515, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (682, '1737', 25, NULL, NULL, NULL, 907, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (683, '1738', 25, NULL, NULL, NULL, 1221, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (684, '1738', 25, NULL, NULL, NULL, 858, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (685, '1738', 25, NULL, NULL, NULL, 839, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (686, '1738', 25, NULL, NULL, NULL, 1264, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (687, '1738', 25, NULL, NULL, NULL, 1518, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (688, '1739', 25, NULL, NULL, NULL, 1336, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (689, '1739', 25, NULL, NULL, NULL, 1415, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (690, '1739', 25, NULL, NULL, NULL, 1162, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (691, '1739', 25, NULL, NULL, NULL, 1090, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (692, '1740', 25, NULL, NULL, NULL, 1120, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (693, '1740', 25, NULL, NULL, NULL, 986, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (694, '1740', 25, NULL, NULL, NULL, 1133, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (695, '1740', 25, NULL, NULL, NULL, 891, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (696, '1740', 25, NULL, NULL, NULL, 994, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (697, '1740', 25, NULL, NULL, NULL, 925, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (698, '1740', 25, NULL, NULL, NULL, 1166, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (699, '1741', 25, NULL, NULL, NULL, 1428, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (700, '1741', 25, NULL, NULL, NULL, 908, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (701, '1741', 25, NULL, NULL, NULL, 991, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (702, '1742', 25, NULL, NULL, NULL, 931, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (703, '1742', 25, NULL, NULL, NULL, 911, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (704, '1743', 25, NULL, NULL, NULL, 1238, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (705, '1743', 25, NULL, NULL, NULL, 1439, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (706, '1743', 25, NULL, NULL, NULL, 831, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (707, '1744', 25, NULL, NULL, NULL, 1334, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (708, '1744', 25, NULL, NULL, NULL, 1453, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (709, '1744', 25, NULL, NULL, NULL, 1234, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (710, '1744', 25, NULL, NULL, NULL, 1474, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (711, '1744', 25, NULL, NULL, NULL, 914, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (712, '1745', 25, NULL, NULL, NULL, 976, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (713, '1745', 25, NULL, NULL, NULL, 973, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (714, '1745', 25, NULL, NULL, NULL, 1359, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (715, '1745', 25, NULL, NULL, NULL, 1347, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (716, '1745', 25, NULL, NULL, NULL, 1322, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (717, '1745', 25, NULL, NULL, NULL, 1015, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (718, '1746', 25, NULL, NULL, NULL, 1003, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (719, '1746', 25, NULL, NULL, NULL, 1424, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (720, '1746', 25, NULL, NULL, NULL, 1262, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (721, '1746', 25, NULL, NULL, NULL, 997, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (722, '1746', 25, NULL, NULL, NULL, 1081, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (723, '1751', 25, NULL, NULL, NULL, 1301, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (724, '1747', 25, NULL, NULL, NULL, 1387, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (725, '1747', 25, NULL, NULL, NULL, 1397, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (726, '1747', 25, NULL, NULL, NULL, 1085, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (727, '1748', 25, NULL, NULL, NULL, 1459, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (728, '1754', 25, NULL, NULL, NULL, 1398, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (729, '1748', 25, NULL, NULL, NULL, 1091, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (730, '1748', 25, NULL, NULL, NULL, 1121, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (731, '1748', 25, NULL, NULL, NULL, 1460, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (732, '1748', 25, NULL, NULL, NULL, 1025, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (733, '1749', 25, NULL, NULL, NULL, 1218, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (734, '1749', 25, NULL, NULL, NULL, 1105, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (735, '1749', 25, NULL, NULL, NULL, 1266, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (736, '1749', 25, NULL, NULL, NULL, 1438, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (737, '1749', 25, NULL, NULL, NULL, 1496, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (738, '1749', 25, NULL, NULL, NULL, 1161, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (739, '1751', 25, NULL, NULL, NULL, 1019, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (740, '1749', 25, NULL, NULL, NULL, 1442, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (741, '1750', 25, NULL, NULL, NULL, 1113, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (742, '1750', 25, NULL, NULL, NULL, 1488, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (743, '1750', 25, NULL, NULL, NULL, 1273, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (744, '1750', 25, NULL, NULL, NULL, 1075, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (745, '1750', 25, NULL, NULL, NULL, 1368, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (746, '1750', 25, NULL, NULL, NULL, 1204, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (747, '1751', 25, NULL, NULL, NULL, 1504, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (748, '1751', 25, NULL, NULL, NULL, 1519, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (749, '1751', 25, NULL, NULL, NULL, 1332, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (750, '1751', 25, NULL, NULL, NULL, 1399, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (751, '1751', 25, NULL, NULL, NULL, 864, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (752, '1751', 25, NULL, NULL, NULL, 1489, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (753, '1751', 25, NULL, NULL, NULL, 1151, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (754, '1751', 25, NULL, NULL, NULL, 843, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (755, '1751', 25, NULL, NULL, NULL, 871, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (756, '1751', 25, NULL, NULL, NULL, 956, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (757, '1751', 25, NULL, NULL, NULL, 1031, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (758, '1751', 25, NULL, NULL, NULL, 1299, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (759, '1751', 25, NULL, NULL, NULL, 980, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (760, '1751', 25, NULL, NULL, NULL, 1542, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (761, '1751', 25, NULL, NULL, NULL, 1016, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (762, '1751', 25, NULL, NULL, NULL, 1313, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (763, '1751', 25, NULL, NULL, NULL, 1534, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (764, '1751', 25, NULL, NULL, NULL, 1480, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (765, '1751', 25, NULL, NULL, NULL, 1447, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (766, '1751', 25, NULL, NULL, NULL, 1125, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (767, '1751', 25, NULL, NULL, NULL, 1065, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (768, '1751', 25, NULL, NULL, NULL, 1060, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (769, '1751', 25, NULL, NULL, NULL, 960, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (770, '1751', 25, NULL, NULL, NULL, 958, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (771, '1751', 25, NULL, NULL, NULL, 1109, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (772, '1751', 25, NULL, NULL, NULL, 1061, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (773, '1751', 25, NULL, NULL, NULL, 929, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (774, '1751', 25, NULL, NULL, NULL, 1614, '2015-11-06 18:13:56.804955+01', NULL, 'p');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (775, '1752', 25, NULL, NULL, NULL, 1595, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (776, '1752', 25, NULL, NULL, NULL, 1252, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (777, '1752', 25, NULL, NULL, NULL, 1040, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (778, '1759', 25, NULL, NULL, NULL, 1364, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (779, '1752', 25, NULL, NULL, NULL, 1002, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (780, '1752', 25, NULL, NULL, NULL, 1323, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (781, '1753', 25, NULL, NULL, NULL, 948, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (782, '1754', 25, NULL, NULL, NULL, 1375, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (783, '1754', 25, NULL, NULL, NULL, 1020, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (784, '1754', 25, NULL, NULL, NULL, 1354, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (785, '1754', 25, NULL, NULL, NULL, 1187, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (786, '1755', 25, NULL, NULL, NULL, 1391, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (787, '1755', 25, NULL, NULL, NULL, 1528, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (788, '1755', 25, NULL, NULL, NULL, 1348, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (789, '1755', 25, NULL, NULL, NULL, 899, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (790, '1755', 25, NULL, NULL, NULL, 1543, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (791, '1755', 25, NULL, NULL, NULL, 1119, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (792, '1755', 25, NULL, NULL, NULL, 1098, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (793, '1755', 25, NULL, NULL, NULL, 1605, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (794, '1755', 25, NULL, NULL, NULL, 1212, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (795, '1756', 25, NULL, NULL, NULL, 1396, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (796, '1756', 25, NULL, NULL, NULL, 862, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (797, '1756', 25, NULL, NULL, NULL, 1276, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (798, '1756', 25, NULL, NULL, NULL, 1076, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (799, '1756', 25, NULL, NULL, NULL, 1054, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (800, '1757', 25, NULL, NULL, NULL, 930, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (801, '1757', 25, NULL, NULL, NULL, 1579, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (802, '1758', 25, NULL, NULL, NULL, 1230, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (803, '1759', 25, NULL, NULL, NULL, 1417, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (804, '1759', 25, NULL, NULL, NULL, 1498, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (805, '1759', 25, NULL, NULL, NULL, 1302, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (806, '1760', 25, NULL, NULL, NULL, 1598, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (807, '1760', 25, NULL, NULL, NULL, 1022, '2015-11-06 18:13:56.804955+01', NULL, ' ');
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (809, '1550', 25, NULL, NULL, NULL, 1619, '2015-11-09 21:17:29.787913+01', '2015-11-09 21:17:58.333961+01', NULL);
INSERT INTO date_objet (pk_date_objet, date_iso, fk_type_date_param, libelle_original_date, notes, descriptif, fk_objet, date_creation, date_modification, certitude) VALUES (808, '1551', 25, NULL, NULL, NULL, 1620, '2015-11-09 21:16:59.121158+01', '2015-11-09 21:18:14.77701+01', NULL);


--
-- TOC entry 2413 (class 0 OID 0)
-- Dependencies: 187
-- Name: date_objet_pk_date_objet_seq; Type: SEQUENCE SET; Schema: objets; Owner: -
--

SELECT pg_catalog.setval('date_objet_pk_date_objet_seq', 809, true);


--
-- TOC entry 2396 (class 0 OID 22737)
-- Dependencies: 179
-- Data for Name: nom_objet; Type: TABLE DATA; Schema: objets; Owner: -
--

INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (8, 'concerner', NULL, NULL, 10, true, '2015-09-30 17:45:49.20009+02', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (9, 'Naissance', NULL, NULL, 11, true, '2015-09-30 17:52:16.518456+02', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (10, 'Naissance', NULL, NULL, 12, true, '2015-09-30 17:53:02.319296+02', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (11, 'Naissance de Kepler', NULL, NULL, 13, true, '2015-09-30 17:56:09.260378+02', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (36, 'Haincmar de Reims, (titre), ed. par NN (Patrologia latina, 612), Paris 1860', NULL, NULL, 35, true, '2015-10-13 17:46:12.942494+02', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (4, 'Astronomie', NULL, NULL, 6, true, '2015-09-28 21:48:24.513948+02', '2015-10-02 23:15:26.894269+02', 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (6, 'Element biographique', NULL, NULL, 8, true, '2015-09-30 17:26:14.167382+02', '2015-10-04 07:38:56.716102+02', 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (12, 'Caractérisation synthètique', NULL, NULL, 14, true, '2015-09-30 23:14:59.243403+02', '2015-10-04 07:39:28.32644+02', 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (39, 'Willem Jacob''s Gravesande', NULL, NULL, 829, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (16, 'Philosophe', NULL, NULL, 18, true, '2015-10-04 08:15:39.193019+02', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (40, 'Chrysologue de Gy', NULL, NULL, 830, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (41, 'Jean-Antoine-Nicolas de Caritat Condorcet', NULL, NULL, 831, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (17, 'Savant', NULL, NULL, 19, true, '2015-10-04 08:38:15.524569+02', '2015-10-04 08:38:35.212498+02', 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (42, 'Georg Matthias Bose', NULL, NULL, 832, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (43, 'Blaise Pascal', NULL, NULL, 833, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (44, 'Jean Chappe d''Auteroche', NULL, NULL, 834, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (45, 'Giovanni Benedetto Moncetto', NULL, NULL, 835, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (18, 'Notice', NULL, NULL, 20, true, '2015-10-04 10:40:12.841066+02', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (46, 'Johannes Nicolaus Frobesius', NULL, NULL, 836, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (47, 'François Jacquier', NULL, NULL, 837, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (48, 'Gerard Keulen', NULL, NULL, 838, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (49, 'Joseph-François Marie', NULL, NULL, 839, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (35, 'Source', NULL, NULL, 34, true, '2015-10-13 17:42:49.184459+02', '2015-11-09 19:02:28.873888+01', 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (1, 'Kepler, Jean', NULL, NULL, 2, true, '2015-09-25 22:42:29.469598+02', '2015-10-04 22:52:57.837407+02', 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (19, 'Galilei, Galileo', NULL, NULL, 7, true, '2015-10-04 23:06:33.201954+02', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (20, 'Weil der Stadt', NULL, NULL, 21, true, '2015-10-05 08:46:30.390569+02', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (21, 'localiser', NULL, NULL, 22, true, '2015-10-05 08:48:23.727187+02', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (22, 'naître', NULL, NULL, 23, true, '2015-10-05 08:59:20.720318+02', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (14, 'Mathématicien', NULL, NULL, 16, true, '2015-10-03 09:57:19.385319+02', '2015-10-05 09:08:21.000977+02', 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (15, 'Nicolas Claude Fabri de Peiresc', NULL, NULL, 17, true, '2015-10-03 09:57:48.242165+02', '2015-10-05 13:51:05.754774+02', 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (13, 'Mathématiques', NULL, NULL, 15, true, '2015-10-02 23:54:54.414336+02', '2015-10-05 13:52:36.540175+02', 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (24, 'Astrologue', NULL, NULL, 25, true, '2015-10-06 04:36:45.268944+02', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (23, 'Astronome', NULL, NULL, 24, true, '2015-10-06 04:31:50.321678+02', '2015-10-06 04:40:17.798511+02', 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (50, 'Giovanni Maria Bonardo', NULL, NULL, 840, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (51, 'John Flamsteed', NULL, NULL, 841, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (52, 'Nicolaas Hartsoeker', NULL, NULL, 842, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (25, 'Écrivain', NULL, NULL, 26, true, '2015-10-06 15:18:36.039768+02', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (26, 'Grammairien', NULL, NULL, 27, true, '2015-10-06 22:29:01.129391+02', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (27, 'Médecin', NULL, NULL, 28, true, '2015-10-06 22:31:41.356626+02', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (28, 'Géographe', NULL, NULL, 29, true, '2015-10-06 22:43:37.318267+02', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (53, 'Hector-Jean Legros', NULL, NULL, 843, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (54, 'Giammaria Ortes', NULL, NULL, 844, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (3, 'Notices tirées de la BNF', NULL, NULL, 5, true, '2015-09-26 10:20:04.358098+02', '2015-10-07 11:07:56.252943+02', 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (29, 'Nicolas Copernic', 'fra', NULL, 30, true, '2015-10-13 15:01:29.86825+02', '2015-10-13 15:06:25.611116+02', 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (30, 'Mikołaj Kopernik', 'pol', 'Vérifier le code du nom', 30, false, '2015-10-13 15:07:15.243613+02', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (55, 'Jean de Murs', NULL, NULL, 845, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (56, 'Maḥmūd ibn Mas´ūd Quṭb al-Dīn al- Šīrāzī', NULL, NULL, 846, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (32, 'Maffeo Barberini', NULL, NULL, 31, false, '2015-10-13 15:12:33.247422+02', NULL, 15, NULL, '1623-08-05');
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (31, 'Urbain VIII', NULL, NULL, 31, true, '2015-10-13 15:09:58.391533+02', '2015-10-13 15:13:25.58489+02', 12, '1623-08-06', NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (33, 'Kepler [Texte imprimé] : la physique céleste : autour de l''"Astronomia Nova" (1609)
Les Belles Lettres / 2011', NULL, NULL, 32, true, '2015-10-13 15:37:11.24158+02', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (34, 'Mes notes sur le livre : Kpler ...', NULL, NULL, 33, true, '2015-10-13 15:43:05.942249+02', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (57, 'Marinus Ghetaldus', NULL, NULL, 847, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (58, 'Sybrandt Hansz. Cardinael', NULL, NULL, 848, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (59, 'Petrus Philomena de Dacia', NULL, NULL, 849, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (60, 'Jean Péna', NULL, NULL, 850, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (61, 'Blaise-François de Pagan', NULL, NULL, 851, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (62, 'al-Muẓaffar ibn Muḥammad Šaraf al-Dīn Ṭūsī', NULL, NULL, 852, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (63, 'Jean Tarde', NULL, NULL, 853, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (64, 'Carlos de Sigüenza y Góngora', NULL, NULL, 854, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (65, 'Girolamo Mercurio', NULL, NULL, 855, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (66, 'Arent Roggeveen', NULL, NULL, 856, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (67, 'Daniel Mögling', NULL, NULL, 857, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (68, 'Flecheux', NULL, NULL, 858, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (69, 'Pierre Petit', NULL, NULL, 859, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (70, 'Tommaso Cornelio', NULL, NULL, 860, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (71, 'Johann Faulhaber', NULL, NULL, 861, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (72, 'Alexandre Ruelle', NULL, NULL, 862, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (73, 'Brook Taylor', NULL, NULL, 863, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (74, 'Bernard Violle', NULL, NULL, 864, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (75, 'Francisco Zarzoso', NULL, NULL, 865, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (76, 'Pierre Gassendi', NULL, NULL, 866, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (77, 'Benedetto Castelli', NULL, NULL, 867, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (78, 'Charles Walmesley', NULL, NULL, 868, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (79, 'Johannes Hudde', NULL, NULL, 869, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (80, 'Giovanni Francesco Mauro Melchior Salvemini da Castiglione', NULL, NULL, 870, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (81, 'Henri Jurain', NULL, NULL, 871, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (82, 'Pierre de Fermat', NULL, NULL, 872, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (83, 'Philippus Lansbergen', NULL, NULL, 873, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (84, 'Le Demaine Godalles', NULL, NULL, 874, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (85, 'Jean-Jacques Dortous de Mairan', NULL, NULL, 875, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (86, 'Edme-Gilles Guyot', NULL, NULL, 876, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (87, 'Jordanus Nemorarius', NULL, NULL, 877, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (7, 'Résumé de la notice', NULL, NULL, 9, true, '2015-09-30 17:31:31.168992+02', '2015-11-09 19:05:25.836996+01', 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (2, 'Notices issues de fr.wikipedia', NULL, NULL, 3, true, '2015-09-25 22:44:01.114866+02', '2015-11-10 15:29:26.376954+01', 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (37, 'Notices BNF avec annotation sémantique', NULL, NULL, 36, true, '2015-11-05 22:03:44.180655+01', '2015-11-25 08:58:06.819811+01', 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (38, 'Notices BNF avec ''ud''', NULL, NULL, 37, true, '2015-11-05 22:11:29.331634+01', '2015-11-11 23:16:39.658673+01', 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (88, 'Paolo Mattia Doria', NULL, NULL, 878, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (89, 'Johann Jacob ScheuchzerZ', NULL, NULL, 879, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (90, 'Dominique-François Rivard', NULL, NULL, 880, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (91, 'Baien Miura', NULL, NULL, 881, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (92, 'Maximilian Rassler', NULL, NULL, 882, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (93, 'Emmanuel ben Jacob de Tarascon Bonfils', NULL, NULL, 883, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (94, 'Joseph-Nicolas Delisle', NULL, NULL, 884, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (95, 'Jérôme de La Lande', NULL, NULL, 885, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (96, 'Adam Lonicer', NULL, NULL, 886, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (97, 'Girolamo Donato', NULL, NULL, 887, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (98, 'Jean Borrel', NULL, NULL, 888, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (99, 'Tadeáš Hájek', NULL, NULL, 889, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (100, 'P. Jacques de Guernisac', NULL, NULL, 890, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (101, 'Nicola Spedalieri', NULL, NULL, 891, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (102, 'Gaspar Torrella', NULL, NULL, 892, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (103, 'Antoine Thomas', NULL, NULL, 893, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (104, 'Jean Glover', NULL, NULL, 894, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (105, 'Hui Yang', NULL, NULL, 895, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (106, 'Girolamo Francisco Cristiani', NULL, NULL, 896, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (107, 'Giovanni Agostino Abate', NULL, NULL, 897, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (108, 'Julien Mahuet', NULL, NULL, 898, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (109, 'Gaspard-Clair-François-Marie Riche de Prony', NULL, NULL, 899, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (110, 'Giuseppe Unicorno', NULL, NULL, 900, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (111, 'Petrus Apian', NULL, NULL, 901, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (112, 'Florimond de Beaune', NULL, NULL, 902, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (113, 'Johann Ludwig Levin Gebhardi', NULL, NULL, 903, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (114, 'Grégoire Chioniadès', NULL, NULL, 904, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (115, 'Guillaume Hobit', NULL, NULL, 905, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (116, 'Claude-François Berthelot', NULL, NULL, 906, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (117, 'William Bayly', NULL, NULL, 907, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (118, 'Stanislaw Wydra', NULL, NULL, 908, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (119, 'Andreas Osiander', NULL, NULL, 909, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (120, 'John Wallis', NULL, NULL, 910, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (121, 'Jacques Poitevin', NULL, NULL, 911, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (122, 'Démétrius Triclinius', NULL, NULL, 912, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (123, 'Petrus Van Musschenbroek', NULL, NULL, 913, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (124, 'Pierre Méchain', NULL, NULL, 914, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (125, 'François-Joachim Duport-Dutertre', NULL, NULL, 915, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (126, 'Giovanni Bianchi', NULL, NULL, 916, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (127, 'Guillaume de Nautonier', NULL, NULL, 917, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (128, 'Alexis Claude Clairaut', NULL, NULL, 918, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (129, 'Johann Schöner', NULL, NULL, 919, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (130, 'Giovanni Antonio Magini', NULL, NULL, 920, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (131, 'Francesco Ottavio Magnocavalli', NULL, NULL, 921, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (132, 'Charles-Marie de La Condamine', NULL, NULL, 922, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (133, 'Andalò Di Negro', NULL, NULL, 923, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (134, 'Bhāskarācārya', NULL, NULL, 924, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (135, 'Thomas Bugge', NULL, NULL, 925, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (136, 'Pierre Bardin', NULL, NULL, 926, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (137, 'John Flamsteed', NULL, NULL, 927, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (138, 'Michel Mourgues', NULL, NULL, 928, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (139, 'Vérologue', NULL, NULL, 929, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (140, 'Carl-Christian von Langsdorf', NULL, NULL, 930, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (141, 'Georg Jonathan von Holland', NULL, NULL, 931, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (142, 'Christian Wolff', NULL, NULL, 932, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (143, 'Alessandro Marchetti', NULL, NULL, 933, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (144, 'Willem Gilliszoon', NULL, NULL, 934, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (145, 'Pierre Joseph de Rivaz', NULL, NULL, 935, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (146, 'Juanelo Turriano', NULL, NULL, 936, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (147, 'Johann Tobias Mayer', NULL, NULL, 937, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (148, 'Christiaan Huygens', NULL, NULL, 938, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (149, 'Ignace-Gaston Pardies', NULL, NULL, 939, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (150, 'John Keill', NULL, NULL, 940, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (151, 'Adam Adamady Kochánski', NULL, NULL, 941, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (152, 'Prospero Calano', NULL, NULL, 942, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (153, 'Jacob Golius', NULL, NULL, 943, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (154, 'Jean Le Febvre', NULL, NULL, 944, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (155, 'Josse Clicthove', NULL, NULL, 945, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (156, 'Jean Bertet', NULL, NULL, 946, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (157, 'Charles Bossut', NULL, NULL, 947, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (158, 'François Gattey', NULL, NULL, 948, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (159, 'Francisco Sánchez', NULL, NULL, 949, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (160, 'Étienne-Simon de Gamaches', NULL, NULL, 950, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (161, 'Anthoine Cathalan', NULL, NULL, 951, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (162, 'Antonio Eximeno', NULL, NULL, 952, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (163, 'Simon Stevin', NULL, NULL, 953, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (164, 'Jonas Moore', NULL, NULL, 954, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (165, 'Leonhard Christoph Sturm', NULL, NULL, 955, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (166, 'J.-B.-M. Duprat', NULL, NULL, 956, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (167, 'Johann Georg Locher', NULL, NULL, 957, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (168, 'Olaf Söderberg', NULL, NULL, 958, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (169, 'Galileo Galilei', NULL, NULL, 959, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (170, 'Nicolas Leverdé', NULL, NULL, 960, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (171, 'Girolamo Francastoro', NULL, NULL, 961, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (172, 'Pierre-Charles Le Monnier', NULL, NULL, 962, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (173, 'Georgius de Hungaria', NULL, NULL, 963, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (174, 'Gilles Personne de Roberval', NULL, NULL, 964, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (175, 'Giovanni Battista Crispo', NULL, NULL, 965, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (176, 'Philippe Desplaces', NULL, NULL, 966, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (177, 'Tobias Mayer', NULL, NULL, 967, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (178, 'Laura Bassi', NULL, NULL, 968, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (179, 'Garcia da Orta', NULL, NULL, 969, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (180, 'Jean de Seville', NULL, NULL, 970, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (181, 'Andrea Argoli', NULL, NULL, 971, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (182, 'Antoine Gaubil', NULL, NULL, 972, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (183, 'Claude-François Guillemeau de Fréval', NULL, NULL, 973, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (184, 'Philippe Avril', NULL, NULL, 974, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (185, 'Johann Jakob Zimmermann', NULL, NULL, 975, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (186, 'Caspar Wessel', NULL, NULL, 976, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (187, 'Christophorus Clavius', NULL, NULL, 977, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (188, 'Georg Wolfgang Krafft', NULL, NULL, 978, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (189, 'Thomas Fantet de Lagny', NULL, NULL, 979, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (190, 'James Dodson', NULL, NULL, 980, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (191, 'Jacques Peletier', NULL, NULL, 981, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (192, 'Pierre Le Voirier', NULL, NULL, 982, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (193, 'Pierre Bourdin', NULL, NULL, 983, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (194, 'Eliya Delmedigo', NULL, NULL, 984, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (195, 'Giordano Riccati', NULL, NULL, 985, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (196, 'Jacques-André Mallet', NULL, NULL, 986, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (197, 'Witelo', NULL, NULL, 987, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (198, 'Hermann Witekind', NULL, NULL, 988, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (199, 'Giovanni Paolo Gallucci', NULL, NULL, 989, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (200, 'Jacques Audierne', NULL, NULL, 990, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (201, 'Vincenzo Chiminello', NULL, NULL, 991, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (202, 'Caspar Dauthendey', NULL, NULL, 992, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (203, 'Edward Brerewood', NULL, NULL, 993, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (204, 'Nicolas-Antoine Nouet', NULL, NULL, 994, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (205, 'Francesco Maria Grimaldi', NULL, NULL, 995, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (206, 'Jacopo Belgrado', NULL, NULL, 996, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (207, 'Giuseppe Piazzi', NULL, NULL, 997, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (208, 'Joseph-Louis Lagrange', NULL, NULL, 998, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (209, 'Johannes Dryander', NULL, NULL, 999, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (210, 'Julius Reichelt', NULL, NULL, 1000, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (211, 'Guillaume Le Blond', NULL, NULL, 1001, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (212, 'Jean-Baptiste Pérès', NULL, NULL, 1002, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (213, 'Gaetano Del Ricco', NULL, NULL, 1003, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (214, 'Nicodemus Frischlin', NULL, NULL, 1004, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (215, 'Johann Stöffler', NULL, NULL, 1005, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (216, 'Gregorio Fontana', NULL, NULL, 1006, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (217, 'Charles de Bovelles', NULL, NULL, 1007, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (218, 'Philipp Müller', NULL, NULL, 1008, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (219, 'Johan de Witt', NULL, NULL, 1009, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (220, 'Denis Papin', NULL, NULL, 1010, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (221, 'Guillaume Delisle', NULL, NULL, 1011, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (222, 'Adriaan Vlacq', NULL, NULL, 1012, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (223, 'Jean Bachou', NULL, NULL, 1013, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (224, 'John Nourse', NULL, NULL, 1014, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (225, 'Nicolas Charles Romme', NULL, NULL, 1015, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (226, 'Joseph Mouchet', NULL, NULL, 1016, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (227, 'Georg von Peurbach', NULL, NULL, 1017, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (228, 'Jean-Matthieu de Chazelles', NULL, NULL, 1018, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (229, 'Marie de La Fresnaye', NULL, NULL, 1019, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (230, 'Colin Mackenzie', NULL, NULL, 1020, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (231, 'Joseph Saurin', NULL, NULL, 1021, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (232, 'Nicolas Antoine Guillard', NULL, NULL, 1022, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (233, 'Paolino Chelucci', NULL, NULL, 1023, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (234, 'Louis Lecomte', NULL, NULL, 1024, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (235, 'Thaddäus Rinderle', NULL, NULL, 1025, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (236, 'Humphry Ditton', NULL, NULL, 1026, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (237, 'Jens Kraft', NULL, NULL, 1027, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (238, 'Paolo Antonio Foscarini', NULL, NULL, 1028, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (239, 'Jean-Pierre de Crousaz', NULL, NULL, 1029, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (240, 'Johann Andreas von Segner', NULL, NULL, 1030, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (241, 'J.P. Audiffred', NULL, NULL, 1031, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (242, 'Federico Gualdi', NULL, NULL, 1032, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (243, 'Johann Nicolai Tetens', NULL, NULL, 1033, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (244, 'Nicolas Bernoulli', NULL, NULL, 1034, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (245, 'Nicole-Reine Lepaute', NULL, NULL, 1035, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (246, 'Paolo Frisi', NULL, NULL, 1036, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (247, 'Luca Pacioli', NULL, NULL, 1037, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (248, 'Jean-Édouard Du Monin', NULL, NULL, 1038, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (249, 'Gabriel Cramer', NULL, NULL, 1039, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (250, 'Jean-Baptiste Labey', NULL, NULL, 1040, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (251, 'Elias van Lennep', NULL, NULL, 1041, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (252, 'Elena Lucrezia Cornaro Piscopia', NULL, NULL, 1042, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (253, 'Martin Basanier', NULL, NULL, 1043, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (254, 'Nicolaus Reimarus Ursus', NULL, NULL, 1044, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (255, 'Pierre Varignon', NULL, NULL, 1045, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (256, 'Diderich Christian Fester', NULL, NULL, 1046, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (257, 'Ǧamšīd ibn Masʿūd Ġiyāṯ al-Dīn al- Kāšī', NULL, NULL, 1047, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (258, 'René Gaultier de Maignannes', NULL, NULL, 1048, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (259, 'Jean-Mathieu de Chazelles', NULL, NULL, 1049, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (260, 'Adam Olearius', NULL, NULL, 1050, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (261, 'Achille Pierre Dionis du Séjour', NULL, NULL, 1051, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (262, 'Philippe de La Hire', NULL, NULL, 1052, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (263, 'Hermann de Carinthie', NULL, NULL, 1053, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (264, 'Joseph Mollet', NULL, NULL, 1054, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (265, 'Johann Hecker', NULL, NULL, 1055, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (266, 'Guido Grandi', NULL, NULL, 1056, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (267, 'Michelangelo Fardella', NULL, NULL, 1057, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (268, 'William Welwod', NULL, NULL, 1058, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (269, 'Allain Manesson-Mallet', NULL, NULL, 1059, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (270, 'Mathurin-Georges Girault de Keroudou', NULL, NULL, 1060, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (271, 'Trabaud', NULL, NULL, 1061, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (272, 'Bonaventura Cavalieri', NULL, NULL, 1062, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (273, 'Melchior Inchofer', NULL, NULL, 1063, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (274, 'François de Aguilón', NULL, NULL, 1064, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (275, 'Marie-Louise Cartan', NULL, NULL, 1065, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (276, 'Jacob Köbel', NULL, NULL, 1066, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (277, 'Rāmacandrācārya', NULL, NULL, 1067, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (278, 'Claude Richer', NULL, NULL, 1068, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (279, 'Ercole Bottrigari', NULL, NULL, 1069, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (280, 'Erasmus Schmied', NULL, NULL, 1070, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (281, 'Francesco Venini', NULL, NULL, 1071, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (282, 'Michael Stifel', NULL, NULL, 1072, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (283, 'Andreas Cellarius', NULL, NULL, 1073, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (284, 'Octavio Pisani', NULL, NULL, 1074, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (285, 'Nicolas-Maurice Chompré', NULL, NULL, 1075, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (286, 'Jan Chrzciciel Władysław Śniadecki', NULL, NULL, 1076, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (287, 'Agostino Ricci', NULL, NULL, 1077, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (288, 'Antoine de Laloubère', NULL, NULL, 1078, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (289, 'Tommaso Ceva', NULL, NULL, 1079, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (290, 'Alessandro Piccolomini', NULL, NULL, 1080, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (291, 'Jean-Claude-Gauthier-Louis de Benaben', NULL, NULL, 1081, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (292, 'Ehrenfried Walter von Tschirnhaus', NULL, NULL, 1082, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (293, 'Philippe Naudé', NULL, NULL, 1083, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (294, 'Renward Cysat', NULL, NULL, 1084, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (295, 'Johann Elert Bode', NULL, NULL, 1085, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (296, 'Thomas Bradwardine', NULL, NULL, 1086, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (297, 'Francesco Levera', NULL, NULL, 1087, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (298, 'Guisnée', NULL, NULL, 1088, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (299, 'Jean-François Gerbillon', NULL, NULL, 1089, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (300, 'José Antonio Alzate y Ramírez', NULL, NULL, 1090, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (301, 'Jean-Dominique Cassini', NULL, NULL, 1091, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (302, 'Albert Girard', NULL, NULL, 1092, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (303, 'Francesco Lana Terzi', NULL, NULL, 1093, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (304, 'Pietro Cataneo', NULL, NULL, 1094, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (305, 'Bartholomäus Pitiscus', NULL, NULL, 1095, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (306, 'John Ray', NULL, NULL, 1096, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (307, 'Simon Tyssot de Patot', NULL, NULL, 1097, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (308, 'Nicolas B. Halma', NULL, NULL, 1098, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (309, 'William Whiston', NULL, NULL, 1099, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (310, 'Celio Calcagnini', NULL, NULL, 1100, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (311, 'Johannes Kepler', NULL, NULL, 1101, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (312, 'Samuel König', NULL, NULL, 1102, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (313, 'Jean François Nicéron', NULL, NULL, 1103, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (314, 'Alexandre-Gui Pingré', NULL, NULL, 1104, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (315, 'Henri Bouchon-Dubournial', NULL, NULL, 1105, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (316, 'Juan de Yciar', NULL, NULL, 1106, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (317, 'Jacques Mengau', NULL, NULL, 1107, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (318, 'Geminiano Montanari', NULL, NULL, 1108, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (319, 'Théodore Bouys', NULL, NULL, 1109, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (320, 'Camillo Guarino Guarini', NULL, NULL, 1110, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (321, 'Lorenzo Buonincontri', NULL, NULL, 1111, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (322, 'François Derand', NULL, NULL, 1112, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (323, 'Caroline Lucretia Herschel', NULL, NULL, 1113, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (324, 'Jacopo da Firenze', NULL, NULL, 1114, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (325, 'Girolamo Fracastoro', NULL, NULL, 1115, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (326, 'Johann Gabriel Doppelmayr', NULL, NULL, 1116, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (327, 'Esprit Pezenas', NULL, NULL, 1117, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (328, 'Jacopo Dondi', NULL, NULL, 1118, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (329, 'Louis Courcier', NULL, NULL, 1119, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (330, 'András Dugonics', NULL, NULL, 1120, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (331, 'Pietro Cossali', NULL, NULL, 1121, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (332, 'Jean Pecham', NULL, NULL, 1122, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (333, 'Camillo Agrippa', NULL, NULL, 1123, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (334, 'Isaac Barrow', NULL, NULL, 1124, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (335, 'Madame Bailly', NULL, NULL, 1125, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (336, 'Henri Baten', NULL, NULL, 1126, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (337, 'Naǧm al-Dīn al- Miṣrī', NULL, NULL, 1127, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (338, 'Jakob Ziegler', NULL, NULL, 1128, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (339, 'Jacques Besson', NULL, NULL, 1129, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (340, 'Jean-Dominique Cassini', NULL, NULL, 1130, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (341, 'Geršon ben Salomon d''Arles', NULL, NULL, 1131, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (342, 'Le Blanc', NULL, NULL, 1132, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (343, 'Joseph Anton Slop von Cadenberg', NULL, NULL, 1133, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (344, 'Johannes Regiomontanus', NULL, NULL, 1134, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (345, 'Jean-Paul de Gua de Malves', NULL, NULL, 1135, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (346, 'Cristóvão Ferreira', NULL, NULL, 1136, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (347, 'Scipione Chiaramonti', NULL, NULL, 1137, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (348, 'Firmin Abauzit', NULL, NULL, 1138, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (349, 'Bernardo Gamucci', NULL, NULL, 1139, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (350, 'Eberhard Welper', NULL, NULL, 1140, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (351, 'Pedro Ciruelo', NULL, NULL, 1141, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (352, 'Benedictus Aretius', NULL, NULL, 1142, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (353, 'François Barrême', NULL, NULL, 1143, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (354, 'Johannes de Sacro Bosco', NULL, NULL, 1144, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (355, 'Bernardino Baldi', NULL, NULL, 1145, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (356, 'Anders Celsius', NULL, NULL, 1146, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (357, 'Jean-Charles Borda', NULL, NULL, 1147, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (358, 'Emmanuel Maignan', NULL, NULL, 1148, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (359, 'Vannoccio Biringuccio', NULL, NULL, 1149, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (360, 'Juan Pérez de Moya', NULL, NULL, 1150, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (361, 'Guillelmus Beer', NULL, NULL, 1151, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (362, 'Melchior Ayrer', NULL, NULL, 1152, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (363, 'Guidobaldo Dal Monte', NULL, NULL, 1153, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (364, 'Petrus Ramus', NULL, NULL, 1154, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (365, 'Jean Picard', NULL, NULL, 1155, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (366, 'Tito Livio Burattini', NULL, NULL, 1156, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (367, 'Charles Messier', NULL, NULL, 1157, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (368, 'Joachim Jungius', NULL, NULL, 1158, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (369, 'César-François Cassini de Thury', NULL, NULL, 1159, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (370, 'Eugénios Voúlgaris', NULL, NULL, 1160, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (371, 'Vincenzo De Filippis', NULL, NULL, 1161, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (372, 'Johann Schultz', NULL, NULL, 1162, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (373, 'Didier Robert de Vaugondy', NULL, NULL, 1163, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (374, 'Jean-Pierre de Mesmes', NULL, NULL, 1164, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (375, 'John Craig', NULL, NULL, 1165, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (376, 'Vicente Tofiño de San Miguel', NULL, NULL, 1166, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (377, 'Luis Teixeira', NULL, NULL, 1167, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (378, 'Abraham Gotthelf Kästner', NULL, NULL, 1168, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (379, 'Giovanni Bianchini', NULL, NULL, 1169, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (380, 'Francesco Barozzi', NULL, NULL, 1170, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (381, 'Nicolaus Gugler', NULL, NULL, 1171, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (382, 'Niccolò Partenio Giannettasio', NULL, NULL, 1172, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (383, 'Sigismondo Fanti', NULL, NULL, 1173, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (384, 'Conradus Dasypodius', NULL, NULL, 1174, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (385, 'Tycho Brahe', NULL, NULL, 1175, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (386, 'Taqī al-Dīn Muḥammad Ibn Maʿrūf', NULL, NULL, 1176, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (387, 'Jacob Aertsz Colom', NULL, NULL, 1177, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (388, 'Claude-François Milliet de Chales', NULL, NULL, 1178, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (389, 'Josef Anton Nagel', NULL, NULL, 1179, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (390, 'Baudouin de Guémadeuc', NULL, NULL, 1180, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (391, 'Konrad Türst', NULL, NULL, 1181, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (392, 'Martinus Hortensius', NULL, NULL, 1182, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (393, 'Niccolò Zucchi', NULL, NULL, 1183, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (394, 'Charles Bossut', NULL, NULL, 1184, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (395, 'Giovanni Dondi dall''Orologio', NULL, NULL, 1185, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (396, 'Leonhard Euler', NULL, NULL, 1186, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (397, 'Nicolas-François Canard', NULL, NULL, 1187, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (398, 'ʿAlī ibn Muḥammad al- Qalaṣādī', NULL, NULL, 1188, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (399, 'Fabrizio Mordente', NULL, NULL, 1189, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (400, 'Giovanni di Strasoldo', NULL, NULL, 1190, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (401, 'Johannes Werner', NULL, NULL, 1191, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (402, 'Nicolas Bion', NULL, NULL, 1192, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (403, 'Jacques Maretz', NULL, NULL, 1193, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (404, 'Jean Gosselin', NULL, NULL, 1194, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (405, 'Robert Smith', NULL, NULL, 1195, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (406, 'János Sajnovics', NULL, NULL, 1196, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (407, 'Moḥamad ben Moḥamad Naṣīr al-Dīn Ṭōsī', NULL, NULL, 1197, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (408, 'Pierre Brumoy', NULL, NULL, 1198, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (409, 'Bernard-Laurent Soumille', NULL, NULL, 1199, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (410, 'Louis Godin', NULL, NULL, 1200, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (411, 'Mario Guiducci', NULL, NULL, 1201, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (412, 'Godfried Wendelen', NULL, NULL, 1202, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (413, 'Claude Irson', NULL, NULL, 1203, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (414, 'Simon Lhuilier', NULL, NULL, 1204, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (415, 'Barlaam de Seminara', NULL, NULL, 1205, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (416, 'Noël Regnault', NULL, NULL, 1206, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (417, 'Nicolas Copernic', NULL, NULL, 1207, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (418, 'Rheticus', NULL, NULL, 1208, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (419, 'Bernardino Zendrini', NULL, NULL, 1209, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (420, 'Nīlakaṇṭha Somayajī', NULL, NULL, 1210, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (421, 'Giovanni Battista Vertova', NULL, NULL, 1211, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (422, 'Pierre Tédenat', NULL, NULL, 1212, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (423, 'Jean-Louis Dupain-Triel', NULL, NULL, 1213, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (424, 'Alexandre de Villedieu', NULL, NULL, 1214, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (425, 'Francesco Feliciano', NULL, NULL, 1215, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (426, 'James Hume', NULL, NULL, 1216, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (427, 'Giovanni Giustino Ciampini', NULL, NULL, 1217, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (428, 'Giuseppe CalandrelliZ', NULL, NULL, 1218, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (429, 'René Descartes', NULL, NULL, 1219, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (430, 'Joseph-Aignan Sigaud de La Fond', NULL, NULL, 1220, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (431, 'Charles-Joseph Mathon de La Cour', NULL, NULL, 1221, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (432, 'Oronce Fine', NULL, NULL, 1222, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (433, 'Willebrordus Snellius', NULL, NULL, 1223, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (434, 'Thomas Lydyat', NULL, NULL, 1224, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (435, 'Johann Matthias Hase', NULL, NULL, 1225, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (436, 'Christfried Kirch', NULL, NULL, 1226, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (437, 'Giovanni Poleni', NULL, NULL, 1227, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (438, 'Louis-Bertrand Castel', NULL, NULL, 1228, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (439, 'Johann Tobias Mayer', NULL, NULL, 1229, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (440, 'Alexandre-Balthazar-Laurent Grimod de La Reynière', NULL, NULL, 1230, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (441, 'Giovanni Battista Amico', NULL, NULL, 1231, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (442, 'Helisaeus Röslin', NULL, NULL, 1232, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (443, 'Niccolò de Martino', NULL, NULL, 1233, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (444, 'Jean Bernoulli', NULL, NULL, 1234, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (445, 'Giovanni Antonio Tagliente', NULL, NULL, 1235, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (446, 'Eustachio Zanotti', NULL, NULL, 1236, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (447, 'Alexandre-Théophile Vandermonde', NULL, NULL, 1237, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (448, 'Antonio CagnoliZ', NULL, NULL, 1238, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (449, 'Théodore Métochite', NULL, NULL, 1239, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (450, 'Maurille-Antoine Moithey', NULL, NULL, 1240, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (451, 'Albert Pighius', NULL, NULL, 1241, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (452, 'Johannes Wilhelm Lauremberg', NULL, NULL, 1242, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (453, 'Antonio Maria Lorgna', NULL, NULL, 1243, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (454, 'Giovanni Battista Amici', NULL, NULL, 1244, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (455, 'Egnatio Danti', NULL, NULL, 1245, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (456, 'Juan de Caramuel y Lobkowitz', NULL, NULL, 1246, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (457, 'John Dee', NULL, NULL, 1247, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (458, 'Anders Bure', NULL, NULL, 1248, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (459, 'Ugolino Pisani', NULL, NULL, 1249, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (460, 'Girolamo Saccheri', NULL, NULL, 1250, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (461, 'Jai Singh', NULL, NULL, 1251, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (462, 'Barnaba Oriani', NULL, NULL, 1252, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (463, 'Pierre Jartoux', NULL, NULL, 1253, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (464, 'Valentin Mennher', NULL, NULL, 1254, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (465, 'Pedro Nunez', NULL, NULL, 1255, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (466, 'Joseph Salomon Delmedigo', NULL, NULL, 1256, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (467, 'Jean Du Temps', NULL, NULL, 1257, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (468, 'Joanne Westenburg', NULL, NULL, 1258, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (469, 'Jakob Bartsch', NULL, NULL, 1259, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (470, 'Katahiro Takebe', NULL, NULL, 1260, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (471, 'Christian Goldbach', NULL, NULL, 1261, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (472, 'Giovanni Battista Venturi', NULL, NULL, 1262, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (473, 'Charles Duvaucel', NULL, NULL, 1263, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (474, 'Thomas Abbt', NULL, NULL, 1264, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (475, 'Philips Mor', NULL, NULL, 1265, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (476, 'Jean-Baptiste Delambre', NULL, NULL, 1266, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (477, 'Charles Cavendish', NULL, NULL, 1267, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (478, 'Erhard Weigel', NULL, NULL, 1268, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (479, 'Ismaël Boulliau', NULL, NULL, 1269, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (480, 'Matthias Bernegger', NULL, NULL, 1270, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (481, 'Muḥammad ibn al-Ḥusayan Bahāʼ al-Dīn ʿĀmilī', NULL, NULL, 1271, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (482, 'Guangqi Xu', NULL, NULL, 1272, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (483, 'Lorenzo Mascheroni', NULL, NULL, 1273, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (484, 'Gerhard Wolter Molanus', NULL, NULL, 1274, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (485, 'Bingzhen Jiao', NULL, NULL, 1275, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (486, 'Ernst Gottfried Fischer', NULL, NULL, 1276, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (487, 'Yves-Marie André', NULL, NULL, 1277, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (488, 'Pedro Nunes', NULL, NULL, 1278, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (489, 'Mario Bettini', NULL, NULL, 1279, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (490, 'Samuel Morland', NULL, NULL, 1280, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (491, 'Michel Coignet', NULL, NULL, 1281, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (492, 'Jean-Baptiste Delure', NULL, NULL, 1282, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (493, 'Giovanni Pontano', NULL, NULL, 1283, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (494, 'Peter Laicksteen', NULL, NULL, 1284, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (495, 'Christoph Meurer', NULL, NULL, 1285, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (496, 'Faustus Verantius', NULL, NULL, 1286, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (497, 'Abraham de Moivre', NULL, NULL, 1287, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (498, 'Walther Hermann Ryff', NULL, NULL, 1288, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (499, 'Pietro Mengoli', NULL, NULL, 1289, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (500, 'Pierre Ango', NULL, NULL, 1290, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (501, 'Ovidio Montalbani', NULL, NULL, 1291, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (502, 'Michel Rolle', NULL, NULL, 1292, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (503, 'Jean Maria Coloni', NULL, NULL, 1293, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (504, 'Orazio Grassi', NULL, NULL, 1294, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (505, 'Marco Antonio De Dominis', NULL, NULL, 1295, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (506, 'Edmund Halley', NULL, NULL, 1296, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (507, 'Johann Gabriel Doppelmayr', NULL, NULL, 1297, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (508, 'Jacques de Billy', NULL, NULL, 1298, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (509, 'Jacques Baradelle', NULL, NULL, 1299, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (510, 'Claude Mydorge', NULL, NULL, 1300, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (511, 'G.-F. Olivier', NULL, NULL, 1301, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (512, 'Thomas Keith', NULL, NULL, 1302, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (513, 'Federico Commandino', NULL, NULL, 1303, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (514, 'José Chaffrion', NULL, NULL, 1304, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (515, 'Pierre-Louis Moreau de Maupertuis', NULL, NULL, 1305, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (516, 'al-Mufaḍḍal ibn ʿUmar Aṯīr al-Dīn al-Abharī', NULL, NULL, 1306, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (517, 'Thomas Hariot', NULL, NULL, 1307, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (518, 'Giovanni Branca', NULL, NULL, 1308, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (519, 'Johann Balthasar Lauterbach', NULL, NULL, 1309, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (520, 'François-César Le Tellier Courtanvaux', NULL, NULL, 1310, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (521, 'Francis Van Schoten', NULL, NULL, 1311, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (522, 'Claude-Gaspard Bachet', NULL, NULL, 1312, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (523, 'Joseph-Louis Vincens de Mauléon de Causans', NULL, NULL, 1313, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (524, 'Giovanni Battista Hodierna', NULL, NULL, 1314, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (525, 'Giuseppe Toaldo', NULL, NULL, 1315, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (526, 'Antoine Deparcieux', NULL, NULL, 1316, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (527, 'Johann Carion', NULL, NULL, 1317, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (528, 'Anthelme', NULL, NULL, 1318, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (529, 'Joachim d'' Alencé', NULL, NULL, 1319, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (530, 'Théodore Méliténiote', NULL, NULL, 1320, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (531, 'Eusebio Francisco Kino', NULL, NULL, 1321, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (532, 'Johann Hieronymus Schröter', NULL, NULL, 1322, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (533, 'Marc-Auguste Pictet', NULL, NULL, 1323, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (534, 'Richard of Wallingford', NULL, NULL, 1324, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (535, 'Rigobert Bonne', NULL, NULL, 1325, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (536, 'Bartolomeo da Messina', NULL, NULL, 1326, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (537, 'Juan de Rojas Sarmiento', NULL, NULL, 1327, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (538, 'Guillaume-Hyacinthe-Joseph-Jean-Baptiste Le Gentil de La Galaisière', NULL, NULL, 1328, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (539, 'Pierre Rémond de Montmort', NULL, NULL, 1329, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (540, 'Jean Tagaut', NULL, NULL, 1330, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (541, 'Samuel Horsley', NULL, NULL, 1331, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (542, 'Antide Janvier', NULL, NULL, 1332, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (543, 'Louis Boulengier', NULL, NULL, 1333, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (544, 'Etienne Lenoir', NULL, NULL, 1334, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (545, 'Jean-Henri Lambert', NULL, NULL, 1335, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (546, 'Ermenegildo Pini', NULL, NULL, 1336, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (547, 'Christoph Wittich', NULL, NULL, 1337, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (548, 'Georg Christoph Eimmart', NULL, NULL, 1338, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (549, 'Bartolomeo da Parma', NULL, NULL, 1339, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (550, 'François Viète', NULL, NULL, 1340, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (551, 'Giovanni-Antonio Rizzi-Zannoni', NULL, NULL, 1341, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (552, 'P. Christoph Grienberger', NULL, NULL, 1342, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (553, 'Cornelius Blockland', NULL, NULL, 1343, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (554, 'Jean-Étienne Montucla', NULL, NULL, 1344, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (555, 'Johann Hartmann', NULL, NULL, 1345, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (556, 'István Hatvani', NULL, NULL, 1346, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (557, 'Fulcrand Jean Joseph Aigrefeuille', NULL, NULL, 1347, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (558, 'Emmanuel-Étienne Duvillard de Durand', NULL, NULL, 1348, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (559, 'Giovanni Battista Audiffredi', NULL, NULL, 1349, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (560, 'Maria Gaetana Agnesi', NULL, NULL, 1350, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (561, 'Cormopede', NULL, NULL, 1351, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (562, 'Christoph Scheiner', NULL, NULL, 1352, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (563, 'Jean Leurechon', NULL, NULL, 1353, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (564, 'Jean-Baptiste Meusnier de La Place', NULL, NULL, 1354, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (565, 'Johannes Isaacus Pontanus', NULL, NULL, 1355, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (566, 'Jeronimo Munoz', NULL, NULL, 1356, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (567, 'Giovanni Battista Benedetti', NULL, NULL, 1357, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (568, 'Paul Yvon', NULL, NULL, 1358, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (569, 'Franz von Paula Triesnecker', NULL, NULL, 1359, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (570, 'Christen Sørensen Longomontanus', NULL, NULL, 1360, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (571, 'Leonardo Fibonacci', NULL, NULL, 1361, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (572, 'Jean Tarde', NULL, NULL, 1362, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (573, 'Francesco Bianchini', NULL, NULL, 1363, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (574, 'Louis-François-Antoine Arbogast', NULL, NULL, 1364, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (575, 'Jan Heweliusz', NULL, NULL, 1365, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (576, 'Vincenzo Viviani', NULL, NULL, 1366, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (577, 'Charles-Étienne-Louis Camus', NULL, NULL, 1367, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (578, 'Scipione Breislak', NULL, NULL, 1368, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (579, 'Jacob ben Machir', NULL, NULL, 1369, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (580, 'Rasmus Bartholin', NULL, NULL, 1370, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (581, 'Jacques Ozanam', NULL, NULL, 1371, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (582, 'de La Roche', NULL, NULL, 1372, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (583, 'Gemma Frisius', NULL, NULL, 1373, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (584, 'Jean Cousin', NULL, NULL, 1374, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (585, 'Antoine de La Salle', NULL, NULL, 1375, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (586, 'Johann Adam Schall von Bell', NULL, NULL, 1376, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (587, 'Heinrich Scherer', NULL, NULL, 1377, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (588, 'François Chevalier', NULL, NULL, 1378, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (589, 'Willem Jansz Blaeu', NULL, NULL, 1379, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (590, 'Guillaume-François-Antoine de L''Hospital', NULL, NULL, 1380, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (591, 'Adrianus Romanus', NULL, NULL, 1381, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (592, 'Giuseppe Moletti', NULL, NULL, 1382, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (593, 'Jacques-François Dicquemare', NULL, NULL, 1383, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (594, 'Mutio Oddi', NULL, NULL, 1384, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (595, 'Philip Lea', NULL, NULL, 1385, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (596, 'Mathieu Bernard Goudin', NULL, NULL, 1386, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (597, 'Jean Foucaud', NULL, NULL, 1387, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (598, 'Rugerius Josephus Boscovich', NULL, NULL, 1388, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (599, 'Eilhard Lubin', NULL, NULL, 1389, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (600, 'David François de Merveilleux', NULL, NULL, 1390, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (601, 'Charles-Étienne Coquebert de Montbret', NULL, NULL, 1391, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (602, 'Niccolò Tartaglia', NULL, NULL, 1392, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (603, 'Athanasius Kircher', NULL, NULL, 1393, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (604, 'D'' Alembert', NULL, NULL, 1394, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (605, 'Filippo Finella', NULL, NULL, 1395, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (606, 'Agricol-Joseph-François-Xavier-Pierre-Esprit-Simon-Paul-Antoine Fortia d''Urban', NULL, NULL, 1396, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (607, 'Jean-Baptiste Bernard', NULL, NULL, 1397, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (608, 'Franz Xaver von Zach', NULL, NULL, 1398, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (609, 'Bazaine', NULL, NULL, 1399, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (610, 'Phillebert Charpentier', NULL, NULL, 1400, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (611, 'Ole Rømer', NULL, NULL, 1401, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (612, 'Jost Bürgi', NULL, NULL, 1402, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (613, 'José Quiroga', NULL, NULL, 1403, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (614, 'Ciriaco Strozzi', NULL, NULL, 1404, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (615, 'Wilhelm Schickard', NULL, NULL, 1405, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (616, 'James Gregory', NULL, NULL, 1406, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (617, 'Roger Cotes', NULL, NULL, 1407, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (618, 'Jean Terrasson', NULL, NULL, 1408, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (619, 'Jean-Baptiste de Laborde', NULL, NULL, 1409, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (620, 'Pierre Hérigone', NULL, NULL, 1410, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (621, 'Gaspar Schott', NULL, NULL, 1411, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (622, 'John Napier', NULL, NULL, 1412, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (623, 'Marc Duncan', NULL, NULL, 1413, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (624, 'Evangelista Torricelli', NULL, NULL, 1414, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (625, 'Jean-Louis Pictet', NULL, NULL, 1415, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (626, 'Nicolas-Claude Duval-Le Roy', NULL, NULL, 1416, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (627, 'Johann Christoph Schuster', NULL, NULL, 1417, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (628, 'Blasius de Parma', NULL, NULL, 1418, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (629, 'François Noël', NULL, NULL, 1419, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (630, 'Jean Sylvain Bailly', NULL, NULL, 1420, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (631, 'Jean-Baptiste Morin', NULL, NULL, 1421, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (632, 'Jacob Hermann', NULL, NULL, 1422, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (633, 'Jacob Christmann', NULL, NULL, 1423, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (634, 'Gaspard Monge', NULL, NULL, 1424, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (635, 'Paolo dal Pozzo Toscanelli', NULL, NULL, 1425, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (636, 'Jacques Bernoulli', NULL, NULL, 1426, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (637, 'Gaspard-François-Anne de Forbin', NULL, NULL, 1427, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (638, 'Alexis Rochon', NULL, NULL, 1428, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (639, 'François Chauveau', NULL, NULL, 1429, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (640, 'Giacomo Oddi', NULL, NULL, 1430, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (641, 'Gerolamo Cardano', NULL, NULL, 1431, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (642, 'Gerard Mercator', NULL, NULL, 1432, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (643, 'Johann Friedrich Weidler', NULL, NULL, 1433, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (644, 'Sámuel Mikoviny', NULL, NULL, 1434, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (645, 'Thomas Le Seur', NULL, NULL, 1435, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (646, 'ʿAbd al-Ġaffār ibn ʿAbd al-Karīm Naǧm al-Dīn al- Qazwīnī', NULL, NULL, 1436, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (647, 'Sethus Calvisius', NULL, NULL, 1437, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (648, 'Paul-Louis Cirodde', NULL, NULL, 1438, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (649, 'Eberhard August Wilhelm von Zimmermann', NULL, NULL, 1439, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (650, 'Achille Pirminius Gasser', NULL, NULL, 1440, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (651, 'Michael Floris Van Langren', NULL, NULL, 1441, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (652, 'William Faden', NULL, NULL, 1442, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (653, 'Jacques Bassantin', NULL, NULL, 1443, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (654, 'Jean-Edme Gallimard', NULL, NULL, 1444, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (655, 'Jean Jombert', NULL, NULL, 1445, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (656, 'Harald Vallerius', NULL, NULL, 1446, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (657, 'Louis Duprat-Duverger', NULL, NULL, 1447, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (658, 'Louis-Jacques Goussier', NULL, NULL, 1448, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (659, 'Abū ʿAbd Allâh Muḥammad al- Baqqār', NULL, NULL, 1449, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (660, 'Andrea Corsali', NULL, NULL, 1450, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (661, 'Sebastian Münster', NULL, NULL, 1451, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (662, 'Johann Bernoulli', NULL, NULL, 1452, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (663, 'François Callet', NULL, NULL, 1453, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (664, 'Nicolas-Claude Fabri Peiresc', NULL, NULL, 1454, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (665, 'Cosimo Bartoli', NULL, NULL, 1455, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (666, 'Thomas Harriot', NULL, NULL, 1456, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (667, 'Bartolomeo Crescenzio', NULL, NULL, 1457, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (668, 'al-Silahî Nasuh', NULL, NULL, 1458, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (669, 'Andreas Riedel', NULL, NULL, 1459, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (670, 'Pons-Joseph Bernard', NULL, NULL, 1460, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (671, 'Fr. François d'' Aguillon', NULL, NULL, 1461, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (672, 'Claude de Visdelou', NULL, NULL, 1462, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (673, 'Jamet Mettayer', NULL, NULL, 1463, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (674, 'Jean Brohon', NULL, NULL, 1464, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (675, 'Giovanni Battista Riccioli', NULL, NULL, 1465, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (676, 'Louis Feuillée', NULL, NULL, 1466, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (677, 'Giovan Battista Nicolosi', NULL, NULL, 1467, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (678, 'Le P.  Chrysologue', NULL, NULL, 1468, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (679, 'Joachim Sterck van Ringelberg', NULL, NULL, 1469, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (680, 'Giacomo Lanteri', NULL, NULL, 1470, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (681, 'Georg Ludwig Frobenius', NULL, NULL, 1471, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (682, 'Louis Bourguet', NULL, NULL, 1472, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (683, 'Philip Apian', NULL, NULL, 1473, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (684, 'José Anastácio da Cunha', NULL, NULL, 1474, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (685, 'Donato Rossetti', NULL, NULL, 1475, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (686, 'Giuseppe Maria Pagnini', NULL, NULL, 1476, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (687, 'Heinrich Schreiber', NULL, NULL, 1477, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (688, 'Teodato Osio', NULL, NULL, 1478, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (689, 'Giovanni Gaetano Bottari', NULL, NULL, 1479, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (690, 'Le Ratz de Lanthenée', NULL, NULL, 1480, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (691, 'Pierre-Thomas Antelmy', NULL, NULL, 1481, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (692, 'Paschasius Hamellius', NULL, NULL, 1482, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (693, 'Gottfried Ploucquet', NULL, NULL, 1483, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (694, 'Prosdocimus de Beldemandis', NULL, NULL, 1484, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (695, 'Adrien Auzout', NULL, NULL, 1485, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (696, 'Lothar Zumbach von Coesfeld', NULL, NULL, 1486, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (697, 'Gabriel Philippe de La Hire', NULL, NULL, 1487, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (698, 'Gilbert Romme', NULL, NULL, 1488, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (699, 'Bonaventure Abat', NULL, NULL, 1489, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (700, 'Grégoire de Saint-Vincent', NULL, NULL, 1490, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (701, 'Antoine-François Payen', NULL, NULL, 1491, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (702, 'Colin MacLaurin', NULL, NULL, 1492, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (703, 'James Stirling', NULL, NULL, 1493, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (704, 'Daniel Bernoulli', NULL, NULL, 1494, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (705, 'Abbé Deidier', NULL, NULL, 1495, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (706, 'Pierre-Simon de Laplace', NULL, NULL, 1496, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (707, 'Didier Henrion', NULL, NULL, 1497, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (708, 'Pierre-René-Auguste Bremond d''Ars', NULL, NULL, 1498, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (709, 'Étienne Bezout', NULL, NULL, 1499, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (710, 'Jean-Philippe Loys de Chéseaux', NULL, NULL, 1500, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (711, 'Girolamo Settimo', NULL, NULL, 1501, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (712, 'Isaac Newton', NULL, NULL, 1502, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (713, 'Robert Simson', NULL, NULL, 1503, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (714, 'Alliette', NULL, NULL, 1504, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (715, 'Edme-Sébastien Jeaurat', NULL, NULL, 1505, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (716, 'Alexandre Anderson', NULL, NULL, 1506, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (717, 'Józef Naronowicz-Naroński', NULL, NULL, 1507, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (718, 'Johann Andreas Planer', NULL, NULL, 1508, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (719, 'David ben Yom-Tov Poel', NULL, NULL, 1509, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (720, 'Cornelius Drebbel', NULL, NULL, 1510, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (721, 'Claude Hardy', NULL, NULL, 1511, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (722, 'Joseph Privat de Molières', NULL, NULL, 1512, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (723, 'Marin Mersenne', NULL, NULL, 1513, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (724, 'Tilemann Stella', NULL, NULL, 1514, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (725, 'Tommaso Valperga di Caluso', NULL, NULL, 1515, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (726, 'Bernardino Baldini', NULL, NULL, 1516, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (727, 'Louis-Charles Desnos', NULL, NULL, 1517, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (728, 'William Herschel', NULL, NULL, 1518, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (729, 'André-Charles Brotier', NULL, NULL, 1519, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (730, 'Bernard Nieuwentijt', NULL, NULL, 1520, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (731, 'William Molyneux', NULL, NULL, 1521, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (732, 'Lodovico Pontico Virunio', NULL, NULL, 1522, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (733, 'Frans Van Schooten', NULL, NULL, 1523, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (734, 'Sigfridus Aronus Forsius', NULL, NULL, 1524, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (735, 'Augustin Darquier de Pellepoix', NULL, NULL, 1525, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (736, 'John Pell', NULL, NULL, 1526, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (737, 'Johann Heinrich Müller', NULL, NULL, 1527, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (738, 'Claude Philippe Bertrand Bertrand', NULL, NULL, 1528, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (739, 'Antonio Manetti', NULL, NULL, 1529, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (740, 'Johannes Danck', NULL, NULL, 1530, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (741, 'Erasmus Oswald Schreckenfuchs', NULL, NULL, 1531, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (742, 'Michael Moestlin', NULL, NULL, 1532, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (743, 'Georges Louis Lesage', NULL, NULL, 1533, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (744, 'Le Professeur de mathématiques du Collège national de Toul', NULL, NULL, 1534, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (745, 'Piero della Francesca', NULL, NULL, 1535, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (746, 'Luca Gaurico', NULL, NULL, 1536, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (747, 'Henri Michel Sauvage', NULL, NULL, 1537, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (748, 'Johann Welper', NULL, NULL, 1538, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (749, 'François Para Du Phanjas', NULL, NULL, 1539, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (750, 'Claude Comiers', NULL, NULL, 1540, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (751, 'Étienne-Nicolas Blondeau', NULL, NULL, 1541, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (752, 'Jean-Louis Gœury', NULL, NULL, 1542, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (753, 'Jean Anthelme Brillat-Savarin', NULL, NULL, 1543, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (754, 'Jean Richer', NULL, NULL, 1544, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (755, 'Christopher Wren', NULL, NULL, 1545, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (756, 'Jacques Cassini', NULL, NULL, 1546, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (757, 'Henry Briggs', NULL, NULL, 1547, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (758, 'Eustachio Manfredi', NULL, NULL, 1548, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (759, 'Leonardo Ximenes', NULL, NULL, 1549, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (760, 'Jean François', NULL, NULL, 1550, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (761, 'Campanus de Novare', NULL, NULL, 1551, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (762, 'John Greaves', NULL, NULL, 1552, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (763, 'Isaac ben Joseph Israeli', NULL, NULL, 1553, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (764, 'Alessandro Vittorio Papacino d''Antoni', NULL, NULL, 1554, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (765, 'Giacomo Allegretti', NULL, NULL, 1555, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (766, 'Johann Christoph Sturm', NULL, NULL, 1556, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (767, 'Giovanni Alfonso Borelli', NULL, NULL, 1557, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (768, 'Diego de Torres Villarroel', NULL, NULL, 1558, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (769, 'Vitale Giordano', NULL, NULL, 1559, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (770, 'Hermann le Dalmate', NULL, NULL, 1560, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (771, 'Michele Zappulo', NULL, NULL, 1561, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (772, 'Giuseppe Maria Asclepi', NULL, NULL, 1562, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (773, 'Bernard Frénicle de Bessy', NULL, NULL, 1563, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (774, 'Johann Lorenz Schmidt', NULL, NULL, 1564, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (775, 'Antonio Dolciati', NULL, NULL, 1565, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (776, 'Pierre Forcadel', NULL, NULL, 1566, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (777, 'Libert Froidmont', NULL, NULL, 1567, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (778, 'Guillaume-Germain Guyot', NULL, NULL, 1568, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (779, 'Jacopo Francesco Riccati', NULL, NULL, 1569, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (780, 'Claude Bonjour', NULL, NULL, 1570, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (781, 'Jean Paul Grandjean de Fouchy', NULL, NULL, 1571, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (782, 'Bartolomeo Zamberti', NULL, NULL, 1572, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (783, 'Nevil Maskelyne', NULL, NULL, 1573, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (784, 'Pierre Gautruche', NULL, NULL, 1574, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (785, 'Francesco Ingoli', NULL, NULL, 1575, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (786, 'Johannes Voegelin', NULL, NULL, 1576, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (787, 'Joannes Michael Gigas', NULL, NULL, 1577, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (788, 'Jean Pigeon', NULL, NULL, 1578, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (789, 'Dominique Blanqui', NULL, NULL, 1579, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (790, 'Anianus', NULL, NULL, 1580, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (791, 'Jean Bonfa', NULL, NULL, 1581, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (792, 'Ottaviano Cametti', NULL, NULL, 1582, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (793, 'Jean L''Hoste', NULL, NULL, 1583, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (794, 'Joannes Portantius', NULL, NULL, 1584, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (795, 'Benjamin Robins', NULL, NULL, 1585, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (796, 'Jacques Grandami', NULL, NULL, 1586, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (797, 'Ferdinand Verbiest', NULL, NULL, 1587, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (798, 'Jacques Charpentier', NULL, NULL, 1588, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (799, 'Robertus Castrensis', NULL, NULL, 1589, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (800, 'Taddeo da Parma', NULL, NULL, 1590, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (801, 'Nicolas-Louis de La Caille', NULL, NULL, 1591, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (802, 'Claude de Boissière', NULL, NULL, 1592, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (803, 'Maria Cunitia', NULL, NULL, 1593, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (804, 'Joseph Amiot', NULL, NULL, 1594, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (805, 'Adrien-Marie Legendre', NULL, NULL, 1595, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (806, 'Maurice Bressieu', NULL, NULL, 1596, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (807, 'Samuel Marolois', NULL, NULL, 1597, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (808, 'Giovanni Paradisi', NULL, NULL, 1598, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (809, 'Michelangelo Galilei', NULL, NULL, 1599, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (810, 'Guillaume Bonjour', NULL, NULL, 1600, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (811, 'Henri de Monantheuil', NULL, NULL, 1601, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (812, 'Rodolphus Goclenius', NULL, NULL, 1602, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (813, 'Gersonide', NULL, NULL, 1603, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (814, 'Giovanni Abiosi', NULL, NULL, 1604, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (815, 'Nikolaus von Fuss', NULL, NULL, 1605, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (816, 'Takakazu Seki', NULL, NULL, 1606, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (817, 'Benito Bails', NULL, NULL, 1607, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (818, 'Patrizio Tricasso', NULL, NULL, 1608, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (819, 'Eilhard Lubbin', NULL, NULL, 1609, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (820, 'Johann Bernoulli', NULL, NULL, 1610, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (821, 'John Winthrop', NULL, NULL, 1611, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (822, 'René-François De Sluse', NULL, NULL, 1612, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (823, 'Aegidius Martini', NULL, NULL, 1613, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (824, 'Veuve de Louis Courcier', NULL, NULL, 1614, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (825, 'Francesco Maria Pompeo Colonna', NULL, NULL, 1615, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (826, 'Thomas Simpson', NULL, NULL, 1616, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (827, 'André-Pierre Le Guay de Prémontval', NULL, NULL, 1617, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (828, 'Livio Sanuto', NULL, NULL, 1618, true, '2015-11-06 16:04:13.593497+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (829, 'Maestlin, Michael', NULL, NULL, 1619, true, '2015-11-09 20:49:27.523476+01', '2015-11-09 21:17:58.333961+01', 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (831, 'Enseignement', NULL, NULL, 1621, true, '2015-11-09 22:47:05.88286+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (830, 'Grienberger, Christoph', NULL, NULL, 1620, true, '2015-11-09 21:16:14.612612+01', '2015-11-09 21:18:14.77701+01', 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (832, 'enseigné (être)', NULL, NULL, 1622, true, '2015-11-09 22:55:11.522404+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (833, 'exercé (être)', NULL, NULL, 1623, true, '2015-11-09 22:55:53.606288+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (834, 'exercer', NULL, NULL, 1624, true, '2015-11-09 22:56:49.257973+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (835, 'Professeur', NULL, NULL, 1625, true, '2015-11-09 23:15:10.594084+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (836, 'Caractéristiques d''un objet', NULL, NULL, 1626, true, '2015-11-10 08:30:34.176083+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (837, 'typer', NULL, NULL, 1627, true, '2015-11-10 08:45:58.265717+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (838, 'caractériser', NULL, NULL, 1628, true, '2015-11-10 08:46:54.63968+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (839, 'Théologien', NULL, NULL, 1629, true, '2015-11-10 22:00:21.157754+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (840, 'Physicien', NULL, NULL, 1630, true, '2015-11-10 22:13:25.653964+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (841, 'Libraire', NULL, NULL, 1631, true, '2015-11-13 17:45:46.72275+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (842, 'Imprimeur', NULL, NULL, 1632, true, '2015-11-13 17:58:26.832029+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (843, 'Ingénieur', NULL, NULL, 1633, true, '2015-11-13 18:00:15.934578+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (844, 'Chimiste', NULL, NULL, 1634, true, '2015-11-13 18:02:31.108708+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (845, 'Architecte', NULL, NULL, 1635, true, '2015-11-13 18:09:46.344278+01', NULL, 15, NULL, NULL);
INSERT INTO nom_objet (pk_nom_objet, nom, langue, notes, fk_objet, est_standard, date_creation, date_modification, fk_type_nom_param, date_debut, date_fin) VALUES (846, 'Cartographe', NULL, NULL, 1636, true, '2015-11-13 18:12:35.512831+01', NULL, 15, NULL, NULL);


--
-- TOC entry 2414 (class 0 OID 0)
-- Dependencies: 180
-- Name: nom_objet_cle_nom_objet_seq; Type: SEQUENCE SET; Schema: objets; Owner: -
--

SELECT pg_catalog.setval('nom_objet_cle_nom_objet_seq', 846, true);


--
-- TOC entry 2398 (class 0 OID 22746)
-- Dependencies: 181
-- Data for Name: objet; Type: TABLE DATA; Schema: objets; Owner: -
--

INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (34, 'Ce concept indique la source d''un texte, d''une connaissance, etc.', NULL, '2015-10-13 17:42:49.184459+02', '2015-11-09 19:02:28.873888+01', NULL, NULL, NULL, NULL, NULL, 3, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1197, 'Mathématicien et astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12399386c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12399386c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (35, NULL, NULL, '2015-10-13 17:46:12.942494+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (9, 'Tout résumé synthétique placé au début d''une notice de dictionnaire qui résume les traits essentiels de l''objet concerné par la notice (acteur, institution, etc.)', NULL, '2015-09-30 17:31:31.168992+02', '2015-11-09 19:05:25.836996+01', NULL, NULL, NULL, NULL, NULL, 3, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1619, 'Astronome', NULL, '2015-11-09 20:49:27.523476+01', '2015-11-09 21:17:58.333961+01', NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1620, 'Jésuite, astronome', NULL, '2015-11-09 21:16:14.612612+01', '2015-11-09 21:18:14.77701+01', NULL, NULL, NULL, NULL, NULL, 1, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1621, 'Exercer la fonction d''enseigner, avec indication de l''institution auprès de laquelle s''exerce l''enseignement et des matières enseignées. (TyIn97)', NULL, '2015-11-09 22:47:05.88286+01', NULL, NULL, NULL, NULL, NULL, NULL, 37, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1622, 'Associe une matière enseignée', NULL, '2015-11-09 22:55:11.522404+01', NULL, NULL, NULL, NULL, NULL, NULL, 38, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (904, 'Astronome, physicien et médecin byzantin. - Évêque de Tabriz, Iran', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12007088c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12007088c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1193, 'Dessinateur et graveur, mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb153705873#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb153705873#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1623, 'Une profession ou tout autre caractère social qui est exercé', NULL, '2015-11-09 22:55:53.606288+01', NULL, NULL, NULL, NULL, NULL, NULL, 38, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1624, 'Exercer un métier, un enseignement, ... – associe l''acteur qui exerce', NULL, '2015-11-09 22:56:49.257973+01', NULL, NULL, NULL, NULL, NULL, NULL, 38, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1625, 'Personne qui enseigne une discipline, une technique, un art.', NULL, '2015-11-09 23:15:10.594084+01', NULL, NULL, NULL, NULL, NULL, NULL, 4, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (856, 'Mathématicien, navigateur et hydrographe', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb153879695#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb153879695#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1626, 'Les informations de ce type sont utilisées pour exprimer une caractéristique d''un objet à un moment donné', NULL, '2015-11-10 08:30:34.176083+01', NULL, NULL, NULL, NULL, NULL, NULL, 37, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (851, 'Ingénieur et astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12155087r#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12155087r#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1627, 'Associe un type sour forme d''objet abstrait', NULL, '2015-11-10 08:45:58.265717+01', NULL, NULL, NULL, NULL, NULL, NULL, 38, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1628, 'Associe une caractéristique sous forme d''objet abstrait', NULL, '2015-11-10 08:46:54.63968+01', NULL, NULL, NULL, NULL, NULL, NULL, 38, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1126, 'Philosophe et théologien. - Astronome. - Poète et musicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12220635h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12220635h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1306, 'Philosophe, logicien, astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15935708x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15935708x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (20, 'Descriptif synthétique des caractéristiques d''un objet, tel un article de dictionnaire, etc.', NULL, '2015-10-04 10:40:12.841066+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 3, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (6, 'Discipline qui étudie les mouvements des astres', NULL, '2015-09-28 21:20:15.740526+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 3, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (11, 'Le fait de la naissance d''une personne, avec le lieu et la date', NULL, '2015-09-30 17:52:16.518456+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 37, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (12, 'La mention de la naissance d''une personne, avec le lieu et la date', NULL, '2015-09-30 17:53:02.319296+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 36, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (10, 'Associe l''objet concerné par l''unité de connaissance', NULL, '2015-09-30 17:45:49.20009+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 38, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (13, NULL, NULL, '2015-09-30 17:56:09.260378+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 33, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1339, 'Astrologue, géomancien et astronome. Fut professeur à l''Université de Bologne (1288-1297)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb144790439#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb144790439#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1551, 'Astronome. - Mathématicien, commentateur d''Euclide', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb124917005#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb124917005#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1509, 'Philosophe. - Médecin. - Père de l''astronome Jacob Poel', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16540698w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16540698w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (912, 'Philologue. - Mathématicien et astrologue', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12311753x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12311753x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1131, 'Éxégète. - Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb134867338#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb134867338#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (895, 'Mathématicien chinois. En activité entre 1261 et 1275', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13746624q#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13746624q#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1553, 'Astronome. - Elève d''Asher ben Jehiel', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16540863s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16540863s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1114, 'Mathématicien. - Actif en 1307', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb157815579#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb157815579#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (877, 'Mathématicien. - Probablement d''origine italienne', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11986727x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11986727x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (849, 'Mathématicien, astronome, philosophe. - Attesté entre 1290 et 1300. - Élève à l''Université de Bologne (1291-1292) puis de Paris. - Chanoine de Roskilde, Danemark. - A distinguer de Petrus de Dacia, recteur de l''Université de Paris en 1327', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11887258w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11887258w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1436, 'Mathématicien et jurisconsulte chaféite', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb155674927#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb155674927#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (923, 'Astronome. - Précepteur de Boccace. - Ambassadeur de la République de Gênes auprès de l''empereur Alexis Comnène (en 1314)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121998732#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121998732#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1239, 'Homme d''état, philosophe, poète, astronome et rhéteur', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12000562c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12000562c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (2, 'Astronome, mathématicien de l''empereur du Saint-Empire', NULL, '2015-09-25 22:41:54.367439+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 1, 'm', NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (7, 'Astronome et mathématicien', NULL, '2015-09-28 22:42:59.619909+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 1, 'm', NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (21, NULL, NULL, '2015-10-05 08:46:30.390569+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, 8.86666699999999963, 48.75, NULL, 9, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (22, 'Associe un objet qui localiser l''unité de connaissance', NULL, '2015-10-05 08:48:23.727187+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 38, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (23, 'Associe l''acteur concern; par l''UC ''naissance''', NULL, '2015-10-05 08:59:20.720318+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 38, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (16, 'Celui ou celle qui pratique ou enseigne les mathématiques', NULL, '2015-10-03 09:57:19.385319+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 4, NULL, 'test', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (17, NULL, NULL, '2015-10-03 09:57:48.242165+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 1, 'm', NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1205, 'Moine basilien, abbé du Saint-Esprit à Constantinople (1331), évêque de Gérace (1342-1348). - Théologien, philosophe, mathématicien, astronome et helléniste', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13549924x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13549924x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (15, 'Discipline enseignée dans les universités qui s''intéresse aux nombres et à leurs relations', NULL, '2015-10-02 23:54:54.414336+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 3, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (25, 'Celui ou celle qui pratique ou enseigne l''astrologie', NULL, '2015-10-06 04:36:45.268944+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 4, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1118, 'Philosophe, astronome, médecin italien célèbre pour la construction d''une pendule astrale à Padoue. - Père de Giovanni Dondi', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb124119184#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb124119184#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (24, 'Personne qui pratique ou enseigne l''astronomie', NULL, '2015-10-06 04:31:50.321678+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 4, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1086, 'Mathématicien, philosophe et théologien. - Surnommé le "Doctor Profundus". - Archevêque de Canterbury en 1349', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12269047v#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12269047v#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1324, 'Mathématicien. - Astronome. - Abbé du monastère bénédictin de St Albans', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12128305h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12128305h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (3, NULL, NULL, '2015-09-25 22:47:03.926285+02', '2015-11-10 15:29:26.376954+01', NULL, NULL, NULL, NULL, '<root>
<ud>
<eud>Michael Maestlin</eud>

<ud ana="9">
<in ana="11"><en ref="1619"  ana="23">Michael Maestlin</en> (aussi appelé Mästlin, Möstlin, ou Moestlin), né le <dat when="15500930" type="du">30 septembre 1550</dat> à <en type="li" ana="22">Göppingen en Bade-Wurtemberg</en></in>, mort le 20 octobre 1631 à Tübingen, est un astronome et mathématicien allemand, connu pour être le mentor de Johannes Kepler.
</ud>



<ud>
<eud>Carrière</eud>

Maestlin a étudié la théologie, les mathématiques et l''astronomie au Tübinger Stift à Tübingen, une ville du Wurtemberg. Il a obtenu la maîtrise en 1571 et est devenu en 1576 un diacre luthérien à Backnang, tout en continuant ses études dans cette ville.

<in ana="1621"><dat when="1580" type="dd">En 1580</dat>, <en ref="1619"  ana="1624">il</en> est devenu <en><en ref="1625"  ana="1623">professeur</en> de <en ref="15"  ana="1622">mathématiques</en></en> à l''<en ana="10">université de <en type="li">Heidelberg</en></en>[jusqu''en <dat when="1583" type="df">1583</dat>]</in>. Il a écrit une introduction populaire à l''astronomie, en 1582. <in ana="1621"><en ref="1619"  ana="1624">Il</en> a enseigné ensuite à l''<en ana="10">université de <en type="li">Tübingen</en></en> à partir de <dat when="1583" type="dd">1583</dat>, à l''âge de 47 ans</in>.

Il comptait parmi ses étudiants Johannes Kepler (1571-1630)1. Bien qu''il enseignât au départ la représentation géocentrique traditionnelle du Système solaire selon Ptolémée, Maestlin était aussi l''un des premiers à accepter et à enseigner la représentation héliocentrique de Copernic. Maestlin correspondait fréquemment avec Kepler et joua un rôle significatif dans son adoption du système copernicien. On attribue aussi l''adoption de l''héliocentrisme par Galilée à Maestlin2.

Le premier calcul connu de l''inverse du nombre d''or où il donne la valeur « environ 0.6180340 » a été écrit en 1597 par Maestlin dans une lettre à Kepler.
</ud>
<ud ana="34">https://fr.wikipedia.org/w/index.php?title=Michael_Maestlin&amp;oldid=115018735</ud>
</ud>



<ud>
<eud>Christopher Grienberger</eud>

<ud ana="9"><in ana="11"><en ref="1620"  ana="23">Christopher Grienberger</en> (aussi écrit Christopher Gruemberger, ou encore Grinberg, Bamberger, ou Gamberger, voire Panberger), né le <dat when="15510702" type="du">2 juillet 1551</dat> à <en type="li" ana="22">Hall dans le Tyrol</en></in>, et mort le 11 mars 1636 à Rome, est prêtre jésuite autrichien, mathématicien et professeur au Collège romain. Un cratère lunaire est nommé en son honneur Gruemberger.</ud>

<ud>
<eud>Biographie</eud>
Grienberger entre dans la Compagnie de Jésus le 20 août 1580. Après des études de rhétorique à Prague (1583–1584), il devient professeur de mathématiques à Olomouc en 1587. On le retrouve à Vienne, de 1589 à 1591, où il enseigne la théologie et les mathématiques.

En 1595, il rejoint Clavius à Rome, et en 1597, il enseigne à Graz, où il approche Johannes Kepler.

Ami de Marin Ghetaldi durant de longues années, il assista celui-ci dans ses expériences. En correspondance avec Galilée et Clavius, il succéda à celui-ci à la direction du Collège romain en 1612. Quelque sympathie qu''il eût pour les théories de Galilée, il fut obligé de défendre, sur ordre du Père général des jésuites, Claudio Acquaviva, les théories aristotéliciennes d''une Terre immobile.

Dans une lettre de 1634 adressée à Élie Diodati (en), il confesse à ce propos :

    « Si Galilée avait su se garder la bienveillance des pères du collège romain, il aurait pu vivre tranquille en ce monde, et rien de malheureux ne lui serait arrivé ; il aurait pu écrire à sa convenance, sur chaque sujet, et même sur le mouvement de la terre. »</ud>

<ud>
<eud>Travaux</eud>

On ne connaît souvent de lui qu''un catalogue d''étoiles nouvellement découvertes et des tables trigonométriques.

Par ailleurs, il apporta son aide aux autres mathématiciens de l''époque, comme Mario Bettinus et Giuseppe Biancani.

Le premier écrit, dans la préface de son ouvrage, Universae Philosophiae Mathematicae (1642)1 :

    « J''ai bénéficié, mon lecteur, de l''esprit et de l''industrie du très instruit et extrêmement modeste homme, Grienberger, qui, alors qu''il aurait découvert de nombreuses merveilles par lui-même, a préféré se mettre au service des inventions et pour la gloire d''autres personnes. »

Il se livra enfin à des travaux d''optique et on lui doit un montage astronomique des jumelles, utilisant le système équatorial, précédant le télescope, et nommé le montage allemand.

D''autre part, il prépara l''expédition de Johann Adam Schall von Bell et d''autres missionnaires jésuites en Chine.
</ud>


<ud ana="34">Source : https://fr.wikipedia.org/w/index.php?title=Christopher_Grienberger&amp;oldid=116722907</ud>
</ud>





<ud>
<eud>Giovanni Antonio Magini</eud>

<ud ana="9">Giovanni Antonio Magini (en latin, Maginus) (Padoue, 13 juin 1555 - Bologne, 11 février 1617) était un astronome, un astrologue, un cartographe, un mathématicien et un universitaire italien.
</ud>

<ud>
<eud>Biographie</eud>

Fils de Pasquale Magini, un citoyen de Padoue, sa ville natale, Giovanni Antonio Magini a suivi des études en philosophie à Bologne en 1579.

Se consacrant ensuite à l''astronomie, il a écrit en 1582 Ephemerides coelestium motuum, traduit l''année suivante en italien.

En 1588, il a été choisi devant Galilée pour occuper la chaire de mathématiques de l''université de Bologne après la mort de Egnatio Danti. Magini a soutenu une vision géocentrique du monde, a contrario du système héliocentrique émergent de Copernic. Magini a conçu sa propre théorie planétaire, la préférant aux autres existantes. Le système de Magini était composé de onze sphères tournantes, qu''il a décrit dans Novæ cœlestium orbium theoricæ congruentes cum observationibus N. Copernici (Venise, 1589).

Dans De Planis Triangulis (Venise, 1592), il s''est intéressé à l''utilisation des quadrants dans la topographie et à l''astronomie. En 1592, Magini a publié Tabula tetragonica et en 1606, il a conçu des tables trigonométriques extrêmement précises. Il a aussi travaillé sur la géométrie de la sphère et ses applications à la trigonométrie, pour lesquelles il a inventé des dispositifs calculateurs. Il a également travaillé sur le problème des miroirs et il a publié sur la théorie des miroirs sphériques concaves.

En 1593, Il fait partie des mathématiciens du monde entier pressenti par Adrien Romain pour résoudre son équation de degrés 45, et dont François Viète triomphera.

Il a aussi publié un commentaire sur Geographia de Ptolémée (Cologne, 1596).

En tant que cartographe, il a travaillé toute sa vie à la préparation de Italia ou Atlante geografico d''Italia (Atlas géographique de l''Italie), imprimé après sa mort par son fils en 1620. Il a été conçu pour inclure les cartes de toutes les régions de l''Italie avec la nomenclature exacte et des notes historiques.

Il s''est également intéressé à la métoposcopie et devint en 1599, l''astrologue officiel du duc de Mantoue.

Il correspondait avec Tycho Brahe, Clavius, Abraham Ortelius et Johannes Kepler. Sa correspondance a été éditée en 1886 par Antonio Favaro.

Il est mort à Bologne.
</ud>

<ud ana="34">https://fr.wikipedia.org/w/index.php?title=Giovanni_Antonio_Magini&amp;oldid=118941415</ud>
</ud>








<ud>
<eud>Nicolas-Claude Fabri de Peiresc</eud>

<ud ana="9"><in ana="11"><en ref="17"  ana="23">Nicolas-Claude Fabri de Peiresc</en> (également orthographié de Peyresc), né le <dat when="15801201" type="du">1er décembre 1580</dat> à <en type="li" ana="22">Belgentier</en></in> et mort le 24 juin 1637 à Aix-en-Provence, est un intellectuel de l''époque baroque, conseiller au Parlement de Provence, scientifique, homme de lettres, astronome et collectionneur.

Il est connu notamment pour avoir entrepris de dresser la première carte de la Lune fondée sur des observations télescopiques.
</ud>



<ud>
<eud>Biographie</eud>
Jeunesse et formation
Armes des Fabri de Rians1, famille dont est issu Fabri de Peiresc.

Claude Fabri naît à Belgentier, où ses parents, aixois, se sont réfugiés afin d’échapper à la peste qui sévit à Aix. Il prend en 1604 le nom de Peiresc, terroir des Alpes-de-Haute-Provence (aujourd''hui Peyresq) qui lui vient de son père et où il n''a jamais mis les pieds2.

Il fait des études de philosophie et ressent de l’intérêt pour l''astronomie, les mathématiques, les langues, etc.3.

Appartenant à une famille de robe, il apprend le droit et est attiré par l''archéologie, ce qui lui permet de poursuivre ses études en Italie. Il revient en France en 1602 afin de préparer son doctorat à l''université de Montpellier et en 1604 il soutient sa thèse, obtenant le grade de docteur en Droit.

Il fait de nombreux voyages (Paris, Londres, région des Flandres) avant d''être nommé conseiller au parlement de Provence2.</ud>


<ud>
<eud>Un éminent collectionneur d''art</eud>

Peiresc constitue dans sa demeure d''Aix-en-Provence, un cabinet, véritable musée où se côtoient sculptures antiques, peintures modernes, médailles, bibliothèque, et un jardin d''acclimatation.

Il fait représenter ces objets précieux, dont de nombreux vases antiques, sous forme de dessins réunis dans deux recueils; l''un d''eux, cédé avec sa collection par l''abbé de Marolles à Louis XIV, intègre en 1667 la bibliothèque royale et est inventorié en 1684 (mention de 158 pièces); l''autre, légué par Henri du Bouchet à l''abbaye de Saint-Victor et qui est utilisé en 1719 par dom Bernard de Montfaucon pour son Antiquité expliquée et représentée en figures, transite vers 1797 par l''hôtel de ville de Paris. En 1766 Joly, garde des Estampes du Roi, en dresse un inventaire détaillé. Réunis, les deux volumes sont reliés sous le Premier Empire (Bibliothèque Nationale de France).

Peiresc est un exemple de grand intellectuel, à la charnière de la Renaissance et de l''essor scientifique moderne, ce qui lui vaut le titre de « Prince de la république des Lettres ».
</ud>


<ud>
<eud>Un épistolier infatigable</eud>

S''il fut un politique remarqué dans sa région, Fabri de Peiresc est aussi un infatigable épistolier avec ses 10 000 lettres. Il est en correspondance régulière avec Malherbe, Hugo Grotius, les frères Dupuy, avec le frère du cardinal Richelieu, Jean Barclay, Rubens, Gassendi, dont il est le grand ami, mais aussi Galilée4 et Campanella pour lesquels il lutte afin de les défendre des attaques de l''Inquisition.

Sans qu’on sache comment il se l’est procuré, il offre l’ivoire Barberini, une exceptionnelle œuvre byzantine en ivoire, au cardinal Francesco Barberini, œuvre qui appartient au Louvre depuis 1899.

Sa correspondance avec Malherbe permet de mieux comprendre la personnalité du fils de celui-ci, tué en duel par Pierre-Paul de Fortia de Piles avec l’aide de Gaspard de Covet de Marignane le 13 juillet 1627. Ce drame ravage Malherbe de douleur, qui en meurt l''année suivante.


Le chercheur

Début juillet 1608, les faubourgs d''Aix-en-Provence sont recouverts d''une pluie de « sang ». Quelques moines désireux d''exploiter la crédulité humaine n''hésitent pas à voir dans cet évènement des influences sataniques. Peiresc fait des relevés de cette pluie en recueillant quelques gouttes sur la muraille du cimetière de la cathédrale. Il découvre que ce liquide est laissé par les chrysalides des vanesses lorsqu''elles se muent en papillons (papillons qui avaient été observés)3. Le centre ville n''ayant pas été envahi, il est resté épargné. Cette explication scientifique ne calme pas la terreur populaire5.


Peiresc et l''astronomie

Son talent ne s''arrête pas là. Peiresc est aussi astronome et, à la suite de son ami Galilée, il observe les satellites de Jupiter dont il laisse des croquis montrant qu''il a très bien compris qu''il s''agit de satellites de cette planète. Il veut utiliser les disparitions de ces satellites pour améliorer la connaissance des longitudes et commence à dresser des tables très précises. Apprenant que Galilée a le même projet, il l''abandonne par déférence envers celui qu''il admire6.
Reproduction partielle d''un manuscrit de Peiresc conservé à la Bibliothèque Inguimbertine et montrant la première annonce de la découverte de la nébuleuse d''Orion faite par Peiresc le 26 novembre 1610.

Entre la fin novembre et le début décembre 1610, il découvre la nébuleuse d''Orion qu''il décrit dans ses manuscrits par ces mots :

    « In Orione media... ex duabus stellis composita nubecula quamdam illuminata prima fronte referabat coelo non oie sereno » (observation du 26 novembre 1610).

Il s''aperçoit que la méthode des satellites de Jupiter pour améliorer la connaissance des longitudes n''est pas commode à utiliser, notamment pour les marins. Il tente alors une méthode bien connue des astronomes qui consiste à observer un même phénomène depuis deux lieux distants (par exemple une éclipse de Lune). Pour cela, il coordonne l''observation de l''éclipse de Lune du 28 août 1635 en répartissant des observateurs tout le long de la Méditerranée ; ceci lui permet de constater que cette mer est en réalité plus courte de près de 1 000 km que ce que l''on croyait jusqu''alors6.

Avec l''appui de Gassendi qui l''avait baptisé "le prince des curieux", Peiresc demande au graveur Claude Mellan de dresser la première carte de la Lune fondée sur des observations télescopiques réalisées depuis l''observatoire personnel qu''il a mis en place sur le toit de sa demeure, mais sa mort, alors qu''il est le commanditaire et le financier du projet, va l''empêcher de mener à bien cette tâche.


Un savant éclectique

Peiresc est encore numismate7 (avec son médaillier de plus de 18 000 pièces), archéologue, amateur d''art, historien (il montre que Jules César, lors de sa conquête de l’Angleterre, n’est pas parti de Calais, mais de Saint-Omer), égyptologue, botaniste, zoologue (études sur les caméléons, les crocodiles, l''éléphant et l''alzaron, sorte de gazelle à tête de taureau venant de Nubie et aujourd''hui disparue), physiologiste, géographe (projet de construction d''un canal de Provence reliant Aix à Marseille), et écologiste.

Il s''intéresse également à la géologie et à la paléontologie8

Cet humaniste s''éteint à l''âge de 57 ans.
</ud>
<ud ana="34">https://fr.wikipedia.org/w/index.php?title=Nicolas-Claude_Fabri_de_Peiresc&amp;oldid=118560581</ud>
</ud>







<ud>
<eud>Philippe van Lansberge</eud>

<ud ana="9">Philippe van Lansberge, Lansberg ou Landsbergius est un mathématicien et astronome belge, né à Gand le 25 août 1561, mort après 1632 ; il est seigneur de Maulabeecke</ud>


<ud>
<eud>Biographie</eud>

Fils de Daniel van Lansberge, seigneur de Meulebeke, et de Paulinevan den Honigh. Ses parents l''élevèrent dans la religion protestante à laquelle il resta toujours attaché. Il étudia en Angleterre, revint à Gand, puis quitta derechef sa ville natale pour se fixer à Anvers vers 1580. Lorsqu''en 1585, la métropole commerciale retomba sous l''autorité de Philippe II d''Espagne, il abandonna la Belgique pour s''installer aux Pays-Bas, à Leyden, où il professa comme pasteur puis à Goes puis à Middelbourg, où il exerça la médecine et put surtout se livrer à ses études favorites, les mathématiques et l''astronomie. Il fut l''élève de Simon Stevin à Leyde, et se lia avec Willebrord Snell, qui partageait avec lui la même passion. Il mourut à Middelbourg le 8 novembre 1635 ou le 8 décembre 1632 selon différentes sources (dont Isaac Beeckman), laissant après lui dix enfants. Tallement des Reaux note dans ses historiettes qu''il fut un des rares européens à comprendre l''algèbre de François Viète ; Kepler se sert de ses calculs.

Lansberge fut partisan des hypothèses de Copernic et de Kepler (dont il n''acceptait pas la forme elliptique des orbites planétaires), ce qui lui valut de multiples désagréments de la part des pasteurs protestants.
</ud>


<ud ana="34">https://fr.wikipedia.org/w/index.php?title=Philippe_van_Lansberge&amp;oldid=116732291</ud>
</ud>
</root>', 8, NULL, '
{ud0}
{eud}Michael Maestlin{/eud}

{ud0_9}
{in0_11}{en1619_23}Michael Maestlin{/en} (aussi appelé Mästlin, Möstlin, ou Moestlin), né le {dat15500930_du}30 septembre 1550{/dat} à {en0li_22}Göppingen en Bade-Wurtemberg{/en}{/in}, mort le 20 octobre 1631 à Tübingen, est un astronome et mathématicien allemand, connu pour être le mentor de Johannes Kepler.
{/ud}



{ud0}
{eud}Carrière{/eud}

Maestlin a étudié la théologie, les mathématiques et l''astronomie au Tübinger Stift à Tübingen, une ville du Wurtemberg. Il a obtenu la maîtrise en 1571 et est devenu en 1576 un diacre luthérien à Backnang, tout en continuant ses études dans cette ville.

{in0_1621}{dat1580_dd}En 1580{/dat}, {en1619_1624}il{/en} est devenu {en0}{en1625_1623}professeur{/en} de {en15_1622}mathématiques{/en}{/en} à l''{en0_10}université de {en0li}Heidelberg{/en}{/en}[jusqu''en {dat1583_df}1583{/dat}]{/in}. Il a écrit une introduction populaire à l''astronomie, en 1582. {in0_1621}{en1619_1624}Il{/en} a enseigné ensuite à l''{en0_10}université de {en0li}Tübingen{/en}{/en} à partir de {dat1583_dd}1583{/dat}, à l''âge de 47 ans{/in}.

Il comptait parmi ses étudiants Johannes Kepler (1571-1630)1. Bien qu''il enseignât au départ la représentation géocentrique traditionnelle du Système solaire selon Ptolémée, Maestlin était aussi l''un des premiers à accepter et à enseigner la représentation héliocentrique de Copernic. Maestlin correspondait fréquemment avec Kepler et joua un rôle significatif dans son adoption du système copernicien. On attribue aussi l''adoption de l''héliocentrisme par Galilée à Maestlin2.

Le premier calcul connu de l''inverse du nombre d''or où il donne la valeur « environ 0.6180340 » a été écrit en 1597 par Maestlin dans une lettre à Kepler.
{/ud}
{ud0_34}https://fr.wikipedia.org/w/index.php?title=Michael_Maestlin&oldid=115018735{/ud}
{/ud}



{ud0}
{eud}Christopher Grienberger{/eud}

{ud0_9}{in0_11}{en1620_23}Christopher Grienberger{/en} (aussi écrit Christopher Gruemberger, ou encore Grinberg, Bamberger, ou Gamberger, voire Panberger), né le {dat15510702_du}2 juillet 1551{/dat} à {en0li_22}Hall dans le Tyrol{/en}{/in}, et mort le 11 mars 1636 à Rome, est prêtre jésuite autrichien, mathématicien et professeur au Collège romain. Un cratère lunaire est nommé en son honneur Gruemberger.{/ud}

{ud0}
{eud}Biographie{/eud}
Grienberger entre dans la Compagnie de Jésus le 20 août 1580. Après des études de rhétorique à Prague (1583–1584), il devient professeur de mathématiques à Olomouc en 1587. On le retrouve à Vienne, de 1589 à 1591, où il enseigne la théologie et les mathématiques.

En 1595, il rejoint Clavius à Rome, et en 1597, il enseigne à Graz, où il approche Johannes Kepler.

Ami de Marin Ghetaldi durant de longues années, il assista celui-ci dans ses expériences. En correspondance avec Galilée et Clavius, il succéda à celui-ci à la direction du Collège romain en 1612. Quelque sympathie qu''il eût pour les théories de Galilée, il fut obligé de défendre, sur ordre du Père général des jésuites, Claudio Acquaviva, les théories aristotéliciennes d''une Terre immobile.

Dans une lettre de 1634 adressée à Élie Diodati (en), il confesse à ce propos :

    « Si Galilée avait su se garder la bienveillance des pères du collège romain, il aurait pu vivre tranquille en ce monde, et rien de malheureux ne lui serait arrivé ; il aurait pu écrire à sa convenance, sur chaque sujet, et même sur le mouvement de la terre. »{/ud}

{ud0}
{eud}Travaux{/eud}

On ne connaît souvent de lui qu''un catalogue d''étoiles nouvellement découvertes et des tables trigonométriques.

Par ailleurs, il apporta son aide aux autres mathématiciens de l''époque, comme Mario Bettinus et Giuseppe Biancani.

Le premier écrit, dans la préface de son ouvrage, Universae Philosophiae Mathematicae (1642)1 :

    « J''ai bénéficié, mon lecteur, de l''esprit et de l''industrie du très instruit et extrêmement modeste homme, Grienberger, qui, alors qu''il aurait découvert de nombreuses merveilles par lui-même, a préféré se mettre au service des inventions et pour la gloire d''autres personnes. »

Il se livra enfin à des travaux d''optique et on lui doit un montage astronomique des jumelles, utilisant le système équatorial, précédant le télescope, et nommé le montage allemand.

D''autre part, il prépara l''expédition de Johann Adam Schall von Bell et d''autres missionnaires jésuites en Chine.
{/ud}


{ud0_34}Source : https://fr.wikipedia.org/w/index.php?title=Christopher_Grienberger&oldid=116722907{/ud}
{/ud}





{ud0}
{eud}Giovanni Antonio Magini{/eud}

{ud0_9}Giovanni Antonio Magini (en latin, Maginus) (Padoue, 13 juin 1555 - Bologne, 11 février 1617) était un astronome, un astrologue, un cartographe, un mathématicien et un universitaire italien.
{/ud}

{ud0}
{eud}Biographie{/eud}

Fils de Pasquale Magini, un citoyen de Padoue, sa ville natale, Giovanni Antonio Magini a suivi des études en philosophie à Bologne en 1579.

Se consacrant ensuite à l''astronomie, il a écrit en 1582 Ephemerides coelestium motuum, traduit l''année suivante en italien.

En 1588, il a été choisi devant Galilée pour occuper la chaire de mathématiques de l''université de Bologne après la mort de Egnatio Danti. Magini a soutenu une vision géocentrique du monde, a contrario du système héliocentrique émergent de Copernic. Magini a conçu sa propre théorie planétaire, la préférant aux autres existantes. Le système de Magini était composé de onze sphères tournantes, qu''il a décrit dans Novæ cœlestium orbium theoricæ congruentes cum observationibus N. Copernici (Venise, 1589).

Dans De Planis Triangulis (Venise, 1592), il s''est intéressé à l''utilisation des quadrants dans la topographie et à l''astronomie. En 1592, Magini a publié Tabula tetragonica et en 1606, il a conçu des tables trigonométriques extrêmement précises. Il a aussi travaillé sur la géométrie de la sphère et ses applications à la trigonométrie, pour lesquelles il a inventé des dispositifs calculateurs. Il a également travaillé sur le problème des miroirs et il a publié sur la théorie des miroirs sphériques concaves.

En 1593, Il fait partie des mathématiciens du monde entier pressenti par Adrien Romain pour résoudre son équation de degrés 45, et dont François Viète triomphera.

Il a aussi publié un commentaire sur Geographia de Ptolémée (Cologne, 1596).

En tant que cartographe, il a travaillé toute sa vie à la préparation de Italia ou Atlante geografico d''Italia (Atlas géographique de l''Italie), imprimé après sa mort par son fils en 1620. Il a été conçu pour inclure les cartes de toutes les régions de l''Italie avec la nomenclature exacte et des notes historiques.

Il s''est également intéressé à la métoposcopie et devint en 1599, l''astrologue officiel du duc de Mantoue.

Il correspondait avec Tycho Brahe, Clavius, Abraham Ortelius et Johannes Kepler. Sa correspondance a été éditée en 1886 par Antonio Favaro.

Il est mort à Bologne.
{/ud}

{ud0_34}https://fr.wikipedia.org/w/index.php?title=Giovanni_Antonio_Magini&oldid=118941415{/ud}
{/ud}








{ud0}
{eud}Nicolas-Claude Fabri de Peiresc{/eud}

{ud0_9}{in0_11}{en17_23}Nicolas-Claude Fabri de Peiresc{/en} (également orthographié de Peyresc), né le {dat15801201_du}1er décembre 1580{/dat} à {en0li_22}Belgentier{/en}{/in} et mort le 24 juin 1637 à Aix-en-Provence, est un intellectuel de l''époque baroque, conseiller au Parlement de Provence, scientifique, homme de lettres, astronome et collectionneur.

Il est connu notamment pour avoir entrepris de dresser la première carte de la Lune fondée sur des observations télescopiques.
{/ud}



{ud0}
{eud}Biographie{/eud}
Jeunesse et formation
Armes des Fabri de Rians1, famille dont est issu Fabri de Peiresc.

Claude Fabri naît à Belgentier, où ses parents, aixois, se sont réfugiés afin d’échapper à la peste qui sévit à Aix. Il prend en 1604 le nom de Peiresc, terroir des Alpes-de-Haute-Provence (aujourd''hui Peyresq) qui lui vient de son père et où il n''a jamais mis les pieds2.

Il fait des études de philosophie et ressent de l’intérêt pour l''astronomie, les mathématiques, les langues, etc.3.

Appartenant à une famille de robe, il apprend le droit et est attiré par l''archéologie, ce qui lui permet de poursuivre ses études en Italie. Il revient en France en 1602 afin de préparer son doctorat à l''université de Montpellier et en 1604 il soutient sa thèse, obtenant le grade de docteur en Droit.

Il fait de nombreux voyages (Paris, Londres, région des Flandres) avant d''être nommé conseiller au parlement de Provence2.{/ud}


{ud}
{eud}Un éminent collectionneur d''art{/eud}

Peiresc constitue dans sa demeure d''Aix-en-Provence, un cabinet, véritable musée où se côtoient sculptures antiques, peintures modernes, médailles, bibliothèque, et un jardin d''acclimatation.

Il fait représenter ces objets précieux, dont de nombreux vases antiques, sous forme de dessins réunis dans deux recueils; l''un d''eux, cédé avec sa collection par l''abbé de Marolles à Louis XIV, intègre en 1667 la bibliothèque royale et est inventorié en 1684 (mention de 158 pièces); l''autre, légué par Henri du Bouchet à l''abbaye de Saint-Victor et qui est utilisé en 1719 par dom Bernard de Montfaucon pour son Antiquité expliquée et représentée en figures, transite vers 1797 par l''hôtel de ville de Paris. En 1766 Joly, garde des Estampes du Roi, en dresse un inventaire détaillé. Réunis, les deux volumes sont reliés sous le Premier Empire (Bibliothèque Nationale de France).

Peiresc est un exemple de grand intellectuel, à la charnière de la Renaissance et de l''essor scientifique moderne, ce qui lui vaut le titre de « Prince de la république des Lettres ».
{/ud}


{ud}
{eud}Un épistolier infatigable{/eud}

S''il fut un politique remarqué dans sa région, Fabri de Peiresc est aussi un infatigable épistolier avec ses 10 000 lettres. Il est en correspondance régulière avec Malherbe, Hugo Grotius, les frères Dupuy, avec le frère du cardinal Richelieu, Jean Barclay, Rubens, Gassendi, dont il est le grand ami, mais aussi Galilée4 et Campanella pour lesquels il lutte afin de les défendre des attaques de l''Inquisition.

Sans qu’on sache comment il se l’est procuré, il offre l’ivoire Barberini, une exceptionnelle œuvre byzantine en ivoire, au cardinal Francesco Barberini, œuvre qui appartient au Louvre depuis 1899.

Sa correspondance avec Malherbe permet de mieux comprendre la personnalité du fils de celui-ci, tué en duel par Pierre-Paul de Fortia de Piles avec l’aide de Gaspard de Covet de Marignane le 13 juillet 1627. Ce drame ravage Malherbe de douleur, qui en meurt l''année suivante.


Le chercheur

Début juillet 1608, les faubourgs d''Aix-en-Provence sont recouverts d''une pluie de « sang ». Quelques moines désireux d''exploiter la crédulité humaine n''hésitent pas à voir dans cet évènement des influences sataniques. Peiresc fait des relevés de cette pluie en recueillant quelques gouttes sur la muraille du cimetière de la cathédrale. Il découvre que ce liquide est laissé par les chrysalides des vanesses lorsqu''elles se muent en papillons (papillons qui avaient été observés)3. Le centre ville n''ayant pas été envahi, il est resté épargné. Cette explication scientifique ne calme pas la terreur populaire5.


Peiresc et l''astronomie

Son talent ne s''arrête pas là. Peiresc est aussi astronome et, à la suite de son ami Galilée, il observe les satellites de Jupiter dont il laisse des croquis montrant qu''il a très bien compris qu''il s''agit de satellites de cette planète. Il veut utiliser les disparitions de ces satellites pour améliorer la connaissance des longitudes et commence à dresser des tables très précises. Apprenant que Galilée a le même projet, il l''abandonne par déférence envers celui qu''il admire6.
Reproduction partielle d''un manuscrit de Peiresc conservé à la Bibliothèque Inguimbertine et montrant la première annonce de la découverte de la nébuleuse d''Orion faite par Peiresc le 26 novembre 1610.

Entre la fin novembre et le début décembre 1610, il découvre la nébuleuse d''Orion qu''il décrit dans ses manuscrits par ces mots :

    « In Orione media... ex duabus stellis composita nubecula quamdam illuminata prima fronte referabat coelo non oie sereno » (observation du 26 novembre 1610).

Il s''aperçoit que la méthode des satellites de Jupiter pour améliorer la connaissance des longitudes n''est pas commode à utiliser, notamment pour les marins. Il tente alors une méthode bien connue des astronomes qui consiste à observer un même phénomène depuis deux lieux distants (par exemple une éclipse de Lune). Pour cela, il coordonne l''observation de l''éclipse de Lune du 28 août 1635 en répartissant des observateurs tout le long de la Méditerranée ; ceci lui permet de constater que cette mer est en réalité plus courte de près de 1 000 km que ce que l''on croyait jusqu''alors6.

Avec l''appui de Gassendi qui l''avait baptisé "le prince des curieux", Peiresc demande au graveur Claude Mellan de dresser la première carte de la Lune fondée sur des observations télescopiques réalisées depuis l''observatoire personnel qu''il a mis en place sur le toit de sa demeure, mais sa mort, alors qu''il est le commanditaire et le financier du projet, va l''empêcher de mener à bien cette tâche.


Un savant éclectique

Peiresc est encore numismate7 (avec son médaillier de plus de 18 000 pièces), archéologue, amateur d''art, historien (il montre que Jules César, lors de sa conquête de l’Angleterre, n’est pas parti de Calais, mais de Saint-Omer), égyptologue, botaniste, zoologue (études sur les caméléons, les crocodiles, l''éléphant et l''alzaron, sorte de gazelle à tête de taureau venant de Nubie et aujourd''hui disparue), physiologiste, géographe (projet de construction d''un canal de Provence reliant Aix à Marseille), et écologiste.

Il s''intéresse également à la géologie et à la paléontologie8

Cet humaniste s''éteint à l''âge de 57 ans.
{/ud}
{ud0_34}https://fr.wikipedia.org/w/index.php?title=Nicolas-Claude_Fabri_de_Peiresc&oldid=118560581{/ud}
{/ud}







{ud0}
{eud}Philippe van Lansberge{/eud}

{ud0_9}Philippe van Lansberge, Lansberg ou Landsbergius est un mathématicien et astronome belge, né à Gand le 25 août 1561, mort après 1632 ; il est seigneur de Maulabeecke{/ud}


{ud0}
{eud}Biographie{/eud}

Fils de Daniel van Lansberge, seigneur de Meulebeke, et de Paulinevan den Honigh. Ses parents l''élevèrent dans la religion protestante à laquelle il resta toujours attaché. Il étudia en Angleterre, revint à Gand, puis quitta derechef sa ville natale pour se fixer à Anvers vers 1580. Lorsqu''en 1585, la métropole commerciale retomba sous l''autorité de Philippe II d''Espagne, il abandonna la Belgique pour s''installer aux Pays-Bas, à Leyden, où il professa comme pasteur puis à Goes puis à Middelbourg, où il exerça la médecine et put surtout se livrer à ses études favorites, les mathématiques et l''astronomie. Il fut l''élève de Simon Stevin à Leyde, et se lia avec Willebrord Snell, qui partageait avec lui la même passion. Il mourut à Middelbourg le 8 novembre 1635 ou le 8 décembre 1632 selon différentes sources (dont Isaac Beeckman), laissant après lui dix enfants. Tallement des Reaux note dans ses historiettes qu''il fut un des rares européens à comprendre l''algèbre de François Viète ; Kepler se sert de ses calculs.

Lansberge fut partisan des hypothèses de Copernic et de Kepler (dont il n''acceptait pas la forme elliptique des orbites planétaires), ce qui lui valut de multiples désagréments de la part des pasteurs protestants.
{/ud}


{ud0_34}https://fr.wikipedia.org/w/index.php?title=Philippe_van_Lansberge&oldid=116732291{/ud}
{/ud}


', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (36, 'Notices BNF (cf. objet ) avec encodage sémantique', NULL, '2015-11-05 22:03:44.180655+01', '2015-11-25 08:58:17.325144+01', NULL, NULL, NULL, NULL, '<root><ud>
Hermann de Carinthie (<en type="li">île de Korčula (Croatie)</en>, <dat when="1105">1105</dat>) <en ref="18" >Philosophe</en>, écrivain, <en ref="16" >mathématicien</en>, <en ref="25" >astrologue</en> et traducteur croate [http://data.bnf.fr/ark:/12148/cb16243624j#foaf:Person]
</ud>
<ud>
Hermann le Dalmate (<en type="li">Saint Peter en Istrie une partie du duché de Carinthie (au sud de l''Autriche)</en>, <dat when="1110">1110</dat>) <en ref="18" >Philosophe</en>, <en ref="24" >astronome</en>, <en ref="25" >astrologue</en>, <en ref="16" >mathématicien</en> et traducteur d''ouvrages scientifiques et de la littérature. - Il vint très jeune en 1135 en France à Paris et à Chartres. - Eut pour maître Thierry de Chartres. - L''abbé de Cluny, Pierre le Vénérable, poussa Herman à traduire à écrire sur la vie et l''oeuvre de Mahomet [http://data.bnf.fr/ark:/12148/cb12364029w#foaf:Person]
</ud>
<ud>
Bhāskarācārya (<en type="li">Dekkan, Inde</en>, <dat when="1114">1114</dat>) <en ref="16" >Mathématicien</en>. - <en ref="24" >Astronome</en>. - Fils de Maheśvara. - Auteur de :  "Siddhāntaśiromanī" (en 1150) ; "Karṇakutūhala" [http://data.bnf.fr/ark:/12148/cb14498624v#foaf:Person]
</ud>
<ud>
al-Muẓaffar ibn Muḥammad Šaraf al-Dīn Ṭūsī (<dat when="1151">1151</dat>) <en ref="16" >Mathématicien</en>. - Originaire de Ṭūs, Hamad̲ān, Mosul, Alep, Damas. - Écrivait vers 1209 [http://data.bnf.fr/ark:/12148/cb120864072#foaf:Person]
</ud>
<ud>
Johannes de Sacro Bosco (<dat when="1151">1151</dat>) <en ref="16" >Mathématicien</en>. - Chanoine prémontré de Holywood (comté de Dumfries, Écosse). - <in ana="1621">Professeur à l''Université de Paris</in>. - Semble être né à Halifax (Yorkshire, Angleterre). - Mort en 1256 ou 1244 [http://data.bnf.fr/ark:/12148/cb121284153#foaf:Person]
</ud>
<ud>
Robertus Castrensis (<dat when="1151">1151</dat>) Traducteur de traités scientifiques et de mathématiques. - Sa période d''activité se situe aux alentours de 1145 [http://data.bnf.fr/ark:/12148/cb12223624k#foaf:Person]
</ud>
<ud>
Alexandre de Villedieu (<en type="li">Villedieu (Manche)</en>, <dat when="1170">1170</dat>) Franciscain. - Grammairien, <en ref="16" >mathématicien</en> et poète. - Chanoine de la cathédrale Saint-André d''Avranches [http://data.bnf.fr/ark:/12148/cb12536245w#foaf:Person]
</ud>
<ud>
Leonardo Fibonacci (<dat when="1170">1170</dat>) <en ref="16" >Mathématicien</en>. - Surnommé Leonardo Pisano [http://data.bnf.fr/ark:/12148/cb13092437c#foaf:Person]
</ud>
<ud>
Moḥamad ben Moḥamad Naṣīr al-Dīn Ṭōsī (<en type="li">Tus (Iran)</en>, <dat when="1201">1201</dat>) <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb12399386c#foaf:Person]
</ud>
<ud>
Jean Pecham (<dat when="1220">1220</dat>) Provincial des franciscains d''Angleterre. - Archevêque de Cantorbéry (à partir de 1279). - <en ref="1629" >Théologien</en>, <en ref="16" >mathématicien</en> et <en ref="1630" >physicien</en> [http://data.bnf.fr/ark:/12148/cb12459837w#foaf:Person]
</ud>
<ud>
Witelo (<dat when="1220">1220</dat>) <en ref="18" >Philosophe</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12054316n#foaf:Person]
</ud>
<ud>
Maḥmūd ibn Mas´ūd Quṭb al-Dīn al- Šīrāzī (<en type="li">Shīrāz</en>, <dat when="1236">1236</dat>) <en ref="24" >Astronome</en>, <en ref="28" >médecin</en>, <en ref="18" >philosophe</en> et <en ref="1629" >théologien</en> [http://data.bnf.fr/ark:/12148/cb12086388m#foaf:Person]
</ud>
<ud>
Jacob ben Machir (<en type="li">Marseille</en>, <dat when="1238">1238</dat>) <en ref="24" >Astronome</en>. - <en ref="28" >Médecin</en>. - Chancellier de la faculté de <en ref="28" >médecin</en>e de Montpellier [http://data.bnf.fr/ark:/12148/cb165406517#foaf:Person]
</ud>
<ud>
Grégoire Chioniadès (<dat when="1240">1240</dat>) <en ref="24" >Astronome</en>, <en ref="1630" >physicien</en> et <en ref="28" >médecin</en> byzantin. - Évêque de Tabriz, Iran [http://data.bnf.fr/ark:/12148/cb12007088c#foaf:Person]
</ud>
<ud>
Henri Baten (<dat when="1246">1246</dat>) <en ref="18" >Philosophe</en> et <en ref="1629" >théologien</en>. - <en ref="24" >Astronome</en>. - Poète et musicien [http://data.bnf.fr/ark:/12148/cb12220635h#foaf:Person]
</ud>
<ud>
al-Mufaḍḍal ibn ʿUmar Aṯīr al-Dīn al-Abharī (<dat when="1251">1251</dat>) <en ref="18" >Philosophe</en>, logicien, <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb15935708x#foaf:Person]
</ud>
<ud>
Bartolomeo da Parma (<dat when="1251">1251</dat>) <en ref="25" >Astrologue</en>, géomancien et <en ref="24" >astronome</en>. <in ana="1621">Fut professeur à l''Université de Bologne (1288-1297)</in> [http://data.bnf.fr/ark:/12148/cb144790439#foaf:Person]
</ud>
<ud>
Campanus de Novare (<dat when="1251">1251</dat>) <en ref="24" >Astronome</en>. - <en ref="16" >Mathématicien</en>, commentateur d''Euclide [http://data.bnf.fr/ark:/12148/cb124917005#foaf:Person]
</ud>
<ud>
David ben Yom-Tov Poel (<dat when="1251">1251</dat>) <en ref="18" >Philosophe</en>. - <en ref="28" >Médecin</en>. - Père de l''<en ref="24" >astronome</en> Jacob Poel [http://data.bnf.fr/ark:/12148/cb16540698w#foaf:Person]
</ud>
<ud>
Démétrius Triclinius (<en type="li">Thessalonique</en>, <dat when="1251">1251</dat>) Philologue. - <en ref="16" >Mathématicien</en> et <en ref="25" >astrologue</en> [http://data.bnf.fr/ark:/12148/cb12311753x#foaf:Person]
</ud>
<ud>
Geršon ben Salomon d''Arles (<en type="li">Béziers</en>, <dat when="1251">1251</dat>) Éxégète. - <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb134867338#foaf:Person]
</ud>
<ud>
Hui Yang (<dat when="1251">1251</dat>) <en ref="16" >Mathématicien</en> chinois. En activité entre 1261 et 1275 [http://data.bnf.fr/ark:/12148/cb13746624q#foaf:Person]
</ud>
<ud>
Isaac ben Joseph Israeli (<dat when="1251">1251</dat>) <en ref="24" >Astronome</en>. - Elève d''Asher ben Jehiel [http://data.bnf.fr/ark:/12148/cb16540863s#foaf:Person]
</ud>
<ud>
Jacopo da Firenze (<dat when="1251">1251</dat>) <en ref="16" >Mathématicien</en>. - Actif en 1307 [http://data.bnf.fr/ark:/12148/cb157815579#foaf:Person]
</ud>
<ud>
Jordanus Nemorarius (<dat when="1251">1251</dat>) <en ref="16" >Mathématicien</en>. - Probablement d''origine italienne [http://data.bnf.fr/ark:/12148/cb11986727x#foaf:Person]
</ud>
<ud>
Petrus Philomena de Dacia (<dat when="1251">1251</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en>, <en ref="18" >philosophe</en>. - Attesté entre 1290 et 1300. - Élève à l''Université de Bologne (1291-1292) puis de Paris. - Chanoine de Roskilde, Danemark. - A distinguer de Petrus de Dacia, recteur de l''Université de Paris en 1327 [http://data.bnf.fr/ark:/12148/cb11887258w#foaf:Person]
</ud>
<ud>
ʿAbd al-Ġaffār ibn ʿAbd al-Karīm Naǧm al-Dīn al- Qazwīnī (<dat when="1251">1251</dat>) <en ref="16" >Mathématicien</en> et jurisconsulte chaféite [http://data.bnf.fr/ark:/12148/cb155674927#foaf:Person]
</ud>
<ud>
Andalò Di Negro (<en type="li">Gênes (?), Italie</en>, <dat when="1260">1260</dat>) <en ref="24" >Astronome</en>. - Précepteur de Boccace. - Ambassadeur de la République de Gênes auprès de l''empereur Alexis Comnène (en 1314) [http://data.bnf.fr/ark:/12148/cb121998732#foaf:Person]
</ud>
<ud>
Théodore Métochite (<en type="li">Constantinople</en>, <dat when="1260">1260</dat>) Homme d''état, <en ref="18" >philosophe</en>, poète, <en ref="24" >astronome</en> et rhéteur [http://data.bnf.fr/ark:/12148/cb12000562c#foaf:Person]
</ud>
<ud>
Gersonide (Bagnols-sur-Cèze (<en type="li">Gard)</en>, <dat when="1288">1288</dat>) Exégète biblique, <en ref="16" >mathématicien</en>, <en ref="24" >astronome</en>, <en ref="18" >philosophe</en>, <en ref="1630" >physicien</en> [http://data.bnf.fr/ark:/12148/cb12131941j#foaf:Person]
</ud>
<ud>
Barlaam de Seminara (<dat when="1290">1290</dat>) Moine basilien, abbé du Saint-Esprit à Constantinople (<dat when="1331">1331</dat>), évêque de Gérace (1342-1348). - <en ref="1629" >Théologien</en>, <en ref="18" >philosophe</en>, <en ref="16" >mathématicien</en>, <en ref="24" >astronome</en> et helléniste [http://data.bnf.fr/ark:/12148/cb13549924x#foaf:Person]
</ud>
<ud>
Jacopo Dondi (<dat when="1290">1290</dat>) <en ref="18" >Philosophe</en>, <en ref="24" >astronome</en>, <en ref="28" >médecin</en> italien célèbre pour la construction d''une pendule astrale à Padoue. - Père de Giovanni Dondi [http://data.bnf.fr/ark:/12148/cb124119184#foaf:Person]
</ud>
<ud>
Thomas Bradwardine (<dat when="1290">1290</dat>) <en ref="16" >Mathématicien</en>, <en ref="18" >philosophe</en> et <en ref="1629" >théologien</en>. - Surnommé le "Doctor Profundus". - Archevêque de Canterbury en 1349 [http://data.bnf.fr/ark:/12148/cb12269047v#foaf:Person]
</ud>
<ud>
Richard of Wallingford (<dat when="1292">1292</dat>) <en ref="16" >Mathématicien</en>. - <en ref="24" >Astronome</en>. - Abbé du monastère bénédictin de St Albans [http://data.bnf.fr/ark:/12148/cb12128305h#foaf:Person]
</ud>
<ud>
Jean de Murs (<dat when="1300">1300</dat>) <en ref="24" >Astronome</en>, <en ref="16" >mathématicien</en> et théoricien de la musique. - Maître-ès-arts de l''Université de Paris (<dat when="1321">1321</dat>) [http://data.bnf.fr/ark:/12148/cb121715011#foaf:Person]
</ud>
<ud>
Giovanni Dondi dall''Orologio (<en type="li">Chiogga, Italie</en>, <dat when="1318">1318</dat>) <en ref="28" >Médecin</en> et poète. - <en ref="24" >Astronome</en> et horloger, a terminé l''horloge astronomique, installée par son père : Dondi, Jacopo (1298-1359), à Padoue ou Pavie, Italie [http://data.bnf.fr/ark:/12148/cb122241024#foaf:Person]
</ud>
<ud>
Giacomo Allegretti (<dat when="1325">1325</dat>) <en ref="28" >Médecin</en> , poète et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb14405998n#foaf:Person]
</ud>
<ud>
Blasius de Parma (<dat when="1347">1347</dat>) <en ref="18" >Philosophe</en>, <en ref="16" >mathématicien</en>, <en ref="28" >médecin</en>. - Recteur de l''université de Parme (en 1412) [http://data.bnf.fr/ark:/12148/cb12182615f#foaf:Person]
</ud>
<ud>
Abū ʿAbd Allâh Muḥammad al- Baqqār (<dat when="1351">1351</dat>) <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb155102056#foaf:Person]
</ud>
<ud>
Emmanuel ben Jacob de Tarascon Bonfils (<dat when="1351">1351</dat>) <en ref="24" >Astronome</en>, <en ref="28" >médecin</en> et <en ref="16" >mathématicien</en> ayant vécu à Orange puis à Tarascon. Il est l''auteur de nombreux traités d''astronomie [http://data.bnf.fr/ark:/12148/cb15620448d#foaf:Person]
</ud>
<ud>
Ǧamšīd ibn Masʿūd Ġiyāṯ al-Dīn al- Kāšī (<dat when="1351">1351</dat>) <en ref="28" >Médecin</en>, <en ref="16" >mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb11351746b#foaf:Person]
</ud>
<ud>
Johannes Danck (<dat when="1351">1351</dat>) <en ref="24" >Astronome</en>. - A enseigné à l''Université de Paris de 1327 à 1355 [http://data.bnf.fr/ark:/12148/cb12531239r#foaf:Person]
</ud>
<ud>
Naǧm al-Dīn al- Miṣrī (<dat when="1351">1351</dat>) Auteur supposé de traités portant sur les instruments astronomiques [http://data.bnf.fr/ark:/12148/cb14566743g#foaf:Person]
</ud>
<ud>
Prosdocimus de Beldemandis (<dat when="1351">1351</dat>) Théoricien de la musique, <en ref="16" >mathématicien</en> et <en ref="1630" >physicien</en> [http://data.bnf.fr/ark:/12148/cb127653823#foaf:Person]
</ud>
<ud>
Taddeo da Parma (<dat when="1351">1351</dat>) <en ref="18" >Philosophe</en> averroïste et <en ref="24" >astronome</en>. - A enseigné la philosophie à Bologne vers 1320 [http://data.bnf.fr/ark:/12148/cb10103512f#foaf:Person]
</ud>
<ud>
Théodore Méliténiote (<en type="li">Constantinople</en>, <dat when="1351">1351</dat>) Grand sacellaire de l''Église byzantine, maître des maîtres de l''École patriarcale et archidiacre du clergé palatin. - A laissé un ouvrage d''exégèse de l''Évangile, un traité d''astronomie et un poème allégorique [http://data.bnf.fr/ark:/12148/cb12153709d#foaf:Person]
</ud>
<ud>
Paolo dal Pozzo Toscanelli (<dat when="1397">1397</dat>) <en ref="16" >Mathématicien</en>, <en ref="1630" >physicien</en>, <en ref="29" >géographe</en>, <en ref="24" >astronome</en> et <en ref="25" >astrologue</en>. - Inventeur des gnomons modernes. - Conservateur de la Bibliothèque de Florence [http://data.bnf.fr/ark:/12148/cb12455406j#foaf:Person]
</ud>
<ud>
Ugolino Pisani (<en type="li">Parme, Italie</en>, <dat when="1405">1405</dat>) <en ref="18" >Philosophe</en>, <en ref="16" >mathématicien</en>, auteur de comédies [http://data.bnf.fr/ark:/12148/cb12689419t#foaf:Person]
</ud>
<ud>
Lorenzo Buonincontri (<en type="li">San Miniato, Italie</en>, <dat when="1411">1411</dat>) Militaire, <en ref="16" >mathématicien</en>, <en ref="24" >astronome</en>, <en ref="25" >astrologue</en>, poète et historien. - <in ana="1621">Professeur d''astronomie à Naples</in> [http://data.bnf.fr/ark:/12148/cb12536229n#foaf:Person]
</ud>
<ud>
ʿAlī ibn Muḥammad al- Qalaṣādī (<en type="li">Baza (Espagne)</en>, <dat when="1412">1412</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en>, juriste et savant [http://data.bnf.fr/ark:/12148/cb12440997n#foaf:Person]
</ud>
<ud>
Piero della Francesca (<en type="li">Borgo San Sepolcro, Italie</en>, <dat when="1416">1416</dat>) Peintre. - A écrit des traités de mathématiques, perspective et géométrie et des écrits sur la science des couleurs et du paysage [http://data.bnf.fr/ark:/12148/cb12060279h#foaf:Person]
</ud>
<ud>
Georgius de Hungaria (<en type="li">Romosz, aujourd''hui Romos, Roumanie</en>, <dat when="1422">1422</dat>) Prisonnier des Turcs (1438-1458). - Dominicain. - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb130923013#foaf:Person]
</ud>
<ud>
Antonio Manetti (<en type="li">Florence, Italie</en>, <dat when="1423">1423</dat>) Homme de lettres. - <en ref="1635" >Architecte</en>, <en ref="24" >astronome</en>, <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb11914242h#foaf:Person]
</ud>
<ud>
Georg von Peurbach (<en type="li">Peuerbach, Autriche</en>, <dat when="1423">1423</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb12374660w#foaf:Person]
</ud>
<ud>
Giovanni Pontano (<en type="li">Cerreto di Spoleto (Perouse), Italie</en>, <dat when="1426">1426</dat>) Homme politique. - Humaniste. - Auteur de traités astronomiques et philosophiques [http://data.bnf.fr/ark:/12148/cb123298807#foaf:Person]
</ud>
<ud>
Johannes Regiomontanus (<en type="li">Königsberg, Allemagne</en>, <dat when="1436">1436</dat>) <en ref="24" >Astronome</en>. - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12159829r#foaf:Person]
</ud>
<ud>
Nīlakaṇṭha Somayajī (<dat when="1443">1443</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en> de l''école de Kerala (Inde) [http://data.bnf.fr/ark:/12148/cb165324540#foaf:Person]
</ud>
<ud>
Luca Pacioli (<dat when="1445">1445</dat>) <en ref="16" >Mathématicien</en>. - Franciscain [http://data.bnf.fr/ark:/12148/cb11918350c#foaf:Person]
</ud>
<ud>
Konrad Türst (<dat when="1450">1450</dat>) <en ref="16" >Mathématicien</en> suisse de Zürich [http://data.bnf.fr/ark:/12148/cb15336511g#foaf:Person]
</ud>
<ud>
Agostino Ricci (<dat when="1451">1451</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb12539498r#foaf:Person]
</ud>
<ud>
Andrea Corsali (<dat when="1451">1451</dat>) <en ref="24" >Astronome</en>, cosmographe, navigateur dans la péninsule arabique et aux Indes. - Pourrait avoir introduit l''imprimerie en Éthiopie (ca 1524), où vraisemblament il meurt [http://data.bnf.fr/ark:/12148/cb13517283d#foaf:Person]
</ud>
<ud>
Anianus (<dat when="1451">1451</dat>) <en ref="24" >Astronome</en> et poète [http://data.bnf.fr/ark:/12148/cb125156549#foaf:Person]
</ud>
<ud>
Antonio Dolciati (<dat when="1451">1451</dat>) Augustinien et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb134854696#foaf:Person]
</ud>
<ud>
Bartolomeo da Messina (<dat when="1451">1451</dat>) Écclésiastique et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb125393703#foaf:Person]
</ud>
<ud>
Gaspar Torrella (<dat when="1451">1451</dat>) <en ref="28" >Médecin</en> et <en ref="16" >mathématicien</en>. - Évêque de Santa-Giusta (Sardaigne) en 1494. - Originaire de Valence (Espagne) [http://data.bnf.fr/ark:/12148/cb13486025q#foaf:Person]
</ud>
<ud>
Giovanni Abiosi (<dat when="1451">1451</dat>) <en ref="28" >Médecin</en>, <en ref="24" >astronome</en>, <en ref="16" >mathématicien</en> et <en ref="18" >philosophe</en>. - Né à Bagnuolo (Royaume de Naples), mort vers 1500 [http://data.bnf.fr/ark:/12148/cb12537367q#foaf:Person]
</ud>
<ud>
Giovanni Antonio Tagliente (<dat when="1451">1451</dat>) Calligraphe. - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12179148h#foaf:Person]
</ud>
<ud>
Giovanni Benedetto Moncetto (<dat when="1451">1451</dat>) Agostinien. - <en ref="1629" >Théologien</en>, <en ref="18" >philosophe</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb125688716#foaf:Person]
</ud>
<ud>
Giovanni Bianchini (<dat when="1451">1451</dat>) <en ref="24" >Astronome</en> mort après 1469 [http://data.bnf.fr/ark:/12148/cb16163624s#foaf:Person]
</ud>
<ud>
Guillaume Hobit (<dat when="1451">1451</dat>) <en ref="24" >Astronome</en> ; <en ref="25" >astrologue</en> de Philippe le Bon, duc de Bourgogne [http://data.bnf.fr/ark:/12148/cb15063496s#foaf:Person]
</ud>
<ud>
Jacob Köbel (<en type="li">Heidelberg, Allemagne</en>, <dat when="1451">1451</dat>) <en ref="16" >Mathématicien</en>, éditeur et <en ref="1631" >libraire</en> [http://data.bnf.fr/ark:/12148/cb10244031k#foaf:Person]
</ud>
<ud>
Louis Boulengier (<dat when="1451">1451</dat>) <en ref="24" >Astronome</en> et <en ref="29" >géographe</en> d''Albi [http://data.bnf.fr/ark:/12148/cb152949413#foaf:Person]
</ud>
<ud>
Rāmacandrācārya (<dat when="1451">1451</dat>) Grammairien et commentateur de Pāṇini (actif au 15e s.). - Fils de Kr̥ṣṇācārya. - A aussi écrit des ouvrages de philosophie (Vedānta) et d''astronomie [http://data.bnf.fr/ark:/12148/cb137708651#foaf:Person]
</ud>
<ud>
Sigismondo Fanti (<en type="li">Ferrare, Italie</en>, <dat when="1451">1451</dat>) Poète, <en ref="18" >philosophe</en> et <en ref="16" >mathématicien</en>. - Meurt après 1527 [http://data.bnf.fr/ark:/12148/cb12567416q#foaf:Person]
</ud>
<ud>
Willem Gilliszoon (<dat when="1451">1451</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en>. - Originaire de Wissekerc (Zélande) [http://data.bnf.fr/ark:/12148/cb12548011q#foaf:Person]
</ud>
<ud>
Girolamo Donato (<dat when="1454">1454</dat>) Magistrat, poète, <en ref="18" >philosophe</en>, <en ref="1629" >théologien</en> et <en ref="16" >mathématicien</en>. - Fut gouverneur de Brescia (<dat when="1496">1496</dat>), de Ferrare (<dat when="1498">1498</dat>), ambassadeur de Venise près le pape Jules II (<dat when="1510">1510</dat>) [http://data.bnf.fr/ark:/12148/cb13325565p#foaf:Person]
</ud>
<ud>
Eliya Delmedigo (<dat when="1460">1460</dat>) <en ref="28" >Médecin</en>. - <en ref="24" >Astronome</en>. - <en ref="16" >Mathématicien</en>. - Né en Crète. - <en ref="18" >Philosophe</en>. - Maître d''hébreu de Pic de la Mirandole (1463-1494). - Commentateur des écrits d''Averroés (1126-1198) [http://data.bnf.fr/ark:/12148/cb122623668#foaf:Person]
</ud>
<ud>
Lodovico Pontico Virunio (<dat when="1467">1467</dat>) <in ana="1621">Professeur de lettres, <en ref="18" >philosophe</en></in>, <en ref="16" >mathématicien</en> et poète. - Fut chargé de l''éducation des fils de Ludovico Sforza, duc de Milan. - Eut l''intention de fonder une imprimerie grecque et latine à Reggio Emilia, mais ses caractères furent volés par Ludovico Bonaccioli, <en ref="28" >médecin</en> de la duchesse de Ferrare. - Né à Belluno, meurt à Bologne [http://data.bnf.fr/ark:/12148/cb13324006j#foaf:Person]
</ud>
<ud>
Johannes Werner (<en type="li">Nuremberg, Allemagne</en>, <dat when="1468">1468</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en> et <en ref="1636" >cartographe</en> [http://data.bnf.fr/ark:/12148/cb154028305#foaf:Person]
</ud>
<ud>
Jakob Ziegler (<en type="li">Landau (Allemagne)</en>, <dat when="1470">1470</dat>) <en ref="1629" >Théologien</en>, <en ref="16" >mathématicien</en>, <en ref="24" >astronome</en> et <en ref="29" >géographe</en>. - <in ana="1621">Professeur de théologie.</in> - Commentateur et auteur d''ouvrages historiques et théologiques [http://data.bnf.fr/ark:/12148/cb15029346k#foaf:Person]
</ud>
<ud>
Pedro Ciruelo (<en type="li">Daroca, Espagne</en>, <dat when="1470">1470</dat>) <in ana="1621">Professeur de théologie à l''Université d''Alcala (1510-)</in>, chanoine de la cathédrale de cette ville. - Fut l''un des précepteurs de Philippe II. - Étudia à Salamanque et à Paris, où il édita des oeuvres mathématiques et scientifiques. - Est également l''auteur d''un traité sur la sorcellerie dont la traduction espagnole eut une diffusion importante [http://data.bnf.fr/ark:/12148/cb128071494#foaf:Person]
</ud>
<ud>
Johann Stöffler (<en type="li">Justingen, Allemagne</en>, <dat when="1472">1472</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb125156905#foaf:Person]
</ud>
<ud>
Josse Clicthove (Nieuport, Pays-Bas, <dat when="1472">1472</dat>) <en ref="1629" >Théologien</en> et <en ref="16" >mathématicien</en>. - Théologal de Chartres. - Un des premiers à combattre les idées de Luther [http://data.bnf.fr/ark:/12148/cb12234610b#foaf:Person]
</ud>
<ud>
Bartolomeo Zamberti (<en type="li">Venise, Italie</en>, <dat when="1473">1473</dat>) <en ref="16" >Mathématicien</en> et humaniste. - <in ana="1621">Professeur de lettres.</in> - Notaire des Consuls des marchands de Venise [http://data.bnf.fr/ark:/12148/cb12033590z#foaf:Person]
</ud>
<ud>
Nicolas Copernic (<dat when="1473">1473</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb118976048#foaf:Person]
</ud>
<ud>
Luca Gaurico (<en type="li">Giffoni, Italie</en>, <dat when="1476">1476</dat>) Évêque de Civita Ducale (1545-1549). - <en ref="16" >Mathématicien</en>, <en ref="18" >philosophe</en>, <en ref="24" >astronome</en> et <en ref="25" >astrologue</en> [http://data.bnf.fr/ark:/12148/cb134849440#foaf:Person]
</ud>
<ud>
Johann Schöner (<dat when="1477">1477</dat>) Né à Karlstadt près de Würzburg. - Prédicateur protestant. - <en ref="24" >Astronome</en>. - <en ref="29" >Géographe</en>. - <in ana="1621">Professeur de mathématiques à Nuremberg.</in> - A aussi écrit en latin [http://data.bnf.fr/ark:/12148/cb119992233#foaf:Person]
</ud>
<ud>
Girolamo Fracastoro (<en type="li">Vérone, Italie</en>, <dat when="1478">1478</dat>) <en ref="28" >Médecin</en>, auteur du "De contagione et contagiosis morbis et curatione libri III" ; nommé par le pape Paul III <en ref="28" >médecin</en> officiel du Concile de Trente. - Auteur de poèmes en latin, d''oeuvres de géographie, d''astronomie, de physique, de théologie et de philosophie. - Élève de Pomponazzi, ami de Copernic [http://data.bnf.fr/ark:/12148/cb120587788#foaf:Person]
</ud>
<ud>
Girolamo Francastoro (<dat when="1478">1478</dat>) <en ref="28" >Médecin</en>, <en ref="24" >astronome</en>, géologiste, poète, précurseur de la notion de contagion [http://data.bnf.fr/ark:/12148/cb15699396m#foaf:Person]
</ud>
<ud>
Celio Calcagnini (<en type="li">Ferrare, Italie</en>, <dat when="1479">1479</dat>) Poète, philologue, <en ref="18" >philosophe</en> et <en ref="24" >astronome</en>. - Accompagna Hippolyte d''Este en Hongrie et en Pologne [http://data.bnf.fr/ark:/12148/cb122157991#foaf:Person]
</ud>
<ud>
Charles de Bovelles (<dat when="1479">1479</dat>) <en ref="18" >Philosophe</en>, <en ref="16" >mathématicien</en> et linguiste. - Chanoine de Noyon. - Né avant le 28 mars 1479 [http://data.bnf.fr/ark:/12148/cb118932166#foaf:Person]
</ud>
<ud>
Prospero Calano (<en type="li">Sarzana, Italie</en>, <dat when="1480">1480</dat>) <en ref="28" >Médecin</en>, <en ref="24" >astronome</en> et <en ref="18" >philosophe</en> [http://data.bnf.fr/ark:/12148/cb12568870v#foaf:Person]
</ud>
<ud>
Vannoccio Biringuccio (<en type="li">Sienne, Italie</en>, <dat when="1480">1480</dat>) <en ref="16" >Mathématicien</en>, chimiste, <en ref="1635" >architecte</en> et <en ref="1633" >ingénieur</en>, spécialiste en métallurgie [http://data.bnf.fr/ark:/12148/cb12195640k#foaf:Person]
</ud>
<ud>
Michael Stifel (<dat when="1487">1487</dat>) <en ref="1629" >Théologien</en> et <en ref="16" >mathématicien</en>. - Inventeur du logarithme. - Enseigna la théologie et les mathématiques à l''Université de Königsberg, puis les mathématiques à l''Université de Iéna [http://data.bnf.fr/ark:/12148/cb12795734z#foaf:Person]
</ud>
<ud>
Sebastian Münster (<en type="li">Ingelheim, Allemagne</en>, <dat when="1489">1489</dat>) Hébraïsant, <en ref="29" >géographe</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb11996987j#foaf:Person]
</ud>
<ud>
Albert Pighius (Kampen, Pays-Bas, <dat when="1490">1490</dat>) <en ref="1629" >Théologien</en>, <en ref="16" >mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb10448635x#foaf:Person]
</ud>
<ud>
Patrizio Tricasso (<en type="li">Ceresara, Italie</en>, <dat when="1491">1491</dat>) Dominicain. - <en ref="16" >Mathématicien</en> et <en ref="25" >astrologue</en> [http://data.bnf.fr/ark:/12148/cb107034397#foaf:Person]
</ud>
<ud>
Heinrich Schreiber (<en type="li">Erfurt, Allemagne</en>, <dat when="1492">1492</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb10734904t#foaf:Person]
</ud>
<ud>
Jean Borrel (<dat when="1492">1492</dat>) Géomètre et <en ref="16" >mathématicien</en>. - Chanoine régulier de l''Ordre de Saint-Antoine [http://data.bnf.fr/ark:/12148/cb12515817n#foaf:Person]
</ud>
<ud>
Pedro Nunez (<dat when="1492">1492</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12548918m#foaf:Person]
</ud>
<ud>
Oronce Fine (Briançon (Hautes-Alpes), <dat when="1494">1494</dat>) Sieur de Champrouet. - <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb122937307#foaf:Person]
</ud>
<ud>
Petrus Apian (<en type="li">Leisnig (Allemagne)</en>, <dat when="1495">1495</dat>) <en ref="24" >Astronome</en>, <en ref="1636" >cartographe</en> et <en ref="16" >mathématicien</en>. - Nommé Chevalier de l''Empire par Charles Quint. - Surnom de : Bienewitz (ou Bennewitz), Peter [http://data.bnf.fr/ark:/12148/cb12515640m#foaf:Person]
</ud>
<ud>
Andreas Osiander (<en type="li">Gunzenhausen, Allemagne</en>, <dat when="1498">1498</dat>) <en ref="1629" >Théologien</en> protestant, <en ref="24" >astronome</en> et <en ref="16" >mathématicien</en>. - Parfois désigné sous le nom "Andreas Osiander l''Ancien" [http://data.bnf.fr/ark:/12148/cb11988942v#foaf:Person]
</ud>
<ud>
Garcia da Orta (<en type="li">Castelo di Vide, Portugal</en>, <dat when="1499">1499</dat>) <en ref="28" >Médecin</en> et naturaliste. - A enseigné les mathématiques à l''Université de Lisbonne [http://data.bnf.fr/ark:/12148/cb119983323#foaf:Person]
</ud>
<ud>
Giovanni Agostino Abate (<dat when="1499">1499</dat>) <en ref="16" >Mathématicien</en> et historien [http://data.bnf.fr/ark:/12148/cb14624324z#foaf:Person]
</ud>
<ud>
Joachim Sterck van Ringelberg (<en type="li">Anvers, Belgique</en>, <dat when="1499">1499</dat>) Humaniste, <en ref="16" >mathématicien</en> et <en ref="25" >astrologue</en>. - Meurt selon les sources le 1er janvier 1531, en 1536 ou en 1556 [http://data.bnf.fr/ark:/12148/cb10645118k#foaf:Person]
</ud>
<ud>
Johann Carion (<en type="li">Bietigheim, Allemagne</en>, <dat when="1499">1499</dat>) <en ref="25" >Astrologue</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12805831h#foaf:Person]
</ud>
<ud>
Johannes Dryander (<en type="li">Wetter, Allemagne</en>, <dat when="1500">1500</dat>) <en ref="16" >Mathématicien</en>, <en ref="1630" >physicien</en> et <en ref="24" >astronome</en>, <in ana="1621">professeur à Marburg</in>, édité par Sebastian Münster et Abraham Ortelius [http://data.bnf.fr/ark:/12148/cb15379218m#foaf:Person]
</ud>
<ud>
Johannes Voegelin (<en type="li">Heilbronn, Allemagne</en>, <dat when="1500">1500</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en>. - Professeur à l''Université de Vienne [http://data.bnf.fr/ark:/12148/cb10490264h#foaf:Person]
</ud>
<ud>
Niccolò Tartaglia (<dat when="1500">1500</dat>) <en ref="16" >Mathématicien</en>, <en ref="1633" >ingénieur</en> et <en ref="1635" >architecte</en>. - Pseudonyme de Niccolò Fontana [http://data.bnf.fr/ark:/12148/cb12914492r#foaf:Person]
</ud>
<ud>
Gerolamo Cardano (<en type="li">Pavie, Italie</en>, <dat when="1501">1501</dat>) <en ref="28" >Médecin</en>, <en ref="16" >mathématicien</en> et <en ref="18" >philosophe</en> [http://data.bnf.fr/ark:/12148/cb11895137c#foaf:Person]
</ud>
<ud>
Pedro Nunes (<en type="li">Alcácer do Sol (Portugal)</en>, <dat when="1502">1502</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en> portugais [http://data.bnf.fr/ark:/12148/cb13510349t#foaf:Person]
</ud>
<ud>
Cosimo Bartoli (<en type="li">Florence, Italie</en>, <dat when="1503">1503</dat>) Ambassadeur, poète et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb125520809#foaf:Person]
</ud>
<ud>
Jean Cousin (<en type="li">Soucy (Yonne, France)</en>, <dat when="1503">1503</dat>) Peintre, sculpteur, graveur, <en ref="1635" >architecte</en>, <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12467444s#foaf:Person]
</ud>
<ud>
Ciriaco Strozzi (<en type="li">Capalle, Italie</en>, <dat when="1504">1504</dat>) Helléniste, <en ref="18" >philosophe</en>, <en ref="16" >mathématicien</en> et <en ref="1635" >architecte</en> [http://data.bnf.fr/ark:/12148/cb10418521b#foaf:Person]
</ud>
<ud>
Jacques Bassantin (<dat when="1504">1504</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12548014r#foaf:Person]
</ud>
<ud>
Achille Pirminius Gasser (<dat when="1505">1505</dat>) <en ref="28" >Médecin</en>, historien et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb12516715x#foaf:Person]
</ud>
<ud>
Benedictus Aretius (<dat when="1505">1505</dat>) <en ref="1629" >Théologien</en> protestant. - Botaniste et <en ref="24" >astronome</en>. - <in ana="1621">Professeur de logique à l''Université de Marbourg</in>, puis <in ana="1621">professeur de théologie à Berne</in>. - Fut lié avec Conrad Gesner. - Né et mort à Berne [http://data.bnf.fr/ark:/12148/cb12515850g#foaf:Person]
</ud>
<ud>
Alessandro Piccolomini (<en type="li">Sienne, Italie</en>, <dat when="1508">1508</dat>) Écrivain, dramaturge, <en ref="24" >astronome</en> et traducteur d''oeuvres de l''Antiquité, de comédies, de traités philosophiques et scientifiques. - Membre de l''Accademia degli Intronati de Sienne, sous le pseudonyme : lo Stordito. - Archevêque de Patras et coadjuteur de l''archevêque de Sienne Francesco Bandini Piccolomini, du 28 juillet 1574 à 1578 [http://data.bnf.fr/ark:/12148/cb12240709n#foaf:Person]
</ud>
<ud>
Gemma Frisius (Dokkum (Pays-Bas), <dat when="1508">1508</dat>) <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en>. - Professeur et docteur en <en ref="28" >médecin</en>e de l''Université de Louvain [http://data.bnf.fr/ark:/12148/cb125195002#foaf:Person]
</ud>
<ud>
Federico Commandino (<en type="li">Sassocorvaro, Italie</en>, <dat when="1509">1509</dat>) <en ref="16" >Mathématicien</en>. - A été le tuteur du duc d''Urbino [http://data.bnf.fr/ark:/12148/cb12562850s#foaf:Person]
</ud>
<ud>
Jean Gosselin (<en type="li">Vire, Calvados</en>, <dat when="1510">1510</dat>) <en ref="25" >Astrologue</en> et <en ref="16" >mathématicien</en>. - Conservateur de la bibliothèque du roi [http://data.bnf.fr/ark:/12148/cb133321861#foaf:Person]
</ud>
<ud>
Pietro Cataneo (<dat when="1510">1510</dat>) <en ref="1635" >Architecte</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12557068n#foaf:Person]
</ud>
<ud>
Erasmus Oswald Schreckenfuchs (<dat when="1511">1511</dat>) Hébraïsant. - <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb12115338j#foaf:Person]
</ud>
<ud>
Giovanni Battista Amici (<en type="li">Cosenza, Italie</en>, <dat when="1511">1511</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb15583428k#foaf:Person]
</ud>
<ud>
Juanelo Turriano (<dat when="1511">1511</dat>) <en ref="16" >Mathématicien</en> et <en ref="1633" >ingénieur</en> [http://data.bnf.fr/ark:/12148/cb129309990#foaf:Person]
</ud>
<ud>
Gerard Mercator (<en type="li">Rupelmonde, Flandres</en>, <dat when="1512">1512</dat>) <en ref="29" >Géographe</en>, <en ref="1636" >cartographe</en>, cosmographe et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12789989j#foaf:Person]
</ud>
<ud>
Giovanni Battista Amico (<dat when="1512">1512</dat>) <en ref="18" >Philosophe</en>, <en ref="16" >mathématicien</en> et <en ref="25" >astrologue</en>. - Originaire de Cosenza, fut assassiné à Padoue [http://data.bnf.fr/ark:/12148/cb12570280s#foaf:Person]
</ud>
<ud>
Juan Pérez de Moya (<dat when="1513">1513</dat>) <en ref="16" >Mathématicien</en> et humaniste [http://data.bnf.fr/ark:/12148/cb12146300q#foaf:Person]
</ud>
<ud>
Rheticus (<dat when="1514">1514</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb13615799v#foaf:Person]
</ud>
<ud>
Bernardino Baldini (<dat when="1515">1515</dat>) Professeur de <en ref="28" >médecin</en>e à Pavie puis de mathématiques à Milan [http://data.bnf.fr/ark:/12148/cb13163998r#foaf:Person]
</ud>
<ud>
Petrus Ramus (<en type="li">Cuts (Aisne)</en>, <dat when="1515">1515</dat>) <en ref="18" >Philosophe</en>, grammairien, <en ref="16" >mathématicien</en> et humaniste. - Professeur de mathématique au Collège royal (Collège de France). - Se convertit au protestantisme et fut tué au cours du Massacre de la Saint-Barthélemy [http://data.bnf.fr/ark:/12148/cb120645094#foaf:Person]
</ud>
<ud>
Jean-Pierre de Mesmes (<dat when="1516">1516</dat>) Savant et poète. - Fils de Pierre de Mesmes, chambellan du roi de Navarre. - Etait lié avec Ronsard, du Bellay, Baïf, Charondas, Herberay, Jean Maugin, Ol. de Magny. - A était un des premiers auteurs à avoir écrit en français sur l''astronomie [http://data.bnf.fr/ark:/12148/cb125177720#foaf:Person]
</ud>
<ud>
Jacques Peletier (<dat when="1517">1517</dat>) Poète et critique humaniste. - <en ref="16" >Mathématicien</en>. - A participé à la réforme de l''orthographe. - Traducteur d''Horace [http://data.bnf.fr/ark:/12148/cb122992680#foaf:Person]
</ud>
<ud>
Jeronimo Munoz (<dat when="1520">1520</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb14646245j#foaf:Person]
</ud>
<ud>
Livio Sanuto (<dat when="1520">1520</dat>) <en ref="29" >Géographe</en> et <en ref="16" >mathématicien</en> à Venise, fabriquant d''un globe avec son frère Giulio en 1561 [http://data.bnf.fr/ark:/12148/cb153816227#foaf:Person]
</ud>
<ud>
Melchior Ayrer (<dat when="1520">1520</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb162974318#foaf:Person]
</ud>
<ud>
Nicolaus Gugler (<en type="li">Nuremberg (Allemagne)</en>, <dat when="1521">1521</dat>) <en ref="28" >Médecin</en> et <en ref="24" >astronome</en>, a reçu une formation de juriste. - Fils de Hans Gugler (1480-1560) [http://data.bnf.fr/ark:/12148/cb16504896w#foaf:Person]
</ud>
<ud>
Valentin Mennher (<dat when="1521">1521</dat>) <en ref="16" >Mathématicien</en>. - Membre de la guilde des instituteurs d''Anvers [http://data.bnf.fr/ark:/12148/cb12563197r#foaf:Person]
</ud>
<ud>
Hermann Witekind (<en type="li">Neuenrade (Allemagne)</en>, <dat when="1522">1522</dat>) <en ref="16" >Mathématicien</en> et humaniste [http://data.bnf.fr/ark:/12148/cb162248258#foaf:Person]
</ud>
<ud>
Giovanni Maria Bonardo (<en type="li">Fratta Polesine, Italie</en>, <dat when="1523">1523</dat>) Poète. - Agronome. - <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb12181418p#foaf:Person]
</ud>
<ud>
Juan de Yciar (Durango (prov. de Vizcaya), <dat when="1523">1523</dat>) Pédagogue, <en ref="16" >mathématicien</en> et calligraphe [http://data.bnf.fr/ark:/12148/cb128696315#foaf:Person]
</ud>
<ud>
Jacques Charpentier (Clermont-en-Beauvaisis (<en type="li">Oise)</en>, <dat when="1524">1524</dat>) <en ref="18" >Philosophe</en> et <en ref="28" >médecin</en>. - Lecteur de mathématiques au Collège de France. - <en ref="28" >Médecin</en> du roi [http://data.bnf.fr/ark:/12148/cb121323921#foaf:Person]
</ud>
<ud>
Tadeáš Hájek (<en type="li">Prague</en>, <dat when="1525">1525</dat>) <en ref="16" >Mathématicien</en> et <en ref="28" >médecin</en>. - Reçu docteur à Bologne, occupa une chaire au Carolinum de Prague, fut premier <en ref="28" >médecin</en> des empereurs Maximilien II et Rodolphe II [http://data.bnf.fr/ark:/12148/cb13009688n#foaf:Person]
</ud>
<ud>
Tilemann Stella (<en type="li">Siegen (Allemagne)</en>, <dat when="1525">1525</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en>, <en ref="29" >géographe</en>, <en ref="1635" >architecte</en> et bibliothécaire. - <en ref="1636" >Cartographe</en> à Wittenberg, ses cartes ont été éditées par Ortelius, Jode et Hondius [http://data.bnf.fr/ark:/12148/cb15376436c#foaf:Person]
</ud>
<ud>
Taqī al-Dīn Muḥammad Ibn Maʿrūf (<en type="li">Damas</en>, <dat when="1526">1526</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en> ottoman [http://data.bnf.fr/ark:/12148/cb14599962n#foaf:Person]
</ud>
<ud>
John Dee (<dat when="1527">1527</dat>) <en ref="25" >Astrologue</en>, <en ref="16" >mathématicien</en> et antiquaire [http://data.bnf.fr/ark:/12148/cb119854464#foaf:Person]
</ud>
<ud>
Adam Lonicer (<en type="li">Marburg (Allemagne)</en>, <dat when="1528">1528</dat>) Medecin et botaniste. - Professeur de <en ref="28" >médecin</en>e, chimie et mathématiques. - Fils du <en ref="1629" >théologien</en> : Lonicer, Johann (1499-15969) [http://data.bnf.fr/ark:/12148/cb10279221n#foaf:Person]
</ud>
<ud>
Cornelius Blockland (<dat when="1530">1530</dat>) Musicien, <en ref="25" >astrologue</en>, <en ref="16" >mathématicien</en> et <en ref="28" >médecin</en>. - Actif de 1571 à 1586. - Frère du peintre Anthonie Blockland van Montfort [http://data.bnf.fr/ark:/12148/cb13497580p#foaf:Person]
</ud>
<ud>
Giovanni Battista Benedetti (<en type="li">Venise, Italie</en>, <dat when="1530">1530</dat>) <en ref="16" >Mathématicien</en> et <en ref="1633" >ingénieur</en>. - Fondateur de la géométrie analytique [http://data.bnf.fr/ark:/12148/cb11998820g#foaf:Person]
</ud>
<ud>
Jean Péna (<dat when="1530">1530</dat>) <en ref="16" >Mathématicien</en>, traducteur et éditeur de textes mathématiques et géométriques antiques [http://data.bnf.fr/ark:/12148/cb13483147k#foaf:Person]
</ud>
<ud>
Conradus Dasypodius (<en type="li">Frauenfeld, Suisse</en>, <dat when="1531">1531</dat>) <en ref="16" >Mathématicien</en>. - A tracé le plan de l''horloge astronomique de la cathédrale de Strasbourg [http://data.bnf.fr/ark:/12148/cb16534831x#foaf:Person]
</ud>
<ud>
Ercole Bottrigari (<dat when="1531">1531</dat>) Humaniste, <en ref="16" >mathématicien</en>, musicien, poète, linguiste et <en ref="18" >philosophe</en> [http://data.bnf.fr/ark:/12148/cb125347809#foaf:Person]
</ud>
<ud>
Giuseppe Moletti (<dat when="1531">1531</dat>) Cosmographe et <en ref="29" >géographe</en>. - Professeur de <en ref="28" >médecin</en>e, de mathématique et d''astronomie à l''Université de Padoue [http://data.bnf.fr/ark:/12148/cb134849518#foaf:Person]
</ud>
<ud>
Philip Apian (<en type="li">Ingoldstadt, Allemagne</en>, <dat when="1531">1531</dat>) <en ref="1636" >Cartographe</en>, <en ref="16" >mathématicien</en> et <en ref="1630" >physicien</en>. - Fils de Peter Apian, succède à son père à l''Université d''Ingolstadt [http://data.bnf.fr/ark:/12148/cb152383864#foaf:Person]
</ud>
<ud>
Fabrizio Mordente (<en type="li">Salerne, Italie</en>, <dat when="1532">1532</dat>) <en ref="16" >Mathématicien</en>. - A inventé le compas de proportion à huit points [http://data.bnf.fr/ark:/12148/cb14643668k#foaf:Person]
</ud>
<ud>
Egnatio Danti (<en type="li">Pérouse, Italie</en>, <dat when="1536">1536</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en>, <en ref="1636" >cartographe</en> et cosmographe. - Dominicain [http://data.bnf.fr/ark:/12148/cb145332908#foaf:Person]
</ud>
<ud>
Henri de Monantheuil (<dat when="1536">1536</dat>) <en ref="16" >Mathématicien</en> et <en ref="28" >médecin</en>. - Régent de la Faculté de <en ref="28" >médecin</en>e de Paris, puis professeur de mathématiques au Collège de France (1574-). - Né à Reims, meurt à Paris [http://data.bnf.fr/ark:/12148/cb13006651k#foaf:Person]
</ud>
<ud>
Christophorus Clavius (<dat when="1537">1537</dat>) Jésuite, musicien et <in ana="1621">professeur de mathématiques</in>. - Fut chargé par Grégoire XIII de la réforme du calendrier [http://data.bnf.fr/ark:/12148/cb125466080#foaf:Person]
</ud>
<ud>
Francesco Barozzi (<en type="li">Heraklion, Grèce</en>, <dat when="1537">1537</dat>) <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb10462395x#foaf:Person]
</ud>
<ud>
Giovanni Paolo Gallucci (<en type="li">Salò, Italie</en>, <dat when="1538">1538</dat>) <en ref="24" >Astronome</en>. - Homme de lettres [http://data.bnf.fr/ark:/12148/cb106019703#foaf:Person]
</ud>
<ud>
Philips Mor (<dat when="1539">1539</dat>) Humaniste, <en ref="16" >mathématicien</en> et poète néolatin. - Chanoine du chapitre de St Salvator d''Utrecht. - Fils du peintre Anthonis Mor van Dashorst (Antonio Moro) [http://data.bnf.fr/ark:/12148/cb12384177f#foaf:Person]
</ud>
<ud>
François Viète (Fontenay-le-Comte (<en type="li">Vendée)</en>, <dat when="1540">1540</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb120511976#foaf:Person]
</ud>
<ud>
Cormopede (<dat when="1541">1541</dat>) <en ref="16" >Mathématicien</en> et <en ref="25" >astrologue</en>. - Gentilhomme de la maison du Comte de Sterckenberg. - Date de naissance présumée d''après le "portrait de Cormopede à l''âge de 51 ans" figurant au F. A. 2 de l''"Almanach des almanachs pour l''an MDXCIII" [http://data.bnf.fr/ark:/12148/cb13491791f#foaf:Person]
</ud>
<ud>
Giovanni di Strasoldo (<dat when="1544">1544</dat>) Noble. - Homme d''arme. - <en ref="16" >Mathématicien</en>. - Poète [http://data.bnf.fr/ark:/12148/cb15122132t#foaf:Person]
</ud>
<ud>
Guidobaldo Dal Monte (<dat when="1545">1545</dat>) <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en>. - Protégea <en ref="7" >Galilée</en> et lui fit obtenir sa première chaire à Pise. - Né à Pesaro, meurt dans son chateau de Monte Baroccio [http://data.bnf.fr/ark:/12148/cb135173214#foaf:Person]
</ud>
<ud>
Renward Cysat (<en type="li">Lucerne (Suisse)</en>, <dat when="1545">1545</dat>) Chancelier de la ville de Lucerne, Suisse. - Historien, dramaturge, pharmacien et naturaliste. - Père de : Cysat, Johann Baptist (1587-1653), <en ref="16" >mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb12748433g#foaf:Person]
</ud>
<ud>
Maurice Bressieu (<dat when="1546">1546</dat>) <en ref="16" >Mathématicien</en>, <en ref="18" >philosophe</en> et humaniste. - Titulaire de la chaire de mathématiques au Collège de France (1575-), orateur des rois de France à Rome (1586-), intendant de la Bibliothèque vaticane [http://data.bnf.fr/ark:/12148/cb13495175h#foaf:Person]
</ud>
<ud>
Tycho Brahe (<en type="li">Knudstrup (Suède)</en>, <dat when="1546">1546</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb11893749j#foaf:Person]
</ud>
<ud>
Muḥammad ibn al-Ḥusayan Bahāʼ al-Dīn ʿĀmilī (<dat when="1547">1547</dat>) Érudit arabe, <en ref="18" >philosophe</en>, <en ref="1629" >théologien</en>, <en ref="24" >astronome</en>, grammairien, auteur d''anthologies [http://data.bnf.fr/ark:/12148/cb12451570z#foaf:Person]
</ud>
<ud>
Nicodemus Frischlin (<en type="li">Balingen, Allemagne</en>, <dat when="1547">1547</dat>) Philologue et écrivain. - A enseigné les belles-lettres et les mathématiques à l''Université de Tubingue. - Traducteur d''Aristophane, de Callimaque et de Tryphiodore. - Auteur d''une comédie, présentée devant l''empereur Rodolphe, qui lui décerna le titre de comte-palatin [http://data.bnf.fr/ark:/12148/cb12463064b#foaf:Person]
</ud>
<ud>
Michele Zappulo (<dat when="1548">1548</dat>) Docteur en droit canon et civil. - <en ref="24" >Astronome</en>, historien et poète [http://data.bnf.fr/ark:/12148/cb125454264#foaf:Person]
</ud>
<ud>
Simon Stevin (<en type="li">Bruges, Belgique</en>, <dat when="1548">1548</dat>) <in ana="1621">Professeur de mathématiques de Maurice de Nassau</in> [http://data.bnf.fr/ark:/12148/cb119941019#foaf:Person]
</ud>
<ud>
Michel Coignet (<dat when="1549">1549</dat>) <en ref="1633" >Ingénieur</en>, <en ref="16" >mathématicien</en>, fabricant d''instruments de navigation, poète [http://data.bnf.fr/ark:/12148/cb124231863#foaf:Person]
</ud>
<ud>
Francisco Sánchez (<dat when="1550">1550</dat>) <en ref="28" >Médecin</en>, <en ref="18" >philosophe</en>, <en ref="16" >mathématicien</en> et poète. - Également connu sous le pseudonyme d''El Escéptico [http://data.bnf.fr/ark:/12148/cb120172346#foaf:Person]
</ud>
<ud>
Giovanni Battista Crispo (<en type="li">Gallipoli, Italie</en>, <dat when="1550">1550</dat>) Prêtre. - <en ref="16" >Mathématicien</en>, <en ref="1629" >théologien</en> et homme de lettres [http://data.bnf.fr/ark:/12148/cb10615268s#foaf:Person]
</ud>
<ud>
John Napier (<dat when="1550">1550</dat>) <en ref="16" >Mathématicien</en> et <en ref="1629" >théologien</en>. - Baron de Merchiston [http://data.bnf.fr/ark:/12148/cb12353925j#foaf:Person]
</ud>
<ud>
Michael Moestlin (<dat when="1550">1550</dat>) Né à Göppingen (Wurtemberg). - <en ref="16" >Mathématicien</en>. - <en ref="24" >Astronome</en>. - Luthérien, hostile à la réforme grégorienne du calendrier [http://data.bnf.fr/ark:/12148/cb12330628m#foaf:Person]
</ud>
<ud>
Sigfridus Aronus Forsius (<dat when="1550">1550</dat>) <en ref="24" >Astronome</en> et <en ref="25" >astrologue</en> finlandais [http://data.bnf.fr/ark:/12148/cb131923734#foaf:Person]
</ud>
<ud>
Aegidius Martini (<dat when="1551">1551</dat>) <en ref="1636" >Cartographe</en>, <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb15376579x#foaf:Person]
</ud>
<ud>
al-Silahî Nasuh (<dat when="1551">1551</dat>) Savant, miniaturiste et calligraphe ottoman. - A écrit plusieurs ouvrages sur les armes et les combats, sur la géométrie et les mathématiques ainsi que sur l''histoire. - Inventeur du jeu de "matraque", il est mieux connu sous son surnom "Matrakçı" : "Matrakçı Nasuh Efendi", "Nasuh al-Silahî", "Matraki", "Nasuh el-Mitraki", "Nasuh üs-Silahi", "Matraqçi Nasuh", "Nasuh b. Abdullah" et "Nasuh b. Karagöz el-Bosnevi" sont parmi les autres formes de référence [http://data.bnf.fr/ark:/12148/cb119562090#foaf:Person]
</ud>
<ud>
Anthoine Cathalan (<dat when="1551">1551</dat>) <in ana="1621">Professeur de mathématiques </in>[http://data.bnf.fr/ark:/12148/cb14526861v#foaf:Person]
</ud>
<ud>
Bartolomeo Crescenzio (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en>, <en ref="1633" >ingénieur</en> naval et voyageur. - Fut capitaine de galère de la marine pontificale [http://data.bnf.fr/ark:/12148/cb125466487#foaf:Person]
</ud>
<ud>
Bernardo Gamucci (<en type="li">San Gimignano, Italie</en>, <dat when="1551">1551</dat>) Archéologue, <en ref="1635" >architecte</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb10435220v#foaf:Person]
</ud>
<ud>
Camillo Agrippa (<dat when="1551">1551</dat>) <en ref="18" >Philosophe</en>, <en ref="16" >mathématicien</en>, <en ref="1635" >architecte</en> et <en ref="1633" >ingénieur</en>. - Est aussi l''auteur de l''un des premiers traité d''escrime [http://data.bnf.fr/ark:/12148/cb12536260s#foaf:Person]
</ud>
<ud>
Claude de Boissière (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en>. - Auteur d''un "Art poétique" [http://data.bnf.fr/ark:/12148/cb12509709h#foaf:Person]
</ud>
<ud>
Didier Henrion (<dat when="1551">1551</dat>) <in ana="1621">Professeur de mathématiques à Paris</in>. - <en ref="1633" >Ingénieur</en> au service des Provinces-Unies. - N''est pas un pseudonyme de Clément Cyriaque de Mangin [http://data.bnf.fr/ark:/12148/cb144882445#foaf:Person]
</ud>
<ud>
Eilhard Lubbin (<dat when="1551">1551</dat>) <en ref="1636" >Cartographe</en> et <en ref="16" >mathématicien</en> à Rostock [http://data.bnf.fr/ark:/12148/cb153777849#foaf:Person]
</ud>
<ud>
Faustus Verantius (Sebenico aujord''hui Šibenik (<en type="li">Croatie)</en>, <dat when="1551">1551</dat>) Lexicographe, <en ref="1630" >physicien</en> et <en ref="16" >mathématicien</en>. - Évêque de Czanad (Hongrie) (<dat when="1594">1594</dat>) et de la République de Venise. - Neveu d''Antun Vrančić (1504-1573) [http://data.bnf.fr/ark:/12148/cb10703670x#foaf:Person]
</ud>
<ud>
Francesco Feliciano (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en>, augustinien et miniaturiste [http://data.bnf.fr/ark:/12148/cb13485419n#foaf:Person]
</ud>
<ud>
Francis Van Schoten (<dat when="1551">1551</dat>) <in ana="1621">Professeur de mathématiques à Leyde</in>, <en ref="1636" >cartographe</en> [http://data.bnf.fr/ark:/12148/cb15337130w#foaf:Person]
</ud>
<ud>
Francisco Zarzoso (<en type="li">Cella, Espagne</en>, <dat when="1551">1551</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb119512329#foaf:Person]
</ud>
<ud>
Giacomo Lanteri (<en type="li">Paratico, Italie</en>, <dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en> et <en ref="1633" >ingénieur</en> [http://data.bnf.fr/ark:/12148/cb104024969#foaf:Person]
</ud>
<ud>
Girolamo Mercurio (<dat when="1551">1551</dat>) Dominicain. - <en ref="28" >Médecin</en>, <in ana="1621">professeur de logique et de mathématique </in>[http://data.bnf.fr/ark:/12148/cb13484092c#foaf:Person]
</ud>
<ud>
Giuseppe Unicorno (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en>. - <en ref="18" >Philosophe</en>. - <en ref="25" >Astrologue</en>. - Musicologue. - <en ref="1629" >Théologien</en>. - Originaire de Bergame [http://data.bnf.fr/ark:/12148/cb125394931#foaf:Person]
</ud>
<ud>
Helisaeus Röslin (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en>. - <en ref="24" >Astronome</en>. - <en ref="28" >Médecin</en> (pratiquait à Strasbourg et Francfort) [http://data.bnf.fr/ark:/12148/cb132003253#foaf:Person]
</ud>
<ud>
Jacques Besson (<en type="li">Colombières (Italie)</en>, <dat when="1551">1551</dat>) <en ref="1633" >Ingénieur</en> et <en ref="16" >mathématicien</en>. - Né à Colombières, vallée d''Oulx (aujourd''hui en Italie), d''après Eugénie Droz [http://data.bnf.fr/ark:/12148/cb12376654f#foaf:Person]
</ud>
<ud>
Jacques Maretz (<dat when="1551">1551</dat>) Dessinateur et graveur, <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb153705873#foaf:Person]
</ud>
<ud>
Jamet Mettayer (<dat when="1551">1551</dat>) Autre(s) graphie(s) : Metayer ; Messor ; Metayerus ; Mettayier. - Variante(s) de prénom : Jean ; Jean Jamet. - <en ref="1632" >Imprimeur</en>-<en ref="1631" >libraire</en> ; <en ref="1632" >imprimeur</en> du Roi pour les mathématiques (<dat when="1580">1580</dat>) et <en ref="1632" >imprimeur</en> ordinaire du Roi (1583-1605). - En 1588, le roi Henri III le fait <en ref="1632" >imprimeur</en> officiel de sa congrégation des pénitents de l''Annonciation. De 1588 à 1594, il suit le Roi et la Cour à Blois puis  à Tours. - De retour à Paris, doit partager sa charge avec Pierre L''Huillier et Fédéric II Morel en vertu de l''arrêt du Conseil du 20 avril 1594. Revend à Tours son atelier et sa boutique à l''<en ref="1632" >imprimeur</en> Maurice Bouguereau. En mars  1596, le Roi l''associe à la Compagnie des usages avec Pierre L''Huillier. Décédé avant le 12 fév. 1605. Des publications paraissent encore sous son nom jusqu''en 1614. - A travaillé en association avec Mathurin Challenge (<dat when="1573">1573</dat>) et Barthélemy Gomet à Blois. S''associe à Tours (oct. 1591 - oct. 1593) avec Jean Richer, Claude de Monstr''oeil, Sébastien Molin, Mathieu I Guillemot, Georges Drobet et Marc Orry, son gendre. Travaille en association étroite avec Pierre L''Huillier et avec son fils Pierre Mettayer qui se trouvaient eux aussi à Tours [http://data.bnf.fr/ark:/12148/cb125031934#foaf:Person]
</ud>
<ud>
Jean Brohon (<dat when="1551">1551</dat>) <en ref="28" >Médecin</en>, botaniste et <en ref="24" >astronome</en>. - Fut recteur de l''Université de Caen [http://data.bnf.fr/ark:/12148/cb12545367f#foaf:Person]
</ud>
<ud>
Jean de Seville (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en> et hydrographe [http://data.bnf.fr/ark:/12148/cb13496046w#foaf:Person]
</ud>
<ud>
Jean Maria Coloni (<dat when="1551">1551</dat>) Citoyen de Romans en Dauphiné. - <en ref="16" >Mathématicien</en> et <en ref="25" >astrologue</en> [http://data.bnf.fr/ark:/12148/cb13479237s#foaf:Person]
</ud>
<ud>
Jean Tagaut (<dat when="1551">1551</dat>) Poète. - <en ref="28" >Médecin</en>, <en ref="16" >mathématicien</en>, professeur à Lausanne et Genève [http://data.bnf.fr/ark:/12148/cb12249180j#foaf:Person]
</ud>
<ud>
Joannes Portantius (<dat when="1551">1551</dat>) <en ref="24" >Astronome</en>, <en ref="16" >mathématicien</en> et <en ref="29" >géographe</en> à Anvers, édité par Ortelius et De Jode [http://data.bnf.fr/ark:/12148/cb153817246#foaf:Person]
</ud>
<ud>
Johann Georg Locher (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb13006978f#foaf:Person]
</ud>
<ud>
Juan de Rojas Sarmiento (<en type="li">Palencia, Espagne</en>, <dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb140653109#foaf:Person]
</ud>
<ud>
Marc Duncan (<dat when="1551">1551</dat>) <en ref="28" >Médecin</en>, originaire d''Écosse, s''établit à Saumur en 1606 à l''appel de l''Académie protestante de la ville. - Professeur de mathématiques, de grec et d''humanités [http://data.bnf.fr/ark:/12148/cb13006401g#foaf:Person]
</ud>
<ud>
Martin Basanier (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en>, musicien [http://data.bnf.fr/ark:/12148/cb12510914p#foaf:Person]
</ud>
<ud>
Martinus Hortensius (<dat when="1551">1551</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb13007384z#foaf:Person]
</ud>
<ud>
Nicolaus Reimarus Ursus (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en>. - <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb145753184#foaf:Person]
</ud>
<ud>
Paschasius Hamellius (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb13173242d#foaf:Person]
</ud>
<ud>
Paul Yvon (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en>. - Achète la seigneurie de Laleu en 1592 et y fait construire le château. - Maire de La Rochelle en 1616. - S'' installe à Paris en décembre 1633 et abjure le protestantisme [http://data.bnf.fr/ark:/12148/cb12135021d#foaf:Person]
</ud>
<ud>
Peter Laicksteen (<dat when="1551">1551</dat>) <en ref="1636" >Cartographe</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb15370391s#foaf:Person]
</ud>
<ud>
Phillebert Charpentier (<dat when="1551">1551</dat>) Éditeur. - Marchand d''estampes et d''instruments de mathématiques [http://data.bnf.fr/ark:/12148/cb16553551w#foaf:Person]
</ud>
<ud>
Pierre Forcadel (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb103947442#foaf:Person]
</ud>
<ud>
Pierre Hérigone (<dat when="1551">1551</dat>) <in ana="1621">Professeur de mathématiques à Paris</in>. - N''est pas un pseudonyme de Clément Cyriaque de Mangin [http://data.bnf.fr/ark:/12148/cb144882503#foaf:Person]
</ud>
<ud>
Pierre Le Voirier (<dat when="1551">1551</dat>) Autre(s) graphie(s) : Le Voirrier ; Le Verrier. - <en ref="1632" >Imprimeur</en> du Roi pour les mathématiques. - Beau-père de Mathieu I Guillemot (<dat when="1584">1584</dat>). Encore en activité le 31 déc. 1589. Décédé entre 1591 et le 7 nov. 1594 (compte de succession) [http://data.bnf.fr/ark:/12148/cb12230743m#foaf:Person]
</ud>
<ud>
Teodato Osio (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en>. - Musicien [http://data.bnf.fr/ark:/12148/cb125559272#foaf:Person]
</ud>
<ud>
Walther Hermann Ryff (<dat when="1551">1551</dat>) Apothicaire, <en ref="28" >médecin</en>, <en ref="16" >mathématicien</en> et <en ref="1635" >architecte</en> [http://data.bnf.fr/ark:/12148/cb11948264d#foaf:Person]
</ud>
<ud>
William Welwod (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en>. - <in ana="1621">Professeur de droit </in>[http://data.bnf.fr/ark:/12148/cb125630488#foaf:Person]
</ud>
<ud>
Jost Bürgi (<dat when="1552">1552</dat>) Horloger, <en ref="24" >astronome</en> et <en ref="16" >mathématicien</en> suisse [http://data.bnf.fr/ark:/12148/cb123814270#foaf:Person]
</ud>
<ud>
Bernardino Baldi (<en type="li">Urbino, Italie</en>, <dat when="1553">1553</dat>) Abbé de Guastalla. - Poète, prosateur, <en ref="16" >mathématicien</en> et historien. - Polyglotte, connaissait le grec et le latin, l''hébreu, l''arabe, le persan et le hongrois [http://data.bnf.fr/ark:/12148/cb12179488k#foaf:Person]
</ud>
<ud>
Jacob Christmann (<dat when="1554">1554</dat>) Orientaliste, <en ref="16" >mathématicien</en> et <en ref="24" >astronome</en>. - A été le premier à utiliser le télescope avec d''autres instruments comme le sextant [http://data.bnf.fr/ark:/12148/cb12560133s#foaf:Person]
</ud>
<ud>
Giovanni Antonio Magini (<en type="li">Padoue, Italie</en>, <dat when="1555">1555</dat>) <en ref="24" >Astronome</en>, <en ref="16" >mathématicien</en> et <en ref="29" >géographe</en>. - A occupé la chaire d''astronomie à l''Université de Bologne en 1588. - Auteur prétendu de prédictions et de nombreux almanachs publiés en France, en Allemagne et aux Pays-Bas jusqu''au 19e siècle [http://data.bnf.fr/ark:/12148/cb12162475b#foaf:Person]
</ud>
<ud>
Jean Du Temps (<dat when="1555">1555</dat>) Fils de l''avocat Jean Du Temps I, il fut lui-même avocat et avait des connaissances en astrologie et mathématique. Frère d''Adam Du Temps, spécialiste des fortifications qui participa peut-être à la carte du Blésois dont il est l''auteur [http://data.bnf.fr/ark:/12148/cb15302460t#foaf:Person]
</ud>
<ud>
Sethus Calvisius (<dat when="1556">1556</dat>) Organiste, compositeur et théoricien de la musique ; <en ref="24" >astronome</en> ; historien ; <en ref="1631" >libraire</en> et éditeur de musique. - Natif de Gorsleben près de Sachsenburg (Thuringe) et issu d''une famille paysanne. Après des études aux universités de Leipzig et Helmstedt, il devient à partir de 1581 et jusqu''à sa mort "cantor" de plusieurs églises de Leipzig successivement. Auteur de plusieurs ouvrages théoriques et compositions musicales, ainsi que d''un "Opus chronologicum" (1605 ; au moins 6 rééd.) et d''un "Elenchus calendarii Gregoriani" (<dat when="1612">1612</dat>). Décédé à Leipzig en nov. 1615. À distinguer du pasteur et prédicateur de Quedlinburg Sethus Calvisius (ou : Seth Kal(l)witz) (1639-1698), parfois appelé à tort "Sethus Calvisius le fils" [http://data.bnf.fr/ark:/12148/cb12875550d#foaf:Person]
</ud>
<ud>
Guillaume de Nautonier (<dat when="1557">1557</dat>) Savant, <en ref="16" >mathématicien</en>, <en ref="24" >astronome</en>, d''origine protestante, <en ref="29" >géographe</en> du roi Henri IV [http://data.bnf.fr/ark:/12148/cb12412403z#foaf:Person]
</ud>
<ud>
Christoph Meurer (<dat when="1558">1558</dat>) Professeur de mathématiques à Leipzig (<dat when="1613">1613</dat>). - <en ref="28" >Médecin</en> [http://data.bnf.fr/ark:/12148/cb14333201g#foaf:Person]
</ud>
<ud>
Jean-Édouard Du Monin (<dat when="1559">1559</dat>) <en ref="16" >Mathématicien</en> et spécialiste des langues anciennes. - Fut professeur à Paris, puis à Poitiers [http://data.bnf.fr/ark:/12148/cb12463074n#foaf:Person]
</ud>
<ud>
Thomas Hariot (<en type="li">Oxford, GB</en>, <dat when="1560">1560</dat>) <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en>. - Envoyé comme conseiller aux Amériques en 1585-86 [http://data.bnf.fr/ark:/12148/cb12215671c#foaf:Person]
</ud>
<ud>
Thomas Harriot (<dat when="1560">1560</dat>) <en ref="16" >Mathématicien</en>, <en ref="1630" >physicien</en> et <en ref="24" >astronome</en> anglais [http://data.bnf.fr/ark:/12148/cb124346111#foaf:Person]
</ud>
<ud>
Adrianus Romanus (<en type="li">Louvain</en>, <dat when="1561">1561</dat>) <en ref="28" >Médecin</en>, <en ref="16" >mathématicien</en> et voyageur. - Enseigna à Louvain et à Würzburg, fut <en ref="16" >mathématicien</en> royal en Pologne [http://data.bnf.fr/ark:/12148/cb12459969s#foaf:Person]
</ud>
<ud>
Bartholomäus Pitiscus (<dat when="1561">1561</dat>) A aussi écrit en latin. - Prédicateur protestant à la cour de l''Électeur palatin. - Également auteur d''ouvrages mathématiques [http://data.bnf.fr/ark:/12148/cb121457326#foaf:Person]
</ud>
<ud>
Henry Briggs (<dat when="1561">1561</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12305061c#foaf:Person]
</ud>
<ud>
Jean Tarde (La Roque-Gageac (<en type="li">Dordogne)</en>, <dat when="1561">1561</dat>) <en ref="16" >Mathématicien</en>, historien, <en ref="29" >géographe</en> et <en ref="24" >astronome</en>. - Chanoine [http://data.bnf.fr/ark:/12148/cb12641353z#foaf:Person]
</ud>
<ud>
Jean Tarde (<dat when="1561">1561</dat>) Chanoine de Sarlat, <en ref="16" >mathématicien</en> et <en ref="1636" >cartographe</en> [http://data.bnf.fr/ark:/12148/cb153143878#foaf:Person]
</ud>
<ud>
P. Christoph Grienberger (<dat when="1561">1561</dat>) Jésuite, <en ref="16" >mathématicien</en>, <en ref="24" >astronome</en> et <en ref="1635" >architecte</en>. Il a realisé les plans du Collège d''Aurillac et du Charleville [http://data.bnf.fr/ark:/12148/cb10686921r#foaf:Person]
</ud>
<ud>
Philippus Lansbergen (<en type="li">Gand (Belgique)</en>, <dat when="1561">1561</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en> et pasteur [http://data.bnf.fr/ark:/12148/cb130073828#foaf:Person]
</ud>
<ud>
Christen Sørensen Longomontanus (<dat when="1562">1562</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en>. - Fut l''élève de Tycho-Brahé. - Professeur de hautes mathématiques à l''Université de Copenhague [http://data.bnf.fr/ark:/12148/cb13011001c#foaf:Person]
</ud>
<ud>
Guangqi Xu (<en type="li">Shanghai</en>, <dat when="1562">1562</dat>) Haut fonctionnaire chinois, initié et converti au christianisme par le père jésuite Matteo Ricci. - <en ref="16" >Mathématicien</en>. - <en ref="24" >Astronome</en>. - Disciple de Matteo Ricci [http://data.bnf.fr/ark:/12148/cb150892932#foaf:Person]
</ud>
<ud>
<en ref="7" >Galileo Galilei</en> (<en type="li">Pise, Italie</en>, <dat when="1564">1564</dat>) <en ref="1630" >Physicien</en>, <en ref="18" >philosophe</en>, <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb11903931b#foaf:Person]
</ud>
<ud>
Luis Teixeira (<dat when="1564">1564</dat>) Jésuite portugais, <en ref="16" >mathématicien</en> et <en ref="1636" >cartographe</en> actif de 1564 à 1613 [http://data.bnf.fr/ark:/12148/cb153361957#foaf:Person]
</ud>
<ud>
Edward Brerewood (<dat when="1565">1565</dat>) Antiquaire et <en ref="16" >mathématicien</en>, linguiste et humaniste. - Professeur d''astronomie au Gresham college de Londres [http://data.bnf.fr/ark:/12148/cb125109678#foaf:Person]
</ud>
<ud>
Eilhard Lubin (<dat when="1565">1565</dat>) Humaniste, philologue, <en ref="1636" >cartographe</en>, <en ref="1629" >théologien</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb15040859j#foaf:Person]
</ud>
<ud>
Paolo Antonio Foscarini (<en type="li">Montalto Uffugo, Italie</en>, <dat when="1565">1565</dat>) Carme. - <en ref="1629" >Théologien</en>. - <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb12377530d#foaf:Person]
</ud>
<ud>
Scipione Chiaramonti (<en type="li">Cesena, Italie</en>, <dat when="1565">1565</dat>) <en ref="24" >Astronome</en> et <en ref="18" >philosophe</en>. - Professeur de philosophie à l''Université de Pise [http://data.bnf.fr/ark:/12148/cb10545041n#foaf:Person]
</ud>
<ud>
Fr. François d'' Aguillon (<dat when="1566">1566</dat>) Jésuite, <en ref="1635" >architecte</en> et <en ref="16" >mathématicien</en>. Auteur d''un projet pour le noviciat de Tournai. Préposé de la Maison professe, professeur d''Anvers [http://data.bnf.fr/ark:/12148/cb16240952w#foaf:Person]
</ud>
<ud>
Georg Ludwig Frobenius (<dat when="1566">1566</dat>) <en ref="1631" >Libraire</en>. - Natif d''Iphofen, près de Wurzbourg. Titulaire d''une maîtrise de théologie. Après des études aux universités de Tübingen et Wittenberg, travaille avec l''<en ref="24" >astronome</en> Tycho Brahe jusqu''à la mort de celui-ci. Reçu ensuite bourgeois de Hambourg, où il s''établit <en ref="1631" >libraire</en> [http://data.bnf.fr/ark:/12148/cb12229506t#foaf:Person]
</ud>
<ud>
Marco Antonio De Dominis (l''île de Rab (<en type="li">Croatie)</en>, <dat when="1566">1566</dat>) <in ana="1621">Professeur de rhétorique, mathématiques et philosophie dans la Compagnie de Jésus, à Padoue et Brescia</in>. - Evêque de Segna (Senj ou Zengg en Croatie) de 1600 à 1602; de Spalato (Split) de 1602 à 1615. - Gagné au protestantisme et exilé en Angleterre, doyen de Windsor. - Abjure et rentre en grâce (<dat when="1622">1622</dat>) [http://data.bnf.fr/ark:/12148/cb121335726#foaf:Person]
</ud>
<ud>
Marinus Ghetaldus (Raguse aujourd''hui Dubrovnik (<en type="li">Croatie)</en>, <dat when="1566">1566</dat>) <en ref="16" >Mathématicien</en> et <en ref="1630" >physicien</en>. - Il exerça une grande influence sur le développement de l''application de l''algèbre à la géométrie. - Il mit au point le miroir parabolique, aujourd''hui conservé au National Maritime Museum de Londres. - Il collabora, entre autres, avec François Viète en France et avec <en ref="7" >Galilée</en> en Italie [http://data.bnf.fr/ark:/12148/cb146476018#foaf:Person]
</ud>
<ud>
François de Aguilón (<dat when="1567">1567</dat>) <en ref="1635" >Architecte</en> et <en ref="16" >mathématicien</en> belge d''origine espagnole [http://data.bnf.fr/ark:/12148/cb119998212#foaf:Person]
</ud>
<ud>
Johann Hartmann (<dat when="1568">1568</dat>) <en ref="16" >Mathématicien</en> et naturaliste. - Professeur de chimie à l''Université de Marburg [http://data.bnf.fr/ark:/12148/cb13009199x#foaf:Person]
</ud>
<ud>
P. Jacques de Guernisac (<dat when="1568">1568</dat>) Jésuite et <en ref="1635" >architecte</en>, professeur de mathématique à Pont-à-Mousson puis à La Flèche, recteur du collège des Jésuites de Quimper [http://data.bnf.fr/ark:/12148/cb16215104d#foaf:Person]
</ud>
<ud>
Mutio Oddi (<dat when="1569">1569</dat>) <en ref="16" >Mathématicien</en>. - <en ref="1635" >Architecte</en> [http://data.bnf.fr/ark:/12148/cb165299645#foaf:Person]
</ud>
<ud>
Andrea Argoli (<dat when="1570">1570</dat>) <en ref="16" >Mathématicien</en>. - <en ref="24" >Astronome</en>. - Professeur de mathématique à l''Université de Padoue [http://data.bnf.fr/ark:/12148/cb121593328#foaf:Person]
</ud>
<ud>
Erasmus Schmied (<dat when="1570">1570</dat>) Né à Delitzsch, près de Leipzig. - <in ana="1621">Professeur de grec et de mathématiques à Wittenberg </in>[http://data.bnf.fr/ark:/12148/cb12045847b#foaf:Person]
</ud>
<ud>
Anders Bure (<dat when="1571">1571</dat>) <en ref="1636" >Cartographe</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb14509982d#foaf:Person]
</ud>
<ud>
Giovanni Branca (<dat when="1571">1571</dat>) <en ref="1635" >Architecte</en>, <en ref="1633" >ingénieur</en> et <en ref="16" >mathématicien</en>. - Né à Pesaro, meurt à Pérouse [http://data.bnf.fr/ark:/12148/cb121826472#foaf:Person]
</ud>
<ud>
Johannes Isaacus Pontanus (<en type="li">Elseneur (Danemark)</en>, <dat when="1571">1571</dat>) Historien. - Philologue. - <in ana="1621">Professeur de mathématiques et de physique </in>[http://data.bnf.fr/ark:/12148/cb123875836#foaf:Person]
</ud>
<ud>
Johannes Kepler (<dat when="1571">1571</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb11909597m#foaf:Person]
</ud>
<ud>
Willem Jansz Blaeu (<dat when="1571">1571</dat>) Autre(s) graphie(s) : Janssonius Blaeuw. - <en ref="1632" >Imprimeur</en>-<en ref="1631" >libraire</en> et éditeur de cartes et d''atlas. - Originaire d''Alkmaar ou des environs. Passe 2 ans auprès de Tycho Brahé au Danemark. À son retour à Amsterdam en 1596, s''établit <en ref="1636" >cartographe</en> et fabricant de globes terrestres et célestes. Monte ensuite une imprimerie et une fonderie. Également auteur d''ouvrages cartographiques et astronomiques [http://data.bnf.fr/ark:/12148/cb12169772t#foaf:Person]
</ud>
<ud>
Cornelius Drebbel (<dat when="1572">1572</dat>) Graveur. - <en ref="16" >Mathématicien</en>. - <en ref="1630" >Physicien</en>. - Chimiste [http://data.bnf.fr/ark:/12148/cb12382467g#foaf:Person]
</ud>
<ud>
Rodolphus Goclenius (<dat when="1572">1572</dat>) Docteur en <en ref="28" >médecin</en>e en 1601. - <in ana="1621">Professeur de physique en 1608</in>. - <in ana="1621">Professeur de mathématiques à l''Université de Marbourg en 1621</in> [http://data.bnf.fr/ark:/12148/cb121595722#foaf:Person]
</ud>
<ud>
Samuel Marolois (<dat when="1572">1572</dat>) <en ref="16" >Mathématicien</en> français ayant vécu une grande partie de sa vie aux Pays-Bas [http://data.bnf.fr/ark:/12148/cb14912871p#foaf:Person]
</ud>
<ud>
Thomas Lydyat (<en type="li">Okerton, GB</en>, <dat when="1572">1572</dat>) <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb12390032f#foaf:Person]
</ud>
<ud>
Christoph Scheiner (<dat when="1575">1575</dat>) Jésuite. - <en ref="1630" >Physicien</en>, <en ref="16" >mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb13483688j#foaf:Person]
</ud>
<ud>
Michelangelo Galilei (<dat when="1575">1575</dat>) Luthiste et compositeur italien de la Renaissance. - Fils du compositeur et théoricien Vincenzo Galilei, et frère de l''<en ref="24" >astronome</en> <en ref="7" >Galileo Galilei</en> [http://data.bnf.fr/ark:/12148/cb140013401#foaf:Person]
</ud>
<ud>
Octavio Pisani (<en type="li">Naples, Italie</en>, <dat when="1575">1575</dat>) Cosmographe et <en ref="24" >astronome</en>, travaille à Anvers de 1612 à 1637 [http://data.bnf.fr/ark:/12148/cb15404394h#foaf:Person]
</ud>
<ud>
Francesco Ingoli (<en type="li">Ravenne (Italie)</en>, <dat when="1578">1578</dat>) Secrétaire de la propagande, débat avec Copernic (en 1616 et 1624) et écrit Relazione delle quattro parti del mondo avec pour objectif de soutenir missions et propagande religieuses. - Étudie l''astronomie, la cosmographie et la géographie et connait le grec, le français, l''espagnon et l''arabe. - Diplômé en droit civil et en droit canon à l''Université de Padoue, Italie [http://data.bnf.fr/ark:/12148/cb13749501h#foaf:Person]
</ud>
<ud>
Sybrandt Hansz. Cardinael (Harlingen (Pays-Bas), <dat when="1578">1578</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb15944052f#foaf:Person]
</ud>
<ud>
Cristóvão Ferreira (<dat when="1580">1580</dat>) Supérieur et procurateur de la mission jésuite au Japon, il abjura en 1633 et se convertit au zen. - Auteur en 1636 de la "Supercherie dévoilée". - Traducteur d''ouvrages d''astronomie et de chirurgie [http://data.bnf.fr/ark:/12148/cb13524212c#foaf:Person]
</ud>
<ud>
Godfried Wendelen (<dat when="1580">1580</dat>) <en ref="24" >Astronome</en> et géomètre. - Avocat au Parlement de Paris puis doyen du chapitre de Rothnac, Belgique [http://data.bnf.fr/ark:/12148/cb123969373#foaf:Person]
</ud>
<ud>
Joannes Michael Gigas (<dat when="1580">1580</dat>) Docteur, <en ref="16" >mathématicien</en> et <en ref="29" >géographe</en> édité par Blaeu et Hondius [http://data.bnf.fr/ark:/12148/cb153239798#foaf:Person]
</ud>
<ud>
Johann Faulhaber (<dat when="1580">1580</dat>) <en ref="16" >Mathématicien</en> allemand. S''est aussi intéressé à l''ingénierie des fortifications [http://data.bnf.fr/ark:/12148/cb137778453#foaf:Person]
</ud>
<ud>
Nicolas-Claude Fabri Peiresc (<en type="li">Belgentier (Var)</en>, <dat when="1580">1580</dat>) Conseiller au Parlement de Provence. - <en ref="24" >Astronome</en>, archéologue et naturaliste [http://data.bnf.fr/ark:/12148/cb11918940q#foaf:Person]
</ud>
<ud>
Willebrordus Snellius (Leyde, Pays-Bas, <dat when="1580">1580</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en> et <en ref="29" >géographe</en> [http://data.bnf.fr/ark:/12148/cb15336105f#foaf:Person]
</ud>
<ud>
Claude-Gaspard Bachet (Bourg-en-Bresse (<en type="li">Ain)</en>, <dat when="1581">1581</dat>) <en ref="16" >Mathématicien</en> et littérateur. - Sieur de Méziriac. - Érudit, auteur de poèmes en français, italien et latin. - Membre de l''Académie française (élu en 1634) [http://data.bnf.fr/ark:/12148/cb120028244#foaf:Person]
</ud>
<ud>
Alexandre Anderson (<dat when="1582">1582</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb16296598k#foaf:Person]
</ud>
<ud>
Jean François (<dat when="1582">1582</dat>) Nom en religion de Jean Charnage. - Jésuite. - <in ana="1621">Professeur de philosophie et de mathématiques à La Flèche</in> [http://data.bnf.fr/ark:/12148/cb121629197#foaf:Person]
</ud>
<ud>
Mario Bettini (<en type="li">Bologne, Italie</en>, <dat when="1582">1582</dat>) Jésuite. - <en ref="18" >Philosophe</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12545452p#foaf:Person]
</ud>
<ud>
Matthias Bernegger (<en type="li">Hallstatt (Autriche)</en>, <dat when="1582">1582</dat>) Philologue, historien, <en ref="16" >mathématicien</en> et <en ref="24" >astronome</en>. - Protestant. - Professeur d''histoire et d''éloquence à Strasbourg, recteur de l''Université de cette même ville [http://data.bnf.fr/ark:/12148/cb129928534#foaf:Person]
</ud>
<ud>
Jean-Baptiste Morin (Villefranche-sur-Saône (<en type="li">Rhône)</en>, <dat when="1583">1583</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb11916881j#foaf:Person]
</ud>
<ud>
Orazio Grassi (<en type="li">Savone, Italie</en>, <dat when="1583">1583</dat>) Jésuite. - <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en> et <en ref="1635" >architecte</en> [http://data.bnf.fr/ark:/12148/cb125377863#foaf:Person]
</ud>
<ud>
Filippo Finella (<en type="li">Naples, Italie</en>, <dat when="1584">1584</dat>) <en ref="25" >Astrologue</en>. - <en ref="24" >Astronome</en>. - Auteur dramatique [http://data.bnf.fr/ark:/12148/cb122006609#foaf:Person]
</ud>
<ud>
Grégoire de Saint-Vincent (<dat when="1584">1584</dat>) <en ref="16" >Mathématicien</en>. - <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb16197665z#foaf:Person]
</ud>
<ud>
James Hume (<dat when="1584">1584</dat>) <en ref="16" >Mathématicien</en>. - <en ref="24" >Astronome</en>. - Historien. - Hébraïsant. - Actif en 1639. - A vécu à Paris. - Fils de David Hume (1558-163.) et frère aîné de la poétesse et traductrice Anna Hume (1586?-16..) [http://data.bnf.fr/ark:/12148/cb12072629r#foaf:Person]
</ud>
<ud>
Claude Mydorge (<dat when="1585">1585</dat>) <en ref="16" >Mathématicien</en> et <en ref="1630" >physicien</en> [http://data.bnf.fr/ark:/12148/cb144888873#foaf:Person]
</ud>
<ud>
Mario Guiducci (<en type="li">Florence, Italie</en>, <dat when="1585">1585</dat>) Homme de lettres et <en ref="24" >astronome</en>. - A collaboré avec <en ref="7" >Galileo Galilei</en> [http://data.bnf.fr/ark:/12148/cb144609004#foaf:Person]
</ud>
<ud>
Melchior Inchofer (<en type="li">Vienne</en>, <dat when="1585">1585</dat>) Jésuite. - <en ref="18" >Philosophe</en>, <en ref="16" >mathématicien</en> et <en ref="1629" >théologien</en> professeur à Messine, Italie [http://data.bnf.fr/ark:/12148/cb10735485h#foaf:Person]
</ud>
<ud>
Philipp Müller (<dat when="1585">1585</dat>) <en ref="16" >Mathématicien</en>, <en ref="28" >médecin</en>, chimiste et botaniste. - Professeur à l''université de Leipzig [http://data.bnf.fr/ark:/12148/cb14065362j#foaf:Person]
</ud>
<ud>
Jean L''Hoste (<en type="li">Nancy</en>, <dat when="1586">1586</dat>) <en ref="1633" >Ingénieur</en>. - Intendant des fortifications du duc de Lorraine. - Professeur de droit et de mathématiques à Pont-à-Mousson [http://data.bnf.fr/ark:/12148/cb16628764j#foaf:Person]
</ud>
<ud>
Niccolò Zucchi (<en type="li">Parme, Italie</en>, <dat when="1586">1586</dat>) Jésuite. - Recteur du Collegio romano (1646-1649). - <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb10077816w#foaf:Person]
</ud>
<ud>
Benedetto Castelli (<en type="li">Brescia, Italie</en>, <dat when="1587">1587</dat>) Dominicain. - <en ref="16" >Mathématicien</en>, inventeur et écrivain. - Disciple de <en ref="7" >Galilée</en>, dont il défendit les théories astronomiques [http://data.bnf.fr/ark:/12148/cb12545385c#foaf:Person]
</ud>
<ud>
Joachim Jungius (<dat when="1587">1587</dat>) Naturaliste, <en ref="16" >mathématicien</en> et <en ref="18" >philosophe</en> [http://data.bnf.fr/ark:/12148/cb120247195#foaf:Person]
</ud>
<ud>
Libert Froidmont (<en type="li">Liège</en>, <dat when="1587">1587</dat>) <en ref="1629" >Théologien</en>. - <en ref="16" >Mathématicien</en>, <en ref="1630" >physicien</en> et géologue [http://data.bnf.fr/ark:/12148/cb14462868z#foaf:Person]
</ud>
<ud>
François Derand (<dat when="1588">1588</dat>) Jésuite. - <in ana="1621">Professeur de grammaire et de mathématiques</in>. - <en ref="1635" >Architecte</en>. - Né à Vic s/Seille (Moselle), mort à Agde (Hérault) [http://data.bnf.fr/ark:/12148/cb13012148j#foaf:Person]
</ud>
<ud>
Jacques Grandami (<dat when="1588">1588</dat>) Jésuite. - <in ana="1621">Professeur de belles lettres, de philosophie et de théologie</in>, puis recteur de Bourges, Rennes, La Flèche, Tours et Rouen. - Visiteur de la province de France. - <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb12155155d#foaf:Person]
</ud>
<ud>
Marin Mersenne (<dat when="1588">1588</dat>) <en ref="18" >Philosophe</en> et savant, <en ref="24" >astronome</en>, <en ref="16" >mathématicien</en>. - Théoricien de la musique. - Minime [http://data.bnf.fr/ark:/12148/cb119157157#foaf:Person]
</ud>
<ud>
Eberhard Welper (<dat when="1590">1590</dat>) <en ref="1632" >Imprimeur</en>-<en ref="1631" >libraire</en>. - Natif de Lohra (comté de Lohenstein, près de Marburg, Allemagne). <en ref="16" >Mathématicien</en>, <en ref="25" >astrologue</en> et <en ref="24" >astronome</en>, il se fixe à Strasbourg en 1618. Établi <en ref="1631" >libraire</en> en 1620 puis <en ref="1632" >imprimeur</en> dès 1621. Publie notamment chaque année un almanach et des prédictions. Auteur de plusieurs ouvrages scientifiques, dont des "Elementa geometrica..." (1re éd., <dat when="1620">1620</dat>), une "Gnomonica" (<dat when="1625">1625</dat>), un "Compendium astronomiae..." (<dat when="1634">1634</dat>) et un traité de la divination, "Rota-Fortunae, oder Glück-Rad..." (s. d., plusieurs rééd.). De 1634 à 1639, assure des fonctions d''enseignant au Gymnase (lycée) de Strasbourg. En 1654, sollicite en vain la charge d''<en ref="1632" >imprimeur</en> de l''évêché de Saverne. De 1653 à 1661, imprime sous le pseudonyme de Hartmann Bär quelques ouvrages pour l''académie des Jésuites à Molsheim. Son fils aîné Johann Welper (1642-1720) lui succède en 1664, mais des éditions paraissent encore sous son nom en 1689. Son autre fils Eberhard (II) Welper (1644-1670) sera lui aussi <en ref="16" >mathématicien</en>, <en ref="25" >astrologue</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb158750586#foaf:Person]
</ud>
<ud>
Johannes Wilhelm Lauremberg (<dat when="1590">1590</dat>) Auteur, <en ref="16" >mathématicien</en> et historien à Rostock [http://data.bnf.fr/ark:/12148/cb15377794m#foaf:Person]
</ud>
<ud>
Jean Leurechon (Bar-le-Duc, <dat when="1591">1591</dat>) Jésuite. - Professeur de philosophie et de mathématiques, à Pont-à-Mousson notamment. - Confesseur du duc de Lorraine Charles IV. - Henry Van Etten, qui signe la dédicace de la première édition des "Récréations mathématiques" n''est pas un pseudonyme de Jean Leurechon, mais le nom d''un de ses élèves, qui aurait réellement existé d''après Trevor H. Hall [http://data.bnf.fr/ark:/12148/cb13009618g#foaf:Person]
</ud>
<ud>
Joseph Salomon Delmedigo (<dat when="1591">1591</dat>) <en ref="28" >Médecin</en>. - <en ref="24" >Astronome</en>. - <en ref="16" >Mathématicien</en>. - Né en Crète. - Fils d''Eliya Delmedigo (1460-1497) [http://data.bnf.fr/ark:/12148/cb122623548#foaf:Person]
</ud>
<ud>
Giovanni Battista Vertova (<en type="li">Bergame, Italie</en>, <dat when="1592">1592</dat>) <en ref="16" >Mathématicien</en> et <en ref="1633" >ingénieur</en> militaire. - Chevalier de l''Ordre de Malte [http://data.bnf.fr/ark:/12148/cb15093021d#foaf:Person]
</ud>
<ud>
Johann Adam Schall von Bell (<dat when="1592">1592</dat>) Jésuite. - Missionnaire en Chine (de 1619 à sa mort). - <en ref="16" >Mathématicien</en>. - Conseiller et <en ref="24" >astronome</en> de la Cour impériale de Chine [http://data.bnf.fr/ark:/12148/cb12362941r#foaf:Person]
</ud>
<ud>
Pierre Gassendi (<en type="li">Champtercier, près de Digne</en>, <dat when="1592">1592</dat>) <en ref="18" >Philosophe</en>, <en ref="24" >astronome</en>, <en ref="16" >mathématicien</en>, <en ref="1630" >physicien</en>, docteur en théologie et théoricien de la musique. - Entre dans les ordres en 1615 [http://data.bnf.fr/ark:/12148/cb120250393#foaf:Person]
</ud>
<ud>
Wilhelm Schickard (<en type="li">Herrenberg, Allemagne</en>, <dat when="1592">1592</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en>, professeur d''agriculture [http://data.bnf.fr/ark:/12148/cb11969696s#foaf:Person]
</ud>
<ud>
Albert Girard (Saint-Mihiel, <dat when="1595">1595</dat>) <en ref="16" >Mathématicien</en> et <en ref="1633" >ingénieur</en>. - <en ref="1633" >Ingénieur</en> dans l''armée de Frédéric de Nassau, prince d''Orange [http://data.bnf.fr/ark:/12148/cb121123333#foaf:Person]
</ud>
<ud>
Pierre Bardin (<en type="li">Rouen</en>, <dat when="1595">1595</dat>) Homme de lettres, <en ref="18" >philosophe</en> et <en ref="16" >mathématicien</en>. - Précepteur. - Membre de l''Académie française (élu en 1634) [http://data.bnf.fr/ark:/12148/cb125272379#foaf:Person]
</ud>
<ud>
Pierre Bourdin (<dat when="1595">1595</dat>) Jésuite. - <in ana="1621">Professeur de mathématiques</in> [http://data.bnf.fr/ark:/12148/cb123902440#foaf:Person]
</ud>
<ud>
Daniel Mögling (<en type="li">Böblingen</en>, <dat when="1596">1596</dat>) Alchimiste, rosicrucien, <en ref="28" >médecin</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb167575369#foaf:Person]
</ud>
<ud>
Jacob Golius (<dat when="1596">1596</dat>) Orientaliste. - <en ref="16" >Mathématicien</en>. - Philologue, spécialiste des littératures [http://data.bnf.fr/ark:/12148/cb123338386#foaf:Person]
</ud>
<ud>
René Descartes (Descartes (Indre-et-Loire), <dat when="1596">1596</dat>) <en ref="18" >Philosophe</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb11899775j#foaf:Person]
</ud>
<ud>
Giovanni Battista Hodierna (<dat when="1597">1597</dat>) <en ref="24" >Astronome</en> italien [http://data.bnf.fr/ark:/12148/cb120704558#foaf:Person]
</ud>
<ud>
Bonaventura Cavalieri (<en type="li">Milan, Italie</en>, <dat when="1598">1598</dat>) Jésuite. - <en ref="16" >Mathématicien</en>, géomètre et <en ref="24" >astronome</en>, disciple de <en ref="7" >Galilée</en>. - Fut professeur à l''Université de Bologne [http://data.bnf.fr/ark:/12148/cb12085151g#foaf:Person]
</ud>
<ud>
Giovanni Battista Riccioli (<en type="li">Ferrare, Italie</en>, <dat when="1598">1598</dat>) Jésuite. - <en ref="24" >Astronome</en>. - <in ana="1621">Professeur de lettres, de philosophie et de théologie, à Parme puis à Bologne</in>. - <en ref="16" >Mathématicien</en> et historien de la géographie [http://data.bnf.fr/ark:/12148/cb12546680q#foaf:Person]
</ud>
<ud>
Pierre Petit (<dat when="1598">1598</dat>) <en ref="16" >Mathématicien</en> et <en ref="1630" >physicien</en>. - Intendant général des ports et fortifications de France (<dat when="1649">1649</dat>) [http://data.bnf.fr/ark:/12148/cb123944733#foaf:Person]
</ud>
<ud>
Adam Olearius (<en type="li">Aschersleben, Allemagne</en>, <dat when="1599">1599</dat>) Voyageur, en particulier en Russie et en Perse. - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12817277v#foaf:Person]
</ud>
<ud>
Jacob Aertsz Colom (<dat when="1599">1599</dat>) <en ref="16" >Mathématicien</en>, navigateur et <en ref="1636" >cartographe</en>. - <en ref="1632" >Imprimeur</en> à Amsterdam [http://data.bnf.fr/ark:/12148/cb153358650#foaf:Person]
</ud>
<ud>
Adriaan Vlacq (<dat when="1600">1600</dat>) Autre(s) graphie(s) : Ulack ; Vlac. - Variante(s) de prénom : Adriaen ; Adrien. - <en ref="1632" >Imprimeur</en>-<en ref="1631" >libraire</en>. - Originaire de Gouda. Édite différents périodiques dont "De Haegsche Vrijdaeghse Post-Tijdingen". A publié en 1659 une contrefaçon de Johannes Elzevier et de Pieter Leffen. A également publié sous les fausses adresses et pseudonymes de "Cologne, Pierre Du Marteau" et "Amsterdam, Peter Le Grand". - Également <en ref="16" >mathématicien</en> connu pour ses travaux sur les logarithmes et auteur d''ouvrages d''astronomie et de pamphlets en faveur des royalistes anglais en 1652-1655. Mort peu avant le 8 avril 1667. Des éd. paraissent encore sous son nom jusqu''en 1669, en association avec Johannes Vlacq [http://data.bnf.fr/ark:/12148/cb121635061#foaf:Person]
</ud>
<ud>
Antoine de Laloubère (<dat when="1600">1600</dat>) Jésuite. - <en ref="16" >Mathématicien</en> et géomètre, fut le premier scientifique à étudier les propriétés de l''hélice. - Polémiqua avec Pascal, qui l''appelle "Allouerus" dans l''"Histoire de la roulette". - <in ana="1621">Professeur de rhétorique, de théologie et de mathématiques au collège de Toulouse</in>. - Né à Rieux, meurt à Toulouse [http://data.bnf.fr/ark:/12148/cb13006798h#foaf:Person]
</ud>
<ud>
Giacomo Oddi (<dat when="1600">1600</dat>) <en ref="1636" >Cartographe</en> et <en ref="16" >mathématicien</en>. Etudie à Naples [http://data.bnf.fr/ark:/12148/cb153917817#foaf:Person]
</ud>
<ud>
Jakob Bartsch (<dat when="1600">1600</dat>) <en ref="28" >Médecin</en>. - <in ana="1621">Professeur de mathématiques à Strasbourg</in>. - <en ref="24" >Astronome</en>. - Gendre et collaborateur de l''<en ref="24" >astronome</en> Johann Kepler (1571-1630) [http://data.bnf.fr/ark:/12148/cb12163632v#foaf:Person]
</ud>
<ud>
Emmanuel Maignan (<dat when="1601">1601</dat>) Religieux minime. - <en ref="18" >Philosophe</en>, <en ref="16" >mathématicien</en> et peintre. - Membre de la Société des lanternistes [http://data.bnf.fr/ark:/12148/cb130127157#foaf:Person]
</ud>
<ud>
Florimond de Beaune (<dat when="1601">1601</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb11890827s#foaf:Person]
</ud>
<ud>
Ovidio Montalbani (<dat when="1601">1601</dat>) Docteur en philosophie et <en ref="28" >médecin</en>e de l'' Université de Bologne, professeur de mathématiques, chargé du musée Aldrovandi à partir de 1657, fut aussi un citoyen actif de Bologne, où il assura plusieurs magistratures ("giudice del Foro de mercanti, e de tribuni della plebe"). - Membre de l''Accademia dei Gelati de Bologne ("l''Innestato"), de l''Accademia degli Indomiti de Bologne ("lo Stellato"), et de l''Accademia della Notte de Bologne ("il Rugiadoso") [http://data.bnf.fr/ark:/12148/cb12064289s#foaf:Person]
</ud>
<ud>
Pierre de Fermat (Beaumont-de-Lomagne (Tarn-et-Garonne), <dat when="1601">1601</dat>) <en ref="16" >Mathématicien</en>, célèbre pour son théorème. - On lui doit aussi le Principe de Fermat en optique. - Conseiller au Parlement de Toulouse et commissaire en la chambre des requêtes du Palais à Toulouse (mai 1631) [http://data.bnf.fr/ark:/12148/cb11902568b#foaf:Person]
</ud>
<ud>
Athanasius Kircher (<en type="li">Geisa (Allemagne)</en>, <dat when="1602">1602</dat>) Jésuite. - <in ana="1621">Professeur de physique, de mathématiques et de langues orientales, Collegio Romano, Rome</in>. - Dessinateur et graveur [http://data.bnf.fr/ark:/12148/cb119097824#foaf:Person]
</ud>
<ud>
Gilles Personne de Roberval (<en type="li">Roberval, Oise</en>, <dat when="1602">1602</dat>) Professeur de philosophie (<dat when="1634">1634</dat>) et de mathématiques (<dat when="1655">1655</dat>) au Collège royal, Paris. - Membre fondateur de l''Académie royale des sciences [http://data.bnf.fr/ark:/12148/cb12144923j#foaf:Person]
</ud>
<ud>
Jacques de Billy (<dat when="1602">1602</dat>) Jésuite (à partir de 1619). - <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb123773436#foaf:Person]
</ud>
<ud>
John Greaves (<en type="li">Colemore, GB</en>, <dat when="1602">1602</dat>) <en ref="16" >Mathématicien</en>. - Orientaliste. - Professeur d''astronomie à Londres puis à Oxford [http://data.bnf.fr/ark:/12148/cb129277690#foaf:Person]
</ud>
<ud>
Pierre Gautruche (<dat when="1602">1602</dat>) Jésuite. - <in ana="1621">Professeur de philosophie, de théologie et de mathématiques</in>. - Identifié par certains à Pierre Gautier (1599-16..), luthiste et compositeur [http://data.bnf.fr/ark:/12148/cb121990328#foaf:Person]
</ud>
<ud>
Blaise-François de Pagan (<en type="li">Avignon</en>, <dat when="1604">1604</dat>) <en ref="1633" >Ingénieur</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb12155087r#foaf:Person]
</ud>
<ud>
Claude Hardy (<dat when="1604">1604</dat>) Fils de Sébastien Hardy. - Conseiller au Châtelet. - <en ref="16" >Mathématicien</en>. - Ami de Mydorge, Descartes et du Père Mersenne ; souvent cité dans la correspondance de ces deux derniers [http://data.bnf.fr/ark:/12148/cb12134536k#foaf:Person]
</ud>
<ud>
Bernard Frénicle de Bessy (<dat when="1605">1605</dat>) <en ref="16" >Mathématicien</en>, géomètre et arithméticien. - Membre de l''Académie des Sciences. - Conseiller à la Cour des monnaies [http://data.bnf.fr/ark:/12148/cb12459881c#foaf:Person]
</ud>
<ud>
Ismaël Boulliau (<en type="li">Loudun (Vienne)</en>, <dat when="1605">1605</dat>) <en ref="24" >Astronome</en>. - Secrétaire de Jacques Du Puy et attaché au président de Thou [http://data.bnf.fr/ark:/12148/cb124621511#foaf:Person]
</ud>
<ud>
Juan de Caramuel y Lobkowitz (<en type="li">Madrid</en>, <dat when="1606">1606</dat>) Cistercien. - Evêque de Satriano et Campagna (1657-1673) puis de Vigevano (1673-). - Humaniste, <en ref="1629" >théologien</en>, <en ref="16" >mathématicien</en>, <en ref="18" >philosophe</en> et <en ref="1635" >architecte</en>. - Défenseur de la doctrine probabiliste [http://data.bnf.fr/ark:/12148/cb12392566m#foaf:Person]
</ud>
<ud>
Evangelista Torricelli (<en type="li">Faenza, Italie</en>, <dat when="1608">1608</dat>) <en ref="1630" >Physicien</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12117674q#foaf:Person]
</ud>
<ud>
Gaspar Schott (<en type="li">Königshaufen, Allemagne</en>, <dat when="1608">1608</dat>) <en ref="16" >Mathématicien</en> et <en ref="1630" >physicien</en>. - Jésuite [http://data.bnf.fr/ark:/12148/cb12519717b#foaf:Person]
</ud>
<ud>
Giovanni Alfonso Borelli (<en type="li">Naples, Italie</en>, <dat when="1608">1608</dat>) <en ref="16" >Mathématicien</en>, phycisien, <en ref="28" >médecin</en>, <en ref="18" >philosophe</en>. - Membre de l''Accademia del Cimento [http://data.bnf.fr/ark:/12148/cb12462534j#foaf:Person]
</ud>
<ud>
Giovan Battista Nicolosi (<en type="li">Paternò, Italie</en>, <dat when="1610">1610</dat>) <en ref="29" >Géographe</en> et <en ref="1636" >cartographe</en>. - Professeur de mathématiques et de géographie à l''Université de Rome [http://data.bnf.fr/ark:/12148/cb15404103t#foaf:Person]
</ud>
<ud>
Józef Naronowicz-Naroński (<dat when="1610">1610</dat>) <en ref="16" >Mathématicien</en>. - <en ref="1636" >Cartographe</en>. - <en ref="1635" >Architecte</en> au service de la famille Radzwill. - Né en Lituanie [http://data.bnf.fr/ark:/12148/cb150812338#foaf:Person]
</ud>
<ud>
Maria Cunitia (<dat when="1610">1610</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb162514419#foaf:Person]
</ud>
<ud>
Jan Heweliusz (<dat when="1611">1611</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb121054498#foaf:Person]
</ud>
<ud>
John Pell (<dat when="1611">1611</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb146515879#foaf:Person]
</ud>
<ud>
Michael Floris Van Langren (<dat when="1612">1612</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en> du roi d''Espagne installé à Bruxelles [http://data.bnf.fr/ark:/12148/cb153283774#foaf:Person]
</ud>
<ud>
Francesco Maria Grimaldi (<dat when="1613">1613</dat>) Jésuite. - <en ref="18" >Philosophe</en>, <en ref="24" >astronome</en>, opticien et <in ana="1621">professeur de mathématiques</in>. - Né et mort à Bologne [http://data.bnf.fr/ark:/12148/cb13326913s#foaf:Person]
</ud>
<ud>
François Chauveau (<dat when="1613">1613</dat>) Grava des cartouches notamment pour Nicolas Sanson. Eut un neveu du nom de François Chauveau. Son frère, Jean-Baptiste, habile <en ref="1633" >ingénieur</en> et <en ref="16" >mathématicien</en> fut assassiné en 1670. [http://data.bnf.fr/ark:/12148/cb15302394v#foaf:Person]
</ud>
<ud>
Jean François Nicéron (<en type="li">Paris</en>, <dat when="1613">1613</dat>) Religieux de l''Ordre des minimes. - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb14404933t#foaf:Person]
</ud>
<ud>
Tommaso Cornelio (<en type="li">Rovito, Italie</en>, <dat when="1614">1614</dat>) <en ref="28" >Médecin</en>, <en ref="18" >philosophe</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb13484167f#foaf:Person]
</ud>
<ud>
Frans Van Schooten (<dat when="1615">1615</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12529949q#foaf:Person]
</ud>
<ud>
John Wallis (<dat when="1616">1616</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb123396143#foaf:Person]
</ud>
<ud>
Jonas Moore (<dat when="1617">1617</dat>) <en ref="16" >Mathématicien</en> britannique. - S''est intéressé aux mathématiques appliquées (astronomie, cosmographie, architecture...) [http://data.bnf.fr/ark:/12148/cb135104102#foaf:Person]
</ud>
<ud>
Tito Livio Burattini (<en type="li">Agordo, Italie</en>, <dat when="1617">1617</dat>) <en ref="16" >Mathématicien</en>, <en ref="1636" >cartographe</en> et égyptologue [http://data.bnf.fr/ark:/12148/cb162142362#foaf:Person]
</ud>
<ud>
Anthelme (Chatenay-Vaudin (Haute-Marne), <dat when="1618">1618</dat>) Religieux de la Chartreuse de Dijon. - <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb106267229#foaf:Person]
</ud>
<ud>
Charles Cavendish (<dat when="1620">1620</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb14651592w#foaf:Person]
</ud>
<ud>
Jean Picard (<en type="li">La Flèche (Sarthe)</en>, <dat when="1620">1620</dat>) <en ref="24" >Astronome</en>. - Membre de l''Académie des sciences (<dat when="1666">1666</dat>) [http://data.bnf.fr/ark:/12148/cb11941359d#foaf:Person]
</ud>
<ud>
Claude-François Milliet de Chales (<dat when="1621">1621</dat>) <en ref="16" >Mathématicien</en>. - Professeur d''hydrographie à Marseille [http://data.bnf.fr/ark:/12148/cb12397222c#foaf:Person]
</ud>
<ud>
Adrien Auzout (<en type="li">Rouen</en>, <dat when="1622">1622</dat>) <en ref="24" >Astronome</en>, <en ref="1630" >physicien</en> et <en ref="16" >mathématicien</en>. - A contribué au développement du micromètre [http://data.bnf.fr/ark:/12148/cb134752474#foaf:Person]
</ud>
<ud>
Jean Bertet (<dat when="1622">1622</dat>) Jésuite, quitte la Compagnie en 1681 pour entrer chez les Bénédictins. - <in ana="1621">Professeur de rhétorique, philosophie et mathématiques</in>. - Poète [http://data.bnf.fr/ark:/12148/cb11999230c#foaf:Person]
</ud>
<ud>
René-François De Sluse (<dat when="1622">1622</dat>) <en ref="16" >Mathématicien</en>. - Chanoine de la Cathédrale de Liège et abbé d''Amay [http://data.bnf.fr/ark:/12148/cb12427294z#foaf:Person]
</ud>
<ud>
Vincenzo Viviani (<en type="li">Florence, Italie</en>, <dat when="1622">1622</dat>) Florentin. - <en ref="16" >Mathématicien</en>. - Membre de l'' "accademia della Crusca" [http://data.bnf.fr/ark:/12148/cb12000373g#foaf:Person]
</ud>
<ud>
Blaise Pascal (Clermont-Ferrand (Puy-de-Dôme), <dat when="1623">1623</dat>) <en ref="16" >Mathématicien</en>, <en ref="1630" >physicien</en>, écrivain. - Frère de : Pascal, Jacqueline (1625-1661) [http://data.bnf.fr/ark:/12148/cb11918679x#foaf:Person]
</ud>
<ud>
Ferdinand Verbiest (<en type="li">Pitthem, Belgique</en>, <dat when="1623">1623</dat>) Jésuite, missionnaire en Chine. - <en ref="24" >Astronome</en>. - Fut placé à la tête du tribunal des mathématiques, chargé de la rédaction des éphémérides et de la direction des fonderies de canons. - A publié en langue chinoise, sous le nom de Nanhoai-jin, un grand nombre d''ouvrages scientifiques [http://data.bnf.fr/ark:/12148/cb12215344n#foaf:Person]
</ud>
<ud>
Camillo Guarino Guarini (<en type="li">Modène, Italie</en>, <dat when="1624">1624</dat>) Clerc régulier, théatin. - <en ref="1635" >Architecte</en> du duc de Savoie, <en ref="18" >philosophe</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12348027r#foaf:Person]
</ud>
<ud>
Christoph Wittich (<dat when="1625">1625</dat>) <en ref="1629" >Théologien</en>. - <in ana="1621">Professeur de mathématiques et de théologie</in> [http://data.bnf.fr/ark:/12148/cb13014027s#foaf:Person]
</ud>
<ud>
Erhard Weigel (<dat when="1625">1625</dat>) <en ref="18" >Philosophe</en>. - <in ana="1621">Professeur de mathématiques, maître de Leibniz et de Pufendorf</in> [http://data.bnf.fr/ark:/12148/cb11935908x#foaf:Person]
</ud>
<ud>
Jean-Dominique Cassini (<en type="li">Perinaldo (comté de Nice)</en>, <dat when="1625">1625</dat>) Titulaire de la chaire d''astronomie de Bologne de 1650 à 1669, surintendant des eaux du Bolonais de 1657 à 1669, surintendant des eaux de l''Etat pontifical et titulaire d''autres charges auprès du pape. - Appelé en France an avril 1669 par Louis XIV. - Membre de l''Académie des sciences, directeur de l''Observatoire de Paris (à partir de 1672). - Naturalisé français en 1673 [http://data.bnf.fr/ark:/12148/cb121019904#foaf:Person]
</ud>
<ud>
Johan de Witt (Dordrecht, Pays-Bas, <dat when="1625">1625</dat>) Homme d''état et <en ref="16" >mathématicien</en>. - Grand pensionnaire de Hollande [http://data.bnf.fr/ark:/12148/cb13598046j#foaf:Person]
</ud>
<ud>
Johann Hecker (<en type="li">Gdansk (Pologne)</en>, <dat when="1625">1625</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb12875545t#foaf:Person]
</ud>
<ud>
Rasmus Bartholin (<en type="li">Roskilde, Danemark</en>, <dat when="1625">1625</dat>) <en ref="1630" >Physicien</en>. - <en ref="16" >Mathématicien</en>. - <en ref="28" >Médecin</en>. - Professeur de mathématiques et de <en ref="28" >médecin</en>e à Copenhague. - A découvert la difraction de la lumière. - Fils de Kaspar Bartholin [http://data.bnf.fr/ark:/12148/cb11890430k#foaf:Person]
</ud>
<ud>
Samuel Morland (<dat when="1625">1625</dat>) <en ref="16" >Mathématicien</en> et inventeur [http://data.bnf.fr/ark:/12148/cb10365749d#foaf:Person]
</ud>
<ud>
Pietro Mengoli (<en type="li">Bologne (Italie)</en>, <dat when="1626">1626</dat>) <en ref="16" >Mathématicien</en>. - Professeur de mécanique (1650-1678) puis titulaire de la chaire de mathématiques et d''astronomie (1678-1686) à l''université de Bologne [http://data.bnf.fr/ark:/12148/cb120851477#foaf:Person]
</ud>
<ud>
John Ray (<en type="li">Black Notley (Essex)</en>, <dat when="1627">1627</dat>) <in ana="1621">Professeur de mathématiques et de lettres</in>. - Naturaliste. - Botaniste. - Membre de la Société royale de Londres [http://data.bnf.fr/ark:/12148/cb12220184b#foaf:Person]
</ud>
<ud>
Heinrich Scherer (<dat when="1628">1628</dat>) Jésuite, <en ref="29" >géographe</en> et <in ana="1621">professeur de mathématiques à Munich</in> [http://data.bnf.fr/ark:/12148/cb15317471w#foaf:Person]
</ud>
<ud>
Johannes Hudde (<dat when="1628">1628</dat>) <en ref="16" >Mathématicien</en>, élève de Frans Van Schooten. - Bourgmestre de la ville d''Amsterdam [http://data.bnf.fr/ark:/12148/cb13488288n#foaf:Person]
</ud>
<ud>
Christiaan Huygens (<dat when="1629">1629</dat>) <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en>. - A vécu aux Pays-Bas et en France. - Élu membre de la "Royal society" de Londres (en 1663) [http://data.bnf.fr/ark:/12148/cb12192922r#foaf:Person]
</ud>
<ud>
Allain Manesson-Mallet (<en type="li">Paris (France)</en>, <dat when="1630">1630</dat>) <en ref="1633" >Ingénieur</en> et <en ref="1636" >cartographe</en>. - Maître de mathématiques des pages du roi de France, sergent-major d''artillerie du roi de Portugal [http://data.bnf.fr/ark:/12148/cb153363577#foaf:Person]
</ud>
<ud>
Isaac Barrow (<dat when="1630">1630</dat>) <en ref="16" >Mathématicien</en> et <en ref="1629" >théologien</en> [http://data.bnf.fr/ark:/12148/cb12340135q#foaf:Person]
</ud>
<ud>
Jean Richer (<dat when="1630">1630</dat>) <en ref="24" >Astronome</en> à l''Observatoire de Paris, il figure parmi les premiers membres de l''Académie des sciences (<dat when="1666">1666</dat>). - Chargé d''une mission géodésique à Cayenne (1672-73) [http://data.bnf.fr/ark:/12148/cb14064426q#foaf:Person]
</ud>
<ud>
Adam Adamady Kochánski (<dat when="1631">1631</dat>) <en ref="16" >Mathématicien</en> polonais, auteur de la rectification approchée de la circonférence. Réside en 1677 à Wroclaw [http://data.bnf.fr/ark:/12148/cb16187484g#foaf:Person]
</ud>
<ud>
Francesco Lana Terzi (<en type="li">Brescia, Italie</en>, <dat when="1631">1631</dat>) Jésuite. - <en ref="16" >Mathématicien</en>, naturaliste. - Pionnier de l''aéronautique [http://data.bnf.fr/ark:/12148/cb10681783j#foaf:Person]
</ud>
<ud>
Christopher Wren (<en type="li">East Knoyle, Wiltshire, GB</en>, <dat when="1632">1632</dat>) <en ref="1635" >Architecte</en>. - <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en>, Sir Christopher Wren fut l''un des membres fondateurs de la Société royale des sciences [http://data.bnf.fr/ark:/12148/cb121401670#foaf:Person]
</ud>
<ud>
Alessandro Marchetti (<en type="li">Empoli, Italie</en>, <dat when="1633">1633</dat>) Poète naturaliste, l''un des principaux animateurs du courant naturaliste toscan de la seconde moitié du XVIIe siècle. - Professeur de philosophie puis de mathématiques à l''Université de Pise [http://data.bnf.fr/ark:/12148/cb12570345j#foaf:Person]
</ud>
<ud>
Donato Rossetti (<en type="li">Livourne, Italie</en>, <dat when="1633">1633</dat>) <en ref="16" >Mathématicien</en>. - Professeur de philosophie au "Studio" de Pise [http://data.bnf.fr/ark:/12148/cb144820894#foaf:Person]
</ud>
<ud>
Geminiano Montanari (<en type="li">Modène, Italie</en>, <dat when="1633">1633</dat>) Docteur en droit, <en ref="16" >mathématicien</en> et <en ref="24" >astronome</en>. - Enseigne à Florence, Modène (1661-1664), Bologne (chaire de mathématiques, 1664-1677) et Padoue (chaire d''astronomie, 1678-1687). - Membre de l''Accademia dei Gelati ("l''Elevato") et de l''Accademia della Treccia de Bologne [http://data.bnf.fr/ark:/12148/cb12309300z#foaf:Person]
</ud>
<ud>
Gerhard Wolter Molanus (<dat when="1633">1633</dat>) <en ref="1629" >Théologien</en> luthérien. - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12133744h#foaf:Person]
</ud>
<ud>
Giovanni Giustino Ciampini (<en type="li">Rome</en>, <dat when="1633">1633</dat>) Historien, archéologue, <en ref="16" >mathématicien</en>. - Membre de la Curie pontificale [http://data.bnf.fr/ark:/12148/cb14323561z#foaf:Person]
</ud>
<ud>
Vitale Giordano (<dat when="1633">1633</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb15520924m#foaf:Person]
</ud>
<ud>
Johann Christoph Sturm (<en type="li">Hilpolstein, Allemagne</en>, <dat when="1635">1635</dat>) <en ref="18" >Philosophe</en>, <en ref="16" >mathématicien</en> et <en ref="1630" >physicien</en>. - Professeur à l''université d''Altdorf [http://data.bnf.fr/ark:/12148/cb133240234#foaf:Person]
</ud>
<ud>
Ignace-Gaston Pardies (<dat when="1636">1636</dat>) <en ref="16" >Mathématicien</en>. - Jésuite. - Il a enseigné la philosophie puis les mathématiques au collège Louis-Le-Grand [http://data.bnf.fr/ark:/12148/cb12174258w#foaf:Person]
</ud>
<ud>
Elias van Lennep (Borculo, Pays-Bas, <dat when="1637">1637</dat>) Graveur. - <en ref="1633" >Ingénieur</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb15053499m#foaf:Person]
</ud>
<ud>
Julius Reichelt (<dat when="1637">1637</dat>) <en ref="16" >Mathématicien</en> strasbourgeois [http://data.bnf.fr/ark:/12148/cb15377331m#foaf:Person]
</ud>
<ud>
François Barrême (<en type="li">Tarascon, France</en>, <dat when="1638">1638</dat>) <en ref="16" >Mathématicien</en> et financier [http://data.bnf.fr/ark:/12148/cb118903320#foaf:Person]
</ud>
<ud>
Georg Christoph Eimmart (<en type="li">Ratisbonne (Allemagne)</en>, <dat when="1638">1638</dat>) Peintre d''histoire, portraitiste, graveur, <en ref="16" >mathématicien</en> et <en ref="24" >astronome</en>. - Fils et élève du peintre Georg-Christoph Eimmart (1603-1658), dit le vieux [http://data.bnf.fr/ark:/12148/cb12983761h#foaf:Person]
</ud>
<ud>
James Gregory (<dat when="1638">1638</dat>) <en ref="16" >Mathématicien</en> et opticien écossais [http://data.bnf.fr/ark:/12148/cb12459917j#foaf:Person]
</ud>
<ud>
Jean Bonfa (<en type="li">Nîmes</en>, <dat when="1638">1638</dat>) Est admis à la Société de Jésus en 1654. - Dans les années 1670 jusqu''en 1683, il enseigne les mathématiques et la théologie aux collèges jésuites de Grenoble, puis d''Avignon. - De 1680 à 1682, enseigne la géométrie et l''hydrographie. - Effectue des travaux astronomiques. - Devient membre correspondant de l''Académie royale des sciences (en 1699) [http://data.bnf.fr/ark:/12148/cb15130186g#foaf:Person]
</ud>
<ud>
Jacques Ozanam (Sainte-Olive (<en type="li">Ain)</en>, <dat when="1640">1640</dat>) <en ref="16" >Mathématicien</en>. - <in ana="1621">Professeur de mathématiques à Paris et à Lyon</in> [http://data.bnf.fr/ark:/12148/cb120960958#foaf:Person]
</ud>
<ud>
Philippe de La Hire (<en type="li">Paris (France)</en>, <dat when="1640">1640</dat>) <en ref="16" >Mathématicien</en>. - Géomètre et <en ref="24" >astronome</en>. - <in ana="1621">Professeur de mathématiques au Collège de France</in>. - Membre de l''Académie des sciences (<dat when="1678">1678</dat>) [http://data.bnf.fr/ark:/12148/cb121592847#foaf:Person]
</ud>
<ud>
Pierre Ango (<dat when="1640">1640</dat>) Jésuite. - Enseigna les humanités, les mathématiques et la philosophie. - Né à Rouen, mort à La Flèche [http://data.bnf.fr/ark:/12148/cb12512101m#foaf:Person]
</ud>
<ud>
Denis Papin (<dat when="1642">1642</dat>) <en ref="1630" >Physicien</en>. - Un des précurseurs de l''invention de la machine à vapeur, qui eu l''idée du piston (dés 1690), et inspira la machine que l''Anglais Thomas Newcomen (1664-1729), mis au point ensuite (en 1712). - Quitta définitivement la France, après la révocation de l''Édit de Nantes (<dat when="1685">1685</dat>). - Occupa une chaire de mathématiques à l''Université de Marburg, Allemagne (<dat when="1687">1687</dat>). - Rédige un article (Ars nova ad aquam ignis...) présentant sa machine dans la revue " Acta Eruditorum", Leipzig (en 1707), revue célèbre pour les publications de Leibniz (1646-1716), sur le calcul différentiel et intégral [http://data.bnf.fr/ark:/12148/cb12087889k#foaf:Person]
</ud>
<ud>
Isaac Newton (Woolsthorpe, Lincolnshire (<en type="li">GB)</en>, <dat when="1642">1642</dat>) <en ref="1630" >Physicien</en>, <en ref="16" >mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb119176085#foaf:Person]
</ud>
<ud>
Johann Welper (<dat when="1642">1642</dat>) Variante(s) de prénom : Johannes ; Jean. - <en ref="1632" >Imprimeur</en>-<en ref="1631" >libraire</en>. - Fils et apprenti d''Eberhard Welper, <en ref="1632" >imprimeur</en>-<en ref="1631" >libraire</en> et <en ref="16" >mathématicien</en> à Strasbourg. A été compagnon pendant 6 ans à Ulm, Augsbourg, Munich, Vienne, Leipzig et Nuremberg, avant de succéder à son père. L''enquête de 1700-1701 le dit âgé de 60 ans et "établi à Strasbourg depuis 42 ans". À sa mort, son entreprise est rachetée par Melchior Pauschinger [http://data.bnf.fr/ark:/12148/cb160636269#foaf:Person]
</ud>
<ud>
Michel Mourgues (<dat when="1642">1642</dat>) Jésuite. - Enseigna la rhétorique et les mathématiques à l''Université de Toulouse [http://data.bnf.fr/ark:/12148/cb124637183#foaf:Person]
</ud>
<ud>
Takakazu Seki (<dat when="1642">1642</dat>) <en ref="16" >Mathématicien</en> japonais [http://data.bnf.fr/ark:/12148/cb12443516f#foaf:Person]
</ud>
<ud>
Jean Jombert (<dat when="1643">1643</dat>) <en ref="1631" >Libraire</en>. - Fils d''un fruitier et marchand de vins parisien. En apprentissage chez le <en ref="1631" >libraire</en> parisien Pierre II Baudouin à partir de janv. 1666, il travaille en 1670-1671 chez Louis Billaine et Pierre Le Petit, puis chez la veuve de Pierre I Baudouin à partir de 1672. Gendre en 1res noces (<dat when="1671">1671</dat>) du <en ref="1631" >libraire</en> Jean d''Houry. Publie sous son propre nom dès 1680, peut-être dès 1678, mais n''est reçu maître que le 17 sept. 1686. Publie de nombreux ouvrages de mathématiques. Dit âgé d''env. 60 ans lors de l''enquête de nov.-déc. 1701. Testaments le 9 août 1704 et le 6 oct. 1705. Décédé au début de nov. 1705. Sa veuve lui succède [http://data.bnf.fr/ark:/12148/cb15074749j#foaf:Person]
</ud>
<ud>
Antoine Thomas (<en type="li">Namur</en>, <dat when="1644">1644</dat>) Jésuite (à partir de 1660). - <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en> de l''empereur de Chine [http://data.bnf.fr/ark:/12148/cb10636254r#foaf:Person]
</ud>
<ud>
Johann Jakob Zimmermann (<en type="li">Vaihingen an der Enz, Allemagne</en>, <dat when="1644">1644</dat>) <en ref="1629" >Théologien</en>, <en ref="16" >mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb10721479d#foaf:Person]
</ud>
<ud>
Ole Rømer (<en type="li">Åarhus, Danemark</en>, <dat when="1644">1644</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb12324191r#foaf:Person]
</ud>
<ud>
Carlos de Sigüenza y Góngora (<en type="li">Mexico</en>, <dat when="1645">1645</dat>) <en ref="24" >Astronome</en>, <en ref="16" >mathématicien</en>, poète, historien. - Sa bibliothèque, comprenant des documents uniques sur l''histoire du Mexique, disparut dans un incendie lors de l''insurrection de 1692 [http://data.bnf.fr/ark:/12148/cb121021638#foaf:Person]
</ud>
<ud>
Eusebio Francisco Kino (<en type="li">Taio, Italie</en>, <dat when="1645">1645</dat>) <en ref="16" >Mathématicien</en> et <en ref="29" >géographe</en> de formation. - Jésuite, arrive au Mexique en 1681 [http://data.bnf.fr/ark:/12148/cb122190783#foaf:Person]
</ud>
<ud>
Maximilian Rassler (<en type="li">Waldsee (Allemagne)</en>, <dat when="1645">1645</dat>) Jésuite. - <in ana="1621">Professeur de réthorique, de mathématiques, philosophie et contreverse</in>. - Recteur et chancelier de l''Université de Dillingen, Allemagne [http://data.bnf.fr/ark:/12148/cb158132748#foaf:Person]
</ud>
<ud>
Elena Lucrezia Cornaro Piscopia (<en type="li">Venise (Italie)</en>, <dat when="1646">1646</dat>) <en ref="18" >Philosophe</en> et <en ref="16" >mathématicien</en>ne. - Première femme docteur en philosophie [http://data.bnf.fr/ark:/12148/cb16591183r#foaf:Person]
</ud>
<ud>
Francesco Maria Pompeo Colonna (<en type="li">Rome</en>, <dat when="1646">1646</dat>) <en ref="16" >Mathématicien</en>, <en ref="1630" >physicien</en> et occultiste. - Vécut à Paris à partir de 1668 [http://data.bnf.fr/ark:/12148/cb118973978#foaf:Person]
</ud>
<ud>
Harald Vallerius (<dat when="1646">1646</dat>) Professeur universitaire de mathématiques [http://data.bnf.fr/ark:/12148/cb16032560b#foaf:Person]
</ud>
<ud>
John Flamsteed (<dat when="1646">1646</dat>) <en ref="24" >Astronome</en>. - Fut le premier directeur de l''Observatoire de Greenwich, GB, fondé en 1675 [http://data.bnf.fr/ark:/12148/cb13524243n#foaf:Person]
</ud>
<ud>
John Flamsteed (<dat when="1646">1646</dat>) <en ref="24" >Astronome</en> britannique. Fut le premier directeur de l''observatoire de Greenwich, fondé en 1675 [http://data.bnf.fr/ark:/12148/cb13510391m#foaf:Person]
</ud>
<ud>
Niccolò Partenio Giannettasio (<dat when="1648">1648</dat>) Jésuite. - Historien et poète. - Professeur de mathématiques et d''hébreu au Collège des Jésuites de Naples. - Né à Naples, meurt à Massa [http://data.bnf.fr/ark:/12148/cb133256727#foaf:Person]
</ud>
<ud>
Tommaso Ceva (<dat when="1648">1648</dat>) Jésuite. - <en ref="18" >Philosophe</en>, <en ref="24" >astronome</en>, <en ref="1630" >physicien</en> et poète. - Membre de l''Académie de l''Arcadie sous le pseudonyme : Callimaco Neridio [http://data.bnf.fr/ark:/12148/cb13321850h#foaf:Person]
</ud>
<ud>
Jean Le Febvre (<en type="li">Lisieux (Calvados)</en>, <dat when="1650">1650</dat>) Tisserand, puis <en ref="24" >astronome</en>. - Membre de l''Académie des sciences de 1682 à 1702 [http://data.bnf.fr/ark:/12148/cb16176897g#foaf:Person]
</ud>
<ud>
Michelangelo Fardella (<dat when="1650">1650</dat>) Franciscain. - <en ref="18" >Philosophe</en>, <en ref="24" >astronome</en> et <en ref="16" >mathématicien</en>. - Professeur de philosophie, de théologie, de mathématiques, professeur d''astronomie et de physique à l''Université de Padoue (1694-). - Né à Trapani, meurt à Naples [http://data.bnf.fr/ark:/12148/cb12093422f#foaf:Person]
</ud>
<ud>
Andreas Cellarius (<dat when="1651">1651</dat>) <en ref="16" >Mathématicien</en> et <en ref="29" >géographe</en> hollandais actif de 1656 à 1702. En 1660 il est recteur de l''Ecole latine de Hoorn [http://data.bnf.fr/ark:/12148/cb15338282n#foaf:Person]
</ud>
<ud>
Antoine-François Payen (<en type="li">Avignon</en>, <dat when="1651">1651</dat>) Jurisconsulte et <en ref="24" >astronome</en>. - Enseigna la jurisprudence civile dès 1642 à Avignon [http://data.bnf.fr/ark:/12148/cb144713316#foaf:Person]
</ud>
<ud>
Arent Roggeveen (<dat when="1651">1651</dat>) <en ref="16" >Mathématicien</en>, navigateur et hydrographe [http://data.bnf.fr/ark:/12148/cb153879695#foaf:Person]
</ud>
<ud>
Bingzhen Jiao (<dat when="1651">1651</dat>) Peintre et <en ref="16" >mathématicien</en> à la cour de l''empereur Kangxi [http://data.bnf.fr/ark:/12148/cb14546684c#foaf:Person]
</ud>
<ud>
Caspar Dauthendey (<dat when="1651">1651</dat>) <en ref="1635" >Architecte</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb153778194#foaf:Person]
</ud>
<ud>
Claude Bonjour (<dat when="1651">1651</dat>) Augustin du couvent de Pontarlier. <en ref="29" >Géographe</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb15294805z#foaf:Person]
</ud>
<ud>
Claude Comiers (<dat when="1651">1651</dat>) <en ref="1629" >Théologien</en> et <en ref="16" >mathématicien</en>, né à Embrun. Chanoine d''Embrun, <en ref="1633" >ingénieur</en> des armées, puis prévôt de l''église collégiale de Ternant, professeur de mathématiques à Paris ; protonotaire apostolique et officier du Saint-Office. - Il a laissé des livres et des articles sur des sujets variés : géométrie, astronomie, <en ref="28" >médecin</en>e, occultisme, physique... [http://data.bnf.fr/ark:/12148/cb12250531g#foaf:Person]
</ud>
<ud>
Claude Irson (<dat when="1651">1651</dat>) <en ref="16" >Mathématicien</en> et grammairien. - A été teneur de comptes vers 1678 [http://data.bnf.fr/ark:/12148/cb125155096#foaf:Person]
</ud>
<ud>
de La Roche (<dat when="1651">1651</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb13009642b#foaf:Person]
</ud>
<ud>
Ehrenfried Walter von Tschirnhaus (<en type="li">Kieslingswalde, Allemagne</en>, <dat when="1651">1651</dat>) <en ref="18" >Philosophe</en>, <en ref="16" >mathématicien</en> et biologiste. - Industriel, considéré comme l''inventeur de la porcellaine blanche en Europe [http://data.bnf.fr/ark:/12148/cb12515471b#foaf:Person]
</ud>
<ud>
Federico Gualdi (<dat when="1651">1651</dat>) Alchimiste, <en ref="24" >astronome</en>, <en ref="16" >mathématicien</en>. - <en ref="18" >Philosophe</en> hermétique. - Membre de la Rose-croix d''Or. - Serait d''origine allemande ou italienne [http://data.bnf.fr/ark:/12148/cb150904929#foaf:Person]
</ud>
<ud>
Francesco Levera (<en type="li">Savoie</en>, <dat when="1651">1651</dat>) <en ref="18" >Philosophe</en>, <en ref="24" >astronome</en> et <en ref="1629" >théologien</en> [http://data.bnf.fr/ark:/12148/cb10442558v#foaf:Person]
</ud>
<ud>
François Chevalier (Sainte-Maur, <dat when="1651">1651</dat>) Elève de l''abbé Galloys. Associé géomètre à l''Académie des sciences en 1707. Pensionnaire mécanicien en 1725. <in ana="1621">Professeur de mathématiques au Collège de France</in>. Maître de mathématiques du roi et des pages de la Petite Ecurie. Présenta en 1707 à l''Académie une méthode de collecte des informations cartographiques sur des châssis concentriques [http://data.bnf.fr/ark:/12148/cb153045899#foaf:Person]
</ud>
<ud>
François Noël (Hestrud, Pays-Bas Méridionaux, <dat when="1651">1651</dat>) Jésuite (à partir de 1670) ordonné prêtre en 1682. - Missionnaire en Chine, il fut envoyé à Rome à l''occasion de la querelle des rites, et ne put rentrer en Chinê. - Il enseigna ensuite à Prague. - Auteur de poésies et de théâtre, d''un traité d''astronomie, de traductions et d''un ouvrage catéchétique en chinois [http://data.bnf.fr/ark:/12148/cb16653645d#foaf:Person]
</ud>
<ud>
Guisnée (<dat when="1651">1651</dat>) <en ref="16" >Mathématicien</en>. - Membre de l''Académie royale des sciences [http://data.bnf.fr/ark:/12148/cb14618149h#foaf:Person]
</ud>
<ud>
Jacques Mengau (<dat when="1651">1651</dat>) <in ana="1621">Professeur de mathématiques</in>. - Auteur de mazarinades. - Actif de 1648 à 1652 [http://data.bnf.fr/ark:/12148/cb12166762s#foaf:Person]
</ud>
<ud>
Jean Bachou (<dat when="1651">1651</dat>) <en ref="16" >Mathématicien</en> et alchimiste lyonnais. - Avocat au parlement [http://data.bnf.fr/ark:/12148/cb12158814g#foaf:Person]
</ud>
<ud>
Jean Glover (<dat when="1651">1651</dat>) <en ref="1633" >Ingénieur</en> et <en ref="16" >mathématicien</en> originaire d''Écosse et établi en France. - Auteur notamment de plusieurs propositions de loteries et d''une "Nouvelle Manière d''exécuter les loteries..." (<en type="li">Paris</en>, <dat when="1705">1705</dat>). - Se qualifie d''"esquire, seigneur de Glaideny et de la baronnie de Baltillée en Ecosse" [http://data.bnf.fr/ark:/12148/cb15818830h#foaf:Person]
</ud>
<ud>
Jean-Baptiste Delure (<dat when="1651">1651</dat>) Éditeur d''estampes et de cartes géographiques. - <en ref="1633" >Ingénieur</en> pour les instruments de mathématiques et fabricant de cartes et de globes ; éditeur occasionnel [http://data.bnf.fr/ark:/12148/cb153164066#foaf:Person]
</ud>
<ud>
Joachim d'' Alencé (<dat when="1651">1651</dat>) <en ref="24" >Astronome</en> et <en ref="1630" >physicien</en> [http://data.bnf.fr/ark:/12148/cb12397878n#foaf:Person]
</ud>
<ud>
Joanne Westenburg (<dat when="1651">1651</dat>) <en ref="1636" >Cartographe</en>, <en ref="28" >médecin</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb15377993t#foaf:Person]
</ud>
<ud>
Johann Andreas Planer (<en type="li">Strelen, Allemagne</en>, <dat when="1651">1651</dat>) <en ref="16" >Mathématicien</en>. - Professeur de mathématiques à l''Université de Wittenberg [http://data.bnf.fr/ark:/12148/cb16672375p#foaf:Person]
</ud>
<ud>
Le Blanc (<dat when="1651">1651</dat>) Professeur de mathématiques (<dat when="1692">1692</dat>). - Réside rue de Seine à Paris en 1692 [http://data.bnf.fr/ark:/12148/cb16650697x#foaf:Person]
</ud>
<ud>
Le Demaine Godalles (<dat when="1651">1651</dat>) Hydrographe, <en ref="1633" >Ingénieur</en> du roi et <in ana="1621">professeur de Mathématiques, <en ref="1635" >Architecte</en></in> [http://data.bnf.fr/ark:/12148/cb15375819n#foaf:Person]
</ud>
<ud>
Philip Lea (<dat when="1651">1651</dat>) <en ref="1636" >Cartographe</en>, fabricant et éditeur de globes, de cartes, d''instruments de mathématiques, actif de 1666 à 1700 à Londres [http://data.bnf.fr/ark:/12148/cb15328427v#foaf:Person]
</ud>
<ud>
René Gaultier de Maignannes (<dat when="1651">1651</dat>) <en ref="16" >Mathématicien</en> angevin. - Spécialiste de la perspective [http://data.bnf.fr/ark:/12148/cb12536157m#foaf:Person]
</ud>
<ud>
David François de Merveilleux (<dat when="1652">1652</dat>) <en ref="29" >Géographe</en> et <en ref="1636" >cartographe</en>. Connaissances mathématiques étendues (il publie un traîté d''arithmétique et de géométrie). En 1695 il entre au service de Guillaume III qui lui accorde le brevet de Capitaine <en ref="1633" >Ingénieur</en> au service d''Angleterre et des Etats généraux [http://data.bnf.fr/ark:/12148/cb15304894q#foaf:Person]
</ud>
<ud>
Michel Rolle (Ambert (Puy-de-Dôme), <dat when="1652">1652</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb130110121#foaf:Person]
</ud>
<ud>
Nicolas Bion (<dat when="1652">1652</dat>) <en ref="1633" >Ingénieur</en> du roi pour les instruments de mathématique. - Avait un atelier à Paris, quai de l''Horloge, qui était l''un des mieux achalandés du temps. - Son "Usage des globes" connut 6 éditions entre 1699 et 1751. - Édita en 1694 le globe terrestre de P. Courtin (diam. 25 cm) et en 1712 une paire de globes de même diamètre, un globe céleste antérieur à 1710 atteignit 32 cm de diamètre [http://data.bnf.fr/ark:/12148/cb152909089#foaf:Person]
</ud>
<ud>
José Chaffrion (<dat when="1653">1653</dat>) <en ref="1636" >Cartographe</en> et <en ref="16" >mathématicien</en> de Valence en Espagne [http://data.bnf.fr/ark:/12148/cb15330290b#foaf:Person]
</ud>
<ud>
Bernard Nieuwentijt (West Graftdijk, Pays-Bas, <dat when="1654">1654</dat>) <en ref="18" >Philosophe</en>, <en ref="28" >médecin</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb14587835s#foaf:Person]
</ud>
<ud>
Jacques Bernoulli (<en type="li">Bâle, Suisse</en>, <dat when="1654">1654</dat>) <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en>. - Professeur de mathématiques à l''université de Bâle, Suisse [http://data.bnf.fr/ark:/12148/cb120751142#foaf:Person]
</ud>
<ud>
Jean Pigeon (<en type="li">Donzy (Nièvre)</en>, <dat when="1654">1654</dat>) Peintre, <en ref="16" >mathématicien</en> et facteur de globes, <en ref="29" >géographe</en> du Duc d''Orléans à partir de 1714 [http://data.bnf.fr/ark:/12148/cb15147433m#foaf:Person]
</ud>
<ud>
Jean-François Gerbillon (<dat when="1654">1654</dat>) Jésuite. - <en ref="16" >Mathématicien</en>, fut envoyé en Chine par Louis XIV en 1685. - Écrivit des traités de géométrie et de l''usage de l''astrolabe en chinois et en tartare. - Supérieur général de la Mission française de Chine [http://data.bnf.fr/ark:/12148/cb124622770#foaf:Person]
</ud>
<ud>
Philippe Avril (<en type="li">Angoulême (Charente)</en>, <dat when="1654">1654</dat>) Missionnaire. - Voyageur, jésuite dès 1670, il enseigna les mathématiques à Louis-le-Grand. - Chercha un nouveau passage vers la Chine par la Tartarie, le Kurdistan et l''Arménie [http://data.bnf.fr/ark:/12148/cb15327596q#foaf:Person]
</ud>
<ud>
Philippe Naudé (<en type="li">Metz</en>, <dat when="1654">1654</dat>) <en ref="1629" >Théologien</en> et <en ref="16" >mathématicien</en>. - Se réfugia en Prusse après la révocation de l''Édit de Nantes [http://data.bnf.fr/ark:/12148/cb10366497p#foaf:Person]
</ud>
<ud>
Pierre Varignon (<en type="li">Caen (Calvados)</en>, <dat when="1654">1654</dat>) <en ref="16" >Mathématicien</en>. - Jésuite. - Membre de l''Académie des sciences, il entre au collège de France en 1704 [http://data.bnf.fr/ark:/12148/cb121123302#foaf:Person]
</ud>
<ud>
Louis Lecomte (<dat when="1655">1655</dat>) Jésuite. - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12151496v#foaf:Person]
</ud>
<ud>
Simon Tyssot de Patot (<en type="li">Londres</en>, <dat when="1655">1655</dat>) Professeur ordinaire de mathématiques à l''École illustre de Deventer (1699-1727 ; professeur extraordinaire dès 1690). - Vécut en France de 1658 environ à 1664, puis aux Pays-Bas [http://data.bnf.fr/ark:/12148/cb11927303t#foaf:Person]
</ud>
<ud>
Claude de Visdelou (Erquy (Côtes-d''Armor), <dat when="1656">1656</dat>) Jésuite. - <en ref="16" >Mathématicien</en>. - Missionnaire en Chine. - Évèque titulaire de de Claudiopolis-en-Isaurie (à partir de 1708/1709). - Vicaire apostolique du Koueitchéou et du Yunnan, et administrateu du Houkouang (de 1708 à 1709) [http://data.bnf.fr/ark:/12148/cb150791582#foaf:Person]
</ud>
<ud>
Edmund Halley (<dat when="1656">1656</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb119960783#foaf:Person]
</ud>
<ud>
Nicolaas Hartsoeker (Gouda (Pays-Bas), <dat when="1656">1656</dat>) <en ref="1630" >Physicien</en>, micrographe et <en ref="28" >médecin</en>. - Apporta des perfectionnements importants à la fabrication des verres de lunettes astronomiques, découvrit les animalcules spermatiques [http://data.bnf.fr/ark:/12148/cb13010358x#foaf:Person]
</ud>
<ud>
William Molyneux (<en type="li">Dublin</en>, <dat when="1656">1656</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en>, <en ref="1630" >physicien</en> et <en ref="18" >philosophe</en>. - Premier secrétaire de la Société philosophique de Dublin (en 1684) [http://data.bnf.fr/ark:/12148/cb124596616#foaf:Person]
</ud>
<ud>
Jean-Mathieu de Chazelles (<en type="li">Lyon</en>, <dat when="1657">1657</dat>) <en ref="1636" >Cartographe</en>, <en ref="29" >géographe</en> et <en ref="24" >astronome</en> associé à l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb106281104#foaf:Person]
</ud>
<ud>
Jean-Matthieu de Chazelles (<en type="li">Lyon</en>, <dat when="1657">1657</dat>) Fit ses études chez les jésuites et devint l''auxiliaire de Cassini I. Fut associé aux travaux géodésiques menés par l''Académie des sciences. Dessina le planisphère de l''Observatoire. Collabora au Neptune françois. Associé <en ref="24" >astronome</en> de l''Académie des sciences en 1695; associé mécanicien en 1699. Professeur d''hydrographie à Marseille [http://data.bnf.fr/ark:/12148/cb15304334g#foaf:Person]
</ud>
<ud>
Joseph Saurin (<en type="li">Courthézon (Vaucluse)</en>, <dat when="1659">1659</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb10330722j#foaf:Person]
</ud>
<ud>
Philippe Desplaces (<dat when="1659">1659</dat>) <en ref="24" >Astronome</en>. - Auteur d''éphémérides [http://data.bnf.fr/ark:/12148/cb12223720g#foaf:Person]
</ud>
<ud>
Louis Feuillée (Mane (Alpes-de-Haute-Provence), <dat when="1660">1660</dat>) <en ref="24" >Astronome</en> et botaniste. - Religieux de l''ordre des Minimes. - Initié à la botanique par le P. Plumier. Correspondant <en ref="24" >astronome</en> de l''Académie des sciences, il obtient une mission dans le Levant. Revenu à Marseille en 1702, il embarque l''année suivante pour les Antilles et parvient à Carthagène en 1704. Nommé <en ref="16" >mathématicien</en> du roi, il s''embarque pour l''Amérique du Sud en 1707. En 1724, il est chargé de déterminer la position exacte de l''île de Fer [http://data.bnf.fr/ark:/12148/cb15309142r#foaf:Person]
</ud>
<ud>
Thomas Fantet de Lagny (<en type="li">Lyon (Rhône)</en>, <dat when="1660">1660</dat>) <en ref="16" >Mathématicien</en>. - Professeur [http://data.bnf.fr/ark:/12148/cb14548143w#foaf:Person]
</ud>
<ud>
Guillaume-François-Antoine de L''Hospital (<dat when="1661">1661</dat>) Marquis de Sainte-Mesme. - <en ref="16" >Mathématicien</en>, membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb12000655c#foaf:Person]
</ud>
<ud>
Francesco Bianchini (<en type="li">Vérone, Italie</en>, <dat when="1662">1662</dat>) <en ref="1629" >Théologien</en>, historien, <en ref="24" >astronome</en> et <en ref="1630" >physicien</en> [http://data.bnf.fr/ark:/12148/cb12452255g#foaf:Person]
</ud>
<ud>
Paolo Mattia Doria (<dat when="1662">1662</dat>) <en ref="18" >Philosophe</en> et <en ref="16" >mathématicien</en> italien [http://data.bnf.fr/ark:/12148/cb121118306#foaf:Person]
</ud>
<ud>
Jean-Pierre de Crousaz (<dat when="1663">1663</dat>) <in ana="1621">Professeur de philosophie et mathématiques à Lausanne et Groningue</in>. - Conseiller de la légation de Suède en Hollande. - Membre des Académies de Bordeaux et Paris [http://data.bnf.fr/ark:/12148/cb12016566d#foaf:Person]
</ud>
<ud>
Johann Balthasar Lauterbach (<dat when="1663">1663</dat>) <en ref="16" >Mathématicien</en> et <en ref="1635" >architecte</en> allemand [http://data.bnf.fr/ark:/12148/cb137778333#foaf:Person]
</ud>
<ud>
John Craig (<dat when="1663">1663</dat>) <en ref="16" >Mathématicien</en> et <en ref="1629" >théologien</en> écossais [http://data.bnf.fr/ark:/12148/cb114408210#foaf:Person]
</ud>
<ud>
Katahiro Takebe (<dat when="1664">1664</dat>) <en ref="16" >Mathématicien</en> japonais [http://data.bnf.fr/ark:/12148/cb12443517s#foaf:Person]
</ud>
<ud>
Lothar Zumbach von Coesfeld (<en type="li">Trèves (Allemagne)</en>, <dat when="1664">1664</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en>, <en ref="28" >médecin</en>, musicien. - <en ref="16" >Mathématicien</en> et musicien de l''électeur de Trèves (1685-1688). - Lecteur en astronomie à l''université de Leyde. - <in ana="1621">Professeur de mathématiques au Carolinum de Kassel</in> [http://data.bnf.fr/ark:/12148/cb14853628w#foaf:Person]
</ud>
<ud>
Abraham de Moivre (Vitry-le-François (<en type="li">Marne)</en>, <dat when="1667">1667</dat>) <en ref="16" >Mathématicien</en>. - Émigra en Grande-Bretagne après la révocation de l''Édit de Nantes (en 1686). - Membre de la Royal Society, de l''Académie de Berlin et de l''Académie de Saint-Pétersbourg [http://data.bnf.fr/ark:/12148/cb130110001#foaf:Person]
</ud>
<ud>
Girolamo Saccheri (<en type="li">San Remo, Italie</en>, <dat when="1667">1667</dat>) Jésuite. - <in ana="1621">Professeur de mathématiques</in> [http://data.bnf.fr/ark:/12148/cb13164455b#foaf:Person]
</ud>
<ud>
Johann Bernoulli (<en type="li">Bâle, Suisse</en>, <dat when="1667">1667</dat>) <en ref="16" >Mathématicien</en> et <en ref="1630" >physicien</en>, maître d''Euler, professeur à l''Université de Groningue puis à l''Université de Bâle. - A travaillé sur le calcul différentiel, intégral et exponentiel. - Également auteur de traités de <en ref="28" >médecin</en>e, fondateur de la théorie mécanico-physique de la fermentation [http://data.bnf.fr/ark:/12148/cb122991692#foaf:Person]
</ud>
<ud>
William Whiston (Norton-juxta-Twycross (G. B.), <dat when="1667">1667</dat>) <en ref="1629" >Théologien</en> et <en ref="24" >astronome</en>. - Professeur de mathématiques à Cambridge, d''où il fut exclu pour ses écrits théologiques. - Traducteur de Flavius Josèphe [http://data.bnf.fr/ark:/12148/cb11997914k#foaf:Person]
</ud>
<ud>
Guillaume Bonjour (Toulouse (Haute-Garonne), <dat when="1669">1669</dat>) Augustin. - Missionnaire en Chine. - Orientaliste, <en ref="24" >astronome</en> et <en ref="1636" >cartographe</en> [http://data.bnf.fr/ark:/12148/cb13613529n#foaf:Person]
</ud>
<ud>
Leonhard Christoph Sturm (<en type="li">Aldorf, Allemagne</en>, <dat when="1669">1669</dat>) <en ref="16" >Mathématicien</en>. - <en ref="1635" >Architecte</en> [http://data.bnf.fr/ark:/12148/cb143383238#foaf:Person]
</ud>
<ud>
Jean Terrasson (<en type="li">Lyon</en>, <dat when="1670">1670</dat>) Oratorien, <en ref="16" >mathématicien</en> et <en ref="18" >philosophe</en>. - <in ana="1621">Professeur de grec et latin au Collège de France</in>. - Membre de l''Institut, Académie Française (élu en 1732) [http://data.bnf.fr/ark:/12148/cb119262217#foaf:Person]
</ud>
<ud>
Guido Grandi (<en type="li">Crémone, Italie</en>, <dat when="1671">1671</dat>) <en ref="16" >Mathématicien</en>, <en ref="1629" >théologien</en>, biographe, antiquaire et poète. - Soutint Descartes contre l''aristotélisme. - Professeur de philosophie à l''Université de Pise. - Fut en correspondance avec Leibniz, Newton, Bernoulli. - Intendant général des eaux en Toscane [http://data.bnf.fr/ark:/12148/cb121384290#foaf:Person]
</ud>
<ud>
Johann Gabriel Doppelmayr (<dat when="1671">1671</dat>) Fils d''un riche négociant qui s''occupait de physique, et destiné d''abord à l''étude du droit, il la quitta pour celle des mathématiques et voyagea jusqu''en 1702. Professeur à Nuremberg et membre de la Royal Society de Londres [http://data.bnf.fr/ark:/12148/cb15327296w#foaf:Person]
</ud>
<ud>
Johann Gabriel Doppelmayr (<dat when="1671">1671</dat>) <en ref="16" >Mathématicien</en>. - Membre de la Royal Society de Londres (<dat when="1713">1713</dat>) [http://data.bnf.fr/ark:/12148/cb12158680q#foaf:Person]
</ud>
<ud>
Johann Gabriel Doppelmayr (<dat when="1671">1671</dat>) <en ref="24" >Astronome</en> et <en ref="1636" >cartographe</en> ayant véçu à Nuremberg, né en 1671 ou 1677 [http://data.bnf.fr/ark:/12148/cb15327296w#foaf:Person]
</ud>
<ud>
Johann Heinrich Müller (<dat when="1671">1671</dat>) <en ref="1630" >Physicien</en>, <en ref="24" >astronome</en>, <en ref="16" >mathématicien</en>. - Professeur à l''université d''Altdorf (Allemagne) [http://data.bnf.fr/ark:/12148/cb10706008k#foaf:Person]
</ud>
<ud>
John Keill (<dat when="1671">1671</dat>) <en ref="16" >Mathématicien</en> écossais. - Professeur d''astronomie à Oxford [http://data.bnf.fr/ark:/12148/cb123670586#foaf:Person]
</ud>
<ud>
Étienne-Simon de Gamaches (<dat when="1672">1672</dat>) <en ref="24" >Astronome</en> et moraliste. - Chanoine de Sainte Croix de La Bretonnerie. - Membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb12004341t#foaf:Person]
</ud>
<ud>
Johann Jacob Scheuchzer (<en type="li">Zürich</en>, <dat when="1672">1672</dat>) <en ref="28" >Médecin</en>, naturaliste, historien, archéologue, numismate, <en ref="24" >astronome</en> et <en ref="1630" >physicien</en> [http://data.bnf.fr/ark:/12148/cb123955592#foaf:Person]
</ud>
<ud>
Eustachio Manfredi (<dat when="1674">1674</dat>) <en ref="24" >Astronome</en>. - Poète. - Fondateur de l''Académie de Bologne [http://data.bnf.fr/ark:/12148/cb12202194q#foaf:Person]
</ud>
<ud>
Julien Mahuet (<dat when="1674">1674</dat>) Jésuite. - Né à Reims. Entre au noviciat le 24 août 1692. Enseigne les humanités à Reims, la rhétorique à Metz et les mathématiques à Reims. - Écrit du théâtre pour le Collège de Reims [http://data.bnf.fr/ark:/12148/cb13165624v#foaf:Person]
</ud>
<ud>
Guillaume Delisle (<dat when="1675">1675</dat>) <en ref="1636" >Cartographe</en>. - Fils de Claude Delisle, fut l''élève de Jean-Dominique Cassini. Élève <en ref="24" >astronome</en> à l''Académie des sciences en 1702, il en devint membre en 1718 ; enseigna la géographie au jeune Louis XV et fut nommé premier <en ref="29" >géographe</en> du roi ; produisit quelque 100 cartes qu''il édita lui-même [http://data.bnf.fr/ark:/12148/cb15238363g#foaf:Person]
</ud>
<ud>
Humphry Ditton (Salisbury (G. B.), <dat when="1675">1675</dat>) <en ref="16" >Mathématicien</en> et <en ref="1629" >théologien</en> [http://data.bnf.fr/ark:/12148/cb15994181b#foaf:Person]
</ud>
<ud>
Yves-Marie André (<dat when="1675">1675</dat>) Jésuite. - <in ana="1621">Professeur de mathématiques à Caen</in> [http://data.bnf.fr/ark:/12148/cb12180932c#foaf:Person]
</ud>
<ud>
Jacopo Francesco Riccati (<dat when="1676">1676</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb120689750#foaf:Person]
</ud>
<ud>
Gabriel Philippe de La Hire (<en type="li">Paris</en>, <dat when="1677">1677</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb106522995#foaf:Person]
</ud>
<ud>
Jacques Cassini (<en type="li">Paris</en>, <dat when="1677">1677</dat>) Fils de Jean-Dominique Cassini et père de César-François Cassini de Thury. Associé <en ref="24" >astronome</en> à l''Académie des sciences en 1699, pensionnaire en 1712. En 1700 participa à la mesure de la méridienne de l''Observatoire et y travailla jusqu''à son achèvement en 1718. En 1706 maître ordinaire à la Chambre des comptes. Etudia les planètes et leurs satellites. Soutint la thèse de l''allongement de la Terre aux pôles. [http://data.bnf.fr/ark:/12148/cb15238366h#foaf:Person]
</ud>
<ud>
Joseph Privat de Molières (Tarascon (ouches-du-Rhône), <dat when="1677">1677</dat>) <en ref="1630" >Physicien</en> et <en ref="16" >mathématicien</en>. - Oratorien (vers 1709). - Professeur au collège royal (<dat when="1723">1723</dat>). - Adjoint (<dat when="1721">1721</dat>) puis associé (<dat when="1729">1729</dat>) de l''Académie royale des sciences [http://data.bnf.fr/ark:/12148/cb145391041#foaf:Person]
</ud>
<ud>
Gerard Keulen (<dat when="1678">1678</dat>) Graveur, <en ref="1636" >cartographe</en>, <en ref="16" >mathématicien</en> et éditeur. - Fils de Johannes van Keulen [http://data.bnf.fr/ark:/12148/cb15332761m#foaf:Person]
</ud>
<ud>
Jacob Hermann (<dat when="1678">1678</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12319998c#foaf:Person]
</ud>
<ud>
Jean-Jacques Dortous de Mairan (<en type="li">Béziers</en>, <dat when="1678">1678</dat>) <en ref="1630" >Physicien</en> et <en ref="16" >mathématicien</en>. - Membre puis secrétaire perpétuel de l''Académie des sciences. - Membre de l''Académie française (élu en 1743) [http://data.bnf.fr/ark:/12148/cb12395086k#foaf:Person]
</ud>
<ud>
Louis Bourguet (<en type="li">Nïmes</en>, <dat when="1678">1678</dat>) <in ana="1621">Professeur de philosophie et de mathématiques à Neuchâtel</in>. - Est l''un des fondateurs de la "Bibliothèque italique" (1728-) et du "Mercure suisse" (1732-). - Naturalisé Neuchâtelois en 1710 [http://data.bnf.fr/ark:/12148/cb12797692b#foaf:Person]
</ud>
<ud>
Pierre Rémond de Montmort (<en type="li">Paris</en>, <dat when="1678">1678</dat>) <en ref="16" >Mathématicien</en>. - Spécialiste de probabilités [http://data.bnf.fr/ark:/12148/cb12391046c#foaf:Person]
</ud>
<ud>
Bernardino Zendrini (<en type="li">Saviore, Italie</en>, <dat when="1679">1679</dat>) <en ref="28" >Médecin</en>. - <en ref="16" >Mathématicien</en>. - Hydraulicien [http://data.bnf.fr/ark:/12148/cb13545066d#foaf:Person]
</ud>
<ud>
Christian Wolff (<en type="li">Breslau, Silésie (Wrocław, Pologne)</en>, <dat when="1679">1679</dat>) Juriste, <en ref="16" >mathématicien</en> et <en ref="18" >philosophe</en> [http://data.bnf.fr/ark:/12148/cb121387859#foaf:Person]
</ud>
<ud>
Firmin Abauzit (<en type="li">Uzès</en>, <dat when="1679">1679</dat>) <en ref="16" >Mathématicien</en>, <en ref="18" >philosophe</en> et bibliothécaire. - Fut bibliothécaire à la Bibliothèque de Genève. - Vécut à Genève après la révocation de l''Édit de Nantes [http://data.bnf.fr/ark:/12148/cb121711117#foaf:Person]
</ud>
<ud>
Claude Richer (<dat when="1680">1680</dat>) Abbé. - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12532604f#foaf:Person]
</ud>
<ud>
Pierre Jartoux (<dat when="1680">1680</dat>) <en ref="24" >Astronome</en> et missionnaire jésuite en Chine [http://data.bnf.fr/ark:/12148/cb15367486z#foaf:Person]
</ud>
<ud>
Paolino Chelucci (<en type="li">Lucca, Italie</en>, <dat when="1681">1681</dat>) Professeur d''éloquence à l''Université de Rome. - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb104300443#foaf:Person]
</ud>
<ud>
Roger Cotes (<en type="li">Burbage (Leicestershire)</en>, <dat when="1682">1682</dat>) <en ref="16" >Mathématicien</en>. - Professeur d''astronomie et de philosophie expérimentale au Trinity College, Cambridge (1707-). - A édité la seconde édition des "Principia" de Newton [http://data.bnf.fr/ark:/12148/cb123946202#foaf:Person]
</ud>
<ud>
Noël Regnault (<dat when="1683">1683</dat>) Jésuite. - <in ana="1621">Professeur de mathématiques et physique au collège de Paris</in> [http://data.bnf.fr/ark:/12148/cb12218681d#foaf:Person]
</ud>
<ud>
Johann Matthias Hase (<dat when="1684">1684</dat>) <en ref="29" >Géographe</en> et <en ref="1636" >cartographe</en> ; historien. - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb13007561v#foaf:Person]
</ud>
<ud>
Brook Taylor (<dat when="1685">1685</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12315365s#foaf:Person]
</ud>
<ud>
Giovanni Poleni (<en type="li">Venise, Italie</en>, <dat when="1685">1685</dat>) <en ref="1630" >Physicien</en>, <en ref="16" >mathématicien</en> et archéologue [http://data.bnf.fr/ark:/12148/cb12161210z#foaf:Person]
</ud>
<ud>
Jean-Edme Gallimard (<en type="li">Paris</en>, <dat when="1685">1685</dat>) <in ana="1621">Professeur de mathématiques</in> [http://data.bnf.fr/ark:/12148/cb120827146#foaf:Person]
</ud>
<ud>
Jai Singh (<en type="li">Amber (Rajasthan, Inde)</en>, <dat when="1686">1686</dat>) Mahārāja de Jaipur (Rajasthan, Inde) de 1699 à 1743. - Fondateur de la ville de Jaipur (en 1727). - Chef du clan rajput des Kachhwa. - Bâtisseur de cinq observatoires astronomiques (yantra) dans l''Inde du Nord, à Delhi, Jaipur, Mathura, Varanasi et Ujjain. - Publia des tables astronomiques. - Les dates biographiques (1688-1743) sont aussi parfois retenues [http://data.bnf.fr/ark:/12148/cb16578505b#foaf:Person]
</ud>
<ud>
Nicolas Bernoulli (<dat when="1687">1687</dat>) <en ref="16" >Mathématicien</en> et juriste suisse [http://data.bnf.fr/ark:/12148/cb13510346s#foaf:Person]
</ud>
<ud>
Robert Simson (<dat when="1687">1687</dat>) <en ref="16" >Mathématicien</en>. - A été professeur à l''Université de Glasgow, GB [http://data.bnf.fr/ark:/12148/cb12399224j#foaf:Person]
</ud>
<ud>
Joseph-Nicolas Delisle (<en type="li">Paris</en>, <dat when="1688">1688</dat>) <en ref="24" >Astronome</en>. - Il reçut l''enseignement de Cassini II. - <in ana="1621">Professeur de mathématiques au Collège de France</in> et <en ref="29" >géographe</en> de la marine. - Membre de l''Institut, Académie des sciences (<dat when="1714">1714</dat>). - Fondateur de l''École d''astronomie de Saint-Pétersbourg (à partir de 1725), a séjourné en Russie jusqu''en 1747 [http://data.bnf.fr/ark:/12148/cb12150746w#foaf:Person]
</ud>
<ud>
Louis-Bertrand Castel (<en type="li">Montpellier</en>, <dat when="1688">1688</dat>) Jésuite (<dat when="1703">1703</dat>). - <en ref="18" >Philosophe</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12462543h#foaf:Person]
</ud>
<ud>
Pierre Brumoy (<en type="li">Rouen</en>, <dat when="1688">1688</dat>) Jésuite en 1704. - Professeur de rhétorique à Caen, précepteur du prince de Talmont, professeur de mathématiques au collège de Louis-le-Grand à Paris. - Collabore au Journal de Trévoux de 1722 à 1739. - Littérateur [http://data.bnf.fr/ark:/12148/cb12069382v#foaf:Person]
</ud>
<ud>
Willem Jacob''s Gravesande (<dat when="1688">1688</dat>) <en ref="1630" >Physicien</en>. - <en ref="18" >Philosophe</en>. - Professeur de mathématique et astronomie à Leyde, Pays-Bas. - Éditeur du "Journal littéraire de la Haye", devenu "Journal de la République des Lettres" [http://data.bnf.fr/ark:/12148/cb12218384m#foaf:Person]
</ud>
<ud>
Antoine Gaubil (<en type="li">Gaillac (Aveyron)</en>, <dat when="1689">1689</dat>) Jésuite et missionnaire en Chine. - Établit un observatoire à Pékin, dans la résidence française. - Écrit sur l''astronomie, la géographie, l''histoire et la littérature de la Chine [http://data.bnf.fr/ark:/12148/cb12150997b#foaf:Person]
</ud>
<ud>
Giovanni Gaetano Bottari (<en type="li">Rome</en>, <dat when="1689">1689</dat>) Savant prélat. - A étudié les langues et la littérature de l''Antiquité, les mathématiques, la philosophie et la théologie. - Membre de l''Académie della Crusca. - Conservateur de la bibliothèque du Vatican [http://data.bnf.fr/ark:/12148/cb12516784r#foaf:Person]
</ud>
<ud>
Robert Smith (<en type="li">Lea, GB</en>, <dat when="1689">1689</dat>) <in ana="1621">Professeur de mathématiques et de philosophie naturelle à Cambridge</in> [http://data.bnf.fr/ark:/12148/cb15075770m#foaf:Person]
</ud>
<ud>
Christian Goldbach (<dat when="1690">1690</dat>) <en ref="16" >Mathématicien</en> allemand [http://data.bnf.fr/ark:/12148/cb124384045#foaf:Person]
</ud>
<ud>
Johann Friedrich Weidler (Gros-Neuhausen, Allemagne, <dat when="1691">1691</dat>) Écrivain, <en ref="16" >mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb151541516#foaf:Person]
</ud>
<ud>
Esprit Pezenas (<en type="li">Avignon</en>, <dat when="1692">1692</dat>) Jésuite. - <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en>. - Professeur d''hydrographie à Marseille et directeur de l''Observatoire de Marseille (<dat when="1749">1749</dat>) [http://data.bnf.fr/ark:/12148/cb12120600p#foaf:Person]
</ud>
<ud>
James Stirling (<en type="li">Garden, GB</en>, <dat when="1692">1692</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb13475586v#foaf:Person]
</ud>
<ud>
Petrus Van Musschenbroek (<dat when="1692">1692</dat>) <en ref="1630" >Physicien</en>, docteur en <en ref="28" >médecin</en>e et en philosophie. - Fut l''inventeur de la pyrométrie. - Fut professeur de philosophie naturelle, de mathématiques et d''astronomie à l''Université d''Utrecht, puis professeur à Leiden [http://data.bnf.fr/ark:/12148/cb13475113j#foaf:Person]
</ud>
<ud>
Diego de Torres Villarroel (<dat when="1693">1693</dat>) Prêtre catholique. - Homme de lettres. - Professeur de mathématiques à l''université de Salamanque [http://data.bnf.fr/ark:/12148/cb119268467#foaf:Person]
</ud>
<ud>
Giovanni Bianchi (<en type="li">Rimini (Italie)</en>, <dat when="1693">1693</dat>) <en ref="28" >Médecin</en>. - Professeur d''anatomie à l''Université de Sienne (1741-). - Auteur d''ouvrages médicaux, archéologiques, astronomiques, etc. [http://data.bnf.fr/ark:/12148/cb10649342z#foaf:Person]
</ud>
<ud>
Christfried Kirch (<dat when="1694">1694</dat>) <en ref="24" >Astronome</en> allemand. - Il succéda à son père Gottfried (1639-1710) dans la direction de l''Observatoire royal de Prusse (1716-1740). - Membre de l''Académie des sciences de Berlin (<dat when="1716">1716</dat>) et associé de celles de Paris (<dat when="1723">1723</dat>) et de Saint-Pétersbourg [http://data.bnf.fr/ark:/12148/cb12648455m#foaf:Person]
</ud>
<ud>
Dominique-François Rivard (<dat when="1697">1697</dat>) <en ref="16" >Mathématicien</en>. - <en ref="18" >Philosophe</en>. - Professeur au collège de Beauvais [http://data.bnf.fr/ark:/12148/cb119220838#foaf:Person]
</ud>
<ud>
Abbé Deidier (<en type="li">Marseille</en>, <dat when="1698">1698</dat>) Abbé. - <en ref="16" >Mathématicien</en>. - Professeur d''artillerie à l''Ecole militaire de La Fère [http://data.bnf.fr/ark:/12148/cb102670411#foaf:Person]
</ud>
<ud>
Colin MacLaurin (<en type="li">Kilmodan, GB</en>, <dat when="1698">1698</dat>) <en ref="16" >Mathématicien</en> et <en ref="1630" >physicien</en> [http://data.bnf.fr/ark:/12148/cb12534513m#foaf:Person]
</ud>
<ud>
Pierre-Louis Moreau de Maupertuis (Saint-Malo, Ille-et-Villaine, <dat when="1698">1698</dat>) <en ref="18" >Philosophe</en>, <en ref="24" >astronome</en> et <en ref="1630" >physicien</en>. - Fut invité par Frédéric II à réorganiser puis présider l''Académie de Berlin. - Ami puis ennemi de Voltaire, qui écrivit contre lui "Micromégas". - Membre de l''Académie française (élu en 1743) [http://data.bnf.fr/ark:/12148/cb11915229j#foaf:Person]
</ud>
<ud>
Charles-Étienne-Louis Camus (Crécy-en-Brie (Seine-et-Marne), <dat when="1699">1699</dat>) <en ref="16" >Mathématicien</en>. - <en ref="24" >Astronome</en>. - Participa à l''expédition de 1736 en Laponie. - Membre de l''Académie des sciences (<dat when="1727">1727</dat>) et de l''Académie d''architecture (<dat when="1739">1739</dat>) [http://data.bnf.fr/ark:/12148/cb12181030f#foaf:Person]
</ud>
<ud>
Johann Ludwig Levin Gebhardi (<en type="li">Braunschweig, Allemagne</en>, <dat when="1699">1699</dat>) Historien, professeur de philologie à l''académie équestre de Lüneburg (<dat when="1723">1723</dat>). - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb143273694#foaf:Person]
</ud>
<ud>
Daniel Bernoulli (Groningue (Pays-Bas), <dat when="1700">1700</dat>) <en ref="16" >Mathématicien</en>, <en ref="1630" >physicien</en> et <en ref="24" >astronome</en>. - Fut professeur à Saint-Petersbourg (1725-1733) et à Bâle (1733-) [http://data.bnf.fr/ark:/12148/cb122991859#foaf:Person]
</ud>
<ud>
Sámuel Mikoviny (<en type="li">Ábelfalva, aujourd''hui Ábelová, Slovaquie</en>, <dat when="1700">1700</dat>) <en ref="1636" >Cartographe</en>. - Officier du génie. - Spécialiste en hydraulique. - <en ref="16" >Mathématicien</en>. - Disciple de Bél Mátyás (1684-1749). - Études à Jena et à Nuremberg, Allemagne [http://data.bnf.fr/ark:/12148/cb103650124#foaf:Person]
</ud>
<ud>
Anders Celsius (<dat when="1701">1701</dat>) <en ref="24" >Astronome</en> et naturaliste. - Professeur d''astronomie à l''université d''Uppsala (<dat when="1730">1730</dat>) [http://data.bnf.fr/ark:/12148/cb14606035v#foaf:Person]
</ud>
<ud>
Charles-Marie de La Condamine (<en type="li">Paris</en>, <dat when="1701">1701</dat>) Savant. - <en ref="24" >Astronome</en>. - <en ref="29" >Géographe</en>. Mesura l''arc du Méridien avec Godin et Bouguer. - Membre de l''Académie française (élu en 1760) [http://data.bnf.fr/ark:/12148/cb119102567#foaf:Person]
</ud>
<ud>
Georg Wolfgang Krafft (<en type="li">Tuttlingen (Allemagne)</en>, <dat when="1701">1701</dat>) <en ref="1630" >Physicien</en>, <in ana="1621">professeur de mathématiques et de physique</in> [http://data.bnf.fr/ark:/12148/cb10587905k#foaf:Person]
</ud>
<ud>
Johannes Nicolaus Frobesius (<en type="li">Goslar, Allemagne</en>, <dat when="1701">1701</dat>) <en ref="16" >Mathématicien</en> et <in ana="1621">professeur de philosophie</in> [http://data.bnf.fr/ark:/12148/cb12355199c#foaf:Person]
</ud>
<ud>
Niccolò de Martino (<dat when="1701">1701</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb16265590z#foaf:Person]
</ud>
<ud>
Johann Lorenz Schmidt (<dat when="1702">1702</dat>) Fils de pasteur, a étudié la théologie et s''est intéressé à la  philosophie et aux mathématiques. - A publié en 1735 une traduction annotée de la première partie de la Bible, les cinq livres de Moïse (ou Torah ou Pentateuque), connue sous le nom de "Wertheimer Bible", laquelle a été censurée par l''empereur [http://data.bnf.fr/ark:/12148/cb150701237#foaf:Person]
</ud>
<ud>
Antoine Deparcieux (<dat when="1703">1703</dat>) <en ref="16" >Mathématicien</en> et statisticien. - Fut constructeur de cadrans solaires et inventeur de machines pour élever les eaux et de presse pour le tabac. - Membre de l''Académie des sciences (<dat when="1746">1746</dat>) [http://data.bnf.fr/ark:/12148/cb121904326#foaf:Person]
</ud>
<ud>
Bernard-Laurent Soumille (<dat when="1703">1703</dat>) <en ref="16" >Mathématicien</en>, <en ref="1630" >physicien</en> et agronome. - Prêtre-bénéficier du chapitre de Villeneuve-lès-Avignon (à partir de 1736, environ). - Correspondant de l''Académie royale des sciences de Paris [http://data.bnf.fr/ark:/12148/cb130919156#foaf:Person]
</ud>
<ud>
Thomas Le Seur (<dat when="1703">1703</dat>) Franciscain. - Professeur de mathématique à l''Université de la Sapience (Rome) [http://data.bnf.fr/ark:/12148/cb155933751#foaf:Person]
</ud>
<ud>
Gabriel Cramer (<en type="li">Genève, Suisse</en>, <dat when="1704">1704</dat>) Professeur de philosophie et de mathématiques des Académies et Sociétés royales de Londres, de Berlin, de Montpellier, de Lyon et de l''Académie de l''Institut de Bologne [http://data.bnf.fr/ark:/12148/cb15006804w#foaf:Person]
</ud>
<ud>
Guillaume Le Blond (<en type="li">Paris</en>, <dat when="1704">1704</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb14330967m#foaf:Person]
</ud>
<ud>
Henri Michel Sauvage (<en type="li">Verdun</en>, <dat when="1704">1704</dat>) Jésuite. - Professeur d''humanités, de mathématiques et de philosophie [http://data.bnf.fr/ark:/12148/cb16180102s#foaf:Person]
</ud>
<ud>
Jacopo Belgrado (<dat when="1704">1704</dat>) Jésuite. - <en ref="1630" >Physicien</en>, <en ref="16" >mathématicien</en> et archéologue [http://data.bnf.fr/ark:/12148/cb12161284h#foaf:Person]
</ud>
<ud>
Johann Andreas von Segner (<dat when="1704">1704</dat>) Naturaliste, <en ref="16" >mathématicien</en>, <en ref="28" >médecin</en>, logicien, <en ref="18" >philosophe</en>. - Né à Presbourg (l''actuelle Bratislava), il fit toute sa carrière en Allemagne (à Iéna, Göttingen, Halle notamment) [http://data.bnf.fr/ark:/12148/cb12316478n#foaf:Person]
</ud>
<ud>
Louis Godin (<en type="li">Paris</en>, <dat when="1704">1704</dat>) <en ref="24" >Astronome</en>, membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb15004534h#foaf:Person]
</ud>
<ud>
John Nourse (<dat when="1705">1705</dat>) Variante(s) de prénom : Jean. - <en ref="1631" >Libraire</en> ; <en ref="1631" >libraire</en> (ordinaire) de Sa Majesté (<dat when="1762">1762</dat>) ; <en ref="1631" >libraire</en> de la "Society for the Encouragement of learning". - Baptisé à Oxford le 8 juillet 1705 ; fils d''un chirurgien. En apprentissage chez le <en ref="1631" >libraire</en> de Londres John I Osborne d''août 1722 à oct. 1729. Établi vers 1730. Succède au <en ref="1631" >libraire</en> William Mears après lui avoir été associé. Spécialiste des publications scientifiques, particulièrement de mathématiques, et des éditions étrangères, de <en ref="18" >philosophe</en>s notamment. Séjourne à Paris en 1780. Décédé à Kensington en avril 1765. Son frère Charles Nourse puis Francis Wingrave lui succèdent [http://data.bnf.fr/ark:/12148/cb13605346z#foaf:Person]
</ud>
<ud>
Edme-Gilles Guyot (<en type="li">Paris</en>, <dat when="1706">1706</dat>) Les ouvrages "Nouvelles récréations physiques et mathématiques" et "Essai sur la construction des ballons aérostatiques et sur la manière de les diriger" lui sont attribués par Hoefer et Quérard. - DBF et Michaud soulignent la confusion entre lui et Guillaume-Germain Guyot pour l''attribution de ces ouvrages [http://data.bnf.fr/ark:/12148/cb14651894d#foaf:Person]
</ud>
<ud>
Girolamo Settimo (<dat when="1706">1706</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb162655930#foaf:Person]
</ud>
<ud>
Giuseppe Maria Asclepi (<dat when="1706">1706</dat>) Jésuite, enseigna les mathématiques et les humanités [http://data.bnf.fr/ark:/12148/cb12240755t#foaf:Person]
</ud>
<ud>
Benjamin Robins (<en type="li">Bath, GB</en>, <dat when="1707">1707</dat>) <en ref="16" >Mathématicien</en> et <en ref="1633" >ingénieur</en> militaire. - Pamphlétaire [http://data.bnf.fr/ark:/12148/cb121289860#foaf:Person]
</ud>
<ud>
Francesco Ottavio Magnocavalli (<en type="li">Casale, Italie</en>, <dat when="1707">1707</dat>) <en ref="1635" >Architecte</en>, <en ref="16" >mathématicien</en> et poète [http://data.bnf.fr/ark:/12148/cb10732099c#foaf:Person]
</ud>
<ud>
Jean Paul Grandjean de Fouchy (<en type="li">Paris</en>, <dat when="1707">1707</dat>) <en ref="24" >Astronome</en>. - Secrétaire perpétuel de l''Académie des Sciences (<dat when="1743">1743</dat>) [http://data.bnf.fr/ark:/12148/cb10667779b#foaf:Person]
</ud>
<ud>
José Quiroga (<dat when="1707">1707</dat>) Jésuite, <en ref="16" >mathématicien</en> et pilote [http://data.bnf.fr/ark:/12148/cb12570261h#foaf:Person]
</ud>
<ud>
Leonhard Euler (<en type="li">Bâle (Suisse)</en>, <dat when="1707">1707</dat>) <en ref="16" >Mathématicien</en> et <en ref="1630" >physicien</en>. - <en ref="18" >Philosophe</en>, <en ref="1629" >théologien</en> et orientaliste. - Membre de l''Académie des sciences de Saint-Pétersbourg (à partir de 1733) et de celle de Berlin (à partir de 1741), et membre associé de celle de Paris (à partir de 1755) [http://data.bnf.fr/ark:/12148/cb12157666x#foaf:Person]
</ud>
<ud>
Giovanni Francesco Mauro Melchior Salvemini da Castiglione (<dat when="1708">1708</dat>) Professeur de mathématiques à Utrecht (<dat when="1751">1751</dat>) puis directeur de la classe de mathématiques de l''Académie de Berlin. - Découvrit la solution du problème consistant à inscrire dans un cercle un triangle dont les côtés passent par trois points donnés [http://data.bnf.fr/ark:/12148/cb130145422#foaf:Person]
</ud>
<ud>
Eustachio Zanotti (<en type="li">Bologne, Italie</en>, <dat when="1709">1709</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb12202196d#foaf:Person]
</ud>
<ud>
Giordano Riccati (<en type="li">Castelfranco Veneto, Italie</en>, <dat when="1709">1709</dat>) Comte. - <en ref="16" >Mathématicien</en>, acousticien et théoricien de la musique. - Fut aussi <en ref="1630" >physicien</en> et <en ref="1635" >architecte</en> [http://data.bnf.fr/ark:/12148/cb12252383n#foaf:Person]
</ud>
<ud>
Georg Matthias Bose (<en type="li">Leipzig (Allemagne)</en>, <dat when="1710">1710</dat>) <en ref="24" >Astronome</en>, <en ref="1630" >physicien</en>, <en ref="16" >mathématicien</en>. - Professeur de physique à l''université de Wittenberg [http://data.bnf.fr/ark:/12148/cb14065311n#foaf:Person]
</ud>
<ud>
Jacques Audierne (<dat when="1710">1710</dat>) Auteur comique et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb10425836p#foaf:Person]
</ud>
<ud>
Johann Bernoulli (<dat when="1710">1710</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb14852857s#foaf:Person]
</ud>
<ud>
Thomas Simpson (<dat when="1710">1710</dat>) Membre de la société royale de Londres, professeur de mathématiques à Woolwich (en 1755) [http://data.bnf.fr/ark:/12148/cb103759851#foaf:Person]
</ud>
<ud>
Alexandre-Gui Pingré (<en type="li">Paris</en>, <dat when="1711">1711</dat>) Génovéfain. - <en ref="24" >Astronome</en>. - Correspondant (à partir de 1753), puis associé libre de l''Académie des sciences. - <en ref="29" >Géographe</en> de la Marine. - Chancelier de l''Université de Paris (1769-17..). - Bibliothécaire de Sainte-Geneviève (à partir de 1792) [http://data.bnf.fr/ark:/12148/cb12151017m#foaf:Person]
</ud>
<ud>
François Jacquier (Vitry-le-François (<en type="li">Marne)</en>, <dat when="1711">1711</dat>) Religieux de l''ordre des Minimes. - <in ana="1621">Professeur de physique et mathématiques</in> [http://data.bnf.fr/ark:/12148/cb12198105d#foaf:Person]
</ud>
<ud>
Laura Bassi (<en type="li">Bologne, Italie</en>, <dat when="1711">1711</dat>) <en ref="16" >Mathématicien</en>ne et <en ref="1630" >physicien</en>ne. - Professeur de biologie et de physique à l''Université de Bologne. - Première femme titulaire d''une chaire universitaire en Europe [http://data.bnf.fr/ark:/12148/cb135103950#foaf:Person]
</ud>
<ud>
Ottaviano Cametti (<en type="li">Gattinara, Italie</en>, <dat when="1711">1711</dat>) <en ref="16" >Mathématicien</en>, <en ref="1630" >physicien</en> et historien [http://data.bnf.fr/ark:/12148/cb10464765k#foaf:Person]
</ud>
<ud>
Pierre Joseph de Rivaz (<dat when="1711">1711</dat>) <en ref="16" >Mathématicien</en>, inventeur-mécanicien et historien. - Directeur des salines de Moutiers. - Né dans le Valais et mort à Moutiers (Tarentaise) [http://data.bnf.fr/ark:/12148/cb128398731#foaf:Person]
</ud>
<ud>
Rugerius Josephus Boscovich (Raguse aujourd''hui Dubrovnik (<en type="li">Croatie)</en>, <dat when="1711">1711</dat>) Jésuite. - <en ref="1630" >Physicien</en>, <en ref="16" >mathématicien</en>, <en ref="24" >astronome</en> et <en ref="18" >philosophe</en>. - <in ana="1621">Professeur de mathématiques à Rome, Pavie et Milan</in>. - Directeur de l''optique de la Marine royale à Paris et membre de la "Royal Society" à Londres. - Dans son ouvrage majeur "Théorie de la philosophie naturelle" il élabore la théorie initiale des forces et de la structure fondamentale de la matière, dont les concepts ont trouvé écho dans les découvertes de la physique moderne. - Il publie nombre d''ouvrages contenant ses découvertes en mathématiques, en astronomie, en géophysique et en archéologie. - Il mit au point différents instruments optiques, astronomiques et géodésiques et réalisa des expertises et des mesures hydrotechniques, géodésiques, cartographiques et statiques. - Il consolida la coupole de la basilique Saint-Pierre de Rome et de la flèche de la cathédrale de Milan [http://data.bnf.fr/ark:/12148/cb12054879x#foaf:Person]
</ud>
<ud>
Jean-Paul de Gua de Malves (<en type="li">Malves (Aude)</en>, <dat when="1712">1712</dat>) Abbé. - <en ref="16" >Mathématicien</en>, géomètre, économiste politique. - Titulaire de la chaire de philosophie au Collège de France (1742-1749) [http://data.bnf.fr/ark:/12148/cb15325204x#foaf:Person]
</ud>
<ud>
Samuel König (<dat when="1712">1712</dat>) Date de mort : 21 août ou 22 juillet 1757. - A également écrit en français. - <en ref="16" >Mathématicien</en>, <en ref="18" >philosophe</en> et juriste [http://data.bnf.fr/ark:/12148/cb120941298#foaf:Person]
</ud>
<ud>
Alexis Claude Clairaut (<en type="li">Paris (France)</en>, <dat when="1713">1713</dat>) <en ref="16" >Mathématicien</en> très précoce et <en ref="24" >astronome</en>. - Ami de Voltaire et de la marquise Du Chatelet [http://data.bnf.fr/ark:/12148/cb124002538#foaf:Person]
</ud>
<ud>
Giammaria Ortes (<dat when="1713">1713</dat>) Moine camaldule. - <en ref="16" >Mathématicien</en>, économiste et <en ref="18" >philosophe</en> [http://data.bnf.fr/ark:/12148/cb13753557w#foaf:Person]
</ud>
<ud>
Nicolas-Louis de La Caille (<en type="li">Rumigny, Ardennes</en>, <dat when="1713">1713</dat>) Abbé. - <in ana="1621">Professeur de mathématiques au Collège Mazarin</in>. - Membre de l''Académie royale des sciences [http://data.bnf.fr/ark:/12148/cb12124353d#foaf:Person]
</ud>
<ud>
Alessandro Vittorio Papacino d''Antoni (<en type="li">Villafranca, Italie</en>, <dat when="1714">1714</dat>) <en ref="1633" >Ingénieur</en>, <en ref="16" >mathématicien</en>. - Membre de l''Académie des sciences de Turin [http://data.bnf.fr/ark:/12148/cb10709482t#foaf:Person]
</ud>
<ud>
César-François Cassini de Thury (Thury-sous-Clermont (<en type="li">Oise)</en>, <dat when="1714">1714</dat>) <en ref="24" >Astronome</en> et géomètre. - Membre de l''Académie des sciences (<dat when="1736">1736</dat>). - Fils de Jacques Cassini (1677-1756) et père de Jean-Dominique Cassini (1748-1845). - Participa avec son père à la mesure de la perpendiculaire de l''Observatoire. - Son oeuvre principale est la carte de France, première carte de base de ce pays, dont la publication commença en 1756 [http://data.bnf.fr/ark:/12148/cb12241101g#foaf:Person]
</ud>
<ud>
Giovanni Battista Audiffredi (<en type="li">Saorge, Italie</en>, <dat when="1714">1714</dat>) Dominicain. - <en ref="24" >Astronome</en>. - Préfet de la Biblioteca Casanatense, Rome (1759-1794). - Né Giulio Cesare Audiffredi, change de prénom en entrant chez les Dominicains (<dat when="1730">1730</dat>) [http://data.bnf.fr/ark:/12148/cb13595556h#foaf:Person]
</ud>
<ud>
John Winthrop (<dat when="1714">1714</dat>) <in ana="1621">Professeur de Mathématiques et de Philosophie naturelle à Harvard</in> [http://data.bnf.fr/ark:/12148/cb14594660x#foaf:Person]
</ud>
<ud>
François-Joachim Duport-Dutertre (Saint-Servan (Ille-et-Vilaine), <dat when="1715">1715</dat>) Littérateur. - <en ref="16" >Mathématicien</en>. - Voyageur [http://data.bnf.fr/ark:/12148/cb12533121w#foaf:Person]
</ud>
<ud>
Pierre-Charles Le Monnier (<en type="li">Paris</en>, <dat when="1715">1715</dat>) <en ref="24" >Astronome</en>. - Membre de l''Académie des sciences (<dat when="1741">1741</dat>). - Professeur de physique au Collège de France (de 1749 à 1793), puis membre de la classe des sciences physiques et mathématiques de l''Institut [http://data.bnf.fr/ark:/12148/cb121064574#foaf:Person]
</ud>
<ud>
André-Pierre Le Guay de Prémontval (Charenton (Val-de-Marne), <dat when="1716">1716</dat>) <in ana="1621">Professeur de mathématiques</in>. - Membre de l''Académie de Berlin [http://data.bnf.fr/ark:/12148/cb122271303#foaf:Person]
</ud>
<ud>
Eugénios Voúlgaris (<en type="li">Corfou (Îles Ioniennes, Grèce)</en>, <dat when="1716">1716</dat>) Métropolite de l''Église orthodoxe grecque. - <en ref="1629" >Théologien</en>, <en ref="18" >philosophe</en> et <en ref="16" >mathématicien</en>. - "Éducateur de la Nation" et précurseur des Lumières en Grèce ; traducteur de Voltaire et Virgile. - Nommé évêque en Russie [http://data.bnf.fr/ark:/12148/cb12564304q#foaf:Person]
</ud>
<ud>
Gottfried Ploucquet (<dat when="1716">1716</dat>) <en ref="18" >Philosophe</en>, <en ref="16" >mathématicien</en> et <en ref="1629" >théologien</en>. - Professeur de philosophie à l''université de Tübingen (1750-1782) [http://data.bnf.fr/ark:/12148/cb13324024g#foaf:Person]
</ud>
<ud>
Leonardo Ximenes (<en type="li">Trapani, Italie</en>, <dat when="1716">1716</dat>) Jésuite. - Geographe, <en ref="24" >astronome</en>, <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb106577403#foaf:Person]
</ud>
<ud>
D'' Alembert (<en type="li">Paris</en>, <dat when="1717">1717</dat>) <en ref="16" >Mathématicien</en> et <en ref="18" >philosophe</en>. - Nom patronymique : Jean Le Rond, d̲i̲t̲ d'' Alembert. - Membre de l''Institut, Académie française (élu en 1754) [http://data.bnf.fr/ark:/12148/cb118883708#foaf:Person]
</ud>
<ud>
Josef Anton Nagel (<dat when="1717">1717</dat>) Professeur, <en ref="16" >mathématicien</en>, scientifique allemand [http://data.bnf.fr/ark:/12148/cb12091922b#foaf:Person]
</ud>
<ud>
Augustin Darquier de Pellepoix (<en type="li">Toulouse</en>, <dat when="1718">1718</dat>) <en ref="24" >Astronome</en>. - Associé non résidant de l''Académie des sciences. - Receveur des tailles de la généralité d''Auch [http://data.bnf.fr/ark:/12148/cb12155190x#foaf:Person]
</ud>
<ud>
Claude-François Berthelot (<dat when="1718">1718</dat>) <en ref="1633" >Ingénieur</en>. - Professeur de mathématiques à l''École royale militaire. - Inventeur de l''"affut de Gribeauval" [http://data.bnf.fr/ark:/12148/cb134984423#foaf:Person]
</ud>
<ud>
François-César Le Tellier Courtanvaux (<dat when="1718">1718</dat>) Duc de Doudeauville. - Capitaine-colonel des cent-suisses de la garde du roi. - <en ref="24" >Astronome</en>, membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb121904446#foaf:Person]
</ud>
<ud>
Gaspard-François-Anne de Forbin (<dat when="1718">1718</dat>) Né le 8 ou le 18 juillet 1718. - Embrassa d'' abord la carrière militaire. - Chevalier de Malte. - <en ref="16" >Mathématicien</en> et <en ref="1630" >Physicien</en> [http://data.bnf.fr/ark:/12148/cb12108181n#foaf:Person]
</ud>
<ud>
István Hatvani (<en type="li">Rimaszombat, aujourd''hui Rimavská Sobota, Slovaquie</en>, <dat when="1718">1718</dat>) <en ref="16" >Mathématicien</en>, <en ref="1630" >physicien</en>. - <en ref="28" >Médecin</en>. - Pédagogue, <in ana="1621">professeur à Debrecen,Református Kollégium, Hongrie.</in> - Diplômé de l''Université de Bâle, Suisse [http://data.bnf.fr/ark:/12148/cb10355679v#foaf:Person]
</ud>
<ud>
Jean-Philippe Loys de Chéseaux (<dat when="1718">1718</dat>) <en ref="24" >Astronome</en> et <en ref="1630" >physicien</en>. - Né à Lausanne, mort à Paris [http://data.bnf.fr/ark:/12148/cb133196302#foaf:Person]
</ud>
<ud>
Joseph Amiot (<en type="li">Toulon</en>, <dat when="1718">1718</dat>) Jésuite de 1737 à 1773 (ordonné prêtre en 1749). - Sinologue et <en ref="24" >astronome</en>. - Missionnaire en Chine (à partir de 1749) [http://data.bnf.fr/ark:/12148/cb12112654w#foaf:Person]
</ud>
<ud>
Maria Gaetana Agnesi (<en type="li">Milan, Italie</en>, <dat when="1718">1718</dat>) <en ref="16" >Mathématicien</en>ne [http://data.bnf.fr/ark:/12148/cb105423187#foaf:Person]
</ud>
<ud>
Abraham Gotthelf Kästner (<en type="li">Leipzig, Allemagne</en>, <dat when="1719">1719</dat>) <en ref="16" >Mathématicien</en>. - Poète et épigrammatiste. - Critique [http://data.bnf.fr/ark:/12148/cb123392338#foaf:Person]
</ud>
<ud>
Giuseppe Toaldo (<en type="li">Pianezze, Italie</en>, <dat when="1719">1719</dat>) Prêtre. - <en ref="1630" >Physicien</en>. - Professeur d''astronomie, de géographie et de météorologie à l''Université de Padoue [http://data.bnf.fr/ark:/12148/cb10578331h#foaf:Person]
</ud>
<ud>
Jens Kraft (<dat when="1720">1720</dat>) <en ref="18" >Philosophe</en> des lumières danois. - <in ana="1621">Professeur de mathématiques et de philosophie à Soroe</in> [http://data.bnf.fr/ark:/12148/cb12442689p#foaf:Person]
</ud>
<ud>
Charles Walmesley (<dat when="1722">1722</dat>) Évêque de Rama. - <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb10748264x#foaf:Person]
</ud>
<ud>
Jean Chappe d''Auteroche (<en type="li">Mauriac (Cantal)</en>, <dat when="1722">1722</dat>) <en ref="24" >Astronome</en>. - Explorateur en Sibérie et en Californie [http://data.bnf.fr/ark:/12148/cb12402595h#foaf:Person]
</ud>
<ud>
Jean-Louis Dupain-Triel (<dat when="1722">1722</dat>) Homme de lettres, poète. - S''intéressa aux mathématiques, à la géographie et à l''enseignement des arts [http://data.bnf.fr/ark:/12148/cb119011560#foaf:Person]
</ud>
<ud>
Louis-Jacques Goussier (<dat when="1722">1722</dat>) <en ref="16" >Mathématicien</en> et inventeur [http://data.bnf.fr/ark:/12148/cb13485055d#foaf:Person]
</ud>
<ud>
Baien Miura (<dat when="1723">1723</dat>) Lettré du milieu de l''époque d''Edo. - A créé son propre système de pensée philosophique appelé "jōrigaku" : méthode de spéculation fondée sur l''éthique, la logique, les mathématiques et la physique, recourant à une pensée dialectique appelée "hankan gōitsu" [http://data.bnf.fr/ark:/12148/cb12293200x#foaf:Person]
</ud>
<ud>
Didier Robert de Vaugondy (<dat when="1723">1723</dat>) <en ref="29" >Géographe</en> ordinaire du roi, <in ana="1621">professeur de mathématiques et de géographie, fils de Gilles Robert Vaugondy</in>. - Didier signe "Robert de Vaugondy" [http://data.bnf.fr/ark:/12148/cb12380757h#foaf:Person]
</ud>
<ud>
Étienne-Nicolas Blondeau (<dat when="1723">1723</dat>) <in ana="1621">Professeur de mathématiques</in>. - <en ref="1633" >Ingénieur</en> de la marine. - Collaborateur de l''Encyclopédie méthodique (1782-1783?) [http://data.bnf.fr/ark:/12148/cb10737141j#foaf:Person]
</ud>
<ud>
Johann Tobias Mayer (<dat when="1723">1723</dat>) <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en>, a travaillé avec Homann Herben de 1746 à 1751, puid pour Kilian à partir de 1752 [http://data.bnf.fr/ark:/12148/cb153509764#foaf:Person]
</ud>
<ud>
Johann Tobias Mayer (<dat when="1723">1723</dat>) <en ref="24" >Astronome</en> allemand [http://data.bnf.fr/ark:/12148/cb11958863x#foaf:Person]
</ud>
<ud>
Nicole-Reine Lepaute (<en type="li">Paris</en>, <dat when="1723">1723</dat>) Née Nicole-Reine Étable de La Brière, épouse de Jean-André Lepaute, horloger du Roi. - <en ref="16" >Mathématicien</en>ne, <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb14555447k#foaf:Person]
</ud>
<ud>
Tobias Mayer (<en type="li">Marbach (Allemagne)</en>, <dat when="1723">1723</dat>) <en ref="24" >Astronome</en>, <en ref="16" >mathématicien</en>. - Directeur de l''Observatoire de Göttingen, Allemagne [http://data.bnf.fr/ark:/12148/cb121551484#foaf:Person]
</ud>
<ud>
Edme-Sébastien Jeaurat (<dat when="1724">1724</dat>) <en ref="1633" >Ingénieur</en>-<en ref="29" >géographe</en> et <en ref="24" >astronome</en>. - <in ana="1621">Professeur à l''école militaire.</in> - Membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb122175393#foaf:Person]
</ud>
<ud>
François Para Du Phanjas (Chabottes (Hautes-Alpes), <dat when="1724">1724</dat>) <en ref="18" >Philosophe</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12528863r#foaf:Person]
</ud>
<ud>
Georges Louis Lesage (<en type="li">Genève</en>, <dat when="1724">1724</dat>) <en ref="16" >Mathématicien</en> et <en ref="1630" >physicien</en> suisse. - Etudie à Genève puis Paris. - Etabli à Genève [http://data.bnf.fr/ark:/12148/cb155857475#foaf:Person]
</ud>
<ud>
Guillaume-Germain Guyot (<en type="li">Orléans</en>, <dat when="1724">1724</dat>) Les ouvrages "Nouvelles récréations physiques et mathématiques" et "Essai sur la construction des ballons aérostatiques et sur la manière de les diriger" lui sont attribués par le DBF et par Samuel Ersch dans "La France littéraire contenant les auteurs français de 1771 à 1796", DBF. - Quérard et Michaud soulignent la confusion entre lui et Edme-Gilles Guyot pour l''attribution de ces ouvrages [http://data.bnf.fr/ark:/12148/cb12214218k#foaf:Person]
</ud>
<ud>
Guillaume-Hyacinthe-Joseph-Jean-Baptiste Le Gentil de La Galaisière (<dat when="1725">1725</dat>) <en ref="24" >Astronome</en> et voyageur. - Entre à l''Observatoire en 1750. - Membre de l''Académie des sciences en 1753 [http://data.bnf.fr/ark:/12148/cb12151459n#foaf:Person]
</ud>
<ud>
Jean-Étienne Montucla (<dat when="1725">1725</dat>) Historien des mathématiques [http://data.bnf.fr/ark:/12148/cb12127574n#foaf:Person]
</ud>
<ud>
Louis-Charles Desnos (<dat when="1725">1725</dat>) <en ref="1631" >Libraire</en> ; <en ref="1631" >libraire</en> et (<en ref="1633" >ingénieur</en>) <en ref="29" >géographe</en> (pour les globes et les sphères) du roi de Danemark (ou : de Sa Majesté danoise) (1769-1789). - Fils d''un marchand drapier de Pont-Sainte-Maxence (Oise). Apprenti fondeur de caractères à Paris à partir d''avril 1745 (reçu maître fondeur en 1757).  <en ref="1633" >Ingénieur</en> <en ref="29" >géographe</en> (de la ville de Paris à partir de 1769), fabricant et marchand de sphères et d''instruments astronomiques établi vers 1753 en succession de Jacques Hardy, après avoir épousé en 1749 la veuve de son fils Nicolas Hardy ; également marchand d''estampes et de cartes géographiques. Un des 12 <en ref="1631" >libraire</en>s non jurés reçus le 4 oct. 1767. - Éditeur et auteur de nombreux atlas, almanachs et publications géographiques entre 1756 et 1795 env. Rédige également plusieurs catalogues de son fonds entre 1768 et 1792. Une partie de son fonds est rachetée en 1805 par Jean (17..-1839), marchand de cartes et d''estampes [http://data.bnf.fr/ark:/12148/cb12402252d#foaf:Person]
</ud>
<ud>
Rigobert Bonne (Raucourt (Meurthe-et-Moselle), <dat when="1727">1727</dat>) <en ref="1633" >Ingénieur</en>. - <en ref="29" >Géographe</en>. - Hydrographe. - Célèbre par la projection qui porte son nom et qui remplacera pour la carte de France la projection de Cassini. D''abord <en ref="1633" >ingénieur</en> <en ref="29" >géographe</en> et maître de mathématiques. En 1775 <en ref="1633" >ingénieur</en> hydrographe de la Marine. Fut mis à la retraite contre sa volonté en 1789. Collabora au Neptune américo-septentrional [http://data.bnf.fr/ark:/12148/cb12169793s#foaf:Person]
</ud>
<ud>
Chrysologue de Gy (Gy (Haute-Saône), <dat when="1728">1728</dat>) Capucin. - <en ref="24" >Astronome</en>, <en ref="1636" >cartographe</en> et géologue [http://data.bnf.fr/ark:/12148/cb10728734z#foaf:Person]
</ud>
<ud>
Jean-Henri Lambert (<en type="li">Mulhouse, Suisse</en>, <dat when="1728">1728</dat>) <en ref="16" >Mathématicien</en>, <en ref="1630" >physicien</en>, <en ref="24" >astronome</en> et <en ref="18" >philosophe</en>. - Spécialiste de géometrie. - En poste à l''Académie royale des sciences et belles lettres de Berlin (de 1765 à 1777) [http://data.bnf.fr/ark:/12148/cb12359659g#foaf:Person]
</ud>
<ud>
Le P.  Chrysologue (<en type="li">Gy</en>, <dat when="1728">1728</dat>) Capucin, nom de religion de Noël André. - Attiré par la géographie et l''astronomie, fut l''élève de Lemonnier. Mesura les altitudes des Vosges, du Jura et des Alpes. Se retira dans sa famille au moment de la Révolution.  En 1806 publia un important traité de géologie dont Cuvier fit un rapport élogieux [http://data.bnf.fr/ark:/12148/cb153054042#foaf:Person]
</ud>
<ud>
Paolo Frisi (<en type="li">Melegnano, Italie</en>, <dat when="1728">1728</dat>) Barnabite. - <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en> et écrivain. - Professeur dans les Écoles palatines de Milan (1764-) [http://data.bnf.fr/ark:/12148/cb120849325#foaf:Person]
</ud>
<ud>
Antonio Eximeno (<dat when="1729">1729</dat>) Théoricien de la musique et polémiste. - Jésuite, il devient professeur de rhétorique à l''Université de Valence, puis professeur de mathématiques à l''Académie militaire de Ségovie (<dat when="1764">1764</dat>). - Lorsque les jésuites sont expulsés d''Espagne en 1767, il se rend à Rome où il étudie la musique. - Connu aussi sous le pseud. : "Aristosseno Megareo" (BnF, Musique, fichier général auteurs), ou "Aristodemo Megareo" (Fétis) [http://data.bnf.fr/ark:/12148/cb13755053m#foaf:Person]
</ud>
<ud>
Charles Bossut (<dat when="1730">1730</dat>) <en ref="16" >Mathématicien</en>, membre de l''Académie des sciences (<dat when="1779">1779</dat>), il participa à la rédaction de la partie mathématique de l''Encyclopédie [http://data.bnf.fr/ark:/12148/cb11763983g#foaf:Person]
</ud>
<ud>
Charles Bossut (<dat when="1730">1730</dat>) <en ref="16" >Mathématicien</en> et <en ref="1630" >physicien</en>. - Membre de l''Académie des sciences, pensionnaire de la classe de mécanique (<dat when="1785">1785</dat>). - Écrivit plusieurs articles dans l''"Encyclopédie" [http://data.bnf.fr/ark:/12148/cb124599882#foaf:Person]
</ud>
<ud>
Charles Messier (Badonviller (Meurthe-et-Moselle), <dat when="1730">1730</dat>) <en ref="24" >Astronome</en> de la marine. - Académicien (<dat when="1770">1770</dat>). - Membre de l''Institut [http://data.bnf.fr/ark:/12148/cb124827900#foaf:Person]
</ud>
<ud>
Étienne Bezout (<en type="li">Nemours</en>, <dat when="1730">1730</dat>) <en ref="16" >Mathématicien</en>. - Membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb12267459g#foaf:Person]
</ud>
<ud>
Jean-Baptiste de Laborde (<dat when="1730">1730</dat>) <en ref="1630" >Physicien</en> et <en ref="16" >mathématicien</en>. - Jésuite [http://data.bnf.fr/ark:/12148/cb13196726p#foaf:Person]
</ud>
<ud>
Joseph-Aignan Sigaud de La Fond (<en type="li">Bourges</en>, <dat when="1730">1730</dat>) <en ref="16" >Mathématicien</en>, <en ref="1630" >physicien</en> et moraliste. - <in ana="1621">Professeur de physique à Bourges</in> [http://data.bnf.fr/ark:/12148/cb12401095w#foaf:Person]
</ud>
<ud>
Pierre-Thomas Antelmy (<en type="li">Trigance, France</en>, <dat when="1730">1730</dat>) <en ref="16" >Mathématicien</en>, professeur de mathématiques à l''École militaire [http://data.bnf.fr/ark:/12148/cb13011110m#foaf:Person]
</ud>
<ud>
Benito Bails (<dat when="1731">1731</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb162593727#foaf:Person]
</ud>
<ud>
Girolamo Francisco Cristiani (<en type="li">Brescia, Italie</en>, <dat when="1731">1731</dat>) <en ref="16" >Mathématicien</en> et <en ref="1630" >physicien</en> [http://data.bnf.fr/ark:/12148/cb14065297x#foaf:Person]
</ud>
<ud>
Nicolas-Claude Duval-Le Roy (<dat when="1731">1731</dat>) Professeur de mathématiques et d''hydrographie, <en ref="1630" >physicien</en> et <en ref="24" >astronome</en>. - Membre de l''Académie royale de marine. - Correspondant à l''Académie royale des sciences (<dat when="1789">1789</dat>), associé non résident de l''Institut (<dat when="1796">1796</dat>) [http://data.bnf.fr/ark:/12148/cb12548660k#foaf:Person]
</ud>
<ud>
Diderich Christian Fester (<dat when="1732">1732</dat>) <en ref="16" >Mathématicien</en> et <en ref="1636" >cartographe</en> à Trondheim [http://data.bnf.fr/ark:/12148/cb15384550x#foaf:Person]
</ud>
<ud>
Jérôme de La Lande (Bourg-en-Bresse (<en type="li">Ain)</en>, <dat when="1732">1732</dat>) <en ref="24" >Astronome</en>. - Membre de l''Académie de Berlin. - Membre de l''Académie des sciences (<dat when="1753">1753</dat>). - Professeur d''astronomie au Collège de France (<dat when="1762">1762</dat>). - Directeur de l''Observatoire de Paris de 1768 à sa mort [http://data.bnf.fr/ark:/12148/cb12012398h#foaf:Person]
</ud>
<ud>
Maurille-Antoine Moithey (<dat when="1732">1732</dat>) Éditeur et marchand de cartes géographiques ; <en ref="1631" >libraire</en>. - <en ref="1633" >Ingénieur</en> <en ref="29" >géographe</en> du Roi et <in ana="1621">professeur de mathématiques des pages du prince et de la princesse de Conti</in>. Auteur de plans, de cartes, d''ouvrages illustrés et d''atlas, qu''il publie et diffuse parfois lui-même de 1776 à 1792 au moins. Auteur notamment d''un "Dictionnaire hydrographique de la France..." (1re éd., l''auteur, 1787 ; rééd., Paris, Blanchon, <dat when="1803">1803</dat>) et d''une série de "Recherches historiques" sur les villes de France (Angers, Orléans, Reims, 1775-1776). Se qualifie de <en ref="1631" >libraire</en> en 1791-1792. Décédé à Paris le 21 frimaire an XIV (12 déc. 1805, Arch. de Paris) [http://data.bnf.fr/ark:/12148/cb13531657x#foaf:Person]
</ud>
<ud>
Nevil Maskelyne (<dat when="1732">1732</dat>) <en ref="24" >Astronome</en> royal d''Angleterre. - Membre associé de l''Académie des sciences de Paris [http://data.bnf.fr/ark:/12148/cb12155150p#foaf:Person]
</ud>
<ud>
Jacques-François Dicquemare (<en type="li">Le Havre</en>, <dat when="1733">1733</dat>) <en ref="24" >Astronome</en>. - Hydrographe. - Zoologue marin [http://data.bnf.fr/ark:/12148/cb15317071s#foaf:Person]
</ud>
<ud>
János Sajnovics (<en type="li">Tordas, Hongrie</en>, <dat when="1733">1733</dat>) <en ref="24" >Astronome</en>. - Linguiste. - Père jésuite [http://data.bnf.fr/ark:/12148/cb12246417w#foaf:Person]
</ud>
<ud>
Jean-Charles Borda (<en type="li">Dax (Landes)</en>, <dat when="1733">1733</dat>) Officier de marine. - Membre de l''Académie de Marine (élu en 1769). - Entra dans le Génie militaire et se fit remarquer par ses travaux sur l''hydraulique. - Il détermina la longitude des Canaries (en 1776). - Prit part à la guerre d''indépendance américaine. - Participa avec Delambre et Méchain à la mesure de l''arc de méridien Dunkerque-Barcelone. - En qualité de commissaire de l''Académie des sciences participa à l''étude des montres marines sur la frégate la Flore (en 1771). - Membre de l''Institut, Académie des sciences (élu en 1772). - Membre de la Commission des poids et mesures (en 1791), il travailla à l''établissement du système métrique. - Membre de l''Institut national des sciences et arts, section mathématiques (actuel Institut de France) et du Bureau des longitudes (en 1795). - Co-fondateur de La Société de Borda (créée en 1876), avec Jacques-François de Borda d''Oro (1718-1804) [http://data.bnf.fr/ark:/12148/cb12482831r#foaf:Person]
</ud>
<ud>
Samuel Horsley (<dat when="1733">1733</dat>) Evêque; secrétaire de la Royal Society; publia des livres de théologie et de mathématiques [http://data.bnf.fr/ark:/12148/cb120697374#foaf:Person]
</ud>
<ud>
Achille Pierre Dionis du Séjour (<en type="li">Paris</en>, <dat when="1734">1734</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb10680537k#foaf:Person]
</ud>
<ud>
Baudouin de Guémadeuc (<dat when="1734">1734</dat>) Homme de loi, homme de lettres, pamphlétaire puis <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb144447840#foaf:Person]
</ud>
<ud>
Charles Duvaucel (<dat when="1734">1734</dat>) <en ref="24" >Astronome</en>, spécialisé dans les éclipses du soleil. [http://data.bnf.fr/ark:/12148/cb15318527x#foaf:Person]
</ud>
<ud>
Mathieu Bernard Goudin (<en type="li">Paris</en>, <dat when="1734">1734</dat>) Magistrat. - <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb10586154b#foaf:Person]
</ud>
<ud>
Alexandre-Théophile Vandermonde (<en type="li">Paris</en>, <dat when="1735">1735</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12534847r#foaf:Person]
</ud>
<ud>
Antonio Maria Lorgna (<en type="li">Cerea, Italie</en>, <dat when="1735">1735</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12387058m#foaf:Person]
</ud>
<ud>
Gregorio Fontana (<en type="li">Villa di Nogaredo, Italie</en>, <dat when="1735">1735</dat>) <en ref="16" >Mathématicien</en> et <en ref="1630" >physicien</en>. - Recteur et professeur de calcul sublime à l''Ateneo lombardo. - Bibliothécaire du Collegio Ghisleri, Pavie [http://data.bnf.fr/ark:/12148/cb10601676b#foaf:Person]
</ud>
<ud>
Giovanni-Antonio Rizzi-Zannoni (<en type="li">Padoue, Italie</en>, <dat when="1736">1736</dat>) <en ref="29" >Géographe</en> de la république de Venise, <en ref="24" >astronome</en>, il voyage en Amérique du nord en 1757 [http://data.bnf.fr/ark:/12148/cb153024615#foaf:Person]
</ud>
<ud>
Jean Sylvain Bailly (<en type="li">Paris</en>, <dat when="1736">1736</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en> et homme politique. - Entre à l''Académie des sciences (en 1763), à l''Académie française (en 1784) puis à l''Académie des inscriptions (en 1785). - Député du Tiers-État aux États-Généraux ; Maire de Paris ; Député à l''Assemblée Nationale Constituante [http://data.bnf.fr/ark:/12148/cb12516744h#foaf:Person]
</ud>
<ud>
Johann Nicolai Tetens (<en type="li">Tetenbüll, Allemagne</en>, <dat when="1736">1736</dat>) <en ref="16" >Mathématicien</en>, <en ref="1630" >physicien</en> et <en ref="18" >philosophe</en> [http://data.bnf.fr/ark:/12148/cb12531163b#foaf:Person]
</ud>
<ud>
Joseph-Louis Lagrange (<dat when="1736">1736</dat>) <en ref="16" >Mathématicien</en>. - D''origine italienne. - A été à l''origine de la fondation de l''Académie des sciences de Turin. - Membre de l''Académie des sciences de Paris, Berlin, Turin. - A partir de 1787, enseigne à Paris à l''École normale et à l''École polytechnique [http://data.bnf.fr/ark:/12148/cb12125247f#foaf:Person]
</ud>
<ud>
Francesco Venini (<en type="li">Varenna, Italie</en>, <dat when="1737">1737</dat>) Abbé. - <en ref="16" >Mathématicien</en> et poète [http://data.bnf.fr/ark:/12148/cb105963005#foaf:Person]
</ud>
<ud>
Giuseppe Maria Pagnini (<en type="li">Pistoia, Italie</en>, <dat when="1737">1737</dat>) Au siècle : Luca Antonio ; en religion, carme : Giuseppe Maria. - Poète. - <en ref="16" >Mathématicien</en>. - Savant latiniste et helléniste. - Professeur à l'' Université de Parme puis de Pise [http://data.bnf.fr/ark:/12148/cb11996942k#foaf:Person]
</ud>
<ud>
Tommaso Valperga di Caluso (<en type="li">Turin, Italie</en>, <dat when="1737">1737</dat>) Abbé. - Homme de lettres, <en ref="18" >philosophe</en> et <en ref="16" >mathématicien</en>. - Chevalier de Malte [http://data.bnf.fr/ark:/12148/cb10748197m#foaf:Person]
</ud>
<ud>
William Bayly (<dat when="1737">1737</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb14065321z#foaf:Person]
</ud>
<ud>
Charles-Joseph Mathon de La Cour (<en type="li">Lyon (Rhône)</en>, <dat when="1738">1738</dat>) Économiste. - Philanthrope. - Fondateur du "Journal de Lyon". - Rédacteur de "L''Almanach musical" (1775-1778), et au "Journal de musique", Paris (1764-1768). - Fils de : Mathon de La Cour, Jacques (1712-1770), <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb121925904#foaf:Person]
</ud>
<ud>
Flecheux (<dat when="1738">1738</dat>) <en ref="24" >Astronome</en> et mécanicien français. - Adresse en 1784 : Paris, rue du Sentier, hôtel de madame la présidente de Meslay, n° 31 [http://data.bnf.fr/ark:/12148/cb15585605z#foaf:Person]
</ud>
<ud>
Joseph-François Marie (<en type="li">Rodez</en>, <dat when="1738">1738</dat>) Abbé. - Fut <in ana="1621">professeur de mathématiques au Collège Mazarin</in> [http://data.bnf.fr/ark:/12148/cb146364765#foaf:Person]
</ud>
<ud>
Thomas Abbt (<en type="li">Ulm, Allemagne</en>, <dat when="1738">1738</dat>) Écrivain, <en ref="18" >philosophe</en>, <en ref="16" >mathématicien</en>, juriste et conseiller aulique [http://data.bnf.fr/ark:/12148/cb125347464#foaf:Person]
</ud>
<ud>
William Herschel (<en type="li">Hanovre, Allemagne</en>, <dat when="1738">1738</dat>) <en ref="24" >Astronome</en> et compositeur. - A découvert la planète Uranus. - S''installe en Grande-Bretagne en 1757 [http://data.bnf.fr/ark:/12148/cb14064893z#foaf:Person]
</ud>
<ud>
Ermenegildo Pini (<en type="li">Milan, Italie</en>, <dat when="1739">1739</dat>) Barnabite. - <en ref="1630" >Physicien</en>, géologue, <en ref="1635" >architecte</en>. - Professeur de mathématiques, puis d''histoire naturelle au Collège Saint-Alexandre, Milan. - Dans le siècle : Pini, Carlo [http://data.bnf.fr/ark:/12148/cb13013593q#foaf:Person]
</ud>
<ud>
Jean-Louis Pictet (<dat when="1739">1739</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb146402484#foaf:Person]
</ud>
<ud>
Johann Schultz (<dat when="1739">1739</dat>) A été professeur de mathématiques à l''université de Königsberg, Allemagne [http://data.bnf.fr/ark:/12148/cb121741380#foaf:Person]
</ud>
<ud>
José Antonio Alzate y Ramírez (<dat when="1739">1739</dat>) <en ref="24" >Astronome</en> et <en ref="29" >géographe</en> [http://data.bnf.fr/ark:/12148/cb15376450x#foaf:Person]
</ud>
<ud>
András Dugonics (<en type="li">Szeged (Hongrie)</en>, <dat when="1740">1740</dat>) Écrivain. - Poète. - Piariste. - <in ana="1621">Professeur de mathématiques</in>. - A fait des études de théologie  à Privigye (aujourd''hui Prievidza, Slovaquie) et à Nyitra (aujourd''hui Nitra, Slovaquie) [http://data.bnf.fr/ark:/12148/cb12246575b#foaf:Person]
</ud>
<ud>
Jacques-André Mallet (<dat when="1740">1740</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb10552198c#foaf:Person]
</ud>
<ud>
Joseph Anton Slop von Cadenberg (<dat when="1740">1740</dat>) <en ref="24" >Astronome</en>. - À l''Observatoire de Pise à partir de 1765 [http://data.bnf.fr/ark:/12148/cb12159312n#foaf:Person]
</ud>
<ud>
Nicola Spedalieri (<en type="li">Bronte (Italie)</en>, <dat when="1740">1740</dat>) <in ana="1621">Professeur de philosophie, théologie et mathématique</in>, poète, musicien, historien [http://data.bnf.fr/ark:/12148/cb16219670j#foaf:Person]
</ud>
<ud>
Nicolas-Antoine Nouet (<dat when="1740">1740</dat>) <en ref="24" >Astronome</en>. - Attaché à l''Observatoire en 1785. - Participe à l''expédition d''Égypte en 1798. - <en ref="1633" >Ingénieur</en> au Bureau de la guerre en 1802 [http://data.bnf.fr/ark:/12148/cb12151453k#foaf:Person]
</ud>
<ud>
Thomas Bugge (<en type="li">Copenhague</en>, <dat when="1740">1740</dat>) <en ref="24" >Astronome</en> et <en ref="1636" >cartographe</en> [http://data.bnf.fr/ark:/12148/cb121931908#foaf:Person]
</ud>
<ud>
Vicente Tofiño de San Miguel (<dat when="1740">1740</dat>) <en ref="24" >Astronome</en>. - Capitaine de vaisseau. - Directeur des compagnies des gardes royales de la marine en 1786. - Membre de l''Académie d''histoire de Madrid. - Correspondant de l''Académie des sciences de Paris [http://data.bnf.fr/ark:/12148/cb12159995t#foaf:Person]
</ud>
<ud>
Alexis Rochon (<en type="li">Brest (Finistère)</en>, <dat when="1741">1741</dat>) Prêtre, <en ref="24" >astronome</en> de la marine, <en ref="1630" >physicien</en> et inventeur. - Bibliothécaire de l''Académie royale de marine à Brest (1765-), <en ref="24" >astronome</en> opticien de la Marine (<dat when="1787">1787</dat>), membre de la Commission des poids et mesures et des monnaies (<dat when="1792">1792</dat>). - Membre de l''Académie royale des sciences, puis membre de l''Institut. - Clerc tonsuré [http://data.bnf.fr/ark:/12148/cb129983745#foaf:Person]
</ud>
<ud>
Stanislaw Wydra (<dat when="1741">1741</dat>) <in ana="1621">Professeur de mathématiques</in> [http://data.bnf.fr/ark:/12148/cb15512813z#foaf:Person]
</ud>
<ud>
Vincenzo Chiminello (<en type="li">Marostica, Italie</en>, <dat when="1741">1741</dat>) Abbé. - <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb10522164f#foaf:Person]
</ud>
<ud>
Georg Jonathan von Holland (<dat when="1742">1742</dat>) <en ref="1629" >Théologien</en>. - <en ref="16" >Mathématicien</en>. - Précepteur des princes de Wurttemberg [http://data.bnf.fr/ark:/12148/cb119076602#foaf:Person]
</ud>
<ud>
Jacques Poitevin (<en type="li">Montpellier</en>, <dat when="1742">1742</dat>) Savant <en ref="24" >astronome</en> et agriculteur. - Conseiller de préfecture du département de l''Hérault. - Membre de la Société royale des sciences de Montpellier [http://data.bnf.fr/ark:/12148/cb10644654k#foaf:Person]
</ud>
<ud>
Antonio Cagnoli (<en type="li">Zante, Grèce</en>, <dat when="1743">1743</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en>. - Crée un observatoire d''astronomie à Vérone. - Enseigne les mathématiques à l''École militaire de Modène après la prise de Vérone par les Français (<dat when="1797">1797</dat>). - Membre de nombreuses académies d''Europe [http://data.bnf.fr/ark:/12148/cb12562781s#foaf:Person]
</ud>
<ud>
Eberhard August Wilhelm von Zimmermann (<en type="li">Uelzen, Allemagne</en>, <dat when="1743">1743</dat>) <en ref="29" >Géographe</en> et naturaliste. - <in ana="1621">Professeur de mathématiques et de sciences naturelles au Collegium Carolinum de Brunswick de 1766 à 1815</in>. - Conseiller aulique en 1786, puis conseiller d''état en 1801 [http://data.bnf.fr/ark:/12148/cb12330956p#foaf:Person]
</ud>
<ud>
Jean-Antoine-Nicolas de Caritat Condorcet (<dat when="1743">1743</dat>) <en ref="18" >Philosophe</en>, <en ref="16" >mathématicien</en> et  économiste. - Membre de l''Académie française (<dat when="1782">1782</dat>). - Homme politique. - A aussi écrit sous le pseudonyme M. Schwartz, pasteur à Bienne [http://data.bnf.fr/ark:/12148/cb118975118#foaf:Person]
</ud>
<ud>
Etienne Lenoir (<dat when="1744">1744</dat>) <en ref="1633" >Ingénieur</en>. - Mit au point plusieurs instruments d''astronomie et de géodésie [http://data.bnf.fr/ark:/12148/cb151423156#foaf:Person]
</ud>
<ud>
François Callet (<en type="li">Versailles</en>, <dat when="1744">1744</dat>) Professeur de mathématiques et d''hydrographie [http://data.bnf.fr/ark:/12148/cb10544471f#foaf:Person]
</ud>
<ud>
Jean Bernoulli (<en type="li">Bâle, Suisse</en>, <dat when="1744">1744</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en>. - Membre des Académies des sciences de Berlin, de Petersbourg, de Stockholm, de Bologne, de Lyon, &amp; de Marseille, de la Société pour l''encouragement des arts, de Londres, de celle des <en ref="1630" >physicien</en>s de Bâle, de l''Académie des Arcades de Rome [http://data.bnf.fr/ark:/12148/cb14508854n#foaf:Person]
</ud>
<ud>
José Anastácio da Cunha (<dat when="1744">1744</dat>) Poète portugais. - <en ref="16" >Mathématicien</en>, professeur de géométrie à l''Université de Coimbra. - Officier d''artillerie à Valença do Minho (1764-1778) [http://data.bnf.fr/ark:/12148/cb121612626#foaf:Person]
</ud>
<ud>
Pierre Méchain (<en type="li">Laon</en>, <dat when="1744">1744</dat>) <en ref="24" >Astronome</en> français. - Prénoms complets : Pierre François André [http://data.bnf.fr/ark:/12148/cb12090251r#foaf:Person]
</ud>
<ud>
Caspar Wessel (<en type="li">Vestby, Norvège</en>, <dat when="1745">1745</dat>) <en ref="16" >Mathématicien</en>. - Reçut la médaille d''argent de la Royal Danish academy [http://data.bnf.fr/ark:/12148/cb12563002z#foaf:Person]
</ud>
<ud>
Claude-François Guillemeau de Fréval (<en type="li">Paris</en>, <dat when="1745">1745</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb10017540p#foaf:Person]
</ud>
<ud>
Franz von Paula Triesnecker (<dat when="1745">1745</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb15115995f#foaf:Person]
</ud>
<ud>
Fulcrand Jean Joseph Aigrefeuille (<dat when="1745">1745</dat>) G<en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb16296114m#foaf:Person]
</ud>
<ud>
Johann Hieronymus Schröter (<dat when="1745">1745</dat>) Magistrat et <en ref="24" >astronome</en> amateur allemand [http://data.bnf.fr/ark:/12148/cb11973603q#foaf:Person]
</ud>
<ud>
Nicolas Charles Romme (Riom, Puy-de-Dôme, <dat when="1745">1745</dat>) Professeur de mathématiques et de navigation à l''École de Rochefort. - Membre de l''Institut [http://data.bnf.fr/ark:/12148/cb12805333t#foaf:Person]
</ud>
<ud>
Gaetano Del Ricco (<dat when="1746">1746</dat>) Piariste (17 mai 1761). - <en ref="16" >Mathématicien</en>. - Librettiste. - Prénom de baptême : Vincenzo [http://data.bnf.fr/ark:/12148/cb16659347q#foaf:Person]
</ud>
<ud>
Gaspard Monge (<dat when="1746">1746</dat>) <en ref="16" >Mathématicien</en> et géomètre. - Fondateur de l''École polytechnique et de l''École normale. - Président de l''Institut du Caire. - Membre de l''Institut, Académie des sciences. - Député au Conseil des Cinq-Cents, au Conseil des Anciens, ministre de la Marine (<dat when="1792">1792</dat>), sénateur (<dat when="1799">1799</dat>), comte de Péluse (<dat when="1808">1808</dat>) [http://data.bnf.fr/ark:/12148/cb121412336#foaf:Person]
</ud>
<ud>
Giovanni Battista Venturi (<en type="li">Bibbiano, Italie</en>, <dat when="1746">1746</dat>) <en ref="1630" >Physicien</en> et <en ref="16" >mathématicien</en>. - Homme politique et diplomate [http://data.bnf.fr/ark:/12148/cb127228927#foaf:Person]
</ud>
<ud>
Giuseppe Piazzi (<en type="li">Ponte di Valtellina, Italie</en>, <dat when="1746">1746</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb12920801z#foaf:Person]
</ud>
<ud>
Jean-Claude-Gauthier-Louis de Benaben (<dat when="1746">1746</dat>) Oratorien et <in ana="1621">professeur de mathématiques</in>. - Fut directeur de l''Ecole centrale d''Angers. - Fut président des Amis de la Constitution. - Fut commissaire civil du département de Maine-et-Loire [http://data.bnf.fr/ark:/12148/cb125680474#foaf:Person]
</ud>
<ud>
Jean Foucaud (<dat when="1747">1747</dat>) Prédicateur, <en ref="16" >mathématicien</en>, philologue. - A écrit en patois limousin des fables imitées de La Fontaine, qu''il a aussi traduit dans cette même langue. - Fut l''un des rédacteurs du "Journal du département de la Haute-Vienne". - Fut à Limoges une personalité agissante du Club des jacobins, membre du Comité de salut public, juge de paix et payeur du département de Haute-Vienne. - Défroqué en 1793, il mourut réconcilié avec l''Église [http://data.bnf.fr/ark:/12148/cb119031941#foaf:Person]
</ud>
<ud>
Jean-Baptiste Bernard (<dat when="1747">1747</dat>) <en ref="1631" >Libraire</en> ; <en ref="1631" >libraire</en> de l''École polytechnique (<dat when="1800">1800</dat>) ; de l''École des Ponts et Chaussées (<dat when="1801">1801</dat>) ; des Écoles impériales polytechnique et des Ponts et chaussées (<dat when="1805">1805</dat>). - Né à Marseille. <en ref="1631" >Libraire</en> spécialisé dans les "mathématiques, sciences et arts", il travaille jusqu''en 1796 en association avec Régent au bureau du "Journal polytechnique" ou "Bulletin des Travaux publics..." Historien et philologue, éditeur des "Œuvres posthumes" de Montesquieu. Décédé à Saint-Maur-des-Fossés (Val-de-Marne) en oct. 1808. Sa veuve lui succède avant de revendre son fonds en 1810 à Jean Klostermann [http://data.bnf.fr/ark:/12148/cb122388832#foaf:Person]
</ud>
<ud>
Johann Elert Bode (<en type="li">Hambourg (Allemagne)</en>, <dat when="1747">1747</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb104634498#foaf:Person]
</ud>
<ud>
Andreas Riedel (<en type="li">Vienne</en>, <dat when="1748">1748</dat>) Jacobin viennois. - Professeur de mathématiques, précepteur des enfants du Grand duc Léopold, futur empereur,  1779-1790, Florence (Italie). - Études de <en ref="28" >médecin</en>e, élève du professeur Franz Anton Mesmer. - Emprisonné à Brno (1806-1809). - Se réfugia en France 1810-1837 [http://data.bnf.fr/ark:/12148/cb14593357z#foaf:Person]
</ud>
<ud>
Jean-Dominique Cassini (<dat when="1748">1748</dat>) <en ref="24" >Astronome</en>. - Membre de l''Académie des sciences (<dat when="1770">1770</dat>). - Fils de l''<en ref="24" >astronome</en> César-François Cassini (1714-1784), qui était aussi appelé Cassini de Thury, car né à Thury (Oise) en 1714. - Succède à son père comme directeur de l''Observatoire de Paris (en 1784) [http://data.bnf.fr/ark:/12148/cb12157999q#foaf:Person]
</ud>
<ud>
Pietro Cossali (<en type="li">Vérone, Italie</en>, <dat when="1748">1748</dat>) <en ref="16" >Mathématicien</en>. - A enseigné à l''université de Padoue [http://data.bnf.fr/ark:/12148/cb146340668#foaf:Person]
</ud>
<ud>
Pons-Joseph Bernard (<dat when="1748">1748</dat>) <en ref="16" >Mathématicien</en>. - Directeur adjoint de l''Observatoire de Marseille [http://data.bnf.fr/ark:/12148/cb12306722n#foaf:Person]
</ud>
<ud>
Thaddäus Rinderle (<dat when="1748">1748</dat>) Moine bénédictin, <en ref="16" >mathématicien</en> et horloger [http://data.bnf.fr/ark:/12148/cb15037954k#foaf:Person]
</ud>
<ud>
Giuseppe Calandrelli (<en type="li">Zagarolo, Italie</en>, <dat when="1749">1749</dat>) <en ref="24" >Astronome</en>. - Directeur du "Collegio romano" [http://data.bnf.fr/ark:/12148/cb10544460s#foaf:Person]
</ud>
<ud>
Henri Bouchon-Dubournial (<dat when="1749">1749</dat>) <en ref="1633" >Ingénieur</en> et <en ref="16" >mathématicien</en>. - Fut professeur à l''Ecole militaire et l''Ecole royale militaire. - Fut le traducteur de Cervantès [http://data.bnf.fr/ark:/12148/cb125620183#foaf:Person]
</ud>
<ud>
Jean-Baptiste Delambre (<en type="li">Amiens</en>, <dat when="1749">1749</dat>) <en ref="24" >Astronome</en>. - Ses calculs ont servi à  déterminer la longueur du mètre. - Membre de l''Académie des sciences (<dat when="1792">1792</dat>) [http://data.bnf.fr/ark:/12148/cb12096096m#foaf:Person]
</ud>
<ud>
Paul-Louis Cirodde (<dat when="1749">1749</dat>) <in ana="1621">Professeur de mathématiques</in> [http://data.bnf.fr/ark:/12148/cb102655606#foaf:Person]
</ud>
<ud>
Pierre-Simon de Laplace (Beaumont-en-Auge (<en type="li">Calvados)</en>, <dat when="1749">1749</dat>) <en ref="24" >Astronome</en>, <en ref="16" >mathématicien</en> et <en ref="1630" >physicien</en>. - Membre de l''Institut, Académie des sciences (élu en 1795), puis de l''Académie française (élu en 1816). - Obtint le titre de marquis (en 1817) [http://data.bnf.fr/ark:/12148/cb119110516#foaf:Person]
</ud>
<ud>
Vincenzo De Filippis (<dat when="1749">1749</dat>) Scientifique, <en ref="16" >mathématicien</en>. - Ministre de la République parthénopéenne en février 1799, fut probablement victime de la répression au rétablissement des Bourbons en juin de la même année [http://data.bnf.fr/ark:/12148/cb12290835h#foaf:Person]
</ud>
<ud>
William Faden (<dat when="1749">1749</dat>) <en ref="1631" >Libraire</en>, éditeur et marchand de cartes et d''estampes ; également <en ref="29" >géographe</en> ordinaire du roi d''Angleterre (1783-1820) et du prince de Galles (1790-1820). - Fils de l''<en ref="1632" >imprimeur</en> londonien William I Faden (à l''origine Mackfaden, 1711-1783). En apprentissage de juillet 1764 à août 1771. Travaille en association avec la famille du <en ref="1631" >libraire</en> et <en ref="29" >géographe</en> du Roi Thomas Jefferys (m. 1771) jusqu''en 1776 env. Membre de la "Society of civil engineers". Beau-frère du peintre et <en ref="24" >astronome</en> John Russell. Se retire en 1823 et cède son affaire à son ancien apprenti James Wyld. Décédé à Shepperton en mars 1836 [http://data.bnf.fr/ark:/12148/cb15615346f#foaf:Person]
</ud>
<ud>
Caroline Lucretia Herschel (Hanovre (Basse-Saxe,  Allemagne), <dat when="1750">1750</dat>) <en ref="24" >Astronome</en>. - Assistante de son frère, William Herschel (1738-1822), lui aussi <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb16108822m#foaf:Person]
</ud>
<ud>
Gilbert Romme (<dat when="1750">1750</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en> et <en ref="29" >géographe</en>. - Député du Puy-de-Dôme à l''Assemblée législative puis à la Convention, représentant en mission près l''armée de Cherbourg, préconise l''essai du télégraphe aérien de Chiappe. - A participé à l''établissement du calendrier révolutionnaire [http://data.bnf.fr/ark:/12148/cb12536106q#foaf:Person]
</ud>
<ud>
Lorenzo Mascheroni (<en type="li">Bergame, Italie</en>, <dat when="1750">1750</dat>) <en ref="16" >Mathématicien</en> et poète. - Professeur de physique et de mathématique au Séminaire de Bergame, puis d''algèbre et de géométrie à l''Université de Pavie, dont il sera recteur. - Député au Corps législatif de Milan (<dat when="1799">1799</dat>), admirateur de Napoléon, fait partie des 29 qui signent l''appel à régner en Italie au Premier Consul après 1799 [http://data.bnf.fr/ark:/12148/cb119149502#foaf:Person]
</ud>
<ud>
Nicolas-Maurice Chompré (<en type="li">Paris (France)</en>, <dat when="1750">1750</dat>) Directeur, entre 1777 et 1786, de la Correspondance générale à la Division des mines et de l''agriculture du Contrôleur général des Finances Bertin. - Diplomate. - Auteur d''ouvrages de physique et de mathématiques [http://data.bnf.fr/ark:/12148/cb122074802#foaf:Person]
</ud>
<ud>
Scipione Breislak (<en type="li">Rome</en>, <dat when="1750">1750</dat>) Géologue. - <in ana="1621">Professeur de mathématiques à Raguse puis à Rome</in> [http://data.bnf.fr/ark:/12148/cb151306996#foaf:Person]
</ud>
<ud>
Simon Lhuilier (<dat when="1750">1750</dat>) <en ref="16" >Mathématicien</en> et <en ref="18" >philosophe</en>. - Établi à Varsovie [http://data.bnf.fr/ark:/12148/cb13005974t#foaf:Person]
</ud>
<ud>
Alliette (<dat when="1751">1751</dat>) Cartomancien de la fin du 18e siècle. - Marchand d''estampes. - Professeur de mathématiques (vers 1753). - La forme "Etteilla" est l''anagramme d''Alliette [http://data.bnf.fr/ark:/12148/cb118885161#foaf:Person]
</ud>
<ud>
André-Charles Brotier (<en type="li">Paris</en>, <dat when="1751">1751</dat>) Abbé, <en ref="16" >mathématicien</en> et homme politique. - Enseigna les mathématiques à l''Ecole militaire. - Collabora à l''"Année littéraire" et au "Journal de la France" [http://data.bnf.fr/ark:/12148/cb124621991#foaf:Person]
</ud>
<ud>
Antide Janvier (Lavans-lès-Saint-Claude (<en type="li">Jura)</en>, <dat when="1751">1751</dat>) Horloger, <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb12614643k#foaf:Person]
</ud>
<ud>
Bazaine (<dat when="1751">1751</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb10735226f#foaf:Person]
</ud>
<ud>
Bernard Violle (<dat when="1751">1751</dat>) <en ref="16" >Mathématicien</en>. - Géomètre. - Chevalier de Saint-Louis (<dat when="1815">1815</dat>) [http://data.bnf.fr/ark:/12148/cb13006994p#foaf:Person]
</ud>
<ud>
Bonaventure Abat (<dat when="1751">1751</dat>) <en ref="16" >Mathématicien</en> et <en ref="1629" >théologien</en>, cordelier de l''Observance. - Fut membre associé de l''Académie royale des belles-lettres de Barcelone [http://data.bnf.fr/ark:/12148/cb134813469#foaf:Person]
</ud>
<ud>
G.-F. Olivier (<dat when="1751">1751</dat>) Bachelier ès sciences. - Professeur d''humanités et de mathématiques (en 1825). Professeur au collège de Troyes [http://data.bnf.fr/ark:/12148/cb10728006s#foaf:Person]
</ud>
<ud>
Guillelmus Beer (<dat when="1751">1751</dat>) <en ref="1636" >Cartographe</en>, <en ref="29" >géographe</en> et peut-être <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb15332855z#foaf:Person]
</ud>
<ud>
Hector-Jean Legros (<dat when="1751">1751</dat>) Adjoint-général pendant les guerres de Vendée et d''Italie. - <in ana="1621">Professeur de mathématiques</in> [http://data.bnf.fr/ark:/12148/cb13484693c#foaf:Person]
</ud>
<ud>
Henri Jurain (<dat when="1751">1751</dat>) Abbé. - <in ana="1621">Professeur de mathématiques à Reims</in>. - Correspondant de l''Académie des Sciences [http://data.bnf.fr/ark:/12148/cb12224993g#foaf:Person]
</ud>
<ud>
J.-B.-M. Duprat (<dat when="1751">1751</dat>) <en ref="1631" >Libraire</en> pour les mathématiques. - En activité de mars 1797 à 1803 au moins. Apparenté à Louis (-Alexis) Duprat-Duverger, en activité à partir de 1802, qui a pu se qualifier lui aussi de "<en ref="1631" >libraire</en> pour les mathématiques". Louis Courcier, "<en ref="1632" >imprimeur</en> et <en ref="1631" >libraire</en> pour les mathématiques", lui succède en 1803 à la même adresse (quai des Augustins, n° 71). Une "madame Duprat" est cependant répertoriée, à l''adresse du pont Saint-Michel, par le "Tableau des <en ref="1631" >libraire</en>s" de Debray (Paris, janv. 1804) [http://data.bnf.fr/ark:/12148/cb16701987t#foaf:Person]
</ud>
<ud>
J.P. Audiffred (<dat when="1751">1751</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb125867381#foaf:Person]
</ud>
<ud>
Jacques Baradelle (<dat when="1751">1751</dat>) Etabli dès 1740 quai de l''Horloge du Palais, il fabriquait des instruments de navigation, des cadrans solaires, des sphères astronomiques et géographiques [http://data.bnf.fr/ark:/12148/cb15281028g#foaf:Person]
</ud>
<ud>
James Dodson (<dat when="1751">1751</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb153816258#foaf:Person]
</ud>
<ud>
Jean-Louis Gœury (<dat when="1751">1751</dat>) <en ref="1631" >Libraire</en> ; <en ref="1631" >libraire</en> pour les mathématiques et l''architecture ; <en ref="1631" >libraire</en> de l''École des Ponts et chaussées (<dat when="1802">1802</dat>) ; des <en ref="1633" >ingénieur</en>s et de l''École impériale des Ponts et chaussées (<dat when="1805">1805</dat>). - Semble avoir été commis du <en ref="1631" >libraire</en> parisien Charles-Antoine Jombert de 1770 à 1773 au moins. Père du <en ref="28" >médecin</en> Jean-Louis Gœury-Duvivier, né le 2 mars 1803. En activité dès 1800. Breveté <en ref="1631" >libraire</en> le 1er oct. 1812 (brevet renouvelé le 11 sept. 1818). Décédé peu avant le 28 juin 1827, date à laquelle son fils Jean-Louis Gœury (dit plus tard Gœury-Duvivier) demande à succéder à son brevet [http://data.bnf.fr/ark:/12148/cb12230577c#foaf:Person]
</ud>
<ud>
Joseph Mouchet (<dat when="1751">1751</dat>) Professeur de rhétorique et de mathématiques, professeur de physique à l''université de Nantes de 1780 à 1784. - Aéronaute. - Membre de la Congrégation de l''Oratoire [http://data.bnf.fr/ark:/12148/cb16514291q#foaf:Person]
</ud>
<ud>
Joseph-Louis Vincens de Mauléon de Causans (<en type="li">Avignon</en>, <dat when="1751">1751</dat>) <en ref="16" >Mathématicien</en>. - Colonel d''infanterie du régiment de Conti. - Chevalier de Malte [http://data.bnf.fr/ark:/12148/cb145658189#foaf:Person]
</ud>
<ud>
Le Professeur de mathématiques du Collège national de Toul (<dat when="1751">1751</dat>) <in ana="1621">Professeur de mathématiques du Collège national de Toul</in> [http://data.bnf.fr/ark:/12148/cb125373980#foaf:Person]
</ud>
<ud>
Le Ratz de Lanthenée (<dat when="1751">1751</dat>) Gentilhomme liégeois. - <en ref="16" >Mathématicien</en> et <en ref="1630" >physicien</en> [http://data.bnf.fr/ark:/12148/cb124022694#foaf:Person]
</ud>
<ud>
Louis Duprat-Duverger (<dat when="1751">1751</dat>) Variante(s) de prénom : Louis-Alexis. - <en ref="1631" >Libraire</en> pour les mathématiques ; également éditeur de cartes et d''atlas. - Apparenté au "<en ref="1631" >libraire</en> pour les mathématiques" J.-B.-M. Duprat, en activité à Paris entre 1797 et 1803. Établi dès 1802, d''abord en association sous la raison "L. Duprat, Letellier et compagnie" jusqu''en 1804, seul ensuite. Breveté <en ref="1631" >libraire</en> le 1er oct. 1812 ; brevet renouvelé le 15 mars 1817 ; duplicata délivré le 27 avril 1824. Encore en activité en 1829 [http://data.bnf.fr/ark:/12148/cb133399518#foaf:Person]
</ud>
<ud>
Madame Bailly (<dat when="1751">1751</dat>) Épouse de Jean-Sylvain Bailly, <en ref="16" >mathématicien</en>, <en ref="24" >astronome</en> et homme politique, guillotiné en 1793 [http://data.bnf.fr/ark:/12148/cb16541654h#foaf:Person]
</ud>
<ud>
Marie de La Fresnaye (<en type="li">Barfleur (Manche)</en>, <dat when="1751">1751</dat>) <in ana="1621">Professeur de littérature et de mathématiques</in> [http://data.bnf.fr/ark:/12148/cb100430283#foaf:Person]
</ud>
<ud>
Marie-Louise Cartan (<dat when="1751">1751</dat>) Femme d''Elie Cartan, mère du compositeur Jean Cartan et du <en ref="16" >mathématicien</en> Henri Cartan. - Née Marie-Louise Bianconi [http://data.bnf.fr/ark:/12148/cb148511208#foaf:Person]
</ud>
<ud>
Mathurin-Georges Girault de Keroudou (<dat when="1751">1751</dat>) Abbé. - <en ref="16" >Mathématicien</en> français. - Principal du collège de Quimper. - <in ana="1621">Professeur de philosophie et de mathématiques au collège de Navarre à Paris</in>. - Professeur au collège de Louis-le-Grand à Paris [http://data.bnf.fr/ark:/12148/cb15085298t#foaf:Person]
</ud>
<ud>
Nicolas Leverdé (<dat when="1751">1751</dat>) <en ref="25" >Astrologue</en> et <en ref="16" >mathématicien</en>. - Auteur d''almanachs [http://data.bnf.fr/ark:/12148/cb10403809w#foaf:Person]
</ud>
<ud>
Olaf Söderberg (<dat when="1751">1751</dat>) Botaniste et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12563978p#foaf:Person]
</ud>
<ud>
Théodore Bouys (<dat when="1751">1751</dat>) <en ref="16" >Mathématicien</en> favorable à Necker et à la Révolution [http://data.bnf.fr/ark:/12148/cb12240772d#foaf:Person]
</ud>
<ud>
Trabaud (<dat when="1751">1751</dat>) Maître de mathématiques [http://data.bnf.fr/ark:/12148/cb134811442#foaf:Person]
</ud>
<ud>
Vérologue (<dat when="1751">1751</dat>) "Seul <en ref="1632" >imprimeur</en> d''Apollon pour la satyre en prose". - Pseud. auquel est adjoint le qualificatif "seul <en ref="1632" >imprimeur</en> d''Apollon pour la satyre en prose" et qui, sous la fausse adresse "Sur l''imprimé au Parnasse", dissimule une impression française (parisienne selon Weller et G. Brunet, plutôt provinciale d''après le matériel typographique) de "La Nouvelle Astronomie du Parnasse françois, ou l''Apothéose des écrivains vivans dans la présente année 1740", due au chevalier Jean-Florent-Joseph de Neufville de Brunaubois-Montador [http://data.bnf.fr/ark:/12148/cb165246377#foaf:Person]
</ud>
<ud>
Veuve de Louis Courcier (<dat when="1751">1751</dat>) Nom patronymique : Victoire-Félicité Lemaire. - <en ref="1632" >Imprimeur</en>-<en ref="1631" >libraire</en> ; <en ref="1632" >imprimeur</en>-<en ref="1631" >libraire</en> pour les mathématiques, la marine, les sciences et les arts. - Brevetée <en ref="1632" >imprimeur</en> en succession de son mari le 12 août 1811 (brevet renouvelé le 15 oct. 1816) et <en ref="1631" >libraire</en> le 1er oct. 1812 (brevet renouvelé le 15 mars 1817). Deux de ses  gendres lui succèdent : Démophile Huzard (-Courcier) en mars 1820 (brevet du 14 mars 1820) comme <en ref="1632" >imprimeur</en>, et Victor Bachelier le 10 nov. 1821 comme <en ref="1631" >libraire</en> [http://data.bnf.fr/ark:/12148/cb124778683#foaf:Person]
</ud>
<ud>
Adrien-Marie Legendre (<dat when="1752">1752</dat>) <en ref="16" >Mathématicien</en>. - Président de l''Académie des sciences (<dat when="1806">1806</dat>). - A aussi écrit avec Charles-Etienne Coquebert de Montbret et François Gattey sous le pseudonyme collectif "C.-G.-L. Métrophile" [http://data.bnf.fr/ark:/12148/cb12443375d#foaf:Person]
</ud>
<ud>
Barnaba Oriani (<en type="li">Carignano, Italie</en>, <dat when="1752">1752</dat>) <en ref="24" >Astronome</en> de l''Observatoire de Brera (1777-), puis de Milan. - A découvert qu''Uranus était une planète à partir de son orbite. - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12537845s#foaf:Person]
</ud>
<ud>
Jean-Baptiste Labey (La Chapelle-Hainfray (Calvados), aujourd''hui Valsemé (<en type="li">Calvados)</en>, <dat when="1752">1752</dat>) <en ref="16" >Mathématicien</en>. - Professeur à l''École militaire, à l''École centrale du Panthéon, à l''École polytechnique et au Lycée Napoléon de Paris [http://data.bnf.fr/ark:/12148/cb12112257t#foaf:Person]
</ud>
<ud>
Jean-Baptiste Pérès (Valence d''Agen (Tarn-et-Garonne), <dat when="1752">1752</dat>) Oratorien. - <in ana="1621">Professeur de mathématiques et de physique  à Lyon</in>, membre de la Société des amis de la Constitution de la ville durant la Révolution, puis substitut du procureur général près la cour royale d''Agen et bibliothécaire de cette ville [http://data.bnf.fr/ark:/12148/cb126307361#foaf:Person]
</ud>
<ud>
Marc-Auguste Pictet (<en type="li">Genève (Suisse)</en>, <dat when="1752">1752</dat>) Naturaliste genevois, littérateur, chimiste, <en ref="1630" >physicien</en> et <en ref="24" >astronome</en>. - Membre fondateur de la Société de physique et d''histoire naturelle de Genève, Suisse. - Correspondant de la Société royale de Londres [http://data.bnf.fr/ark:/12148/cb125386742#foaf:Person]
</ud>
<ud>
François Gattey (<dat when="1753">1753</dat>) <en ref="16" >Mathématicien</en>. - Directeur du Bureau des poids et mesures (en 1795). - A aussi écrit avec Charles-Etienne Coquebert de Montbret et Adrien-Marie Legendre sous le pseudonyme collectif "C.-G.-L. Métrophile" [http://data.bnf.fr/ark:/12148/cb12447886d#foaf:Person]
</ud>
<ud>
Antoine de La Salle (<dat when="1754">1754</dat>) <en ref="18" >Philosophe</en>. - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12173561c#foaf:Person]
</ud>
<ud>
Colin Mackenzie (Stornoway (Lewis, Western isles, Royaume-Uni), <dat when="1754">1754</dat>) <en ref="16" >Mathématicien</en>. - Fonctionnaire collonial en Inde (1815-1821). - Chargé du relevé cartographique de l''Inde et de la description de ses régions. - Collectionneur de divers documents (manuscrits, dessins aquarelles...) constituant le fonds d''études indianistes, collection dispersée aujourd''hui entre l''India office library, Londres et : Government oriental manuscripts library, Madras et Calcutta [http://data.bnf.fr/ark:/12148/cb14374770r#foaf:Person]
</ud>
<ud>
Franz Xaver von Zach (<en type="li">Bratislava</en>, <dat when="1754">1754</dat>) <en ref="24" >Astronome</en>. - Directeur de l''Observatoire du Seeberg (près de Gotha), de 1787 à 1808. - Dirigea les "Allgemeinen geographischen Ephemeriden" (1796-) [http://data.bnf.fr/ark:/12148/cb121732757#foaf:Person]
</ud>
<ud>
Jean-Baptiste Meusnier de La Place (Tours (Indre-et-Loire), <dat when="1754">1754</dat>) <en ref="16" >Mathématicien</en> et Officier. - Elu à l''Académie des sciences en 1784 pour son étude locale des surfaces. - Prénoms complets : Jean-Baptiste Marie Charles [http://data.bnf.fr/ark:/12148/cb10732160m#foaf:Person]
</ud>
<ud>
Nicolas-François Canard (<dat when="1754">1754</dat>) <en ref="16" >Mathématicien</en> et économiste [http://data.bnf.fr/ark:/12148/cb12519510c#foaf:Person]
</ud>
<ud>
Charles-Étienne Coquebert de Montbret (<en type="li">Paris</en>, <dat when="1755">1755</dat>) Diplomate, <en ref="16" >mathématicien</en> et <en ref="29" >géographe</en>. - Nommé responsable de l''organisation du nouveau système de poids et mesures (décret de 1793), professeur de géographie physique et gîtes de minerais à l''École des mines. - A aussi écrit avec François Gattey et Adrien-Marie Legendre sous le pseudonyme collectif "C.-G.-L. Métrophile". - Membre de l''Institut, membre libre de l''Académie des Sciences (en 1816) [http://data.bnf.fr/ark:/12148/cb12447869t#foaf:Person]
</ud>
<ud>
Claude Philippe Bertrand Bertrand (Autun (Saône-et-Loire), <dat when="1755">1755</dat>) <en ref="29" >Géographe</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb16506861q#foaf:Person]
</ud>
<ud>
Emmanuel-Étienne Duvillard de Durand (<en type="li">Genève</en>, <dat when="1755">1755</dat>) <en ref="16" >Mathématicien</en>, statisticien. - A développé la mathématisation de l''économie [http://data.bnf.fr/ark:/12148/cb129987837#foaf:Person]
</ud>
<ud>
Gaspard-Clair-François-Marie Riche de Prony (<en type="li">Chamelet (Rhône)</en>, <dat when="1755">1755</dat>) <en ref="16" >Mathématicien</en> et <en ref="1633" >ingénieur</en>. - Directeur de l''École des Ponts et Chaussées (1799-1830). - Membre de l''Académie des Sciences. - Baron à titre personnel (<dat when="1828">1828</dat>) [http://data.bnf.fr/ark:/12148/cb12535038t#foaf:Person]
</ud>
<ud>
Jean Anthelme Brillat-Savarin (<en type="li">Belley, Ain</en>, <dat when="1755">1755</dat>) Magistrat. - Député aux États Généraux (élu en 1789). - G<en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb12305674c#foaf:Person]
</ud>
<ud>
Louis Courcier (<dat when="1755">1755</dat>) <en ref="1632" >Imprimeur</en>-<en ref="1631" >libraire</en> ; <en ref="1632" >imprimeur</en>-<en ref="1631" >libraire</en> pour les mathématiques (<dat when="1801">1801</dat>) ; <en ref="1632" >imprimeur</en>-<en ref="1631" >libraire</en> pour les mathématiques (, les sciences et les arts) (1804-1808). - Exerce l''imprimerie dès l''été 1790. Aurait été auparavant "marchand de peaux de lapin" d''après l''enquête des inspecteurs de la librairie de déc. 1810. Proche des Girondins, il émarge au budget du Bureau de l''Esprit public du ministre Jean-Marie Roland de La Platière en 1792. Dirige le "Courrier du Corps législatif et de la Guerre" (<dat when="1797">1797</dat>). Rachète le fonds du <en ref="1631" >libraire</en> J.-B.-M. Duprat et lui succède en 1803 ; rachète l''imprimerie de Jean-Georges-Antoine Stoupe après la mort de celui-ci (<dat when="1808">1808</dat>). Breveté <en ref="1632" >imprimeur</en> le 1er avril 1811. Dit âgé de 56 ans lors de son décès (30 juillet 1811). Sa veuve est brevetée en sa succession dès le 12 août 1811 [http://data.bnf.fr/ark:/12148/cb12421329b#foaf:Person]
</ud>
<ud>
Nicolas B. Halma (<dat when="1755">1755</dat>) Chanoine de Paris. - <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en>. - Professeur [http://data.bnf.fr/ark:/12148/cb11906753t#foaf:Person]
</ud>
<ud>
Nikolaus von Fuss (<dat when="1755">1755</dat>) <en ref="16" >Mathématicien</en>, géomètre. - Né à Bâle, s''intalla à Saint-Pétersbourg en 1773 à la demande d''Euler. - Membre de l''Académie des sciences de Saint-Pétersbourg (1775-), secrétaire perpétuel (1800-). - Meurt à Saint-Pétersbourg le 23 décembre 1825 (style grégorien) [http://data.bnf.fr/ark:/12148/cb12359314p#foaf:Person]
</ud>
<ud>
Pierre Tédenat (<dat when="1755">1755</dat>) Docteur en mathématiques. - Recteur de l''académie Nîmes (1809-1818) et <in ana="1621">professeur de philosophie à la faculté des lettres de Nîmes</in> [http://data.bnf.fr/ark:/12148/cb10379875d#foaf:Person]
</ud>
<ud>
Agricol-Joseph-François-Xavier-Pierre-Esprit-Simon-Paul-Antoine Fortia d''Urban (<en type="li">Avignon</en>, <dat when="1756">1756</dat>) <en ref="16" >Mathématicien</en> et littérateur. - Chevalier de la Légion d''honneur en 1811, correspondant de l''Académie de Belgique en 1828 et membre libre de l''Académie des Inscriptions et belles-lettres en 1830 [http://data.bnf.fr/ark:/12148/cb121468483#foaf:Person]
</ud>
<ud>
Alexandre Ruelle (<en type="li">Blois</en>, <dat when="1756">1756</dat>) <en ref="24" >Astronome</en>. - Professeur d''astronomie à l''Observatoire de Paris de 1783 à 1795 [http://data.bnf.fr/ark:/12148/cb121582720#foaf:Person]
</ud>
<ud>
Ernst Gottfried Fischer (<dat when="1756">1756</dat>) <en ref="1630" >Physicien</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb124025182#foaf:Person]
</ud>
<ud>
Jan Chrzciciel Władysław Śniadecki (<dat when="1756">1756</dat>) <en ref="16" >Mathématicien</en> et <en ref="18" >philosophe</en>, un des plus grands savants polonais des Lumières [http://data.bnf.fr/ark:/12148/cb123726267#foaf:Person]
</ud>
<ud>
Joseph Mollet (Aix-en-Provence (Bouches-du-Rhône), <dat when="1756">1756</dat>) Oratorien. - <in ana="1621">Professeur de physique et de mathématique, École Centrale, Lyon, Rhône</in>. - Doyen de la Faculté des sciences de Lyon (1809-1815) [http://data.bnf.fr/ark:/12148/cb12196474k#foaf:Person]
</ud>
<ud>
Carl-Christian von Langsdorf (<en type="li">Nauheim (Allemagne)</en>, <dat when="1757">1757</dat>) <en ref="16" >Mathématicien</en>. - <en ref="1633" >Ingénieur</en>. - Professeur de mathématiques à Erlangen (Allemagne), de 1798 à 1804, puis à Vilnius (Lituanie) de 1804 à 1806. - Frère de Langsdorf, Johann-Wilhelm (1745-1827) [http://data.bnf.fr/ark:/12148/cb10661030m#foaf:Person]
</ud>
<ud>
Dominique Blanqui (<dat when="1757">1757</dat>) Professeur de philosophie et d''astronomie. - Député à la Convention. - Membre du Conseil des Cinq-cents [http://data.bnf.fr/ark:/12148/cb12534874n#foaf:Person]
</ud>
<ud>
Alexandre-Balthazar-Laurent Grimod de La Reynière (<en type="li">Paris</en>, <dat when="1758">1758</dat>) Avocat. - Pamphlétaire. - G<en ref="24" >astronome</en>, fondateur et président du "Jury dégustateur" [http://data.bnf.fr/ark:/12148/cb11905936j#foaf:Person]
</ud>
<ud>
Johann Christoph Schuster (<dat when="1759">1759</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb16505504t#foaf:Person]
</ud>
<ud>
Louis-François-Antoine Arbogast (<en type="li">Mutzig, Alsace</en>, <dat when="1759">1759</dat>) <en ref="16" >Mathématicien</en>. - Directeur du Collège royal (en 1791). - Député à l''Assemblée législative puis à la Convention nationale [http://data.bnf.fr/ark:/12148/cb12520232w#foaf:Person]
</ud>
<ud>
Pierre-René-Auguste Bremond d''Ars (<dat when="1759">1759</dat>) Député de la noblesse. - Fut <in ana="1621">professeur de mathématiques et de latin</in> [http://data.bnf.fr/ark:/12148/cb12540611f#foaf:Person]
</ud>
<ud>
Thomas Keith (<en type="li">Winestead (GB)</en>, <dat when="1759">1759</dat>) <en ref="16" >Mathématicien</en>. - Professeur [http://data.bnf.fr/ark:/12148/cb10275963j#foaf:Person]
</ud>
<ud>
Giovanni Paradisi (<en type="li">Reggio Emilia, Italie</en>, <dat when="1760">1760</dat>) Comte. - Homme politique. - <en ref="16" >Mathématicien</en>. - Poète [http://data.bnf.fr/ark:/12148/cb105910991#foaf:Person]
</ud>
<ud>
Nicolas Antoine Guillard (<en type="li">Sorbais, Aisne</en>, <dat when="1760">1760</dat>) <in ana="1621">Professeur de mathématiques</in> [http://data.bnf.fr/ark:/12148/cb10617134p#foaf:Person]
</ud></root>', 8, NULL, '{ud0}
Hermann de Carinthie ({en0li}île de Korčula (Croatie){/en}, {dat1105}1105{/dat}) {en18}Philosophe{/en}, écrivain, {en16}mathématicien{/en}, {en25}astrologue{/en} et traducteur croate [http://data.bnf.fr/ark:/12148/cb16243624j#foaf:Person]
{/ud}
{ud0}
Hermann le Dalmate ({en0li}Saint Peter en Istrie une partie du duché de Carinthie (au sud de l''Autriche){/en}, {dat1110}1110{/dat}) {en18}Philosophe{/en}, {en24}astronome{/en}, {en25}astrologue{/en}, {en16}mathématicien{/en} et traducteur d''ouvrages scientifiques et de la littérature. - Il vint très jeune en 1135 en France à Paris et à Chartres. - Eut pour maître Thierry de Chartres. - L''abbé de Cluny, Pierre le Vénérable, poussa Herman à traduire à écrire sur la vie et l''oeuvre de Mahomet [http://data.bnf.fr/ark:/12148/cb12364029w#foaf:Person]
{/ud}
{ud0}
Bhāskarācārya ({en0li}Dekkan, Inde{/en}, {dat1114}1114{/dat}) {en16}Mathématicien{/en}. - {en24}Astronome{/en}. - Fils de Maheśvara. - Auteur de :  "Siddhāntaśiromanī" (en 1150) ; "Karṇakutūhala" [http://data.bnf.fr/ark:/12148/cb14498624v#foaf:Person]
{/ud}
{ud0}
al-Muẓaffar ibn Muḥammad Šaraf al-Dīn Ṭūsī ({dat1151}1151{/dat}) {en16}Mathématicien{/en}. - Originaire de Ṭūs, Hamad̲ān, Mosul, Alep, Damas. - Écrivait vers 1209 [http://data.bnf.fr/ark:/12148/cb120864072#foaf:Person]
{/ud}
{ud0}
Johannes de Sacro Bosco ({dat1151}1151{/dat}) {en16}Mathématicien{/en}. - Chanoine prémontré de Holywood (comté de Dumfries, Écosse). - {in0_1621}Professeur à l''Université de Paris{/in}. - Semble être né à Halifax (Yorkshire, Angleterre). - Mort en 1256 ou 1244 [http://data.bnf.fr/ark:/12148/cb121284153#foaf:Person]
{/ud}
{ud0}
Robertus Castrensis ({dat1151}1151{/dat}) Traducteur de traités scientifiques et de mathématiques. - Sa période d''activité se situe aux alentours de 1145 [http://data.bnf.fr/ark:/12148/cb12223624k#foaf:Person]
{/ud}
{ud0}
Alexandre de Villedieu ({en0li}Villedieu (Manche){/en}, {dat1170}1170{/dat}) Franciscain. - Grammairien, {en16}mathématicien{/en} et poète. - Chanoine de la cathédrale Saint-André d''Avranches [http://data.bnf.fr/ark:/12148/cb12536245w#foaf:Person]
{/ud}
{ud0}
Leonardo Fibonacci ({dat1170}1170{/dat}) {en16}Mathématicien{/en}. - Surnommé Leonardo Pisano [http://data.bnf.fr/ark:/12148/cb13092437c#foaf:Person]
{/ud}
{ud0}
Moḥamad ben Moḥamad Naṣīr al-Dīn Ṭōsī ({en0li}Tus (Iran){/en}, {dat1201}1201{/dat}) {en16}Mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb12399386c#foaf:Person]
{/ud}
{ud0}
Jean Pecham ({dat1220}1220{/dat}) Provincial des franciscains d''Angleterre. - Archevêque de Cantorbéry (à partir de 1279). - {en1629}Théologien{/en}, {en16}mathématicien{/en} et {en1630}physicien{/en} [http://data.bnf.fr/ark:/12148/cb12459837w#foaf:Person]
{/ud}
{ud0}
Witelo ({dat1220}1220{/dat}) {en18}Philosophe{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12054316n#foaf:Person]
{/ud}
{ud0}
Maḥmūd ibn Mas´ūd Quṭb al-Dīn al- Šīrāzī ({en0li}Shīrāz{/en}, {dat1236}1236{/dat}) {en24}Astronome{/en}, {en28}médecin{/en}, {en18}philosophe{/en} et {en1629}théologien{/en} [http://data.bnf.fr/ark:/12148/cb12086388m#foaf:Person]
{/ud}
{ud0}
Jacob ben Machir ({en0li}Marseille{/en}, {dat1238}1238{/dat}) {en24}Astronome{/en}. - {en28}Médecin{/en}. - Chancellier de la faculté de {en28}médecin{/en}e de Montpellier [http://data.bnf.fr/ark:/12148/cb165406517#foaf:Person]
{/ud}
{ud0}
Grégoire Chioniadès ({dat1240}1240{/dat}) {en24}Astronome{/en}, {en1630}physicien{/en} et {en28}médecin{/en} byzantin. - Évêque de Tabriz, Iran [http://data.bnf.fr/ark:/12148/cb12007088c#foaf:Person]
{/ud}
{ud0}
Henri Baten ({dat1246}1246{/dat}) {en18}Philosophe{/en} et {en1629}théologien{/en}. - {en24}Astronome{/en}. - Poète et musicien [http://data.bnf.fr/ark:/12148/cb12220635h#foaf:Person]
{/ud}
{ud0}
al-Mufaḍḍal ibn ʿUmar Aṯīr al-Dīn al-Abharī ({dat1251}1251{/dat}) {en18}Philosophe{/en}, logicien, {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb15935708x#foaf:Person]
{/ud}
{ud0}
Bartolomeo da Parma ({dat1251}1251{/dat}) {en25}Astrologue{/en}, géomancien et {en24}astronome{/en}. {in0_1621}Fut professeur à l''Université de Bologne (1288-1297){/in} [http://data.bnf.fr/ark:/12148/cb144790439#foaf:Person]
{/ud}
{ud0}
Campanus de Novare ({dat1251}1251{/dat}) {en24}Astronome{/en}. - {en16}Mathématicien{/en}, commentateur d''Euclide [http://data.bnf.fr/ark:/12148/cb124917005#foaf:Person]
{/ud}
{ud0}
David ben Yom-Tov Poel ({dat1251}1251{/dat}) {en18}Philosophe{/en}. - {en28}Médecin{/en}. - Père de l''{en24}astronome{/en} Jacob Poel [http://data.bnf.fr/ark:/12148/cb16540698w#foaf:Person]
{/ud}
{ud0}
Démétrius Triclinius ({en0li}Thessalonique{/en}, {dat1251}1251{/dat}) Philologue. - {en16}Mathématicien{/en} et {en25}astrologue{/en} [http://data.bnf.fr/ark:/12148/cb12311753x#foaf:Person]
{/ud}
{ud0}
Geršon ben Salomon d''Arles ({en0li}Béziers{/en}, {dat1251}1251{/dat}) Éxégète. - {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb134867338#foaf:Person]
{/ud}
{ud0}
Hui Yang ({dat1251}1251{/dat}) {en16}Mathématicien{/en} chinois. En activité entre 1261 et 1275 [http://data.bnf.fr/ark:/12148/cb13746624q#foaf:Person]
{/ud}
{ud0}
Isaac ben Joseph Israeli ({dat1251}1251{/dat}) {en24}Astronome{/en}. - Elève d''Asher ben Jehiel [http://data.bnf.fr/ark:/12148/cb16540863s#foaf:Person]
{/ud}
{ud0}
Jacopo da Firenze ({dat1251}1251{/dat}) {en16}Mathématicien{/en}. - Actif en 1307 [http://data.bnf.fr/ark:/12148/cb157815579#foaf:Person]
{/ud}
{ud0}
Jordanus Nemorarius ({dat1251}1251{/dat}) {en16}Mathématicien{/en}. - Probablement d''origine italienne [http://data.bnf.fr/ark:/12148/cb11986727x#foaf:Person]
{/ud}
{ud0}
Petrus Philomena de Dacia ({dat1251}1251{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en}, {en18}philosophe{/en}. - Attesté entre 1290 et 1300. - Élève à l''Université de Bologne (1291-1292) puis de Paris. - Chanoine de Roskilde, Danemark. - A distinguer de Petrus de Dacia, recteur de l''Université de Paris en 1327 [http://data.bnf.fr/ark:/12148/cb11887258w#foaf:Person]
{/ud}
{ud0}
ʿAbd al-Ġaffār ibn ʿAbd al-Karīm Naǧm al-Dīn al- Qazwīnī ({dat1251}1251{/dat}) {en16}Mathématicien{/en} et jurisconsulte chaféite [http://data.bnf.fr/ark:/12148/cb155674927#foaf:Person]
{/ud}
{ud0}
Andalò Di Negro ({en0li}Gênes (?), Italie{/en}, {dat1260}1260{/dat}) {en24}Astronome{/en}. - Précepteur de Boccace. - Ambassadeur de la République de Gênes auprès de l''empereur Alexis Comnène (en 1314) [http://data.bnf.fr/ark:/12148/cb121998732#foaf:Person]
{/ud}
{ud0}
Théodore Métochite ({en0li}Constantinople{/en}, {dat1260}1260{/dat}) Homme d''état, {en18}philosophe{/en}, poète, {en24}astronome{/en} et rhéteur [http://data.bnf.fr/ark:/12148/cb12000562c#foaf:Person]
{/ud}
{ud0}
Gersonide (Bagnols-sur-Cèze ({en0li}Gard){/en}, {dat1288}1288{/dat}) Exégète biblique, {en16}mathématicien{/en}, {en24}astronome{/en}, {en18}philosophe{/en}, {en1630}physicien{/en} [http://data.bnf.fr/ark:/12148/cb12131941j#foaf:Person]
{/ud}
{ud0}
Barlaam de Seminara ({dat1290}1290{/dat}) Moine basilien, abbé du Saint-Esprit à Constantinople ({dat1331}1331{/dat}), évêque de Gérace (1342-1348). - {en1629}Théologien{/en}, {en18}philosophe{/en}, {en16}mathématicien{/en}, {en24}astronome{/en} et helléniste [http://data.bnf.fr/ark:/12148/cb13549924x#foaf:Person]
{/ud}
{ud0}
Jacopo Dondi ({dat1290}1290{/dat}) {en18}Philosophe{/en}, {en24}astronome{/en}, {en28}médecin{/en} italien célèbre pour la construction d''une pendule astrale à Padoue. - Père de Giovanni Dondi [http://data.bnf.fr/ark:/12148/cb124119184#foaf:Person]
{/ud}
{ud0}
Thomas Bradwardine ({dat1290}1290{/dat}) {en16}Mathématicien{/en}, {en18}philosophe{/en} et {en1629}théologien{/en}. - Surnommé le "Doctor Profundus". - Archevêque de Canterbury en 1349 [http://data.bnf.fr/ark:/12148/cb12269047v#foaf:Person]
{/ud}
{ud0}
Richard of Wallingford ({dat1292}1292{/dat}) {en16}Mathématicien{/en}. - {en24}Astronome{/en}. - Abbé du monastère bénédictin de St Albans [http://data.bnf.fr/ark:/12148/cb12128305h#foaf:Person]
{/ud}
{ud0}
Jean de Murs ({dat1300}1300{/dat}) {en24}Astronome{/en}, {en16}mathématicien{/en} et théoricien de la musique. - Maître-ès-arts de l''Université de Paris ({dat1321}1321{/dat}) [http://data.bnf.fr/ark:/12148/cb121715011#foaf:Person]
{/ud}
{ud0}
Giovanni Dondi dall''Orologio ({en0li}Chiogga, Italie{/en}, {dat1318}1318{/dat}) {en28}Médecin{/en} et poète. - {en24}Astronome{/en} et horloger, a terminé l''horloge astronomique, installée par son père : Dondi, Jacopo (1298-1359), à Padoue ou Pavie, Italie [http://data.bnf.fr/ark:/12148/cb122241024#foaf:Person]
{/ud}
{ud0}
Giacomo Allegretti ({dat1325}1325{/dat}) {en28}Médecin{/en} , poète et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb14405998n#foaf:Person]
{/ud}
{ud0}
Blasius de Parma ({dat1347}1347{/dat}) {en18}Philosophe{/en}, {en16}mathématicien{/en}, {en28}médecin{/en}. - Recteur de l''université de Parme (en 1412) [http://data.bnf.fr/ark:/12148/cb12182615f#foaf:Person]
{/ud}
{ud0}
Abū ʿAbd Allâh Muḥammad al- Baqqār ({dat1351}1351{/dat}) {en16}Mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb155102056#foaf:Person]
{/ud}
{ud0}
Emmanuel ben Jacob de Tarascon Bonfils ({dat1351}1351{/dat}) {en24}Astronome{/en}, {en28}médecin{/en} et {en16}mathématicien{/en} ayant vécu à Orange puis à Tarascon. Il est l''auteur de nombreux traités d''astronomie [http://data.bnf.fr/ark:/12148/cb15620448d#foaf:Person]
{/ud}
{ud0}
Ǧamšīd ibn Masʿūd Ġiyāṯ al-Dīn al- Kāšī ({dat1351}1351{/dat}) {en28}Médecin{/en}, {en16}mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb11351746b#foaf:Person]
{/ud}
{ud0}
Johannes Danck ({dat1351}1351{/dat}) {en24}Astronome{/en}. - A enseigné à l''Université de Paris de 1327 à 1355 [http://data.bnf.fr/ark:/12148/cb12531239r#foaf:Person]
{/ud}
{ud0}
Naǧm al-Dīn al- Miṣrī ({dat1351}1351{/dat}) Auteur supposé de traités portant sur les instruments astronomiques [http://data.bnf.fr/ark:/12148/cb14566743g#foaf:Person]
{/ud}
{ud0}
Prosdocimus de Beldemandis ({dat1351}1351{/dat}) Théoricien de la musique, {en16}mathématicien{/en} et {en1630}physicien{/en} [http://data.bnf.fr/ark:/12148/cb127653823#foaf:Person]
{/ud}
{ud0}
Taddeo da Parma ({dat1351}1351{/dat}) {en18}Philosophe{/en} averroïste et {en24}astronome{/en}. - A enseigné la philosophie à Bologne vers 1320 [http://data.bnf.fr/ark:/12148/cb10103512f#foaf:Person]
{/ud}
{ud0}
Théodore Méliténiote ({en0li}Constantinople{/en}, {dat1351}1351{/dat}) Grand sacellaire de l''Église byzantine, maître des maîtres de l''École patriarcale et archidiacre du clergé palatin. - A laissé un ouvrage d''exégèse de l''Évangile, un traité d''astronomie et un poème allégorique [http://data.bnf.fr/ark:/12148/cb12153709d#foaf:Person]
{/ud}
{ud0}
Paolo dal Pozzo Toscanelli ({dat1397}1397{/dat}) {en16}Mathématicien{/en}, {en1630}physicien{/en}, {en29}géographe{/en}, {en24}astronome{/en} et {en25}astrologue{/en}. - Inventeur des gnomons modernes. - Conservateur de la Bibliothèque de Florence [http://data.bnf.fr/ark:/12148/cb12455406j#foaf:Person]
{/ud}
{ud0}
Ugolino Pisani ({en0li}Parme, Italie{/en}, {dat1405}1405{/dat}) {en18}Philosophe{/en}, {en16}mathématicien{/en}, auteur de comédies [http://data.bnf.fr/ark:/12148/cb12689419t#foaf:Person]
{/ud}
{ud0}
Lorenzo Buonincontri ({en0li}San Miniato, Italie{/en}, {dat1411}1411{/dat}) Militaire, {en16}mathématicien{/en}, {en24}astronome{/en}, {en25}astrologue{/en}, poète et historien. - {in0_1621}Professeur d''astronomie à Naples{/in} [http://data.bnf.fr/ark:/12148/cb12536229n#foaf:Person]
{/ud}
{ud0}
ʿAlī ibn Muḥammad al- Qalaṣādī ({en0li}Baza (Espagne){/en}, {dat1412}1412{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en}, juriste et savant [http://data.bnf.fr/ark:/12148/cb12440997n#foaf:Person]
{/ud}
{ud0}
Piero della Francesca ({en0li}Borgo San Sepolcro, Italie{/en}, {dat1416}1416{/dat}) Peintre. - A écrit des traités de mathématiques, perspective et géométrie et des écrits sur la science des couleurs et du paysage [http://data.bnf.fr/ark:/12148/cb12060279h#foaf:Person]
{/ud}
{ud0}
Georgius de Hungaria ({en0li}Romosz, aujourd''hui Romos, Roumanie{/en}, {dat1422}1422{/dat}) Prisonnier des Turcs (1438-1458). - Dominicain. - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb130923013#foaf:Person]
{/ud}
{ud0}
Antonio Manetti ({en0li}Florence, Italie{/en}, {dat1423}1423{/dat}) Homme de lettres. - {en1635}Architecte{/en}, {en24}astronome{/en}, {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb11914242h#foaf:Person]
{/ud}
{ud0}
Georg von Peurbach ({en0li}Peuerbach, Autriche{/en}, {dat1423}1423{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb12374660w#foaf:Person]
{/ud}
{ud0}
Giovanni Pontano ({en0li}Cerreto di Spoleto (Perouse), Italie{/en}, {dat1426}1426{/dat}) Homme politique. - Humaniste. - Auteur de traités astronomiques et philosophiques [http://data.bnf.fr/ark:/12148/cb123298807#foaf:Person]
{/ud}
{ud0}
Johannes Regiomontanus ({en0li}Königsberg, Allemagne{/en}, {dat1436}1436{/dat}) {en24}Astronome{/en}. - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12159829r#foaf:Person]
{/ud}
{ud0}
Nīlakaṇṭha Somayajī ({dat1443}1443{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en} de l''école de Kerala (Inde) [http://data.bnf.fr/ark:/12148/cb165324540#foaf:Person]
{/ud}
{ud0}
Luca Pacioli ({dat1445}1445{/dat}) {en16}Mathématicien{/en}. - Franciscain [http://data.bnf.fr/ark:/12148/cb11918350c#foaf:Person]
{/ud}
{ud0}
Konrad Türst ({dat1450}1450{/dat}) {en16}Mathématicien{/en} suisse de Zürich [http://data.bnf.fr/ark:/12148/cb15336511g#foaf:Person]
{/ud}
{ud0}
Agostino Ricci ({dat1451}1451{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb12539498r#foaf:Person]
{/ud}
{ud0}
Andrea Corsali ({dat1451}1451{/dat}) {en24}Astronome{/en}, cosmographe, navigateur dans la péninsule arabique et aux Indes. - Pourrait avoir introduit l''imprimerie en Éthiopie (ca 1524), où vraisemblament il meurt [http://data.bnf.fr/ark:/12148/cb13517283d#foaf:Person]
{/ud}
{ud0}
Anianus ({dat1451}1451{/dat}) {en24}Astronome{/en} et poète [http://data.bnf.fr/ark:/12148/cb125156549#foaf:Person]
{/ud}
{ud0}
Antonio Dolciati ({dat1451}1451{/dat}) Augustinien et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb134854696#foaf:Person]
{/ud}
{ud0}
Bartolomeo da Messina ({dat1451}1451{/dat}) Écclésiastique et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb125393703#foaf:Person]
{/ud}
{ud0}
Gaspar Torrella ({dat1451}1451{/dat}) {en28}Médecin{/en} et {en16}mathématicien{/en}. - Évêque de Santa-Giusta (Sardaigne) en 1494. - Originaire de Valence (Espagne) [http://data.bnf.fr/ark:/12148/cb13486025q#foaf:Person]
{/ud}
{ud0}
Giovanni Abiosi ({dat1451}1451{/dat}) {en28}Médecin{/en}, {en24}astronome{/en}, {en16}mathématicien{/en} et {en18}philosophe{/en}. - Né à Bagnuolo (Royaume de Naples), mort vers 1500 [http://data.bnf.fr/ark:/12148/cb12537367q#foaf:Person]
{/ud}
{ud0}
Giovanni Antonio Tagliente ({dat1451}1451{/dat}) Calligraphe. - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12179148h#foaf:Person]
{/ud}
{ud0}
Giovanni Benedetto Moncetto ({dat1451}1451{/dat}) Agostinien. - {en1629}Théologien{/en}, {en18}philosophe{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb125688716#foaf:Person]
{/ud}
{ud0}
Giovanni Bianchini ({dat1451}1451{/dat}) {en24}Astronome{/en} mort après 1469 [http://data.bnf.fr/ark:/12148/cb16163624s#foaf:Person]
{/ud}
{ud0}
Guillaume Hobit ({dat1451}1451{/dat}) {en24}Astronome{/en} ; {en25}astrologue{/en} de Philippe le Bon, duc de Bourgogne [http://data.bnf.fr/ark:/12148/cb15063496s#foaf:Person]
{/ud}
{ud0}
Jacob Köbel ({en0li}Heidelberg, Allemagne{/en}, {dat1451}1451{/dat}) {en16}Mathématicien{/en}, éditeur et {en1631}libraire{/en} [http://data.bnf.fr/ark:/12148/cb10244031k#foaf:Person]
{/ud}
{ud0}
Louis Boulengier ({dat1451}1451{/dat}) {en24}Astronome{/en} et {en29}géographe{/en} d''Albi [http://data.bnf.fr/ark:/12148/cb152949413#foaf:Person]
{/ud}
{ud0}
Rāmacandrācārya ({dat1451}1451{/dat}) Grammairien et commentateur de Pāṇini (actif au 15e s.). - Fils de Kr̥ṣṇācārya. - A aussi écrit des ouvrages de philosophie (Vedānta) et d''astronomie [http://data.bnf.fr/ark:/12148/cb137708651#foaf:Person]
{/ud}
{ud0}
Sigismondo Fanti ({en0li}Ferrare, Italie{/en}, {dat1451}1451{/dat}) Poète, {en18}philosophe{/en} et {en16}mathématicien{/en}. - Meurt après 1527 [http://data.bnf.fr/ark:/12148/cb12567416q#foaf:Person]
{/ud}
{ud0}
Willem Gilliszoon ({dat1451}1451{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en}. - Originaire de Wissekerc (Zélande) [http://data.bnf.fr/ark:/12148/cb12548011q#foaf:Person]
{/ud}
{ud0}
Girolamo Donato ({dat1454}1454{/dat}) Magistrat, poète, {en18}philosophe{/en}, {en1629}théologien{/en} et {en16}mathématicien{/en}. - Fut gouverneur de Brescia ({dat1496}1496{/dat}), de Ferrare ({dat1498}1498{/dat}), ambassadeur de Venise près le pape Jules II ({dat1510}1510{/dat}) [http://data.bnf.fr/ark:/12148/cb13325565p#foaf:Person]
{/ud}
{ud0}
Eliya Delmedigo ({dat1460}1460{/dat}) {en28}Médecin{/en}. - {en24}Astronome{/en}. - {en16}Mathématicien{/en}. - Né en Crète. - {en18}Philosophe{/en}. - Maître d''hébreu de Pic de la Mirandole (1463-1494). - Commentateur des écrits d''Averroés (1126-1198) [http://data.bnf.fr/ark:/12148/cb122623668#foaf:Person]
{/ud}
{ud0}
Lodovico Pontico Virunio ({dat1467}1467{/dat}) {in0_1621}Professeur de lettres, {en18}philosophe{/en}{/in}, {en16}mathématicien{/en} et poète. - Fut chargé de l''éducation des fils de Ludovico Sforza, duc de Milan. - Eut l''intention de fonder une imprimerie grecque et latine à Reggio Emilia, mais ses caractères furent volés par Ludovico Bonaccioli, {en28}médecin{/en} de la duchesse de Ferrare. - Né à Belluno, meurt à Bologne [http://data.bnf.fr/ark:/12148/cb13324006j#foaf:Person]
{/ud}
{ud0}
Johannes Werner ({en0li}Nuremberg, Allemagne{/en}, {dat1468}1468{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en} et {en1636}cartographe{/en} [http://data.bnf.fr/ark:/12148/cb154028305#foaf:Person]
{/ud}
{ud0}
Jakob Ziegler ({en0li}Landau (Allemagne){/en}, {dat1470}1470{/dat}) {en1629}Théologien{/en}, {en16}mathématicien{/en}, {en24}astronome{/en} et {en29}géographe{/en}. - {in0_1621}Professeur de théologie.{/in} - Commentateur et auteur d''ouvrages historiques et théologiques [http://data.bnf.fr/ark:/12148/cb15029346k#foaf:Person]
{/ud}
{ud0}
Pedro Ciruelo ({en0li}Daroca, Espagne{/en}, {dat1470}1470{/dat}) {in0_1621}Professeur de théologie à l''Université d''Alcala (1510-){/in}, chanoine de la cathédrale de cette ville. - Fut l''un des précepteurs de Philippe II. - Étudia à Salamanque et à Paris, où il édita des oeuvres mathématiques et scientifiques. - Est également l''auteur d''un traité sur la sorcellerie dont la traduction espagnole eut une diffusion importante [http://data.bnf.fr/ark:/12148/cb128071494#foaf:Person]
{/ud}
{ud0}
Johann Stöffler ({en0li}Justingen, Allemagne{/en}, {dat1472}1472{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb125156905#foaf:Person]
{/ud}
{ud0}
Josse Clicthove (Nieuport, Pays-Bas, {dat1472}1472{/dat}) {en1629}Théologien{/en} et {en16}mathématicien{/en}. - Théologal de Chartres. - Un des premiers à combattre les idées de Luther [http://data.bnf.fr/ark:/12148/cb12234610b#foaf:Person]
{/ud}
{ud0}
Bartolomeo Zamberti ({en0li}Venise, Italie{/en}, {dat1473}1473{/dat}) {en16}Mathématicien{/en} et humaniste. - {in0_1621}Professeur de lettres.{/in} - Notaire des Consuls des marchands de Venise [http://data.bnf.fr/ark:/12148/cb12033590z#foaf:Person]
{/ud}
{ud0}
Nicolas Copernic ({dat1473}1473{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb118976048#foaf:Person]
{/ud}
{ud0}
Luca Gaurico ({en0li}Giffoni, Italie{/en}, {dat1476}1476{/dat}) Évêque de Civita Ducale (1545-1549). - {en16}Mathématicien{/en}, {en18}philosophe{/en}, {en24}astronome{/en} et {en25}astrologue{/en} [http://data.bnf.fr/ark:/12148/cb134849440#foaf:Person]
{/ud}
{ud0}
Johann Schöner ({dat1477}1477{/dat}) Né à Karlstadt près de Würzburg. - Prédicateur protestant. - {en24}Astronome{/en}. - {en29}Géographe{/en}. - {in0_1621}Professeur de mathématiques à Nuremberg.{/in} - A aussi écrit en latin [http://data.bnf.fr/ark:/12148/cb119992233#foaf:Person]
{/ud}
{ud0}
Girolamo Fracastoro ({en0li}Vérone, Italie{/en}, {dat1478}1478{/dat}) {en28}Médecin{/en}, auteur du "De contagione et contagiosis morbis et curatione libri III" ; nommé par le pape Paul III {en28}médecin{/en} officiel du Concile de Trente. - Auteur de poèmes en latin, d''oeuvres de géographie, d''astronomie, de physique, de théologie et de philosophie. - Élève de Pomponazzi, ami de Copernic [http://data.bnf.fr/ark:/12148/cb120587788#foaf:Person]
{/ud}
{ud0}
Girolamo Francastoro ({dat1478}1478{/dat}) {en28}Médecin{/en}, {en24}astronome{/en}, géologiste, poète, précurseur de la notion de contagion [http://data.bnf.fr/ark:/12148/cb15699396m#foaf:Person]
{/ud}
{ud0}
Celio Calcagnini ({en0li}Ferrare, Italie{/en}, {dat1479}1479{/dat}) Poète, philologue, {en18}philosophe{/en} et {en24}astronome{/en}. - Accompagna Hippolyte d''Este en Hongrie et en Pologne [http://data.bnf.fr/ark:/12148/cb122157991#foaf:Person]
{/ud}
{ud0}
Charles de Bovelles ({dat1479}1479{/dat}) {en18}Philosophe{/en}, {en16}mathématicien{/en} et linguiste. - Chanoine de Noyon. - Né avant le 28 mars 1479 [http://data.bnf.fr/ark:/12148/cb118932166#foaf:Person]
{/ud}
{ud0}
Prospero Calano ({en0li}Sarzana, Italie{/en}, {dat1480}1480{/dat}) {en28}Médecin{/en}, {en24}astronome{/en} et {en18}philosophe{/en} [http://data.bnf.fr/ark:/12148/cb12568870v#foaf:Person]
{/ud}
{ud0}
Vannoccio Biringuccio ({en0li}Sienne, Italie{/en}, {dat1480}1480{/dat}) {en16}Mathématicien{/en}, chimiste, {en1635}architecte{/en} et {en1633}ingénieur{/en}, spécialiste en métallurgie [http://data.bnf.fr/ark:/12148/cb12195640k#foaf:Person]
{/ud}
{ud0}
Michael Stifel ({dat1487}1487{/dat}) {en1629}Théologien{/en} et {en16}mathématicien{/en}. - Inventeur du logarithme. - Enseigna la théologie et les mathématiques à l''Université de Königsberg, puis les mathématiques à l''Université de Iéna [http://data.bnf.fr/ark:/12148/cb12795734z#foaf:Person]
{/ud}
{ud0}
Sebastian Münster ({en0li}Ingelheim, Allemagne{/en}, {dat1489}1489{/dat}) Hébraïsant, {en29}géographe{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb11996987j#foaf:Person]
{/ud}
{ud0}
Albert Pighius (Kampen, Pays-Bas, {dat1490}1490{/dat}) {en1629}Théologien{/en}, {en16}mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb10448635x#foaf:Person]
{/ud}
{ud0}
Patrizio Tricasso ({en0li}Ceresara, Italie{/en}, {dat1491}1491{/dat}) Dominicain. - {en16}Mathématicien{/en} et {en25}astrologue{/en} [http://data.bnf.fr/ark:/12148/cb107034397#foaf:Person]
{/ud}
{ud0}
Heinrich Schreiber ({en0li}Erfurt, Allemagne{/en}, {dat1492}1492{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb10734904t#foaf:Person]
{/ud}
{ud0}
Jean Borrel ({dat1492}1492{/dat}) Géomètre et {en16}mathématicien{/en}. - Chanoine régulier de l''Ordre de Saint-Antoine [http://data.bnf.fr/ark:/12148/cb12515817n#foaf:Person]
{/ud}
{ud0}
Pedro Nunez ({dat1492}1492{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12548918m#foaf:Person]
{/ud}
{ud0}
Oronce Fine (Briançon (Hautes-Alpes), {dat1494}1494{/dat}) Sieur de Champrouet. - {en16}Mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb122937307#foaf:Person]
{/ud}
{ud0}
Petrus Apian ({en0li}Leisnig (Allemagne){/en}, {dat1495}1495{/dat}) {en24}Astronome{/en}, {en1636}cartographe{/en} et {en16}mathématicien{/en}. - Nommé Chevalier de l''Empire par Charles Quint. - Surnom de : Bienewitz (ou Bennewitz), Peter [http://data.bnf.fr/ark:/12148/cb12515640m#foaf:Person]
{/ud}
{ud0}
Andreas Osiander ({en0li}Gunzenhausen, Allemagne{/en}, {dat1498}1498{/dat}) {en1629}Théologien{/en} protestant, {en24}astronome{/en} et {en16}mathématicien{/en}. - Parfois désigné sous le nom "Andreas Osiander l''Ancien" [http://data.bnf.fr/ark:/12148/cb11988942v#foaf:Person]
{/ud}
{ud0}
Garcia da Orta ({en0li}Castelo di Vide, Portugal{/en}, {dat1499}1499{/dat}) {en28}Médecin{/en} et naturaliste. - A enseigné les mathématiques à l''Université de Lisbonne [http://data.bnf.fr/ark:/12148/cb119983323#foaf:Person]
{/ud}
{ud0}
Giovanni Agostino Abate ({dat1499}1499{/dat}) {en16}Mathématicien{/en} et historien [http://data.bnf.fr/ark:/12148/cb14624324z#foaf:Person]
{/ud}
{ud0}
Joachim Sterck van Ringelberg ({en0li}Anvers, Belgique{/en}, {dat1499}1499{/dat}) Humaniste, {en16}mathématicien{/en} et {en25}astrologue{/en}. - Meurt selon les sources le 1er janvier 1531, en 1536 ou en 1556 [http://data.bnf.fr/ark:/12148/cb10645118k#foaf:Person]
{/ud}
{ud0}
Johann Carion ({en0li}Bietigheim, Allemagne{/en}, {dat1499}1499{/dat}) {en25}Astrologue{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12805831h#foaf:Person]
{/ud}
{ud0}
Johannes Dryander ({en0li}Wetter, Allemagne{/en}, {dat1500}1500{/dat}) {en16}Mathématicien{/en}, {en1630}physicien{/en} et {en24}astronome{/en}, {in0_1621}professeur à Marburg{/in}, édité par Sebastian Münster et Abraham Ortelius [http://data.bnf.fr/ark:/12148/cb15379218m#foaf:Person]
{/ud}
{ud0}
Johannes Voegelin ({en0li}Heilbronn, Allemagne{/en}, {dat1500}1500{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en}. - Professeur à l''Université de Vienne [http://data.bnf.fr/ark:/12148/cb10490264h#foaf:Person]
{/ud}
{ud0}
Niccolò Tartaglia ({dat1500}1500{/dat}) {en16}Mathématicien{/en}, {en1633}ingénieur{/en} et {en1635}architecte{/en}. - Pseudonyme de Niccolò Fontana [http://data.bnf.fr/ark:/12148/cb12914492r#foaf:Person]
{/ud}
{ud0}
Gerolamo Cardano ({en0li}Pavie, Italie{/en}, {dat1501}1501{/dat}) {en28}Médecin{/en}, {en16}mathématicien{/en} et {en18}philosophe{/en} [http://data.bnf.fr/ark:/12148/cb11895137c#foaf:Person]
{/ud}
{ud0}
Pedro Nunes ({en0li}Alcácer do Sol (Portugal){/en}, {dat1502}1502{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en} portugais [http://data.bnf.fr/ark:/12148/cb13510349t#foaf:Person]
{/ud}
{ud0}
Cosimo Bartoli ({en0li}Florence, Italie{/en}, {dat1503}1503{/dat}) Ambassadeur, poète et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb125520809#foaf:Person]
{/ud}
{ud0}
Jean Cousin ({en0li}Soucy (Yonne, France){/en}, {dat1503}1503{/dat}) Peintre, sculpteur, graveur, {en1635}architecte{/en}, {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12467444s#foaf:Person]
{/ud}
{ud0}
Ciriaco Strozzi ({en0li}Capalle, Italie{/en}, {dat1504}1504{/dat}) Helléniste, {en18}philosophe{/en}, {en16}mathématicien{/en} et {en1635}architecte{/en} [http://data.bnf.fr/ark:/12148/cb10418521b#foaf:Person]
{/ud}
{ud0}
Jacques Bassantin ({dat1504}1504{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12548014r#foaf:Person]
{/ud}
{ud0}
Achille Pirminius Gasser ({dat1505}1505{/dat}) {en28}Médecin{/en}, historien et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb12516715x#foaf:Person]
{/ud}
{ud0}
Benedictus Aretius ({dat1505}1505{/dat}) {en1629}Théologien{/en} protestant. - Botaniste et {en24}astronome{/en}. - {in0_1621}Professeur de logique à l''Université de Marbourg{/in}, puis {in0_1621}professeur de théologie à Berne{/in}. - Fut lié avec Conrad Gesner. - Né et mort à Berne [http://data.bnf.fr/ark:/12148/cb12515850g#foaf:Person]
{/ud}
{ud0}
Alessandro Piccolomini ({en0li}Sienne, Italie{/en}, {dat1508}1508{/dat}) Écrivain, dramaturge, {en24}astronome{/en} et traducteur d''oeuvres de l''Antiquité, de comédies, de traités philosophiques et scientifiques. - Membre de l''Accademia degli Intronati de Sienne, sous le pseudonyme : lo Stordito. - Archevêque de Patras et coadjuteur de l''archevêque de Sienne Francesco Bandini Piccolomini, du 28 juillet 1574 à 1578 [http://data.bnf.fr/ark:/12148/cb12240709n#foaf:Person]
{/ud}
{ud0}
Gemma Frisius (Dokkum (Pays-Bas), {dat1508}1508{/dat}) {en16}Mathématicien{/en} et {en24}astronome{/en}. - Professeur et docteur en {en28}médecin{/en}e de l''Université de Louvain [http://data.bnf.fr/ark:/12148/cb125195002#foaf:Person]
{/ud}
{ud0}
Federico Commandino ({en0li}Sassocorvaro, Italie{/en}, {dat1509}1509{/dat}) {en16}Mathématicien{/en}. - A été le tuteur du duc d''Urbino [http://data.bnf.fr/ark:/12148/cb12562850s#foaf:Person]
{/ud}
{ud0}
Jean Gosselin ({en0li}Vire, Calvados{/en}, {dat1510}1510{/dat}) {en25}Astrologue{/en} et {en16}mathématicien{/en}. - Conservateur de la bibliothèque du roi [http://data.bnf.fr/ark:/12148/cb133321861#foaf:Person]
{/ud}
{ud0}
Pietro Cataneo ({dat1510}1510{/dat}) {en1635}Architecte{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12557068n#foaf:Person]
{/ud}
{ud0}
Erasmus Oswald Schreckenfuchs ({dat1511}1511{/dat}) Hébraïsant. - {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb12115338j#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Amici ({en0li}Cosenza, Italie{/en}, {dat1511}1511{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb15583428k#foaf:Person]
{/ud}
{ud0}
Juanelo Turriano ({dat1511}1511{/dat}) {en16}Mathématicien{/en} et {en1633}ingénieur{/en} [http://data.bnf.fr/ark:/12148/cb129309990#foaf:Person]
{/ud}
{ud0}
Gerard Mercator ({en0li}Rupelmonde, Flandres{/en}, {dat1512}1512{/dat}) {en29}Géographe{/en}, {en1636}cartographe{/en}, cosmographe et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12789989j#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Amico ({dat1512}1512{/dat}) {en18}Philosophe{/en}, {en16}mathématicien{/en} et {en25}astrologue{/en}. - Originaire de Cosenza, fut assassiné à Padoue [http://data.bnf.fr/ark:/12148/cb12570280s#foaf:Person]
{/ud}
{ud0}
Juan Pérez de Moya ({dat1513}1513{/dat}) {en16}Mathématicien{/en} et humaniste [http://data.bnf.fr/ark:/12148/cb12146300q#foaf:Person]
{/ud}
{ud0}
Rheticus ({dat1514}1514{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb13615799v#foaf:Person]
{/ud}
{ud0}
Bernardino Baldini ({dat1515}1515{/dat}) Professeur de {en28}médecin{/en}e à Pavie puis de mathématiques à Milan [http://data.bnf.fr/ark:/12148/cb13163998r#foaf:Person]
{/ud}
{ud0}
Petrus Ramus ({en0li}Cuts (Aisne){/en}, {dat1515}1515{/dat}) {en18}Philosophe{/en}, grammairien, {en16}mathématicien{/en} et humaniste. - Professeur de mathématique au Collège royal (Collège de France). - Se convertit au protestantisme et fut tué au cours du Massacre de la Saint-Barthélemy [http://data.bnf.fr/ark:/12148/cb120645094#foaf:Person]
{/ud}
{ud0}
Jean-Pierre de Mesmes ({dat1516}1516{/dat}) Savant et poète. - Fils de Pierre de Mesmes, chambellan du roi de Navarre. - Etait lié avec Ronsard, du Bellay, Baïf, Charondas, Herberay, Jean Maugin, Ol. de Magny. - A était un des premiers auteurs à avoir écrit en français sur l''astronomie [http://data.bnf.fr/ark:/12148/cb125177720#foaf:Person]
{/ud}
{ud0}
Jacques Peletier ({dat1517}1517{/dat}) Poète et critique humaniste. - {en16}Mathématicien{/en}. - A participé à la réforme de l''orthographe. - Traducteur d''Horace [http://data.bnf.fr/ark:/12148/cb122992680#foaf:Person]
{/ud}
{ud0}
Jeronimo Munoz ({dat1520}1520{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb14646245j#foaf:Person]
{/ud}
{ud0}
Livio Sanuto ({dat1520}1520{/dat}) {en29}Géographe{/en} et {en16}mathématicien{/en} à Venise, fabriquant d''un globe avec son frère Giulio en 1561 [http://data.bnf.fr/ark:/12148/cb153816227#foaf:Person]
{/ud}
{ud0}
Melchior Ayrer ({dat1520}1520{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb162974318#foaf:Person]
{/ud}
{ud0}
Nicolaus Gugler ({en0li}Nuremberg (Allemagne){/en}, {dat1521}1521{/dat}) {en28}Médecin{/en} et {en24}astronome{/en}, a reçu une formation de juriste. - Fils de Hans Gugler (1480-1560) [http://data.bnf.fr/ark:/12148/cb16504896w#foaf:Person]
{/ud}
{ud0}
Valentin Mennher ({dat1521}1521{/dat}) {en16}Mathématicien{/en}. - Membre de la guilde des instituteurs d''Anvers [http://data.bnf.fr/ark:/12148/cb12563197r#foaf:Person]
{/ud}
{ud0}
Hermann Witekind ({en0li}Neuenrade (Allemagne){/en}, {dat1522}1522{/dat}) {en16}Mathématicien{/en} et humaniste [http://data.bnf.fr/ark:/12148/cb162248258#foaf:Person]
{/ud}
{ud0}
Giovanni Maria Bonardo ({en0li}Fratta Polesine, Italie{/en}, {dat1523}1523{/dat}) Poète. - Agronome. - {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb12181418p#foaf:Person]
{/ud}
{ud0}
Juan de Yciar (Durango (prov. de Vizcaya), {dat1523}1523{/dat}) Pédagogue, {en16}mathématicien{/en} et calligraphe [http://data.bnf.fr/ark:/12148/cb128696315#foaf:Person]
{/ud}
{ud0}
Jacques Charpentier (Clermont-en-Beauvaisis ({en0li}Oise){/en}, {dat1524}1524{/dat}) {en18}Philosophe{/en} et {en28}médecin{/en}. - Lecteur de mathématiques au Collège de France. - {en28}Médecin{/en} du roi [http://data.bnf.fr/ark:/12148/cb121323921#foaf:Person]
{/ud}
{ud0}
Tadeáš Hájek ({en0li}Prague{/en}, {dat1525}1525{/dat}) {en16}Mathématicien{/en} et {en28}médecin{/en}. - Reçu docteur à Bologne, occupa une chaire au Carolinum de Prague, fut premier {en28}médecin{/en} des empereurs Maximilien II et Rodolphe II [http://data.bnf.fr/ark:/12148/cb13009688n#foaf:Person]
{/ud}
{ud0}
Tilemann Stella ({en0li}Siegen (Allemagne){/en}, {dat1525}1525{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en}, {en29}géographe{/en}, {en1635}architecte{/en} et bibliothécaire. - {en1636}Cartographe{/en} à Wittenberg, ses cartes ont été éditées par Ortelius, Jode et Hondius [http://data.bnf.fr/ark:/12148/cb15376436c#foaf:Person]
{/ud}
{ud0}
Taqī al-Dīn Muḥammad Ibn Maʿrūf ({en0li}Damas{/en}, {dat1526}1526{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en} ottoman [http://data.bnf.fr/ark:/12148/cb14599962n#foaf:Person]
{/ud}
{ud0}
John Dee ({dat1527}1527{/dat}) {en25}Astrologue{/en}, {en16}mathématicien{/en} et antiquaire [http://data.bnf.fr/ark:/12148/cb119854464#foaf:Person]
{/ud}
{ud0}
Adam Lonicer ({en0li}Marburg (Allemagne){/en}, {dat1528}1528{/dat}) Medecin et botaniste. - Professeur de {en28}médecin{/en}e, chimie et mathématiques. - Fils du {en1629}théologien{/en} : Lonicer, Johann (1499-15969) [http://data.bnf.fr/ark:/12148/cb10279221n#foaf:Person]
{/ud}
{ud0}
Cornelius Blockland ({dat1530}1530{/dat}) Musicien, {en25}astrologue{/en}, {en16}mathématicien{/en} et {en28}médecin{/en}. - Actif de 1571 à 1586. - Frère du peintre Anthonie Blockland van Montfort [http://data.bnf.fr/ark:/12148/cb13497580p#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Benedetti ({en0li}Venise, Italie{/en}, {dat1530}1530{/dat}) {en16}Mathématicien{/en} et {en1633}ingénieur{/en}. - Fondateur de la géométrie analytique [http://data.bnf.fr/ark:/12148/cb11998820g#foaf:Person]
{/ud}
{ud0}
Jean Péna ({dat1530}1530{/dat}) {en16}Mathématicien{/en}, traducteur et éditeur de textes mathématiques et géométriques antiques [http://data.bnf.fr/ark:/12148/cb13483147k#foaf:Person]
{/ud}
{ud0}
Conradus Dasypodius ({en0li}Frauenfeld, Suisse{/en}, {dat1531}1531{/dat}) {en16}Mathématicien{/en}. - A tracé le plan de l''horloge astronomique de la cathédrale de Strasbourg [http://data.bnf.fr/ark:/12148/cb16534831x#foaf:Person]
{/ud}
{ud0}
Ercole Bottrigari ({dat1531}1531{/dat}) Humaniste, {en16}mathématicien{/en}, musicien, poète, linguiste et {en18}philosophe{/en} [http://data.bnf.fr/ark:/12148/cb125347809#foaf:Person]
{/ud}
{ud0}
Giuseppe Moletti ({dat1531}1531{/dat}) Cosmographe et {en29}géographe{/en}. - Professeur de {en28}médecin{/en}e, de mathématique et d''astronomie à l''Université de Padoue [http://data.bnf.fr/ark:/12148/cb134849518#foaf:Person]
{/ud}
{ud0}
Philip Apian ({en0li}Ingoldstadt, Allemagne{/en}, {dat1531}1531{/dat}) {en1636}Cartographe{/en}, {en16}mathématicien{/en} et {en1630}physicien{/en}. - Fils de Peter Apian, succède à son père à l''Université d''Ingolstadt [http://data.bnf.fr/ark:/12148/cb152383864#foaf:Person]
{/ud}
{ud0}
Fabrizio Mordente ({en0li}Salerne, Italie{/en}, {dat1532}1532{/dat}) {en16}Mathématicien{/en}. - A inventé le compas de proportion à huit points [http://data.bnf.fr/ark:/12148/cb14643668k#foaf:Person]
{/ud}
{ud0}
Egnatio Danti ({en0li}Pérouse, Italie{/en}, {dat1536}1536{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en}, {en1636}cartographe{/en} et cosmographe. - Dominicain [http://data.bnf.fr/ark:/12148/cb145332908#foaf:Person]
{/ud}
{ud0}
Henri de Monantheuil ({dat1536}1536{/dat}) {en16}Mathématicien{/en} et {en28}médecin{/en}. - Régent de la Faculté de {en28}médecin{/en}e de Paris, puis professeur de mathématiques au Collège de France (1574-). - Né à Reims, meurt à Paris [http://data.bnf.fr/ark:/12148/cb13006651k#foaf:Person]
{/ud}
{ud0}
Christophorus Clavius ({dat1537}1537{/dat}) Jésuite, musicien et {in0_1621}professeur de mathématiques{/in}. - Fut chargé par Grégoire XIII de la réforme du calendrier [http://data.bnf.fr/ark:/12148/cb125466080#foaf:Person]
{/ud}
{ud0}
Francesco Barozzi ({en0li}Heraklion, Grèce{/en}, {dat1537}1537{/dat}) {en16}Mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb10462395x#foaf:Person]
{/ud}
{ud0}
Giovanni Paolo Gallucci ({en0li}Salò, Italie{/en}, {dat1538}1538{/dat}) {en24}Astronome{/en}. - Homme de lettres [http://data.bnf.fr/ark:/12148/cb106019703#foaf:Person]
{/ud}
{ud0}
Philips Mor ({dat1539}1539{/dat}) Humaniste, {en16}mathématicien{/en} et poète néolatin. - Chanoine du chapitre de St Salvator d''Utrecht. - Fils du peintre Anthonis Mor van Dashorst (Antonio Moro) [http://data.bnf.fr/ark:/12148/cb12384177f#foaf:Person]
{/ud}
{ud0}
François Viète (Fontenay-le-Comte ({en0li}Vendée){/en}, {dat1540}1540{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb120511976#foaf:Person]
{/ud}
{ud0}
Cormopede ({dat1541}1541{/dat}) {en16}Mathématicien{/en} et {en25}astrologue{/en}. - Gentilhomme de la maison du Comte de Sterckenberg. - Date de naissance présumée d''après le "portrait de Cormopede à l''âge de 51 ans" figurant au F. A. 2 de l''"Almanach des almanachs pour l''an MDXCIII" [http://data.bnf.fr/ark:/12148/cb13491791f#foaf:Person]
{/ud}
{ud0}
Giovanni di Strasoldo ({dat1544}1544{/dat}) Noble. - Homme d''arme. - {en16}Mathématicien{/en}. - Poète [http://data.bnf.fr/ark:/12148/cb15122132t#foaf:Person]
{/ud}
{ud0}
Guidobaldo Dal Monte ({dat1545}1545{/dat}) {en16}Mathématicien{/en} et {en24}astronome{/en}. - Protégea {en7}Galilée{/en} et lui fit obtenir sa première chaire à Pise. - Né à Pesaro, meurt dans son chateau de Monte Baroccio [http://data.bnf.fr/ark:/12148/cb135173214#foaf:Person]
{/ud}
{ud0}
Renward Cysat ({en0li}Lucerne (Suisse){/en}, {dat1545}1545{/dat}) Chancelier de la ville de Lucerne, Suisse. - Historien, dramaturge, pharmacien et naturaliste. - Père de : Cysat, Johann Baptist (1587-1653), {en16}mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb12748433g#foaf:Person]
{/ud}
{ud0}
Maurice Bressieu ({dat1546}1546{/dat}) {en16}Mathématicien{/en}, {en18}philosophe{/en} et humaniste. - Titulaire de la chaire de mathématiques au Collège de France (1575-), orateur des rois de France à Rome (1586-), intendant de la Bibliothèque vaticane [http://data.bnf.fr/ark:/12148/cb13495175h#foaf:Person]
{/ud}
{ud0}
Tycho Brahe ({en0li}Knudstrup (Suède){/en}, {dat1546}1546{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb11893749j#foaf:Person]
{/ud}
{ud0}
Muḥammad ibn al-Ḥusayan Bahāʼ al-Dīn ʿĀmilī ({dat1547}1547{/dat}) Érudit arabe, {en18}philosophe{/en}, {en1629}théologien{/en}, {en24}astronome{/en}, grammairien, auteur d''anthologies [http://data.bnf.fr/ark:/12148/cb12451570z#foaf:Person]
{/ud}
{ud0}
Nicodemus Frischlin ({en0li}Balingen, Allemagne{/en}, {dat1547}1547{/dat}) Philologue et écrivain. - A enseigné les belles-lettres et les mathématiques à l''Université de Tubingue. - Traducteur d''Aristophane, de Callimaque et de Tryphiodore. - Auteur d''une comédie, présentée devant l''empereur Rodolphe, qui lui décerna le titre de comte-palatin [http://data.bnf.fr/ark:/12148/cb12463064b#foaf:Person]
{/ud}
{ud0}
Michele Zappulo ({dat1548}1548{/dat}) Docteur en droit canon et civil. - {en24}Astronome{/en}, historien et poète [http://data.bnf.fr/ark:/12148/cb125454264#foaf:Person]
{/ud}
{ud0}
Simon Stevin ({en0li}Bruges, Belgique{/en}, {dat1548}1548{/dat}) {in0_1621}Professeur de mathématiques de Maurice de Nassau{/in} [http://data.bnf.fr/ark:/12148/cb119941019#foaf:Person]
{/ud}
{ud0}
Michel Coignet ({dat1549}1549{/dat}) {en1633}Ingénieur{/en}, {en16}mathématicien{/en}, fabricant d''instruments de navigation, poète [http://data.bnf.fr/ark:/12148/cb124231863#foaf:Person]
{/ud}
{ud0}
Francisco Sánchez ({dat1550}1550{/dat}) {en28}Médecin{/en}, {en18}philosophe{/en}, {en16}mathématicien{/en} et poète. - Également connu sous le pseudonyme d''El Escéptico [http://data.bnf.fr/ark:/12148/cb120172346#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Crispo ({en0li}Gallipoli, Italie{/en}, {dat1550}1550{/dat}) Prêtre. - {en16}Mathématicien{/en}, {en1629}théologien{/en} et homme de lettres [http://data.bnf.fr/ark:/12148/cb10615268s#foaf:Person]
{/ud}
{ud0}
John Napier ({dat1550}1550{/dat}) {en16}Mathématicien{/en} et {en1629}théologien{/en}. - Baron de Merchiston [http://data.bnf.fr/ark:/12148/cb12353925j#foaf:Person]
{/ud}
{ud0}
Michael Moestlin ({dat1550}1550{/dat}) Né à Göppingen (Wurtemberg). - {en16}Mathématicien{/en}. - {en24}Astronome{/en}. - Luthérien, hostile à la réforme grégorienne du calendrier [http://data.bnf.fr/ark:/12148/cb12330628m#foaf:Person]
{/ud}
{ud0}
Sigfridus Aronus Forsius ({dat1550}1550{/dat}) {en24}Astronome{/en} et {en25}astrologue{/en} finlandais [http://data.bnf.fr/ark:/12148/cb131923734#foaf:Person]
{/ud}
{ud0}
Aegidius Martini ({dat1551}1551{/dat}) {en1636}Cartographe{/en}, {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb15376579x#foaf:Person]
{/ud}
{ud0}
al-Silahî Nasuh ({dat1551}1551{/dat}) Savant, miniaturiste et calligraphe ottoman. - A écrit plusieurs ouvrages sur les armes et les combats, sur la géométrie et les mathématiques ainsi que sur l''histoire. - Inventeur du jeu de "matraque", il est mieux connu sous son surnom "Matrakçı" : "Matrakçı Nasuh Efendi", "Nasuh al-Silahî", "Matraki", "Nasuh el-Mitraki", "Nasuh üs-Silahi", "Matraqçi Nasuh", "Nasuh b. Abdullah" et "Nasuh b. Karagöz el-Bosnevi" sont parmi les autres formes de référence [http://data.bnf.fr/ark:/12148/cb119562090#foaf:Person]
{/ud}
{ud0}
Anthoine Cathalan ({dat1551}1551{/dat}) {in0_1621}Professeur de mathématiques {/in}[http://data.bnf.fr/ark:/12148/cb14526861v#foaf:Person]
{/ud}
{ud0}
Bartolomeo Crescenzio ({dat1551}1551{/dat}) {en16}Mathématicien{/en}, {en1633}ingénieur{/en} naval et voyageur. - Fut capitaine de galère de la marine pontificale [http://data.bnf.fr/ark:/12148/cb125466487#foaf:Person]
{/ud}
{ud0}
Bernardo Gamucci ({en0li}San Gimignano, Italie{/en}, {dat1551}1551{/dat}) Archéologue, {en1635}architecte{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb10435220v#foaf:Person]
{/ud}
{ud0}
Camillo Agrippa ({dat1551}1551{/dat}) {en18}Philosophe{/en}, {en16}mathématicien{/en}, {en1635}architecte{/en} et {en1633}ingénieur{/en}. - Est aussi l''auteur de l''un des premiers traité d''escrime [http://data.bnf.fr/ark:/12148/cb12536260s#foaf:Person]
{/ud}
{ud0}
Claude de Boissière ({dat1551}1551{/dat}) {en16}Mathématicien{/en}. - Auteur d''un "Art poétique" [http://data.bnf.fr/ark:/12148/cb12509709h#foaf:Person]
{/ud}
{ud0}
Didier Henrion ({dat1551}1551{/dat}) {in0_1621}Professeur de mathématiques à Paris{/in}. - {en1633}Ingénieur{/en} au service des Provinces-Unies. - N''est pas un pseudonyme de Clément Cyriaque de Mangin [http://data.bnf.fr/ark:/12148/cb144882445#foaf:Person]
{/ud}
{ud0}
Eilhard Lubbin ({dat1551}1551{/dat}) {en1636}Cartographe{/en} et {en16}mathématicien{/en} à Rostock [http://data.bnf.fr/ark:/12148/cb153777849#foaf:Person]
{/ud}
{ud0}
Faustus Verantius (Sebenico aujord''hui Šibenik ({en0li}Croatie){/en}, {dat1551}1551{/dat}) Lexicographe, {en1630}physicien{/en} et {en16}mathématicien{/en}. - Évêque de Czanad (Hongrie) ({dat1594}1594{/dat}) et de la République de Venise. - Neveu d''Antun Vrančić (1504-1573) [http://data.bnf.fr/ark:/12148/cb10703670x#foaf:Person]
{/ud}
{ud0}
Francesco Feliciano ({dat1551}1551{/dat}) {en16}Mathématicien{/en}, augustinien et miniaturiste [http://data.bnf.fr/ark:/12148/cb13485419n#foaf:Person]
{/ud}
{ud0}
Francis Van Schoten ({dat1551}1551{/dat}) {in0_1621}Professeur de mathématiques à Leyde{/in}, {en1636}cartographe{/en} [http://data.bnf.fr/ark:/12148/cb15337130w#foaf:Person]
{/ud}
{ud0}
Francisco Zarzoso ({en0li}Cella, Espagne{/en}, {dat1551}1551{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb119512329#foaf:Person]
{/ud}
{ud0}
Giacomo Lanteri ({en0li}Paratico, Italie{/en}, {dat1551}1551{/dat}) {en16}Mathématicien{/en} et {en1633}ingénieur{/en} [http://data.bnf.fr/ark:/12148/cb104024969#foaf:Person]
{/ud}
{ud0}
Girolamo Mercurio ({dat1551}1551{/dat}) Dominicain. - {en28}Médecin{/en}, {in0_1621}professeur de logique et de mathématique {/in}[http://data.bnf.fr/ark:/12148/cb13484092c#foaf:Person]
{/ud}
{ud0}
Giuseppe Unicorno ({dat1551}1551{/dat}) {en16}Mathématicien{/en}. - {en18}Philosophe{/en}. - {en25}Astrologue{/en}. - Musicologue. - {en1629}Théologien{/en}. - Originaire de Bergame [http://data.bnf.fr/ark:/12148/cb125394931#foaf:Person]
{/ud}
{ud0}
Helisaeus Röslin ({dat1551}1551{/dat}) {en16}Mathématicien{/en}. - {en24}Astronome{/en}. - {en28}Médecin{/en} (pratiquait à Strasbourg et Francfort) [http://data.bnf.fr/ark:/12148/cb132003253#foaf:Person]
{/ud}
{ud0}
Jacques Besson ({en0li}Colombières (Italie){/en}, {dat1551}1551{/dat}) {en1633}Ingénieur{/en} et {en16}mathématicien{/en}. - Né à Colombières, vallée d''Oulx (aujourd''hui en Italie), d''après Eugénie Droz [http://data.bnf.fr/ark:/12148/cb12376654f#foaf:Person]
{/ud}
{ud0}
Jacques Maretz ({dat1551}1551{/dat}) Dessinateur et graveur, {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb153705873#foaf:Person]
{/ud}
{ud0}
Jamet Mettayer ({dat1551}1551{/dat}) Autre(s) graphie(s) : Metayer ; Messor ; Metayerus ; Mettayier. - Variante(s) de prénom : Jean ; Jean Jamet. - {en1632}Imprimeur{/en}-{en1631}libraire{/en} ; {en1632}imprimeur{/en} du Roi pour les mathématiques ({dat1580}1580{/dat}) et {en1632}imprimeur{/en} ordinaire du Roi (1583-1605). - En 1588, le roi Henri III le fait {en1632}imprimeur{/en} officiel de sa congrégation des pénitents de l''Annonciation. De 1588 à 1594, il suit le Roi et la Cour à Blois puis  à Tours. - De retour à Paris, doit partager sa charge avec Pierre L''Huillier et Fédéric II Morel en vertu de l''arrêt du Conseil du 20 avril 1594. Revend à Tours son atelier et sa boutique à l''{en1632}imprimeur{/en} Maurice Bouguereau. En mars  1596, le Roi l''associe à la Compagnie des usages avec Pierre L''Huillier. Décédé avant le 12 fév. 1605. Des publications paraissent encore sous son nom jusqu''en 1614. - A travaillé en association avec Mathurin Challenge ({dat1573}1573{/dat}) et Barthélemy Gomet à Blois. S''associe à Tours (oct. 1591 - oct. 1593) avec Jean Richer, Claude de Monstr''oeil, Sébastien Molin, Mathieu I Guillemot, Georges Drobet et Marc Orry, son gendre. Travaille en association étroite avec Pierre L''Huillier et avec son fils Pierre Mettayer qui se trouvaient eux aussi à Tours [http://data.bnf.fr/ark:/12148/cb125031934#foaf:Person]
{/ud}
{ud0}
Jean Brohon ({dat1551}1551{/dat}) {en28}Médecin{/en}, botaniste et {en24}astronome{/en}. - Fut recteur de l''Université de Caen [http://data.bnf.fr/ark:/12148/cb12545367f#foaf:Person]
{/ud}
{ud0}
Jean de Seville ({dat1551}1551{/dat}) {en16}Mathématicien{/en} et hydrographe [http://data.bnf.fr/ark:/12148/cb13496046w#foaf:Person]
{/ud}
{ud0}
Jean Maria Coloni ({dat1551}1551{/dat}) Citoyen de Romans en Dauphiné. - {en16}Mathématicien{/en} et {en25}astrologue{/en} [http://data.bnf.fr/ark:/12148/cb13479237s#foaf:Person]
{/ud}
{ud0}
Jean Tagaut ({dat1551}1551{/dat}) Poète. - {en28}Médecin{/en}, {en16}mathématicien{/en}, professeur à Lausanne et Genève [http://data.bnf.fr/ark:/12148/cb12249180j#foaf:Person]
{/ud}
{ud0}
Joannes Portantius ({dat1551}1551{/dat}) {en24}Astronome{/en}, {en16}mathématicien{/en} et {en29}géographe{/en} à Anvers, édité par Ortelius et De Jode [http://data.bnf.fr/ark:/12148/cb153817246#foaf:Person]
{/ud}
{ud0}
Johann Georg Locher ({dat1551}1551{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb13006978f#foaf:Person]
{/ud}
{ud0}
Juan de Rojas Sarmiento ({en0li}Palencia, Espagne{/en}, {dat1551}1551{/dat}) {en16}Mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb140653109#foaf:Person]
{/ud}
{ud0}
Marc Duncan ({dat1551}1551{/dat}) {en28}Médecin{/en}, originaire d''Écosse, s''établit à Saumur en 1606 à l''appel de l''Académie protestante de la ville. - Professeur de mathématiques, de grec et d''humanités [http://data.bnf.fr/ark:/12148/cb13006401g#foaf:Person]
{/ud}
{ud0}
Martin Basanier ({dat1551}1551{/dat}) {en16}Mathématicien{/en}, musicien [http://data.bnf.fr/ark:/12148/cb12510914p#foaf:Person]
{/ud}
{ud0}
Martinus Hortensius ({dat1551}1551{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb13007384z#foaf:Person]
{/ud}
{ud0}
Nicolaus Reimarus Ursus ({dat1551}1551{/dat}) {en16}Mathématicien{/en}. - {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb145753184#foaf:Person]
{/ud}
{ud0}
Paschasius Hamellius ({dat1551}1551{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb13173242d#foaf:Person]
{/ud}
{ud0}
Paul Yvon ({dat1551}1551{/dat}) {en16}Mathématicien{/en}. - Achète la seigneurie de Laleu en 1592 et y fait construire le château. - Maire de La Rochelle en 1616. - S'' installe à Paris en décembre 1633 et abjure le protestantisme [http://data.bnf.fr/ark:/12148/cb12135021d#foaf:Person]
{/ud}
{ud0}
Peter Laicksteen ({dat1551}1551{/dat}) {en1636}Cartographe{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb15370391s#foaf:Person]
{/ud}
{ud0}
Phillebert Charpentier ({dat1551}1551{/dat}) Éditeur. - Marchand d''estampes et d''instruments de mathématiques [http://data.bnf.fr/ark:/12148/cb16553551w#foaf:Person]
{/ud}
{ud0}
Pierre Forcadel ({dat1551}1551{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb103947442#foaf:Person]
{/ud}
{ud0}
Pierre Hérigone ({dat1551}1551{/dat}) {in0_1621}Professeur de mathématiques à Paris{/in}. - N''est pas un pseudonyme de Clément Cyriaque de Mangin [http://data.bnf.fr/ark:/12148/cb144882503#foaf:Person]
{/ud}
{ud0}
Pierre Le Voirier ({dat1551}1551{/dat}) Autre(s) graphie(s) : Le Voirrier ; Le Verrier. - {en1632}Imprimeur{/en} du Roi pour les mathématiques. - Beau-père de Mathieu I Guillemot ({dat1584}1584{/dat}). Encore en activité le 31 déc. 1589. Décédé entre 1591 et le 7 nov. 1594 (compte de succession) [http://data.bnf.fr/ark:/12148/cb12230743m#foaf:Person]
{/ud}
{ud0}
Teodato Osio ({dat1551}1551{/dat}) {en16}Mathématicien{/en}. - Musicien [http://data.bnf.fr/ark:/12148/cb125559272#foaf:Person]
{/ud}
{ud0}
Walther Hermann Ryff ({dat1551}1551{/dat}) Apothicaire, {en28}médecin{/en}, {en16}mathématicien{/en} et {en1635}architecte{/en} [http://data.bnf.fr/ark:/12148/cb11948264d#foaf:Person]
{/ud}
{ud0}
William Welwod ({dat1551}1551{/dat}) {en16}Mathématicien{/en}. - {in0_1621}Professeur de droit {/in}[http://data.bnf.fr/ark:/12148/cb125630488#foaf:Person]
{/ud}
{ud0}
Jost Bürgi ({dat1552}1552{/dat}) Horloger, {en24}astronome{/en} et {en16}mathématicien{/en} suisse [http://data.bnf.fr/ark:/12148/cb123814270#foaf:Person]
{/ud}
{ud0}
Bernardino Baldi ({en0li}Urbino, Italie{/en}, {dat1553}1553{/dat}) Abbé de Guastalla. - Poète, prosateur, {en16}mathématicien{/en} et historien. - Polyglotte, connaissait le grec et le latin, l''hébreu, l''arabe, le persan et le hongrois [http://data.bnf.fr/ark:/12148/cb12179488k#foaf:Person]
{/ud}
{ud0}
Jacob Christmann ({dat1554}1554{/dat}) Orientaliste, {en16}mathématicien{/en} et {en24}astronome{/en}. - A été le premier à utiliser le télescope avec d''autres instruments comme le sextant [http://data.bnf.fr/ark:/12148/cb12560133s#foaf:Person]
{/ud}
{ud0}
Giovanni Antonio Magini ({en0li}Padoue, Italie{/en}, {dat1555}1555{/dat}) {en24}Astronome{/en}, {en16}mathématicien{/en} et {en29}géographe{/en}. - A occupé la chaire d''astronomie à l''Université de Bologne en 1588. - Auteur prétendu de prédictions et de nombreux almanachs publiés en France, en Allemagne et aux Pays-Bas jusqu''au 19e siècle [http://data.bnf.fr/ark:/12148/cb12162475b#foaf:Person]
{/ud}
{ud0}
Jean Du Temps ({dat1555}1555{/dat}) Fils de l''avocat Jean Du Temps I, il fut lui-même avocat et avait des connaissances en astrologie et mathématique. Frère d''Adam Du Temps, spécialiste des fortifications qui participa peut-être à la carte du Blésois dont il est l''auteur [http://data.bnf.fr/ark:/12148/cb15302460t#foaf:Person]
{/ud}
{ud0}
Sethus Calvisius ({dat1556}1556{/dat}) Organiste, compositeur et théoricien de la musique ; {en24}astronome{/en} ; historien ; {en1631}libraire{/en} et éditeur de musique. - Natif de Gorsleben près de Sachsenburg (Thuringe) et issu d''une famille paysanne. Après des études aux universités de Leipzig et Helmstedt, il devient à partir de 1581 et jusqu''à sa mort "cantor" de plusieurs églises de Leipzig successivement. Auteur de plusieurs ouvrages théoriques et compositions musicales, ainsi que d''un "Opus chronologicum" (1605 ; au moins 6 rééd.) et d''un "Elenchus calendarii Gregoriani" ({dat1612}1612{/dat}). Décédé à Leipzig en nov. 1615. À distinguer du pasteur et prédicateur de Quedlinburg Sethus Calvisius (ou : Seth Kal(l)witz) (1639-1698), parfois appelé à tort "Sethus Calvisius le fils" [http://data.bnf.fr/ark:/12148/cb12875550d#foaf:Person]
{/ud}
{ud0}
Guillaume de Nautonier ({dat1557}1557{/dat}) Savant, {en16}mathématicien{/en}, {en24}astronome{/en}, d''origine protestante, {en29}géographe{/en} du roi Henri IV [http://data.bnf.fr/ark:/12148/cb12412403z#foaf:Person]
{/ud}
{ud0}
Christoph Meurer ({dat1558}1558{/dat}) Professeur de mathématiques à Leipzig ({dat1613}1613{/dat}). - {en28}Médecin{/en} [http://data.bnf.fr/ark:/12148/cb14333201g#foaf:Person]
{/ud}
{ud0}
Jean-Édouard Du Monin ({dat1559}1559{/dat}) {en16}Mathématicien{/en} et spécialiste des langues anciennes. - Fut professeur à Paris, puis à Poitiers [http://data.bnf.fr/ark:/12148/cb12463074n#foaf:Person]
{/ud}
{ud0}
Thomas Hariot ({en0li}Oxford, GB{/en}, {dat1560}1560{/dat}) {en16}Mathématicien{/en} et {en24}astronome{/en}. - Envoyé comme conseiller aux Amériques en 1585-86 [http://data.bnf.fr/ark:/12148/cb12215671c#foaf:Person]
{/ud}
{ud0}
Thomas Harriot ({dat1560}1560{/dat}) {en16}Mathématicien{/en}, {en1630}physicien{/en} et {en24}astronome{/en} anglais [http://data.bnf.fr/ark:/12148/cb124346111#foaf:Person]
{/ud}
{ud0}
Adrianus Romanus ({en0li}Louvain{/en}, {dat1561}1561{/dat}) {en28}Médecin{/en}, {en16}mathématicien{/en} et voyageur. - Enseigna à Louvain et à Würzburg, fut {en16}mathématicien{/en} royal en Pologne [http://data.bnf.fr/ark:/12148/cb12459969s#foaf:Person]
{/ud}
{ud0}
Bartholomäus Pitiscus ({dat1561}1561{/dat}) A aussi écrit en latin. - Prédicateur protestant à la cour de l''Électeur palatin. - Également auteur d''ouvrages mathématiques [http://data.bnf.fr/ark:/12148/cb121457326#foaf:Person]
{/ud}
{ud0}
Henry Briggs ({dat1561}1561{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12305061c#foaf:Person]
{/ud}
{ud0}
Jean Tarde (La Roque-Gageac ({en0li}Dordogne){/en}, {dat1561}1561{/dat}) {en16}Mathématicien{/en}, historien, {en29}géographe{/en} et {en24}astronome{/en}. - Chanoine [http://data.bnf.fr/ark:/12148/cb12641353z#foaf:Person]
{/ud}
{ud0}
Jean Tarde ({dat1561}1561{/dat}) Chanoine de Sarlat, {en16}mathématicien{/en} et {en1636}cartographe{/en} [http://data.bnf.fr/ark:/12148/cb153143878#foaf:Person]
{/ud}
{ud0}
P. Christoph Grienberger ({dat1561}1561{/dat}) Jésuite, {en16}mathématicien{/en}, {en24}astronome{/en} et {en1635}architecte{/en}. Il a realisé les plans du Collège d''Aurillac et du Charleville [http://data.bnf.fr/ark:/12148/cb10686921r#foaf:Person]
{/ud}
{ud0}
Philippus Lansbergen ({en0li}Gand (Belgique){/en}, {dat1561}1561{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en} et pasteur [http://data.bnf.fr/ark:/12148/cb130073828#foaf:Person]
{/ud}
{ud0}
Christen Sørensen Longomontanus ({dat1562}1562{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en}. - Fut l''élève de Tycho-Brahé. - Professeur de hautes mathématiques à l''Université de Copenhague [http://data.bnf.fr/ark:/12148/cb13011001c#foaf:Person]
{/ud}
{ud0}
Guangqi Xu ({en0li}Shanghai{/en}, {dat1562}1562{/dat}) Haut fonctionnaire chinois, initié et converti au christianisme par le père jésuite Matteo Ricci. - {en16}Mathématicien{/en}. - {en24}Astronome{/en}. - Disciple de Matteo Ricci [http://data.bnf.fr/ark:/12148/cb150892932#foaf:Person]
{/ud}
{ud0}
{en7}Galileo Galilei{/en} ({en0li}Pise, Italie{/en}, {dat1564}1564{/dat}) {en1630}Physicien{/en}, {en18}philosophe{/en}, {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb11903931b#foaf:Person]
{/ud}
{ud0}
Luis Teixeira ({dat1564}1564{/dat}) Jésuite portugais, {en16}mathématicien{/en} et {en1636}cartographe{/en} actif de 1564 à 1613 [http://data.bnf.fr/ark:/12148/cb153361957#foaf:Person]
{/ud}
{ud0}
Edward Brerewood ({dat1565}1565{/dat}) Antiquaire et {en16}mathématicien{/en}, linguiste et humaniste. - Professeur d''astronomie au Gresham college de Londres [http://data.bnf.fr/ark:/12148/cb125109678#foaf:Person]
{/ud}
{ud0}
Eilhard Lubin ({dat1565}1565{/dat}) Humaniste, philologue, {en1636}cartographe{/en}, {en1629}théologien{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb15040859j#foaf:Person]
{/ud}
{ud0}
Paolo Antonio Foscarini ({en0li}Montalto Uffugo, Italie{/en}, {dat1565}1565{/dat}) Carme. - {en1629}Théologien{/en}. - {en16}Mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb12377530d#foaf:Person]
{/ud}
{ud0}
Scipione Chiaramonti ({en0li}Cesena, Italie{/en}, {dat1565}1565{/dat}) {en24}Astronome{/en} et {en18}philosophe{/en}. - Professeur de philosophie à l''Université de Pise [http://data.bnf.fr/ark:/12148/cb10545041n#foaf:Person]
{/ud}
{ud0}
Fr. François d'' Aguillon ({dat1566}1566{/dat}) Jésuite, {en1635}architecte{/en} et {en16}mathématicien{/en}. Auteur d''un projet pour le noviciat de Tournai. Préposé de la Maison professe, professeur d''Anvers [http://data.bnf.fr/ark:/12148/cb16240952w#foaf:Person]
{/ud}
{ud0}
Georg Ludwig Frobenius ({dat1566}1566{/dat}) {en1631}Libraire{/en}. - Natif d''Iphofen, près de Wurzbourg. Titulaire d''une maîtrise de théologie. Après des études aux universités de Tübingen et Wittenberg, travaille avec l''{en24}astronome{/en} Tycho Brahe jusqu''à la mort de celui-ci. Reçu ensuite bourgeois de Hambourg, où il s''établit {en1631}libraire{/en} [http://data.bnf.fr/ark:/12148/cb12229506t#foaf:Person]
{/ud}
{ud0}
Marco Antonio De Dominis (l''île de Rab ({en0li}Croatie){/en}, {dat1566}1566{/dat}) {in0_1621}Professeur de rhétorique, mathématiques et philosophie dans la Compagnie de Jésus, à Padoue et Brescia{/in}. - Evêque de Segna (Senj ou Zengg en Croatie) de 1600 à 1602; de Spalato (Split) de 1602 à 1615. - Gagné au protestantisme et exilé en Angleterre, doyen de Windsor. - Abjure et rentre en grâce ({dat1622}1622{/dat}) [http://data.bnf.fr/ark:/12148/cb121335726#foaf:Person]
{/ud}
{ud0}
Marinus Ghetaldus (Raguse aujourd''hui Dubrovnik ({en0li}Croatie){/en}, {dat1566}1566{/dat}) {en16}Mathématicien{/en} et {en1630}physicien{/en}. - Il exerça une grande influence sur le développement de l''application de l''algèbre à la géométrie. - Il mit au point le miroir parabolique, aujourd''hui conservé au National Maritime Museum de Londres. - Il collabora, entre autres, avec François Viète en France et avec {en7}Galilée{/en} en Italie [http://data.bnf.fr/ark:/12148/cb146476018#foaf:Person]
{/ud}
{ud0}
François de Aguilón ({dat1567}1567{/dat}) {en1635}Architecte{/en} et {en16}mathématicien{/en} belge d''origine espagnole [http://data.bnf.fr/ark:/12148/cb119998212#foaf:Person]
{/ud}
{ud0}
Johann Hartmann ({dat1568}1568{/dat}) {en16}Mathématicien{/en} et naturaliste. - Professeur de chimie à l''Université de Marburg [http://data.bnf.fr/ark:/12148/cb13009199x#foaf:Person]
{/ud}
{ud0}
P. Jacques de Guernisac ({dat1568}1568{/dat}) Jésuite et {en1635}architecte{/en}, professeur de mathématique à Pont-à-Mousson puis à La Flèche, recteur du collège des Jésuites de Quimper [http://data.bnf.fr/ark:/12148/cb16215104d#foaf:Person]
{/ud}
{ud0}
Mutio Oddi ({dat1569}1569{/dat}) {en16}Mathématicien{/en}. - {en1635}Architecte{/en} [http://data.bnf.fr/ark:/12148/cb165299645#foaf:Person]
{/ud}
{ud0}
Andrea Argoli ({dat1570}1570{/dat}) {en16}Mathématicien{/en}. - {en24}Astronome{/en}. - Professeur de mathématique à l''Université de Padoue [http://data.bnf.fr/ark:/12148/cb121593328#foaf:Person]
{/ud}
{ud0}
Erasmus Schmied ({dat1570}1570{/dat}) Né à Delitzsch, près de Leipzig. - {in0_1621}Professeur de grec et de mathématiques à Wittenberg {/in}[http://data.bnf.fr/ark:/12148/cb12045847b#foaf:Person]
{/ud}
{ud0}
Anders Bure ({dat1571}1571{/dat}) {en1636}Cartographe{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb14509982d#foaf:Person]
{/ud}
{ud0}
Giovanni Branca ({dat1571}1571{/dat}) {en1635}Architecte{/en}, {en1633}ingénieur{/en} et {en16}mathématicien{/en}. - Né à Pesaro, meurt à Pérouse [http://data.bnf.fr/ark:/12148/cb121826472#foaf:Person]
{/ud}
{ud0}
Johannes Isaacus Pontanus ({en0li}Elseneur (Danemark){/en}, {dat1571}1571{/dat}) Historien. - Philologue. - {in0_1621}Professeur de mathématiques et de physique {/in}[http://data.bnf.fr/ark:/12148/cb123875836#foaf:Person]
{/ud}
{ud0}
Johannes Kepler ({dat1571}1571{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb11909597m#foaf:Person]
{/ud}
{ud0}
Willem Jansz Blaeu ({dat1571}1571{/dat}) Autre(s) graphie(s) : Janssonius Blaeuw. - {en1632}Imprimeur{/en}-{en1631}libraire{/en} et éditeur de cartes et d''atlas. - Originaire d''Alkmaar ou des environs. Passe 2 ans auprès de Tycho Brahé au Danemark. À son retour à Amsterdam en 1596, s''établit {en1636}cartographe{/en} et fabricant de globes terrestres et célestes. Monte ensuite une imprimerie et une fonderie. Également auteur d''ouvrages cartographiques et astronomiques [http://data.bnf.fr/ark:/12148/cb12169772t#foaf:Person]
{/ud}
{ud0}
Cornelius Drebbel ({dat1572}1572{/dat}) Graveur. - {en16}Mathématicien{/en}. - {en1630}Physicien{/en}. - Chimiste [http://data.bnf.fr/ark:/12148/cb12382467g#foaf:Person]
{/ud}
{ud0}
Rodolphus Goclenius ({dat1572}1572{/dat}) Docteur en {en28}médecin{/en}e en 1601. - {in0_1621}Professeur de physique en 1608{/in}. - {in0_1621}Professeur de mathématiques à l''Université de Marbourg en 1621{/in} [http://data.bnf.fr/ark:/12148/cb121595722#foaf:Person]
{/ud}
{ud0}
Samuel Marolois ({dat1572}1572{/dat}) {en16}Mathématicien{/en} français ayant vécu une grande partie de sa vie aux Pays-Bas [http://data.bnf.fr/ark:/12148/cb14912871p#foaf:Person]
{/ud}
{ud0}
Thomas Lydyat ({en0li}Okerton, GB{/en}, {dat1572}1572{/dat}) {en16}Mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb12390032f#foaf:Person]
{/ud}
{ud0}
Christoph Scheiner ({dat1575}1575{/dat}) Jésuite. - {en1630}Physicien{/en}, {en16}mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb13483688j#foaf:Person]
{/ud}
{ud0}
Michelangelo Galilei ({dat1575}1575{/dat}) Luthiste et compositeur italien de la Renaissance. - Fils du compositeur et théoricien Vincenzo Galilei, et frère de l''{en24}astronome{/en} {en7}Galileo Galilei{/en} [http://data.bnf.fr/ark:/12148/cb140013401#foaf:Person]
{/ud}
{ud0}
Octavio Pisani ({en0li}Naples, Italie{/en}, {dat1575}1575{/dat}) Cosmographe et {en24}astronome{/en}, travaille à Anvers de 1612 à 1637 [http://data.bnf.fr/ark:/12148/cb15404394h#foaf:Person]
{/ud}
{ud0}
Francesco Ingoli ({en0li}Ravenne (Italie){/en}, {dat1578}1578{/dat}) Secrétaire de la propagande, débat avec Copernic (en 1616 et 1624) et écrit Relazione delle quattro parti del mondo avec pour objectif de soutenir missions et propagande religieuses. - Étudie l''astronomie, la cosmographie et la géographie et connait le grec, le français, l''espagnon et l''arabe. - Diplômé en droit civil et en droit canon à l''Université de Padoue, Italie [http://data.bnf.fr/ark:/12148/cb13749501h#foaf:Person]
{/ud}
{ud0}
Sybrandt Hansz. Cardinael (Harlingen (Pays-Bas), {dat1578}1578{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb15944052f#foaf:Person]
{/ud}
{ud0}
Cristóvão Ferreira ({dat1580}1580{/dat}) Supérieur et procurateur de la mission jésuite au Japon, il abjura en 1633 et se convertit au zen. - Auteur en 1636 de la "Supercherie dévoilée". - Traducteur d''ouvrages d''astronomie et de chirurgie [http://data.bnf.fr/ark:/12148/cb13524212c#foaf:Person]
{/ud}
{ud0}
Godfried Wendelen ({dat1580}1580{/dat}) {en24}Astronome{/en} et géomètre. - Avocat au Parlement de Paris puis doyen du chapitre de Rothnac, Belgique [http://data.bnf.fr/ark:/12148/cb123969373#foaf:Person]
{/ud}
{ud0}
Joannes Michael Gigas ({dat1580}1580{/dat}) Docteur, {en16}mathématicien{/en} et {en29}géographe{/en} édité par Blaeu et Hondius [http://data.bnf.fr/ark:/12148/cb153239798#foaf:Person]
{/ud}
{ud0}
Johann Faulhaber ({dat1580}1580{/dat}) {en16}Mathématicien{/en} allemand. S''est aussi intéressé à l''ingénierie des fortifications [http://data.bnf.fr/ark:/12148/cb137778453#foaf:Person]
{/ud}
{ud0}
Nicolas-Claude Fabri Peiresc ({en0li}Belgentier (Var){/en}, {dat1580}1580{/dat}) Conseiller au Parlement de Provence. - {en24}Astronome{/en}, archéologue et naturaliste [http://data.bnf.fr/ark:/12148/cb11918940q#foaf:Person]
{/ud}
{ud0}
Willebrordus Snellius (Leyde, Pays-Bas, {dat1580}1580{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en} et {en29}géographe{/en} [http://data.bnf.fr/ark:/12148/cb15336105f#foaf:Person]
{/ud}
{ud0}
Claude-Gaspard Bachet (Bourg-en-Bresse ({en0li}Ain){/en}, {dat1581}1581{/dat}) {en16}Mathématicien{/en} et littérateur. - Sieur de Méziriac. - Érudit, auteur de poèmes en français, italien et latin. - Membre de l''Académie française (élu en 1634) [http://data.bnf.fr/ark:/12148/cb120028244#foaf:Person]
{/ud}
{ud0}
Alexandre Anderson ({dat1582}1582{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb16296598k#foaf:Person]
{/ud}
{ud0}
Jean François ({dat1582}1582{/dat}) Nom en religion de Jean Charnage. - Jésuite. - {in0_1621}Professeur de philosophie et de mathématiques à La Flèche{/in} [http://data.bnf.fr/ark:/12148/cb121629197#foaf:Person]
{/ud}
{ud0}
Mario Bettini ({en0li}Bologne, Italie{/en}, {dat1582}1582{/dat}) Jésuite. - {en18}Philosophe{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12545452p#foaf:Person]
{/ud}
{ud0}
Matthias Bernegger ({en0li}Hallstatt (Autriche){/en}, {dat1582}1582{/dat}) Philologue, historien, {en16}mathématicien{/en} et {en24}astronome{/en}. - Protestant. - Professeur d''histoire et d''éloquence à Strasbourg, recteur de l''Université de cette même ville [http://data.bnf.fr/ark:/12148/cb129928534#foaf:Person]
{/ud}
{ud0}
Jean-Baptiste Morin (Villefranche-sur-Saône ({en0li}Rhône){/en}, {dat1583}1583{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb11916881j#foaf:Person]
{/ud}
{ud0}
Orazio Grassi ({en0li}Savone, Italie{/en}, {dat1583}1583{/dat}) Jésuite. - {en16}Mathématicien{/en}, {en24}astronome{/en} et {en1635}architecte{/en} [http://data.bnf.fr/ark:/12148/cb125377863#foaf:Person]
{/ud}
{ud0}
Filippo Finella ({en0li}Naples, Italie{/en}, {dat1584}1584{/dat}) {en25}Astrologue{/en}. - {en24}Astronome{/en}. - Auteur dramatique [http://data.bnf.fr/ark:/12148/cb122006609#foaf:Person]
{/ud}
{ud0}
Grégoire de Saint-Vincent ({dat1584}1584{/dat}) {en16}Mathématicien{/en}. - {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb16197665z#foaf:Person]
{/ud}
{ud0}
James Hume ({dat1584}1584{/dat}) {en16}Mathématicien{/en}. - {en24}Astronome{/en}. - Historien. - Hébraïsant. - Actif en 1639. - A vécu à Paris. - Fils de David Hume (1558-163.) et frère aîné de la poétesse et traductrice Anna Hume (1586?-16..) [http://data.bnf.fr/ark:/12148/cb12072629r#foaf:Person]
{/ud}
{ud0}
Claude Mydorge ({dat1585}1585{/dat}) {en16}Mathématicien{/en} et {en1630}physicien{/en} [http://data.bnf.fr/ark:/12148/cb144888873#foaf:Person]
{/ud}
{ud0}
Mario Guiducci ({en0li}Florence, Italie{/en}, {dat1585}1585{/dat}) Homme de lettres et {en24}astronome{/en}. - A collaboré avec {en7}Galileo Galilei{/en} [http://data.bnf.fr/ark:/12148/cb144609004#foaf:Person]
{/ud}
{ud0}
Melchior Inchofer ({en0li}Vienne{/en}, {dat1585}1585{/dat}) Jésuite. - {en18}Philosophe{/en}, {en16}mathématicien{/en} et {en1629}théologien{/en} professeur à Messine, Italie [http://data.bnf.fr/ark:/12148/cb10735485h#foaf:Person]
{/ud}
{ud0}
Philipp Müller ({dat1585}1585{/dat}) {en16}Mathématicien{/en}, {en28}médecin{/en}, chimiste et botaniste. - Professeur à l''université de Leipzig [http://data.bnf.fr/ark:/12148/cb14065362j#foaf:Person]
{/ud}
{ud0}
Jean L''Hoste ({en0li}Nancy{/en}, {dat1586}1586{/dat}) {en1633}Ingénieur{/en}. - Intendant des fortifications du duc de Lorraine. - Professeur de droit et de mathématiques à Pont-à-Mousson [http://data.bnf.fr/ark:/12148/cb16628764j#foaf:Person]
{/ud}
{ud0}
Niccolò Zucchi ({en0li}Parme, Italie{/en}, {dat1586}1586{/dat}) Jésuite. - Recteur du Collegio romano (1646-1649). - {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb10077816w#foaf:Person]
{/ud}
{ud0}
Benedetto Castelli ({en0li}Brescia, Italie{/en}, {dat1587}1587{/dat}) Dominicain. - {en16}Mathématicien{/en}, inventeur et écrivain. - Disciple de {en7}Galilée{/en}, dont il défendit les théories astronomiques [http://data.bnf.fr/ark:/12148/cb12545385c#foaf:Person]
{/ud}
{ud0}
Joachim Jungius ({dat1587}1587{/dat}) Naturaliste, {en16}mathématicien{/en} et {en18}philosophe{/en} [http://data.bnf.fr/ark:/12148/cb120247195#foaf:Person]
{/ud}
{ud0}
Libert Froidmont ({en0li}Liège{/en}, {dat1587}1587{/dat}) {en1629}Théologien{/en}. - {en16}Mathématicien{/en}, {en1630}physicien{/en} et géologue [http://data.bnf.fr/ark:/12148/cb14462868z#foaf:Person]
{/ud}
{ud0}
François Derand ({dat1588}1588{/dat}) Jésuite. - {in0_1621}Professeur de grammaire et de mathématiques{/in}. - {en1635}Architecte{/en}. - Né à Vic s/Seille (Moselle), mort à Agde (Hérault) [http://data.bnf.fr/ark:/12148/cb13012148j#foaf:Person]
{/ud}
{ud0}
Jacques Grandami ({dat1588}1588{/dat}) Jésuite. - {in0_1621}Professeur de belles lettres, de philosophie et de théologie{/in}, puis recteur de Bourges, Rennes, La Flèche, Tours et Rouen. - Visiteur de la province de France. - {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb12155155d#foaf:Person]
{/ud}
{ud0}
Marin Mersenne ({dat1588}1588{/dat}) {en18}Philosophe{/en} et savant, {en24}astronome{/en}, {en16}mathématicien{/en}. - Théoricien de la musique. - Minime [http://data.bnf.fr/ark:/12148/cb119157157#foaf:Person]
{/ud}
{ud0}
Eberhard Welper ({dat1590}1590{/dat}) {en1632}Imprimeur{/en}-{en1631}libraire{/en}. - Natif de Lohra (comté de Lohenstein, près de Marburg, Allemagne). {en16}Mathématicien{/en}, {en25}astrologue{/en} et {en24}astronome{/en}, il se fixe à Strasbourg en 1618. Établi {en1631}libraire{/en} en 1620 puis {en1632}imprimeur{/en} dès 1621. Publie notamment chaque année un almanach et des prédictions. Auteur de plusieurs ouvrages scientifiques, dont des "Elementa geometrica..." (1re éd., {dat1620}1620{/dat}), une "Gnomonica" ({dat1625}1625{/dat}), un "Compendium astronomiae..." ({dat1634}1634{/dat}) et un traité de la divination, "Rota-Fortunae, oder Glück-Rad..." (s. d., plusieurs rééd.). De 1634 à 1639, assure des fonctions d''enseignant au Gymnase (lycée) de Strasbourg. En 1654, sollicite en vain la charge d''{en1632}imprimeur{/en} de l''évêché de Saverne. De 1653 à 1661, imprime sous le pseudonyme de Hartmann Bär quelques ouvrages pour l''académie des Jésuites à Molsheim. Son fils aîné Johann Welper (1642-1720) lui succède en 1664, mais des éditions paraissent encore sous son nom en 1689. Son autre fils Eberhard (II) Welper (1644-1670) sera lui aussi {en16}mathématicien{/en}, {en25}astrologue{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb158750586#foaf:Person]
{/ud}
{ud0}
Johannes Wilhelm Lauremberg ({dat1590}1590{/dat}) Auteur, {en16}mathématicien{/en} et historien à Rostock [http://data.bnf.fr/ark:/12148/cb15377794m#foaf:Person]
{/ud}
{ud0}
Jean Leurechon (Bar-le-Duc, {dat1591}1591{/dat}) Jésuite. - Professeur de philosophie et de mathématiques, à Pont-à-Mousson notamment. - Confesseur du duc de Lorraine Charles IV. - Henry Van Etten, qui signe la dédicace de la première édition des "Récréations mathématiques" n''est pas un pseudonyme de Jean Leurechon, mais le nom d''un de ses élèves, qui aurait réellement existé d''après Trevor H. Hall [http://data.bnf.fr/ark:/12148/cb13009618g#foaf:Person]
{/ud}
{ud0}
Joseph Salomon Delmedigo ({dat1591}1591{/dat}) {en28}Médecin{/en}. - {en24}Astronome{/en}. - {en16}Mathématicien{/en}. - Né en Crète. - Fils d''Eliya Delmedigo (1460-1497) [http://data.bnf.fr/ark:/12148/cb122623548#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Vertova ({en0li}Bergame, Italie{/en}, {dat1592}1592{/dat}) {en16}Mathématicien{/en} et {en1633}ingénieur{/en} militaire. - Chevalier de l''Ordre de Malte [http://data.bnf.fr/ark:/12148/cb15093021d#foaf:Person]
{/ud}
{ud0}
Johann Adam Schall von Bell ({dat1592}1592{/dat}) Jésuite. - Missionnaire en Chine (de 1619 à sa mort). - {en16}Mathématicien{/en}. - Conseiller et {en24}astronome{/en} de la Cour impériale de Chine [http://data.bnf.fr/ark:/12148/cb12362941r#foaf:Person]
{/ud}
{ud0}
Pierre Gassendi ({en0li}Champtercier, près de Digne{/en}, {dat1592}1592{/dat}) {en18}Philosophe{/en}, {en24}astronome{/en}, {en16}mathématicien{/en}, {en1630}physicien{/en}, docteur en théologie et théoricien de la musique. - Entre dans les ordres en 1615 [http://data.bnf.fr/ark:/12148/cb120250393#foaf:Person]
{/ud}
{ud0}
Wilhelm Schickard ({en0li}Herrenberg, Allemagne{/en}, {dat1592}1592{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en}, professeur d''agriculture [http://data.bnf.fr/ark:/12148/cb11969696s#foaf:Person]
{/ud}
{ud0}
Albert Girard (Saint-Mihiel, {dat1595}1595{/dat}) {en16}Mathématicien{/en} et {en1633}ingénieur{/en}. - {en1633}Ingénieur{/en} dans l''armée de Frédéric de Nassau, prince d''Orange [http://data.bnf.fr/ark:/12148/cb121123333#foaf:Person]
{/ud}
{ud0}
Pierre Bardin ({en0li}Rouen{/en}, {dat1595}1595{/dat}) Homme de lettres, {en18}philosophe{/en} et {en16}mathématicien{/en}. - Précepteur. - Membre de l''Académie française (élu en 1634) [http://data.bnf.fr/ark:/12148/cb125272379#foaf:Person]
{/ud}
{ud0}
Pierre Bourdin ({dat1595}1595{/dat}) Jésuite. - {in0_1621}Professeur de mathématiques{/in} [http://data.bnf.fr/ark:/12148/cb123902440#foaf:Person]
{/ud}
{ud0}
Daniel Mögling ({en0li}Böblingen{/en}, {dat1596}1596{/dat}) Alchimiste, rosicrucien, {en28}médecin{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb167575369#foaf:Person]
{/ud}
{ud0}
Jacob Golius ({dat1596}1596{/dat}) Orientaliste. - {en16}Mathématicien{/en}. - Philologue, spécialiste des littératures [http://data.bnf.fr/ark:/12148/cb123338386#foaf:Person]
{/ud}
{ud0}
René Descartes (Descartes (Indre-et-Loire), {dat1596}1596{/dat}) {en18}Philosophe{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb11899775j#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Hodierna ({dat1597}1597{/dat}) {en24}Astronome{/en} italien [http://data.bnf.fr/ark:/12148/cb120704558#foaf:Person]
{/ud}
{ud0}
Bonaventura Cavalieri ({en0li}Milan, Italie{/en}, {dat1598}1598{/dat}) Jésuite. - {en16}Mathématicien{/en}, géomètre et {en24}astronome{/en}, disciple de {en7}Galilée{/en}. - Fut professeur à l''Université de Bologne [http://data.bnf.fr/ark:/12148/cb12085151g#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Riccioli ({en0li}Ferrare, Italie{/en}, {dat1598}1598{/dat}) Jésuite. - {en24}Astronome{/en}. - {in0_1621}Professeur de lettres, de philosophie et de théologie, à Parme puis à Bologne{/in}. - {en16}Mathématicien{/en} et historien de la géographie [http://data.bnf.fr/ark:/12148/cb12546680q#foaf:Person]
{/ud}
{ud0}
Pierre Petit ({dat1598}1598{/dat}) {en16}Mathématicien{/en} et {en1630}physicien{/en}. - Intendant général des ports et fortifications de France ({dat1649}1649{/dat}) [http://data.bnf.fr/ark:/12148/cb123944733#foaf:Person]
{/ud}
{ud0}
Adam Olearius ({en0li}Aschersleben, Allemagne{/en}, {dat1599}1599{/dat}) Voyageur, en particulier en Russie et en Perse. - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12817277v#foaf:Person]
{/ud}
{ud0}
Jacob Aertsz Colom ({dat1599}1599{/dat}) {en16}Mathématicien{/en}, navigateur et {en1636}cartographe{/en}. - {en1632}Imprimeur{/en} à Amsterdam [http://data.bnf.fr/ark:/12148/cb153358650#foaf:Person]
{/ud}
{ud0}
Adriaan Vlacq ({dat1600}1600{/dat}) Autre(s) graphie(s) : Ulack ; Vlac. - Variante(s) de prénom : Adriaen ; Adrien. - {en1632}Imprimeur{/en}-{en1631}libraire{/en}. - Originaire de Gouda. Édite différents périodiques dont "De Haegsche Vrijdaeghse Post-Tijdingen". A publié en 1659 une contrefaçon de Johannes Elzevier et de Pieter Leffen. A également publié sous les fausses adresses et pseudonymes de "Cologne, Pierre Du Marteau" et "Amsterdam, Peter Le Grand". - Également {en16}mathématicien{/en} connu pour ses travaux sur les logarithmes et auteur d''ouvrages d''astronomie et de pamphlets en faveur des royalistes anglais en 1652-1655. Mort peu avant le 8 avril 1667. Des éd. paraissent encore sous son nom jusqu''en 1669, en association avec Johannes Vlacq [http://data.bnf.fr/ark:/12148/cb121635061#foaf:Person]
{/ud}
{ud0}
Antoine de Laloubère ({dat1600}1600{/dat}) Jésuite. - {en16}Mathématicien{/en} et géomètre, fut le premier scientifique à étudier les propriétés de l''hélice. - Polémiqua avec Pascal, qui l''appelle "Allouerus" dans l''"Histoire de la roulette". - {in0_1621}Professeur de rhétorique, de théologie et de mathématiques au collège de Toulouse{/in}. - Né à Rieux, meurt à Toulouse [http://data.bnf.fr/ark:/12148/cb13006798h#foaf:Person]
{/ud}
{ud0}
Giacomo Oddi ({dat1600}1600{/dat}) {en1636}Cartographe{/en} et {en16}mathématicien{/en}. Etudie à Naples [http://data.bnf.fr/ark:/12148/cb153917817#foaf:Person]
{/ud}
{ud0}
Jakob Bartsch ({dat1600}1600{/dat}) {en28}Médecin{/en}. - {in0_1621}Professeur de mathématiques à Strasbourg{/in}. - {en24}Astronome{/en}. - Gendre et collaborateur de l''{en24}astronome{/en} Johann Kepler (1571-1630) [http://data.bnf.fr/ark:/12148/cb12163632v#foaf:Person]
{/ud}
{ud0}
Emmanuel Maignan ({dat1601}1601{/dat}) Religieux minime. - {en18}Philosophe{/en}, {en16}mathématicien{/en} et peintre. - Membre de la Société des lanternistes [http://data.bnf.fr/ark:/12148/cb130127157#foaf:Person]
{/ud}
{ud0}
Florimond de Beaune ({dat1601}1601{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb11890827s#foaf:Person]
{/ud}
{ud0}
Ovidio Montalbani ({dat1601}1601{/dat}) Docteur en philosophie et {en28}médecin{/en}e de l'' Université de Bologne, professeur de mathématiques, chargé du musée Aldrovandi à partir de 1657, fut aussi un citoyen actif de Bologne, où il assura plusieurs magistratures ("giudice del Foro de mercanti, e de tribuni della plebe"). - Membre de l''Accademia dei Gelati de Bologne ("l''Innestato"), de l''Accademia degli Indomiti de Bologne ("lo Stellato"), et de l''Accademia della Notte de Bologne ("il Rugiadoso") [http://data.bnf.fr/ark:/12148/cb12064289s#foaf:Person]
{/ud}
{ud0}
Pierre de Fermat (Beaumont-de-Lomagne (Tarn-et-Garonne), {dat1601}1601{/dat}) {en16}Mathématicien{/en}, célèbre pour son théorème. - On lui doit aussi le Principe de Fermat en optique. - Conseiller au Parlement de Toulouse et commissaire en la chambre des requêtes du Palais à Toulouse (mai 1631) [http://data.bnf.fr/ark:/12148/cb11902568b#foaf:Person]
{/ud}
{ud0}
Athanasius Kircher ({en0li}Geisa (Allemagne){/en}, {dat1602}1602{/dat}) Jésuite. - {in0_1621}Professeur de physique, de mathématiques et de langues orientales, Collegio Romano, Rome{/in}. - Dessinateur et graveur [http://data.bnf.fr/ark:/12148/cb119097824#foaf:Person]
{/ud}
{ud0}
Gilles Personne de Roberval ({en0li}Roberval, Oise{/en}, {dat1602}1602{/dat}) Professeur de philosophie ({dat1634}1634{/dat}) et de mathématiques ({dat1655}1655{/dat}) au Collège royal, Paris. - Membre fondateur de l''Académie royale des sciences [http://data.bnf.fr/ark:/12148/cb12144923j#foaf:Person]
{/ud}
{ud0}
Jacques de Billy ({dat1602}1602{/dat}) Jésuite (à partir de 1619). - {en16}Mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb123773436#foaf:Person]
{/ud}
{ud0}
John Greaves ({en0li}Colemore, GB{/en}, {dat1602}1602{/dat}) {en16}Mathématicien{/en}. - Orientaliste. - Professeur d''astronomie à Londres puis à Oxford [http://data.bnf.fr/ark:/12148/cb129277690#foaf:Person]
{/ud}
{ud0}
Pierre Gautruche ({dat1602}1602{/dat}) Jésuite. - {in0_1621}Professeur de philosophie, de théologie et de mathématiques{/in}. - Identifié par certains à Pierre Gautier (1599-16..), luthiste et compositeur [http://data.bnf.fr/ark:/12148/cb121990328#foaf:Person]
{/ud}
{ud0}
Blaise-François de Pagan ({en0li}Avignon{/en}, {dat1604}1604{/dat}) {en1633}Ingénieur{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb12155087r#foaf:Person]
{/ud}
{ud0}
Claude Hardy ({dat1604}1604{/dat}) Fils de Sébastien Hardy. - Conseiller au Châtelet. - {en16}Mathématicien{/en}. - Ami de Mydorge, Descartes et du Père Mersenne ; souvent cité dans la correspondance de ces deux derniers [http://data.bnf.fr/ark:/12148/cb12134536k#foaf:Person]
{/ud}
{ud0}
Bernard Frénicle de Bessy ({dat1605}1605{/dat}) {en16}Mathématicien{/en}, géomètre et arithméticien. - Membre de l''Académie des Sciences. - Conseiller à la Cour des monnaies [http://data.bnf.fr/ark:/12148/cb12459881c#foaf:Person]
{/ud}
{ud0}
Ismaël Boulliau ({en0li}Loudun (Vienne){/en}, {dat1605}1605{/dat}) {en24}Astronome{/en}. - Secrétaire de Jacques Du Puy et attaché au président de Thou [http://data.bnf.fr/ark:/12148/cb124621511#foaf:Person]
{/ud}
{ud0}
Juan de Caramuel y Lobkowitz ({en0li}Madrid{/en}, {dat1606}1606{/dat}) Cistercien. - Evêque de Satriano et Campagna (1657-1673) puis de Vigevano (1673-). - Humaniste, {en1629}théologien{/en}, {en16}mathématicien{/en}, {en18}philosophe{/en} et {en1635}architecte{/en}. - Défenseur de la doctrine probabiliste [http://data.bnf.fr/ark:/12148/cb12392566m#foaf:Person]
{/ud}
{ud0}
Evangelista Torricelli ({en0li}Faenza, Italie{/en}, {dat1608}1608{/dat}) {en1630}Physicien{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12117674q#foaf:Person]
{/ud}
{ud0}
Gaspar Schott ({en0li}Königshaufen, Allemagne{/en}, {dat1608}1608{/dat}) {en16}Mathématicien{/en} et {en1630}physicien{/en}. - Jésuite [http://data.bnf.fr/ark:/12148/cb12519717b#foaf:Person]
{/ud}
{ud0}
Giovanni Alfonso Borelli ({en0li}Naples, Italie{/en}, {dat1608}1608{/dat}) {en16}Mathématicien{/en}, phycisien, {en28}médecin{/en}, {en18}philosophe{/en}. - Membre de l''Accademia del Cimento [http://data.bnf.fr/ark:/12148/cb12462534j#foaf:Person]
{/ud}
{ud0}
Giovan Battista Nicolosi ({en0li}Paternò, Italie{/en}, {dat1610}1610{/dat}) {en29}Géographe{/en} et {en1636}cartographe{/en}. - Professeur de mathématiques et de géographie à l''Université de Rome [http://data.bnf.fr/ark:/12148/cb15404103t#foaf:Person]
{/ud}
{ud0}
Józef Naronowicz-Naroński ({dat1610}1610{/dat}) {en16}Mathématicien{/en}. - {en1636}Cartographe{/en}. - {en1635}Architecte{/en} au service de la famille Radzwill. - Né en Lituanie [http://data.bnf.fr/ark:/12148/cb150812338#foaf:Person]
{/ud}
{ud0}
Maria Cunitia ({dat1610}1610{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb162514419#foaf:Person]
{/ud}
{ud0}
Jan Heweliusz ({dat1611}1611{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb121054498#foaf:Person]
{/ud}
{ud0}
John Pell ({dat1611}1611{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb146515879#foaf:Person]
{/ud}
{ud0}
Michael Floris Van Langren ({dat1612}1612{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en} du roi d''Espagne installé à Bruxelles [http://data.bnf.fr/ark:/12148/cb153283774#foaf:Person]
{/ud}
{ud0}
Francesco Maria Grimaldi ({dat1613}1613{/dat}) Jésuite. - {en18}Philosophe{/en}, {en24}astronome{/en}, opticien et {in0_1621}professeur de mathématiques{/in}. - Né et mort à Bologne [http://data.bnf.fr/ark:/12148/cb13326913s#foaf:Person]
{/ud}
{ud0}
François Chauveau ({dat1613}1613{/dat}) Grava des cartouches notamment pour Nicolas Sanson. Eut un neveu du nom de François Chauveau. Son frère, Jean-Baptiste, habile {en1633}ingénieur{/en} et {en16}mathématicien{/en} fut assassiné en 1670. [http://data.bnf.fr/ark:/12148/cb15302394v#foaf:Person]
{/ud}
{ud0}
Jean François Nicéron ({en0li}Paris{/en}, {dat1613}1613{/dat}) Religieux de l''Ordre des minimes. - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb14404933t#foaf:Person]
{/ud}
{ud0}
Tommaso Cornelio ({en0li}Rovito, Italie{/en}, {dat1614}1614{/dat}) {en28}Médecin{/en}, {en18}philosophe{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb13484167f#foaf:Person]
{/ud}
{ud0}
Frans Van Schooten ({dat1615}1615{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12529949q#foaf:Person]
{/ud}
{ud0}
John Wallis ({dat1616}1616{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb123396143#foaf:Person]
{/ud}
{ud0}
Jonas Moore ({dat1617}1617{/dat}) {en16}Mathématicien{/en} britannique. - S''est intéressé aux mathématiques appliquées (astronomie, cosmographie, architecture...) [http://data.bnf.fr/ark:/12148/cb135104102#foaf:Person]
{/ud}
{ud0}
Tito Livio Burattini ({en0li}Agordo, Italie{/en}, {dat1617}1617{/dat}) {en16}Mathématicien{/en}, {en1636}cartographe{/en} et égyptologue [http://data.bnf.fr/ark:/12148/cb162142362#foaf:Person]
{/ud}
{ud0}
Anthelme (Chatenay-Vaudin (Haute-Marne), {dat1618}1618{/dat}) Religieux de la Chartreuse de Dijon. - {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb106267229#foaf:Person]
{/ud}
{ud0}
Charles Cavendish ({dat1620}1620{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb14651592w#foaf:Person]
{/ud}
{ud0}
Jean Picard ({en0li}La Flèche (Sarthe){/en}, {dat1620}1620{/dat}) {en24}Astronome{/en}. - Membre de l''Académie des sciences ({dat1666}1666{/dat}) [http://data.bnf.fr/ark:/12148/cb11941359d#foaf:Person]
{/ud}
{ud0}
Claude-François Milliet de Chales ({dat1621}1621{/dat}) {en16}Mathématicien{/en}. - Professeur d''hydrographie à Marseille [http://data.bnf.fr/ark:/12148/cb12397222c#foaf:Person]
{/ud}
{ud0}
Adrien Auzout ({en0li}Rouen{/en}, {dat1622}1622{/dat}) {en24}Astronome{/en}, {en1630}physicien{/en} et {en16}mathématicien{/en}. - A contribué au développement du micromètre [http://data.bnf.fr/ark:/12148/cb134752474#foaf:Person]
{/ud}
{ud0}
Jean Bertet ({dat1622}1622{/dat}) Jésuite, quitte la Compagnie en 1681 pour entrer chez les Bénédictins. - {in0_1621}Professeur de rhétorique, philosophie et mathématiques{/in}. - Poète [http://data.bnf.fr/ark:/12148/cb11999230c#foaf:Person]
{/ud}
{ud0}
René-François De Sluse ({dat1622}1622{/dat}) {en16}Mathématicien{/en}. - Chanoine de la Cathédrale de Liège et abbé d''Amay [http://data.bnf.fr/ark:/12148/cb12427294z#foaf:Person]
{/ud}
{ud0}
Vincenzo Viviani ({en0li}Florence, Italie{/en}, {dat1622}1622{/dat}) Florentin. - {en16}Mathématicien{/en}. - Membre de l'' "accademia della Crusca" [http://data.bnf.fr/ark:/12148/cb12000373g#foaf:Person]
{/ud}
{ud0}
Blaise Pascal (Clermont-Ferrand (Puy-de-Dôme), {dat1623}1623{/dat}) {en16}Mathématicien{/en}, {en1630}physicien{/en}, écrivain. - Frère de : Pascal, Jacqueline (1625-1661) [http://data.bnf.fr/ark:/12148/cb11918679x#foaf:Person]
{/ud}
{ud0}
Ferdinand Verbiest ({en0li}Pitthem, Belgique{/en}, {dat1623}1623{/dat}) Jésuite, missionnaire en Chine. - {en24}Astronome{/en}. - Fut placé à la tête du tribunal des mathématiques, chargé de la rédaction des éphémérides et de la direction des fonderies de canons. - A publié en langue chinoise, sous le nom de Nanhoai-jin, un grand nombre d''ouvrages scientifiques [http://data.bnf.fr/ark:/12148/cb12215344n#foaf:Person]
{/ud}
{ud0}
Camillo Guarino Guarini ({en0li}Modène, Italie{/en}, {dat1624}1624{/dat}) Clerc régulier, théatin. - {en1635}Architecte{/en} du duc de Savoie, {en18}philosophe{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12348027r#foaf:Person]
{/ud}
{ud0}
Christoph Wittich ({dat1625}1625{/dat}) {en1629}Théologien{/en}. - {in0_1621}Professeur de mathématiques et de théologie{/in} [http://data.bnf.fr/ark:/12148/cb13014027s#foaf:Person]
{/ud}
{ud0}
Erhard Weigel ({dat1625}1625{/dat}) {en18}Philosophe{/en}. - {in0_1621}Professeur de mathématiques, maître de Leibniz et de Pufendorf{/in} [http://data.bnf.fr/ark:/12148/cb11935908x#foaf:Person]
{/ud}
{ud0}
Jean-Dominique Cassini ({en0li}Perinaldo (comté de Nice){/en}, {dat1625}1625{/dat}) Titulaire de la chaire d''astronomie de Bologne de 1650 à 1669, surintendant des eaux du Bolonais de 1657 à 1669, surintendant des eaux de l''Etat pontifical et titulaire d''autres charges auprès du pape. - Appelé en France an avril 1669 par Louis XIV. - Membre de l''Académie des sciences, directeur de l''Observatoire de Paris (à partir de 1672). - Naturalisé français en 1673 [http://data.bnf.fr/ark:/12148/cb121019904#foaf:Person]
{/ud}
{ud0}
Johan de Witt (Dordrecht, Pays-Bas, {dat1625}1625{/dat}) Homme d''état et {en16}mathématicien{/en}. - Grand pensionnaire de Hollande [http://data.bnf.fr/ark:/12148/cb13598046j#foaf:Person]
{/ud}
{ud0}
Johann Hecker ({en0li}Gdansk (Pologne){/en}, {dat1625}1625{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb12875545t#foaf:Person]
{/ud}
{ud0}
Rasmus Bartholin ({en0li}Roskilde, Danemark{/en}, {dat1625}1625{/dat}) {en1630}Physicien{/en}. - {en16}Mathématicien{/en}. - {en28}Médecin{/en}. - Professeur de mathématiques et de {en28}médecin{/en}e à Copenhague. - A découvert la difraction de la lumière. - Fils de Kaspar Bartholin [http://data.bnf.fr/ark:/12148/cb11890430k#foaf:Person]
{/ud}
{ud0}
Samuel Morland ({dat1625}1625{/dat}) {en16}Mathématicien{/en} et inventeur [http://data.bnf.fr/ark:/12148/cb10365749d#foaf:Person]
{/ud}
{ud0}
Pietro Mengoli ({en0li}Bologne (Italie){/en}, {dat1626}1626{/dat}) {en16}Mathématicien{/en}. - Professeur de mécanique (1650-1678) puis titulaire de la chaire de mathématiques et d''astronomie (1678-1686) à l''université de Bologne [http://data.bnf.fr/ark:/12148/cb120851477#foaf:Person]
{/ud}
{ud0}
John Ray ({en0li}Black Notley (Essex){/en}, {dat1627}1627{/dat}) {in0_1621}Professeur de mathématiques et de lettres{/in}. - Naturaliste. - Botaniste. - Membre de la Société royale de Londres [http://data.bnf.fr/ark:/12148/cb12220184b#foaf:Person]
{/ud}
{ud0}
Heinrich Scherer ({dat1628}1628{/dat}) Jésuite, {en29}géographe{/en} et {in0_1621}professeur de mathématiques à Munich{/in} [http://data.bnf.fr/ark:/12148/cb15317471w#foaf:Person]
{/ud}
{ud0}
Johannes Hudde ({dat1628}1628{/dat}) {en16}Mathématicien{/en}, élève de Frans Van Schooten. - Bourgmestre de la ville d''Amsterdam [http://data.bnf.fr/ark:/12148/cb13488288n#foaf:Person]
{/ud}
{ud0}
Christiaan Huygens ({dat1629}1629{/dat}) {en16}Mathématicien{/en} et {en24}astronome{/en}. - A vécu aux Pays-Bas et en France. - Élu membre de la "Royal society" de Londres (en 1663) [http://data.bnf.fr/ark:/12148/cb12192922r#foaf:Person]
{/ud}
{ud0}
Allain Manesson-Mallet ({en0li}Paris (France){/en}, {dat1630}1630{/dat}) {en1633}Ingénieur{/en} et {en1636}cartographe{/en}. - Maître de mathématiques des pages du roi de France, sergent-major d''artillerie du roi de Portugal [http://data.bnf.fr/ark:/12148/cb153363577#foaf:Person]
{/ud}
{ud0}
Isaac Barrow ({dat1630}1630{/dat}) {en16}Mathématicien{/en} et {en1629}théologien{/en} [http://data.bnf.fr/ark:/12148/cb12340135q#foaf:Person]
{/ud}
{ud0}
Jean Richer ({dat1630}1630{/dat}) {en24}Astronome{/en} à l''Observatoire de Paris, il figure parmi les premiers membres de l''Académie des sciences ({dat1666}1666{/dat}). - Chargé d''une mission géodésique à Cayenne (1672-73) [http://data.bnf.fr/ark:/12148/cb14064426q#foaf:Person]
{/ud}
{ud0}
Adam Adamady Kochánski ({dat1631}1631{/dat}) {en16}Mathématicien{/en} polonais, auteur de la rectification approchée de la circonférence. Réside en 1677 à Wroclaw [http://data.bnf.fr/ark:/12148/cb16187484g#foaf:Person]
{/ud}
{ud0}
Francesco Lana Terzi ({en0li}Brescia, Italie{/en}, {dat1631}1631{/dat}) Jésuite. - {en16}Mathématicien{/en}, naturaliste. - Pionnier de l''aéronautique [http://data.bnf.fr/ark:/12148/cb10681783j#foaf:Person]
{/ud}
{ud0}
Christopher Wren ({en0li}East Knoyle, Wiltshire, GB{/en}, {dat1632}1632{/dat}) {en1635}Architecte{/en}. - {en16}Mathématicien{/en} et {en24}astronome{/en}, Sir Christopher Wren fut l''un des membres fondateurs de la Société royale des sciences [http://data.bnf.fr/ark:/12148/cb121401670#foaf:Person]
{/ud}
{ud0}
Alessandro Marchetti ({en0li}Empoli, Italie{/en}, {dat1633}1633{/dat}) Poète naturaliste, l''un des principaux animateurs du courant naturaliste toscan de la seconde moitié du XVIIe siècle. - Professeur de philosophie puis de mathématiques à l''Université de Pise [http://data.bnf.fr/ark:/12148/cb12570345j#foaf:Person]
{/ud}
{ud0}
Donato Rossetti ({en0li}Livourne, Italie{/en}, {dat1633}1633{/dat}) {en16}Mathématicien{/en}. - Professeur de philosophie au "Studio" de Pise [http://data.bnf.fr/ark:/12148/cb144820894#foaf:Person]
{/ud}
{ud0}
Geminiano Montanari ({en0li}Modène, Italie{/en}, {dat1633}1633{/dat}) Docteur en droit, {en16}mathématicien{/en} et {en24}astronome{/en}. - Enseigne à Florence, Modène (1661-1664), Bologne (chaire de mathématiques, 1664-1677) et Padoue (chaire d''astronomie, 1678-1687). - Membre de l''Accademia dei Gelati ("l''Elevato") et de l''Accademia della Treccia de Bologne [http://data.bnf.fr/ark:/12148/cb12309300z#foaf:Person]
{/ud}
{ud0}
Gerhard Wolter Molanus ({dat1633}1633{/dat}) {en1629}Théologien{/en} luthérien. - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12133744h#foaf:Person]
{/ud}
{ud0}
Giovanni Giustino Ciampini ({en0li}Rome{/en}, {dat1633}1633{/dat}) Historien, archéologue, {en16}mathématicien{/en}. - Membre de la Curie pontificale [http://data.bnf.fr/ark:/12148/cb14323561z#foaf:Person]
{/ud}
{ud0}
Vitale Giordano ({dat1633}1633{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb15520924m#foaf:Person]
{/ud}
{ud0}
Johann Christoph Sturm ({en0li}Hilpolstein, Allemagne{/en}, {dat1635}1635{/dat}) {en18}Philosophe{/en}, {en16}mathématicien{/en} et {en1630}physicien{/en}. - Professeur à l''université d''Altdorf [http://data.bnf.fr/ark:/12148/cb133240234#foaf:Person]
{/ud}
{ud0}
Ignace-Gaston Pardies ({dat1636}1636{/dat}) {en16}Mathématicien{/en}. - Jésuite. - Il a enseigné la philosophie puis les mathématiques au collège Louis-Le-Grand [http://data.bnf.fr/ark:/12148/cb12174258w#foaf:Person]
{/ud}
{ud0}
Elias van Lennep (Borculo, Pays-Bas, {dat1637}1637{/dat}) Graveur. - {en1633}Ingénieur{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb15053499m#foaf:Person]
{/ud}
{ud0}
Julius Reichelt ({dat1637}1637{/dat}) {en16}Mathématicien{/en} strasbourgeois [http://data.bnf.fr/ark:/12148/cb15377331m#foaf:Person]
{/ud}
{ud0}
François Barrême ({en0li}Tarascon, France{/en}, {dat1638}1638{/dat}) {en16}Mathématicien{/en} et financier [http://data.bnf.fr/ark:/12148/cb118903320#foaf:Person]
{/ud}
{ud0}
Georg Christoph Eimmart ({en0li}Ratisbonne (Allemagne){/en}, {dat1638}1638{/dat}) Peintre d''histoire, portraitiste, graveur, {en16}mathématicien{/en} et {en24}astronome{/en}. - Fils et élève du peintre Georg-Christoph Eimmart (1603-1658), dit le vieux [http://data.bnf.fr/ark:/12148/cb12983761h#foaf:Person]
{/ud}
{ud0}
James Gregory ({dat1638}1638{/dat}) {en16}Mathématicien{/en} et opticien écossais [http://data.bnf.fr/ark:/12148/cb12459917j#foaf:Person]
{/ud}
{ud0}
Jean Bonfa ({en0li}Nîmes{/en}, {dat1638}1638{/dat}) Est admis à la Société de Jésus en 1654. - Dans les années 1670 jusqu''en 1683, il enseigne les mathématiques et la théologie aux collèges jésuites de Grenoble, puis d''Avignon. - De 1680 à 1682, enseigne la géométrie et l''hydrographie. - Effectue des travaux astronomiques. - Devient membre correspondant de l''Académie royale des sciences (en 1699) [http://data.bnf.fr/ark:/12148/cb15130186g#foaf:Person]
{/ud}
{ud0}
Jacques Ozanam (Sainte-Olive ({en0li}Ain){/en}, {dat1640}1640{/dat}) {en16}Mathématicien{/en}. - {in0_1621}Professeur de mathématiques à Paris et à Lyon{/in} [http://data.bnf.fr/ark:/12148/cb120960958#foaf:Person]
{/ud}
{ud0}
Philippe de La Hire ({en0li}Paris (France){/en}, {dat1640}1640{/dat}) {en16}Mathématicien{/en}. - Géomètre et {en24}astronome{/en}. - {in0_1621}Professeur de mathématiques au Collège de France{/in}. - Membre de l''Académie des sciences ({dat1678}1678{/dat}) [http://data.bnf.fr/ark:/12148/cb121592847#foaf:Person]
{/ud}
{ud0}
Pierre Ango ({dat1640}1640{/dat}) Jésuite. - Enseigna les humanités, les mathématiques et la philosophie. - Né à Rouen, mort à La Flèche [http://data.bnf.fr/ark:/12148/cb12512101m#foaf:Person]
{/ud}
{ud0}
Denis Papin ({dat1642}1642{/dat}) {en1630}Physicien{/en}. - Un des précurseurs de l''invention de la machine à vapeur, qui eu l''idée du piston (dés 1690), et inspira la machine que l''Anglais Thomas Newcomen (1664-1729), mis au point ensuite (en 1712). - Quitta définitivement la France, après la révocation de l''Édit de Nantes ({dat1685}1685{/dat}). - Occupa une chaire de mathématiques à l''Université de Marburg, Allemagne ({dat1687}1687{/dat}). - Rédige un article (Ars nova ad aquam ignis...) présentant sa machine dans la revue " Acta Eruditorum", Leipzig (en 1707), revue célèbre pour les publications de Leibniz (1646-1716), sur le calcul différentiel et intégral [http://data.bnf.fr/ark:/12148/cb12087889k#foaf:Person]
{/ud}
{ud0}
Isaac Newton (Woolsthorpe, Lincolnshire ({en0li}GB){/en}, {dat1642}1642{/dat}) {en1630}Physicien{/en}, {en16}mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb119176085#foaf:Person]
{/ud}
{ud0}
Johann Welper ({dat1642}1642{/dat}) Variante(s) de prénom : Johannes ; Jean. - {en1632}Imprimeur{/en}-{en1631}libraire{/en}. - Fils et apprenti d''Eberhard Welper, {en1632}imprimeur{/en}-{en1631}libraire{/en} et {en16}mathématicien{/en} à Strasbourg. A été compagnon pendant 6 ans à Ulm, Augsbourg, Munich, Vienne, Leipzig et Nuremberg, avant de succéder à son père. L''enquête de 1700-1701 le dit âgé de 60 ans et "établi à Strasbourg depuis 42 ans". À sa mort, son entreprise est rachetée par Melchior Pauschinger [http://data.bnf.fr/ark:/12148/cb160636269#foaf:Person]
{/ud}
{ud0}
Michel Mourgues ({dat1642}1642{/dat}) Jésuite. - Enseigna la rhétorique et les mathématiques à l''Université de Toulouse [http://data.bnf.fr/ark:/12148/cb124637183#foaf:Person]
{/ud}
{ud0}
Takakazu Seki ({dat1642}1642{/dat}) {en16}Mathématicien{/en} japonais [http://data.bnf.fr/ark:/12148/cb12443516f#foaf:Person]
{/ud}
{ud0}
Jean Jombert ({dat1643}1643{/dat}) {en1631}Libraire{/en}. - Fils d''un fruitier et marchand de vins parisien. En apprentissage chez le {en1631}libraire{/en} parisien Pierre II Baudouin à partir de janv. 1666, il travaille en 1670-1671 chez Louis Billaine et Pierre Le Petit, puis chez la veuve de Pierre I Baudouin à partir de 1672. Gendre en 1res noces ({dat1671}1671{/dat}) du {en1631}libraire{/en} Jean d''Houry. Publie sous son propre nom dès 1680, peut-être dès 1678, mais n''est reçu maître que le 17 sept. 1686. Publie de nombreux ouvrages de mathématiques. Dit âgé d''env. 60 ans lors de l''enquête de nov.-déc. 1701. Testaments le 9 août 1704 et le 6 oct. 1705. Décédé au début de nov. 1705. Sa veuve lui succède [http://data.bnf.fr/ark:/12148/cb15074749j#foaf:Person]
{/ud}
{ud0}
Antoine Thomas ({en0li}Namur{/en}, {dat1644}1644{/dat}) Jésuite (à partir de 1660). - {en16}Mathématicien{/en} et {en24}astronome{/en} de l''empereur de Chine [http://data.bnf.fr/ark:/12148/cb10636254r#foaf:Person]
{/ud}
{ud0}
Johann Jakob Zimmermann ({en0li}Vaihingen an der Enz, Allemagne{/en}, {dat1644}1644{/dat}) {en1629}Théologien{/en}, {en16}mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb10721479d#foaf:Person]
{/ud}
{ud0}
Ole Rømer ({en0li}Åarhus, Danemark{/en}, {dat1644}1644{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb12324191r#foaf:Person]
{/ud}
{ud0}
Carlos de Sigüenza y Góngora ({en0li}Mexico{/en}, {dat1645}1645{/dat}) {en24}Astronome{/en}, {en16}mathématicien{/en}, poète, historien. - Sa bibliothèque, comprenant des documents uniques sur l''histoire du Mexique, disparut dans un incendie lors de l''insurrection de 1692 [http://data.bnf.fr/ark:/12148/cb121021638#foaf:Person]
{/ud}
{ud0}
Eusebio Francisco Kino ({en0li}Taio, Italie{/en}, {dat1645}1645{/dat}) {en16}Mathématicien{/en} et {en29}géographe{/en} de formation. - Jésuite, arrive au Mexique en 1681 [http://data.bnf.fr/ark:/12148/cb122190783#foaf:Person]
{/ud}
{ud0}
Maximilian Rassler ({en0li}Waldsee (Allemagne){/en}, {dat1645}1645{/dat}) Jésuite. - {in0_1621}Professeur de réthorique, de mathématiques, philosophie et contreverse{/in}. - Recteur et chancelier de l''Université de Dillingen, Allemagne [http://data.bnf.fr/ark:/12148/cb158132748#foaf:Person]
{/ud}
{ud0}
Elena Lucrezia Cornaro Piscopia ({en0li}Venise (Italie){/en}, {dat1646}1646{/dat}) {en18}Philosophe{/en} et {en16}mathématicien{/en}ne. - Première femme docteur en philosophie [http://data.bnf.fr/ark:/12148/cb16591183r#foaf:Person]
{/ud}
{ud0}
Francesco Maria Pompeo Colonna ({en0li}Rome{/en}, {dat1646}1646{/dat}) {en16}Mathématicien{/en}, {en1630}physicien{/en} et occultiste. - Vécut à Paris à partir de 1668 [http://data.bnf.fr/ark:/12148/cb118973978#foaf:Person]
{/ud}
{ud0}
Harald Vallerius ({dat1646}1646{/dat}) Professeur universitaire de mathématiques [http://data.bnf.fr/ark:/12148/cb16032560b#foaf:Person]
{/ud}
{ud0}
John Flamsteed ({dat1646}1646{/dat}) {en24}Astronome{/en}. - Fut le premier directeur de l''Observatoire de Greenwich, GB, fondé en 1675 [http://data.bnf.fr/ark:/12148/cb13524243n#foaf:Person]
{/ud}
{ud0}
John Flamsteed ({dat1646}1646{/dat}) {en24}Astronome{/en} britannique. Fut le premier directeur de l''observatoire de Greenwich, fondé en 1675 [http://data.bnf.fr/ark:/12148/cb13510391m#foaf:Person]
{/ud}
{ud0}
Niccolò Partenio Giannettasio ({dat1648}1648{/dat}) Jésuite. - Historien et poète. - Professeur de mathématiques et d''hébreu au Collège des Jésuites de Naples. - Né à Naples, meurt à Massa [http://data.bnf.fr/ark:/12148/cb133256727#foaf:Person]
{/ud}
{ud0}
Tommaso Ceva ({dat1648}1648{/dat}) Jésuite. - {en18}Philosophe{/en}, {en24}astronome{/en}, {en1630}physicien{/en} et poète. - Membre de l''Académie de l''Arcadie sous le pseudonyme : Callimaco Neridio [http://data.bnf.fr/ark:/12148/cb13321850h#foaf:Person]
{/ud}
{ud0}
Jean Le Febvre ({en0li}Lisieux (Calvados){/en}, {dat1650}1650{/dat}) Tisserand, puis {en24}astronome{/en}. - Membre de l''Académie des sciences de 1682 à 1702 [http://data.bnf.fr/ark:/12148/cb16176897g#foaf:Person]
{/ud}
{ud0}
Michelangelo Fardella ({dat1650}1650{/dat}) Franciscain. - {en18}Philosophe{/en}, {en24}astronome{/en} et {en16}mathématicien{/en}. - Professeur de philosophie, de théologie, de mathématiques, professeur d''astronomie et de physique à l''Université de Padoue (1694-). - Né à Trapani, meurt à Naples [http://data.bnf.fr/ark:/12148/cb12093422f#foaf:Person]
{/ud}
{ud0}
Andreas Cellarius ({dat1651}1651{/dat}) {en16}Mathématicien{/en} et {en29}géographe{/en} hollandais actif de 1656 à 1702. En 1660 il est recteur de l''Ecole latine de Hoorn [http://data.bnf.fr/ark:/12148/cb15338282n#foaf:Person]
{/ud}
{ud0}
Antoine-François Payen ({en0li}Avignon{/en}, {dat1651}1651{/dat}) Jurisconsulte et {en24}astronome{/en}. - Enseigna la jurisprudence civile dès 1642 à Avignon [http://data.bnf.fr/ark:/12148/cb144713316#foaf:Person]
{/ud}
{ud0}
Arent Roggeveen ({dat1651}1651{/dat}) {en16}Mathématicien{/en}, navigateur et hydrographe [http://data.bnf.fr/ark:/12148/cb153879695#foaf:Person]
{/ud}
{ud0}
Bingzhen Jiao ({dat1651}1651{/dat}) Peintre et {en16}mathématicien{/en} à la cour de l''empereur Kangxi [http://data.bnf.fr/ark:/12148/cb14546684c#foaf:Person]
{/ud}
{ud0}
Caspar Dauthendey ({dat1651}1651{/dat}) {en1635}Architecte{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb153778194#foaf:Person]
{/ud}
{ud0}
Claude Bonjour ({dat1651}1651{/dat}) Augustin du couvent de Pontarlier. {en29}Géographe{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb15294805z#foaf:Person]
{/ud}
{ud0}
Claude Comiers ({dat1651}1651{/dat}) {en1629}Théologien{/en} et {en16}mathématicien{/en}, né à Embrun. Chanoine d''Embrun, {en1633}ingénieur{/en} des armées, puis prévôt de l''église collégiale de Ternant, professeur de mathématiques à Paris ; protonotaire apostolique et officier du Saint-Office. - Il a laissé des livres et des articles sur des sujets variés : géométrie, astronomie, {en28}médecin{/en}e, occultisme, physique... [http://data.bnf.fr/ark:/12148/cb12250531g#foaf:Person]
{/ud}
{ud0}
Claude Irson ({dat1651}1651{/dat}) {en16}Mathématicien{/en} et grammairien. - A été teneur de comptes vers 1678 [http://data.bnf.fr/ark:/12148/cb125155096#foaf:Person]
{/ud}
{ud0}
de La Roche ({dat1651}1651{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb13009642b#foaf:Person]
{/ud}
{ud0}
Ehrenfried Walter von Tschirnhaus ({en0li}Kieslingswalde, Allemagne{/en}, {dat1651}1651{/dat}) {en18}Philosophe{/en}, {en16}mathématicien{/en} et biologiste. - Industriel, considéré comme l''inventeur de la porcellaine blanche en Europe [http://data.bnf.fr/ark:/12148/cb12515471b#foaf:Person]
{/ud}
{ud0}
Federico Gualdi ({dat1651}1651{/dat}) Alchimiste, {en24}astronome{/en}, {en16}mathématicien{/en}. - {en18}Philosophe{/en} hermétique. - Membre de la Rose-croix d''Or. - Serait d''origine allemande ou italienne [http://data.bnf.fr/ark:/12148/cb150904929#foaf:Person]
{/ud}
{ud0}
Francesco Levera ({en0li}Savoie{/en}, {dat1651}1651{/dat}) {en18}Philosophe{/en}, {en24}astronome{/en} et {en1629}théologien{/en} [http://data.bnf.fr/ark:/12148/cb10442558v#foaf:Person]
{/ud}
{ud0}
François Chevalier (Sainte-Maur, {dat1651}1651{/dat}) Elève de l''abbé Galloys. Associé géomètre à l''Académie des sciences en 1707. Pensionnaire mécanicien en 1725. {in0_1621}Professeur de mathématiques au Collège de France{/in}. Maître de mathématiques du roi et des pages de la Petite Ecurie. Présenta en 1707 à l''Académie une méthode de collecte des informations cartographiques sur des châssis concentriques [http://data.bnf.fr/ark:/12148/cb153045899#foaf:Person]
{/ud}
{ud0}
François Noël (Hestrud, Pays-Bas Méridionaux, {dat1651}1651{/dat}) Jésuite (à partir de 1670) ordonné prêtre en 1682. - Missionnaire en Chine, il fut envoyé à Rome à l''occasion de la querelle des rites, et ne put rentrer en Chinê. - Il enseigna ensuite à Prague. - Auteur de poésies et de théâtre, d''un traité d''astronomie, de traductions et d''un ouvrage catéchétique en chinois [http://data.bnf.fr/ark:/12148/cb16653645d#foaf:Person]
{/ud}
{ud0}
Guisnée ({dat1651}1651{/dat}) {en16}Mathématicien{/en}. - Membre de l''Académie royale des sciences [http://data.bnf.fr/ark:/12148/cb14618149h#foaf:Person]
{/ud}
{ud0}
Jacques Mengau ({dat1651}1651{/dat}) {in0_1621}Professeur de mathématiques{/in}. - Auteur de mazarinades. - Actif de 1648 à 1652 [http://data.bnf.fr/ark:/12148/cb12166762s#foaf:Person]
{/ud}
{ud0}
Jean Bachou ({dat1651}1651{/dat}) {en16}Mathématicien{/en} et alchimiste lyonnais. - Avocat au parlement [http://data.bnf.fr/ark:/12148/cb12158814g#foaf:Person]
{/ud}
{ud0}
Jean Glover ({dat1651}1651{/dat}) {en1633}Ingénieur{/en} et {en16}mathématicien{/en} originaire d''Écosse et établi en France. - Auteur notamment de plusieurs propositions de loteries et d''une "Nouvelle Manière d''exécuter les loteries..." ({en0li}Paris{/en}, {dat1705}1705{/dat}). - Se qualifie d''"esquire, seigneur de Glaideny et de la baronnie de Baltillée en Ecosse" [http://data.bnf.fr/ark:/12148/cb15818830h#foaf:Person]
{/ud}
{ud0}
Jean-Baptiste Delure ({dat1651}1651{/dat}) Éditeur d''estampes et de cartes géographiques. - {en1633}Ingénieur{/en} pour les instruments de mathématiques et fabricant de cartes et de globes ; éditeur occasionnel [http://data.bnf.fr/ark:/12148/cb153164066#foaf:Person]
{/ud}
{ud0}
Joachim d'' Alencé ({dat1651}1651{/dat}) {en24}Astronome{/en} et {en1630}physicien{/en} [http://data.bnf.fr/ark:/12148/cb12397878n#foaf:Person]
{/ud}
{ud0}
Joanne Westenburg ({dat1651}1651{/dat}) {en1636}Cartographe{/en}, {en28}médecin{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb15377993t#foaf:Person]
{/ud}
{ud0}
Johann Andreas Planer ({en0li}Strelen, Allemagne{/en}, {dat1651}1651{/dat}) {en16}Mathématicien{/en}. - Professeur de mathématiques à l''Université de Wittenberg [http://data.bnf.fr/ark:/12148/cb16672375p#foaf:Person]
{/ud}
{ud0}
Le Blanc ({dat1651}1651{/dat}) Professeur de mathématiques ({dat1692}1692{/dat}). - Réside rue de Seine à Paris en 1692 [http://data.bnf.fr/ark:/12148/cb16650697x#foaf:Person]
{/ud}
{ud0}
Le Demaine Godalles ({dat1651}1651{/dat}) Hydrographe, {en1633}Ingénieur{/en} du roi et {in0_1621}professeur de Mathématiques, {en1635}Architecte{/en}{/in} [http://data.bnf.fr/ark:/12148/cb15375819n#foaf:Person]
{/ud}
{ud0}
Philip Lea ({dat1651}1651{/dat}) {en1636}Cartographe{/en}, fabricant et éditeur de globes, de cartes, d''instruments de mathématiques, actif de 1666 à 1700 à Londres [http://data.bnf.fr/ark:/12148/cb15328427v#foaf:Person]
{/ud}
{ud0}
René Gaultier de Maignannes ({dat1651}1651{/dat}) {en16}Mathématicien{/en} angevin. - Spécialiste de la perspective [http://data.bnf.fr/ark:/12148/cb12536157m#foaf:Person]
{/ud}
{ud0}
David François de Merveilleux ({dat1652}1652{/dat}) {en29}Géographe{/en} et {en1636}cartographe{/en}. Connaissances mathématiques étendues (il publie un traîté d''arithmétique et de géométrie). En 1695 il entre au service de Guillaume III qui lui accorde le brevet de Capitaine {en1633}Ingénieur{/en} au service d''Angleterre et des Etats généraux [http://data.bnf.fr/ark:/12148/cb15304894q#foaf:Person]
{/ud}
{ud0}
Michel Rolle (Ambert (Puy-de-Dôme), {dat1652}1652{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb130110121#foaf:Person]
{/ud}
{ud0}
Nicolas Bion ({dat1652}1652{/dat}) {en1633}Ingénieur{/en} du roi pour les instruments de mathématique. - Avait un atelier à Paris, quai de l''Horloge, qui était l''un des mieux achalandés du temps. - Son "Usage des globes" connut 6 éditions entre 1699 et 1751. - Édita en 1694 le globe terrestre de P. Courtin (diam. 25 cm) et en 1712 une paire de globes de même diamètre, un globe céleste antérieur à 1710 atteignit 32 cm de diamètre [http://data.bnf.fr/ark:/12148/cb152909089#foaf:Person]
{/ud}
{ud0}
José Chaffrion ({dat1653}1653{/dat}) {en1636}Cartographe{/en} et {en16}mathématicien{/en} de Valence en Espagne [http://data.bnf.fr/ark:/12148/cb15330290b#foaf:Person]
{/ud}
{ud0}
Bernard Nieuwentijt (West Graftdijk, Pays-Bas, {dat1654}1654{/dat}) {en18}Philosophe{/en}, {en28}médecin{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb14587835s#foaf:Person]
{/ud}
{ud0}
Jacques Bernoulli ({en0li}Bâle, Suisse{/en}, {dat1654}1654{/dat}) {en16}Mathématicien{/en} et {en24}astronome{/en}. - Professeur de mathématiques à l''université de Bâle, Suisse [http://data.bnf.fr/ark:/12148/cb120751142#foaf:Person]
{/ud}
{ud0}
Jean Pigeon ({en0li}Donzy (Nièvre){/en}, {dat1654}1654{/dat}) Peintre, {en16}mathématicien{/en} et facteur de globes, {en29}géographe{/en} du Duc d''Orléans à partir de 1714 [http://data.bnf.fr/ark:/12148/cb15147433m#foaf:Person]
{/ud}
{ud0}
Jean-François Gerbillon ({dat1654}1654{/dat}) Jésuite. - {en16}Mathématicien{/en}, fut envoyé en Chine par Louis XIV en 1685. - Écrivit des traités de géométrie et de l''usage de l''astrolabe en chinois et en tartare. - Supérieur général de la Mission française de Chine [http://data.bnf.fr/ark:/12148/cb124622770#foaf:Person]
{/ud}
{ud0}
Philippe Avril ({en0li}Angoulême (Charente){/en}, {dat1654}1654{/dat}) Missionnaire. - Voyageur, jésuite dès 1670, il enseigna les mathématiques à Louis-le-Grand. - Chercha un nouveau passage vers la Chine par la Tartarie, le Kurdistan et l''Arménie [http://data.bnf.fr/ark:/12148/cb15327596q#foaf:Person]
{/ud}
{ud0}
Philippe Naudé ({en0li}Metz{/en}, {dat1654}1654{/dat}) {en1629}Théologien{/en} et {en16}mathématicien{/en}. - Se réfugia en Prusse après la révocation de l''Édit de Nantes [http://data.bnf.fr/ark:/12148/cb10366497p#foaf:Person]
{/ud}
{ud0}
Pierre Varignon ({en0li}Caen (Calvados){/en}, {dat1654}1654{/dat}) {en16}Mathématicien{/en}. - Jésuite. - Membre de l''Académie des sciences, il entre au collège de France en 1704 [http://data.bnf.fr/ark:/12148/cb121123302#foaf:Person]
{/ud}
{ud0}
Louis Lecomte ({dat1655}1655{/dat}) Jésuite. - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12151496v#foaf:Person]
{/ud}
{ud0}
Simon Tyssot de Patot ({en0li}Londres{/en}, {dat1655}1655{/dat}) Professeur ordinaire de mathématiques à l''École illustre de Deventer (1699-1727 ; professeur extraordinaire dès 1690). - Vécut en France de 1658 environ à 1664, puis aux Pays-Bas [http://data.bnf.fr/ark:/12148/cb11927303t#foaf:Person]
{/ud}
{ud0}
Claude de Visdelou (Erquy (Côtes-d''Armor), {dat1656}1656{/dat}) Jésuite. - {en16}Mathématicien{/en}. - Missionnaire en Chine. - Évèque titulaire de de Claudiopolis-en-Isaurie (à partir de 1708/1709). - Vicaire apostolique du Koueitchéou et du Yunnan, et administrateu du Houkouang (de 1708 à 1709) [http://data.bnf.fr/ark:/12148/cb150791582#foaf:Person]
{/ud}
{ud0}
Edmund Halley ({dat1656}1656{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb119960783#foaf:Person]
{/ud}
{ud0}
Nicolaas Hartsoeker (Gouda (Pays-Bas), {dat1656}1656{/dat}) {en1630}Physicien{/en}, micrographe et {en28}médecin{/en}. - Apporta des perfectionnements importants à la fabrication des verres de lunettes astronomiques, découvrit les animalcules spermatiques [http://data.bnf.fr/ark:/12148/cb13010358x#foaf:Person]
{/ud}
{ud0}
William Molyneux ({en0li}Dublin{/en}, {dat1656}1656{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en}, {en1630}physicien{/en} et {en18}philosophe{/en}. - Premier secrétaire de la Société philosophique de Dublin (en 1684) [http://data.bnf.fr/ark:/12148/cb124596616#foaf:Person]
{/ud}
{ud0}
Jean-Mathieu de Chazelles ({en0li}Lyon{/en}, {dat1657}1657{/dat}) {en1636}Cartographe{/en}, {en29}géographe{/en} et {en24}astronome{/en} associé à l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb106281104#foaf:Person]
{/ud}
{ud0}
Jean-Matthieu de Chazelles ({en0li}Lyon{/en}, {dat1657}1657{/dat}) Fit ses études chez les jésuites et devint l''auxiliaire de Cassini I. Fut associé aux travaux géodésiques menés par l''Académie des sciences. Dessina le planisphère de l''Observatoire. Collabora au Neptune françois. Associé {en24}astronome{/en} de l''Académie des sciences en 1695; associé mécanicien en 1699. Professeur d''hydrographie à Marseille [http://data.bnf.fr/ark:/12148/cb15304334g#foaf:Person]
{/ud}
{ud0}
Joseph Saurin ({en0li}Courthézon (Vaucluse){/en}, {dat1659}1659{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb10330722j#foaf:Person]
{/ud}
{ud0}
Philippe Desplaces ({dat1659}1659{/dat}) {en24}Astronome{/en}. - Auteur d''éphémérides [http://data.bnf.fr/ark:/12148/cb12223720g#foaf:Person]
{/ud}
{ud0}
Louis Feuillée (Mane (Alpes-de-Haute-Provence), {dat1660}1660{/dat}) {en24}Astronome{/en} et botaniste. - Religieux de l''ordre des Minimes. - Initié à la botanique par le P. Plumier. Correspondant {en24}astronome{/en} de l''Académie des sciences, il obtient une mission dans le Levant. Revenu à Marseille en 1702, il embarque l''année suivante pour les Antilles et parvient à Carthagène en 1704. Nommé {en16}mathématicien{/en} du roi, il s''embarque pour l''Amérique du Sud en 1707. En 1724, il est chargé de déterminer la position exacte de l''île de Fer [http://data.bnf.fr/ark:/12148/cb15309142r#foaf:Person]
{/ud}
{ud0}
Thomas Fantet de Lagny ({en0li}Lyon (Rhône){/en}, {dat1660}1660{/dat}) {en16}Mathématicien{/en}. - Professeur [http://data.bnf.fr/ark:/12148/cb14548143w#foaf:Person]
{/ud}
{ud0}
Guillaume-François-Antoine de L''Hospital ({dat1661}1661{/dat}) Marquis de Sainte-Mesme. - {en16}Mathématicien{/en}, membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb12000655c#foaf:Person]
{/ud}
{ud0}
Francesco Bianchini ({en0li}Vérone, Italie{/en}, {dat1662}1662{/dat}) {en1629}Théologien{/en}, historien, {en24}astronome{/en} et {en1630}physicien{/en} [http://data.bnf.fr/ark:/12148/cb12452255g#foaf:Person]
{/ud}
{ud0}
Paolo Mattia Doria ({dat1662}1662{/dat}) {en18}Philosophe{/en} et {en16}mathématicien{/en} italien [http://data.bnf.fr/ark:/12148/cb121118306#foaf:Person]
{/ud}
{ud0}
Jean-Pierre de Crousaz ({dat1663}1663{/dat}) {in0_1621}Professeur de philosophie et mathématiques à Lausanne et Groningue{/in}. - Conseiller de la légation de Suède en Hollande. - Membre des Académies de Bordeaux et Paris [http://data.bnf.fr/ark:/12148/cb12016566d#foaf:Person]
{/ud}
{ud0}
Johann Balthasar Lauterbach ({dat1663}1663{/dat}) {en16}Mathématicien{/en} et {en1635}architecte{/en} allemand [http://data.bnf.fr/ark:/12148/cb137778333#foaf:Person]
{/ud}
{ud0}
John Craig ({dat1663}1663{/dat}) {en16}Mathématicien{/en} et {en1629}théologien{/en} écossais [http://data.bnf.fr/ark:/12148/cb114408210#foaf:Person]
{/ud}
{ud0}
Katahiro Takebe ({dat1664}1664{/dat}) {en16}Mathématicien{/en} japonais [http://data.bnf.fr/ark:/12148/cb12443517s#foaf:Person]
{/ud}
{ud0}
Lothar Zumbach von Coesfeld ({en0li}Trèves (Allemagne){/en}, {dat1664}1664{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en}, {en28}médecin{/en}, musicien. - {en16}Mathématicien{/en} et musicien de l''électeur de Trèves (1685-1688). - Lecteur en astronomie à l''université de Leyde. - {in0_1621}Professeur de mathématiques au Carolinum de Kassel{/in} [http://data.bnf.fr/ark:/12148/cb14853628w#foaf:Person]
{/ud}
{ud0}
Abraham de Moivre (Vitry-le-François ({en0li}Marne){/en}, {dat1667}1667{/dat}) {en16}Mathématicien{/en}. - Émigra en Grande-Bretagne après la révocation de l''Édit de Nantes (en 1686). - Membre de la Royal Society, de l''Académie de Berlin et de l''Académie de Saint-Pétersbourg [http://data.bnf.fr/ark:/12148/cb130110001#foaf:Person]
{/ud}
{ud0}
Girolamo Saccheri ({en0li}San Remo, Italie{/en}, {dat1667}1667{/dat}) Jésuite. - {in0_1621}Professeur de mathématiques{/in} [http://data.bnf.fr/ark:/12148/cb13164455b#foaf:Person]
{/ud}
{ud0}
Johann Bernoulli ({en0li}Bâle, Suisse{/en}, {dat1667}1667{/dat}) {en16}Mathématicien{/en} et {en1630}physicien{/en}, maître d''Euler, professeur à l''Université de Groningue puis à l''Université de Bâle. - A travaillé sur le calcul différentiel, intégral et exponentiel. - Également auteur de traités de {en28}médecin{/en}e, fondateur de la théorie mécanico-physique de la fermentation [http://data.bnf.fr/ark:/12148/cb122991692#foaf:Person]
{/ud}
{ud0}
William Whiston (Norton-juxta-Twycross (G. B.), {dat1667}1667{/dat}) {en1629}Théologien{/en} et {en24}astronome{/en}. - Professeur de mathématiques à Cambridge, d''où il fut exclu pour ses écrits théologiques. - Traducteur de Flavius Josèphe [http://data.bnf.fr/ark:/12148/cb11997914k#foaf:Person]
{/ud}
{ud0}
Guillaume Bonjour (Toulouse (Haute-Garonne), {dat1669}1669{/dat}) Augustin. - Missionnaire en Chine. - Orientaliste, {en24}astronome{/en} et {en1636}cartographe{/en} [http://data.bnf.fr/ark:/12148/cb13613529n#foaf:Person]
{/ud}
{ud0}
Leonhard Christoph Sturm ({en0li}Aldorf, Allemagne{/en}, {dat1669}1669{/dat}) {en16}Mathématicien{/en}. - {en1635}Architecte{/en} [http://data.bnf.fr/ark:/12148/cb143383238#foaf:Person]
{/ud}
{ud0}
Jean Terrasson ({en0li}Lyon{/en}, {dat1670}1670{/dat}) Oratorien, {en16}mathématicien{/en} et {en18}philosophe{/en}. - {in0_1621}Professeur de grec et latin au Collège de France{/in}. - Membre de l''Institut, Académie Française (élu en 1732) [http://data.bnf.fr/ark:/12148/cb119262217#foaf:Person]
{/ud}
{ud0}
Guido Grandi ({en0li}Crémone, Italie{/en}, {dat1671}1671{/dat}) {en16}Mathématicien{/en}, {en1629}théologien{/en}, biographe, antiquaire et poète. - Soutint Descartes contre l''aristotélisme. - Professeur de philosophie à l''Université de Pise. - Fut en correspondance avec Leibniz, Newton, Bernoulli. - Intendant général des eaux en Toscane [http://data.bnf.fr/ark:/12148/cb121384290#foaf:Person]
{/ud}
{ud0}
Johann Gabriel Doppelmayr ({dat1671}1671{/dat}) Fils d''un riche négociant qui s''occupait de physique, et destiné d''abord à l''étude du droit, il la quitta pour celle des mathématiques et voyagea jusqu''en 1702. Professeur à Nuremberg et membre de la Royal Society de Londres [http://data.bnf.fr/ark:/12148/cb15327296w#foaf:Person]
{/ud}
{ud0}
Johann Gabriel Doppelmayr ({dat1671}1671{/dat}) {en16}Mathématicien{/en}. - Membre de la Royal Society de Londres ({dat1713}1713{/dat}) [http://data.bnf.fr/ark:/12148/cb12158680q#foaf:Person]
{/ud}
{ud0}
Johann Gabriel Doppelmayr ({dat1671}1671{/dat}) {en24}Astronome{/en} et {en1636}cartographe{/en} ayant véçu à Nuremberg, né en 1671 ou 1677 [http://data.bnf.fr/ark:/12148/cb15327296w#foaf:Person]
{/ud}
{ud0}
Johann Heinrich Müller ({dat1671}1671{/dat}) {en1630}Physicien{/en}, {en24}astronome{/en}, {en16}mathématicien{/en}. - Professeur à l''université d''Altdorf (Allemagne) [http://data.bnf.fr/ark:/12148/cb10706008k#foaf:Person]
{/ud}
{ud0}
John Keill ({dat1671}1671{/dat}) {en16}Mathématicien{/en} écossais. - Professeur d''astronomie à Oxford [http://data.bnf.fr/ark:/12148/cb123670586#foaf:Person]
{/ud}
{ud0}
Étienne-Simon de Gamaches ({dat1672}1672{/dat}) {en24}Astronome{/en} et moraliste. - Chanoine de Sainte Croix de La Bretonnerie. - Membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb12004341t#foaf:Person]
{/ud}
{ud0}
Johann Jacob Scheuchzer ({en0li}Zürich{/en}, {dat1672}1672{/dat}) {en28}Médecin{/en}, naturaliste, historien, archéologue, numismate, {en24}astronome{/en} et {en1630}physicien{/en} [http://data.bnf.fr/ark:/12148/cb123955592#foaf:Person]
{/ud}
{ud0}
Eustachio Manfredi ({dat1674}1674{/dat}) {en24}Astronome{/en}. - Poète. - Fondateur de l''Académie de Bologne [http://data.bnf.fr/ark:/12148/cb12202194q#foaf:Person]
{/ud}
{ud0}
Julien Mahuet ({dat1674}1674{/dat}) Jésuite. - Né à Reims. Entre au noviciat le 24 août 1692. Enseigne les humanités à Reims, la rhétorique à Metz et les mathématiques à Reims. - Écrit du théâtre pour le Collège de Reims [http://data.bnf.fr/ark:/12148/cb13165624v#foaf:Person]
{/ud}
{ud0}
Guillaume Delisle ({dat1675}1675{/dat}) {en1636}Cartographe{/en}. - Fils de Claude Delisle, fut l''élève de Jean-Dominique Cassini. Élève {en24}astronome{/en} à l''Académie des sciences en 1702, il en devint membre en 1718 ; enseigna la géographie au jeune Louis XV et fut nommé premier {en29}géographe{/en} du roi ; produisit quelque 100 cartes qu''il édita lui-même [http://data.bnf.fr/ark:/12148/cb15238363g#foaf:Person]
{/ud}
{ud0}
Humphry Ditton (Salisbury (G. B.), {dat1675}1675{/dat}) {en16}Mathématicien{/en} et {en1629}théologien{/en} [http://data.bnf.fr/ark:/12148/cb15994181b#foaf:Person]
{/ud}
{ud0}
Yves-Marie André ({dat1675}1675{/dat}) Jésuite. - {in0_1621}Professeur de mathématiques à Caen{/in} [http://data.bnf.fr/ark:/12148/cb12180932c#foaf:Person]
{/ud}
{ud0}
Jacopo Francesco Riccati ({dat1676}1676{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb120689750#foaf:Person]
{/ud}
{ud0}
Gabriel Philippe de La Hire ({en0li}Paris{/en}, {dat1677}1677{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb106522995#foaf:Person]
{/ud}
{ud0}
Jacques Cassini ({en0li}Paris{/en}, {dat1677}1677{/dat}) Fils de Jean-Dominique Cassini et père de César-François Cassini de Thury. Associé {en24}astronome{/en} à l''Académie des sciences en 1699, pensionnaire en 1712. En 1700 participa à la mesure de la méridienne de l''Observatoire et y travailla jusqu''à son achèvement en 1718. En 1706 maître ordinaire à la Chambre des comptes. Etudia les planètes et leurs satellites. Soutint la thèse de l''allongement de la Terre aux pôles. [http://data.bnf.fr/ark:/12148/cb15238366h#foaf:Person]
{/ud}
{ud0}
Joseph Privat de Molières (Tarascon (ouches-du-Rhône), {dat1677}1677{/dat}) {en1630}Physicien{/en} et {en16}mathématicien{/en}. - Oratorien (vers 1709). - Professeur au collège royal ({dat1723}1723{/dat}). - Adjoint ({dat1721}1721{/dat}) puis associé ({dat1729}1729{/dat}) de l''Académie royale des sciences [http://data.bnf.fr/ark:/12148/cb145391041#foaf:Person]
{/ud}
{ud0}
Gerard Keulen ({dat1678}1678{/dat}) Graveur, {en1636}cartographe{/en}, {en16}mathématicien{/en} et éditeur. - Fils de Johannes van Keulen [http://data.bnf.fr/ark:/12148/cb15332761m#foaf:Person]
{/ud}
{ud0}
Jacob Hermann ({dat1678}1678{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12319998c#foaf:Person]
{/ud}
{ud0}
Jean-Jacques Dortous de Mairan ({en0li}Béziers{/en}, {dat1678}1678{/dat}) {en1630}Physicien{/en} et {en16}mathématicien{/en}. - Membre puis secrétaire perpétuel de l''Académie des sciences. - Membre de l''Académie française (élu en 1743) [http://data.bnf.fr/ark:/12148/cb12395086k#foaf:Person]
{/ud}
{ud0}
Louis Bourguet ({en0li}Nïmes{/en}, {dat1678}1678{/dat}) {in0_1621}Professeur de philosophie et de mathématiques à Neuchâtel{/in}. - Est l''un des fondateurs de la "Bibliothèque italique" (1728-) et du "Mercure suisse" (1732-). - Naturalisé Neuchâtelois en 1710 [http://data.bnf.fr/ark:/12148/cb12797692b#foaf:Person]
{/ud}
{ud0}
Pierre Rémond de Montmort ({en0li}Paris{/en}, {dat1678}1678{/dat}) {en16}Mathématicien{/en}. - Spécialiste de probabilités [http://data.bnf.fr/ark:/12148/cb12391046c#foaf:Person]
{/ud}
{ud0}
Bernardino Zendrini ({en0li}Saviore, Italie{/en}, {dat1679}1679{/dat}) {en28}Médecin{/en}. - {en16}Mathématicien{/en}. - Hydraulicien [http://data.bnf.fr/ark:/12148/cb13545066d#foaf:Person]
{/ud}
{ud0}
Christian Wolff ({en0li}Breslau, Silésie (Wrocław, Pologne){/en}, {dat1679}1679{/dat}) Juriste, {en16}mathématicien{/en} et {en18}philosophe{/en} [http://data.bnf.fr/ark:/12148/cb121387859#foaf:Person]
{/ud}
{ud0}
Firmin Abauzit ({en0li}Uzès{/en}, {dat1679}1679{/dat}) {en16}Mathématicien{/en}, {en18}philosophe{/en} et bibliothécaire. - Fut bibliothécaire à la Bibliothèque de Genève. - Vécut à Genève après la révocation de l''Édit de Nantes [http://data.bnf.fr/ark:/12148/cb121711117#foaf:Person]
{/ud}
{ud0}
Claude Richer ({dat1680}1680{/dat}) Abbé. - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12532604f#foaf:Person]
{/ud}
{ud0}
Pierre Jartoux ({dat1680}1680{/dat}) {en24}Astronome{/en} et missionnaire jésuite en Chine [http://data.bnf.fr/ark:/12148/cb15367486z#foaf:Person]
{/ud}
{ud0}
Paolino Chelucci ({en0li}Lucca, Italie{/en}, {dat1681}1681{/dat}) Professeur d''éloquence à l''Université de Rome. - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb104300443#foaf:Person]
{/ud}
{ud0}
Roger Cotes ({en0li}Burbage (Leicestershire){/en}, {dat1682}1682{/dat}) {en16}Mathématicien{/en}. - Professeur d''astronomie et de philosophie expérimentale au Trinity College, Cambridge (1707-). - A édité la seconde édition des "Principia" de Newton [http://data.bnf.fr/ark:/12148/cb123946202#foaf:Person]
{/ud}
{ud0}
Noël Regnault ({dat1683}1683{/dat}) Jésuite. - {in0_1621}Professeur de mathématiques et physique au collège de Paris{/in} [http://data.bnf.fr/ark:/12148/cb12218681d#foaf:Person]
{/ud}
{ud0}
Johann Matthias Hase ({dat1684}1684{/dat}) {en29}Géographe{/en} et {en1636}cartographe{/en} ; historien. - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb13007561v#foaf:Person]
{/ud}
{ud0}
Brook Taylor ({dat1685}1685{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12315365s#foaf:Person]
{/ud}
{ud0}
Giovanni Poleni ({en0li}Venise, Italie{/en}, {dat1685}1685{/dat}) {en1630}Physicien{/en}, {en16}mathématicien{/en} et archéologue [http://data.bnf.fr/ark:/12148/cb12161210z#foaf:Person]
{/ud}
{ud0}
Jean-Edme Gallimard ({en0li}Paris{/en}, {dat1685}1685{/dat}) {in0_1621}Professeur de mathématiques{/in} [http://data.bnf.fr/ark:/12148/cb120827146#foaf:Person]
{/ud}
{ud0}
Jai Singh ({en0li}Amber (Rajasthan, Inde){/en}, {dat1686}1686{/dat}) Mahārāja de Jaipur (Rajasthan, Inde) de 1699 à 1743. - Fondateur de la ville de Jaipur (en 1727). - Chef du clan rajput des Kachhwa. - Bâtisseur de cinq observatoires astronomiques (yantra) dans l''Inde du Nord, à Delhi, Jaipur, Mathura, Varanasi et Ujjain. - Publia des tables astronomiques. - Les dates biographiques (1688-1743) sont aussi parfois retenues [http://data.bnf.fr/ark:/12148/cb16578505b#foaf:Person]
{/ud}
{ud0}
Nicolas Bernoulli ({dat1687}1687{/dat}) {en16}Mathématicien{/en} et juriste suisse [http://data.bnf.fr/ark:/12148/cb13510346s#foaf:Person]
{/ud}
{ud0}
Robert Simson ({dat1687}1687{/dat}) {en16}Mathématicien{/en}. - A été professeur à l''Université de Glasgow, GB [http://data.bnf.fr/ark:/12148/cb12399224j#foaf:Person]
{/ud}
{ud0}
Joseph-Nicolas Delisle ({en0li}Paris{/en}, {dat1688}1688{/dat}) {en24}Astronome{/en}. - Il reçut l''enseignement de Cassini II. - {in0_1621}Professeur de mathématiques au Collège de France{/in} et {en29}géographe{/en} de la marine. - Membre de l''Institut, Académie des sciences ({dat1714}1714{/dat}). - Fondateur de l''École d''astronomie de Saint-Pétersbourg (à partir de 1725), a séjourné en Russie jusqu''en 1747 [http://data.bnf.fr/ark:/12148/cb12150746w#foaf:Person]
{/ud}
{ud0}
Louis-Bertrand Castel ({en0li}Montpellier{/en}, {dat1688}1688{/dat}) Jésuite ({dat1703}1703{/dat}). - {en18}Philosophe{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12462543h#foaf:Person]
{/ud}
{ud0}
Pierre Brumoy ({en0li}Rouen{/en}, {dat1688}1688{/dat}) Jésuite en 1704. - Professeur de rhétorique à Caen, précepteur du prince de Talmont, professeur de mathématiques au collège de Louis-le-Grand à Paris. - Collabore au Journal de Trévoux de 1722 à 1739. - Littérateur [http://data.bnf.fr/ark:/12148/cb12069382v#foaf:Person]
{/ud}
{ud0}
Willem Jacob''s Gravesande ({dat1688}1688{/dat}) {en1630}Physicien{/en}. - {en18}Philosophe{/en}. - Professeur de mathématique et astronomie à Leyde, Pays-Bas. - Éditeur du "Journal littéraire de la Haye", devenu "Journal de la République des Lettres" [http://data.bnf.fr/ark:/12148/cb12218384m#foaf:Person]
{/ud}
{ud0}
Antoine Gaubil ({en0li}Gaillac (Aveyron){/en}, {dat1689}1689{/dat}) Jésuite et missionnaire en Chine. - Établit un observatoire à Pékin, dans la résidence française. - Écrit sur l''astronomie, la géographie, l''histoire et la littérature de la Chine [http://data.bnf.fr/ark:/12148/cb12150997b#foaf:Person]
{/ud}
{ud0}
Giovanni Gaetano Bottari ({en0li}Rome{/en}, {dat1689}1689{/dat}) Savant prélat. - A étudié les langues et la littérature de l''Antiquité, les mathématiques, la philosophie et la théologie. - Membre de l''Académie della Crusca. - Conservateur de la bibliothèque du Vatican [http://data.bnf.fr/ark:/12148/cb12516784r#foaf:Person]
{/ud}
{ud0}
Robert Smith ({en0li}Lea, GB{/en}, {dat1689}1689{/dat}) {in0_1621}Professeur de mathématiques et de philosophie naturelle à Cambridge{/in} [http://data.bnf.fr/ark:/12148/cb15075770m#foaf:Person]
{/ud}
{ud0}
Christian Goldbach ({dat1690}1690{/dat}) {en16}Mathématicien{/en} allemand [http://data.bnf.fr/ark:/12148/cb124384045#foaf:Person]
{/ud}
{ud0}
Johann Friedrich Weidler (Gros-Neuhausen, Allemagne, {dat1691}1691{/dat}) Écrivain, {en16}mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb151541516#foaf:Person]
{/ud}
{ud0}
Esprit Pezenas ({en0li}Avignon{/en}, {dat1692}1692{/dat}) Jésuite. - {en24}Astronome{/en} et {en16}mathématicien{/en}. - Professeur d''hydrographie à Marseille et directeur de l''Observatoire de Marseille ({dat1749}1749{/dat}) [http://data.bnf.fr/ark:/12148/cb12120600p#foaf:Person]
{/ud}
{ud0}
James Stirling ({en0li}Garden, GB{/en}, {dat1692}1692{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb13475586v#foaf:Person]
{/ud}
{ud0}
Petrus Van Musschenbroek ({dat1692}1692{/dat}) {en1630}Physicien{/en}, docteur en {en28}médecin{/en}e et en philosophie. - Fut l''inventeur de la pyrométrie. - Fut professeur de philosophie naturelle, de mathématiques et d''astronomie à l''Université d''Utrecht, puis professeur à Leiden [http://data.bnf.fr/ark:/12148/cb13475113j#foaf:Person]
{/ud}
{ud0}
Diego de Torres Villarroel ({dat1693}1693{/dat}) Prêtre catholique. - Homme de lettres. - Professeur de mathématiques à l''université de Salamanque [http://data.bnf.fr/ark:/12148/cb119268467#foaf:Person]
{/ud}
{ud0}
Giovanni Bianchi ({en0li}Rimini (Italie){/en}, {dat1693}1693{/dat}) {en28}Médecin{/en}. - Professeur d''anatomie à l''Université de Sienne (1741-). - Auteur d''ouvrages médicaux, archéologiques, astronomiques, etc. [http://data.bnf.fr/ark:/12148/cb10649342z#foaf:Person]
{/ud}
{ud0}
Christfried Kirch ({dat1694}1694{/dat}) {en24}Astronome{/en} allemand. - Il succéda à son père Gottfried (1639-1710) dans la direction de l''Observatoire royal de Prusse (1716-1740). - Membre de l''Académie des sciences de Berlin ({dat1716}1716{/dat}) et associé de celles de Paris ({dat1723}1723{/dat}) et de Saint-Pétersbourg [http://data.bnf.fr/ark:/12148/cb12648455m#foaf:Person]
{/ud}
{ud0}
Dominique-François Rivard ({dat1697}1697{/dat}) {en16}Mathématicien{/en}. - {en18}Philosophe{/en}. - Professeur au collège de Beauvais [http://data.bnf.fr/ark:/12148/cb119220838#foaf:Person]
{/ud}
{ud0}
Abbé Deidier ({en0li}Marseille{/en}, {dat1698}1698{/dat}) Abbé. - {en16}Mathématicien{/en}. - Professeur d''artillerie à l''Ecole militaire de La Fère [http://data.bnf.fr/ark:/12148/cb102670411#foaf:Person]
{/ud}
{ud0}
Colin MacLaurin ({en0li}Kilmodan, GB{/en}, {dat1698}1698{/dat}) {en16}Mathématicien{/en} et {en1630}physicien{/en} [http://data.bnf.fr/ark:/12148/cb12534513m#foaf:Person]
{/ud}
{ud0}
Pierre-Louis Moreau de Maupertuis (Saint-Malo, Ille-et-Villaine, {dat1698}1698{/dat}) {en18}Philosophe{/en}, {en24}astronome{/en} et {en1630}physicien{/en}. - Fut invité par Frédéric II à réorganiser puis présider l''Académie de Berlin. - Ami puis ennemi de Voltaire, qui écrivit contre lui "Micromégas". - Membre de l''Académie française (élu en 1743) [http://data.bnf.fr/ark:/12148/cb11915229j#foaf:Person]
{/ud}
{ud0}
Charles-Étienne-Louis Camus (Crécy-en-Brie (Seine-et-Marne), {dat1699}1699{/dat}) {en16}Mathématicien{/en}. - {en24}Astronome{/en}. - Participa à l''expédition de 1736 en Laponie. - Membre de l''Académie des sciences ({dat1727}1727{/dat}) et de l''Académie d''architecture ({dat1739}1739{/dat}) [http://data.bnf.fr/ark:/12148/cb12181030f#foaf:Person]
{/ud}
{ud0}
Johann Ludwig Levin Gebhardi ({en0li}Braunschweig, Allemagne{/en}, {dat1699}1699{/dat}) Historien, professeur de philologie à l''académie équestre de Lüneburg ({dat1723}1723{/dat}). - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb143273694#foaf:Person]
{/ud}
{ud0}
Daniel Bernoulli (Groningue (Pays-Bas), {dat1700}1700{/dat}) {en16}Mathématicien{/en}, {en1630}physicien{/en} et {en24}astronome{/en}. - Fut professeur à Saint-Petersbourg (1725-1733) et à Bâle (1733-) [http://data.bnf.fr/ark:/12148/cb122991859#foaf:Person]
{/ud}
{ud0}
Sámuel Mikoviny ({en0li}Ábelfalva, aujourd''hui Ábelová, Slovaquie{/en}, {dat1700}1700{/dat}) {en1636}Cartographe{/en}. - Officier du génie. - Spécialiste en hydraulique. - {en16}Mathématicien{/en}. - Disciple de Bél Mátyás (1684-1749). - Études à Jena et à Nuremberg, Allemagne [http://data.bnf.fr/ark:/12148/cb103650124#foaf:Person]
{/ud}
{ud0}
Anders Celsius ({dat1701}1701{/dat}) {en24}Astronome{/en} et naturaliste. - Professeur d''astronomie à l''université d''Uppsala ({dat1730}1730{/dat}) [http://data.bnf.fr/ark:/12148/cb14606035v#foaf:Person]
{/ud}
{ud0}
Charles-Marie de La Condamine ({en0li}Paris{/en}, {dat1701}1701{/dat}) Savant. - {en24}Astronome{/en}. - {en29}Géographe{/en}. Mesura l''arc du Méridien avec Godin et Bouguer. - Membre de l''Académie française (élu en 1760) [http://data.bnf.fr/ark:/12148/cb119102567#foaf:Person]
{/ud}
{ud0}
Georg Wolfgang Krafft ({en0li}Tuttlingen (Allemagne){/en}, {dat1701}1701{/dat}) {en1630}Physicien{/en}, {in0_1621}professeur de mathématiques et de physique{/in} [http://data.bnf.fr/ark:/12148/cb10587905k#foaf:Person]
{/ud}
{ud0}
Johannes Nicolaus Frobesius ({en0li}Goslar, Allemagne{/en}, {dat1701}1701{/dat}) {en16}Mathématicien{/en} et {in0_1621}professeur de philosophie{/in} [http://data.bnf.fr/ark:/12148/cb12355199c#foaf:Person]
{/ud}
{ud0}
Niccolò de Martino ({dat1701}1701{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb16265590z#foaf:Person]
{/ud}
{ud0}
Johann Lorenz Schmidt ({dat1702}1702{/dat}) Fils de pasteur, a étudié la théologie et s''est intéressé à la  philosophie et aux mathématiques. - A publié en 1735 une traduction annotée de la première partie de la Bible, les cinq livres de Moïse (ou Torah ou Pentateuque), connue sous le nom de "Wertheimer Bible", laquelle a été censurée par l''empereur [http://data.bnf.fr/ark:/12148/cb150701237#foaf:Person]
{/ud}
{ud0}
Antoine Deparcieux ({dat1703}1703{/dat}) {en16}Mathématicien{/en} et statisticien. - Fut constructeur de cadrans solaires et inventeur de machines pour élever les eaux et de presse pour le tabac. - Membre de l''Académie des sciences ({dat1746}1746{/dat}) [http://data.bnf.fr/ark:/12148/cb121904326#foaf:Person]
{/ud}
{ud0}
Bernard-Laurent Soumille ({dat1703}1703{/dat}) {en16}Mathématicien{/en}, {en1630}physicien{/en} et agronome. - Prêtre-bénéficier du chapitre de Villeneuve-lès-Avignon (à partir de 1736, environ). - Correspondant de l''Académie royale des sciences de Paris [http://data.bnf.fr/ark:/12148/cb130919156#foaf:Person]
{/ud}
{ud0}
Thomas Le Seur ({dat1703}1703{/dat}) Franciscain. - Professeur de mathématique à l''Université de la Sapience (Rome) [http://data.bnf.fr/ark:/12148/cb155933751#foaf:Person]
{/ud}
{ud0}
Gabriel Cramer ({en0li}Genève, Suisse{/en}, {dat1704}1704{/dat}) Professeur de philosophie et de mathématiques des Académies et Sociétés royales de Londres, de Berlin, de Montpellier, de Lyon et de l''Académie de l''Institut de Bologne [http://data.bnf.fr/ark:/12148/cb15006804w#foaf:Person]
{/ud}
{ud0}
Guillaume Le Blond ({en0li}Paris{/en}, {dat1704}1704{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb14330967m#foaf:Person]
{/ud}
{ud0}
Henri Michel Sauvage ({en0li}Verdun{/en}, {dat1704}1704{/dat}) Jésuite. - Professeur d''humanités, de mathématiques et de philosophie [http://data.bnf.fr/ark:/12148/cb16180102s#foaf:Person]
{/ud}
{ud0}
Jacopo Belgrado ({dat1704}1704{/dat}) Jésuite. - {en1630}Physicien{/en}, {en16}mathématicien{/en} et archéologue [http://data.bnf.fr/ark:/12148/cb12161284h#foaf:Person]
{/ud}
{ud0}
Johann Andreas von Segner ({dat1704}1704{/dat}) Naturaliste, {en16}mathématicien{/en}, {en28}médecin{/en}, logicien, {en18}philosophe{/en}. - Né à Presbourg (l''actuelle Bratislava), il fit toute sa carrière en Allemagne (à Iéna, Göttingen, Halle notamment) [http://data.bnf.fr/ark:/12148/cb12316478n#foaf:Person]
{/ud}
{ud0}
Louis Godin ({en0li}Paris{/en}, {dat1704}1704{/dat}) {en24}Astronome{/en}, membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb15004534h#foaf:Person]
{/ud}
{ud0}
John Nourse ({dat1705}1705{/dat}) Variante(s) de prénom : Jean. - {en1631}Libraire{/en} ; {en1631}libraire{/en} (ordinaire) de Sa Majesté ({dat1762}1762{/dat}) ; {en1631}libraire{/en} de la "Society for the Encouragement of learning". - Baptisé à Oxford le 8 juillet 1705 ; fils d''un chirurgien. En apprentissage chez le {en1631}libraire{/en} de Londres John I Osborne d''août 1722 à oct. 1729. Établi vers 1730. Succède au {en1631}libraire{/en} William Mears après lui avoir été associé. Spécialiste des publications scientifiques, particulièrement de mathématiques, et des éditions étrangères, de {en18}philosophe{/en}s notamment. Séjourne à Paris en 1780. Décédé à Kensington en avril 1765. Son frère Charles Nourse puis Francis Wingrave lui succèdent [http://data.bnf.fr/ark:/12148/cb13605346z#foaf:Person]
{/ud}
{ud0}
Edme-Gilles Guyot ({en0li}Paris{/en}, {dat1706}1706{/dat}) Les ouvrages "Nouvelles récréations physiques et mathématiques" et "Essai sur la construction des ballons aérostatiques et sur la manière de les diriger" lui sont attribués par Hoefer et Quérard. - DBF et Michaud soulignent la confusion entre lui et Guillaume-Germain Guyot pour l''attribution de ces ouvrages [http://data.bnf.fr/ark:/12148/cb14651894d#foaf:Person]
{/ud}
{ud0}
Girolamo Settimo ({dat1706}1706{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb162655930#foaf:Person]
{/ud}
{ud0}
Giuseppe Maria Asclepi ({dat1706}1706{/dat}) Jésuite, enseigna les mathématiques et les humanités [http://data.bnf.fr/ark:/12148/cb12240755t#foaf:Person]
{/ud}
{ud0}
Benjamin Robins ({en0li}Bath, GB{/en}, {dat1707}1707{/dat}) {en16}Mathématicien{/en} et {en1633}ingénieur{/en} militaire. - Pamphlétaire [http://data.bnf.fr/ark:/12148/cb121289860#foaf:Person]
{/ud}
{ud0}
Francesco Ottavio Magnocavalli ({en0li}Casale, Italie{/en}, {dat1707}1707{/dat}) {en1635}Architecte{/en}, {en16}mathématicien{/en} et poète [http://data.bnf.fr/ark:/12148/cb10732099c#foaf:Person]
{/ud}
{ud0}
Jean Paul Grandjean de Fouchy ({en0li}Paris{/en}, {dat1707}1707{/dat}) {en24}Astronome{/en}. - Secrétaire perpétuel de l''Académie des Sciences ({dat1743}1743{/dat}) [http://data.bnf.fr/ark:/12148/cb10667779b#foaf:Person]
{/ud}
{ud0}
José Quiroga ({dat1707}1707{/dat}) Jésuite, {en16}mathématicien{/en} et pilote [http://data.bnf.fr/ark:/12148/cb12570261h#foaf:Person]
{/ud}
{ud0}
Leonhard Euler ({en0li}Bâle (Suisse){/en}, {dat1707}1707{/dat}) {en16}Mathématicien{/en} et {en1630}physicien{/en}. - {en18}Philosophe{/en}, {en1629}théologien{/en} et orientaliste. - Membre de l''Académie des sciences de Saint-Pétersbourg (à partir de 1733) et de celle de Berlin (à partir de 1741), et membre associé de celle de Paris (à partir de 1755) [http://data.bnf.fr/ark:/12148/cb12157666x#foaf:Person]
{/ud}
{ud0}
Giovanni Francesco Mauro Melchior Salvemini da Castiglione ({dat1708}1708{/dat}) Professeur de mathématiques à Utrecht ({dat1751}1751{/dat}) puis directeur de la classe de mathématiques de l''Académie de Berlin. - Découvrit la solution du problème consistant à inscrire dans un cercle un triangle dont les côtés passent par trois points donnés [http://data.bnf.fr/ark:/12148/cb130145422#foaf:Person]
{/ud}
{ud0}
Eustachio Zanotti ({en0li}Bologne, Italie{/en}, {dat1709}1709{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb12202196d#foaf:Person]
{/ud}
{ud0}
Giordano Riccati ({en0li}Castelfranco Veneto, Italie{/en}, {dat1709}1709{/dat}) Comte. - {en16}Mathématicien{/en}, acousticien et théoricien de la musique. - Fut aussi {en1630}physicien{/en} et {en1635}architecte{/en} [http://data.bnf.fr/ark:/12148/cb12252383n#foaf:Person]
{/ud}
{ud0}
Georg Matthias Bose ({en0li}Leipzig (Allemagne){/en}, {dat1710}1710{/dat}) {en24}Astronome{/en}, {en1630}physicien{/en}, {en16}mathématicien{/en}. - Professeur de physique à l''université de Wittenberg [http://data.bnf.fr/ark:/12148/cb14065311n#foaf:Person]
{/ud}
{ud0}
Jacques Audierne ({dat1710}1710{/dat}) Auteur comique et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb10425836p#foaf:Person]
{/ud}
{ud0}
Johann Bernoulli ({dat1710}1710{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb14852857s#foaf:Person]
{/ud}
{ud0}
Thomas Simpson ({dat1710}1710{/dat}) Membre de la société royale de Londres, professeur de mathématiques à Woolwich (en 1755) [http://data.bnf.fr/ark:/12148/cb103759851#foaf:Person]
{/ud}
{ud0}
Alexandre-Gui Pingré ({en0li}Paris{/en}, {dat1711}1711{/dat}) Génovéfain. - {en24}Astronome{/en}. - Correspondant (à partir de 1753), puis associé libre de l''Académie des sciences. - {en29}Géographe{/en} de la Marine. - Chancelier de l''Université de Paris (1769-17..). - Bibliothécaire de Sainte-Geneviève (à partir de 1792) [http://data.bnf.fr/ark:/12148/cb12151017m#foaf:Person]
{/ud}
{ud0}
François Jacquier (Vitry-le-François ({en0li}Marne){/en}, {dat1711}1711{/dat}) Religieux de l''ordre des Minimes. - {in0_1621}Professeur de physique et mathématiques{/in} [http://data.bnf.fr/ark:/12148/cb12198105d#foaf:Person]
{/ud}
{ud0}
Laura Bassi ({en0li}Bologne, Italie{/en}, {dat1711}1711{/dat}) {en16}Mathématicien{/en}ne et {en1630}physicien{/en}ne. - Professeur de biologie et de physique à l''Université de Bologne. - Première femme titulaire d''une chaire universitaire en Europe [http://data.bnf.fr/ark:/12148/cb135103950#foaf:Person]
{/ud}
{ud0}
Ottaviano Cametti ({en0li}Gattinara, Italie{/en}, {dat1711}1711{/dat}) {en16}Mathématicien{/en}, {en1630}physicien{/en} et historien [http://data.bnf.fr/ark:/12148/cb10464765k#foaf:Person]
{/ud}
{ud0}
Pierre Joseph de Rivaz ({dat1711}1711{/dat}) {en16}Mathématicien{/en}, inventeur-mécanicien et historien. - Directeur des salines de Moutiers. - Né dans le Valais et mort à Moutiers (Tarentaise) [http://data.bnf.fr/ark:/12148/cb128398731#foaf:Person]
{/ud}
{ud0}
Rugerius Josephus Boscovich (Raguse aujourd''hui Dubrovnik ({en0li}Croatie){/en}, {dat1711}1711{/dat}) Jésuite. - {en1630}Physicien{/en}, {en16}mathématicien{/en}, {en24}astronome{/en} et {en18}philosophe{/en}. - {in0_1621}Professeur de mathématiques à Rome, Pavie et Milan{/in}. - Directeur de l''optique de la Marine royale à Paris et membre de la "Royal Society" à Londres. - Dans son ouvrage majeur "Théorie de la philosophie naturelle" il élabore la théorie initiale des forces et de la structure fondamentale de la matière, dont les concepts ont trouvé écho dans les découvertes de la physique moderne. - Il publie nombre d''ouvrages contenant ses découvertes en mathématiques, en astronomie, en géophysique et en archéologie. - Il mit au point différents instruments optiques, astronomiques et géodésiques et réalisa des expertises et des mesures hydrotechniques, géodésiques, cartographiques et statiques. - Il consolida la coupole de la basilique Saint-Pierre de Rome et de la flèche de la cathédrale de Milan [http://data.bnf.fr/ark:/12148/cb12054879x#foaf:Person]
{/ud}
{ud0}
Jean-Paul de Gua de Malves ({en0li}Malves (Aude){/en}, {dat1712}1712{/dat}) Abbé. - {en16}Mathématicien{/en}, géomètre, économiste politique. - Titulaire de la chaire de philosophie au Collège de France (1742-1749) [http://data.bnf.fr/ark:/12148/cb15325204x#foaf:Person]
{/ud}
{ud0}
Samuel König ({dat1712}1712{/dat}) Date de mort : 21 août ou 22 juillet 1757. - A également écrit en français. - {en16}Mathématicien{/en}, {en18}philosophe{/en} et juriste [http://data.bnf.fr/ark:/12148/cb120941298#foaf:Person]
{/ud}
{ud0}
Alexis Claude Clairaut ({en0li}Paris (France){/en}, {dat1713}1713{/dat}) {en16}Mathématicien{/en} très précoce et {en24}astronome{/en}. - Ami de Voltaire et de la marquise Du Chatelet [http://data.bnf.fr/ark:/12148/cb124002538#foaf:Person]
{/ud}
{ud0}
Giammaria Ortes ({dat1713}1713{/dat}) Moine camaldule. - {en16}Mathématicien{/en}, économiste et {en18}philosophe{/en} [http://data.bnf.fr/ark:/12148/cb13753557w#foaf:Person]
{/ud}
{ud0}
Nicolas-Louis de La Caille ({en0li}Rumigny, Ardennes{/en}, {dat1713}1713{/dat}) Abbé. - {in0_1621}Professeur de mathématiques au Collège Mazarin{/in}. - Membre de l''Académie royale des sciences [http://data.bnf.fr/ark:/12148/cb12124353d#foaf:Person]
{/ud}
{ud0}
Alessandro Vittorio Papacino d''Antoni ({en0li}Villafranca, Italie{/en}, {dat1714}1714{/dat}) {en1633}Ingénieur{/en}, {en16}mathématicien{/en}. - Membre de l''Académie des sciences de Turin [http://data.bnf.fr/ark:/12148/cb10709482t#foaf:Person]
{/ud}
{ud0}
César-François Cassini de Thury (Thury-sous-Clermont ({en0li}Oise){/en}, {dat1714}1714{/dat}) {en24}Astronome{/en} et géomètre. - Membre de l''Académie des sciences ({dat1736}1736{/dat}). - Fils de Jacques Cassini (1677-1756) et père de Jean-Dominique Cassini (1748-1845). - Participa avec son père à la mesure de la perpendiculaire de l''Observatoire. - Son oeuvre principale est la carte de France, première carte de base de ce pays, dont la publication commença en 1756 [http://data.bnf.fr/ark:/12148/cb12241101g#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Audiffredi ({en0li}Saorge, Italie{/en}, {dat1714}1714{/dat}) Dominicain. - {en24}Astronome{/en}. - Préfet de la Biblioteca Casanatense, Rome (1759-1794). - Né Giulio Cesare Audiffredi, change de prénom en entrant chez les Dominicains ({dat1730}1730{/dat}) [http://data.bnf.fr/ark:/12148/cb13595556h#foaf:Person]
{/ud}
{ud0}
John Winthrop ({dat1714}1714{/dat}) {in0_1621}Professeur de Mathématiques et de Philosophie naturelle à Harvard{/in} [http://data.bnf.fr/ark:/12148/cb14594660x#foaf:Person]
{/ud}
{ud0}
François-Joachim Duport-Dutertre (Saint-Servan (Ille-et-Vilaine), {dat1715}1715{/dat}) Littérateur. - {en16}Mathématicien{/en}. - Voyageur [http://data.bnf.fr/ark:/12148/cb12533121w#foaf:Person]
{/ud}
{ud0}
Pierre-Charles Le Monnier ({en0li}Paris{/en}, {dat1715}1715{/dat}) {en24}Astronome{/en}. - Membre de l''Académie des sciences ({dat1741}1741{/dat}). - Professeur de physique au Collège de France (de 1749 à 1793), puis membre de la classe des sciences physiques et mathématiques de l''Institut [http://data.bnf.fr/ark:/12148/cb121064574#foaf:Person]
{/ud}
{ud0}
André-Pierre Le Guay de Prémontval (Charenton (Val-de-Marne), {dat1716}1716{/dat}) {in0_1621}Professeur de mathématiques{/in}. - Membre de l''Académie de Berlin [http://data.bnf.fr/ark:/12148/cb122271303#foaf:Person]
{/ud}
{ud0}
Eugénios Voúlgaris ({en0li}Corfou (Îles Ioniennes, Grèce){/en}, {dat1716}1716{/dat}) Métropolite de l''Église orthodoxe grecque. - {en1629}Théologien{/en}, {en18}philosophe{/en} et {en16}mathématicien{/en}. - "Éducateur de la Nation" et précurseur des Lumières en Grèce ; traducteur de Voltaire et Virgile. - Nommé évêque en Russie [http://data.bnf.fr/ark:/12148/cb12564304q#foaf:Person]
{/ud}
{ud0}
Gottfried Ploucquet ({dat1716}1716{/dat}) {en18}Philosophe{/en}, {en16}mathématicien{/en} et {en1629}théologien{/en}. - Professeur de philosophie à l''université de Tübingen (1750-1782) [http://data.bnf.fr/ark:/12148/cb13324024g#foaf:Person]
{/ud}
{ud0}
Leonardo Ximenes ({en0li}Trapani, Italie{/en}, {dat1716}1716{/dat}) Jésuite. - Geographe, {en24}astronome{/en}, {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb106577403#foaf:Person]
{/ud}
{ud0}
D'' Alembert ({en0li}Paris{/en}, {dat1717}1717{/dat}) {en16}Mathématicien{/en} et {en18}philosophe{/en}. - Nom patronymique : Jean Le Rond, d̲i̲t̲ d'' Alembert. - Membre de l''Institut, Académie française (élu en 1754) [http://data.bnf.fr/ark:/12148/cb118883708#foaf:Person]
{/ud}
{ud0}
Josef Anton Nagel ({dat1717}1717{/dat}) Professeur, {en16}mathématicien{/en}, scientifique allemand [http://data.bnf.fr/ark:/12148/cb12091922b#foaf:Person]
{/ud}
{ud0}
Augustin Darquier de Pellepoix ({en0li}Toulouse{/en}, {dat1718}1718{/dat}) {en24}Astronome{/en}. - Associé non résidant de l''Académie des sciences. - Receveur des tailles de la généralité d''Auch [http://data.bnf.fr/ark:/12148/cb12155190x#foaf:Person]
{/ud}
{ud0}
Claude-François Berthelot ({dat1718}1718{/dat}) {en1633}Ingénieur{/en}. - Professeur de mathématiques à l''École royale militaire. - Inventeur de l''"affut de Gribeauval" [http://data.bnf.fr/ark:/12148/cb134984423#foaf:Person]
{/ud}
{ud0}
François-César Le Tellier Courtanvaux ({dat1718}1718{/dat}) Duc de Doudeauville. - Capitaine-colonel des cent-suisses de la garde du roi. - {en24}Astronome{/en}, membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb121904446#foaf:Person]
{/ud}
{ud0}
Gaspard-François-Anne de Forbin ({dat1718}1718{/dat}) Né le 8 ou le 18 juillet 1718. - Embrassa d'' abord la carrière militaire. - Chevalier de Malte. - {en16}Mathématicien{/en} et {en1630}Physicien{/en} [http://data.bnf.fr/ark:/12148/cb12108181n#foaf:Person]
{/ud}
{ud0}
István Hatvani ({en0li}Rimaszombat, aujourd''hui Rimavská Sobota, Slovaquie{/en}, {dat1718}1718{/dat}) {en16}Mathématicien{/en}, {en1630}physicien{/en}. - {en28}Médecin{/en}. - Pédagogue, {in0_1621}professeur à Debrecen,Református Kollégium, Hongrie.{/in} - Diplômé de l''Université de Bâle, Suisse [http://data.bnf.fr/ark:/12148/cb10355679v#foaf:Person]
{/ud}
{ud0}
Jean-Philippe Loys de Chéseaux ({dat1718}1718{/dat}) {en24}Astronome{/en} et {en1630}physicien{/en}. - Né à Lausanne, mort à Paris [http://data.bnf.fr/ark:/12148/cb133196302#foaf:Person]
{/ud}
{ud0}
Joseph Amiot ({en0li}Toulon{/en}, {dat1718}1718{/dat}) Jésuite de 1737 à 1773 (ordonné prêtre en 1749). - Sinologue et {en24}astronome{/en}. - Missionnaire en Chine (à partir de 1749) [http://data.bnf.fr/ark:/12148/cb12112654w#foaf:Person]
{/ud}
{ud0}
Maria Gaetana Agnesi ({en0li}Milan, Italie{/en}, {dat1718}1718{/dat}) {en16}Mathématicien{/en}ne [http://data.bnf.fr/ark:/12148/cb105423187#foaf:Person]
{/ud}
{ud0}
Abraham Gotthelf Kästner ({en0li}Leipzig, Allemagne{/en}, {dat1719}1719{/dat}) {en16}Mathématicien{/en}. - Poète et épigrammatiste. - Critique [http://data.bnf.fr/ark:/12148/cb123392338#foaf:Person]
{/ud}
{ud0}
Giuseppe Toaldo ({en0li}Pianezze, Italie{/en}, {dat1719}1719{/dat}) Prêtre. - {en1630}Physicien{/en}. - Professeur d''astronomie, de géographie et de météorologie à l''Université de Padoue [http://data.bnf.fr/ark:/12148/cb10578331h#foaf:Person]
{/ud}
{ud0}
Jens Kraft ({dat1720}1720{/dat}) {en18}Philosophe{/en} des lumières danois. - {in0_1621}Professeur de mathématiques et de philosophie à Soroe{/in} [http://data.bnf.fr/ark:/12148/cb12442689p#foaf:Person]
{/ud}
{ud0}
Charles Walmesley ({dat1722}1722{/dat}) Évêque de Rama. - {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb10748264x#foaf:Person]
{/ud}
{ud0}
Jean Chappe d''Auteroche ({en0li}Mauriac (Cantal){/en}, {dat1722}1722{/dat}) {en24}Astronome{/en}. - Explorateur en Sibérie et en Californie [http://data.bnf.fr/ark:/12148/cb12402595h#foaf:Person]
{/ud}
{ud0}
Jean-Louis Dupain-Triel ({dat1722}1722{/dat}) Homme de lettres, poète. - S''intéressa aux mathématiques, à la géographie et à l''enseignement des arts [http://data.bnf.fr/ark:/12148/cb119011560#foaf:Person]
{/ud}
{ud0}
Louis-Jacques Goussier ({dat1722}1722{/dat}) {en16}Mathématicien{/en} et inventeur [http://data.bnf.fr/ark:/12148/cb13485055d#foaf:Person]
{/ud}
{ud0}
Baien Miura ({dat1723}1723{/dat}) Lettré du milieu de l''époque d''Edo. - A créé son propre système de pensée philosophique appelé "jōrigaku" : méthode de spéculation fondée sur l''éthique, la logique, les mathématiques et la physique, recourant à une pensée dialectique appelée "hankan gōitsu" [http://data.bnf.fr/ark:/12148/cb12293200x#foaf:Person]
{/ud}
{ud0}
Didier Robert de Vaugondy ({dat1723}1723{/dat}) {en29}Géographe{/en} ordinaire du roi, {in0_1621}professeur de mathématiques et de géographie, fils de Gilles Robert Vaugondy{/in}. - Didier signe "Robert de Vaugondy" [http://data.bnf.fr/ark:/12148/cb12380757h#foaf:Person]
{/ud}
{ud0}
Étienne-Nicolas Blondeau ({dat1723}1723{/dat}) {in0_1621}Professeur de mathématiques{/in}. - {en1633}Ingénieur{/en} de la marine. - Collaborateur de l''Encyclopédie méthodique (1782-1783?) [http://data.bnf.fr/ark:/12148/cb10737141j#foaf:Person]
{/ud}
{ud0}
Johann Tobias Mayer ({dat1723}1723{/dat}) {en16}Mathématicien{/en} et {en24}astronome{/en}, a travaillé avec Homann Herben de 1746 à 1751, puid pour Kilian à partir de 1752 [http://data.bnf.fr/ark:/12148/cb153509764#foaf:Person]
{/ud}
{ud0}
Johann Tobias Mayer ({dat1723}1723{/dat}) {en24}Astronome{/en} allemand [http://data.bnf.fr/ark:/12148/cb11958863x#foaf:Person]
{/ud}
{ud0}
Nicole-Reine Lepaute ({en0li}Paris{/en}, {dat1723}1723{/dat}) Née Nicole-Reine Étable de La Brière, épouse de Jean-André Lepaute, horloger du Roi. - {en16}Mathématicien{/en}ne, {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb14555447k#foaf:Person]
{/ud}
{ud0}
Tobias Mayer ({en0li}Marbach (Allemagne){/en}, {dat1723}1723{/dat}) {en24}Astronome{/en}, {en16}mathématicien{/en}. - Directeur de l''Observatoire de Göttingen, Allemagne [http://data.bnf.fr/ark:/12148/cb121551484#foaf:Person]
{/ud}
{ud0}
Edme-Sébastien Jeaurat ({dat1724}1724{/dat}) {en1633}Ingénieur{/en}-{en29}géographe{/en} et {en24}astronome{/en}. - {in0_1621}Professeur à l''école militaire.{/in} - Membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb122175393#foaf:Person]
{/ud}
{ud0}
François Para Du Phanjas (Chabottes (Hautes-Alpes), {dat1724}1724{/dat}) {en18}Philosophe{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12528863r#foaf:Person]
{/ud}
{ud0}
Georges Louis Lesage ({en0li}Genève{/en}, {dat1724}1724{/dat}) {en16}Mathématicien{/en} et {en1630}physicien{/en} suisse. - Etudie à Genève puis Paris. - Etabli à Genève [http://data.bnf.fr/ark:/12148/cb155857475#foaf:Person]
{/ud}
{ud0}
Guillaume-Germain Guyot ({en0li}Orléans{/en}, {dat1724}1724{/dat}) Les ouvrages "Nouvelles récréations physiques et mathématiques" et "Essai sur la construction des ballons aérostatiques et sur la manière de les diriger" lui sont attribués par le DBF et par Samuel Ersch dans "La France littéraire contenant les auteurs français de 1771 à 1796", DBF. - Quérard et Michaud soulignent la confusion entre lui et Edme-Gilles Guyot pour l''attribution de ces ouvrages [http://data.bnf.fr/ark:/12148/cb12214218k#foaf:Person]
{/ud}
{ud0}
Guillaume-Hyacinthe-Joseph-Jean-Baptiste Le Gentil de La Galaisière ({dat1725}1725{/dat}) {en24}Astronome{/en} et voyageur. - Entre à l''Observatoire en 1750. - Membre de l''Académie des sciences en 1753 [http://data.bnf.fr/ark:/12148/cb12151459n#foaf:Person]
{/ud}
{ud0}
Jean-Étienne Montucla ({dat1725}1725{/dat}) Historien des mathématiques [http://data.bnf.fr/ark:/12148/cb12127574n#foaf:Person]
{/ud}
{ud0}
Louis-Charles Desnos ({dat1725}1725{/dat}) {en1631}Libraire{/en} ; {en1631}libraire{/en} et ({en1633}ingénieur{/en}) {en29}géographe{/en} (pour les globes et les sphères) du roi de Danemark (ou : de Sa Majesté danoise) (1769-1789). - Fils d''un marchand drapier de Pont-Sainte-Maxence (Oise). Apprenti fondeur de caractères à Paris à partir d''avril 1745 (reçu maître fondeur en 1757).  {en1633}Ingénieur{/en} {en29}géographe{/en} (de la ville de Paris à partir de 1769), fabricant et marchand de sphères et d''instruments astronomiques établi vers 1753 en succession de Jacques Hardy, après avoir épousé en 1749 la veuve de son fils Nicolas Hardy ; également marchand d''estampes et de cartes géographiques. Un des 12 {en1631}libraire{/en}s non jurés reçus le 4 oct. 1767. - Éditeur et auteur de nombreux atlas, almanachs et publications géographiques entre 1756 et 1795 env. Rédige également plusieurs catalogues de son fonds entre 1768 et 1792. Une partie de son fonds est rachetée en 1805 par Jean (17..-1839), marchand de cartes et d''estampes [http://data.bnf.fr/ark:/12148/cb12402252d#foaf:Person]
{/ud}
{ud0}
Rigobert Bonne (Raucourt (Meurthe-et-Moselle), {dat1727}1727{/dat}) {en1633}Ingénieur{/en}. - {en29}Géographe{/en}. - Hydrographe. - Célèbre par la projection qui porte son nom et qui remplacera pour la carte de France la projection de Cassini. D''abord {en1633}ingénieur{/en} {en29}géographe{/en} et maître de mathématiques. En 1775 {en1633}ingénieur{/en} hydrographe de la Marine. Fut mis à la retraite contre sa volonté en 1789. Collabora au Neptune américo-septentrional [http://data.bnf.fr/ark:/12148/cb12169793s#foaf:Person]
{/ud}
{ud0}
Chrysologue de Gy (Gy (Haute-Saône), {dat1728}1728{/dat}) Capucin. - {en24}Astronome{/en}, {en1636}cartographe{/en} et géologue [http://data.bnf.fr/ark:/12148/cb10728734z#foaf:Person]
{/ud}
{ud0}
Jean-Henri Lambert ({en0li}Mulhouse, Suisse{/en}, {dat1728}1728{/dat}) {en16}Mathématicien{/en}, {en1630}physicien{/en}, {en24}astronome{/en} et {en18}philosophe{/en}. - Spécialiste de géometrie. - En poste à l''Académie royale des sciences et belles lettres de Berlin (de 1765 à 1777) [http://data.bnf.fr/ark:/12148/cb12359659g#foaf:Person]
{/ud}
{ud0}
Le P.  Chrysologue ({en0li}Gy{/en}, {dat1728}1728{/dat}) Capucin, nom de religion de Noël André. - Attiré par la géographie et l''astronomie, fut l''élève de Lemonnier. Mesura les altitudes des Vosges, du Jura et des Alpes. Se retira dans sa famille au moment de la Révolution.  En 1806 publia un important traité de géologie dont Cuvier fit un rapport élogieux [http://data.bnf.fr/ark:/12148/cb153054042#foaf:Person]
{/ud}
{ud0}
Paolo Frisi ({en0li}Melegnano, Italie{/en}, {dat1728}1728{/dat}) Barnabite. - {en16}Mathématicien{/en}, {en24}astronome{/en} et écrivain. - Professeur dans les Écoles palatines de Milan (1764-) [http://data.bnf.fr/ark:/12148/cb120849325#foaf:Person]
{/ud}
{ud0}
Antonio Eximeno ({dat1729}1729{/dat}) Théoricien de la musique et polémiste. - Jésuite, il devient professeur de rhétorique à l''Université de Valence, puis professeur de mathématiques à l''Académie militaire de Ségovie ({dat1764}1764{/dat}). - Lorsque les jésuites sont expulsés d''Espagne en 1767, il se rend à Rome où il étudie la musique. - Connu aussi sous le pseud. : "Aristosseno Megareo" (BnF, Musique, fichier général auteurs), ou "Aristodemo Megareo" (Fétis) [http://data.bnf.fr/ark:/12148/cb13755053m#foaf:Person]
{/ud}
{ud0}
Charles Bossut ({dat1730}1730{/dat}) {en16}Mathématicien{/en}, membre de l''Académie des sciences ({dat1779}1779{/dat}), il participa à la rédaction de la partie mathématique de l''Encyclopédie [http://data.bnf.fr/ark:/12148/cb11763983g#foaf:Person]
{/ud}
{ud0}
Charles Bossut ({dat1730}1730{/dat}) {en16}Mathématicien{/en} et {en1630}physicien{/en}. - Membre de l''Académie des sciences, pensionnaire de la classe de mécanique ({dat1785}1785{/dat}). - Écrivit plusieurs articles dans l''"Encyclopédie" [http://data.bnf.fr/ark:/12148/cb124599882#foaf:Person]
{/ud}
{ud0}
Charles Messier (Badonviller (Meurthe-et-Moselle), {dat1730}1730{/dat}) {en24}Astronome{/en} de la marine. - Académicien ({dat1770}1770{/dat}). - Membre de l''Institut [http://data.bnf.fr/ark:/12148/cb124827900#foaf:Person]
{/ud}
{ud0}
Étienne Bezout ({en0li}Nemours{/en}, {dat1730}1730{/dat}) {en16}Mathématicien{/en}. - Membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb12267459g#foaf:Person]
{/ud}
{ud0}
Jean-Baptiste de Laborde ({dat1730}1730{/dat}) {en1630}Physicien{/en} et {en16}mathématicien{/en}. - Jésuite [http://data.bnf.fr/ark:/12148/cb13196726p#foaf:Person]
{/ud}
{ud0}
Joseph-Aignan Sigaud de La Fond ({en0li}Bourges{/en}, {dat1730}1730{/dat}) {en16}Mathématicien{/en}, {en1630}physicien{/en} et moraliste. - {in0_1621}Professeur de physique à Bourges{/in} [http://data.bnf.fr/ark:/12148/cb12401095w#foaf:Person]
{/ud}
{ud0}
Pierre-Thomas Antelmy ({en0li}Trigance, France{/en}, {dat1730}1730{/dat}) {en16}Mathématicien{/en}, professeur de mathématiques à l''École militaire [http://data.bnf.fr/ark:/12148/cb13011110m#foaf:Person]
{/ud}
{ud0}
Benito Bails ({dat1731}1731{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb162593727#foaf:Person]
{/ud}
{ud0}
Girolamo Francisco Cristiani ({en0li}Brescia, Italie{/en}, {dat1731}1731{/dat}) {en16}Mathématicien{/en} et {en1630}physicien{/en} [http://data.bnf.fr/ark:/12148/cb14065297x#foaf:Person]
{/ud}
{ud0}
Nicolas-Claude Duval-Le Roy ({dat1731}1731{/dat}) Professeur de mathématiques et d''hydrographie, {en1630}physicien{/en} et {en24}astronome{/en}. - Membre de l''Académie royale de marine. - Correspondant à l''Académie royale des sciences ({dat1789}1789{/dat}), associé non résident de l''Institut ({dat1796}1796{/dat}) [http://data.bnf.fr/ark:/12148/cb12548660k#foaf:Person]
{/ud}
{ud0}
Diderich Christian Fester ({dat1732}1732{/dat}) {en16}Mathématicien{/en} et {en1636}cartographe{/en} à Trondheim [http://data.bnf.fr/ark:/12148/cb15384550x#foaf:Person]
{/ud}
{ud0}
Jérôme de La Lande (Bourg-en-Bresse ({en0li}Ain){/en}, {dat1732}1732{/dat}) {en24}Astronome{/en}. - Membre de l''Académie de Berlin. - Membre de l''Académie des sciences ({dat1753}1753{/dat}). - Professeur d''astronomie au Collège de France ({dat1762}1762{/dat}). - Directeur de l''Observatoire de Paris de 1768 à sa mort [http://data.bnf.fr/ark:/12148/cb12012398h#foaf:Person]
{/ud}
{ud0}
Maurille-Antoine Moithey ({dat1732}1732{/dat}) Éditeur et marchand de cartes géographiques ; {en1631}libraire{/en}. - {en1633}Ingénieur{/en} {en29}géographe{/en} du Roi et {in0_1621}professeur de mathématiques des pages du prince et de la princesse de Conti{/in}. Auteur de plans, de cartes, d''ouvrages illustrés et d''atlas, qu''il publie et diffuse parfois lui-même de 1776 à 1792 au moins. Auteur notamment d''un "Dictionnaire hydrographique de la France..." (1re éd., l''auteur, 1787 ; rééd., Paris, Blanchon, {dat1803}1803{/dat}) et d''une série de "Recherches historiques" sur les villes de France (Angers, Orléans, Reims, 1775-1776). Se qualifie de {en1631}libraire{/en} en 1791-1792. Décédé à Paris le 21 frimaire an XIV (12 déc. 1805, Arch. de Paris) [http://data.bnf.fr/ark:/12148/cb13531657x#foaf:Person]
{/ud}
{ud0}
Nevil Maskelyne ({dat1732}1732{/dat}) {en24}Astronome{/en} royal d''Angleterre. - Membre associé de l''Académie des sciences de Paris [http://data.bnf.fr/ark:/12148/cb12155150p#foaf:Person]
{/ud}
{ud0}
Jacques-François Dicquemare ({en0li}Le Havre{/en}, {dat1733}1733{/dat}) {en24}Astronome{/en}. - Hydrographe. - Zoologue marin [http://data.bnf.fr/ark:/12148/cb15317071s#foaf:Person]
{/ud}
{ud0}
János Sajnovics ({en0li}Tordas, Hongrie{/en}, {dat1733}1733{/dat}) {en24}Astronome{/en}. - Linguiste. - Père jésuite [http://data.bnf.fr/ark:/12148/cb12246417w#foaf:Person]
{/ud}
{ud0}
Jean-Charles Borda ({en0li}Dax (Landes){/en}, {dat1733}1733{/dat}) Officier de marine. - Membre de l''Académie de Marine (élu en 1769). - Entra dans le Génie militaire et se fit remarquer par ses travaux sur l''hydraulique. - Il détermina la longitude des Canaries (en 1776). - Prit part à la guerre d''indépendance américaine. - Participa avec Delambre et Méchain à la mesure de l''arc de méridien Dunkerque-Barcelone. - En qualité de commissaire de l''Académie des sciences participa à l''étude des montres marines sur la frégate la Flore (en 1771). - Membre de l''Institut, Académie des sciences (élu en 1772). - Membre de la Commission des poids et mesures (en 1791), il travailla à l''établissement du système métrique. - Membre de l''Institut national des sciences et arts, section mathématiques (actuel Institut de France) et du Bureau des longitudes (en 1795). - Co-fondateur de La Société de Borda (créée en 1876), avec Jacques-François de Borda d''Oro (1718-1804) [http://data.bnf.fr/ark:/12148/cb12482831r#foaf:Person]
{/ud}
{ud0}
Samuel Horsley ({dat1733}1733{/dat}) Evêque; secrétaire de la Royal Society; publia des livres de théologie et de mathématiques [http://data.bnf.fr/ark:/12148/cb120697374#foaf:Person]
{/ud}
{ud0}
Achille Pierre Dionis du Séjour ({en0li}Paris{/en}, {dat1734}1734{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb10680537k#foaf:Person]
{/ud}
{ud0}
Baudouin de Guémadeuc ({dat1734}1734{/dat}) Homme de loi, homme de lettres, pamphlétaire puis {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb144447840#foaf:Person]
{/ud}
{ud0}
Charles Duvaucel ({dat1734}1734{/dat}) {en24}Astronome{/en}, spécialisé dans les éclipses du soleil. [http://data.bnf.fr/ark:/12148/cb15318527x#foaf:Person]
{/ud}
{ud0}
Mathieu Bernard Goudin ({en0li}Paris{/en}, {dat1734}1734{/dat}) Magistrat. - {en16}Mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb10586154b#foaf:Person]
{/ud}
{ud0}
Alexandre-Théophile Vandermonde ({en0li}Paris{/en}, {dat1735}1735{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12534847r#foaf:Person]
{/ud}
{ud0}
Antonio Maria Lorgna ({en0li}Cerea, Italie{/en}, {dat1735}1735{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12387058m#foaf:Person]
{/ud}
{ud0}
Gregorio Fontana ({en0li}Villa di Nogaredo, Italie{/en}, {dat1735}1735{/dat}) {en16}Mathématicien{/en} et {en1630}physicien{/en}. - Recteur et professeur de calcul sublime à l''Ateneo lombardo. - Bibliothécaire du Collegio Ghisleri, Pavie [http://data.bnf.fr/ark:/12148/cb10601676b#foaf:Person]
{/ud}
{ud0}
Giovanni-Antonio Rizzi-Zannoni ({en0li}Padoue, Italie{/en}, {dat1736}1736{/dat}) {en29}Géographe{/en} de la république de Venise, {en24}astronome{/en}, il voyage en Amérique du nord en 1757 [http://data.bnf.fr/ark:/12148/cb153024615#foaf:Person]
{/ud}
{ud0}
Jean Sylvain Bailly ({en0li}Paris{/en}, {dat1736}1736{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en} et homme politique. - Entre à l''Académie des sciences (en 1763), à l''Académie française (en 1784) puis à l''Académie des inscriptions (en 1785). - Député du Tiers-État aux États-Généraux ; Maire de Paris ; Député à l''Assemblée Nationale Constituante [http://data.bnf.fr/ark:/12148/cb12516744h#foaf:Person]
{/ud}
{ud0}
Johann Nicolai Tetens ({en0li}Tetenbüll, Allemagne{/en}, {dat1736}1736{/dat}) {en16}Mathématicien{/en}, {en1630}physicien{/en} et {en18}philosophe{/en} [http://data.bnf.fr/ark:/12148/cb12531163b#foaf:Person]
{/ud}
{ud0}
Joseph-Louis Lagrange ({dat1736}1736{/dat}) {en16}Mathématicien{/en}. - D''origine italienne. - A été à l''origine de la fondation de l''Académie des sciences de Turin. - Membre de l''Académie des sciences de Paris, Berlin, Turin. - A partir de 1787, enseigne à Paris à l''École normale et à l''École polytechnique [http://data.bnf.fr/ark:/12148/cb12125247f#foaf:Person]
{/ud}
{ud0}
Francesco Venini ({en0li}Varenna, Italie{/en}, {dat1737}1737{/dat}) Abbé. - {en16}Mathématicien{/en} et poète [http://data.bnf.fr/ark:/12148/cb105963005#foaf:Person]
{/ud}
{ud0}
Giuseppe Maria Pagnini ({en0li}Pistoia, Italie{/en}, {dat1737}1737{/dat}) Au siècle : Luca Antonio ; en religion, carme : Giuseppe Maria. - Poète. - {en16}Mathématicien{/en}. - Savant latiniste et helléniste. - Professeur à l'' Université de Parme puis de Pise [http://data.bnf.fr/ark:/12148/cb11996942k#foaf:Person]
{/ud}
{ud0}
Tommaso Valperga di Caluso ({en0li}Turin, Italie{/en}, {dat1737}1737{/dat}) Abbé. - Homme de lettres, {en18}philosophe{/en} et {en16}mathématicien{/en}. - Chevalier de Malte [http://data.bnf.fr/ark:/12148/cb10748197m#foaf:Person]
{/ud}
{ud0}
William Bayly ({dat1737}1737{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb14065321z#foaf:Person]
{/ud}
{ud0}
Charles-Joseph Mathon de La Cour ({en0li}Lyon (Rhône){/en}, {dat1738}1738{/dat}) Économiste. - Philanthrope. - Fondateur du "Journal de Lyon". - Rédacteur de "L''Almanach musical" (1775-1778), et au "Journal de musique", Paris (1764-1768). - Fils de : Mathon de La Cour, Jacques (1712-1770), {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb121925904#foaf:Person]
{/ud}
{ud0}
Flecheux ({dat1738}1738{/dat}) {en24}Astronome{/en} et mécanicien français. - Adresse en 1784 : Paris, rue du Sentier, hôtel de madame la présidente de Meslay, n° 31 [http://data.bnf.fr/ark:/12148/cb15585605z#foaf:Person]
{/ud}
{ud0}
Joseph-François Marie ({en0li}Rodez{/en}, {dat1738}1738{/dat}) Abbé. - Fut {in0_1621}professeur de mathématiques au Collège Mazarin{/in} [http://data.bnf.fr/ark:/12148/cb146364765#foaf:Person]
{/ud}
{ud0}
Thomas Abbt ({en0li}Ulm, Allemagne{/en}, {dat1738}1738{/dat}) Écrivain, {en18}philosophe{/en}, {en16}mathématicien{/en}, juriste et conseiller aulique [http://data.bnf.fr/ark:/12148/cb125347464#foaf:Person]
{/ud}
{ud0}
William Herschel ({en0li}Hanovre, Allemagne{/en}, {dat1738}1738{/dat}) {en24}Astronome{/en} et compositeur. - A découvert la planète Uranus. - S''installe en Grande-Bretagne en 1757 [http://data.bnf.fr/ark:/12148/cb14064893z#foaf:Person]
{/ud}
{ud0}
Ermenegildo Pini ({en0li}Milan, Italie{/en}, {dat1739}1739{/dat}) Barnabite. - {en1630}Physicien{/en}, géologue, {en1635}architecte{/en}. - Professeur de mathématiques, puis d''histoire naturelle au Collège Saint-Alexandre, Milan. - Dans le siècle : Pini, Carlo [http://data.bnf.fr/ark:/12148/cb13013593q#foaf:Person]
{/ud}
{ud0}
Jean-Louis Pictet ({dat1739}1739{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb146402484#foaf:Person]
{/ud}
{ud0}
Johann Schultz ({dat1739}1739{/dat}) A été professeur de mathématiques à l''université de Königsberg, Allemagne [http://data.bnf.fr/ark:/12148/cb121741380#foaf:Person]
{/ud}
{ud0}
José Antonio Alzate y Ramírez ({dat1739}1739{/dat}) {en24}Astronome{/en} et {en29}géographe{/en} [http://data.bnf.fr/ark:/12148/cb15376450x#foaf:Person]
{/ud}
{ud0}
András Dugonics ({en0li}Szeged (Hongrie){/en}, {dat1740}1740{/dat}) Écrivain. - Poète. - Piariste. - {in0_1621}Professeur de mathématiques{/in}. - A fait des études de théologie  à Privigye (aujourd''hui Prievidza, Slovaquie) et à Nyitra (aujourd''hui Nitra, Slovaquie) [http://data.bnf.fr/ark:/12148/cb12246575b#foaf:Person]
{/ud}
{ud0}
Jacques-André Mallet ({dat1740}1740{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb10552198c#foaf:Person]
{/ud}
{ud0}
Joseph Anton Slop von Cadenberg ({dat1740}1740{/dat}) {en24}Astronome{/en}. - À l''Observatoire de Pise à partir de 1765 [http://data.bnf.fr/ark:/12148/cb12159312n#foaf:Person]
{/ud}
{ud0}
Nicola Spedalieri ({en0li}Bronte (Italie){/en}, {dat1740}1740{/dat}) {in0_1621}Professeur de philosophie, théologie et mathématique{/in}, poète, musicien, historien [http://data.bnf.fr/ark:/12148/cb16219670j#foaf:Person]
{/ud}
{ud0}
Nicolas-Antoine Nouet ({dat1740}1740{/dat}) {en24}Astronome{/en}. - Attaché à l''Observatoire en 1785. - Participe à l''expédition d''Égypte en 1798. - {en1633}Ingénieur{/en} au Bureau de la guerre en 1802 [http://data.bnf.fr/ark:/12148/cb12151453k#foaf:Person]
{/ud}
{ud0}
Thomas Bugge ({en0li}Copenhague{/en}, {dat1740}1740{/dat}) {en24}Astronome{/en} et {en1636}cartographe{/en} [http://data.bnf.fr/ark:/12148/cb121931908#foaf:Person]
{/ud}
{ud0}
Vicente Tofiño de San Miguel ({dat1740}1740{/dat}) {en24}Astronome{/en}. - Capitaine de vaisseau. - Directeur des compagnies des gardes royales de la marine en 1786. - Membre de l''Académie d''histoire de Madrid. - Correspondant de l''Académie des sciences de Paris [http://data.bnf.fr/ark:/12148/cb12159995t#foaf:Person]
{/ud}
{ud0}
Alexis Rochon ({en0li}Brest (Finistère){/en}, {dat1741}1741{/dat}) Prêtre, {en24}astronome{/en} de la marine, {en1630}physicien{/en} et inventeur. - Bibliothécaire de l''Académie royale de marine à Brest (1765-), {en24}astronome{/en} opticien de la Marine ({dat1787}1787{/dat}), membre de la Commission des poids et mesures et des monnaies ({dat1792}1792{/dat}). - Membre de l''Académie royale des sciences, puis membre de l''Institut. - Clerc tonsuré [http://data.bnf.fr/ark:/12148/cb129983745#foaf:Person]
{/ud}
{ud0}
Stanislaw Wydra ({dat1741}1741{/dat}) {in0_1621}Professeur de mathématiques{/in} [http://data.bnf.fr/ark:/12148/cb15512813z#foaf:Person]
{/ud}
{ud0}
Vincenzo Chiminello ({en0li}Marostica, Italie{/en}, {dat1741}1741{/dat}) Abbé. - {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb10522164f#foaf:Person]
{/ud}
{ud0}
Georg Jonathan von Holland ({dat1742}1742{/dat}) {en1629}Théologien{/en}. - {en16}Mathématicien{/en}. - Précepteur des princes de Wurttemberg [http://data.bnf.fr/ark:/12148/cb119076602#foaf:Person]
{/ud}
{ud0}
Jacques Poitevin ({en0li}Montpellier{/en}, {dat1742}1742{/dat}) Savant {en24}astronome{/en} et agriculteur. - Conseiller de préfecture du département de l''Hérault. - Membre de la Société royale des sciences de Montpellier [http://data.bnf.fr/ark:/12148/cb10644654k#foaf:Person]
{/ud}
{ud0}
Antonio Cagnoli ({en0li}Zante, Grèce{/en}, {dat1743}1743{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en}. - Crée un observatoire d''astronomie à Vérone. - Enseigne les mathématiques à l''École militaire de Modène après la prise de Vérone par les Français ({dat1797}1797{/dat}). - Membre de nombreuses académies d''Europe [http://data.bnf.fr/ark:/12148/cb12562781s#foaf:Person]
{/ud}
{ud0}
Eberhard August Wilhelm von Zimmermann ({en0li}Uelzen, Allemagne{/en}, {dat1743}1743{/dat}) {en29}Géographe{/en} et naturaliste. - {in0_1621}Professeur de mathématiques et de sciences naturelles au Collegium Carolinum de Brunswick de 1766 à 1815{/in}. - Conseiller aulique en 1786, puis conseiller d''état en 1801 [http://data.bnf.fr/ark:/12148/cb12330956p#foaf:Person]
{/ud}
{ud0}
Jean-Antoine-Nicolas de Caritat Condorcet ({dat1743}1743{/dat}) {en18}Philosophe{/en}, {en16}mathématicien{/en} et  économiste. - Membre de l''Académie française ({dat1782}1782{/dat}). - Homme politique. - A aussi écrit sous le pseudonyme M. Schwartz, pasteur à Bienne [http://data.bnf.fr/ark:/12148/cb118975118#foaf:Person]
{/ud}
{ud0}
Etienne Lenoir ({dat1744}1744{/dat}) {en1633}Ingénieur{/en}. - Mit au point plusieurs instruments d''astronomie et de géodésie [http://data.bnf.fr/ark:/12148/cb151423156#foaf:Person]
{/ud}
{ud0}
François Callet ({en0li}Versailles{/en}, {dat1744}1744{/dat}) Professeur de mathématiques et d''hydrographie [http://data.bnf.fr/ark:/12148/cb10544471f#foaf:Person]
{/ud}
{ud0}
Jean Bernoulli ({en0li}Bâle, Suisse{/en}, {dat1744}1744{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en}. - Membre des Académies des sciences de Berlin, de Petersbourg, de Stockholm, de Bologne, de Lyon, & de Marseille, de la Société pour l''encouragement des arts, de Londres, de celle des {en1630}physicien{/en}s de Bâle, de l''Académie des Arcades de Rome [http://data.bnf.fr/ark:/12148/cb14508854n#foaf:Person]
{/ud}
{ud0}
José Anastácio da Cunha ({dat1744}1744{/dat}) Poète portugais. - {en16}Mathématicien{/en}, professeur de géométrie à l''Université de Coimbra. - Officier d''artillerie à Valença do Minho (1764-1778) [http://data.bnf.fr/ark:/12148/cb121612626#foaf:Person]
{/ud}
{ud0}
Pierre Méchain ({en0li}Laon{/en}, {dat1744}1744{/dat}) {en24}Astronome{/en} français. - Prénoms complets : Pierre François André [http://data.bnf.fr/ark:/12148/cb12090251r#foaf:Person]
{/ud}
{ud0}
Caspar Wessel ({en0li}Vestby, Norvège{/en}, {dat1745}1745{/dat}) {en16}Mathématicien{/en}. - Reçut la médaille d''argent de la Royal Danish academy [http://data.bnf.fr/ark:/12148/cb12563002z#foaf:Person]
{/ud}
{ud0}
Claude-François Guillemeau de Fréval ({en0li}Paris{/en}, {dat1745}1745{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb10017540p#foaf:Person]
{/ud}
{ud0}
Franz von Paula Triesnecker ({dat1745}1745{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb15115995f#foaf:Person]
{/ud}
{ud0}
Fulcrand Jean Joseph Aigrefeuille ({dat1745}1745{/dat}) G{en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb16296114m#foaf:Person]
{/ud}
{ud0}
Johann Hieronymus Schröter ({dat1745}1745{/dat}) Magistrat et {en24}astronome{/en} amateur allemand [http://data.bnf.fr/ark:/12148/cb11973603q#foaf:Person]
{/ud}
{ud0}
Nicolas Charles Romme (Riom, Puy-de-Dôme, {dat1745}1745{/dat}) Professeur de mathématiques et de navigation à l''École de Rochefort. - Membre de l''Institut [http://data.bnf.fr/ark:/12148/cb12805333t#foaf:Person]
{/ud}
{ud0}
Gaetano Del Ricco ({dat1746}1746{/dat}) Piariste (17 mai 1761). - {en16}Mathématicien{/en}. - Librettiste. - Prénom de baptême : Vincenzo [http://data.bnf.fr/ark:/12148/cb16659347q#foaf:Person]
{/ud}
{ud0}
Gaspard Monge ({dat1746}1746{/dat}) {en16}Mathématicien{/en} et géomètre. - Fondateur de l''École polytechnique et de l''École normale. - Président de l''Institut du Caire. - Membre de l''Institut, Académie des sciences. - Député au Conseil des Cinq-Cents, au Conseil des Anciens, ministre de la Marine ({dat1792}1792{/dat}), sénateur ({dat1799}1799{/dat}), comte de Péluse ({dat1808}1808{/dat}) [http://data.bnf.fr/ark:/12148/cb121412336#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Venturi ({en0li}Bibbiano, Italie{/en}, {dat1746}1746{/dat}) {en1630}Physicien{/en} et {en16}mathématicien{/en}. - Homme politique et diplomate [http://data.bnf.fr/ark:/12148/cb127228927#foaf:Person]
{/ud}
{ud0}
Giuseppe Piazzi ({en0li}Ponte di Valtellina, Italie{/en}, {dat1746}1746{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb12920801z#foaf:Person]
{/ud}
{ud0}
Jean-Claude-Gauthier-Louis de Benaben ({dat1746}1746{/dat}) Oratorien et {in0_1621}professeur de mathématiques{/in}. - Fut directeur de l''Ecole centrale d''Angers. - Fut président des Amis de la Constitution. - Fut commissaire civil du département de Maine-et-Loire [http://data.bnf.fr/ark:/12148/cb125680474#foaf:Person]
{/ud}
{ud0}
Jean Foucaud ({dat1747}1747{/dat}) Prédicateur, {en16}mathématicien{/en}, philologue. - A écrit en patois limousin des fables imitées de La Fontaine, qu''il a aussi traduit dans cette même langue. - Fut l''un des rédacteurs du "Journal du département de la Haute-Vienne". - Fut à Limoges une personalité agissante du Club des jacobins, membre du Comité de salut public, juge de paix et payeur du département de Haute-Vienne. - Défroqué en 1793, il mourut réconcilié avec l''Église [http://data.bnf.fr/ark:/12148/cb119031941#foaf:Person]
{/ud}
{ud0}
Jean-Baptiste Bernard ({dat1747}1747{/dat}) {en1631}Libraire{/en} ; {en1631}libraire{/en} de l''École polytechnique ({dat1800}1800{/dat}) ; de l''École des Ponts et Chaussées ({dat1801}1801{/dat}) ; des Écoles impériales polytechnique et des Ponts et chaussées ({dat1805}1805{/dat}). - Né à Marseille. {en1631}Libraire{/en} spécialisé dans les "mathématiques, sciences et arts", il travaille jusqu''en 1796 en association avec Régent au bureau du "Journal polytechnique" ou "Bulletin des Travaux publics..." Historien et philologue, éditeur des "Œuvres posthumes" de Montesquieu. Décédé à Saint-Maur-des-Fossés (Val-de-Marne) en oct. 1808. Sa veuve lui succède avant de revendre son fonds en 1810 à Jean Klostermann [http://data.bnf.fr/ark:/12148/cb122388832#foaf:Person]
{/ud}
{ud0}
Johann Elert Bode ({en0li}Hambourg (Allemagne){/en}, {dat1747}1747{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb104634498#foaf:Person]
{/ud}
{ud0}
Andreas Riedel ({en0li}Vienne{/en}, {dat1748}1748{/dat}) Jacobin viennois. - Professeur de mathématiques, précepteur des enfants du Grand duc Léopold, futur empereur,  1779-1790, Florence (Italie). - Études de {en28}médecin{/en}e, élève du professeur Franz Anton Mesmer. - Emprisonné à Brno (1806-1809). - Se réfugia en France 1810-1837 [http://data.bnf.fr/ark:/12148/cb14593357z#foaf:Person]
{/ud}
{ud0}
Jean-Dominique Cassini ({dat1748}1748{/dat}) {en24}Astronome{/en}. - Membre de l''Académie des sciences ({dat1770}1770{/dat}). - Fils de l''{en24}astronome{/en} César-François Cassini (1714-1784), qui était aussi appelé Cassini de Thury, car né à Thury (Oise) en 1714. - Succède à son père comme directeur de l''Observatoire de Paris (en 1784) [http://data.bnf.fr/ark:/12148/cb12157999q#foaf:Person]
{/ud}
{ud0}
Pietro Cossali ({en0li}Vérone, Italie{/en}, {dat1748}1748{/dat}) {en16}Mathématicien{/en}. - A enseigné à l''université de Padoue [http://data.bnf.fr/ark:/12148/cb146340668#foaf:Person]
{/ud}
{ud0}
Pons-Joseph Bernard ({dat1748}1748{/dat}) {en16}Mathématicien{/en}. - Directeur adjoint de l''Observatoire de Marseille [http://data.bnf.fr/ark:/12148/cb12306722n#foaf:Person]
{/ud}
{ud0}
Thaddäus Rinderle ({dat1748}1748{/dat}) Moine bénédictin, {en16}mathématicien{/en} et horloger [http://data.bnf.fr/ark:/12148/cb15037954k#foaf:Person]
{/ud}
{ud0}
Giuseppe Calandrelli ({en0li}Zagarolo, Italie{/en}, {dat1749}1749{/dat}) {en24}Astronome{/en}. - Directeur du "Collegio romano" [http://data.bnf.fr/ark:/12148/cb10544460s#foaf:Person]
{/ud}
{ud0}
Henri Bouchon-Dubournial ({dat1749}1749{/dat}) {en1633}Ingénieur{/en} et {en16}mathématicien{/en}. - Fut professeur à l''Ecole militaire et l''Ecole royale militaire. - Fut le traducteur de Cervantès [http://data.bnf.fr/ark:/12148/cb125620183#foaf:Person]
{/ud}
{ud0}
Jean-Baptiste Delambre ({en0li}Amiens{/en}, {dat1749}1749{/dat}) {en24}Astronome{/en}. - Ses calculs ont servi à  déterminer la longueur du mètre. - Membre de l''Académie des sciences ({dat1792}1792{/dat}) [http://data.bnf.fr/ark:/12148/cb12096096m#foaf:Person]
{/ud}
{ud0}
Paul-Louis Cirodde ({dat1749}1749{/dat}) {in0_1621}Professeur de mathématiques{/in} [http://data.bnf.fr/ark:/12148/cb102655606#foaf:Person]
{/ud}
{ud0}
Pierre-Simon de Laplace (Beaumont-en-Auge ({en0li}Calvados){/en}, {dat1749}1749{/dat}) {en24}Astronome{/en}, {en16}mathématicien{/en} et {en1630}physicien{/en}. - Membre de l''Institut, Académie des sciences (élu en 1795), puis de l''Académie française (élu en 1816). - Obtint le titre de marquis (en 1817) [http://data.bnf.fr/ark:/12148/cb119110516#foaf:Person]
{/ud}
{ud0}
Vincenzo De Filippis ({dat1749}1749{/dat}) Scientifique, {en16}mathématicien{/en}. - Ministre de la République parthénopéenne en février 1799, fut probablement victime de la répression au rétablissement des Bourbons en juin de la même année [http://data.bnf.fr/ark:/12148/cb12290835h#foaf:Person]
{/ud}
{ud0}
William Faden ({dat1749}1749{/dat}) {en1631}Libraire{/en}, éditeur et marchand de cartes et d''estampes ; également {en29}géographe{/en} ordinaire du roi d''Angleterre (1783-1820) et du prince de Galles (1790-1820). - Fils de l''{en1632}imprimeur{/en} londonien William I Faden (à l''origine Mackfaden, 1711-1783). En apprentissage de juillet 1764 à août 1771. Travaille en association avec la famille du {en1631}libraire{/en} et {en29}géographe{/en} du Roi Thomas Jefferys (m. 1771) jusqu''en 1776 env. Membre de la "Society of civil engineers". Beau-frère du peintre et {en24}astronome{/en} John Russell. Se retire en 1823 et cède son affaire à son ancien apprenti James Wyld. Décédé à Shepperton en mars 1836 [http://data.bnf.fr/ark:/12148/cb15615346f#foaf:Person]
{/ud}
{ud0}
Caroline Lucretia Herschel (Hanovre (Basse-Saxe,  Allemagne), {dat1750}1750{/dat}) {en24}Astronome{/en}. - Assistante de son frère, William Herschel (1738-1822), lui aussi {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb16108822m#foaf:Person]
{/ud}
{ud0}
Gilbert Romme ({dat1750}1750{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en} et {en29}géographe{/en}. - Député du Puy-de-Dôme à l''Assemblée législative puis à la Convention, représentant en mission près l''armée de Cherbourg, préconise l''essai du télégraphe aérien de Chiappe. - A participé à l''établissement du calendrier révolutionnaire [http://data.bnf.fr/ark:/12148/cb12536106q#foaf:Person]
{/ud}
{ud0}
Lorenzo Mascheroni ({en0li}Bergame, Italie{/en}, {dat1750}1750{/dat}) {en16}Mathématicien{/en} et poète. - Professeur de physique et de mathématique au Séminaire de Bergame, puis d''algèbre et de géométrie à l''Université de Pavie, dont il sera recteur. - Député au Corps législatif de Milan ({dat1799}1799{/dat}), admirateur de Napoléon, fait partie des 29 qui signent l''appel à régner en Italie au Premier Consul après 1799 [http://data.bnf.fr/ark:/12148/cb119149502#foaf:Person]
{/ud}
{ud0}
Nicolas-Maurice Chompré ({en0li}Paris (France){/en}, {dat1750}1750{/dat}) Directeur, entre 1777 et 1786, de la Correspondance générale à la Division des mines et de l''agriculture du Contrôleur général des Finances Bertin. - Diplomate. - Auteur d''ouvrages de physique et de mathématiques [http://data.bnf.fr/ark:/12148/cb122074802#foaf:Person]
{/ud}
{ud0}
Scipione Breislak ({en0li}Rome{/en}, {dat1750}1750{/dat}) Géologue. - {in0_1621}Professeur de mathématiques à Raguse puis à Rome{/in} [http://data.bnf.fr/ark:/12148/cb151306996#foaf:Person]
{/ud}
{ud0}
Simon Lhuilier ({dat1750}1750{/dat}) {en16}Mathématicien{/en} et {en18}philosophe{/en}. - Établi à Varsovie [http://data.bnf.fr/ark:/12148/cb13005974t#foaf:Person]
{/ud}
{ud0}
Alliette ({dat1751}1751{/dat}) Cartomancien de la fin du 18e siècle. - Marchand d''estampes. - Professeur de mathématiques (vers 1753). - La forme "Etteilla" est l''anagramme d''Alliette [http://data.bnf.fr/ark:/12148/cb118885161#foaf:Person]
{/ud}
{ud0}
André-Charles Brotier ({en0li}Paris{/en}, {dat1751}1751{/dat}) Abbé, {en16}mathématicien{/en} et homme politique. - Enseigna les mathématiques à l''Ecole militaire. - Collabora à l''"Année littéraire" et au "Journal de la France" [http://data.bnf.fr/ark:/12148/cb124621991#foaf:Person]
{/ud}
{ud0}
Antide Janvier (Lavans-lès-Saint-Claude ({en0li}Jura){/en}, {dat1751}1751{/dat}) Horloger, {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb12614643k#foaf:Person]
{/ud}
{ud0}
Bazaine ({dat1751}1751{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb10735226f#foaf:Person]
{/ud}
{ud0}
Bernard Violle ({dat1751}1751{/dat}) {en16}Mathématicien{/en}. - Géomètre. - Chevalier de Saint-Louis ({dat1815}1815{/dat}) [http://data.bnf.fr/ark:/12148/cb13006994p#foaf:Person]
{/ud}
{ud0}
Bonaventure Abat ({dat1751}1751{/dat}) {en16}Mathématicien{/en} et {en1629}théologien{/en}, cordelier de l''Observance. - Fut membre associé de l''Académie royale des belles-lettres de Barcelone [http://data.bnf.fr/ark:/12148/cb134813469#foaf:Person]
{/ud}
{ud0}
G.-F. Olivier ({dat1751}1751{/dat}) Bachelier ès sciences. - Professeur d''humanités et de mathématiques (en 1825). Professeur au collège de Troyes [http://data.bnf.fr/ark:/12148/cb10728006s#foaf:Person]
{/ud}
{ud0}
Guillelmus Beer ({dat1751}1751{/dat}) {en1636}Cartographe{/en}, {en29}géographe{/en} et peut-être {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb15332855z#foaf:Person]
{/ud}
{ud0}
Hector-Jean Legros ({dat1751}1751{/dat}) Adjoint-général pendant les guerres de Vendée et d''Italie. - {in0_1621}Professeur de mathématiques{/in} [http://data.bnf.fr/ark:/12148/cb13484693c#foaf:Person]
{/ud}
{ud0}
Henri Jurain ({dat1751}1751{/dat}) Abbé. - {in0_1621}Professeur de mathématiques à Reims{/in}. - Correspondant de l''Académie des Sciences [http://data.bnf.fr/ark:/12148/cb12224993g#foaf:Person]
{/ud}
{ud0}
J.-B.-M. Duprat ({dat1751}1751{/dat}) {en1631}Libraire{/en} pour les mathématiques. - En activité de mars 1797 à 1803 au moins. Apparenté à Louis (-Alexis) Duprat-Duverger, en activité à partir de 1802, qui a pu se qualifier lui aussi de "{en1631}libraire{/en} pour les mathématiques". Louis Courcier, "{en1632}imprimeur{/en} et {en1631}libraire{/en} pour les mathématiques", lui succède en 1803 à la même adresse (quai des Augustins, n° 71). Une "madame Duprat" est cependant répertoriée, à l''adresse du pont Saint-Michel, par le "Tableau des {en1631}libraire{/en}s" de Debray (Paris, janv. 1804) [http://data.bnf.fr/ark:/12148/cb16701987t#foaf:Person]
{/ud}
{ud0}
J.P. Audiffred ({dat1751}1751{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb125867381#foaf:Person]
{/ud}
{ud0}
Jacques Baradelle ({dat1751}1751{/dat}) Etabli dès 1740 quai de l''Horloge du Palais, il fabriquait des instruments de navigation, des cadrans solaires, des sphères astronomiques et géographiques [http://data.bnf.fr/ark:/12148/cb15281028g#foaf:Person]
{/ud}
{ud0}
James Dodson ({dat1751}1751{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb153816258#foaf:Person]
{/ud}
{ud0}
Jean-Louis Gœury ({dat1751}1751{/dat}) {en1631}Libraire{/en} ; {en1631}libraire{/en} pour les mathématiques et l''architecture ; {en1631}libraire{/en} de l''École des Ponts et chaussées ({dat1802}1802{/dat}) ; des {en1633}ingénieur{/en}s et de l''École impériale des Ponts et chaussées ({dat1805}1805{/dat}). - Semble avoir été commis du {en1631}libraire{/en} parisien Charles-Antoine Jombert de 1770 à 1773 au moins. Père du {en28}médecin{/en} Jean-Louis Gœury-Duvivier, né le 2 mars 1803. En activité dès 1800. Breveté {en1631}libraire{/en} le 1er oct. 1812 (brevet renouvelé le 11 sept. 1818). Décédé peu avant le 28 juin 1827, date à laquelle son fils Jean-Louis Gœury (dit plus tard Gœury-Duvivier) demande à succéder à son brevet [http://data.bnf.fr/ark:/12148/cb12230577c#foaf:Person]
{/ud}
{ud0}
Joseph Mouchet ({dat1751}1751{/dat}) Professeur de rhétorique et de mathématiques, professeur de physique à l''université de Nantes de 1780 à 1784. - Aéronaute. - Membre de la Congrégation de l''Oratoire [http://data.bnf.fr/ark:/12148/cb16514291q#foaf:Person]
{/ud}
{ud0}
Joseph-Louis Vincens de Mauléon de Causans ({en0li}Avignon{/en}, {dat1751}1751{/dat}) {en16}Mathématicien{/en}. - Colonel d''infanterie du régiment de Conti. - Chevalier de Malte [http://data.bnf.fr/ark:/12148/cb145658189#foaf:Person]
{/ud}
{ud0}
Le Professeur de mathématiques du Collège national de Toul ({dat1751}1751{/dat}) {in0_1621}Professeur de mathématiques du Collège national de Toul{/in} [http://data.bnf.fr/ark:/12148/cb125373980#foaf:Person]
{/ud}
{ud0}
Le Ratz de Lanthenée ({dat1751}1751{/dat}) Gentilhomme liégeois. - {en16}Mathématicien{/en} et {en1630}physicien{/en} [http://data.bnf.fr/ark:/12148/cb124022694#foaf:Person]
{/ud}
{ud0}
Louis Duprat-Duverger ({dat1751}1751{/dat}) Variante(s) de prénom : Louis-Alexis. - {en1631}Libraire{/en} pour les mathématiques ; également éditeur de cartes et d''atlas. - Apparenté au "{en1631}libraire{/en} pour les mathématiques" J.-B.-M. Duprat, en activité à Paris entre 1797 et 1803. Établi dès 1802, d''abord en association sous la raison "L. Duprat, Letellier et compagnie" jusqu''en 1804, seul ensuite. Breveté {en1631}libraire{/en} le 1er oct. 1812 ; brevet renouvelé le 15 mars 1817 ; duplicata délivré le 27 avril 1824. Encore en activité en 1829 [http://data.bnf.fr/ark:/12148/cb133399518#foaf:Person]
{/ud}
{ud0}
Madame Bailly ({dat1751}1751{/dat}) Épouse de Jean-Sylvain Bailly, {en16}mathématicien{/en}, {en24}astronome{/en} et homme politique, guillotiné en 1793 [http://data.bnf.fr/ark:/12148/cb16541654h#foaf:Person]
{/ud}
{ud0}
Marie de La Fresnaye ({en0li}Barfleur (Manche){/en}, {dat1751}1751{/dat}) {in0_1621}Professeur de littérature et de mathématiques{/in} [http://data.bnf.fr/ark:/12148/cb100430283#foaf:Person]
{/ud}
{ud0}
Marie-Louise Cartan ({dat1751}1751{/dat}) Femme d''Elie Cartan, mère du compositeur Jean Cartan et du {en16}mathématicien{/en} Henri Cartan. - Née Marie-Louise Bianconi [http://data.bnf.fr/ark:/12148/cb148511208#foaf:Person]
{/ud}
{ud0}
Mathurin-Georges Girault de Keroudou ({dat1751}1751{/dat}) Abbé. - {en16}Mathématicien{/en} français. - Principal du collège de Quimper. - {in0_1621}Professeur de philosophie et de mathématiques au collège de Navarre à Paris{/in}. - Professeur au collège de Louis-le-Grand à Paris [http://data.bnf.fr/ark:/12148/cb15085298t#foaf:Person]
{/ud}
{ud0}
Nicolas Leverdé ({dat1751}1751{/dat}) {en25}Astrologue{/en} et {en16}mathématicien{/en}. - Auteur d''almanachs [http://data.bnf.fr/ark:/12148/cb10403809w#foaf:Person]
{/ud}
{ud0}
Olaf Söderberg ({dat1751}1751{/dat}) Botaniste et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12563978p#foaf:Person]
{/ud}
{ud0}
Théodore Bouys ({dat1751}1751{/dat}) {en16}Mathématicien{/en} favorable à Necker et à la Révolution [http://data.bnf.fr/ark:/12148/cb12240772d#foaf:Person]
{/ud}
{ud0}
Trabaud ({dat1751}1751{/dat}) Maître de mathématiques [http://data.bnf.fr/ark:/12148/cb134811442#foaf:Person]
{/ud}
{ud0}
Vérologue ({dat1751}1751{/dat}) "Seul {en1632}imprimeur{/en} d''Apollon pour la satyre en prose". - Pseud. auquel est adjoint le qualificatif "seul {en1632}imprimeur{/en} d''Apollon pour la satyre en prose" et qui, sous la fausse adresse "Sur l''imprimé au Parnasse", dissimule une impression française (parisienne selon Weller et G. Brunet, plutôt provinciale d''après le matériel typographique) de "La Nouvelle Astronomie du Parnasse françois, ou l''Apothéose des écrivains vivans dans la présente année 1740", due au chevalier Jean-Florent-Joseph de Neufville de Brunaubois-Montador [http://data.bnf.fr/ark:/12148/cb165246377#foaf:Person]
{/ud}
{ud0}
Veuve de Louis Courcier ({dat1751}1751{/dat}) Nom patronymique : Victoire-Félicité Lemaire. - {en1632}Imprimeur{/en}-{en1631}libraire{/en} ; {en1632}imprimeur{/en}-{en1631}libraire{/en} pour les mathématiques, la marine, les sciences et les arts. - Brevetée {en1632}imprimeur{/en} en succession de son mari le 12 août 1811 (brevet renouvelé le 15 oct. 1816) et {en1631}libraire{/en} le 1er oct. 1812 (brevet renouvelé le 15 mars 1817). Deux de ses  gendres lui succèdent : Démophile Huzard (-Courcier) en mars 1820 (brevet du 14 mars 1820) comme {en1632}imprimeur{/en}, et Victor Bachelier le 10 nov. 1821 comme {en1631}libraire{/en} [http://data.bnf.fr/ark:/12148/cb124778683#foaf:Person]
{/ud}
{ud0}
Adrien-Marie Legendre ({dat1752}1752{/dat}) {en16}Mathématicien{/en}. - Président de l''Académie des sciences ({dat1806}1806{/dat}). - A aussi écrit avec Charles-Etienne Coquebert de Montbret et François Gattey sous le pseudonyme collectif "C.-G.-L. Métrophile" [http://data.bnf.fr/ark:/12148/cb12443375d#foaf:Person]
{/ud}
{ud0}
Barnaba Oriani ({en0li}Carignano, Italie{/en}, {dat1752}1752{/dat}) {en24}Astronome{/en} de l''Observatoire de Brera (1777-), puis de Milan. - A découvert qu''Uranus était une planète à partir de son orbite. - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12537845s#foaf:Person]
{/ud}
{ud0}
Jean-Baptiste Labey (La Chapelle-Hainfray (Calvados), aujourd''hui Valsemé ({en0li}Calvados){/en}, {dat1752}1752{/dat}) {en16}Mathématicien{/en}. - Professeur à l''École militaire, à l''École centrale du Panthéon, à l''École polytechnique et au Lycée Napoléon de Paris [http://data.bnf.fr/ark:/12148/cb12112257t#foaf:Person]
{/ud}
{ud0}
Jean-Baptiste Pérès (Valence d''Agen (Tarn-et-Garonne), {dat1752}1752{/dat}) Oratorien. - {in0_1621}Professeur de mathématiques et de physique  à Lyon{/in}, membre de la Société des amis de la Constitution de la ville durant la Révolution, puis substitut du procureur général près la cour royale d''Agen et bibliothécaire de cette ville [http://data.bnf.fr/ark:/12148/cb126307361#foaf:Person]
{/ud}
{ud0}
Marc-Auguste Pictet ({en0li}Genève (Suisse){/en}, {dat1752}1752{/dat}) Naturaliste genevois, littérateur, chimiste, {en1630}physicien{/en} et {en24}astronome{/en}. - Membre fondateur de la Société de physique et d''histoire naturelle de Genève, Suisse. - Correspondant de la Société royale de Londres [http://data.bnf.fr/ark:/12148/cb125386742#foaf:Person]
{/ud}
{ud0}
François Gattey ({dat1753}1753{/dat}) {en16}Mathématicien{/en}. - Directeur du Bureau des poids et mesures (en 1795). - A aussi écrit avec Charles-Etienne Coquebert de Montbret et Adrien-Marie Legendre sous le pseudonyme collectif "C.-G.-L. Métrophile" [http://data.bnf.fr/ark:/12148/cb12447886d#foaf:Person]
{/ud}
{ud0}
Antoine de La Salle ({dat1754}1754{/dat}) {en18}Philosophe{/en}. - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12173561c#foaf:Person]
{/ud}
{ud0}
Colin Mackenzie (Stornoway (Lewis, Western isles, Royaume-Uni), {dat1754}1754{/dat}) {en16}Mathématicien{/en}. - Fonctionnaire collonial en Inde (1815-1821). - Chargé du relevé cartographique de l''Inde et de la description de ses régions. - Collectionneur de divers documents (manuscrits, dessins aquarelles...) constituant le fonds d''études indianistes, collection dispersée aujourd''hui entre l''India office library, Londres et : Government oriental manuscripts library, Madras et Calcutta [http://data.bnf.fr/ark:/12148/cb14374770r#foaf:Person]
{/ud}
{ud0}
Franz Xaver von Zach ({en0li}Bratislava{/en}, {dat1754}1754{/dat}) {en24}Astronome{/en}. - Directeur de l''Observatoire du Seeberg (près de Gotha), de 1787 à 1808. - Dirigea les "Allgemeinen geographischen Ephemeriden" (1796-) [http://data.bnf.fr/ark:/12148/cb121732757#foaf:Person]
{/ud}
{ud0}
Jean-Baptiste Meusnier de La Place (Tours (Indre-et-Loire), {dat1754}1754{/dat}) {en16}Mathématicien{/en} et Officier. - Elu à l''Académie des sciences en 1784 pour son étude locale des surfaces. - Prénoms complets : Jean-Baptiste Marie Charles [http://data.bnf.fr/ark:/12148/cb10732160m#foaf:Person]
{/ud}
{ud0}
Nicolas-François Canard ({dat1754}1754{/dat}) {en16}Mathématicien{/en} et économiste [http://data.bnf.fr/ark:/12148/cb12519510c#foaf:Person]
{/ud}
{ud0}
Charles-Étienne Coquebert de Montbret ({en0li}Paris{/en}, {dat1755}1755{/dat}) Diplomate, {en16}mathématicien{/en} et {en29}géographe{/en}. - Nommé responsable de l''organisation du nouveau système de poids et mesures (décret de 1793), professeur de géographie physique et gîtes de minerais à l''École des mines. - A aussi écrit avec François Gattey et Adrien-Marie Legendre sous le pseudonyme collectif "C.-G.-L. Métrophile". - Membre de l''Institut, membre libre de l''Académie des Sciences (en 1816) [http://data.bnf.fr/ark:/12148/cb12447869t#foaf:Person]
{/ud}
{ud0}
Claude Philippe Bertrand Bertrand (Autun (Saône-et-Loire), {dat1755}1755{/dat}) {en29}Géographe{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb16506861q#foaf:Person]
{/ud}
{ud0}
Emmanuel-Étienne Duvillard de Durand ({en0li}Genève{/en}, {dat1755}1755{/dat}) {en16}Mathématicien{/en}, statisticien. - A développé la mathématisation de l''économie [http://data.bnf.fr/ark:/12148/cb129987837#foaf:Person]
{/ud}
{ud0}
Gaspard-Clair-François-Marie Riche de Prony ({en0li}Chamelet (Rhône){/en}, {dat1755}1755{/dat}) {en16}Mathématicien{/en} et {en1633}ingénieur{/en}. - Directeur de l''École des Ponts et Chaussées (1799-1830). - Membre de l''Académie des Sciences. - Baron à titre personnel ({dat1828}1828{/dat}) [http://data.bnf.fr/ark:/12148/cb12535038t#foaf:Person]
{/ud}
{ud0}
Jean Anthelme Brillat-Savarin ({en0li}Belley, Ain{/en}, {dat1755}1755{/dat}) Magistrat. - Député aux États Généraux (élu en 1789). - G{en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb12305674c#foaf:Person]
{/ud}
{ud0}
Louis Courcier ({dat1755}1755{/dat}) {en1632}Imprimeur{/en}-{en1631}libraire{/en} ; {en1632}imprimeur{/en}-{en1631}libraire{/en} pour les mathématiques ({dat1801}1801{/dat}) ; {en1632}imprimeur{/en}-{en1631}libraire{/en} pour les mathématiques (, les sciences et les arts) (1804-1808). - Exerce l''imprimerie dès l''été 1790. Aurait été auparavant "marchand de peaux de lapin" d''après l''enquête des inspecteurs de la librairie de déc. 1810. Proche des Girondins, il émarge au budget du Bureau de l''Esprit public du ministre Jean-Marie Roland de La Platière en 1792. Dirige le "Courrier du Corps législatif et de la Guerre" ({dat1797}1797{/dat}). Rachète le fonds du {en1631}libraire{/en} J.-B.-M. Duprat et lui succède en 1803 ; rachète l''imprimerie de Jean-Georges-Antoine Stoupe après la mort de celui-ci ({dat1808}1808{/dat}). Breveté {en1632}imprimeur{/en} le 1er avril 1811. Dit âgé de 56 ans lors de son décès (30 juillet 1811). Sa veuve est brevetée en sa succession dès le 12 août 1811 [http://data.bnf.fr/ark:/12148/cb12421329b#foaf:Person]
{/ud}
{ud0}
Nicolas B. Halma ({dat1755}1755{/dat}) Chanoine de Paris. - {en24}Astronome{/en} et {en16}mathématicien{/en}. - Professeur [http://data.bnf.fr/ark:/12148/cb11906753t#foaf:Person]
{/ud}
{ud0}
Nikolaus von Fuss ({dat1755}1755{/dat}) {en16}Mathématicien{/en}, géomètre. - Né à Bâle, s''intalla à Saint-Pétersbourg en 1773 à la demande d''Euler. - Membre de l''Académie des sciences de Saint-Pétersbourg (1775-), secrétaire perpétuel (1800-). - Meurt à Saint-Pétersbourg le 23 décembre 1825 (style grégorien) [http://data.bnf.fr/ark:/12148/cb12359314p#foaf:Person]
{/ud}
{ud0}
Pierre Tédenat ({dat1755}1755{/dat}) Docteur en mathématiques. - Recteur de l''académie Nîmes (1809-1818) et {in0_1621}professeur de philosophie à la faculté des lettres de Nîmes{/in} [http://data.bnf.fr/ark:/12148/cb10379875d#foaf:Person]
{/ud}
{ud0}
Agricol-Joseph-François-Xavier-Pierre-Esprit-Simon-Paul-Antoine Fortia d''Urban ({en0li}Avignon{/en}, {dat1756}1756{/dat}) {en16}Mathématicien{/en} et littérateur. - Chevalier de la Légion d''honneur en 1811, correspondant de l''Académie de Belgique en 1828 et membre libre de l''Académie des Inscriptions et belles-lettres en 1830 [http://data.bnf.fr/ark:/12148/cb121468483#foaf:Person]
{/ud}
{ud0}
Alexandre Ruelle ({en0li}Blois{/en}, {dat1756}1756{/dat}) {en24}Astronome{/en}. - Professeur d''astronomie à l''Observatoire de Paris de 1783 à 1795 [http://data.bnf.fr/ark:/12148/cb121582720#foaf:Person]
{/ud}
{ud0}
Ernst Gottfried Fischer ({dat1756}1756{/dat}) {en1630}Physicien{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb124025182#foaf:Person]
{/ud}
{ud0}
Jan Chrzciciel Władysław Śniadecki ({dat1756}1756{/dat}) {en16}Mathématicien{/en} et {en18}philosophe{/en}, un des plus grands savants polonais des Lumières [http://data.bnf.fr/ark:/12148/cb123726267#foaf:Person]
{/ud}
{ud0}
Joseph Mollet (Aix-en-Provence (Bouches-du-Rhône), {dat1756}1756{/dat}) Oratorien. - {in0_1621}Professeur de physique et de mathématique, École Centrale, Lyon, Rhône{/in}. - Doyen de la Faculté des sciences de Lyon (1809-1815) [http://data.bnf.fr/ark:/12148/cb12196474k#foaf:Person]
{/ud}
{ud0}
Carl-Christian von Langsdorf ({en0li}Nauheim (Allemagne){/en}, {dat1757}1757{/dat}) {en16}Mathématicien{/en}. - {en1633}Ingénieur{/en}. - Professeur de mathématiques à Erlangen (Allemagne), de 1798 à 1804, puis à Vilnius (Lituanie) de 1804 à 1806. - Frère de Langsdorf, Johann-Wilhelm (1745-1827) [http://data.bnf.fr/ark:/12148/cb10661030m#foaf:Person]
{/ud}
{ud0}
Dominique Blanqui ({dat1757}1757{/dat}) Professeur de philosophie et d''astronomie. - Député à la Convention. - Membre du Conseil des Cinq-cents [http://data.bnf.fr/ark:/12148/cb12534874n#foaf:Person]
{/ud}
{ud0}
Alexandre-Balthazar-Laurent Grimod de La Reynière ({en0li}Paris{/en}, {dat1758}1758{/dat}) Avocat. - Pamphlétaire. - G{en24}astronome{/en}, fondateur et président du "Jury dégustateur" [http://data.bnf.fr/ark:/12148/cb11905936j#foaf:Person]
{/ud}
{ud0}
Johann Christoph Schuster ({dat1759}1759{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb16505504t#foaf:Person]
{/ud}
{ud0}
Louis-François-Antoine Arbogast ({en0li}Mutzig, Alsace{/en}, {dat1759}1759{/dat}) {en16}Mathématicien{/en}. - Directeur du Collège royal (en 1791). - Député à l''Assemblée législative puis à la Convention nationale [http://data.bnf.fr/ark:/12148/cb12520232w#foaf:Person]
{/ud}
{ud0}
Pierre-René-Auguste Bremond d''Ars ({dat1759}1759{/dat}) Député de la noblesse. - Fut {in0_1621}professeur de mathématiques et de latin{/in} [http://data.bnf.fr/ark:/12148/cb12540611f#foaf:Person]
{/ud}
{ud0}
Thomas Keith ({en0li}Winestead (GB){/en}, {dat1759}1759{/dat}) {en16}Mathématicien{/en}. - Professeur [http://data.bnf.fr/ark:/12148/cb10275963j#foaf:Person]
{/ud}
{ud0}
Giovanni Paradisi ({en0li}Reggio Emilia, Italie{/en}, {dat1760}1760{/dat}) Comte. - Homme politique. - {en16}Mathématicien{/en}. - Poète [http://data.bnf.fr/ark:/12148/cb105910991#foaf:Person]
{/ud}
{ud0}
Nicolas Antoine Guillard ({en0li}Sorbais, Aisne{/en}, {dat1760}1760{/dat}) {in0_1621}Professeur de mathématiques{/in} [http://data.bnf.fr/ark:/12148/cb10617134p#foaf:Person]
{/ud}', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (8, 'Type de segment', NULL, '2015-09-30 17:26:14.167382+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 3, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (14, 'En quelques mots l''essentiel de l''activité de l''acteur est résumé', NULL, '2015-09-30 23:14:59.243403+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 3, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (18, 'Personne qui pratique ou enseigne la philosophie', NULL, '2015-10-04 08:15:39.193019+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 4, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (26, 'Personne qui rédige de textes destiné à la lecture', NULL, '2015-10-06 15:18:36.039768+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 4, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (19, 'Personne qui se consacre à l''étude des disciplines du savoir', NULL, '2015-10-04 08:38:15.524569+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 4, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (27, 'Versé dans la connaissance d''une langue / personne qui, par profession, enseigne la grammaire ou compose des ouvrages de grammaire (http://www.cnrtl.fr/definition/Grammairien)', NULL, '2015-10-06 22:29:01.129391+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 4, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (28, 'Personne habilitée à exercer la médecine après avoir été admise à différents examens sanctionnant plusieurs années d''études médicales', NULL, '2015-10-06 22:31:41.356626+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 4, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (29, 'Personne qui étudie ou qui enseigne la géogrpahie', NULL, '2015-10-06 22:43:37.318267+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 4, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (5, 'Notices tirées d''une requête SPARQL et nettoyée dans un tableur avec Calc', NULL, '2015-09-26 09:57:29.684167+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, '<root><ud>
Hermann de Carinthie (<en type="li">île de Korčula (Croatie)</en>, <dat when="1105">1105</dat>) <en ref="18" >Philosophe</en>, <en ref="26" >écrivain</en>, <en ref="16" >mathématicien</en>, <en ref="25" >astrologue</en> et traducteur croate [http://data.bnf.fr/ark:/12148/cb16243624j#foaf:Person]
</ud>
<ud>
Hermann le Dalmate (<en type="li">Saint Peter en Istrie une partie du duché de Carinthie (au sud de l''Autriche)</en>, <dat when="1110">1110</dat>) <en ref="18" >Philosophe</en>, <en ref="24" >astronome</en>, <en ref="25" >astrologue</en>, <en ref="16" >mathématicien</en> et traducteur d''ouvrages scientifiques et de la littérature. - Il vint très jeune en 1135 en France à Paris et à Chartres. - Eut pour maître Thierry de Chartres. - L''abbé de Cluny, Pierre le Vénérable, poussa Herman à traduire à écrire sur la vie et l''oeuvre de Mahomet [http://data.bnf.fr/ark:/12148/cb12364029w#foaf:Person]
</ud>
<ud>
Bhāskarācārya (<en type="li">Dekkan, Inde</en>, <dat when="1114">1114</dat>) <en ref="16" >Mathématicien</en>. - <en ref="24" >Astronome</en>. - Fils de Maheśvara. - Auteur de :  "Siddhāntaśiromanī" (en 1150) ; "Karṇakutūhala" [http://data.bnf.fr/ark:/12148/cb14498624v#foaf:Person]
</ud>
<ud>
al-Muẓaffar ibn Muḥammad Šaraf al-Dīn Ṭūsī (<dat when="1151">1151</dat>) <en ref="16" >Mathématicien</en>. - Originaire de Ṭūs, Hamad̲ān, Mosul, Alep, Damas. - Écrivait vers 1209 [http://data.bnf.fr/ark:/12148/cb120864072#foaf:Person]
</ud>
<ud>
Johannes de Sacro Bosco (<dat when="1151">1151</dat>) <en ref="16" >Mathématicien</en>. - Chanoine prémontré de Holywood (comté de Dumfries, Écosse). - Professeur à l''Université de Paris. - Semble être né à Halifax (Yorkshire, Angleterre). - Mort en 1256 ou 1244 [http://data.bnf.fr/ark:/12148/cb121284153#foaf:Person]
</ud>
<ud>
Robertus Castrensis (<dat when="1151">1151</dat>) Traducteur de traités scientifiques et de mathématiques. - Sa période d''activité se situe aux alentours de 1145 [http://data.bnf.fr/ark:/12148/cb12223624k#foaf:Person]
</ud>
<ud>
Alexandre de Villedieu (<en type="li">Villedieu (Manche)</en>, <dat when="1170">1170</dat>) Franciscain. - <en ref="27" >Grammairien</en>, <en ref="16" >mathématicien</en> et poète. - Chanoine de la cathédrale Saint-André d''Avranches [http://data.bnf.fr/ark:/12148/cb12536245w#foaf:Person]
</ud>
<ud>
Leonardo Fibonacci (<dat when="1170">1170</dat>) <en ref="16" >Mathématicien</en>. - Surnommé Leonardo Pisano [http://data.bnf.fr/ark:/12148/cb13092437c#foaf:Person]
</ud>
<ud>
Moḥamad ben Moḥamad Naṣīr al-Dīn Ṭōsī (<en type="li">Tus (Iran)</en>, <dat when="1201">1201</dat>) <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb12399386c#foaf:Person]
</ud>
<ud>
Jean Pecham (<dat when="1220">1220</dat>) Provincial des franciscains d''Angleterre. - Archevêque de Cantorbéry (à partir de 1279). - Théologien, <en ref="16" >mathématicien</en> et physicien [http://data.bnf.fr/ark:/12148/cb12459837w#foaf:Person]
</ud>
<ud>
Witelo (<dat when="1220">1220</dat>) <en ref="18" >Philosophe</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12054316n#foaf:Person]
</ud>
<ud>
Maḥmūd ibn Mas´ūd Quṭb al-Dīn al- Šīrāzī (<en type="li">Shīrāz</en>, <dat when="1236">1236</dat>) <en ref="24" >Astronome</en>, <en ref="28" >médecin</en>, <en ref="18" >philosophe</en> et théologien [http://data.bnf.fr/ark:/12148/cb12086388m#foaf:Person]
</ud>
<ud>
Jacob ben Machir (<en type="li">Marseille</en>, <dat when="1238">1238</dat>) <en ref="24" >Astronome</en>. - <en ref="28" >Médecin</en>. - Chancellier de la faculté de médecine de Montpellier [http://data.bnf.fr/ark:/12148/cb165406517#foaf:Person]
</ud>
<ud>
Grégoire Chioniadès (<dat when="1240">1240</dat>) <en ref="24" >Astronome</en>, physicien et <en ref="28" >médecin</en> byzantin. - Évêque de Tabriz, Iran [http://data.bnf.fr/ark:/12148/cb12007088c#foaf:Person]
</ud>
<ud>
Henri Baten (<dat when="1246">1246</dat>) <en ref="18" >Philosophe</en> et théologien. - <en ref="24" >Astronome</en>. - Poète et musicien [http://data.bnf.fr/ark:/12148/cb12220635h#foaf:Person]
</ud>
<ud>
al-Mufaḍḍal ibn ʿUmar Aṯīr al-Dīn al-Abharī (<dat when="1251">1251</dat>) <en ref="18" >Philosophe</en>, logicien, <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb15935708x#foaf:Person]
</ud>
<ud>
Bartolomeo da Parma (<dat when="1251">1251</dat>) <en ref="25" >Astrologue</en>, géomancien et <en ref="24" >astronome</en>. Fut professeur à l''Université de Bologne (1288-1297) [http://data.bnf.fr/ark:/12148/cb144790439#foaf:Person]
</ud>
<ud>
Campanus de Novare (<dat when="1251">1251</dat>) <en ref="24" >Astronome</en>. - <en ref="16" >Mathématicien</en>, commentateur d''Euclide [http://data.bnf.fr/ark:/12148/cb124917005#foaf:Person]
</ud>
<ud>
David ben Yom-Tov Poel (<dat when="1251">1251</dat>) <en ref="18" >Philosophe</en>. - <en ref="28" >Médecin</en>. - Père de l''<en ref="24" >astronome</en> Jacob Poel [http://data.bnf.fr/ark:/12148/cb16540698w#foaf:Person]
</ud>
<ud>
Démétrius Triclinius (<en type="li">Thessalonique</en>, <dat when="1251">1251</dat>) Philologue. - <en ref="16" >Mathématicien</en> et <en ref="25" >astrologue</en> [http://data.bnf.fr/ark:/12148/cb12311753x#foaf:Person]
</ud>
<ud>
Geršon ben Salomon d''Arles (<en type="li">Béziers</en>, <dat when="1251">1251</dat>) Éxégète. - <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb134867338#foaf:Person]
</ud>
<ud>
Hui Yang (<dat when="1251">1251</dat>) <en ref="16" >Mathématicien</en> chinois. En activité entre 1261 et 1275 [http://data.bnf.fr/ark:/12148/cb13746624q#foaf:Person]
</ud>
<ud>
Isaac ben Joseph Israeli (<dat when="1251">1251</dat>) <en ref="24" >Astronome</en>. - Elève d''Asher ben Jehiel [http://data.bnf.fr/ark:/12148/cb16540863s#foaf:Person]
</ud>
<ud>
Jacopo da Firenze (<dat when="1251">1251</dat>) <en ref="16" >Mathématicien</en>. - Actif en 1307 [http://data.bnf.fr/ark:/12148/cb157815579#foaf:Person]
</ud>
<ud>
Jordanus Nemorarius (<dat when="1251">1251</dat>) <en ref="16" >Mathématicien</en>. - Probablement d''origine italienne [http://data.bnf.fr/ark:/12148/cb11986727x#foaf:Person]
</ud>
<ud>
Petrus Philomena de Dacia (<dat when="1251">1251</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en>, <en ref="18" >philosophe</en>. - Attesté entre 1290 et 1300. - Élève à l''Université de Bologne (1291-1292) puis de Paris. - Chanoine de Roskilde, Danemark. - A distinguer de Petrus de Dacia, recteur de l''Université de Paris en 1327 [http://data.bnf.fr/ark:/12148/cb11887258w#foaf:Person]
</ud>
<ud>
ʿAbd al-Ġaffār ibn ʿAbd al-Karīm Naǧm al-Dīn al- Qazwīnī (<dat when="1251">1251</dat>) <en ref="16" >Mathématicien</en> et jurisconsulte chaféite [http://data.bnf.fr/ark:/12148/cb155674927#foaf:Person]
</ud>
<ud>
Andalò Di Negro (<en type="li">Gênes (?), Italie</en>, <dat when="1260">1260</dat>) <en ref="24" >Astronome</en>. - Précepteur de Boccace. - Ambassadeur de la République de Gênes auprès de l''empereur Alexis Comnène (en 1314) [http://data.bnf.fr/ark:/12148/cb121998732#foaf:Person]
</ud>
<ud>
Théodore Métochite (<en type="li">Constantinople</en>, <dat when="1260">1260</dat>) Homme d''état, <en ref="18" >philosophe</en>, poète, <en ref="24" >astronome</en> et rhéteur [http://data.bnf.fr/ark:/12148/cb12000562c#foaf:Person]
</ud>
<ud>
Gersonide (Bagnols-sur-Cèze (<en type="li">Gard)</en>, <dat when="1288">1288</dat>) Exégète biblique, <en ref="16" >mathématicien</en>, <en ref="24" >astronome</en>, <en ref="18" >philosophe</en>, physicien [http://data.bnf.fr/ark:/12148/cb12131941j#foaf:Person]
</ud>
<ud>
Barlaam de Seminara (<dat when="1290">1290</dat>) Moine basilien, abbé du Saint-Esprit à Constantinople (<dat when="1331">1331</dat>), évêque de Gérace (1342-1348). - Théologien, <en ref="18" >philosophe</en>, <en ref="16" >mathématicien</en>, <en ref="24" >astronome</en> et helléniste [http://data.bnf.fr/ark:/12148/cb13549924x#foaf:Person]
</ud>
<ud>
Jacopo Dondi (<dat when="1290">1290</dat>) <en ref="18" >Philosophe</en>, <en ref="24" >astronome</en>, <en ref="28" >médecin</en> italien célèbre pour la construction d''une pendule astrale à Padoue. - Père de Giovanni Dondi [http://data.bnf.fr/ark:/12148/cb124119184#foaf:Person]
</ud>
<ud>
Thomas Bradwardine (<dat when="1290">1290</dat>) <en ref="16" >Mathématicien</en>, <en ref="18" >philosophe</en> et théologien. - Surnommé le "Doctor Profundus". - Archevêque de Canterbury en 1349 [http://data.bnf.fr/ark:/12148/cb12269047v#foaf:Person]
</ud>
<ud>
Richard of Wallingford (<dat when="1292">1292</dat>) <en ref="16" >Mathématicien</en>. - <en ref="24" >Astronome</en>. - Abbé du monastère bénédictin de St Albans [http://data.bnf.fr/ark:/12148/cb12128305h#foaf:Person]
</ud>
<ud>
Jean de Murs (<dat when="1300">1300</dat>) <en ref="24" >Astronome</en>, <en ref="16" >mathématicien</en> et théoricien de la musique. - Maître-ès-arts de l''Université de Paris (<dat when="1321">1321</dat>) [http://data.bnf.fr/ark:/12148/cb121715011#foaf:Person]
</ud>
<ud>
Giovanni Dondi dall''Orologio (<en type="li">Chiogga, Italie</en>, <dat when="1318">1318</dat>) <en ref="28" >Médecin</en> et poète. - <en ref="24" >Astronome</en> et horloger, a terminé l''horloge astronomique, installée par son père : Dondi, Jacopo (1298-1359), à Padoue ou Pavie, Italie [http://data.bnf.fr/ark:/12148/cb122241024#foaf:Person]
</ud>
<ud>
Giacomo Allegretti (<dat when="1325">1325</dat>) <en ref="28" >Médecin</en> , poète et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb14405998n#foaf:Person]
</ud>
<ud>
Blasius de Parma (<dat when="1347">1347</dat>) <en ref="18" >Philosophe</en>, <en ref="16" >mathématicien</en>, <en ref="28" >médecin</en>. - Recteur de l''université de Parme (en 1412) [http://data.bnf.fr/ark:/12148/cb12182615f#foaf:Person]
</ud>
<ud>
Abū ʿAbd Allâh Muḥammad al- Baqqār (<dat when="1351">1351</dat>) <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb155102056#foaf:Person]
</ud>
<ud>
Emmanuel ben Jacob de Tarascon Bonfils (<dat when="1351">1351</dat>) <en ref="24" >Astronome</en>, <en ref="28" >médecin</en> et <en ref="16" >mathématicien</en> ayant vécu à Orange puis à Tarascon. Il est l''auteur de nombreux traités d''astronomie [http://data.bnf.fr/ark:/12148/cb15620448d#foaf:Person]
</ud>
<ud>
Ǧamšīd ibn Masʿūd Ġiyāṯ al-Dīn al- Kāšī (<dat when="1351">1351</dat>) <en ref="28" >Médecin</en>, <en ref="16" >mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb11351746b#foaf:Person]
</ud>
<ud>
Johannes Danck (<dat when="1351">1351</dat>) <en ref="24" >Astronome</en>. - A enseigné à l''Université de Paris de 1327 à 1355 [http://data.bnf.fr/ark:/12148/cb12531239r#foaf:Person]
</ud>
<ud>
Naǧm al-Dīn al- Miṣrī (<dat when="1351">1351</dat>) Auteur supposé de traités portant sur les instruments astronomiques [http://data.bnf.fr/ark:/12148/cb14566743g#foaf:Person]
</ud>
<ud>
Prosdocimus de Beldemandis (<dat when="1351">1351</dat>) Théoricien de la musique, <en ref="16" >mathématicien</en> et physicien [http://data.bnf.fr/ark:/12148/cb127653823#foaf:Person]
</ud>
<ud>
Taddeo da Parma (<dat when="1351">1351</dat>) <en ref="18" >Philosophe</en> averroïste et <en ref="24" >astronome</en>. - A enseigné la philosophie à Bologne vers 1320 [http://data.bnf.fr/ark:/12148/cb10103512f#foaf:Person]
</ud>
<ud>
Théodore Méliténiote (<en type="li">Constantinople</en>, <dat when="1351">1351</dat>) Grand sacellaire de l''Église byzantine, maître des maîtres de l''École patriarcale et archidiacre du clergé palatin. - A laissé un ouvrage d''exégèse de l''Évangile, un traité d''astronomie et un poème allégorique [http://data.bnf.fr/ark:/12148/cb12153709d#foaf:Person]
</ud>
<ud>
Paolo dal Pozzo Toscanelli (<dat when="1397">1397</dat>) <en ref="16" >Mathématicien</en>, physicien, <en ref="29" >géographe</en>, <en ref="24" >astronome</en> et <en ref="25" >astrologue</en>. - Inventeur des gnomons modernes. - Conservateur de la Bibliothèque de Florence [http://data.bnf.fr/ark:/12148/cb12455406j#foaf:Person]
</ud>
<ud>
Ugolino Pisani (<en type="li">Parme, Italie</en>, <dat when="1405">1405</dat>) <en ref="18" >Philosophe</en>, <en ref="16" >mathématicien</en>, auteur de comédies [http://data.bnf.fr/ark:/12148/cb12689419t#foaf:Person]
</ud>
<ud>
Lorenzo Buonincontri (<en type="li">San Miniato, Italie</en>, <dat when="1411">1411</dat>) Militaire, <en ref="16" >mathématicien</en>, <en ref="24" >astronome</en>, <en ref="25" >astrologue</en>, poète et historien. - Professeur d''astronomie à Naples [http://data.bnf.fr/ark:/12148/cb12536229n#foaf:Person]
</ud>
<ud>
ʿAlī ibn Muḥammad al- Qalaṣādī (<en type="li">Baza (Espagne)</en>, <dat when="1412">1412</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en>, juriste et savant [http://data.bnf.fr/ark:/12148/cb12440997n#foaf:Person]
</ud>
<ud>
Piero della Francesca (<en type="li">Borgo San Sepolcro, Italie</en>, <dat when="1416">1416</dat>) Peintre. - A écrit des traités de mathématiques, perspective et géométrie et des écrits sur la science des couleurs et du paysage [http://data.bnf.fr/ark:/12148/cb12060279h#foaf:Person]
</ud>
<ud>
Georgius de Hungaria (<en type="li">Romosz, aujourd''hui Romos, Roumanie</en>, <dat when="1422">1422</dat>) Prisonnier des Turcs (1438-1458). - Dominicain. - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb130923013#foaf:Person]
</ud>
<ud>
Antonio Manetti (<en type="li">Florence, Italie</en>, <dat when="1423">1423</dat>) Homme de lettres. - Architecte, <en ref="24" >astronome</en>, <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb11914242h#foaf:Person]
</ud>
<ud>
Georg von Peurbach (<en type="li">Peuerbach, Autriche</en>, <dat when="1423">1423</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb12374660w#foaf:Person]
</ud>
<ud>
Giovanni Pontano (<en type="li">Cerreto di Spoleto (Perouse), Italie</en>, <dat when="1426">1426</dat>) Homme politique. - Humaniste. - Auteur de traités astronomiques et philosophiques [http://data.bnf.fr/ark:/12148/cb123298807#foaf:Person]
</ud>
<ud>
Johannes Regiomontanus (<en type="li">Königsberg, Allemagne</en>, <dat when="1436">1436</dat>) <en ref="24" >Astronome</en>. - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12159829r#foaf:Person]
</ud>
<ud>
Nīlakaṇṭha Somayajī (<dat when="1443">1443</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en> de l''école de Kerala (Inde) [http://data.bnf.fr/ark:/12148/cb165324540#foaf:Person]
</ud>
<ud>
Luca Pacioli (<dat when="1445">1445</dat>) <en ref="16" >Mathématicien</en>. - Franciscain [http://data.bnf.fr/ark:/12148/cb11918350c#foaf:Person]
</ud>
<ud>
Konrad Türst (<dat when="1450">1450</dat>) <en ref="16" >Mathématicien</en> suisse de Zürich [http://data.bnf.fr/ark:/12148/cb15336511g#foaf:Person]
</ud>
<ud>
Agostino Ricci (<dat when="1451">1451</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb12539498r#foaf:Person]
</ud>
<ud>
Andrea Corsali (<dat when="1451">1451</dat>) <en ref="24" >Astronome</en>, cosmographe, navigateur dans la péninsule arabique et aux Indes. - Pourrait avoir introduit l''imprimerie en Éthiopie (ca 1524), où vraisemblament il meurt [http://data.bnf.fr/ark:/12148/cb13517283d#foaf:Person]
</ud>
<ud>
Anianus (<dat when="1451">1451</dat>) <en ref="24" >Astronome</en> et poète [http://data.bnf.fr/ark:/12148/cb125156549#foaf:Person]
</ud>
<ud>
Antonio Dolciati (<dat when="1451">1451</dat>) Augustinien et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb134854696#foaf:Person]
</ud>
<ud>
Bartolomeo da Messina (<dat when="1451">1451</dat>) Écclésiastique et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb125393703#foaf:Person]
</ud>
<ud>
Gaspar Torrella (<dat when="1451">1451</dat>) <en ref="28" >Médecin</en> et <en ref="16" >mathématicien</en>. - Évêque de Santa-Giusta (Sardaigne) en 1494. - Originaire de Valence (Espagne) [http://data.bnf.fr/ark:/12148/cb13486025q#foaf:Person]
</ud>
<ud>
Giovanni Abiosi (<dat when="1451">1451</dat>) <en ref="28" >Médecin</en>, <en ref="24" >astronome</en>, <en ref="16" >mathématicien</en> et <en ref="18" >philosophe</en>. - Né à Bagnuolo (Royaume de Naples), mort vers 1500 [http://data.bnf.fr/ark:/12148/cb12537367q#foaf:Person]
</ud>
<ud>
Giovanni Antonio Tagliente (<dat when="1451">1451</dat>) Calligraphe. - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12179148h#foaf:Person]
</ud>
<ud>
Giovanni Benedetto Moncetto (<dat when="1451">1451</dat>) Agostinien. - Théologien, <en ref="18" >philosophe</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb125688716#foaf:Person]
</ud>
<ud>
Giovanni Bianchini (<dat when="1451">1451</dat>) <en ref="24" >Astronome</en> mort après 1469 [http://data.bnf.fr/ark:/12148/cb16163624s#foaf:Person]
</ud>
<ud>
Guillaume Hobit (<dat when="1451">1451</dat>) <en ref="24" >Astronome</en> ; <en ref="25" >astrologue</en> de Philippe le Bon, duc de Bourgogne [http://data.bnf.fr/ark:/12148/cb15063496s#foaf:Person]
</ud>
<ud>
Jacob Köbel (<en type="li">Heidelberg, Allemagne</en>, <dat when="1451">1451</dat>) <en ref="16" >Mathématicien</en>, éditeur et libraire [http://data.bnf.fr/ark:/12148/cb10244031k#foaf:Person]
</ud>
<ud>
Louis Boulengier (<dat when="1451">1451</dat>) <en ref="24" >Astronome</en> et <en ref="29" >géographe</en> d''Albi [http://data.bnf.fr/ark:/12148/cb152949413#foaf:Person]
</ud>
<ud>
Rāmacandrācārya (<dat when="1451">1451</dat>) <en ref="27" >Grammairien</en> et commentateur de Pāṇini (actif au 15e s.). - Fils de Kr̥ṣṇācārya. - A aussi écrit des ouvrages de philosophie (Vedānta) et d''astronomie [http://data.bnf.fr/ark:/12148/cb137708651#foaf:Person]
</ud>
<ud>
Sigismondo Fanti (<en type="li">Ferrare, Italie</en>, <dat when="1451">1451</dat>) Poète, <en ref="18" >philosophe</en> et <en ref="16" >mathématicien</en>. - Meurt après 1527 [http://data.bnf.fr/ark:/12148/cb12567416q#foaf:Person]
</ud>
<ud>
Willem Gilliszoon (<dat when="1451">1451</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en>. - Originaire de Wissekerc (Zélande) [http://data.bnf.fr/ark:/12148/cb12548011q#foaf:Person]
</ud>
<ud>
Girolamo Donato (<dat when="1454">1454</dat>) Magistrat, poète, <en ref="18" >philosophe</en>, théologien et <en ref="16" >mathématicien</en>. - Fut gouverneur de Brescia (<dat when="1496">1496</dat>), de Ferrare (<dat when="1498">1498</dat>), ambassadeur de Venise près le pape Jules II (<dat when="1510">1510</dat>) [http://data.bnf.fr/ark:/12148/cb13325565p#foaf:Person]
</ud>
<ud>
Eliya Delmedigo (<dat when="1460">1460</dat>) <en ref="28" >Médecin</en>. - <en ref="24" >Astronome</en>. - <en ref="16" >Mathématicien</en>. - Né en Crète. - <en ref="18" >Philosophe</en>. - Maître d''hébreu de Pic de la Mirandole (1463-1494). - Commentateur des écrits d''Averroés (1126-1198) [http://data.bnf.fr/ark:/12148/cb122623668#foaf:Person]
</ud>
<ud>
Lodovico Pontico Virunio (<dat when="1467">1467</dat>) Professeur de lettres, <en ref="18" >philosophe</en>, <en ref="16" >mathématicien</en> et poète. - Fut chargé de l''éducation des fils de Ludovico Sforza, duc de Milan. - Eut l''intention de fonder une imprimerie grecque et latine à Reggio Emilia, mais ses caractères furent volés par Ludovico Bonaccioli, <en ref="28" >médecin</en> de la duchesse de Ferrare. - Né à Belluno, meurt à Bologne [http://data.bnf.fr/ark:/12148/cb13324006j#foaf:Person]
</ud>
<ud>
Johannes Werner (<en type="li">Nuremberg, Allemagne</en>, <dat when="1468">1468</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en> et cartographe [http://data.bnf.fr/ark:/12148/cb154028305#foaf:Person]
</ud>
<ud>
Jakob Ziegler (<en type="li">Landau (Allemagne)</en>, <dat when="1470">1470</dat>) Théologien, <en ref="16" >mathématicien</en>, <en ref="24" >astronome</en> et <en ref="29" >géographe</en>. - Professeur de théologie. - Commentateur et auteur d''ouvrages historiques et théologiques [http://data.bnf.fr/ark:/12148/cb15029346k#foaf:Person]
</ud>
<ud>
Pedro Ciruelo (<en type="li">Daroca, Espagne</en>, <dat when="1470">1470</dat>) Professeur de théologie à l''Université d''Alcala (1510-), chanoine de la cathédrale de cette ville. - Fut l''un des précepteurs de Philippe II. - Étudia à Salamanque et à Paris, où il édita des oeuvres mathématiques et scientifiques. - Est également l''auteur d''un traité sur la sorcellerie dont la traduction espagnole eut une diffusion importante [http://data.bnf.fr/ark:/12148/cb128071494#foaf:Person]
</ud>
<ud>
Johann Stöffler (<en type="li">Justingen, Allemagne</en>, <dat when="1472">1472</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb125156905#foaf:Person]
</ud>
<ud>
Josse Clicthove (Nieuport, Pays-Bas, <dat when="1472">1472</dat>) Théologien et <en ref="16" >mathématicien</en>. - Théologal de Chartres. - Un des premiers à combattre les idées de Luther [http://data.bnf.fr/ark:/12148/cb12234610b#foaf:Person]
</ud>
<ud>
Bartolomeo Zamberti (<en type="li">Venise, Italie</en>, <dat when="1473">1473</dat>) <en ref="16" >Mathématicien</en> et humaniste. - Professeur de lettres. - Notaire des Consuls des marchands de Venise [http://data.bnf.fr/ark:/12148/cb12033590z#foaf:Person]
</ud>
<ud>
Nicolas Copernic (<dat when="1473">1473</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb118976048#foaf:Person]
</ud>
<ud>
Luca Gaurico (<en type="li">Giffoni, Italie</en>, <dat when="1476">1476</dat>) Évêque de Civita Ducale (1545-1549). - <en ref="16" >Mathématicien</en>, <en ref="18" >philosophe</en>, <en ref="24" >astronome</en> et <en ref="25" >astrologue</en> [http://data.bnf.fr/ark:/12148/cb134849440#foaf:Person]
</ud>
<ud>
Johann Schöner (<dat when="1477">1477</dat>) Né à Karlstadt près de Würzburg. - Prédicateur protestant. - <en ref="24" >Astronome</en>. - <en ref="29" >Géographe</en>. - Professeur de mathématiques à Nuremberg. - A aussi écrit en latin [http://data.bnf.fr/ark:/12148/cb119992233#foaf:Person]
</ud>
<ud>
Girolamo Fracastoro (<en type="li">Vérone, Italie</en>, <dat when="1478">1478</dat>) <en ref="28" >Médecin</en>, auteur du "De contagione et contagiosis morbis et curatione libri III" ; nommé par le pape Paul III <en ref="28" >médecin</en> officiel du Concile de Trente. - Auteur de poèmes en latin, d''oeuvres de géographie, d''astronomie, de physique, de théologie et de philosophie. - Élève de Pomponazzi, ami de Copernic [http://data.bnf.fr/ark:/12148/cb120587788#foaf:Person]
</ud>
<ud>
Girolamo Francastoro (<dat when="1478">1478</dat>) <en ref="28" >Médecin</en>, <en ref="24" >astronome</en>, géologiste, poète, précurseur de la notion de contagion [http://data.bnf.fr/ark:/12148/cb15699396m#foaf:Person]
</ud>
<ud>
Celio Calcagnini (<en type="li">Ferrare, Italie</en>, <dat when="1479">1479</dat>) Poète, philologue, <en ref="18" >philosophe</en> et <en ref="24" >astronome</en>. - Accompagna Hippolyte d''Este en Hongrie et en Pologne [http://data.bnf.fr/ark:/12148/cb122157991#foaf:Person]
</ud>
<ud>
Charles de Bovelles (<dat when="1479">1479</dat>) <en ref="18" >Philosophe</en>, <en ref="16" >mathématicien</en> et linguiste. - Chanoine de Noyon. - Né avant le 28 mars 1479 [http://data.bnf.fr/ark:/12148/cb118932166#foaf:Person]
</ud>
<ud>
Prospero Calano (<en type="li">Sarzana, Italie</en>, <dat when="1480">1480</dat>) <en ref="28" >Médecin</en>, <en ref="24" >astronome</en> et <en ref="18" >philosophe</en> [http://data.bnf.fr/ark:/12148/cb12568870v#foaf:Person]
</ud>
<ud>
Vannoccio Biringuccio (<en type="li">Sienne, Italie</en>, <dat when="1480">1480</dat>) <en ref="16" >Mathématicien</en>, chimiste, architecte et ingénieur, spécialiste en métallurgie [http://data.bnf.fr/ark:/12148/cb12195640k#foaf:Person]
</ud>
<ud>
Michael Stifel (<dat when="1487">1487</dat>) Théologien et <en ref="16" >mathématicien</en>. - Inventeur du logarithme. - Enseigna la théologie et les mathématiques à l''Université de Königsberg, puis les mathématiques à l''Université de Iéna [http://data.bnf.fr/ark:/12148/cb12795734z#foaf:Person]
</ud>
<ud>
Sebastian Münster (<en type="li">Ingelheim, Allemagne</en>, <dat when="1489">1489</dat>) Hébraïsant, <en ref="29" >géographe</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb11996987j#foaf:Person]
</ud>
<ud>
Albert Pighius (Kampen, Pays-Bas, <dat when="1490">1490</dat>) Théologien, <en ref="16" >mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb10448635x#foaf:Person]
</ud>
<ud>
Patrizio Tricasso (<en type="li">Ceresara, Italie</en>, <dat when="1491">1491</dat>) Dominicain. - <en ref="16" >Mathématicien</en> et <en ref="25" >astrologue</en> [http://data.bnf.fr/ark:/12148/cb107034397#foaf:Person]
</ud>
<ud>
Heinrich Schreiber (<en type="li">Erfurt, Allemagne</en>, <dat when="1492">1492</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb10734904t#foaf:Person]
</ud>
<ud>
Jean Borrel (<dat when="1492">1492</dat>) Géomètre et <en ref="16" >mathématicien</en>. - Chanoine régulier de l''Ordre de Saint-Antoine [http://data.bnf.fr/ark:/12148/cb12515817n#foaf:Person]
</ud>
<ud>
Pedro Nunez (<dat when="1492">1492</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12548918m#foaf:Person]
</ud>
<ud>
Oronce Fine (Briançon (Hautes-Alpes), <dat when="1494">1494</dat>) Sieur de Champrouet. - <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb122937307#foaf:Person]
</ud>
<ud>
Petrus Apian (<en type="li">Leisnig (Allemagne)</en>, <dat when="1495">1495</dat>) <en ref="24" >Astronome</en>, cartographe et <en ref="16" >mathématicien</en>. - Nommé Chevalier de l''Empire par Charles Quint. - Surnom de : Bienewitz (ou Bennewitz), Peter [http://data.bnf.fr/ark:/12148/cb12515640m#foaf:Person]
</ud>
<ud>
Andreas Osiander (<en type="li">Gunzenhausen, Allemagne</en>, <dat when="1498">1498</dat>) Théologien protestant, <en ref="24" >astronome</en> et <en ref="16" >mathématicien</en>. - Parfois désigné sous le nom "Andreas Osiander l''Ancien" [http://data.bnf.fr/ark:/12148/cb11988942v#foaf:Person]
</ud>
<ud>
Garcia da Orta (<en type="li">Castelo di Vide, Portugal</en>, <dat when="1499">1499</dat>) <en ref="28" >Médecin</en> et naturaliste. - A enseigné les mathématiques à l''Université de Lisbonne [http://data.bnf.fr/ark:/12148/cb119983323#foaf:Person]
</ud>
<ud>
Giovanni Agostino Abate (<dat when="1499">1499</dat>) <en ref="16" >Mathématicien</en> et historien [http://data.bnf.fr/ark:/12148/cb14624324z#foaf:Person]
</ud>
<ud>
Joachim Sterck van Ringelberg (<en type="li">Anvers, Belgique</en>, <dat when="1499">1499</dat>) Humaniste, <en ref="16" >mathématicien</en> et <en ref="25" >astrologue</en>. - Meurt selon les sources le 1er janvier 1531, en 1536 ou en 1556 [http://data.bnf.fr/ark:/12148/cb10645118k#foaf:Person]
</ud>
<ud>
Johann Carion (<en type="li">Bietigheim, Allemagne</en>, <dat when="1499">1499</dat>) <en ref="25" >Astrologue</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12805831h#foaf:Person]
</ud>
<ud>
Johannes Dryander (<en type="li">Wetter, Allemagne</en>, <dat when="1500">1500</dat>) <en ref="16" >Mathématicien</en>, physicien et <en ref="24" >astronome</en>, professeur à Marburg, édité par Sebastian Münster et Abraham Ortelius [http://data.bnf.fr/ark:/12148/cb15379218m#foaf:Person]
</ud>
<ud>
Johannes Voegelin (<en type="li">Heilbronn, Allemagne</en>, <dat when="1500">1500</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en>. - Professeur à l''Université de Vienne [http://data.bnf.fr/ark:/12148/cb10490264h#foaf:Person]
</ud>
<ud>
Niccolò Tartaglia (<dat when="1500">1500</dat>) <en ref="16" >Mathématicien</en>, ingénieur et architecte. - Pseudonyme de Niccolò Fontana [http://data.bnf.fr/ark:/12148/cb12914492r#foaf:Person]
</ud>
<ud>
Gerolamo Cardano (<en type="li">Pavie, Italie</en>, <dat when="1501">1501</dat>) <en ref="28" >Médecin</en>, <en ref="16" >mathématicien</en> et <en ref="18" >philosophe</en> [http://data.bnf.fr/ark:/12148/cb11895137c#foaf:Person]
</ud>
<ud>
Pedro Nunes (<en type="li">Alcácer do Sol (Portugal)</en>, <dat when="1502">1502</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en> portugais [http://data.bnf.fr/ark:/12148/cb13510349t#foaf:Person]
</ud>
<ud>
Cosimo Bartoli (<en type="li">Florence, Italie</en>, <dat when="1503">1503</dat>) Ambassadeur, poète et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb125520809#foaf:Person]
</ud>
<ud>
Jean Cousin (<en type="li">Soucy (Yonne, France)</en>, <dat when="1503">1503</dat>) Peintre, sculpteur, graveur, architecte, <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12467444s#foaf:Person]
</ud>
<ud>
Ciriaco Strozzi (<en type="li">Capalle, Italie</en>, <dat when="1504">1504</dat>) Helléniste, <en ref="18" >philosophe</en>, <en ref="16" >mathématicien</en> et architecte [http://data.bnf.fr/ark:/12148/cb10418521b#foaf:Person]
</ud>
<ud>
Jacques Bassantin (<dat when="1504">1504</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12548014r#foaf:Person]
</ud>
<ud>
Achille Pirminius Gasser (<dat when="1505">1505</dat>) <en ref="28" >Médecin</en>, historien et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb12516715x#foaf:Person]
</ud>
<ud>
Benedictus Aretius (<dat when="1505">1505</dat>) Théologien protestant. - Botaniste et <en ref="24" >astronome</en>. - Professeur de logique à l''Université de Marbourg, puis professeur de théologie à Berne. - Fut lié avec Conrad Gesner. - Né et mort à Berne [http://data.bnf.fr/ark:/12148/cb12515850g#foaf:Person]
</ud>
<ud>
Alessandro Piccolomini (<en type="li">Sienne, Italie</en>, <dat when="1508">1508</dat>) <en ref="26" >Écrivain</en>, dramaturge, <en ref="24" >astronome</en> et traducteur d''oeuvres de l''Antiquité, de comédies, de traités philosophiques et scientifiques. - Membre de l''Accademia degli Intronati de Sienne, sous le pseudonyme : lo Stordito. - Archevêque de Patras et coadjuteur de l''archevêque de Sienne Francesco Bandini Piccolomini, du 28 juillet 1574 à 1578 [http://data.bnf.fr/ark:/12148/cb12240709n#foaf:Person]
</ud>
<ud>
Gemma Frisius (Dokkum (Pays-Bas), <dat when="1508">1508</dat>) <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en>. - Professeur et docteur en médecine de l''Université de Louvain [http://data.bnf.fr/ark:/12148/cb125195002#foaf:Person]
</ud>
<ud>
Federico Commandino (<en type="li">Sassocorvaro, Italie</en>, <dat when="1509">1509</dat>) <en ref="16" >Mathématicien</en>. - A été le tuteur du duc d''Urbino [http://data.bnf.fr/ark:/12148/cb12562850s#foaf:Person]
</ud>
<ud>
Jean Gosselin (<en type="li">Vire, Calvados</en>, <dat when="1510">1510</dat>) <en ref="25" >Astrologue</en> et <en ref="16" >mathématicien</en>. - Conservateur de la bibliothèque du roi [http://data.bnf.fr/ark:/12148/cb133321861#foaf:Person]
</ud>
<ud>
Pietro Cataneo (<dat when="1510">1510</dat>) Architecte et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12557068n#foaf:Person]
</ud>
<ud>
Erasmus Oswald Schreckenfuchs (<dat when="1511">1511</dat>) Hébraïsant. - <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb12115338j#foaf:Person]
</ud>
<ud>
Giovanni Battista Amici (<en type="li">Cosenza, Italie</en>, <dat when="1511">1511</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb15583428k#foaf:Person]
</ud>
<ud>
Juanelo Turriano (<dat when="1511">1511</dat>) <en ref="16" >Mathématicien</en> et ingénieur [http://data.bnf.fr/ark:/12148/cb129309990#foaf:Person]
</ud>
<ud>
Gerard Mercator (<en type="li">Rupelmonde, Flandres</en>, <dat when="1512">1512</dat>) <en ref="29" >Géographe</en>, cartographe, cosmographe et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12789989j#foaf:Person]
</ud>
<ud>
Giovanni Battista Amico (<dat when="1512">1512</dat>) <en ref="18" >Philosophe</en>, <en ref="16" >mathématicien</en> et <en ref="25" >astrologue</en>. - Originaire de Cosenza, fut assassiné à Padoue [http://data.bnf.fr/ark:/12148/cb12570280s#foaf:Person]
</ud>
<ud>
Juan Pérez de Moya (<dat when="1513">1513</dat>) <en ref="16" >Mathématicien</en> et humaniste [http://data.bnf.fr/ark:/12148/cb12146300q#foaf:Person]
</ud>
<ud>
Rheticus (<dat when="1514">1514</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb13615799v#foaf:Person]
</ud>
<ud>
Bernardino Baldini (<dat when="1515">1515</dat>) Professeur de médecine à Pavie puis de mathématiques à Milan [http://data.bnf.fr/ark:/12148/cb13163998r#foaf:Person]
</ud>
<ud>
Petrus Ramus (<en type="li">Cuts (Aisne)</en>, <dat when="1515">1515</dat>) <en ref="18" >Philosophe</en>, <en ref="27" >grammairien</en>, <en ref="16" >mathématicien</en> et humaniste. - Professeur de mathématique au Collège royal (Collège de France). - Se convertit au protestantisme et fut tué au cours du Massacre de la Saint-Barthélemy [http://data.bnf.fr/ark:/12148/cb120645094#foaf:Person]
</ud>
<ud>
Jean-Pierre de Mesmes (<dat when="1516">1516</dat>) Savant et poète. - Fils de Pierre de Mesmes, chambellan du roi de Navarre. - Etait lié avec Ronsard, du Bellay, Baïf, Charondas, Herberay, Jean Maugin, Ol. de Magny. - A était un des premiers auteurs à avoir écrit en français sur l''astronomie [http://data.bnf.fr/ark:/12148/cb125177720#foaf:Person]
</ud>
<ud>
Jacques Peletier (<dat when="1517">1517</dat>) Poète et critique humaniste. - <en ref="16" >Mathématicien</en>. - A participé à la réforme de l''orthographe. - Traducteur d''Horace [http://data.bnf.fr/ark:/12148/cb122992680#foaf:Person]
</ud>
<ud>
Jeronimo Munoz (<dat when="1520">1520</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb14646245j#foaf:Person]
</ud>
<ud>
Livio Sanuto (<dat when="1520">1520</dat>) <en ref="29" >Géographe</en> et <en ref="16" >mathématicien</en> à Venise, fabriquant d''un globe avec son frère Giulio en 1561 [http://data.bnf.fr/ark:/12148/cb153816227#foaf:Person]
</ud>
<ud>
Melchior Ayrer (<dat when="1520">1520</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb162974318#foaf:Person]
</ud>
<ud>
Nicolaus Gugler (<en type="li">Nuremberg (Allemagne)</en>, <dat when="1521">1521</dat>) <en ref="28" >Médecin</en> et <en ref="24" >astronome</en>, a reçu une formation de juriste. - Fils de Hans Gugler (1480-1560) [http://data.bnf.fr/ark:/12148/cb16504896w#foaf:Person]
</ud>
<ud>
Valentin Mennher (<dat when="1521">1521</dat>) <en ref="16" >Mathématicien</en>. - Membre de la guilde des instituteurs d''Anvers [http://data.bnf.fr/ark:/12148/cb12563197r#foaf:Person]
</ud>
<ud>
Hermann Witekind (<en type="li">Neuenrade (Allemagne)</en>, <dat when="1522">1522</dat>) <en ref="16" >Mathématicien</en> et humaniste [http://data.bnf.fr/ark:/12148/cb162248258#foaf:Person]
</ud>
<ud>
Giovanni Maria Bonardo (<en type="li">Fratta Polesine, Italie</en>, <dat when="1523">1523</dat>) Poète. - Agronome. - <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb12181418p#foaf:Person]
</ud>
<ud>
Juan de Yciar (Durango (prov. de Vizcaya), <dat when="1523">1523</dat>) Pédagogue, <en ref="16" >mathématicien</en> et calligraphe [http://data.bnf.fr/ark:/12148/cb128696315#foaf:Person]
</ud>
<ud>
Jacques Charpentier (Clermont-en-Beauvaisis (<en type="li">Oise)</en>, <dat when="1524">1524</dat>) <en ref="18" >Philosophe</en> et <en ref="28" >médecin</en>. - Lecteur de mathématiques au Collège de France. - <en ref="28" >Médecin</en> du roi [http://data.bnf.fr/ark:/12148/cb121323921#foaf:Person]
</ud>
<ud>
Tadeáš Hájek (<en type="li">Prague</en>, <dat when="1525">1525</dat>) <en ref="16" >Mathématicien</en> et <en ref="28" >médecin</en>. - Reçu docteur à Bologne, occupa une chaire au Carolinum de Prague, fut premier <en ref="28" >médecin</en> des empereurs Maximilien II et Rodolphe II [http://data.bnf.fr/ark:/12148/cb13009688n#foaf:Person]
</ud>
<ud>
Tilemann Stella (<en type="li">Siegen (Allemagne)</en>, <dat when="1525">1525</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en>, <en ref="29" >géographe</en>, architecte et bibliothécaire. - Cartographe à Wittenberg, ses cartes ont été éditées par Ortelius, Jode et Hondius [http://data.bnf.fr/ark:/12148/cb15376436c#foaf:Person]
</ud>
<ud>
Taqī al-Dīn Muḥammad Ibn Maʿrūf (<en type="li">Damas</en>, <dat when="1526">1526</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en> ottoman [http://data.bnf.fr/ark:/12148/cb14599962n#foaf:Person]
</ud>
<ud>
John Dee (<dat when="1527">1527</dat>) <en ref="25" >Astrologue</en>, <en ref="16" >mathématicien</en> et antiquaire [http://data.bnf.fr/ark:/12148/cb119854464#foaf:Person]
</ud>
<ud>
Adam Lonicer (<en type="li">Marburg (Allemagne)</en>, <dat when="1528">1528</dat>) <en ref="28" >Medecin</en> et botaniste. - Professeur de médecine, chimie et mathématiques. - Fils du théologien : Lonicer, Johann (1499-15969) [http://data.bnf.fr/ark:/12148/cb10279221n#foaf:Person]
</ud>
<ud>
Cornelius Blockland (<dat when="1530">1530</dat>) Musicien, <en ref="25" >astrologue</en>, <en ref="16" >mathématicien</en> et <en ref="28" >médecin</en>. - Actif de 1571 à 1586. - Frère du peintre Anthonie Blockland van Montfort [http://data.bnf.fr/ark:/12148/cb13497580p#foaf:Person]
</ud>
<ud>
Giovanni Battista Benedetti (<en type="li">Venise, Italie</en>, <dat when="1530">1530</dat>) <en ref="16" >Mathématicien</en> et ingénieur. - Fondateur de la géométrie analytique [http://data.bnf.fr/ark:/12148/cb11998820g#foaf:Person]
</ud>
<ud>
Jean Péna (<dat when="1530">1530</dat>) <en ref="16" >Mathématicien</en>, traducteur et éditeur de textes mathématiques et géométriques antiques [http://data.bnf.fr/ark:/12148/cb13483147k#foaf:Person]
</ud>
<ud>
Conradus Dasypodius (<en type="li">Frauenfeld, Suisse</en>, <dat when="1531">1531</dat>) <en ref="16" >Mathématicien</en>. - A tracé le plan de l''horloge astronomique de la cathédrale de Strasbourg [http://data.bnf.fr/ark:/12148/cb16534831x#foaf:Person]
</ud>
<ud>
Ercole Bottrigari (<dat when="1531">1531</dat>) Humaniste, <en ref="16" >mathématicien</en>, musicien, poète, linguiste et <en ref="18" >philosophe</en> [http://data.bnf.fr/ark:/12148/cb125347809#foaf:Person]
</ud>
<ud>
Giuseppe Moletti (<dat when="1531">1531</dat>) Cosmographe et <en ref="29" >géographe</en>. - Professeur de médecine, de mathématique et d''astronomie à l''Université de Padoue [http://data.bnf.fr/ark:/12148/cb134849518#foaf:Person]
</ud>
<ud>
Philip Apian (<en type="li">Ingoldstadt, Allemagne</en>, <dat when="1531">1531</dat>) Cartographe, <en ref="16" >mathématicien</en> et physicien. - Fils de Peter Apian, succède à son père à l''Université d''Ingolstadt [http://data.bnf.fr/ark:/12148/cb152383864#foaf:Person]
</ud>
<ud>
Fabrizio Mordente (<en type="li">Salerne, Italie</en>, <dat when="1532">1532</dat>) <en ref="16" >Mathématicien</en>. - A inventé le compas de proportion à huit points [http://data.bnf.fr/ark:/12148/cb14643668k#foaf:Person]
</ud>
<ud>
Egnatio Danti (<en type="li">Pérouse, Italie</en>, <dat when="1536">1536</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en>, cartographe et cosmographe. - Dominicain [http://data.bnf.fr/ark:/12148/cb145332908#foaf:Person]
</ud>
<ud>
Henri de Monantheuil (<dat when="1536">1536</dat>) <en ref="16" >Mathématicien</en> et <en ref="28" >médecin</en>. - Régent de la Faculté de médecine de Paris, puis professeur de mathématiques au Collège de France (1574-). - Né à Reims, meurt à Paris [http://data.bnf.fr/ark:/12148/cb13006651k#foaf:Person]
</ud>
<ud>
Christophorus Clavius (<dat when="1537">1537</dat>) Jésuite, musicien et professeur de mathématiques. - Fut chargé par Grégoire XIII de la réforme du calendrier [http://data.bnf.fr/ark:/12148/cb125466080#foaf:Person]
</ud>
<ud>
Francesco Barozzi (<en type="li">Heraklion, Grèce</en>, <dat when="1537">1537</dat>) <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb10462395x#foaf:Person]
</ud>
<ud>
Giovanni Paolo Gallucci (<en type="li">Salò, Italie</en>, <dat when="1538">1538</dat>) <en ref="24" >Astronome</en>. - Homme de lettres [http://data.bnf.fr/ark:/12148/cb106019703#foaf:Person]
</ud>
<ud>
Philips Mor (<dat when="1539">1539</dat>) Humaniste, <en ref="16" >mathématicien</en> et poète néolatin. - Chanoine du chapitre de St Salvator d''Utrecht. - Fils du peintre Anthonis Mor van Dashorst (Antonio Moro) [http://data.bnf.fr/ark:/12148/cb12384177f#foaf:Person]
</ud>
<ud>
François Viète (Fontenay-le-Comte (<en type="li">Vendée)</en>, <dat when="1540">1540</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb120511976#foaf:Person]
</ud>
<ud>
Cormopede (<dat when="1541">1541</dat>) <en ref="16" >Mathématicien</en> et <en ref="25" >astrologue</en>. - Gentilhomme de la maison du Comte de Sterckenberg. - Date de naissance présumée d''après le "portrait de Cormopede à l''âge de 51 ans" figurant au F. A. 2 de l''"Almanach des almanachs pour l''an MDXCIII" [http://data.bnf.fr/ark:/12148/cb13491791f#foaf:Person]
</ud>
<ud>
Giovanni di Strasoldo (<dat when="1544">1544</dat>) Noble. - Homme d''arme. - <en ref="16" >Mathématicien</en>. - Poète [http://data.bnf.fr/ark:/12148/cb15122132t#foaf:Person]
</ud>
<ud>
Guidobaldo Dal Monte (<dat when="1545">1545</dat>) <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en>. - Protégea <en ref="7" >Galilée</en> et lui fit obtenir sa première chaire à Pise. - Né à Pesaro, meurt dans son chateau de Monte Baroccio [http://data.bnf.fr/ark:/12148/cb135173214#foaf:Person]
</ud>
<ud>
Renward Cysat (<en type="li">Lucerne (Suisse)</en>, <dat when="1545">1545</dat>) Chancelier de la ville de Lucerne, Suisse. - Historien, dramaturge, pharmacien et naturaliste. - Père de : Cysat, Johann Baptist (1587-1653), <en ref="16" >mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb12748433g#foaf:Person]
</ud>
<ud>
Maurice Bressieu (<dat when="1546">1546</dat>) <en ref="16" >Mathématicien</en>, <en ref="18" >philosophe</en> et humaniste. - Titulaire de la chaire de mathématiques au Collège de France (1575-), orateur des rois de France à Rome (1586-), intendant de la Bibliothèque vaticane [http://data.bnf.fr/ark:/12148/cb13495175h#foaf:Person]
</ud>
<ud>
Tycho Brahe (<en type="li">Knudstrup (Suède)</en>, <dat when="1546">1546</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb11893749j#foaf:Person]
</ud>
<ud>
Muḥammad ibn al-Ḥusayan Bahāʼ al-Dīn ʿĀmilī (<dat when="1547">1547</dat>) Érudit arabe, <en ref="18" >philosophe</en>, théologien, <en ref="24" >astronome</en>, <en ref="27" >grammairien</en>, auteur d''anthologies [http://data.bnf.fr/ark:/12148/cb12451570z#foaf:Person]
</ud>
<ud>
Nicodemus Frischlin (<en type="li">Balingen, Allemagne</en>, <dat when="1547">1547</dat>) Philologue et <en ref="26" >écrivain</en>. - A enseigné les belles-lettres et les mathématiques à l''Université de Tubingue. - Traducteur d''Aristophane, de Callimaque et de Tryphiodore. - Auteur d''une comédie, présentée devant l''empereur Rodolphe, qui lui décerna le titre de comte-palatin [http://data.bnf.fr/ark:/12148/cb12463064b#foaf:Person]
</ud>
<ud>
Michele Zappulo (<dat when="1548">1548</dat>) Docteur en droit canon et civil. - <en ref="24" >Astronome</en>, historien et poète [http://data.bnf.fr/ark:/12148/cb125454264#foaf:Person]
</ud>
<ud>
Simon Stevin (<en type="li">Bruges, Belgique</en>, <dat when="1548">1548</dat>) Professeur de mathématiques de Maurice de Nassau [http://data.bnf.fr/ark:/12148/cb119941019#foaf:Person]
</ud>
<ud>
Michel Coignet (<dat when="1549">1549</dat>) Ingénieur, <en ref="16" >mathématicien</en>, fabricant d''instruments de navigation, poète [http://data.bnf.fr/ark:/12148/cb124231863#foaf:Person]
</ud>
<ud>
Francisco Sánchez (<dat when="1550">1550</dat>) <en ref="28" >Médecin</en>, <en ref="18" >philosophe</en>, <en ref="16" >mathématicien</en> et poète. - Également connu sous le pseudonyme d''El Escéptico [http://data.bnf.fr/ark:/12148/cb120172346#foaf:Person]
</ud>
<ud>
Giovanni Battista Crispo (<en type="li">Gallipoli, Italie</en>, <dat when="1550">1550</dat>) Prêtre. - <en ref="16" >Mathématicien</en>, théologien et homme de lettres [http://data.bnf.fr/ark:/12148/cb10615268s#foaf:Person]
</ud>
<ud>
John Napier (<dat when="1550">1550</dat>) <en ref="16" >Mathématicien</en> et théologien. - Baron de Merchiston [http://data.bnf.fr/ark:/12148/cb12353925j#foaf:Person]
</ud>
<ud>
Michael Moestlin (<dat when="1550">1550</dat>) Né à Göppingen (Wurtemberg). - <en ref="16" >Mathématicien</en>. - <en ref="24" >Astronome</en>. - Luthérien, hostile à la réforme grégorienne du calendrier [http://data.bnf.fr/ark:/12148/cb12330628m#foaf:Person]
</ud>
<ud>
Sigfridus Aronus Forsius (<dat when="1550">1550</dat>) <en ref="24" >Astronome</en> et <en ref="25" >astrologue</en> finlandais [http://data.bnf.fr/ark:/12148/cb131923734#foaf:Person]
</ud>
<ud>
Aegidius Martini (<dat when="1551">1551</dat>) Cartographe, <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb15376579x#foaf:Person]
</ud>
<ud>
al-Silahî Nasuh (<dat when="1551">1551</dat>) Savant, miniaturiste et calligraphe ottoman. - A écrit plusieurs ouvrages sur les armes et les combats, sur la géométrie et les mathématiques ainsi que sur l''histoire. - Inventeur du jeu de "matraque", il est mieux connu sous son surnom "Matrakçı" : "Matrakçı Nasuh Efendi", "Nasuh al-Silahî", "Matraki", "Nasuh el-Mitraki", "Nasuh üs-Silahi", "Matraqçi Nasuh", "Nasuh b. Abdullah" et "Nasuh b. Karagöz el-Bosnevi" sont parmi les autres formes de référence [http://data.bnf.fr/ark:/12148/cb119562090#foaf:Person]
</ud>
<ud>
Anthoine Cathalan (<dat when="1551">1551</dat>) Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb14526861v#foaf:Person]
</ud>
<ud>
Bartolomeo Crescenzio (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en>, ingénieur naval et voyageur. - Fut capitaine de galère de la marine pontificale [http://data.bnf.fr/ark:/12148/cb125466487#foaf:Person]
</ud>
<ud>
Bernardo Gamucci (<en type="li">San Gimignano, Italie</en>, <dat when="1551">1551</dat>) Archéologue, architecte et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb10435220v#foaf:Person]
</ud>
<ud>
Camillo Agrippa (<dat when="1551">1551</dat>) <en ref="18" >Philosophe</en>, <en ref="16" >mathématicien</en>, architecte et ingénieur. - Est aussi l''auteur de l''un des premiers traité d''escrime [http://data.bnf.fr/ark:/12148/cb12536260s#foaf:Person]
</ud>
<ud>
Claude de Boissière (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en>. - Auteur d''un "Art poétique" [http://data.bnf.fr/ark:/12148/cb12509709h#foaf:Person]
</ud>
<ud>
Didier Henrion (<dat when="1551">1551</dat>) Professeur de mathématiques à Paris. - Ingénieur au service des Provinces-Unies. - N''est pas un pseudonyme de Clément Cyriaque de Mangin [http://data.bnf.fr/ark:/12148/cb144882445#foaf:Person]
</ud>
<ud>
Eilhard Lubbin (<dat when="1551">1551</dat>) Cartographe et <en ref="16" >mathématicien</en> à Rostock [http://data.bnf.fr/ark:/12148/cb153777849#foaf:Person]
</ud>
<ud>
Faustus Verantius (Sebenico aujord''hui Šibenik (<en type="li">Croatie)</en>, <dat when="1551">1551</dat>) Lexicographe, physicien et <en ref="16" >mathématicien</en>. - Évêque de Czanad (Hongrie) (<dat when="1594">1594</dat>) et de la République de Venise. - Neveu d''Antun Vrančić (1504-1573) [http://data.bnf.fr/ark:/12148/cb10703670x#foaf:Person]
</ud>
<ud>
Francesco Feliciano (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en>, augustinien et miniaturiste [http://data.bnf.fr/ark:/12148/cb13485419n#foaf:Person]
</ud>
<ud>
Francis Van Schoten (<dat when="1551">1551</dat>) Professeur de mathématiques à Leyde, cartographe [http://data.bnf.fr/ark:/12148/cb15337130w#foaf:Person]
</ud>
<ud>
Francisco Zarzoso (<en type="li">Cella, Espagne</en>, <dat when="1551">1551</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb119512329#foaf:Person]
</ud>
<ud>
Giacomo Lanteri (<en type="li">Paratico, Italie</en>, <dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en> et ingénieur [http://data.bnf.fr/ark:/12148/cb104024969#foaf:Person]
</ud>
<ud>
Girolamo Mercurio (<dat when="1551">1551</dat>) Dominicain. - <en ref="28" >Médecin</en>, professeur de logique et de mathématique [http://data.bnf.fr/ark:/12148/cb13484092c#foaf:Person]
</ud>
<ud>
Giuseppe Unicorno (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en>. - <en ref="18" >Philosophe</en>. - <en ref="25" >Astrologue</en>. - Musicologue. - Théologien. - Originaire de Bergame [http://data.bnf.fr/ark:/12148/cb125394931#foaf:Person]
</ud>
<ud>
Helisaeus Röslin (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en>. - <en ref="24" >Astronome</en>. - <en ref="28" >Médecin</en> (pratiquait à Strasbourg et Francfort) [http://data.bnf.fr/ark:/12148/cb132003253#foaf:Person]
</ud>
<ud>
Jacques Besson (<en type="li">Colombières (Italie)</en>, <dat when="1551">1551</dat>) Ingénieur et <en ref="16" >mathématicien</en>. - Né à Colombières, vallée d''Oulx (aujourd''hui en Italie), d''après Eugénie Droz [http://data.bnf.fr/ark:/12148/cb12376654f#foaf:Person]
</ud>
<ud>
Jacques Maretz (<dat when="1551">1551</dat>) Dessinateur et graveur, <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb153705873#foaf:Person]
</ud>
<ud>
Jamet Mettayer (<dat when="1551">1551</dat>) Autre(s) graphie(s) : Metayer ; Messor ; Metayerus ; Mettayier. - Variante(s) de prénom : Jean ; Jean Jamet. - Imprimeur-libraire ; imprimeur du Roi pour les mathématiques (<dat when="1580">1580</dat>) et imprimeur ordinaire du Roi (1583-1605). - En 1588, le roi Henri III le fait imprimeur officiel de sa congrégation des pénitents de l''Annonciation. De 1588 à 1594, il suit le Roi et la Cour à Blois puis  à Tours. - De retour à Paris, doit partager sa charge avec Pierre L''Huillier et Fédéric II Morel en vertu de l''arrêt du Conseil du 20 avril 1594. Revend à Tours son atelier et sa boutique à l''imprimeur Maurice Bouguereau. En mars  1596, le Roi l''associe à la Compagnie des usages avec Pierre L''Huillier. Décédé avant le 12 fév. 1605. Des publications paraissent encore sous son nom jusqu''en 1614. - A travaillé en association avec Mathurin Challenge (<dat when="1573">1573</dat>) et Barthélemy Gomet à Blois. S''associe à Tours (oct. 1591 - oct. 1593) avec Jean Richer, Claude de Monstr''oeil, Sébastien Molin, Mathieu I Guillemot, Georges Drobet et Marc Orry, son gendre. Travaille en association étroite avec Pierre L''Huillier et avec son fils Pierre Mettayer qui se trouvaient eux aussi à Tours [http://data.bnf.fr/ark:/12148/cb125031934#foaf:Person]
</ud>
<ud>
Jean Brohon (<dat when="1551">1551</dat>) <en ref="28" >Médecin</en>, botaniste et <en ref="24" >astronome</en>. - Fut recteur de l''Université de Caen [http://data.bnf.fr/ark:/12148/cb12545367f#foaf:Person]
</ud>
<ud>
Jean de Seville (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en> et hydrographe [http://data.bnf.fr/ark:/12148/cb13496046w#foaf:Person]
</ud>
<ud>
Jean Maria Coloni (<dat when="1551">1551</dat>) Citoyen de Romans en Dauphiné. - <en ref="16" >Mathématicien</en> et <en ref="25" >astrologue</en> [http://data.bnf.fr/ark:/12148/cb13479237s#foaf:Person]
</ud>
<ud>
Jean Tagaut (<dat when="1551">1551</dat>) Poète. - <en ref="28" >Médecin</en>, <en ref="16" >mathématicien</en>, professeur à Lausanne et Genève [http://data.bnf.fr/ark:/12148/cb12249180j#foaf:Person]
</ud>
<ud>
Joannes Portantius (<dat when="1551">1551</dat>) <en ref="24" >Astronome</en>, <en ref="16" >mathématicien</en> et <en ref="29" >géographe</en> à Anvers, édité par Ortelius et De Jode [http://data.bnf.fr/ark:/12148/cb153817246#foaf:Person]
</ud>
<ud>
Johann Georg Locher (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb13006978f#foaf:Person]
</ud>
<ud>
Juan de Rojas Sarmiento (<en type="li">Palencia, Espagne</en>, <dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb140653109#foaf:Person]
</ud>
<ud>
Marc Duncan (<dat when="1551">1551</dat>) <en ref="28" >Médecin</en>, originaire d''Écosse, s''établit à Saumur en 1606 à l''appel de l''Académie protestante de la ville. - Professeur de mathématiques, de grec et d''humanités [http://data.bnf.fr/ark:/12148/cb13006401g#foaf:Person]
</ud>
<ud>
Martin Basanier (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en>, musicien [http://data.bnf.fr/ark:/12148/cb12510914p#foaf:Person]
</ud>
<ud>
Martinus Hortensius (<dat when="1551">1551</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb13007384z#foaf:Person]
</ud>
<ud>
Nicolaus Reimarus Ursus (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en>. - <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb145753184#foaf:Person]
</ud>
<ud>
Paschasius Hamellius (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb13173242d#foaf:Person]
</ud>
<ud>
Paul Yvon (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en>. - Achète la seigneurie de Laleu en 1592 et y fait construire le château. - Maire de La Rochelle en 1616. - S'' installe à Paris en décembre 1633 et abjure le protestantisme [http://data.bnf.fr/ark:/12148/cb12135021d#foaf:Person]
</ud>
<ud>
Peter Laicksteen (<dat when="1551">1551</dat>) Cartographe et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb15370391s#foaf:Person]
</ud>
<ud>
Phillebert Charpentier (<dat when="1551">1551</dat>) Éditeur. - Marchand d''estampes et d''instruments de mathématiques [http://data.bnf.fr/ark:/12148/cb16553551w#foaf:Person]
</ud>
<ud>
Pierre Forcadel (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb103947442#foaf:Person]
</ud>
<ud>
Pierre Hérigone (<dat when="1551">1551</dat>) Professeur de mathématiques à Paris. - N''est pas un pseudonyme de Clément Cyriaque de Mangin [http://data.bnf.fr/ark:/12148/cb144882503#foaf:Person]
</ud>
<ud>
Pierre Le Voirier (<dat when="1551">1551</dat>) Autre(s) graphie(s) : Le Voirrier ; Le Verrier. - Imprimeur du Roi pour les mathématiques. - Beau-père de Mathieu I Guillemot (<dat when="1584">1584</dat>). Encore en activité le 31 déc. 1589. Décédé entre 1591 et le 7 nov. 1594 (compte de succession) [http://data.bnf.fr/ark:/12148/cb12230743m#foaf:Person]
</ud>
<ud>
Teodato Osio (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en>. - Musicien [http://data.bnf.fr/ark:/12148/cb125559272#foaf:Person]
</ud>
<ud>
Walther Hermann Ryff (<dat when="1551">1551</dat>) Apothicaire, <en ref="28" >médecin</en>, <en ref="16" >mathématicien</en> et architecte [http://data.bnf.fr/ark:/12148/cb11948264d#foaf:Person]
</ud>
<ud>
William Welwod (<dat when="1551">1551</dat>) <en ref="16" >Mathématicien</en>. - Professeur de droit [http://data.bnf.fr/ark:/12148/cb125630488#foaf:Person]
</ud>
<ud>
Jost Bürgi (<dat when="1552">1552</dat>) Horloger, <en ref="24" >astronome</en> et <en ref="16" >mathématicien</en> suisse [http://data.bnf.fr/ark:/12148/cb123814270#foaf:Person]
</ud>
<ud>
Bernardino Baldi (<en type="li">Urbino, Italie</en>, <dat when="1553">1553</dat>) Abbé de Guastalla. - Poète, prosateur, <en ref="16" >mathématicien</en> et historien. - Polyglotte, connaissait le grec et le latin, l''hébreu, l''arabe, le persan et le hongrois [http://data.bnf.fr/ark:/12148/cb12179488k#foaf:Person]
</ud>
<ud>
Jacob Christmann (<dat when="1554">1554</dat>) Orientaliste, <en ref="16" >mathématicien</en> et <en ref="24" >astronome</en>. - A été le premier à utiliser le télescope avec d''autres instruments comme le sextant [http://data.bnf.fr/ark:/12148/cb12560133s#foaf:Person]
</ud>
<ud>
Giovanni Antonio Magini (<en type="li">Padoue, Italie</en>, <dat when="1555">1555</dat>) <en ref="24" >Astronome</en>, <en ref="16" >mathématicien</en> et <en ref="29" >géographe</en>. - A occupé la chaire d''astronomie à l''Université de Bologne en 1588. - Auteur prétendu de prédictions et de nombreux almanachs publiés en France, en Allemagne et aux Pays-Bas jusqu''au 19e siècle [http://data.bnf.fr/ark:/12148/cb12162475b#foaf:Person]
</ud>
<ud>
Jean Du Temps (<dat when="1555">1555</dat>) Fils de l''avocat Jean Du Temps I, il fut lui-même avocat et avait des connaissances en astrologie et mathématique. Frère d''Adam Du Temps, spécialiste des fortifications qui participa peut-être à la carte du Blésois dont il est l''auteur [http://data.bnf.fr/ark:/12148/cb15302460t#foaf:Person]
</ud>
<ud>
Sethus Calvisius (<dat when="1556">1556</dat>) Organiste, compositeur et théoricien de la musique ; <en ref="24" >astronome</en> ; historien ; libraire et éditeur de musique. - Natif de Gorsleben près de Sachsenburg (Thuringe) et issu d''une famille paysanne. Après des études aux universités de Leipzig et Helmstedt, il devient à partir de 1581 et jusqu''à sa mort "cantor" de plusieurs églises de Leipzig successivement. Auteur de plusieurs ouvrages théoriques et compositions musicales, ainsi que d''un "Opus chronologicum" (1605 ; au moins 6 rééd.) et d''un "Elenchus calendarii Gregoriani" (<dat when="1612">1612</dat>). Décédé à Leipzig en nov. 1615. À distinguer du pasteur et prédicateur de Quedlinburg Sethus Calvisius (ou : Seth Kal(l)witz) (1639-1698), parfois appelé à tort "Sethus Calvisius le fils" [http://data.bnf.fr/ark:/12148/cb12875550d#foaf:Person]
</ud>
<ud>
Guillaume de Nautonier (<dat when="1557">1557</dat>) Savant, <en ref="16" >mathématicien</en>, <en ref="24" >astronome</en>, d''origine protestante, <en ref="29" >géographe</en> du roi Henri IV [http://data.bnf.fr/ark:/12148/cb12412403z#foaf:Person]
</ud>
<ud>
Christoph Meurer (<dat when="1558">1558</dat>) Professeur de mathématiques à Leipzig (<dat when="1613">1613</dat>). - <en ref="28" >Médecin</en> [http://data.bnf.fr/ark:/12148/cb14333201g#foaf:Person]
</ud>
<ud>
Jean-Édouard Du Monin (<dat when="1559">1559</dat>) <en ref="16" >Mathématicien</en> et spécialiste des langues anciennes. - Fut professeur à Paris, puis à Poitiers [http://data.bnf.fr/ark:/12148/cb12463074n#foaf:Person]
</ud>
<ud>
Thomas Hariot (<en type="li">Oxford, GB</en>, <dat when="1560">1560</dat>) <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en>. - Envoyé comme conseiller aux Amériques en 1585-86 [http://data.bnf.fr/ark:/12148/cb12215671c#foaf:Person]
</ud>
<ud>
Thomas Harriot (<dat when="1560">1560</dat>) <en ref="16" >Mathématicien</en>, physicien et <en ref="24" >astronome</en> anglais [http://data.bnf.fr/ark:/12148/cb124346111#foaf:Person]
</ud>
<ud>
Adrianus Romanus (<en type="li">Louvain</en>, <dat when="1561">1561</dat>) <en ref="28" >Médecin</en>, <en ref="16" >mathématicien</en> et voyageur. - Enseigna à Louvain et à Würzburg, fut <en ref="16" >mathématicien</en> royal en Pologne [http://data.bnf.fr/ark:/12148/cb12459969s#foaf:Person]
</ud>
<ud>
Bartholomäus Pitiscus (<dat when="1561">1561</dat>) A aussi écrit en latin. - Prédicateur protestant à la cour de l''Électeur palatin. - Également auteur d''ouvrages mathématiques [http://data.bnf.fr/ark:/12148/cb121457326#foaf:Person]
</ud>
<ud>
Henry Briggs (<dat when="1561">1561</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12305061c#foaf:Person]
</ud>
<ud>
Jean Tarde (La Roque-Gageac (<en type="li">Dordogne)</en>, <dat when="1561">1561</dat>) <en ref="16" >Mathématicien</en>, historien, <en ref="29" >géographe</en> et <en ref="24" >astronome</en>. - Chanoine [http://data.bnf.fr/ark:/12148/cb12641353z#foaf:Person]
</ud>
<ud>
Jean Tarde (<dat when="1561">1561</dat>) Chanoine de Sarlat, <en ref="16" >mathématicien</en> et cartographe [http://data.bnf.fr/ark:/12148/cb153143878#foaf:Person]
</ud>
<ud>
P. Christoph Grienberger (<dat when="1561">1561</dat>) Jésuite, <en ref="16" >mathématicien</en>, <en ref="24" >astronome</en> et architecte. Il a realisé les plans du Collège d''Aurillac et du Charleville [http://data.bnf.fr/ark:/12148/cb10686921r#foaf:Person]
</ud>
<ud>
Philippus Lansbergen (<en type="li">Gand (Belgique)</en>, <dat when="1561">1561</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en> et pasteur [http://data.bnf.fr/ark:/12148/cb130073828#foaf:Person]
</ud>
<ud>
Christen Sørensen Longomontanus (<dat when="1562">1562</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en>. - Fut l''élève de Tycho-Brahé. - Professeur de hautes mathématiques à l''Université de Copenhague [http://data.bnf.fr/ark:/12148/cb13011001c#foaf:Person]
</ud>
<ud>
Guangqi Xu (<en type="li">Shanghai</en>, <dat when="1562">1562</dat>) Haut fonctionnaire chinois, initié et converti au christianisme par le père jésuite Matteo Ricci. - <en ref="16" >Mathématicien</en>. - <en ref="24" >Astronome</en>. - Disciple de Matteo Ricci [http://data.bnf.fr/ark:/12148/cb150892932#foaf:Person]
</ud>
<ud>
<en ref="7" >Galileo Galilei</en> (<en type="li">Pise, Italie</en>, <dat when="1564">1564</dat>) Physicien, <en ref="18" >philosophe</en>, <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb11903931b#foaf:Person]
</ud>
<ud>
Luis Teixeira (<dat when="1564">1564</dat>) Jésuite portugais, <en ref="16" >mathématicien</en> et cartographe actif de 1564 à 1613 [http://data.bnf.fr/ark:/12148/cb153361957#foaf:Person]
</ud>
<ud>
Edward Brerewood (<dat when="1565">1565</dat>) Antiquaire et <en ref="16" >mathématicien</en>, linguiste et humaniste. - Professeur d''astronomie au Gresham college de Londres [http://data.bnf.fr/ark:/12148/cb125109678#foaf:Person]
</ud>
<ud>
Eilhard Lubin (<dat when="1565">1565</dat>) Humaniste, philologue, cartographe, théologien et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb15040859j#foaf:Person]
</ud>
<ud>
Paolo Antonio Foscarini (<en type="li">Montalto Uffugo, Italie</en>, <dat when="1565">1565</dat>) Carme. - Théologien. - <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb12377530d#foaf:Person]
</ud>
<ud>
Scipione Chiaramonti (<en type="li">Cesena, Italie</en>, <dat when="1565">1565</dat>) <en ref="24" >Astronome</en> et <en ref="18" >philosophe</en>. - Professeur de philosophie à l''Université de Pise [http://data.bnf.fr/ark:/12148/cb10545041n#foaf:Person]
</ud>
<ud>
Fr. François d'' Aguillon (<dat when="1566">1566</dat>) Jésuite, architecte et <en ref="16" >mathématicien</en>. Auteur d''un projet pour le noviciat de Tournai. Préposé de la Maison professe, professeur d''Anvers [http://data.bnf.fr/ark:/12148/cb16240952w#foaf:Person]
</ud>
<ud>
Georg Ludwig Frobenius (<dat when="1566">1566</dat>) Libraire. - Natif d''Iphofen, près de Wurzbourg. Titulaire d''une maîtrise de théologie. Après des études aux universités de Tübingen et Wittenberg, travaille avec l''<en ref="24" >astronome</en> Tycho Brahe jusqu''à la mort de celui-ci. Reçu ensuite bourgeois de Hambourg, où il s''établit libraire [http://data.bnf.fr/ark:/12148/cb12229506t#foaf:Person]
</ud>
<ud>
Marco Antonio De Dominis (l''île de Rab (<en type="li">Croatie)</en>, <dat when="1566">1566</dat>) Professeur de rhétorique, mathématiques et philosophie dans la Compagnie de Jésus, à Padoue et Brescia. - Evêque de Segna (Senj ou Zengg en Croatie) de 1600 à 1602; de Spalato (Split) de 1602 à 1615. - Gagné au protestantisme et exilé en Angleterre, doyen de Windsor. - Abjure et rentre en grâce (<dat when="1622">1622</dat>) [http://data.bnf.fr/ark:/12148/cb121335726#foaf:Person]
</ud>
<ud>
Marinus Ghetaldus (Raguse aujourd''hui Dubrovnik (<en type="li">Croatie)</en>, <dat when="1566">1566</dat>) <en ref="16" >Mathématicien</en> et physicien. - Il exerça une grande influence sur le développement de l''application de l''algèbre à la géométrie. - Il mit au point le miroir parabolique, aujourd''hui conservé au National Maritime Museum de Londres. - Il collabora, entre autres, avec François Viète en France et avec <en ref="7" >Galilée</en> en Italie [http://data.bnf.fr/ark:/12148/cb146476018#foaf:Person]
</ud>
<ud>
François de Aguilón (<dat when="1567">1567</dat>) Architecte et <en ref="16" >mathématicien</en> belge d''origine espagnole [http://data.bnf.fr/ark:/12148/cb119998212#foaf:Person]
</ud>
<ud>
Johann Hartmann (<dat when="1568">1568</dat>) <en ref="16" >Mathématicien</en> et naturaliste. - Professeur de chimie à l''Université de Marburg [http://data.bnf.fr/ark:/12148/cb13009199x#foaf:Person]
</ud>
<ud>
P. Jacques de Guernisac (<dat when="1568">1568</dat>) Jésuite et architecte,   à Pont-à-Mousson puis à La Flèche, recteur du collège des Jésuites de Quimper [http://data.bnf.fr/ark:/12148/cb16215104d#foaf:Person]
</ud>
<ud>
Mutio Oddi (<dat when="1569">1569</dat>) <en ref="16" >Mathématicien</en>. - Architecte [http://data.bnf.fr/ark:/12148/cb165299645#foaf:Person]
</ud>
<ud>
Andrea Argoli (<dat when="1570">1570</dat>) <en ref="16" >Mathématicien</en>. - <en ref="24" >Astronome</en>. - Professeur de mathématique à l''Université de Padoue [http://data.bnf.fr/ark:/12148/cb121593328#foaf:Person]
</ud>
<ud>
Erasmus Schmied (<dat when="1570">1570</dat>) Né à Delitzsch, près de Leipzig. - Professeur de grec et de mathématiques à Wittenberg [http://data.bnf.fr/ark:/12148/cb12045847b#foaf:Person]
</ud>
<ud>
Anders Bure (<dat when="1571">1571</dat>) Cartographe et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb14509982d#foaf:Person]
</ud>
<ud>
Giovanni Branca (<dat when="1571">1571</dat>) Architecte, ingénieur et <en ref="16" >mathématicien</en>. - Né à Pesaro, meurt à Pérouse [http://data.bnf.fr/ark:/12148/cb121826472#foaf:Person]
</ud>
<ud>
Johannes Isaacus Pontanus (<en type="li">Elseneur (Danemark)</en>, <dat when="1571">1571</dat>) Historien. - Philologue. - Professeur de mathématiques et de physique [http://data.bnf.fr/ark:/12148/cb123875836#foaf:Person]
</ud>
<ud>
Johannes Kepler (<dat when="1571">1571</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb11909597m#foaf:Person]
</ud>
<ud>
Willem Jansz Blaeu (<dat when="1571">1571</dat>) Autre(s) graphie(s) : Janssonius Blaeuw. - Imprimeur-libraire et éditeur de cartes et d''atlas. - Originaire d''Alkmaar ou des environs. Passe 2 ans auprès de Tycho Brahé au Danemark. À son retour à Amsterdam en 1596, s''établit cartographe et fabricant de globes terrestres et célestes. Monte ensuite une imprimerie et une fonderie. Également auteur d''ouvrages cartographiques et astronomiques [http://data.bnf.fr/ark:/12148/cb12169772t#foaf:Person]
</ud>
<ud>
Cornelius Drebbel (<dat when="1572">1572</dat>) Graveur. - <en ref="16" >Mathématicien</en>. - Physicien. - Chimiste [http://data.bnf.fr/ark:/12148/cb12382467g#foaf:Person]
</ud>
<ud>
Rodolphus Goclenius (<dat when="1572">1572</dat>) Docteur en médecine en 1601. - Professeur de physique en 1608. - Professeur de mathématiques à l''Université de Marbourg en 1621 [http://data.bnf.fr/ark:/12148/cb121595722#foaf:Person]
</ud>
<ud>
Samuel Marolois (<dat when="1572">1572</dat>) <en ref="16" >Mathématicien</en> français ayant vécu une grande partie de sa vie aux Pays-Bas [http://data.bnf.fr/ark:/12148/cb14912871p#foaf:Person]
</ud>
<ud>
Thomas Lydyat (<en type="li">Okerton, GB</en>, <dat when="1572">1572</dat>) <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb12390032f#foaf:Person]
</ud>
<ud>
Christoph Scheiner (<dat when="1575">1575</dat>) Jésuite. - Physicien, <en ref="16" >mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb13483688j#foaf:Person]
</ud>
<ud>
Michelangelo Galilei (<dat when="1575">1575</dat>) Luthiste et compositeur italien de la Renaissance. - Fils du compositeur et théoricien Vincenzo Galilei, et frère de l''<en ref="24" >astronome</en> <en ref="7" >Galileo Galilei</en> [http://data.bnf.fr/ark:/12148/cb140013401#foaf:Person]
</ud>
<ud>
Octavio Pisani (<en type="li">Naples, Italie</en>, <dat when="1575">1575</dat>) Cosmographe et <en ref="24" >astronome</en>, travaille à Anvers de 1612 à 1637 [http://data.bnf.fr/ark:/12148/cb15404394h#foaf:Person]
</ud>
<ud>
Francesco Ingoli (<en type="li">Ravenne (Italie)</en>, <dat when="1578">1578</dat>) Secrétaire de la propagande, débat avec Copernic (en 1616 et 1624) et écrit Relazione delle quattro parti del mondo avec pour objectif de soutenir missions et propagande religieuses. - Étudie l''astronomie, la cosmographie et la géographie et connait le grec, le français, l''espagnon et l''arabe. - Diplômé en droit civil et en droit canon à l''Université de Padoue, Italie [http://data.bnf.fr/ark:/12148/cb13749501h#foaf:Person]
</ud>
<ud>
Sybrandt Hansz. Cardinael (Harlingen (Pays-Bas), <dat when="1578">1578</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb15944052f#foaf:Person]
</ud>
<ud>
Cristóvão Ferreira (<dat when="1580">1580</dat>) Supérieur et procurateur de la mission jésuite au Japon, il abjura en 1633 et se convertit au zen. - Auteur en 1636 de la "Supercherie dévoilée". - Traducteur d''ouvrages d''astronomie et de chirurgie [http://data.bnf.fr/ark:/12148/cb13524212c#foaf:Person]
</ud>
<ud>
Godfried Wendelen (<dat when="1580">1580</dat>) <en ref="24" >Astronome</en> et géomètre. - Avocat au Parlement de Paris puis doyen du chapitre de Rothnac, Belgique [http://data.bnf.fr/ark:/12148/cb123969373#foaf:Person]
</ud>
<ud>
Joannes Michael Gigas (<dat when="1580">1580</dat>) Docteur, <en ref="16" >mathématicien</en> et <en ref="29" >géographe</en> édité par Blaeu et Hondius [http://data.bnf.fr/ark:/12148/cb153239798#foaf:Person]
</ud>
<ud>
Johann Faulhaber (<dat when="1580">1580</dat>) <en ref="16" >Mathématicien</en> allemand. S''est aussi intéressé à l''ingénierie des fortifications [http://data.bnf.fr/ark:/12148/cb137778453#foaf:Person]
</ud>
<ud>
Nicolas-Claude Fabri Peiresc (<en type="li">Belgentier (Var)</en>, <dat when="1580">1580</dat>) Conseiller au Parlement de Provence. - <en ref="24" >Astronome</en>, archéologue et naturaliste [http://data.bnf.fr/ark:/12148/cb11918940q#foaf:Person]
</ud>
<ud>
Willebrordus Snellius (Leyde, Pays-Bas, <dat when="1580">1580</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en> et <en ref="29" >géographe</en> [http://data.bnf.fr/ark:/12148/cb15336105f#foaf:Person]
</ud>
<ud>
Claude-Gaspard Bachet (Bourg-en-Bresse (<en type="li">Ain)</en>, <dat when="1581">1581</dat>) <en ref="16" >Mathématicien</en> et littérateur. - Sieur de Méziriac. - Érudit, auteur de poèmes en français, italien et latin. - Membre de l''Académie française (élu en 1634) [http://data.bnf.fr/ark:/12148/cb120028244#foaf:Person]
</ud>
<ud>
Alexandre Anderson (<dat when="1582">1582</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb16296598k#foaf:Person]
</ud>
<ud>
Jean François (<dat when="1582">1582</dat>) Nom en religion de Jean Charnage. - Jésuite. - Professeur de philosophie et de mathématiques à La Flèche [http://data.bnf.fr/ark:/12148/cb121629197#foaf:Person]
</ud>
<ud>
Mario Bettini (<en type="li">Bologne, Italie</en>, <dat when="1582">1582</dat>) Jésuite. - <en ref="18" >Philosophe</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12545452p#foaf:Person]
</ud>
<ud>
Matthias Bernegger (<en type="li">Hallstatt (Autriche)</en>, <dat when="1582">1582</dat>) Philologue, historien, <en ref="16" >mathématicien</en> et <en ref="24" >astronome</en>. - Protestant. - Professeur d''histoire et d''éloquence à Strasbourg, recteur de l''Université de cette même ville [http://data.bnf.fr/ark:/12148/cb129928534#foaf:Person]
</ud>
<ud>
Jean-Baptiste Morin (Villefranche-sur-Saône (<en type="li">Rhône)</en>, <dat when="1583">1583</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb11916881j#foaf:Person]
</ud>
<ud>
Orazio Grassi (<en type="li">Savone, Italie</en>, <dat when="1583">1583</dat>) Jésuite. - <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en> et architecte [http://data.bnf.fr/ark:/12148/cb125377863#foaf:Person]
</ud>
<ud>
Filippo Finella (<en type="li">Naples, Italie</en>, <dat when="1584">1584</dat>) <en ref="25" >Astrologue</en>. - <en ref="24" >Astronome</en>. - Auteur dramatique [http://data.bnf.fr/ark:/12148/cb122006609#foaf:Person]
</ud>
<ud>
Grégoire de Saint-Vincent (<dat when="1584">1584</dat>) <en ref="16" >Mathématicien</en>. - <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb16197665z#foaf:Person]
</ud>
<ud>
James Hume (<dat when="1584">1584</dat>) <en ref="16" >Mathématicien</en>. - <en ref="24" >Astronome</en>. - Historien. - Hébraïsant. - Actif en 1639. - A vécu à Paris. - Fils de David Hume (1558-163.) et frère aîné de la poétesse et traductrice Anna Hume (1586?-16..) [http://data.bnf.fr/ark:/12148/cb12072629r#foaf:Person]
</ud>
<ud>
Claude Mydorge (<dat when="1585">1585</dat>) <en ref="16" >Mathématicien</en> et physicien [http://data.bnf.fr/ark:/12148/cb144888873#foaf:Person]
</ud>
<ud>
Mario Guiducci (<en type="li">Florence, Italie</en>, <dat when="1585">1585</dat>) Homme de lettres et <en ref="24" >astronome</en>. - A collaboré avec <en ref="7" >Galileo Galilei</en> [http://data.bnf.fr/ark:/12148/cb144609004#foaf:Person]
</ud>
<ud>
Melchior Inchofer (<en type="li">Vienne</en>, <dat when="1585">1585</dat>) Jésuite. - <en ref="18" >Philosophe</en>, <en ref="16" >mathématicien</en> et théologien professeur à Messine, Italie [http://data.bnf.fr/ark:/12148/cb10735485h#foaf:Person]
</ud>
<ud>
Philipp Müller (<dat when="1585">1585</dat>) <en ref="16" >Mathématicien</en>, <en ref="28" >médecin</en>, chimiste et botaniste. - Professeur à l''université de Leipzig [http://data.bnf.fr/ark:/12148/cb14065362j#foaf:Person]
</ud>
<ud>
Jean L''Hoste (<en type="li">Nancy</en>, <dat when="1586">1586</dat>) Ingénieur. - Intendant des fortifications du duc de Lorraine. - Professeur de droit et de mathématiques à Pont-à-Mousson [http://data.bnf.fr/ark:/12148/cb16628764j#foaf:Person]
</ud>
<ud>
Niccolò Zucchi (<en type="li">Parme, Italie</en>, <dat when="1586">1586</dat>) Jésuite. - Recteur du Collegio romano (1646-1649). - <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb10077816w#foaf:Person]
</ud>
<ud>
Benedetto Castelli (<en type="li">Brescia, Italie</en>, <dat when="1587">1587</dat>) Dominicain. - <en ref="16" >Mathématicien</en>, inventeur et <en ref="26" >écrivain</en>. - Disciple de <en ref="7" >Galilée</en>, dont il défendit les théories astronomiques [http://data.bnf.fr/ark:/12148/cb12545385c#foaf:Person]
</ud>
<ud>
Joachim Jungius (<dat when="1587">1587</dat>) Naturaliste, <en ref="16" >mathématicien</en> et <en ref="18" >philosophe</en> [http://data.bnf.fr/ark:/12148/cb120247195#foaf:Person]
</ud>
<ud>
Libert Froidmont (<en type="li">Liège</en>, <dat when="1587">1587</dat>) Théologien. - <en ref="16" >Mathématicien</en>, physicien et géologue [http://data.bnf.fr/ark:/12148/cb14462868z#foaf:Person]
</ud>
<ud>
François Derand (<dat when="1588">1588</dat>) Jésuite. - Professeur de grammaire et de mathématiques. - Architecte. - Né à Vic s/Seille (Moselle), mort à Agde (Hérault) [http://data.bnf.fr/ark:/12148/cb13012148j#foaf:Person]
</ud>
<ud>
Jacques Grandami (<dat when="1588">1588</dat>) Jésuite. - Professeur de belles lettres, de philosophie et de théologie, puis recteur de Bourges, Rennes, La Flèche, Tours et Rouen. - Visiteur de la province de France. - <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb12155155d#foaf:Person]
</ud>
<ud>
Marin Mersenne (<dat when="1588">1588</dat>) <en ref="18" >Philosophe</en> et savant, <en ref="24" >astronome</en>, <en ref="16" >mathématicien</en>. - Théoricien de la musique. - Minime [http://data.bnf.fr/ark:/12148/cb119157157#foaf:Person]
</ud>
<ud>
Eberhard Welper (<dat when="1590">1590</dat>) Imprimeur-libraire. - Natif de Lohra (comté de Lohenstein, près de Marburg, Allemagne). <en ref="16" >Mathématicien</en>, <en ref="25" >astrologue</en> et <en ref="24" >astronome</en>, il se fixe à Strasbourg en 1618. Établi libraire en 1620 puis imprimeur dès 1621. Publie notamment chaque année un almanach et des prédictions. Auteur de plusieurs ouvrages scientifiques, dont des "Elementa geometrica..." (1re éd., <dat when="1620">1620</dat>), une "Gnomonica" (<dat when="1625">1625</dat>), un "Compendium astronomiae..." (<dat when="1634">1634</dat>) et un traité de la divination, "Rota-Fortunae, oder Glück-Rad..." (s. d., plusieurs rééd.). De 1634 à 1639, assure des fonctions d''enseignant au Gymnase (lycée) de Strasbourg. En 1654, sollicite en vain la charge d''imprimeur de l''évêché de Saverne. De 1653 à 1661, imprime sous le pseudonyme de Hartmann Bär quelques ouvrages pour l''académie des Jésuites à Molsheim. Son fils aîné Johann Welper (1642-1720) lui succède en 1664, mais des éditions paraissent encore sous son nom en 1689. Son autre fils Eberhard (II) Welper (1644-1670) sera lui aussi <en ref="16" >mathématicien</en>, <en ref="25" >astrologue</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb158750586#foaf:Person]
</ud>
<ud>
Johannes Wilhelm Lauremberg (<dat when="1590">1590</dat>) Auteur, <en ref="16" >mathématicien</en> et historien à Rostock [http://data.bnf.fr/ark:/12148/cb15377794m#foaf:Person]
</ud>
<ud>
Jean Leurechon (Bar-le-Duc, <dat when="1591">1591</dat>) Jésuite. - Professeur de philosophie et de mathématiques, à Pont-à-Mousson notamment. - Confesseur du duc de Lorraine Charles IV. - Henry Van Etten, qui signe la dédicace de la première édition des "Récréations mathématiques" n''est pas un pseudonyme de Jean Leurechon, mais le nom d''un de ses élèves, qui aurait réellement existé d''après Trevor H. Hall [http://data.bnf.fr/ark:/12148/cb13009618g#foaf:Person]
</ud>
<ud>
Joseph Salomon Delmedigo (<dat when="1591">1591</dat>) <en ref="28" >Médecin</en>. - <en ref="24" >Astronome</en>. - <en ref="16" >Mathématicien</en>. - Né en Crète. - Fils d''Eliya Delmedigo (1460-1497) [http://data.bnf.fr/ark:/12148/cb122623548#foaf:Person]
</ud>
<ud>
Giovanni Battista Vertova (<en type="li">Bergame, Italie</en>, <dat when="1592">1592</dat>) <en ref="16" >Mathématicien</en> et ingénieur militaire. - Chevalier de l''Ordre de Malte [http://data.bnf.fr/ark:/12148/cb15093021d#foaf:Person]
</ud>
<ud>
Johann Adam Schall von Bell (<dat when="1592">1592</dat>) Jésuite. - Missionnaire en Chine (de 1619 à sa mort). - <en ref="16" >Mathématicien</en>. - Conseiller et <en ref="24" >astronome</en> de la Cour impériale de Chine [http://data.bnf.fr/ark:/12148/cb12362941r#foaf:Person]
</ud>
<ud>
Pierre Gassendi (<en type="li">Champtercier, près de Digne</en>, <dat when="1592">1592</dat>) <en ref="18" >Philosophe</en>, <en ref="24" >astronome</en>, <en ref="16" >mathématicien</en>, physicien, docteur en théologie et théoricien de la musique. - Entre dans les ordres en 1615 [http://data.bnf.fr/ark:/12148/cb120250393#foaf:Person]
</ud>
<ud>
Wilhelm Schickard (<en type="li">Herrenberg, Allemagne</en>, <dat when="1592">1592</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en>, professeur d''agriculture [http://data.bnf.fr/ark:/12148/cb11969696s#foaf:Person]
</ud>
<ud>
Albert Girard (Saint-Mihiel, <dat when="1595">1595</dat>) <en ref="16" >Mathématicien</en> et ingénieur. - Ingénieur dans l''armée de Frédéric de Nassau, prince d''Orange [http://data.bnf.fr/ark:/12148/cb121123333#foaf:Person]
</ud>
<ud>
Pierre Bardin (<en type="li">Rouen</en>, <dat when="1595">1595</dat>) Homme de lettres, <en ref="18" >philosophe</en> et <en ref="16" >mathématicien</en>. - Précepteur. - Membre de l''Académie française (élu en 1634) [http://data.bnf.fr/ark:/12148/cb125272379#foaf:Person]
</ud>
<ud>
Pierre Bourdin (<dat when="1595">1595</dat>) Jésuite. - Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb123902440#foaf:Person]
</ud>
<ud>
Daniel Mögling (<en type="li">Böblingen</en>, <dat when="1596">1596</dat>) Alchimiste, rosicrucien, <en ref="28" >médecin</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb167575369#foaf:Person]
</ud>
<ud>
Jacob Golius (<dat when="1596">1596</dat>) Orientaliste. - <en ref="16" >Mathématicien</en>. - Philologue, spécialiste des littératures [http://data.bnf.fr/ark:/12148/cb123338386#foaf:Person]
</ud>
<ud>
René Descartes (Descartes (Indre-et-Loire), <dat when="1596">1596</dat>) <en ref="18" >Philosophe</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb11899775j#foaf:Person]
</ud>
<ud>
Giovanni Battista Hodierna (<dat when="1597">1597</dat>) <en ref="24" >Astronome</en> italien [http://data.bnf.fr/ark:/12148/cb120704558#foaf:Person]
</ud>
<ud>
Bonaventura Cavalieri (<en type="li">Milan, Italie</en>, <dat when="1598">1598</dat>) Jésuite. - <en ref="16" >Mathématicien</en>, géomètre et <en ref="24" >astronome</en>, disciple de <en ref="7" >Galilée</en>. - Fut professeur à l''Université de Bologne [http://data.bnf.fr/ark:/12148/cb12085151g#foaf:Person]
</ud>
<ud>
Giovanni Battista Riccioli (<en type="li">Ferrare, Italie</en>, <dat when="1598">1598</dat>) Jésuite. - <en ref="24" >Astronome</en>. - Professeur de lettres, de philosophie et de théologie, à Parme puis à Bologne. - <en ref="16" >Mathématicien</en> et historien de la géographie [http://data.bnf.fr/ark:/12148/cb12546680q#foaf:Person]
</ud>
<ud>
Pierre Petit (<dat when="1598">1598</dat>) <en ref="16" >Mathématicien</en> et physicien. - Intendant général des ports et fortifications de France (<dat when="1649">1649</dat>) [http://data.bnf.fr/ark:/12148/cb123944733#foaf:Person]
</ud>
<ud>
Adam Olearius (<en type="li">Aschersleben, Allemagne</en>, <dat when="1599">1599</dat>) Voyageur, en particulier en Russie et en Perse. - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12817277v#foaf:Person]
</ud>
<ud>
Jacob Aertsz Colom (<dat when="1599">1599</dat>) <en ref="16" >Mathématicien</en>, navigateur et cartographe. - Imprimeur à Amsterdam [http://data.bnf.fr/ark:/12148/cb153358650#foaf:Person]
</ud>
<ud>
Adriaan Vlacq (<dat when="1600">1600</dat>) Autre(s) graphie(s) : Ulack ; Vlac. - Variante(s) de prénom : Adriaen ; Adrien. - Imprimeur-libraire. - Originaire de Gouda. Édite différents périodiques dont "De Haegsche Vrijdaeghse Post-Tijdingen". A publié en 1659 une contrefaçon de Johannes Elzevier et de Pieter Leffen. A également publié sous les fausses adresses et pseudonymes de "Cologne, Pierre Du Marteau" et "Amsterdam, Peter Le Grand". - Également <en ref="16" >mathématicien</en> connu pour ses travaux sur les logarithmes et auteur d''ouvrages d''astronomie et de pamphlets en faveur des royalistes anglais en 1652-1655. Mort peu avant le 8 avril 1667. Des éd. paraissent encore sous son nom jusqu''en 1669, en association avec Johannes Vlacq [http://data.bnf.fr/ark:/12148/cb121635061#foaf:Person]
</ud>
<ud>
Antoine de Laloubère (<dat when="1600">1600</dat>) Jésuite. - <en ref="16" >Mathématicien</en> et géomètre, fut le premier scientifique à étudier les propriétés de l''hélice. - Polémiqua avec Pascal, qui l''appelle "Allouerus" dans l''"Histoire de la roulette". - Professeur de rhétorique, de théologie et de mathématiques au collège de Toulouse. - Né à Rieux, meurt à Toulouse [http://data.bnf.fr/ark:/12148/cb13006798h#foaf:Person]
</ud>
<ud>
Giacomo Oddi (<dat when="1600">1600</dat>) Cartographe et <en ref="16" >mathématicien</en>. Etudie à Naples [http://data.bnf.fr/ark:/12148/cb153917817#foaf:Person]
</ud>
<ud>
Jakob Bartsch (<dat when="1600">1600</dat>) <en ref="28" >Médecin</en>. - Professeur de mathématiques à Strasbourg. - <en ref="24" >Astronome</en>. - Gendre et collaborateur de l''<en ref="24" >astronome</en> Johann Kepler (1571-1630) [http://data.bnf.fr/ark:/12148/cb12163632v#foaf:Person]
</ud>
<ud>
Emmanuel Maignan (<dat when="1601">1601</dat>) Religieux minime. - <en ref="18" >Philosophe</en>, <en ref="16" >mathématicien</en> et peintre. - Membre de la Société des lanternistes [http://data.bnf.fr/ark:/12148/cb130127157#foaf:Person]
</ud>
<ud>
Florimond de Beaune (<dat when="1601">1601</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb11890827s#foaf:Person]
</ud>
<ud>
Ovidio Montalbani (<dat when="1601">1601</dat>) Docteur en philosophie et médecine de l'' Université de Bologne, professeur de mathématiques, chargé du musée Aldrovandi à partir de 1657, fut aussi un citoyen actif de Bologne, où il assura plusieurs magistratures ("giudice del Foro de mercanti, e de tribuni della plebe"). - Membre de l''Accademia dei Gelati de Bologne ("l''Innestato"), de l''Accademia degli Indomiti de Bologne ("lo Stellato"), et de l''Accademia della Notte de Bologne ("il Rugiadoso") [http://data.bnf.fr/ark:/12148/cb12064289s#foaf:Person]
</ud>
<ud>
Pierre de Fermat (Beaumont-de-Lomagne (Tarn-et-Garonne), <dat when="1601">1601</dat>) <en ref="16" >Mathématicien</en>, célèbre pour son théorème. - On lui doit aussi le Principe de Fermat en optique. - Conseiller au Parlement de Toulouse et commissaire en la chambre des requêtes du Palais à Toulouse (mai 1631) [http://data.bnf.fr/ark:/12148/cb11902568b#foaf:Person]
</ud>
<ud>
Athanasius Kircher (<en type="li">Geisa (Allemagne)</en>, <dat when="1602">1602</dat>) Jésuite. - Professeur de physique, de mathématiques et de langues orientales, Collegio Romano, Rome. - Dessinateur et graveur [http://data.bnf.fr/ark:/12148/cb119097824#foaf:Person]
</ud>
<ud>
Gilles Personne de Roberval (<en type="li">Roberval, Oise</en>, <dat when="1602">1602</dat>) Professeur de philosophie (<dat when="1634">1634</dat>) et de mathématiques (<dat when="1655">1655</dat>) au Collège royal, Paris. - Membre fondateur de l''Académie royale des sciences [http://data.bnf.fr/ark:/12148/cb12144923j#foaf:Person]
</ud>
<ud>
Jacques de Billy (<dat when="1602">1602</dat>) Jésuite (à partir de 1619). - <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb123773436#foaf:Person]
</ud>
<ud>
John Greaves (<en type="li">Colemore, GB</en>, <dat when="1602">1602</dat>) <en ref="16" >Mathématicien</en>. - Orientaliste. - Professeur d''astronomie à Londres puis à Oxford [http://data.bnf.fr/ark:/12148/cb129277690#foaf:Person]
</ud>
<ud>
Pierre Gautruche (<dat when="1602">1602</dat>) Jésuite. - Professeur de philosophie, de théologie et de mathématiques. - Identifié par certains à Pierre Gautier (1599-16..), luthiste et compositeur [http://data.bnf.fr/ark:/12148/cb121990328#foaf:Person]
</ud>
<ud>
Blaise-François de Pagan (<en type="li">Avignon</en>, <dat when="1604">1604</dat>) Ingénieur et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb12155087r#foaf:Person]
</ud>
<ud>
Claude Hardy (<dat when="1604">1604</dat>) Fils de Sébastien Hardy. - Conseiller au Châtelet. - <en ref="16" >Mathématicien</en>. - Ami de Mydorge, Descartes et du Père Mersenne ; souvent cité dans la correspondance de ces deux derniers [http://data.bnf.fr/ark:/12148/cb12134536k#foaf:Person]
</ud>
<ud>
Bernard Frénicle de Bessy (<dat when="1605">1605</dat>) <en ref="16" >Mathématicien</en>, géomètre et arithméticien. - Membre de l''Académie des Sciences. - Conseiller à la Cour des monnaies [http://data.bnf.fr/ark:/12148/cb12459881c#foaf:Person]
</ud>
<ud>
Ismaël Boulliau (<en type="li">Loudun (Vienne)</en>, <dat when="1605">1605</dat>) <en ref="24" >Astronome</en>. - Secrétaire de Jacques Du Puy et attaché au président de Thou [http://data.bnf.fr/ark:/12148/cb124621511#foaf:Person]
</ud>
<ud>
Juan de Caramuel y Lobkowitz (<en type="li">Madrid</en>, <dat when="1606">1606</dat>) Cistercien. - Evêque de Satriano et Campagna (1657-1673) puis de Vigevano (1673-). - Humaniste, théologien, <en ref="16" >mathématicien</en>, <en ref="18" >philosophe</en> et architecte. - Défenseur de la doctrine probabiliste [http://data.bnf.fr/ark:/12148/cb12392566m#foaf:Person]
</ud>
<ud>
Evangelista Torricelli (<en type="li">Faenza, Italie</en>, <dat when="1608">1608</dat>) Physicien et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12117674q#foaf:Person]
</ud>
<ud>
Gaspar Schott (<en type="li">Königshaufen, Allemagne</en>, <dat when="1608">1608</dat>) <en ref="16" >Mathématicien</en> et physicien. - Jésuite [http://data.bnf.fr/ark:/12148/cb12519717b#foaf:Person]
</ud>
<ud>
Giovanni Alfonso Borelli (<en type="li">Naples, Italie</en>, <dat when="1608">1608</dat>) <en ref="16" >Mathématicien</en>, phycisien, <en ref="28" >médecin</en>, <en ref="18" >philosophe</en>. - Membre de l''Accademia del Cimento [http://data.bnf.fr/ark:/12148/cb12462534j#foaf:Person]
</ud>
<ud>
Giovan Battista Nicolosi (<en type="li">Paternò, Italie</en>, <dat when="1610">1610</dat>) <en ref="29" >Géographe</en> et cartographe. - Professeur de mathématiques et de géographie à l''Université de Rome [http://data.bnf.fr/ark:/12148/cb15404103t#foaf:Person]
</ud>
<ud>
Józef Naronowicz-Naroński (<dat when="1610">1610</dat>) <en ref="16" >Mathématicien</en>. - Cartographe. - Architecte au service de la famille Radzwill. - Né en Lituanie [http://data.bnf.fr/ark:/12148/cb150812338#foaf:Person]
</ud>
<ud>
Maria Cunitia (<dat when="1610">1610</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb162514419#foaf:Person]
</ud>
<ud>
Jan Heweliusz (<dat when="1611">1611</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb121054498#foaf:Person]
</ud>
<ud>
John Pell (<dat when="1611">1611</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb146515879#foaf:Person]
</ud>
<ud>
Michael Floris Van Langren (<dat when="1612">1612</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en> du roi d''Espagne installé à Bruxelles [http://data.bnf.fr/ark:/12148/cb153283774#foaf:Person]
</ud>
<ud>
Francesco Maria Grimaldi (<dat when="1613">1613</dat>) Jésuite. - <en ref="18" >Philosophe</en>, <en ref="24" >astronome</en>, opticien et professeur de mathématiques. - Né et mort à Bologne [http://data.bnf.fr/ark:/12148/cb13326913s#foaf:Person]
</ud>
<ud>
François Chauveau (<dat when="1613">1613</dat>) Grava des cartouches notamment pour Nicolas Sanson. Eut un neveu du nom de François Chauveau. Son frère, Jean-Baptiste, habile ingénieur et <en ref="16" >mathématicien</en> fut assassiné en 1670. [http://data.bnf.fr/ark:/12148/cb15302394v#foaf:Person]
</ud>
<ud>
Jean François Nicéron (<en type="li">Paris</en>, <dat when="1613">1613</dat>) Religieux de l''Ordre des minimes. - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb14404933t#foaf:Person]
</ud>
<ud>
Tommaso Cornelio (<en type="li">Rovito, Italie</en>, <dat when="1614">1614</dat>) <en ref="28" >Médecin</en>, <en ref="18" >philosophe</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb13484167f#foaf:Person]
</ud>
<ud>
Frans Van Schooten (<dat when="1615">1615</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12529949q#foaf:Person]
</ud>
<ud>
John Wallis (<dat when="1616">1616</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb123396143#foaf:Person]
</ud>
<ud>
Jonas Moore (<dat when="1617">1617</dat>) <en ref="16" >Mathématicien</en> britannique. - S''est intéressé aux mathématiques appliquées (astronomie, cosmographie, architecture...) [http://data.bnf.fr/ark:/12148/cb135104102#foaf:Person]
</ud>
<ud>
Tito Livio Burattini (<en type="li">Agordo, Italie</en>, <dat when="1617">1617</dat>) <en ref="16" >Mathématicien</en>, cartographe et égyptologue [http://data.bnf.fr/ark:/12148/cb162142362#foaf:Person]
</ud>
<ud>
Anthelme (Chatenay-Vaudin (Haute-Marne), <dat when="1618">1618</dat>) Religieux de la Chartreuse de Dijon. - <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb106267229#foaf:Person]
</ud>
<ud>
Charles Cavendish (<dat when="1620">1620</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb14651592w#foaf:Person]
</ud>
<ud>
Jean Picard (<en type="li">La Flèche (Sarthe)</en>, <dat when="1620">1620</dat>) <en ref="24" >Astronome</en>. - Membre de l''Académie des sciences (<dat when="1666">1666</dat>) [http://data.bnf.fr/ark:/12148/cb11941359d#foaf:Person]
</ud>
<ud>
Claude-François Milliet de Chales (<dat when="1621">1621</dat>) <en ref="16" >Mathématicien</en>. - Professeur d''hydrographie à Marseille [http://data.bnf.fr/ark:/12148/cb12397222c#foaf:Person]
</ud>
<ud>
Adrien Auzout (<en type="li">Rouen</en>, <dat when="1622">1622</dat>) <en ref="24" >Astronome</en>, physicien et <en ref="16" >mathématicien</en>. - A contribué au développement du micromètre [http://data.bnf.fr/ark:/12148/cb134752474#foaf:Person]
</ud>
<ud>
Jean Bertet (<dat when="1622">1622</dat>) Jésuite, quitte la Compagnie en 1681 pour entrer chez les Bénédictins. - Professeur de rhétorique, philosophie et mathématiques. - Poète [http://data.bnf.fr/ark:/12148/cb11999230c#foaf:Person]
</ud>
<ud>
René-François De Sluse (<dat when="1622">1622</dat>) <en ref="16" >Mathématicien</en>. - Chanoine de la Cathédrale de Liège et abbé d''Amay [http://data.bnf.fr/ark:/12148/cb12427294z#foaf:Person]
</ud>
<ud>
Vincenzo Viviani (<en type="li">Florence, Italie</en>, <dat when="1622">1622</dat>) Florentin. - <en ref="16" >Mathématicien</en>. - Membre de l'' "accademia della Crusca" [http://data.bnf.fr/ark:/12148/cb12000373g#foaf:Person]
</ud>
<ud>
Blaise Pascal (Clermont-Ferrand (Puy-de-Dôme), <dat when="1623">1623</dat>) <en ref="16" >Mathématicien</en>, physicien, <en ref="26" >écrivain</en>. - Frère de : Pascal, Jacqueline (1625-1661) [http://data.bnf.fr/ark:/12148/cb11918679x#foaf:Person]
</ud>
<ud>
Ferdinand Verbiest (<en type="li">Pitthem, Belgique</en>, <dat when="1623">1623</dat>) Jésuite, missionnaire en Chine. - <en ref="24" >Astronome</en>. - Fut placé à la tête du tribunal des mathématiques, chargé de la rédaction des éphémérides et de la direction des fonderies de canons. - A publié en langue chinoise, sous le nom de Nanhoai-jin, un grand nombre d''ouvrages scientifiques [http://data.bnf.fr/ark:/12148/cb12215344n#foaf:Person]
</ud>
<ud>
Camillo Guarino Guarini (<en type="li">Modène, Italie</en>, <dat when="1624">1624</dat>) Clerc régulier, théatin. - Architecte du duc de Savoie, <en ref="18" >philosophe</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12348027r#foaf:Person]
</ud>
<ud>
Christoph Wittich (<dat when="1625">1625</dat>) Théologien. - Professeur de mathématiques et de théologie [http://data.bnf.fr/ark:/12148/cb13014027s#foaf:Person]
</ud>
<ud>
Erhard Weigel (<dat when="1625">1625</dat>) <en ref="18" >Philosophe</en>. - Professeur de mathématiques, maître de Leibniz et de Pufendorf [http://data.bnf.fr/ark:/12148/cb11935908x#foaf:Person]
</ud>
<ud>
Jean-Dominique Cassini (<en type="li">Perinaldo (comté de Nice)</en>, <dat when="1625">1625</dat>) Titulaire de la chaire d''astronomie de Bologne de 1650 à 1669, surintendant des eaux du Bolonais de 1657 à 1669, surintendant des eaux de l''Etat pontifical et titulaire d''autres charges auprès du pape. - Appelé en France an avril 1669 par Louis XIV. - Membre de l''Académie des sciences, directeur de l''Observatoire de Paris (à partir de 1672). - Naturalisé français en 1673 [http://data.bnf.fr/ark:/12148/cb121019904#foaf:Person]
</ud>
<ud>
Johan de Witt (Dordrecht, Pays-Bas, <dat when="1625">1625</dat>) Homme d''état et <en ref="16" >mathématicien</en>. - Grand pensionnaire de Hollande [http://data.bnf.fr/ark:/12148/cb13598046j#foaf:Person]
</ud>
<ud>
Johann Hecker (<en type="li">Gdansk (Pologne)</en>, <dat when="1625">1625</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb12875545t#foaf:Person]
</ud>
<ud>
Rasmus Bartholin (<en type="li">Roskilde, Danemark</en>, <dat when="1625">1625</dat>) Physicien. - <en ref="16" >Mathématicien</en>. - <en ref="28" >Médecin</en>. - Professeur de mathématiques et de médecine à Copenhague. - A découvert la difraction de la lumière. - Fils de Kaspar Bartholin [http://data.bnf.fr/ark:/12148/cb11890430k#foaf:Person]
</ud>
<ud>
Samuel Morland (<dat when="1625">1625</dat>) <en ref="16" >Mathématicien</en> et inventeur [http://data.bnf.fr/ark:/12148/cb10365749d#foaf:Person]
</ud>
<ud>
Pietro Mengoli (<en type="li">Bologne (Italie)</en>, <dat when="1626">1626</dat>) <en ref="16" >Mathématicien</en>. - Professeur de mécanique (1650-1678) puis titulaire de la chaire de mathématiques et d''astronomie (1678-1686) à l''université de Bologne [http://data.bnf.fr/ark:/12148/cb120851477#foaf:Person]
</ud>
<ud>
John Ray (<en type="li">Black Notley (Essex)</en>, <dat when="1627">1627</dat>) Professeur de mathématiques et de lettres. - Naturaliste. - Botaniste. - Membre de la Société royale de Londres [http://data.bnf.fr/ark:/12148/cb12220184b#foaf:Person]
</ud>
<ud>
Heinrich Scherer (<dat when="1628">1628</dat>) Jésuite, <en ref="29" >géographe</en> et professeur de mathématiques à Munich [http://data.bnf.fr/ark:/12148/cb15317471w#foaf:Person]
</ud>
<ud>
Johannes Hudde (<dat when="1628">1628</dat>) <en ref="16" >Mathématicien</en>, élève de Frans Van Schooten. - Bourgmestre de la ville d''Amsterdam [http://data.bnf.fr/ark:/12148/cb13488288n#foaf:Person]
</ud>
<ud>
Christiaan Huygens (<dat when="1629">1629</dat>) <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en>. - A vécu aux Pays-Bas et en France. - Élu membre de la "Royal society" de Londres (en 1663) [http://data.bnf.fr/ark:/12148/cb12192922r#foaf:Person]
</ud>
<ud>
Allain Manesson-Mallet (<en type="li">Paris (France)</en>, <dat when="1630">1630</dat>) Ingénieur et cartographe. - Maître de mathématiques des pages du roi de France, sergent-major d''artillerie du roi de Portugal [http://data.bnf.fr/ark:/12148/cb153363577#foaf:Person]
</ud>
<ud>
Isaac Barrow (<dat when="1630">1630</dat>) <en ref="16" >Mathématicien</en> et théologien [http://data.bnf.fr/ark:/12148/cb12340135q#foaf:Person]
</ud>
<ud>
Jean Richer (<dat when="1630">1630</dat>) <en ref="24" >Astronome</en> à l''Observatoire de Paris, il figure parmi les premiers membres de l''Académie des sciences (<dat when="1666">1666</dat>). - Chargé d''une mission géodésique à Cayenne (1672-73) [http://data.bnf.fr/ark:/12148/cb14064426q#foaf:Person]
</ud>
<ud>
Adam Adamady Kochánski (<dat when="1631">1631</dat>) <en ref="16" >Mathématicien</en> polonais, auteur de la rectification approchée de la circonférence. Réside en 1677 à Wroclaw [http://data.bnf.fr/ark:/12148/cb16187484g#foaf:Person]
</ud>
<ud>
Francesco Lana Terzi (<en type="li">Brescia, Italie</en>, <dat when="1631">1631</dat>) Jésuite. - <en ref="16" >Mathématicien</en>, naturaliste. - Pionnier de l''aéronautique [http://data.bnf.fr/ark:/12148/cb10681783j#foaf:Person]
</ud>
<ud>
Christopher Wren (<en type="li">East Knoyle, Wiltshire, GB</en>, <dat when="1632">1632</dat>) Architecte. - <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en>, Sir Christopher Wren fut l''un des membres fondateurs de la Société royale des sciences [http://data.bnf.fr/ark:/12148/cb121401670#foaf:Person]
</ud>
<ud>
Alessandro Marchetti (<en type="li">Empoli, Italie</en>, <dat when="1633">1633</dat>) Poète naturaliste, l''un des principaux animateurs du courant naturaliste toscan de la seconde moitié du XVIIe siècle. - Professeur de philosophie puis de mathématiques à l''Université de Pise [http://data.bnf.fr/ark:/12148/cb12570345j#foaf:Person]
</ud>
<ud>
Donato Rossetti (<en type="li">Livourne, Italie</en>, <dat when="1633">1633</dat>) <en ref="16" >Mathématicien</en>. - Professeur de philosophie au "Studio" de Pise [http://data.bnf.fr/ark:/12148/cb144820894#foaf:Person]
</ud>
<ud>
Geminiano Montanari (<en type="li">Modène, Italie</en>, <dat when="1633">1633</dat>) Docteur en droit, <en ref="16" >mathématicien</en> et <en ref="24" >astronome</en>. - Enseigne à Florence, Modène (1661-1664), Bologne (chaire de mathématiques, 1664-1677) et Padoue (chaire d''astronomie, 1678-1687). - Membre de l''Accademia dei Gelati ("l''Elevato") et de l''Accademia della Treccia de Bologne [http://data.bnf.fr/ark:/12148/cb12309300z#foaf:Person]
</ud>
<ud>
Gerhard Wolter Molanus (<dat when="1633">1633</dat>) Théologien luthérien. - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12133744h#foaf:Person]
</ud>
<ud>
Giovanni Giustino Ciampini (<en type="li">Rome</en>, <dat when="1633">1633</dat>) Historien, archéologue, <en ref="16" >mathématicien</en>. - Membre de la Curie pontificale [http://data.bnf.fr/ark:/12148/cb14323561z#foaf:Person]
</ud>
<ud>
Vitale Giordano (<dat when="1633">1633</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb15520924m#foaf:Person]
</ud>
<ud>
Johann Christoph Sturm (<en type="li">Hilpolstein, Allemagne</en>, <dat when="1635">1635</dat>) <en ref="18" >Philosophe</en>, <en ref="16" >mathématicien</en> et physicien. - Professeur à l''université d''Altdorf [http://data.bnf.fr/ark:/12148/cb133240234#foaf:Person]
</ud>
<ud>
Ignace-Gaston Pardies (<dat when="1636">1636</dat>) <en ref="16" >Mathématicien</en>. - Jésuite. - Il a enseigné la philosophie puis les mathématiques au collège Louis-Le-Grand [http://data.bnf.fr/ark:/12148/cb12174258w#foaf:Person]
</ud>
<ud>
Elias van Lennep (Borculo, Pays-Bas, <dat when="1637">1637</dat>) Graveur. - Ingénieur et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb15053499m#foaf:Person]
</ud>
<ud>
Julius Reichelt (<dat when="1637">1637</dat>) <en ref="16" >Mathématicien</en> strasbourgeois [http://data.bnf.fr/ark:/12148/cb15377331m#foaf:Person]
</ud>
<ud>
François Barrême (<en type="li">Tarascon, France</en>, <dat when="1638">1638</dat>) <en ref="16" >Mathématicien</en> et financier [http://data.bnf.fr/ark:/12148/cb118903320#foaf:Person]
</ud>
<ud>
Georg Christoph Eimmart (<en type="li">Ratisbonne (Allemagne)</en>, <dat when="1638">1638</dat>) Peintre d''histoire, portraitiste, graveur, <en ref="16" >mathématicien</en> et <en ref="24" >astronome</en>. - Fils et élève du peintre Georg-Christoph Eimmart (1603-1658), dit le vieux [http://data.bnf.fr/ark:/12148/cb12983761h#foaf:Person]
</ud>
<ud>
James Gregory (<dat when="1638">1638</dat>) <en ref="16" >Mathématicien</en> et opticien écossais [http://data.bnf.fr/ark:/12148/cb12459917j#foaf:Person]
</ud>
<ud>
Jean Bonfa (<en type="li">Nîmes</en>, <dat when="1638">1638</dat>) Est admis à la Société de Jésus en 1654. - Dans les années 1670 jusqu''en 1683, il enseigne les mathématiques et la théologie aux collèges jésuites de Grenoble, puis d''Avignon. - De 1680 à 1682, enseigne la géométrie et l''hydrographie. - Effectue des travaux astronomiques. - Devient membre correspondant de l''Académie royale des sciences (en 1699) [http://data.bnf.fr/ark:/12148/cb15130186g#foaf:Person]
</ud>
<ud>
Jacques Ozanam (Sainte-Olive (<en type="li">Ain)</en>, <dat when="1640">1640</dat>) <en ref="16" >Mathématicien</en>. - Professeur de mathématiques à Paris et à Lyon [http://data.bnf.fr/ark:/12148/cb120960958#foaf:Person]
</ud>
<ud>
Philippe de La Hire (<en type="li">Paris (France)</en>, <dat when="1640">1640</dat>) <en ref="16" >Mathématicien</en>. - Géomètre et <en ref="24" >astronome</en>. - Professeur de mathématiques au Collège de France. - Membre de l''Académie des sciences (<dat when="1678">1678</dat>) [http://data.bnf.fr/ark:/12148/cb121592847#foaf:Person]
</ud>
<ud>
Pierre Ango (<dat when="1640">1640</dat>) Jésuite. - Enseigna les humanités, les mathématiques et la philosophie. - Né à Rouen, mort à La Flèche [http://data.bnf.fr/ark:/12148/cb12512101m#foaf:Person]
</ud>
<ud>
Denis Papin (<dat when="1642">1642</dat>) Physicien. - Un des précurseurs de l''invention de la machine à vapeur, qui eu l''idée du piston (dés 1690), et inspira la machine que l''Anglais Thomas Newcomen (1664-1729), mis au point ensuite (en 1712). - Quitta définitivement la France, après la révocation de l''Édit de Nantes (<dat when="1685">1685</dat>). - Occupa une chaire de mathématiques à l''Université de Marburg, Allemagne (<dat when="1687">1687</dat>). - Rédige un article (Ars nova ad aquam ignis...) présentant sa machine dans la revue " Acta Eruditorum", Leipzig (en 1707), revue célèbre pour les publications de Leibniz (1646-1716), sur le calcul différentiel et intégral [http://data.bnf.fr/ark:/12148/cb12087889k#foaf:Person]
</ud>
<ud>
Isaac Newton (Woolsthorpe, Lincolnshire (<en type="li">GB)</en>, <dat when="1642">1642</dat>) Physicien, <en ref="16" >mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb119176085#foaf:Person]
</ud>
<ud>
Johann Welper (<dat when="1642">1642</dat>) Variante(s) de prénom : Johannes ; Jean. - Imprimeur-libraire. - Fils et apprenti d''Eberhard Welper, imprimeur-libraire et <en ref="16" >mathématicien</en> à Strasbourg. A été compagnon pendant 6 ans à Ulm, Augsbourg, Munich, Vienne, Leipzig et Nuremberg, avant de succéder à son père. L''enquête de 1700-1701 le dit âgé de 60 ans et "établi à Strasbourg depuis 42 ans". À sa mort, son entreprise est rachetée par Melchior Pauschinger [http://data.bnf.fr/ark:/12148/cb160636269#foaf:Person]
</ud>
<ud>
Michel Mourgues (<dat when="1642">1642</dat>) Jésuite. - Enseigna la rhétorique et les mathématiques à l''Université de Toulouse [http://data.bnf.fr/ark:/12148/cb124637183#foaf:Person]
</ud>
<ud>
Takakazu Seki (<dat when="1642">1642</dat>) <en ref="16" >Mathématicien</en> japonais [http://data.bnf.fr/ark:/12148/cb12443516f#foaf:Person]
</ud>
<ud>
Jean Jombert (<dat when="1643">1643</dat>) Libraire. - Fils d''un fruitier et marchand de vins parisien. En apprentissage chez le libraire parisien Pierre II Baudouin à partir de janv. 1666, il travaille en 1670-1671 chez Louis Billaine et Pierre Le Petit, puis chez la veuve de Pierre I Baudouin à partir de 1672. Gendre en 1res noces (<dat when="1671">1671</dat>) du libraire Jean d''Houry. Publie sous son propre nom dès 1680, peut-être dès 1678, mais n''est reçu maître que le 17 sept. 1686. Publie de nombreux ouvrages de mathématiques. Dit âgé d''env. 60 ans lors de l''enquête de nov.-déc. 1701. Testaments le 9 août 1704 et le 6 oct. 1705. Décédé au début de nov. 1705. Sa veuve lui succède [http://data.bnf.fr/ark:/12148/cb15074749j#foaf:Person]
</ud>
<ud>
Antoine Thomas (<en type="li">Namur</en>, <dat when="1644">1644</dat>) Jésuite (à partir de 1660). - <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en> de l''empereur de Chine [http://data.bnf.fr/ark:/12148/cb10636254r#foaf:Person]
</ud>
<ud>
Johann Jakob Zimmermann (<en type="li">Vaihingen an der Enz, Allemagne</en>, <dat when="1644">1644</dat>) Théologien, <en ref="16" >mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb10721479d#foaf:Person]
</ud>
<ud>
Ole Rømer (<en type="li">Åarhus, Danemark</en>, <dat when="1644">1644</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb12324191r#foaf:Person]
</ud>
<ud>
Carlos de Sigüenza y Góngora (<en type="li">Mexico</en>, <dat when="1645">1645</dat>) <en ref="24" >Astronome</en>, <en ref="16" >mathématicien</en>, poète, historien. - Sa bibliothèque, comprenant des documents uniques sur l''histoire du Mexique, disparut dans un incendie lors de l''insurrection de 1692 [http://data.bnf.fr/ark:/12148/cb121021638#foaf:Person]
</ud>
<ud>
Eusebio Francisco Kino (<en type="li">Taio, Italie</en>, <dat when="1645">1645</dat>) <en ref="16" >Mathématicien</en> et <en ref="29" >géographe</en> de formation. - Jésuite, arrive au Mexique en 1681 [http://data.bnf.fr/ark:/12148/cb122190783#foaf:Person]
</ud>
<ud>
Maximilian Rassler (<en type="li">Waldsee (Allemagne)</en>, <dat when="1645">1645</dat>) Jésuite. - Professeur de réthorique, de mathématiques, philosophie et contreverse. - Recteur et chancelier de l''Université de Dillingen, Allemagne [http://data.bnf.fr/ark:/12148/cb158132748#foaf:Person]
</ud>
<ud>
Elena Lucrezia Cornaro Piscopia (<en type="li">Venise (Italie)</en>, <dat when="1646">1646</dat>) <en ref="18" >Philosophe</en> et <en ref="16" >mathématicien</en>ne. - Première femme docteur en philosophie [http://data.bnf.fr/ark:/12148/cb16591183r#foaf:Person]
</ud>
<ud>
Francesco Maria Pompeo Colonna (<en type="li">Rome</en>, <dat when="1646">1646</dat>) <en ref="16" >Mathématicien</en>, physicien et occultiste. - Vécut à Paris à partir de 1668 [http://data.bnf.fr/ark:/12148/cb118973978#foaf:Person]
</ud>
<ud>
Harald Vallerius (<dat when="1646">1646</dat>) Professeur universitaire de mathématiques [http://data.bnf.fr/ark:/12148/cb16032560b#foaf:Person]
</ud>
<ud>
John Flamsteed (<dat when="1646">1646</dat>) <en ref="24" >Astronome</en>. - Fut le premier directeur de l''Observatoire de Greenwich, GB, fondé en 1675 [http://data.bnf.fr/ark:/12148/cb13524243n#foaf:Person]
</ud>
<ud>
John Flamsteed (<dat when="1646">1646</dat>) <en ref="24" >Astronome</en> britannique. Fut le premier directeur de l''observatoire de Greenwich, fondé en 1675 [http://data.bnf.fr/ark:/12148/cb13510391m#foaf:Person]
</ud>
<ud>
Niccolò Partenio Giannettasio (<dat when="1648">1648</dat>) Jésuite. - Historien et poète. - Professeur de mathématiques et d''hébreu au Collège des Jésuites de Naples. - Né à Naples, meurt à Massa [http://data.bnf.fr/ark:/12148/cb133256727#foaf:Person]
</ud>
<ud>
Tommaso Ceva (<dat when="1648">1648</dat>) Jésuite. - <en ref="18" >Philosophe</en>, <en ref="24" >astronome</en>, physicien et poète. - Membre de l''Académie de l''Arcadie sous le pseudonyme : Callimaco Neridio [http://data.bnf.fr/ark:/12148/cb13321850h#foaf:Person]
</ud>
<ud>
Jean Le Febvre (<en type="li">Lisieux (Calvados)</en>, <dat when="1650">1650</dat>) Tisserand, puis <en ref="24" >astronome</en>. - Membre de l''Académie des sciences de 1682 à 1702 [http://data.bnf.fr/ark:/12148/cb16176897g#foaf:Person]
</ud>
<ud>
Michelangelo Fardella (<dat when="1650">1650</dat>) Franciscain. - <en ref="18" >Philosophe</en>, <en ref="24" >astronome</en> et <en ref="16" >mathématicien</en>. - Professeur de philosophie, de théologie, de mathématiques, professeur d''astronomie et de physique à l''Université de Padoue (1694-). - Né à Trapani, meurt à Naples [http://data.bnf.fr/ark:/12148/cb12093422f#foaf:Person]
</ud>
<ud>
Andreas Cellarius (<dat when="1651">1651</dat>) <en ref="16" >Mathématicien</en> et <en ref="29" >géographe</en> hollandais actif de 1656 à 1702. En 1660 il est recteur de l''Ecole latine de Hoorn [http://data.bnf.fr/ark:/12148/cb15338282n#foaf:Person]
</ud>
<ud>
Antoine-François Payen (<en type="li">Avignon</en>, <dat when="1651">1651</dat>) Jurisconsulte et <en ref="24" >astronome</en>. - Enseigna la jurisprudence civile dès 1642 à Avignon [http://data.bnf.fr/ark:/12148/cb144713316#foaf:Person]
</ud>
<ud>
Arent Roggeveen (<dat when="1651">1651</dat>) <en ref="16" >Mathématicien</en>, navigateur et hydrographe [http://data.bnf.fr/ark:/12148/cb153879695#foaf:Person]
</ud>
<ud>
Bingzhen Jiao (<dat when="1651">1651</dat>) Peintre et <en ref="16" >mathématicien</en> à la cour de l''empereur Kangxi [http://data.bnf.fr/ark:/12148/cb14546684c#foaf:Person]
</ud>
<ud>
Caspar Dauthendey (<dat when="1651">1651</dat>) Architecte et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb153778194#foaf:Person]
</ud>
<ud>
Claude Bonjour (<dat when="1651">1651</dat>) Augustin du couvent de Pontarlier. <en ref="29" >Géographe</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb15294805z#foaf:Person]
</ud>
<ud>
Claude Comiers (<dat when="1651">1651</dat>) Théologien et <en ref="16" >mathématicien</en>, né à Embrun. Chanoine d''Embrun, ingénieur des armées, puis prévôt de l''église collégiale de Ternant, professeur de mathématiques à Paris ; protonotaire apostolique et officier du Saint-Office. - Il a laissé des livres et des articles sur des sujets variés : géométrie, astronomie, médecine, occultisme, physique... [http://data.bnf.fr/ark:/12148/cb12250531g#foaf:Person]
</ud>
<ud>
Claude Irson (<dat when="1651">1651</dat>) <en ref="16" >Mathématicien</en> et <en ref="27" >grammairien</en>. - A été teneur de comptes vers 1678 [http://data.bnf.fr/ark:/12148/cb125155096#foaf:Person]
</ud>
<ud>
de La Roche (<dat when="1651">1651</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb13009642b#foaf:Person]
</ud>
<ud>
Ehrenfried Walter von Tschirnhaus (<en type="li">Kieslingswalde, Allemagne</en>, <dat when="1651">1651</dat>) <en ref="18" >Philosophe</en>, <en ref="16" >mathématicien</en> et biologiste. - Industriel, considéré comme l''inventeur de la porcellaine blanche en Europe [http://data.bnf.fr/ark:/12148/cb12515471b#foaf:Person]
</ud>
<ud>
Federico Gualdi (<dat when="1651">1651</dat>) Alchimiste, <en ref="24" >astronome</en>, <en ref="16" >mathématicien</en>. - <en ref="18" >Philosophe</en> hermétique. - Membre de la Rose-croix d''Or. - Serait d''origine allemande ou italienne [http://data.bnf.fr/ark:/12148/cb150904929#foaf:Person]
</ud>
<ud>
Francesco Levera (<en type="li">Savoie</en>, <dat when="1651">1651</dat>) <en ref="18" >Philosophe</en>, <en ref="24" >astronome</en> et théologien [http://data.bnf.fr/ark:/12148/cb10442558v#foaf:Person]
</ud>
<ud>
François Chevalier (Sainte-Maur, <dat when="1651">1651</dat>) Elève de l''abbé Galloys. Associé géomètre à l''Académie des sciences en 1707. Pensionnaire mécanicien en 1725. Professeur de mathématiques au Collège de France. Maître de mathématiques du roi et des pages de la Petite Ecurie. Présenta en 1707 à l''Académie une méthode de collecte des informations cartographiques sur des châssis concentriques [http://data.bnf.fr/ark:/12148/cb153045899#foaf:Person]
</ud>
<ud>
François Noël (Hestrud, Pays-Bas Méridionaux, <dat when="1651">1651</dat>) Jésuite (à partir de 1670) ordonné prêtre en 1682. - Missionnaire en Chine, il fut envoyé à Rome à l''occasion de la querelle des rites, et ne put rentrer en Chinê. - Il enseigna ensuite à Prague. - Auteur de poésies et de théâtre, d''un traité d''astronomie, de traductions et d''un ouvrage catéchétique en chinois [http://data.bnf.fr/ark:/12148/cb16653645d#foaf:Person]
</ud>
<ud>
Guisnée (<dat when="1651">1651</dat>) <en ref="16" >Mathématicien</en>. - Membre de l''Académie royale des sciences [http://data.bnf.fr/ark:/12148/cb14618149h#foaf:Person]
</ud>
<ud>
Jacques Mengau (<dat when="1651">1651</dat>) Professeur de mathématiques. - Auteur de mazarinades. - Actif de 1648 à 1652 [http://data.bnf.fr/ark:/12148/cb12166762s#foaf:Person]
</ud>
<ud>
Jean Bachou (<dat when="1651">1651</dat>) <en ref="16" >Mathématicien</en> et alchimiste lyonnais. - Avocat au parlement [http://data.bnf.fr/ark:/12148/cb12158814g#foaf:Person]
</ud>
<ud>
Jean Glover (<dat when="1651">1651</dat>) Ingénieur et <en ref="16" >mathématicien</en> originaire d''Écosse et établi en France. - Auteur notamment de plusieurs propositions de loteries et d''une "Nouvelle Manière d''exécuter les loteries..." (<en type="li">Paris</en>, <dat when="1705">1705</dat>). - Se qualifie d''"esquire, seigneur de Glaideny et de la baronnie de Baltillée en Ecosse" [http://data.bnf.fr/ark:/12148/cb15818830h#foaf:Person]
</ud>
<ud>
Jean-Baptiste Delure (<dat when="1651">1651</dat>) Éditeur d''estampes et de cartes géographiques. - Ingénieur pour les instruments de mathématiques et fabricant de cartes et de globes ; éditeur occasionnel [http://data.bnf.fr/ark:/12148/cb153164066#foaf:Person]
</ud>
<ud>
Joachim d'' Alencé (<dat when="1651">1651</dat>) <en ref="24" >Astronome</en> et physicien [http://data.bnf.fr/ark:/12148/cb12397878n#foaf:Person]
</ud>
<ud>
Joanne Westenburg (<dat when="1651">1651</dat>) Cartographe, <en ref="28" >médecin</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb15377993t#foaf:Person]
</ud>
<ud>
Johann Andreas Planer (<en type="li">Strelen, Allemagne</en>, <dat when="1651">1651</dat>) <en ref="16" >Mathématicien</en>. - Professeur de mathématiques à l''Université de Wittenberg [http://data.bnf.fr/ark:/12148/cb16672375p#foaf:Person]
</ud>
<ud>
Le Blanc (<dat when="1651">1651</dat>) Professeur de mathématiques (<dat when="1692">1692</dat>). - Réside rue de Seine à Paris en 1692 [http://data.bnf.fr/ark:/12148/cb16650697x#foaf:Person]
</ud>
<ud>
Le Demaine Godalles (<dat when="1651">1651</dat>) Hydrographe, Ingénieur du roi et professeur de Mathématiques, Architecte [http://data.bnf.fr/ark:/12148/cb15375819n#foaf:Person]
</ud>
<ud>
Philip Lea (<dat when="1651">1651</dat>) Cartographe, fabricant et éditeur de globes, de cartes, d''instruments de mathématiques, actif de 1666 à 1700 à Londres [http://data.bnf.fr/ark:/12148/cb15328427v#foaf:Person]
</ud>
<ud>
René Gaultier de Maignannes (<dat when="1651">1651</dat>) <en ref="16" >Mathématicien</en> angevin. - Spécialiste de la perspective [http://data.bnf.fr/ark:/12148/cb12536157m#foaf:Person]
</ud>
<ud>
David François de Merveilleux (<dat when="1652">1652</dat>) <en ref="29" >Géographe</en> et cartographe. Connaissances mathématiques étendues (il publie un traîté d''arithmétique et de géométrie). En 1695 il entre au service de Guillaume III qui lui accorde le brevet de Capitaine Ingénieur au service d''Angleterre et des Etats généraux [http://data.bnf.fr/ark:/12148/cb15304894q#foaf:Person]
</ud>
<ud>
Michel Rolle (Ambert (Puy-de-Dôme), <dat when="1652">1652</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb130110121#foaf:Person]
</ud>
<ud>
Nicolas Bion (<dat when="1652">1652</dat>) Ingénieur du roi pour les instruments de mathématique. - Avait un atelier à Paris, quai de l''Horloge, qui était l''un des mieux achalandés du temps. - Son "Usage des globes" connut 6 éditions entre 1699 et 1751. - Édita en 1694 le globe terrestre de P. Courtin (diam. 25 cm) et en 1712 une paire de globes de même diamètre, un globe céleste antérieur à 1710 atteignit 32 cm de diamètre [http://data.bnf.fr/ark:/12148/cb152909089#foaf:Person]
</ud>
<ud>
José Chaffrion (<dat when="1653">1653</dat>) Cartographe et <en ref="16" >mathématicien</en> de Valence en Espagne [http://data.bnf.fr/ark:/12148/cb15330290b#foaf:Person]
</ud>
<ud>
Bernard Nieuwentijt (West Graftdijk, Pays-Bas, <dat when="1654">1654</dat>) <en ref="18" >Philosophe</en>, <en ref="28" >médecin</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb14587835s#foaf:Person]
</ud>
<ud>
Jacques Bernoulli (<en type="li">Bâle, Suisse</en>, <dat when="1654">1654</dat>) <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en>. - Professeur de mathématiques à l''université de Bâle, Suisse [http://data.bnf.fr/ark:/12148/cb120751142#foaf:Person]
</ud>
<ud>
Jean Pigeon (<en type="li">Donzy (Nièvre)</en>, <dat when="1654">1654</dat>) Peintre, <en ref="16" >mathématicien</en> et facteur de globes, <en ref="29" >géographe</en> du Duc d''Orléans à partir de 1714 [http://data.bnf.fr/ark:/12148/cb15147433m#foaf:Person]
</ud>
<ud>
Jean-François Gerbillon (<dat when="1654">1654</dat>) Jésuite. - <en ref="16" >Mathématicien</en>, fut envoyé en Chine par Louis XIV en 1685. - Écrivit des traités de géométrie et de l''usage de l''astrolabe en chinois et en tartare. - Supérieur général de la Mission française de Chine [http://data.bnf.fr/ark:/12148/cb124622770#foaf:Person]
</ud>
<ud>
Philippe Avril (<en type="li">Angoulême (Charente)</en>, <dat when="1654">1654</dat>) Missionnaire. - Voyageur, jésuite dès 1670, il enseigna les mathématiques à Louis-le-Grand. - Chercha un nouveau passage vers la Chine par la Tartarie, le Kurdistan et l''Arménie [http://data.bnf.fr/ark:/12148/cb15327596q#foaf:Person]
</ud>
<ud>
Philippe Naudé (<en type="li">Metz</en>, <dat when="1654">1654</dat>) Théologien et <en ref="16" >mathématicien</en>. - Se réfugia en Prusse après la révocation de l''Édit de Nantes [http://data.bnf.fr/ark:/12148/cb10366497p#foaf:Person]
</ud>
<ud>
Pierre Varignon (<en type="li">Caen (Calvados)</en>, <dat when="1654">1654</dat>) <en ref="16" >Mathématicien</en>. - Jésuite. - Membre de l''Académie des sciences, il entre au collège de France en 1704 [http://data.bnf.fr/ark:/12148/cb121123302#foaf:Person]
</ud>
<ud>
Louis Lecomte (<dat when="1655">1655</dat>) Jésuite. - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12151496v#foaf:Person]
</ud>
<ud>
Simon Tyssot de Patot (<en type="li">Londres</en>, <dat when="1655">1655</dat>) Professeur ordinaire de mathématiques à l''École illustre de Deventer (1699-1727 ; professeur extraordinaire dès 1690). - Vécut en France de 1658 environ à 1664, puis aux Pays-Bas [http://data.bnf.fr/ark:/12148/cb11927303t#foaf:Person]
</ud>
<ud>
Claude de Visdelou (Erquy (Côtes-d''Armor), <dat when="1656">1656</dat>) Jésuite. - <en ref="16" >Mathématicien</en>. - Missionnaire en Chine. - Évèque titulaire de de Claudiopolis-en-Isaurie (à partir de 1708/1709). - Vicaire apostolique du Koueitchéou et du Yunnan, et administrateu du Houkouang (de 1708 à 1709) [http://data.bnf.fr/ark:/12148/cb150791582#foaf:Person]
</ud>
<ud>
Edmund Halley (<dat when="1656">1656</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb119960783#foaf:Person]
</ud>
<ud>
Nicolaas Hartsoeker (Gouda (Pays-Bas), <dat when="1656">1656</dat>) Physicien, micrographe et <en ref="28" >médecin</en>. - Apporta des perfectionnements importants à la fabrication des verres de lunettes astronomiques, découvrit les animalcules spermatiques [http://data.bnf.fr/ark:/12148/cb13010358x#foaf:Person]
</ud>
<ud>
William Molyneux (<en type="li">Dublin</en>, <dat when="1656">1656</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en>, physicien et <en ref="18" >philosophe</en>. - Premier secrétaire de la Société philosophique de Dublin (en 1684) [http://data.bnf.fr/ark:/12148/cb124596616#foaf:Person]
</ud>
<ud>
Jean-Mathieu de Chazelles (<en type="li">Lyon</en>, <dat when="1657">1657</dat>) Cartographe, <en ref="29" >géographe</en> et <en ref="24" >astronome</en> associé à l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb106281104#foaf:Person]
</ud>
<ud>
Jean-Matthieu de Chazelles (<en type="li">Lyon</en>, <dat when="1657">1657</dat>) Fit ses études chez les jésuites et devint l''auxiliaire de Cassini I. Fut associé aux travaux géodésiques menés par l''Académie des sciences. Dessina le planisphère de l''Observatoire. Collabora au Neptune françois. Associé <en ref="24" >astronome</en> de l''Académie des sciences en 1695; associé mécanicien en 1699. Professeur d''hydrographie à Marseille [http://data.bnf.fr/ark:/12148/cb15304334g#foaf:Person]
</ud>
<ud>
Joseph Saurin (<en type="li">Courthézon (Vaucluse)</en>, <dat when="1659">1659</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb10330722j#foaf:Person]
</ud>
<ud>
Philippe Desplaces (<dat when="1659">1659</dat>) <en ref="24" >Astronome</en>. - Auteur d''éphémérides [http://data.bnf.fr/ark:/12148/cb12223720g#foaf:Person]
</ud>
<ud>
Louis Feuillée (Mane (Alpes-de-Haute-Provence), <dat when="1660">1660</dat>) <en ref="24" >Astronome</en> et botaniste. - Religieux de l''ordre des Minimes. - Initié à la botanique par le P. Plumier. Correspondant <en ref="24" >astronome</en> de l''Académie des sciences, il obtient une mission dans le Levant. Revenu à Marseille en 1702, il embarque l''année suivante pour les Antilles et parvient à Carthagène en 1704. Nommé <en ref="16" >mathématicien</en> du roi, il s''embarque pour l''Amérique du Sud en 1707. En 1724, il est chargé de déterminer la position exacte de l''île de Fer [http://data.bnf.fr/ark:/12148/cb15309142r#foaf:Person]
</ud>
<ud>
Thomas Fantet de Lagny (<en type="li">Lyon (Rhône)</en>, <dat when="1660">1660</dat>) <en ref="16" >Mathématicien</en>. - Professeur [http://data.bnf.fr/ark:/12148/cb14548143w#foaf:Person]
</ud>
<ud>
Guillaume-François-Antoine de L''Hospital (<dat when="1661">1661</dat>) Marquis de Sainte-Mesme. - <en ref="16" >Mathématicien</en>, membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb12000655c#foaf:Person]
</ud>
<ud>
Francesco Bianchini (<en type="li">Vérone, Italie</en>, <dat when="1662">1662</dat>) Théologien, historien, <en ref="24" >astronome</en> et physicien [http://data.bnf.fr/ark:/12148/cb12452255g#foaf:Person]
</ud>
<ud>
Paolo Mattia Doria (<dat when="1662">1662</dat>) <en ref="18" >Philosophe</en> et <en ref="16" >mathématicien</en> italien [http://data.bnf.fr/ark:/12148/cb121118306#foaf:Person]
</ud>
<ud>
Jean-Pierre de Crousaz (<dat when="1663">1663</dat>) Professeur de philosophie et mathématiques à Lausanne et Groningue. - Conseiller de la légation de Suède en Hollande. - Membre des Académies de Bordeaux et Paris [http://data.bnf.fr/ark:/12148/cb12016566d#foaf:Person]
</ud>
<ud>
Johann Balthasar Lauterbach (<dat when="1663">1663</dat>) <en ref="16" >Mathématicien</en> et architecte allemand [http://data.bnf.fr/ark:/12148/cb137778333#foaf:Person]
</ud>
<ud>
John Craig (<dat when="1663">1663</dat>) <en ref="16" >Mathématicien</en> et théologien écossais [http://data.bnf.fr/ark:/12148/cb114408210#foaf:Person]
</ud>
<ud>
Katahiro Takebe (<dat when="1664">1664</dat>) <en ref="16" >Mathématicien</en> japonais [http://data.bnf.fr/ark:/12148/cb12443517s#foaf:Person]
</ud>
<ud>
Lothar Zumbach von Coesfeld (<en type="li">Trèves (Allemagne)</en>, <dat when="1664">1664</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en>, <en ref="28" >médecin</en>, musicien. - <en ref="16" >Mathématicien</en> et musicien de l''électeur de Trèves (1685-1688). - Lecteur en astronomie à l''université de Leyde. - Professeur de mathématiques au Carolinum de Kassel [http://data.bnf.fr/ark:/12148/cb14853628w#foaf:Person]
</ud>
<ud>
Abraham de Moivre (Vitry-le-François (<en type="li">Marne)</en>, <dat when="1667">1667</dat>) <en ref="16" >Mathématicien</en>. - Émigra en Grande-Bretagne après la révocation de l''Édit de Nantes (en 1686). - Membre de la Royal Society, de l''Académie de Berlin et de l''Académie de Saint-Pétersbourg [http://data.bnf.fr/ark:/12148/cb130110001#foaf:Person]
</ud>
<ud>
Girolamo Saccheri (<en type="li">San Remo, Italie</en>, <dat when="1667">1667</dat>) Jésuite. - Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb13164455b#foaf:Person]
</ud>
<ud>
Johann Bernoulli (<en type="li">Bâle, Suisse</en>, <dat when="1667">1667</dat>) <en ref="16" >Mathématicien</en> et physicien, maître d''Euler, professeur à l''Université de Groningue puis à l''Université de Bâle. - A travaillé sur le calcul différentiel, intégral et exponentiel. - Également auteur de traités de médecine, fondateur de la théorie mécanico-physique de la fermentation [http://data.bnf.fr/ark:/12148/cb122991692#foaf:Person]
</ud>
<ud>
William Whiston (Norton-juxta-Twycross (G. B.), <dat when="1667">1667</dat>) Théologien et <en ref="24" >astronome</en>. - Professeur de mathématiques à Cambridge, d''où il fut exclu pour ses écrits théologiques. - Traducteur de Flavius Josèphe [http://data.bnf.fr/ark:/12148/cb11997914k#foaf:Person]
</ud>
<ud>
Guillaume Bonjour (Toulouse (Haute-Garonne), <dat when="1669">1669</dat>) Augustin. - Missionnaire en Chine. - Orientaliste, <en ref="24" >astronome</en> et cartographe [http://data.bnf.fr/ark:/12148/cb13613529n#foaf:Person]
</ud>
<ud>
Leonhard Christoph Sturm (<en type="li">Aldorf, Allemagne</en>, <dat when="1669">1669</dat>) <en ref="16" >Mathématicien</en>. - Architecte [http://data.bnf.fr/ark:/12148/cb143383238#foaf:Person]
</ud>
<ud>
Jean Terrasson (<en type="li">Lyon</en>, <dat when="1670">1670</dat>) Oratorien, <en ref="16" >mathématicien</en> et <en ref="18" >philosophe</en>. - Professeur de grec et latin au Collège de France. - Membre de l''Institut, Académie Française (élu en 1732) [http://data.bnf.fr/ark:/12148/cb119262217#foaf:Person]
</ud>
<ud>
Guido Grandi (<en type="li">Crémone, Italie</en>, <dat when="1671">1671</dat>) <en ref="16" >Mathématicien</en>, théologien, biographe, antiquaire et poète. - Soutint Descartes contre l''aristotélisme. - Professeur de philosophie à l''Université de Pise. - Fut en correspondance avec Leibniz, Newton, Bernoulli. - Intendant général des eaux en Toscane [http://data.bnf.fr/ark:/12148/cb121384290#foaf:Person]
</ud>
<ud>
Johann Gabriel Doppelmayr (<dat when="1671">1671</dat>) Fils d''un riche négociant qui s''occupait de physique, et destiné d''abord à l''étude du droit, il la quitta pour celle des mathématiques et voyagea jusqu''en 1702. Professeur à Nuremberg et membre de la Royal Society de Londres [http://data.bnf.fr/ark:/12148/cb15327296w#foaf:Person]
</ud>
<ud>
Johann Gabriel Doppelmayr (<dat when="1671">1671</dat>) <en ref="16" >Mathématicien</en>. - Membre de la Royal Society de Londres (<dat when="1713">1713</dat>) [http://data.bnf.fr/ark:/12148/cb12158680q#foaf:Person]
</ud>
<ud>
Johann Gabriel Doppelmayr (<dat when="1671">1671</dat>) <en ref="24" >Astronome</en> et cartographe ayant véçu à Nuremberg, né en 1671 ou 1677 [http://data.bnf.fr/ark:/12148/cb15327296w#foaf:Person]
</ud>
<ud>
Johann Heinrich Müller (<dat when="1671">1671</dat>) Physicien, <en ref="24" >astronome</en>, <en ref="16" >mathématicien</en>. - Professeur à l''université d''Altdorf (Allemagne) [http://data.bnf.fr/ark:/12148/cb10706008k#foaf:Person]
</ud>
<ud>
John Keill (<dat when="1671">1671</dat>) <en ref="16" >Mathématicien</en> écossais. - Professeur d''astronomie à Oxford [http://data.bnf.fr/ark:/12148/cb123670586#foaf:Person]
</ud>
<ud>
Étienne-Simon de Gamaches (<dat when="1672">1672</dat>) <en ref="24" >Astronome</en> et moraliste. - Chanoine de Sainte Croix de La Bretonnerie. - Membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb12004341t#foaf:Person]
</ud>
<ud>
Johann Jacob Scheuchzer (<en type="li">Zürich</en>, <dat when="1672">1672</dat>) <en ref="28" >Médecin</en>, naturaliste, historien, archéologue, numismate, <en ref="24" >astronome</en> et physicien [http://data.bnf.fr/ark:/12148/cb123955592#foaf:Person]
</ud>
<ud>
Eustachio Manfredi (<dat when="1674">1674</dat>) <en ref="24" >Astronome</en>. - Poète. - Fondateur de l''Académie de Bologne [http://data.bnf.fr/ark:/12148/cb12202194q#foaf:Person]
</ud>
<ud>
Julien Mahuet (<dat when="1674">1674</dat>) Jésuite. - Né à Reims. Entre au noviciat le 24 août 1692. Enseigne les humanités à Reims, la rhétorique à Metz et les mathématiques à Reims. - Écrit du théâtre pour le Collège de Reims [http://data.bnf.fr/ark:/12148/cb13165624v#foaf:Person]
</ud>
<ud>
Guillaume Delisle (<dat when="1675">1675</dat>) Cartographe. - Fils de Claude Delisle, fut l''élève de Jean-Dominique Cassini. Élève <en ref="24" >astronome</en> à l''Académie des sciences en 1702, il en devint membre en 1718 ; enseigna la géographie au jeune Louis XV et fut nommé premier <en ref="29" >géographe</en> du roi ; produisit quelque 100 cartes qu''il édita lui-même [http://data.bnf.fr/ark:/12148/cb15238363g#foaf:Person]
</ud>
<ud>
Humphry Ditton (Salisbury (G. B.), <dat when="1675">1675</dat>) <en ref="16" >Mathématicien</en> et théologien [http://data.bnf.fr/ark:/12148/cb15994181b#foaf:Person]
</ud>
<ud>
Yves-Marie André (<dat when="1675">1675</dat>) Jésuite. - Professeur de mathématiques à Caen [http://data.bnf.fr/ark:/12148/cb12180932c#foaf:Person]
</ud>
<ud>
Jacopo Francesco Riccati (<dat when="1676">1676</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb120689750#foaf:Person]
</ud>
<ud>
Gabriel Philippe de La Hire (<en type="li">Paris</en>, <dat when="1677">1677</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb106522995#foaf:Person]
</ud>
<ud>
Jacques Cassini (<en type="li">Paris</en>, <dat when="1677">1677</dat>) Fils de Jean-Dominique Cassini et père de César-François Cassini de Thury. Associé <en ref="24" >astronome</en> à l''Académie des sciences en 1699, pensionnaire en 1712. En 1700 participa à la mesure de la méridienne de l''Observatoire et y travailla jusqu''à son achèvement en 1718. En 1706 maître ordinaire à la Chambre des comptes. Etudia les planètes et leurs satellites. Soutint la thèse de l''allongement de la Terre aux pôles. [http://data.bnf.fr/ark:/12148/cb15238366h#foaf:Person]
</ud>
<ud>
Joseph Privat de Molières (Tarascon (ouches-du-Rhône), <dat when="1677">1677</dat>) Physicien et <en ref="16" >mathématicien</en>. - Oratorien (vers 1709). - Professeur au collège royal (<dat when="1723">1723</dat>). - Adjoint (<dat when="1721">1721</dat>) puis associé (<dat when="1729">1729</dat>) de l''Académie royale des sciences [http://data.bnf.fr/ark:/12148/cb145391041#foaf:Person]
</ud>
<ud>
Gerard Keulen (<dat when="1678">1678</dat>) Graveur, cartographe, <en ref="16" >mathématicien</en> et éditeur. - Fils de Johannes van Keulen [http://data.bnf.fr/ark:/12148/cb15332761m#foaf:Person]
</ud>
<ud>
Jacob Hermann (<dat when="1678">1678</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12319998c#foaf:Person]
</ud>
<ud>
Jean-Jacques Dortous de Mairan (<en type="li">Béziers</en>, <dat when="1678">1678</dat>) Physicien et <en ref="16" >mathématicien</en>. - Membre puis secrétaire perpétuel de l''Académie des sciences. - Membre de l''Académie française (élu en 1743) [http://data.bnf.fr/ark:/12148/cb12395086k#foaf:Person]
</ud>
<ud>
Louis Bourguet (<en type="li">Nïmes</en>, <dat when="1678">1678</dat>) Professeur de philosophie et de mathématiques à Neuchâtel. - Est l''un des fondateurs de la "Bibliothèque italique" (1728-) et du "Mercure suisse" (1732-). - Naturalisé Neuchâtelois en 1710 [http://data.bnf.fr/ark:/12148/cb12797692b#foaf:Person]
</ud>
<ud>
Pierre Rémond de Montmort (<en type="li">Paris</en>, <dat when="1678">1678</dat>) <en ref="16" >Mathématicien</en>. - Spécialiste de probabilités [http://data.bnf.fr/ark:/12148/cb12391046c#foaf:Person]
</ud>
<ud>
Bernardino Zendrini (<en type="li">Saviore, Italie</en>, <dat when="1679">1679</dat>) <en ref="28" >Médecin</en>. - <en ref="16" >Mathématicien</en>. - Hydraulicien [http://data.bnf.fr/ark:/12148/cb13545066d#foaf:Person]
</ud>
<ud>
Christian Wolff (<en type="li">Breslau, Silésie (Wrocław, Pologne)</en>, <dat when="1679">1679</dat>) Juriste, <en ref="16" >mathématicien</en> et <en ref="18" >philosophe</en> [http://data.bnf.fr/ark:/12148/cb121387859#foaf:Person]
</ud>
<ud>
Firmin Abauzit (<en type="li">Uzès</en>, <dat when="1679">1679</dat>) <en ref="16" >Mathématicien</en>, <en ref="18" >philosophe</en> et bibliothécaire. - Fut bibliothécaire à la Bibliothèque de Genève. - Vécut à Genève après la révocation de l''Édit de Nantes [http://data.bnf.fr/ark:/12148/cb121711117#foaf:Person]
</ud>
<ud>
Claude Richer (<dat when="1680">1680</dat>) Abbé. - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12532604f#foaf:Person]
</ud>
<ud>
Pierre Jartoux (<dat when="1680">1680</dat>) <en ref="24" >Astronome</en> et missionnaire jésuite en Chine [http://data.bnf.fr/ark:/12148/cb15367486z#foaf:Person]
</ud>
<ud>
Paolino Chelucci (<en type="li">Lucca, Italie</en>, <dat when="1681">1681</dat>) Professeur d''éloquence à l''Université de Rome. - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb104300443#foaf:Person]
</ud>
<ud>
Roger Cotes (<en type="li">Burbage (Leicestershire)</en>, <dat when="1682">1682</dat>) <en ref="16" >Mathématicien</en>. - Professeur d''astronomie et de philosophie expérimentale au Trinity College, Cambridge (1707-). - A édité la seconde édition des "Principia" de Newton [http://data.bnf.fr/ark:/12148/cb123946202#foaf:Person]
</ud>
<ud>
Noël Regnault (<dat when="1683">1683</dat>) Jésuite. - Professeur de mathématiques et physique au collège de Paris [http://data.bnf.fr/ark:/12148/cb12218681d#foaf:Person]
</ud>
<ud>
Johann Matthias Hase (<dat when="1684">1684</dat>) <en ref="29" >Géographe</en> et cartographe ; historien. - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb13007561v#foaf:Person]
</ud>
<ud>
Brook Taylor (<dat when="1685">1685</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12315365s#foaf:Person]
</ud>
<ud>
Giovanni Poleni (<en type="li">Venise, Italie</en>, <dat when="1685">1685</dat>) Physicien, <en ref="16" >mathématicien</en> et archéologue [http://data.bnf.fr/ark:/12148/cb12161210z#foaf:Person]
</ud>
<ud>
Jean-Edme Gallimard (<en type="li">Paris</en>, <dat when="1685">1685</dat>) Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb120827146#foaf:Person]
</ud>
<ud>
Jai Singh (<en type="li">Amber (Rajasthan, Inde)</en>, <dat when="1686">1686</dat>) Mahārāja de Jaipur (Rajasthan, Inde) de 1699 à 1743. - Fondateur de la ville de Jaipur (en 1727). - Chef du clan rajput des Kachhwa. - Bâtisseur de cinq observatoires astronomiques (yantra) dans l''Inde du Nord, à Delhi, Jaipur, Mathura, Varanasi et Ujjain. - Publia des tables astronomiques. - Les dates biographiques (1688-1743) sont aussi parfois retenues [http://data.bnf.fr/ark:/12148/cb16578505b#foaf:Person]
</ud>
<ud>
Nicolas Bernoulli (<dat when="1687">1687</dat>) <en ref="16" >Mathématicien</en> et juriste suisse [http://data.bnf.fr/ark:/12148/cb13510346s#foaf:Person]
</ud>
<ud>
Robert Simson (<dat when="1687">1687</dat>) <en ref="16" >Mathématicien</en>. - A été professeur à l''Université de Glasgow, GB [http://data.bnf.fr/ark:/12148/cb12399224j#foaf:Person]
</ud>
<ud>
Joseph-Nicolas Delisle (<en type="li">Paris</en>, <dat when="1688">1688</dat>) <en ref="24" >Astronome</en>. - Il reçut l''enseignement de Cassini II. - Professeur de mathématiques au Collège de France et <en ref="29" >géographe</en> de la marine. - Membre de l''Institut, Académie des sciences (<dat when="1714">1714</dat>). - Fondateur de l''École d''astronomie de Saint-Pétersbourg (à partir de 1725), a séjourné en Russie jusqu''en 1747 [http://data.bnf.fr/ark:/12148/cb12150746w#foaf:Person]
</ud>
<ud>
Louis-Bertrand Castel (<en type="li">Montpellier</en>, <dat when="1688">1688</dat>) Jésuite (<dat when="1703">1703</dat>). - <en ref="18" >Philosophe</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12462543h#foaf:Person]
</ud>
<ud>
Pierre Brumoy (<en type="li">Rouen</en>, <dat when="1688">1688</dat>) Jésuite en 1704. - Professeur de rhétorique à Caen, précepteur du prince de Talmont, professeur de mathématiques au collège de Louis-le-Grand à Paris. - Collabore au Journal de Trévoux de 1722 à 1739. - Littérateur [http://data.bnf.fr/ark:/12148/cb12069382v#foaf:Person]
</ud>
<ud>
Willem Jacob''s Gravesande (<dat when="1688">1688</dat>) Physicien. - <en ref="18" >Philosophe</en>. - Professeur de mathématique et astronomie à Leyde, Pays-Bas. - Éditeur du "Journal littéraire de la Haye", devenu "Journal de la République des Lettres" [http://data.bnf.fr/ark:/12148/cb12218384m#foaf:Person]
</ud>
<ud>
Antoine Gaubil (<en type="li">Gaillac (Aveyron)</en>, <dat when="1689">1689</dat>) Jésuite et missionnaire en Chine. - Établit un observatoire à Pékin, dans la résidence française. - Écrit sur l''astronomie, la géographie, l''histoire et la littérature de la Chine [http://data.bnf.fr/ark:/12148/cb12150997b#foaf:Person]
</ud>
<ud>
Giovanni Gaetano Bottari (<en type="li">Rome</en>, <dat when="1689">1689</dat>) Savant prélat. - A étudié les langues et la littérature de l''Antiquité, les mathématiques, la philosophie et la théologie. - Membre de l''Académie della Crusca. - Conservateur de la bibliothèque du Vatican [http://data.bnf.fr/ark:/12148/cb12516784r#foaf:Person]
</ud>
<ud>
Robert Smith (<en type="li">Lea, GB</en>, <dat when="1689">1689</dat>) Professeur de mathématiques et de philosophie naturelle à Cambridge [http://data.bnf.fr/ark:/12148/cb15075770m#foaf:Person]
</ud>
<ud>
Christian Goldbach (<dat when="1690">1690</dat>) <en ref="16" >Mathématicien</en> allemand [http://data.bnf.fr/ark:/12148/cb124384045#foaf:Person]
</ud>
<ud>
Johann Friedrich Weidler (Gros-Neuhausen, Allemagne, <dat when="1691">1691</dat>) <en ref="26" >Écrivain</en>, <en ref="16" >mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb151541516#foaf:Person]
</ud>
<ud>
Esprit Pezenas (<en type="li">Avignon</en>, <dat when="1692">1692</dat>) Jésuite. - <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en>. - Professeur d''hydrographie à Marseille et directeur de l''Observatoire de Marseille (<dat when="1749">1749</dat>) [http://data.bnf.fr/ark:/12148/cb12120600p#foaf:Person]
</ud>
<ud>
James Stirling (<en type="li">Garden, GB</en>, <dat when="1692">1692</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb13475586v#foaf:Person]
</ud>
<ud>
Petrus Van Musschenbroek (<dat when="1692">1692</dat>) Physicien, docteur en médecine et en philosophie. - Fut l''inventeur de la pyrométrie. - Fut professeur de philosophie naturelle, de mathématiques et d''astronomie à l''Université d''Utrecht, puis professeur à Leiden [http://data.bnf.fr/ark:/12148/cb13475113j#foaf:Person]
</ud>
<ud>
Diego de Torres Villarroel (<dat when="1693">1693</dat>) Prêtre catholique. - Homme de lettres. - Professeur de mathématiques à l''université de Salamanque [http://data.bnf.fr/ark:/12148/cb119268467#foaf:Person]
</ud>
<ud>
Giovanni Bianchi (<en type="li">Rimini (Italie)</en>, <dat when="1693">1693</dat>) <en ref="28" >Médecin</en>. - Professeur d''anatomie à l''Université de Sienne (1741-). - Auteur d''ouvrages médicaux, archéologiques, astronomiques, etc. [http://data.bnf.fr/ark:/12148/cb10649342z#foaf:Person]
</ud>
<ud>
Christfried Kirch (<dat when="1694">1694</dat>) <en ref="24" >Astronome</en> allemand. - Il succéda à son père Gottfried (1639-1710) dans la direction de l''Observatoire royal de Prusse (1716-1740). - Membre de l''Académie des sciences de Berlin (<dat when="1716">1716</dat>) et associé de celles de Paris (<dat when="1723">1723</dat>) et de Saint-Pétersbourg [http://data.bnf.fr/ark:/12148/cb12648455m#foaf:Person]
</ud>
<ud>
Dominique-François Rivard (<dat when="1697">1697</dat>) <en ref="16" >Mathématicien</en>. - <en ref="18" >Philosophe</en>. - Professeur au collège de Beauvais [http://data.bnf.fr/ark:/12148/cb119220838#foaf:Person]
</ud>
<ud>
Abbé Deidier (<en type="li">Marseille</en>, <dat when="1698">1698</dat>) Abbé. - <en ref="16" >Mathématicien</en>. - Professeur d''artillerie à l''Ecole militaire de La Fère [http://data.bnf.fr/ark:/12148/cb102670411#foaf:Person]
</ud>
<ud>
Colin MacLaurin (<en type="li">Kilmodan, GB</en>, <dat when="1698">1698</dat>) <en ref="16" >Mathématicien</en> et physicien [http://data.bnf.fr/ark:/12148/cb12534513m#foaf:Person]
</ud>
<ud>
Pierre-Louis Moreau de Maupertuis (Saint-Malo, Ille-et-Villaine, <dat when="1698">1698</dat>) <en ref="18" >Philosophe</en>, <en ref="24" >astronome</en> et physicien. - Fut invité par Frédéric II à réorganiser puis présider l''Académie de Berlin. - Ami puis ennemi de Voltaire, qui écrivit contre lui "Micromégas". - Membre de l''Académie française (élu en 1743) [http://data.bnf.fr/ark:/12148/cb11915229j#foaf:Person]
</ud>
<ud>
Charles-Étienne-Louis Camus (Crécy-en-Brie (Seine-et-Marne), <dat when="1699">1699</dat>) <en ref="16" >Mathématicien</en>. - <en ref="24" >Astronome</en>. - Participa à l''expédition de 1736 en Laponie. - Membre de l''Académie des sciences (<dat when="1727">1727</dat>) et de l''Académie d''architecture (<dat when="1739">1739</dat>) [http://data.bnf.fr/ark:/12148/cb12181030f#foaf:Person]
</ud>
<ud>
Johann Ludwig Levin Gebhardi (<en type="li">Braunschweig, Allemagne</en>, <dat when="1699">1699</dat>) Historien, professeur de philologie à l''académie équestre de Lüneburg (<dat when="1723">1723</dat>). - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb143273694#foaf:Person]
</ud>
<ud>
Daniel Bernoulli (Groningue (Pays-Bas), <dat when="1700">1700</dat>) <en ref="16" >Mathématicien</en>, physicien et <en ref="24" >astronome</en>. - Fut professeur à Saint-Petersbourg (1725-1733) et à Bâle (1733-) [http://data.bnf.fr/ark:/12148/cb122991859#foaf:Person]
</ud>
<ud>
Sámuel Mikoviny (<en type="li">Ábelfalva, aujourd''hui Ábelová, Slovaquie</en>, <dat when="1700">1700</dat>) Cartographe. - Officier du génie. - Spécialiste en hydraulique. - <en ref="16" >Mathématicien</en>. - Disciple de Bél Mátyás (1684-1749). - Études à Jena et à Nuremberg, Allemagne [http://data.bnf.fr/ark:/12148/cb103650124#foaf:Person]
</ud>
<ud>
Anders Celsius (<dat when="1701">1701</dat>) <en ref="24" >Astronome</en> et naturaliste. - Professeur d''astronomie à l''université d''Uppsala (<dat when="1730">1730</dat>) [http://data.bnf.fr/ark:/12148/cb14606035v#foaf:Person]
</ud>
<ud>
Charles-Marie de La Condamine (<en type="li">Paris</en>, <dat when="1701">1701</dat>) Savant. - <en ref="24" >Astronome</en>. - <en ref="29" >Géographe</en>. Mesura l''arc du Méridien avec Godin et Bouguer. - Membre de l''Académie française (élu en 1760) [http://data.bnf.fr/ark:/12148/cb119102567#foaf:Person]
</ud>
<ud>
Georg Wolfgang Krafft (<en type="li">Tuttlingen (Allemagne)</en>, <dat when="1701">1701</dat>) Physicien, professeur de mathématiques et de physique [http://data.bnf.fr/ark:/12148/cb10587905k#foaf:Person]
</ud>
<ud>
Johannes Nicolaus Frobesius (<en type="li">Goslar, Allemagne</en>, <dat when="1701">1701</dat>) <en ref="16" >Mathématicien</en> et professeur de philosophie [http://data.bnf.fr/ark:/12148/cb12355199c#foaf:Person]
</ud>
<ud>
Niccolò de Martino (<dat when="1701">1701</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb16265590z#foaf:Person]
</ud>
<ud>
Johann Lorenz Schmidt (<dat when="1702">1702</dat>) Fils de pasteur, a étudié la théologie et s''est intéressé à la  philosophie et aux mathématiques. - A publié en 1735 une traduction annotée de la première partie de la Bible, les cinq livres de Moïse (ou Torah ou Pentateuque), connue sous le nom de "Wertheimer Bible", laquelle a été censurée par l''empereur [http://data.bnf.fr/ark:/12148/cb150701237#foaf:Person]
</ud>
<ud>
Antoine Deparcieux (<dat when="1703">1703</dat>) <en ref="16" >Mathématicien</en> et statisticien. - Fut constructeur de cadrans solaires et inventeur de machines pour élever les eaux et de presse pour le tabac. - Membre de l''Académie des sciences (<dat when="1746">1746</dat>) [http://data.bnf.fr/ark:/12148/cb121904326#foaf:Person]
</ud>
<ud>
Bernard-Laurent Soumille (<dat when="1703">1703</dat>) <en ref="16" >Mathématicien</en>, physicien et agronome. - Prêtre-bénéficier du chapitre de Villeneuve-lès-Avignon (à partir de 1736, environ). - Correspondant de l''Académie royale des sciences de Paris [http://data.bnf.fr/ark:/12148/cb130919156#foaf:Person]
</ud>
<ud>
Thomas Le Seur (<dat when="1703">1703</dat>) Franciscain. - Professeur de mathématique à l''Université de la Sapience (Rome) [http://data.bnf.fr/ark:/12148/cb155933751#foaf:Person]
</ud>
<ud>
Gabriel Cramer (<en type="li">Genève, Suisse</en>, <dat when="1704">1704</dat>) Professeur de philosophie et de mathématiques des Académies et Sociétés royales de Londres, de Berlin, de Montpellier, de Lyon et de l''Académie de l''Institut de Bologne [http://data.bnf.fr/ark:/12148/cb15006804w#foaf:Person]
</ud>
<ud>
Guillaume Le Blond (<en type="li">Paris</en>, <dat when="1704">1704</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb14330967m#foaf:Person]
</ud>
<ud>
Henri Michel Sauvage (<en type="li">Verdun</en>, <dat when="1704">1704</dat>) Jésuite. - Professeur d''humanités, de mathématiques et de philosophie [http://data.bnf.fr/ark:/12148/cb16180102s#foaf:Person]
</ud>
<ud>
Jacopo Belgrado (<dat when="1704">1704</dat>) Jésuite. - Physicien, <en ref="16" >mathématicien</en> et archéologue [http://data.bnf.fr/ark:/12148/cb12161284h#foaf:Person]
</ud>
<ud>
Johann Andreas von Segner (<dat when="1704">1704</dat>) Naturaliste, <en ref="16" >mathématicien</en>, <en ref="28" >médecin</en>, logicien, <en ref="18" >philosophe</en>. - Né à Presbourg (l''actuelle Bratislava), il fit toute sa carrière en Allemagne (à Iéna, Göttingen, Halle notamment) [http://data.bnf.fr/ark:/12148/cb12316478n#foaf:Person]
</ud>
<ud>
Louis Godin (<en type="li">Paris</en>, <dat when="1704">1704</dat>) <en ref="24" >Astronome</en>, membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb15004534h#foaf:Person]
</ud>
<ud>
John Nourse (<dat when="1705">1705</dat>) Variante(s) de prénom : Jean. - Libraire ; libraire (ordinaire) de Sa Majesté (<dat when="1762">1762</dat>) ; libraire de la "Society for the Encouragement of learning". - Baptisé à Oxford le 8 juillet 1705 ; fils d''un chirurgien. En apprentissage chez le libraire de Londres John I Osborne d''août 1722 à oct. 1729. Établi vers 1730. Succède au libraire William Mears après lui avoir été associé. Spécialiste des publications scientifiques, particulièrement de mathématiques, et des éditions étrangères, de <en ref="18" >philosophe</en>s notamment. Séjourne à Paris en 1780. Décédé à Kensington en avril 1765. Son frère Charles Nourse puis Francis Wingrave lui succèdent [http://data.bnf.fr/ark:/12148/cb13605346z#foaf:Person]
</ud>
<ud>
Edme-Gilles Guyot (<en type="li">Paris</en>, <dat when="1706">1706</dat>) Les ouvrages "Nouvelles récréations physiques et mathématiques" et "Essai sur la construction des ballons aérostatiques et sur la manière de les diriger" lui sont attribués par Hoefer et Quérard. - DBF et Michaud soulignent la confusion entre lui et Guillaume-Germain Guyot pour l''attribution de ces ouvrages [http://data.bnf.fr/ark:/12148/cb14651894d#foaf:Person]
</ud>
<ud>
Girolamo Settimo (<dat when="1706">1706</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb162655930#foaf:Person]
</ud>
<ud>
Giuseppe Maria Asclepi (<dat when="1706">1706</dat>) Jésuite, enseigna les mathématiques et les humanités [http://data.bnf.fr/ark:/12148/cb12240755t#foaf:Person]
</ud>
<ud>
Benjamin Robins (<en type="li">Bath, GB</en>, <dat when="1707">1707</dat>) <en ref="16" >Mathématicien</en> et ingénieur militaire. - Pamphlétaire [http://data.bnf.fr/ark:/12148/cb121289860#foaf:Person]
</ud>
<ud>
Francesco Ottavio Magnocavalli (<en type="li">Casale, Italie</en>, <dat when="1707">1707</dat>) Architecte, <en ref="16" >mathématicien</en> et poète [http://data.bnf.fr/ark:/12148/cb10732099c#foaf:Person]
</ud>
<ud>
Jean Paul Grandjean de Fouchy (<en type="li">Paris</en>, <dat when="1707">1707</dat>) <en ref="24" >Astronome</en>. - Secrétaire perpétuel de l''Académie des Sciences (<dat when="1743">1743</dat>) [http://data.bnf.fr/ark:/12148/cb10667779b#foaf:Person]
</ud>
<ud>
José Quiroga (<dat when="1707">1707</dat>) Jésuite, <en ref="16" >mathématicien</en> et pilote [http://data.bnf.fr/ark:/12148/cb12570261h#foaf:Person]
</ud>
<ud>
Leonhard Euler (<en type="li">Bâle (Suisse)</en>, <dat when="1707">1707</dat>) <en ref="16" >Mathématicien</en> et physicien. - <en ref="18" >Philosophe</en>, théologien et orientaliste. - Membre de l''Académie des sciences de Saint-Pétersbourg (à partir de 1733) et de celle de Berlin (à partir de 1741), et membre associé de celle de Paris (à partir de 1755) [http://data.bnf.fr/ark:/12148/cb12157666x#foaf:Person]
</ud>
<ud>
Giovanni Francesco Mauro Melchior Salvemini da Castiglione (<dat when="1708">1708</dat>) Professeur de mathématiques à Utrecht (<dat when="1751">1751</dat>) puis directeur de la classe de mathématiques de l''Académie de Berlin. - Découvrit la solution du problème consistant à inscrire dans un cercle un triangle dont les côtés passent par trois points donnés [http://data.bnf.fr/ark:/12148/cb130145422#foaf:Person]
</ud>
<ud>
Eustachio Zanotti (<en type="li">Bologne, Italie</en>, <dat when="1709">1709</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb12202196d#foaf:Person]
</ud>
<ud>
Giordano Riccati (<en type="li">Castelfranco Veneto, Italie</en>, <dat when="1709">1709</dat>) Comte. - <en ref="16" >Mathématicien</en>, acousticien et théoricien de la musique. - Fut aussi physicien et architecte [http://data.bnf.fr/ark:/12148/cb12252383n#foaf:Person]
</ud>
<ud>
Georg Matthias Bose (<en type="li">Leipzig (Allemagne)</en>, <dat when="1710">1710</dat>) <en ref="24" >Astronome</en>, physicien, <en ref="16" >mathématicien</en>. - Professeur de physique à l''université de Wittenberg [http://data.bnf.fr/ark:/12148/cb14065311n#foaf:Person]
</ud>
<ud>
Jacques Audierne (<dat when="1710">1710</dat>) Auteur comique et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb10425836p#foaf:Person]
</ud>
<ud>
Johann Bernoulli (<dat when="1710">1710</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb14852857s#foaf:Person]
</ud>
<ud>
Thomas Simpson (<dat when="1710">1710</dat>) Membre de la société royale de Londres, professeur de mathématiques à Woolwich (en 1755) [http://data.bnf.fr/ark:/12148/cb103759851#foaf:Person]
</ud>
<ud>
Alexandre-Gui Pingré (<en type="li">Paris</en>, <dat when="1711">1711</dat>) Génovéfain. - <en ref="24" >Astronome</en>. - Correspondant (à partir de 1753), puis associé libre de l''Académie des sciences. - <en ref="29" >Géographe</en> de la Marine. - Chancelier de l''Université de Paris (1769-17..). - Bibliothécaire de Sainte-Geneviève (à partir de 1792) [http://data.bnf.fr/ark:/12148/cb12151017m#foaf:Person]
</ud>
<ud>
François Jacquier (Vitry-le-François (<en type="li">Marne)</en>, <dat when="1711">1711</dat>) Religieux de l''ordre des Minimes. - Professeur de physique et mathématiques [http://data.bnf.fr/ark:/12148/cb12198105d#foaf:Person]
</ud>
<ud>
Laura Bassi (<en type="li">Bologne, Italie</en>, <dat when="1711">1711</dat>) <en ref="16" >Mathématicien</en>ne et physicienne. - Professeur de biologie et de physique à l''Université de Bologne. - Première femme titulaire d''une chaire universitaire en Europe [http://data.bnf.fr/ark:/12148/cb135103950#foaf:Person]
</ud>
<ud>
Ottaviano Cametti (<en type="li">Gattinara, Italie</en>, <dat when="1711">1711</dat>) <en ref="16" >Mathématicien</en>, physicien et historien [http://data.bnf.fr/ark:/12148/cb10464765k#foaf:Person]
</ud>
<ud>
Pierre Joseph de Rivaz (<dat when="1711">1711</dat>) <en ref="16" >Mathématicien</en>, inventeur-mécanicien et historien. - Directeur des salines de Moutiers. - Né dans le Valais et mort à Moutiers (Tarentaise) [http://data.bnf.fr/ark:/12148/cb128398731#foaf:Person]
</ud>
<ud>
Rugerius Josephus Boscovich (Raguse aujourd''hui Dubrovnik (<en type="li">Croatie)</en>, <dat when="1711">1711</dat>) Jésuite. - Physicien, <en ref="16" >mathématicien</en>, <en ref="24" >astronome</en> et <en ref="18" >philosophe</en>. - Professeur de mathématiques à Rome, Pavie et Milan. - Directeur de l''optique de la Marine royale à Paris et membre de la "Royal Society" à Londres. - Dans son ouvrage majeur "Théorie de la philosophie naturelle" il élabore la théorie initiale des forces et de la structure fondamentale de la matière, dont les concepts ont trouvé écho dans les découvertes de la physique moderne. - Il publie nombre d''ouvrages contenant ses découvertes en mathématiques, en astronomie, en géophysique et en archéologie. - Il mit au point différents instruments optiques, astronomiques et géodésiques et réalisa des expertises et des mesures hydrotechniques, géodésiques, cartographiques et statiques. - Il consolida la coupole de la basilique Saint-Pierre de Rome et de la flèche de la cathédrale de Milan [http://data.bnf.fr/ark:/12148/cb12054879x#foaf:Person]
</ud>
<ud>
Jean-Paul de Gua de Malves (<en type="li">Malves (Aude)</en>, <dat when="1712">1712</dat>) Abbé. - <en ref="16" >Mathématicien</en>, géomètre, économiste politique. - Titulaire de la chaire de philosophie au Collège de France (1742-1749) [http://data.bnf.fr/ark:/12148/cb15325204x#foaf:Person]
</ud>
<ud>
Samuel König (<dat when="1712">1712</dat>) Date de mort : 21 août ou 22 juillet 1757. - A également écrit en français. - <en ref="16" >Mathématicien</en>, <en ref="18" >philosophe</en> et juriste [http://data.bnf.fr/ark:/12148/cb120941298#foaf:Person]
</ud>
<ud>
Alexis Claude Clairaut (<en type="li">Paris (France)</en>, <dat when="1713">1713</dat>) <en ref="16" >Mathématicien</en> très précoce et <en ref="24" >astronome</en>. - Ami de Voltaire et de la marquise Du Chatelet [http://data.bnf.fr/ark:/12148/cb124002538#foaf:Person]
</ud>
<ud>
Giammaria Ortes (<dat when="1713">1713</dat>) Moine camaldule. - <en ref="16" >Mathématicien</en>, économiste et <en ref="18" >philosophe</en> [http://data.bnf.fr/ark:/12148/cb13753557w#foaf:Person]
</ud>
<ud>
Nicolas-Louis de La Caille (<en type="li">Rumigny, Ardennes</en>, <dat when="1713">1713</dat>) Abbé. - Professeur de mathématiques au Collège Mazarin. - Membre de l''Académie royale des sciences [http://data.bnf.fr/ark:/12148/cb12124353d#foaf:Person]
</ud>
<ud>
Alessandro Vittorio Papacino d''Antoni (<en type="li">Villafranca, Italie</en>, <dat when="1714">1714</dat>) Ingénieur, <en ref="16" >mathématicien</en>. - Membre de l''Académie des sciences de Turin [http://data.bnf.fr/ark:/12148/cb10709482t#foaf:Person]
</ud>
<ud>
César-François Cassini de Thury (Thury-sous-Clermont (<en type="li">Oise)</en>, <dat when="1714">1714</dat>) <en ref="24" >Astronome</en> et géomètre. - Membre de l''Académie des sciences (<dat when="1736">1736</dat>). - Fils de Jacques Cassini (1677-1756) et père de Jean-Dominique Cassini (1748-1845). - Participa avec son père à la mesure de la perpendiculaire de l''Observatoire. - Son oeuvre principale est la carte de France, première carte de base de ce pays, dont la publication commença en 1756 [http://data.bnf.fr/ark:/12148/cb12241101g#foaf:Person]
</ud>
<ud>
Giovanni Battista Audiffredi (<en type="li">Saorge, Italie</en>, <dat when="1714">1714</dat>) Dominicain. - <en ref="24" >Astronome</en>. - Préfet de la Biblioteca Casanatense, Rome (1759-1794). - Né Giulio Cesare Audiffredi, change de prénom en entrant chez les Dominicains (<dat when="1730">1730</dat>) [http://data.bnf.fr/ark:/12148/cb13595556h#foaf:Person]
</ud>
<ud>
John Winthrop (<dat when="1714">1714</dat>) Professeur de Mathématiques et de Philosophie naturelle à Harvard [http://data.bnf.fr/ark:/12148/cb14594660x#foaf:Person]
</ud>
<ud>
François-Joachim Duport-Dutertre (Saint-Servan (Ille-et-Vilaine), <dat when="1715">1715</dat>) Littérateur. - <en ref="16" >Mathématicien</en>. - Voyageur [http://data.bnf.fr/ark:/12148/cb12533121w#foaf:Person]
</ud>
<ud>
Pierre-Charles Le Monnier (<en type="li">Paris</en>, <dat when="1715">1715</dat>) <en ref="24" >Astronome</en>. - Membre de l''Académie des sciences (<dat when="1741">1741</dat>). - Professeur de physique au Collège de France (de 1749 à 1793), puis membre de la classe des sciences physiques et mathématiques de l''Institut [http://data.bnf.fr/ark:/12148/cb121064574#foaf:Person]
</ud>
<ud>
André-Pierre Le Guay de Prémontval (Charenton (Val-de-Marne), <dat when="1716">1716</dat>) Professeur de mathématiques. - Membre de l''Académie de Berlin [http://data.bnf.fr/ark:/12148/cb122271303#foaf:Person]
</ud>
<ud>
Eugénios Voúlgaris (<en type="li">Corfou (Îles Ioniennes, Grèce)</en>, <dat when="1716">1716</dat>) Métropolite de l''Église orthodoxe grecque. - Théologien, <en ref="18" >philosophe</en> et <en ref="16" >mathématicien</en>. - "Éducateur de la Nation" et précurseur des Lumières en Grèce ; traducteur de Voltaire et Virgile. - Nommé évêque en Russie [http://data.bnf.fr/ark:/12148/cb12564304q#foaf:Person]
</ud>
<ud>
Gottfried Ploucquet (<dat when="1716">1716</dat>) <en ref="18" >Philosophe</en>, <en ref="16" >mathématicien</en> et théologien. - Professeur de philosophie à l''université de Tübingen (1750-1782) [http://data.bnf.fr/ark:/12148/cb13324024g#foaf:Person]
</ud>
<ud>
Leonardo Ximenes (<en type="li">Trapani, Italie</en>, <dat when="1716">1716</dat>) Jésuite. - <en ref="29" >Geographe</en>, <en ref="24" >astronome</en>, <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb106577403#foaf:Person]
</ud>
<ud>
D'' Alembert (<en type="li">Paris</en>, <dat when="1717">1717</dat>) <en ref="16" >Mathématicien</en> et <en ref="18" >philosophe</en>. - Nom patronymique : Jean Le Rond, d̲i̲t̲ d'' Alembert. - Membre de l''Institut, Académie française (élu en 1754) [http://data.bnf.fr/ark:/12148/cb118883708#foaf:Person]
</ud>
<ud>
Josef Anton Nagel (<dat when="1717">1717</dat>) Professeur, <en ref="16" >mathématicien</en>, scientifique allemand [http://data.bnf.fr/ark:/12148/cb12091922b#foaf:Person]
</ud>
<ud>
Augustin Darquier de Pellepoix (<en type="li">Toulouse</en>, <dat when="1718">1718</dat>) <en ref="24" >Astronome</en>. - Associé non résidant de l''Académie des sciences. - Receveur des tailles de la généralité d''Auch [http://data.bnf.fr/ark:/12148/cb12155190x#foaf:Person]
</ud>
<ud>
Claude-François Berthelot (<dat when="1718">1718</dat>) Ingénieur. - Professeur de mathématiques à l''École royale militaire. - Inventeur de l''"affut de Gribeauval" [http://data.bnf.fr/ark:/12148/cb134984423#foaf:Person]
</ud>
<ud>
François-César Le Tellier Courtanvaux (<dat when="1718">1718</dat>) Duc de Doudeauville. - Capitaine-colonel des cent-suisses de la garde du roi. - <en ref="24" >Astronome</en>, membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb121904446#foaf:Person]
</ud>
<ud>
Gaspard-François-Anne de Forbin (<dat when="1718">1718</dat>) Né le 8 ou le 18 juillet 1718. - Embrassa d'' abord la carrière militaire. - Chevalier de Malte. - <en ref="16" >Mathématicien</en> et Physicien [http://data.bnf.fr/ark:/12148/cb12108181n#foaf:Person]
</ud>
<ud>
István Hatvani (<en type="li">Rimaszombat, aujourd''hui Rimavská Sobota, Slovaquie</en>, <dat when="1718">1718</dat>) <en ref="16" >Mathématicien</en>, physicien. - <en ref="28" >Médecin</en>. - Pédagogue, professeur à Debrecen,Református Kollégium, Hongrie. - Diplômé de l''Université de Bâle, Suisse [http://data.bnf.fr/ark:/12148/cb10355679v#foaf:Person]
</ud>
<ud>
Jean-Philippe Loys de Chéseaux (<dat when="1718">1718</dat>) <en ref="24" >Astronome</en> et physicien. - Né à Lausanne, mort à Paris [http://data.bnf.fr/ark:/12148/cb133196302#foaf:Person]
</ud>
<ud>
Joseph Amiot (<en type="li">Toulon</en>, <dat when="1718">1718</dat>) Jésuite de 1737 à 1773 (ordonné prêtre en 1749). - Sinologue et <en ref="24" >astronome</en>. - Missionnaire en Chine (à partir de 1749) [http://data.bnf.fr/ark:/12148/cb12112654w#foaf:Person]
</ud>
<ud>
Maria Gaetana Agnesi (<en type="li">Milan, Italie</en>, <dat when="1718">1718</dat>) <en ref="16" >Mathématicien</en>ne [http://data.bnf.fr/ark:/12148/cb105423187#foaf:Person]
</ud>
<ud>
Abraham Gotthelf Kästner (<en type="li">Leipzig, Allemagne</en>, <dat when="1719">1719</dat>) <en ref="16" >Mathématicien</en>. - Poète et épigrammatiste. - Critique [http://data.bnf.fr/ark:/12148/cb123392338#foaf:Person]
</ud>
<ud>
Giuseppe Toaldo (<en type="li">Pianezze, Italie</en>, <dat when="1719">1719</dat>) Prêtre. - Physicien. - Professeur d''astronomie, de géographie et de météorologie à l''Université de Padoue [http://data.bnf.fr/ark:/12148/cb10578331h#foaf:Person]
</ud>
<ud>
Jens Kraft (<dat when="1720">1720</dat>) <en ref="18" >Philosophe</en> des lumières danois. - Professeur de mathématiques et de philosophie à Soroe [http://data.bnf.fr/ark:/12148/cb12442689p#foaf:Person]
</ud>
<ud>
Charles Walmesley (<dat when="1722">1722</dat>) Évêque de Rama. - <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb10748264x#foaf:Person]
</ud>
<ud>
Jean Chappe d''Auteroche (<en type="li">Mauriac (Cantal)</en>, <dat when="1722">1722</dat>) <en ref="24" >Astronome</en>. - Explorateur en Sibérie et en Californie [http://data.bnf.fr/ark:/12148/cb12402595h#foaf:Person]
</ud>
<ud>
Jean-Louis Dupain-Triel (<dat when="1722">1722</dat>) Homme de lettres, poète. - S''intéressa aux mathématiques, à la géographie et à l''enseignement des arts [http://data.bnf.fr/ark:/12148/cb119011560#foaf:Person]
</ud>
<ud>
Louis-Jacques Goussier (<dat when="1722">1722</dat>) <en ref="16" >Mathématicien</en> et inventeur [http://data.bnf.fr/ark:/12148/cb13485055d#foaf:Person]
</ud>
<ud>
Baien Miura (<dat when="1723">1723</dat>) Lettré du milieu de l''époque d''Edo. - A créé son propre système de pensée philosophique appelé "jōrigaku" : méthode de spéculation fondée sur l''éthique, la logique, les mathématiques et la physique, recourant à une pensée dialectique appelée "hankan gōitsu" [http://data.bnf.fr/ark:/12148/cb12293200x#foaf:Person]
</ud>
<ud>
Didier Robert de Vaugondy (<dat when="1723">1723</dat>) <en ref="29" >Géographe</en> ordinaire du roi, professeur de mathématiques et de géographie, fils de Gilles Robert Vaugondy. - Didier signe "Robert de Vaugondy" [http://data.bnf.fr/ark:/12148/cb12380757h#foaf:Person]
</ud>
<ud>
Étienne-Nicolas Blondeau (<dat when="1723">1723</dat>) Professeur de mathématiques. - Ingénieur de la marine. - Collaborateur de l''Encyclopédie méthodique (1782-1783?) [http://data.bnf.fr/ark:/12148/cb10737141j#foaf:Person]
</ud>
<ud>
Johann Tobias Mayer (<dat when="1723">1723</dat>) <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en>, a travaillé avec Homann Herben de 1746 à 1751, puid pour Kilian à partir de 1752 [http://data.bnf.fr/ark:/12148/cb153509764#foaf:Person]
</ud>
<ud>
Johann Tobias Mayer (<dat when="1723">1723</dat>) <en ref="24" >Astronome</en> allemand [http://data.bnf.fr/ark:/12148/cb11958863x#foaf:Person]
</ud>
<ud>
Nicole-Reine Lepaute (<en type="li">Paris</en>, <dat when="1723">1723</dat>) Née Nicole-Reine Étable de La Brière, épouse de Jean-André Lepaute, horloger du Roi. - <en ref="16" >Mathématicien</en>ne, <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb14555447k#foaf:Person]
</ud>
<ud>
Tobias Mayer (<en type="li">Marbach (Allemagne)</en>, <dat when="1723">1723</dat>) <en ref="24" >Astronome</en>, <en ref="16" >mathématicien</en>. - Directeur de l''Observatoire de Göttingen, Allemagne [http://data.bnf.fr/ark:/12148/cb121551484#foaf:Person]
</ud>
<ud>
Edme-Sébastien Jeaurat (<dat when="1724">1724</dat>) Ingénieur-<en ref="29" >géographe</en> et <en ref="24" >astronome</en>. - Professeur à l''école militaire. - Membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb122175393#foaf:Person]
</ud>
<ud>
François Para Du Phanjas (Chabottes (Hautes-Alpes), <dat when="1724">1724</dat>) <en ref="18" >Philosophe</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12528863r#foaf:Person]
</ud>
<ud>
Georges Louis Lesage (<en type="li">Genève</en>, <dat when="1724">1724</dat>) <en ref="16" >Mathématicien</en> et physicien suisse. - Etudie à Genève puis Paris. - Etabli à Genève [http://data.bnf.fr/ark:/12148/cb155857475#foaf:Person]
</ud>
<ud>
Guillaume-Germain Guyot (<en type="li">Orléans</en>, <dat when="1724">1724</dat>) Les ouvrages "Nouvelles récréations physiques et mathématiques" et "Essai sur la construction des ballons aérostatiques et sur la manière de les diriger" lui sont attribués par le DBF et par Samuel Ersch dans "La France littéraire contenant les auteurs français de 1771 à 1796", DBF. - Quérard et Michaud soulignent la confusion entre lui et Edme-Gilles Guyot pour l''attribution de ces ouvrages [http://data.bnf.fr/ark:/12148/cb12214218k#foaf:Person]
</ud>
<ud>
Guillaume-Hyacinthe-Joseph-Jean-Baptiste Le Gentil de La Galaisière (<dat when="1725">1725</dat>) <en ref="24" >Astronome</en> et voyageur. - Entre à l''Observatoire en 1750. - Membre de l''Académie des sciences en 1753 [http://data.bnf.fr/ark:/12148/cb12151459n#foaf:Person]
</ud>
<ud>
Jean-Étienne Montucla (<dat when="1725">1725</dat>) Historien des mathématiques [http://data.bnf.fr/ark:/12148/cb12127574n#foaf:Person]
</ud>
<ud>
Louis-Charles Desnos (<dat when="1725">1725</dat>) Libraire ; libraire et (ingénieur) <en ref="29" >géographe</en> (pour les globes et les sphères) du roi de Danemark (ou : de Sa Majesté danoise) (1769-1789). - Fils d''un marchand drapier de Pont-Sainte-Maxence (Oise). Apprenti fondeur de caractères à Paris à partir d''avril 1745 (reçu maître fondeur en 1757).  Ingénieur <en ref="29" >géographe</en> (de la ville de Paris à partir de 1769), fabricant et marchand de sphères et d''instruments astronomiques établi vers 1753 en succession de Jacques Hardy, après avoir épousé en 1749 la veuve de son fils Nicolas Hardy ; également marchand d''estampes et de cartes géographiques. Un des 12 libraires non jurés reçus le 4 oct. 1767. - Éditeur et auteur de nombreux atlas, almanachs et publications géographiques entre 1756 et 1795 env. Rédige également plusieurs catalogues de son fonds entre 1768 et 1792. Une partie de son fonds est rachetée en 1805 par Jean (17..-1839), marchand de cartes et d''estampes [http://data.bnf.fr/ark:/12148/cb12402252d#foaf:Person]
</ud>
<ud>
Rigobert Bonne (Raucourt (Meurthe-et-Moselle), <dat when="1727">1727</dat>) Ingénieur. - <en ref="29" >Géographe</en>. - Hydrographe. - Célèbre par la projection qui porte son nom et qui remplacera pour la carte de France la projection de Cassini. D''abord ingénieur <en ref="29" >géographe</en> et maître de mathématiques. En 1775 ingénieur hydrographe de la Marine. Fut mis à la retraite contre sa volonté en 1789. Collabora au Neptune américo-septentrional [http://data.bnf.fr/ark:/12148/cb12169793s#foaf:Person]
</ud>
<ud>
Chrysologue de Gy (Gy (Haute-Saône), <dat when="1728">1728</dat>) Capucin. - <en ref="24" >Astronome</en>, cartographe et géologue [http://data.bnf.fr/ark:/12148/cb10728734z#foaf:Person]
</ud>
<ud>
Jean-Henri Lambert (<en type="li">Mulhouse, Suisse</en>, <dat when="1728">1728</dat>) <en ref="16" >Mathématicien</en>, physicien, <en ref="24" >astronome</en> et <en ref="18" >philosophe</en>. - Spécialiste de géometrie. - En poste à l''Académie royale des sciences et belles lettres de Berlin (de 1765 à 1777) [http://data.bnf.fr/ark:/12148/cb12359659g#foaf:Person]
</ud>
<ud>
Le P.  Chrysologue (<en type="li">Gy</en>, <dat when="1728">1728</dat>) Capucin, nom de religion de Noël André. - Attiré par la géographie et l''astronomie, fut l''élève de Lemonnier. Mesura les altitudes des Vosges, du Jura et des Alpes. Se retira dans sa famille au moment de la Révolution.  En 1806 publia un important traité de géologie dont Cuvier fit un rapport élogieux [http://data.bnf.fr/ark:/12148/cb153054042#foaf:Person]
</ud>
<ud>
Paolo Frisi (<en type="li">Melegnano, Italie</en>, <dat when="1728">1728</dat>) Barnabite. - <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en> et <en ref="26" >écrivain</en>. - Professeur dans les Écoles palatines de Milan (1764-) [http://data.bnf.fr/ark:/12148/cb120849325#foaf:Person]
</ud>
<ud>
Antonio Eximeno (<dat when="1729">1729</dat>) Théoricien de la musique et polémiste. - Jésuite, il devient professeur de rhétorique à l''Université de Valence, puis professeur de mathématiques à l''Académie militaire de Ségovie (<dat when="1764">1764</dat>). - Lorsque les jésuites sont expulsés d''Espagne en 1767, il se rend à Rome où il étudie la musique. - Connu aussi sous le pseud. : "Aristosseno Megareo" (BnF, Musique, fichier général auteurs), ou "Aristodemo Megareo" (Fétis) [http://data.bnf.fr/ark:/12148/cb13755053m#foaf:Person]
</ud>
<ud>
Charles Bossut (<dat when="1730">1730</dat>) <en ref="16" >Mathématicien</en>, membre de l''Académie des sciences (<dat when="1779">1779</dat>), il participa à la rédaction de la partie mathématique de l''Encyclopédie [http://data.bnf.fr/ark:/12148/cb11763983g#foaf:Person]
</ud>
<ud>
Charles Bossut (<dat when="1730">1730</dat>) <en ref="16" >Mathématicien</en> et physicien. - Membre de l''Académie des sciences, pensionnaire de la classe de mécanique (<dat when="1785">1785</dat>). - Écrivit plusieurs articles dans l''"Encyclopédie" [http://data.bnf.fr/ark:/12148/cb124599882#foaf:Person]
</ud>
<ud>
Charles Messier (Badonviller (Meurthe-et-Moselle), <dat when="1730">1730</dat>) <en ref="24" >Astronome</en> de la marine. - Académicien (<dat when="1770">1770</dat>). - Membre de l''Institut [http://data.bnf.fr/ark:/12148/cb124827900#foaf:Person]
</ud>
<ud>
Étienne Bezout (<en type="li">Nemours</en>, <dat when="1730">1730</dat>) <en ref="16" >Mathématicien</en>. - Membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb12267459g#foaf:Person]
</ud>
<ud>
Jean-Baptiste de Laborde (<dat when="1730">1730</dat>) Physicien et <en ref="16" >mathématicien</en>. - Jésuite [http://data.bnf.fr/ark:/12148/cb13196726p#foaf:Person]
</ud>
<ud>
Joseph-Aignan Sigaud de La Fond (<en type="li">Bourges</en>, <dat when="1730">1730</dat>) <en ref="16" >Mathématicien</en>, physicien et moraliste. - Professeur de physique à Bourges [http://data.bnf.fr/ark:/12148/cb12401095w#foaf:Person]
</ud>
<ud>
Pierre-Thomas Antelmy (<en type="li">Trigance, France</en>, <dat when="1730">1730</dat>) <en ref="16" >Mathématicien</en>, professeur de mathématiques à l''École militaire [http://data.bnf.fr/ark:/12148/cb13011110m#foaf:Person]
</ud>
<ud>
Benito Bails (<dat when="1731">1731</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb162593727#foaf:Person]
</ud>
<ud>
Girolamo Francisco Cristiani (<en type="li">Brescia, Italie</en>, <dat when="1731">1731</dat>) <en ref="16" >Mathématicien</en> et physicien [http://data.bnf.fr/ark:/12148/cb14065297x#foaf:Person]
</ud>
<ud>
Nicolas-Claude Duval-Le Roy (<dat when="1731">1731</dat>) Professeur de mathématiques et d''hydrographie, physicien et <en ref="24" >astronome</en>. - Membre de l''Académie royale de marine. - Correspondant à l''Académie royale des sciences (<dat when="1789">1789</dat>), associé non résident de l''Institut (<dat when="1796">1796</dat>) [http://data.bnf.fr/ark:/12148/cb12548660k#foaf:Person]
</ud>
<ud>
Diderich Christian Fester (<dat when="1732">1732</dat>) <en ref="16" >Mathématicien</en> et cartographe à Trondheim [http://data.bnf.fr/ark:/12148/cb15384550x#foaf:Person]
</ud>
<ud>
Jérôme de La Lande (Bourg-en-Bresse (<en type="li">Ain)</en>, <dat when="1732">1732</dat>) <en ref="24" >Astronome</en>. - Membre de l''Académie de Berlin. - Membre de l''Académie des sciences (<dat when="1753">1753</dat>). - Professeur d''astronomie au Collège de France (<dat when="1762">1762</dat>). - Directeur de l''Observatoire de Paris de 1768 à sa mort [http://data.bnf.fr/ark:/12148/cb12012398h#foaf:Person]
</ud>
<ud>
Maurille-Antoine Moithey (<dat when="1732">1732</dat>) Éditeur et marchand de cartes géographiques ; libraire. - Ingénieur <en ref="29" >géographe</en> du Roi et professeur de mathématiques des pages du prince et de la princesse de Conti. Auteur de plans, de cartes, d''ouvrages illustrés et d''atlas, qu''il publie et diffuse parfois lui-même de 1776 à 1792 au moins. Auteur notamment d''un "Dictionnaire hydrographique de la France..." (1re éd., l''auteur, 1787 ; rééd., Paris, Blanchon, <dat when="1803">1803</dat>) et d''une série de "Recherches historiques" sur les villes de France (Angers, Orléans, Reims, 1775-1776). Se qualifie de libraire en 1791-1792. Décédé à Paris le 21 frimaire an XIV (12 déc. 1805, Arch. de Paris) [http://data.bnf.fr/ark:/12148/cb13531657x#foaf:Person]
</ud>
<ud>
Nevil Maskelyne (<dat when="1732">1732</dat>) <en ref="24" >Astronome</en> royal d''Angleterre. - Membre associé de l''Académie des sciences de Paris [http://data.bnf.fr/ark:/12148/cb12155150p#foaf:Person]
</ud>
<ud>
Jacques-François Dicquemare (<en type="li">Le Havre</en>, <dat when="1733">1733</dat>) <en ref="24" >Astronome</en>. - Hydrographe. - Zoologue marin [http://data.bnf.fr/ark:/12148/cb15317071s#foaf:Person]
</ud>
<ud>
János Sajnovics (<en type="li">Tordas, Hongrie</en>, <dat when="1733">1733</dat>) <en ref="24" >Astronome</en>. - Linguiste. - Père jésuite [http://data.bnf.fr/ark:/12148/cb12246417w#foaf:Person]
</ud>
<ud>
Jean-Charles Borda (<en type="li">Dax (Landes)</en>, <dat when="1733">1733</dat>) Officier de marine. - Membre de l''Académie de Marine (élu en 1769). - Entra dans le Génie militaire et se fit remarquer par ses travaux sur l''hydraulique. - Il détermina la longitude des Canaries (en 1776). - Prit part à la guerre d''indépendance américaine. - Participa avec Delambre et Méchain à la mesure de l''arc de méridien Dunkerque-Barcelone. - En qualité de commissaire de l''Académie des sciences participa à l''étude des montres marines sur la frégate la Flore (en 1771). - Membre de l''Institut, Académie des sciences (élu en 1772). - Membre de la Commission des poids et mesures (en 1791), il travailla à l''établissement du système métrique. - Membre de l''Institut national des sciences et arts, section mathématiques (actuel Institut de France) et du Bureau des longitudes (en 1795). - Co-fondateur de La Société de Borda (créée en 1876), avec Jacques-François de Borda d''Oro (1718-1804) [http://data.bnf.fr/ark:/12148/cb12482831r#foaf:Person]
</ud>
<ud>
Samuel Horsley (<dat when="1733">1733</dat>) Evêque; secrétaire de la Royal Society; publia des livres de théologie et de mathématiques [http://data.bnf.fr/ark:/12148/cb120697374#foaf:Person]
</ud>
<ud>
Achille Pierre Dionis du Séjour (<en type="li">Paris</en>, <dat when="1734">1734</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb10680537k#foaf:Person]
</ud>
<ud>
Baudouin de Guémadeuc (<dat when="1734">1734</dat>) Homme de loi, homme de lettres, pamphlétaire puis <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb144447840#foaf:Person]
</ud>
<ud>
Charles Duvaucel (<dat when="1734">1734</dat>) <en ref="24" >Astronome</en>, spécialisé dans les éclipses du soleil. [http://data.bnf.fr/ark:/12148/cb15318527x#foaf:Person]
</ud>
<ud>
Mathieu Bernard Goudin (<en type="li">Paris</en>, <dat when="1734">1734</dat>) Magistrat. - <en ref="16" >Mathématicien</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb10586154b#foaf:Person]
</ud>
<ud>
Alexandre-Théophile Vandermonde (<en type="li">Paris</en>, <dat when="1735">1735</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12534847r#foaf:Person]
</ud>
<ud>
Antonio Maria Lorgna (<en type="li">Cerea, Italie</en>, <dat when="1735">1735</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12387058m#foaf:Person]
</ud>
<ud>
Gregorio Fontana (<en type="li">Villa di Nogaredo, Italie</en>, <dat when="1735">1735</dat>) <en ref="16" >Mathématicien</en> et physicien. - Recteur et professeur de calcul sublime à l''Ateneo lombardo. - Bibliothécaire du Collegio Ghisleri, Pavie [http://data.bnf.fr/ark:/12148/cb10601676b#foaf:Person]
</ud>
<ud>
Giovanni-Antonio Rizzi-Zannoni (<en type="li">Padoue, Italie</en>, <dat when="1736">1736</dat>) <en ref="29" >Géographe</en> de la république de Venise, <en ref="24" >astronome</en>, il voyage en Amérique du nord en 1757 [http://data.bnf.fr/ark:/12148/cb153024615#foaf:Person]
</ud>
<ud>
Jean Sylvain Bailly (<en type="li">Paris</en>, <dat when="1736">1736</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en> et homme politique. - Entre à l''Académie des sciences (en 1763), à l''Académie française (en 1784) puis à l''Académie des inscriptions (en 1785). - Député du Tiers-État aux États-Généraux ; Maire de Paris ; Député à l''Assemblée Nationale Constituante [http://data.bnf.fr/ark:/12148/cb12516744h#foaf:Person]
</ud>
<ud>
Johann Nicolai Tetens (<en type="li">Tetenbüll, Allemagne</en>, <dat when="1736">1736</dat>) <en ref="16" >Mathématicien</en>, physicien et <en ref="18" >philosophe</en> [http://data.bnf.fr/ark:/12148/cb12531163b#foaf:Person]
</ud>
<ud>
Joseph-Louis Lagrange (<dat when="1736">1736</dat>) <en ref="16" >Mathématicien</en>. - D''origine italienne. - A été à l''origine de la fondation de l''Académie des sciences de Turin. - Membre de l''Académie des sciences de Paris, Berlin, Turin. - A partir de 1787, enseigne à Paris à l''École normale et à l''École polytechnique [http://data.bnf.fr/ark:/12148/cb12125247f#foaf:Person]
</ud>
<ud>
Francesco Venini (<en type="li">Varenna, Italie</en>, <dat when="1737">1737</dat>) Abbé. - <en ref="16" >Mathématicien</en> et poète [http://data.bnf.fr/ark:/12148/cb105963005#foaf:Person]
</ud>
<ud>
Giuseppe Maria Pagnini (<en type="li">Pistoia, Italie</en>, <dat when="1737">1737</dat>) Au siècle : Luca Antonio ; en religion, carme : Giuseppe Maria. - Poète. - <en ref="16" >Mathématicien</en>. - Savant latiniste et helléniste. - Professeur à l'' Université de Parme puis de Pise [http://data.bnf.fr/ark:/12148/cb11996942k#foaf:Person]
</ud>
<ud>
Tommaso Valperga di Caluso (<en type="li">Turin, Italie</en>, <dat when="1737">1737</dat>) Abbé. - Homme de lettres, <en ref="18" >philosophe</en> et <en ref="16" >mathématicien</en>. - Chevalier de Malte [http://data.bnf.fr/ark:/12148/cb10748197m#foaf:Person]
</ud>
<ud>
William Bayly (<dat when="1737">1737</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb14065321z#foaf:Person]
</ud>
<ud>
Charles-Joseph Mathon de La Cour (<en type="li">Lyon (Rhône)</en>, <dat when="1738">1738</dat>) Économiste. - Philanthrope. - Fondateur du "Journal de Lyon". - Rédacteur de "L''Almanach musical" (1775-1778), et au "Journal de musique", Paris (1764-1768). - Fils de : Mathon de La Cour, Jacques (1712-1770), <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb121925904#foaf:Person]
</ud>
<ud>
Flecheux (<dat when="1738">1738</dat>) <en ref="24" >Astronome</en> et mécanicien français. - Adresse en 1784 : Paris, rue du Sentier, hôtel de madame la présidente de Meslay, n° 31 [http://data.bnf.fr/ark:/12148/cb15585605z#foaf:Person]
</ud>
<ud>
Joseph-François Marie (<en type="li">Rodez</en>, <dat when="1738">1738</dat>) Abbé. - Fut professeur de mathématiques au Collège Mazarin [http://data.bnf.fr/ark:/12148/cb146364765#foaf:Person]
</ud>
<ud>
Thomas Abbt (<en type="li">Ulm, Allemagne</en>, <dat when="1738">1738</dat>) <en ref="26" >Écrivain</en>, <en ref="18" >philosophe</en>, <en ref="16" >mathématicien</en>, juriste et conseiller aulique [http://data.bnf.fr/ark:/12148/cb125347464#foaf:Person]
</ud>
<ud>
William Herschel (<en type="li">Hanovre, Allemagne</en>, <dat when="1738">1738</dat>) <en ref="24" >Astronome</en> et compositeur. - A découvert la planète Uranus. - S''installe en Grande-Bretagne en 1757 [http://data.bnf.fr/ark:/12148/cb14064893z#foaf:Person]
</ud>
<ud>
Ermenegildo Pini (<en type="li">Milan, Italie</en>, <dat when="1739">1739</dat>) Barnabite. - Physicien, géologue, architecte. - Professeur de mathématiques, puis d''histoire naturelle au Collège Saint-Alexandre, Milan. - Dans le siècle : Pini, Carlo [http://data.bnf.fr/ark:/12148/cb13013593q#foaf:Person]
</ud>
<ud>
Jean-Louis Pictet (<dat when="1739">1739</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb146402484#foaf:Person]
</ud>
<ud>
Johann Schultz (<dat when="1739">1739</dat>) A été professeur de mathématiques à l''université de Königsberg, Allemagne [http://data.bnf.fr/ark:/12148/cb121741380#foaf:Person]
</ud>
<ud>
José Antonio Alzate y Ramírez (<dat when="1739">1739</dat>) <en ref="24" >Astronome</en> et <en ref="29" >géographe</en> [http://data.bnf.fr/ark:/12148/cb15376450x#foaf:Person]
</ud>
<ud>
András Dugonics (<en type="li">Szeged (Hongrie)</en>, <dat when="1740">1740</dat>) <en ref="26" >Écrivain</en>. - Poète. - Piariste. - Professeur de mathématiques. - A fait des études de théologie  à Privigye (aujourd''hui Prievidza, Slovaquie) et à Nyitra (aujourd''hui Nitra, Slovaquie) [http://data.bnf.fr/ark:/12148/cb12246575b#foaf:Person]
</ud>
<ud>
Jacques-André Mallet (<dat when="1740">1740</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb10552198c#foaf:Person]
</ud>
<ud>
Joseph Anton Slop von Cadenberg (<dat when="1740">1740</dat>) <en ref="24" >Astronome</en>. - À l''Observatoire de Pise à partir de 1765 [http://data.bnf.fr/ark:/12148/cb12159312n#foaf:Person]
</ud>
<ud>
Nicola Spedalieri (<en type="li">Bronte (Italie)</en>, <dat when="1740">1740</dat>) Professeur de philosophie, théologie et mathématique, poète, musicien, historien [http://data.bnf.fr/ark:/12148/cb16219670j#foaf:Person]
</ud>
<ud>
Nicolas-Antoine Nouet (<dat when="1740">1740</dat>) <en ref="24" >Astronome</en>. - Attaché à l''Observatoire en 1785. - Participe à l''expédition d''Égypte en 1798. - Ingénieur au Bureau de la guerre en 1802 [http://data.bnf.fr/ark:/12148/cb12151453k#foaf:Person]
</ud>
<ud>
Thomas Bugge (<en type="li">Copenhague</en>, <dat when="1740">1740</dat>) <en ref="24" >Astronome</en> et cartographe [http://data.bnf.fr/ark:/12148/cb121931908#foaf:Person]
</ud>
<ud>
Vicente Tofiño de San Miguel (<dat when="1740">1740</dat>) <en ref="24" >Astronome</en>. - Capitaine de vaisseau. - Directeur des compagnies des gardes royales de la marine en 1786. - Membre de l''Académie d''histoire de Madrid. - Correspondant de l''Académie des sciences de Paris [http://data.bnf.fr/ark:/12148/cb12159995t#foaf:Person]
</ud>
<ud>
Alexis Rochon (<en type="li">Brest (Finistère)</en>, <dat when="1741">1741</dat>) Prêtre, <en ref="24" >astronome</en> de la marine, physicien et inventeur. - Bibliothécaire de l''Académie royale de marine à Brest (1765-), <en ref="24" >astronome</en> opticien de la Marine (<dat when="1787">1787</dat>), membre de la Commission des poids et mesures et des monnaies (<dat when="1792">1792</dat>). - Membre de l''Académie royale des sciences, puis membre de l''Institut. - Clerc tonsuré [http://data.bnf.fr/ark:/12148/cb129983745#foaf:Person]
</ud>
<ud>
Stanislaw Wydra (<dat when="1741">1741</dat>) Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb15512813z#foaf:Person]
</ud>
<ud>
Vincenzo Chiminello (<en type="li">Marostica, Italie</en>, <dat when="1741">1741</dat>) Abbé. - <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb10522164f#foaf:Person]
</ud>
<ud>
Georg Jonathan von Holland (<dat when="1742">1742</dat>) Théologien. - <en ref="16" >Mathématicien</en>. - Précepteur des princes de Wurttemberg [http://data.bnf.fr/ark:/12148/cb119076602#foaf:Person]
</ud>
<ud>
Jacques Poitevin (<en type="li">Montpellier</en>, <dat when="1742">1742</dat>) Savant <en ref="24" >astronome</en> et agriculteur. - Conseiller de préfecture du département de l''Hérault. - Membre de la Société royale des sciences de Montpellier [http://data.bnf.fr/ark:/12148/cb10644654k#foaf:Person]
</ud>
<ud>
Antonio Cagnoli (<en type="li">Zante, Grèce</en>, <dat when="1743">1743</dat>) <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en>. - Crée un observatoire d''astronomie à Vérone. - Enseigne les mathématiques à l''École militaire de Modène après la prise de Vérone par les Français (<dat when="1797">1797</dat>). - Membre de nombreuses académies d''Europe [http://data.bnf.fr/ark:/12148/cb12562781s#foaf:Person]
</ud>
<ud>
Eberhard August Wilhelm von Zimmermann (<en type="li">Uelzen, Allemagne</en>, <dat when="1743">1743</dat>) <en ref="29" >Géographe</en> et naturaliste. - Professeur de mathématiques et de sciences naturelles au Collegium Carolinum de Brunswick de 1766 à 1815. - Conseiller aulique en 1786, puis conseiller d''état en 1801 [http://data.bnf.fr/ark:/12148/cb12330956p#foaf:Person]
</ud>
<ud>
Jean-Antoine-Nicolas de Caritat Condorcet (<dat when="1743">1743</dat>) <en ref="18" >Philosophe</en>, <en ref="16" >mathématicien</en> et  économiste. - Membre de l''Académie française (<dat when="1782">1782</dat>). - Homme politique. - A aussi écrit sous le pseudonyme M. Schwartz, pasteur à Bienne [http://data.bnf.fr/ark:/12148/cb118975118#foaf:Person]
</ud>
<ud>
Etienne Lenoir (<dat when="1744">1744</dat>) Ingénieur. - Mit au point plusieurs instruments d''astronomie et de géodésie [http://data.bnf.fr/ark:/12148/cb151423156#foaf:Person]
</ud>
<ud>
François Callet (<en type="li">Versailles</en>, <dat when="1744">1744</dat>) Professeur de mathématiques et d''hydrographie [http://data.bnf.fr/ark:/12148/cb10544471f#foaf:Person]
</ud>
<ud>
Jean Bernoulli (<en type="li">Bâle, Suisse</en>, <dat when="1744">1744</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en>. - Membre des Académies des sciences de Berlin, de Petersbourg, de Stockholm, de Bologne, de Lyon, &amp; de Marseille, de la Société pour l''encouragement des arts, de Londres, de celle des physiciens de Bâle, de l''Académie des Arcades de Rome [http://data.bnf.fr/ark:/12148/cb14508854n#foaf:Person]
</ud>
<ud>
José Anastácio da Cunha (<dat when="1744">1744</dat>) Poète portugais. - <en ref="16" >Mathématicien</en>, professeur de géométrie à l''Université de Coimbra. - Officier d''artillerie à Valença do Minho (1764-1778) [http://data.bnf.fr/ark:/12148/cb121612626#foaf:Person]
</ud>
<ud>
Pierre Méchain (<en type="li">Laon</en>, <dat when="1744">1744</dat>) <en ref="24" >Astronome</en> français. - Prénoms complets : Pierre François André [http://data.bnf.fr/ark:/12148/cb12090251r#foaf:Person]
</ud>
<ud>
Caspar Wessel (<en type="li">Vestby, Norvège</en>, <dat when="1745">1745</dat>) <en ref="16" >Mathématicien</en>. - Reçut la médaille d''argent de la Royal Danish academy [http://data.bnf.fr/ark:/12148/cb12563002z#foaf:Person]
</ud>
<ud>
Claude-François Guillemeau de Fréval (<en type="li">Paris</en>, <dat when="1745">1745</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb10017540p#foaf:Person]
</ud>
<ud>
Franz von Paula Triesnecker (<dat when="1745">1745</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb15115995f#foaf:Person]
</ud>
<ud>
Fulcrand Jean Joseph Aigrefeuille (<dat when="1745">1745</dat>) G<en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb16296114m#foaf:Person]
</ud>
<ud>
Johann Hieronymus Schröter (<dat when="1745">1745</dat>) Magistrat et <en ref="24" >astronome</en> amateur allemand [http://data.bnf.fr/ark:/12148/cb11973603q#foaf:Person]
</ud>
<ud>
Nicolas Charles Romme (Riom, Puy-de-Dôme, <dat when="1745">1745</dat>) Professeur de mathématiques et de navigation à l''École de Rochefort. - Membre de l''Institut [http://data.bnf.fr/ark:/12148/cb12805333t#foaf:Person]
</ud>
<ud>
Gaetano Del Ricco (<dat when="1746">1746</dat>) Piariste (17 mai 1761). - <en ref="16" >Mathématicien</en>. - Librettiste. - Prénom de baptême : Vincenzo [http://data.bnf.fr/ark:/12148/cb16659347q#foaf:Person]
</ud>
<ud>
Gaspard Monge (<dat when="1746">1746</dat>) <en ref="16" >Mathématicien</en> et géomètre. - Fondateur de l''École polytechnique et de l''École normale. - Président de l''Institut du Caire. - Membre de l''Institut, Académie des sciences. - Député au Conseil des Cinq-Cents, au Conseil des Anciens, ministre de la Marine (<dat when="1792">1792</dat>), sénateur (<dat when="1799">1799</dat>), comte de Péluse (<dat when="1808">1808</dat>) [http://data.bnf.fr/ark:/12148/cb121412336#foaf:Person]
</ud>
<ud>
Giovanni Battista Venturi (<en type="li">Bibbiano, Italie</en>, <dat when="1746">1746</dat>) Physicien et <en ref="16" >mathématicien</en>. - Homme politique et diplomate [http://data.bnf.fr/ark:/12148/cb127228927#foaf:Person]
</ud>
<ud>
Giuseppe Piazzi (<en type="li">Ponte di Valtellina, Italie</en>, <dat when="1746">1746</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb12920801z#foaf:Person]
</ud>
<ud>
Jean-Claude-Gauthier-Louis de Benaben (<dat when="1746">1746</dat>) Oratorien et professeur de mathématiques. - Fut directeur de l''Ecole centrale d''Angers. - Fut président des Amis de la Constitution. - Fut commissaire civil du département de Maine-et-Loire [http://data.bnf.fr/ark:/12148/cb125680474#foaf:Person]
</ud>
<ud>
Jean Foucaud (<dat when="1747">1747</dat>) Prédicateur, <en ref="16" >mathématicien</en>, philologue. - A écrit en patois limousin des fables imitées de La Fontaine, qu''il a aussi traduit dans cette même langue. - Fut l''un des rédacteurs du "Journal du département de la Haute-Vienne". - Fut à Limoges une personalité agissante du Club des jacobins, membre du Comité de salut public, juge de paix et payeur du département de Haute-Vienne. - Défroqué en 1793, il mourut réconcilié avec l''Église [http://data.bnf.fr/ark:/12148/cb119031941#foaf:Person]
</ud>
<ud>
Jean-Baptiste Bernard (<dat when="1747">1747</dat>) Libraire ; libraire de l''École polytechnique (<dat when="1800">1800</dat>) ; de l''École des Ponts et Chaussées (<dat when="1801">1801</dat>) ; des Écoles impériales polytechnique et des Ponts et chaussées (<dat when="1805">1805</dat>). - Né à Marseille. Libraire spécialisé dans les "mathématiques, sciences et arts", il travaille jusqu''en 1796 en association avec Régent au bureau du "Journal polytechnique" ou "Bulletin des Travaux publics..." Historien et philologue, éditeur des "Œuvres posthumes" de Montesquieu. Décédé à Saint-Maur-des-Fossés (Val-de-Marne) en oct. 1808. Sa veuve lui succède avant de revendre son fonds en 1810 à Jean Klostermann [http://data.bnf.fr/ark:/12148/cb122388832#foaf:Person]
</ud>
<ud>
Johann Elert Bode (<en type="li">Hambourg (Allemagne)</en>, <dat when="1747">1747</dat>) <en ref="24" >Astronome</en> [http://data.bnf.fr/ark:/12148/cb104634498#foaf:Person]
</ud>
<ud>
Andreas Riedel (<en type="li">Vienne</en>, <dat when="1748">1748</dat>) Jacobin viennois. - Professeur de mathématiques, précepteur des enfants du Grand duc Léopold, futur empereur,  1779-1790, Florence (Italie). - Études de médecine, élève du professeur Franz Anton Mesmer. - Emprisonné à Brno (1806-1809). - Se réfugia en France 1810-1837 [http://data.bnf.fr/ark:/12148/cb14593357z#foaf:Person]
</ud>
<ud>
Jean-Dominique Cassini (<dat when="1748">1748</dat>) <en ref="24" >Astronome</en>. - Membre de l''Académie des sciences (<dat when="1770">1770</dat>). - Fils de l''<en ref="24" >astronome</en> César-François Cassini (1714-1784), qui était aussi appelé Cassini de Thury, car né à Thury (Oise) en 1714. - Succède à son père comme directeur de l''Observatoire de Paris (en 1784) [http://data.bnf.fr/ark:/12148/cb12157999q#foaf:Person]
</ud>
<ud>
Pietro Cossali (<en type="li">Vérone, Italie</en>, <dat when="1748">1748</dat>) <en ref="16" >Mathématicien</en>. - A enseigné à l''université de Padoue [http://data.bnf.fr/ark:/12148/cb146340668#foaf:Person]
</ud>
<ud>
Pons-Joseph Bernard (<dat when="1748">1748</dat>) <en ref="16" >Mathématicien</en>. - Directeur adjoint de l''Observatoire de Marseille [http://data.bnf.fr/ark:/12148/cb12306722n#foaf:Person]
</ud>
<ud>
Thaddäus Rinderle (<dat when="1748">1748</dat>) Moine bénédictin, <en ref="16" >mathématicien</en> et horloger [http://data.bnf.fr/ark:/12148/cb15037954k#foaf:Person]
</ud>
<ud>
Giuseppe Calandrelli (<en type="li">Zagarolo, Italie</en>, <dat when="1749">1749</dat>) <en ref="24" >Astronome</en>. - Directeur du "Collegio romano" [http://data.bnf.fr/ark:/12148/cb10544460s#foaf:Person]
</ud>
<ud>
Henri Bouchon-Dubournial (<dat when="1749">1749</dat>) Ingénieur et <en ref="16" >mathématicien</en>. - Fut professeur à l''Ecole militaire et l''Ecole royale militaire. - Fut le traducteur de Cervantès [http://data.bnf.fr/ark:/12148/cb125620183#foaf:Person]
</ud>
<ud>
Jean-Baptiste Delambre (<en type="li">Amiens</en>, <dat when="1749">1749</dat>) <en ref="24" >Astronome</en>. - Ses calculs ont servi à  déterminer la longueur du mètre. - Membre de l''Académie des sciences (<dat when="1792">1792</dat>) [http://data.bnf.fr/ark:/12148/cb12096096m#foaf:Person]
</ud>
<ud>
Paul-Louis Cirodde (<dat when="1749">1749</dat>) Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb102655606#foaf:Person]
</ud>
<ud>
Pierre-Simon de Laplace (Beaumont-en-Auge (<en type="li">Calvados)</en>, <dat when="1749">1749</dat>) <en ref="24" >Astronome</en>, <en ref="16" >mathématicien</en> et physicien. - Membre de l''Institut, Académie des sciences (élu en 1795), puis de l''Académie française (élu en 1816). - Obtint le titre de marquis (en 1817) [http://data.bnf.fr/ark:/12148/cb119110516#foaf:Person]
</ud>
<ud>
Vincenzo De Filippis (<dat when="1749">1749</dat>) Scientifique, <en ref="16" >mathématicien</en>. - Ministre de la République parthénopéenne en février 1799, fut probablement victime de la répression au rétablissement des Bourbons en juin de la même année [http://data.bnf.fr/ark:/12148/cb12290835h#foaf:Person]
</ud>
<ud>
William Faden (<dat when="1749">1749</dat>) Libraire, éditeur et marchand de cartes et d''estampes ; également <en ref="29" >géographe</en> ordinaire du roi d''Angleterre (1783-1820) et du prince de Galles (1790-1820). - Fils de l''imprimeur londonien William I Faden (à l''origine Mackfaden, 1711-1783). En apprentissage de juillet 1764 à août 1771. Travaille en association avec la famille du libraire et <en ref="29" >géographe</en> du Roi Thomas Jefferys (m. 1771) jusqu''en 1776 env. Membre de la "Society of civil engineers". Beau-frère du peintre et <en ref="24" >astronome</en> John Russell. Se retire en 1823 et cède son affaire à son ancien apprenti James Wyld. Décédé à Shepperton en mars 1836 [http://data.bnf.fr/ark:/12148/cb15615346f#foaf:Person]
</ud>
<ud>
Caroline Lucretia Herschel (Hanovre (Basse-Saxe,  Allemagne), <dat when="1750">1750</dat>) <en ref="24" >Astronome</en>. - Assistante de son frère, William Herschel (1738-1822), lui aussi <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb16108822m#foaf:Person]
</ud>
<ud>
Gilbert Romme (<dat when="1750">1750</dat>) <en ref="16" >Mathématicien</en>, <en ref="24" >astronome</en> et <en ref="29" >géographe</en>. - Député du Puy-de-Dôme à l''Assemblée législative puis à la Convention, représentant en mission près l''armée de Cherbourg, préconise l''essai du télégraphe aérien de Chiappe. - A participé à l''établissement du calendrier révolutionnaire [http://data.bnf.fr/ark:/12148/cb12536106q#foaf:Person]
</ud>
<ud>
Lorenzo Mascheroni (<en type="li">Bergame, Italie</en>, <dat when="1750">1750</dat>) <en ref="16" >Mathématicien</en> et poète. - Professeur de physique et de mathématique au Séminaire de Bergame, puis d''algèbre et de géométrie à l''Université de Pavie, dont il sera recteur. - Député au Corps législatif de Milan (<dat when="1799">1799</dat>), admirateur de Napoléon, fait partie des 29 qui signent l''appel à régner en Italie au Premier Consul après 1799 [http://data.bnf.fr/ark:/12148/cb119149502#foaf:Person]
</ud>
<ud>
Nicolas-Maurice Chompré (<en type="li">Paris (France)</en>, <dat when="1750">1750</dat>) Directeur, entre 1777 et 1786, de la Correspondance générale à la Division des mines et de l''agriculture du Contrôleur général des Finances Bertin. - Diplomate. - Auteur d''ouvrages de physique et de mathématiques [http://data.bnf.fr/ark:/12148/cb122074802#foaf:Person]
</ud>
<ud>
Scipione Breislak (<en type="li">Rome</en>, <dat when="1750">1750</dat>) Géologue. - Professeur de mathématiques à Raguse puis à Rome [http://data.bnf.fr/ark:/12148/cb151306996#foaf:Person]
</ud>
<ud>
Simon Lhuilier (<dat when="1750">1750</dat>) <en ref="16" >Mathématicien</en> et <en ref="18" >philosophe</en>. - Établi à Varsovie [http://data.bnf.fr/ark:/12148/cb13005974t#foaf:Person]
</ud>
<ud>
Alliette (<dat when="1751">1751</dat>) Cartomancien de la fin du 18e siècle. - Marchand d''estampes. - Professeur de mathématiques (vers 1753). - La forme "Etteilla" est l''anagramme d''Alliette [http://data.bnf.fr/ark:/12148/cb118885161#foaf:Person]
</ud>
<ud>
André-Charles Brotier (<en type="li">Paris</en>, <dat when="1751">1751</dat>) Abbé, <en ref="16" >mathématicien</en> et homme politique. - Enseigna les mathématiques à l''Ecole militaire. - Collabora à l''"Année littéraire" et au "Journal de la France" [http://data.bnf.fr/ark:/12148/cb124621991#foaf:Person]
</ud>
<ud>
Antide Janvier (Lavans-lès-Saint-Claude (<en type="li">Jura)</en>, <dat when="1751">1751</dat>) Horloger, <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb12614643k#foaf:Person]
</ud>
<ud>
Bazaine (<dat when="1751">1751</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb10735226f#foaf:Person]
</ud>
<ud>
Bernard Violle (<dat when="1751">1751</dat>) <en ref="16" >Mathématicien</en>. - Géomètre. - Chevalier de Saint-Louis (<dat when="1815">1815</dat>) [http://data.bnf.fr/ark:/12148/cb13006994p#foaf:Person]
</ud>
<ud>
Bonaventure Abat (<dat when="1751">1751</dat>) <en ref="16" >Mathématicien</en> et théologien, cordelier de l''Observance. - Fut membre associé de l''Académie royale des belles-lettres de Barcelone [http://data.bnf.fr/ark:/12148/cb134813469#foaf:Person]
</ud>
<ud>
G.-F. Olivier (<dat when="1751">1751</dat>) Bachelier ès sciences. - Professeur d''humanités et de mathématiques (en 1825). Professeur au collège de Troyes [http://data.bnf.fr/ark:/12148/cb10728006s#foaf:Person]
</ud>
<ud>
Guillelmus Beer (<dat when="1751">1751</dat>) Cartographe, <en ref="29" >géographe</en> et peut-être <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb15332855z#foaf:Person]
</ud>
<ud>
Hector-Jean Legros (<dat when="1751">1751</dat>) Adjoint-général pendant les guerres de Vendée et d''Italie. - Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb13484693c#foaf:Person]
</ud>
<ud>
Henri Jurain (<dat when="1751">1751</dat>) Abbé. - Professeur de mathématiques à Reims. - Correspondant de l''Académie des Sciences [http://data.bnf.fr/ark:/12148/cb12224993g#foaf:Person]
</ud>
<ud>
J.-B.-M. Duprat (<dat when="1751">1751</dat>) Libraire pour les mathématiques. - En activité de mars 1797 à 1803 au moins. Apparenté à Louis (-Alexis) Duprat-Duverger, en activité à partir de 1802, qui a pu se qualifier lui aussi de "libraire pour les mathématiques". Louis Courcier, "imprimeur et libraire pour les mathématiques", lui succède en 1803 à la même adresse (quai des Augustins, n° 71). Une "madame Duprat" est cependant répertoriée, à l''adresse du pont Saint-Michel, par le "Tableau des libraires" de Debray (Paris, janv. 1804) [http://data.bnf.fr/ark:/12148/cb16701987t#foaf:Person]
</ud>
<ud>
J.P. Audiffred (<dat when="1751">1751</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb125867381#foaf:Person]
</ud>
<ud>
Jacques Baradelle (<dat when="1751">1751</dat>) Etabli dès 1740 quai de l''Horloge du Palais, il fabriquait des instruments de navigation, des cadrans solaires, des sphères astronomiques et géographiques [http://data.bnf.fr/ark:/12148/cb15281028g#foaf:Person]
</ud>
<ud>
James Dodson (<dat when="1751">1751</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb153816258#foaf:Person]
</ud>
<ud>
Jean-Louis Gœury (<dat when="1751">1751</dat>) Libraire ; libraire pour les mathématiques et l''architecture ; libraire de l''École des Ponts et chaussées (<dat when="1802">1802</dat>) ; des ingénieurs et de l''École impériale des Ponts et chaussées (<dat when="1805">1805</dat>). - Semble avoir été commis du libraire parisien Charles-Antoine Jombert de 1770 à 1773 au moins. Père du <en ref="28" >médecin</en> Jean-Louis Gœury-Duvivier, né le 2 mars 1803. En activité dès 1800. Breveté libraire le 1er oct. 1812 (brevet renouvelé le 11 sept. 1818). Décédé peu avant le 28 juin 1827, date à laquelle son fils Jean-Louis Gœury (dit plus tard Gœury-Duvivier) demande à succéder à son brevet [http://data.bnf.fr/ark:/12148/cb12230577c#foaf:Person]
</ud>
<ud>
Joseph Mouchet (<dat when="1751">1751</dat>) Professeur de rhétorique et de mathématiques, professeur de physique à l''université de Nantes de 1780 à 1784. - Aéronaute. - Membre de la Congrégation de l''Oratoire [http://data.bnf.fr/ark:/12148/cb16514291q#foaf:Person]
</ud>
<ud>
Joseph-Louis Vincens de Mauléon de Causans (<en type="li">Avignon</en>, <dat when="1751">1751</dat>) <en ref="16" >Mathématicien</en>. - Colonel d''infanterie du régiment de Conti. - Chevalier de Malte [http://data.bnf.fr/ark:/12148/cb145658189#foaf:Person]
</ud>
<ud>
Le Professeur de mathématiques du Collège national de Toul (<dat when="1751">1751</dat>) Professeur de mathématiques du Collège national de Toul [http://data.bnf.fr/ark:/12148/cb125373980#foaf:Person]
</ud>
<ud>
Le Ratz de Lanthenée (<dat when="1751">1751</dat>) Gentilhomme liégeois. - <en ref="16" >Mathématicien</en> et physicien [http://data.bnf.fr/ark:/12148/cb124022694#foaf:Person]
</ud>
<ud>
Louis Duprat-Duverger (<dat when="1751">1751</dat>) Variante(s) de prénom : Louis-Alexis. - Libraire pour les mathématiques ; également éditeur de cartes et d''atlas. - Apparenté au "libraire pour les mathématiques" J.-B.-M. Duprat, en activité à Paris entre 1797 et 1803. Établi dès 1802, d''abord en association sous la raison "L. Duprat, Letellier et compagnie" jusqu''en 1804, seul ensuite. Breveté libraire le 1er oct. 1812 ; brevet renouvelé le 15 mars 1817 ; duplicata délivré le 27 avril 1824. Encore en activité en 1829 [http://data.bnf.fr/ark:/12148/cb133399518#foaf:Person]
</ud>
<ud>
Madame Bailly (<dat when="1751">1751</dat>) Épouse de Jean-Sylvain Bailly, <en ref="16" >mathématicien</en>, <en ref="24" >astronome</en> et homme politique, guillotiné en 1793 [http://data.bnf.fr/ark:/12148/cb16541654h#foaf:Person]
</ud>
<ud>
Marie de La Fresnaye (<en type="li">Barfleur (Manche)</en>, <dat when="1751">1751</dat>) Professeur de littérature et de mathématiques [http://data.bnf.fr/ark:/12148/cb100430283#foaf:Person]
</ud>
<ud>
Marie-Louise Cartan (<dat when="1751">1751</dat>) Femme d''Elie Cartan, mère du compositeur Jean Cartan et du <en ref="16" >mathématicien</en> Henri Cartan. - Née Marie-Louise Bianconi [http://data.bnf.fr/ark:/12148/cb148511208#foaf:Person]
</ud>
<ud>
Mathurin-Georges Girault de Keroudou (<dat when="1751">1751</dat>) Abbé. - <en ref="16" >Mathématicien</en> français. - Principal du collège de Quimper. - Professeur de philosophie et de mathématiques au collège de Navarre à Paris. - Professeur au collège de Louis-le-Grand à Paris [http://data.bnf.fr/ark:/12148/cb15085298t#foaf:Person]
</ud>
<ud>
Nicolas Leverdé (<dat when="1751">1751</dat>) <en ref="25" >Astrologue</en> et <en ref="16" >mathématicien</en>. - Auteur d''almanachs [http://data.bnf.fr/ark:/12148/cb10403809w#foaf:Person]
</ud>
<ud>
Olaf Söderberg (<dat when="1751">1751</dat>) Botaniste et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12563978p#foaf:Person]
</ud>
<ud>
Théodore Bouys (<dat when="1751">1751</dat>) <en ref="16" >Mathématicien</en> favorable à Necker et à la Révolution [http://data.bnf.fr/ark:/12148/cb12240772d#foaf:Person]
</ud>
<ud>
Trabaud (<dat when="1751">1751</dat>) Maître de mathématiques [http://data.bnf.fr/ark:/12148/cb134811442#foaf:Person]
</ud>
<ud>
Vérologue (<dat when="1751">1751</dat>) "Seul imprimeur d''Apollon pour la satyre en prose". - Pseud. auquel est adjoint le qualificatif "seul imprimeur d''Apollon pour la satyre en prose" et qui, sous la fausse adresse "Sur l''imprimé au Parnasse", dissimule une impression française (parisienne selon Weller et G. Brunet, plutôt provinciale d''après le matériel typographique) de "La Nouvelle Astronomie du Parnasse françois, ou l''Apothéose des <en ref="26" >écrivain</en>s vivans dans la présente année 1740", due au chevalier Jean-Florent-Joseph de Neufville de Brunaubois-Montador [http://data.bnf.fr/ark:/12148/cb165246377#foaf:Person]
</ud>
<ud>
Veuve de Louis Courcier (<dat when="1751">1751</dat>) Nom patronymique : Victoire-Félicité Lemaire. - Imprimeur-libraire ; imprimeur-libraire pour les mathématiques, la marine, les sciences et les arts. - Brevetée imprimeur en succession de son mari le 12 août 1811 (brevet renouvelé le 15 oct. 1816) et libraire le 1er oct. 1812 (brevet renouvelé le 15 mars 1817). Deux de ses  gendres lui succèdent : Démophile Huzard (-Courcier) en mars 1820 (brevet du 14 mars 1820) comme imprimeur, et Victor Bachelier le 10 nov. 1821 comme libraire [http://data.bnf.fr/ark:/12148/cb124778683#foaf:Person]
</ud>
<ud>
Adrien-Marie Legendre (<dat when="1752">1752</dat>) <en ref="16" >Mathématicien</en>. - Président de l''Académie des sciences (<dat when="1806">1806</dat>). - A aussi écrit avec Charles-Etienne Coquebert de Montbret et François Gattey sous le pseudonyme collectif "C.-G.-L. Métrophile" [http://data.bnf.fr/ark:/12148/cb12443375d#foaf:Person]
</ud>
<ud>
Barnaba Oriani (<en type="li">Carignano, Italie</en>, <dat when="1752">1752</dat>) <en ref="24" >Astronome</en> de l''Observatoire de Brera (1777-), puis de Milan. - A découvert qu''Uranus était une planète à partir de son orbite. - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12537845s#foaf:Person]
</ud>
<ud>
Jean-Baptiste Labey (La Chapelle-Hainfray (Calvados), aujourd''hui Valsemé (<en type="li">Calvados)</en>, <dat when="1752">1752</dat>) <en ref="16" >Mathématicien</en>. - Professeur à l''École militaire, à l''École centrale du Panthéon, à l''École polytechnique et au Lycée Napoléon de Paris [http://data.bnf.fr/ark:/12148/cb12112257t#foaf:Person]
</ud>
<ud>
Jean-Baptiste Pérès (Valence d''Agen (Tarn-et-Garonne), <dat when="1752">1752</dat>) Oratorien. - Professeur de mathématiques et de physique  à Lyon, membre de la Société des amis de la Constitution de la ville durant la Révolution, puis substitut du procureur général près la cour royale d''Agen et bibliothécaire de cette ville [http://data.bnf.fr/ark:/12148/cb126307361#foaf:Person]
</ud>
<ud>
Marc-Auguste Pictet (<en type="li">Genève (Suisse)</en>, <dat when="1752">1752</dat>) Naturaliste genevois, littérateur, chimiste, physicien et <en ref="24" >astronome</en>. - Membre fondateur de la Société de physique et d''histoire naturelle de Genève, Suisse. - Correspondant de la Société royale de Londres [http://data.bnf.fr/ark:/12148/cb125386742#foaf:Person]
</ud>
<ud>
François Gattey (<dat when="1753">1753</dat>) <en ref="16" >Mathématicien</en>. - Directeur du Bureau des poids et mesures (en 1795). - A aussi écrit avec Charles-Etienne Coquebert de Montbret et Adrien-Marie Legendre sous le pseudonyme collectif "C.-G.-L. Métrophile" [http://data.bnf.fr/ark:/12148/cb12447886d#foaf:Person]
</ud>
<ud>
Antoine de La Salle (<dat when="1754">1754</dat>) <en ref="18" >Philosophe</en>. - <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb12173561c#foaf:Person]
</ud>
<ud>
Colin Mackenzie (Stornoway (Lewis, Western isles, Royaume-Uni), <dat when="1754">1754</dat>) <en ref="16" >Mathématicien</en>. - Fonctionnaire collonial en Inde (1815-1821). - Chargé du relevé cartographique de l''Inde et de la description de ses régions. - Collectionneur de divers documents (manuscrits, dessins aquarelles...) constituant le fonds d''études indianistes, collection dispersée aujourd''hui entre l''India office library, Londres et : Government oriental manuscripts library, Madras et Calcutta [http://data.bnf.fr/ark:/12148/cb14374770r#foaf:Person]
</ud>
<ud>
Franz Xaver von Zach (<en type="li">Bratislava</en>, <dat when="1754">1754</dat>) <en ref="24" >Astronome</en>. - Directeur de l''Observatoire du Seeberg (près de Gotha), de 1787 à 1808. - Dirigea les "Allgemeinen geographischen Ephemeriden" (1796-) [http://data.bnf.fr/ark:/12148/cb121732757#foaf:Person]
</ud>
<ud>
Jean-Baptiste Meusnier de La Place (Tours (Indre-et-Loire), <dat when="1754">1754</dat>) <en ref="16" >Mathématicien</en> et Officier. - Elu à l''Académie des sciences en 1784 pour son étude locale des surfaces. - Prénoms complets : Jean-Baptiste Marie Charles [http://data.bnf.fr/ark:/12148/cb10732160m#foaf:Person]
</ud>
<ud>
Nicolas-François Canard (<dat when="1754">1754</dat>) <en ref="16" >Mathématicien</en> et économiste [http://data.bnf.fr/ark:/12148/cb12519510c#foaf:Person]
</ud>
<ud>
Charles-Étienne Coquebert de Montbret (<en type="li">Paris</en>, <dat when="1755">1755</dat>) Diplomate, <en ref="16" >mathématicien</en> et <en ref="29" >géographe</en>. - Nommé responsable de l''organisation du nouveau système de poids et mesures (décret de 1793), professeur de géographie physique et gîtes de minerais à l''École des mines. - A aussi écrit avec François Gattey et Adrien-Marie Legendre sous le pseudonyme collectif "C.-G.-L. Métrophile". - Membre de l''Institut, membre libre de l''Académie des Sciences (en 1816) [http://data.bnf.fr/ark:/12148/cb12447869t#foaf:Person]
</ud>
<ud>
Claude Philippe Bertrand Bertrand (Autun (Saône-et-Loire), <dat when="1755">1755</dat>) <en ref="29" >Géographe</en> et <en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb16506861q#foaf:Person]
</ud>
<ud>
Emmanuel-Étienne Duvillard de Durand (<en type="li">Genève</en>, <dat when="1755">1755</dat>) <en ref="16" >Mathématicien</en>, statisticien. - A développé la mathématisation de l''économie [http://data.bnf.fr/ark:/12148/cb129987837#foaf:Person]
</ud>
<ud>
Gaspard-Clair-François-Marie Riche de Prony (<en type="li">Chamelet (Rhône)</en>, <dat when="1755">1755</dat>) <en ref="16" >Mathématicien</en> et ingénieur. - Directeur de l''École des Ponts et Chaussées (1799-1830). - Membre de l''Académie des Sciences. - Baron à titre personnel (<dat when="1828">1828</dat>) [http://data.bnf.fr/ark:/12148/cb12535038t#foaf:Person]
</ud>
<ud>
Jean Anthelme Brillat-Savarin (<en type="li">Belley, Ain</en>, <dat when="1755">1755</dat>) Magistrat. - Député aux États Généraux (élu en 1789). - G<en ref="24" >astronome</en> [http://data.bnf.fr/ark:/12148/cb12305674c#foaf:Person]
</ud>
<ud>
Louis Courcier (<dat when="1755">1755</dat>) Imprimeur-libraire ; imprimeur-libraire pour les mathématiques (<dat when="1801">1801</dat>) ; imprimeur-libraire pour les mathématiques (, les sciences et les arts) (1804-1808). - Exerce l''imprimerie dès l''été 1790. Aurait été auparavant "marchand de peaux de lapin" d''après l''enquête des inspecteurs de la librairie de déc. 1810. Proche des Girondins, il émarge au budget du Bureau de l''Esprit public du ministre Jean-Marie Roland de La Platière en 1792. Dirige le "Courrier du Corps législatif et de la Guerre" (<dat when="1797">1797</dat>). Rachète le fonds du libraire J.-B.-M. Duprat et lui succède en 1803 ; rachète l''imprimerie de Jean-Georges-Antoine Stoupe après la mort de celui-ci (<dat when="1808">1808</dat>). Breveté imprimeur le 1er avril 1811. Dit âgé de 56 ans lors de son décès (30 juillet 1811). Sa veuve est brevetée en sa succession dès le 12 août 1811 [http://data.bnf.fr/ark:/12148/cb12421329b#foaf:Person]
</ud>
<ud>
Nicolas B. Halma (<dat when="1755">1755</dat>) Chanoine de Paris. - <en ref="24" >Astronome</en> et <en ref="16" >mathématicien</en>. - Professeur [http://data.bnf.fr/ark:/12148/cb11906753t#foaf:Person]
</ud>
<ud>
Nikolaus von Fuss (<dat when="1755">1755</dat>) <en ref="16" >Mathématicien</en>, géomètre. - Né à Bâle, s''intalla à Saint-Pétersbourg en 1773 à la demande d''Euler. - Membre de l''Académie des sciences de Saint-Pétersbourg (1775-), secrétaire perpétuel (1800-). - Meurt à Saint-Pétersbourg le 23 décembre 1825 (style grégorien) [http://data.bnf.fr/ark:/12148/cb12359314p#foaf:Person]
</ud>
<ud>
Pierre Tédenat (<dat when="1755">1755</dat>) Docteur en mathématiques. - Recteur de l''académie Nîmes (1809-1818) et professeur de philosophie à la faculté des lettres de Nîmes [http://data.bnf.fr/ark:/12148/cb10379875d#foaf:Person]
</ud>
<ud>
Agricol-Joseph-François-Xavier-Pierre-Esprit-Simon-Paul-Antoine Fortia d''Urban (<en type="li">Avignon</en>, <dat when="1756">1756</dat>) <en ref="16" >Mathématicien</en> et littérateur. - Chevalier de la Légion d''honneur en 1811, correspondant de l''Académie de Belgique en 1828 et membre libre de l''Académie des Inscriptions et belles-lettres en 1830 [http://data.bnf.fr/ark:/12148/cb121468483#foaf:Person]
</ud>
<ud>
Alexandre Ruelle (<en type="li">Blois</en>, <dat when="1756">1756</dat>) <en ref="24" >Astronome</en>. - Professeur d''astronomie à l''Observatoire de Paris de 1783 à 1795 [http://data.bnf.fr/ark:/12148/cb121582720#foaf:Person]
</ud>
<ud>
Ernst Gottfried Fischer (<dat when="1756">1756</dat>) Physicien et <en ref="16" >mathématicien</en> [http://data.bnf.fr/ark:/12148/cb124025182#foaf:Person]
</ud>
<ud>
Jan Chrzciciel Władysław Śniadecki (<dat when="1756">1756</dat>) <en ref="16" >Mathématicien</en> et <en ref="18" >philosophe</en>, un des plus grands savants polonais des Lumières [http://data.bnf.fr/ark:/12148/cb123726267#foaf:Person]
</ud>
<ud>
Joseph Mollet (Aix-en-Provence (Bouches-du-Rhône), <dat when="1756">1756</dat>) Oratorien. - Professeur de physique et de mathématique, École Centrale, Lyon, Rhône. - Doyen de la Faculté des sciences de Lyon (1809-1815) [http://data.bnf.fr/ark:/12148/cb12196474k#foaf:Person]
</ud>
<ud>
Carl-Christian von Langsdorf (<en type="li">Nauheim (Allemagne)</en>, <dat when="1757">1757</dat>) <en ref="16" >Mathématicien</en>. - Ingénieur. - Professeur de mathématiques à Erlangen (Allemagne), de 1798 à 1804, puis à Vilnius (Lituanie) de 1804 à 1806. - Frère de Langsdorf, Johann-Wilhelm (1745-1827) [http://data.bnf.fr/ark:/12148/cb10661030m#foaf:Person]
</ud>
<ud>
Dominique Blanqui (<dat when="1757">1757</dat>) Professeur de philosophie et d''astronomie. - Député à la Convention. - Membre du Conseil des Cinq-cents [http://data.bnf.fr/ark:/12148/cb12534874n#foaf:Person]
</ud>
<ud>
Alexandre-Balthazar-Laurent Grimod de La Reynière (<en type="li">Paris</en>, <dat when="1758">1758</dat>) Avocat. - Pamphlétaire. - G<en ref="24" >astronome</en>, fondateur et président du "Jury dégustateur" [http://data.bnf.fr/ark:/12148/cb11905936j#foaf:Person]
</ud>
<ud>
Johann Christoph Schuster (<dat when="1759">1759</dat>) <en ref="16" >Mathématicien</en> [http://data.bnf.fr/ark:/12148/cb16505504t#foaf:Person]
</ud>
<ud>
Louis-François-Antoine Arbogast (<en type="li">Mutzig, Alsace</en>, <dat when="1759">1759</dat>) <en ref="16" >Mathématicien</en>. - Directeur du Collège royal (en 1791). - Député à l''Assemblée législative puis à la Convention nationale [http://data.bnf.fr/ark:/12148/cb12520232w#foaf:Person]
</ud>
<ud>
Pierre-René-Auguste Bremond d''Ars (<dat when="1759">1759</dat>) Député de la noblesse. - Fut professeur de mathématiques et de latin [http://data.bnf.fr/ark:/12148/cb12540611f#foaf:Person]
</ud>
<ud>
Thomas Keith (<en type="li">Winestead (GB)</en>, <dat when="1759">1759</dat>) <en ref="16" >Mathématicien</en>. - Professeur [http://data.bnf.fr/ark:/12148/cb10275963j#foaf:Person]
</ud>
<ud>
Giovanni Paradisi (<en type="li">Reggio Emilia, Italie</en>, <dat when="1760">1760</dat>) Comte. - Homme politique. - <en ref="16" >Mathématicien</en>. - Poète [http://data.bnf.fr/ark:/12148/cb105910991#foaf:Person]
</ud>
<ud>
Nicolas Antoine Guillard (<en type="li">Sorbais, Aisne</en>, <dat when="1760">1760</dat>) Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb10617134p#foaf:Person]
</ud></root>', 8, NULL, '{ud0}
Hermann de Carinthie ({en0li}île de Korčula (Croatie){/en}, {dat1105}1105{/dat}) {en18}Philosophe{/en}, {en26}écrivain{/en}, {en16}mathématicien{/en}, {en25}astrologue{/en} et traducteur croate [http://data.bnf.fr/ark:/12148/cb16243624j#foaf:Person]
{/ud}
{ud0}
Hermann le Dalmate ({en0li}Saint Peter en Istrie une partie du duché de Carinthie (au sud de l''Autriche){/en}, {dat1110}1110{/dat}) {en18}Philosophe{/en}, {en24}astronome{/en}, {en25}astrologue{/en}, {en16}mathématicien{/en} et traducteur d''ouvrages scientifiques et de la littérature. - Il vint très jeune en 1135 en France à Paris et à Chartres. - Eut pour maître Thierry de Chartres. - L''abbé de Cluny, Pierre le Vénérable, poussa Herman à traduire à écrire sur la vie et l''oeuvre de Mahomet [http://data.bnf.fr/ark:/12148/cb12364029w#foaf:Person]
{/ud}
{ud0}
Bhāskarācārya ({en0li}Dekkan, Inde{/en}, {dat1114}1114{/dat}) {en16}Mathématicien{/en}. - {en24}Astronome{/en}. - Fils de Maheśvara. - Auteur de :  "Siddhāntaśiromanī" (en 1150) ; "Karṇakutūhala" [http://data.bnf.fr/ark:/12148/cb14498624v#foaf:Person]
{/ud}
{ud0}
al-Muẓaffar ibn Muḥammad Šaraf al-Dīn Ṭūsī ({dat1151}1151{/dat}) {en16}Mathématicien{/en}. - Originaire de Ṭūs, Hamad̲ān, Mosul, Alep, Damas. - Écrivait vers 1209 [http://data.bnf.fr/ark:/12148/cb120864072#foaf:Person]
{/ud}
{ud0}
Johannes de Sacro Bosco ({dat1151}1151{/dat}) {en16}Mathématicien{/en}. - Chanoine prémontré de Holywood (comté de Dumfries, Écosse). - Professeur à l''Université de Paris. - Semble être né à Halifax (Yorkshire, Angleterre). - Mort en 1256 ou 1244 [http://data.bnf.fr/ark:/12148/cb121284153#foaf:Person]
{/ud}
{ud0}
Robertus Castrensis ({dat1151}1151{/dat}) Traducteur de traités scientifiques et de mathématiques. - Sa période d''activité se situe aux alentours de 1145 [http://data.bnf.fr/ark:/12148/cb12223624k#foaf:Person]
{/ud}
{ud0}
Alexandre de Villedieu ({en0li}Villedieu (Manche){/en}, {dat1170}1170{/dat}) Franciscain. - {en27}Grammairien{/en}, {en16}mathématicien{/en} et poète. - Chanoine de la cathédrale Saint-André d''Avranches [http://data.bnf.fr/ark:/12148/cb12536245w#foaf:Person]
{/ud}
{ud0}
Leonardo Fibonacci ({dat1170}1170{/dat}) {en16}Mathématicien{/en}. - Surnommé Leonardo Pisano [http://data.bnf.fr/ark:/12148/cb13092437c#foaf:Person]
{/ud}
{ud0}
Moḥamad ben Moḥamad Naṣīr al-Dīn Ṭōsī ({en0li}Tus (Iran){/en}, {dat1201}1201{/dat}) {en16}Mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb12399386c#foaf:Person]
{/ud}
{ud0}
Jean Pecham ({dat1220}1220{/dat}) Provincial des franciscains d''Angleterre. - Archevêque de Cantorbéry (à partir de 1279). - Théologien, {en16}mathématicien{/en} et physicien [http://data.bnf.fr/ark:/12148/cb12459837w#foaf:Person]
{/ud}
{ud0}
Witelo ({dat1220}1220{/dat}) {en18}Philosophe{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12054316n#foaf:Person]
{/ud}
{ud0}
Maḥmūd ibn Mas´ūd Quṭb al-Dīn al- Šīrāzī ({en0li}Shīrāz{/en}, {dat1236}1236{/dat}) {en24}Astronome{/en}, {en28}médecin{/en}, {en18}philosophe{/en} et théologien [http://data.bnf.fr/ark:/12148/cb12086388m#foaf:Person]
{/ud}
{ud0}
Jacob ben Machir ({en0li}Marseille{/en}, {dat1238}1238{/dat}) {en24}Astronome{/en}. - {en28}Médecin{/en}. - Chancellier de la faculté de médecine de Montpellier [http://data.bnf.fr/ark:/12148/cb165406517#foaf:Person]
{/ud}
{ud0}
Grégoire Chioniadès ({dat1240}1240{/dat}) {en24}Astronome{/en}, physicien et {en28}médecin{/en} byzantin. - Évêque de Tabriz, Iran [http://data.bnf.fr/ark:/12148/cb12007088c#foaf:Person]
{/ud}
{ud0}
Henri Baten ({dat1246}1246{/dat}) {en18}Philosophe{/en} et théologien. - {en24}Astronome{/en}. - Poète et musicien [http://data.bnf.fr/ark:/12148/cb12220635h#foaf:Person]
{/ud}
{ud0}
al-Mufaḍḍal ibn ʿUmar Aṯīr al-Dīn al-Abharī ({dat1251}1251{/dat}) {en18}Philosophe{/en}, logicien, {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb15935708x#foaf:Person]
{/ud}
{ud0}
Bartolomeo da Parma ({dat1251}1251{/dat}) {en25}Astrologue{/en}, géomancien et {en24}astronome{/en}. Fut professeur à l''Université de Bologne (1288-1297) [http://data.bnf.fr/ark:/12148/cb144790439#foaf:Person]
{/ud}
{ud0}
Campanus de Novare ({dat1251}1251{/dat}) {en24}Astronome{/en}. - {en16}Mathématicien{/en}, commentateur d''Euclide [http://data.bnf.fr/ark:/12148/cb124917005#foaf:Person]
{/ud}
{ud0}
David ben Yom-Tov Poel ({dat1251}1251{/dat}) {en18}Philosophe{/en}. - {en28}Médecin{/en}. - Père de l''{en24}astronome{/en} Jacob Poel [http://data.bnf.fr/ark:/12148/cb16540698w#foaf:Person]
{/ud}
{ud0}
Démétrius Triclinius ({en0li}Thessalonique{/en}, {dat1251}1251{/dat}) Philologue. - {en16}Mathématicien{/en} et {en25}astrologue{/en} [http://data.bnf.fr/ark:/12148/cb12311753x#foaf:Person]
{/ud}
{ud0}
Geršon ben Salomon d''Arles ({en0li}Béziers{/en}, {dat1251}1251{/dat}) Éxégète. - {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb134867338#foaf:Person]
{/ud}
{ud0}
Hui Yang ({dat1251}1251{/dat}) {en16}Mathématicien{/en} chinois. En activité entre 1261 et 1275 [http://data.bnf.fr/ark:/12148/cb13746624q#foaf:Person]
{/ud}
{ud0}
Isaac ben Joseph Israeli ({dat1251}1251{/dat}) {en24}Astronome{/en}. - Elève d''Asher ben Jehiel [http://data.bnf.fr/ark:/12148/cb16540863s#foaf:Person]
{/ud}
{ud0}
Jacopo da Firenze ({dat1251}1251{/dat}) {en16}Mathématicien{/en}. - Actif en 1307 [http://data.bnf.fr/ark:/12148/cb157815579#foaf:Person]
{/ud}
{ud0}
Jordanus Nemorarius ({dat1251}1251{/dat}) {en16}Mathématicien{/en}. - Probablement d''origine italienne [http://data.bnf.fr/ark:/12148/cb11986727x#foaf:Person]
{/ud}
{ud0}
Petrus Philomena de Dacia ({dat1251}1251{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en}, {en18}philosophe{/en}. - Attesté entre 1290 et 1300. - Élève à l''Université de Bologne (1291-1292) puis de Paris. - Chanoine de Roskilde, Danemark. - A distinguer de Petrus de Dacia, recteur de l''Université de Paris en 1327 [http://data.bnf.fr/ark:/12148/cb11887258w#foaf:Person]
{/ud}
{ud0}
ʿAbd al-Ġaffār ibn ʿAbd al-Karīm Naǧm al-Dīn al- Qazwīnī ({dat1251}1251{/dat}) {en16}Mathématicien{/en} et jurisconsulte chaféite [http://data.bnf.fr/ark:/12148/cb155674927#foaf:Person]
{/ud}
{ud0}
Andalò Di Negro ({en0li}Gênes (?), Italie{/en}, {dat1260}1260{/dat}) {en24}Astronome{/en}. - Précepteur de Boccace. - Ambassadeur de la République de Gênes auprès de l''empereur Alexis Comnène (en 1314) [http://data.bnf.fr/ark:/12148/cb121998732#foaf:Person]
{/ud}
{ud0}
Théodore Métochite ({en0li}Constantinople{/en}, {dat1260}1260{/dat}) Homme d''état, {en18}philosophe{/en}, poète, {en24}astronome{/en} et rhéteur [http://data.bnf.fr/ark:/12148/cb12000562c#foaf:Person]
{/ud}
{ud0}
Gersonide (Bagnols-sur-Cèze ({en0li}Gard){/en}, {dat1288}1288{/dat}) Exégète biblique, {en16}mathématicien{/en}, {en24}astronome{/en}, {en18}philosophe{/en}, physicien [http://data.bnf.fr/ark:/12148/cb12131941j#foaf:Person]
{/ud}
{ud0}
Barlaam de Seminara ({dat1290}1290{/dat}) Moine basilien, abbé du Saint-Esprit à Constantinople ({dat1331}1331{/dat}), évêque de Gérace (1342-1348). - Théologien, {en18}philosophe{/en}, {en16}mathématicien{/en}, {en24}astronome{/en} et helléniste [http://data.bnf.fr/ark:/12148/cb13549924x#foaf:Person]
{/ud}
{ud0}
Jacopo Dondi ({dat1290}1290{/dat}) {en18}Philosophe{/en}, {en24}astronome{/en}, {en28}médecin{/en} italien célèbre pour la construction d''une pendule astrale à Padoue. - Père de Giovanni Dondi [http://data.bnf.fr/ark:/12148/cb124119184#foaf:Person]
{/ud}
{ud0}
Thomas Bradwardine ({dat1290}1290{/dat}) {en16}Mathématicien{/en}, {en18}philosophe{/en} et théologien. - Surnommé le "Doctor Profundus". - Archevêque de Canterbury en 1349 [http://data.bnf.fr/ark:/12148/cb12269047v#foaf:Person]
{/ud}
{ud0}
Richard of Wallingford ({dat1292}1292{/dat}) {en16}Mathématicien{/en}. - {en24}Astronome{/en}. - Abbé du monastère bénédictin de St Albans [http://data.bnf.fr/ark:/12148/cb12128305h#foaf:Person]
{/ud}
{ud0}
Jean de Murs ({dat1300}1300{/dat}) {en24}Astronome{/en}, {en16}mathématicien{/en} et théoricien de la musique. - Maître-ès-arts de l''Université de Paris ({dat1321}1321{/dat}) [http://data.bnf.fr/ark:/12148/cb121715011#foaf:Person]
{/ud}
{ud0}
Giovanni Dondi dall''Orologio ({en0li}Chiogga, Italie{/en}, {dat1318}1318{/dat}) {en28}Médecin{/en} et poète. - {en24}Astronome{/en} et horloger, a terminé l''horloge astronomique, installée par son père : Dondi, Jacopo (1298-1359), à Padoue ou Pavie, Italie [http://data.bnf.fr/ark:/12148/cb122241024#foaf:Person]
{/ud}
{ud0}
Giacomo Allegretti ({dat1325}1325{/dat}) {en28}Médecin{/en} , poète et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb14405998n#foaf:Person]
{/ud}
{ud0}
Blasius de Parma ({dat1347}1347{/dat}) {en18}Philosophe{/en}, {en16}mathématicien{/en}, {en28}médecin{/en}. - Recteur de l''université de Parme (en 1412) [http://data.bnf.fr/ark:/12148/cb12182615f#foaf:Person]
{/ud}
{ud0}
Abū ʿAbd Allâh Muḥammad al- Baqqār ({dat1351}1351{/dat}) {en16}Mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb155102056#foaf:Person]
{/ud}
{ud0}
Emmanuel ben Jacob de Tarascon Bonfils ({dat1351}1351{/dat}) {en24}Astronome{/en}, {en28}médecin{/en} et {en16}mathématicien{/en} ayant vécu à Orange puis à Tarascon. Il est l''auteur de nombreux traités d''astronomie [http://data.bnf.fr/ark:/12148/cb15620448d#foaf:Person]
{/ud}
{ud0}
Ǧamšīd ibn Masʿūd Ġiyāṯ al-Dīn al- Kāšī ({dat1351}1351{/dat}) {en28}Médecin{/en}, {en16}mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb11351746b#foaf:Person]
{/ud}
{ud0}
Johannes Danck ({dat1351}1351{/dat}) {en24}Astronome{/en}. - A enseigné à l''Université de Paris de 1327 à 1355 [http://data.bnf.fr/ark:/12148/cb12531239r#foaf:Person]
{/ud}
{ud0}
Naǧm al-Dīn al- Miṣrī ({dat1351}1351{/dat}) Auteur supposé de traités portant sur les instruments astronomiques [http://data.bnf.fr/ark:/12148/cb14566743g#foaf:Person]
{/ud}
{ud0}
Prosdocimus de Beldemandis ({dat1351}1351{/dat}) Théoricien de la musique, {en16}mathématicien{/en} et physicien [http://data.bnf.fr/ark:/12148/cb127653823#foaf:Person]
{/ud}
{ud0}
Taddeo da Parma ({dat1351}1351{/dat}) {en18}Philosophe{/en} averroïste et {en24}astronome{/en}. - A enseigné la philosophie à Bologne vers 1320 [http://data.bnf.fr/ark:/12148/cb10103512f#foaf:Person]
{/ud}
{ud0}
Théodore Méliténiote ({en0li}Constantinople{/en}, {dat1351}1351{/dat}) Grand sacellaire de l''Église byzantine, maître des maîtres de l''École patriarcale et archidiacre du clergé palatin. - A laissé un ouvrage d''exégèse de l''Évangile, un traité d''astronomie et un poème allégorique [http://data.bnf.fr/ark:/12148/cb12153709d#foaf:Person]
{/ud}
{ud0}
Paolo dal Pozzo Toscanelli ({dat1397}1397{/dat}) {en16}Mathématicien{/en}, physicien, {en29}géographe{/en}, {en24}astronome{/en} et {en25}astrologue{/en}. - Inventeur des gnomons modernes. - Conservateur de la Bibliothèque de Florence [http://data.bnf.fr/ark:/12148/cb12455406j#foaf:Person]
{/ud}
{ud0}
Ugolino Pisani ({en0li}Parme, Italie{/en}, {dat1405}1405{/dat}) {en18}Philosophe{/en}, {en16}mathématicien{/en}, auteur de comédies [http://data.bnf.fr/ark:/12148/cb12689419t#foaf:Person]
{/ud}
{ud0}
Lorenzo Buonincontri ({en0li}San Miniato, Italie{/en}, {dat1411}1411{/dat}) Militaire, {en16}mathématicien{/en}, {en24}astronome{/en}, {en25}astrologue{/en}, poète et historien. - Professeur d''astronomie à Naples [http://data.bnf.fr/ark:/12148/cb12536229n#foaf:Person]
{/ud}
{ud0}
ʿAlī ibn Muḥammad al- Qalaṣādī ({en0li}Baza (Espagne){/en}, {dat1412}1412{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en}, juriste et savant [http://data.bnf.fr/ark:/12148/cb12440997n#foaf:Person]
{/ud}
{ud0}
Piero della Francesca ({en0li}Borgo San Sepolcro, Italie{/en}, {dat1416}1416{/dat}) Peintre. - A écrit des traités de mathématiques, perspective et géométrie et des écrits sur la science des couleurs et du paysage [http://data.bnf.fr/ark:/12148/cb12060279h#foaf:Person]
{/ud}
{ud0}
Georgius de Hungaria ({en0li}Romosz, aujourd''hui Romos, Roumanie{/en}, {dat1422}1422{/dat}) Prisonnier des Turcs (1438-1458). - Dominicain. - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb130923013#foaf:Person]
{/ud}
{ud0}
Antonio Manetti ({en0li}Florence, Italie{/en}, {dat1423}1423{/dat}) Homme de lettres. - Architecte, {en24}astronome{/en}, {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb11914242h#foaf:Person]
{/ud}
{ud0}
Georg von Peurbach ({en0li}Peuerbach, Autriche{/en}, {dat1423}1423{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb12374660w#foaf:Person]
{/ud}
{ud0}
Giovanni Pontano ({en0li}Cerreto di Spoleto (Perouse), Italie{/en}, {dat1426}1426{/dat}) Homme politique. - Humaniste. - Auteur de traités astronomiques et philosophiques [http://data.bnf.fr/ark:/12148/cb123298807#foaf:Person]
{/ud}
{ud0}
Johannes Regiomontanus ({en0li}Königsberg, Allemagne{/en}, {dat1436}1436{/dat}) {en24}Astronome{/en}. - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12159829r#foaf:Person]
{/ud}
{ud0}
Nīlakaṇṭha Somayajī ({dat1443}1443{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en} de l''école de Kerala (Inde) [http://data.bnf.fr/ark:/12148/cb165324540#foaf:Person]
{/ud}
{ud0}
Luca Pacioli ({dat1445}1445{/dat}) {en16}Mathématicien{/en}. - Franciscain [http://data.bnf.fr/ark:/12148/cb11918350c#foaf:Person]
{/ud}
{ud0}
Konrad Türst ({dat1450}1450{/dat}) {en16}Mathématicien{/en} suisse de Zürich [http://data.bnf.fr/ark:/12148/cb15336511g#foaf:Person]
{/ud}
{ud0}
Agostino Ricci ({dat1451}1451{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb12539498r#foaf:Person]
{/ud}
{ud0}
Andrea Corsali ({dat1451}1451{/dat}) {en24}Astronome{/en}, cosmographe, navigateur dans la péninsule arabique et aux Indes. - Pourrait avoir introduit l''imprimerie en Éthiopie (ca 1524), où vraisemblament il meurt [http://data.bnf.fr/ark:/12148/cb13517283d#foaf:Person]
{/ud}
{ud0}
Anianus ({dat1451}1451{/dat}) {en24}Astronome{/en} et poète [http://data.bnf.fr/ark:/12148/cb125156549#foaf:Person]
{/ud}
{ud0}
Antonio Dolciati ({dat1451}1451{/dat}) Augustinien et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb134854696#foaf:Person]
{/ud}
{ud0}
Bartolomeo da Messina ({dat1451}1451{/dat}) Écclésiastique et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb125393703#foaf:Person]
{/ud}
{ud0}
Gaspar Torrella ({dat1451}1451{/dat}) {en28}Médecin{/en} et {en16}mathématicien{/en}. - Évêque de Santa-Giusta (Sardaigne) en 1494. - Originaire de Valence (Espagne) [http://data.bnf.fr/ark:/12148/cb13486025q#foaf:Person]
{/ud}
{ud0}
Giovanni Abiosi ({dat1451}1451{/dat}) {en28}Médecin{/en}, {en24}astronome{/en}, {en16}mathématicien{/en} et {en18}philosophe{/en}. - Né à Bagnuolo (Royaume de Naples), mort vers 1500 [http://data.bnf.fr/ark:/12148/cb12537367q#foaf:Person]
{/ud}
{ud0}
Giovanni Antonio Tagliente ({dat1451}1451{/dat}) Calligraphe. - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12179148h#foaf:Person]
{/ud}
{ud0}
Giovanni Benedetto Moncetto ({dat1451}1451{/dat}) Agostinien. - Théologien, {en18}philosophe{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb125688716#foaf:Person]
{/ud}
{ud0}
Giovanni Bianchini ({dat1451}1451{/dat}) {en24}Astronome{/en} mort après 1469 [http://data.bnf.fr/ark:/12148/cb16163624s#foaf:Person]
{/ud}
{ud0}
Guillaume Hobit ({dat1451}1451{/dat}) {en24}Astronome{/en} ; {en25}astrologue{/en} de Philippe le Bon, duc de Bourgogne [http://data.bnf.fr/ark:/12148/cb15063496s#foaf:Person]
{/ud}
{ud0}
Jacob Köbel ({en0li}Heidelberg, Allemagne{/en}, {dat1451}1451{/dat}) {en16}Mathématicien{/en}, éditeur et libraire [http://data.bnf.fr/ark:/12148/cb10244031k#foaf:Person]
{/ud}
{ud0}
Louis Boulengier ({dat1451}1451{/dat}) {en24}Astronome{/en} et {en29}géographe{/en} d''Albi [http://data.bnf.fr/ark:/12148/cb152949413#foaf:Person]
{/ud}
{ud0}
Rāmacandrācārya ({dat1451}1451{/dat}) {en27}Grammairien{/en} et commentateur de Pāṇini (actif au 15e s.). - Fils de Kr̥ṣṇācārya. - A aussi écrit des ouvrages de philosophie (Vedānta) et d''astronomie [http://data.bnf.fr/ark:/12148/cb137708651#foaf:Person]
{/ud}
{ud0}
Sigismondo Fanti ({en0li}Ferrare, Italie{/en}, {dat1451}1451{/dat}) Poète, {en18}philosophe{/en} et {en16}mathématicien{/en}. - Meurt après 1527 [http://data.bnf.fr/ark:/12148/cb12567416q#foaf:Person]
{/ud}
{ud0}
Willem Gilliszoon ({dat1451}1451{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en}. - Originaire de Wissekerc (Zélande) [http://data.bnf.fr/ark:/12148/cb12548011q#foaf:Person]
{/ud}
{ud0}
Girolamo Donato ({dat1454}1454{/dat}) Magistrat, poète, {en18}philosophe{/en}, théologien et {en16}mathématicien{/en}. - Fut gouverneur de Brescia ({dat1496}1496{/dat}), de Ferrare ({dat1498}1498{/dat}), ambassadeur de Venise près le pape Jules II ({dat1510}1510{/dat}) [http://data.bnf.fr/ark:/12148/cb13325565p#foaf:Person]
{/ud}
{ud0}
Eliya Delmedigo ({dat1460}1460{/dat}) {en28}Médecin{/en}. - {en24}Astronome{/en}. - {en16}Mathématicien{/en}. - Né en Crète. - {en18}Philosophe{/en}. - Maître d''hébreu de Pic de la Mirandole (1463-1494). - Commentateur des écrits d''Averroés (1126-1198) [http://data.bnf.fr/ark:/12148/cb122623668#foaf:Person]
{/ud}
{ud0}
Lodovico Pontico Virunio ({dat1467}1467{/dat}) Professeur de lettres, {en18}philosophe{/en}, {en16}mathématicien{/en} et poète. - Fut chargé de l''éducation des fils de Ludovico Sforza, duc de Milan. - Eut l''intention de fonder une imprimerie grecque et latine à Reggio Emilia, mais ses caractères furent volés par Ludovico Bonaccioli, {en28}médecin{/en} de la duchesse de Ferrare. - Né à Belluno, meurt à Bologne [http://data.bnf.fr/ark:/12148/cb13324006j#foaf:Person]
{/ud}
{ud0}
Johannes Werner ({en0li}Nuremberg, Allemagne{/en}, {dat1468}1468{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en} et cartographe [http://data.bnf.fr/ark:/12148/cb154028305#foaf:Person]
{/ud}
{ud0}
Jakob Ziegler ({en0li}Landau (Allemagne){/en}, {dat1470}1470{/dat}) Théologien, {en16}mathématicien{/en}, {en24}astronome{/en} et {en29}géographe{/en}. - Professeur de théologie. - Commentateur et auteur d''ouvrages historiques et théologiques [http://data.bnf.fr/ark:/12148/cb15029346k#foaf:Person]
{/ud}
{ud0}
Pedro Ciruelo ({en0li}Daroca, Espagne{/en}, {dat1470}1470{/dat}) Professeur de théologie à l''Université d''Alcala (1510-), chanoine de la cathédrale de cette ville. - Fut l''un des précepteurs de Philippe II. - Étudia à Salamanque et à Paris, où il édita des oeuvres mathématiques et scientifiques. - Est également l''auteur d''un traité sur la sorcellerie dont la traduction espagnole eut une diffusion importante [http://data.bnf.fr/ark:/12148/cb128071494#foaf:Person]
{/ud}
{ud0}
Johann Stöffler ({en0li}Justingen, Allemagne{/en}, {dat1472}1472{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb125156905#foaf:Person]
{/ud}
{ud0}
Josse Clicthove (Nieuport, Pays-Bas, {dat1472}1472{/dat}) Théologien et {en16}mathématicien{/en}. - Théologal de Chartres. - Un des premiers à combattre les idées de Luther [http://data.bnf.fr/ark:/12148/cb12234610b#foaf:Person]
{/ud}
{ud0}
Bartolomeo Zamberti ({en0li}Venise, Italie{/en}, {dat1473}1473{/dat}) {en16}Mathématicien{/en} et humaniste. - Professeur de lettres. - Notaire des Consuls des marchands de Venise [http://data.bnf.fr/ark:/12148/cb12033590z#foaf:Person]
{/ud}
{ud0}
Nicolas Copernic ({dat1473}1473{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb118976048#foaf:Person]
{/ud}
{ud0}
Luca Gaurico ({en0li}Giffoni, Italie{/en}, {dat1476}1476{/dat}) Évêque de Civita Ducale (1545-1549). - {en16}Mathématicien{/en}, {en18}philosophe{/en}, {en24}astronome{/en} et {en25}astrologue{/en} [http://data.bnf.fr/ark:/12148/cb134849440#foaf:Person]
{/ud}
{ud0}
Johann Schöner ({dat1477}1477{/dat}) Né à Karlstadt près de Würzburg. - Prédicateur protestant. - {en24}Astronome{/en}. - {en29}Géographe{/en}. - Professeur de mathématiques à Nuremberg. - A aussi écrit en latin [http://data.bnf.fr/ark:/12148/cb119992233#foaf:Person]
{/ud}
{ud0}
Girolamo Fracastoro ({en0li}Vérone, Italie{/en}, {dat1478}1478{/dat}) {en28}Médecin{/en}, auteur du "De contagione et contagiosis morbis et curatione libri III" ; nommé par le pape Paul III {en28}médecin{/en} officiel du Concile de Trente. - Auteur de poèmes en latin, d''oeuvres de géographie, d''astronomie, de physique, de théologie et de philosophie. - Élève de Pomponazzi, ami de Copernic [http://data.bnf.fr/ark:/12148/cb120587788#foaf:Person]
{/ud}
{ud0}
Girolamo Francastoro ({dat1478}1478{/dat}) {en28}Médecin{/en}, {en24}astronome{/en}, géologiste, poète, précurseur de la notion de contagion [http://data.bnf.fr/ark:/12148/cb15699396m#foaf:Person]
{/ud}
{ud0}
Celio Calcagnini ({en0li}Ferrare, Italie{/en}, {dat1479}1479{/dat}) Poète, philologue, {en18}philosophe{/en} et {en24}astronome{/en}. - Accompagna Hippolyte d''Este en Hongrie et en Pologne [http://data.bnf.fr/ark:/12148/cb122157991#foaf:Person]
{/ud}
{ud0}
Charles de Bovelles ({dat1479}1479{/dat}) {en18}Philosophe{/en}, {en16}mathématicien{/en} et linguiste. - Chanoine de Noyon. - Né avant le 28 mars 1479 [http://data.bnf.fr/ark:/12148/cb118932166#foaf:Person]
{/ud}
{ud0}
Prospero Calano ({en0li}Sarzana, Italie{/en}, {dat1480}1480{/dat}) {en28}Médecin{/en}, {en24}astronome{/en} et {en18}philosophe{/en} [http://data.bnf.fr/ark:/12148/cb12568870v#foaf:Person]
{/ud}
{ud0}
Vannoccio Biringuccio ({en0li}Sienne, Italie{/en}, {dat1480}1480{/dat}) {en16}Mathématicien{/en}, chimiste, architecte et ingénieur, spécialiste en métallurgie [http://data.bnf.fr/ark:/12148/cb12195640k#foaf:Person]
{/ud}
{ud0}
Michael Stifel ({dat1487}1487{/dat}) Théologien et {en16}mathématicien{/en}. - Inventeur du logarithme. - Enseigna la théologie et les mathématiques à l''Université de Königsberg, puis les mathématiques à l''Université de Iéna [http://data.bnf.fr/ark:/12148/cb12795734z#foaf:Person]
{/ud}
{ud0}
Sebastian Münster ({en0li}Ingelheim, Allemagne{/en}, {dat1489}1489{/dat}) Hébraïsant, {en29}géographe{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb11996987j#foaf:Person]
{/ud}
{ud0}
Albert Pighius (Kampen, Pays-Bas, {dat1490}1490{/dat}) Théologien, {en16}mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb10448635x#foaf:Person]
{/ud}
{ud0}
Patrizio Tricasso ({en0li}Ceresara, Italie{/en}, {dat1491}1491{/dat}) Dominicain. - {en16}Mathématicien{/en} et {en25}astrologue{/en} [http://data.bnf.fr/ark:/12148/cb107034397#foaf:Person]
{/ud}
{ud0}
Heinrich Schreiber ({en0li}Erfurt, Allemagne{/en}, {dat1492}1492{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb10734904t#foaf:Person]
{/ud}
{ud0}
Jean Borrel ({dat1492}1492{/dat}) Géomètre et {en16}mathématicien{/en}. - Chanoine régulier de l''Ordre de Saint-Antoine [http://data.bnf.fr/ark:/12148/cb12515817n#foaf:Person]
{/ud}
{ud0}
Pedro Nunez ({dat1492}1492{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12548918m#foaf:Person]
{/ud}
{ud0}
Oronce Fine (Briançon (Hautes-Alpes), {dat1494}1494{/dat}) Sieur de Champrouet. - {en16}Mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb122937307#foaf:Person]
{/ud}
{ud0}
Petrus Apian ({en0li}Leisnig (Allemagne){/en}, {dat1495}1495{/dat}) {en24}Astronome{/en}, cartographe et {en16}mathématicien{/en}. - Nommé Chevalier de l''Empire par Charles Quint. - Surnom de : Bienewitz (ou Bennewitz), Peter [http://data.bnf.fr/ark:/12148/cb12515640m#foaf:Person]
{/ud}
{ud0}
Andreas Osiander ({en0li}Gunzenhausen, Allemagne{/en}, {dat1498}1498{/dat}) Théologien protestant, {en24}astronome{/en} et {en16}mathématicien{/en}. - Parfois désigné sous le nom "Andreas Osiander l''Ancien" [http://data.bnf.fr/ark:/12148/cb11988942v#foaf:Person]
{/ud}
{ud0}
Garcia da Orta ({en0li}Castelo di Vide, Portugal{/en}, {dat1499}1499{/dat}) {en28}Médecin{/en} et naturaliste. - A enseigné les mathématiques à l''Université de Lisbonne [http://data.bnf.fr/ark:/12148/cb119983323#foaf:Person]
{/ud}
{ud0}
Giovanni Agostino Abate ({dat1499}1499{/dat}) {en16}Mathématicien{/en} et historien [http://data.bnf.fr/ark:/12148/cb14624324z#foaf:Person]
{/ud}
{ud0}
Joachim Sterck van Ringelberg ({en0li}Anvers, Belgique{/en}, {dat1499}1499{/dat}) Humaniste, {en16}mathématicien{/en} et {en25}astrologue{/en}. - Meurt selon les sources le 1er janvier 1531, en 1536 ou en 1556 [http://data.bnf.fr/ark:/12148/cb10645118k#foaf:Person]
{/ud}
{ud0}
Johann Carion ({en0li}Bietigheim, Allemagne{/en}, {dat1499}1499{/dat}) {en25}Astrologue{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12805831h#foaf:Person]
{/ud}
{ud0}
Johannes Dryander ({en0li}Wetter, Allemagne{/en}, {dat1500}1500{/dat}) {en16}Mathématicien{/en}, physicien et {en24}astronome{/en}, professeur à Marburg, édité par Sebastian Münster et Abraham Ortelius [http://data.bnf.fr/ark:/12148/cb15379218m#foaf:Person]
{/ud}
{ud0}
Johannes Voegelin ({en0li}Heilbronn, Allemagne{/en}, {dat1500}1500{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en}. - Professeur à l''Université de Vienne [http://data.bnf.fr/ark:/12148/cb10490264h#foaf:Person]
{/ud}
{ud0}
Niccolò Tartaglia ({dat1500}1500{/dat}) {en16}Mathématicien{/en}, ingénieur et architecte. - Pseudonyme de Niccolò Fontana [http://data.bnf.fr/ark:/12148/cb12914492r#foaf:Person]
{/ud}
{ud0}
Gerolamo Cardano ({en0li}Pavie, Italie{/en}, {dat1501}1501{/dat}) {en28}Médecin{/en}, {en16}mathématicien{/en} et {en18}philosophe{/en} [http://data.bnf.fr/ark:/12148/cb11895137c#foaf:Person]
{/ud}
{ud0}
Pedro Nunes ({en0li}Alcácer do Sol (Portugal){/en}, {dat1502}1502{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en} portugais [http://data.bnf.fr/ark:/12148/cb13510349t#foaf:Person]
{/ud}
{ud0}
Cosimo Bartoli ({en0li}Florence, Italie{/en}, {dat1503}1503{/dat}) Ambassadeur, poète et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb125520809#foaf:Person]
{/ud}
{ud0}
Jean Cousin ({en0li}Soucy (Yonne, France){/en}, {dat1503}1503{/dat}) Peintre, sculpteur, graveur, architecte, {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12467444s#foaf:Person]
{/ud}
{ud0}
Ciriaco Strozzi ({en0li}Capalle, Italie{/en}, {dat1504}1504{/dat}) Helléniste, {en18}philosophe{/en}, {en16}mathématicien{/en} et architecte [http://data.bnf.fr/ark:/12148/cb10418521b#foaf:Person]
{/ud}
{ud0}
Jacques Bassantin ({dat1504}1504{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12548014r#foaf:Person]
{/ud}
{ud0}
Achille Pirminius Gasser ({dat1505}1505{/dat}) {en28}Médecin{/en}, historien et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb12516715x#foaf:Person]
{/ud}
{ud0}
Benedictus Aretius ({dat1505}1505{/dat}) Théologien protestant. - Botaniste et {en24}astronome{/en}. - Professeur de logique à l''Université de Marbourg, puis professeur de théologie à Berne. - Fut lié avec Conrad Gesner. - Né et mort à Berne [http://data.bnf.fr/ark:/12148/cb12515850g#foaf:Person]
{/ud}
{ud0}
Alessandro Piccolomini ({en0li}Sienne, Italie{/en}, {dat1508}1508{/dat}) {en26}Écrivain{/en}, dramaturge, {en24}astronome{/en} et traducteur d''oeuvres de l''Antiquité, de comédies, de traités philosophiques et scientifiques. - Membre de l''Accademia degli Intronati de Sienne, sous le pseudonyme : lo Stordito. - Archevêque de Patras et coadjuteur de l''archevêque de Sienne Francesco Bandini Piccolomini, du 28 juillet 1574 à 1578 [http://data.bnf.fr/ark:/12148/cb12240709n#foaf:Person]
{/ud}
{ud0}
Gemma Frisius (Dokkum (Pays-Bas), {dat1508}1508{/dat}) {en16}Mathématicien{/en} et {en24}astronome{/en}. - Professeur et docteur en médecine de l''Université de Louvain [http://data.bnf.fr/ark:/12148/cb125195002#foaf:Person]
{/ud}
{ud0}
Federico Commandino ({en0li}Sassocorvaro, Italie{/en}, {dat1509}1509{/dat}) {en16}Mathématicien{/en}. - A été le tuteur du duc d''Urbino [http://data.bnf.fr/ark:/12148/cb12562850s#foaf:Person]
{/ud}
{ud0}
Jean Gosselin ({en0li}Vire, Calvados{/en}, {dat1510}1510{/dat}) {en25}Astrologue{/en} et {en16}mathématicien{/en}. - Conservateur de la bibliothèque du roi [http://data.bnf.fr/ark:/12148/cb133321861#foaf:Person]
{/ud}
{ud0}
Pietro Cataneo ({dat1510}1510{/dat}) Architecte et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12557068n#foaf:Person]
{/ud}
{ud0}
Erasmus Oswald Schreckenfuchs ({dat1511}1511{/dat}) Hébraïsant. - {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb12115338j#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Amici ({en0li}Cosenza, Italie{/en}, {dat1511}1511{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb15583428k#foaf:Person]
{/ud}
{ud0}
Juanelo Turriano ({dat1511}1511{/dat}) {en16}Mathématicien{/en} et ingénieur [http://data.bnf.fr/ark:/12148/cb129309990#foaf:Person]
{/ud}
{ud0}
Gerard Mercator ({en0li}Rupelmonde, Flandres{/en}, {dat1512}1512{/dat}) {en29}Géographe{/en}, cartographe, cosmographe et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12789989j#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Amico ({dat1512}1512{/dat}) {en18}Philosophe{/en}, {en16}mathématicien{/en} et {en25}astrologue{/en}. - Originaire de Cosenza, fut assassiné à Padoue [http://data.bnf.fr/ark:/12148/cb12570280s#foaf:Person]
{/ud}
{ud0}
Juan Pérez de Moya ({dat1513}1513{/dat}) {en16}Mathématicien{/en} et humaniste [http://data.bnf.fr/ark:/12148/cb12146300q#foaf:Person]
{/ud}
{ud0}
Rheticus ({dat1514}1514{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb13615799v#foaf:Person]
{/ud}
{ud0}
Bernardino Baldini ({dat1515}1515{/dat}) Professeur de médecine à Pavie puis de mathématiques à Milan [http://data.bnf.fr/ark:/12148/cb13163998r#foaf:Person]
{/ud}
{ud0}
Petrus Ramus ({en0li}Cuts (Aisne){/en}, {dat1515}1515{/dat}) {en18}Philosophe{/en}, {en27}grammairien{/en}, {en16}mathématicien{/en} et humaniste. - Professeur de mathématique au Collège royal (Collège de France). - Se convertit au protestantisme et fut tué au cours du Massacre de la Saint-Barthélemy [http://data.bnf.fr/ark:/12148/cb120645094#foaf:Person]
{/ud}
{ud0}
Jean-Pierre de Mesmes ({dat1516}1516{/dat}) Savant et poète. - Fils de Pierre de Mesmes, chambellan du roi de Navarre. - Etait lié avec Ronsard, du Bellay, Baïf, Charondas, Herberay, Jean Maugin, Ol. de Magny. - A était un des premiers auteurs à avoir écrit en français sur l''astronomie [http://data.bnf.fr/ark:/12148/cb125177720#foaf:Person]
{/ud}
{ud0}
Jacques Peletier ({dat1517}1517{/dat}) Poète et critique humaniste. - {en16}Mathématicien{/en}. - A participé à la réforme de l''orthographe. - Traducteur d''Horace [http://data.bnf.fr/ark:/12148/cb122992680#foaf:Person]
{/ud}
{ud0}
Jeronimo Munoz ({dat1520}1520{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb14646245j#foaf:Person]
{/ud}
{ud0}
Livio Sanuto ({dat1520}1520{/dat}) {en29}Géographe{/en} et {en16}mathématicien{/en} à Venise, fabriquant d''un globe avec son frère Giulio en 1561 [http://data.bnf.fr/ark:/12148/cb153816227#foaf:Person]
{/ud}
{ud0}
Melchior Ayrer ({dat1520}1520{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb162974318#foaf:Person]
{/ud}
{ud0}
Nicolaus Gugler ({en0li}Nuremberg (Allemagne){/en}, {dat1521}1521{/dat}) {en28}Médecin{/en} et {en24}astronome{/en}, a reçu une formation de juriste. - Fils de Hans Gugler (1480-1560) [http://data.bnf.fr/ark:/12148/cb16504896w#foaf:Person]
{/ud}
{ud0}
Valentin Mennher ({dat1521}1521{/dat}) {en16}Mathématicien{/en}. - Membre de la guilde des instituteurs d''Anvers [http://data.bnf.fr/ark:/12148/cb12563197r#foaf:Person]
{/ud}
{ud0}
Hermann Witekind ({en0li}Neuenrade (Allemagne){/en}, {dat1522}1522{/dat}) {en16}Mathématicien{/en} et humaniste [http://data.bnf.fr/ark:/12148/cb162248258#foaf:Person]
{/ud}
{ud0}
Giovanni Maria Bonardo ({en0li}Fratta Polesine, Italie{/en}, {dat1523}1523{/dat}) Poète. - Agronome. - {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb12181418p#foaf:Person]
{/ud}
{ud0}
Juan de Yciar (Durango (prov. de Vizcaya), {dat1523}1523{/dat}) Pédagogue, {en16}mathématicien{/en} et calligraphe [http://data.bnf.fr/ark:/12148/cb128696315#foaf:Person]
{/ud}
{ud0}
Jacques Charpentier (Clermont-en-Beauvaisis ({en0li}Oise){/en}, {dat1524}1524{/dat}) {en18}Philosophe{/en} et {en28}médecin{/en}. - Lecteur de mathématiques au Collège de France. - {en28}Médecin{/en} du roi [http://data.bnf.fr/ark:/12148/cb121323921#foaf:Person]
{/ud}
{ud0}
Tadeáš Hájek ({en0li}Prague{/en}, {dat1525}1525{/dat}) {en16}Mathématicien{/en} et {en28}médecin{/en}. - Reçu docteur à Bologne, occupa une chaire au Carolinum de Prague, fut premier {en28}médecin{/en} des empereurs Maximilien II et Rodolphe II [http://data.bnf.fr/ark:/12148/cb13009688n#foaf:Person]
{/ud}
{ud0}
Tilemann Stella ({en0li}Siegen (Allemagne){/en}, {dat1525}1525{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en}, {en29}géographe{/en}, architecte et bibliothécaire. - Cartographe à Wittenberg, ses cartes ont été éditées par Ortelius, Jode et Hondius [http://data.bnf.fr/ark:/12148/cb15376436c#foaf:Person]
{/ud}
{ud0}
Taqī al-Dīn Muḥammad Ibn Maʿrūf ({en0li}Damas{/en}, {dat1526}1526{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en} ottoman [http://data.bnf.fr/ark:/12148/cb14599962n#foaf:Person]
{/ud}
{ud0}
John Dee ({dat1527}1527{/dat}) {en25}Astrologue{/en}, {en16}mathématicien{/en} et antiquaire [http://data.bnf.fr/ark:/12148/cb119854464#foaf:Person]
{/ud}
{ud0}
Adam Lonicer ({en0li}Marburg (Allemagne){/en}, {dat1528}1528{/dat}) {en28}Medecin{/en} et botaniste. - Professeur de médecine, chimie et mathématiques. - Fils du théologien : Lonicer, Johann (1499-15969) [http://data.bnf.fr/ark:/12148/cb10279221n#foaf:Person]
{/ud}
{ud0}
Cornelius Blockland ({dat1530}1530{/dat}) Musicien, {en25}astrologue{/en}, {en16}mathématicien{/en} et {en28}médecin{/en}. - Actif de 1571 à 1586. - Frère du peintre Anthonie Blockland van Montfort [http://data.bnf.fr/ark:/12148/cb13497580p#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Benedetti ({en0li}Venise, Italie{/en}, {dat1530}1530{/dat}) {en16}Mathématicien{/en} et ingénieur. - Fondateur de la géométrie analytique [http://data.bnf.fr/ark:/12148/cb11998820g#foaf:Person]
{/ud}
{ud0}
Jean Péna ({dat1530}1530{/dat}) {en16}Mathématicien{/en}, traducteur et éditeur de textes mathématiques et géométriques antiques [http://data.bnf.fr/ark:/12148/cb13483147k#foaf:Person]
{/ud}
{ud0}
Conradus Dasypodius ({en0li}Frauenfeld, Suisse{/en}, {dat1531}1531{/dat}) {en16}Mathématicien{/en}. - A tracé le plan de l''horloge astronomique de la cathédrale de Strasbourg [http://data.bnf.fr/ark:/12148/cb16534831x#foaf:Person]
{/ud}
{ud0}
Ercole Bottrigari ({dat1531}1531{/dat}) Humaniste, {en16}mathématicien{/en}, musicien, poète, linguiste et {en18}philosophe{/en} [http://data.bnf.fr/ark:/12148/cb125347809#foaf:Person]
{/ud}
{ud0}
Giuseppe Moletti ({dat1531}1531{/dat}) Cosmographe et {en29}géographe{/en}. - Professeur de médecine, de mathématique et d''astronomie à l''Université de Padoue [http://data.bnf.fr/ark:/12148/cb134849518#foaf:Person]
{/ud}
{ud0}
Philip Apian ({en0li}Ingoldstadt, Allemagne{/en}, {dat1531}1531{/dat}) Cartographe, {en16}mathématicien{/en} et physicien. - Fils de Peter Apian, succède à son père à l''Université d''Ingolstadt [http://data.bnf.fr/ark:/12148/cb152383864#foaf:Person]
{/ud}
{ud0}
Fabrizio Mordente ({en0li}Salerne, Italie{/en}, {dat1532}1532{/dat}) {en16}Mathématicien{/en}. - A inventé le compas de proportion à huit points [http://data.bnf.fr/ark:/12148/cb14643668k#foaf:Person]
{/ud}
{ud0}
Egnatio Danti ({en0li}Pérouse, Italie{/en}, {dat1536}1536{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en}, cartographe et cosmographe. - Dominicain [http://data.bnf.fr/ark:/12148/cb145332908#foaf:Person]
{/ud}
{ud0}
Henri de Monantheuil ({dat1536}1536{/dat}) {en16}Mathématicien{/en} et {en28}médecin{/en}. - Régent de la Faculté de médecine de Paris, puis professeur de mathématiques au Collège de France (1574-). - Né à Reims, meurt à Paris [http://data.bnf.fr/ark:/12148/cb13006651k#foaf:Person]
{/ud}
{ud0}
Christophorus Clavius ({dat1537}1537{/dat}) Jésuite, musicien et professeur de mathématiques. - Fut chargé par Grégoire XIII de la réforme du calendrier [http://data.bnf.fr/ark:/12148/cb125466080#foaf:Person]
{/ud}
{ud0}
Francesco Barozzi ({en0li}Heraklion, Grèce{/en}, {dat1537}1537{/dat}) {en16}Mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb10462395x#foaf:Person]
{/ud}
{ud0}
Giovanni Paolo Gallucci ({en0li}Salò, Italie{/en}, {dat1538}1538{/dat}) {en24}Astronome{/en}. - Homme de lettres [http://data.bnf.fr/ark:/12148/cb106019703#foaf:Person]
{/ud}
{ud0}
Philips Mor ({dat1539}1539{/dat}) Humaniste, {en16}mathématicien{/en} et poète néolatin. - Chanoine du chapitre de St Salvator d''Utrecht. - Fils du peintre Anthonis Mor van Dashorst (Antonio Moro) [http://data.bnf.fr/ark:/12148/cb12384177f#foaf:Person]
{/ud}
{ud0}
François Viète (Fontenay-le-Comte ({en0li}Vendée){/en}, {dat1540}1540{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb120511976#foaf:Person]
{/ud}
{ud0}
Cormopede ({dat1541}1541{/dat}) {en16}Mathématicien{/en} et {en25}astrologue{/en}. - Gentilhomme de la maison du Comte de Sterckenberg. - Date de naissance présumée d''après le "portrait de Cormopede à l''âge de 51 ans" figurant au F. A. 2 de l''"Almanach des almanachs pour l''an MDXCIII" [http://data.bnf.fr/ark:/12148/cb13491791f#foaf:Person]
{/ud}
{ud0}
Giovanni di Strasoldo ({dat1544}1544{/dat}) Noble. - Homme d''arme. - {en16}Mathématicien{/en}. - Poète [http://data.bnf.fr/ark:/12148/cb15122132t#foaf:Person]
{/ud}
{ud0}
Guidobaldo Dal Monte ({dat1545}1545{/dat}) {en16}Mathématicien{/en} et {en24}astronome{/en}. - Protégea {en7}Galilée{/en} et lui fit obtenir sa première chaire à Pise. - Né à Pesaro, meurt dans son chateau de Monte Baroccio [http://data.bnf.fr/ark:/12148/cb135173214#foaf:Person]
{/ud}
{ud0}
Renward Cysat ({en0li}Lucerne (Suisse){/en}, {dat1545}1545{/dat}) Chancelier de la ville de Lucerne, Suisse. - Historien, dramaturge, pharmacien et naturaliste. - Père de : Cysat, Johann Baptist (1587-1653), {en16}mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb12748433g#foaf:Person]
{/ud}
{ud0}
Maurice Bressieu ({dat1546}1546{/dat}) {en16}Mathématicien{/en}, {en18}philosophe{/en} et humaniste. - Titulaire de la chaire de mathématiques au Collège de France (1575-), orateur des rois de France à Rome (1586-), intendant de la Bibliothèque vaticane [http://data.bnf.fr/ark:/12148/cb13495175h#foaf:Person]
{/ud}
{ud0}
Tycho Brahe ({en0li}Knudstrup (Suède){/en}, {dat1546}1546{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb11893749j#foaf:Person]
{/ud}
{ud0}
Muḥammad ibn al-Ḥusayan Bahāʼ al-Dīn ʿĀmilī ({dat1547}1547{/dat}) Érudit arabe, {en18}philosophe{/en}, théologien, {en24}astronome{/en}, {en27}grammairien{/en}, auteur d''anthologies [http://data.bnf.fr/ark:/12148/cb12451570z#foaf:Person]
{/ud}
{ud0}
Nicodemus Frischlin ({en0li}Balingen, Allemagne{/en}, {dat1547}1547{/dat}) Philologue et {en26}écrivain{/en}. - A enseigné les belles-lettres et les mathématiques à l''Université de Tubingue. - Traducteur d''Aristophane, de Callimaque et de Tryphiodore. - Auteur d''une comédie, présentée devant l''empereur Rodolphe, qui lui décerna le titre de comte-palatin [http://data.bnf.fr/ark:/12148/cb12463064b#foaf:Person]
{/ud}
{ud0}
Michele Zappulo ({dat1548}1548{/dat}) Docteur en droit canon et civil. - {en24}Astronome{/en}, historien et poète [http://data.bnf.fr/ark:/12148/cb125454264#foaf:Person]
{/ud}
{ud0}
Simon Stevin ({en0li}Bruges, Belgique{/en}, {dat1548}1548{/dat}) Professeur de mathématiques de Maurice de Nassau [http://data.bnf.fr/ark:/12148/cb119941019#foaf:Person]
{/ud}
{ud0}
Michel Coignet ({dat1549}1549{/dat}) Ingénieur, {en16}mathématicien{/en}, fabricant d''instruments de navigation, poète [http://data.bnf.fr/ark:/12148/cb124231863#foaf:Person]
{/ud}
{ud0}
Francisco Sánchez ({dat1550}1550{/dat}) {en28}Médecin{/en}, {en18}philosophe{/en}, {en16}mathématicien{/en} et poète. - Également connu sous le pseudonyme d''El Escéptico [http://data.bnf.fr/ark:/12148/cb120172346#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Crispo ({en0li}Gallipoli, Italie{/en}, {dat1550}1550{/dat}) Prêtre. - {en16}Mathématicien{/en}, théologien et homme de lettres [http://data.bnf.fr/ark:/12148/cb10615268s#foaf:Person]
{/ud}
{ud0}
John Napier ({dat1550}1550{/dat}) {en16}Mathématicien{/en} et théologien. - Baron de Merchiston [http://data.bnf.fr/ark:/12148/cb12353925j#foaf:Person]
{/ud}
{ud0}
Michael Moestlin ({dat1550}1550{/dat}) Né à Göppingen (Wurtemberg). - {en16}Mathématicien{/en}. - {en24}Astronome{/en}. - Luthérien, hostile à la réforme grégorienne du calendrier [http://data.bnf.fr/ark:/12148/cb12330628m#foaf:Person]
{/ud}
{ud0}
Sigfridus Aronus Forsius ({dat1550}1550{/dat}) {en24}Astronome{/en} et {en25}astrologue{/en} finlandais [http://data.bnf.fr/ark:/12148/cb131923734#foaf:Person]
{/ud}
{ud0}
Aegidius Martini ({dat1551}1551{/dat}) Cartographe, {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb15376579x#foaf:Person]
{/ud}
{ud0}
al-Silahî Nasuh ({dat1551}1551{/dat}) Savant, miniaturiste et calligraphe ottoman. - A écrit plusieurs ouvrages sur les armes et les combats, sur la géométrie et les mathématiques ainsi que sur l''histoire. - Inventeur du jeu de "matraque", il est mieux connu sous son surnom "Matrakçı" : "Matrakçı Nasuh Efendi", "Nasuh al-Silahî", "Matraki", "Nasuh el-Mitraki", "Nasuh üs-Silahi", "Matraqçi Nasuh", "Nasuh b. Abdullah" et "Nasuh b. Karagöz el-Bosnevi" sont parmi les autres formes de référence [http://data.bnf.fr/ark:/12148/cb119562090#foaf:Person]
{/ud}
{ud0}
Anthoine Cathalan ({dat1551}1551{/dat}) Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb14526861v#foaf:Person]
{/ud}
{ud0}
Bartolomeo Crescenzio ({dat1551}1551{/dat}) {en16}Mathématicien{/en}, ingénieur naval et voyageur. - Fut capitaine de galère de la marine pontificale [http://data.bnf.fr/ark:/12148/cb125466487#foaf:Person]
{/ud}
{ud0}
Bernardo Gamucci ({en0li}San Gimignano, Italie{/en}, {dat1551}1551{/dat}) Archéologue, architecte et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb10435220v#foaf:Person]
{/ud}
{ud0}
Camillo Agrippa ({dat1551}1551{/dat}) {en18}Philosophe{/en}, {en16}mathématicien{/en}, architecte et ingénieur. - Est aussi l''auteur de l''un des premiers traité d''escrime [http://data.bnf.fr/ark:/12148/cb12536260s#foaf:Person]
{/ud}
{ud0}
Claude de Boissière ({dat1551}1551{/dat}) {en16}Mathématicien{/en}. - Auteur d''un "Art poétique" [http://data.bnf.fr/ark:/12148/cb12509709h#foaf:Person]
{/ud}
{ud0}
Didier Henrion ({dat1551}1551{/dat}) Professeur de mathématiques à Paris. - Ingénieur au service des Provinces-Unies. - N''est pas un pseudonyme de Clément Cyriaque de Mangin [http://data.bnf.fr/ark:/12148/cb144882445#foaf:Person]
{/ud}
{ud0}
Eilhard Lubbin ({dat1551}1551{/dat}) Cartographe et {en16}mathématicien{/en} à Rostock [http://data.bnf.fr/ark:/12148/cb153777849#foaf:Person]
{/ud}
{ud0}
Faustus Verantius (Sebenico aujord''hui Šibenik ({en0li}Croatie){/en}, {dat1551}1551{/dat}) Lexicographe, physicien et {en16}mathématicien{/en}. - Évêque de Czanad (Hongrie) ({dat1594}1594{/dat}) et de la République de Venise. - Neveu d''Antun Vrančić (1504-1573) [http://data.bnf.fr/ark:/12148/cb10703670x#foaf:Person]
{/ud}
{ud0}
Francesco Feliciano ({dat1551}1551{/dat}) {en16}Mathématicien{/en}, augustinien et miniaturiste [http://data.bnf.fr/ark:/12148/cb13485419n#foaf:Person]
{/ud}
{ud0}
Francis Van Schoten ({dat1551}1551{/dat}) Professeur de mathématiques à Leyde, cartographe [http://data.bnf.fr/ark:/12148/cb15337130w#foaf:Person]
{/ud}
{ud0}
Francisco Zarzoso ({en0li}Cella, Espagne{/en}, {dat1551}1551{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb119512329#foaf:Person]
{/ud}
{ud0}
Giacomo Lanteri ({en0li}Paratico, Italie{/en}, {dat1551}1551{/dat}) {en16}Mathématicien{/en} et ingénieur [http://data.bnf.fr/ark:/12148/cb104024969#foaf:Person]
{/ud}
{ud0}
Girolamo Mercurio ({dat1551}1551{/dat}) Dominicain. - {en28}Médecin{/en}, professeur de logique et de mathématique [http://data.bnf.fr/ark:/12148/cb13484092c#foaf:Person]
{/ud}
{ud0}
Giuseppe Unicorno ({dat1551}1551{/dat}) {en16}Mathématicien{/en}. - {en18}Philosophe{/en}. - {en25}Astrologue{/en}. - Musicologue. - Théologien. - Originaire de Bergame [http://data.bnf.fr/ark:/12148/cb125394931#foaf:Person]
{/ud}
{ud0}
Helisaeus Röslin ({dat1551}1551{/dat}) {en16}Mathématicien{/en}. - {en24}Astronome{/en}. - {en28}Médecin{/en} (pratiquait à Strasbourg et Francfort) [http://data.bnf.fr/ark:/12148/cb132003253#foaf:Person]
{/ud}
{ud0}
Jacques Besson ({en0li}Colombières (Italie){/en}, {dat1551}1551{/dat}) Ingénieur et {en16}mathématicien{/en}. - Né à Colombières, vallée d''Oulx (aujourd''hui en Italie), d''après Eugénie Droz [http://data.bnf.fr/ark:/12148/cb12376654f#foaf:Person]
{/ud}
{ud0}
Jacques Maretz ({dat1551}1551{/dat}) Dessinateur et graveur, {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb153705873#foaf:Person]
{/ud}
{ud0}
Jamet Mettayer ({dat1551}1551{/dat}) Autre(s) graphie(s) : Metayer ; Messor ; Metayerus ; Mettayier. - Variante(s) de prénom : Jean ; Jean Jamet. - Imprimeur-libraire ; imprimeur du Roi pour les mathématiques ({dat1580}1580{/dat}) et imprimeur ordinaire du Roi (1583-1605). - En 1588, le roi Henri III le fait imprimeur officiel de sa congrégation des pénitents de l''Annonciation. De 1588 à 1594, il suit le Roi et la Cour à Blois puis  à Tours. - De retour à Paris, doit partager sa charge avec Pierre L''Huillier et Fédéric II Morel en vertu de l''arrêt du Conseil du 20 avril 1594. Revend à Tours son atelier et sa boutique à l''imprimeur Maurice Bouguereau. En mars  1596, le Roi l''associe à la Compagnie des usages avec Pierre L''Huillier. Décédé avant le 12 fév. 1605. Des publications paraissent encore sous son nom jusqu''en 1614. - A travaillé en association avec Mathurin Challenge ({dat1573}1573{/dat}) et Barthélemy Gomet à Blois. S''associe à Tours (oct. 1591 - oct. 1593) avec Jean Richer, Claude de Monstr''oeil, Sébastien Molin, Mathieu I Guillemot, Georges Drobet et Marc Orry, son gendre. Travaille en association étroite avec Pierre L''Huillier et avec son fils Pierre Mettayer qui se trouvaient eux aussi à Tours [http://data.bnf.fr/ark:/12148/cb125031934#foaf:Person]
{/ud}
{ud0}
Jean Brohon ({dat1551}1551{/dat}) {en28}Médecin{/en}, botaniste et {en24}astronome{/en}. - Fut recteur de l''Université de Caen [http://data.bnf.fr/ark:/12148/cb12545367f#foaf:Person]
{/ud}
{ud0}
Jean de Seville ({dat1551}1551{/dat}) {en16}Mathématicien{/en} et hydrographe [http://data.bnf.fr/ark:/12148/cb13496046w#foaf:Person]
{/ud}
{ud0}
Jean Maria Coloni ({dat1551}1551{/dat}) Citoyen de Romans en Dauphiné. - {en16}Mathématicien{/en} et {en25}astrologue{/en} [http://data.bnf.fr/ark:/12148/cb13479237s#foaf:Person]
{/ud}
{ud0}
Jean Tagaut ({dat1551}1551{/dat}) Poète. - {en28}Médecin{/en}, {en16}mathématicien{/en}, professeur à Lausanne et Genève [http://data.bnf.fr/ark:/12148/cb12249180j#foaf:Person]
{/ud}
{ud0}
Joannes Portantius ({dat1551}1551{/dat}) {en24}Astronome{/en}, {en16}mathématicien{/en} et {en29}géographe{/en} à Anvers, édité par Ortelius et De Jode [http://data.bnf.fr/ark:/12148/cb153817246#foaf:Person]
{/ud}
{ud0}
Johann Georg Locher ({dat1551}1551{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb13006978f#foaf:Person]
{/ud}
{ud0}
Juan de Rojas Sarmiento ({en0li}Palencia, Espagne{/en}, {dat1551}1551{/dat}) {en16}Mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb140653109#foaf:Person]
{/ud}
{ud0}
Marc Duncan ({dat1551}1551{/dat}) {en28}Médecin{/en}, originaire d''Écosse, s''établit à Saumur en 1606 à l''appel de l''Académie protestante de la ville. - Professeur de mathématiques, de grec et d''humanités [http://data.bnf.fr/ark:/12148/cb13006401g#foaf:Person]
{/ud}
{ud0}
Martin Basanier ({dat1551}1551{/dat}) {en16}Mathématicien{/en}, musicien [http://data.bnf.fr/ark:/12148/cb12510914p#foaf:Person]
{/ud}
{ud0}
Martinus Hortensius ({dat1551}1551{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb13007384z#foaf:Person]
{/ud}
{ud0}
Nicolaus Reimarus Ursus ({dat1551}1551{/dat}) {en16}Mathématicien{/en}. - {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb145753184#foaf:Person]
{/ud}
{ud0}
Paschasius Hamellius ({dat1551}1551{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb13173242d#foaf:Person]
{/ud}
{ud0}
Paul Yvon ({dat1551}1551{/dat}) {en16}Mathématicien{/en}. - Achète la seigneurie de Laleu en 1592 et y fait construire le château. - Maire de La Rochelle en 1616. - S'' installe à Paris en décembre 1633 et abjure le protestantisme [http://data.bnf.fr/ark:/12148/cb12135021d#foaf:Person]
{/ud}
{ud0}
Peter Laicksteen ({dat1551}1551{/dat}) Cartographe et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb15370391s#foaf:Person]
{/ud}
{ud0}
Phillebert Charpentier ({dat1551}1551{/dat}) Éditeur. - Marchand d''estampes et d''instruments de mathématiques [http://data.bnf.fr/ark:/12148/cb16553551w#foaf:Person]
{/ud}
{ud0}
Pierre Forcadel ({dat1551}1551{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb103947442#foaf:Person]
{/ud}
{ud0}
Pierre Hérigone ({dat1551}1551{/dat}) Professeur de mathématiques à Paris. - N''est pas un pseudonyme de Clément Cyriaque de Mangin [http://data.bnf.fr/ark:/12148/cb144882503#foaf:Person]
{/ud}
{ud0}
Pierre Le Voirier ({dat1551}1551{/dat}) Autre(s) graphie(s) : Le Voirrier ; Le Verrier. - Imprimeur du Roi pour les mathématiques. - Beau-père de Mathieu I Guillemot ({dat1584}1584{/dat}). Encore en activité le 31 déc. 1589. Décédé entre 1591 et le 7 nov. 1594 (compte de succession) [http://data.bnf.fr/ark:/12148/cb12230743m#foaf:Person]
{/ud}
{ud0}
Teodato Osio ({dat1551}1551{/dat}) {en16}Mathématicien{/en}. - Musicien [http://data.bnf.fr/ark:/12148/cb125559272#foaf:Person]
{/ud}
{ud0}
Walther Hermann Ryff ({dat1551}1551{/dat}) Apothicaire, {en28}médecin{/en}, {en16}mathématicien{/en} et architecte [http://data.bnf.fr/ark:/12148/cb11948264d#foaf:Person]
{/ud}
{ud0}
William Welwod ({dat1551}1551{/dat}) {en16}Mathématicien{/en}. - Professeur de droit [http://data.bnf.fr/ark:/12148/cb125630488#foaf:Person]
{/ud}
{ud0}
Jost Bürgi ({dat1552}1552{/dat}) Horloger, {en24}astronome{/en} et {en16}mathématicien{/en} suisse [http://data.bnf.fr/ark:/12148/cb123814270#foaf:Person]
{/ud}
{ud0}
Bernardino Baldi ({en0li}Urbino, Italie{/en}, {dat1553}1553{/dat}) Abbé de Guastalla. - Poète, prosateur, {en16}mathématicien{/en} et historien. - Polyglotte, connaissait le grec et le latin, l''hébreu, l''arabe, le persan et le hongrois [http://data.bnf.fr/ark:/12148/cb12179488k#foaf:Person]
{/ud}
{ud0}
Jacob Christmann ({dat1554}1554{/dat}) Orientaliste, {en16}mathématicien{/en} et {en24}astronome{/en}. - A été le premier à utiliser le télescope avec d''autres instruments comme le sextant [http://data.bnf.fr/ark:/12148/cb12560133s#foaf:Person]
{/ud}
{ud0}
Giovanni Antonio Magini ({en0li}Padoue, Italie{/en}, {dat1555}1555{/dat}) {en24}Astronome{/en}, {en16}mathématicien{/en} et {en29}géographe{/en}. - A occupé la chaire d''astronomie à l''Université de Bologne en 1588. - Auteur prétendu de prédictions et de nombreux almanachs publiés en France, en Allemagne et aux Pays-Bas jusqu''au 19e siècle [http://data.bnf.fr/ark:/12148/cb12162475b#foaf:Person]
{/ud}
{ud0}
Jean Du Temps ({dat1555}1555{/dat}) Fils de l''avocat Jean Du Temps I, il fut lui-même avocat et avait des connaissances en astrologie et mathématique. Frère d''Adam Du Temps, spécialiste des fortifications qui participa peut-être à la carte du Blésois dont il est l''auteur [http://data.bnf.fr/ark:/12148/cb15302460t#foaf:Person]
{/ud}
{ud0}
Sethus Calvisius ({dat1556}1556{/dat}) Organiste, compositeur et théoricien de la musique ; {en24}astronome{/en} ; historien ; libraire et éditeur de musique. - Natif de Gorsleben près de Sachsenburg (Thuringe) et issu d''une famille paysanne. Après des études aux universités de Leipzig et Helmstedt, il devient à partir de 1581 et jusqu''à sa mort "cantor" de plusieurs églises de Leipzig successivement. Auteur de plusieurs ouvrages théoriques et compositions musicales, ainsi que d''un "Opus chronologicum" (1605 ; au moins 6 rééd.) et d''un "Elenchus calendarii Gregoriani" ({dat1612}1612{/dat}). Décédé à Leipzig en nov. 1615. À distinguer du pasteur et prédicateur de Quedlinburg Sethus Calvisius (ou : Seth Kal(l)witz) (1639-1698), parfois appelé à tort "Sethus Calvisius le fils" [http://data.bnf.fr/ark:/12148/cb12875550d#foaf:Person]
{/ud}
{ud0}
Guillaume de Nautonier ({dat1557}1557{/dat}) Savant, {en16}mathématicien{/en}, {en24}astronome{/en}, d''origine protestante, {en29}géographe{/en} du roi Henri IV [http://data.bnf.fr/ark:/12148/cb12412403z#foaf:Person]
{/ud}
{ud0}
Christoph Meurer ({dat1558}1558{/dat}) Professeur de mathématiques à Leipzig ({dat1613}1613{/dat}). - {en28}Médecin{/en} [http://data.bnf.fr/ark:/12148/cb14333201g#foaf:Person]
{/ud}
{ud0}
Jean-Édouard Du Monin ({dat1559}1559{/dat}) {en16}Mathématicien{/en} et spécialiste des langues anciennes. - Fut professeur à Paris, puis à Poitiers [http://data.bnf.fr/ark:/12148/cb12463074n#foaf:Person]
{/ud}
{ud0}
Thomas Hariot ({en0li}Oxford, GB{/en}, {dat1560}1560{/dat}) {en16}Mathématicien{/en} et {en24}astronome{/en}. - Envoyé comme conseiller aux Amériques en 1585-86 [http://data.bnf.fr/ark:/12148/cb12215671c#foaf:Person]
{/ud}
{ud0}
Thomas Harriot ({dat1560}1560{/dat}) {en16}Mathématicien{/en}, physicien et {en24}astronome{/en} anglais [http://data.bnf.fr/ark:/12148/cb124346111#foaf:Person]
{/ud}
{ud0}
Adrianus Romanus ({en0li}Louvain{/en}, {dat1561}1561{/dat}) {en28}Médecin{/en}, {en16}mathématicien{/en} et voyageur. - Enseigna à Louvain et à Würzburg, fut {en16}mathématicien{/en} royal en Pologne [http://data.bnf.fr/ark:/12148/cb12459969s#foaf:Person]
{/ud}
{ud0}
Bartholomäus Pitiscus ({dat1561}1561{/dat}) A aussi écrit en latin. - Prédicateur protestant à la cour de l''Électeur palatin. - Également auteur d''ouvrages mathématiques [http://data.bnf.fr/ark:/12148/cb121457326#foaf:Person]
{/ud}
{ud0}
Henry Briggs ({dat1561}1561{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12305061c#foaf:Person]
{/ud}
{ud0}
Jean Tarde (La Roque-Gageac ({en0li}Dordogne){/en}, {dat1561}1561{/dat}) {en16}Mathématicien{/en}, historien, {en29}géographe{/en} et {en24}astronome{/en}. - Chanoine [http://data.bnf.fr/ark:/12148/cb12641353z#foaf:Person]
{/ud}
{ud0}
Jean Tarde ({dat1561}1561{/dat}) Chanoine de Sarlat, {en16}mathématicien{/en} et cartographe [http://data.bnf.fr/ark:/12148/cb153143878#foaf:Person]
{/ud}
{ud0}
P. Christoph Grienberger ({dat1561}1561{/dat}) Jésuite, {en16}mathématicien{/en}, {en24}astronome{/en} et architecte. Il a realisé les plans du Collège d''Aurillac et du Charleville [http://data.bnf.fr/ark:/12148/cb10686921r#foaf:Person]
{/ud}
{ud0}
Philippus Lansbergen ({en0li}Gand (Belgique){/en}, {dat1561}1561{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en} et pasteur [http://data.bnf.fr/ark:/12148/cb130073828#foaf:Person]
{/ud}
{ud0}
Christen Sørensen Longomontanus ({dat1562}1562{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en}. - Fut l''élève de Tycho-Brahé. - Professeur de hautes mathématiques à l''Université de Copenhague [http://data.bnf.fr/ark:/12148/cb13011001c#foaf:Person]
{/ud}
{ud0}
Guangqi Xu ({en0li}Shanghai{/en}, {dat1562}1562{/dat}) Haut fonctionnaire chinois, initié et converti au christianisme par le père jésuite Matteo Ricci. - {en16}Mathématicien{/en}. - {en24}Astronome{/en}. - Disciple de Matteo Ricci [http://data.bnf.fr/ark:/12148/cb150892932#foaf:Person]
{/ud}
{ud0}
{en7}Galileo Galilei{/en} ({en0li}Pise, Italie{/en}, {dat1564}1564{/dat}) Physicien, {en18}philosophe{/en}, {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb11903931b#foaf:Person]
{/ud}
{ud0}
Luis Teixeira ({dat1564}1564{/dat}) Jésuite portugais, {en16}mathématicien{/en} et cartographe actif de 1564 à 1613 [http://data.bnf.fr/ark:/12148/cb153361957#foaf:Person]
{/ud}
{ud0}
Edward Brerewood ({dat1565}1565{/dat}) Antiquaire et {en16}mathématicien{/en}, linguiste et humaniste. - Professeur d''astronomie au Gresham college de Londres [http://data.bnf.fr/ark:/12148/cb125109678#foaf:Person]
{/ud}
{ud0}
Eilhard Lubin ({dat1565}1565{/dat}) Humaniste, philologue, cartographe, théologien et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb15040859j#foaf:Person]
{/ud}
{ud0}
Paolo Antonio Foscarini ({en0li}Montalto Uffugo, Italie{/en}, {dat1565}1565{/dat}) Carme. - Théologien. - {en16}Mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb12377530d#foaf:Person]
{/ud}
{ud0}
Scipione Chiaramonti ({en0li}Cesena, Italie{/en}, {dat1565}1565{/dat}) {en24}Astronome{/en} et {en18}philosophe{/en}. - Professeur de philosophie à l''Université de Pise [http://data.bnf.fr/ark:/12148/cb10545041n#foaf:Person]
{/ud}
{ud0}
Fr. François d'' Aguillon ({dat1566}1566{/dat}) Jésuite, architecte et {en16}mathématicien{/en}. Auteur d''un projet pour le noviciat de Tournai. Préposé de la Maison professe, professeur d''Anvers [http://data.bnf.fr/ark:/12148/cb16240952w#foaf:Person]
{/ud}
{ud0}
Georg Ludwig Frobenius ({dat1566}1566{/dat}) Libraire. - Natif d''Iphofen, près de Wurzbourg. Titulaire d''une maîtrise de théologie. Après des études aux universités de Tübingen et Wittenberg, travaille avec l''{en24}astronome{/en} Tycho Brahe jusqu''à la mort de celui-ci. Reçu ensuite bourgeois de Hambourg, où il s''établit libraire [http://data.bnf.fr/ark:/12148/cb12229506t#foaf:Person]
{/ud}
{ud0}
Marco Antonio De Dominis (l''île de Rab ({en0li}Croatie){/en}, {dat1566}1566{/dat}) Professeur de rhétorique, mathématiques et philosophie dans la Compagnie de Jésus, à Padoue et Brescia. - Evêque de Segna (Senj ou Zengg en Croatie) de 1600 à 1602; de Spalato (Split) de 1602 à 1615. - Gagné au protestantisme et exilé en Angleterre, doyen de Windsor. - Abjure et rentre en grâce ({dat1622}1622{/dat}) [http://data.bnf.fr/ark:/12148/cb121335726#foaf:Person]
{/ud}
{ud0}
Marinus Ghetaldus (Raguse aujourd''hui Dubrovnik ({en0li}Croatie){/en}, {dat1566}1566{/dat}) {en16}Mathématicien{/en} et physicien. - Il exerça une grande influence sur le développement de l''application de l''algèbre à la géométrie. - Il mit au point le miroir parabolique, aujourd''hui conservé au National Maritime Museum de Londres. - Il collabora, entre autres, avec François Viète en France et avec {en7}Galilée{/en} en Italie [http://data.bnf.fr/ark:/12148/cb146476018#foaf:Person]
{/ud}
{ud0}
François de Aguilón ({dat1567}1567{/dat}) Architecte et {en16}mathématicien{/en} belge d''origine espagnole [http://data.bnf.fr/ark:/12148/cb119998212#foaf:Person]
{/ud}
{ud0}
Johann Hartmann ({dat1568}1568{/dat}) {en16}Mathématicien{/en} et naturaliste. - Professeur de chimie à l''Université de Marburg [http://data.bnf.fr/ark:/12148/cb13009199x#foaf:Person]
{/ud}
{ud0}
P. Jacques de Guernisac ({dat1568}1568{/dat}) Jésuite et architecte,   à Pont-à-Mousson puis à La Flèche, recteur du collège des Jésuites de Quimper [http://data.bnf.fr/ark:/12148/cb16215104d#foaf:Person]
{/ud}
{ud0}
Mutio Oddi ({dat1569}1569{/dat}) {en16}Mathématicien{/en}. - Architecte [http://data.bnf.fr/ark:/12148/cb165299645#foaf:Person]
{/ud}
{ud0}
Andrea Argoli ({dat1570}1570{/dat}) {en16}Mathématicien{/en}. - {en24}Astronome{/en}. - Professeur de mathématique à l''Université de Padoue [http://data.bnf.fr/ark:/12148/cb121593328#foaf:Person]
{/ud}
{ud0}
Erasmus Schmied ({dat1570}1570{/dat}) Né à Delitzsch, près de Leipzig. - Professeur de grec et de mathématiques à Wittenberg [http://data.bnf.fr/ark:/12148/cb12045847b#foaf:Person]
{/ud}
{ud0}
Anders Bure ({dat1571}1571{/dat}) Cartographe et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb14509982d#foaf:Person]
{/ud}
{ud0}
Giovanni Branca ({dat1571}1571{/dat}) Architecte, ingénieur et {en16}mathématicien{/en}. - Né à Pesaro, meurt à Pérouse [http://data.bnf.fr/ark:/12148/cb121826472#foaf:Person]
{/ud}
{ud0}
Johannes Isaacus Pontanus ({en0li}Elseneur (Danemark){/en}, {dat1571}1571{/dat}) Historien. - Philologue. - Professeur de mathématiques et de physique [http://data.bnf.fr/ark:/12148/cb123875836#foaf:Person]
{/ud}
{ud0}
Johannes Kepler ({dat1571}1571{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb11909597m#foaf:Person]
{/ud}
{ud0}
Willem Jansz Blaeu ({dat1571}1571{/dat}) Autre(s) graphie(s) : Janssonius Blaeuw. - Imprimeur-libraire et éditeur de cartes et d''atlas. - Originaire d''Alkmaar ou des environs. Passe 2 ans auprès de Tycho Brahé au Danemark. À son retour à Amsterdam en 1596, s''établit cartographe et fabricant de globes terrestres et célestes. Monte ensuite une imprimerie et une fonderie. Également auteur d''ouvrages cartographiques et astronomiques [http://data.bnf.fr/ark:/12148/cb12169772t#foaf:Person]
{/ud}
{ud0}
Cornelius Drebbel ({dat1572}1572{/dat}) Graveur. - {en16}Mathématicien{/en}. - Physicien. - Chimiste [http://data.bnf.fr/ark:/12148/cb12382467g#foaf:Person]
{/ud}
{ud0}
Rodolphus Goclenius ({dat1572}1572{/dat}) Docteur en médecine en 1601. - Professeur de physique en 1608. - Professeur de mathématiques à l''Université de Marbourg en 1621 [http://data.bnf.fr/ark:/12148/cb121595722#foaf:Person]
{/ud}
{ud0}
Samuel Marolois ({dat1572}1572{/dat}) {en16}Mathématicien{/en} français ayant vécu une grande partie de sa vie aux Pays-Bas [http://data.bnf.fr/ark:/12148/cb14912871p#foaf:Person]
{/ud}
{ud0}
Thomas Lydyat ({en0li}Okerton, GB{/en}, {dat1572}1572{/dat}) {en16}Mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb12390032f#foaf:Person]
{/ud}
{ud0}
Christoph Scheiner ({dat1575}1575{/dat}) Jésuite. - Physicien, {en16}mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb13483688j#foaf:Person]
{/ud}
{ud0}
Michelangelo Galilei ({dat1575}1575{/dat}) Luthiste et compositeur italien de la Renaissance. - Fils du compositeur et théoricien Vincenzo Galilei, et frère de l''{en24}astronome{/en} {en7}Galileo Galilei{/en} [http://data.bnf.fr/ark:/12148/cb140013401#foaf:Person]
{/ud}
{ud0}
Octavio Pisani ({en0li}Naples, Italie{/en}, {dat1575}1575{/dat}) Cosmographe et {en24}astronome{/en}, travaille à Anvers de 1612 à 1637 [http://data.bnf.fr/ark:/12148/cb15404394h#foaf:Person]
{/ud}
{ud0}
Francesco Ingoli ({en0li}Ravenne (Italie){/en}, {dat1578}1578{/dat}) Secrétaire de la propagande, débat avec Copernic (en 1616 et 1624) et écrit Relazione delle quattro parti del mondo avec pour objectif de soutenir missions et propagande religieuses. - Étudie l''astronomie, la cosmographie et la géographie et connait le grec, le français, l''espagnon et l''arabe. - Diplômé en droit civil et en droit canon à l''Université de Padoue, Italie [http://data.bnf.fr/ark:/12148/cb13749501h#foaf:Person]
{/ud}
{ud0}
Sybrandt Hansz. Cardinael (Harlingen (Pays-Bas), {dat1578}1578{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb15944052f#foaf:Person]
{/ud}
{ud0}
Cristóvão Ferreira ({dat1580}1580{/dat}) Supérieur et procurateur de la mission jésuite au Japon, il abjura en 1633 et se convertit au zen. - Auteur en 1636 de la "Supercherie dévoilée". - Traducteur d''ouvrages d''astronomie et de chirurgie [http://data.bnf.fr/ark:/12148/cb13524212c#foaf:Person]
{/ud}
{ud0}
Godfried Wendelen ({dat1580}1580{/dat}) {en24}Astronome{/en} et géomètre. - Avocat au Parlement de Paris puis doyen du chapitre de Rothnac, Belgique [http://data.bnf.fr/ark:/12148/cb123969373#foaf:Person]
{/ud}
{ud0}
Joannes Michael Gigas ({dat1580}1580{/dat}) Docteur, {en16}mathématicien{/en} et {en29}géographe{/en} édité par Blaeu et Hondius [http://data.bnf.fr/ark:/12148/cb153239798#foaf:Person]
{/ud}
{ud0}
Johann Faulhaber ({dat1580}1580{/dat}) {en16}Mathématicien{/en} allemand. S''est aussi intéressé à l''ingénierie des fortifications [http://data.bnf.fr/ark:/12148/cb137778453#foaf:Person]
{/ud}
{ud0}
Nicolas-Claude Fabri Peiresc ({en0li}Belgentier (Var){/en}, {dat1580}1580{/dat}) Conseiller au Parlement de Provence. - {en24}Astronome{/en}, archéologue et naturaliste [http://data.bnf.fr/ark:/12148/cb11918940q#foaf:Person]
{/ud}
{ud0}
Willebrordus Snellius (Leyde, Pays-Bas, {dat1580}1580{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en} et {en29}géographe{/en} [http://data.bnf.fr/ark:/12148/cb15336105f#foaf:Person]
{/ud}
{ud0}
Claude-Gaspard Bachet (Bourg-en-Bresse ({en0li}Ain){/en}, {dat1581}1581{/dat}) {en16}Mathématicien{/en} et littérateur. - Sieur de Méziriac. - Érudit, auteur de poèmes en français, italien et latin. - Membre de l''Académie française (élu en 1634) [http://data.bnf.fr/ark:/12148/cb120028244#foaf:Person]
{/ud}
{ud0}
Alexandre Anderson ({dat1582}1582{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb16296598k#foaf:Person]
{/ud}
{ud0}
Jean François ({dat1582}1582{/dat}) Nom en religion de Jean Charnage. - Jésuite. - Professeur de philosophie et de mathématiques à La Flèche [http://data.bnf.fr/ark:/12148/cb121629197#foaf:Person]
{/ud}
{ud0}
Mario Bettini ({en0li}Bologne, Italie{/en}, {dat1582}1582{/dat}) Jésuite. - {en18}Philosophe{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12545452p#foaf:Person]
{/ud}
{ud0}
Matthias Bernegger ({en0li}Hallstatt (Autriche){/en}, {dat1582}1582{/dat}) Philologue, historien, {en16}mathématicien{/en} et {en24}astronome{/en}. - Protestant. - Professeur d''histoire et d''éloquence à Strasbourg, recteur de l''Université de cette même ville [http://data.bnf.fr/ark:/12148/cb129928534#foaf:Person]
{/ud}
{ud0}
Jean-Baptiste Morin (Villefranche-sur-Saône ({en0li}Rhône){/en}, {dat1583}1583{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb11916881j#foaf:Person]
{/ud}
{ud0}
Orazio Grassi ({en0li}Savone, Italie{/en}, {dat1583}1583{/dat}) Jésuite. - {en16}Mathématicien{/en}, {en24}astronome{/en} et architecte [http://data.bnf.fr/ark:/12148/cb125377863#foaf:Person]
{/ud}
{ud0}
Filippo Finella ({en0li}Naples, Italie{/en}, {dat1584}1584{/dat}) {en25}Astrologue{/en}. - {en24}Astronome{/en}. - Auteur dramatique [http://data.bnf.fr/ark:/12148/cb122006609#foaf:Person]
{/ud}
{ud0}
Grégoire de Saint-Vincent ({dat1584}1584{/dat}) {en16}Mathématicien{/en}. - {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb16197665z#foaf:Person]
{/ud}
{ud0}
James Hume ({dat1584}1584{/dat}) {en16}Mathématicien{/en}. - {en24}Astronome{/en}. - Historien. - Hébraïsant. - Actif en 1639. - A vécu à Paris. - Fils de David Hume (1558-163.) et frère aîné de la poétesse et traductrice Anna Hume (1586?-16..) [http://data.bnf.fr/ark:/12148/cb12072629r#foaf:Person]
{/ud}
{ud0}
Claude Mydorge ({dat1585}1585{/dat}) {en16}Mathématicien{/en} et physicien [http://data.bnf.fr/ark:/12148/cb144888873#foaf:Person]
{/ud}
{ud0}
Mario Guiducci ({en0li}Florence, Italie{/en}, {dat1585}1585{/dat}) Homme de lettres et {en24}astronome{/en}. - A collaboré avec {en7}Galileo Galilei{/en} [http://data.bnf.fr/ark:/12148/cb144609004#foaf:Person]
{/ud}
{ud0}
Melchior Inchofer ({en0li}Vienne{/en}, {dat1585}1585{/dat}) Jésuite. - {en18}Philosophe{/en}, {en16}mathématicien{/en} et théologien professeur à Messine, Italie [http://data.bnf.fr/ark:/12148/cb10735485h#foaf:Person]
{/ud}
{ud0}
Philipp Müller ({dat1585}1585{/dat}) {en16}Mathématicien{/en}, {en28}médecin{/en}, chimiste et botaniste. - Professeur à l''université de Leipzig [http://data.bnf.fr/ark:/12148/cb14065362j#foaf:Person]
{/ud}
{ud0}
Jean L''Hoste ({en0li}Nancy{/en}, {dat1586}1586{/dat}) Ingénieur. - Intendant des fortifications du duc de Lorraine. - Professeur de droit et de mathématiques à Pont-à-Mousson [http://data.bnf.fr/ark:/12148/cb16628764j#foaf:Person]
{/ud}
{ud0}
Niccolò Zucchi ({en0li}Parme, Italie{/en}, {dat1586}1586{/dat}) Jésuite. - Recteur du Collegio romano (1646-1649). - {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb10077816w#foaf:Person]
{/ud}
{ud0}
Benedetto Castelli ({en0li}Brescia, Italie{/en}, {dat1587}1587{/dat}) Dominicain. - {en16}Mathématicien{/en}, inventeur et {en26}écrivain{/en}. - Disciple de {en7}Galilée{/en}, dont il défendit les théories astronomiques [http://data.bnf.fr/ark:/12148/cb12545385c#foaf:Person]
{/ud}
{ud0}
Joachim Jungius ({dat1587}1587{/dat}) Naturaliste, {en16}mathématicien{/en} et {en18}philosophe{/en} [http://data.bnf.fr/ark:/12148/cb120247195#foaf:Person]
{/ud}
{ud0}
Libert Froidmont ({en0li}Liège{/en}, {dat1587}1587{/dat}) Théologien. - {en16}Mathématicien{/en}, physicien et géologue [http://data.bnf.fr/ark:/12148/cb14462868z#foaf:Person]
{/ud}
{ud0}
François Derand ({dat1588}1588{/dat}) Jésuite. - Professeur de grammaire et de mathématiques. - Architecte. - Né à Vic s/Seille (Moselle), mort à Agde (Hérault) [http://data.bnf.fr/ark:/12148/cb13012148j#foaf:Person]
{/ud}
{ud0}
Jacques Grandami ({dat1588}1588{/dat}) Jésuite. - Professeur de belles lettres, de philosophie et de théologie, puis recteur de Bourges, Rennes, La Flèche, Tours et Rouen. - Visiteur de la province de France. - {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb12155155d#foaf:Person]
{/ud}
{ud0}
Marin Mersenne ({dat1588}1588{/dat}) {en18}Philosophe{/en} et savant, {en24}astronome{/en}, {en16}mathématicien{/en}. - Théoricien de la musique. - Minime [http://data.bnf.fr/ark:/12148/cb119157157#foaf:Person]
{/ud}
{ud0}
Eberhard Welper ({dat1590}1590{/dat}) Imprimeur-libraire. - Natif de Lohra (comté de Lohenstein, près de Marburg, Allemagne). {en16}Mathématicien{/en}, {en25}astrologue{/en} et {en24}astronome{/en}, il se fixe à Strasbourg en 1618. Établi libraire en 1620 puis imprimeur dès 1621. Publie notamment chaque année un almanach et des prédictions. Auteur de plusieurs ouvrages scientifiques, dont des "Elementa geometrica..." (1re éd., {dat1620}1620{/dat}), une "Gnomonica" ({dat1625}1625{/dat}), un "Compendium astronomiae..." ({dat1634}1634{/dat}) et un traité de la divination, "Rota-Fortunae, oder Glück-Rad..." (s. d., plusieurs rééd.). De 1634 à 1639, assure des fonctions d''enseignant au Gymnase (lycée) de Strasbourg. En 1654, sollicite en vain la charge d''imprimeur de l''évêché de Saverne. De 1653 à 1661, imprime sous le pseudonyme de Hartmann Bär quelques ouvrages pour l''académie des Jésuites à Molsheim. Son fils aîné Johann Welper (1642-1720) lui succède en 1664, mais des éditions paraissent encore sous son nom en 1689. Son autre fils Eberhard (II) Welper (1644-1670) sera lui aussi {en16}mathématicien{/en}, {en25}astrologue{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb158750586#foaf:Person]
{/ud}
{ud0}
Johannes Wilhelm Lauremberg ({dat1590}1590{/dat}) Auteur, {en16}mathématicien{/en} et historien à Rostock [http://data.bnf.fr/ark:/12148/cb15377794m#foaf:Person]
{/ud}
{ud0}
Jean Leurechon (Bar-le-Duc, {dat1591}1591{/dat}) Jésuite. - Professeur de philosophie et de mathématiques, à Pont-à-Mousson notamment. - Confesseur du duc de Lorraine Charles IV. - Henry Van Etten, qui signe la dédicace de la première édition des "Récréations mathématiques" n''est pas un pseudonyme de Jean Leurechon, mais le nom d''un de ses élèves, qui aurait réellement existé d''après Trevor H. Hall [http://data.bnf.fr/ark:/12148/cb13009618g#foaf:Person]
{/ud}
{ud0}
Joseph Salomon Delmedigo ({dat1591}1591{/dat}) {en28}Médecin{/en}. - {en24}Astronome{/en}. - {en16}Mathématicien{/en}. - Né en Crète. - Fils d''Eliya Delmedigo (1460-1497) [http://data.bnf.fr/ark:/12148/cb122623548#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Vertova ({en0li}Bergame, Italie{/en}, {dat1592}1592{/dat}) {en16}Mathématicien{/en} et ingénieur militaire. - Chevalier de l''Ordre de Malte [http://data.bnf.fr/ark:/12148/cb15093021d#foaf:Person]
{/ud}
{ud0}
Johann Adam Schall von Bell ({dat1592}1592{/dat}) Jésuite. - Missionnaire en Chine (de 1619 à sa mort). - {en16}Mathématicien{/en}. - Conseiller et {en24}astronome{/en} de la Cour impériale de Chine [http://data.bnf.fr/ark:/12148/cb12362941r#foaf:Person]
{/ud}
{ud0}
Pierre Gassendi ({en0li}Champtercier, près de Digne{/en}, {dat1592}1592{/dat}) {en18}Philosophe{/en}, {en24}astronome{/en}, {en16}mathématicien{/en}, physicien, docteur en théologie et théoricien de la musique. - Entre dans les ordres en 1615 [http://data.bnf.fr/ark:/12148/cb120250393#foaf:Person]
{/ud}
{ud0}
Wilhelm Schickard ({en0li}Herrenberg, Allemagne{/en}, {dat1592}1592{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en}, professeur d''agriculture [http://data.bnf.fr/ark:/12148/cb11969696s#foaf:Person]
{/ud}
{ud0}
Albert Girard (Saint-Mihiel, {dat1595}1595{/dat}) {en16}Mathématicien{/en} et ingénieur. - Ingénieur dans l''armée de Frédéric de Nassau, prince d''Orange [http://data.bnf.fr/ark:/12148/cb121123333#foaf:Person]
{/ud}
{ud0}
Pierre Bardin ({en0li}Rouen{/en}, {dat1595}1595{/dat}) Homme de lettres, {en18}philosophe{/en} et {en16}mathématicien{/en}. - Précepteur. - Membre de l''Académie française (élu en 1634) [http://data.bnf.fr/ark:/12148/cb125272379#foaf:Person]
{/ud}
{ud0}
Pierre Bourdin ({dat1595}1595{/dat}) Jésuite. - Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb123902440#foaf:Person]
{/ud}
{ud0}
Daniel Mögling ({en0li}Böblingen{/en}, {dat1596}1596{/dat}) Alchimiste, rosicrucien, {en28}médecin{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb167575369#foaf:Person]
{/ud}
{ud0}
Jacob Golius ({dat1596}1596{/dat}) Orientaliste. - {en16}Mathématicien{/en}. - Philologue, spécialiste des littératures [http://data.bnf.fr/ark:/12148/cb123338386#foaf:Person]
{/ud}
{ud0}
René Descartes (Descartes (Indre-et-Loire), {dat1596}1596{/dat}) {en18}Philosophe{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb11899775j#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Hodierna ({dat1597}1597{/dat}) {en24}Astronome{/en} italien [http://data.bnf.fr/ark:/12148/cb120704558#foaf:Person]
{/ud}
{ud0}
Bonaventura Cavalieri ({en0li}Milan, Italie{/en}, {dat1598}1598{/dat}) Jésuite. - {en16}Mathématicien{/en}, géomètre et {en24}astronome{/en}, disciple de {en7}Galilée{/en}. - Fut professeur à l''Université de Bologne [http://data.bnf.fr/ark:/12148/cb12085151g#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Riccioli ({en0li}Ferrare, Italie{/en}, {dat1598}1598{/dat}) Jésuite. - {en24}Astronome{/en}. - Professeur de lettres, de philosophie et de théologie, à Parme puis à Bologne. - {en16}Mathématicien{/en} et historien de la géographie [http://data.bnf.fr/ark:/12148/cb12546680q#foaf:Person]
{/ud}
{ud0}
Pierre Petit ({dat1598}1598{/dat}) {en16}Mathématicien{/en} et physicien. - Intendant général des ports et fortifications de France ({dat1649}1649{/dat}) [http://data.bnf.fr/ark:/12148/cb123944733#foaf:Person]
{/ud}
{ud0}
Adam Olearius ({en0li}Aschersleben, Allemagne{/en}, {dat1599}1599{/dat}) Voyageur, en particulier en Russie et en Perse. - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12817277v#foaf:Person]
{/ud}
{ud0}
Jacob Aertsz Colom ({dat1599}1599{/dat}) {en16}Mathématicien{/en}, navigateur et cartographe. - Imprimeur à Amsterdam [http://data.bnf.fr/ark:/12148/cb153358650#foaf:Person]
{/ud}
{ud0}
Adriaan Vlacq ({dat1600}1600{/dat}) Autre(s) graphie(s) : Ulack ; Vlac. - Variante(s) de prénom : Adriaen ; Adrien. - Imprimeur-libraire. - Originaire de Gouda. Édite différents périodiques dont "De Haegsche Vrijdaeghse Post-Tijdingen". A publié en 1659 une contrefaçon de Johannes Elzevier et de Pieter Leffen. A également publié sous les fausses adresses et pseudonymes de "Cologne, Pierre Du Marteau" et "Amsterdam, Peter Le Grand". - Également {en16}mathématicien{/en} connu pour ses travaux sur les logarithmes et auteur d''ouvrages d''astronomie et de pamphlets en faveur des royalistes anglais en 1652-1655. Mort peu avant le 8 avril 1667. Des éd. paraissent encore sous son nom jusqu''en 1669, en association avec Johannes Vlacq [http://data.bnf.fr/ark:/12148/cb121635061#foaf:Person]
{/ud}
{ud0}
Antoine de Laloubère ({dat1600}1600{/dat}) Jésuite. - {en16}Mathématicien{/en} et géomètre, fut le premier scientifique à étudier les propriétés de l''hélice. - Polémiqua avec Pascal, qui l''appelle "Allouerus" dans l''"Histoire de la roulette". - Professeur de rhétorique, de théologie et de mathématiques au collège de Toulouse. - Né à Rieux, meurt à Toulouse [http://data.bnf.fr/ark:/12148/cb13006798h#foaf:Person]
{/ud}
{ud0}
Giacomo Oddi ({dat1600}1600{/dat}) Cartographe et {en16}mathématicien{/en}. Etudie à Naples [http://data.bnf.fr/ark:/12148/cb153917817#foaf:Person]
{/ud}
{ud0}
Jakob Bartsch ({dat1600}1600{/dat}) {en28}Médecin{/en}. - Professeur de mathématiques à Strasbourg. - {en24}Astronome{/en}. - Gendre et collaborateur de l''{en24}astronome{/en} Johann Kepler (1571-1630) [http://data.bnf.fr/ark:/12148/cb12163632v#foaf:Person]
{/ud}
{ud0}
Emmanuel Maignan ({dat1601}1601{/dat}) Religieux minime. - {en18}Philosophe{/en}, {en16}mathématicien{/en} et peintre. - Membre de la Société des lanternistes [http://data.bnf.fr/ark:/12148/cb130127157#foaf:Person]
{/ud}
{ud0}
Florimond de Beaune ({dat1601}1601{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb11890827s#foaf:Person]
{/ud}
{ud0}
Ovidio Montalbani ({dat1601}1601{/dat}) Docteur en philosophie et médecine de l'' Université de Bologne, professeur de mathématiques, chargé du musée Aldrovandi à partir de 1657, fut aussi un citoyen actif de Bologne, où il assura plusieurs magistratures ("giudice del Foro de mercanti, e de tribuni della plebe"). - Membre de l''Accademia dei Gelati de Bologne ("l''Innestato"), de l''Accademia degli Indomiti de Bologne ("lo Stellato"), et de l''Accademia della Notte de Bologne ("il Rugiadoso") [http://data.bnf.fr/ark:/12148/cb12064289s#foaf:Person]
{/ud}
{ud0}
Pierre de Fermat (Beaumont-de-Lomagne (Tarn-et-Garonne), {dat1601}1601{/dat}) {en16}Mathématicien{/en}, célèbre pour son théorème. - On lui doit aussi le Principe de Fermat en optique. - Conseiller au Parlement de Toulouse et commissaire en la chambre des requêtes du Palais à Toulouse (mai 1631) [http://data.bnf.fr/ark:/12148/cb11902568b#foaf:Person]
{/ud}
{ud0}
Athanasius Kircher ({en0li}Geisa (Allemagne){/en}, {dat1602}1602{/dat}) Jésuite. - Professeur de physique, de mathématiques et de langues orientales, Collegio Romano, Rome. - Dessinateur et graveur [http://data.bnf.fr/ark:/12148/cb119097824#foaf:Person]
{/ud}
{ud0}
Gilles Personne de Roberval ({en0li}Roberval, Oise{/en}, {dat1602}1602{/dat}) Professeur de philosophie ({dat1634}1634{/dat}) et de mathématiques ({dat1655}1655{/dat}) au Collège royal, Paris. - Membre fondateur de l''Académie royale des sciences [http://data.bnf.fr/ark:/12148/cb12144923j#foaf:Person]
{/ud}
{ud0}
Jacques de Billy ({dat1602}1602{/dat}) Jésuite (à partir de 1619). - {en16}Mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb123773436#foaf:Person]
{/ud}
{ud0}
John Greaves ({en0li}Colemore, GB{/en}, {dat1602}1602{/dat}) {en16}Mathématicien{/en}. - Orientaliste. - Professeur d''astronomie à Londres puis à Oxford [http://data.bnf.fr/ark:/12148/cb129277690#foaf:Person]
{/ud}
{ud0}
Pierre Gautruche ({dat1602}1602{/dat}) Jésuite. - Professeur de philosophie, de théologie et de mathématiques. - Identifié par certains à Pierre Gautier (1599-16..), luthiste et compositeur [http://data.bnf.fr/ark:/12148/cb121990328#foaf:Person]
{/ud}
{ud0}
Blaise-François de Pagan ({en0li}Avignon{/en}, {dat1604}1604{/dat}) Ingénieur et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb12155087r#foaf:Person]
{/ud}
{ud0}
Claude Hardy ({dat1604}1604{/dat}) Fils de Sébastien Hardy. - Conseiller au Châtelet. - {en16}Mathématicien{/en}. - Ami de Mydorge, Descartes et du Père Mersenne ; souvent cité dans la correspondance de ces deux derniers [http://data.bnf.fr/ark:/12148/cb12134536k#foaf:Person]
{/ud}
{ud0}
Bernard Frénicle de Bessy ({dat1605}1605{/dat}) {en16}Mathématicien{/en}, géomètre et arithméticien. - Membre de l''Académie des Sciences. - Conseiller à la Cour des monnaies [http://data.bnf.fr/ark:/12148/cb12459881c#foaf:Person]
{/ud}
{ud0}
Ismaël Boulliau ({en0li}Loudun (Vienne){/en}, {dat1605}1605{/dat}) {en24}Astronome{/en}. - Secrétaire de Jacques Du Puy et attaché au président de Thou [http://data.bnf.fr/ark:/12148/cb124621511#foaf:Person]
{/ud}
{ud0}
Juan de Caramuel y Lobkowitz ({en0li}Madrid{/en}, {dat1606}1606{/dat}) Cistercien. - Evêque de Satriano et Campagna (1657-1673) puis de Vigevano (1673-). - Humaniste, théologien, {en16}mathématicien{/en}, {en18}philosophe{/en} et architecte. - Défenseur de la doctrine probabiliste [http://data.bnf.fr/ark:/12148/cb12392566m#foaf:Person]
{/ud}
{ud0}
Evangelista Torricelli ({en0li}Faenza, Italie{/en}, {dat1608}1608{/dat}) Physicien et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12117674q#foaf:Person]
{/ud}
{ud0}
Gaspar Schott ({en0li}Königshaufen, Allemagne{/en}, {dat1608}1608{/dat}) {en16}Mathématicien{/en} et physicien. - Jésuite [http://data.bnf.fr/ark:/12148/cb12519717b#foaf:Person]
{/ud}
{ud0}
Giovanni Alfonso Borelli ({en0li}Naples, Italie{/en}, {dat1608}1608{/dat}) {en16}Mathématicien{/en}, phycisien, {en28}médecin{/en}, {en18}philosophe{/en}. - Membre de l''Accademia del Cimento [http://data.bnf.fr/ark:/12148/cb12462534j#foaf:Person]
{/ud}
{ud0}
Giovan Battista Nicolosi ({en0li}Paternò, Italie{/en}, {dat1610}1610{/dat}) {en29}Géographe{/en} et cartographe. - Professeur de mathématiques et de géographie à l''Université de Rome [http://data.bnf.fr/ark:/12148/cb15404103t#foaf:Person]
{/ud}
{ud0}
Józef Naronowicz-Naroński ({dat1610}1610{/dat}) {en16}Mathématicien{/en}. - Cartographe. - Architecte au service de la famille Radzwill. - Né en Lituanie [http://data.bnf.fr/ark:/12148/cb150812338#foaf:Person]
{/ud}
{ud0}
Maria Cunitia ({dat1610}1610{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb162514419#foaf:Person]
{/ud}
{ud0}
Jan Heweliusz ({dat1611}1611{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb121054498#foaf:Person]
{/ud}
{ud0}
John Pell ({dat1611}1611{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb146515879#foaf:Person]
{/ud}
{ud0}
Michael Floris Van Langren ({dat1612}1612{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en} du roi d''Espagne installé à Bruxelles [http://data.bnf.fr/ark:/12148/cb153283774#foaf:Person]
{/ud}
{ud0}
Francesco Maria Grimaldi ({dat1613}1613{/dat}) Jésuite. - {en18}Philosophe{/en}, {en24}astronome{/en}, opticien et professeur de mathématiques. - Né et mort à Bologne [http://data.bnf.fr/ark:/12148/cb13326913s#foaf:Person]
{/ud}
{ud0}
François Chauveau ({dat1613}1613{/dat}) Grava des cartouches notamment pour Nicolas Sanson. Eut un neveu du nom de François Chauveau. Son frère, Jean-Baptiste, habile ingénieur et {en16}mathématicien{/en} fut assassiné en 1670. [http://data.bnf.fr/ark:/12148/cb15302394v#foaf:Person]
{/ud}
{ud0}
Jean François Nicéron ({en0li}Paris{/en}, {dat1613}1613{/dat}) Religieux de l''Ordre des minimes. - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb14404933t#foaf:Person]
{/ud}
{ud0}
Tommaso Cornelio ({en0li}Rovito, Italie{/en}, {dat1614}1614{/dat}) {en28}Médecin{/en}, {en18}philosophe{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb13484167f#foaf:Person]
{/ud}
{ud0}
Frans Van Schooten ({dat1615}1615{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12529949q#foaf:Person]
{/ud}
{ud0}
John Wallis ({dat1616}1616{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb123396143#foaf:Person]
{/ud}
{ud0}
Jonas Moore ({dat1617}1617{/dat}) {en16}Mathématicien{/en} britannique. - S''est intéressé aux mathématiques appliquées (astronomie, cosmographie, architecture...) [http://data.bnf.fr/ark:/12148/cb135104102#foaf:Person]
{/ud}
{ud0}
Tito Livio Burattini ({en0li}Agordo, Italie{/en}, {dat1617}1617{/dat}) {en16}Mathématicien{/en}, cartographe et égyptologue [http://data.bnf.fr/ark:/12148/cb162142362#foaf:Person]
{/ud}
{ud0}
Anthelme (Chatenay-Vaudin (Haute-Marne), {dat1618}1618{/dat}) Religieux de la Chartreuse de Dijon. - {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb106267229#foaf:Person]
{/ud}
{ud0}
Charles Cavendish ({dat1620}1620{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb14651592w#foaf:Person]
{/ud}
{ud0}
Jean Picard ({en0li}La Flèche (Sarthe){/en}, {dat1620}1620{/dat}) {en24}Astronome{/en}. - Membre de l''Académie des sciences ({dat1666}1666{/dat}) [http://data.bnf.fr/ark:/12148/cb11941359d#foaf:Person]
{/ud}
{ud0}
Claude-François Milliet de Chales ({dat1621}1621{/dat}) {en16}Mathématicien{/en}. - Professeur d''hydrographie à Marseille [http://data.bnf.fr/ark:/12148/cb12397222c#foaf:Person]
{/ud}
{ud0}
Adrien Auzout ({en0li}Rouen{/en}, {dat1622}1622{/dat}) {en24}Astronome{/en}, physicien et {en16}mathématicien{/en}. - A contribué au développement du micromètre [http://data.bnf.fr/ark:/12148/cb134752474#foaf:Person]
{/ud}
{ud0}
Jean Bertet ({dat1622}1622{/dat}) Jésuite, quitte la Compagnie en 1681 pour entrer chez les Bénédictins. - Professeur de rhétorique, philosophie et mathématiques. - Poète [http://data.bnf.fr/ark:/12148/cb11999230c#foaf:Person]
{/ud}
{ud0}
René-François De Sluse ({dat1622}1622{/dat}) {en16}Mathématicien{/en}. - Chanoine de la Cathédrale de Liège et abbé d''Amay [http://data.bnf.fr/ark:/12148/cb12427294z#foaf:Person]
{/ud}
{ud0}
Vincenzo Viviani ({en0li}Florence, Italie{/en}, {dat1622}1622{/dat}) Florentin. - {en16}Mathématicien{/en}. - Membre de l'' "accademia della Crusca" [http://data.bnf.fr/ark:/12148/cb12000373g#foaf:Person]
{/ud}
{ud0}
Blaise Pascal (Clermont-Ferrand (Puy-de-Dôme), {dat1623}1623{/dat}) {en16}Mathématicien{/en}, physicien, {en26}écrivain{/en}. - Frère de : Pascal, Jacqueline (1625-1661) [http://data.bnf.fr/ark:/12148/cb11918679x#foaf:Person]
{/ud}
{ud0}
Ferdinand Verbiest ({en0li}Pitthem, Belgique{/en}, {dat1623}1623{/dat}) Jésuite, missionnaire en Chine. - {en24}Astronome{/en}. - Fut placé à la tête du tribunal des mathématiques, chargé de la rédaction des éphémérides et de la direction des fonderies de canons. - A publié en langue chinoise, sous le nom de Nanhoai-jin, un grand nombre d''ouvrages scientifiques [http://data.bnf.fr/ark:/12148/cb12215344n#foaf:Person]
{/ud}
{ud0}
Camillo Guarino Guarini ({en0li}Modène, Italie{/en}, {dat1624}1624{/dat}) Clerc régulier, théatin. - Architecte du duc de Savoie, {en18}philosophe{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12348027r#foaf:Person]
{/ud}
{ud0}
Christoph Wittich ({dat1625}1625{/dat}) Théologien. - Professeur de mathématiques et de théologie [http://data.bnf.fr/ark:/12148/cb13014027s#foaf:Person]
{/ud}
{ud0}
Erhard Weigel ({dat1625}1625{/dat}) {en18}Philosophe{/en}. - Professeur de mathématiques, maître de Leibniz et de Pufendorf [http://data.bnf.fr/ark:/12148/cb11935908x#foaf:Person]
{/ud}
{ud0}
Jean-Dominique Cassini ({en0li}Perinaldo (comté de Nice){/en}, {dat1625}1625{/dat}) Titulaire de la chaire d''astronomie de Bologne de 1650 à 1669, surintendant des eaux du Bolonais de 1657 à 1669, surintendant des eaux de l''Etat pontifical et titulaire d''autres charges auprès du pape. - Appelé en France an avril 1669 par Louis XIV. - Membre de l''Académie des sciences, directeur de l''Observatoire de Paris (à partir de 1672). - Naturalisé français en 1673 [http://data.bnf.fr/ark:/12148/cb121019904#foaf:Person]
{/ud}
{ud0}
Johan de Witt (Dordrecht, Pays-Bas, {dat1625}1625{/dat}) Homme d''état et {en16}mathématicien{/en}. - Grand pensionnaire de Hollande [http://data.bnf.fr/ark:/12148/cb13598046j#foaf:Person]
{/ud}
{ud0}
Johann Hecker ({en0li}Gdansk (Pologne){/en}, {dat1625}1625{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb12875545t#foaf:Person]
{/ud}
{ud0}
Rasmus Bartholin ({en0li}Roskilde, Danemark{/en}, {dat1625}1625{/dat}) Physicien. - {en16}Mathématicien{/en}. - {en28}Médecin{/en}. - Professeur de mathématiques et de médecine à Copenhague. - A découvert la difraction de la lumière. - Fils de Kaspar Bartholin [http://data.bnf.fr/ark:/12148/cb11890430k#foaf:Person]
{/ud}
{ud0}
Samuel Morland ({dat1625}1625{/dat}) {en16}Mathématicien{/en} et inventeur [http://data.bnf.fr/ark:/12148/cb10365749d#foaf:Person]
{/ud}
{ud0}
Pietro Mengoli ({en0li}Bologne (Italie){/en}, {dat1626}1626{/dat}) {en16}Mathématicien{/en}. - Professeur de mécanique (1650-1678) puis titulaire de la chaire de mathématiques et d''astronomie (1678-1686) à l''université de Bologne [http://data.bnf.fr/ark:/12148/cb120851477#foaf:Person]
{/ud}
{ud0}
John Ray ({en0li}Black Notley (Essex){/en}, {dat1627}1627{/dat}) Professeur de mathématiques et de lettres. - Naturaliste. - Botaniste. - Membre de la Société royale de Londres [http://data.bnf.fr/ark:/12148/cb12220184b#foaf:Person]
{/ud}
{ud0}
Heinrich Scherer ({dat1628}1628{/dat}) Jésuite, {en29}géographe{/en} et professeur de mathématiques à Munich [http://data.bnf.fr/ark:/12148/cb15317471w#foaf:Person]
{/ud}
{ud0}
Johannes Hudde ({dat1628}1628{/dat}) {en16}Mathématicien{/en}, élève de Frans Van Schooten. - Bourgmestre de la ville d''Amsterdam [http://data.bnf.fr/ark:/12148/cb13488288n#foaf:Person]
{/ud}
{ud0}
Christiaan Huygens ({dat1629}1629{/dat}) {en16}Mathématicien{/en} et {en24}astronome{/en}. - A vécu aux Pays-Bas et en France. - Élu membre de la "Royal society" de Londres (en 1663) [http://data.bnf.fr/ark:/12148/cb12192922r#foaf:Person]
{/ud}
{ud0}
Allain Manesson-Mallet ({en0li}Paris (France){/en}, {dat1630}1630{/dat}) Ingénieur et cartographe. - Maître de mathématiques des pages du roi de France, sergent-major d''artillerie du roi de Portugal [http://data.bnf.fr/ark:/12148/cb153363577#foaf:Person]
{/ud}
{ud0}
Isaac Barrow ({dat1630}1630{/dat}) {en16}Mathématicien{/en} et théologien [http://data.bnf.fr/ark:/12148/cb12340135q#foaf:Person]
{/ud}
{ud0}
Jean Richer ({dat1630}1630{/dat}) {en24}Astronome{/en} à l''Observatoire de Paris, il figure parmi les premiers membres de l''Académie des sciences ({dat1666}1666{/dat}). - Chargé d''une mission géodésique à Cayenne (1672-73) [http://data.bnf.fr/ark:/12148/cb14064426q#foaf:Person]
{/ud}
{ud0}
Adam Adamady Kochánski ({dat1631}1631{/dat}) {en16}Mathématicien{/en} polonais, auteur de la rectification approchée de la circonférence. Réside en 1677 à Wroclaw [http://data.bnf.fr/ark:/12148/cb16187484g#foaf:Person]
{/ud}
{ud0}
Francesco Lana Terzi ({en0li}Brescia, Italie{/en}, {dat1631}1631{/dat}) Jésuite. - {en16}Mathématicien{/en}, naturaliste. - Pionnier de l''aéronautique [http://data.bnf.fr/ark:/12148/cb10681783j#foaf:Person]
{/ud}
{ud0}
Christopher Wren ({en0li}East Knoyle, Wiltshire, GB{/en}, {dat1632}1632{/dat}) Architecte. - {en16}Mathématicien{/en} et {en24}astronome{/en}, Sir Christopher Wren fut l''un des membres fondateurs de la Société royale des sciences [http://data.bnf.fr/ark:/12148/cb121401670#foaf:Person]
{/ud}
{ud0}
Alessandro Marchetti ({en0li}Empoli, Italie{/en}, {dat1633}1633{/dat}) Poète naturaliste, l''un des principaux animateurs du courant naturaliste toscan de la seconde moitié du XVIIe siècle. - Professeur de philosophie puis de mathématiques à l''Université de Pise [http://data.bnf.fr/ark:/12148/cb12570345j#foaf:Person]
{/ud}
{ud0}
Donato Rossetti ({en0li}Livourne, Italie{/en}, {dat1633}1633{/dat}) {en16}Mathématicien{/en}. - Professeur de philosophie au "Studio" de Pise [http://data.bnf.fr/ark:/12148/cb144820894#foaf:Person]
{/ud}
{ud0}
Geminiano Montanari ({en0li}Modène, Italie{/en}, {dat1633}1633{/dat}) Docteur en droit, {en16}mathématicien{/en} et {en24}astronome{/en}. - Enseigne à Florence, Modène (1661-1664), Bologne (chaire de mathématiques, 1664-1677) et Padoue (chaire d''astronomie, 1678-1687). - Membre de l''Accademia dei Gelati ("l''Elevato") et de l''Accademia della Treccia de Bologne [http://data.bnf.fr/ark:/12148/cb12309300z#foaf:Person]
{/ud}
{ud0}
Gerhard Wolter Molanus ({dat1633}1633{/dat}) Théologien luthérien. - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12133744h#foaf:Person]
{/ud}
{ud0}
Giovanni Giustino Ciampini ({en0li}Rome{/en}, {dat1633}1633{/dat}) Historien, archéologue, {en16}mathématicien{/en}. - Membre de la Curie pontificale [http://data.bnf.fr/ark:/12148/cb14323561z#foaf:Person]
{/ud}
{ud0}
Vitale Giordano ({dat1633}1633{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb15520924m#foaf:Person]
{/ud}
{ud0}
Johann Christoph Sturm ({en0li}Hilpolstein, Allemagne{/en}, {dat1635}1635{/dat}) {en18}Philosophe{/en}, {en16}mathématicien{/en} et physicien. - Professeur à l''université d''Altdorf [http://data.bnf.fr/ark:/12148/cb133240234#foaf:Person]
{/ud}
{ud0}
Ignace-Gaston Pardies ({dat1636}1636{/dat}) {en16}Mathématicien{/en}. - Jésuite. - Il a enseigné la philosophie puis les mathématiques au collège Louis-Le-Grand [http://data.bnf.fr/ark:/12148/cb12174258w#foaf:Person]
{/ud}
{ud0}
Elias van Lennep (Borculo, Pays-Bas, {dat1637}1637{/dat}) Graveur. - Ingénieur et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb15053499m#foaf:Person]
{/ud}
{ud0}
Julius Reichelt ({dat1637}1637{/dat}) {en16}Mathématicien{/en} strasbourgeois [http://data.bnf.fr/ark:/12148/cb15377331m#foaf:Person]
{/ud}
{ud0}
François Barrême ({en0li}Tarascon, France{/en}, {dat1638}1638{/dat}) {en16}Mathématicien{/en} et financier [http://data.bnf.fr/ark:/12148/cb118903320#foaf:Person]
{/ud}
{ud0}
Georg Christoph Eimmart ({en0li}Ratisbonne (Allemagne){/en}, {dat1638}1638{/dat}) Peintre d''histoire, portraitiste, graveur, {en16}mathématicien{/en} et {en24}astronome{/en}. - Fils et élève du peintre Georg-Christoph Eimmart (1603-1658), dit le vieux [http://data.bnf.fr/ark:/12148/cb12983761h#foaf:Person]
{/ud}
{ud0}
James Gregory ({dat1638}1638{/dat}) {en16}Mathématicien{/en} et opticien écossais [http://data.bnf.fr/ark:/12148/cb12459917j#foaf:Person]
{/ud}
{ud0}
Jean Bonfa ({en0li}Nîmes{/en}, {dat1638}1638{/dat}) Est admis à la Société de Jésus en 1654. - Dans les années 1670 jusqu''en 1683, il enseigne les mathématiques et la théologie aux collèges jésuites de Grenoble, puis d''Avignon. - De 1680 à 1682, enseigne la géométrie et l''hydrographie. - Effectue des travaux astronomiques. - Devient membre correspondant de l''Académie royale des sciences (en 1699) [http://data.bnf.fr/ark:/12148/cb15130186g#foaf:Person]
{/ud}
{ud0}
Jacques Ozanam (Sainte-Olive ({en0li}Ain){/en}, {dat1640}1640{/dat}) {en16}Mathématicien{/en}. - Professeur de mathématiques à Paris et à Lyon [http://data.bnf.fr/ark:/12148/cb120960958#foaf:Person]
{/ud}
{ud0}
Philippe de La Hire ({en0li}Paris (France){/en}, {dat1640}1640{/dat}) {en16}Mathématicien{/en}. - Géomètre et {en24}astronome{/en}. - Professeur de mathématiques au Collège de France. - Membre de l''Académie des sciences ({dat1678}1678{/dat}) [http://data.bnf.fr/ark:/12148/cb121592847#foaf:Person]
{/ud}
{ud0}
Pierre Ango ({dat1640}1640{/dat}) Jésuite. - Enseigna les humanités, les mathématiques et la philosophie. - Né à Rouen, mort à La Flèche [http://data.bnf.fr/ark:/12148/cb12512101m#foaf:Person]
{/ud}
{ud0}
Denis Papin ({dat1642}1642{/dat}) Physicien. - Un des précurseurs de l''invention de la machine à vapeur, qui eu l''idée du piston (dés 1690), et inspira la machine que l''Anglais Thomas Newcomen (1664-1729), mis au point ensuite (en 1712). - Quitta définitivement la France, après la révocation de l''Édit de Nantes ({dat1685}1685{/dat}). - Occupa une chaire de mathématiques à l''Université de Marburg, Allemagne ({dat1687}1687{/dat}). - Rédige un article (Ars nova ad aquam ignis...) présentant sa machine dans la revue " Acta Eruditorum", Leipzig (en 1707), revue célèbre pour les publications de Leibniz (1646-1716), sur le calcul différentiel et intégral [http://data.bnf.fr/ark:/12148/cb12087889k#foaf:Person]
{/ud}
{ud0}
Isaac Newton (Woolsthorpe, Lincolnshire ({en0li}GB){/en}, {dat1642}1642{/dat}) Physicien, {en16}mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb119176085#foaf:Person]
{/ud}
{ud0}
Johann Welper ({dat1642}1642{/dat}) Variante(s) de prénom : Johannes ; Jean. - Imprimeur-libraire. - Fils et apprenti d''Eberhard Welper, imprimeur-libraire et {en16}mathématicien{/en} à Strasbourg. A été compagnon pendant 6 ans à Ulm, Augsbourg, Munich, Vienne, Leipzig et Nuremberg, avant de succéder à son père. L''enquête de 1700-1701 le dit âgé de 60 ans et "établi à Strasbourg depuis 42 ans". À sa mort, son entreprise est rachetée par Melchior Pauschinger [http://data.bnf.fr/ark:/12148/cb160636269#foaf:Person]
{/ud}
{ud0}
Michel Mourgues ({dat1642}1642{/dat}) Jésuite. - Enseigna la rhétorique et les mathématiques à l''Université de Toulouse [http://data.bnf.fr/ark:/12148/cb124637183#foaf:Person]
{/ud}
{ud0}
Takakazu Seki ({dat1642}1642{/dat}) {en16}Mathématicien{/en} japonais [http://data.bnf.fr/ark:/12148/cb12443516f#foaf:Person]
{/ud}
{ud0}
Jean Jombert ({dat1643}1643{/dat}) Libraire. - Fils d''un fruitier et marchand de vins parisien. En apprentissage chez le libraire parisien Pierre II Baudouin à partir de janv. 1666, il travaille en 1670-1671 chez Louis Billaine et Pierre Le Petit, puis chez la veuve de Pierre I Baudouin à partir de 1672. Gendre en 1res noces ({dat1671}1671{/dat}) du libraire Jean d''Houry. Publie sous son propre nom dès 1680, peut-être dès 1678, mais n''est reçu maître que le 17 sept. 1686. Publie de nombreux ouvrages de mathématiques. Dit âgé d''env. 60 ans lors de l''enquête de nov.-déc. 1701. Testaments le 9 août 1704 et le 6 oct. 1705. Décédé au début de nov. 1705. Sa veuve lui succède [http://data.bnf.fr/ark:/12148/cb15074749j#foaf:Person]
{/ud}
{ud0}
Antoine Thomas ({en0li}Namur{/en}, {dat1644}1644{/dat}) Jésuite (à partir de 1660). - {en16}Mathématicien{/en} et {en24}astronome{/en} de l''empereur de Chine [http://data.bnf.fr/ark:/12148/cb10636254r#foaf:Person]
{/ud}
{ud0}
Johann Jakob Zimmermann ({en0li}Vaihingen an der Enz, Allemagne{/en}, {dat1644}1644{/dat}) Théologien, {en16}mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb10721479d#foaf:Person]
{/ud}
{ud0}
Ole Rømer ({en0li}Åarhus, Danemark{/en}, {dat1644}1644{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb12324191r#foaf:Person]
{/ud}
{ud0}
Carlos de Sigüenza y Góngora ({en0li}Mexico{/en}, {dat1645}1645{/dat}) {en24}Astronome{/en}, {en16}mathématicien{/en}, poète, historien. - Sa bibliothèque, comprenant des documents uniques sur l''histoire du Mexique, disparut dans un incendie lors de l''insurrection de 1692 [http://data.bnf.fr/ark:/12148/cb121021638#foaf:Person]
{/ud}
{ud0}
Eusebio Francisco Kino ({en0li}Taio, Italie{/en}, {dat1645}1645{/dat}) {en16}Mathématicien{/en} et {en29}géographe{/en} de formation. - Jésuite, arrive au Mexique en 1681 [http://data.bnf.fr/ark:/12148/cb122190783#foaf:Person]
{/ud}
{ud0}
Maximilian Rassler ({en0li}Waldsee (Allemagne){/en}, {dat1645}1645{/dat}) Jésuite. - Professeur de réthorique, de mathématiques, philosophie et contreverse. - Recteur et chancelier de l''Université de Dillingen, Allemagne [http://data.bnf.fr/ark:/12148/cb158132748#foaf:Person]
{/ud}
{ud0}
Elena Lucrezia Cornaro Piscopia ({en0li}Venise (Italie){/en}, {dat1646}1646{/dat}) {en18}Philosophe{/en} et {en16}mathématicien{/en}ne. - Première femme docteur en philosophie [http://data.bnf.fr/ark:/12148/cb16591183r#foaf:Person]
{/ud}
{ud0}
Francesco Maria Pompeo Colonna ({en0li}Rome{/en}, {dat1646}1646{/dat}) {en16}Mathématicien{/en}, physicien et occultiste. - Vécut à Paris à partir de 1668 [http://data.bnf.fr/ark:/12148/cb118973978#foaf:Person]
{/ud}
{ud0}
Harald Vallerius ({dat1646}1646{/dat}) Professeur universitaire de mathématiques [http://data.bnf.fr/ark:/12148/cb16032560b#foaf:Person]
{/ud}
{ud0}
John Flamsteed ({dat1646}1646{/dat}) {en24}Astronome{/en}. - Fut le premier directeur de l''Observatoire de Greenwich, GB, fondé en 1675 [http://data.bnf.fr/ark:/12148/cb13524243n#foaf:Person]
{/ud}
{ud0}
John Flamsteed ({dat1646}1646{/dat}) {en24}Astronome{/en} britannique. Fut le premier directeur de l''observatoire de Greenwich, fondé en 1675 [http://data.bnf.fr/ark:/12148/cb13510391m#foaf:Person]
{/ud}
{ud0}
Niccolò Partenio Giannettasio ({dat1648}1648{/dat}) Jésuite. - Historien et poète. - Professeur de mathématiques et d''hébreu au Collège des Jésuites de Naples. - Né à Naples, meurt à Massa [http://data.bnf.fr/ark:/12148/cb133256727#foaf:Person]
{/ud}
{ud0}
Tommaso Ceva ({dat1648}1648{/dat}) Jésuite. - {en18}Philosophe{/en}, {en24}astronome{/en}, physicien et poète. - Membre de l''Académie de l''Arcadie sous le pseudonyme : Callimaco Neridio [http://data.bnf.fr/ark:/12148/cb13321850h#foaf:Person]
{/ud}
{ud0}
Jean Le Febvre ({en0li}Lisieux (Calvados){/en}, {dat1650}1650{/dat}) Tisserand, puis {en24}astronome{/en}. - Membre de l''Académie des sciences de 1682 à 1702 [http://data.bnf.fr/ark:/12148/cb16176897g#foaf:Person]
{/ud}
{ud0}
Michelangelo Fardella ({dat1650}1650{/dat}) Franciscain. - {en18}Philosophe{/en}, {en24}astronome{/en} et {en16}mathématicien{/en}. - Professeur de philosophie, de théologie, de mathématiques, professeur d''astronomie et de physique à l''Université de Padoue (1694-). - Né à Trapani, meurt à Naples [http://data.bnf.fr/ark:/12148/cb12093422f#foaf:Person]
{/ud}
{ud0}
Andreas Cellarius ({dat1651}1651{/dat}) {en16}Mathématicien{/en} et {en29}géographe{/en} hollandais actif de 1656 à 1702. En 1660 il est recteur de l''Ecole latine de Hoorn [http://data.bnf.fr/ark:/12148/cb15338282n#foaf:Person]
{/ud}
{ud0}
Antoine-François Payen ({en0li}Avignon{/en}, {dat1651}1651{/dat}) Jurisconsulte et {en24}astronome{/en}. - Enseigna la jurisprudence civile dès 1642 à Avignon [http://data.bnf.fr/ark:/12148/cb144713316#foaf:Person]
{/ud}
{ud0}
Arent Roggeveen ({dat1651}1651{/dat}) {en16}Mathématicien{/en}, navigateur et hydrographe [http://data.bnf.fr/ark:/12148/cb153879695#foaf:Person]
{/ud}
{ud0}
Bingzhen Jiao ({dat1651}1651{/dat}) Peintre et {en16}mathématicien{/en} à la cour de l''empereur Kangxi [http://data.bnf.fr/ark:/12148/cb14546684c#foaf:Person]
{/ud}
{ud0}
Caspar Dauthendey ({dat1651}1651{/dat}) Architecte et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb153778194#foaf:Person]
{/ud}
{ud0}
Claude Bonjour ({dat1651}1651{/dat}) Augustin du couvent de Pontarlier. {en29}Géographe{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb15294805z#foaf:Person]
{/ud}
{ud0}
Claude Comiers ({dat1651}1651{/dat}) Théologien et {en16}mathématicien{/en}, né à Embrun. Chanoine d''Embrun, ingénieur des armées, puis prévôt de l''église collégiale de Ternant, professeur de mathématiques à Paris ; protonotaire apostolique et officier du Saint-Office. - Il a laissé des livres et des articles sur des sujets variés : géométrie, astronomie, médecine, occultisme, physique... [http://data.bnf.fr/ark:/12148/cb12250531g#foaf:Person]
{/ud}
{ud0}
Claude Irson ({dat1651}1651{/dat}) {en16}Mathématicien{/en} et {en27}grammairien{/en}. - A été teneur de comptes vers 1678 [http://data.bnf.fr/ark:/12148/cb125155096#foaf:Person]
{/ud}
{ud0}
de La Roche ({dat1651}1651{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb13009642b#foaf:Person]
{/ud}
{ud0}
Ehrenfried Walter von Tschirnhaus ({en0li}Kieslingswalde, Allemagne{/en}, {dat1651}1651{/dat}) {en18}Philosophe{/en}, {en16}mathématicien{/en} et biologiste. - Industriel, considéré comme l''inventeur de la porcellaine blanche en Europe [http://data.bnf.fr/ark:/12148/cb12515471b#foaf:Person]
{/ud}
{ud0}
Federico Gualdi ({dat1651}1651{/dat}) Alchimiste, {en24}astronome{/en}, {en16}mathématicien{/en}. - {en18}Philosophe{/en} hermétique. - Membre de la Rose-croix d''Or. - Serait d''origine allemande ou italienne [http://data.bnf.fr/ark:/12148/cb150904929#foaf:Person]
{/ud}
{ud0}
Francesco Levera ({en0li}Savoie{/en}, {dat1651}1651{/dat}) {en18}Philosophe{/en}, {en24}astronome{/en} et théologien [http://data.bnf.fr/ark:/12148/cb10442558v#foaf:Person]
{/ud}
{ud0}
François Chevalier (Sainte-Maur, {dat1651}1651{/dat}) Elève de l''abbé Galloys. Associé géomètre à l''Académie des sciences en 1707. Pensionnaire mécanicien en 1725. Professeur de mathématiques au Collège de France. Maître de mathématiques du roi et des pages de la Petite Ecurie. Présenta en 1707 à l''Académie une méthode de collecte des informations cartographiques sur des châssis concentriques [http://data.bnf.fr/ark:/12148/cb153045899#foaf:Person]
{/ud}
{ud0}
François Noël (Hestrud, Pays-Bas Méridionaux, {dat1651}1651{/dat}) Jésuite (à partir de 1670) ordonné prêtre en 1682. - Missionnaire en Chine, il fut envoyé à Rome à l''occasion de la querelle des rites, et ne put rentrer en Chinê. - Il enseigna ensuite à Prague. - Auteur de poésies et de théâtre, d''un traité d''astronomie, de traductions et d''un ouvrage catéchétique en chinois [http://data.bnf.fr/ark:/12148/cb16653645d#foaf:Person]
{/ud}
{ud0}
Guisnée ({dat1651}1651{/dat}) {en16}Mathématicien{/en}. - Membre de l''Académie royale des sciences [http://data.bnf.fr/ark:/12148/cb14618149h#foaf:Person]
{/ud}
{ud0}
Jacques Mengau ({dat1651}1651{/dat}) Professeur de mathématiques. - Auteur de mazarinades. - Actif de 1648 à 1652 [http://data.bnf.fr/ark:/12148/cb12166762s#foaf:Person]
{/ud}
{ud0}
Jean Bachou ({dat1651}1651{/dat}) {en16}Mathématicien{/en} et alchimiste lyonnais. - Avocat au parlement [http://data.bnf.fr/ark:/12148/cb12158814g#foaf:Person]
{/ud}
{ud0}
Jean Glover ({dat1651}1651{/dat}) Ingénieur et {en16}mathématicien{/en} originaire d''Écosse et établi en France. - Auteur notamment de plusieurs propositions de loteries et d''une "Nouvelle Manière d''exécuter les loteries..." ({en0li}Paris{/en}, {dat1705}1705{/dat}). - Se qualifie d''"esquire, seigneur de Glaideny et de la baronnie de Baltillée en Ecosse" [http://data.bnf.fr/ark:/12148/cb15818830h#foaf:Person]
{/ud}
{ud0}
Jean-Baptiste Delure ({dat1651}1651{/dat}) Éditeur d''estampes et de cartes géographiques. - Ingénieur pour les instruments de mathématiques et fabricant de cartes et de globes ; éditeur occasionnel [http://data.bnf.fr/ark:/12148/cb153164066#foaf:Person]
{/ud}
{ud0}
Joachim d'' Alencé ({dat1651}1651{/dat}) {en24}Astronome{/en} et physicien [http://data.bnf.fr/ark:/12148/cb12397878n#foaf:Person]
{/ud}
{ud0}
Joanne Westenburg ({dat1651}1651{/dat}) Cartographe, {en28}médecin{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb15377993t#foaf:Person]
{/ud}
{ud0}
Johann Andreas Planer ({en0li}Strelen, Allemagne{/en}, {dat1651}1651{/dat}) {en16}Mathématicien{/en}. - Professeur de mathématiques à l''Université de Wittenberg [http://data.bnf.fr/ark:/12148/cb16672375p#foaf:Person]
{/ud}
{ud0}
Le Blanc ({dat1651}1651{/dat}) Professeur de mathématiques ({dat1692}1692{/dat}). - Réside rue de Seine à Paris en 1692 [http://data.bnf.fr/ark:/12148/cb16650697x#foaf:Person]
{/ud}
{ud0}
Le Demaine Godalles ({dat1651}1651{/dat}) Hydrographe, Ingénieur du roi et professeur de Mathématiques, Architecte [http://data.bnf.fr/ark:/12148/cb15375819n#foaf:Person]
{/ud}
{ud0}
Philip Lea ({dat1651}1651{/dat}) Cartographe, fabricant et éditeur de globes, de cartes, d''instruments de mathématiques, actif de 1666 à 1700 à Londres [http://data.bnf.fr/ark:/12148/cb15328427v#foaf:Person]
{/ud}
{ud0}
René Gaultier de Maignannes ({dat1651}1651{/dat}) {en16}Mathématicien{/en} angevin. - Spécialiste de la perspective [http://data.bnf.fr/ark:/12148/cb12536157m#foaf:Person]
{/ud}
{ud0}
David François de Merveilleux ({dat1652}1652{/dat}) {en29}Géographe{/en} et cartographe. Connaissances mathématiques étendues (il publie un traîté d''arithmétique et de géométrie). En 1695 il entre au service de Guillaume III qui lui accorde le brevet de Capitaine Ingénieur au service d''Angleterre et des Etats généraux [http://data.bnf.fr/ark:/12148/cb15304894q#foaf:Person]
{/ud}
{ud0}
Michel Rolle (Ambert (Puy-de-Dôme), {dat1652}1652{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb130110121#foaf:Person]
{/ud}
{ud0}
Nicolas Bion ({dat1652}1652{/dat}) Ingénieur du roi pour les instruments de mathématique. - Avait un atelier à Paris, quai de l''Horloge, qui était l''un des mieux achalandés du temps. - Son "Usage des globes" connut 6 éditions entre 1699 et 1751. - Édita en 1694 le globe terrestre de P. Courtin (diam. 25 cm) et en 1712 une paire de globes de même diamètre, un globe céleste antérieur à 1710 atteignit 32 cm de diamètre [http://data.bnf.fr/ark:/12148/cb152909089#foaf:Person]
{/ud}
{ud0}
José Chaffrion ({dat1653}1653{/dat}) Cartographe et {en16}mathématicien{/en} de Valence en Espagne [http://data.bnf.fr/ark:/12148/cb15330290b#foaf:Person]
{/ud}
{ud0}
Bernard Nieuwentijt (West Graftdijk, Pays-Bas, {dat1654}1654{/dat}) {en18}Philosophe{/en}, {en28}médecin{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb14587835s#foaf:Person]
{/ud}
{ud0}
Jacques Bernoulli ({en0li}Bâle, Suisse{/en}, {dat1654}1654{/dat}) {en16}Mathématicien{/en} et {en24}astronome{/en}. - Professeur de mathématiques à l''université de Bâle, Suisse [http://data.bnf.fr/ark:/12148/cb120751142#foaf:Person]
{/ud}
{ud0}
Jean Pigeon ({en0li}Donzy (Nièvre){/en}, {dat1654}1654{/dat}) Peintre, {en16}mathématicien{/en} et facteur de globes, {en29}géographe{/en} du Duc d''Orléans à partir de 1714 [http://data.bnf.fr/ark:/12148/cb15147433m#foaf:Person]
{/ud}
{ud0}
Jean-François Gerbillon ({dat1654}1654{/dat}) Jésuite. - {en16}Mathématicien{/en}, fut envoyé en Chine par Louis XIV en 1685. - Écrivit des traités de géométrie et de l''usage de l''astrolabe en chinois et en tartare. - Supérieur général de la Mission française de Chine [http://data.bnf.fr/ark:/12148/cb124622770#foaf:Person]
{/ud}
{ud0}
Philippe Avril ({en0li}Angoulême (Charente){/en}, {dat1654}1654{/dat}) Missionnaire. - Voyageur, jésuite dès 1670, il enseigna les mathématiques à Louis-le-Grand. - Chercha un nouveau passage vers la Chine par la Tartarie, le Kurdistan et l''Arménie [http://data.bnf.fr/ark:/12148/cb15327596q#foaf:Person]
{/ud}
{ud0}
Philippe Naudé ({en0li}Metz{/en}, {dat1654}1654{/dat}) Théologien et {en16}mathématicien{/en}. - Se réfugia en Prusse après la révocation de l''Édit de Nantes [http://data.bnf.fr/ark:/12148/cb10366497p#foaf:Person]
{/ud}
{ud0}
Pierre Varignon ({en0li}Caen (Calvados){/en}, {dat1654}1654{/dat}) {en16}Mathématicien{/en}. - Jésuite. - Membre de l''Académie des sciences, il entre au collège de France en 1704 [http://data.bnf.fr/ark:/12148/cb121123302#foaf:Person]
{/ud}
{ud0}
Louis Lecomte ({dat1655}1655{/dat}) Jésuite. - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12151496v#foaf:Person]
{/ud}
{ud0}
Simon Tyssot de Patot ({en0li}Londres{/en}, {dat1655}1655{/dat}) Professeur ordinaire de mathématiques à l''École illustre de Deventer (1699-1727 ; professeur extraordinaire dès 1690). - Vécut en France de 1658 environ à 1664, puis aux Pays-Bas [http://data.bnf.fr/ark:/12148/cb11927303t#foaf:Person]
{/ud}
{ud0}
Claude de Visdelou (Erquy (Côtes-d''Armor), {dat1656}1656{/dat}) Jésuite. - {en16}Mathématicien{/en}. - Missionnaire en Chine. - Évèque titulaire de de Claudiopolis-en-Isaurie (à partir de 1708/1709). - Vicaire apostolique du Koueitchéou et du Yunnan, et administrateu du Houkouang (de 1708 à 1709) [http://data.bnf.fr/ark:/12148/cb150791582#foaf:Person]
{/ud}
{ud0}
Edmund Halley ({dat1656}1656{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb119960783#foaf:Person]
{/ud}
{ud0}
Nicolaas Hartsoeker (Gouda (Pays-Bas), {dat1656}1656{/dat}) Physicien, micrographe et {en28}médecin{/en}. - Apporta des perfectionnements importants à la fabrication des verres de lunettes astronomiques, découvrit les animalcules spermatiques [http://data.bnf.fr/ark:/12148/cb13010358x#foaf:Person]
{/ud}
{ud0}
William Molyneux ({en0li}Dublin{/en}, {dat1656}1656{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en}, physicien et {en18}philosophe{/en}. - Premier secrétaire de la Société philosophique de Dublin (en 1684) [http://data.bnf.fr/ark:/12148/cb124596616#foaf:Person]
{/ud}
{ud0}
Jean-Mathieu de Chazelles ({en0li}Lyon{/en}, {dat1657}1657{/dat}) Cartographe, {en29}géographe{/en} et {en24}astronome{/en} associé à l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb106281104#foaf:Person]
{/ud}
{ud0}
Jean-Matthieu de Chazelles ({en0li}Lyon{/en}, {dat1657}1657{/dat}) Fit ses études chez les jésuites et devint l''auxiliaire de Cassini I. Fut associé aux travaux géodésiques menés par l''Académie des sciences. Dessina le planisphère de l''Observatoire. Collabora au Neptune françois. Associé {en24}astronome{/en} de l''Académie des sciences en 1695; associé mécanicien en 1699. Professeur d''hydrographie à Marseille [http://data.bnf.fr/ark:/12148/cb15304334g#foaf:Person]
{/ud}
{ud0}
Joseph Saurin ({en0li}Courthézon (Vaucluse){/en}, {dat1659}1659{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb10330722j#foaf:Person]
{/ud}
{ud0}
Philippe Desplaces ({dat1659}1659{/dat}) {en24}Astronome{/en}. - Auteur d''éphémérides [http://data.bnf.fr/ark:/12148/cb12223720g#foaf:Person]
{/ud}
{ud0}
Louis Feuillée (Mane (Alpes-de-Haute-Provence), {dat1660}1660{/dat}) {en24}Astronome{/en} et botaniste. - Religieux de l''ordre des Minimes. - Initié à la botanique par le P. Plumier. Correspondant {en24}astronome{/en} de l''Académie des sciences, il obtient une mission dans le Levant. Revenu à Marseille en 1702, il embarque l''année suivante pour les Antilles et parvient à Carthagène en 1704. Nommé {en16}mathématicien{/en} du roi, il s''embarque pour l''Amérique du Sud en 1707. En 1724, il est chargé de déterminer la position exacte de l''île de Fer [http://data.bnf.fr/ark:/12148/cb15309142r#foaf:Person]
{/ud}
{ud0}
Thomas Fantet de Lagny ({en0li}Lyon (Rhône){/en}, {dat1660}1660{/dat}) {en16}Mathématicien{/en}. - Professeur [http://data.bnf.fr/ark:/12148/cb14548143w#foaf:Person]
{/ud}
{ud0}
Guillaume-François-Antoine de L''Hospital ({dat1661}1661{/dat}) Marquis de Sainte-Mesme. - {en16}Mathématicien{/en}, membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb12000655c#foaf:Person]
{/ud}
{ud0}
Francesco Bianchini ({en0li}Vérone, Italie{/en}, {dat1662}1662{/dat}) Théologien, historien, {en24}astronome{/en} et physicien [http://data.bnf.fr/ark:/12148/cb12452255g#foaf:Person]
{/ud}
{ud0}
Paolo Mattia Doria ({dat1662}1662{/dat}) {en18}Philosophe{/en} et {en16}mathématicien{/en} italien [http://data.bnf.fr/ark:/12148/cb121118306#foaf:Person]
{/ud}
{ud0}
Jean-Pierre de Crousaz ({dat1663}1663{/dat}) Professeur de philosophie et mathématiques à Lausanne et Groningue. - Conseiller de la légation de Suède en Hollande. - Membre des Académies de Bordeaux et Paris [http://data.bnf.fr/ark:/12148/cb12016566d#foaf:Person]
{/ud}
{ud0}
Johann Balthasar Lauterbach ({dat1663}1663{/dat}) {en16}Mathématicien{/en} et architecte allemand [http://data.bnf.fr/ark:/12148/cb137778333#foaf:Person]
{/ud}
{ud0}
John Craig ({dat1663}1663{/dat}) {en16}Mathématicien{/en} et théologien écossais [http://data.bnf.fr/ark:/12148/cb114408210#foaf:Person]
{/ud}
{ud0}
Katahiro Takebe ({dat1664}1664{/dat}) {en16}Mathématicien{/en} japonais [http://data.bnf.fr/ark:/12148/cb12443517s#foaf:Person]
{/ud}
{ud0}
Lothar Zumbach von Coesfeld ({en0li}Trèves (Allemagne){/en}, {dat1664}1664{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en}, {en28}médecin{/en}, musicien. - {en16}Mathématicien{/en} et musicien de l''électeur de Trèves (1685-1688). - Lecteur en astronomie à l''université de Leyde. - Professeur de mathématiques au Carolinum de Kassel [http://data.bnf.fr/ark:/12148/cb14853628w#foaf:Person]
{/ud}
{ud0}
Abraham de Moivre (Vitry-le-François ({en0li}Marne){/en}, {dat1667}1667{/dat}) {en16}Mathématicien{/en}. - Émigra en Grande-Bretagne après la révocation de l''Édit de Nantes (en 1686). - Membre de la Royal Society, de l''Académie de Berlin et de l''Académie de Saint-Pétersbourg [http://data.bnf.fr/ark:/12148/cb130110001#foaf:Person]
{/ud}
{ud0}
Girolamo Saccheri ({en0li}San Remo, Italie{/en}, {dat1667}1667{/dat}) Jésuite. - Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb13164455b#foaf:Person]
{/ud}
{ud0}
Johann Bernoulli ({en0li}Bâle, Suisse{/en}, {dat1667}1667{/dat}) {en16}Mathématicien{/en} et physicien, maître d''Euler, professeur à l''Université de Groningue puis à l''Université de Bâle. - A travaillé sur le calcul différentiel, intégral et exponentiel. - Également auteur de traités de médecine, fondateur de la théorie mécanico-physique de la fermentation [http://data.bnf.fr/ark:/12148/cb122991692#foaf:Person]
{/ud}
{ud0}
William Whiston (Norton-juxta-Twycross (G. B.), {dat1667}1667{/dat}) Théologien et {en24}astronome{/en}. - Professeur de mathématiques à Cambridge, d''où il fut exclu pour ses écrits théologiques. - Traducteur de Flavius Josèphe [http://data.bnf.fr/ark:/12148/cb11997914k#foaf:Person]
{/ud}
{ud0}
Guillaume Bonjour (Toulouse (Haute-Garonne), {dat1669}1669{/dat}) Augustin. - Missionnaire en Chine. - Orientaliste, {en24}astronome{/en} et cartographe [http://data.bnf.fr/ark:/12148/cb13613529n#foaf:Person]
{/ud}
{ud0}
Leonhard Christoph Sturm ({en0li}Aldorf, Allemagne{/en}, {dat1669}1669{/dat}) {en16}Mathématicien{/en}. - Architecte [http://data.bnf.fr/ark:/12148/cb143383238#foaf:Person]
{/ud}
{ud0}
Jean Terrasson ({en0li}Lyon{/en}, {dat1670}1670{/dat}) Oratorien, {en16}mathématicien{/en} et {en18}philosophe{/en}. - Professeur de grec et latin au Collège de France. - Membre de l''Institut, Académie Française (élu en 1732) [http://data.bnf.fr/ark:/12148/cb119262217#foaf:Person]
{/ud}
{ud0}
Guido Grandi ({en0li}Crémone, Italie{/en}, {dat1671}1671{/dat}) {en16}Mathématicien{/en}, théologien, biographe, antiquaire et poète. - Soutint Descartes contre l''aristotélisme. - Professeur de philosophie à l''Université de Pise. - Fut en correspondance avec Leibniz, Newton, Bernoulli. - Intendant général des eaux en Toscane [http://data.bnf.fr/ark:/12148/cb121384290#foaf:Person]
{/ud}
{ud0}
Johann Gabriel Doppelmayr ({dat1671}1671{/dat}) Fils d''un riche négociant qui s''occupait de physique, et destiné d''abord à l''étude du droit, il la quitta pour celle des mathématiques et voyagea jusqu''en 1702. Professeur à Nuremberg et membre de la Royal Society de Londres [http://data.bnf.fr/ark:/12148/cb15327296w#foaf:Person]
{/ud}
{ud0}
Johann Gabriel Doppelmayr ({dat1671}1671{/dat}) {en16}Mathématicien{/en}. - Membre de la Royal Society de Londres ({dat1713}1713{/dat}) [http://data.bnf.fr/ark:/12148/cb12158680q#foaf:Person]
{/ud}
{ud0}
Johann Gabriel Doppelmayr ({dat1671}1671{/dat}) {en24}Astronome{/en} et cartographe ayant véçu à Nuremberg, né en 1671 ou 1677 [http://data.bnf.fr/ark:/12148/cb15327296w#foaf:Person]
{/ud}
{ud0}
Johann Heinrich Müller ({dat1671}1671{/dat}) Physicien, {en24}astronome{/en}, {en16}mathématicien{/en}. - Professeur à l''université d''Altdorf (Allemagne) [http://data.bnf.fr/ark:/12148/cb10706008k#foaf:Person]
{/ud}
{ud0}
John Keill ({dat1671}1671{/dat}) {en16}Mathématicien{/en} écossais. - Professeur d''astronomie à Oxford [http://data.bnf.fr/ark:/12148/cb123670586#foaf:Person]
{/ud}
{ud0}
Étienne-Simon de Gamaches ({dat1672}1672{/dat}) {en24}Astronome{/en} et moraliste. - Chanoine de Sainte Croix de La Bretonnerie. - Membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb12004341t#foaf:Person]
{/ud}
{ud0}
Johann Jacob Scheuchzer ({en0li}Zürich{/en}, {dat1672}1672{/dat}) {en28}Médecin{/en}, naturaliste, historien, archéologue, numismate, {en24}astronome{/en} et physicien [http://data.bnf.fr/ark:/12148/cb123955592#foaf:Person]
{/ud}
{ud0}
Eustachio Manfredi ({dat1674}1674{/dat}) {en24}Astronome{/en}. - Poète. - Fondateur de l''Académie de Bologne [http://data.bnf.fr/ark:/12148/cb12202194q#foaf:Person]
{/ud}
{ud0}
Julien Mahuet ({dat1674}1674{/dat}) Jésuite. - Né à Reims. Entre au noviciat le 24 août 1692. Enseigne les humanités à Reims, la rhétorique à Metz et les mathématiques à Reims. - Écrit du théâtre pour le Collège de Reims [http://data.bnf.fr/ark:/12148/cb13165624v#foaf:Person]
{/ud}
{ud0}
Guillaume Delisle ({dat1675}1675{/dat}) Cartographe. - Fils de Claude Delisle, fut l''élève de Jean-Dominique Cassini. Élève {en24}astronome{/en} à l''Académie des sciences en 1702, il en devint membre en 1718 ; enseigna la géographie au jeune Louis XV et fut nommé premier {en29}géographe{/en} du roi ; produisit quelque 100 cartes qu''il édita lui-même [http://data.bnf.fr/ark:/12148/cb15238363g#foaf:Person]
{/ud}
{ud0}
Humphry Ditton (Salisbury (G. B.), {dat1675}1675{/dat}) {en16}Mathématicien{/en} et théologien [http://data.bnf.fr/ark:/12148/cb15994181b#foaf:Person]
{/ud}
{ud0}
Yves-Marie André ({dat1675}1675{/dat}) Jésuite. - Professeur de mathématiques à Caen [http://data.bnf.fr/ark:/12148/cb12180932c#foaf:Person]
{/ud}
{ud0}
Jacopo Francesco Riccati ({dat1676}1676{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb120689750#foaf:Person]
{/ud}
{ud0}
Gabriel Philippe de La Hire ({en0li}Paris{/en}, {dat1677}1677{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb106522995#foaf:Person]
{/ud}
{ud0}
Jacques Cassini ({en0li}Paris{/en}, {dat1677}1677{/dat}) Fils de Jean-Dominique Cassini et père de César-François Cassini de Thury. Associé {en24}astronome{/en} à l''Académie des sciences en 1699, pensionnaire en 1712. En 1700 participa à la mesure de la méridienne de l''Observatoire et y travailla jusqu''à son achèvement en 1718. En 1706 maître ordinaire à la Chambre des comptes. Etudia les planètes et leurs satellites. Soutint la thèse de l''allongement de la Terre aux pôles. [http://data.bnf.fr/ark:/12148/cb15238366h#foaf:Person]
{/ud}
{ud0}
Joseph Privat de Molières (Tarascon (ouches-du-Rhône), {dat1677}1677{/dat}) Physicien et {en16}mathématicien{/en}. - Oratorien (vers 1709). - Professeur au collège royal ({dat1723}1723{/dat}). - Adjoint ({dat1721}1721{/dat}) puis associé ({dat1729}1729{/dat}) de l''Académie royale des sciences [http://data.bnf.fr/ark:/12148/cb145391041#foaf:Person]
{/ud}
{ud0}
Gerard Keulen ({dat1678}1678{/dat}) Graveur, cartographe, {en16}mathématicien{/en} et éditeur. - Fils de Johannes van Keulen [http://data.bnf.fr/ark:/12148/cb15332761m#foaf:Person]
{/ud}
{ud0}
Jacob Hermann ({dat1678}1678{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12319998c#foaf:Person]
{/ud}
{ud0}
Jean-Jacques Dortous de Mairan ({en0li}Béziers{/en}, {dat1678}1678{/dat}) Physicien et {en16}mathématicien{/en}. - Membre puis secrétaire perpétuel de l''Académie des sciences. - Membre de l''Académie française (élu en 1743) [http://data.bnf.fr/ark:/12148/cb12395086k#foaf:Person]
{/ud}
{ud0}
Louis Bourguet ({en0li}Nïmes{/en}, {dat1678}1678{/dat}) Professeur de philosophie et de mathématiques à Neuchâtel. - Est l''un des fondateurs de la "Bibliothèque italique" (1728-) et du "Mercure suisse" (1732-). - Naturalisé Neuchâtelois en 1710 [http://data.bnf.fr/ark:/12148/cb12797692b#foaf:Person]
{/ud}
{ud0}
Pierre Rémond de Montmort ({en0li}Paris{/en}, {dat1678}1678{/dat}) {en16}Mathématicien{/en}. - Spécialiste de probabilités [http://data.bnf.fr/ark:/12148/cb12391046c#foaf:Person]
{/ud}
{ud0}
Bernardino Zendrini ({en0li}Saviore, Italie{/en}, {dat1679}1679{/dat}) {en28}Médecin{/en}. - {en16}Mathématicien{/en}. - Hydraulicien [http://data.bnf.fr/ark:/12148/cb13545066d#foaf:Person]
{/ud}
{ud0}
Christian Wolff ({en0li}Breslau, Silésie (Wrocław, Pologne){/en}, {dat1679}1679{/dat}) Juriste, {en16}mathématicien{/en} et {en18}philosophe{/en} [http://data.bnf.fr/ark:/12148/cb121387859#foaf:Person]
{/ud}
{ud0}
Firmin Abauzit ({en0li}Uzès{/en}, {dat1679}1679{/dat}) {en16}Mathématicien{/en}, {en18}philosophe{/en} et bibliothécaire. - Fut bibliothécaire à la Bibliothèque de Genève. - Vécut à Genève après la révocation de l''Édit de Nantes [http://data.bnf.fr/ark:/12148/cb121711117#foaf:Person]
{/ud}
{ud0}
Claude Richer ({dat1680}1680{/dat}) Abbé. - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12532604f#foaf:Person]
{/ud}
{ud0}
Pierre Jartoux ({dat1680}1680{/dat}) {en24}Astronome{/en} et missionnaire jésuite en Chine [http://data.bnf.fr/ark:/12148/cb15367486z#foaf:Person]
{/ud}
{ud0}
Paolino Chelucci ({en0li}Lucca, Italie{/en}, {dat1681}1681{/dat}) Professeur d''éloquence à l''Université de Rome. - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb104300443#foaf:Person]
{/ud}
{ud0}
Roger Cotes ({en0li}Burbage (Leicestershire){/en}, {dat1682}1682{/dat}) {en16}Mathématicien{/en}. - Professeur d''astronomie et de philosophie expérimentale au Trinity College, Cambridge (1707-). - A édité la seconde édition des "Principia" de Newton [http://data.bnf.fr/ark:/12148/cb123946202#foaf:Person]
{/ud}
{ud0}
Noël Regnault ({dat1683}1683{/dat}) Jésuite. - Professeur de mathématiques et physique au collège de Paris [http://data.bnf.fr/ark:/12148/cb12218681d#foaf:Person]
{/ud}
{ud0}
Johann Matthias Hase ({dat1684}1684{/dat}) {en29}Géographe{/en} et cartographe ; historien. - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb13007561v#foaf:Person]
{/ud}
{ud0}
Brook Taylor ({dat1685}1685{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12315365s#foaf:Person]
{/ud}
{ud0}
Giovanni Poleni ({en0li}Venise, Italie{/en}, {dat1685}1685{/dat}) Physicien, {en16}mathématicien{/en} et archéologue [http://data.bnf.fr/ark:/12148/cb12161210z#foaf:Person]
{/ud}
{ud0}
Jean-Edme Gallimard ({en0li}Paris{/en}, {dat1685}1685{/dat}) Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb120827146#foaf:Person]
{/ud}
{ud0}
Jai Singh ({en0li}Amber (Rajasthan, Inde){/en}, {dat1686}1686{/dat}) Mahārāja de Jaipur (Rajasthan, Inde) de 1699 à 1743. - Fondateur de la ville de Jaipur (en 1727). - Chef du clan rajput des Kachhwa. - Bâtisseur de cinq observatoires astronomiques (yantra) dans l''Inde du Nord, à Delhi, Jaipur, Mathura, Varanasi et Ujjain. - Publia des tables astronomiques. - Les dates biographiques (1688-1743) sont aussi parfois retenues [http://data.bnf.fr/ark:/12148/cb16578505b#foaf:Person]
{/ud}
{ud0}
Nicolas Bernoulli ({dat1687}1687{/dat}) {en16}Mathématicien{/en} et juriste suisse [http://data.bnf.fr/ark:/12148/cb13510346s#foaf:Person]
{/ud}
{ud0}
Robert Simson ({dat1687}1687{/dat}) {en16}Mathématicien{/en}. - A été professeur à l''Université de Glasgow, GB [http://data.bnf.fr/ark:/12148/cb12399224j#foaf:Person]
{/ud}
{ud0}
Joseph-Nicolas Delisle ({en0li}Paris{/en}, {dat1688}1688{/dat}) {en24}Astronome{/en}. - Il reçut l''enseignement de Cassini II. - Professeur de mathématiques au Collège de France et {en29}géographe{/en} de la marine. - Membre de l''Institut, Académie des sciences ({dat1714}1714{/dat}). - Fondateur de l''École d''astronomie de Saint-Pétersbourg (à partir de 1725), a séjourné en Russie jusqu''en 1747 [http://data.bnf.fr/ark:/12148/cb12150746w#foaf:Person]
{/ud}
{ud0}
Louis-Bertrand Castel ({en0li}Montpellier{/en}, {dat1688}1688{/dat}) Jésuite ({dat1703}1703{/dat}). - {en18}Philosophe{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12462543h#foaf:Person]
{/ud}
{ud0}
Pierre Brumoy ({en0li}Rouen{/en}, {dat1688}1688{/dat}) Jésuite en 1704. - Professeur de rhétorique à Caen, précepteur du prince de Talmont, professeur de mathématiques au collège de Louis-le-Grand à Paris. - Collabore au Journal de Trévoux de 1722 à 1739. - Littérateur [http://data.bnf.fr/ark:/12148/cb12069382v#foaf:Person]
{/ud}
{ud0}
Willem Jacob''s Gravesande ({dat1688}1688{/dat}) Physicien. - {en18}Philosophe{/en}. - Professeur de mathématique et astronomie à Leyde, Pays-Bas. - Éditeur du "Journal littéraire de la Haye", devenu "Journal de la République des Lettres" [http://data.bnf.fr/ark:/12148/cb12218384m#foaf:Person]
{/ud}
{ud0}
Antoine Gaubil ({en0li}Gaillac (Aveyron){/en}, {dat1689}1689{/dat}) Jésuite et missionnaire en Chine. - Établit un observatoire à Pékin, dans la résidence française. - Écrit sur l''astronomie, la géographie, l''histoire et la littérature de la Chine [http://data.bnf.fr/ark:/12148/cb12150997b#foaf:Person]
{/ud}
{ud0}
Giovanni Gaetano Bottari ({en0li}Rome{/en}, {dat1689}1689{/dat}) Savant prélat. - A étudié les langues et la littérature de l''Antiquité, les mathématiques, la philosophie et la théologie. - Membre de l''Académie della Crusca. - Conservateur de la bibliothèque du Vatican [http://data.bnf.fr/ark:/12148/cb12516784r#foaf:Person]
{/ud}
{ud0}
Robert Smith ({en0li}Lea, GB{/en}, {dat1689}1689{/dat}) Professeur de mathématiques et de philosophie naturelle à Cambridge [http://data.bnf.fr/ark:/12148/cb15075770m#foaf:Person]
{/ud}
{ud0}
Christian Goldbach ({dat1690}1690{/dat}) {en16}Mathématicien{/en} allemand [http://data.bnf.fr/ark:/12148/cb124384045#foaf:Person]
{/ud}
{ud0}
Johann Friedrich Weidler (Gros-Neuhausen, Allemagne, {dat1691}1691{/dat}) {en26}Écrivain{/en}, {en16}mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb151541516#foaf:Person]
{/ud}
{ud0}
Esprit Pezenas ({en0li}Avignon{/en}, {dat1692}1692{/dat}) Jésuite. - {en24}Astronome{/en} et {en16}mathématicien{/en}. - Professeur d''hydrographie à Marseille et directeur de l''Observatoire de Marseille ({dat1749}1749{/dat}) [http://data.bnf.fr/ark:/12148/cb12120600p#foaf:Person]
{/ud}
{ud0}
James Stirling ({en0li}Garden, GB{/en}, {dat1692}1692{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb13475586v#foaf:Person]
{/ud}
{ud0}
Petrus Van Musschenbroek ({dat1692}1692{/dat}) Physicien, docteur en médecine et en philosophie. - Fut l''inventeur de la pyrométrie. - Fut professeur de philosophie naturelle, de mathématiques et d''astronomie à l''Université d''Utrecht, puis professeur à Leiden [http://data.bnf.fr/ark:/12148/cb13475113j#foaf:Person]
{/ud}
{ud0}
Diego de Torres Villarroel ({dat1693}1693{/dat}) Prêtre catholique. - Homme de lettres. - Professeur de mathématiques à l''université de Salamanque [http://data.bnf.fr/ark:/12148/cb119268467#foaf:Person]
{/ud}
{ud0}
Giovanni Bianchi ({en0li}Rimini (Italie){/en}, {dat1693}1693{/dat}) {en28}Médecin{/en}. - Professeur d''anatomie à l''Université de Sienne (1741-). - Auteur d''ouvrages médicaux, archéologiques, astronomiques, etc. [http://data.bnf.fr/ark:/12148/cb10649342z#foaf:Person]
{/ud}
{ud0}
Christfried Kirch ({dat1694}1694{/dat}) {en24}Astronome{/en} allemand. - Il succéda à son père Gottfried (1639-1710) dans la direction de l''Observatoire royal de Prusse (1716-1740). - Membre de l''Académie des sciences de Berlin ({dat1716}1716{/dat}) et associé de celles de Paris ({dat1723}1723{/dat}) et de Saint-Pétersbourg [http://data.bnf.fr/ark:/12148/cb12648455m#foaf:Person]
{/ud}
{ud0}
Dominique-François Rivard ({dat1697}1697{/dat}) {en16}Mathématicien{/en}. - {en18}Philosophe{/en}. - Professeur au collège de Beauvais [http://data.bnf.fr/ark:/12148/cb119220838#foaf:Person]
{/ud}
{ud0}
Abbé Deidier ({en0li}Marseille{/en}, {dat1698}1698{/dat}) Abbé. - {en16}Mathématicien{/en}. - Professeur d''artillerie à l''Ecole militaire de La Fère [http://data.bnf.fr/ark:/12148/cb102670411#foaf:Person]
{/ud}
{ud0}
Colin MacLaurin ({en0li}Kilmodan, GB{/en}, {dat1698}1698{/dat}) {en16}Mathématicien{/en} et physicien [http://data.bnf.fr/ark:/12148/cb12534513m#foaf:Person]
{/ud}
{ud0}
Pierre-Louis Moreau de Maupertuis (Saint-Malo, Ille-et-Villaine, {dat1698}1698{/dat}) {en18}Philosophe{/en}, {en24}astronome{/en} et physicien. - Fut invité par Frédéric II à réorganiser puis présider l''Académie de Berlin. - Ami puis ennemi de Voltaire, qui écrivit contre lui "Micromégas". - Membre de l''Académie française (élu en 1743) [http://data.bnf.fr/ark:/12148/cb11915229j#foaf:Person]
{/ud}
{ud0}
Charles-Étienne-Louis Camus (Crécy-en-Brie (Seine-et-Marne), {dat1699}1699{/dat}) {en16}Mathématicien{/en}. - {en24}Astronome{/en}. - Participa à l''expédition de 1736 en Laponie. - Membre de l''Académie des sciences ({dat1727}1727{/dat}) et de l''Académie d''architecture ({dat1739}1739{/dat}) [http://data.bnf.fr/ark:/12148/cb12181030f#foaf:Person]
{/ud}
{ud0}
Johann Ludwig Levin Gebhardi ({en0li}Braunschweig, Allemagne{/en}, {dat1699}1699{/dat}) Historien, professeur de philologie à l''académie équestre de Lüneburg ({dat1723}1723{/dat}). - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb143273694#foaf:Person]
{/ud}
{ud0}
Daniel Bernoulli (Groningue (Pays-Bas), {dat1700}1700{/dat}) {en16}Mathématicien{/en}, physicien et {en24}astronome{/en}. - Fut professeur à Saint-Petersbourg (1725-1733) et à Bâle (1733-) [http://data.bnf.fr/ark:/12148/cb122991859#foaf:Person]
{/ud}
{ud0}
Sámuel Mikoviny ({en0li}Ábelfalva, aujourd''hui Ábelová, Slovaquie{/en}, {dat1700}1700{/dat}) Cartographe. - Officier du génie. - Spécialiste en hydraulique. - {en16}Mathématicien{/en}. - Disciple de Bél Mátyás (1684-1749). - Études à Jena et à Nuremberg, Allemagne [http://data.bnf.fr/ark:/12148/cb103650124#foaf:Person]
{/ud}
{ud0}
Anders Celsius ({dat1701}1701{/dat}) {en24}Astronome{/en} et naturaliste. - Professeur d''astronomie à l''université d''Uppsala ({dat1730}1730{/dat}) [http://data.bnf.fr/ark:/12148/cb14606035v#foaf:Person]
{/ud}
{ud0}
Charles-Marie de La Condamine ({en0li}Paris{/en}, {dat1701}1701{/dat}) Savant. - {en24}Astronome{/en}. - {en29}Géographe{/en}. Mesura l''arc du Méridien avec Godin et Bouguer. - Membre de l''Académie française (élu en 1760) [http://data.bnf.fr/ark:/12148/cb119102567#foaf:Person]
{/ud}
{ud0}
Georg Wolfgang Krafft ({en0li}Tuttlingen (Allemagne){/en}, {dat1701}1701{/dat}) Physicien, professeur de mathématiques et de physique [http://data.bnf.fr/ark:/12148/cb10587905k#foaf:Person]
{/ud}
{ud0}
Johannes Nicolaus Frobesius ({en0li}Goslar, Allemagne{/en}, {dat1701}1701{/dat}) {en16}Mathématicien{/en} et professeur de philosophie [http://data.bnf.fr/ark:/12148/cb12355199c#foaf:Person]
{/ud}
{ud0}
Niccolò de Martino ({dat1701}1701{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb16265590z#foaf:Person]
{/ud}
{ud0}
Johann Lorenz Schmidt ({dat1702}1702{/dat}) Fils de pasteur, a étudié la théologie et s''est intéressé à la  philosophie et aux mathématiques. - A publié en 1735 une traduction annotée de la première partie de la Bible, les cinq livres de Moïse (ou Torah ou Pentateuque), connue sous le nom de "Wertheimer Bible", laquelle a été censurée par l''empereur [http://data.bnf.fr/ark:/12148/cb150701237#foaf:Person]
{/ud}
{ud0}
Antoine Deparcieux ({dat1703}1703{/dat}) {en16}Mathématicien{/en} et statisticien. - Fut constructeur de cadrans solaires et inventeur de machines pour élever les eaux et de presse pour le tabac. - Membre de l''Académie des sciences ({dat1746}1746{/dat}) [http://data.bnf.fr/ark:/12148/cb121904326#foaf:Person]
{/ud}
{ud0}
Bernard-Laurent Soumille ({dat1703}1703{/dat}) {en16}Mathématicien{/en}, physicien et agronome. - Prêtre-bénéficier du chapitre de Villeneuve-lès-Avignon (à partir de 1736, environ). - Correspondant de l''Académie royale des sciences de Paris [http://data.bnf.fr/ark:/12148/cb130919156#foaf:Person]
{/ud}
{ud0}
Thomas Le Seur ({dat1703}1703{/dat}) Franciscain. - Professeur de mathématique à l''Université de la Sapience (Rome) [http://data.bnf.fr/ark:/12148/cb155933751#foaf:Person]
{/ud}
{ud0}
Gabriel Cramer ({en0li}Genève, Suisse{/en}, {dat1704}1704{/dat}) Professeur de philosophie et de mathématiques des Académies et Sociétés royales de Londres, de Berlin, de Montpellier, de Lyon et de l''Académie de l''Institut de Bologne [http://data.bnf.fr/ark:/12148/cb15006804w#foaf:Person]
{/ud}
{ud0}
Guillaume Le Blond ({en0li}Paris{/en}, {dat1704}1704{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb14330967m#foaf:Person]
{/ud}
{ud0}
Henri Michel Sauvage ({en0li}Verdun{/en}, {dat1704}1704{/dat}) Jésuite. - Professeur d''humanités, de mathématiques et de philosophie [http://data.bnf.fr/ark:/12148/cb16180102s#foaf:Person]
{/ud}
{ud0}
Jacopo Belgrado ({dat1704}1704{/dat}) Jésuite. - Physicien, {en16}mathématicien{/en} et archéologue [http://data.bnf.fr/ark:/12148/cb12161284h#foaf:Person]
{/ud}
{ud0}
Johann Andreas von Segner ({dat1704}1704{/dat}) Naturaliste, {en16}mathématicien{/en}, {en28}médecin{/en}, logicien, {en18}philosophe{/en}. - Né à Presbourg (l''actuelle Bratislava), il fit toute sa carrière en Allemagne (à Iéna, Göttingen, Halle notamment) [http://data.bnf.fr/ark:/12148/cb12316478n#foaf:Person]
{/ud}
{ud0}
Louis Godin ({en0li}Paris{/en}, {dat1704}1704{/dat}) {en24}Astronome{/en}, membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb15004534h#foaf:Person]
{/ud}
{ud0}
John Nourse ({dat1705}1705{/dat}) Variante(s) de prénom : Jean. - Libraire ; libraire (ordinaire) de Sa Majesté ({dat1762}1762{/dat}) ; libraire de la "Society for the Encouragement of learning". - Baptisé à Oxford le 8 juillet 1705 ; fils d''un chirurgien. En apprentissage chez le libraire de Londres John I Osborne d''août 1722 à oct. 1729. Établi vers 1730. Succède au libraire William Mears après lui avoir été associé. Spécialiste des publications scientifiques, particulièrement de mathématiques, et des éditions étrangères, de {en18}philosophe{/en}s notamment. Séjourne à Paris en 1780. Décédé à Kensington en avril 1765. Son frère Charles Nourse puis Francis Wingrave lui succèdent [http://data.bnf.fr/ark:/12148/cb13605346z#foaf:Person]
{/ud}
{ud0}
Edme-Gilles Guyot ({en0li}Paris{/en}, {dat1706}1706{/dat}) Les ouvrages "Nouvelles récréations physiques et mathématiques" et "Essai sur la construction des ballons aérostatiques et sur la manière de les diriger" lui sont attribués par Hoefer et Quérard. - DBF et Michaud soulignent la confusion entre lui et Guillaume-Germain Guyot pour l''attribution de ces ouvrages [http://data.bnf.fr/ark:/12148/cb14651894d#foaf:Person]
{/ud}
{ud0}
Girolamo Settimo ({dat1706}1706{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb162655930#foaf:Person]
{/ud}
{ud0}
Giuseppe Maria Asclepi ({dat1706}1706{/dat}) Jésuite, enseigna les mathématiques et les humanités [http://data.bnf.fr/ark:/12148/cb12240755t#foaf:Person]
{/ud}
{ud0}
Benjamin Robins ({en0li}Bath, GB{/en}, {dat1707}1707{/dat}) {en16}Mathématicien{/en} et ingénieur militaire. - Pamphlétaire [http://data.bnf.fr/ark:/12148/cb121289860#foaf:Person]
{/ud}
{ud0}
Francesco Ottavio Magnocavalli ({en0li}Casale, Italie{/en}, {dat1707}1707{/dat}) Architecte, {en16}mathématicien{/en} et poète [http://data.bnf.fr/ark:/12148/cb10732099c#foaf:Person]
{/ud}
{ud0}
Jean Paul Grandjean de Fouchy ({en0li}Paris{/en}, {dat1707}1707{/dat}) {en24}Astronome{/en}. - Secrétaire perpétuel de l''Académie des Sciences ({dat1743}1743{/dat}) [http://data.bnf.fr/ark:/12148/cb10667779b#foaf:Person]
{/ud}
{ud0}
José Quiroga ({dat1707}1707{/dat}) Jésuite, {en16}mathématicien{/en} et pilote [http://data.bnf.fr/ark:/12148/cb12570261h#foaf:Person]
{/ud}
{ud0}
Leonhard Euler ({en0li}Bâle (Suisse){/en}, {dat1707}1707{/dat}) {en16}Mathématicien{/en} et physicien. - {en18}Philosophe{/en}, théologien et orientaliste. - Membre de l''Académie des sciences de Saint-Pétersbourg (à partir de 1733) et de celle de Berlin (à partir de 1741), et membre associé de celle de Paris (à partir de 1755) [http://data.bnf.fr/ark:/12148/cb12157666x#foaf:Person]
{/ud}
{ud0}
Giovanni Francesco Mauro Melchior Salvemini da Castiglione ({dat1708}1708{/dat}) Professeur de mathématiques à Utrecht ({dat1751}1751{/dat}) puis directeur de la classe de mathématiques de l''Académie de Berlin. - Découvrit la solution du problème consistant à inscrire dans un cercle un triangle dont les côtés passent par trois points donnés [http://data.bnf.fr/ark:/12148/cb130145422#foaf:Person]
{/ud}
{ud0}
Eustachio Zanotti ({en0li}Bologne, Italie{/en}, {dat1709}1709{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb12202196d#foaf:Person]
{/ud}
{ud0}
Giordano Riccati ({en0li}Castelfranco Veneto, Italie{/en}, {dat1709}1709{/dat}) Comte. - {en16}Mathématicien{/en}, acousticien et théoricien de la musique. - Fut aussi physicien et architecte [http://data.bnf.fr/ark:/12148/cb12252383n#foaf:Person]
{/ud}
{ud0}
Georg Matthias Bose ({en0li}Leipzig (Allemagne){/en}, {dat1710}1710{/dat}) {en24}Astronome{/en}, physicien, {en16}mathématicien{/en}. - Professeur de physique à l''université de Wittenberg [http://data.bnf.fr/ark:/12148/cb14065311n#foaf:Person]
{/ud}
{ud0}
Jacques Audierne ({dat1710}1710{/dat}) Auteur comique et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb10425836p#foaf:Person]
{/ud}
{ud0}
Johann Bernoulli ({dat1710}1710{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb14852857s#foaf:Person]
{/ud}
{ud0}
Thomas Simpson ({dat1710}1710{/dat}) Membre de la société royale de Londres, professeur de mathématiques à Woolwich (en 1755) [http://data.bnf.fr/ark:/12148/cb103759851#foaf:Person]
{/ud}
{ud0}
Alexandre-Gui Pingré ({en0li}Paris{/en}, {dat1711}1711{/dat}) Génovéfain. - {en24}Astronome{/en}. - Correspondant (à partir de 1753), puis associé libre de l''Académie des sciences. - {en29}Géographe{/en} de la Marine. - Chancelier de l''Université de Paris (1769-17..). - Bibliothécaire de Sainte-Geneviève (à partir de 1792) [http://data.bnf.fr/ark:/12148/cb12151017m#foaf:Person]
{/ud}
{ud0}
François Jacquier (Vitry-le-François ({en0li}Marne){/en}, {dat1711}1711{/dat}) Religieux de l''ordre des Minimes. - Professeur de physique et mathématiques [http://data.bnf.fr/ark:/12148/cb12198105d#foaf:Person]
{/ud}
{ud0}
Laura Bassi ({en0li}Bologne, Italie{/en}, {dat1711}1711{/dat}) {en16}Mathématicien{/en}ne et physicienne. - Professeur de biologie et de physique à l''Université de Bologne. - Première femme titulaire d''une chaire universitaire en Europe [http://data.bnf.fr/ark:/12148/cb135103950#foaf:Person]
{/ud}
{ud0}
Ottaviano Cametti ({en0li}Gattinara, Italie{/en}, {dat1711}1711{/dat}) {en16}Mathématicien{/en}, physicien et historien [http://data.bnf.fr/ark:/12148/cb10464765k#foaf:Person]
{/ud}
{ud0}
Pierre Joseph de Rivaz ({dat1711}1711{/dat}) {en16}Mathématicien{/en}, inventeur-mécanicien et historien. - Directeur des salines de Moutiers. - Né dans le Valais et mort à Moutiers (Tarentaise) [http://data.bnf.fr/ark:/12148/cb128398731#foaf:Person]
{/ud}
{ud0}
Rugerius Josephus Boscovich (Raguse aujourd''hui Dubrovnik ({en0li}Croatie){/en}, {dat1711}1711{/dat}) Jésuite. - Physicien, {en16}mathématicien{/en}, {en24}astronome{/en} et {en18}philosophe{/en}. - Professeur de mathématiques à Rome, Pavie et Milan. - Directeur de l''optique de la Marine royale à Paris et membre de la "Royal Society" à Londres. - Dans son ouvrage majeur "Théorie de la philosophie naturelle" il élabore la théorie initiale des forces et de la structure fondamentale de la matière, dont les concepts ont trouvé écho dans les découvertes de la physique moderne. - Il publie nombre d''ouvrages contenant ses découvertes en mathématiques, en astronomie, en géophysique et en archéologie. - Il mit au point différents instruments optiques, astronomiques et géodésiques et réalisa des expertises et des mesures hydrotechniques, géodésiques, cartographiques et statiques. - Il consolida la coupole de la basilique Saint-Pierre de Rome et de la flèche de la cathédrale de Milan [http://data.bnf.fr/ark:/12148/cb12054879x#foaf:Person]
{/ud}
{ud0}
Jean-Paul de Gua de Malves ({en0li}Malves (Aude){/en}, {dat1712}1712{/dat}) Abbé. - {en16}Mathématicien{/en}, géomètre, économiste politique. - Titulaire de la chaire de philosophie au Collège de France (1742-1749) [http://data.bnf.fr/ark:/12148/cb15325204x#foaf:Person]
{/ud}
{ud0}
Samuel König ({dat1712}1712{/dat}) Date de mort : 21 août ou 22 juillet 1757. - A également écrit en français. - {en16}Mathématicien{/en}, {en18}philosophe{/en} et juriste [http://data.bnf.fr/ark:/12148/cb120941298#foaf:Person]
{/ud}
{ud0}
Alexis Claude Clairaut ({en0li}Paris (France){/en}, {dat1713}1713{/dat}) {en16}Mathématicien{/en} très précoce et {en24}astronome{/en}. - Ami de Voltaire et de la marquise Du Chatelet [http://data.bnf.fr/ark:/12148/cb124002538#foaf:Person]
{/ud}
{ud0}
Giammaria Ortes ({dat1713}1713{/dat}) Moine camaldule. - {en16}Mathématicien{/en}, économiste et {en18}philosophe{/en} [http://data.bnf.fr/ark:/12148/cb13753557w#foaf:Person]
{/ud}
{ud0}
Nicolas-Louis de La Caille ({en0li}Rumigny, Ardennes{/en}, {dat1713}1713{/dat}) Abbé. - Professeur de mathématiques au Collège Mazarin. - Membre de l''Académie royale des sciences [http://data.bnf.fr/ark:/12148/cb12124353d#foaf:Person]
{/ud}
{ud0}
Alessandro Vittorio Papacino d''Antoni ({en0li}Villafranca, Italie{/en}, {dat1714}1714{/dat}) Ingénieur, {en16}mathématicien{/en}. - Membre de l''Académie des sciences de Turin [http://data.bnf.fr/ark:/12148/cb10709482t#foaf:Person]
{/ud}
{ud0}
César-François Cassini de Thury (Thury-sous-Clermont ({en0li}Oise){/en}, {dat1714}1714{/dat}) {en24}Astronome{/en} et géomètre. - Membre de l''Académie des sciences ({dat1736}1736{/dat}). - Fils de Jacques Cassini (1677-1756) et père de Jean-Dominique Cassini (1748-1845). - Participa avec son père à la mesure de la perpendiculaire de l''Observatoire. - Son oeuvre principale est la carte de France, première carte de base de ce pays, dont la publication commença en 1756 [http://data.bnf.fr/ark:/12148/cb12241101g#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Audiffredi ({en0li}Saorge, Italie{/en}, {dat1714}1714{/dat}) Dominicain. - {en24}Astronome{/en}. - Préfet de la Biblioteca Casanatense, Rome (1759-1794). - Né Giulio Cesare Audiffredi, change de prénom en entrant chez les Dominicains ({dat1730}1730{/dat}) [http://data.bnf.fr/ark:/12148/cb13595556h#foaf:Person]
{/ud}
{ud0}
John Winthrop ({dat1714}1714{/dat}) Professeur de Mathématiques et de Philosophie naturelle à Harvard [http://data.bnf.fr/ark:/12148/cb14594660x#foaf:Person]
{/ud}
{ud0}
François-Joachim Duport-Dutertre (Saint-Servan (Ille-et-Vilaine), {dat1715}1715{/dat}) Littérateur. - {en16}Mathématicien{/en}. - Voyageur [http://data.bnf.fr/ark:/12148/cb12533121w#foaf:Person]
{/ud}
{ud0}
Pierre-Charles Le Monnier ({en0li}Paris{/en}, {dat1715}1715{/dat}) {en24}Astronome{/en}. - Membre de l''Académie des sciences ({dat1741}1741{/dat}). - Professeur de physique au Collège de France (de 1749 à 1793), puis membre de la classe des sciences physiques et mathématiques de l''Institut [http://data.bnf.fr/ark:/12148/cb121064574#foaf:Person]
{/ud}
{ud0}
André-Pierre Le Guay de Prémontval (Charenton (Val-de-Marne), {dat1716}1716{/dat}) Professeur de mathématiques. - Membre de l''Académie de Berlin [http://data.bnf.fr/ark:/12148/cb122271303#foaf:Person]
{/ud}
{ud0}
Eugénios Voúlgaris ({en0li}Corfou (Îles Ioniennes, Grèce){/en}, {dat1716}1716{/dat}) Métropolite de l''Église orthodoxe grecque. - Théologien, {en18}philosophe{/en} et {en16}mathématicien{/en}. - "Éducateur de la Nation" et précurseur des Lumières en Grèce ; traducteur de Voltaire et Virgile. - Nommé évêque en Russie [http://data.bnf.fr/ark:/12148/cb12564304q#foaf:Person]
{/ud}
{ud0}
Gottfried Ploucquet ({dat1716}1716{/dat}) {en18}Philosophe{/en}, {en16}mathématicien{/en} et théologien. - Professeur de philosophie à l''université de Tübingen (1750-1782) [http://data.bnf.fr/ark:/12148/cb13324024g#foaf:Person]
{/ud}
{ud0}
Leonardo Ximenes ({en0li}Trapani, Italie{/en}, {dat1716}1716{/dat}) Jésuite. - {en29}Geographe{/en}, {en24}astronome{/en}, {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb106577403#foaf:Person]
{/ud}
{ud0}
D'' Alembert ({en0li}Paris{/en}, {dat1717}1717{/dat}) {en16}Mathématicien{/en} et {en18}philosophe{/en}. - Nom patronymique : Jean Le Rond, d̲i̲t̲ d'' Alembert. - Membre de l''Institut, Académie française (élu en 1754) [http://data.bnf.fr/ark:/12148/cb118883708#foaf:Person]
{/ud}
{ud0}
Josef Anton Nagel ({dat1717}1717{/dat}) Professeur, {en16}mathématicien{/en}, scientifique allemand [http://data.bnf.fr/ark:/12148/cb12091922b#foaf:Person]
{/ud}
{ud0}
Augustin Darquier de Pellepoix ({en0li}Toulouse{/en}, {dat1718}1718{/dat}) {en24}Astronome{/en}. - Associé non résidant de l''Académie des sciences. - Receveur des tailles de la généralité d''Auch [http://data.bnf.fr/ark:/12148/cb12155190x#foaf:Person]
{/ud}
{ud0}
Claude-François Berthelot ({dat1718}1718{/dat}) Ingénieur. - Professeur de mathématiques à l''École royale militaire. - Inventeur de l''"affut de Gribeauval" [http://data.bnf.fr/ark:/12148/cb134984423#foaf:Person]
{/ud}
{ud0}
François-César Le Tellier Courtanvaux ({dat1718}1718{/dat}) Duc de Doudeauville. - Capitaine-colonel des cent-suisses de la garde du roi. - {en24}Astronome{/en}, membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb121904446#foaf:Person]
{/ud}
{ud0}
Gaspard-François-Anne de Forbin ({dat1718}1718{/dat}) Né le 8 ou le 18 juillet 1718. - Embrassa d'' abord la carrière militaire. - Chevalier de Malte. - {en16}Mathématicien{/en} et Physicien [http://data.bnf.fr/ark:/12148/cb12108181n#foaf:Person]
{/ud}
{ud0}
István Hatvani ({en0li}Rimaszombat, aujourd''hui Rimavská Sobota, Slovaquie{/en}, {dat1718}1718{/dat}) {en16}Mathématicien{/en}, physicien. - {en28}Médecin{/en}. - Pédagogue, professeur à Debrecen,Református Kollégium, Hongrie. - Diplômé de l''Université de Bâle, Suisse [http://data.bnf.fr/ark:/12148/cb10355679v#foaf:Person]
{/ud}
{ud0}
Jean-Philippe Loys de Chéseaux ({dat1718}1718{/dat}) {en24}Astronome{/en} et physicien. - Né à Lausanne, mort à Paris [http://data.bnf.fr/ark:/12148/cb133196302#foaf:Person]
{/ud}
{ud0}
Joseph Amiot ({en0li}Toulon{/en}, {dat1718}1718{/dat}) Jésuite de 1737 à 1773 (ordonné prêtre en 1749). - Sinologue et {en24}astronome{/en}. - Missionnaire en Chine (à partir de 1749) [http://data.bnf.fr/ark:/12148/cb12112654w#foaf:Person]
{/ud}
{ud0}
Maria Gaetana Agnesi ({en0li}Milan, Italie{/en}, {dat1718}1718{/dat}) {en16}Mathématicien{/en}ne [http://data.bnf.fr/ark:/12148/cb105423187#foaf:Person]
{/ud}
{ud0}
Abraham Gotthelf Kästner ({en0li}Leipzig, Allemagne{/en}, {dat1719}1719{/dat}) {en16}Mathématicien{/en}. - Poète et épigrammatiste. - Critique [http://data.bnf.fr/ark:/12148/cb123392338#foaf:Person]
{/ud}
{ud0}
Giuseppe Toaldo ({en0li}Pianezze, Italie{/en}, {dat1719}1719{/dat}) Prêtre. - Physicien. - Professeur d''astronomie, de géographie et de météorologie à l''Université de Padoue [http://data.bnf.fr/ark:/12148/cb10578331h#foaf:Person]
{/ud}
{ud0}
Jens Kraft ({dat1720}1720{/dat}) {en18}Philosophe{/en} des lumières danois. - Professeur de mathématiques et de philosophie à Soroe [http://data.bnf.fr/ark:/12148/cb12442689p#foaf:Person]
{/ud}
{ud0}
Charles Walmesley ({dat1722}1722{/dat}) Évêque de Rama. - {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb10748264x#foaf:Person]
{/ud}
{ud0}
Jean Chappe d''Auteroche ({en0li}Mauriac (Cantal){/en}, {dat1722}1722{/dat}) {en24}Astronome{/en}. - Explorateur en Sibérie et en Californie [http://data.bnf.fr/ark:/12148/cb12402595h#foaf:Person]
{/ud}
{ud0}
Jean-Louis Dupain-Triel ({dat1722}1722{/dat}) Homme de lettres, poète. - S''intéressa aux mathématiques, à la géographie et à l''enseignement des arts [http://data.bnf.fr/ark:/12148/cb119011560#foaf:Person]
{/ud}
{ud0}
Louis-Jacques Goussier ({dat1722}1722{/dat}) {en16}Mathématicien{/en} et inventeur [http://data.bnf.fr/ark:/12148/cb13485055d#foaf:Person]
{/ud}
{ud0}
Baien Miura ({dat1723}1723{/dat}) Lettré du milieu de l''époque d''Edo. - A créé son propre système de pensée philosophique appelé "jōrigaku" : méthode de spéculation fondée sur l''éthique, la logique, les mathématiques et la physique, recourant à une pensée dialectique appelée "hankan gōitsu" [http://data.bnf.fr/ark:/12148/cb12293200x#foaf:Person]
{/ud}
{ud0}
Didier Robert de Vaugondy ({dat1723}1723{/dat}) {en29}Géographe{/en} ordinaire du roi, professeur de mathématiques et de géographie, fils de Gilles Robert Vaugondy. - Didier signe "Robert de Vaugondy" [http://data.bnf.fr/ark:/12148/cb12380757h#foaf:Person]
{/ud}
{ud0}
Étienne-Nicolas Blondeau ({dat1723}1723{/dat}) Professeur de mathématiques. - Ingénieur de la marine. - Collaborateur de l''Encyclopédie méthodique (1782-1783?) [http://data.bnf.fr/ark:/12148/cb10737141j#foaf:Person]
{/ud}
{ud0}
Johann Tobias Mayer ({dat1723}1723{/dat}) {en16}Mathématicien{/en} et {en24}astronome{/en}, a travaillé avec Homann Herben de 1746 à 1751, puid pour Kilian à partir de 1752 [http://data.bnf.fr/ark:/12148/cb153509764#foaf:Person]
{/ud}
{ud0}
Johann Tobias Mayer ({dat1723}1723{/dat}) {en24}Astronome{/en} allemand [http://data.bnf.fr/ark:/12148/cb11958863x#foaf:Person]
{/ud}
{ud0}
Nicole-Reine Lepaute ({en0li}Paris{/en}, {dat1723}1723{/dat}) Née Nicole-Reine Étable de La Brière, épouse de Jean-André Lepaute, horloger du Roi. - {en16}Mathématicien{/en}ne, {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb14555447k#foaf:Person]
{/ud}
{ud0}
Tobias Mayer ({en0li}Marbach (Allemagne){/en}, {dat1723}1723{/dat}) {en24}Astronome{/en}, {en16}mathématicien{/en}. - Directeur de l''Observatoire de Göttingen, Allemagne [http://data.bnf.fr/ark:/12148/cb121551484#foaf:Person]
{/ud}
{ud0}
Edme-Sébastien Jeaurat ({dat1724}1724{/dat}) Ingénieur-{en29}géographe{/en} et {en24}astronome{/en}. - Professeur à l''école militaire. - Membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb122175393#foaf:Person]
{/ud}
{ud0}
François Para Du Phanjas (Chabottes (Hautes-Alpes), {dat1724}1724{/dat}) {en18}Philosophe{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12528863r#foaf:Person]
{/ud}
{ud0}
Georges Louis Lesage ({en0li}Genève{/en}, {dat1724}1724{/dat}) {en16}Mathématicien{/en} et physicien suisse. - Etudie à Genève puis Paris. - Etabli à Genève [http://data.bnf.fr/ark:/12148/cb155857475#foaf:Person]
{/ud}
{ud0}
Guillaume-Germain Guyot ({en0li}Orléans{/en}, {dat1724}1724{/dat}) Les ouvrages "Nouvelles récréations physiques et mathématiques" et "Essai sur la construction des ballons aérostatiques et sur la manière de les diriger" lui sont attribués par le DBF et par Samuel Ersch dans "La France littéraire contenant les auteurs français de 1771 à 1796", DBF. - Quérard et Michaud soulignent la confusion entre lui et Edme-Gilles Guyot pour l''attribution de ces ouvrages [http://data.bnf.fr/ark:/12148/cb12214218k#foaf:Person]
{/ud}
{ud0}
Guillaume-Hyacinthe-Joseph-Jean-Baptiste Le Gentil de La Galaisière ({dat1725}1725{/dat}) {en24}Astronome{/en} et voyageur. - Entre à l''Observatoire en 1750. - Membre de l''Académie des sciences en 1753 [http://data.bnf.fr/ark:/12148/cb12151459n#foaf:Person]
{/ud}
{ud0}
Jean-Étienne Montucla ({dat1725}1725{/dat}) Historien des mathématiques [http://data.bnf.fr/ark:/12148/cb12127574n#foaf:Person]
{/ud}
{ud0}
Louis-Charles Desnos ({dat1725}1725{/dat}) Libraire ; libraire et (ingénieur) {en29}géographe{/en} (pour les globes et les sphères) du roi de Danemark (ou : de Sa Majesté danoise) (1769-1789). - Fils d''un marchand drapier de Pont-Sainte-Maxence (Oise). Apprenti fondeur de caractères à Paris à partir d''avril 1745 (reçu maître fondeur en 1757).  Ingénieur {en29}géographe{/en} (de la ville de Paris à partir de 1769), fabricant et marchand de sphères et d''instruments astronomiques établi vers 1753 en succession de Jacques Hardy, après avoir épousé en 1749 la veuve de son fils Nicolas Hardy ; également marchand d''estampes et de cartes géographiques. Un des 12 libraires non jurés reçus le 4 oct. 1767. - Éditeur et auteur de nombreux atlas, almanachs et publications géographiques entre 1756 et 1795 env. Rédige également plusieurs catalogues de son fonds entre 1768 et 1792. Une partie de son fonds est rachetée en 1805 par Jean (17..-1839), marchand de cartes et d''estampes [http://data.bnf.fr/ark:/12148/cb12402252d#foaf:Person]
{/ud}
{ud0}
Rigobert Bonne (Raucourt (Meurthe-et-Moselle), {dat1727}1727{/dat}) Ingénieur. - {en29}Géographe{/en}. - Hydrographe. - Célèbre par la projection qui porte son nom et qui remplacera pour la carte de France la projection de Cassini. D''abord ingénieur {en29}géographe{/en} et maître de mathématiques. En 1775 ingénieur hydrographe de la Marine. Fut mis à la retraite contre sa volonté en 1789. Collabora au Neptune américo-septentrional [http://data.bnf.fr/ark:/12148/cb12169793s#foaf:Person]
{/ud}
{ud0}
Chrysologue de Gy (Gy (Haute-Saône), {dat1728}1728{/dat}) Capucin. - {en24}Astronome{/en}, cartographe et géologue [http://data.bnf.fr/ark:/12148/cb10728734z#foaf:Person]
{/ud}
{ud0}
Jean-Henri Lambert ({en0li}Mulhouse, Suisse{/en}, {dat1728}1728{/dat}) {en16}Mathématicien{/en}, physicien, {en24}astronome{/en} et {en18}philosophe{/en}. - Spécialiste de géometrie. - En poste à l''Académie royale des sciences et belles lettres de Berlin (de 1765 à 1777) [http://data.bnf.fr/ark:/12148/cb12359659g#foaf:Person]
{/ud}
{ud0}
Le P.  Chrysologue ({en0li}Gy{/en}, {dat1728}1728{/dat}) Capucin, nom de religion de Noël André. - Attiré par la géographie et l''astronomie, fut l''élève de Lemonnier. Mesura les altitudes des Vosges, du Jura et des Alpes. Se retira dans sa famille au moment de la Révolution.  En 1806 publia un important traité de géologie dont Cuvier fit un rapport élogieux [http://data.bnf.fr/ark:/12148/cb153054042#foaf:Person]
{/ud}
{ud0}
Paolo Frisi ({en0li}Melegnano, Italie{/en}, {dat1728}1728{/dat}) Barnabite. - {en16}Mathématicien{/en}, {en24}astronome{/en} et {en26}écrivain{/en}. - Professeur dans les Écoles palatines de Milan (1764-) [http://data.bnf.fr/ark:/12148/cb120849325#foaf:Person]
{/ud}
{ud0}
Antonio Eximeno ({dat1729}1729{/dat}) Théoricien de la musique et polémiste. - Jésuite, il devient professeur de rhétorique à l''Université de Valence, puis professeur de mathématiques à l''Académie militaire de Ségovie ({dat1764}1764{/dat}). - Lorsque les jésuites sont expulsés d''Espagne en 1767, il se rend à Rome où il étudie la musique. - Connu aussi sous le pseud. : "Aristosseno Megareo" (BnF, Musique, fichier général auteurs), ou "Aristodemo Megareo" (Fétis) [http://data.bnf.fr/ark:/12148/cb13755053m#foaf:Person]
{/ud}
{ud0}
Charles Bossut ({dat1730}1730{/dat}) {en16}Mathématicien{/en}, membre de l''Académie des sciences ({dat1779}1779{/dat}), il participa à la rédaction de la partie mathématique de l''Encyclopédie [http://data.bnf.fr/ark:/12148/cb11763983g#foaf:Person]
{/ud}
{ud0}
Charles Bossut ({dat1730}1730{/dat}) {en16}Mathématicien{/en} et physicien. - Membre de l''Académie des sciences, pensionnaire de la classe de mécanique ({dat1785}1785{/dat}). - Écrivit plusieurs articles dans l''"Encyclopédie" [http://data.bnf.fr/ark:/12148/cb124599882#foaf:Person]
{/ud}
{ud0}
Charles Messier (Badonviller (Meurthe-et-Moselle), {dat1730}1730{/dat}) {en24}Astronome{/en} de la marine. - Académicien ({dat1770}1770{/dat}). - Membre de l''Institut [http://data.bnf.fr/ark:/12148/cb124827900#foaf:Person]
{/ud}
{ud0}
Étienne Bezout ({en0li}Nemours{/en}, {dat1730}1730{/dat}) {en16}Mathématicien{/en}. - Membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb12267459g#foaf:Person]
{/ud}
{ud0}
Jean-Baptiste de Laborde ({dat1730}1730{/dat}) Physicien et {en16}mathématicien{/en}. - Jésuite [http://data.bnf.fr/ark:/12148/cb13196726p#foaf:Person]
{/ud}
{ud0}
Joseph-Aignan Sigaud de La Fond ({en0li}Bourges{/en}, {dat1730}1730{/dat}) {en16}Mathématicien{/en}, physicien et moraliste. - Professeur de physique à Bourges [http://data.bnf.fr/ark:/12148/cb12401095w#foaf:Person]
{/ud}
{ud0}
Pierre-Thomas Antelmy ({en0li}Trigance, France{/en}, {dat1730}1730{/dat}) {en16}Mathématicien{/en}, professeur de mathématiques à l''École militaire [http://data.bnf.fr/ark:/12148/cb13011110m#foaf:Person]
{/ud}
{ud0}
Benito Bails ({dat1731}1731{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb162593727#foaf:Person]
{/ud}
{ud0}
Girolamo Francisco Cristiani ({en0li}Brescia, Italie{/en}, {dat1731}1731{/dat}) {en16}Mathématicien{/en} et physicien [http://data.bnf.fr/ark:/12148/cb14065297x#foaf:Person]
{/ud}
{ud0}
Nicolas-Claude Duval-Le Roy ({dat1731}1731{/dat}) Professeur de mathématiques et d''hydrographie, physicien et {en24}astronome{/en}. - Membre de l''Académie royale de marine. - Correspondant à l''Académie royale des sciences ({dat1789}1789{/dat}), associé non résident de l''Institut ({dat1796}1796{/dat}) [http://data.bnf.fr/ark:/12148/cb12548660k#foaf:Person]
{/ud}
{ud0}
Diderich Christian Fester ({dat1732}1732{/dat}) {en16}Mathématicien{/en} et cartographe à Trondheim [http://data.bnf.fr/ark:/12148/cb15384550x#foaf:Person]
{/ud}
{ud0}
Jérôme de La Lande (Bourg-en-Bresse ({en0li}Ain){/en}, {dat1732}1732{/dat}) {en24}Astronome{/en}. - Membre de l''Académie de Berlin. - Membre de l''Académie des sciences ({dat1753}1753{/dat}). - Professeur d''astronomie au Collège de France ({dat1762}1762{/dat}). - Directeur de l''Observatoire de Paris de 1768 à sa mort [http://data.bnf.fr/ark:/12148/cb12012398h#foaf:Person]
{/ud}
{ud0}
Maurille-Antoine Moithey ({dat1732}1732{/dat}) Éditeur et marchand de cartes géographiques ; libraire. - Ingénieur {en29}géographe{/en} du Roi et professeur de mathématiques des pages du prince et de la princesse de Conti. Auteur de plans, de cartes, d''ouvrages illustrés et d''atlas, qu''il publie et diffuse parfois lui-même de 1776 à 1792 au moins. Auteur notamment d''un "Dictionnaire hydrographique de la France..." (1re éd., l''auteur, 1787 ; rééd., Paris, Blanchon, {dat1803}1803{/dat}) et d''une série de "Recherches historiques" sur les villes de France (Angers, Orléans, Reims, 1775-1776). Se qualifie de libraire en 1791-1792. Décédé à Paris le 21 frimaire an XIV (12 déc. 1805, Arch. de Paris) [http://data.bnf.fr/ark:/12148/cb13531657x#foaf:Person]
{/ud}
{ud0}
Nevil Maskelyne ({dat1732}1732{/dat}) {en24}Astronome{/en} royal d''Angleterre. - Membre associé de l''Académie des sciences de Paris [http://data.bnf.fr/ark:/12148/cb12155150p#foaf:Person]
{/ud}
{ud0}
Jacques-François Dicquemare ({en0li}Le Havre{/en}, {dat1733}1733{/dat}) {en24}Astronome{/en}. - Hydrographe. - Zoologue marin [http://data.bnf.fr/ark:/12148/cb15317071s#foaf:Person]
{/ud}
{ud0}
János Sajnovics ({en0li}Tordas, Hongrie{/en}, {dat1733}1733{/dat}) {en24}Astronome{/en}. - Linguiste. - Père jésuite [http://data.bnf.fr/ark:/12148/cb12246417w#foaf:Person]
{/ud}
{ud0}
Jean-Charles Borda ({en0li}Dax (Landes){/en}, {dat1733}1733{/dat}) Officier de marine. - Membre de l''Académie de Marine (élu en 1769). - Entra dans le Génie militaire et se fit remarquer par ses travaux sur l''hydraulique. - Il détermina la longitude des Canaries (en 1776). - Prit part à la guerre d''indépendance américaine. - Participa avec Delambre et Méchain à la mesure de l''arc de méridien Dunkerque-Barcelone. - En qualité de commissaire de l''Académie des sciences participa à l''étude des montres marines sur la frégate la Flore (en 1771). - Membre de l''Institut, Académie des sciences (élu en 1772). - Membre de la Commission des poids et mesures (en 1791), il travailla à l''établissement du système métrique. - Membre de l''Institut national des sciences et arts, section mathématiques (actuel Institut de France) et du Bureau des longitudes (en 1795). - Co-fondateur de La Société de Borda (créée en 1876), avec Jacques-François de Borda d''Oro (1718-1804) [http://data.bnf.fr/ark:/12148/cb12482831r#foaf:Person]
{/ud}
{ud0}
Samuel Horsley ({dat1733}1733{/dat}) Evêque; secrétaire de la Royal Society; publia des livres de théologie et de mathématiques [http://data.bnf.fr/ark:/12148/cb120697374#foaf:Person]
{/ud}
{ud0}
Achille Pierre Dionis du Séjour ({en0li}Paris{/en}, {dat1734}1734{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb10680537k#foaf:Person]
{/ud}
{ud0}
Baudouin de Guémadeuc ({dat1734}1734{/dat}) Homme de loi, homme de lettres, pamphlétaire puis {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb144447840#foaf:Person]
{/ud}
{ud0}
Charles Duvaucel ({dat1734}1734{/dat}) {en24}Astronome{/en}, spécialisé dans les éclipses du soleil. [http://data.bnf.fr/ark:/12148/cb15318527x#foaf:Person]
{/ud}
{ud0}
Mathieu Bernard Goudin ({en0li}Paris{/en}, {dat1734}1734{/dat}) Magistrat. - {en16}Mathématicien{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb10586154b#foaf:Person]
{/ud}
{ud0}
Alexandre-Théophile Vandermonde ({en0li}Paris{/en}, {dat1735}1735{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12534847r#foaf:Person]
{/ud}
{ud0}
Antonio Maria Lorgna ({en0li}Cerea, Italie{/en}, {dat1735}1735{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12387058m#foaf:Person]
{/ud}
{ud0}
Gregorio Fontana ({en0li}Villa di Nogaredo, Italie{/en}, {dat1735}1735{/dat}) {en16}Mathématicien{/en} et physicien. - Recteur et professeur de calcul sublime à l''Ateneo lombardo. - Bibliothécaire du Collegio Ghisleri, Pavie [http://data.bnf.fr/ark:/12148/cb10601676b#foaf:Person]
{/ud}
{ud0}
Giovanni-Antonio Rizzi-Zannoni ({en0li}Padoue, Italie{/en}, {dat1736}1736{/dat}) {en29}Géographe{/en} de la république de Venise, {en24}astronome{/en}, il voyage en Amérique du nord en 1757 [http://data.bnf.fr/ark:/12148/cb153024615#foaf:Person]
{/ud}
{ud0}
Jean Sylvain Bailly ({en0li}Paris{/en}, {dat1736}1736{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en} et homme politique. - Entre à l''Académie des sciences (en 1763), à l''Académie française (en 1784) puis à l''Académie des inscriptions (en 1785). - Député du Tiers-État aux États-Généraux ; Maire de Paris ; Député à l''Assemblée Nationale Constituante [http://data.bnf.fr/ark:/12148/cb12516744h#foaf:Person]
{/ud}
{ud0}
Johann Nicolai Tetens ({en0li}Tetenbüll, Allemagne{/en}, {dat1736}1736{/dat}) {en16}Mathématicien{/en}, physicien et {en18}philosophe{/en} [http://data.bnf.fr/ark:/12148/cb12531163b#foaf:Person]
{/ud}
{ud0}
Joseph-Louis Lagrange ({dat1736}1736{/dat}) {en16}Mathématicien{/en}. - D''origine italienne. - A été à l''origine de la fondation de l''Académie des sciences de Turin. - Membre de l''Académie des sciences de Paris, Berlin, Turin. - A partir de 1787, enseigne à Paris à l''École normale et à l''École polytechnique [http://data.bnf.fr/ark:/12148/cb12125247f#foaf:Person]
{/ud}
{ud0}
Francesco Venini ({en0li}Varenna, Italie{/en}, {dat1737}1737{/dat}) Abbé. - {en16}Mathématicien{/en} et poète [http://data.bnf.fr/ark:/12148/cb105963005#foaf:Person]
{/ud}
{ud0}
Giuseppe Maria Pagnini ({en0li}Pistoia, Italie{/en}, {dat1737}1737{/dat}) Au siècle : Luca Antonio ; en religion, carme : Giuseppe Maria. - Poète. - {en16}Mathématicien{/en}. - Savant latiniste et helléniste. - Professeur à l'' Université de Parme puis de Pise [http://data.bnf.fr/ark:/12148/cb11996942k#foaf:Person]
{/ud}
{ud0}
Tommaso Valperga di Caluso ({en0li}Turin, Italie{/en}, {dat1737}1737{/dat}) Abbé. - Homme de lettres, {en18}philosophe{/en} et {en16}mathématicien{/en}. - Chevalier de Malte [http://data.bnf.fr/ark:/12148/cb10748197m#foaf:Person]
{/ud}
{ud0}
William Bayly ({dat1737}1737{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb14065321z#foaf:Person]
{/ud}
{ud0}
Charles-Joseph Mathon de La Cour ({en0li}Lyon (Rhône){/en}, {dat1738}1738{/dat}) Économiste. - Philanthrope. - Fondateur du "Journal de Lyon". - Rédacteur de "L''Almanach musical" (1775-1778), et au "Journal de musique", Paris (1764-1768). - Fils de : Mathon de La Cour, Jacques (1712-1770), {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb121925904#foaf:Person]
{/ud}
{ud0}
Flecheux ({dat1738}1738{/dat}) {en24}Astronome{/en} et mécanicien français. - Adresse en 1784 : Paris, rue du Sentier, hôtel de madame la présidente de Meslay, n° 31 [http://data.bnf.fr/ark:/12148/cb15585605z#foaf:Person]
{/ud}
{ud0}
Joseph-François Marie ({en0li}Rodez{/en}, {dat1738}1738{/dat}) Abbé. - Fut professeur de mathématiques au Collège Mazarin [http://data.bnf.fr/ark:/12148/cb146364765#foaf:Person]
{/ud}
{ud0}
Thomas Abbt ({en0li}Ulm, Allemagne{/en}, {dat1738}1738{/dat}) {en26}Écrivain{/en}, {en18}philosophe{/en}, {en16}mathématicien{/en}, juriste et conseiller aulique [http://data.bnf.fr/ark:/12148/cb125347464#foaf:Person]
{/ud}
{ud0}
William Herschel ({en0li}Hanovre, Allemagne{/en}, {dat1738}1738{/dat}) {en24}Astronome{/en} et compositeur. - A découvert la planète Uranus. - S''installe en Grande-Bretagne en 1757 [http://data.bnf.fr/ark:/12148/cb14064893z#foaf:Person]
{/ud}
{ud0}
Ermenegildo Pini ({en0li}Milan, Italie{/en}, {dat1739}1739{/dat}) Barnabite. - Physicien, géologue, architecte. - Professeur de mathématiques, puis d''histoire naturelle au Collège Saint-Alexandre, Milan. - Dans le siècle : Pini, Carlo [http://data.bnf.fr/ark:/12148/cb13013593q#foaf:Person]
{/ud}
{ud0}
Jean-Louis Pictet ({dat1739}1739{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb146402484#foaf:Person]
{/ud}
{ud0}
Johann Schultz ({dat1739}1739{/dat}) A été professeur de mathématiques à l''université de Königsberg, Allemagne [http://data.bnf.fr/ark:/12148/cb121741380#foaf:Person]
{/ud}
{ud0}
José Antonio Alzate y Ramírez ({dat1739}1739{/dat}) {en24}Astronome{/en} et {en29}géographe{/en} [http://data.bnf.fr/ark:/12148/cb15376450x#foaf:Person]
{/ud}
{ud0}
András Dugonics ({en0li}Szeged (Hongrie){/en}, {dat1740}1740{/dat}) {en26}Écrivain{/en}. - Poète. - Piariste. - Professeur de mathématiques. - A fait des études de théologie  à Privigye (aujourd''hui Prievidza, Slovaquie) et à Nyitra (aujourd''hui Nitra, Slovaquie) [http://data.bnf.fr/ark:/12148/cb12246575b#foaf:Person]
{/ud}
{ud0}
Jacques-André Mallet ({dat1740}1740{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb10552198c#foaf:Person]
{/ud}
{ud0}
Joseph Anton Slop von Cadenberg ({dat1740}1740{/dat}) {en24}Astronome{/en}. - À l''Observatoire de Pise à partir de 1765 [http://data.bnf.fr/ark:/12148/cb12159312n#foaf:Person]
{/ud}
{ud0}
Nicola Spedalieri ({en0li}Bronte (Italie){/en}, {dat1740}1740{/dat}) Professeur de philosophie, théologie et mathématique, poète, musicien, historien [http://data.bnf.fr/ark:/12148/cb16219670j#foaf:Person]
{/ud}
{ud0}
Nicolas-Antoine Nouet ({dat1740}1740{/dat}) {en24}Astronome{/en}. - Attaché à l''Observatoire en 1785. - Participe à l''expédition d''Égypte en 1798. - Ingénieur au Bureau de la guerre en 1802 [http://data.bnf.fr/ark:/12148/cb12151453k#foaf:Person]
{/ud}
{ud0}
Thomas Bugge ({en0li}Copenhague{/en}, {dat1740}1740{/dat}) {en24}Astronome{/en} et cartographe [http://data.bnf.fr/ark:/12148/cb121931908#foaf:Person]
{/ud}
{ud0}
Vicente Tofiño de San Miguel ({dat1740}1740{/dat}) {en24}Astronome{/en}. - Capitaine de vaisseau. - Directeur des compagnies des gardes royales de la marine en 1786. - Membre de l''Académie d''histoire de Madrid. - Correspondant de l''Académie des sciences de Paris [http://data.bnf.fr/ark:/12148/cb12159995t#foaf:Person]
{/ud}
{ud0}
Alexis Rochon ({en0li}Brest (Finistère){/en}, {dat1741}1741{/dat}) Prêtre, {en24}astronome{/en} de la marine, physicien et inventeur. - Bibliothécaire de l''Académie royale de marine à Brest (1765-), {en24}astronome{/en} opticien de la Marine ({dat1787}1787{/dat}), membre de la Commission des poids et mesures et des monnaies ({dat1792}1792{/dat}). - Membre de l''Académie royale des sciences, puis membre de l''Institut. - Clerc tonsuré [http://data.bnf.fr/ark:/12148/cb129983745#foaf:Person]
{/ud}
{ud0}
Stanislaw Wydra ({dat1741}1741{/dat}) Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb15512813z#foaf:Person]
{/ud}
{ud0}
Vincenzo Chiminello ({en0li}Marostica, Italie{/en}, {dat1741}1741{/dat}) Abbé. - {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb10522164f#foaf:Person]
{/ud}
{ud0}
Georg Jonathan von Holland ({dat1742}1742{/dat}) Théologien. - {en16}Mathématicien{/en}. - Précepteur des princes de Wurttemberg [http://data.bnf.fr/ark:/12148/cb119076602#foaf:Person]
{/ud}
{ud0}
Jacques Poitevin ({en0li}Montpellier{/en}, {dat1742}1742{/dat}) Savant {en24}astronome{/en} et agriculteur. - Conseiller de préfecture du département de l''Hérault. - Membre de la Société royale des sciences de Montpellier [http://data.bnf.fr/ark:/12148/cb10644654k#foaf:Person]
{/ud}
{ud0}
Antonio Cagnoli ({en0li}Zante, Grèce{/en}, {dat1743}1743{/dat}) {en24}Astronome{/en} et {en16}mathématicien{/en}. - Crée un observatoire d''astronomie à Vérone. - Enseigne les mathématiques à l''École militaire de Modène après la prise de Vérone par les Français ({dat1797}1797{/dat}). - Membre de nombreuses académies d''Europe [http://data.bnf.fr/ark:/12148/cb12562781s#foaf:Person]
{/ud}
{ud0}
Eberhard August Wilhelm von Zimmermann ({en0li}Uelzen, Allemagne{/en}, {dat1743}1743{/dat}) {en29}Géographe{/en} et naturaliste. - Professeur de mathématiques et de sciences naturelles au Collegium Carolinum de Brunswick de 1766 à 1815. - Conseiller aulique en 1786, puis conseiller d''état en 1801 [http://data.bnf.fr/ark:/12148/cb12330956p#foaf:Person]
{/ud}
{ud0}
Jean-Antoine-Nicolas de Caritat Condorcet ({dat1743}1743{/dat}) {en18}Philosophe{/en}, {en16}mathématicien{/en} et  économiste. - Membre de l''Académie française ({dat1782}1782{/dat}). - Homme politique. - A aussi écrit sous le pseudonyme M. Schwartz, pasteur à Bienne [http://data.bnf.fr/ark:/12148/cb118975118#foaf:Person]
{/ud}
{ud0}
Etienne Lenoir ({dat1744}1744{/dat}) Ingénieur. - Mit au point plusieurs instruments d''astronomie et de géodésie [http://data.bnf.fr/ark:/12148/cb151423156#foaf:Person]
{/ud}
{ud0}
François Callet ({en0li}Versailles{/en}, {dat1744}1744{/dat}) Professeur de mathématiques et d''hydrographie [http://data.bnf.fr/ark:/12148/cb10544471f#foaf:Person]
{/ud}
{ud0}
Jean Bernoulli ({en0li}Bâle, Suisse{/en}, {dat1744}1744{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en}. - Membre des Académies des sciences de Berlin, de Petersbourg, de Stockholm, de Bologne, de Lyon, & de Marseille, de la Société pour l''encouragement des arts, de Londres, de celle des physiciens de Bâle, de l''Académie des Arcades de Rome [http://data.bnf.fr/ark:/12148/cb14508854n#foaf:Person]
{/ud}
{ud0}
José Anastácio da Cunha ({dat1744}1744{/dat}) Poète portugais. - {en16}Mathématicien{/en}, professeur de géométrie à l''Université de Coimbra. - Officier d''artillerie à Valença do Minho (1764-1778) [http://data.bnf.fr/ark:/12148/cb121612626#foaf:Person]
{/ud}
{ud0}
Pierre Méchain ({en0li}Laon{/en}, {dat1744}1744{/dat}) {en24}Astronome{/en} français. - Prénoms complets : Pierre François André [http://data.bnf.fr/ark:/12148/cb12090251r#foaf:Person]
{/ud}
{ud0}
Caspar Wessel ({en0li}Vestby, Norvège{/en}, {dat1745}1745{/dat}) {en16}Mathématicien{/en}. - Reçut la médaille d''argent de la Royal Danish academy [http://data.bnf.fr/ark:/12148/cb12563002z#foaf:Person]
{/ud}
{ud0}
Claude-François Guillemeau de Fréval ({en0li}Paris{/en}, {dat1745}1745{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb10017540p#foaf:Person]
{/ud}
{ud0}
Franz von Paula Triesnecker ({dat1745}1745{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb15115995f#foaf:Person]
{/ud}
{ud0}
Fulcrand Jean Joseph Aigrefeuille ({dat1745}1745{/dat}) G{en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb16296114m#foaf:Person]
{/ud}
{ud0}
Johann Hieronymus Schröter ({dat1745}1745{/dat}) Magistrat et {en24}astronome{/en} amateur allemand [http://data.bnf.fr/ark:/12148/cb11973603q#foaf:Person]
{/ud}
{ud0}
Nicolas Charles Romme (Riom, Puy-de-Dôme, {dat1745}1745{/dat}) Professeur de mathématiques et de navigation à l''École de Rochefort. - Membre de l''Institut [http://data.bnf.fr/ark:/12148/cb12805333t#foaf:Person]
{/ud}
{ud0}
Gaetano Del Ricco ({dat1746}1746{/dat}) Piariste (17 mai 1761). - {en16}Mathématicien{/en}. - Librettiste. - Prénom de baptême : Vincenzo [http://data.bnf.fr/ark:/12148/cb16659347q#foaf:Person]
{/ud}
{ud0}
Gaspard Monge ({dat1746}1746{/dat}) {en16}Mathématicien{/en} et géomètre. - Fondateur de l''École polytechnique et de l''École normale. - Président de l''Institut du Caire. - Membre de l''Institut, Académie des sciences. - Député au Conseil des Cinq-Cents, au Conseil des Anciens, ministre de la Marine ({dat1792}1792{/dat}), sénateur ({dat1799}1799{/dat}), comte de Péluse ({dat1808}1808{/dat}) [http://data.bnf.fr/ark:/12148/cb121412336#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Venturi ({en0li}Bibbiano, Italie{/en}, {dat1746}1746{/dat}) Physicien et {en16}mathématicien{/en}. - Homme politique et diplomate [http://data.bnf.fr/ark:/12148/cb127228927#foaf:Person]
{/ud}
{ud0}
Giuseppe Piazzi ({en0li}Ponte di Valtellina, Italie{/en}, {dat1746}1746{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb12920801z#foaf:Person]
{/ud}
{ud0}
Jean-Claude-Gauthier-Louis de Benaben ({dat1746}1746{/dat}) Oratorien et professeur de mathématiques. - Fut directeur de l''Ecole centrale d''Angers. - Fut président des Amis de la Constitution. - Fut commissaire civil du département de Maine-et-Loire [http://data.bnf.fr/ark:/12148/cb125680474#foaf:Person]
{/ud}
{ud0}
Jean Foucaud ({dat1747}1747{/dat}) Prédicateur, {en16}mathématicien{/en}, philologue. - A écrit en patois limousin des fables imitées de La Fontaine, qu''il a aussi traduit dans cette même langue. - Fut l''un des rédacteurs du "Journal du département de la Haute-Vienne". - Fut à Limoges une personalité agissante du Club des jacobins, membre du Comité de salut public, juge de paix et payeur du département de Haute-Vienne. - Défroqué en 1793, il mourut réconcilié avec l''Église [http://data.bnf.fr/ark:/12148/cb119031941#foaf:Person]
{/ud}
{ud0}
Jean-Baptiste Bernard ({dat1747}1747{/dat}) Libraire ; libraire de l''École polytechnique ({dat1800}1800{/dat}) ; de l''École des Ponts et Chaussées ({dat1801}1801{/dat}) ; des Écoles impériales polytechnique et des Ponts et chaussées ({dat1805}1805{/dat}). - Né à Marseille. Libraire spécialisé dans les "mathématiques, sciences et arts", il travaille jusqu''en 1796 en association avec Régent au bureau du "Journal polytechnique" ou "Bulletin des Travaux publics..." Historien et philologue, éditeur des "Œuvres posthumes" de Montesquieu. Décédé à Saint-Maur-des-Fossés (Val-de-Marne) en oct. 1808. Sa veuve lui succède avant de revendre son fonds en 1810 à Jean Klostermann [http://data.bnf.fr/ark:/12148/cb122388832#foaf:Person]
{/ud}
{ud0}
Johann Elert Bode ({en0li}Hambourg (Allemagne){/en}, {dat1747}1747{/dat}) {en24}Astronome{/en} [http://data.bnf.fr/ark:/12148/cb104634498#foaf:Person]
{/ud}
{ud0}
Andreas Riedel ({en0li}Vienne{/en}, {dat1748}1748{/dat}) Jacobin viennois. - Professeur de mathématiques, précepteur des enfants du Grand duc Léopold, futur empereur,  1779-1790, Florence (Italie). - Études de médecine, élève du professeur Franz Anton Mesmer. - Emprisonné à Brno (1806-1809). - Se réfugia en France 1810-1837 [http://data.bnf.fr/ark:/12148/cb14593357z#foaf:Person]
{/ud}
{ud0}
Jean-Dominique Cassini ({dat1748}1748{/dat}) {en24}Astronome{/en}. - Membre de l''Académie des sciences ({dat1770}1770{/dat}). - Fils de l''{en24}astronome{/en} César-François Cassini (1714-1784), qui était aussi appelé Cassini de Thury, car né à Thury (Oise) en 1714. - Succède à son père comme directeur de l''Observatoire de Paris (en 1784) [http://data.bnf.fr/ark:/12148/cb12157999q#foaf:Person]
{/ud}
{ud0}
Pietro Cossali ({en0li}Vérone, Italie{/en}, {dat1748}1748{/dat}) {en16}Mathématicien{/en}. - A enseigné à l''université de Padoue [http://data.bnf.fr/ark:/12148/cb146340668#foaf:Person]
{/ud}
{ud0}
Pons-Joseph Bernard ({dat1748}1748{/dat}) {en16}Mathématicien{/en}. - Directeur adjoint de l''Observatoire de Marseille [http://data.bnf.fr/ark:/12148/cb12306722n#foaf:Person]
{/ud}
{ud0}
Thaddäus Rinderle ({dat1748}1748{/dat}) Moine bénédictin, {en16}mathématicien{/en} et horloger [http://data.bnf.fr/ark:/12148/cb15037954k#foaf:Person]
{/ud}
{ud0}
Giuseppe Calandrelli ({en0li}Zagarolo, Italie{/en}, {dat1749}1749{/dat}) {en24}Astronome{/en}. - Directeur du "Collegio romano" [http://data.bnf.fr/ark:/12148/cb10544460s#foaf:Person]
{/ud}
{ud0}
Henri Bouchon-Dubournial ({dat1749}1749{/dat}) Ingénieur et {en16}mathématicien{/en}. - Fut professeur à l''Ecole militaire et l''Ecole royale militaire. - Fut le traducteur de Cervantès [http://data.bnf.fr/ark:/12148/cb125620183#foaf:Person]
{/ud}
{ud0}
Jean-Baptiste Delambre ({en0li}Amiens{/en}, {dat1749}1749{/dat}) {en24}Astronome{/en}. - Ses calculs ont servi à  déterminer la longueur du mètre. - Membre de l''Académie des sciences ({dat1792}1792{/dat}) [http://data.bnf.fr/ark:/12148/cb12096096m#foaf:Person]
{/ud}
{ud0}
Paul-Louis Cirodde ({dat1749}1749{/dat}) Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb102655606#foaf:Person]
{/ud}
{ud0}
Pierre-Simon de Laplace (Beaumont-en-Auge ({en0li}Calvados){/en}, {dat1749}1749{/dat}) {en24}Astronome{/en}, {en16}mathématicien{/en} et physicien. - Membre de l''Institut, Académie des sciences (élu en 1795), puis de l''Académie française (élu en 1816). - Obtint le titre de marquis (en 1817) [http://data.bnf.fr/ark:/12148/cb119110516#foaf:Person]
{/ud}
{ud0}
Vincenzo De Filippis ({dat1749}1749{/dat}) Scientifique, {en16}mathématicien{/en}. - Ministre de la République parthénopéenne en février 1799, fut probablement victime de la répression au rétablissement des Bourbons en juin de la même année [http://data.bnf.fr/ark:/12148/cb12290835h#foaf:Person]
{/ud}
{ud0}
William Faden ({dat1749}1749{/dat}) Libraire, éditeur et marchand de cartes et d''estampes ; également {en29}géographe{/en} ordinaire du roi d''Angleterre (1783-1820) et du prince de Galles (1790-1820). - Fils de l''imprimeur londonien William I Faden (à l''origine Mackfaden, 1711-1783). En apprentissage de juillet 1764 à août 1771. Travaille en association avec la famille du libraire et {en29}géographe{/en} du Roi Thomas Jefferys (m. 1771) jusqu''en 1776 env. Membre de la "Society of civil engineers". Beau-frère du peintre et {en24}astronome{/en} John Russell. Se retire en 1823 et cède son affaire à son ancien apprenti James Wyld. Décédé à Shepperton en mars 1836 [http://data.bnf.fr/ark:/12148/cb15615346f#foaf:Person]
{/ud}
{ud0}
Caroline Lucretia Herschel (Hanovre (Basse-Saxe,  Allemagne), {dat1750}1750{/dat}) {en24}Astronome{/en}. - Assistante de son frère, William Herschel (1738-1822), lui aussi {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb16108822m#foaf:Person]
{/ud}
{ud0}
Gilbert Romme ({dat1750}1750{/dat}) {en16}Mathématicien{/en}, {en24}astronome{/en} et {en29}géographe{/en}. - Député du Puy-de-Dôme à l''Assemblée législative puis à la Convention, représentant en mission près l''armée de Cherbourg, préconise l''essai du télégraphe aérien de Chiappe. - A participé à l''établissement du calendrier révolutionnaire [http://data.bnf.fr/ark:/12148/cb12536106q#foaf:Person]
{/ud}
{ud0}
Lorenzo Mascheroni ({en0li}Bergame, Italie{/en}, {dat1750}1750{/dat}) {en16}Mathématicien{/en} et poète. - Professeur de physique et de mathématique au Séminaire de Bergame, puis d''algèbre et de géométrie à l''Université de Pavie, dont il sera recteur. - Député au Corps législatif de Milan ({dat1799}1799{/dat}), admirateur de Napoléon, fait partie des 29 qui signent l''appel à régner en Italie au Premier Consul après 1799 [http://data.bnf.fr/ark:/12148/cb119149502#foaf:Person]
{/ud}
{ud0}
Nicolas-Maurice Chompré ({en0li}Paris (France){/en}, {dat1750}1750{/dat}) Directeur, entre 1777 et 1786, de la Correspondance générale à la Division des mines et de l''agriculture du Contrôleur général des Finances Bertin. - Diplomate. - Auteur d''ouvrages de physique et de mathématiques [http://data.bnf.fr/ark:/12148/cb122074802#foaf:Person]
{/ud}
{ud0}
Scipione Breislak ({en0li}Rome{/en}, {dat1750}1750{/dat}) Géologue. - Professeur de mathématiques à Raguse puis à Rome [http://data.bnf.fr/ark:/12148/cb151306996#foaf:Person]
{/ud}
{ud0}
Simon Lhuilier ({dat1750}1750{/dat}) {en16}Mathématicien{/en} et {en18}philosophe{/en}. - Établi à Varsovie [http://data.bnf.fr/ark:/12148/cb13005974t#foaf:Person]
{/ud}
{ud0}
Alliette ({dat1751}1751{/dat}) Cartomancien de la fin du 18e siècle. - Marchand d''estampes. - Professeur de mathématiques (vers 1753). - La forme "Etteilla" est l''anagramme d''Alliette [http://data.bnf.fr/ark:/12148/cb118885161#foaf:Person]
{/ud}
{ud0}
André-Charles Brotier ({en0li}Paris{/en}, {dat1751}1751{/dat}) Abbé, {en16}mathématicien{/en} et homme politique. - Enseigna les mathématiques à l''Ecole militaire. - Collabora à l''"Année littéraire" et au "Journal de la France" [http://data.bnf.fr/ark:/12148/cb124621991#foaf:Person]
{/ud}
{ud0}
Antide Janvier (Lavans-lès-Saint-Claude ({en0li}Jura){/en}, {dat1751}1751{/dat}) Horloger, {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb12614643k#foaf:Person]
{/ud}
{ud0}
Bazaine ({dat1751}1751{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb10735226f#foaf:Person]
{/ud}
{ud0}
Bernard Violle ({dat1751}1751{/dat}) {en16}Mathématicien{/en}. - Géomètre. - Chevalier de Saint-Louis ({dat1815}1815{/dat}) [http://data.bnf.fr/ark:/12148/cb13006994p#foaf:Person]
{/ud}
{ud0}
Bonaventure Abat ({dat1751}1751{/dat}) {en16}Mathématicien{/en} et théologien, cordelier de l''Observance. - Fut membre associé de l''Académie royale des belles-lettres de Barcelone [http://data.bnf.fr/ark:/12148/cb134813469#foaf:Person]
{/ud}
{ud0}
G.-F. Olivier ({dat1751}1751{/dat}) Bachelier ès sciences. - Professeur d''humanités et de mathématiques (en 1825). Professeur au collège de Troyes [http://data.bnf.fr/ark:/12148/cb10728006s#foaf:Person]
{/ud}
{ud0}
Guillelmus Beer ({dat1751}1751{/dat}) Cartographe, {en29}géographe{/en} et peut-être {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb15332855z#foaf:Person]
{/ud}
{ud0}
Hector-Jean Legros ({dat1751}1751{/dat}) Adjoint-général pendant les guerres de Vendée et d''Italie. - Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb13484693c#foaf:Person]
{/ud}
{ud0}
Henri Jurain ({dat1751}1751{/dat}) Abbé. - Professeur de mathématiques à Reims. - Correspondant de l''Académie des Sciences [http://data.bnf.fr/ark:/12148/cb12224993g#foaf:Person]
{/ud}
{ud0}
J.-B.-M. Duprat ({dat1751}1751{/dat}) Libraire pour les mathématiques. - En activité de mars 1797 à 1803 au moins. Apparenté à Louis (-Alexis) Duprat-Duverger, en activité à partir de 1802, qui a pu se qualifier lui aussi de "libraire pour les mathématiques". Louis Courcier, "imprimeur et libraire pour les mathématiques", lui succède en 1803 à la même adresse (quai des Augustins, n° 71). Une "madame Duprat" est cependant répertoriée, à l''adresse du pont Saint-Michel, par le "Tableau des libraires" de Debray (Paris, janv. 1804) [http://data.bnf.fr/ark:/12148/cb16701987t#foaf:Person]
{/ud}
{ud0}
J.P. Audiffred ({dat1751}1751{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb125867381#foaf:Person]
{/ud}
{ud0}
Jacques Baradelle ({dat1751}1751{/dat}) Etabli dès 1740 quai de l''Horloge du Palais, il fabriquait des instruments de navigation, des cadrans solaires, des sphères astronomiques et géographiques [http://data.bnf.fr/ark:/12148/cb15281028g#foaf:Person]
{/ud}
{ud0}
James Dodson ({dat1751}1751{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb153816258#foaf:Person]
{/ud}
{ud0}
Jean-Louis Gœury ({dat1751}1751{/dat}) Libraire ; libraire pour les mathématiques et l''architecture ; libraire de l''École des Ponts et chaussées ({dat1802}1802{/dat}) ; des ingénieurs et de l''École impériale des Ponts et chaussées ({dat1805}1805{/dat}). - Semble avoir été commis du libraire parisien Charles-Antoine Jombert de 1770 à 1773 au moins. Père du {en28}médecin{/en} Jean-Louis Gœury-Duvivier, né le 2 mars 1803. En activité dès 1800. Breveté libraire le 1er oct. 1812 (brevet renouvelé le 11 sept. 1818). Décédé peu avant le 28 juin 1827, date à laquelle son fils Jean-Louis Gœury (dit plus tard Gœury-Duvivier) demande à succéder à son brevet [http://data.bnf.fr/ark:/12148/cb12230577c#foaf:Person]
{/ud}
{ud0}
Joseph Mouchet ({dat1751}1751{/dat}) Professeur de rhétorique et de mathématiques, professeur de physique à l''université de Nantes de 1780 à 1784. - Aéronaute. - Membre de la Congrégation de l''Oratoire [http://data.bnf.fr/ark:/12148/cb16514291q#foaf:Person]
{/ud}
{ud0}
Joseph-Louis Vincens de Mauléon de Causans ({en0li}Avignon{/en}, {dat1751}1751{/dat}) {en16}Mathématicien{/en}. - Colonel d''infanterie du régiment de Conti. - Chevalier de Malte [http://data.bnf.fr/ark:/12148/cb145658189#foaf:Person]
{/ud}
{ud0}
Le Professeur de mathématiques du Collège national de Toul ({dat1751}1751{/dat}) Professeur de mathématiques du Collège national de Toul [http://data.bnf.fr/ark:/12148/cb125373980#foaf:Person]
{/ud}
{ud0}
Le Ratz de Lanthenée ({dat1751}1751{/dat}) Gentilhomme liégeois. - {en16}Mathématicien{/en} et physicien [http://data.bnf.fr/ark:/12148/cb124022694#foaf:Person]
{/ud}
{ud0}
Louis Duprat-Duverger ({dat1751}1751{/dat}) Variante(s) de prénom : Louis-Alexis. - Libraire pour les mathématiques ; également éditeur de cartes et d''atlas. - Apparenté au "libraire pour les mathématiques" J.-B.-M. Duprat, en activité à Paris entre 1797 et 1803. Établi dès 1802, d''abord en association sous la raison "L. Duprat, Letellier et compagnie" jusqu''en 1804, seul ensuite. Breveté libraire le 1er oct. 1812 ; brevet renouvelé le 15 mars 1817 ; duplicata délivré le 27 avril 1824. Encore en activité en 1829 [http://data.bnf.fr/ark:/12148/cb133399518#foaf:Person]
{/ud}
{ud0}
Madame Bailly ({dat1751}1751{/dat}) Épouse de Jean-Sylvain Bailly, {en16}mathématicien{/en}, {en24}astronome{/en} et homme politique, guillotiné en 1793 [http://data.bnf.fr/ark:/12148/cb16541654h#foaf:Person]
{/ud}
{ud0}
Marie de La Fresnaye ({en0li}Barfleur (Manche){/en}, {dat1751}1751{/dat}) Professeur de littérature et de mathématiques [http://data.bnf.fr/ark:/12148/cb100430283#foaf:Person]
{/ud}
{ud0}
Marie-Louise Cartan ({dat1751}1751{/dat}) Femme d''Elie Cartan, mère du compositeur Jean Cartan et du {en16}mathématicien{/en} Henri Cartan. - Née Marie-Louise Bianconi [http://data.bnf.fr/ark:/12148/cb148511208#foaf:Person]
{/ud}
{ud0}
Mathurin-Georges Girault de Keroudou ({dat1751}1751{/dat}) Abbé. - {en16}Mathématicien{/en} français. - Principal du collège de Quimper. - Professeur de philosophie et de mathématiques au collège de Navarre à Paris. - Professeur au collège de Louis-le-Grand à Paris [http://data.bnf.fr/ark:/12148/cb15085298t#foaf:Person]
{/ud}
{ud0}
Nicolas Leverdé ({dat1751}1751{/dat}) {en25}Astrologue{/en} et {en16}mathématicien{/en}. - Auteur d''almanachs [http://data.bnf.fr/ark:/12148/cb10403809w#foaf:Person]
{/ud}
{ud0}
Olaf Söderberg ({dat1751}1751{/dat}) Botaniste et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12563978p#foaf:Person]
{/ud}
{ud0}
Théodore Bouys ({dat1751}1751{/dat}) {en16}Mathématicien{/en} favorable à Necker et à la Révolution [http://data.bnf.fr/ark:/12148/cb12240772d#foaf:Person]
{/ud}
{ud0}
Trabaud ({dat1751}1751{/dat}) Maître de mathématiques [http://data.bnf.fr/ark:/12148/cb134811442#foaf:Person]
{/ud}
{ud0}
Vérologue ({dat1751}1751{/dat}) "Seul imprimeur d''Apollon pour la satyre en prose". - Pseud. auquel est adjoint le qualificatif "seul imprimeur d''Apollon pour la satyre en prose" et qui, sous la fausse adresse "Sur l''imprimé au Parnasse", dissimule une impression française (parisienne selon Weller et G. Brunet, plutôt provinciale d''après le matériel typographique) de "La Nouvelle Astronomie du Parnasse françois, ou l''Apothéose des {en26}écrivain{/en}s vivans dans la présente année 1740", due au chevalier Jean-Florent-Joseph de Neufville de Brunaubois-Montador [http://data.bnf.fr/ark:/12148/cb165246377#foaf:Person]
{/ud}
{ud0}
Veuve de Louis Courcier ({dat1751}1751{/dat}) Nom patronymique : Victoire-Félicité Lemaire. - Imprimeur-libraire ; imprimeur-libraire pour les mathématiques, la marine, les sciences et les arts. - Brevetée imprimeur en succession de son mari le 12 août 1811 (brevet renouvelé le 15 oct. 1816) et libraire le 1er oct. 1812 (brevet renouvelé le 15 mars 1817). Deux de ses  gendres lui succèdent : Démophile Huzard (-Courcier) en mars 1820 (brevet du 14 mars 1820) comme imprimeur, et Victor Bachelier le 10 nov. 1821 comme libraire [http://data.bnf.fr/ark:/12148/cb124778683#foaf:Person]
{/ud}
{ud0}
Adrien-Marie Legendre ({dat1752}1752{/dat}) {en16}Mathématicien{/en}. - Président de l''Académie des sciences ({dat1806}1806{/dat}). - A aussi écrit avec Charles-Etienne Coquebert de Montbret et François Gattey sous le pseudonyme collectif "C.-G.-L. Métrophile" [http://data.bnf.fr/ark:/12148/cb12443375d#foaf:Person]
{/ud}
{ud0}
Barnaba Oriani ({en0li}Carignano, Italie{/en}, {dat1752}1752{/dat}) {en24}Astronome{/en} de l''Observatoire de Brera (1777-), puis de Milan. - A découvert qu''Uranus était une planète à partir de son orbite. - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12537845s#foaf:Person]
{/ud}
{ud0}
Jean-Baptiste Labey (La Chapelle-Hainfray (Calvados), aujourd''hui Valsemé ({en0li}Calvados){/en}, {dat1752}1752{/dat}) {en16}Mathématicien{/en}. - Professeur à l''École militaire, à l''École centrale du Panthéon, à l''École polytechnique et au Lycée Napoléon de Paris [http://data.bnf.fr/ark:/12148/cb12112257t#foaf:Person]
{/ud}
{ud0}
Jean-Baptiste Pérès (Valence d''Agen (Tarn-et-Garonne), {dat1752}1752{/dat}) Oratorien. - Professeur de mathématiques et de physique  à Lyon, membre de la Société des amis de la Constitution de la ville durant la Révolution, puis substitut du procureur général près la cour royale d''Agen et bibliothécaire de cette ville [http://data.bnf.fr/ark:/12148/cb126307361#foaf:Person]
{/ud}
{ud0}
Marc-Auguste Pictet ({en0li}Genève (Suisse){/en}, {dat1752}1752{/dat}) Naturaliste genevois, littérateur, chimiste, physicien et {en24}astronome{/en}. - Membre fondateur de la Société de physique et d''histoire naturelle de Genève, Suisse. - Correspondant de la Société royale de Londres [http://data.bnf.fr/ark:/12148/cb125386742#foaf:Person]
{/ud}
{ud0}
François Gattey ({dat1753}1753{/dat}) {en16}Mathématicien{/en}. - Directeur du Bureau des poids et mesures (en 1795). - A aussi écrit avec Charles-Etienne Coquebert de Montbret et Adrien-Marie Legendre sous le pseudonyme collectif "C.-G.-L. Métrophile" [http://data.bnf.fr/ark:/12148/cb12447886d#foaf:Person]
{/ud}
{ud0}
Antoine de La Salle ({dat1754}1754{/dat}) {en18}Philosophe{/en}. - {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb12173561c#foaf:Person]
{/ud}
{ud0}
Colin Mackenzie (Stornoway (Lewis, Western isles, Royaume-Uni), {dat1754}1754{/dat}) {en16}Mathématicien{/en}. - Fonctionnaire collonial en Inde (1815-1821). - Chargé du relevé cartographique de l''Inde et de la description de ses régions. - Collectionneur de divers documents (manuscrits, dessins aquarelles...) constituant le fonds d''études indianistes, collection dispersée aujourd''hui entre l''India office library, Londres et : Government oriental manuscripts library, Madras et Calcutta [http://data.bnf.fr/ark:/12148/cb14374770r#foaf:Person]
{/ud}
{ud0}
Franz Xaver von Zach ({en0li}Bratislava{/en}, {dat1754}1754{/dat}) {en24}Astronome{/en}. - Directeur de l''Observatoire du Seeberg (près de Gotha), de 1787 à 1808. - Dirigea les "Allgemeinen geographischen Ephemeriden" (1796-) [http://data.bnf.fr/ark:/12148/cb121732757#foaf:Person]
{/ud}
{ud0}
Jean-Baptiste Meusnier de La Place (Tours (Indre-et-Loire), {dat1754}1754{/dat}) {en16}Mathématicien{/en} et Officier. - Elu à l''Académie des sciences en 1784 pour son étude locale des surfaces. - Prénoms complets : Jean-Baptiste Marie Charles [http://data.bnf.fr/ark:/12148/cb10732160m#foaf:Person]
{/ud}
{ud0}
Nicolas-François Canard ({dat1754}1754{/dat}) {en16}Mathématicien{/en} et économiste [http://data.bnf.fr/ark:/12148/cb12519510c#foaf:Person]
{/ud}
{ud0}
Charles-Étienne Coquebert de Montbret ({en0li}Paris{/en}, {dat1755}1755{/dat}) Diplomate, {en16}mathématicien{/en} et {en29}géographe{/en}. - Nommé responsable de l''organisation du nouveau système de poids et mesures (décret de 1793), professeur de géographie physique et gîtes de minerais à l''École des mines. - A aussi écrit avec François Gattey et Adrien-Marie Legendre sous le pseudonyme collectif "C.-G.-L. Métrophile". - Membre de l''Institut, membre libre de l''Académie des Sciences (en 1816) [http://data.bnf.fr/ark:/12148/cb12447869t#foaf:Person]
{/ud}
{ud0}
Claude Philippe Bertrand Bertrand (Autun (Saône-et-Loire), {dat1755}1755{/dat}) {en29}Géographe{/en} et {en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb16506861q#foaf:Person]
{/ud}
{ud0}
Emmanuel-Étienne Duvillard de Durand ({en0li}Genève{/en}, {dat1755}1755{/dat}) {en16}Mathématicien{/en}, statisticien. - A développé la mathématisation de l''économie [http://data.bnf.fr/ark:/12148/cb129987837#foaf:Person]
{/ud}
{ud0}
Gaspard-Clair-François-Marie Riche de Prony ({en0li}Chamelet (Rhône){/en}, {dat1755}1755{/dat}) {en16}Mathématicien{/en} et ingénieur. - Directeur de l''École des Ponts et Chaussées (1799-1830). - Membre de l''Académie des Sciences. - Baron à titre personnel ({dat1828}1828{/dat}) [http://data.bnf.fr/ark:/12148/cb12535038t#foaf:Person]
{/ud}
{ud0}
Jean Anthelme Brillat-Savarin ({en0li}Belley, Ain{/en}, {dat1755}1755{/dat}) Magistrat. - Député aux États Généraux (élu en 1789). - G{en24}astronome{/en} [http://data.bnf.fr/ark:/12148/cb12305674c#foaf:Person]
{/ud}
{ud0}
Louis Courcier ({dat1755}1755{/dat}) Imprimeur-libraire ; imprimeur-libraire pour les mathématiques ({dat1801}1801{/dat}) ; imprimeur-libraire pour les mathématiques (, les sciences et les arts) (1804-1808). - Exerce l''imprimerie dès l''été 1790. Aurait été auparavant "marchand de peaux de lapin" d''après l''enquête des inspecteurs de la librairie de déc. 1810. Proche des Girondins, il émarge au budget du Bureau de l''Esprit public du ministre Jean-Marie Roland de La Platière en 1792. Dirige le "Courrier du Corps législatif et de la Guerre" ({dat1797}1797{/dat}). Rachète le fonds du libraire J.-B.-M. Duprat et lui succède en 1803 ; rachète l''imprimerie de Jean-Georges-Antoine Stoupe après la mort de celui-ci ({dat1808}1808{/dat}). Breveté imprimeur le 1er avril 1811. Dit âgé de 56 ans lors de son décès (30 juillet 1811). Sa veuve est brevetée en sa succession dès le 12 août 1811 [http://data.bnf.fr/ark:/12148/cb12421329b#foaf:Person]
{/ud}
{ud0}
Nicolas B. Halma ({dat1755}1755{/dat}) Chanoine de Paris. - {en24}Astronome{/en} et {en16}mathématicien{/en}. - Professeur [http://data.bnf.fr/ark:/12148/cb11906753t#foaf:Person]
{/ud}
{ud0}
Nikolaus von Fuss ({dat1755}1755{/dat}) {en16}Mathématicien{/en}, géomètre. - Né à Bâle, s''intalla à Saint-Pétersbourg en 1773 à la demande d''Euler. - Membre de l''Académie des sciences de Saint-Pétersbourg (1775-), secrétaire perpétuel (1800-). - Meurt à Saint-Pétersbourg le 23 décembre 1825 (style grégorien) [http://data.bnf.fr/ark:/12148/cb12359314p#foaf:Person]
{/ud}
{ud0}
Pierre Tédenat ({dat1755}1755{/dat}) Docteur en mathématiques. - Recteur de l''académie Nîmes (1809-1818) et professeur de philosophie à la faculté des lettres de Nîmes [http://data.bnf.fr/ark:/12148/cb10379875d#foaf:Person]
{/ud}
{ud0}
Agricol-Joseph-François-Xavier-Pierre-Esprit-Simon-Paul-Antoine Fortia d''Urban ({en0li}Avignon{/en}, {dat1756}1756{/dat}) {en16}Mathématicien{/en} et littérateur. - Chevalier de la Légion d''honneur en 1811, correspondant de l''Académie de Belgique en 1828 et membre libre de l''Académie des Inscriptions et belles-lettres en 1830 [http://data.bnf.fr/ark:/12148/cb121468483#foaf:Person]
{/ud}
{ud0}
Alexandre Ruelle ({en0li}Blois{/en}, {dat1756}1756{/dat}) {en24}Astronome{/en}. - Professeur d''astronomie à l''Observatoire de Paris de 1783 à 1795 [http://data.bnf.fr/ark:/12148/cb121582720#foaf:Person]
{/ud}
{ud0}
Ernst Gottfried Fischer ({dat1756}1756{/dat}) Physicien et {en16}mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb124025182#foaf:Person]
{/ud}
{ud0}
Jan Chrzciciel Władysław Śniadecki ({dat1756}1756{/dat}) {en16}Mathématicien{/en} et {en18}philosophe{/en}, un des plus grands savants polonais des Lumières [http://data.bnf.fr/ark:/12148/cb123726267#foaf:Person]
{/ud}
{ud0}
Joseph Mollet (Aix-en-Provence (Bouches-du-Rhône), {dat1756}1756{/dat}) Oratorien. - Professeur de physique et de mathématique, École Centrale, Lyon, Rhône. - Doyen de la Faculté des sciences de Lyon (1809-1815) [http://data.bnf.fr/ark:/12148/cb12196474k#foaf:Person]
{/ud}
{ud0}
Carl-Christian von Langsdorf ({en0li}Nauheim (Allemagne){/en}, {dat1757}1757{/dat}) {en16}Mathématicien{/en}. - Ingénieur. - Professeur de mathématiques à Erlangen (Allemagne), de 1798 à 1804, puis à Vilnius (Lituanie) de 1804 à 1806. - Frère de Langsdorf, Johann-Wilhelm (1745-1827) [http://data.bnf.fr/ark:/12148/cb10661030m#foaf:Person]
{/ud}
{ud0}
Dominique Blanqui ({dat1757}1757{/dat}) Professeur de philosophie et d''astronomie. - Député à la Convention. - Membre du Conseil des Cinq-cents [http://data.bnf.fr/ark:/12148/cb12534874n#foaf:Person]
{/ud}
{ud0}
Alexandre-Balthazar-Laurent Grimod de La Reynière ({en0li}Paris{/en}, {dat1758}1758{/dat}) Avocat. - Pamphlétaire. - G{en24}astronome{/en}, fondateur et président du "Jury dégustateur" [http://data.bnf.fr/ark:/12148/cb11905936j#foaf:Person]
{/ud}
{ud0}
Johann Christoph Schuster ({dat1759}1759{/dat}) {en16}Mathématicien{/en} [http://data.bnf.fr/ark:/12148/cb16505504t#foaf:Person]
{/ud}
{ud0}
Louis-François-Antoine Arbogast ({en0li}Mutzig, Alsace{/en}, {dat1759}1759{/dat}) {en16}Mathématicien{/en}. - Directeur du Collège royal (en 1791). - Député à l''Assemblée législative puis à la Convention nationale [http://data.bnf.fr/ark:/12148/cb12520232w#foaf:Person]
{/ud}
{ud0}
Pierre-René-Auguste Bremond d''Ars ({dat1759}1759{/dat}) Député de la noblesse. - Fut professeur de mathématiques et de latin [http://data.bnf.fr/ark:/12148/cb12540611f#foaf:Person]
{/ud}
{ud0}
Thomas Keith ({en0li}Winestead (GB){/en}, {dat1759}1759{/dat}) {en16}Mathématicien{/en}. - Professeur [http://data.bnf.fr/ark:/12148/cb10275963j#foaf:Person]
{/ud}
{ud0}
Giovanni Paradisi ({en0li}Reggio Emilia, Italie{/en}, {dat1760}1760{/dat}) Comte. - Homme politique. - {en16}Mathématicien{/en}. - Poète [http://data.bnf.fr/ark:/12148/cb105910991#foaf:Person]
{/ud}
{ud0}
Nicolas Antoine Guillard ({en0li}Sorbais, Aisne{/en}, {dat1760}1760{/dat}) Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb10617134p#foaf:Person]
{/ud}', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (30, 'Astronome polonais', NULL, '2015-10-13 15:01:29.86825+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 1, 'm', NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (31, 'Le pape qui a condamné Galilée', NULL, '2015-10-13 15:09:58.391533+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 1, 'm', NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (32, NULL, NULL, '2015-10-13 15:37:11.24158+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 5, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (33, 'cahier 4, p. 34-36', NULL, '2015-10-13 15:43:05.942249+02', '2015-11-06 18:03:40.521576+01', NULL, NULL, NULL, NULL, NULL, 8, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (845, 'Astronome, mathématicien et théoricien de la musique. - Maître-ès-arts de l''Université de Paris (1321)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121715011#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121715011#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1185, 'Médecin et poète. - Astronome et horloger, a terminé l''horloge astronomique, installée par son père : Dondi, Jacopo (1298-1359), à Padoue ou Pavie, Italie', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb122241024#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb122241024#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1555, 'Médecin , poète et astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14405998n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14405998n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1418, 'Philosophe, mathématicien, médecin. - Recteur de l''université de Parme (en 1412)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12182615f#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12182615f#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1449, 'Mathématicien et astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb155102056#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb155102056#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (883, 'Astronome, médecin et mathématicien ayant vécu à Orange puis à Tarascon. Il est l''auteur de nombreux traités d''astronomie', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15620448d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15620448d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1047, 'Médecin, mathématicien et astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11351746b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11351746b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1530, 'Astronome. - A enseigné à l''Université de Paris de 1327 à 1355', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12531239r#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12531239r#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1127, 'Auteur supposé de traités portant sur les instruments astronomiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14566743g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14566743g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1484, 'Théoricien de la musique, mathématicien et physicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb127653823#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb127653823#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1320, 'Grand sacellaire de l''Église byzantine, maître des maîtres de l''École patriarcale et archidiacre du clergé palatin. - A laissé un ouvrage d''exégèse de l''Évangile, un traité d''astronomie et un poème allégorique', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12153709d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12153709d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1425, 'Mathématicien, physicien, géographe, astronome et astrologue. - Inventeur des gnomons modernes. - Conservateur de la Bibliothèque de Florence', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12455406j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12455406j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1249, 'Philosophe, mathématicien, auteur de comédies', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12689419t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12689419t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1111, 'Militaire, mathématicien, astronome, astrologue, poète et historien. - Professeur d''astronomie à Naples', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12536229n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12536229n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1188, 'Mathématicien, astronome, juriste et savant', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12440997n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12440997n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1535, 'Peintre. - A écrit des traités de mathématiques, perspective et géométrie et des écrits sur la science des couleurs et du paysage', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12060279h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12060279h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (963, 'Prisonnier des Turcs (1438-1458). - Dominicain. - Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb130923013#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb130923013#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1529, 'Homme de lettres. - Architecte, astronome, mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11914242h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11914242h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1017, 'Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12374660w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12374660w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1283, 'Homme politique. - Humaniste. - Auteur de traités astronomiques et philosophiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb123298807#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb123298807#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1134, 'Astronome. - Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12159829r#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12159829r#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1210, 'Astronome et mathématicien de l''école de Kerala (Inde)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb165324540#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb165324540#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1037, 'Mathématicien. - Franciscain', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11918350c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11918350c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1181, 'Mathématicien suisse de Zürich', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15336511g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15336511g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1077, 'Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12539498r#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12539498r#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1450, 'Astronome, cosmographe, navigateur dans la péninsule arabique et aux Indes. - Pourrait avoir introduit l''imprimerie en Éthiopie (ca 1524), où vraisemblament il meurt', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13517283d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13517283d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1580, 'Astronome et poète', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125156549#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125156549#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1565, 'Augustinien et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb134854696#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb134854696#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1326, 'Écclésiastique et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125393703#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125393703#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (892, 'Médecin et mathématicien. - Évêque de Santa-Giusta (Sardaigne) en 1494. - Originaire de Valence (Espagne)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13486025q#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13486025q#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1235, 'Calligraphe. - Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12179148h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12179148h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (835, 'Agostinien. - Théologien, philosophe et astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125688716#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125688716#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1169, 'Astronome mort après 1469', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16163624s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16163624s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (905, 'Astronome ; astrologue de Philippe le Bon, duc de Bourgogne', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15063496s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15063496s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1066, 'Mathématicien, éditeur et libraire', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10244031k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10244031k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1333, 'Astronome et géographe d''Albi', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb152949413#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb152949413#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1067, 'Grammairien et commentateur de Pāṇini (actif au 15e s.). - Fils de Kr̥ṣṇācārya. - A aussi écrit des ouvrages de philosophie (Vedānta) et d''astronomie', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb137708651#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb137708651#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1173, 'Poète, philosophe et mathématicien. - Meurt après 1527', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12567416q#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12567416q#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (934, 'Astronome et mathématicien. - Originaire de Wissekerc (Zélande)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12548011q#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12548011q#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (887, 'Magistrat, poète, philosophe, théologien et mathématicien. - Fut gouverneur de Brescia (1496), de Ferrare (1498), ambassadeur de Venise près le pape Jules II (1510)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13325565p#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13325565p#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (984, 'Médecin. - Astronome. - Mathématicien. - Né en Crète. - Philosophe. - Maître d''hébreu de Pic de la Mirandole (1463-1494). - Commentateur des écrits d''Averroés (1126-1198)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb122623668#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb122623668#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1522, 'Professeur de lettres, philosophe, mathématicien et poète. - Fut chargé de l''éducation des fils de Ludovico Sforza, duc de Milan. - Eut l''intention de fonder une imprimerie grecque et latine à Reggio Emilia, mais ses caractères furent volés par Ludovico Bonaccioli, médecin de la duchesse de Ferrare. - Né à Belluno, meurt à Bologne', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13324006j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13324006j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1191, 'Mathématicien, astronome et cartographe', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb154028305#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb154028305#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1128, 'Théologien, mathématicien, astronome et géographe. - Professeur de théologie. - Commentateur et auteur d''ouvrages historiques et théologiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15029346k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15029346k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1141, 'Professeur de théologie à l''Université d''Alcala (1510-), chanoine de la cathédrale de cette ville. - Fut l''un des précepteurs de Philippe II. - Étudia à Salamanque et à Paris, où il édita des oeuvres mathématiques et scientifiques. - Est également l''auteur d''un traité sur la sorcellerie dont la traduction espagnole eut une diffusion importante', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb128071494#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb128071494#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1005, 'Astronome et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125156905#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125156905#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (945, 'Théologien et mathématicien. - Théologal de Chartres. - Un des premiers à combattre les idées de Luther', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12234610b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12234610b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1572, 'Mathématicien et humaniste. - Professeur de lettres. - Notaire des Consuls des marchands de Venise', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12033590z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12033590z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1207, 'Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb118976048#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb118976048#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1536, 'Évêque de Civita Ducale (1545-1549). - Mathématicien, philosophe, astronome et astrologue', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb134849440#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb134849440#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (919, 'Né à Karlstadt près de Würzburg. - Prédicateur protestant. - Astronome. - Géographe. - Professeur de mathématiques à Nuremberg. - A aussi écrit en latin', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb119992233#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb119992233#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1115, 'Médecin, auteur du "De contagione et contagiosis morbis et curatione libri III" ; nommé par le pape Paul III médecin officiel du Concile de Trente. - Auteur de poèmes en latin, d''oeuvres de géographie, d''astronomie, de physique, de théologie et de philosophie. - Élève de Pomponazzi, ami de Copernic', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb120587788#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb120587788#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (961, 'Médecin, astronome, géologiste, poète, précurseur de la notion de contagion', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15699396m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15699396m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1100, 'Poète, philologue, philosophe et astronome. - Accompagna Hippolyte d''Este en Hongrie et en Pologne', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb122157991#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb122157991#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1007, 'Philosophe, mathématicien et linguiste. - Chanoine de Noyon. - Né avant le 28 mars 1479', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb118932166#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb118932166#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (942, 'Médecin, astronome et philosophe', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12568870v#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12568870v#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1149, 'Mathématicien, chimiste, architecte et ingénieur, spécialiste en métallurgie', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12195640k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12195640k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1072, 'Théologien et mathématicien. - Inventeur du logarithme. - Enseigna la théologie et les mathématiques à l''Université de Königsberg, puis les mathématiques à l''Université de Iéna', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12795734z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12795734z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1451, 'Hébraïsant, géographe et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11996987j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11996987j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1241, 'Théologien, mathématicien et astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10448635x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10448635x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1477, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10734904t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10734904t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (888, 'Géomètre et mathématicien. - Chanoine régulier de l''Ordre de Saint-Antoine', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12515817n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12515817n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1255, 'Astronome et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12548918m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12548918m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1222, 'Sieur de Champrouet. - Mathématicien et astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb122937307#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb122937307#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (901, 'Astronome, cartographe et mathématicien. - Nommé Chevalier de l''Empire par Charles Quint. - Surnom de : Bienewitz (ou Bennewitz), Peter', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12515640m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12515640m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1493, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13475586v#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13475586v#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (909, 'Théologien protestant, astronome et mathématicien. - Parfois désigné sous le nom "Andreas Osiander l''Ancien"', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11988942v#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11988942v#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (969, 'Médecin et naturaliste. - A enseigné les mathématiques à l''Université de Lisbonne', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb119983323#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb119983323#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (897, 'Mathématicien et historien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14624324z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14624324z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1469, 'Humaniste, mathématicien et astrologue. - Meurt selon les sources le 1er janvier 1531, en 1536 ou en 1556', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10645118k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10645118k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1317, 'Astrologue et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12805831h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12805831h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (999, 'Mathématicien, physicien et astronome, professeur à Marburg, édité par Sebastian Münster et Abraham Ortelius', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15379218m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15379218m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1576, 'Astronome et mathématicien. - Professeur à l''Université de Vienne', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10490264h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10490264h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1392, 'Mathématicien, ingénieur et architecte. - Pseudonyme de Niccolò Fontana', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12914492r#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12914492r#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1431, 'Médecin, mathématicien et philosophe', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11895137c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11895137c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1278, 'Astronome et mathématicien portugais', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13510349t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13510349t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1455, 'Ambassadeur, poète et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125520809#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125520809#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1374, 'Peintre, sculpteur, graveur, architecte, mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12467444s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12467444s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1404, 'Helléniste, philosophe, mathématicien et architecte', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10418521b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10418521b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1443, 'Astronome et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12548014r#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12548014r#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1440, 'Médecin, historien et astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12516715x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12516715x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1142, 'Théologien protestant. - Botaniste et astronome. - Professeur de logique à l''Université de Marbourg, puis professeur de théologie à Berne. - Fut lié avec Conrad Gesner. - Né et mort à Berne', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12515850g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12515850g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1548, 'Astronome. - Poète. - Fondateur de l''Académie de Bologne', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12202194q#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12202194q#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1080, 'Écrivain, dramaturge, astronome et traducteur d''oeuvres de l''Antiquité, de comédies, de traités philosophiques et scientifiques. - Membre de l''Accademia degli Intronati de Sienne, sous le pseudonyme : lo Stordito. - Archevêque de Patras et coadjuteur de l''archevêque de Sienne Francesco Bandini Piccolomini, du 28 juillet 1574 à 1578', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12240709n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12240709n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1373, 'Mathématicien et astronome. - Professeur et docteur en médecine de l''Université de Louvain', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125195002#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125195002#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1303, 'Mathématicien. - A été le tuteur du duc d''Urbino', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12562850s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12562850s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1194, 'Astrologue et mathématicien. - Conservateur de la bibliothèque du roi', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb133321861#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb133321861#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1094, 'Architecte et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12557068n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12557068n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1531, 'Hébraïsant. - Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12115338j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12115338j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1244, 'Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15583428k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15583428k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (936, 'Mathématicien et ingénieur', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb129309990#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb129309990#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1432, 'Géographe, cartographe, cosmographe et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12789989j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12789989j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1231, 'Philosophe, mathématicien et astrologue. - Originaire de Cosenza, fut assassiné à Padoue', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12570280s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12570280s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1150, 'Mathématicien et humaniste', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12146300q#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12146300q#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1208, 'Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13615799v#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13615799v#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1516, 'Professeur de médecine à Pavie puis de mathématiques à Milan', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13163998r#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13163998r#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1154, 'Philosophe, grammairien, mathématicien et humaniste. - Professeur de mathématique au Collège royal (Collège de France). - Se convertit au protestantisme et fut tué au cours du Massacre de la Saint-Barthélemy', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb120645094#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb120645094#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1164, 'Savant et poète. - Fils de Pierre de Mesmes, chambellan du roi de Navarre. - Etait lié avec Ronsard, du Bellay, Baïf, Charondas, Herberay, Jean Maugin, Ol. de Magny. - A était un des premiers auteurs à avoir écrit en français sur l''astronomie', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125177720#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125177720#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (981, 'Poète et critique humaniste. - Mathématicien. - A participé à la réforme de l''orthographe. - Traducteur d''Horace', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb122992680#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb122992680#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1356, 'Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14646245j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14646245j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1152, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb162974318#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb162974318#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1171, 'Médecin et astronome, a reçu une formation de juriste. - Fils de Hans Gugler (1480-1560)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16504896w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16504896w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1254, 'Mathématicien. - Membre de la guilde des instituteurs d''Anvers', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12563197r#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12563197r#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (988, 'Mathématicien et humaniste', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb162248258#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb162248258#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (840, 'Poète. - Agronome. - Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12181418p#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12181418p#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1106, 'Pédagogue, mathématicien et calligraphe', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb128696315#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb128696315#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (921, 'Architecte, mathématicien et poète', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10732099c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10732099c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (889, 'Mathématicien et médecin. - Reçu docteur à Bologne, occupa une chaire au Carolinum de Prague, fut premier médecin des empereurs Maximilien II et Rodolphe II', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13009688n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13009688n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1514, 'Mathématicien, astronome, géographe, architecte et bibliothécaire. - Cartographe à Wittenberg, ses cartes ont été éditées par Ortelius, Jode et Hondius', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15376436c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15376436c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1176, 'Astronome et mathématicien ottoman', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14599962n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14599962n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1247, 'Astrologue, mathématicien et antiquaire', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb119854464#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb119854464#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (886, 'Medecin et botaniste. - Professeur de médecine, chimie et mathématiques. - Fils du théologien : Lonicer, Johann (1499-15969)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10279221n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10279221n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1343, 'Musicien, astrologue, mathématicien et médecin. - Actif de 1571 à 1586. - Frère du peintre Anthonie Blockland van Montfort', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13497580p#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13497580p#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1357, 'Mathématicien et ingénieur. - Fondateur de la géométrie analytique', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11998820g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11998820g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (850, 'Mathématicien, traducteur et éditeur de textes mathématiques et géométriques antiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13483147k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13483147k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1174, 'Mathématicien. - A tracé le plan de l''horloge astronomique de la cathédrale de Strasbourg', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16534831x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16534831x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1069, 'Humaniste, mathématicien, musicien, poète, linguiste et philosophe', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125347809#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125347809#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1382, 'Cosmographe et géographe. - Professeur de médecine, de mathématique et d''astronomie à l''Université de Padoue', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb134849518#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb134849518#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1473, 'Cartographe, mathématicien et physicien. - Fils de Peter Apian, succède à son père à l''Université d''Ingolstadt', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb152383864#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb152383864#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1189, 'Mathématicien. - A inventé le compas de proportion à huit points', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14643668k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14643668k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1245, 'Mathématicien, astronome, cartographe et cosmographe. - Dominicain', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb145332908#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb145332908#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1629, 'Spécialiste de théologie, professeur de théologie', NULL, '2015-11-10 22:00:21.157754+01', NULL, NULL, NULL, NULL, NULL, NULL, 4, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (977, 'Jésuite, musicien et professeur de mathématiques. - Fut chargé par Grégoire XIII de la réforme du calendrier', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125466080#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125466080#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1170, 'Mathématicien et astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10462395x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10462395x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (989, 'Astronome. - Homme de lettres', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb106019703#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb106019703#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1265, 'Humaniste, mathématicien et poète néolatin. - Chanoine du chapitre de St Salvator d''Utrecht. - Fils du peintre Anthonis Mor van Dashorst (Antonio Moro)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12384177f#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12384177f#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1340, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb120511976#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb120511976#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1351, 'Mathématicien et astrologue. - Gentilhomme de la maison du Comte de Sterckenberg. - Date de naissance présumée d''après le "portrait de Cormopede à l''âge de 51 ans" figurant au F. A. 2 de l''"Almanach des almanachs pour l''an MDXCIII"', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13491791f#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13491791f#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1190, 'Noble. - Homme d''arme. - Mathématicien. - Poète', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15122132t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15122132t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1153, 'Mathématicien et astronome. - Protégea Galilée et lui fit obtenir sa première chaire à Pise. - Né à Pesaro, meurt dans son chateau de Monte Baroccio', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb135173214#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb135173214#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1084, 'Chancelier de la ville de Lucerne, Suisse. - Historien, dramaturge, pharmacien et naturaliste. - Père de : Cysat, Johann Baptist (1587-1653), mathématicien et astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12748433g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12748433g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1175, 'Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11893749j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11893749j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1271, 'Érudit arabe, philosophe, théologien, astronome, grammairien, auteur d''anthologies', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12451570z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12451570z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1004, 'Philologue et écrivain. - A enseigné les belles-lettres et les mathématiques à l''Université de Tubingue. - Traducteur d''Aristophane, de Callimaque et de Tryphiodore. - Auteur d''une comédie, présentée devant l''empereur Rodolphe, qui lui décerna le titre de comte-palatin', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12463064b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12463064b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1561, 'Docteur en droit canon et civil. - Astronome, historien et poète', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125454264#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125454264#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (953, 'Professeur de mathématiques de Maurice de Nassau', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb119941019#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb119941019#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1281, 'Ingénieur, mathématicien, fabricant d''instruments de navigation, poète', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb124231863#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb124231863#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (949, 'Médecin, philosophe, mathématicien et poète. - Également connu sous le pseudonyme d''El Escéptico', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb120172346#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb120172346#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (965, 'Prêtre. - Mathématicien, théologien et homme de lettres', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10615268s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10615268s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1412, 'Mathématicien et théologien. - Baron de Merchiston', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12353925j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12353925j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1532, 'Né à Göppingen (Wurtemberg). - Mathématicien. - Astronome. - Luthérien, hostile à la réforme grégorienne du calendrier', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12330628m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12330628m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1524, 'Astronome et astrologue finlandais', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb131923734#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb131923734#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1540, 'Théologien et mathématicien, né à Embrun. Chanoine d''Embrun, ingénieur des armées, puis prévôt de l''église collégiale de Ternant, professeur de mathématiques à Paris ; protonotaire apostolique et officier du Saint-Office. - Il a laissé des livres et des articles sur des sujets variés : géométrie, astronomie, médecine, occultisme, physique...', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12250531g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12250531g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1458, 'Savant, miniaturiste et calligraphe ottoman. - A écrit plusieurs ouvrages sur les armes et les combats, sur la géométrie et les mathématiques ainsi que sur l''histoire. - Inventeur du jeu de "matraque", il est mieux connu sous son surnom "Matrakçı" : "Matrakçı Nasuh Efendi", "Nasuh al-Silahî", "Matraki", "Nasuh el-Mitraki", "Nasuh üs-Silahi", "Matraqçi Nasuh", "Nasuh b. Abdullah" et "Nasuh b. Karagöz el-Bosnevi" sont parmi les autres formes de référence', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb119562090#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb119562090#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (951, 'Professeur de mathématiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14526861v#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14526861v#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1457, 'Mathématicien, ingénieur naval et voyageur. - Fut capitaine de galère de la marine pontificale', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125466487#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125466487#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1139, 'Archéologue, architecte et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10435220v#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10435220v#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1123, 'Philosophe, mathématicien, architecte et ingénieur. - Est aussi l''auteur de l''un des premiers traité d''escrime', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12536260s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12536260s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1071, 'Abbé. - Mathématicien et poète', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb105963005#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb105963005#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1497, 'Professeur de mathématiques à Paris. - Ingénieur au service des Provinces-Unies. - N''est pas un pseudonyme de Clément Cyriaque de Mangin', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb144882445#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb144882445#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1286, 'Lexicographe, physicien et mathématicien. - Évêque de Czanad (Hongrie) (1594) et de la République de Venise. - Neveu d''Antun Vrančić (1504-1573)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10703670x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10703670x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1215, 'Mathématicien, augustinien et miniaturiste', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13485419n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13485419n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1311, 'Professeur de mathématiques à Leyde, cartographe', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15337130w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15337130w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (865, 'Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb119512329#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb119512329#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1470, 'Mathématicien et ingénieur', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb104024969#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb104024969#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (855, 'Dominicain. - Médecin, professeur de logique et de mathématique', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13484092c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13484092c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (900, 'Mathématicien. - Philosophe. - Astrologue. - Musicologue. - Théologien. - Originaire de Bergame', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125394931#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125394931#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1232, 'Mathématicien. - Astronome. - Médecin (pratiquait à Strasbourg et Francfort)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb132003253#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb132003253#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1129, 'Ingénieur et mathématicien. - Né à Colombières, vallée d''Oulx (aujourd''hui en Italie), d''après Eugénie Droz', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12376654f#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12376654f#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (944, 'Tisserand, puis astronome. - Membre de l''Académie des sciences de 1682 à 1702', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16176897g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16176897g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1463, 'Autre(s) graphie(s) : Metayer ; Messor ; Metayerus ; Mettayier. - Variante(s) de prénom : Jean ; Jean Jamet. - Imprimeur-libraire ; imprimeur du Roi pour les mathématiques (1580) et imprimeur ordinaire du Roi (1583-1605). - En 1588, le roi Henri III le fait imprimeur officiel de sa congrégation des pénitents de l''Annonciation. De 1588 à 1594, il suit le Roi et la Cour à Blois puis  à Tours. - De retour à Paris, doit partager sa charge avec Pierre L''Huillier et Fédéric II Morel en vertu de l''arrêt du Conseil du 20 avril 1594. Revend à Tours son atelier et sa boutique à l''imprimeur Maurice Bouguereau. En mars  1596, le Roi l''associe à la Compagnie des usages avec Pierre L''Huillier. Décédé avant le 12 fév. 1605. Des publications paraissent encore sous son nom jusqu''en 1614. - A travaillé en association avec Mathurin Challenge (1573) et Barthélemy Gomet à Blois. S''associe à Tours (oct. 1591 - oct. 1593) avec Jean Richer, Claude de Monstr''oeil, Sébastien Molin, Mathieu I Guillemot, Georges Drobet et Marc Orry, son gendre. Travaille en association étroite avec Pierre L''Huillier et avec son fils Pierre Mettayer qui se trouvaient eux aussi à Tours', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125031934#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125031934#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1464, 'Médecin, botaniste et astronome. - Fut recteur de l''Université de Caen', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12545367f#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12545367f#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (970, 'Mathématicien et hydrographe', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13496046w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13496046w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1293, 'Citoyen de Romans en Dauphiné. - Mathématicien et astrologue', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13479237s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13479237s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1330, 'Poète. - Médecin, mathématicien, professeur à Lausanne et Genève', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12249180j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12249180j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1584, 'Astronome, mathématicien et géographe à Anvers, édité par Ortelius et De Jode', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb153817246#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb153817246#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (957, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13006978f#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13006978f#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1327, 'Mathématicien et astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb140653109#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb140653109#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1413, 'Médecin, originaire d''Écosse, s''établit à Saumur en 1606 à l''appel de l''Académie protestante de la ville. - Professeur de mathématiques, de grec et d''humanités', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13006401g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13006401g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1043, 'Mathématicien, musicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12510914p#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12510914p#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1182, 'Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13007384z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13007384z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1044, 'Mathématicien. - Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb145753184#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb145753184#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1482, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13173242d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13173242d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1358, 'Mathématicien. - Achète la seigneurie de Laleu en 1592 et y fait construire le château. - Maire de La Rochelle en 1616. - S'' installe à Paris en décembre 1633 et abjure le protestantisme', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12135021d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12135021d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1284, 'Cartographe et astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15370391s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15370391s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1400, 'Éditeur. - Marchand d''estampes et d''instruments de mathématiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16553551w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16553551w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1566, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb103947442#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb103947442#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1410, 'Professeur de mathématiques à Paris. - N''est pas un pseudonyme de Clément Cyriaque de Mangin', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb144882503#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb144882503#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (982, 'Autre(s) graphie(s) : Le Voirrier ; Le Verrier. - Imprimeur du Roi pour les mathématiques. - Beau-père de Mathieu I Guillemot (1584). Encore en activité le 31 déc. 1589. Décédé entre 1591 et le 7 nov. 1594 (compte de succession)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12230743m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12230743m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1478, 'Mathématicien. - Musicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125559272#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125559272#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1288, 'Apothicaire, médecin, mathématicien et architecte', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11948264d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11948264d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1058, 'Mathématicien. - Professeur de droit', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125630488#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125630488#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1402, 'Horloger, astronome et mathématicien suisse', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb123814270#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb123814270#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1145, 'Abbé de Guastalla. - Poète, prosateur, mathématicien et historien. - Polyglotte, connaissait le grec et le latin, l''hébreu, l''arabe, le persan et le hongrois', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12179488k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12179488k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1423, 'Orientaliste, mathématicien et astronome. - A été le premier à utiliser le télescope avec d''autres instruments comme le sextant', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12560133s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12560133s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (971, 'Mathématicien. - Astronome. - Professeur de mathématique à l''Université de Padoue', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121593328#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121593328#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (920, 'Astronome, mathématicien et géographe. - A occupé la chaire d''astronomie à l''Université de Bologne en 1588. - Auteur prétendu de prédictions et de nombreux almanachs publiés en France, en Allemagne et aux Pays-Bas jusqu''au 19e siècle', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12162475b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12162475b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1257, 'Fils de l''avocat Jean Du Temps I, il fut lui-même avocat et avait des connaissances en astrologie et mathématique. Frère d''Adam Du Temps, spécialiste des fortifications qui participa peut-être à la carte du Blésois dont il est l''auteur', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15302460t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15302460t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1437, 'Organiste, compositeur et théoricien de la musique ; astronome ; historien ; libraire et éditeur de musique. - Natif de Gorsleben près de Sachsenburg (Thuringe) et issu d''une famille paysanne. Après des études aux universités de Leipzig et Helmstedt, il devient à partir de 1581 et jusqu''à sa mort "cantor" de plusieurs églises de Leipzig successivement. Auteur de plusieurs ouvrages théoriques et compositions musicales, ainsi que d''un "Opus chronologicum" (1605 ; au moins 6 rééd.) et d''un "Elenchus calendarii Gregoriani" (1612). Décédé à Leipzig en nov. 1615. À distinguer du pasteur et prédicateur de Quedlinburg Sethus Calvisius (ou : Seth Kal(l)witz) (1639-1698), parfois appelé à tort "Sethus Calvisius le fils"', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12875550d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12875550d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1539, 'Philosophe et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12528863r#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12528863r#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (917, 'Savant, mathématicien, astronome, d''origine protestante, géographe du roi Henri IV', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12412403z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12412403z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1285, 'Professeur de mathématiques à Leipzig (1613). - Médecin', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14333201g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14333201g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1038, 'Mathématicien et spécialiste des langues anciennes. - Fut professeur à Paris, puis à Poitiers', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12463074n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12463074n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1307, 'Mathématicien et astronome. - Envoyé comme conseiller aux Amériques en 1585-86', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12215671c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12215671c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1456, 'Mathématicien, physicien et astronome anglais', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb124346111#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb124346111#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1381, 'Médecin, mathématicien et voyageur. - Enseigna à Louvain et à Würzburg, fut mathématicien royal en Pologne', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12459969s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12459969s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1095, 'A aussi écrit en latin. - Prédicateur protestant à la cour de l''Électeur palatin. - Également auteur d''ouvrages mathématiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121457326#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121457326#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1547, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12305061c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12305061c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1362, 'Mathématicien, historien, géographe et astronome. - Chanoine', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12641353z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12641353z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (853, 'Chanoine de Sarlat, mathématicien et cartographe', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb153143878#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb153143878#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1342, 'Jésuite, mathématicien, astronome et architecte. Il a realisé les plans du Collège d''Aurillac et du Charleville', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10686921r#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10686921r#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (873, 'Mathématicien, astronome et pasteur', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb130073828#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb130073828#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1360, 'Astronome et mathématicien. - Fut l''élève de Tycho-Brahé. - Professeur de hautes mathématiques à l''Université de Copenhague', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13011001c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13011001c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1272, 'Haut fonctionnaire chinois, initié et converti au christianisme par le père jésuite Matteo Ricci. - Mathématicien. - Astronome. - Disciple de Matteo Ricci', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb150892932#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb150892932#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (959, 'Physicien, philosophe, astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11903931b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11903931b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1167, 'Jésuite portugais, mathématicien et cartographe actif de 1564 à 1613', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb153361957#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb153361957#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (993, 'Antiquaire et mathématicien, linguiste et humaniste. - Professeur d''astronomie au Gresham college de Londres', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125109678#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125109678#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1389, 'Humaniste, philologue, cartographe, théologien et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15040859j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15040859j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1028, 'Carme. - Théologien. - Mathématicien et astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12377530d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12377530d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1137, 'Astronome et philosophe. - Professeur de philosophie à l''Université de Pise', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10545041n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10545041n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1237, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12534847r#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12534847r#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1461, 'Jésuite, architecte et mathématicien. Auteur d''un projet pour le noviciat de Tournai. Préposé de la Maison professe, professeur d''Anvers', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16240952w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16240952w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1471, 'Libraire. - Natif d''Iphofen, près de Wurzbourg. Titulaire d''une maîtrise de théologie. Après des études aux universités de Tübingen et Wittenberg, travaille avec l''astronome Tycho Brahe jusqu''à la mort de celui-ci. Reçu ensuite bourgeois de Hambourg, où il s''établit libraire', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12229506t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12229506t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1295, 'Professeur de rhétorique, mathématiques et philosophie dans la Compagnie de Jésus, à Padoue et Brescia. - Evêque de Segna (Senj ou Zengg en Croatie) de 1600 à 1602; de Spalato (Split) de 1602 à 1615. - Gagné au protestantisme et exilé en Angleterre, doyen de Windsor. - Abjure et rentre en grâce (1622)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121335726#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121335726#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (847, 'Mathématicien et physicien. - Il exerça une grande influence sur le développement de l''application de l''algèbre à la géométrie. - Il mit au point le miroir parabolique, aujourd''hui conservé au National Maritime Museum de Londres. - Il collabora, entre autres, avec François Viète en France et avec Galilée en Italie', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb146476018#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb146476018#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1064, 'Architecte et mathématicien belge d''origine espagnole', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb119998212#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb119998212#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1345, 'Mathématicien et naturaliste. - Professeur de chimie à l''Université de Marburg', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13009199x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13009199x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (890, 'Jésuite et architecte, professeur de mathématique à Pont-à-Mousson puis à La Flèche, recteur du collège des Jésuites de Quimper', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16215104d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16215104d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1384, 'Mathématicien. - Architecte', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb165299645#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb165299645#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1070, 'Né à Delitzsch, près de Leipzig. - Professeur de grec et de mathématiques à Wittenberg', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12045847b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12045847b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1248, 'Cartographe et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14509982d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14509982d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1308, 'Architecte, ingénieur et mathématicien. - Né à Pesaro, meurt à Pérouse', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121826472#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121826472#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1355, 'Historien. - Philologue. - Professeur de mathématiques et de physique', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb123875836#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb123875836#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1101, 'Astronome et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11909597m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11909597m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1379, 'Autre(s) graphie(s) : Janssonius Blaeuw. - Imprimeur-libraire et éditeur de cartes et d''atlas. - Originaire d''Alkmaar ou des environs. Passe 2 ans auprès de Tycho Brahé au Danemark. À son retour à Amsterdam en 1596, s''établit cartographe et fabricant de globes terrestres et célestes. Monte ensuite une imprimerie et une fonderie. Également auteur d''ouvrages cartographiques et astronomiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12169772t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12169772t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1510, 'Graveur. - Mathématicien. - Physicien. - Chimiste', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12382467g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12382467g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1224, 'Mathématicien et astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12390032f#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12390032f#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1352, 'Jésuite. - Physicien, mathématicien et astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13483688j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13483688j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1074, 'Cosmographe et astronome, travaille à Anvers de 1612 à 1637', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15404394h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15404394h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1476, 'Au siècle : Luca Antonio ; en religion, carme : Giuseppe Maria. - Poète. - Mathématicien. - Savant latiniste et helléniste. - Professeur à l'' Université de Parme puis de Pise', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11996942k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11996942k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1575, 'Secrétaire de la propagande, débat avec Copernic (en 1616 et 1624) et écrit Relazione delle quattro parti del mondo avec pour objectif de soutenir missions et propagande religieuses. - Étudie l''astronomie, la cosmographie et la géographie et connait le grec, le français, l''espagnon et l''arabe. - Diplômé en droit civil et en droit canon à l''Université de Padoue, Italie', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13749501h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13749501h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1136, 'Supérieur et procurateur de la mission jésuite au Japon, il abjura en 1633 et se convertit au zen. - Auteur en 1636 de la "Supercherie dévoilée". - Traducteur d''ouvrages d''astronomie et de chirurgie', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13524212c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13524212c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1202, 'Astronome et géomètre. - Avocat au Parlement de Paris puis doyen du chapitre de Rothnac, Belgique', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb123969373#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb123969373#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1577, 'Docteur, mathématicien et géographe édité par Blaeu et Hondius', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb153239798#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb153239798#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (861, 'Mathématicien allemand. S''est aussi intéressé à l''ingénierie des fortifications', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb137778453#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb137778453#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1454, 'Conseiller au Parlement de Provence. - Astronome, archéologue et naturaliste', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11918940q#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11918940q#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1223, 'Mathématicien, astronome et géographe', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15336105f#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15336105f#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1312, 'Mathématicien et littérateur. - Sieur de Méziriac. - Érudit, auteur de poèmes en français, italien et latin. - Membre de l''Académie française (élu en 1634)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb120028244#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb120028244#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1506, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16296598k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16296598k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1550, 'Nom en religion de Jean Charnage. - Jésuite. - Professeur de philosophie et de mathématiques à La Flèche', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121629197#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121629197#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1279, 'Jésuite. - Philosophe et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12545452p#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12545452p#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1270, 'Philologue, historien, mathématicien et astronome. - Protestant. - Professeur d''histoire et d''éloquence à Strasbourg, recteur de l''Université de cette même ville', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb129928534#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb129928534#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1421, 'Astronome et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11916881j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11916881j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1294, 'Jésuite. - Mathématicien, astronome et architecte', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125377863#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125377863#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1395, 'Astrologue. - Astronome. - Auteur dramatique', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb122006609#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb122006609#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1490, 'Mathématicien. - Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16197665z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16197665z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1216, 'Mathématicien. - Astronome. - Historien. - Hébraïsant. - Actif en 1639. - A vécu à Paris. - Fils de David Hume (1558-163.) et frère aîné de la poétesse et traductrice Anna Hume (1586?-16..)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12072629r#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12072629r#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1300, 'Mathématicien et physicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb144888873#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb144888873#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1201, 'Homme de lettres et astronome. - A collaboré avec Galileo Galilei', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb144609004#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb144609004#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1063, 'Jésuite. - Philosophe, mathématicien et théologien professeur à Messine, Italie', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10735485h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10735485h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1008, 'Mathématicien, médecin, chimiste et botaniste. - Professeur à l''université de Leipzig', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14065362j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14065362j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1583, 'Ingénieur. - Intendant des fortifications du duc de Lorraine. - Professeur de droit et de mathématiques à Pont-à-Mousson', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16628764j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16628764j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1183, 'Jésuite. - Recteur du Collegio romano (1646-1649). - Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10077816w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10077816w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (867, 'Dominicain. - Mathématicien, inventeur et écrivain. - Disciple de Galilée, dont il défendit les théories astronomiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12545385c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12545385c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1158, 'Naturaliste, mathématicien et philosophe', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb120247195#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb120247195#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1567, 'Théologien. - Mathématicien, physicien et géologue', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14462868z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14462868z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1112, 'Jésuite. - Professeur de grammaire et de mathématiques. - Architecte. - Né à Vic s/Seille (Moselle), mort à Agde (Hérault)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13012148j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13012148j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1513, 'Philosophe et savant, astronome, mathématicien. - Théoricien de la musique. - Minime', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb119157157#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb119157157#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1515, 'Abbé. - Homme de lettres, philosophe et mathématicien. - Chevalier de Malte', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10748197m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10748197m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1057, 'Franciscain. - Philosophe, astronome et mathématicien. - Professeur de philosophie, de théologie, de mathématiques, professeur d''astronomie et de physique à l''Université de Padoue (1694-). - Né à Trapani, meurt à Naples', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12093422f#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12093422f#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1073, 'Mathématicien et géographe hollandais actif de 1656 à 1702. En 1660 il est recteur de l''Ecole latine de Hoorn', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15338282n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15338282n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1491, 'Jurisconsulte et astronome. - Enseigna la jurisprudence civile dès 1642 à Avignon', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb144713316#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb144713316#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1140, 'Imprimeur-libraire. - Natif de Lohra (comté de Lohenstein, près de Marburg, Allemagne). Mathématicien, astrologue et astronome, il se fixe à Strasbourg en 1618. Établi libraire en 1620 puis imprimeur dès 1621. Publie notamment chaque année un almanach et des prédictions. Auteur de plusieurs ouvrages scientifiques, dont des "Elementa geometrica..." (1re éd., 1620), une "Gnomonica" (1625), un "Compendium astronomiae..." (1634) et un traité de la divination, "Rota-Fortunae, oder Glück-Rad..." (s. d., plusieurs rééd.). De 1634 à 1639, assure des fonctions d''enseignant au Gymnase (lycée) de Strasbourg. En 1654, sollicite en vain la charge d''imprimeur de l''évêché de Saverne. De 1653 à 1661, imprime sous le pseudonyme de Hartmann Bär quelques ouvrages pour l''académie des Jésuites à Molsheim. Son fils aîné Johann Welper (1642-1720) lui succède en 1664, mais des éditions paraissent encore sous son nom en 1689. Son autre fils Eberhard (II) Welper (1644-1670) sera lui aussi mathématicien, astrologue et astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb158750586#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb158750586#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1242, 'Auteur, mathématicien et historien à Rostock', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15377794m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15377794m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1353, 'Jésuite. - Professeur de philosophie et de mathématiques, à Pont-à-Mousson notamment. - Confesseur du duc de Lorraine Charles IV. - Henry Van Etten, qui signe la dédicace de la première édition des "Récréations mathématiques" n''est pas un pseudonyme de Jean Leurechon, mais le nom d''un de ses élèves, qui aurait réellement existé d''après Trevor H. Hall', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13009618g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13009618g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1256, 'Médecin. - Astronome. - Mathématicien. - Né en Crète. - Fils d''Eliya Delmedigo (1460-1497)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb122623548#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb122623548#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1211, 'Mathématicien et ingénieur militaire. - Chevalier de l''Ordre de Malte', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15093021d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15093021d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1376, 'Jésuite. - Missionnaire en Chine (de 1619 à sa mort). - Mathématicien. - Conseiller et astronome de la Cour impériale de Chine', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12362941r#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12362941r#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (866, 'Philosophe, astronome, mathématicien, physicien, docteur en théologie et théoricien de la musique. - Entre dans les ordres en 1615', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb120250393#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb120250393#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1405, 'Mathématicien, astronome, professeur d''agriculture', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11969696s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11969696s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1092, 'Mathématicien et ingénieur. - Ingénieur dans l''armée de Frédéric de Nassau, prince d''Orange', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121123333#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121123333#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (926, 'Homme de lettres, philosophe et mathématicien. - Précepteur. - Membre de l''Académie française (élu en 1634)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125272379#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125272379#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (983, 'Jésuite. - Professeur de mathématiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb123902440#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb123902440#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (857, 'Alchimiste, rosicrucien, médecin et astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb167575369#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb167575369#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (943, 'Orientaliste. - Mathématicien. - Philologue, spécialiste des littératures', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb123338386#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb123338386#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1219, 'Philosophe et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11899775j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11899775j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1314, 'Astronome italien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb120704558#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb120704558#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1062, 'Jésuite. - Mathématicien, géomètre et astronome, disciple de Galilée. - Fut professeur à l''Université de Bologne', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12085151g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12085151g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1465, 'Jésuite. - Astronome. - Professeur de lettres, de philosophie et de théologie, à Parme puis à Bologne. - Mathématicien et historien de la géographie', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12546680q#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12546680q#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (859, 'Mathématicien et physicien. - Intendant général des ports et fortifications de France (1649)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb123944733#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb123944733#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1050, 'Voyageur, en particulier en Russie et en Perse. - Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12817277v#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12817277v#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1177, 'Mathématicien, navigateur et cartographe. - Imprimeur à Amsterdam', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb153358650#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb153358650#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (907, 'Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14065321z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14065321z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1518, 'Astronome et compositeur. - A découvert la planète Uranus. - S''installe en Grande-Bretagne en 1757', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14064893z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14064893z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1012, 'Autre(s) graphie(s) : Ulack ; Vlac. - Variante(s) de prénom : Adriaen ; Adrien. - Imprimeur-libraire. - Originaire de Gouda. Édite différents périodiques dont "De Haegsche Vrijdaeghse Post-Tijdingen". A publié en 1659 une contrefaçon de Johannes Elzevier et de Pieter Leffen. A également publié sous les fausses adresses et pseudonymes de "Cologne, Pierre Du Marteau" et "Amsterdam, Peter Le Grand". - Également mathématicien connu pour ses travaux sur les logarithmes et auteur d''ouvrages d''astronomie et de pamphlets en faveur des royalistes anglais en 1652-1655. Mort peu avant le 8 avril 1667. Des éd. paraissent encore sous son nom jusqu''en 1669, en association avec Johannes Vlacq', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121635061#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121635061#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1078, 'Jésuite. - Mathématicien et géomètre, fut le premier scientifique à étudier les propriétés de l''hélice. - Polémiqua avec Pascal, qui l''appelle "Allouerus" dans l''"Histoire de la roulette". - Professeur de rhétorique, de théologie et de mathématiques au collège de Toulouse. - Né à Rieux, meurt à Toulouse', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13006798h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13006798h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1430, 'Cartographe et mathématicien. Etudie à Naples', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb153917817#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb153917817#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1259, 'Médecin. - Professeur de mathématiques à Strasbourg. - Astronome. - Gendre et collaborateur de l''astronome Johann Kepler (1571-1630)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12163632v#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12163632v#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1148, 'Religieux minime. - Philosophe, mathématicien et peintre. - Membre de la Société des lanternistes', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb130127157#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb130127157#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (902, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11890827s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11890827s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1275, 'Peintre et mathématicien à la cour de l''empereur Kangxi', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14546684c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14546684c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (992, 'Architecte et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb153778194#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb153778194#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1570, 'Augustin du couvent de Pontarlier. Géographe et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15294805z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15294805z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1291, 'Docteur en philosophie et médecine de l'' Université de Bologne, professeur de mathématiques, chargé du musée Aldrovandi à partir de 1657, fut aussi un citoyen actif de Bologne, où il assura plusieurs magistratures ("giudice del Foro de mercanti, e de tribuni della plebe"). - Membre de l''Accademia dei Gelati de Bologne ("l''Innestato"), de l''Accademia degli Indomiti de Bologne ("lo Stellato"), et de l''Accademia della Notte de Bologne ("il Rugiadoso")', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12064289s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12064289s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (872, 'Mathématicien, célèbre pour son théorème. - On lui doit aussi le Principe de Fermat en optique. - Conseiller au Parlement de Toulouse et commissaire en la chambre des requêtes du Palais à Toulouse (mai 1631)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11902568b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11902568b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1393, 'Jésuite. - Professeur de physique, de mathématiques et de langues orientales, Collegio Romano, Rome. - Dessinateur et graveur', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb119097824#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb119097824#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (964, 'Professeur de philosophie (1634) et de mathématiques (1655) au Collège royal, Paris. - Membre fondateur de l''Académie royale des sciences', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12144923j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12144923j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1298, 'Jésuite (à partir de 1619). - Mathématicien et astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb123773436#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb123773436#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1552, 'Mathématicien. - Orientaliste. - Professeur d''astronomie à Londres puis à Oxford', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb129277690#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb129277690#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1574, 'Jésuite. - Professeur de philosophie, de théologie et de mathématiques. - Identifié par certains à Pierre Gautier (1599-16..), luthiste et compositeur', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121990328#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121990328#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1511, 'Fils de Sébastien Hardy. - Conseiller au Châtelet. - Mathématicien. - Ami de Mydorge, Descartes et du Père Mersenne ; souvent cité dans la correspondance de ces deux derniers', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12134536k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12134536k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1563, 'Mathématicien, géomètre et arithméticien. - Membre de l''Académie des Sciences. - Conseiller à la Cour des monnaies', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12459881c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12459881c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1269, 'Astronome. - Secrétaire de Jacques Du Puy et attaché au président de Thou', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb124621511#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb124621511#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1246, 'Cistercien. - Evêque de Satriano et Campagna (1657-1673) puis de Vigevano (1673-). - Humaniste, théologien, mathématicien, philosophe et architecte. - Défenseur de la doctrine probabiliste', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12392566m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12392566m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1414, 'Physicien et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12117674q#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12117674q#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1411, 'Mathématicien et physicien. - Jésuite', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12519717b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12519717b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1557, 'Mathématicien, phycisien, médecin, philosophe. - Membre de l''Accademia del Cimento', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12462534j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12462534j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1467, 'Géographe et cartographe. - Professeur de mathématiques et de géographie à l''Université de Rome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15404103t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15404103t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1630, 'Celui, celle qui s''occupe de physique. (Vieilli:) Celui, celle qui étudie, décrit et tente d''expliquer les éléments de la nature', NULL, '2015-11-10 22:13:25.653964+01', NULL, NULL, NULL, NULL, NULL, NULL, 4, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1507, 'Mathématicien. - Cartographe. - Architecte au service de la famille Radzwill. - Né en Lituanie', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb150812338#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb150812338#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1365, 'Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121054498#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121054498#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1526, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb146515879#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb146515879#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1441, 'Astronome et mathématicien du roi d''Espagne installé à Bruxelles', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb153283774#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb153283774#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (995, 'Jésuite. - Philosophe, astronome, opticien et professeur de mathématiques. - Né et mort à Bologne', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13326913s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13326913s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1429, 'Grava des cartouches notamment pour Nicolas Sanson. Eut un neveu du nom de François Chauveau. Son frère, Jean-Baptiste, habile ingénieur et mathématicien fut assassiné en 1670.', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15302394v#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15302394v#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1103, 'Religieux de l''Ordre des minimes. - Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14404933t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14404933t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (860, 'Médecin, philosophe et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13484167f#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13484167f#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1523, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12529949q#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12529949q#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (910, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb123396143#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb123396143#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (954, 'Mathématicien britannique. - S''est intéressé aux mathématiques appliquées (astronomie, cosmographie, architecture...)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb135104102#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb135104102#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1156, 'Mathématicien, cartographe et égyptologue', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb162142362#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb162142362#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1318, 'Religieux de la Chartreuse de Dijon. - Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb106267229#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb106267229#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1267, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14651592w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14651592w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1155, 'Astronome. - Membre de l''Académie des sciences (1666)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11941359d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11941359d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1178, 'Mathématicien. - Professeur d''hydrographie à Marseille', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12397222c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12397222c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1485, 'Astronome, physicien et mathématicien. - A contribué au développement du micromètre', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb134752474#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb134752474#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (37, 'Notices tirées d''une requête SPARQL sur le serveur BNF, annotées en ajoutant les balises ''ud'' (unités documentaires) qui séparent les textes.
De ce texte on été les 790 objets digitaux qui contiennent, dans le champs "définition", le texte des notices de la BNF', NULL, '2015-11-05 22:11:29.331634+01', '2015-11-11 23:16:39.658673+01', NULL, NULL, NULL, NULL, '<root><ud>
Hermann de Carinthie (île de Korčula (Croatie), 1105) Philosophe, écrivain, mathématicien, astrologue et traducteur croate [http://data.bnf.fr/ark:/12148/cb16243624j#foaf:Person]
</ud>
<ud>
Hermann le Dalmate (Saint Peter en Istrie une partie du duché de Carinthie (au sud de l''Autriche), 1110) Philosophe, astronome, astrologue, mathématicien et traducteur d''ouvrages scientifiques et de la littérature. - Il vint très jeune en 1135 en France à Paris et à Chartres. - Eut pour maître Thierry de Chartres. - L''abbé de Cluny, Pierre le Vénérable, poussa Herman à traduire à écrire sur la vie et l''oeuvre de Mahomet [http://data.bnf.fr/ark:/12148/cb12364029w#foaf:Person]
</ud>
<ud>
Bhāskarācārya (Dekkan, Inde, 1114) Mathématicien. - Astronome. - Fils de Maheśvara. - Auteur de :  "Siddhāntaśiromanī" (en 1150) ; "Karṇakutūhala" [http://data.bnf.fr/ark:/12148/cb14498624v#foaf:Person]
</ud>
<ud>
al-Muẓaffar ibn Muḥammad Šaraf al-Dīn Ṭūsī (1151) Mathématicien. - Originaire de Ṭūs, Hamad̲ān, Mosul, Alep, Damas. - Écrivait vers 1209 [http://data.bnf.fr/ark:/12148/cb120864072#foaf:Person]
</ud>
<ud>
Johannes de Sacro Bosco (1151) Mathématicien. - Chanoine prémontré de Holywood (comté de Dumfries, Écosse). - Professeur à l''Université de Paris. - Semble être né à Halifax (Yorkshire, Angleterre). - Mort en 1256 ou 1244 [http://data.bnf.fr/ark:/12148/cb121284153#foaf:Person]
</ud>
<ud>
Robertus Castrensis (1151) Traducteur de traités scientifiques et de mathématiques. - Sa période d''activité se situe aux alentours de 1145 [http://data.bnf.fr/ark:/12148/cb12223624k#foaf:Person]
</ud>
<ud>
Alexandre de Villedieu (Villedieu (Manche), 1170) Franciscain. - Grammairien, mathématicien et poète. - Chanoine de la cathédrale Saint-André d''Avranches [http://data.bnf.fr/ark:/12148/cb12536245w#foaf:Person]
</ud>
<ud>
Leonardo Fibonacci (1170) Mathématicien. - Surnommé Leonardo Pisano [http://data.bnf.fr/ark:/12148/cb13092437c#foaf:Person]
</ud>
<ud>
Moḥamad ben Moḥamad Naṣīr al-Dīn Ṭōsī (Tus (Iran), 1201) Mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb12399386c#foaf:Person]
</ud>
<ud>
Jean Pecham (1220) Provincial des franciscains d''Angleterre. - Archevêque de Cantorbéry (à partir de 1279). - Théologien, mathématicien et physicien [http://data.bnf.fr/ark:/12148/cb12459837w#foaf:Person]
</ud>
<ud>
Witelo (1220) Philosophe et mathématicien [http://data.bnf.fr/ark:/12148/cb12054316n#foaf:Person]
</ud>
<ud>
Maḥmūd ibn Mas´ūd Quṭb al-Dīn al- Šīrāzī (Shīrāz, 1236) Astronome, médecin, philosophe et théologien [http://data.bnf.fr/ark:/12148/cb12086388m#foaf:Person]
</ud>
<ud>
Jacob ben Machir (Marseille, 1238) Astronome. - Médecin. - Chancellier de la faculté de médecine de Montpellier [http://data.bnf.fr/ark:/12148/cb165406517#foaf:Person]
</ud>
<ud>
Grégoire Chioniadès (1240) Astronome, physicien et médecin byzantin. - Évêque de Tabriz, Iran [http://data.bnf.fr/ark:/12148/cb12007088c#foaf:Person]
</ud>
<ud>
Henri Baten (1246) Philosophe et théologien. - Astronome. - Poète et musicien [http://data.bnf.fr/ark:/12148/cb12220635h#foaf:Person]
</ud>
<ud>
al-Mufaḍḍal ibn ʿUmar Aṯīr al-Dīn al-Abharī (1251) Philosophe, logicien, astronome [http://data.bnf.fr/ark:/12148/cb15935708x#foaf:Person]
</ud>
<ud>
Bartolomeo da Parma (1251) Astrologue, géomancien et astronome. Fut professeur à l''Université de Bologne (1288-1297) [http://data.bnf.fr/ark:/12148/cb144790439#foaf:Person]
</ud>
<ud>
Campanus de Novare (1251) Astronome. - Mathématicien, commentateur d''Euclide [http://data.bnf.fr/ark:/12148/cb124917005#foaf:Person]
</ud>
<ud>
David ben Yom-Tov Poel (1251) Philosophe. - Médecin. - Père de l''astronome Jacob Poel [http://data.bnf.fr/ark:/12148/cb16540698w#foaf:Person]
</ud>
<ud>
Démétrius Triclinius (Thessalonique, 1251) Philologue. - Mathématicien et astrologue [http://data.bnf.fr/ark:/12148/cb12311753x#foaf:Person]
</ud>
<ud>
Geršon ben Salomon d''Arles (Béziers, 1251) Éxégète. - Astronome [http://data.bnf.fr/ark:/12148/cb134867338#foaf:Person]
</ud>
<ud>
Hui Yang (1251) Mathématicien chinois. En activité entre 1261 et 1275 [http://data.bnf.fr/ark:/12148/cb13746624q#foaf:Person]
</ud>
<ud>
Isaac ben Joseph Israeli (1251) Astronome. - Elève d''Asher ben Jehiel [http://data.bnf.fr/ark:/12148/cb16540863s#foaf:Person]
</ud>
<ud>
Jacopo da Firenze (1251) Mathématicien. - Actif en 1307 [http://data.bnf.fr/ark:/12148/cb157815579#foaf:Person]
</ud>
<ud>
Jordanus Nemorarius (1251) Mathématicien. - Probablement d''origine italienne [http://data.bnf.fr/ark:/12148/cb11986727x#foaf:Person]
</ud>
<ud>
Petrus Philomena de Dacia (1251) Mathématicien, astronome, philosophe. - Attesté entre 1290 et 1300. - Élève à l''Université de Bologne (1291-1292) puis de Paris. - Chanoine de Roskilde, Danemark. - A distinguer de Petrus de Dacia, recteur de l''Université de Paris en 1327 [http://data.bnf.fr/ark:/12148/cb11887258w#foaf:Person]
</ud>
<ud>
ʿAbd al-Ġaffār ibn ʿAbd al-Karīm Naǧm al-Dīn al- Qazwīnī (1251) Mathématicien et jurisconsulte chaféite [http://data.bnf.fr/ark:/12148/cb155674927#foaf:Person]
</ud>
<ud>
Andalò Di Negro (Gênes (?), Italie, 1260) Astronome. - Précepteur de Boccace. - Ambassadeur de la République de Gênes auprès de l''empereur Alexis Comnène (en 1314) [http://data.bnf.fr/ark:/12148/cb121998732#foaf:Person]
</ud>
<ud>
Théodore Métochite (Constantinople, 1260) Homme d''état, philosophe, poète, astronome et rhéteur [http://data.bnf.fr/ark:/12148/cb12000562c#foaf:Person]
</ud>
<ud>
Gersonide (Bagnols-sur-Cèze (Gard), 1288) Exégète biblique, mathématicien, astronome, philosophe, physicien [http://data.bnf.fr/ark:/12148/cb12131941j#foaf:Person]
</ud>
<ud>
Barlaam de Seminara (1290) Moine basilien, abbé du Saint-Esprit à Constantinople (1331), évêque de Gérace (1342-1348). - Théologien, philosophe, mathématicien, astronome et helléniste [http://data.bnf.fr/ark:/12148/cb13549924x#foaf:Person]
</ud>
<ud>
Jacopo Dondi (1290) Philosophe, astronome, médecin italien célèbre pour la construction d''une pendule astrale à Padoue. - Père de Giovanni Dondi [http://data.bnf.fr/ark:/12148/cb124119184#foaf:Person]
</ud>
<ud>
Thomas Bradwardine (1290) Mathématicien, philosophe et théologien. - Surnommé le "Doctor Profundus". - Archevêque de Canterbury en 1349 [http://data.bnf.fr/ark:/12148/cb12269047v#foaf:Person]
</ud>
<ud>
Richard of Wallingford (1292) Mathématicien. - Astronome. - Abbé du monastère bénédictin de St Albans [http://data.bnf.fr/ark:/12148/cb12128305h#foaf:Person]
</ud>
<ud>
Jean de Murs (1300) Astronome, mathématicien et théoricien de la musique. - Maître-ès-arts de l''Université de Paris (1321) [http://data.bnf.fr/ark:/12148/cb121715011#foaf:Person]
</ud>
<ud>
Giovanni Dondi dall''Orologio (Chiogga, Italie, 1318) Médecin et poète. - Astronome et horloger, a terminé l''horloge astronomique, installée par son père : Dondi, Jacopo (1298-1359), à Padoue ou Pavie, Italie [http://data.bnf.fr/ark:/12148/cb122241024#foaf:Person]
</ud>
<ud>
Giacomo Allegretti (1325) Médecin , poète et astronome [http://data.bnf.fr/ark:/12148/cb14405998n#foaf:Person]
</ud>
<ud>
Blasius de Parma (1347) Philosophe, mathématicien, médecin. - Recteur de l''université de Parme (en 1412) [http://data.bnf.fr/ark:/12148/cb12182615f#foaf:Person]
</ud>
<ud>
Abū ʿAbd Allâh Muḥammad al- Baqqār (1351) Mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb155102056#foaf:Person]
</ud>
<ud>
Emmanuel ben Jacob de Tarascon Bonfils (1351) Astronome, médecin et mathématicien ayant vécu à Orange puis à Tarascon. Il est l''auteur de nombreux traités d''astronomie [http://data.bnf.fr/ark:/12148/cb15620448d#foaf:Person]
</ud>
<ud>
Ǧamšīd ibn Masʿūd Ġiyāṯ al-Dīn al- Kāšī (1351) Médecin, mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb11351746b#foaf:Person]
</ud>
<ud>
Johannes Danck (1351) Astronome. - A enseigné à l''Université de Paris de 1327 à 1355 [http://data.bnf.fr/ark:/12148/cb12531239r#foaf:Person]
</ud>
<ud>
Naǧm al-Dīn al- Miṣrī (1351) Auteur supposé de traités portant sur les instruments astronomiques [http://data.bnf.fr/ark:/12148/cb14566743g#foaf:Person]
</ud>
<ud>
Prosdocimus de Beldemandis (1351) Théoricien de la musique, mathématicien et physicien [http://data.bnf.fr/ark:/12148/cb127653823#foaf:Person]
</ud>
<ud>
Taddeo da Parma (1351) Philosophe averroïste et astronome. - A enseigné la philosophie à Bologne vers 1320 [http://data.bnf.fr/ark:/12148/cb10103512f#foaf:Person]
</ud>
<ud>
Théodore Méliténiote (Constantinople, 1351) Grand sacellaire de l''Église byzantine, maître des maîtres de l''École patriarcale et archidiacre du clergé palatin. - A laissé un ouvrage d''exégèse de l''Évangile, un traité d''astronomie et un poème allégorique [http://data.bnf.fr/ark:/12148/cb12153709d#foaf:Person]
</ud>
<ud>
Paolo dal Pozzo Toscanelli (1397) Mathématicien, physicien, géographe, astronome et astrologue. - Inventeur des gnomons modernes. - Conservateur de la Bibliothèque de Florence [http://data.bnf.fr/ark:/12148/cb12455406j#foaf:Person]
</ud>
<ud>
Ugolino Pisani (Parme, Italie, 1405) Philosophe, mathématicien, auteur de comédies [http://data.bnf.fr/ark:/12148/cb12689419t#foaf:Person]
</ud>
<ud>
Lorenzo Buonincontri (San Miniato, Italie, 1411) Militaire, mathématicien, astronome, astrologue, poète et historien. - Professeur d''astronomie à Naples [http://data.bnf.fr/ark:/12148/cb12536229n#foaf:Person]
</ud>
<ud>
ʿAlī ibn Muḥammad al- Qalaṣādī (Baza (Espagne), 1412) Mathématicien, astronome, juriste et savant [http://data.bnf.fr/ark:/12148/cb12440997n#foaf:Person]
</ud>
<ud>
Piero della Francesca (Borgo San Sepolcro, Italie, 1416) Peintre. - A écrit des traités de mathématiques, perspective et géométrie et des écrits sur la science des couleurs et du paysage [http://data.bnf.fr/ark:/12148/cb12060279h#foaf:Person]
</ud>
<ud>
Georgius de Hungaria (Romosz, aujourd''hui Romos, Roumanie, 1422) Prisonnier des Turcs (1438-1458). - Dominicain. - Mathématicien [http://data.bnf.fr/ark:/12148/cb130923013#foaf:Person]
</ud>
<ud>
Antonio Manetti (Florence, Italie, 1423) Homme de lettres. - Architecte, astronome, mathématicien [http://data.bnf.fr/ark:/12148/cb11914242h#foaf:Person]
</ud>
<ud>
Georg von Peurbach (Peuerbach, Autriche, 1423) Astronome [http://data.bnf.fr/ark:/12148/cb12374660w#foaf:Person]
</ud>
<ud>
Giovanni Pontano (Cerreto di Spoleto (Perouse), Italie, 1426) Homme politique. - Humaniste. - Auteur de traités astronomiques et philosophiques [http://data.bnf.fr/ark:/12148/cb123298807#foaf:Person]
</ud>
<ud>
Johannes Regiomontanus (Königsberg, Allemagne, 1436) Astronome. - Mathématicien [http://data.bnf.fr/ark:/12148/cb12159829r#foaf:Person]
</ud>
<ud>
Nīlakaṇṭha Somayajī (1443) Astronome et mathématicien de l''école de Kerala (Inde) [http://data.bnf.fr/ark:/12148/cb165324540#foaf:Person]
</ud>
<ud>
Luca Pacioli (1445) Mathématicien. - Franciscain [http://data.bnf.fr/ark:/12148/cb11918350c#foaf:Person]
</ud>
<ud>
Konrad Türst (1450) Mathématicien suisse de Zürich [http://data.bnf.fr/ark:/12148/cb15336511g#foaf:Person]
</ud>
<ud>
Agostino Ricci (1451) Astronome [http://data.bnf.fr/ark:/12148/cb12539498r#foaf:Person]
</ud>
<ud>
Andrea Corsali (1451) Astronome, cosmographe, navigateur dans la péninsule arabique et aux Indes. - Pourrait avoir introduit l''imprimerie en Éthiopie (ca 1524), où vraisemblament il meurt [http://data.bnf.fr/ark:/12148/cb13517283d#foaf:Person]
</ud>
<ud>
Anianus (1451) Astronome et poète [http://data.bnf.fr/ark:/12148/cb125156549#foaf:Person]
</ud>
<ud>
Antonio Dolciati (1451) Augustinien et mathématicien [http://data.bnf.fr/ark:/12148/cb134854696#foaf:Person]
</ud>
<ud>
Bartolomeo da Messina (1451) Écclésiastique et mathématicien [http://data.bnf.fr/ark:/12148/cb125393703#foaf:Person]
</ud>
<ud>
Gaspar Torrella (1451) Médecin et mathématicien. - Évêque de Santa-Giusta (Sardaigne) en 1494. - Originaire de Valence (Espagne) [http://data.bnf.fr/ark:/12148/cb13486025q#foaf:Person]
</ud>
<ud>
Giovanni Abiosi (1451) Médecin, astronome, mathématicien et philosophe. - Né à Bagnuolo (Royaume de Naples), mort vers 1500 [http://data.bnf.fr/ark:/12148/cb12537367q#foaf:Person]
</ud>
<ud>
Giovanni Antonio Tagliente (1451) Calligraphe. - Mathématicien [http://data.bnf.fr/ark:/12148/cb12179148h#foaf:Person]
</ud>
<ud>
Giovanni Benedetto Moncetto (1451) Agostinien. - Théologien, philosophe et astronome [http://data.bnf.fr/ark:/12148/cb125688716#foaf:Person]
</ud>
<ud>
Giovanni Bianchini (1451) Astronome mort après 1469 [http://data.bnf.fr/ark:/12148/cb16163624s#foaf:Person]
</ud>
<ud>
Guillaume Hobit (1451) Astronome ; astrologue de Philippe le Bon, duc de Bourgogne [http://data.bnf.fr/ark:/12148/cb15063496s#foaf:Person]
</ud>
<ud>
Jacob Köbel (Heidelberg, Allemagne, 1451) Mathématicien, éditeur et libraire [http://data.bnf.fr/ark:/12148/cb10244031k#foaf:Person]
</ud>
<ud>
Louis Boulengier (1451) Astronome et géographe d''Albi [http://data.bnf.fr/ark:/12148/cb152949413#foaf:Person]
</ud>
<ud>
Rāmacandrācārya (1451) Grammairien et commentateur de Pāṇini (actif au 15e s.). - Fils de Kr̥ṣṇācārya. - A aussi écrit des ouvrages de philosophie (Vedānta) et d''astronomie [http://data.bnf.fr/ark:/12148/cb137708651#foaf:Person]
</ud>
<ud>
Sigismondo Fanti (Ferrare, Italie, 1451) Poète, philosophe et mathématicien. - Meurt après 1527 [http://data.bnf.fr/ark:/12148/cb12567416q#foaf:Person]
</ud>
<ud>
Willem Gilliszoon (1451) Astronome et mathématicien. - Originaire de Wissekerc (Zélande) [http://data.bnf.fr/ark:/12148/cb12548011q#foaf:Person]
</ud>
<ud>
Girolamo Donato (1454) Magistrat, poète, philosophe, théologien et mathématicien. - Fut gouverneur de Brescia (1496), de Ferrare (1498), ambassadeur de Venise près le pape Jules II (1510) [http://data.bnf.fr/ark:/12148/cb13325565p#foaf:Person]
</ud>
<ud>
Eliya Delmedigo (1460) Médecin. - Astronome. - Mathématicien. - Né en Crète. - Philosophe. - Maître d''hébreu de Pic de la Mirandole (1463-1494). - Commentateur des écrits d''Averroés (1126-1198) [http://data.bnf.fr/ark:/12148/cb122623668#foaf:Person]
</ud>
<ud>
Lodovico Pontico Virunio (1467) Professeur de lettres, philosophe, mathématicien et poète. - Fut chargé de l''éducation des fils de Ludovico Sforza, duc de Milan. - Eut l''intention de fonder une imprimerie grecque et latine à Reggio Emilia, mais ses caractères furent volés par Ludovico Bonaccioli, médecin de la duchesse de Ferrare. - Né à Belluno, meurt à Bologne [http://data.bnf.fr/ark:/12148/cb13324006j#foaf:Person]
</ud>
<ud>
Johannes Werner (Nuremberg, Allemagne, 1468) Mathématicien, astronome et cartographe [http://data.bnf.fr/ark:/12148/cb154028305#foaf:Person]
</ud>
<ud>
Jakob Ziegler (Landau (Allemagne), 1470) Théologien, mathématicien, astronome et géographe. - Professeur de théologie. - Commentateur et auteur d''ouvrages historiques et théologiques [http://data.bnf.fr/ark:/12148/cb15029346k#foaf:Person]
</ud>
<ud>
Pedro Ciruelo (Daroca, Espagne, 1470) Professeur de théologie à l''Université d''Alcala (1510-), chanoine de la cathédrale de cette ville. - Fut l''un des précepteurs de Philippe II. - Étudia à Salamanque et à Paris, où il édita des oeuvres mathématiques et scientifiques. - Est également l''auteur d''un traité sur la sorcellerie dont la traduction espagnole eut une diffusion importante [http://data.bnf.fr/ark:/12148/cb128071494#foaf:Person]
</ud>
<ud>
Johann Stöffler (Justingen, Allemagne, 1472) Astronome et mathématicien [http://data.bnf.fr/ark:/12148/cb125156905#foaf:Person]
</ud>
<ud>
Josse Clicthove (Nieuport, Pays-Bas, 1472) Théologien et mathématicien. - Théologal de Chartres. - Un des premiers à combattre les idées de Luther [http://data.bnf.fr/ark:/12148/cb12234610b#foaf:Person]
</ud>
<ud>
Bartolomeo Zamberti (Venise, Italie, 1473) Mathématicien et humaniste. - Professeur de lettres. - Notaire des Consuls des marchands de Venise [http://data.bnf.fr/ark:/12148/cb12033590z#foaf:Person]
</ud>
<ud>
Nicolas Copernic (1473) Astronome [http://data.bnf.fr/ark:/12148/cb118976048#foaf:Person]
</ud>
<ud>
Luca Gaurico (Giffoni, Italie, 1476) Évêque de Civita Ducale (1545-1549). - Mathématicien, philosophe, astronome et astrologue [http://data.bnf.fr/ark:/12148/cb134849440#foaf:Person]
</ud>
<ud>
Johann Schöner (1477) Né à Karlstadt près de Würzburg. - Prédicateur protestant. - Astronome. - Géographe. - Professeur de mathématiques à Nuremberg. - A aussi écrit en latin [http://data.bnf.fr/ark:/12148/cb119992233#foaf:Person]
</ud>
<ud>
Girolamo Fracastoro (Vérone, Italie, 1478) Médecin, auteur du "De contagione et contagiosis morbis et curatione libri III" ; nommé par le pape Paul III médecin officiel du Concile de Trente. - Auteur de poèmes en latin, d''oeuvres de géographie, d''astronomie, de physique, de théologie et de philosophie. - Élève de Pomponazzi, ami de Copernic [http://data.bnf.fr/ark:/12148/cb120587788#foaf:Person]
</ud>
<ud>
Girolamo Francastoro (1478) Médecin, astronome, géologiste, poète, précurseur de la notion de contagion [http://data.bnf.fr/ark:/12148/cb15699396m#foaf:Person]
</ud>
<ud>
Celio Calcagnini (Ferrare, Italie, 1479) Poète, philologue, philosophe et astronome. - Accompagna Hippolyte d''Este en Hongrie et en Pologne [http://data.bnf.fr/ark:/12148/cb122157991#foaf:Person]
</ud>
<ud>
Charles de Bovelles (1479) Philosophe, mathématicien et linguiste. - Chanoine de Noyon. - Né avant le 28 mars 1479 [http://data.bnf.fr/ark:/12148/cb118932166#foaf:Person]
</ud>
<ud>
Prospero Calano (Sarzana, Italie, 1480) Médecin, astronome et philosophe [http://data.bnf.fr/ark:/12148/cb12568870v#foaf:Person]
</ud>
<ud>
Vannoccio Biringuccio (Sienne, Italie, 1480) Mathématicien, chimiste, architecte et ingénieur, spécialiste en métallurgie [http://data.bnf.fr/ark:/12148/cb12195640k#foaf:Person]
</ud>
<ud>
Michael Stifel (1487) Théologien et mathématicien. - Inventeur du logarithme. - Enseigna la théologie et les mathématiques à l''Université de Königsberg, puis les mathématiques à l''Université de Iéna [http://data.bnf.fr/ark:/12148/cb12795734z#foaf:Person]
</ud>
<ud>
Sebastian Münster (Ingelheim, Allemagne, 1489) Hébraïsant, géographe et mathématicien [http://data.bnf.fr/ark:/12148/cb11996987j#foaf:Person]
</ud>
<ud>
Albert Pighius (Kampen, Pays-Bas, 1490) Théologien, mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb10448635x#foaf:Person]
</ud>
<ud>
Patrizio Tricasso (Ceresara, Italie, 1491) Dominicain. - Mathématicien et astrologue [http://data.bnf.fr/ark:/12148/cb107034397#foaf:Person]
</ud>
<ud>
Heinrich Schreiber (Erfurt, Allemagne, 1492) Mathématicien [http://data.bnf.fr/ark:/12148/cb10734904t#foaf:Person]
</ud>
<ud>
Jean Borrel (1492) Géomètre et mathématicien. - Chanoine régulier de l''Ordre de Saint-Antoine [http://data.bnf.fr/ark:/12148/cb12515817n#foaf:Person]
</ud>
<ud>
Pedro Nunez (1492) Astronome et mathématicien [http://data.bnf.fr/ark:/12148/cb12548918m#foaf:Person]
</ud>
<ud>
Oronce Fine (Briançon (Hautes-Alpes), 1494) Sieur de Champrouet. - Mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb122937307#foaf:Person]
</ud>
<ud>
Petrus Apian (Leisnig (Allemagne), 1495) Astronome, cartographe et mathématicien. - Nommé Chevalier de l''Empire par Charles Quint. - Surnom de : Bienewitz (ou Bennewitz), Peter [http://data.bnf.fr/ark:/12148/cb12515640m#foaf:Person]
</ud>
<ud>
Andreas Osiander (Gunzenhausen, Allemagne, 1498) Théologien protestant, astronome et mathématicien. - Parfois désigné sous le nom "Andreas Osiander l''Ancien" [http://data.bnf.fr/ark:/12148/cb11988942v#foaf:Person]
</ud>
<ud>
Garcia da Orta (Castelo di Vide, Portugal, 1499) Médecin et naturaliste. - A enseigné les mathématiques à l''Université de Lisbonne [http://data.bnf.fr/ark:/12148/cb119983323#foaf:Person]
</ud>
<ud>
Giovanni Agostino Abate (1499) Mathématicien et historien [http://data.bnf.fr/ark:/12148/cb14624324z#foaf:Person]
</ud>
<ud>
Joachim Sterck van Ringelberg (Anvers, Belgique, 1499) Humaniste, mathématicien et astrologue. - Meurt selon les sources le 1er janvier 1531, en 1536 ou en 1556 [http://data.bnf.fr/ark:/12148/cb10645118k#foaf:Person]
</ud>
<ud>
Johann Carion (Bietigheim, Allemagne, 1499) Astrologue et mathématicien [http://data.bnf.fr/ark:/12148/cb12805831h#foaf:Person]
</ud>
<ud>
Johannes Dryander (Wetter, Allemagne, 1500) Mathématicien, physicien et astronome, professeur à Marburg, édité par Sebastian Münster et Abraham Ortelius [http://data.bnf.fr/ark:/12148/cb15379218m#foaf:Person]
</ud>
<ud>
Johannes Voegelin (Heilbronn, Allemagne, 1500) Astronome et mathématicien. - Professeur à l''Université de Vienne [http://data.bnf.fr/ark:/12148/cb10490264h#foaf:Person]
</ud>
<ud>
Niccolò Tartaglia (1500) Mathématicien, ingénieur et architecte. - Pseudonyme de Niccolò Fontana [http://data.bnf.fr/ark:/12148/cb12914492r#foaf:Person]
</ud>
<ud>
Gerolamo Cardano (Pavie, Italie, 1501) Médecin, mathématicien et philosophe [http://data.bnf.fr/ark:/12148/cb11895137c#foaf:Person]
</ud>
<ud>
Pedro Nunes (Alcácer do Sol (Portugal), 1502) Astronome et mathématicien portugais [http://data.bnf.fr/ark:/12148/cb13510349t#foaf:Person]
</ud>
<ud>
Cosimo Bartoli (Florence, Italie, 1503) Ambassadeur, poète et mathématicien [http://data.bnf.fr/ark:/12148/cb125520809#foaf:Person]
</ud>
<ud>
Jean Cousin (Soucy (Yonne, France), 1503) Peintre, sculpteur, graveur, architecte, mathématicien [http://data.bnf.fr/ark:/12148/cb12467444s#foaf:Person]
</ud>
<ud>
Ciriaco Strozzi (Capalle, Italie, 1504) Helléniste, philosophe, mathématicien et architecte [http://data.bnf.fr/ark:/12148/cb10418521b#foaf:Person]
</ud>
<ud>
Jacques Bassantin (1504) Astronome et mathématicien [http://data.bnf.fr/ark:/12148/cb12548014r#foaf:Person]
</ud>
<ud>
Achille Pirminius Gasser (1505) Médecin, historien et astronome [http://data.bnf.fr/ark:/12148/cb12516715x#foaf:Person]
</ud>
<ud>
Benedictus Aretius (1505) Théologien protestant. - Botaniste et astronome. - Professeur de logique à l''Université de Marbourg, puis professeur de théologie à Berne. - Fut lié avec Conrad Gesner. - Né et mort à Berne [http://data.bnf.fr/ark:/12148/cb12515850g#foaf:Person]
</ud>
<ud>
Alessandro Piccolomini (Sienne, Italie, 1508) Écrivain, dramaturge, astronome et traducteur d''oeuvres de l''Antiquité, de comédies, de traités philosophiques et scientifiques. - Membre de l''Accademia degli Intronati de Sienne, sous le pseudonyme : lo Stordito. - Archevêque de Patras et coadjuteur de l''archevêque de Sienne Francesco Bandini Piccolomini, du 28 juillet 1574 à 1578 [http://data.bnf.fr/ark:/12148/cb12240709n#foaf:Person]
</ud>
<ud>
Gemma Frisius (Dokkum (Pays-Bas), 1508) Mathématicien et astronome. - Professeur et docteur en médecine de l''Université de Louvain [http://data.bnf.fr/ark:/12148/cb125195002#foaf:Person]
</ud>
<ud>
Federico Commandino (Sassocorvaro, Italie, 1509) Mathématicien. - A été le tuteur du duc d''Urbino [http://data.bnf.fr/ark:/12148/cb12562850s#foaf:Person]
</ud>
<ud>
Jean Gosselin (Vire, Calvados, 1510) Astrologue et mathématicien. - Conservateur de la bibliothèque du roi [http://data.bnf.fr/ark:/12148/cb133321861#foaf:Person]
</ud>
<ud>
Pietro Cataneo (1510) Architecte et mathématicien [http://data.bnf.fr/ark:/12148/cb12557068n#foaf:Person]
</ud>
<ud>
Erasmus Oswald Schreckenfuchs (1511) Hébraïsant. - Astronome [http://data.bnf.fr/ark:/12148/cb12115338j#foaf:Person]
</ud>
<ud>
Giovanni Battista Amici (Cosenza, Italie, 1511) Astronome [http://data.bnf.fr/ark:/12148/cb15583428k#foaf:Person]
</ud>
<ud>
Juanelo Turriano (1511) Mathématicien et ingénieur [http://data.bnf.fr/ark:/12148/cb129309990#foaf:Person]
</ud>
<ud>
Gerard Mercator (Rupelmonde, Flandres, 1512) Géographe, cartographe, cosmographe et mathématicien [http://data.bnf.fr/ark:/12148/cb12789989j#foaf:Person]
</ud>
<ud>
Giovanni Battista Amico (1512) Philosophe, mathématicien et astrologue. - Originaire de Cosenza, fut assassiné à Padoue [http://data.bnf.fr/ark:/12148/cb12570280s#foaf:Person]
</ud>
<ud>
Juan Pérez de Moya (1513) Mathématicien et humaniste [http://data.bnf.fr/ark:/12148/cb12146300q#foaf:Person]
</ud>
<ud>
Rheticus (1514) Astronome [http://data.bnf.fr/ark:/12148/cb13615799v#foaf:Person]
</ud>
<ud>
Bernardino Baldini (1515) Professeur de médecine à Pavie puis de mathématiques à Milan [http://data.bnf.fr/ark:/12148/cb13163998r#foaf:Person]
</ud>
<ud>
Petrus Ramus (Cuts (Aisne), 1515) Philosophe, grammairien, mathématicien et humaniste. - Professeur de mathématique au Collège royal (Collège de France). - Se convertit au protestantisme et fut tué au cours du Massacre de la Saint-Barthélemy [http://data.bnf.fr/ark:/12148/cb120645094#foaf:Person]
</ud>
<ud>
Jean-Pierre de Mesmes (1516) Savant et poète. - Fils de Pierre de Mesmes, chambellan du roi de Navarre. - Etait lié avec Ronsard, du Bellay, Baïf, Charondas, Herberay, Jean Maugin, Ol. de Magny. - A était un des premiers auteurs à avoir écrit en français sur l''astronomie [http://data.bnf.fr/ark:/12148/cb125177720#foaf:Person]
</ud>
<ud>
Jacques Peletier (1517) Poète et critique humaniste. - Mathématicien. - A participé à la réforme de l''orthographe. - Traducteur d''Horace [http://data.bnf.fr/ark:/12148/cb122992680#foaf:Person]
</ud>
<ud>
Jeronimo Munoz (1520) Astronome [http://data.bnf.fr/ark:/12148/cb14646245j#foaf:Person]
</ud>
<ud>
Livio Sanuto (1520) Géographe et mathématicien à Venise, fabriquant d''un globe avec son frère Giulio en 1561 [http://data.bnf.fr/ark:/12148/cb153816227#foaf:Person]
</ud>
<ud>
Melchior Ayrer (1520) Mathématicien [http://data.bnf.fr/ark:/12148/cb162974318#foaf:Person]
</ud>
<ud>
Nicolaus Gugler (Nuremberg (Allemagne), 1521) Médecin et astronome, a reçu une formation de juriste. - Fils de Hans Gugler (1480-1560) [http://data.bnf.fr/ark:/12148/cb16504896w#foaf:Person]
</ud>
<ud>
Valentin Mennher (1521) Mathématicien. - Membre de la guilde des instituteurs d''Anvers [http://data.bnf.fr/ark:/12148/cb12563197r#foaf:Person]
</ud>
<ud>
Hermann Witekind (Neuenrade (Allemagne), 1522) Mathématicien et humaniste [http://data.bnf.fr/ark:/12148/cb162248258#foaf:Person]
</ud>
<ud>
Giovanni Maria Bonardo (Fratta Polesine, Italie, 1523) Poète. - Agronome. - Astronome [http://data.bnf.fr/ark:/12148/cb12181418p#foaf:Person]
</ud>
<ud>
Juan de Yciar (Durango (prov. de Vizcaya), 1523) Pédagogue, mathématicien et calligraphe [http://data.bnf.fr/ark:/12148/cb128696315#foaf:Person]
</ud>
<ud>
Jacques Charpentier (Clermont-en-Beauvaisis (Oise), 1524) Philosophe et médecin. - Lecteur de mathématiques au Collège de France. - Médecin du roi [http://data.bnf.fr/ark:/12148/cb121323921#foaf:Person]
</ud>
<ud>
Tadeáš Hájek (Prague, 1525) Mathématicien et médecin. - Reçu docteur à Bologne, occupa une chaire au Carolinum de Prague, fut premier médecin des empereurs Maximilien II et Rodolphe II [http://data.bnf.fr/ark:/12148/cb13009688n#foaf:Person]
</ud>
<ud>
Tilemann Stella (Siegen (Allemagne), 1525) Mathématicien, astronome, géographe, architecte et bibliothécaire. - Cartographe à Wittenberg, ses cartes ont été éditées par Ortelius, Jode et Hondius [http://data.bnf.fr/ark:/12148/cb15376436c#foaf:Person]
</ud>
<ud>
Taqī al-Dīn Muḥammad Ibn Maʿrūf (Damas, 1526) Astronome et mathématicien ottoman [http://data.bnf.fr/ark:/12148/cb14599962n#foaf:Person]
</ud>
<ud>
John Dee (1527) Astrologue, mathématicien et antiquaire [http://data.bnf.fr/ark:/12148/cb119854464#foaf:Person]
</ud>
<ud>
Adam Lonicer (Marburg (Allemagne), 1528) Medecin et botaniste. - Professeur de médecine, chimie et mathématiques. - Fils du théologien : Lonicer, Johann (1499-15969) [http://data.bnf.fr/ark:/12148/cb10279221n#foaf:Person]
</ud>
<ud>
Cornelius Blockland (1530) Musicien, astrologue, mathématicien et médecin. - Actif de 1571 à 1586. - Frère du peintre Anthonie Blockland van Montfort [http://data.bnf.fr/ark:/12148/cb13497580p#foaf:Person]
</ud>
<ud>
Giovanni Battista Benedetti (Venise, Italie, 1530) Mathématicien et ingénieur. - Fondateur de la géométrie analytique [http://data.bnf.fr/ark:/12148/cb11998820g#foaf:Person]
</ud>
<ud>
Jean Péna (1530) Mathématicien, traducteur et éditeur de textes mathématiques et géométriques antiques [http://data.bnf.fr/ark:/12148/cb13483147k#foaf:Person]
</ud>
<ud>
Conradus Dasypodius (Frauenfeld, Suisse, 1531) Mathématicien. - A tracé le plan de l''horloge astronomique de la cathédrale de Strasbourg [http://data.bnf.fr/ark:/12148/cb16534831x#foaf:Person]
</ud>
<ud>
Ercole Bottrigari (1531) Humaniste, mathématicien, musicien, poète, linguiste et philosophe [http://data.bnf.fr/ark:/12148/cb125347809#foaf:Person]
</ud>
<ud>
Giuseppe Moletti (1531) Cosmographe et géographe. - Professeur de médecine, de mathématique et d''astronomie à l''Université de Padoue [http://data.bnf.fr/ark:/12148/cb134849518#foaf:Person]
</ud>
<ud>
Philip Apian (Ingoldstadt, Allemagne, 1531) Cartographe, mathématicien et physicien. - Fils de Peter Apian, succède à son père à l''Université d''Ingolstadt [http://data.bnf.fr/ark:/12148/cb152383864#foaf:Person]
</ud>
<ud>
Fabrizio Mordente (Salerne, Italie, 1532) Mathématicien. - A inventé le compas de proportion à huit points [http://data.bnf.fr/ark:/12148/cb14643668k#foaf:Person]
</ud>
<ud>
Egnatio Danti (Pérouse, Italie, 1536) Mathématicien, astronome, cartographe et cosmographe. - Dominicain [http://data.bnf.fr/ark:/12148/cb145332908#foaf:Person]
</ud>
<ud>
Henri de Monantheuil (1536) Mathématicien et médecin. - Régent de la Faculté de médecine de Paris, puis professeur de mathématiques au Collège de France (1574-). - Né à Reims, meurt à Paris [http://data.bnf.fr/ark:/12148/cb13006651k#foaf:Person]
</ud>
<ud>
Christophorus Clavius (1537) Jésuite, musicien et professeur de mathématiques. - Fut chargé par Grégoire XIII de la réforme du calendrier [http://data.bnf.fr/ark:/12148/cb125466080#foaf:Person]
</ud>
<ud>
Francesco Barozzi (Heraklion, Grèce, 1537) Mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb10462395x#foaf:Person]
</ud>
<ud>
Giovanni Paolo Gallucci (Salò, Italie, 1538) Astronome. - Homme de lettres [http://data.bnf.fr/ark:/12148/cb106019703#foaf:Person]
</ud>
<ud>
Philips Mor (1539) Humaniste, mathématicien et poète néolatin. - Chanoine du chapitre de St Salvator d''Utrecht. - Fils du peintre Anthonis Mor van Dashorst (Antonio Moro) [http://data.bnf.fr/ark:/12148/cb12384177f#foaf:Person]
</ud>
<ud>
François Viète (Fontenay-le-Comte (Vendée), 1540) Mathématicien [http://data.bnf.fr/ark:/12148/cb120511976#foaf:Person]
</ud>
<ud>
Cormopede (1541) Mathématicien et astrologue. - Gentilhomme de la maison du Comte de Sterckenberg. - Date de naissance présumée d''après le "portrait de Cormopede à l''âge de 51 ans" figurant au F. A. 2 de l''"Almanach des almanachs pour l''an MDXCIII" [http://data.bnf.fr/ark:/12148/cb13491791f#foaf:Person]
</ud>
<ud>
Giovanni di Strasoldo (1544) Noble. - Homme d''arme. - Mathématicien. - Poète [http://data.bnf.fr/ark:/12148/cb15122132t#foaf:Person]
</ud>
<ud>
Guidobaldo Dal Monte (1545) Mathématicien et astronome. - Protégea Galilée et lui fit obtenir sa première chaire à Pise. - Né à Pesaro, meurt dans son chateau de Monte Baroccio [http://data.bnf.fr/ark:/12148/cb135173214#foaf:Person]
</ud>
<ud>
Renward Cysat (Lucerne (Suisse), 1545) Chancelier de la ville de Lucerne, Suisse. - Historien, dramaturge, pharmacien et naturaliste. - Père de : Cysat, Johann Baptist (1587-1653), mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb12748433g#foaf:Person]
</ud>
<ud>
Maurice Bressieu (1546) Mathématicien, philosophe et humaniste. - Titulaire de la chaire de mathématiques au Collège de France (1575-), orateur des rois de France à Rome (1586-), intendant de la Bibliothèque vaticane [http://data.bnf.fr/ark:/12148/cb13495175h#foaf:Person]
</ud>
<ud>
Tycho Brahe (Knudstrup (Suède), 1546) Astronome [http://data.bnf.fr/ark:/12148/cb11893749j#foaf:Person]
</ud>
<ud>
Muḥammad ibn al-Ḥusayan Bahāʼ al-Dīn ʿĀmilī (1547) Érudit arabe, philosophe, théologien, astronome, grammairien, auteur d''anthologies [http://data.bnf.fr/ark:/12148/cb12451570z#foaf:Person]
</ud>
<ud>
Nicodemus Frischlin (Balingen, Allemagne, 1547) Philologue et écrivain. - A enseigné les belles-lettres et les mathématiques à l''Université de Tubingue. - Traducteur d''Aristophane, de Callimaque et de Tryphiodore. - Auteur d''une comédie, présentée devant l''empereur Rodolphe, qui lui décerna le titre de comte-palatin [http://data.bnf.fr/ark:/12148/cb12463064b#foaf:Person]
</ud>
<ud>
Michele Zappulo (1548) Docteur en droit canon et civil. - Astronome, historien et poète [http://data.bnf.fr/ark:/12148/cb125454264#foaf:Person]
</ud>
<ud>
Simon Stevin (Bruges, Belgique, 1548) Professeur de mathématiques de Maurice de Nassau [http://data.bnf.fr/ark:/12148/cb119941019#foaf:Person]
</ud>
<ud>
Michel Coignet (1549) Ingénieur, mathématicien, fabricant d''instruments de navigation, poète [http://data.bnf.fr/ark:/12148/cb124231863#foaf:Person]
</ud>
<ud>
Francisco Sánchez (1550) Médecin, philosophe, mathématicien et poète. - Également connu sous le pseudonyme d''El Escéptico [http://data.bnf.fr/ark:/12148/cb120172346#foaf:Person]
</ud>
<ud>
Giovanni Battista Crispo (Gallipoli, Italie, 1550) Prêtre. - Mathématicien, théologien et homme de lettres [http://data.bnf.fr/ark:/12148/cb10615268s#foaf:Person]
</ud>
<ud>
John Napier (1550) Mathématicien et théologien. - Baron de Merchiston [http://data.bnf.fr/ark:/12148/cb12353925j#foaf:Person]
</ud>
<ud>
Michael Moestlin (1550) Né à Göppingen (Wurtemberg). - Mathématicien. - Astronome. - Luthérien, hostile à la réforme grégorienne du calendrier [http://data.bnf.fr/ark:/12148/cb12330628m#foaf:Person]
</ud>
<ud>
Sigfridus Aronus Forsius (1550) Astronome et astrologue finlandais [http://data.bnf.fr/ark:/12148/cb131923734#foaf:Person]
</ud>
<ud>
Aegidius Martini (1551) Cartographe, mathématicien [http://data.bnf.fr/ark:/12148/cb15376579x#foaf:Person]
</ud>
<ud>
al-Silahî Nasuh (1551) Savant, miniaturiste et calligraphe ottoman. - A écrit plusieurs ouvrages sur les armes et les combats, sur la géométrie et les mathématiques ainsi que sur l''histoire. - Inventeur du jeu de "matraque", il est mieux connu sous son surnom "Matrakçı" : "Matrakçı Nasuh Efendi", "Nasuh al-Silahî", "Matraki", "Nasuh el-Mitraki", "Nasuh üs-Silahi", "Matraqçi Nasuh", "Nasuh b. Abdullah" et "Nasuh b. Karagöz el-Bosnevi" sont parmi les autres formes de référence [http://data.bnf.fr/ark:/12148/cb119562090#foaf:Person]
</ud>
<ud>
Anthoine Cathalan (1551) Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb14526861v#foaf:Person]
</ud>
<ud>
Bartolomeo Crescenzio (1551) Mathématicien, ingénieur naval et voyageur. - Fut capitaine de galère de la marine pontificale [http://data.bnf.fr/ark:/12148/cb125466487#foaf:Person]
</ud>
<ud>
Bernardo Gamucci (San Gimignano, Italie, 1551) Archéologue, architecte et mathématicien [http://data.bnf.fr/ark:/12148/cb10435220v#foaf:Person]
</ud>
<ud>
Camillo Agrippa (1551) Philosophe, mathématicien, architecte et ingénieur. - Est aussi l''auteur de l''un des premiers traité d''escrime [http://data.bnf.fr/ark:/12148/cb12536260s#foaf:Person]
</ud>
<ud>
Claude de Boissière (1551) Mathématicien. - Auteur d''un "Art poétique" [http://data.bnf.fr/ark:/12148/cb12509709h#foaf:Person]
</ud>
<ud>
Didier Henrion (1551) Professeur de mathématiques à Paris. - Ingénieur au service des Provinces-Unies. - N''est pas un pseudonyme de Clément Cyriaque de Mangin [http://data.bnf.fr/ark:/12148/cb144882445#foaf:Person]
</ud>
<ud>
Eilhard Lubbin (1551) Cartographe et mathématicien à Rostock [http://data.bnf.fr/ark:/12148/cb153777849#foaf:Person]
</ud>
<ud>
Faustus Verantius (Sebenico aujord''hui Šibenik (Croatie), 1551) Lexicographe, physicien et mathématicien. - Évêque de Czanad (Hongrie) (1594) et de la République de Venise. - Neveu d''Antun Vrančić (1504-1573) [http://data.bnf.fr/ark:/12148/cb10703670x#foaf:Person]
</ud>
<ud>
Francesco Feliciano (1551) Mathématicien, augustinien et miniaturiste [http://data.bnf.fr/ark:/12148/cb13485419n#foaf:Person]
</ud>
<ud>
Francis Van Schoten (1551) Professeur de mathématiques à Leyde, cartographe [http://data.bnf.fr/ark:/12148/cb15337130w#foaf:Person]
</ud>
<ud>
Francisco Zarzoso (Cella, Espagne, 1551) Astronome [http://data.bnf.fr/ark:/12148/cb119512329#foaf:Person]
</ud>
<ud>
Giacomo Lanteri (Paratico, Italie, 1551) Mathématicien et ingénieur [http://data.bnf.fr/ark:/12148/cb104024969#foaf:Person]
</ud>
<ud>
Girolamo Mercurio (1551) Dominicain. - Médecin, professeur de logique et de mathématique [http://data.bnf.fr/ark:/12148/cb13484092c#foaf:Person]
</ud>
<ud>
Giuseppe Unicorno (1551) Mathématicien. - Philosophe. - Astrologue. - Musicologue. - Théologien. - Originaire de Bergame [http://data.bnf.fr/ark:/12148/cb125394931#foaf:Person]
</ud>
<ud>
Helisaeus Röslin (1551) Mathématicien. - Astronome. - Médecin (pratiquait à Strasbourg et Francfort) [http://data.bnf.fr/ark:/12148/cb132003253#foaf:Person]
</ud>
<ud>
Jacques Besson (Colombières (Italie), 1551) Ingénieur et mathématicien. - Né à Colombières, vallée d''Oulx (aujourd''hui en Italie), d''après Eugénie Droz [http://data.bnf.fr/ark:/12148/cb12376654f#foaf:Person]
</ud>
<ud>
Jacques Maretz (1551) Dessinateur et graveur, mathématicien [http://data.bnf.fr/ark:/12148/cb153705873#foaf:Person]
</ud>
<ud>
Jamet Mettayer (1551) Autre(s) graphie(s) : Metayer ; Messor ; Metayerus ; Mettayier. - Variante(s) de prénom : Jean ; Jean Jamet. - Imprimeur-libraire ; imprimeur du Roi pour les mathématiques (1580) et imprimeur ordinaire du Roi (1583-1605). - En 1588, le roi Henri III le fait imprimeur officiel de sa congrégation des pénitents de l''Annonciation. De 1588 à 1594, il suit le Roi et la Cour à Blois puis  à Tours. - De retour à Paris, doit partager sa charge avec Pierre L''Huillier et Fédéric II Morel en vertu de l''arrêt du Conseil du 20 avril 1594. Revend à Tours son atelier et sa boutique à l''imprimeur Maurice Bouguereau. En mars  1596, le Roi l''associe à la Compagnie des usages avec Pierre L''Huillier. Décédé avant le 12 fév. 1605. Des publications paraissent encore sous son nom jusqu''en 1614. - A travaillé en association avec Mathurin Challenge (1573) et Barthélemy Gomet à Blois. S''associe à Tours (oct. 1591 - oct. 1593) avec Jean Richer, Claude de Monstr''oeil, Sébastien Molin, Mathieu I Guillemot, Georges Drobet et Marc Orry, son gendre. Travaille en association étroite avec Pierre L''Huillier et avec son fils Pierre Mettayer qui se trouvaient eux aussi à Tours [http://data.bnf.fr/ark:/12148/cb125031934#foaf:Person]
</ud>
<ud>
Jean Brohon (1551) Médecin, botaniste et astronome. - Fut recteur de l''Université de Caen [http://data.bnf.fr/ark:/12148/cb12545367f#foaf:Person]
</ud>
<ud>
Jean de Seville (1551) Mathématicien et hydrographe [http://data.bnf.fr/ark:/12148/cb13496046w#foaf:Person]
</ud>
<ud>
Jean Maria Coloni (1551) Citoyen de Romans en Dauphiné. - Mathématicien et astrologue [http://data.bnf.fr/ark:/12148/cb13479237s#foaf:Person]
</ud>
<ud>
Jean Tagaut (1551) Poète. - Médecin, mathématicien, professeur à Lausanne et Genève [http://data.bnf.fr/ark:/12148/cb12249180j#foaf:Person]
</ud>
<ud>
Joannes Portantius (1551) Astronome, mathématicien et géographe à Anvers, édité par Ortelius et De Jode [http://data.bnf.fr/ark:/12148/cb153817246#foaf:Person]
</ud>
<ud>
Johann Georg Locher (1551) Mathématicien [http://data.bnf.fr/ark:/12148/cb13006978f#foaf:Person]
</ud>
<ud>
Juan de Rojas Sarmiento (Palencia, Espagne, 1551) Mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb140653109#foaf:Person]
</ud>
<ud>
Marc Duncan (1551) Médecin, originaire d''Écosse, s''établit à Saumur en 1606 à l''appel de l''Académie protestante de la ville. - Professeur de mathématiques, de grec et d''humanités [http://data.bnf.fr/ark:/12148/cb13006401g#foaf:Person]
</ud>
<ud>
Martin Basanier (1551) Mathématicien, musicien [http://data.bnf.fr/ark:/12148/cb12510914p#foaf:Person]
</ud>
<ud>
Martinus Hortensius (1551) Astronome [http://data.bnf.fr/ark:/12148/cb13007384z#foaf:Person]
</ud>
<ud>
Nicolaus Reimarus Ursus (1551) Mathématicien. - Astronome [http://data.bnf.fr/ark:/12148/cb145753184#foaf:Person]
</ud>
<ud>
Paschasius Hamellius (1551) Mathématicien [http://data.bnf.fr/ark:/12148/cb13173242d#foaf:Person]
</ud>
<ud>
Paul Yvon (1551) Mathématicien. - Achète la seigneurie de Laleu en 1592 et y fait construire le château. - Maire de La Rochelle en 1616. - S'' installe à Paris en décembre 1633 et abjure le protestantisme [http://data.bnf.fr/ark:/12148/cb12135021d#foaf:Person]
</ud>
<ud>
Peter Laicksteen (1551) Cartographe et astronome [http://data.bnf.fr/ark:/12148/cb15370391s#foaf:Person]
</ud>
<ud>
Phillebert Charpentier (1551) Éditeur. - Marchand d''estampes et d''instruments de mathématiques [http://data.bnf.fr/ark:/12148/cb16553551w#foaf:Person]
</ud>
<ud>
Pierre Forcadel (1551) Mathématicien [http://data.bnf.fr/ark:/12148/cb103947442#foaf:Person]
</ud>
<ud>
Pierre Hérigone (1551) Professeur de mathématiques à Paris. - N''est pas un pseudonyme de Clément Cyriaque de Mangin [http://data.bnf.fr/ark:/12148/cb144882503#foaf:Person]
</ud>
<ud>
Pierre Le Voirier (1551) Autre(s) graphie(s) : Le Voirrier ; Le Verrier. - Imprimeur du Roi pour les mathématiques. - Beau-père de Mathieu I Guillemot (1584). Encore en activité le 31 déc. 1589. Décédé entre 1591 et le 7 nov. 1594 (compte de succession) [http://data.bnf.fr/ark:/12148/cb12230743m#foaf:Person]
</ud>
<ud>
Teodato Osio (1551) Mathématicien. - Musicien [http://data.bnf.fr/ark:/12148/cb125559272#foaf:Person]
</ud>
<ud>
Walther Hermann Ryff (1551) Apothicaire, médecin, mathématicien et architecte [http://data.bnf.fr/ark:/12148/cb11948264d#foaf:Person]
</ud>
<ud>
William Welwod (1551) Mathématicien. - Professeur de droit [http://data.bnf.fr/ark:/12148/cb125630488#foaf:Person]
</ud>
<ud>
Jost Bürgi (1552) Horloger, astronome et mathématicien suisse [http://data.bnf.fr/ark:/12148/cb123814270#foaf:Person]
</ud>
<ud>
Bernardino Baldi (Urbino, Italie, 1553) Abbé de Guastalla. - Poète, prosateur, mathématicien et historien. - Polyglotte, connaissait le grec et le latin, l''hébreu, l''arabe, le persan et le hongrois [http://data.bnf.fr/ark:/12148/cb12179488k#foaf:Person]
</ud>
<ud>
Jacob Christmann (1554) Orientaliste, mathématicien et astronome. - A été le premier à utiliser le télescope avec d''autres instruments comme le sextant [http://data.bnf.fr/ark:/12148/cb12560133s#foaf:Person]
</ud>
<ud>
Giovanni Antonio Magini (Padoue, Italie, 1555) Astronome, mathématicien et géographe. - A occupé la chaire d''astronomie à l''Université de Bologne en 1588. - Auteur prétendu de prédictions et de nombreux almanachs publiés en France, en Allemagne et aux Pays-Bas jusqu''au 19e siècle [http://data.bnf.fr/ark:/12148/cb12162475b#foaf:Person]
</ud>
<ud>
Jean Du Temps (1555) Fils de l''avocat Jean Du Temps I, il fut lui-même avocat et avait des connaissances en astrologie et mathématique. Frère d''Adam Du Temps, spécialiste des fortifications qui participa peut-être à la carte du Blésois dont il est l''auteur [http://data.bnf.fr/ark:/12148/cb15302460t#foaf:Person]
</ud>
<ud>
Sethus Calvisius (1556) Organiste, compositeur et théoricien de la musique ; astronome ; historien ; libraire et éditeur de musique. - Natif de Gorsleben près de Sachsenburg (Thuringe) et issu d''une famille paysanne. Après des études aux universités de Leipzig et Helmstedt, il devient à partir de 1581 et jusqu''à sa mort "cantor" de plusieurs églises de Leipzig successivement. Auteur de plusieurs ouvrages théoriques et compositions musicales, ainsi que d''un "Opus chronologicum" (1605 ; au moins 6 rééd.) et d''un "Elenchus calendarii Gregoriani" (1612). Décédé à Leipzig en nov. 1615. À distinguer du pasteur et prédicateur de Quedlinburg Sethus Calvisius (ou : Seth Kal(l)witz) (1639-1698), parfois appelé à tort "Sethus Calvisius le fils" [http://data.bnf.fr/ark:/12148/cb12875550d#foaf:Person]
</ud>
<ud>
Guillaume de Nautonier (1557) Savant, mathématicien, astronome, d''origine protestante, géographe du roi Henri IV [http://data.bnf.fr/ark:/12148/cb12412403z#foaf:Person]
</ud>
<ud>
Christoph Meurer (1558) Professeur de mathématiques à Leipzig (1613). - Médecin [http://data.bnf.fr/ark:/12148/cb14333201g#foaf:Person]
</ud>
<ud>
Jean-Édouard Du Monin (1559) Mathématicien et spécialiste des langues anciennes. - Fut professeur à Paris, puis à Poitiers [http://data.bnf.fr/ark:/12148/cb12463074n#foaf:Person]
</ud>
<ud>
Thomas Hariot (Oxford, GB, 1560) Mathématicien et astronome. - Envoyé comme conseiller aux Amériques en 1585-86 [http://data.bnf.fr/ark:/12148/cb12215671c#foaf:Person]
</ud>
<ud>
Thomas Harriot (1560) Mathématicien, physicien et astronome anglais [http://data.bnf.fr/ark:/12148/cb124346111#foaf:Person]
</ud>
<ud>
Adrianus Romanus (Louvain, 1561) Médecin, mathématicien et voyageur. - Enseigna à Louvain et à Würzburg, fut mathématicien royal en Pologne [http://data.bnf.fr/ark:/12148/cb12459969s#foaf:Person]
</ud>
<ud>
Bartholomäus Pitiscus (1561) A aussi écrit en latin. - Prédicateur protestant à la cour de l''Électeur palatin. - Également auteur d''ouvrages mathématiques [http://data.bnf.fr/ark:/12148/cb121457326#foaf:Person]
</ud>
<ud>
Henry Briggs (1561) Mathématicien [http://data.bnf.fr/ark:/12148/cb12305061c#foaf:Person]
</ud>
<ud>
Jean Tarde (La Roque-Gageac (Dordogne), 1561) Mathématicien, historien, géographe et astronome. - Chanoine [http://data.bnf.fr/ark:/12148/cb12641353z#foaf:Person]
</ud>
<ud>
Jean Tarde (1561) Chanoine de Sarlat, mathématicien et cartographe [http://data.bnf.fr/ark:/12148/cb153143878#foaf:Person]
</ud>
<ud>
P. Christoph Grienberger (1561) Jésuite, mathématicien, astronome et architecte. Il a realisé les plans du Collège d''Aurillac et du Charleville [http://data.bnf.fr/ark:/12148/cb10686921r#foaf:Person]
</ud>
<ud>
Philippus Lansbergen (Gand (Belgique), 1561) Mathématicien, astronome et pasteur [http://data.bnf.fr/ark:/12148/cb130073828#foaf:Person]
</ud>
<ud>
Christen Sørensen Longomontanus (1562) Astronome et mathématicien. - Fut l''élève de Tycho-Brahé. - Professeur de hautes mathématiques à l''Université de Copenhague [http://data.bnf.fr/ark:/12148/cb13011001c#foaf:Person]
</ud>
<ud>
Guangqi Xu (Shanghai, 1562) Haut fonctionnaire chinois, initié et converti au christianisme par le père jésuite Matteo Ricci. - Mathématicien. - Astronome. - Disciple de Matteo Ricci [http://data.bnf.fr/ark:/12148/cb150892932#foaf:Person]
</ud>
<ud>
Galileo Galilei (Pise, Italie, 1564) Physicien, philosophe, astronome [http://data.bnf.fr/ark:/12148/cb11903931b#foaf:Person]
</ud>
<ud>
Luis Teixeira (1564) Jésuite portugais, mathématicien et cartographe actif de 1564 à 1613 [http://data.bnf.fr/ark:/12148/cb153361957#foaf:Person]
</ud>
<ud>
Edward Brerewood (1565) Antiquaire et mathématicien, linguiste et humaniste. - Professeur d''astronomie au Gresham college de Londres [http://data.bnf.fr/ark:/12148/cb125109678#foaf:Person]
</ud>
<ud>
Eilhard Lubin (1565) Humaniste, philologue, cartographe, théologien et mathématicien [http://data.bnf.fr/ark:/12148/cb15040859j#foaf:Person]
</ud>
<ud>
Paolo Antonio Foscarini (Montalto Uffugo, Italie, 1565) Carme. - Théologien. - Mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb12377530d#foaf:Person]
</ud>
<ud>
Scipione Chiaramonti (Cesena, Italie, 1565) Astronome et philosophe. - Professeur de philosophie à l''Université de Pise [http://data.bnf.fr/ark:/12148/cb10545041n#foaf:Person]
</ud>
<ud>
Fr. François d'' Aguillon (1566) Jésuite, architecte et mathématicien. Auteur d''un projet pour le noviciat de Tournai. Préposé de la Maison professe, professeur d''Anvers [http://data.bnf.fr/ark:/12148/cb16240952w#foaf:Person]
</ud>
<ud>
Georg Ludwig Frobenius (1566) Libraire. - Natif d''Iphofen, près de Wurzbourg. Titulaire d''une maîtrise de théologie. Après des études aux universités de Tübingen et Wittenberg, travaille avec l''astronome Tycho Brahe jusqu''à la mort de celui-ci. Reçu ensuite bourgeois de Hambourg, où il s''établit libraire [http://data.bnf.fr/ark:/12148/cb12229506t#foaf:Person]
</ud>
<ud>
Marco Antonio De Dominis (l''île de Rab (Croatie), 1566) Professeur de rhétorique, mathématiques et philosophie dans la Compagnie de Jésus, à Padoue et Brescia. - Evêque de Segna (Senj ou Zengg en Croatie) de 1600 à 1602; de Spalato (Split) de 1602 à 1615. - Gagné au protestantisme et exilé en Angleterre, doyen de Windsor. - Abjure et rentre en grâce (1622) [http://data.bnf.fr/ark:/12148/cb121335726#foaf:Person]
</ud>
<ud>
Marinus Ghetaldus (Raguse aujourd''hui Dubrovnik (Croatie), 1566) Mathématicien et physicien. - Il exerça une grande influence sur le développement de l''application de l''algèbre à la géométrie. - Il mit au point le miroir parabolique, aujourd''hui conservé au National Maritime Museum de Londres. - Il collabora, entre autres, avec François Viète en France et avec Galilée en Italie [http://data.bnf.fr/ark:/12148/cb146476018#foaf:Person]
</ud>
<ud>
François de Aguilón (1567) Architecte et mathématicien belge d''origine espagnole [http://data.bnf.fr/ark:/12148/cb119998212#foaf:Person]
</ud>
<ud>
Johann Hartmann (1568) Mathématicien et naturaliste. - Professeur de chimie à l''Université de Marburg [http://data.bnf.fr/ark:/12148/cb13009199x#foaf:Person]
</ud>
<ud>
P. Jacques de Guernisac (1568) Jésuite et architecte, professeur de mathématique à Pont-à-Mousson puis à La Flèche, recteur du collège des Jésuites de Quimper [http://data.bnf.fr/ark:/12148/cb16215104d#foaf:Person]
</ud>
<ud>
Mutio Oddi (1569) Mathématicien. - Architecte [http://data.bnf.fr/ark:/12148/cb165299645#foaf:Person]
</ud>
<ud>
Andrea Argoli (1570) Mathématicien. - Astronome. - Professeur de mathématique à l''Université de Padoue [http://data.bnf.fr/ark:/12148/cb121593328#foaf:Person]
</ud>
<ud>
Erasmus Schmied (1570) Né à Delitzsch, près de Leipzig. - Professeur de grec et de mathématiques à Wittenberg [http://data.bnf.fr/ark:/12148/cb12045847b#foaf:Person]
</ud>
<ud>
Anders Bure (1571) Cartographe et mathématicien [http://data.bnf.fr/ark:/12148/cb14509982d#foaf:Person]
</ud>
<ud>
Giovanni Branca (1571) Architecte, ingénieur et mathématicien. - Né à Pesaro, meurt à Pérouse [http://data.bnf.fr/ark:/12148/cb121826472#foaf:Person]
</ud>
<ud>
Johannes Isaacus Pontanus (Elseneur (Danemark), 1571) Historien. - Philologue. - Professeur de mathématiques et de physique [http://data.bnf.fr/ark:/12148/cb123875836#foaf:Person]
</ud>
<ud>
Johannes Kepler (1571) Astronome et mathématicien [http://data.bnf.fr/ark:/12148/cb11909597m#foaf:Person]
</ud>
<ud>
Willem Jansz Blaeu (1571) Autre(s) graphie(s) : Janssonius Blaeuw. - Imprimeur-libraire et éditeur de cartes et d''atlas. - Originaire d''Alkmaar ou des environs. Passe 2 ans auprès de Tycho Brahé au Danemark. À son retour à Amsterdam en 1596, s''établit cartographe et fabricant de globes terrestres et célestes. Monte ensuite une imprimerie et une fonderie. Également auteur d''ouvrages cartographiques et astronomiques [http://data.bnf.fr/ark:/12148/cb12169772t#foaf:Person]
</ud>
<ud>
Cornelius Drebbel (1572) Graveur. - Mathématicien. - Physicien. - Chimiste [http://data.bnf.fr/ark:/12148/cb12382467g#foaf:Person]
</ud>
<ud>
Rodolphus Goclenius (1572) Docteur en médecine en 1601. - Professeur de physique en 1608. - Professeur de mathématiques à l''Université de Marbourg en 1621 [http://data.bnf.fr/ark:/12148/cb121595722#foaf:Person]
</ud>
<ud>
Samuel Marolois (1572) Mathématicien français ayant vécu une grande partie de sa vie aux Pays-Bas [http://data.bnf.fr/ark:/12148/cb14912871p#foaf:Person]
</ud>
<ud>
Thomas Lydyat (Okerton, GB, 1572) Mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb12390032f#foaf:Person]
</ud>
<ud>
Christoph Scheiner (1575) Jésuite. - Physicien, mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb13483688j#foaf:Person]
</ud>
<ud>
Michelangelo Galilei (1575) Luthiste et compositeur italien de la Renaissance. - Fils du compositeur et théoricien Vincenzo Galilei, et frère de l''astronome Galileo Galilei [http://data.bnf.fr/ark:/12148/cb140013401#foaf:Person]
</ud>
<ud>
Octavio Pisani (Naples, Italie, 1575) Cosmographe et astronome, travaille à Anvers de 1612 à 1637 [http://data.bnf.fr/ark:/12148/cb15404394h#foaf:Person]
</ud>
<ud>
Francesco Ingoli (Ravenne (Italie), 1578) Secrétaire de la propagande, débat avec Copernic (en 1616 et 1624) et écrit Relazione delle quattro parti del mondo avec pour objectif de soutenir missions et propagande religieuses. - Étudie l''astronomie, la cosmographie et la géographie et connait le grec, le français, l''espagnon et l''arabe. - Diplômé en droit civil et en droit canon à l''Université de Padoue, Italie [http://data.bnf.fr/ark:/12148/cb13749501h#foaf:Person]
</ud>
<ud>
Sybrandt Hansz. Cardinael (Harlingen (Pays-Bas), 1578) Mathématicien [http://data.bnf.fr/ark:/12148/cb15944052f#foaf:Person]
</ud>
<ud>
Cristóvão Ferreira (1580) Supérieur et procurateur de la mission jésuite au Japon, il abjura en 1633 et se convertit au zen. - Auteur en 1636 de la "Supercherie dévoilée". - Traducteur d''ouvrages d''astronomie et de chirurgie [http://data.bnf.fr/ark:/12148/cb13524212c#foaf:Person]
</ud>
<ud>
Godfried Wendelen (1580) Astronome et géomètre. - Avocat au Parlement de Paris puis doyen du chapitre de Rothnac, Belgique [http://data.bnf.fr/ark:/12148/cb123969373#foaf:Person]
</ud>
<ud>
Joannes Michael Gigas (1580) Docteur, mathématicien et géographe édité par Blaeu et Hondius [http://data.bnf.fr/ark:/12148/cb153239798#foaf:Person]
</ud>
<ud>
Johann Faulhaber (1580) Mathématicien allemand. S''est aussi intéressé à l''ingénierie des fortifications [http://data.bnf.fr/ark:/12148/cb137778453#foaf:Person]
</ud>
<ud>
Nicolas-Claude Fabri Peiresc (Belgentier (Var), 1580) Conseiller au Parlement de Provence. - Astronome, archéologue et naturaliste [http://data.bnf.fr/ark:/12148/cb11918940q#foaf:Person]
</ud>
<ud>
Willebrordus Snellius (Leyde, Pays-Bas, 1580) Mathématicien, astronome et géographe [http://data.bnf.fr/ark:/12148/cb15336105f#foaf:Person]
</ud>
<ud>
Claude-Gaspard Bachet (Bourg-en-Bresse (Ain), 1581) Mathématicien et littérateur. - Sieur de Méziriac. - Érudit, auteur de poèmes en français, italien et latin. - Membre de l''Académie française (élu en 1634) [http://data.bnf.fr/ark:/12148/cb120028244#foaf:Person]
</ud>
<ud>
Alexandre Anderson (1582) Mathématicien [http://data.bnf.fr/ark:/12148/cb16296598k#foaf:Person]
</ud>
<ud>
Jean François (1582) Nom en religion de Jean Charnage. - Jésuite. - Professeur de philosophie et de mathématiques à La Flèche [http://data.bnf.fr/ark:/12148/cb121629197#foaf:Person]
</ud>
<ud>
Mario Bettini (Bologne, Italie, 1582) Jésuite. - Philosophe et mathématicien [http://data.bnf.fr/ark:/12148/cb12545452p#foaf:Person]
</ud>
<ud>
Matthias Bernegger (Hallstatt (Autriche), 1582) Philologue, historien, mathématicien et astronome. - Protestant. - Professeur d''histoire et d''éloquence à Strasbourg, recteur de l''Université de cette même ville [http://data.bnf.fr/ark:/12148/cb129928534#foaf:Person]
</ud>
<ud>
Jean-Baptiste Morin (Villefranche-sur-Saône (Rhône), 1583) Astronome et mathématicien [http://data.bnf.fr/ark:/12148/cb11916881j#foaf:Person]
</ud>
<ud>
Orazio Grassi (Savone, Italie, 1583) Jésuite. - Mathématicien, astronome et architecte [http://data.bnf.fr/ark:/12148/cb125377863#foaf:Person]
</ud>
<ud>
Filippo Finella (Naples, Italie, 1584) Astrologue. - Astronome. - Auteur dramatique [http://data.bnf.fr/ark:/12148/cb122006609#foaf:Person]
</ud>
<ud>
Grégoire de Saint-Vincent (1584) Mathématicien. - Astronome [http://data.bnf.fr/ark:/12148/cb16197665z#foaf:Person]
</ud>
<ud>
James Hume (1584) Mathématicien. - Astronome. - Historien. - Hébraïsant. - Actif en 1639. - A vécu à Paris. - Fils de David Hume (1558-163.) et frère aîné de la poétesse et traductrice Anna Hume (1586?-16..) [http://data.bnf.fr/ark:/12148/cb12072629r#foaf:Person]
</ud>
<ud>
Claude Mydorge (1585) Mathématicien et physicien [http://data.bnf.fr/ark:/12148/cb144888873#foaf:Person]
</ud>
<ud>
Mario Guiducci (Florence, Italie, 1585) Homme de lettres et astronome. - A collaboré avec Galileo Galilei [http://data.bnf.fr/ark:/12148/cb144609004#foaf:Person]
</ud>
<ud>
Melchior Inchofer (Vienne, 1585) Jésuite. - Philosophe, mathématicien et théologien professeur à Messine, Italie [http://data.bnf.fr/ark:/12148/cb10735485h#foaf:Person]
</ud>
<ud>
Philipp Müller (1585) Mathématicien, médecin, chimiste et botaniste. - Professeur à l''université de Leipzig [http://data.bnf.fr/ark:/12148/cb14065362j#foaf:Person]
</ud>
<ud>
Jean L''Hoste (Nancy, 1586) Ingénieur. - Intendant des fortifications du duc de Lorraine. - Professeur de droit et de mathématiques à Pont-à-Mousson [http://data.bnf.fr/ark:/12148/cb16628764j#foaf:Person]
</ud>
<ud>
Niccolò Zucchi (Parme, Italie, 1586) Jésuite. - Recteur du Collegio romano (1646-1649). - Astronome [http://data.bnf.fr/ark:/12148/cb10077816w#foaf:Person]
</ud>
<ud>
Benedetto Castelli (Brescia, Italie, 1587) Dominicain. - Mathématicien, inventeur et écrivain. - Disciple de Galilée, dont il défendit les théories astronomiques [http://data.bnf.fr/ark:/12148/cb12545385c#foaf:Person]
</ud>
<ud>
Joachim Jungius (1587) Naturaliste, mathématicien et philosophe [http://data.bnf.fr/ark:/12148/cb120247195#foaf:Person]
</ud>
<ud>
Libert Froidmont (Liège, 1587) Théologien. - Mathématicien, physicien et géologue [http://data.bnf.fr/ark:/12148/cb14462868z#foaf:Person]
</ud>
<ud>
François Derand (1588) Jésuite. - Professeur de grammaire et de mathématiques. - Architecte. - Né à Vic s/Seille (Moselle), mort à Agde (Hérault) [http://data.bnf.fr/ark:/12148/cb13012148j#foaf:Person]
</ud>
<ud>
Jacques Grandami (1588) Jésuite. - Professeur de belles lettres, de philosophie et de théologie, puis recteur de Bourges, Rennes, La Flèche, Tours et Rouen. - Visiteur de la province de France. - Astronome [http://data.bnf.fr/ark:/12148/cb12155155d#foaf:Person]
</ud>
<ud>
Marin Mersenne (1588) Philosophe et savant, astronome, mathématicien. - Théoricien de la musique. - Minime [http://data.bnf.fr/ark:/12148/cb119157157#foaf:Person]
</ud>
<ud>
Eberhard Welper (1590) Imprimeur-libraire. - Natif de Lohra (comté de Lohenstein, près de Marburg, Allemagne). Mathématicien, astrologue et astronome, il se fixe à Strasbourg en 1618. Établi libraire en 1620 puis imprimeur dès 1621. Publie notamment chaque année un almanach et des prédictions. Auteur de plusieurs ouvrages scientifiques, dont des "Elementa geometrica..." (1re éd., 1620), une "Gnomonica" (1625), un "Compendium astronomiae..." (1634) et un traité de la divination, "Rota-Fortunae, oder Glück-Rad..." (s. d., plusieurs rééd.). De 1634 à 1639, assure des fonctions d''enseignant au Gymnase (lycée) de Strasbourg. En 1654, sollicite en vain la charge d''imprimeur de l''évêché de Saverne. De 1653 à 1661, imprime sous le pseudonyme de Hartmann Bär quelques ouvrages pour l''académie des Jésuites à Molsheim. Son fils aîné Johann Welper (1642-1720) lui succède en 1664, mais des éditions paraissent encore sous son nom en 1689. Son autre fils Eberhard (II) Welper (1644-1670) sera lui aussi mathématicien, astrologue et astronome [http://data.bnf.fr/ark:/12148/cb158750586#foaf:Person]
</ud>
<ud>
Johannes Wilhelm Lauremberg (1590) Auteur, mathématicien et historien à Rostock [http://data.bnf.fr/ark:/12148/cb15377794m#foaf:Person]
</ud>
<ud>
Jean Leurechon (Bar-le-Duc, 1591) Jésuite. - Professeur de philosophie et de mathématiques, à Pont-à-Mousson notamment. - Confesseur du duc de Lorraine Charles IV. - Henry Van Etten, qui signe la dédicace de la première édition des "Récréations mathématiques" n''est pas un pseudonyme de Jean Leurechon, mais le nom d''un de ses élèves, qui aurait réellement existé d''après Trevor H. Hall [http://data.bnf.fr/ark:/12148/cb13009618g#foaf:Person]
</ud>
<ud>
Joseph Salomon Delmedigo (1591) Médecin. - Astronome. - Mathématicien. - Né en Crète. - Fils d''Eliya Delmedigo (1460-1497) [http://data.bnf.fr/ark:/12148/cb122623548#foaf:Person]
</ud>
<ud>
Giovanni Battista Vertova (Bergame, Italie, 1592) Mathématicien et ingénieur militaire. - Chevalier de l''Ordre de Malte [http://data.bnf.fr/ark:/12148/cb15093021d#foaf:Person]
</ud>
<ud>
Johann Adam Schall von Bell (1592) Jésuite. - Missionnaire en Chine (de 1619 à sa mort). - Mathématicien. - Conseiller et astronome de la Cour impériale de Chine [http://data.bnf.fr/ark:/12148/cb12362941r#foaf:Person]
</ud>
<ud>
Pierre Gassendi (Champtercier, près de Digne, 1592) Philosophe, astronome, mathématicien, physicien, docteur en théologie et théoricien de la musique. - Entre dans les ordres en 1615 [http://data.bnf.fr/ark:/12148/cb120250393#foaf:Person]
</ud>
<ud>
Wilhelm Schickard (Herrenberg, Allemagne, 1592) Mathématicien, astronome, professeur d''agriculture [http://data.bnf.fr/ark:/12148/cb11969696s#foaf:Person]
</ud>
<ud>
Albert Girard (Saint-Mihiel, 1595) Mathématicien et ingénieur. - Ingénieur dans l''armée de Frédéric de Nassau, prince d''Orange [http://data.bnf.fr/ark:/12148/cb121123333#foaf:Person]
</ud>
<ud>
Pierre Bardin (Rouen, 1595) Homme de lettres, philosophe et mathématicien. - Précepteur. - Membre de l''Académie française (élu en 1634) [http://data.bnf.fr/ark:/12148/cb125272379#foaf:Person]
</ud>
<ud>
Pierre Bourdin (1595) Jésuite. - Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb123902440#foaf:Person]
</ud>
<ud>
Daniel Mögling (Böblingen, 1596) Alchimiste, rosicrucien, médecin et astronome [http://data.bnf.fr/ark:/12148/cb167575369#foaf:Person]
</ud>
<ud>
Jacob Golius (1596) Orientaliste. - Mathématicien. - Philologue, spécialiste des littératures [http://data.bnf.fr/ark:/12148/cb123338386#foaf:Person]
</ud>
<ud>
René Descartes (Descartes (Indre-et-Loire), 1596) Philosophe et mathématicien [http://data.bnf.fr/ark:/12148/cb11899775j#foaf:Person]
</ud>
<ud>
Giovanni Battista Hodierna (1597) Astronome italien [http://data.bnf.fr/ark:/12148/cb120704558#foaf:Person]
</ud>
<ud>
Bonaventura Cavalieri (Milan, Italie, 1598) Jésuite. - Mathématicien, géomètre et astronome, disciple de Galilée. - Fut professeur à l''Université de Bologne [http://data.bnf.fr/ark:/12148/cb12085151g#foaf:Person]
</ud>
<ud>
Giovanni Battista Riccioli (Ferrare, Italie, 1598) Jésuite. - Astronome. - Professeur de lettres, de philosophie et de théologie, à Parme puis à Bologne. - Mathématicien et historien de la géographie [http://data.bnf.fr/ark:/12148/cb12546680q#foaf:Person]
</ud>
<ud>
Pierre Petit (1598) Mathématicien et physicien. - Intendant général des ports et fortifications de France (1649) [http://data.bnf.fr/ark:/12148/cb123944733#foaf:Person]
</ud>
<ud>
Adam Olearius (Aschersleben, Allemagne, 1599) Voyageur, en particulier en Russie et en Perse. - Mathématicien [http://data.bnf.fr/ark:/12148/cb12817277v#foaf:Person]
</ud>
<ud>
Jacob Aertsz Colom (1599) Mathématicien, navigateur et cartographe. - Imprimeur à Amsterdam [http://data.bnf.fr/ark:/12148/cb153358650#foaf:Person]
</ud>
<ud>
Adriaan Vlacq (1600) Autre(s) graphie(s) : Ulack ; Vlac. - Variante(s) de prénom : Adriaen ; Adrien. - Imprimeur-libraire. - Originaire de Gouda. Édite différents périodiques dont "De Haegsche Vrijdaeghse Post-Tijdingen". A publié en 1659 une contrefaçon de Johannes Elzevier et de Pieter Leffen. A également publié sous les fausses adresses et pseudonymes de "Cologne, Pierre Du Marteau" et "Amsterdam, Peter Le Grand". - Également mathématicien connu pour ses travaux sur les logarithmes et auteur d''ouvrages d''astronomie et de pamphlets en faveur des royalistes anglais en 1652-1655. Mort peu avant le 8 avril 1667. Des éd. paraissent encore sous son nom jusqu''en 1669, en association avec Johannes Vlacq [http://data.bnf.fr/ark:/12148/cb121635061#foaf:Person]
</ud>
<ud>
Antoine de Laloubère (1600) Jésuite. - Mathématicien et géomètre, fut le premier scientifique à étudier les propriétés de l''hélice. - Polémiqua avec Pascal, qui l''appelle "Allouerus" dans l''"Histoire de la roulette". - Professeur de rhétorique, de théologie et de mathématiques au collège de Toulouse. - Né à Rieux, meurt à Toulouse [http://data.bnf.fr/ark:/12148/cb13006798h#foaf:Person]
</ud>
<ud>
Giacomo Oddi (1600) Cartographe et mathématicien. Etudie à Naples [http://data.bnf.fr/ark:/12148/cb153917817#foaf:Person]
</ud>
<ud>
Jakob Bartsch (1600) Médecin. - Professeur de mathématiques à Strasbourg. - Astronome. - Gendre et collaborateur de l''astronome Johann Kepler (1571-1630) [http://data.bnf.fr/ark:/12148/cb12163632v#foaf:Person]
</ud>
<ud>
Emmanuel Maignan (1601) Religieux minime. - Philosophe, mathématicien et peintre. - Membre de la Société des lanternistes [http://data.bnf.fr/ark:/12148/cb130127157#foaf:Person]
</ud>
<ud>
Florimond de Beaune (1601) Mathématicien [http://data.bnf.fr/ark:/12148/cb11890827s#foaf:Person]
</ud>
<ud>
Ovidio Montalbani (1601) Docteur en philosophie et médecine de l'' Université de Bologne, professeur de mathématiques, chargé du musée Aldrovandi à partir de 1657, fut aussi un citoyen actif de Bologne, où il assura plusieurs magistratures ("giudice del Foro de mercanti, e de tribuni della plebe"). - Membre de l''Accademia dei Gelati de Bologne ("l''Innestato"), de l''Accademia degli Indomiti de Bologne ("lo Stellato"), et de l''Accademia della Notte de Bologne ("il Rugiadoso") [http://data.bnf.fr/ark:/12148/cb12064289s#foaf:Person]
</ud>
<ud>
Pierre de Fermat (Beaumont-de-Lomagne (Tarn-et-Garonne), 1601) Mathématicien, célèbre pour son théorème. - On lui doit aussi le Principe de Fermat en optique. - Conseiller au Parlement de Toulouse et commissaire en la chambre des requêtes du Palais à Toulouse (mai 1631) [http://data.bnf.fr/ark:/12148/cb11902568b#foaf:Person]
</ud>
<ud>
Athanasius Kircher (Geisa (Allemagne), 1602) Jésuite. - Professeur de physique, de mathématiques et de langues orientales, Collegio Romano, Rome. - Dessinateur et graveur [http://data.bnf.fr/ark:/12148/cb119097824#foaf:Person]
</ud>
<ud>
Gilles Personne de Roberval (Roberval, Oise, 1602) Professeur de philosophie (1634) et de mathématiques (1655) au Collège royal, Paris. - Membre fondateur de l''Académie royale des sciences [http://data.bnf.fr/ark:/12148/cb12144923j#foaf:Person]
</ud>
<ud>
Jacques de Billy (1602) Jésuite (à partir de 1619). - Mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb123773436#foaf:Person]
</ud>
<ud>
John Greaves (Colemore, GB, 1602) Mathématicien. - Orientaliste. - Professeur d''astronomie à Londres puis à Oxford [http://data.bnf.fr/ark:/12148/cb129277690#foaf:Person]
</ud>
<ud>
Pierre Gautruche (1602) Jésuite. - Professeur de philosophie, de théologie et de mathématiques. - Identifié par certains à Pierre Gautier (1599-16..), luthiste et compositeur [http://data.bnf.fr/ark:/12148/cb121990328#foaf:Person]
</ud>
<ud>
Blaise-François de Pagan (Avignon, 1604) Ingénieur et astronome [http://data.bnf.fr/ark:/12148/cb12155087r#foaf:Person]
</ud>
<ud>
Claude Hardy (1604) Fils de Sébastien Hardy. - Conseiller au Châtelet. - Mathématicien. - Ami de Mydorge, Descartes et du Père Mersenne ; souvent cité dans la correspondance de ces deux derniers [http://data.bnf.fr/ark:/12148/cb12134536k#foaf:Person]
</ud>
<ud>
Bernard Frénicle de Bessy (1605) Mathématicien, géomètre et arithméticien. - Membre de l''Académie des Sciences. - Conseiller à la Cour des monnaies [http://data.bnf.fr/ark:/12148/cb12459881c#foaf:Person]
</ud>
<ud>
Ismaël Boulliau (Loudun (Vienne), 1605) Astronome. - Secrétaire de Jacques Du Puy et attaché au président de Thou [http://data.bnf.fr/ark:/12148/cb124621511#foaf:Person]
</ud>
<ud>
Juan de Caramuel y Lobkowitz (Madrid, 1606) Cistercien. - Evêque de Satriano et Campagna (1657-1673) puis de Vigevano (1673-). - Humaniste, théologien, mathématicien, philosophe et architecte. - Défenseur de la doctrine probabiliste [http://data.bnf.fr/ark:/12148/cb12392566m#foaf:Person]
</ud>
<ud>
Evangelista Torricelli (Faenza, Italie, 1608) Physicien et mathématicien [http://data.bnf.fr/ark:/12148/cb12117674q#foaf:Person]
</ud>
<ud>
Gaspar Schott (Königshaufen, Allemagne, 1608) Mathématicien et physicien. - Jésuite [http://data.bnf.fr/ark:/12148/cb12519717b#foaf:Person]
</ud>
<ud>
Giovanni Alfonso Borelli (Naples, Italie, 1608) Mathématicien, phycisien, médecin, philosophe. - Membre de l''Accademia del Cimento [http://data.bnf.fr/ark:/12148/cb12462534j#foaf:Person]
</ud>
<ud>
Giovan Battista Nicolosi (Paternò, Italie, 1610) Géographe et cartographe. - Professeur de mathématiques et de géographie à l''Université de Rome [http://data.bnf.fr/ark:/12148/cb15404103t#foaf:Person]
</ud>
<ud>
Józef Naronowicz-Naroński (1610) Mathématicien. - Cartographe. - Architecte au service de la famille Radzwill. - Né en Lituanie [http://data.bnf.fr/ark:/12148/cb150812338#foaf:Person]
</ud>
<ud>
Maria Cunitia (1610) Astronome [http://data.bnf.fr/ark:/12148/cb162514419#foaf:Person]
</ud>
<ud>
Jan Heweliusz (1611) Astronome [http://data.bnf.fr/ark:/12148/cb121054498#foaf:Person]
</ud>
<ud>
John Pell (1611) Mathématicien [http://data.bnf.fr/ark:/12148/cb146515879#foaf:Person]
</ud>
<ud>
Michael Floris Van Langren (1612) Astronome et mathématicien du roi d''Espagne installé à Bruxelles [http://data.bnf.fr/ark:/12148/cb153283774#foaf:Person]
</ud>
<ud>
Francesco Maria Grimaldi (1613) Jésuite. - Philosophe, astronome, opticien et professeur de mathématiques. - Né et mort à Bologne [http://data.bnf.fr/ark:/12148/cb13326913s#foaf:Person]
</ud>
<ud>
François Chauveau (1613) Grava des cartouches notamment pour Nicolas Sanson. Eut un neveu du nom de François Chauveau. Son frère, Jean-Baptiste, habile ingénieur et mathématicien fut assassiné en 1670. [http://data.bnf.fr/ark:/12148/cb15302394v#foaf:Person]
</ud>
<ud>
Jean François Nicéron (Paris, 1613) Religieux de l''Ordre des minimes. - Mathématicien [http://data.bnf.fr/ark:/12148/cb14404933t#foaf:Person]
</ud>
<ud>
Tommaso Cornelio (Rovito, Italie, 1614) Médecin, philosophe et mathématicien [http://data.bnf.fr/ark:/12148/cb13484167f#foaf:Person]
</ud>
<ud>
Frans Van Schooten (1615) Mathématicien [http://data.bnf.fr/ark:/12148/cb12529949q#foaf:Person]
</ud>
<ud>
John Wallis (1616) Mathématicien [http://data.bnf.fr/ark:/12148/cb123396143#foaf:Person]
</ud>
<ud>
Jonas Moore (1617) Mathématicien britannique. - S''est intéressé aux mathématiques appliquées (astronomie, cosmographie, architecture...) [http://data.bnf.fr/ark:/12148/cb135104102#foaf:Person]
</ud>
<ud>
Tito Livio Burattini (Agordo, Italie, 1617) Mathématicien, cartographe et égyptologue [http://data.bnf.fr/ark:/12148/cb162142362#foaf:Person]
</ud>
<ud>
Anthelme (Chatenay-Vaudin (Haute-Marne), 1618) Religieux de la Chartreuse de Dijon. - Astronome [http://data.bnf.fr/ark:/12148/cb106267229#foaf:Person]
</ud>
<ud>
Charles Cavendish (1620) Mathématicien [http://data.bnf.fr/ark:/12148/cb14651592w#foaf:Person]
</ud>
<ud>
Jean Picard (La Flèche (Sarthe), 1620) Astronome. - Membre de l''Académie des sciences (1666) [http://data.bnf.fr/ark:/12148/cb11941359d#foaf:Person]
</ud>
<ud>
Claude-François Milliet de Chales (1621) Mathématicien. - Professeur d''hydrographie à Marseille [http://data.bnf.fr/ark:/12148/cb12397222c#foaf:Person]
</ud>
<ud>
Adrien Auzout (Rouen, 1622) Astronome, physicien et mathématicien. - A contribué au développement du micromètre [http://data.bnf.fr/ark:/12148/cb134752474#foaf:Person]
</ud>
<ud>
Jean Bertet (1622) Jésuite, quitte la Compagnie en 1681 pour entrer chez les Bénédictins. - Professeur de rhétorique, philosophie et mathématiques. - Poète [http://data.bnf.fr/ark:/12148/cb11999230c#foaf:Person]
</ud>
<ud>
René-François De Sluse (1622) Mathématicien. - Chanoine de la Cathédrale de Liège et abbé d''Amay [http://data.bnf.fr/ark:/12148/cb12427294z#foaf:Person]
</ud>
<ud>
Vincenzo Viviani (Florence, Italie, 1622) Florentin. - Mathématicien. - Membre de l'' "accademia della Crusca" [http://data.bnf.fr/ark:/12148/cb12000373g#foaf:Person]
</ud>
<ud>
Blaise Pascal (Clermont-Ferrand (Puy-de-Dôme), 1623) Mathématicien, physicien, écrivain. - Frère de : Pascal, Jacqueline (1625-1661) [http://data.bnf.fr/ark:/12148/cb11918679x#foaf:Person]
</ud>
<ud>
Ferdinand Verbiest (Pitthem, Belgique, 1623) Jésuite, missionnaire en Chine. - Astronome. - Fut placé à la tête du tribunal des mathématiques, chargé de la rédaction des éphémérides et de la direction des fonderies de canons. - A publié en langue chinoise, sous le nom de Nanhoai-jin, un grand nombre d''ouvrages scientifiques [http://data.bnf.fr/ark:/12148/cb12215344n#foaf:Person]
</ud>
<ud>
Camillo Guarino Guarini (Modène, Italie, 1624) Clerc régulier, théatin. - Architecte du duc de Savoie, philosophe et mathématicien [http://data.bnf.fr/ark:/12148/cb12348027r#foaf:Person]
</ud>
<ud>
Christoph Wittich (1625) Théologien. - Professeur de mathématiques et de théologie [http://data.bnf.fr/ark:/12148/cb13014027s#foaf:Person]
</ud>
<ud>
Erhard Weigel (1625) Philosophe. - Professeur de mathématiques, maître de Leibniz et de Pufendorf [http://data.bnf.fr/ark:/12148/cb11935908x#foaf:Person]
</ud>
<ud>
Jean-Dominique Cassini (Perinaldo (comté de Nice), 1625) Titulaire de la chaire d''astronomie de Bologne de 1650 à 1669, surintendant des eaux du Bolonais de 1657 à 1669, surintendant des eaux de l''Etat pontifical et titulaire d''autres charges auprès du pape. - Appelé en France an avril 1669 par Louis XIV. - Membre de l''Académie des sciences, directeur de l''Observatoire de Paris (à partir de 1672). - Naturalisé français en 1673 [http://data.bnf.fr/ark:/12148/cb121019904#foaf:Person]
</ud>
<ud>
Johan de Witt (Dordrecht, Pays-Bas, 1625) Homme d''état et mathématicien. - Grand pensionnaire de Hollande [http://data.bnf.fr/ark:/12148/cb13598046j#foaf:Person]
</ud>
<ud>
Johann Hecker (Gdansk (Pologne), 1625) Astronome [http://data.bnf.fr/ark:/12148/cb12875545t#foaf:Person]
</ud>
<ud>
Rasmus Bartholin (Roskilde, Danemark, 1625) Physicien. - Mathématicien. - Médecin. - Professeur de mathématiques et de médecine à Copenhague. - A découvert la difraction de la lumière. - Fils de Kaspar Bartholin [http://data.bnf.fr/ark:/12148/cb11890430k#foaf:Person]
</ud>
<ud>
Samuel Morland (1625) Mathématicien et inventeur [http://data.bnf.fr/ark:/12148/cb10365749d#foaf:Person]
</ud>
<ud>
Pietro Mengoli (Bologne (Italie), 1626) Mathématicien. - Professeur de mécanique (1650-1678) puis titulaire de la chaire de mathématiques et d''astronomie (1678-1686) à l''université de Bologne [http://data.bnf.fr/ark:/12148/cb120851477#foaf:Person]
</ud>
<ud>
John Ray (Black Notley (Essex), 1627) Professeur de mathématiques et de lettres. - Naturaliste. - Botaniste. - Membre de la Société royale de Londres [http://data.bnf.fr/ark:/12148/cb12220184b#foaf:Person]
</ud>
<ud>
Heinrich Scherer (1628) Jésuite, géographe et professeur de mathématiques à Munich [http://data.bnf.fr/ark:/12148/cb15317471w#foaf:Person]
</ud>
<ud>
Johannes Hudde (1628) Mathématicien, élève de Frans Van Schooten. - Bourgmestre de la ville d''Amsterdam [http://data.bnf.fr/ark:/12148/cb13488288n#foaf:Person]
</ud>
<ud>
Christiaan Huygens (1629) Mathématicien et astronome. - A vécu aux Pays-Bas et en France. - Élu membre de la "Royal society" de Londres (en 1663) [http://data.bnf.fr/ark:/12148/cb12192922r#foaf:Person]
</ud>
<ud>
Allain Manesson-Mallet (Paris (France), 1630) Ingénieur et cartographe. - Maître de mathématiques des pages du roi de France, sergent-major d''artillerie du roi de Portugal [http://data.bnf.fr/ark:/12148/cb153363577#foaf:Person]
</ud>
<ud>
Isaac Barrow (1630) Mathématicien et théologien [http://data.bnf.fr/ark:/12148/cb12340135q#foaf:Person]
</ud>
<ud>
Jean Richer (1630) Astronome à l''Observatoire de Paris, il figure parmi les premiers membres de l''Académie des sciences (1666). - Chargé d''une mission géodésique à Cayenne (1672-73) [http://data.bnf.fr/ark:/12148/cb14064426q#foaf:Person]
</ud>
<ud>
Adam Adamady Kochánski (1631) Mathématicien polonais, auteur de la rectification approchée de la circonférence. Réside en 1677 à Wroclaw [http://data.bnf.fr/ark:/12148/cb16187484g#foaf:Person]
</ud>
<ud>
Francesco Lana Terzi (Brescia, Italie, 1631) Jésuite. - Mathématicien, naturaliste. - Pionnier de l''aéronautique [http://data.bnf.fr/ark:/12148/cb10681783j#foaf:Person]
</ud>
<ud>
Christopher Wren (East Knoyle, Wiltshire, GB, 1632) Architecte. - Mathématicien et astronome, Sir Christopher Wren fut l''un des membres fondateurs de la Société royale des sciences [http://data.bnf.fr/ark:/12148/cb121401670#foaf:Person]
</ud>
<ud>
Alessandro Marchetti (Empoli, Italie, 1633) Poète naturaliste, l''un des principaux animateurs du courant naturaliste toscan de la seconde moitié du XVIIe siècle. - Professeur de philosophie puis de mathématiques à l''Université de Pise [http://data.bnf.fr/ark:/12148/cb12570345j#foaf:Person]
</ud>
<ud>
Donato Rossetti (Livourne, Italie, 1633) Mathématicien. - Professeur de philosophie au "Studio" de Pise [http://data.bnf.fr/ark:/12148/cb144820894#foaf:Person]
</ud>
<ud>
Geminiano Montanari (Modène, Italie, 1633) Docteur en droit, mathématicien et astronome. - Enseigne à Florence, Modène (1661-1664), Bologne (chaire de mathématiques, 1664-1677) et Padoue (chaire d''astronomie, 1678-1687). - Membre de l''Accademia dei Gelati ("l''Elevato") et de l''Accademia della Treccia de Bologne [http://data.bnf.fr/ark:/12148/cb12309300z#foaf:Person]
</ud>
<ud>
Gerhard Wolter Molanus (1633) Théologien luthérien. - Mathématicien [http://data.bnf.fr/ark:/12148/cb12133744h#foaf:Person]
</ud>
<ud>
Giovanni Giustino Ciampini (Rome, 1633) Historien, archéologue, mathématicien. - Membre de la Curie pontificale [http://data.bnf.fr/ark:/12148/cb14323561z#foaf:Person]
</ud>
<ud>
Vitale Giordano (1633) Mathématicien [http://data.bnf.fr/ark:/12148/cb15520924m#foaf:Person]
</ud>
<ud>
Johann Christoph Sturm (Hilpolstein, Allemagne, 1635) Philosophe, mathématicien et physicien. - Professeur à l''université d''Altdorf [http://data.bnf.fr/ark:/12148/cb133240234#foaf:Person]
</ud>
<ud>
Ignace-Gaston Pardies (1636) Mathématicien. - Jésuite. - Il a enseigné la philosophie puis les mathématiques au collège Louis-Le-Grand [http://data.bnf.fr/ark:/12148/cb12174258w#foaf:Person]
</ud>
<ud>
Elias van Lennep (Borculo, Pays-Bas, 1637) Graveur. - Ingénieur et mathématicien [http://data.bnf.fr/ark:/12148/cb15053499m#foaf:Person]
</ud>
<ud>
Julius Reichelt (1637) Mathématicien strasbourgeois [http://data.bnf.fr/ark:/12148/cb15377331m#foaf:Person]
</ud>
<ud>
François Barrême (Tarascon, France, 1638) Mathématicien et financier [http://data.bnf.fr/ark:/12148/cb118903320#foaf:Person]
</ud>
<ud>
Georg Christoph Eimmart (Ratisbonne (Allemagne), 1638) Peintre d''histoire, portraitiste, graveur, mathématicien et astronome. - Fils et élève du peintre Georg-Christoph Eimmart (1603-1658), dit le vieux [http://data.bnf.fr/ark:/12148/cb12983761h#foaf:Person]
</ud>
<ud>
James Gregory (1638) Mathématicien et opticien écossais [http://data.bnf.fr/ark:/12148/cb12459917j#foaf:Person]
</ud>
<ud>
Jean Bonfa (Nîmes, 1638) Est admis à la Société de Jésus en 1654. - Dans les années 1670 jusqu''en 1683, il enseigne les mathématiques et la théologie aux collèges jésuites de Grenoble, puis d''Avignon. - De 1680 à 1682, enseigne la géométrie et l''hydrographie. - Effectue des travaux astronomiques. - Devient membre correspondant de l''Académie royale des sciences (en 1699) [http://data.bnf.fr/ark:/12148/cb15130186g#foaf:Person]
</ud>
<ud>
Jacques Ozanam (Sainte-Olive (Ain), 1640) Mathématicien. - Professeur de mathématiques à Paris et à Lyon [http://data.bnf.fr/ark:/12148/cb120960958#foaf:Person]
</ud>
<ud>
Philippe de La Hire (Paris (France), 1640) Mathématicien. - Géomètre et astronome. - Professeur de mathématiques au Collège de France. - Membre de l''Académie des sciences (1678) [http://data.bnf.fr/ark:/12148/cb121592847#foaf:Person]
</ud>
<ud>
Pierre Ango (1640) Jésuite. - Enseigna les humanités, les mathématiques et la philosophie. - Né à Rouen, mort à La Flèche [http://data.bnf.fr/ark:/12148/cb12512101m#foaf:Person]
</ud>
<ud>
Denis Papin (1642) Physicien. - Un des précurseurs de l''invention de la machine à vapeur, qui eu l''idée du piston (dés 1690), et inspira la machine que l''Anglais Thomas Newcomen (1664-1729), mis au point ensuite (en 1712). - Quitta définitivement la France, après la révocation de l''Édit de Nantes (1685). - Occupa une chaire de mathématiques à l''Université de Marburg, Allemagne (1687). - Rédige un article (Ars nova ad aquam ignis...) présentant sa machine dans la revue " Acta Eruditorum", Leipzig (en 1707), revue célèbre pour les publications de Leibniz (1646-1716), sur le calcul différentiel et intégral [http://data.bnf.fr/ark:/12148/cb12087889k#foaf:Person]
</ud>
<ud>
Isaac Newton (Woolsthorpe, Lincolnshire (GB), 1642) Physicien, mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb119176085#foaf:Person]
</ud>
<ud>
Johann Welper (1642) Variante(s) de prénom : Johannes ; Jean. - Imprimeur-libraire. - Fils et apprenti d''Eberhard Welper, imprimeur-libraire et mathématicien à Strasbourg. A été compagnon pendant 6 ans à Ulm, Augsbourg, Munich, Vienne, Leipzig et Nuremberg, avant de succéder à son père. L''enquête de 1700-1701 le dit âgé de 60 ans et "établi à Strasbourg depuis 42 ans". À sa mort, son entreprise est rachetée par Melchior Pauschinger [http://data.bnf.fr/ark:/12148/cb160636269#foaf:Person]
</ud>
<ud>
Michel Mourgues (1642) Jésuite. - Enseigna la rhétorique et les mathématiques à l''Université de Toulouse [http://data.bnf.fr/ark:/12148/cb124637183#foaf:Person]
</ud>
<ud>
Takakazu Seki (1642) Mathématicien japonais [http://data.bnf.fr/ark:/12148/cb12443516f#foaf:Person]
</ud>
<ud>
Jean Jombert (1643) Libraire. - Fils d''un fruitier et marchand de vins parisien. En apprentissage chez le libraire parisien Pierre II Baudouin à partir de janv. 1666, il travaille en 1670-1671 chez Louis Billaine et Pierre Le Petit, puis chez la veuve de Pierre I Baudouin à partir de 1672. Gendre en 1res noces (1671) du libraire Jean d''Houry. Publie sous son propre nom dès 1680, peut-être dès 1678, mais n''est reçu maître que le 17 sept. 1686. Publie de nombreux ouvrages de mathématiques. Dit âgé d''env. 60 ans lors de l''enquête de nov.-déc. 1701. Testaments le 9 août 1704 et le 6 oct. 1705. Décédé au début de nov. 1705. Sa veuve lui succède [http://data.bnf.fr/ark:/12148/cb15074749j#foaf:Person]
</ud>
<ud>
Antoine Thomas (Namur, 1644) Jésuite (à partir de 1660). - Mathématicien et astronome de l''empereur de Chine [http://data.bnf.fr/ark:/12148/cb10636254r#foaf:Person]
</ud>
<ud>
Johann Jakob Zimmermann (Vaihingen an der Enz, Allemagne, 1644) Théologien, mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb10721479d#foaf:Person]
</ud>
<ud>
Ole Rømer (Åarhus, Danemark, 1644) Astronome [http://data.bnf.fr/ark:/12148/cb12324191r#foaf:Person]
</ud>
<ud>
Carlos de Sigüenza y Góngora (Mexico, 1645) Astronome, mathématicien, poète, historien. - Sa bibliothèque, comprenant des documents uniques sur l''histoire du Mexique, disparut dans un incendie lors de l''insurrection de 1692 [http://data.bnf.fr/ark:/12148/cb121021638#foaf:Person]
</ud>
<ud>
Eusebio Francisco Kino (Taio, Italie, 1645) Mathématicien et géographe de formation. - Jésuite, arrive au Mexique en 1681 [http://data.bnf.fr/ark:/12148/cb122190783#foaf:Person]
</ud>
<ud>
Maximilian Rassler (Waldsee (Allemagne), 1645) Jésuite. - Professeur de réthorique, de mathématiques, philosophie et contreverse. - Recteur et chancelier de l''Université de Dillingen, Allemagne [http://data.bnf.fr/ark:/12148/cb158132748#foaf:Person]
</ud>
<ud>
Elena Lucrezia Cornaro Piscopia (Venise (Italie), 1646) Philosophe et mathématicienne. - Première femme docteur en philosophie [http://data.bnf.fr/ark:/12148/cb16591183r#foaf:Person]
</ud>
<ud>
Francesco Maria Pompeo Colonna (Rome, 1646) Mathématicien, physicien et occultiste. - Vécut à Paris à partir de 1668 [http://data.bnf.fr/ark:/12148/cb118973978#foaf:Person]
</ud>
<ud>
Harald Vallerius (1646) Professeur universitaire de mathématiques [http://data.bnf.fr/ark:/12148/cb16032560b#foaf:Person]
</ud>
<ud>
John Flamsteed (1646) Astronome. - Fut le premier directeur de l''Observatoire de Greenwich, GB, fondé en 1675 [http://data.bnf.fr/ark:/12148/cb13524243n#foaf:Person]
</ud>
<ud>
John Flamsteed (1646) Astronome britannique. Fut le premier directeur de l''observatoire de Greenwich, fondé en 1675 [http://data.bnf.fr/ark:/12148/cb13510391m#foaf:Person]
</ud>
<ud>
Niccolò Partenio Giannettasio (1648) Jésuite. - Historien et poète. - Professeur de mathématiques et d''hébreu au Collège des Jésuites de Naples. - Né à Naples, meurt à Massa [http://data.bnf.fr/ark:/12148/cb133256727#foaf:Person]
</ud>
<ud>
Tommaso Ceva (1648) Jésuite. - Philosophe, astronome, physicien et poète. - Membre de l''Académie de l''Arcadie sous le pseudonyme : Callimaco Neridio [http://data.bnf.fr/ark:/12148/cb13321850h#foaf:Person]
</ud>
<ud>
Jean Le Febvre (Lisieux (Calvados), 1650) Tisserand, puis astronome. - Membre de l''Académie des sciences de 1682 à 1702 [http://data.bnf.fr/ark:/12148/cb16176897g#foaf:Person]
</ud>
<ud>
Michelangelo Fardella (1650) Franciscain. - Philosophe, astronome et mathématicien. - Professeur de philosophie, de théologie, de mathématiques, professeur d''astronomie et de physique à l''Université de Padoue (1694-). - Né à Trapani, meurt à Naples [http://data.bnf.fr/ark:/12148/cb12093422f#foaf:Person]
</ud>
<ud>
Andreas Cellarius (1651) Mathématicien et géographe hollandais actif de 1656 à 1702. En 1660 il est recteur de l''Ecole latine de Hoorn [http://data.bnf.fr/ark:/12148/cb15338282n#foaf:Person]
</ud>
<ud>
Antoine-François Payen (Avignon, 1651) Jurisconsulte et astronome. - Enseigna la jurisprudence civile dès 1642 à Avignon [http://data.bnf.fr/ark:/12148/cb144713316#foaf:Person]
</ud>
<ud>
Arent Roggeveen (1651) Mathématicien, navigateur et hydrographe [http://data.bnf.fr/ark:/12148/cb153879695#foaf:Person]
</ud>
<ud>
Bingzhen Jiao (1651) Peintre et mathématicien à la cour de l''empereur Kangxi [http://data.bnf.fr/ark:/12148/cb14546684c#foaf:Person]
</ud>
<ud>
Caspar Dauthendey (1651) Architecte et mathématicien [http://data.bnf.fr/ark:/12148/cb153778194#foaf:Person]
</ud>
<ud>
Claude Bonjour (1651) Augustin du couvent de Pontarlier. Géographe et mathématicien [http://data.bnf.fr/ark:/12148/cb15294805z#foaf:Person]
</ud>
<ud>
Claude Comiers (1651) Théologien et mathématicien, né à Embrun. Chanoine d''Embrun, ingénieur des armées, puis prévôt de l''église collégiale de Ternant, professeur de mathématiques à Paris ; protonotaire apostolique et officier du Saint-Office. - Il a laissé des livres et des articles sur des sujets variés : géométrie, astronomie, médecine, occultisme, physique... [http://data.bnf.fr/ark:/12148/cb12250531g#foaf:Person]
</ud>
<ud>
Claude Irson (1651) Mathématicien et grammairien. - A été teneur de comptes vers 1678 [http://data.bnf.fr/ark:/12148/cb125155096#foaf:Person]
</ud>
<ud>
de La Roche (1651) Mathématicien [http://data.bnf.fr/ark:/12148/cb13009642b#foaf:Person]
</ud>
<ud>
Ehrenfried Walter von Tschirnhaus (Kieslingswalde, Allemagne, 1651) Philosophe, mathématicien et biologiste. - Industriel, considéré comme l''inventeur de la porcellaine blanche en Europe [http://data.bnf.fr/ark:/12148/cb12515471b#foaf:Person]
</ud>
<ud>
Federico Gualdi (1651) Alchimiste, astronome, mathématicien. - Philosophe hermétique. - Membre de la Rose-croix d''Or. - Serait d''origine allemande ou italienne [http://data.bnf.fr/ark:/12148/cb150904929#foaf:Person]
</ud>
<ud>
Francesco Levera (Savoie, 1651) Philosophe, astronome et théologien [http://data.bnf.fr/ark:/12148/cb10442558v#foaf:Person]
</ud>
<ud>
François Chevalier (Sainte-Maur, 1651) Elève de l''abbé Galloys. Associé géomètre à l''Académie des sciences en 1707. Pensionnaire mécanicien en 1725. Professeur de mathématiques au Collège de France. Maître de mathématiques du roi et des pages de la Petite Ecurie. Présenta en 1707 à l''Académie une méthode de collecte des informations cartographiques sur des châssis concentriques [http://data.bnf.fr/ark:/12148/cb153045899#foaf:Person]
</ud>
<ud>
François Noël (Hestrud, Pays-Bas Méridionaux, 1651) Jésuite (à partir de 1670) ordonné prêtre en 1682. - Missionnaire en Chine, il fut envoyé à Rome à l''occasion de la querelle des rites, et ne put rentrer en Chinê. - Il enseigna ensuite à Prague. - Auteur de poésies et de théâtre, d''un traité d''astronomie, de traductions et d''un ouvrage catéchétique en chinois [http://data.bnf.fr/ark:/12148/cb16653645d#foaf:Person]
</ud>
<ud>
Guisnée (1651) Mathématicien. - Membre de l''Académie royale des sciences [http://data.bnf.fr/ark:/12148/cb14618149h#foaf:Person]
</ud>
<ud>
Jacques Mengau (1651) Professeur de mathématiques. - Auteur de mazarinades. - Actif de 1648 à 1652 [http://data.bnf.fr/ark:/12148/cb12166762s#foaf:Person]
</ud>
<ud>
Jean Bachou (1651) Mathématicien et alchimiste lyonnais. - Avocat au parlement [http://data.bnf.fr/ark:/12148/cb12158814g#foaf:Person]
</ud>
<ud>
Jean Glover (1651) Ingénieur et mathématicien originaire d''Écosse et établi en France. - Auteur notamment de plusieurs propositions de loteries et d''une "Nouvelle Manière d''exécuter les loteries..." (Paris, 1705). - Se qualifie d''"esquire, seigneur de Glaideny et de la baronnie de Baltillée en Ecosse" [http://data.bnf.fr/ark:/12148/cb15818830h#foaf:Person]
</ud>
<ud>
Jean-Baptiste Delure (1651) Éditeur d''estampes et de cartes géographiques. - Ingénieur pour les instruments de mathématiques et fabricant de cartes et de globes ; éditeur occasionnel [http://data.bnf.fr/ark:/12148/cb153164066#foaf:Person]
</ud>
<ud>
Joachim d'' Alencé (1651) Astronome et physicien [http://data.bnf.fr/ark:/12148/cb12397878n#foaf:Person]
</ud>
<ud>
Joanne Westenburg (1651) Cartographe, médecin et mathématicien [http://data.bnf.fr/ark:/12148/cb15377993t#foaf:Person]
</ud>
<ud>
Johann Andreas Planer (Strelen, Allemagne, 1651) Mathématicien. - Professeur de mathématiques à l''Université de Wittenberg [http://data.bnf.fr/ark:/12148/cb16672375p#foaf:Person]
</ud>
<ud>
Le Blanc (1651) Professeur de mathématiques (1692). - Réside rue de Seine à Paris en 1692 [http://data.bnf.fr/ark:/12148/cb16650697x#foaf:Person]
</ud>
<ud>
Le Demaine Godalles (1651) Hydrographe, Ingénieur du roi et professeur de Mathématiques, Architecte [http://data.bnf.fr/ark:/12148/cb15375819n#foaf:Person]
</ud>
<ud>
Philip Lea (1651) Cartographe, fabricant et éditeur de globes, de cartes, d''instruments de mathématiques, actif de 1666 à 1700 à Londres [http://data.bnf.fr/ark:/12148/cb15328427v#foaf:Person]
</ud>
<ud>
René Gaultier de Maignannes (1651) Mathématicien angevin. - Spécialiste de la perspective [http://data.bnf.fr/ark:/12148/cb12536157m#foaf:Person]
</ud>
<ud>
David François de Merveilleux (1652) Géographe et cartographe. Connaissances mathématiques étendues (il publie un traîté d''arithmétique et de géométrie). En 1695 il entre au service de Guillaume III qui lui accorde le brevet de Capitaine Ingénieur au service d''Angleterre et des Etats généraux [http://data.bnf.fr/ark:/12148/cb15304894q#foaf:Person]
</ud>
<ud>
Michel Rolle (Ambert (Puy-de-Dôme), 1652) Mathématicien [http://data.bnf.fr/ark:/12148/cb130110121#foaf:Person]
</ud>
<ud>
Nicolas Bion (1652) Ingénieur du roi pour les instruments de mathématique. - Avait un atelier à Paris, quai de l''Horloge, qui était l''un des mieux achalandés du temps. - Son "Usage des globes" connut 6 éditions entre 1699 et 1751. - Édita en 1694 le globe terrestre de P. Courtin (diam. 25 cm) et en 1712 une paire de globes de même diamètre, un globe céleste antérieur à 1710 atteignit 32 cm de diamètre [http://data.bnf.fr/ark:/12148/cb152909089#foaf:Person]
</ud>
<ud>
José Chaffrion (1653) Cartographe et mathématicien de Valence en Espagne [http://data.bnf.fr/ark:/12148/cb15330290b#foaf:Person]
</ud>
<ud>
Bernard Nieuwentijt (West Graftdijk, Pays-Bas, 1654) Philosophe, médecin et mathématicien [http://data.bnf.fr/ark:/12148/cb14587835s#foaf:Person]
</ud>
<ud>
Jacques Bernoulli (Bâle, Suisse, 1654) Mathématicien et astronome. - Professeur de mathématiques à l''université de Bâle, Suisse [http://data.bnf.fr/ark:/12148/cb120751142#foaf:Person]
</ud>
<ud>
Jean Pigeon (Donzy (Nièvre), 1654) Peintre, mathématicien et facteur de globes, géographe du Duc d''Orléans à partir de 1714 [http://data.bnf.fr/ark:/12148/cb15147433m#foaf:Person]
</ud>
<ud>
Jean-François Gerbillon (1654) Jésuite. - Mathématicien, fut envoyé en Chine par Louis XIV en 1685. - Écrivit des traités de géométrie et de l''usage de l''astrolabe en chinois et en tartare. - Supérieur général de la Mission française de Chine [http://data.bnf.fr/ark:/12148/cb124622770#foaf:Person]
</ud>
<ud>
Philippe Avril (Angoulême (Charente), 1654) Missionnaire. - Voyageur, jésuite dès 1670, il enseigna les mathématiques à Louis-le-Grand. - Chercha un nouveau passage vers la Chine par la Tartarie, le Kurdistan et l''Arménie [http://data.bnf.fr/ark:/12148/cb15327596q#foaf:Person]
</ud>
<ud>
Philippe Naudé (Metz, 1654) Théologien et mathématicien. - Se réfugia en Prusse après la révocation de l''Édit de Nantes [http://data.bnf.fr/ark:/12148/cb10366497p#foaf:Person]
</ud>
<ud>
Pierre Varignon (Caen (Calvados), 1654) Mathématicien. - Jésuite. - Membre de l''Académie des sciences, il entre au collège de France en 1704 [http://data.bnf.fr/ark:/12148/cb121123302#foaf:Person]
</ud>
<ud>
Louis Lecomte (1655) Jésuite. - Mathématicien [http://data.bnf.fr/ark:/12148/cb12151496v#foaf:Person]
</ud>
<ud>
Simon Tyssot de Patot (Londres, 1655) Professeur ordinaire de mathématiques à l''École illustre de Deventer (1699-1727 ; professeur extraordinaire dès 1690). - Vécut en France de 1658 environ à 1664, puis aux Pays-Bas [http://data.bnf.fr/ark:/12148/cb11927303t#foaf:Person]
</ud>
<ud>
Claude de Visdelou (Erquy (Côtes-d''Armor), 1656) Jésuite. - Mathématicien. - Missionnaire en Chine. - Évèque titulaire de de Claudiopolis-en-Isaurie (à partir de 1708/1709). - Vicaire apostolique du Koueitchéou et du Yunnan, et administrateu du Houkouang (de 1708 à 1709) [http://data.bnf.fr/ark:/12148/cb150791582#foaf:Person]
</ud>
<ud>
Edmund Halley (1656) Astronome [http://data.bnf.fr/ark:/12148/cb119960783#foaf:Person]
</ud>
<ud>
Nicolaas Hartsoeker (Gouda (Pays-Bas), 1656) Physicien, micrographe et médecin. - Apporta des perfectionnements importants à la fabrication des verres de lunettes astronomiques, découvrit les animalcules spermatiques [http://data.bnf.fr/ark:/12148/cb13010358x#foaf:Person]
</ud>
<ud>
William Molyneux (Dublin, 1656) Mathématicien, astronome, physicien et philosophe. - Premier secrétaire de la Société philosophique de Dublin (en 1684) [http://data.bnf.fr/ark:/12148/cb124596616#foaf:Person]
</ud>
<ud>
Jean-Mathieu de Chazelles (Lyon, 1657) Cartographe, géographe et astronome associé à l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb106281104#foaf:Person]
</ud>
<ud>
Jean-Matthieu de Chazelles (Lyon, 1657) Fit ses études chez les jésuites et devint l''auxiliaire de Cassini I. Fut associé aux travaux géodésiques menés par l''Académie des sciences. Dessina le planisphère de l''Observatoire. Collabora au Neptune françois. Associé astronome de l''Académie des sciences en 1695; associé mécanicien en 1699. Professeur d''hydrographie à Marseille [http://data.bnf.fr/ark:/12148/cb15304334g#foaf:Person]
</ud>
<ud>
Joseph Saurin (Courthézon (Vaucluse), 1659) Mathématicien [http://data.bnf.fr/ark:/12148/cb10330722j#foaf:Person]
</ud>
<ud>
Philippe Desplaces (1659) Astronome. - Auteur d''éphémérides [http://data.bnf.fr/ark:/12148/cb12223720g#foaf:Person]
</ud>
<ud>
Louis Feuillée (Mane (Alpes-de-Haute-Provence), 1660) Astronome et botaniste. - Religieux de l''ordre des Minimes. - Initié à la botanique par le P. Plumier. Correspondant astronome de l''Académie des sciences, il obtient une mission dans le Levant. Revenu à Marseille en 1702, il embarque l''année suivante pour les Antilles et parvient à Carthagène en 1704. Nommé mathématicien du roi, il s''embarque pour l''Amérique du Sud en 1707. En 1724, il est chargé de déterminer la position exacte de l''île de Fer [http://data.bnf.fr/ark:/12148/cb15309142r#foaf:Person]
</ud>
<ud>
Thomas Fantet de Lagny (Lyon (Rhône), 1660) Mathématicien. - Professeur [http://data.bnf.fr/ark:/12148/cb14548143w#foaf:Person]
</ud>
<ud>
Guillaume-François-Antoine de L''Hospital (1661) Marquis de Sainte-Mesme. - Mathématicien, membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb12000655c#foaf:Person]
</ud>
<ud>
Francesco Bianchini (Vérone, Italie, 1662) Théologien, historien, astronome et physicien [http://data.bnf.fr/ark:/12148/cb12452255g#foaf:Person]
</ud>
<ud>
Paolo Mattia Doria (1662) Philosophe et mathématicien italien [http://data.bnf.fr/ark:/12148/cb121118306#foaf:Person]
</ud>
<ud>
Jean-Pierre de Crousaz (1663) Professeur de philosophie et mathématiques à Lausanne et Groningue. - Conseiller de la légation de Suède en Hollande. - Membre des Académies de Bordeaux et Paris [http://data.bnf.fr/ark:/12148/cb12016566d#foaf:Person]
</ud>
<ud>
Johann Balthasar Lauterbach (1663) Mathématicien et architecte allemand [http://data.bnf.fr/ark:/12148/cb137778333#foaf:Person]
</ud>
<ud>
John Craig (1663) Mathématicien et théologien écossais [http://data.bnf.fr/ark:/12148/cb114408210#foaf:Person]
</ud>
<ud>
Katahiro Takebe (1664) Mathématicien japonais [http://data.bnf.fr/ark:/12148/cb12443517s#foaf:Person]
</ud>
<ud>
Lothar Zumbach von Coesfeld (Trèves (Allemagne), 1664) Mathématicien, astronome, médecin, musicien. - Mathématicien et musicien de l''électeur de Trèves (1685-1688). - Lecteur en astronomie à l''université de Leyde. - Professeur de mathématiques au Carolinum de Kassel [http://data.bnf.fr/ark:/12148/cb14853628w#foaf:Person]
</ud>
<ud>
Abraham de Moivre (Vitry-le-François (Marne), 1667) Mathématicien. - Émigra en Grande-Bretagne après la révocation de l''Édit de Nantes (en 1686). - Membre de la Royal Society, de l''Académie de Berlin et de l''Académie de Saint-Pétersbourg [http://data.bnf.fr/ark:/12148/cb130110001#foaf:Person]
</ud>
<ud>
Girolamo Saccheri (San Remo, Italie, 1667) Jésuite. - Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb13164455b#foaf:Person]
</ud>
<ud>
Johann Bernoulli (Bâle, Suisse, 1667) Mathématicien et physicien, maître d''Euler, professeur à l''Université de Groningue puis à l''Université de Bâle. - A travaillé sur le calcul différentiel, intégral et exponentiel. - Également auteur de traités de médecine, fondateur de la théorie mécanico-physique de la fermentation [http://data.bnf.fr/ark:/12148/cb122991692#foaf:Person]
</ud>
<ud>
William Whiston (Norton-juxta-Twycross (G. B.), 1667) Théologien et astronome. - Professeur de mathématiques à Cambridge, d''où il fut exclu pour ses écrits théologiques. - Traducteur de Flavius Josèphe [http://data.bnf.fr/ark:/12148/cb11997914k#foaf:Person]
</ud>
<ud>
Guillaume Bonjour (Toulouse (Haute-Garonne), 1669) Augustin. - Missionnaire en Chine. - Orientaliste, astronome et cartographe [http://data.bnf.fr/ark:/12148/cb13613529n#foaf:Person]
</ud>
<ud>
Leonhard Christoph Sturm (Aldorf, Allemagne, 1669) Mathématicien. - Architecte [http://data.bnf.fr/ark:/12148/cb143383238#foaf:Person]
</ud>
<ud>
Jean Terrasson (Lyon, 1670) Oratorien, mathématicien et philosophe. - Professeur de grec et latin au Collège de France. - Membre de l''Institut, Académie Française (élu en 1732) [http://data.bnf.fr/ark:/12148/cb119262217#foaf:Person]
</ud>
<ud>
Guido Grandi (Crémone, Italie, 1671) Mathématicien, théologien, biographe, antiquaire et poète. - Soutint Descartes contre l''aristotélisme. - Professeur de philosophie à l''Université de Pise. - Fut en correspondance avec Leibniz, Newton, Bernoulli. - Intendant général des eaux en Toscane [http://data.bnf.fr/ark:/12148/cb121384290#foaf:Person]
</ud>
<ud>
Johann Gabriel Doppelmayr (1671) Fils d''un riche négociant qui s''occupait de physique, et destiné d''abord à l''étude du droit, il la quitta pour celle des mathématiques et voyagea jusqu''en 1702. Professeur à Nuremberg et membre de la Royal Society de Londres [http://data.bnf.fr/ark:/12148/cb15327296w#foaf:Person]
</ud>
<ud>
Johann Gabriel Doppelmayr (1671) Mathématicien. - Membre de la Royal Society de Londres (1713) [http://data.bnf.fr/ark:/12148/cb12158680q#foaf:Person]
</ud>
<ud>
Johann Gabriel Doppelmayr (1671) Astronome et cartographe ayant véçu à Nuremberg, né en 1671 ou 1677 [http://data.bnf.fr/ark:/12148/cb15327296w#foaf:Person]
</ud>
<ud>
Johann Heinrich Müller (1671) Physicien, astronome, mathématicien. - Professeur à l''université d''Altdorf (Allemagne) [http://data.bnf.fr/ark:/12148/cb10706008k#foaf:Person]
</ud>
<ud>
John Keill (1671) Mathématicien écossais. - Professeur d''astronomie à Oxford [http://data.bnf.fr/ark:/12148/cb123670586#foaf:Person]
</ud>
<ud>
Étienne-Simon de Gamaches (1672) Astronome et moraliste. - Chanoine de Sainte Croix de La Bretonnerie. - Membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb12004341t#foaf:Person]
</ud>
<ud>
Johann Jacob Scheuchzer (Zürich, 1672) Médecin, naturaliste, historien, archéologue, numismate, astronome et physicien [http://data.bnf.fr/ark:/12148/cb123955592#foaf:Person]
</ud>
<ud>
Eustachio Manfredi (1674) Astronome. - Poète. - Fondateur de l''Académie de Bologne [http://data.bnf.fr/ark:/12148/cb12202194q#foaf:Person]
</ud>
<ud>
Julien Mahuet (1674) Jésuite. - Né à Reims. Entre au noviciat le 24 août 1692. Enseigne les humanités à Reims, la rhétorique à Metz et les mathématiques à Reims. - Écrit du théâtre pour le Collège de Reims [http://data.bnf.fr/ark:/12148/cb13165624v#foaf:Person]
</ud>
<ud>
Guillaume Delisle (1675) Cartographe. - Fils de Claude Delisle, fut l''élève de Jean-Dominique Cassini. Élève astronome à l''Académie des sciences en 1702, il en devint membre en 1718 ; enseigna la géographie au jeune Louis XV et fut nommé premier géographe du roi ; produisit quelque 100 cartes qu''il édita lui-même [http://data.bnf.fr/ark:/12148/cb15238363g#foaf:Person]
</ud>
<ud>
Humphry Ditton (Salisbury (G. B.), 1675) Mathématicien et théologien [http://data.bnf.fr/ark:/12148/cb15994181b#foaf:Person]
</ud>
<ud>
Yves-Marie André (1675) Jésuite. - Professeur de mathématiques à Caen [http://data.bnf.fr/ark:/12148/cb12180932c#foaf:Person]
</ud>
<ud>
Jacopo Francesco Riccati (1676) Mathématicien [http://data.bnf.fr/ark:/12148/cb120689750#foaf:Person]
</ud>
<ud>
Gabriel Philippe de La Hire (Paris, 1677) Astronome [http://data.bnf.fr/ark:/12148/cb106522995#foaf:Person]
</ud>
<ud>
Jacques Cassini (Paris, 1677) Fils de Jean-Dominique Cassini et père de César-François Cassini de Thury. Associé astronome à l''Académie des sciences en 1699, pensionnaire en 1712. En 1700 participa à la mesure de la méridienne de l''Observatoire et y travailla jusqu''à son achèvement en 1718. En 1706 maître ordinaire à la Chambre des comptes. Etudia les planètes et leurs satellites. Soutint la thèse de l''allongement de la Terre aux pôles. [http://data.bnf.fr/ark:/12148/cb15238366h#foaf:Person]
</ud>
<ud>
Joseph Privat de Molières (Tarascon (ouches-du-Rhône), 1677) Physicien et mathématicien. - Oratorien (vers 1709). - Professeur au collège royal (1723). - Adjoint (1721) puis associé (1729) de l''Académie royale des sciences [http://data.bnf.fr/ark:/12148/cb145391041#foaf:Person]
</ud>
<ud>
Gerard Keulen (1678) Graveur, cartographe, mathématicien et éditeur. - Fils de Johannes van Keulen [http://data.bnf.fr/ark:/12148/cb15332761m#foaf:Person]
</ud>
<ud>
Jacob Hermann (1678) Mathématicien [http://data.bnf.fr/ark:/12148/cb12319998c#foaf:Person]
</ud>
<ud>
Jean-Jacques Dortous de Mairan (Béziers, 1678) Physicien et mathématicien. - Membre puis secrétaire perpétuel de l''Académie des sciences. - Membre de l''Académie française (élu en 1743) [http://data.bnf.fr/ark:/12148/cb12395086k#foaf:Person]
</ud>
<ud>
Louis Bourguet (Nïmes, 1678) Professeur de philosophie et de mathématiques à Neuchâtel. - Est l''un des fondateurs de la "Bibliothèque italique" (1728-) et du "Mercure suisse" (1732-). - Naturalisé Neuchâtelois en 1710 [http://data.bnf.fr/ark:/12148/cb12797692b#foaf:Person]
</ud>
<ud>
Pierre Rémond de Montmort (Paris, 1678) Mathématicien. - Spécialiste de probabilités [http://data.bnf.fr/ark:/12148/cb12391046c#foaf:Person]
</ud>
<ud>
Bernardino Zendrini (Saviore, Italie, 1679) Médecin. - Mathématicien. - Hydraulicien [http://data.bnf.fr/ark:/12148/cb13545066d#foaf:Person]
</ud>
<ud>
Christian Wolff (Breslau, Silésie (Wrocław, Pologne), 1679) Juriste, mathématicien et philosophe [http://data.bnf.fr/ark:/12148/cb121387859#foaf:Person]
</ud>
<ud>
Firmin Abauzit (Uzès, 1679) Mathématicien, philosophe et bibliothécaire. - Fut bibliothécaire à la Bibliothèque de Genève. - Vécut à Genève après la révocation de l''Édit de Nantes [http://data.bnf.fr/ark:/12148/cb121711117#foaf:Person]
</ud>
<ud>
Claude Richer (1680) Abbé. - Mathématicien [http://data.bnf.fr/ark:/12148/cb12532604f#foaf:Person]
</ud>
<ud>
Pierre Jartoux (1680) Astronome et missionnaire jésuite en Chine [http://data.bnf.fr/ark:/12148/cb15367486z#foaf:Person]
</ud>
<ud>
Paolino Chelucci (Lucca, Italie, 1681) Professeur d''éloquence à l''Université de Rome. - Mathématicien [http://data.bnf.fr/ark:/12148/cb104300443#foaf:Person]
</ud>
<ud>
Roger Cotes (Burbage (Leicestershire), 1682) Mathématicien. - Professeur d''astronomie et de philosophie expérimentale au Trinity College, Cambridge (1707-). - A édité la seconde édition des "Principia" de Newton [http://data.bnf.fr/ark:/12148/cb123946202#foaf:Person]
</ud>
<ud>
Noël Regnault (1683) Jésuite. - Professeur de mathématiques et physique au collège de Paris [http://data.bnf.fr/ark:/12148/cb12218681d#foaf:Person]
</ud>
<ud>
Johann Matthias Hase (1684) Géographe et cartographe ; historien. - Mathématicien [http://data.bnf.fr/ark:/12148/cb13007561v#foaf:Person]
</ud>
<ud>
Brook Taylor (1685) Mathématicien [http://data.bnf.fr/ark:/12148/cb12315365s#foaf:Person]
</ud>
<ud>
Giovanni Poleni (Venise, Italie, 1685) Physicien, mathématicien et archéologue [http://data.bnf.fr/ark:/12148/cb12161210z#foaf:Person]
</ud>
<ud>
Jean-Edme Gallimard (Paris, 1685) Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb120827146#foaf:Person]
</ud>
<ud>
Jai Singh (Amber (Rajasthan, Inde), 1686) Mahārāja de Jaipur (Rajasthan, Inde) de 1699 à 1743. - Fondateur de la ville de Jaipur (en 1727). - Chef du clan rajput des Kachhwa. - Bâtisseur de cinq observatoires astronomiques (yantra) dans l''Inde du Nord, à Delhi, Jaipur, Mathura, Varanasi et Ujjain. - Publia des tables astronomiques. - Les dates biographiques (1688-1743) sont aussi parfois retenues [http://data.bnf.fr/ark:/12148/cb16578505b#foaf:Person]
</ud>
<ud>
Nicolas Bernoulli (1687) Mathématicien et juriste suisse [http://data.bnf.fr/ark:/12148/cb13510346s#foaf:Person]
</ud>
<ud>
Robert Simson (1687) Mathématicien. - A été professeur à l''Université de Glasgow, GB [http://data.bnf.fr/ark:/12148/cb12399224j#foaf:Person]
</ud>
<ud>
Joseph-Nicolas Delisle (Paris, 1688) Astronome. - Il reçut l''enseignement de Cassini II. - Professeur de mathématiques au Collège de France et géographe de la marine. - Membre de l''Institut, Académie des sciences (1714). - Fondateur de l''École d''astronomie de Saint-Pétersbourg (à partir de 1725), a séjourné en Russie jusqu''en 1747 [http://data.bnf.fr/ark:/12148/cb12150746w#foaf:Person]
</ud>
<ud>
Louis-Bertrand Castel (Montpellier, 1688) Jésuite (1703). - Philosophe et mathématicien [http://data.bnf.fr/ark:/12148/cb12462543h#foaf:Person]
</ud>
<ud>
Pierre Brumoy (Rouen, 1688) Jésuite en 1704. - Professeur de rhétorique à Caen, précepteur du prince de Talmont, professeur de mathématiques au collège de Louis-le-Grand à Paris. - Collabore au Journal de Trévoux de 1722 à 1739. - Littérateur [http://data.bnf.fr/ark:/12148/cb12069382v#foaf:Person]
</ud>
<ud>
Willem Jacob''s Gravesande (1688) Physicien. - Philosophe. - Professeur de mathématique et astronomie à Leyde, Pays-Bas. - Éditeur du "Journal littéraire de la Haye", devenu "Journal de la République des Lettres" [http://data.bnf.fr/ark:/12148/cb12218384m#foaf:Person]
</ud>
<ud>
Antoine Gaubil (Gaillac (Aveyron), 1689) Jésuite et missionnaire en Chine. - Établit un observatoire à Pékin, dans la résidence française. - Écrit sur l''astronomie, la géographie, l''histoire et la littérature de la Chine [http://data.bnf.fr/ark:/12148/cb12150997b#foaf:Person]
</ud>
<ud>
Giovanni Gaetano Bottari (Rome, 1689) Savant prélat. - A étudié les langues et la littérature de l''Antiquité, les mathématiques, la philosophie et la théologie. - Membre de l''Académie della Crusca. - Conservateur de la bibliothèque du Vatican [http://data.bnf.fr/ark:/12148/cb12516784r#foaf:Person]
</ud>
<ud>
Robert Smith (Lea, GB, 1689) Professeur de mathématiques et de philosophie naturelle à Cambridge [http://data.bnf.fr/ark:/12148/cb15075770m#foaf:Person]
</ud>
<ud>
Christian Goldbach (1690) Mathématicien allemand [http://data.bnf.fr/ark:/12148/cb124384045#foaf:Person]
</ud>
<ud>
Johann Friedrich Weidler (Gros-Neuhausen, Allemagne, 1691) Écrivain, mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb151541516#foaf:Person]
</ud>
<ud>
Esprit Pezenas (Avignon, 1692) Jésuite. - Astronome et mathématicien. - Professeur d''hydrographie à Marseille et directeur de l''Observatoire de Marseille (1749) [http://data.bnf.fr/ark:/12148/cb12120600p#foaf:Person]
</ud>
<ud>
James Stirling (Garden, GB, 1692) Mathématicien [http://data.bnf.fr/ark:/12148/cb13475586v#foaf:Person]
</ud>
<ud>
Petrus Van Musschenbroek (1692) Physicien, docteur en médecine et en philosophie. - Fut l''inventeur de la pyrométrie. - Fut professeur de philosophie naturelle, de mathématiques et d''astronomie à l''Université d''Utrecht, puis professeur à Leiden [http://data.bnf.fr/ark:/12148/cb13475113j#foaf:Person]
</ud>
<ud>
Diego de Torres Villarroel (1693) Prêtre catholique. - Homme de lettres. - Professeur de mathématiques à l''université de Salamanque [http://data.bnf.fr/ark:/12148/cb119268467#foaf:Person]
</ud>
<ud>
Giovanni Bianchi (Rimini (Italie), 1693) Médecin. - Professeur d''anatomie à l''Université de Sienne (1741-). - Auteur d''ouvrages médicaux, archéologiques, astronomiques, etc. [http://data.bnf.fr/ark:/12148/cb10649342z#foaf:Person]
</ud>
<ud>
Christfried Kirch (1694) Astronome allemand. - Il succéda à son père Gottfried (1639-1710) dans la direction de l''Observatoire royal de Prusse (1716-1740). - Membre de l''Académie des sciences de Berlin (1716) et associé de celles de Paris (1723) et de Saint-Pétersbourg [http://data.bnf.fr/ark:/12148/cb12648455m#foaf:Person]
</ud>
<ud>
Dominique-François Rivard (1697) Mathématicien. - Philosophe. - Professeur au collège de Beauvais [http://data.bnf.fr/ark:/12148/cb119220838#foaf:Person]
</ud>
<ud>
Abbé Deidier (Marseille, 1698) Abbé. - Mathématicien. - Professeur d''artillerie à l''Ecole militaire de La Fère [http://data.bnf.fr/ark:/12148/cb102670411#foaf:Person]
</ud>
<ud>
Colin MacLaurin (Kilmodan, GB, 1698) Mathématicien et physicien [http://data.bnf.fr/ark:/12148/cb12534513m#foaf:Person]
</ud>
<ud>
Pierre-Louis Moreau de Maupertuis (Saint-Malo, Ille-et-Villaine, 1698) Philosophe, astronome et physicien. - Fut invité par Frédéric II à réorganiser puis présider l''Académie de Berlin. - Ami puis ennemi de Voltaire, qui écrivit contre lui "Micromégas". - Membre de l''Académie française (élu en 1743) [http://data.bnf.fr/ark:/12148/cb11915229j#foaf:Person]
</ud>
<ud>
Charles-Étienne-Louis Camus (Crécy-en-Brie (Seine-et-Marne), 1699) Mathématicien. - Astronome. - Participa à l''expédition de 1736 en Laponie. - Membre de l''Académie des sciences (1727) et de l''Académie d''architecture (1739) [http://data.bnf.fr/ark:/12148/cb12181030f#foaf:Person]
</ud>
<ud>
Johann Ludwig Levin Gebhardi (Braunschweig, Allemagne, 1699) Historien, professeur de philologie à l''académie équestre de Lüneburg (1723). - Mathématicien [http://data.bnf.fr/ark:/12148/cb143273694#foaf:Person]
</ud>
<ud>
Daniel Bernoulli (Groningue (Pays-Bas), 1700) Mathématicien, physicien et astronome. - Fut professeur à Saint-Petersbourg (1725-1733) et à Bâle (1733-) [http://data.bnf.fr/ark:/12148/cb122991859#foaf:Person]
</ud>
<ud>
Sámuel Mikoviny (Ábelfalva, aujourd''hui Ábelová, Slovaquie, 1700) Cartographe. - Officier du génie. - Spécialiste en hydraulique. - Mathématicien. - Disciple de Bél Mátyás (1684-1749). - Études à Jena et à Nuremberg, Allemagne [http://data.bnf.fr/ark:/12148/cb103650124#foaf:Person]
</ud>
<ud>
Anders Celsius (1701) Astronome et naturaliste. - Professeur d''astronomie à l''université d''Uppsala (1730) [http://data.bnf.fr/ark:/12148/cb14606035v#foaf:Person]
</ud>
<ud>
Charles-Marie de La Condamine (Paris, 1701) Savant. - Astronome. - Géographe. Mesura l''arc du Méridien avec Godin et Bouguer. - Membre de l''Académie française (élu en 1760) [http://data.bnf.fr/ark:/12148/cb119102567#foaf:Person]
</ud>
<ud>
Georg Wolfgang Krafft (Tuttlingen (Allemagne), 1701) Physicien, professeur de mathématiques et de physique [http://data.bnf.fr/ark:/12148/cb10587905k#foaf:Person]
</ud>
<ud>
Johannes Nicolaus Frobesius (Goslar, Allemagne, 1701) Mathématicien et professeur de philosophie [http://data.bnf.fr/ark:/12148/cb12355199c#foaf:Person]
</ud>
<ud>
Niccolò de Martino (1701) Mathématicien [http://data.bnf.fr/ark:/12148/cb16265590z#foaf:Person]
</ud>
<ud>
Johann Lorenz Schmidt (1702) Fils de pasteur, a étudié la théologie et s''est intéressé à la  philosophie et aux mathématiques. - A publié en 1735 une traduction annotée de la première partie de la Bible, les cinq livres de Moïse (ou Torah ou Pentateuque), connue sous le nom de "Wertheimer Bible", laquelle a été censurée par l''empereur [http://data.bnf.fr/ark:/12148/cb150701237#foaf:Person]
</ud>
<ud>
Antoine Deparcieux (1703) Mathématicien et statisticien. - Fut constructeur de cadrans solaires et inventeur de machines pour élever les eaux et de presse pour le tabac. - Membre de l''Académie des sciences (1746) [http://data.bnf.fr/ark:/12148/cb121904326#foaf:Person]
</ud>
<ud>
Bernard-Laurent Soumille (1703) Mathématicien, physicien et agronome. - Prêtre-bénéficier du chapitre de Villeneuve-lès-Avignon (à partir de 1736, environ). - Correspondant de l''Académie royale des sciences de Paris [http://data.bnf.fr/ark:/12148/cb130919156#foaf:Person]
</ud>
<ud>
Thomas Le Seur (1703) Franciscain. - Professeur de mathématique à l''Université de la Sapience (Rome) [http://data.bnf.fr/ark:/12148/cb155933751#foaf:Person]
</ud>
<ud>
Gabriel Cramer (Genève, Suisse, 1704) Professeur de philosophie et de mathématiques des Académies et Sociétés royales de Londres, de Berlin, de Montpellier, de Lyon et de l''Académie de l''Institut de Bologne [http://data.bnf.fr/ark:/12148/cb15006804w#foaf:Person]
</ud>
<ud>
Guillaume Le Blond (Paris, 1704) Mathématicien [http://data.bnf.fr/ark:/12148/cb14330967m#foaf:Person]
</ud>
<ud>
Henri Michel Sauvage (Verdun, 1704) Jésuite. - Professeur d''humanités, de mathématiques et de philosophie [http://data.bnf.fr/ark:/12148/cb16180102s#foaf:Person]
</ud>
<ud>
Jacopo Belgrado (1704) Jésuite. - Physicien, mathématicien et archéologue [http://data.bnf.fr/ark:/12148/cb12161284h#foaf:Person]
</ud>
<ud>
Johann Andreas von Segner (1704) Naturaliste, mathématicien, médecin, logicien, philosophe. - Né à Presbourg (l''actuelle Bratislava), il fit toute sa carrière en Allemagne (à Iéna, Göttingen, Halle notamment) [http://data.bnf.fr/ark:/12148/cb12316478n#foaf:Person]
</ud>
<ud>
Louis Godin (Paris, 1704) Astronome, membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb15004534h#foaf:Person]
</ud>
<ud>
John Nourse (1705) Variante(s) de prénom : Jean. - Libraire ; libraire (ordinaire) de Sa Majesté (1762) ; libraire de la "Society for the Encouragement of learning". - Baptisé à Oxford le 8 juillet 1705 ; fils d''un chirurgien. En apprentissage chez le libraire de Londres John I Osborne d''août 1722 à oct. 1729. Établi vers 1730. Succède au libraire William Mears après lui avoir été associé. Spécialiste des publications scientifiques, particulièrement de mathématiques, et des éditions étrangères, de philosophes notamment. Séjourne à Paris en 1780. Décédé à Kensington en avril 1765. Son frère Charles Nourse puis Francis Wingrave lui succèdent [http://data.bnf.fr/ark:/12148/cb13605346z#foaf:Person]
</ud>
<ud>
Edme-Gilles Guyot (Paris, 1706) Les ouvrages "Nouvelles récréations physiques et mathématiques" et "Essai sur la construction des ballons aérostatiques et sur la manière de les diriger" lui sont attribués par Hoefer et Quérard. - DBF et Michaud soulignent la confusion entre lui et Guillaume-Germain Guyot pour l''attribution de ces ouvrages [http://data.bnf.fr/ark:/12148/cb14651894d#foaf:Person]
</ud>
<ud>
Girolamo Settimo (1706) Mathématicien [http://data.bnf.fr/ark:/12148/cb162655930#foaf:Person]
</ud>
<ud>
Giuseppe Maria Asclepi (1706) Jésuite, enseigna les mathématiques et les humanités [http://data.bnf.fr/ark:/12148/cb12240755t#foaf:Person]
</ud>
<ud>
Benjamin Robins (Bath, GB, 1707) Mathématicien et ingénieur militaire. - Pamphlétaire [http://data.bnf.fr/ark:/12148/cb121289860#foaf:Person]
</ud>
<ud>
Francesco Ottavio Magnocavalli (Casale, Italie, 1707) Architecte, mathématicien et poète [http://data.bnf.fr/ark:/12148/cb10732099c#foaf:Person]
</ud>
<ud>
Jean Paul Grandjean de Fouchy (Paris, 1707) Astronome. - Secrétaire perpétuel de l''Académie des Sciences (1743) [http://data.bnf.fr/ark:/12148/cb10667779b#foaf:Person]
</ud>
<ud>
José Quiroga (1707) Jésuite, mathématicien et pilote [http://data.bnf.fr/ark:/12148/cb12570261h#foaf:Person]
</ud>
<ud>
Leonhard Euler (Bâle (Suisse), 1707) Mathématicien et physicien. - Philosophe, théologien et orientaliste. - Membre de l''Académie des sciences de Saint-Pétersbourg (à partir de 1733) et de celle de Berlin (à partir de 1741), et membre associé de celle de Paris (à partir de 1755) [http://data.bnf.fr/ark:/12148/cb12157666x#foaf:Person]
</ud>
<ud>
Giovanni Francesco Mauro Melchior Salvemini da Castiglione (1708) Professeur de mathématiques à Utrecht (1751) puis directeur de la classe de mathématiques de l''Académie de Berlin. - Découvrit la solution du problème consistant à inscrire dans un cercle un triangle dont les côtés passent par trois points donnés [http://data.bnf.fr/ark:/12148/cb130145422#foaf:Person]
</ud>
<ud>
Eustachio Zanotti (Bologne, Italie, 1709) Astronome [http://data.bnf.fr/ark:/12148/cb12202196d#foaf:Person]
</ud>
<ud>
Giordano Riccati (Castelfranco Veneto, Italie, 1709) Comte. - Mathématicien, acousticien et théoricien de la musique. - Fut aussi physicien et architecte [http://data.bnf.fr/ark:/12148/cb12252383n#foaf:Person]
</ud>
<ud>
Georg Matthias Bose (Leipzig (Allemagne), 1710) Astronome, physicien, mathématicien. - Professeur de physique à l''université de Wittenberg [http://data.bnf.fr/ark:/12148/cb14065311n#foaf:Person]
</ud>
<ud>
Jacques Audierne (1710) Auteur comique et mathématicien [http://data.bnf.fr/ark:/12148/cb10425836p#foaf:Person]
</ud>
<ud>
Johann Bernoulli (1710) Mathématicien [http://data.bnf.fr/ark:/12148/cb14852857s#foaf:Person]
</ud>
<ud>
Thomas Simpson (1710) Membre de la société royale de Londres, professeur de mathématiques à Woolwich (en 1755) [http://data.bnf.fr/ark:/12148/cb103759851#foaf:Person]
</ud>
<ud>
Alexandre-Gui Pingré (Paris, 1711) Génovéfain. - Astronome. - Correspondant (à partir de 1753), puis associé libre de l''Académie des sciences. - Géographe de la Marine. - Chancelier de l''Université de Paris (1769-17..). - Bibliothécaire de Sainte-Geneviève (à partir de 1792) [http://data.bnf.fr/ark:/12148/cb12151017m#foaf:Person]
</ud>
<ud>
François Jacquier (Vitry-le-François (Marne), 1711) Religieux de l''ordre des Minimes. - Professeur de physique et mathématiques [http://data.bnf.fr/ark:/12148/cb12198105d#foaf:Person]
</ud>
<ud>
Laura Bassi (Bologne, Italie, 1711) Mathématicienne et physicienne. - Professeur de biologie et de physique à l''Université de Bologne. - Première femme titulaire d''une chaire universitaire en Europe [http://data.bnf.fr/ark:/12148/cb135103950#foaf:Person]
</ud>
<ud>
Ottaviano Cametti (Gattinara, Italie, 1711) Mathématicien, physicien et historien [http://data.bnf.fr/ark:/12148/cb10464765k#foaf:Person]
</ud>
<ud>
Pierre Joseph de Rivaz (1711) Mathématicien, inventeur-mécanicien et historien. - Directeur des salines de Moutiers. - Né dans le Valais et mort à Moutiers (Tarentaise) [http://data.bnf.fr/ark:/12148/cb128398731#foaf:Person]
</ud>
<ud>
Rugerius Josephus Boscovich (Raguse aujourd''hui Dubrovnik (Croatie), 1711) Jésuite. - Physicien, mathématicien, astronome et philosophe. - Professeur de mathématiques à Rome, Pavie et Milan. - Directeur de l''optique de la Marine royale à Paris et membre de la "Royal Society" à Londres. - Dans son ouvrage majeur "Théorie de la philosophie naturelle" il élabore la théorie initiale des forces et de la structure fondamentale de la matière, dont les concepts ont trouvé écho dans les découvertes de la physique moderne. - Il publie nombre d''ouvrages contenant ses découvertes en mathématiques, en astronomie, en géophysique et en archéologie. - Il mit au point différents instruments optiques, astronomiques et géodésiques et réalisa des expertises et des mesures hydrotechniques, géodésiques, cartographiques et statiques. - Il consolida la coupole de la basilique Saint-Pierre de Rome et de la flèche de la cathédrale de Milan [http://data.bnf.fr/ark:/12148/cb12054879x#foaf:Person]
</ud>
<ud>
Jean-Paul de Gua de Malves (Malves (Aude), 1712) Abbé. - Mathématicien, géomètre, économiste politique. - Titulaire de la chaire de philosophie au Collège de France (1742-1749) [http://data.bnf.fr/ark:/12148/cb15325204x#foaf:Person]
</ud>
<ud>
Samuel König (1712) Date de mort : 21 août ou 22 juillet 1757. - A également écrit en français. - Mathématicien, philosophe et juriste [http://data.bnf.fr/ark:/12148/cb120941298#foaf:Person]
</ud>
<ud>
Alexis Claude Clairaut (Paris (France), 1713) Mathématicien très précoce et astronome. - Ami de Voltaire et de la marquise Du Chatelet [http://data.bnf.fr/ark:/12148/cb124002538#foaf:Person]
</ud>
<ud>
Giammaria Ortes (1713) Moine camaldule. - Mathématicien, économiste et philosophe [http://data.bnf.fr/ark:/12148/cb13753557w#foaf:Person]
</ud>
<ud>
Nicolas-Louis de La Caille (Rumigny, Ardennes, 1713) Abbé. - Professeur de mathématiques au Collège Mazarin. - Membre de l''Académie royale des sciences [http://data.bnf.fr/ark:/12148/cb12124353d#foaf:Person]
</ud>
<ud>
Alessandro Vittorio Papacino d''Antoni (Villafranca, Italie, 1714) Ingénieur, mathématicien. - Membre de l''Académie des sciences de Turin [http://data.bnf.fr/ark:/12148/cb10709482t#foaf:Person]
</ud>
<ud>
César-François Cassini de Thury (Thury-sous-Clermont (Oise), 1714) Astronome et géomètre. - Membre de l''Académie des sciences (1736). - Fils de Jacques Cassini (1677-1756) et père de Jean-Dominique Cassini (1748-1845). - Participa avec son père à la mesure de la perpendiculaire de l''Observatoire. - Son oeuvre principale est la carte de France, première carte de base de ce pays, dont la publication commença en 1756 [http://data.bnf.fr/ark:/12148/cb12241101g#foaf:Person]
</ud>
<ud>
Giovanni Battista Audiffredi (Saorge, Italie, 1714) Dominicain. - Astronome. - Préfet de la Biblioteca Casanatense, Rome (1759-1794). - Né Giulio Cesare Audiffredi, change de prénom en entrant chez les Dominicains (1730) [http://data.bnf.fr/ark:/12148/cb13595556h#foaf:Person]
</ud>
<ud>
John Winthrop (1714) Professeur de Mathématiques et de Philosophie naturelle à Harvard [http://data.bnf.fr/ark:/12148/cb14594660x#foaf:Person]
</ud>
<ud>
François-Joachim Duport-Dutertre (Saint-Servan (Ille-et-Vilaine), 1715) Littérateur. - Mathématicien. - Voyageur [http://data.bnf.fr/ark:/12148/cb12533121w#foaf:Person]
</ud>
<ud>
Pierre-Charles Le Monnier (Paris, 1715) Astronome. - Membre de l''Académie des sciences (1741). - Professeur de physique au Collège de France (de 1749 à 1793), puis membre de la classe des sciences physiques et mathématiques de l''Institut [http://data.bnf.fr/ark:/12148/cb121064574#foaf:Person]
</ud>
<ud>
André-Pierre Le Guay de Prémontval (Charenton (Val-de-Marne), 1716) Professeur de mathématiques. - Membre de l''Académie de Berlin [http://data.bnf.fr/ark:/12148/cb122271303#foaf:Person]
</ud>
<ud>
Eugénios Voúlgaris (Corfou (Îles Ioniennes, Grèce), 1716) Métropolite de l''Église orthodoxe grecque. - Théologien, philosophe et mathématicien. - "Éducateur de la Nation" et précurseur des Lumières en Grèce ; traducteur de Voltaire et Virgile. - Nommé évêque en Russie [http://data.bnf.fr/ark:/12148/cb12564304q#foaf:Person]
</ud>
<ud>
Gottfried Ploucquet (1716) Philosophe, mathématicien et théologien. - Professeur de philosophie à l''université de Tübingen (1750-1782) [http://data.bnf.fr/ark:/12148/cb13324024g#foaf:Person]
</ud>
<ud>
Leonardo Ximenes (Trapani, Italie, 1716) Jésuite. - Geographe, astronome, mathématicien [http://data.bnf.fr/ark:/12148/cb106577403#foaf:Person]
</ud>
<ud>
D'' Alembert (Paris, 1717) Mathématicien et philosophe. - Nom patronymique : Jean Le Rond, d̲i̲t̲ d'' Alembert. - Membre de l''Institut, Académie française (élu en 1754) [http://data.bnf.fr/ark:/12148/cb118883708#foaf:Person]
</ud>
<ud>
Josef Anton Nagel (1717) Professeur, mathématicien, scientifique allemand [http://data.bnf.fr/ark:/12148/cb12091922b#foaf:Person]
</ud>
<ud>
Augustin Darquier de Pellepoix (Toulouse, 1718) Astronome. - Associé non résidant de l''Académie des sciences. - Receveur des tailles de la généralité d''Auch [http://data.bnf.fr/ark:/12148/cb12155190x#foaf:Person]
</ud>
<ud>
Claude-François Berthelot (1718) Ingénieur. - Professeur de mathématiques à l''École royale militaire. - Inventeur de l''"affut de Gribeauval" [http://data.bnf.fr/ark:/12148/cb134984423#foaf:Person]
</ud>
<ud>
François-César Le Tellier Courtanvaux (1718) Duc de Doudeauville. - Capitaine-colonel des cent-suisses de la garde du roi. - Astronome, membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb121904446#foaf:Person]
</ud>
<ud>
Gaspard-François-Anne de Forbin (1718) Né le 8 ou le 18 juillet 1718. - Embrassa d'' abord la carrière militaire. - Chevalier de Malte. - Mathématicien et Physicien [http://data.bnf.fr/ark:/12148/cb12108181n#foaf:Person]
</ud>
<ud>
István Hatvani (Rimaszombat, aujourd''hui Rimavská Sobota, Slovaquie, 1718) Mathématicien, physicien. - Médecin. - Pédagogue, professeur à Debrecen,Református Kollégium, Hongrie. - Diplômé de l''Université de Bâle, Suisse [http://data.bnf.fr/ark:/12148/cb10355679v#foaf:Person]
</ud>
<ud>
Jean-Philippe Loys de Chéseaux (1718) Astronome et physicien. - Né à Lausanne, mort à Paris [http://data.bnf.fr/ark:/12148/cb133196302#foaf:Person]
</ud>
<ud>
Joseph Amiot (Toulon, 1718) Jésuite de 1737 à 1773 (ordonné prêtre en 1749). - Sinologue et astronome. - Missionnaire en Chine (à partir de 1749) [http://data.bnf.fr/ark:/12148/cb12112654w#foaf:Person]
</ud>
<ud>
Maria Gaetana Agnesi (Milan, Italie, 1718) Mathématicienne [http://data.bnf.fr/ark:/12148/cb105423187#foaf:Person]
</ud>
<ud>
Abraham Gotthelf Kästner (Leipzig, Allemagne, 1719) Mathématicien. - Poète et épigrammatiste. - Critique [http://data.bnf.fr/ark:/12148/cb123392338#foaf:Person]
</ud>
<ud>
Giuseppe Toaldo (Pianezze, Italie, 1719) Prêtre. - Physicien. - Professeur d''astronomie, de géographie et de météorologie à l''Université de Padoue [http://data.bnf.fr/ark:/12148/cb10578331h#foaf:Person]
</ud>
<ud>
Jens Kraft (1720) Philosophe des lumières danois. - Professeur de mathématiques et de philosophie à Soroe [http://data.bnf.fr/ark:/12148/cb12442689p#foaf:Person]
</ud>
<ud>
Charles Walmesley (1722) Évêque de Rama. - Astronome [http://data.bnf.fr/ark:/12148/cb10748264x#foaf:Person]
</ud>
<ud>
Jean Chappe d''Auteroche (Mauriac (Cantal), 1722) Astronome. - Explorateur en Sibérie et en Californie [http://data.bnf.fr/ark:/12148/cb12402595h#foaf:Person]
</ud>
<ud>
Jean-Louis Dupain-Triel (1722) Homme de lettres, poète. - S''intéressa aux mathématiques, à la géographie et à l''enseignement des arts [http://data.bnf.fr/ark:/12148/cb119011560#foaf:Person]
</ud>
<ud>
Louis-Jacques Goussier (1722) Mathématicien et inventeur [http://data.bnf.fr/ark:/12148/cb13485055d#foaf:Person]
</ud>
<ud>
Baien Miura (1723) Lettré du milieu de l''époque d''Edo. - A créé son propre système de pensée philosophique appelé "jōrigaku" : méthode de spéculation fondée sur l''éthique, la logique, les mathématiques et la physique, recourant à une pensée dialectique appelée "hankan gōitsu" [http://data.bnf.fr/ark:/12148/cb12293200x#foaf:Person]
</ud>
<ud>
Didier Robert de Vaugondy (1723) Géographe ordinaire du roi, professeur de mathématiques et de géographie, fils de Gilles Robert Vaugondy. - Didier signe "Robert de Vaugondy" [http://data.bnf.fr/ark:/12148/cb12380757h#foaf:Person]
</ud>
<ud>
Étienne-Nicolas Blondeau (1723) Professeur de mathématiques. - Ingénieur de la marine. - Collaborateur de l''Encyclopédie méthodique (1782-1783?) [http://data.bnf.fr/ark:/12148/cb10737141j#foaf:Person]
</ud>
<ud>
Johann Tobias Mayer (1723) Mathématicien et astronome, a travaillé avec Homann Herben de 1746 à 1751, puid pour Kilian à partir de 1752 [http://data.bnf.fr/ark:/12148/cb153509764#foaf:Person]
</ud>
<ud>
Johann Tobias Mayer (1723) Astronome allemand [http://data.bnf.fr/ark:/12148/cb11958863x#foaf:Person]
</ud>
<ud>
Nicole-Reine Lepaute (Paris, 1723) Née Nicole-Reine Étable de La Brière, épouse de Jean-André Lepaute, horloger du Roi. - Mathématicienne, astronome [http://data.bnf.fr/ark:/12148/cb14555447k#foaf:Person]
</ud>
<ud>
Tobias Mayer (Marbach (Allemagne), 1723) Astronome, mathématicien. - Directeur de l''Observatoire de Göttingen, Allemagne [http://data.bnf.fr/ark:/12148/cb121551484#foaf:Person]
</ud>
<ud>
Edme-Sébastien Jeaurat (1724) Ingénieur-géographe et astronome. - Professeur à l''école militaire. - Membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb122175393#foaf:Person]
</ud>
<ud>
François Para Du Phanjas (Chabottes (Hautes-Alpes), 1724) Philosophe et mathématicien [http://data.bnf.fr/ark:/12148/cb12528863r#foaf:Person]
</ud>
<ud>
Georges Louis Lesage (Genève, 1724) Mathématicien et physicien suisse. - Etudie à Genève puis Paris. - Etabli à Genève [http://data.bnf.fr/ark:/12148/cb155857475#foaf:Person]
</ud>
<ud>
Guillaume-Germain Guyot (Orléans, 1724) Les ouvrages "Nouvelles récréations physiques et mathématiques" et "Essai sur la construction des ballons aérostatiques et sur la manière de les diriger" lui sont attribués par le DBF et par Samuel Ersch dans "La France littéraire contenant les auteurs français de 1771 à 1796", DBF. - Quérard et Michaud soulignent la confusion entre lui et Edme-Gilles Guyot pour l''attribution de ces ouvrages [http://data.bnf.fr/ark:/12148/cb12214218k#foaf:Person]
</ud>
<ud>
Guillaume-Hyacinthe-Joseph-Jean-Baptiste Le Gentil de La Galaisière (1725) Astronome et voyageur. - Entre à l''Observatoire en 1750. - Membre de l''Académie des sciences en 1753 [http://data.bnf.fr/ark:/12148/cb12151459n#foaf:Person]
</ud>
<ud>
Jean-Étienne Montucla (1725) Historien des mathématiques [http://data.bnf.fr/ark:/12148/cb12127574n#foaf:Person]
</ud>
<ud>
Louis-Charles Desnos (1725) Libraire ; libraire et (ingénieur) géographe (pour les globes et les sphères) du roi de Danemark (ou : de Sa Majesté danoise) (1769-1789). - Fils d''un marchand drapier de Pont-Sainte-Maxence (Oise). Apprenti fondeur de caractères à Paris à partir d''avril 1745 (reçu maître fondeur en 1757).  Ingénieur géographe (de la ville de Paris à partir de 1769), fabricant et marchand de sphères et d''instruments astronomiques établi vers 1753 en succession de Jacques Hardy, après avoir épousé en 1749 la veuve de son fils Nicolas Hardy ; également marchand d''estampes et de cartes géographiques. Un des 12 libraires non jurés reçus le 4 oct. 1767. - Éditeur et auteur de nombreux atlas, almanachs et publications géographiques entre 1756 et 1795 env. Rédige également plusieurs catalogues de son fonds entre 1768 et 1792. Une partie de son fonds est rachetée en 1805 par Jean (17..-1839), marchand de cartes et d''estampes [http://data.bnf.fr/ark:/12148/cb12402252d#foaf:Person]
</ud>
<ud>
Rigobert Bonne (Raucourt (Meurthe-et-Moselle), 1727) Ingénieur. - Géographe. - Hydrographe. - Célèbre par la projection qui porte son nom et qui remplacera pour la carte de France la projection de Cassini. D''abord ingénieur géographe et maître de mathématiques. En 1775 ingénieur hydrographe de la Marine. Fut mis à la retraite contre sa volonté en 1789. Collabora au Neptune américo-septentrional [http://data.bnf.fr/ark:/12148/cb12169793s#foaf:Person]
</ud>
<ud>
Chrysologue de Gy (Gy (Haute-Saône), 1728) Capucin. - Astronome, cartographe et géologue [http://data.bnf.fr/ark:/12148/cb10728734z#foaf:Person]
</ud>
<ud>
Jean-Henri Lambert (Mulhouse, Suisse, 1728) Mathématicien, physicien, astronome et philosophe. - Spécialiste de géometrie. - En poste à l''Académie royale des sciences et belles lettres de Berlin (de 1765 à 1777) [http://data.bnf.fr/ark:/12148/cb12359659g#foaf:Person]
</ud>
<ud>
Le P.  Chrysologue (Gy, 1728) Capucin, nom de religion de Noël André. - Attiré par la géographie et l''astronomie, fut l''élève de Lemonnier. Mesura les altitudes des Vosges, du Jura et des Alpes. Se retira dans sa famille au moment de la Révolution.  En 1806 publia un important traité de géologie dont Cuvier fit un rapport élogieux [http://data.bnf.fr/ark:/12148/cb153054042#foaf:Person]
</ud>
<ud>
Paolo Frisi (Melegnano, Italie, 1728) Barnabite. - Mathématicien, astronome et écrivain. - Professeur dans les Écoles palatines de Milan (1764-) [http://data.bnf.fr/ark:/12148/cb120849325#foaf:Person]
</ud>
<ud>
Antonio Eximeno (1729) Théoricien de la musique et polémiste. - Jésuite, il devient professeur de rhétorique à l''Université de Valence, puis professeur de mathématiques à l''Académie militaire de Ségovie (1764). - Lorsque les jésuites sont expulsés d''Espagne en 1767, il se rend à Rome où il étudie la musique. - Connu aussi sous le pseud. : "Aristosseno Megareo" (BnF, Musique, fichier général auteurs), ou "Aristodemo Megareo" (Fétis) [http://data.bnf.fr/ark:/12148/cb13755053m#foaf:Person]
</ud>
<ud>
Charles Bossut (1730) Mathématicien, membre de l''Académie des sciences (1779), il participa à la rédaction de la partie mathématique de l''Encyclopédie [http://data.bnf.fr/ark:/12148/cb11763983g#foaf:Person]
</ud>
<ud>
Charles Bossut (1730) Mathématicien et physicien. - Membre de l''Académie des sciences, pensionnaire de la classe de mécanique (1785). - Écrivit plusieurs articles dans l''"Encyclopédie" [http://data.bnf.fr/ark:/12148/cb124599882#foaf:Person]
</ud>
<ud>
Charles Messier (Badonviller (Meurthe-et-Moselle), 1730) Astronome de la marine. - Académicien (1770). - Membre de l''Institut [http://data.bnf.fr/ark:/12148/cb124827900#foaf:Person]
</ud>
<ud>
Étienne Bezout (Nemours, 1730) Mathématicien. - Membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb12267459g#foaf:Person]
</ud>
<ud>
Jean-Baptiste de Laborde (1730) Physicien et mathématicien. - Jésuite [http://data.bnf.fr/ark:/12148/cb13196726p#foaf:Person]
</ud>
<ud>
Joseph-Aignan Sigaud de La Fond (Bourges, 1730) Mathématicien, physicien et moraliste. - Professeur de physique à Bourges [http://data.bnf.fr/ark:/12148/cb12401095w#foaf:Person]
</ud>
<ud>
Pierre-Thomas Antelmy (Trigance, France, 1730) Mathématicien, professeur de mathématiques à l''École militaire [http://data.bnf.fr/ark:/12148/cb13011110m#foaf:Person]
</ud>
<ud>
Benito Bails (1731) Mathématicien [http://data.bnf.fr/ark:/12148/cb162593727#foaf:Person]
</ud>
<ud>
Girolamo Francisco Cristiani (Brescia, Italie, 1731) Mathématicien et physicien [http://data.bnf.fr/ark:/12148/cb14065297x#foaf:Person]
</ud>
<ud>
Nicolas-Claude Duval-Le Roy (1731) Professeur de mathématiques et d''hydrographie, physicien et astronome. - Membre de l''Académie royale de marine. - Correspondant à l''Académie royale des sciences (1789), associé non résident de l''Institut (1796) [http://data.bnf.fr/ark:/12148/cb12548660k#foaf:Person]
</ud>
<ud>
Diderich Christian Fester (1732) Mathématicien et cartographe à Trondheim [http://data.bnf.fr/ark:/12148/cb15384550x#foaf:Person]
</ud>
<ud>
Jérôme de La Lande (Bourg-en-Bresse (Ain), 1732) Astronome. - Membre de l''Académie de Berlin. - Membre de l''Académie des sciences (1753). - Professeur d''astronomie au Collège de France (1762). - Directeur de l''Observatoire de Paris de 1768 à sa mort [http://data.bnf.fr/ark:/12148/cb12012398h#foaf:Person]
</ud>
<ud>
Maurille-Antoine Moithey (1732) Éditeur et marchand de cartes géographiques ; libraire. - Ingénieur géographe du Roi et professeur de mathématiques des pages du prince et de la princesse de Conti. Auteur de plans, de cartes, d''ouvrages illustrés et d''atlas, qu''il publie et diffuse parfois lui-même de 1776 à 1792 au moins. Auteur notamment d''un "Dictionnaire hydrographique de la France..." (1re éd., l''auteur, 1787 ; rééd., Paris, Blanchon, 1803) et d''une série de "Recherches historiques" sur les villes de France (Angers, Orléans, Reims, 1775-1776). Se qualifie de libraire en 1791-1792. Décédé à Paris le 21 frimaire an XIV (12 déc. 1805, Arch. de Paris) [http://data.bnf.fr/ark:/12148/cb13531657x#foaf:Person]
</ud>
<ud>
Nevil Maskelyne (1732) Astronome royal d''Angleterre. - Membre associé de l''Académie des sciences de Paris [http://data.bnf.fr/ark:/12148/cb12155150p#foaf:Person]
</ud>
<ud>
Jacques-François Dicquemare (Le Havre, 1733) Astronome. - Hydrographe. - Zoologue marin [http://data.bnf.fr/ark:/12148/cb15317071s#foaf:Person]
</ud>
<ud>
János Sajnovics (Tordas, Hongrie, 1733) Astronome. - Linguiste. - Père jésuite [http://data.bnf.fr/ark:/12148/cb12246417w#foaf:Person]
</ud>
<ud>
Jean-Charles Borda (Dax (Landes), 1733) Officier de marine. - Membre de l''Académie de Marine (élu en 1769). - Entra dans le Génie militaire et se fit remarquer par ses travaux sur l''hydraulique. - Il détermina la longitude des Canaries (en 1776). - Prit part à la guerre d''indépendance américaine. - Participa avec Delambre et Méchain à la mesure de l''arc de méridien Dunkerque-Barcelone. - En qualité de commissaire de l''Académie des sciences participa à l''étude des montres marines sur la frégate la Flore (en 1771). - Membre de l''Institut, Académie des sciences (élu en 1772). - Membre de la Commission des poids et mesures (en 1791), il travailla à l''établissement du système métrique. - Membre de l''Institut national des sciences et arts, section mathématiques (actuel Institut de France) et du Bureau des longitudes (en 1795). - Co-fondateur de La Société de Borda (créée en 1876), avec Jacques-François de Borda d''Oro (1718-1804) [http://data.bnf.fr/ark:/12148/cb12482831r#foaf:Person]
</ud>
<ud>
Samuel Horsley (1733) Evêque; secrétaire de la Royal Society; publia des livres de théologie et de mathématiques [http://data.bnf.fr/ark:/12148/cb120697374#foaf:Person]
</ud>
<ud>
Achille Pierre Dionis du Séjour (Paris, 1734) Astronome et mathématicien [http://data.bnf.fr/ark:/12148/cb10680537k#foaf:Person]
</ud>
<ud>
Baudouin de Guémadeuc (1734) Homme de loi, homme de lettres, pamphlétaire puis astronome [http://data.bnf.fr/ark:/12148/cb144447840#foaf:Person]
</ud>
<ud>
Charles Duvaucel (1734) Astronome, spécialisé dans les éclipses du soleil. [http://data.bnf.fr/ark:/12148/cb15318527x#foaf:Person]
</ud>
<ud>
Mathieu Bernard Goudin (Paris, 1734) Magistrat. - Mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb10586154b#foaf:Person]
</ud>
<ud>
Alexandre-Théophile Vandermonde (Paris, 1735) Mathématicien [http://data.bnf.fr/ark:/12148/cb12534847r#foaf:Person]
</ud>
<ud>
Antonio Maria Lorgna (Cerea, Italie, 1735) Mathématicien [http://data.bnf.fr/ark:/12148/cb12387058m#foaf:Person]
</ud>
<ud>
Gregorio Fontana (Villa di Nogaredo, Italie, 1735) Mathématicien et physicien. - Recteur et professeur de calcul sublime à l''Ateneo lombardo. - Bibliothécaire du Collegio Ghisleri, Pavie [http://data.bnf.fr/ark:/12148/cb10601676b#foaf:Person]
</ud>
<ud>
Giovanni-Antonio Rizzi-Zannoni (Padoue, Italie, 1736) Géographe de la république de Venise, astronome, il voyage en Amérique du nord en 1757 [http://data.bnf.fr/ark:/12148/cb153024615#foaf:Person]
</ud>
<ud>
Jean Sylvain Bailly (Paris, 1736) Mathématicien, astronome et homme politique. - Entre à l''Académie des sciences (en 1763), à l''Académie française (en 1784) puis à l''Académie des inscriptions (en 1785). - Député du Tiers-État aux États-Généraux ; Maire de Paris ; Député à l''Assemblée Nationale Constituante [http://data.bnf.fr/ark:/12148/cb12516744h#foaf:Person]
</ud>
<ud>
Johann Nicolai Tetens (Tetenbüll, Allemagne, 1736) Mathématicien, physicien et philosophe [http://data.bnf.fr/ark:/12148/cb12531163b#foaf:Person]
</ud>
<ud>
Joseph-Louis Lagrange (1736) Mathématicien. - D''origine italienne. - A été à l''origine de la fondation de l''Académie des sciences de Turin. - Membre de l''Académie des sciences de Paris, Berlin, Turin. - A partir de 1787, enseigne à Paris à l''École normale et à l''École polytechnique [http://data.bnf.fr/ark:/12148/cb12125247f#foaf:Person]
</ud>
<ud>
Francesco Venini (Varenna, Italie, 1737) Abbé. - Mathématicien et poète [http://data.bnf.fr/ark:/12148/cb105963005#foaf:Person]
</ud>
<ud>
Giuseppe Maria Pagnini (Pistoia, Italie, 1737) Au siècle : Luca Antonio ; en religion, carme : Giuseppe Maria. - Poète. - Mathématicien. - Savant latiniste et helléniste. - Professeur à l'' Université de Parme puis de Pise [http://data.bnf.fr/ark:/12148/cb11996942k#foaf:Person]
</ud>
<ud>
Tommaso Valperga di Caluso (Turin, Italie, 1737) Abbé. - Homme de lettres, philosophe et mathématicien. - Chevalier de Malte [http://data.bnf.fr/ark:/12148/cb10748197m#foaf:Person]
</ud>
<ud>
William Bayly (1737) Astronome [http://data.bnf.fr/ark:/12148/cb14065321z#foaf:Person]
</ud>
<ud>
Charles-Joseph Mathon de La Cour (Lyon (Rhône), 1738) Économiste. - Philanthrope. - Fondateur du "Journal de Lyon". - Rédacteur de "L''Almanach musical" (1775-1778), et au "Journal de musique", Paris (1764-1768). - Fils de : Mathon de La Cour, Jacques (1712-1770), mathématicien [http://data.bnf.fr/ark:/12148/cb121925904#foaf:Person]
</ud>
<ud>
Flecheux (1738) Astronome et mécanicien français. - Adresse en 1784 : Paris, rue du Sentier, hôtel de madame la présidente de Meslay, n° 31 [http://data.bnf.fr/ark:/12148/cb15585605z#foaf:Person]
</ud>
<ud>
Joseph-François Marie (Rodez, 1738) Abbé. - Fut professeur de mathématiques au Collège Mazarin [http://data.bnf.fr/ark:/12148/cb146364765#foaf:Person]
</ud>
<ud>
Thomas Abbt (Ulm, Allemagne, 1738) Écrivain, philosophe, mathématicien, juriste et conseiller aulique [http://data.bnf.fr/ark:/12148/cb125347464#foaf:Person]
</ud>
<ud>
William Herschel (Hanovre, Allemagne, 1738) Astronome et compositeur. - A découvert la planète Uranus. - S''installe en Grande-Bretagne en 1757 [http://data.bnf.fr/ark:/12148/cb14064893z#foaf:Person]
</ud>
<ud>
Ermenegildo Pini (Milan, Italie, 1739) Barnabite. - Physicien, géologue, architecte. - Professeur de mathématiques, puis d''histoire naturelle au Collège Saint-Alexandre, Milan. - Dans le siècle : Pini, Carlo [http://data.bnf.fr/ark:/12148/cb13013593q#foaf:Person]
</ud>
<ud>
Jean-Louis Pictet (1739) Astronome [http://data.bnf.fr/ark:/12148/cb146402484#foaf:Person]
</ud>
<ud>
Johann Schultz (1739) A été professeur de mathématiques à l''université de Königsberg, Allemagne [http://data.bnf.fr/ark:/12148/cb121741380#foaf:Person]
</ud>
<ud>
José Antonio Alzate y Ramírez (1739) Astronome et géographe [http://data.bnf.fr/ark:/12148/cb15376450x#foaf:Person]
</ud>
<ud>
András Dugonics (Szeged (Hongrie), 1740) Écrivain. - Poète. - Piariste. - Professeur de mathématiques. - A fait des études de théologie  à Privigye (aujourd''hui Prievidza, Slovaquie) et à Nyitra (aujourd''hui Nitra, Slovaquie) [http://data.bnf.fr/ark:/12148/cb12246575b#foaf:Person]
</ud>
<ud>
Jacques-André Mallet (1740) Astronome [http://data.bnf.fr/ark:/12148/cb10552198c#foaf:Person]
</ud>
<ud>
Joseph Anton Slop von Cadenberg (1740) Astronome. - À l''Observatoire de Pise à partir de 1765 [http://data.bnf.fr/ark:/12148/cb12159312n#foaf:Person]
</ud>
<ud>
Nicola Spedalieri (Bronte (Italie), 1740) Professeur de philosophie, théologie et mathématique, poète, musicien, historien [http://data.bnf.fr/ark:/12148/cb16219670j#foaf:Person]
</ud>
<ud>
Nicolas-Antoine Nouet (1740) Astronome. - Attaché à l''Observatoire en 1785. - Participe à l''expédition d''Égypte en 1798. - Ingénieur au Bureau de la guerre en 1802 [http://data.bnf.fr/ark:/12148/cb12151453k#foaf:Person]
</ud>
<ud>
Thomas Bugge (Copenhague, 1740) Astronome et cartographe [http://data.bnf.fr/ark:/12148/cb121931908#foaf:Person]
</ud>
<ud>
Vicente Tofiño de San Miguel (1740) Astronome. - Capitaine de vaisseau. - Directeur des compagnies des gardes royales de la marine en 1786. - Membre de l''Académie d''histoire de Madrid. - Correspondant de l''Académie des sciences de Paris [http://data.bnf.fr/ark:/12148/cb12159995t#foaf:Person]
</ud>
<ud>
Alexis Rochon (Brest (Finistère), 1741) Prêtre, astronome de la marine, physicien et inventeur. - Bibliothécaire de l''Académie royale de marine à Brest (1765-), astronome opticien de la Marine (1787), membre de la Commission des poids et mesures et des monnaies (1792). - Membre de l''Académie royale des sciences, puis membre de l''Institut. - Clerc tonsuré [http://data.bnf.fr/ark:/12148/cb129983745#foaf:Person]
</ud>
<ud>
Stanislaw Wydra (1741) Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb15512813z#foaf:Person]
</ud>
<ud>
Vincenzo Chiminello (Marostica, Italie, 1741) Abbé. - Astronome [http://data.bnf.fr/ark:/12148/cb10522164f#foaf:Person]
</ud>
<ud>
Georg Jonathan von Holland (1742) Théologien. - Mathématicien. - Précepteur des princes de Wurttemberg [http://data.bnf.fr/ark:/12148/cb119076602#foaf:Person]
</ud>
<ud>
Jacques Poitevin (Montpellier, 1742) Savant astronome et agriculteur. - Conseiller de préfecture du département de l''Hérault. - Membre de la Société royale des sciences de Montpellier [http://data.bnf.fr/ark:/12148/cb10644654k#foaf:Person]
</ud>
<ud>
Antonio Cagnoli (Zante, Grèce, 1743) Astronome et mathématicien. - Crée un observatoire d''astronomie à Vérone. - Enseigne les mathématiques à l''École militaire de Modène après la prise de Vérone par les Français (1797). - Membre de nombreuses académies d''Europe [http://data.bnf.fr/ark:/12148/cb12562781s#foaf:Person]
</ud>
<ud>
Eberhard August Wilhelm von Zimmermann (Uelzen, Allemagne, 1743) Géographe et naturaliste. - Professeur de mathématiques et de sciences naturelles au Collegium Carolinum de Brunswick de 1766 à 1815. - Conseiller aulique en 1786, puis conseiller d''état en 1801 [http://data.bnf.fr/ark:/12148/cb12330956p#foaf:Person]
</ud>
<ud>
Jean-Antoine-Nicolas de Caritat Condorcet (1743) Philosophe, mathématicien et  économiste. - Membre de l''Académie française (1782). - Homme politique. - A aussi écrit sous le pseudonyme M. Schwartz, pasteur à Bienne [http://data.bnf.fr/ark:/12148/cb118975118#foaf:Person]
</ud>
<ud>
Etienne Lenoir (1744) Ingénieur. - Mit au point plusieurs instruments d''astronomie et de géodésie [http://data.bnf.fr/ark:/12148/cb151423156#foaf:Person]
</ud>
<ud>
François Callet (Versailles, 1744) Professeur de mathématiques et d''hydrographie [http://data.bnf.fr/ark:/12148/cb10544471f#foaf:Person]
</ud>
<ud>
Jean Bernoulli (Bâle, Suisse, 1744) Mathématicien, astronome. - Membre des Académies des sciences de Berlin, de Petersbourg, de Stockholm, de Bologne, de Lyon, &amp; de Marseille, de la Société pour l''encouragement des arts, de Londres, de celle des physiciens de Bâle, de l''Académie des Arcades de Rome [http://data.bnf.fr/ark:/12148/cb14508854n#foaf:Person]
</ud>
<ud>
José Anastácio da Cunha (1744) Poète portugais. - Mathématicien, professeur de géométrie à l''Université de Coimbra. - Officier d''artillerie à Valença do Minho (1764-1778) [http://data.bnf.fr/ark:/12148/cb121612626#foaf:Person]
</ud>
<ud>
Pierre Méchain (Laon, 1744) Astronome français. - Prénoms complets : Pierre François André [http://data.bnf.fr/ark:/12148/cb12090251r#foaf:Person]
</ud>
<ud>
Caspar Wessel (Vestby, Norvège, 1745) Mathématicien. - Reçut la médaille d''argent de la Royal Danish academy [http://data.bnf.fr/ark:/12148/cb12563002z#foaf:Person]
</ud>
<ud>
Claude-François Guillemeau de Fréval (Paris, 1745) Mathématicien [http://data.bnf.fr/ark:/12148/cb10017540p#foaf:Person]
</ud>
<ud>
Franz von Paula Triesnecker (1745) Astronome [http://data.bnf.fr/ark:/12148/cb15115995f#foaf:Person]
</ud>
<ud>
Fulcrand Jean Joseph Aigrefeuille (1745) Gastronome [http://data.bnf.fr/ark:/12148/cb16296114m#foaf:Person]
</ud>
<ud>
Johann Hieronymus Schröter (1745) Magistrat et astronome amateur allemand [http://data.bnf.fr/ark:/12148/cb11973603q#foaf:Person]
</ud>
<ud>
Nicolas Charles Romme (Riom, Puy-de-Dôme, 1745) Professeur de mathématiques et de navigation à l''École de Rochefort. - Membre de l''Institut [http://data.bnf.fr/ark:/12148/cb12805333t#foaf:Person]
</ud>
<ud>
Gaetano Del Ricco (1746) Piariste (17 mai 1761). - Mathématicien. - Librettiste. - Prénom de baptême : Vincenzo [http://data.bnf.fr/ark:/12148/cb16659347q#foaf:Person]
</ud>
<ud>
Gaspard Monge (1746) Mathématicien et géomètre. - Fondateur de l''École polytechnique et de l''École normale. - Président de l''Institut du Caire. - Membre de l''Institut, Académie des sciences. - Député au Conseil des Cinq-Cents, au Conseil des Anciens, ministre de la Marine (1792), sénateur (1799), comte de Péluse (1808) [http://data.bnf.fr/ark:/12148/cb121412336#foaf:Person]
</ud>
<ud>
Giovanni Battista Venturi (Bibbiano, Italie, 1746) Physicien et mathématicien. - Homme politique et diplomate [http://data.bnf.fr/ark:/12148/cb127228927#foaf:Person]
</ud>
<ud>
Giuseppe Piazzi (Ponte di Valtellina, Italie, 1746) Astronome [http://data.bnf.fr/ark:/12148/cb12920801z#foaf:Person]
</ud>
<ud>
Jean-Claude-Gauthier-Louis de Benaben (1746) Oratorien et professeur de mathématiques. - Fut directeur de l''Ecole centrale d''Angers. - Fut président des Amis de la Constitution. - Fut commissaire civil du département de Maine-et-Loire [http://data.bnf.fr/ark:/12148/cb125680474#foaf:Person]
</ud>
<ud>
Jean Foucaud (1747) Prédicateur, mathématicien, philologue. - A écrit en patois limousin des fables imitées de La Fontaine, qu''il a aussi traduit dans cette même langue. - Fut l''un des rédacteurs du "Journal du département de la Haute-Vienne". - Fut à Limoges une personalité agissante du Club des jacobins, membre du Comité de salut public, juge de paix et payeur du département de Haute-Vienne. - Défroqué en 1793, il mourut réconcilié avec l''Église [http://data.bnf.fr/ark:/12148/cb119031941#foaf:Person]
</ud>
<ud>
Jean-Baptiste Bernard (1747) Libraire ; libraire de l''École polytechnique (1800) ; de l''École des Ponts et Chaussées (1801) ; des Écoles impériales polytechnique et des Ponts et chaussées (1805). - Né à Marseille. Libraire spécialisé dans les "mathématiques, sciences et arts", il travaille jusqu''en 1796 en association avec Régent au bureau du "Journal polytechnique" ou "Bulletin des Travaux publics..." Historien et philologue, éditeur des "Œuvres posthumes" de Montesquieu. Décédé à Saint-Maur-des-Fossés (Val-de-Marne) en oct. 1808. Sa veuve lui succède avant de revendre son fonds en 1810 à Jean Klostermann [http://data.bnf.fr/ark:/12148/cb122388832#foaf:Person]
</ud>
<ud>
Johann Elert Bode (Hambourg (Allemagne), 1747) Astronome [http://data.bnf.fr/ark:/12148/cb104634498#foaf:Person]
</ud>
<ud>
Andreas Riedel (Vienne, 1748) Jacobin viennois. - Professeur de mathématiques, précepteur des enfants du Grand duc Léopold, futur empereur,  1779-1790, Florence (Italie). - Études de médecine, élève du professeur Franz Anton Mesmer. - Emprisonné à Brno (1806-1809). - Se réfugia en France 1810-1837 [http://data.bnf.fr/ark:/12148/cb14593357z#foaf:Person]
</ud>
<ud>
Jean-Dominique Cassini (1748) Astronome. - Membre de l''Académie des sciences (1770). - Fils de l''astronome César-François Cassini (1714-1784), qui était aussi appelé Cassini de Thury, car né à Thury (Oise) en 1714. - Succède à son père comme directeur de l''Observatoire de Paris (en 1784) [http://data.bnf.fr/ark:/12148/cb12157999q#foaf:Person]
</ud>
<ud>
Pietro Cossali (Vérone, Italie, 1748) Mathématicien. - A enseigné à l''université de Padoue [http://data.bnf.fr/ark:/12148/cb146340668#foaf:Person]
</ud>
<ud>
Pons-Joseph Bernard (1748) Mathématicien. - Directeur adjoint de l''Observatoire de Marseille [http://data.bnf.fr/ark:/12148/cb12306722n#foaf:Person]
</ud>
<ud>
Thaddäus Rinderle (1748) Moine bénédictin, mathématicien et horloger [http://data.bnf.fr/ark:/12148/cb15037954k#foaf:Person]
</ud>
<ud>
Giuseppe Calandrelli (Zagarolo, Italie, 1749) Astronome. - Directeur du "Collegio romano" [http://data.bnf.fr/ark:/12148/cb10544460s#foaf:Person]
</ud>
<ud>
Henri Bouchon-Dubournial (1749) Ingénieur et mathématicien. - Fut professeur à l''Ecole militaire et l''Ecole royale militaire. - Fut le traducteur de Cervantès [http://data.bnf.fr/ark:/12148/cb125620183#foaf:Person]
</ud>
<ud>
Jean-Baptiste Delambre (Amiens, 1749) Astronome. - Ses calculs ont servi à  déterminer la longueur du mètre. - Membre de l''Académie des sciences (1792) [http://data.bnf.fr/ark:/12148/cb12096096m#foaf:Person]
</ud>
<ud>
Paul-Louis Cirodde (1749) Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb102655606#foaf:Person]
</ud>
<ud>
Pierre-Simon de Laplace (Beaumont-en-Auge (Calvados), 1749) Astronome, mathématicien et physicien. - Membre de l''Institut, Académie des sciences (élu en 1795), puis de l''Académie française (élu en 1816). - Obtint le titre de marquis (en 1817) [http://data.bnf.fr/ark:/12148/cb119110516#foaf:Person]
</ud>
<ud>
Vincenzo De Filippis (1749) Scientifique, mathématicien. - Ministre de la République parthénopéenne en février 1799, fut probablement victime de la répression au rétablissement des Bourbons en juin de la même année [http://data.bnf.fr/ark:/12148/cb12290835h#foaf:Person]
</ud>
<ud>
William Faden (1749) Libraire, éditeur et marchand de cartes et d''estampes ; également géographe ordinaire du roi d''Angleterre (1783-1820) et du prince de Galles (1790-1820). - Fils de l''imprimeur londonien William I Faden (à l''origine Mackfaden, 1711-1783). En apprentissage de juillet 1764 à août 1771. Travaille en association avec la famille du libraire et géographe du Roi Thomas Jefferys (m. 1771) jusqu''en 1776 env. Membre de la "Society of civil engineers". Beau-frère du peintre et astronome John Russell. Se retire en 1823 et cède son affaire à son ancien apprenti James Wyld. Décédé à Shepperton en mars 1836 [http://data.bnf.fr/ark:/12148/cb15615346f#foaf:Person]
</ud>
<ud>
Caroline Lucretia Herschel (Hanovre (Basse-Saxe,  Allemagne), 1750) Astronome. - Assistante de son frère, William Herschel (1738-1822), lui aussi astronome [http://data.bnf.fr/ark:/12148/cb16108822m#foaf:Person]
</ud>
<ud>
Gilbert Romme (1750) Mathématicien, astronome et géographe. - Député du Puy-de-Dôme à l''Assemblée législative puis à la Convention, représentant en mission près l''armée de Cherbourg, préconise l''essai du télégraphe aérien de Chiappe. - A participé à l''établissement du calendrier révolutionnaire [http://data.bnf.fr/ark:/12148/cb12536106q#foaf:Person]
</ud>
<ud>
Lorenzo Mascheroni (Bergame, Italie, 1750) Mathématicien et poète. - Professeur de physique et de mathématique au Séminaire de Bergame, puis d''algèbre et de géométrie à l''Université de Pavie, dont il sera recteur. - Député au Corps législatif de Milan (1799), admirateur de Napoléon, fait partie des 29 qui signent l''appel à régner en Italie au Premier Consul après 1799 [http://data.bnf.fr/ark:/12148/cb119149502#foaf:Person]
</ud>
<ud>
Nicolas-Maurice Chompré (Paris (France), 1750) Directeur, entre 1777 et 1786, de la Correspondance générale à la Division des mines et de l''agriculture du Contrôleur général des Finances Bertin. - Diplomate. - Auteur d''ouvrages de physique et de mathématiques [http://data.bnf.fr/ark:/12148/cb122074802#foaf:Person]
</ud>
<ud>
Scipione Breislak (Rome, 1750) Géologue. - Professeur de mathématiques à Raguse puis à Rome [http://data.bnf.fr/ark:/12148/cb151306996#foaf:Person]
</ud>
<ud>
Simon Lhuilier (1750) Mathématicien et philosophe. - Établi à Varsovie [http://data.bnf.fr/ark:/12148/cb13005974t#foaf:Person]
</ud>
<ud>
Alliette (1751) Cartomancien de la fin du 18e siècle. - Marchand d''estampes. - Professeur de mathématiques (vers 1753). - La forme "Etteilla" est l''anagramme d''Alliette [http://data.bnf.fr/ark:/12148/cb118885161#foaf:Person]
</ud>
<ud>
André-Charles Brotier (Paris, 1751) Abbé, mathématicien et homme politique. - Enseigna les mathématiques à l''Ecole militaire. - Collabora à l''"Année littéraire" et au "Journal de la France" [http://data.bnf.fr/ark:/12148/cb124621991#foaf:Person]
</ud>
<ud>
Antide Janvier (Lavans-lès-Saint-Claude (Jura), 1751) Horloger, astronome [http://data.bnf.fr/ark:/12148/cb12614643k#foaf:Person]
</ud>
<ud>
Bazaine (1751) Mathématicien [http://data.bnf.fr/ark:/12148/cb10735226f#foaf:Person]
</ud>
<ud>
Bernard Violle (1751) Mathématicien. - Géomètre. - Chevalier de Saint-Louis (1815) [http://data.bnf.fr/ark:/12148/cb13006994p#foaf:Person]
</ud>
<ud>
Bonaventure Abat (1751) Mathématicien et théologien, cordelier de l''Observance. - Fut membre associé de l''Académie royale des belles-lettres de Barcelone [http://data.bnf.fr/ark:/12148/cb134813469#foaf:Person]
</ud>
<ud>
G.-F. Olivier (1751) Bachelier ès sciences. - Professeur d''humanités et de mathématiques (en 1825). Professeur au collège de Troyes [http://data.bnf.fr/ark:/12148/cb10728006s#foaf:Person]
</ud>
<ud>
Guillelmus Beer (1751) Cartographe, géographe et peut-être astronome [http://data.bnf.fr/ark:/12148/cb15332855z#foaf:Person]
</ud>
<ud>
Hector-Jean Legros (1751) Adjoint-général pendant les guerres de Vendée et d''Italie. - Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb13484693c#foaf:Person]
</ud>
<ud>
Henri Jurain (1751) Abbé. - Professeur de mathématiques à Reims. - Correspondant de l''Académie des Sciences [http://data.bnf.fr/ark:/12148/cb12224993g#foaf:Person]
</ud>
<ud>
J.-B.-M. Duprat (1751) Libraire pour les mathématiques. - En activité de mars 1797 à 1803 au moins. Apparenté à Louis (-Alexis) Duprat-Duverger, en activité à partir de 1802, qui a pu se qualifier lui aussi de "libraire pour les mathématiques". Louis Courcier, "imprimeur et libraire pour les mathématiques", lui succède en 1803 à la même adresse (quai des Augustins, n° 71). Une "madame Duprat" est cependant répertoriée, à l''adresse du pont Saint-Michel, par le "Tableau des libraires" de Debray (Paris, janv. 1804) [http://data.bnf.fr/ark:/12148/cb16701987t#foaf:Person]
</ud>
<ud>
J.P. Audiffred (1751) Mathématicien [http://data.bnf.fr/ark:/12148/cb125867381#foaf:Person]
</ud>
<ud>
Jacques Baradelle (1751) Etabli dès 1740 quai de l''Horloge du Palais, il fabriquait des instruments de navigation, des cadrans solaires, des sphères astronomiques et géographiques [http://data.bnf.fr/ark:/12148/cb15281028g#foaf:Person]
</ud>
<ud>
James Dodson (1751) Mathématicien [http://data.bnf.fr/ark:/12148/cb153816258#foaf:Person]
</ud>
<ud>
Jean-Louis Gœury (1751) Libraire ; libraire pour les mathématiques et l''architecture ; libraire de l''École des Ponts et chaussées (1802) ; des ingénieurs et de l''École impériale des Ponts et chaussées (1805). - Semble avoir été commis du libraire parisien Charles-Antoine Jombert de 1770 à 1773 au moins. Père du médecin Jean-Louis Gœury-Duvivier, né le 2 mars 1803. En activité dès 1800. Breveté libraire le 1er oct. 1812 (brevet renouvelé le 11 sept. 1818). Décédé peu avant le 28 juin 1827, date à laquelle son fils Jean-Louis Gœury (dit plus tard Gœury-Duvivier) demande à succéder à son brevet [http://data.bnf.fr/ark:/12148/cb12230577c#foaf:Person]
</ud>
<ud>
Joseph Mouchet (1751) Professeur de rhétorique et de mathématiques, professeur de physique à l''université de Nantes de 1780 à 1784. - Aéronaute. - Membre de la Congrégation de l''Oratoire [http://data.bnf.fr/ark:/12148/cb16514291q#foaf:Person]
</ud>
<ud>
Joseph-Louis Vincens de Mauléon de Causans (Avignon, 1751) Mathématicien. - Colonel d''infanterie du régiment de Conti. - Chevalier de Malte [http://data.bnf.fr/ark:/12148/cb145658189#foaf:Person]
</ud>
<ud>
Le Professeur de mathématiques du Collège national de Toul (1751) Professeur de mathématiques du Collège national de Toul [http://data.bnf.fr/ark:/12148/cb125373980#foaf:Person]
</ud>
<ud>
Le Ratz de Lanthenée (1751) Gentilhomme liégeois. - Mathématicien et physicien [http://data.bnf.fr/ark:/12148/cb124022694#foaf:Person]
</ud>
<ud>
Louis Duprat-Duverger (1751) Variante(s) de prénom : Louis-Alexis. - Libraire pour les mathématiques ; également éditeur de cartes et d''atlas. - Apparenté au "libraire pour les mathématiques" J.-B.-M. Duprat, en activité à Paris entre 1797 et 1803. Établi dès 1802, d''abord en association sous la raison "L. Duprat, Letellier et compagnie" jusqu''en 1804, seul ensuite. Breveté libraire le 1er oct. 1812 ; brevet renouvelé le 15 mars 1817 ; duplicata délivré le 27 avril 1824. Encore en activité en 1829 [http://data.bnf.fr/ark:/12148/cb133399518#foaf:Person]
</ud>
<ud>
Madame Bailly (1751) Épouse de Jean-Sylvain Bailly, mathématicien, astronome et homme politique, guillotiné en 1793 [http://data.bnf.fr/ark:/12148/cb16541654h#foaf:Person]
</ud>
<ud>
Marie de La Fresnaye (Barfleur (Manche), 1751) Professeur de littérature et de mathématiques [http://data.bnf.fr/ark:/12148/cb100430283#foaf:Person]
</ud>
<ud>
Marie-Louise Cartan (1751) Femme d''Elie Cartan, mère du compositeur Jean Cartan et du mathématicien Henri Cartan. - Née Marie-Louise Bianconi [http://data.bnf.fr/ark:/12148/cb148511208#foaf:Person]
</ud>
<ud>
Mathurin-Georges Girault de Keroudou (1751) Abbé. - Mathématicien français. - Principal du collège de Quimper. - Professeur de philosophie et de mathématiques au collège de Navarre à Paris. - Professeur au collège de Louis-le-Grand à Paris [http://data.bnf.fr/ark:/12148/cb15085298t#foaf:Person]
</ud>
<ud>
Nicolas Leverdé (1751) Astrologue et mathématicien. - Auteur d''almanachs [http://data.bnf.fr/ark:/12148/cb10403809w#foaf:Person]
</ud>
<ud>
Olaf Söderberg (1751) Botaniste et mathématicien [http://data.bnf.fr/ark:/12148/cb12563978p#foaf:Person]
</ud>
<ud>
Théodore Bouys (1751) Mathématicien favorable à Necker et à la Révolution [http://data.bnf.fr/ark:/12148/cb12240772d#foaf:Person]
</ud>
<ud>
Trabaud (1751) Maître de mathématiques [http://data.bnf.fr/ark:/12148/cb134811442#foaf:Person]
</ud>
<ud>
Vérologue (1751) "Seul imprimeur d''Apollon pour la satyre en prose". - Pseud. auquel est adjoint le qualificatif "seul imprimeur d''Apollon pour la satyre en prose" et qui, sous la fausse adresse "Sur l''imprimé au Parnasse", dissimule une impression française (parisienne selon Weller et G. Brunet, plutôt provinciale d''après le matériel typographique) de "La Nouvelle Astronomie du Parnasse françois, ou l''Apothéose des écrivains vivans dans la présente année 1740", due au chevalier Jean-Florent-Joseph de Neufville de Brunaubois-Montador [http://data.bnf.fr/ark:/12148/cb165246377#foaf:Person]
</ud>
<ud>
Veuve de Louis Courcier (1751) Nom patronymique : Victoire-Félicité Lemaire. - Imprimeur-libraire ; imprimeur-libraire pour les mathématiques, la marine, les sciences et les arts. - Brevetée imprimeur en succession de son mari le 12 août 1811 (brevet renouvelé le 15 oct. 1816) et libraire le 1er oct. 1812 (brevet renouvelé le 15 mars 1817). Deux de ses  gendres lui succèdent : Démophile Huzard (-Courcier) en mars 1820 (brevet du 14 mars 1820) comme imprimeur, et Victor Bachelier le 10 nov. 1821 comme libraire [http://data.bnf.fr/ark:/12148/cb124778683#foaf:Person]
</ud>
<ud>
Adrien-Marie Legendre (1752) Mathématicien. - Président de l''Académie des sciences (1806). - A aussi écrit avec Charles-Etienne Coquebert de Montbret et François Gattey sous le pseudonyme collectif "C.-G.-L. Métrophile" [http://data.bnf.fr/ark:/12148/cb12443375d#foaf:Person]
</ud>
<ud>
Barnaba Oriani (Carignano, Italie, 1752) Astronome de l''Observatoire de Brera (1777-), puis de Milan. - A découvert qu''Uranus était une planète à partir de son orbite. - Mathématicien [http://data.bnf.fr/ark:/12148/cb12537845s#foaf:Person]
</ud>
<ud>
Jean-Baptiste Labey (La Chapelle-Hainfray (Calvados), aujourd''hui Valsemé (Calvados), 1752) Mathématicien. - Professeur à l''École militaire, à l''École centrale du Panthéon, à l''École polytechnique et au Lycée Napoléon de Paris [http://data.bnf.fr/ark:/12148/cb12112257t#foaf:Person]
</ud>
<ud>
Jean-Baptiste Pérès (Valence d''Agen (Tarn-et-Garonne), 1752) Oratorien. - Professeur de mathématiques et de physique  à Lyon, membre de la Société des amis de la Constitution de la ville durant la Révolution, puis substitut du procureur général près la cour royale d''Agen et bibliothécaire de cette ville [http://data.bnf.fr/ark:/12148/cb126307361#foaf:Person]
</ud>
<ud>
Marc-Auguste Pictet (Genève (Suisse), 1752) Naturaliste genevois, littérateur, chimiste, physicien et astronome. - Membre fondateur de la Société de physique et d''histoire naturelle de Genève, Suisse. - Correspondant de la Société royale de Londres [http://data.bnf.fr/ark:/12148/cb125386742#foaf:Person]
</ud>
<ud>
François Gattey (1753) Mathématicien. - Directeur du Bureau des poids et mesures (en 1795). - A aussi écrit avec Charles-Etienne Coquebert de Montbret et Adrien-Marie Legendre sous le pseudonyme collectif "C.-G.-L. Métrophile" [http://data.bnf.fr/ark:/12148/cb12447886d#foaf:Person]
</ud>
<ud>
Antoine de La Salle (1754) Philosophe. - Mathématicien [http://data.bnf.fr/ark:/12148/cb12173561c#foaf:Person]
</ud>
<ud>
Colin Mackenzie (Stornoway (Lewis, Western isles, Royaume-Uni), 1754) Mathématicien. - Fonctionnaire collonial en Inde (1815-1821). - Chargé du relevé cartographique de l''Inde et de la description de ses régions. - Collectionneur de divers documents (manuscrits, dessins aquarelles...) constituant le fonds d''études indianistes, collection dispersée aujourd''hui entre l''India office library, Londres et : Government oriental manuscripts library, Madras et Calcutta [http://data.bnf.fr/ark:/12148/cb14374770r#foaf:Person]
</ud>
<ud>
Franz Xaver von Zach (Bratislava, 1754) Astronome. - Directeur de l''Observatoire du Seeberg (près de Gotha), de 1787 à 1808. - Dirigea les "Allgemeinen geographischen Ephemeriden" (1796-) [http://data.bnf.fr/ark:/12148/cb121732757#foaf:Person]
</ud>
<ud>
Jean-Baptiste Meusnier de La Place (Tours (Indre-et-Loire), 1754) Mathématicien et Officier. - Elu à l''Académie des sciences en 1784 pour son étude locale des surfaces. - Prénoms complets : Jean-Baptiste Marie Charles [http://data.bnf.fr/ark:/12148/cb10732160m#foaf:Person]
</ud>
<ud>
Nicolas-François Canard (1754) Mathématicien et économiste [http://data.bnf.fr/ark:/12148/cb12519510c#foaf:Person]
</ud>
<ud>
Charles-Étienne Coquebert de Montbret (Paris, 1755) Diplomate, mathématicien et géographe. - Nommé responsable de l''organisation du nouveau système de poids et mesures (décret de 1793), professeur de géographie physique et gîtes de minerais à l''École des mines. - A aussi écrit avec François Gattey et Adrien-Marie Legendre sous le pseudonyme collectif "C.-G.-L. Métrophile". - Membre de l''Institut, membre libre de l''Académie des Sciences (en 1816) [http://data.bnf.fr/ark:/12148/cb12447869t#foaf:Person]
</ud>
<ud>
Claude Philippe Bertrand Bertrand (Autun (Saône-et-Loire), 1755) Géographe et astronome [http://data.bnf.fr/ark:/12148/cb16506861q#foaf:Person]
</ud>
<ud>
Emmanuel-Étienne Duvillard de Durand (Genève, 1755) Mathématicien, statisticien. - A développé la mathématisation de l''économie [http://data.bnf.fr/ark:/12148/cb129987837#foaf:Person]
</ud>
<ud>
Gaspard-Clair-François-Marie Riche de Prony (Chamelet (Rhône), 1755) Mathématicien et ingénieur. - Directeur de l''École des Ponts et Chaussées (1799-1830). - Membre de l''Académie des Sciences. - Baron à titre personnel (1828) [http://data.bnf.fr/ark:/12148/cb12535038t#foaf:Person]
</ud>
<ud>
Jean Anthelme Brillat-Savarin (Belley, Ain, 1755) Magistrat. - Député aux États Généraux (élu en 1789). - Gastronome [http://data.bnf.fr/ark:/12148/cb12305674c#foaf:Person]
</ud>
<ud>
Louis Courcier (1755) Imprimeur-libraire ; imprimeur-libraire pour les mathématiques (1801) ; imprimeur-libraire pour les mathématiques (, les sciences et les arts) (1804-1808). - Exerce l''imprimerie dès l''été 1790. Aurait été auparavant "marchand de peaux de lapin" d''après l''enquête des inspecteurs de la librairie de déc. 1810. Proche des Girondins, il émarge au budget du Bureau de l''Esprit public du ministre Jean-Marie Roland de La Platière en 1792. Dirige le "Courrier du Corps législatif et de la Guerre" (1797). Rachète le fonds du libraire J.-B.-M. Duprat et lui succède en 1803 ; rachète l''imprimerie de Jean-Georges-Antoine Stoupe après la mort de celui-ci (1808). Breveté imprimeur le 1er avril 1811. Dit âgé de 56 ans lors de son décès (30 juillet 1811). Sa veuve est brevetée en sa succession dès le 12 août 1811 [http://data.bnf.fr/ark:/12148/cb12421329b#foaf:Person]
</ud>
<ud>
Nicolas B. Halma (1755) Chanoine de Paris. - Astronome et mathématicien. - Professeur [http://data.bnf.fr/ark:/12148/cb11906753t#foaf:Person]
</ud>
<ud>
Nikolaus von Fuss (1755) Mathématicien, géomètre. - Né à Bâle, s''intalla à Saint-Pétersbourg en 1773 à la demande d''Euler. - Membre de l''Académie des sciences de Saint-Pétersbourg (1775-), secrétaire perpétuel (1800-). - Meurt à Saint-Pétersbourg le 23 décembre 1825 (style grégorien) [http://data.bnf.fr/ark:/12148/cb12359314p#foaf:Person]
</ud>
<ud>
Pierre Tédenat (1755) Docteur en mathématiques. - Recteur de l''académie Nîmes (1809-1818) et professeur de philosophie à la faculté des lettres de Nîmes [http://data.bnf.fr/ark:/12148/cb10379875d#foaf:Person]
</ud>
<ud>
Agricol-Joseph-François-Xavier-Pierre-Esprit-Simon-Paul-Antoine Fortia d''Urban (Avignon, 1756) Mathématicien et littérateur. - Chevalier de la Légion d''honneur en 1811, correspondant de l''Académie de Belgique en 1828 et membre libre de l''Académie des Inscriptions et belles-lettres en 1830 [http://data.bnf.fr/ark:/12148/cb121468483#foaf:Person]
</ud>
<ud>
Alexandre Ruelle (Blois, 1756) Astronome. - Professeur d''astronomie à l''Observatoire de Paris de 1783 à 1795 [http://data.bnf.fr/ark:/12148/cb121582720#foaf:Person]
</ud>
<ud>
Ernst Gottfried Fischer (1756) Physicien et mathématicien [http://data.bnf.fr/ark:/12148/cb124025182#foaf:Person]
</ud>
<ud>
Jan Chrzciciel Władysław Śniadecki (1756) Mathématicien et philosophe, un des plus grands savants polonais des Lumières [http://data.bnf.fr/ark:/12148/cb123726267#foaf:Person]
</ud>
<ud>
Joseph Mollet (Aix-en-Provence (Bouches-du-Rhône), 1756) Oratorien. - Professeur de physique et de mathématique, École Centrale, Lyon, Rhône. - Doyen de la Faculté des sciences de Lyon (1809-1815) [http://data.bnf.fr/ark:/12148/cb12196474k#foaf:Person]
</ud>
<ud>
Carl-Christian von Langsdorf (Nauheim (Allemagne), 1757) Mathématicien. - Ingénieur. - Professeur de mathématiques à Erlangen (Allemagne), de 1798 à 1804, puis à Vilnius (Lituanie) de 1804 à 1806. - Frère de Langsdorf, Johann-Wilhelm (1745-1827) [http://data.bnf.fr/ark:/12148/cb10661030m#foaf:Person]
</ud>
<ud>
Dominique Blanqui (1757) Professeur de philosophie et d''astronomie. - Député à la Convention. - Membre du Conseil des Cinq-cents [http://data.bnf.fr/ark:/12148/cb12534874n#foaf:Person]
</ud>
<ud>
Alexandre-Balthazar-Laurent Grimod de La Reynière (Paris, 1758) Avocat. - Pamphlétaire. - Gastronome, fondateur et président du "Jury dégustateur" [http://data.bnf.fr/ark:/12148/cb11905936j#foaf:Person]
</ud>
<ud>
Johann Christoph Schuster (1759) Mathématicien [http://data.bnf.fr/ark:/12148/cb16505504t#foaf:Person]
</ud>
<ud>
Louis-François-Antoine Arbogast (Mutzig, Alsace, 1759) Mathématicien. - Directeur du Collège royal (en 1791). - Député à l''Assemblée législative puis à la Convention nationale [http://data.bnf.fr/ark:/12148/cb12520232w#foaf:Person]
</ud>
<ud>
Pierre-René-Auguste Bremond d''Ars (1759) Député de la noblesse. - Fut professeur de mathématiques et de latin [http://data.bnf.fr/ark:/12148/cb12540611f#foaf:Person]
</ud>
<ud>
Thomas Keith (Winestead (GB), 1759) Mathématicien. - Professeur [http://data.bnf.fr/ark:/12148/cb10275963j#foaf:Person]
</ud>
<ud>
Giovanni Paradisi (Reggio Emilia, Italie, 1760) Comte. - Homme politique. - Mathématicien. - Poète [http://data.bnf.fr/ark:/12148/cb105910991#foaf:Person]
</ud>
<ud>
Nicolas Antoine Guillard (Sorbais, Aisne, 1760) Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb10617134p#foaf:Person]
</ud></root>', 8, NULL, '{ud0}
Hermann de Carinthie (île de Korčula (Croatie), 1105) Philosophe, écrivain, mathématicien, astrologue et traducteur croate [http://data.bnf.fr/ark:/12148/cb16243624j#foaf:Person]
{/ud}
{ud0}
Hermann le Dalmate (Saint Peter en Istrie une partie du duché de Carinthie (au sud de l''Autriche), 1110) Philosophe, astronome, astrologue, mathématicien et traducteur d''ouvrages scientifiques et de la littérature. - Il vint très jeune en 1135 en France à Paris et à Chartres. - Eut pour maître Thierry de Chartres. - L''abbé de Cluny, Pierre le Vénérable, poussa Herman à traduire à écrire sur la vie et l''oeuvre de Mahomet [http://data.bnf.fr/ark:/12148/cb12364029w#foaf:Person]
{/ud}
{ud0}
Bhāskarācārya (Dekkan, Inde, 1114) Mathématicien. - Astronome. - Fils de Maheśvara. - Auteur de :  "Siddhāntaśiromanī" (en 1150) ; "Karṇakutūhala" [http://data.bnf.fr/ark:/12148/cb14498624v#foaf:Person]
{/ud}
{ud0}
al-Muẓaffar ibn Muḥammad Šaraf al-Dīn Ṭūsī (1151) Mathématicien. - Originaire de Ṭūs, Hamad̲ān, Mosul, Alep, Damas. - Écrivait vers 1209 [http://data.bnf.fr/ark:/12148/cb120864072#foaf:Person]
{/ud}
{ud0}
Johannes de Sacro Bosco (1151) Mathématicien. - Chanoine prémontré de Holywood (comté de Dumfries, Écosse). - Professeur à l''Université de Paris. - Semble être né à Halifax (Yorkshire, Angleterre). - Mort en 1256 ou 1244 [http://data.bnf.fr/ark:/12148/cb121284153#foaf:Person]
{/ud}
{ud0}
Robertus Castrensis (1151) Traducteur de traités scientifiques et de mathématiques. - Sa période d''activité se situe aux alentours de 1145 [http://data.bnf.fr/ark:/12148/cb12223624k#foaf:Person]
{/ud}
{ud0}
Alexandre de Villedieu (Villedieu (Manche), 1170) Franciscain. - Grammairien, mathématicien et poète. - Chanoine de la cathédrale Saint-André d''Avranches [http://data.bnf.fr/ark:/12148/cb12536245w#foaf:Person]
{/ud}
{ud0}
Leonardo Fibonacci (1170) Mathématicien. - Surnommé Leonardo Pisano [http://data.bnf.fr/ark:/12148/cb13092437c#foaf:Person]
{/ud}
{ud0}
Moḥamad ben Moḥamad Naṣīr al-Dīn Ṭōsī (Tus (Iran), 1201) Mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb12399386c#foaf:Person]
{/ud}
{ud0}
Jean Pecham (1220) Provincial des franciscains d''Angleterre. - Archevêque de Cantorbéry (à partir de 1279). - Théologien, mathématicien et physicien [http://data.bnf.fr/ark:/12148/cb12459837w#foaf:Person]
{/ud}
{ud0}
Witelo (1220) Philosophe et mathématicien [http://data.bnf.fr/ark:/12148/cb12054316n#foaf:Person]
{/ud}
{ud0}
Maḥmūd ibn Mas´ūd Quṭb al-Dīn al- Šīrāzī (Shīrāz, 1236) Astronome, médecin, philosophe et théologien [http://data.bnf.fr/ark:/12148/cb12086388m#foaf:Person]
{/ud}
{ud0}
Jacob ben Machir (Marseille, 1238) Astronome. - Médecin. - Chancellier de la faculté de médecine de Montpellier [http://data.bnf.fr/ark:/12148/cb165406517#foaf:Person]
{/ud}
{ud0}
Grégoire Chioniadès (1240) Astronome, physicien et médecin byzantin. - Évêque de Tabriz, Iran [http://data.bnf.fr/ark:/12148/cb12007088c#foaf:Person]
{/ud}
{ud0}
Henri Baten (1246) Philosophe et théologien. - Astronome. - Poète et musicien [http://data.bnf.fr/ark:/12148/cb12220635h#foaf:Person]
{/ud}
{ud0}
al-Mufaḍḍal ibn ʿUmar Aṯīr al-Dīn al-Abharī (1251) Philosophe, logicien, astronome [http://data.bnf.fr/ark:/12148/cb15935708x#foaf:Person]
{/ud}
{ud0}
Bartolomeo da Parma (1251) Astrologue, géomancien et astronome. Fut professeur à l''Université de Bologne (1288-1297) [http://data.bnf.fr/ark:/12148/cb144790439#foaf:Person]
{/ud}
{ud0}
Campanus de Novare (1251) Astronome. - Mathématicien, commentateur d''Euclide [http://data.bnf.fr/ark:/12148/cb124917005#foaf:Person]
{/ud}
{ud0}
David ben Yom-Tov Poel (1251) Philosophe. - Médecin. - Père de l''astronome Jacob Poel [http://data.bnf.fr/ark:/12148/cb16540698w#foaf:Person]
{/ud}
{ud0}
Démétrius Triclinius (Thessalonique, 1251) Philologue. - Mathématicien et astrologue [http://data.bnf.fr/ark:/12148/cb12311753x#foaf:Person]
{/ud}
{ud0}
Geršon ben Salomon d''Arles (Béziers, 1251) Éxégète. - Astronome [http://data.bnf.fr/ark:/12148/cb134867338#foaf:Person]
{/ud}
{ud0}
Hui Yang (1251) Mathématicien chinois. En activité entre 1261 et 1275 [http://data.bnf.fr/ark:/12148/cb13746624q#foaf:Person]
{/ud}
{ud0}
Isaac ben Joseph Israeli (1251) Astronome. - Elève d''Asher ben Jehiel [http://data.bnf.fr/ark:/12148/cb16540863s#foaf:Person]
{/ud}
{ud0}
Jacopo da Firenze (1251) Mathématicien. - Actif en 1307 [http://data.bnf.fr/ark:/12148/cb157815579#foaf:Person]
{/ud}
{ud0}
Jordanus Nemorarius (1251) Mathématicien. - Probablement d''origine italienne [http://data.bnf.fr/ark:/12148/cb11986727x#foaf:Person]
{/ud}
{ud0}
Petrus Philomena de Dacia (1251) Mathématicien, astronome, philosophe. - Attesté entre 1290 et 1300. - Élève à l''Université de Bologne (1291-1292) puis de Paris. - Chanoine de Roskilde, Danemark. - A distinguer de Petrus de Dacia, recteur de l''Université de Paris en 1327 [http://data.bnf.fr/ark:/12148/cb11887258w#foaf:Person]
{/ud}
{ud0}
ʿAbd al-Ġaffār ibn ʿAbd al-Karīm Naǧm al-Dīn al- Qazwīnī (1251) Mathématicien et jurisconsulte chaféite [http://data.bnf.fr/ark:/12148/cb155674927#foaf:Person]
{/ud}
{ud0}
Andalò Di Negro (Gênes (?), Italie, 1260) Astronome. - Précepteur de Boccace. - Ambassadeur de la République de Gênes auprès de l''empereur Alexis Comnène (en 1314) [http://data.bnf.fr/ark:/12148/cb121998732#foaf:Person]
{/ud}
{ud0}
Théodore Métochite (Constantinople, 1260) Homme d''état, philosophe, poète, astronome et rhéteur [http://data.bnf.fr/ark:/12148/cb12000562c#foaf:Person]
{/ud}
{ud0}
Gersonide (Bagnols-sur-Cèze (Gard), 1288) Exégète biblique, mathématicien, astronome, philosophe, physicien [http://data.bnf.fr/ark:/12148/cb12131941j#foaf:Person]
{/ud}
{ud0}
Barlaam de Seminara (1290) Moine basilien, abbé du Saint-Esprit à Constantinople (1331), évêque de Gérace (1342-1348). - Théologien, philosophe, mathématicien, astronome et helléniste [http://data.bnf.fr/ark:/12148/cb13549924x#foaf:Person]
{/ud}
{ud0}
Jacopo Dondi (1290) Philosophe, astronome, médecin italien célèbre pour la construction d''une pendule astrale à Padoue. - Père de Giovanni Dondi [http://data.bnf.fr/ark:/12148/cb124119184#foaf:Person]
{/ud}
{ud0}
Thomas Bradwardine (1290) Mathématicien, philosophe et théologien. - Surnommé le "Doctor Profundus". - Archevêque de Canterbury en 1349 [http://data.bnf.fr/ark:/12148/cb12269047v#foaf:Person]
{/ud}
{ud0}
Richard of Wallingford (1292) Mathématicien. - Astronome. - Abbé du monastère bénédictin de St Albans [http://data.bnf.fr/ark:/12148/cb12128305h#foaf:Person]
{/ud}
{ud0}
Jean de Murs (1300) Astronome, mathématicien et théoricien de la musique. - Maître-ès-arts de l''Université de Paris (1321) [http://data.bnf.fr/ark:/12148/cb121715011#foaf:Person]
{/ud}
{ud0}
Giovanni Dondi dall''Orologio (Chiogga, Italie, 1318) Médecin et poète. - Astronome et horloger, a terminé l''horloge astronomique, installée par son père : Dondi, Jacopo (1298-1359), à Padoue ou Pavie, Italie [http://data.bnf.fr/ark:/12148/cb122241024#foaf:Person]
{/ud}
{ud0}
Giacomo Allegretti (1325) Médecin , poète et astronome [http://data.bnf.fr/ark:/12148/cb14405998n#foaf:Person]
{/ud}
{ud0}
Blasius de Parma (1347) Philosophe, mathématicien, médecin. - Recteur de l''université de Parme (en 1412) [http://data.bnf.fr/ark:/12148/cb12182615f#foaf:Person]
{/ud}
{ud0}
Abū ʿAbd Allâh Muḥammad al- Baqqār (1351) Mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb155102056#foaf:Person]
{/ud}
{ud0}
Emmanuel ben Jacob de Tarascon Bonfils (1351) Astronome, médecin et mathématicien ayant vécu à Orange puis à Tarascon. Il est l''auteur de nombreux traités d''astronomie [http://data.bnf.fr/ark:/12148/cb15620448d#foaf:Person]
{/ud}
{ud0}
Ǧamšīd ibn Masʿūd Ġiyāṯ al-Dīn al- Kāšī (1351) Médecin, mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb11351746b#foaf:Person]
{/ud}
{ud0}
Johannes Danck (1351) Astronome. - A enseigné à l''Université de Paris de 1327 à 1355 [http://data.bnf.fr/ark:/12148/cb12531239r#foaf:Person]
{/ud}
{ud0}
Naǧm al-Dīn al- Miṣrī (1351) Auteur supposé de traités portant sur les instruments astronomiques [http://data.bnf.fr/ark:/12148/cb14566743g#foaf:Person]
{/ud}
{ud0}
Prosdocimus de Beldemandis (1351) Théoricien de la musique, mathématicien et physicien [http://data.bnf.fr/ark:/12148/cb127653823#foaf:Person]
{/ud}
{ud0}
Taddeo da Parma (1351) Philosophe averroïste et astronome. - A enseigné la philosophie à Bologne vers 1320 [http://data.bnf.fr/ark:/12148/cb10103512f#foaf:Person]
{/ud}
{ud0}
Théodore Méliténiote (Constantinople, 1351) Grand sacellaire de l''Église byzantine, maître des maîtres de l''École patriarcale et archidiacre du clergé palatin. - A laissé un ouvrage d''exégèse de l''Évangile, un traité d''astronomie et un poème allégorique [http://data.bnf.fr/ark:/12148/cb12153709d#foaf:Person]
{/ud}
{ud0}
Paolo dal Pozzo Toscanelli (1397) Mathématicien, physicien, géographe, astronome et astrologue. - Inventeur des gnomons modernes. - Conservateur de la Bibliothèque de Florence [http://data.bnf.fr/ark:/12148/cb12455406j#foaf:Person]
{/ud}
{ud0}
Ugolino Pisani (Parme, Italie, 1405) Philosophe, mathématicien, auteur de comédies [http://data.bnf.fr/ark:/12148/cb12689419t#foaf:Person]
{/ud}
{ud0}
Lorenzo Buonincontri (San Miniato, Italie, 1411) Militaire, mathématicien, astronome, astrologue, poète et historien. - Professeur d''astronomie à Naples [http://data.bnf.fr/ark:/12148/cb12536229n#foaf:Person]
{/ud}
{ud0}
ʿAlī ibn Muḥammad al- Qalaṣādī (Baza (Espagne), 1412) Mathématicien, astronome, juriste et savant [http://data.bnf.fr/ark:/12148/cb12440997n#foaf:Person]
{/ud}
{ud0}
Piero della Francesca (Borgo San Sepolcro, Italie, 1416) Peintre. - A écrit des traités de mathématiques, perspective et géométrie et des écrits sur la science des couleurs et du paysage [http://data.bnf.fr/ark:/12148/cb12060279h#foaf:Person]
{/ud}
{ud0}
Georgius de Hungaria (Romosz, aujourd''hui Romos, Roumanie, 1422) Prisonnier des Turcs (1438-1458). - Dominicain. - Mathématicien [http://data.bnf.fr/ark:/12148/cb130923013#foaf:Person]
{/ud}
{ud0}
Antonio Manetti (Florence, Italie, 1423) Homme de lettres. - Architecte, astronome, mathématicien [http://data.bnf.fr/ark:/12148/cb11914242h#foaf:Person]
{/ud}
{ud0}
Georg von Peurbach (Peuerbach, Autriche, 1423) Astronome [http://data.bnf.fr/ark:/12148/cb12374660w#foaf:Person]
{/ud}
{ud0}
Giovanni Pontano (Cerreto di Spoleto (Perouse), Italie, 1426) Homme politique. - Humaniste. - Auteur de traités astronomiques et philosophiques [http://data.bnf.fr/ark:/12148/cb123298807#foaf:Person]
{/ud}
{ud0}
Johannes Regiomontanus (Königsberg, Allemagne, 1436) Astronome. - Mathématicien [http://data.bnf.fr/ark:/12148/cb12159829r#foaf:Person]
{/ud}
{ud0}
Nīlakaṇṭha Somayajī (1443) Astronome et mathématicien de l''école de Kerala (Inde) [http://data.bnf.fr/ark:/12148/cb165324540#foaf:Person]
{/ud}
{ud0}
Luca Pacioli (1445) Mathématicien. - Franciscain [http://data.bnf.fr/ark:/12148/cb11918350c#foaf:Person]
{/ud}
{ud0}
Konrad Türst (1450) Mathématicien suisse de Zürich [http://data.bnf.fr/ark:/12148/cb15336511g#foaf:Person]
{/ud}
{ud0}
Agostino Ricci (1451) Astronome [http://data.bnf.fr/ark:/12148/cb12539498r#foaf:Person]
{/ud}
{ud0}
Andrea Corsali (1451) Astronome, cosmographe, navigateur dans la péninsule arabique et aux Indes. - Pourrait avoir introduit l''imprimerie en Éthiopie (ca 1524), où vraisemblament il meurt [http://data.bnf.fr/ark:/12148/cb13517283d#foaf:Person]
{/ud}
{ud0}
Anianus (1451) Astronome et poète [http://data.bnf.fr/ark:/12148/cb125156549#foaf:Person]
{/ud}
{ud0}
Antonio Dolciati (1451) Augustinien et mathématicien [http://data.bnf.fr/ark:/12148/cb134854696#foaf:Person]
{/ud}
{ud0}
Bartolomeo da Messina (1451) Écclésiastique et mathématicien [http://data.bnf.fr/ark:/12148/cb125393703#foaf:Person]
{/ud}
{ud0}
Gaspar Torrella (1451) Médecin et mathématicien. - Évêque de Santa-Giusta (Sardaigne) en 1494. - Originaire de Valence (Espagne) [http://data.bnf.fr/ark:/12148/cb13486025q#foaf:Person]
{/ud}
{ud0}
Giovanni Abiosi (1451) Médecin, astronome, mathématicien et philosophe. - Né à Bagnuolo (Royaume de Naples), mort vers 1500 [http://data.bnf.fr/ark:/12148/cb12537367q#foaf:Person]
{/ud}
{ud0}
Giovanni Antonio Tagliente (1451) Calligraphe. - Mathématicien [http://data.bnf.fr/ark:/12148/cb12179148h#foaf:Person]
{/ud}
{ud0}
Giovanni Benedetto Moncetto (1451) Agostinien. - Théologien, philosophe et astronome [http://data.bnf.fr/ark:/12148/cb125688716#foaf:Person]
{/ud}
{ud0}
Giovanni Bianchini (1451) Astronome mort après 1469 [http://data.bnf.fr/ark:/12148/cb16163624s#foaf:Person]
{/ud}
{ud0}
Guillaume Hobit (1451) Astronome ; astrologue de Philippe le Bon, duc de Bourgogne [http://data.bnf.fr/ark:/12148/cb15063496s#foaf:Person]
{/ud}
{ud0}
Jacob Köbel (Heidelberg, Allemagne, 1451) Mathématicien, éditeur et libraire [http://data.bnf.fr/ark:/12148/cb10244031k#foaf:Person]
{/ud}
{ud0}
Louis Boulengier (1451) Astronome et géographe d''Albi [http://data.bnf.fr/ark:/12148/cb152949413#foaf:Person]
{/ud}
{ud0}
Rāmacandrācārya (1451) Grammairien et commentateur de Pāṇini (actif au 15e s.). - Fils de Kr̥ṣṇācārya. - A aussi écrit des ouvrages de philosophie (Vedānta) et d''astronomie [http://data.bnf.fr/ark:/12148/cb137708651#foaf:Person]
{/ud}
{ud0}
Sigismondo Fanti (Ferrare, Italie, 1451) Poète, philosophe et mathématicien. - Meurt après 1527 [http://data.bnf.fr/ark:/12148/cb12567416q#foaf:Person]
{/ud}
{ud0}
Willem Gilliszoon (1451) Astronome et mathématicien. - Originaire de Wissekerc (Zélande) [http://data.bnf.fr/ark:/12148/cb12548011q#foaf:Person]
{/ud}
{ud0}
Girolamo Donato (1454) Magistrat, poète, philosophe, théologien et mathématicien. - Fut gouverneur de Brescia (1496), de Ferrare (1498), ambassadeur de Venise près le pape Jules II (1510) [http://data.bnf.fr/ark:/12148/cb13325565p#foaf:Person]
{/ud}
{ud0}
Eliya Delmedigo (1460) Médecin. - Astronome. - Mathématicien. - Né en Crète. - Philosophe. - Maître d''hébreu de Pic de la Mirandole (1463-1494). - Commentateur des écrits d''Averroés (1126-1198) [http://data.bnf.fr/ark:/12148/cb122623668#foaf:Person]
{/ud}
{ud0}
Lodovico Pontico Virunio (1467) Professeur de lettres, philosophe, mathématicien et poète. - Fut chargé de l''éducation des fils de Ludovico Sforza, duc de Milan. - Eut l''intention de fonder une imprimerie grecque et latine à Reggio Emilia, mais ses caractères furent volés par Ludovico Bonaccioli, médecin de la duchesse de Ferrare. - Né à Belluno, meurt à Bologne [http://data.bnf.fr/ark:/12148/cb13324006j#foaf:Person]
{/ud}
{ud0}
Johannes Werner (Nuremberg, Allemagne, 1468) Mathématicien, astronome et cartographe [http://data.bnf.fr/ark:/12148/cb154028305#foaf:Person]
{/ud}
{ud0}
Jakob Ziegler (Landau (Allemagne), 1470) Théologien, mathématicien, astronome et géographe. - Professeur de théologie. - Commentateur et auteur d''ouvrages historiques et théologiques [http://data.bnf.fr/ark:/12148/cb15029346k#foaf:Person]
{/ud}
{ud0}
Pedro Ciruelo (Daroca, Espagne, 1470) Professeur de théologie à l''Université d''Alcala (1510-), chanoine de la cathédrale de cette ville. - Fut l''un des précepteurs de Philippe II. - Étudia à Salamanque et à Paris, où il édita des oeuvres mathématiques et scientifiques. - Est également l''auteur d''un traité sur la sorcellerie dont la traduction espagnole eut une diffusion importante [http://data.bnf.fr/ark:/12148/cb128071494#foaf:Person]
{/ud}
{ud0}
Johann Stöffler (Justingen, Allemagne, 1472) Astronome et mathématicien [http://data.bnf.fr/ark:/12148/cb125156905#foaf:Person]
{/ud}
{ud0}
Josse Clicthove (Nieuport, Pays-Bas, 1472) Théologien et mathématicien. - Théologal de Chartres. - Un des premiers à combattre les idées de Luther [http://data.bnf.fr/ark:/12148/cb12234610b#foaf:Person]
{/ud}
{ud0}
Bartolomeo Zamberti (Venise, Italie, 1473) Mathématicien et humaniste. - Professeur de lettres. - Notaire des Consuls des marchands de Venise [http://data.bnf.fr/ark:/12148/cb12033590z#foaf:Person]
{/ud}
{ud0}
Nicolas Copernic (1473) Astronome [http://data.bnf.fr/ark:/12148/cb118976048#foaf:Person]
{/ud}
{ud0}
Luca Gaurico (Giffoni, Italie, 1476) Évêque de Civita Ducale (1545-1549). - Mathématicien, philosophe, astronome et astrologue [http://data.bnf.fr/ark:/12148/cb134849440#foaf:Person]
{/ud}
{ud0}
Johann Schöner (1477) Né à Karlstadt près de Würzburg. - Prédicateur protestant. - Astronome. - Géographe. - Professeur de mathématiques à Nuremberg. - A aussi écrit en latin [http://data.bnf.fr/ark:/12148/cb119992233#foaf:Person]
{/ud}
{ud0}
Girolamo Fracastoro (Vérone, Italie, 1478) Médecin, auteur du "De contagione et contagiosis morbis et curatione libri III" ; nommé par le pape Paul III médecin officiel du Concile de Trente. - Auteur de poèmes en latin, d''oeuvres de géographie, d''astronomie, de physique, de théologie et de philosophie. - Élève de Pomponazzi, ami de Copernic [http://data.bnf.fr/ark:/12148/cb120587788#foaf:Person]
{/ud}
{ud0}
Girolamo Francastoro (1478) Médecin, astronome, géologiste, poète, précurseur de la notion de contagion [http://data.bnf.fr/ark:/12148/cb15699396m#foaf:Person]
{/ud}
{ud0}
Celio Calcagnini (Ferrare, Italie, 1479) Poète, philologue, philosophe et astronome. - Accompagna Hippolyte d''Este en Hongrie et en Pologne [http://data.bnf.fr/ark:/12148/cb122157991#foaf:Person]
{/ud}
{ud0}
Charles de Bovelles (1479) Philosophe, mathématicien et linguiste. - Chanoine de Noyon. - Né avant le 28 mars 1479 [http://data.bnf.fr/ark:/12148/cb118932166#foaf:Person]
{/ud}
{ud0}
Prospero Calano (Sarzana, Italie, 1480) Médecin, astronome et philosophe [http://data.bnf.fr/ark:/12148/cb12568870v#foaf:Person]
{/ud}
{ud0}
Vannoccio Biringuccio (Sienne, Italie, 1480) Mathématicien, chimiste, architecte et ingénieur, spécialiste en métallurgie [http://data.bnf.fr/ark:/12148/cb12195640k#foaf:Person]
{/ud}
{ud0}
Michael Stifel (1487) Théologien et mathématicien. - Inventeur du logarithme. - Enseigna la théologie et les mathématiques à l''Université de Königsberg, puis les mathématiques à l''Université de Iéna [http://data.bnf.fr/ark:/12148/cb12795734z#foaf:Person]
{/ud}
{ud0}
Sebastian Münster (Ingelheim, Allemagne, 1489) Hébraïsant, géographe et mathématicien [http://data.bnf.fr/ark:/12148/cb11996987j#foaf:Person]
{/ud}
{ud0}
Albert Pighius (Kampen, Pays-Bas, 1490) Théologien, mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb10448635x#foaf:Person]
{/ud}
{ud0}
Patrizio Tricasso (Ceresara, Italie, 1491) Dominicain. - Mathématicien et astrologue [http://data.bnf.fr/ark:/12148/cb107034397#foaf:Person]
{/ud}
{ud0}
Heinrich Schreiber (Erfurt, Allemagne, 1492) Mathématicien [http://data.bnf.fr/ark:/12148/cb10734904t#foaf:Person]
{/ud}
{ud0}
Jean Borrel (1492) Géomètre et mathématicien. - Chanoine régulier de l''Ordre de Saint-Antoine [http://data.bnf.fr/ark:/12148/cb12515817n#foaf:Person]
{/ud}
{ud0}
Pedro Nunez (1492) Astronome et mathématicien [http://data.bnf.fr/ark:/12148/cb12548918m#foaf:Person]
{/ud}
{ud0}
Oronce Fine (Briançon (Hautes-Alpes), 1494) Sieur de Champrouet. - Mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb122937307#foaf:Person]
{/ud}
{ud0}
Petrus Apian (Leisnig (Allemagne), 1495) Astronome, cartographe et mathématicien. - Nommé Chevalier de l''Empire par Charles Quint. - Surnom de : Bienewitz (ou Bennewitz), Peter [http://data.bnf.fr/ark:/12148/cb12515640m#foaf:Person]
{/ud}
{ud0}
Andreas Osiander (Gunzenhausen, Allemagne, 1498) Théologien protestant, astronome et mathématicien. - Parfois désigné sous le nom "Andreas Osiander l''Ancien" [http://data.bnf.fr/ark:/12148/cb11988942v#foaf:Person]
{/ud}
{ud0}
Garcia da Orta (Castelo di Vide, Portugal, 1499) Médecin et naturaliste. - A enseigné les mathématiques à l''Université de Lisbonne [http://data.bnf.fr/ark:/12148/cb119983323#foaf:Person]
{/ud}
{ud0}
Giovanni Agostino Abate (1499) Mathématicien et historien [http://data.bnf.fr/ark:/12148/cb14624324z#foaf:Person]
{/ud}
{ud0}
Joachim Sterck van Ringelberg (Anvers, Belgique, 1499) Humaniste, mathématicien et astrologue. - Meurt selon les sources le 1er janvier 1531, en 1536 ou en 1556 [http://data.bnf.fr/ark:/12148/cb10645118k#foaf:Person]
{/ud}
{ud0}
Johann Carion (Bietigheim, Allemagne, 1499) Astrologue et mathématicien [http://data.bnf.fr/ark:/12148/cb12805831h#foaf:Person]
{/ud}
{ud0}
Johannes Dryander (Wetter, Allemagne, 1500) Mathématicien, physicien et astronome, professeur à Marburg, édité par Sebastian Münster et Abraham Ortelius [http://data.bnf.fr/ark:/12148/cb15379218m#foaf:Person]
{/ud}
{ud0}
Johannes Voegelin (Heilbronn, Allemagne, 1500) Astronome et mathématicien. - Professeur à l''Université de Vienne [http://data.bnf.fr/ark:/12148/cb10490264h#foaf:Person]
{/ud}
{ud0}
Niccolò Tartaglia (1500) Mathématicien, ingénieur et architecte. - Pseudonyme de Niccolò Fontana [http://data.bnf.fr/ark:/12148/cb12914492r#foaf:Person]
{/ud}
{ud0}
Gerolamo Cardano (Pavie, Italie, 1501) Médecin, mathématicien et philosophe [http://data.bnf.fr/ark:/12148/cb11895137c#foaf:Person]
{/ud}
{ud0}
Pedro Nunes (Alcácer do Sol (Portugal), 1502) Astronome et mathématicien portugais [http://data.bnf.fr/ark:/12148/cb13510349t#foaf:Person]
{/ud}
{ud0}
Cosimo Bartoli (Florence, Italie, 1503) Ambassadeur, poète et mathématicien [http://data.bnf.fr/ark:/12148/cb125520809#foaf:Person]
{/ud}
{ud0}
Jean Cousin (Soucy (Yonne, France), 1503) Peintre, sculpteur, graveur, architecte, mathématicien [http://data.bnf.fr/ark:/12148/cb12467444s#foaf:Person]
{/ud}
{ud0}
Ciriaco Strozzi (Capalle, Italie, 1504) Helléniste, philosophe, mathématicien et architecte [http://data.bnf.fr/ark:/12148/cb10418521b#foaf:Person]
{/ud}
{ud0}
Jacques Bassantin (1504) Astronome et mathématicien [http://data.bnf.fr/ark:/12148/cb12548014r#foaf:Person]
{/ud}
{ud0}
Achille Pirminius Gasser (1505) Médecin, historien et astronome [http://data.bnf.fr/ark:/12148/cb12516715x#foaf:Person]
{/ud}
{ud0}
Benedictus Aretius (1505) Théologien protestant. - Botaniste et astronome. - Professeur de logique à l''Université de Marbourg, puis professeur de théologie à Berne. - Fut lié avec Conrad Gesner. - Né et mort à Berne [http://data.bnf.fr/ark:/12148/cb12515850g#foaf:Person]
{/ud}
{ud0}
Alessandro Piccolomini (Sienne, Italie, 1508) Écrivain, dramaturge, astronome et traducteur d''oeuvres de l''Antiquité, de comédies, de traités philosophiques et scientifiques. - Membre de l''Accademia degli Intronati de Sienne, sous le pseudonyme : lo Stordito. - Archevêque de Patras et coadjuteur de l''archevêque de Sienne Francesco Bandini Piccolomini, du 28 juillet 1574 à 1578 [http://data.bnf.fr/ark:/12148/cb12240709n#foaf:Person]
{/ud}
{ud0}
Gemma Frisius (Dokkum (Pays-Bas), 1508) Mathématicien et astronome. - Professeur et docteur en médecine de l''Université de Louvain [http://data.bnf.fr/ark:/12148/cb125195002#foaf:Person]
{/ud}
{ud0}
Federico Commandino (Sassocorvaro, Italie, 1509) Mathématicien. - A été le tuteur du duc d''Urbino [http://data.bnf.fr/ark:/12148/cb12562850s#foaf:Person]
{/ud}
{ud0}
Jean Gosselin (Vire, Calvados, 1510) Astrologue et mathématicien. - Conservateur de la bibliothèque du roi [http://data.bnf.fr/ark:/12148/cb133321861#foaf:Person]
{/ud}
{ud0}
Pietro Cataneo (1510) Architecte et mathématicien [http://data.bnf.fr/ark:/12148/cb12557068n#foaf:Person]
{/ud}
{ud0}
Erasmus Oswald Schreckenfuchs (1511) Hébraïsant. - Astronome [http://data.bnf.fr/ark:/12148/cb12115338j#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Amici (Cosenza, Italie, 1511) Astronome [http://data.bnf.fr/ark:/12148/cb15583428k#foaf:Person]
{/ud}
{ud0}
Juanelo Turriano (1511) Mathématicien et ingénieur [http://data.bnf.fr/ark:/12148/cb129309990#foaf:Person]
{/ud}
{ud0}
Gerard Mercator (Rupelmonde, Flandres, 1512) Géographe, cartographe, cosmographe et mathématicien [http://data.bnf.fr/ark:/12148/cb12789989j#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Amico (1512) Philosophe, mathématicien et astrologue. - Originaire de Cosenza, fut assassiné à Padoue [http://data.bnf.fr/ark:/12148/cb12570280s#foaf:Person]
{/ud}
{ud0}
Juan Pérez de Moya (1513) Mathématicien et humaniste [http://data.bnf.fr/ark:/12148/cb12146300q#foaf:Person]
{/ud}
{ud0}
Rheticus (1514) Astronome [http://data.bnf.fr/ark:/12148/cb13615799v#foaf:Person]
{/ud}
{ud0}
Bernardino Baldini (1515) Professeur de médecine à Pavie puis de mathématiques à Milan [http://data.bnf.fr/ark:/12148/cb13163998r#foaf:Person]
{/ud}
{ud0}
Petrus Ramus (Cuts (Aisne), 1515) Philosophe, grammairien, mathématicien et humaniste. - Professeur de mathématique au Collège royal (Collège de France). - Se convertit au protestantisme et fut tué au cours du Massacre de la Saint-Barthélemy [http://data.bnf.fr/ark:/12148/cb120645094#foaf:Person]
{/ud}
{ud0}
Jean-Pierre de Mesmes (1516) Savant et poète. - Fils de Pierre de Mesmes, chambellan du roi de Navarre. - Etait lié avec Ronsard, du Bellay, Baïf, Charondas, Herberay, Jean Maugin, Ol. de Magny. - A était un des premiers auteurs à avoir écrit en français sur l''astronomie [http://data.bnf.fr/ark:/12148/cb125177720#foaf:Person]
{/ud}
{ud0}
Jacques Peletier (1517) Poète et critique humaniste. - Mathématicien. - A participé à la réforme de l''orthographe. - Traducteur d''Horace [http://data.bnf.fr/ark:/12148/cb122992680#foaf:Person]
{/ud}
{ud0}
Jeronimo Munoz (1520) Astronome [http://data.bnf.fr/ark:/12148/cb14646245j#foaf:Person]
{/ud}
{ud0}
Livio Sanuto (1520) Géographe et mathématicien à Venise, fabriquant d''un globe avec son frère Giulio en 1561 [http://data.bnf.fr/ark:/12148/cb153816227#foaf:Person]
{/ud}
{ud0}
Melchior Ayrer (1520) Mathématicien [http://data.bnf.fr/ark:/12148/cb162974318#foaf:Person]
{/ud}
{ud0}
Nicolaus Gugler (Nuremberg (Allemagne), 1521) Médecin et astronome, a reçu une formation de juriste. - Fils de Hans Gugler (1480-1560) [http://data.bnf.fr/ark:/12148/cb16504896w#foaf:Person]
{/ud}
{ud0}
Valentin Mennher (1521) Mathématicien. - Membre de la guilde des instituteurs d''Anvers [http://data.bnf.fr/ark:/12148/cb12563197r#foaf:Person]
{/ud}
{ud0}
Hermann Witekind (Neuenrade (Allemagne), 1522) Mathématicien et humaniste [http://data.bnf.fr/ark:/12148/cb162248258#foaf:Person]
{/ud}
{ud0}
Giovanni Maria Bonardo (Fratta Polesine, Italie, 1523) Poète. - Agronome. - Astronome [http://data.bnf.fr/ark:/12148/cb12181418p#foaf:Person]
{/ud}
{ud0}
Juan de Yciar (Durango (prov. de Vizcaya), 1523) Pédagogue, mathématicien et calligraphe [http://data.bnf.fr/ark:/12148/cb128696315#foaf:Person]
{/ud}
{ud0}
Jacques Charpentier (Clermont-en-Beauvaisis (Oise), 1524) Philosophe et médecin. - Lecteur de mathématiques au Collège de France. - Médecin du roi [http://data.bnf.fr/ark:/12148/cb121323921#foaf:Person]
{/ud}
{ud0}
Tadeáš Hájek (Prague, 1525) Mathématicien et médecin. - Reçu docteur à Bologne, occupa une chaire au Carolinum de Prague, fut premier médecin des empereurs Maximilien II et Rodolphe II [http://data.bnf.fr/ark:/12148/cb13009688n#foaf:Person]
{/ud}
{ud0}
Tilemann Stella (Siegen (Allemagne), 1525) Mathématicien, astronome, géographe, architecte et bibliothécaire. - Cartographe à Wittenberg, ses cartes ont été éditées par Ortelius, Jode et Hondius [http://data.bnf.fr/ark:/12148/cb15376436c#foaf:Person]
{/ud}
{ud0}
Taqī al-Dīn Muḥammad Ibn Maʿrūf (Damas, 1526) Astronome et mathématicien ottoman [http://data.bnf.fr/ark:/12148/cb14599962n#foaf:Person]
{/ud}
{ud0}
John Dee (1527) Astrologue, mathématicien et antiquaire [http://data.bnf.fr/ark:/12148/cb119854464#foaf:Person]
{/ud}
{ud0}
Adam Lonicer (Marburg (Allemagne), 1528) Medecin et botaniste. - Professeur de médecine, chimie et mathématiques. - Fils du théologien : Lonicer, Johann (1499-15969) [http://data.bnf.fr/ark:/12148/cb10279221n#foaf:Person]
{/ud}
{ud0}
Cornelius Blockland (1530) Musicien, astrologue, mathématicien et médecin. - Actif de 1571 à 1586. - Frère du peintre Anthonie Blockland van Montfort [http://data.bnf.fr/ark:/12148/cb13497580p#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Benedetti (Venise, Italie, 1530) Mathématicien et ingénieur. - Fondateur de la géométrie analytique [http://data.bnf.fr/ark:/12148/cb11998820g#foaf:Person]
{/ud}
{ud0}
Jean Péna (1530) Mathématicien, traducteur et éditeur de textes mathématiques et géométriques antiques [http://data.bnf.fr/ark:/12148/cb13483147k#foaf:Person]
{/ud}
{ud0}
Conradus Dasypodius (Frauenfeld, Suisse, 1531) Mathématicien. - A tracé le plan de l''horloge astronomique de la cathédrale de Strasbourg [http://data.bnf.fr/ark:/12148/cb16534831x#foaf:Person]
{/ud}
{ud0}
Ercole Bottrigari (1531) Humaniste, mathématicien, musicien, poète, linguiste et philosophe [http://data.bnf.fr/ark:/12148/cb125347809#foaf:Person]
{/ud}
{ud0}
Giuseppe Moletti (1531) Cosmographe et géographe. - Professeur de médecine, de mathématique et d''astronomie à l''Université de Padoue [http://data.bnf.fr/ark:/12148/cb134849518#foaf:Person]
{/ud}
{ud0}
Philip Apian (Ingoldstadt, Allemagne, 1531) Cartographe, mathématicien et physicien. - Fils de Peter Apian, succède à son père à l''Université d''Ingolstadt [http://data.bnf.fr/ark:/12148/cb152383864#foaf:Person]
{/ud}
{ud0}
Fabrizio Mordente (Salerne, Italie, 1532) Mathématicien. - A inventé le compas de proportion à huit points [http://data.bnf.fr/ark:/12148/cb14643668k#foaf:Person]
{/ud}
{ud0}
Egnatio Danti (Pérouse, Italie, 1536) Mathématicien, astronome, cartographe et cosmographe. - Dominicain [http://data.bnf.fr/ark:/12148/cb145332908#foaf:Person]
{/ud}
{ud0}
Henri de Monantheuil (1536) Mathématicien et médecin. - Régent de la Faculté de médecine de Paris, puis professeur de mathématiques au Collège de France (1574-). - Né à Reims, meurt à Paris [http://data.bnf.fr/ark:/12148/cb13006651k#foaf:Person]
{/ud}
{ud0}
Christophorus Clavius (1537) Jésuite, musicien et professeur de mathématiques. - Fut chargé par Grégoire XIII de la réforme du calendrier [http://data.bnf.fr/ark:/12148/cb125466080#foaf:Person]
{/ud}
{ud0}
Francesco Barozzi (Heraklion, Grèce, 1537) Mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb10462395x#foaf:Person]
{/ud}
{ud0}
Giovanni Paolo Gallucci (Salò, Italie, 1538) Astronome. - Homme de lettres [http://data.bnf.fr/ark:/12148/cb106019703#foaf:Person]
{/ud}
{ud0}
Philips Mor (1539) Humaniste, mathématicien et poète néolatin. - Chanoine du chapitre de St Salvator d''Utrecht. - Fils du peintre Anthonis Mor van Dashorst (Antonio Moro) [http://data.bnf.fr/ark:/12148/cb12384177f#foaf:Person]
{/ud}
{ud0}
François Viète (Fontenay-le-Comte (Vendée), 1540) Mathématicien [http://data.bnf.fr/ark:/12148/cb120511976#foaf:Person]
{/ud}
{ud0}
Cormopede (1541) Mathématicien et astrologue. - Gentilhomme de la maison du Comte de Sterckenberg. - Date de naissance présumée d''après le "portrait de Cormopede à l''âge de 51 ans" figurant au F. A. 2 de l''"Almanach des almanachs pour l''an MDXCIII" [http://data.bnf.fr/ark:/12148/cb13491791f#foaf:Person]
{/ud}
{ud0}
Giovanni di Strasoldo (1544) Noble. - Homme d''arme. - Mathématicien. - Poète [http://data.bnf.fr/ark:/12148/cb15122132t#foaf:Person]
{/ud}
{ud0}
Guidobaldo Dal Monte (1545) Mathématicien et astronome. - Protégea Galilée et lui fit obtenir sa première chaire à Pise. - Né à Pesaro, meurt dans son chateau de Monte Baroccio [http://data.bnf.fr/ark:/12148/cb135173214#foaf:Person]
{/ud}
{ud0}
Renward Cysat (Lucerne (Suisse), 1545) Chancelier de la ville de Lucerne, Suisse. - Historien, dramaturge, pharmacien et naturaliste. - Père de : Cysat, Johann Baptist (1587-1653), mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb12748433g#foaf:Person]
{/ud}
{ud0}
Maurice Bressieu (1546) Mathématicien, philosophe et humaniste. - Titulaire de la chaire de mathématiques au Collège de France (1575-), orateur des rois de France à Rome (1586-), intendant de la Bibliothèque vaticane [http://data.bnf.fr/ark:/12148/cb13495175h#foaf:Person]
{/ud}
{ud0}
Tycho Brahe (Knudstrup (Suède), 1546) Astronome [http://data.bnf.fr/ark:/12148/cb11893749j#foaf:Person]
{/ud}
{ud0}
Muḥammad ibn al-Ḥusayan Bahāʼ al-Dīn ʿĀmilī (1547) Érudit arabe, philosophe, théologien, astronome, grammairien, auteur d''anthologies [http://data.bnf.fr/ark:/12148/cb12451570z#foaf:Person]
{/ud}
{ud0}
Nicodemus Frischlin (Balingen, Allemagne, 1547) Philologue et écrivain. - A enseigné les belles-lettres et les mathématiques à l''Université de Tubingue. - Traducteur d''Aristophane, de Callimaque et de Tryphiodore. - Auteur d''une comédie, présentée devant l''empereur Rodolphe, qui lui décerna le titre de comte-palatin [http://data.bnf.fr/ark:/12148/cb12463064b#foaf:Person]
{/ud}
{ud0}
Michele Zappulo (1548) Docteur en droit canon et civil. - Astronome, historien et poète [http://data.bnf.fr/ark:/12148/cb125454264#foaf:Person]
{/ud}
{ud0}
Simon Stevin (Bruges, Belgique, 1548) Professeur de mathématiques de Maurice de Nassau [http://data.bnf.fr/ark:/12148/cb119941019#foaf:Person]
{/ud}
{ud0}
Michel Coignet (1549) Ingénieur, mathématicien, fabricant d''instruments de navigation, poète [http://data.bnf.fr/ark:/12148/cb124231863#foaf:Person]
{/ud}
{ud0}
Francisco Sánchez (1550) Médecin, philosophe, mathématicien et poète. - Également connu sous le pseudonyme d''El Escéptico [http://data.bnf.fr/ark:/12148/cb120172346#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Crispo (Gallipoli, Italie, 1550) Prêtre. - Mathématicien, théologien et homme de lettres [http://data.bnf.fr/ark:/12148/cb10615268s#foaf:Person]
{/ud}
{ud0}
John Napier (1550) Mathématicien et théologien. - Baron de Merchiston [http://data.bnf.fr/ark:/12148/cb12353925j#foaf:Person]
{/ud}
{ud0}
Michael Moestlin (1550) Né à Göppingen (Wurtemberg). - Mathématicien. - Astronome. - Luthérien, hostile à la réforme grégorienne du calendrier [http://data.bnf.fr/ark:/12148/cb12330628m#foaf:Person]
{/ud}
{ud0}
Sigfridus Aronus Forsius (1550) Astronome et astrologue finlandais [http://data.bnf.fr/ark:/12148/cb131923734#foaf:Person]
{/ud}
{ud0}
Aegidius Martini (1551) Cartographe, mathématicien [http://data.bnf.fr/ark:/12148/cb15376579x#foaf:Person]
{/ud}
{ud0}
al-Silahî Nasuh (1551) Savant, miniaturiste et calligraphe ottoman. - A écrit plusieurs ouvrages sur les armes et les combats, sur la géométrie et les mathématiques ainsi que sur l''histoire. - Inventeur du jeu de "matraque", il est mieux connu sous son surnom "Matrakçı" : "Matrakçı Nasuh Efendi", "Nasuh al-Silahî", "Matraki", "Nasuh el-Mitraki", "Nasuh üs-Silahi", "Matraqçi Nasuh", "Nasuh b. Abdullah" et "Nasuh b. Karagöz el-Bosnevi" sont parmi les autres formes de référence [http://data.bnf.fr/ark:/12148/cb119562090#foaf:Person]
{/ud}
{ud0}
Anthoine Cathalan (1551) Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb14526861v#foaf:Person]
{/ud}
{ud0}
Bartolomeo Crescenzio (1551) Mathématicien, ingénieur naval et voyageur. - Fut capitaine de galère de la marine pontificale [http://data.bnf.fr/ark:/12148/cb125466487#foaf:Person]
{/ud}
{ud0}
Bernardo Gamucci (San Gimignano, Italie, 1551) Archéologue, architecte et mathématicien [http://data.bnf.fr/ark:/12148/cb10435220v#foaf:Person]
{/ud}
{ud0}
Camillo Agrippa (1551) Philosophe, mathématicien, architecte et ingénieur. - Est aussi l''auteur de l''un des premiers traité d''escrime [http://data.bnf.fr/ark:/12148/cb12536260s#foaf:Person]
{/ud}
{ud0}
Claude de Boissière (1551) Mathématicien. - Auteur d''un "Art poétique" [http://data.bnf.fr/ark:/12148/cb12509709h#foaf:Person]
{/ud}
{ud0}
Didier Henrion (1551) Professeur de mathématiques à Paris. - Ingénieur au service des Provinces-Unies. - N''est pas un pseudonyme de Clément Cyriaque de Mangin [http://data.bnf.fr/ark:/12148/cb144882445#foaf:Person]
{/ud}
{ud0}
Eilhard Lubbin (1551) Cartographe et mathématicien à Rostock [http://data.bnf.fr/ark:/12148/cb153777849#foaf:Person]
{/ud}
{ud0}
Faustus Verantius (Sebenico aujord''hui Šibenik (Croatie), 1551) Lexicographe, physicien et mathématicien. - Évêque de Czanad (Hongrie) (1594) et de la République de Venise. - Neveu d''Antun Vrančić (1504-1573) [http://data.bnf.fr/ark:/12148/cb10703670x#foaf:Person]
{/ud}
{ud0}
Francesco Feliciano (1551) Mathématicien, augustinien et miniaturiste [http://data.bnf.fr/ark:/12148/cb13485419n#foaf:Person]
{/ud}
{ud0}
Francis Van Schoten (1551) Professeur de mathématiques à Leyde, cartographe [http://data.bnf.fr/ark:/12148/cb15337130w#foaf:Person]
{/ud}
{ud0}
Francisco Zarzoso (Cella, Espagne, 1551) Astronome [http://data.bnf.fr/ark:/12148/cb119512329#foaf:Person]
{/ud}
{ud0}
Giacomo Lanteri (Paratico, Italie, 1551) Mathématicien et ingénieur [http://data.bnf.fr/ark:/12148/cb104024969#foaf:Person]
{/ud}
{ud0}
Girolamo Mercurio (1551) Dominicain. - Médecin, professeur de logique et de mathématique [http://data.bnf.fr/ark:/12148/cb13484092c#foaf:Person]
{/ud}
{ud0}
Giuseppe Unicorno (1551) Mathématicien. - Philosophe. - Astrologue. - Musicologue. - Théologien. - Originaire de Bergame [http://data.bnf.fr/ark:/12148/cb125394931#foaf:Person]
{/ud}
{ud0}
Helisaeus Röslin (1551) Mathématicien. - Astronome. - Médecin (pratiquait à Strasbourg et Francfort) [http://data.bnf.fr/ark:/12148/cb132003253#foaf:Person]
{/ud}
{ud0}
Jacques Besson (Colombières (Italie), 1551) Ingénieur et mathématicien. - Né à Colombières, vallée d''Oulx (aujourd''hui en Italie), d''après Eugénie Droz [http://data.bnf.fr/ark:/12148/cb12376654f#foaf:Person]
{/ud}
{ud0}
Jacques Maretz (1551) Dessinateur et graveur, mathématicien [http://data.bnf.fr/ark:/12148/cb153705873#foaf:Person]
{/ud}
{ud0}
Jamet Mettayer (1551) Autre(s) graphie(s) : Metayer ; Messor ; Metayerus ; Mettayier. - Variante(s) de prénom : Jean ; Jean Jamet. - Imprimeur-libraire ; imprimeur du Roi pour les mathématiques (1580) et imprimeur ordinaire du Roi (1583-1605). - En 1588, le roi Henri III le fait imprimeur officiel de sa congrégation des pénitents de l''Annonciation. De 1588 à 1594, il suit le Roi et la Cour à Blois puis  à Tours. - De retour à Paris, doit partager sa charge avec Pierre L''Huillier et Fédéric II Morel en vertu de l''arrêt du Conseil du 20 avril 1594. Revend à Tours son atelier et sa boutique à l''imprimeur Maurice Bouguereau. En mars  1596, le Roi l''associe à la Compagnie des usages avec Pierre L''Huillier. Décédé avant le 12 fév. 1605. Des publications paraissent encore sous son nom jusqu''en 1614. - A travaillé en association avec Mathurin Challenge (1573) et Barthélemy Gomet à Blois. S''associe à Tours (oct. 1591 - oct. 1593) avec Jean Richer, Claude de Monstr''oeil, Sébastien Molin, Mathieu I Guillemot, Georges Drobet et Marc Orry, son gendre. Travaille en association étroite avec Pierre L''Huillier et avec son fils Pierre Mettayer qui se trouvaient eux aussi à Tours [http://data.bnf.fr/ark:/12148/cb125031934#foaf:Person]
{/ud}
{ud0}
Jean Brohon (1551) Médecin, botaniste et astronome. - Fut recteur de l''Université de Caen [http://data.bnf.fr/ark:/12148/cb12545367f#foaf:Person]
{/ud}
{ud0}
Jean de Seville (1551) Mathématicien et hydrographe [http://data.bnf.fr/ark:/12148/cb13496046w#foaf:Person]
{/ud}
{ud0}
Jean Maria Coloni (1551) Citoyen de Romans en Dauphiné. - Mathématicien et astrologue [http://data.bnf.fr/ark:/12148/cb13479237s#foaf:Person]
{/ud}
{ud0}
Jean Tagaut (1551) Poète. - Médecin, mathématicien, professeur à Lausanne et Genève [http://data.bnf.fr/ark:/12148/cb12249180j#foaf:Person]
{/ud}
{ud0}
Joannes Portantius (1551) Astronome, mathématicien et géographe à Anvers, édité par Ortelius et De Jode [http://data.bnf.fr/ark:/12148/cb153817246#foaf:Person]
{/ud}
{ud0}
Johann Georg Locher (1551) Mathématicien [http://data.bnf.fr/ark:/12148/cb13006978f#foaf:Person]
{/ud}
{ud0}
Juan de Rojas Sarmiento (Palencia, Espagne, 1551) Mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb140653109#foaf:Person]
{/ud}
{ud0}
Marc Duncan (1551) Médecin, originaire d''Écosse, s''établit à Saumur en 1606 à l''appel de l''Académie protestante de la ville. - Professeur de mathématiques, de grec et d''humanités [http://data.bnf.fr/ark:/12148/cb13006401g#foaf:Person]
{/ud}
{ud0}
Martin Basanier (1551) Mathématicien, musicien [http://data.bnf.fr/ark:/12148/cb12510914p#foaf:Person]
{/ud}
{ud0}
Martinus Hortensius (1551) Astronome [http://data.bnf.fr/ark:/12148/cb13007384z#foaf:Person]
{/ud}
{ud0}
Nicolaus Reimarus Ursus (1551) Mathématicien. - Astronome [http://data.bnf.fr/ark:/12148/cb145753184#foaf:Person]
{/ud}
{ud0}
Paschasius Hamellius (1551) Mathématicien [http://data.bnf.fr/ark:/12148/cb13173242d#foaf:Person]
{/ud}
{ud0}
Paul Yvon (1551) Mathématicien. - Achète la seigneurie de Laleu en 1592 et y fait construire le château. - Maire de La Rochelle en 1616. - S'' installe à Paris en décembre 1633 et abjure le protestantisme [http://data.bnf.fr/ark:/12148/cb12135021d#foaf:Person]
{/ud}
{ud0}
Peter Laicksteen (1551) Cartographe et astronome [http://data.bnf.fr/ark:/12148/cb15370391s#foaf:Person]
{/ud}
{ud0}
Phillebert Charpentier (1551) Éditeur. - Marchand d''estampes et d''instruments de mathématiques [http://data.bnf.fr/ark:/12148/cb16553551w#foaf:Person]
{/ud}
{ud0}
Pierre Forcadel (1551) Mathématicien [http://data.bnf.fr/ark:/12148/cb103947442#foaf:Person]
{/ud}
{ud0}
Pierre Hérigone (1551) Professeur de mathématiques à Paris. - N''est pas un pseudonyme de Clément Cyriaque de Mangin [http://data.bnf.fr/ark:/12148/cb144882503#foaf:Person]
{/ud}
{ud0}
Pierre Le Voirier (1551) Autre(s) graphie(s) : Le Voirrier ; Le Verrier. - Imprimeur du Roi pour les mathématiques. - Beau-père de Mathieu I Guillemot (1584). Encore en activité le 31 déc. 1589. Décédé entre 1591 et le 7 nov. 1594 (compte de succession) [http://data.bnf.fr/ark:/12148/cb12230743m#foaf:Person]
{/ud}
{ud0}
Teodato Osio (1551) Mathématicien. - Musicien [http://data.bnf.fr/ark:/12148/cb125559272#foaf:Person]
{/ud}
{ud0}
Walther Hermann Ryff (1551) Apothicaire, médecin, mathématicien et architecte [http://data.bnf.fr/ark:/12148/cb11948264d#foaf:Person]
{/ud}
{ud0}
William Welwod (1551) Mathématicien. - Professeur de droit [http://data.bnf.fr/ark:/12148/cb125630488#foaf:Person]
{/ud}
{ud0}
Jost Bürgi (1552) Horloger, astronome et mathématicien suisse [http://data.bnf.fr/ark:/12148/cb123814270#foaf:Person]
{/ud}
{ud0}
Bernardino Baldi (Urbino, Italie, 1553) Abbé de Guastalla. - Poète, prosateur, mathématicien et historien. - Polyglotte, connaissait le grec et le latin, l''hébreu, l''arabe, le persan et le hongrois [http://data.bnf.fr/ark:/12148/cb12179488k#foaf:Person]
{/ud}
{ud0}
Jacob Christmann (1554) Orientaliste, mathématicien et astronome. - A été le premier à utiliser le télescope avec d''autres instruments comme le sextant [http://data.bnf.fr/ark:/12148/cb12560133s#foaf:Person]
{/ud}
{ud0}
Giovanni Antonio Magini (Padoue, Italie, 1555) Astronome, mathématicien et géographe. - A occupé la chaire d''astronomie à l''Université de Bologne en 1588. - Auteur prétendu de prédictions et de nombreux almanachs publiés en France, en Allemagne et aux Pays-Bas jusqu''au 19e siècle [http://data.bnf.fr/ark:/12148/cb12162475b#foaf:Person]
{/ud}
{ud0}
Jean Du Temps (1555) Fils de l''avocat Jean Du Temps I, il fut lui-même avocat et avait des connaissances en astrologie et mathématique. Frère d''Adam Du Temps, spécialiste des fortifications qui participa peut-être à la carte du Blésois dont il est l''auteur [http://data.bnf.fr/ark:/12148/cb15302460t#foaf:Person]
{/ud}
{ud0}
Sethus Calvisius (1556) Organiste, compositeur et théoricien de la musique ; astronome ; historien ; libraire et éditeur de musique. - Natif de Gorsleben près de Sachsenburg (Thuringe) et issu d''une famille paysanne. Après des études aux universités de Leipzig et Helmstedt, il devient à partir de 1581 et jusqu''à sa mort "cantor" de plusieurs églises de Leipzig successivement. Auteur de plusieurs ouvrages théoriques et compositions musicales, ainsi que d''un "Opus chronologicum" (1605 ; au moins 6 rééd.) et d''un "Elenchus calendarii Gregoriani" (1612). Décédé à Leipzig en nov. 1615. À distinguer du pasteur et prédicateur de Quedlinburg Sethus Calvisius (ou : Seth Kal(l)witz) (1639-1698), parfois appelé à tort "Sethus Calvisius le fils" [http://data.bnf.fr/ark:/12148/cb12875550d#foaf:Person]
{/ud}
{ud0}
Guillaume de Nautonier (1557) Savant, mathématicien, astronome, d''origine protestante, géographe du roi Henri IV [http://data.bnf.fr/ark:/12148/cb12412403z#foaf:Person]
{/ud}
{ud0}
Christoph Meurer (1558) Professeur de mathématiques à Leipzig (1613). - Médecin [http://data.bnf.fr/ark:/12148/cb14333201g#foaf:Person]
{/ud}
{ud0}
Jean-Édouard Du Monin (1559) Mathématicien et spécialiste des langues anciennes. - Fut professeur à Paris, puis à Poitiers [http://data.bnf.fr/ark:/12148/cb12463074n#foaf:Person]
{/ud}
{ud0}
Thomas Hariot (Oxford, GB, 1560) Mathématicien et astronome. - Envoyé comme conseiller aux Amériques en 1585-86 [http://data.bnf.fr/ark:/12148/cb12215671c#foaf:Person]
{/ud}
{ud0}
Thomas Harriot (1560) Mathématicien, physicien et astronome anglais [http://data.bnf.fr/ark:/12148/cb124346111#foaf:Person]
{/ud}
{ud0}
Adrianus Romanus (Louvain, 1561) Médecin, mathématicien et voyageur. - Enseigna à Louvain et à Würzburg, fut mathématicien royal en Pologne [http://data.bnf.fr/ark:/12148/cb12459969s#foaf:Person]
{/ud}
{ud0}
Bartholomäus Pitiscus (1561) A aussi écrit en latin. - Prédicateur protestant à la cour de l''Électeur palatin. - Également auteur d''ouvrages mathématiques [http://data.bnf.fr/ark:/12148/cb121457326#foaf:Person]
{/ud}
{ud0}
Henry Briggs (1561) Mathématicien [http://data.bnf.fr/ark:/12148/cb12305061c#foaf:Person]
{/ud}
{ud0}
Jean Tarde (La Roque-Gageac (Dordogne), 1561) Mathématicien, historien, géographe et astronome. - Chanoine [http://data.bnf.fr/ark:/12148/cb12641353z#foaf:Person]
{/ud}
{ud0}
Jean Tarde (1561) Chanoine de Sarlat, mathématicien et cartographe [http://data.bnf.fr/ark:/12148/cb153143878#foaf:Person]
{/ud}
{ud0}
P. Christoph Grienberger (1561) Jésuite, mathématicien, astronome et architecte. Il a realisé les plans du Collège d''Aurillac et du Charleville [http://data.bnf.fr/ark:/12148/cb10686921r#foaf:Person]
{/ud}
{ud0}
Philippus Lansbergen (Gand (Belgique), 1561) Mathématicien, astronome et pasteur [http://data.bnf.fr/ark:/12148/cb130073828#foaf:Person]
{/ud}
{ud0}
Christen Sørensen Longomontanus (1562) Astronome et mathématicien. - Fut l''élève de Tycho-Brahé. - Professeur de hautes mathématiques à l''Université de Copenhague [http://data.bnf.fr/ark:/12148/cb13011001c#foaf:Person]
{/ud}
{ud0}
Guangqi Xu (Shanghai, 1562) Haut fonctionnaire chinois, initié et converti au christianisme par le père jésuite Matteo Ricci. - Mathématicien. - Astronome. - Disciple de Matteo Ricci [http://data.bnf.fr/ark:/12148/cb150892932#foaf:Person]
{/ud}
{ud0}
Galileo Galilei (Pise, Italie, 1564) Physicien, philosophe, astronome [http://data.bnf.fr/ark:/12148/cb11903931b#foaf:Person]
{/ud}
{ud0}
Luis Teixeira (1564) Jésuite portugais, mathématicien et cartographe actif de 1564 à 1613 [http://data.bnf.fr/ark:/12148/cb153361957#foaf:Person]
{/ud}
{ud0}
Edward Brerewood (1565) Antiquaire et mathématicien, linguiste et humaniste. - Professeur d''astronomie au Gresham college de Londres [http://data.bnf.fr/ark:/12148/cb125109678#foaf:Person]
{/ud}
{ud0}
Eilhard Lubin (1565) Humaniste, philologue, cartographe, théologien et mathématicien [http://data.bnf.fr/ark:/12148/cb15040859j#foaf:Person]
{/ud}
{ud0}
Paolo Antonio Foscarini (Montalto Uffugo, Italie, 1565) Carme. - Théologien. - Mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb12377530d#foaf:Person]
{/ud}
{ud0}
Scipione Chiaramonti (Cesena, Italie, 1565) Astronome et philosophe. - Professeur de philosophie à l''Université de Pise [http://data.bnf.fr/ark:/12148/cb10545041n#foaf:Person]
{/ud}
{ud0}
Fr. François d'' Aguillon (1566) Jésuite, architecte et mathématicien. Auteur d''un projet pour le noviciat de Tournai. Préposé de la Maison professe, professeur d''Anvers [http://data.bnf.fr/ark:/12148/cb16240952w#foaf:Person]
{/ud}
{ud0}
Georg Ludwig Frobenius (1566) Libraire. - Natif d''Iphofen, près de Wurzbourg. Titulaire d''une maîtrise de théologie. Après des études aux universités de Tübingen et Wittenberg, travaille avec l''astronome Tycho Brahe jusqu''à la mort de celui-ci. Reçu ensuite bourgeois de Hambourg, où il s''établit libraire [http://data.bnf.fr/ark:/12148/cb12229506t#foaf:Person]
{/ud}
{ud0}
Marco Antonio De Dominis (l''île de Rab (Croatie), 1566) Professeur de rhétorique, mathématiques et philosophie dans la Compagnie de Jésus, à Padoue et Brescia. - Evêque de Segna (Senj ou Zengg en Croatie) de 1600 à 1602; de Spalato (Split) de 1602 à 1615. - Gagné au protestantisme et exilé en Angleterre, doyen de Windsor. - Abjure et rentre en grâce (1622) [http://data.bnf.fr/ark:/12148/cb121335726#foaf:Person]
{/ud}
{ud0}
Marinus Ghetaldus (Raguse aujourd''hui Dubrovnik (Croatie), 1566) Mathématicien et physicien. - Il exerça une grande influence sur le développement de l''application de l''algèbre à la géométrie. - Il mit au point le miroir parabolique, aujourd''hui conservé au National Maritime Museum de Londres. - Il collabora, entre autres, avec François Viète en France et avec Galilée en Italie [http://data.bnf.fr/ark:/12148/cb146476018#foaf:Person]
{/ud}
{ud0}
François de Aguilón (1567) Architecte et mathématicien belge d''origine espagnole [http://data.bnf.fr/ark:/12148/cb119998212#foaf:Person]
{/ud}
{ud0}
Johann Hartmann (1568) Mathématicien et naturaliste. - Professeur de chimie à l''Université de Marburg [http://data.bnf.fr/ark:/12148/cb13009199x#foaf:Person]
{/ud}
{ud0}
P. Jacques de Guernisac (1568) Jésuite et architecte, professeur de mathématique à Pont-à-Mousson puis à La Flèche, recteur du collège des Jésuites de Quimper [http://data.bnf.fr/ark:/12148/cb16215104d#foaf:Person]
{/ud}
{ud0}
Mutio Oddi (1569) Mathématicien. - Architecte [http://data.bnf.fr/ark:/12148/cb165299645#foaf:Person]
{/ud}
{ud0}
Andrea Argoli (1570) Mathématicien. - Astronome. - Professeur de mathématique à l''Université de Padoue [http://data.bnf.fr/ark:/12148/cb121593328#foaf:Person]
{/ud}
{ud0}
Erasmus Schmied (1570) Né à Delitzsch, près de Leipzig. - Professeur de grec et de mathématiques à Wittenberg [http://data.bnf.fr/ark:/12148/cb12045847b#foaf:Person]
{/ud}
{ud0}
Anders Bure (1571) Cartographe et mathématicien [http://data.bnf.fr/ark:/12148/cb14509982d#foaf:Person]
{/ud}
{ud0}
Giovanni Branca (1571) Architecte, ingénieur et mathématicien. - Né à Pesaro, meurt à Pérouse [http://data.bnf.fr/ark:/12148/cb121826472#foaf:Person]
{/ud}
{ud0}
Johannes Isaacus Pontanus (Elseneur (Danemark), 1571) Historien. - Philologue. - Professeur de mathématiques et de physique [http://data.bnf.fr/ark:/12148/cb123875836#foaf:Person]
{/ud}
{ud0}
Johannes Kepler (1571) Astronome et mathématicien [http://data.bnf.fr/ark:/12148/cb11909597m#foaf:Person]
{/ud}
{ud0}
Willem Jansz Blaeu (1571) Autre(s) graphie(s) : Janssonius Blaeuw. - Imprimeur-libraire et éditeur de cartes et d''atlas. - Originaire d''Alkmaar ou des environs. Passe 2 ans auprès de Tycho Brahé au Danemark. À son retour à Amsterdam en 1596, s''établit cartographe et fabricant de globes terrestres et célestes. Monte ensuite une imprimerie et une fonderie. Également auteur d''ouvrages cartographiques et astronomiques [http://data.bnf.fr/ark:/12148/cb12169772t#foaf:Person]
{/ud}
{ud0}
Cornelius Drebbel (1572) Graveur. - Mathématicien. - Physicien. - Chimiste [http://data.bnf.fr/ark:/12148/cb12382467g#foaf:Person]
{/ud}
{ud0}
Rodolphus Goclenius (1572) Docteur en médecine en 1601. - Professeur de physique en 1608. - Professeur de mathématiques à l''Université de Marbourg en 1621 [http://data.bnf.fr/ark:/12148/cb121595722#foaf:Person]
{/ud}
{ud0}
Samuel Marolois (1572) Mathématicien français ayant vécu une grande partie de sa vie aux Pays-Bas [http://data.bnf.fr/ark:/12148/cb14912871p#foaf:Person]
{/ud}
{ud0}
Thomas Lydyat (Okerton, GB, 1572) Mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb12390032f#foaf:Person]
{/ud}
{ud0}
Christoph Scheiner (1575) Jésuite. - Physicien, mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb13483688j#foaf:Person]
{/ud}
{ud0}
Michelangelo Galilei (1575) Luthiste et compositeur italien de la Renaissance. - Fils du compositeur et théoricien Vincenzo Galilei, et frère de l''astronome Galileo Galilei [http://data.bnf.fr/ark:/12148/cb140013401#foaf:Person]
{/ud}
{ud0}
Octavio Pisani (Naples, Italie, 1575) Cosmographe et astronome, travaille à Anvers de 1612 à 1637 [http://data.bnf.fr/ark:/12148/cb15404394h#foaf:Person]
{/ud}
{ud0}
Francesco Ingoli (Ravenne (Italie), 1578) Secrétaire de la propagande, débat avec Copernic (en 1616 et 1624) et écrit Relazione delle quattro parti del mondo avec pour objectif de soutenir missions et propagande religieuses. - Étudie l''astronomie, la cosmographie et la géographie et connait le grec, le français, l''espagnon et l''arabe. - Diplômé en droit civil et en droit canon à l''Université de Padoue, Italie [http://data.bnf.fr/ark:/12148/cb13749501h#foaf:Person]
{/ud}
{ud0}
Sybrandt Hansz. Cardinael (Harlingen (Pays-Bas), 1578) Mathématicien [http://data.bnf.fr/ark:/12148/cb15944052f#foaf:Person]
{/ud}
{ud0}
Cristóvão Ferreira (1580) Supérieur et procurateur de la mission jésuite au Japon, il abjura en 1633 et se convertit au zen. - Auteur en 1636 de la "Supercherie dévoilée". - Traducteur d''ouvrages d''astronomie et de chirurgie [http://data.bnf.fr/ark:/12148/cb13524212c#foaf:Person]
{/ud}
{ud0}
Godfried Wendelen (1580) Astronome et géomètre. - Avocat au Parlement de Paris puis doyen du chapitre de Rothnac, Belgique [http://data.bnf.fr/ark:/12148/cb123969373#foaf:Person]
{/ud}
{ud0}
Joannes Michael Gigas (1580) Docteur, mathématicien et géographe édité par Blaeu et Hondius [http://data.bnf.fr/ark:/12148/cb153239798#foaf:Person]
{/ud}
{ud0}
Johann Faulhaber (1580) Mathématicien allemand. S''est aussi intéressé à l''ingénierie des fortifications [http://data.bnf.fr/ark:/12148/cb137778453#foaf:Person]
{/ud}
{ud0}
Nicolas-Claude Fabri Peiresc (Belgentier (Var), 1580) Conseiller au Parlement de Provence. - Astronome, archéologue et naturaliste [http://data.bnf.fr/ark:/12148/cb11918940q#foaf:Person]
{/ud}
{ud0}
Willebrordus Snellius (Leyde, Pays-Bas, 1580) Mathématicien, astronome et géographe [http://data.bnf.fr/ark:/12148/cb15336105f#foaf:Person]
{/ud}
{ud0}
Claude-Gaspard Bachet (Bourg-en-Bresse (Ain), 1581) Mathématicien et littérateur. - Sieur de Méziriac. - Érudit, auteur de poèmes en français, italien et latin. - Membre de l''Académie française (élu en 1634) [http://data.bnf.fr/ark:/12148/cb120028244#foaf:Person]
{/ud}
{ud0}
Alexandre Anderson (1582) Mathématicien [http://data.bnf.fr/ark:/12148/cb16296598k#foaf:Person]
{/ud}
{ud0}
Jean François (1582) Nom en religion de Jean Charnage. - Jésuite. - Professeur de philosophie et de mathématiques à La Flèche [http://data.bnf.fr/ark:/12148/cb121629197#foaf:Person]
{/ud}
{ud0}
Mario Bettini (Bologne, Italie, 1582) Jésuite. - Philosophe et mathématicien [http://data.bnf.fr/ark:/12148/cb12545452p#foaf:Person]
{/ud}
{ud0}
Matthias Bernegger (Hallstatt (Autriche), 1582) Philologue, historien, mathématicien et astronome. - Protestant. - Professeur d''histoire et d''éloquence à Strasbourg, recteur de l''Université de cette même ville [http://data.bnf.fr/ark:/12148/cb129928534#foaf:Person]
{/ud}
{ud0}
Jean-Baptiste Morin (Villefranche-sur-Saône (Rhône), 1583) Astronome et mathématicien [http://data.bnf.fr/ark:/12148/cb11916881j#foaf:Person]
{/ud}
{ud0}
Orazio Grassi (Savone, Italie, 1583) Jésuite. - Mathématicien, astronome et architecte [http://data.bnf.fr/ark:/12148/cb125377863#foaf:Person]
{/ud}
{ud0}
Filippo Finella (Naples, Italie, 1584) Astrologue. - Astronome. - Auteur dramatique [http://data.bnf.fr/ark:/12148/cb122006609#foaf:Person]
{/ud}
{ud0}
Grégoire de Saint-Vincent (1584) Mathématicien. - Astronome [http://data.bnf.fr/ark:/12148/cb16197665z#foaf:Person]
{/ud}
{ud0}
James Hume (1584) Mathématicien. - Astronome. - Historien. - Hébraïsant. - Actif en 1639. - A vécu à Paris. - Fils de David Hume (1558-163.) et frère aîné de la poétesse et traductrice Anna Hume (1586?-16..) [http://data.bnf.fr/ark:/12148/cb12072629r#foaf:Person]
{/ud}
{ud0}
Claude Mydorge (1585) Mathématicien et physicien [http://data.bnf.fr/ark:/12148/cb144888873#foaf:Person]
{/ud}
{ud0}
Mario Guiducci (Florence, Italie, 1585) Homme de lettres et astronome. - A collaboré avec Galileo Galilei [http://data.bnf.fr/ark:/12148/cb144609004#foaf:Person]
{/ud}
{ud0}
Melchior Inchofer (Vienne, 1585) Jésuite. - Philosophe, mathématicien et théologien professeur à Messine, Italie [http://data.bnf.fr/ark:/12148/cb10735485h#foaf:Person]
{/ud}
{ud0}
Philipp Müller (1585) Mathématicien, médecin, chimiste et botaniste. - Professeur à l''université de Leipzig [http://data.bnf.fr/ark:/12148/cb14065362j#foaf:Person]
{/ud}
{ud0}
Jean L''Hoste (Nancy, 1586) Ingénieur. - Intendant des fortifications du duc de Lorraine. - Professeur de droit et de mathématiques à Pont-à-Mousson [http://data.bnf.fr/ark:/12148/cb16628764j#foaf:Person]
{/ud}
{ud0}
Niccolò Zucchi (Parme, Italie, 1586) Jésuite. - Recteur du Collegio romano (1646-1649). - Astronome [http://data.bnf.fr/ark:/12148/cb10077816w#foaf:Person]
{/ud}
{ud0}
Benedetto Castelli (Brescia, Italie, 1587) Dominicain. - Mathématicien, inventeur et écrivain. - Disciple de Galilée, dont il défendit les théories astronomiques [http://data.bnf.fr/ark:/12148/cb12545385c#foaf:Person]
{/ud}
{ud0}
Joachim Jungius (1587) Naturaliste, mathématicien et philosophe [http://data.bnf.fr/ark:/12148/cb120247195#foaf:Person]
{/ud}
{ud0}
Libert Froidmont (Liège, 1587) Théologien. - Mathématicien, physicien et géologue [http://data.bnf.fr/ark:/12148/cb14462868z#foaf:Person]
{/ud}
{ud0}
François Derand (1588) Jésuite. - Professeur de grammaire et de mathématiques. - Architecte. - Né à Vic s/Seille (Moselle), mort à Agde (Hérault) [http://data.bnf.fr/ark:/12148/cb13012148j#foaf:Person]
{/ud}
{ud0}
Jacques Grandami (1588) Jésuite. - Professeur de belles lettres, de philosophie et de théologie, puis recteur de Bourges, Rennes, La Flèche, Tours et Rouen. - Visiteur de la province de France. - Astronome [http://data.bnf.fr/ark:/12148/cb12155155d#foaf:Person]
{/ud}
{ud0}
Marin Mersenne (1588) Philosophe et savant, astronome, mathématicien. - Théoricien de la musique. - Minime [http://data.bnf.fr/ark:/12148/cb119157157#foaf:Person]
{/ud}
{ud0}
Eberhard Welper (1590) Imprimeur-libraire. - Natif de Lohra (comté de Lohenstein, près de Marburg, Allemagne). Mathématicien, astrologue et astronome, il se fixe à Strasbourg en 1618. Établi libraire en 1620 puis imprimeur dès 1621. Publie notamment chaque année un almanach et des prédictions. Auteur de plusieurs ouvrages scientifiques, dont des "Elementa geometrica..." (1re éd., 1620), une "Gnomonica" (1625), un "Compendium astronomiae..." (1634) et un traité de la divination, "Rota-Fortunae, oder Glück-Rad..." (s. d., plusieurs rééd.). De 1634 à 1639, assure des fonctions d''enseignant au Gymnase (lycée) de Strasbourg. En 1654, sollicite en vain la charge d''imprimeur de l''évêché de Saverne. De 1653 à 1661, imprime sous le pseudonyme de Hartmann Bär quelques ouvrages pour l''académie des Jésuites à Molsheim. Son fils aîné Johann Welper (1642-1720) lui succède en 1664, mais des éditions paraissent encore sous son nom en 1689. Son autre fils Eberhard (II) Welper (1644-1670) sera lui aussi mathématicien, astrologue et astronome [http://data.bnf.fr/ark:/12148/cb158750586#foaf:Person]
{/ud}
{ud0}
Johannes Wilhelm Lauremberg (1590) Auteur, mathématicien et historien à Rostock [http://data.bnf.fr/ark:/12148/cb15377794m#foaf:Person]
{/ud}
{ud0}
Jean Leurechon (Bar-le-Duc, 1591) Jésuite. - Professeur de philosophie et de mathématiques, à Pont-à-Mousson notamment. - Confesseur du duc de Lorraine Charles IV. - Henry Van Etten, qui signe la dédicace de la première édition des "Récréations mathématiques" n''est pas un pseudonyme de Jean Leurechon, mais le nom d''un de ses élèves, qui aurait réellement existé d''après Trevor H. Hall [http://data.bnf.fr/ark:/12148/cb13009618g#foaf:Person]
{/ud}
{ud0}
Joseph Salomon Delmedigo (1591) Médecin. - Astronome. - Mathématicien. - Né en Crète. - Fils d''Eliya Delmedigo (1460-1497) [http://data.bnf.fr/ark:/12148/cb122623548#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Vertova (Bergame, Italie, 1592) Mathématicien et ingénieur militaire. - Chevalier de l''Ordre de Malte [http://data.bnf.fr/ark:/12148/cb15093021d#foaf:Person]
{/ud}
{ud0}
Johann Adam Schall von Bell (1592) Jésuite. - Missionnaire en Chine (de 1619 à sa mort). - Mathématicien. - Conseiller et astronome de la Cour impériale de Chine [http://data.bnf.fr/ark:/12148/cb12362941r#foaf:Person]
{/ud}
{ud0}
Pierre Gassendi (Champtercier, près de Digne, 1592) Philosophe, astronome, mathématicien, physicien, docteur en théologie et théoricien de la musique. - Entre dans les ordres en 1615 [http://data.bnf.fr/ark:/12148/cb120250393#foaf:Person]
{/ud}
{ud0}
Wilhelm Schickard (Herrenberg, Allemagne, 1592) Mathématicien, astronome, professeur d''agriculture [http://data.bnf.fr/ark:/12148/cb11969696s#foaf:Person]
{/ud}
{ud0}
Albert Girard (Saint-Mihiel, 1595) Mathématicien et ingénieur. - Ingénieur dans l''armée de Frédéric de Nassau, prince d''Orange [http://data.bnf.fr/ark:/12148/cb121123333#foaf:Person]
{/ud}
{ud0}
Pierre Bardin (Rouen, 1595) Homme de lettres, philosophe et mathématicien. - Précepteur. - Membre de l''Académie française (élu en 1634) [http://data.bnf.fr/ark:/12148/cb125272379#foaf:Person]
{/ud}
{ud0}
Pierre Bourdin (1595) Jésuite. - Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb123902440#foaf:Person]
{/ud}
{ud0}
Daniel Mögling (Böblingen, 1596) Alchimiste, rosicrucien, médecin et astronome [http://data.bnf.fr/ark:/12148/cb167575369#foaf:Person]
{/ud}
{ud0}
Jacob Golius (1596) Orientaliste. - Mathématicien. - Philologue, spécialiste des littératures [http://data.bnf.fr/ark:/12148/cb123338386#foaf:Person]
{/ud}
{ud0}
René Descartes (Descartes (Indre-et-Loire), 1596) Philosophe et mathématicien [http://data.bnf.fr/ark:/12148/cb11899775j#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Hodierna (1597) Astronome italien [http://data.bnf.fr/ark:/12148/cb120704558#foaf:Person]
{/ud}
{ud0}
Bonaventura Cavalieri (Milan, Italie, 1598) Jésuite. - Mathématicien, géomètre et astronome, disciple de Galilée. - Fut professeur à l''Université de Bologne [http://data.bnf.fr/ark:/12148/cb12085151g#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Riccioli (Ferrare, Italie, 1598) Jésuite. - Astronome. - Professeur de lettres, de philosophie et de théologie, à Parme puis à Bologne. - Mathématicien et historien de la géographie [http://data.bnf.fr/ark:/12148/cb12546680q#foaf:Person]
{/ud}
{ud0}
Pierre Petit (1598) Mathématicien et physicien. - Intendant général des ports et fortifications de France (1649) [http://data.bnf.fr/ark:/12148/cb123944733#foaf:Person]
{/ud}
{ud0}
Adam Olearius (Aschersleben, Allemagne, 1599) Voyageur, en particulier en Russie et en Perse. - Mathématicien [http://data.bnf.fr/ark:/12148/cb12817277v#foaf:Person]
{/ud}
{ud0}
Jacob Aertsz Colom (1599) Mathématicien, navigateur et cartographe. - Imprimeur à Amsterdam [http://data.bnf.fr/ark:/12148/cb153358650#foaf:Person]
{/ud}
{ud0}
Adriaan Vlacq (1600) Autre(s) graphie(s) : Ulack ; Vlac. - Variante(s) de prénom : Adriaen ; Adrien. - Imprimeur-libraire. - Originaire de Gouda. Édite différents périodiques dont "De Haegsche Vrijdaeghse Post-Tijdingen". A publié en 1659 une contrefaçon de Johannes Elzevier et de Pieter Leffen. A également publié sous les fausses adresses et pseudonymes de "Cologne, Pierre Du Marteau" et "Amsterdam, Peter Le Grand". - Également mathématicien connu pour ses travaux sur les logarithmes et auteur d''ouvrages d''astronomie et de pamphlets en faveur des royalistes anglais en 1652-1655. Mort peu avant le 8 avril 1667. Des éd. paraissent encore sous son nom jusqu''en 1669, en association avec Johannes Vlacq [http://data.bnf.fr/ark:/12148/cb121635061#foaf:Person]
{/ud}
{ud0}
Antoine de Laloubère (1600) Jésuite. - Mathématicien et géomètre, fut le premier scientifique à étudier les propriétés de l''hélice. - Polémiqua avec Pascal, qui l''appelle "Allouerus" dans l''"Histoire de la roulette". - Professeur de rhétorique, de théologie et de mathématiques au collège de Toulouse. - Né à Rieux, meurt à Toulouse [http://data.bnf.fr/ark:/12148/cb13006798h#foaf:Person]
{/ud}
{ud0}
Giacomo Oddi (1600) Cartographe et mathématicien. Etudie à Naples [http://data.bnf.fr/ark:/12148/cb153917817#foaf:Person]
{/ud}
{ud0}
Jakob Bartsch (1600) Médecin. - Professeur de mathématiques à Strasbourg. - Astronome. - Gendre et collaborateur de l''astronome Johann Kepler (1571-1630) [http://data.bnf.fr/ark:/12148/cb12163632v#foaf:Person]
{/ud}
{ud0}
Emmanuel Maignan (1601) Religieux minime. - Philosophe, mathématicien et peintre. - Membre de la Société des lanternistes [http://data.bnf.fr/ark:/12148/cb130127157#foaf:Person]
{/ud}
{ud0}
Florimond de Beaune (1601) Mathématicien [http://data.bnf.fr/ark:/12148/cb11890827s#foaf:Person]
{/ud}
{ud0}
Ovidio Montalbani (1601) Docteur en philosophie et médecine de l'' Université de Bologne, professeur de mathématiques, chargé du musée Aldrovandi à partir de 1657, fut aussi un citoyen actif de Bologne, où il assura plusieurs magistratures ("giudice del Foro de mercanti, e de tribuni della plebe"). - Membre de l''Accademia dei Gelati de Bologne ("l''Innestato"), de l''Accademia degli Indomiti de Bologne ("lo Stellato"), et de l''Accademia della Notte de Bologne ("il Rugiadoso") [http://data.bnf.fr/ark:/12148/cb12064289s#foaf:Person]
{/ud}
{ud0}
Pierre de Fermat (Beaumont-de-Lomagne (Tarn-et-Garonne), 1601) Mathématicien, célèbre pour son théorème. - On lui doit aussi le Principe de Fermat en optique. - Conseiller au Parlement de Toulouse et commissaire en la chambre des requêtes du Palais à Toulouse (mai 1631) [http://data.bnf.fr/ark:/12148/cb11902568b#foaf:Person]
{/ud}
{ud0}
Athanasius Kircher (Geisa (Allemagne), 1602) Jésuite. - Professeur de physique, de mathématiques et de langues orientales, Collegio Romano, Rome. - Dessinateur et graveur [http://data.bnf.fr/ark:/12148/cb119097824#foaf:Person]
{/ud}
{ud0}
Gilles Personne de Roberval (Roberval, Oise, 1602) Professeur de philosophie (1634) et de mathématiques (1655) au Collège royal, Paris. - Membre fondateur de l''Académie royale des sciences [http://data.bnf.fr/ark:/12148/cb12144923j#foaf:Person]
{/ud}
{ud0}
Jacques de Billy (1602) Jésuite (à partir de 1619). - Mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb123773436#foaf:Person]
{/ud}
{ud0}
John Greaves (Colemore, GB, 1602) Mathématicien. - Orientaliste. - Professeur d''astronomie à Londres puis à Oxford [http://data.bnf.fr/ark:/12148/cb129277690#foaf:Person]
{/ud}
{ud0}
Pierre Gautruche (1602) Jésuite. - Professeur de philosophie, de théologie et de mathématiques. - Identifié par certains à Pierre Gautier (1599-16..), luthiste et compositeur [http://data.bnf.fr/ark:/12148/cb121990328#foaf:Person]
{/ud}
{ud0}
Blaise-François de Pagan (Avignon, 1604) Ingénieur et astronome [http://data.bnf.fr/ark:/12148/cb12155087r#foaf:Person]
{/ud}
{ud0}
Claude Hardy (1604) Fils de Sébastien Hardy. - Conseiller au Châtelet. - Mathématicien. - Ami de Mydorge, Descartes et du Père Mersenne ; souvent cité dans la correspondance de ces deux derniers [http://data.bnf.fr/ark:/12148/cb12134536k#foaf:Person]
{/ud}
{ud0}
Bernard Frénicle de Bessy (1605) Mathématicien, géomètre et arithméticien. - Membre de l''Académie des Sciences. - Conseiller à la Cour des monnaies [http://data.bnf.fr/ark:/12148/cb12459881c#foaf:Person]
{/ud}
{ud0}
Ismaël Boulliau (Loudun (Vienne), 1605) Astronome. - Secrétaire de Jacques Du Puy et attaché au président de Thou [http://data.bnf.fr/ark:/12148/cb124621511#foaf:Person]
{/ud}
{ud0}
Juan de Caramuel y Lobkowitz (Madrid, 1606) Cistercien. - Evêque de Satriano et Campagna (1657-1673) puis de Vigevano (1673-). - Humaniste, théologien, mathématicien, philosophe et architecte. - Défenseur de la doctrine probabiliste [http://data.bnf.fr/ark:/12148/cb12392566m#foaf:Person]
{/ud}
{ud0}
Evangelista Torricelli (Faenza, Italie, 1608) Physicien et mathématicien [http://data.bnf.fr/ark:/12148/cb12117674q#foaf:Person]
{/ud}
{ud0}
Gaspar Schott (Königshaufen, Allemagne, 1608) Mathématicien et physicien. - Jésuite [http://data.bnf.fr/ark:/12148/cb12519717b#foaf:Person]
{/ud}
{ud0}
Giovanni Alfonso Borelli (Naples, Italie, 1608) Mathématicien, phycisien, médecin, philosophe. - Membre de l''Accademia del Cimento [http://data.bnf.fr/ark:/12148/cb12462534j#foaf:Person]
{/ud}
{ud0}
Giovan Battista Nicolosi (Paternò, Italie, 1610) Géographe et cartographe. - Professeur de mathématiques et de géographie à l''Université de Rome [http://data.bnf.fr/ark:/12148/cb15404103t#foaf:Person]
{/ud}
{ud0}
Józef Naronowicz-Naroński (1610) Mathématicien. - Cartographe. - Architecte au service de la famille Radzwill. - Né en Lituanie [http://data.bnf.fr/ark:/12148/cb150812338#foaf:Person]
{/ud}
{ud0}
Maria Cunitia (1610) Astronome [http://data.bnf.fr/ark:/12148/cb162514419#foaf:Person]
{/ud}
{ud0}
Jan Heweliusz (1611) Astronome [http://data.bnf.fr/ark:/12148/cb121054498#foaf:Person]
{/ud}
{ud0}
John Pell (1611) Mathématicien [http://data.bnf.fr/ark:/12148/cb146515879#foaf:Person]
{/ud}
{ud0}
Michael Floris Van Langren (1612) Astronome et mathématicien du roi d''Espagne installé à Bruxelles [http://data.bnf.fr/ark:/12148/cb153283774#foaf:Person]
{/ud}
{ud0}
Francesco Maria Grimaldi (1613) Jésuite. - Philosophe, astronome, opticien et professeur de mathématiques. - Né et mort à Bologne [http://data.bnf.fr/ark:/12148/cb13326913s#foaf:Person]
{/ud}
{ud0}
François Chauveau (1613) Grava des cartouches notamment pour Nicolas Sanson. Eut un neveu du nom de François Chauveau. Son frère, Jean-Baptiste, habile ingénieur et mathématicien fut assassiné en 1670. [http://data.bnf.fr/ark:/12148/cb15302394v#foaf:Person]
{/ud}
{ud0}
Jean François Nicéron (Paris, 1613) Religieux de l''Ordre des minimes. - Mathématicien [http://data.bnf.fr/ark:/12148/cb14404933t#foaf:Person]
{/ud}
{ud0}
Tommaso Cornelio (Rovito, Italie, 1614) Médecin, philosophe et mathématicien [http://data.bnf.fr/ark:/12148/cb13484167f#foaf:Person]
{/ud}
{ud0}
Frans Van Schooten (1615) Mathématicien [http://data.bnf.fr/ark:/12148/cb12529949q#foaf:Person]
{/ud}
{ud0}
John Wallis (1616) Mathématicien [http://data.bnf.fr/ark:/12148/cb123396143#foaf:Person]
{/ud}
{ud0}
Jonas Moore (1617) Mathématicien britannique. - S''est intéressé aux mathématiques appliquées (astronomie, cosmographie, architecture...) [http://data.bnf.fr/ark:/12148/cb135104102#foaf:Person]
{/ud}
{ud0}
Tito Livio Burattini (Agordo, Italie, 1617) Mathématicien, cartographe et égyptologue [http://data.bnf.fr/ark:/12148/cb162142362#foaf:Person]
{/ud}
{ud0}
Anthelme (Chatenay-Vaudin (Haute-Marne), 1618) Religieux de la Chartreuse de Dijon. - Astronome [http://data.bnf.fr/ark:/12148/cb106267229#foaf:Person]
{/ud}
{ud0}
Charles Cavendish (1620) Mathématicien [http://data.bnf.fr/ark:/12148/cb14651592w#foaf:Person]
{/ud}
{ud0}
Jean Picard (La Flèche (Sarthe), 1620) Astronome. - Membre de l''Académie des sciences (1666) [http://data.bnf.fr/ark:/12148/cb11941359d#foaf:Person]
{/ud}
{ud0}
Claude-François Milliet de Chales (1621) Mathématicien. - Professeur d''hydrographie à Marseille [http://data.bnf.fr/ark:/12148/cb12397222c#foaf:Person]
{/ud}
{ud0}
Adrien Auzout (Rouen, 1622) Astronome, physicien et mathématicien. - A contribué au développement du micromètre [http://data.bnf.fr/ark:/12148/cb134752474#foaf:Person]
{/ud}
{ud0}
Jean Bertet (1622) Jésuite, quitte la Compagnie en 1681 pour entrer chez les Bénédictins. - Professeur de rhétorique, philosophie et mathématiques. - Poète [http://data.bnf.fr/ark:/12148/cb11999230c#foaf:Person]
{/ud}
{ud0}
René-François De Sluse (1622) Mathématicien. - Chanoine de la Cathédrale de Liège et abbé d''Amay [http://data.bnf.fr/ark:/12148/cb12427294z#foaf:Person]
{/ud}
{ud0}
Vincenzo Viviani (Florence, Italie, 1622) Florentin. - Mathématicien. - Membre de l'' "accademia della Crusca" [http://data.bnf.fr/ark:/12148/cb12000373g#foaf:Person]
{/ud}
{ud0}
Blaise Pascal (Clermont-Ferrand (Puy-de-Dôme), 1623) Mathématicien, physicien, écrivain. - Frère de : Pascal, Jacqueline (1625-1661) [http://data.bnf.fr/ark:/12148/cb11918679x#foaf:Person]
{/ud}
{ud0}
Ferdinand Verbiest (Pitthem, Belgique, 1623) Jésuite, missionnaire en Chine. - Astronome. - Fut placé à la tête du tribunal des mathématiques, chargé de la rédaction des éphémérides et de la direction des fonderies de canons. - A publié en langue chinoise, sous le nom de Nanhoai-jin, un grand nombre d''ouvrages scientifiques [http://data.bnf.fr/ark:/12148/cb12215344n#foaf:Person]
{/ud}
{ud0}
Camillo Guarino Guarini (Modène, Italie, 1624) Clerc régulier, théatin. - Architecte du duc de Savoie, philosophe et mathématicien [http://data.bnf.fr/ark:/12148/cb12348027r#foaf:Person]
{/ud}
{ud0}
Christoph Wittich (1625) Théologien. - Professeur de mathématiques et de théologie [http://data.bnf.fr/ark:/12148/cb13014027s#foaf:Person]
{/ud}
{ud0}
Erhard Weigel (1625) Philosophe. - Professeur de mathématiques, maître de Leibniz et de Pufendorf [http://data.bnf.fr/ark:/12148/cb11935908x#foaf:Person]
{/ud}
{ud0}
Jean-Dominique Cassini (Perinaldo (comté de Nice), 1625) Titulaire de la chaire d''astronomie de Bologne de 1650 à 1669, surintendant des eaux du Bolonais de 1657 à 1669, surintendant des eaux de l''Etat pontifical et titulaire d''autres charges auprès du pape. - Appelé en France an avril 1669 par Louis XIV. - Membre de l''Académie des sciences, directeur de l''Observatoire de Paris (à partir de 1672). - Naturalisé français en 1673 [http://data.bnf.fr/ark:/12148/cb121019904#foaf:Person]
{/ud}
{ud0}
Johan de Witt (Dordrecht, Pays-Bas, 1625) Homme d''état et mathématicien. - Grand pensionnaire de Hollande [http://data.bnf.fr/ark:/12148/cb13598046j#foaf:Person]
{/ud}
{ud0}
Johann Hecker (Gdansk (Pologne), 1625) Astronome [http://data.bnf.fr/ark:/12148/cb12875545t#foaf:Person]
{/ud}
{ud0}
Rasmus Bartholin (Roskilde, Danemark, 1625) Physicien. - Mathématicien. - Médecin. - Professeur de mathématiques et de médecine à Copenhague. - A découvert la difraction de la lumière. - Fils de Kaspar Bartholin [http://data.bnf.fr/ark:/12148/cb11890430k#foaf:Person]
{/ud}
{ud0}
Samuel Morland (1625) Mathématicien et inventeur [http://data.bnf.fr/ark:/12148/cb10365749d#foaf:Person]
{/ud}
{ud0}
Pietro Mengoli (Bologne (Italie), 1626) Mathématicien. - Professeur de mécanique (1650-1678) puis titulaire de la chaire de mathématiques et d''astronomie (1678-1686) à l''université de Bologne [http://data.bnf.fr/ark:/12148/cb120851477#foaf:Person]
{/ud}
{ud0}
John Ray (Black Notley (Essex), 1627) Professeur de mathématiques et de lettres. - Naturaliste. - Botaniste. - Membre de la Société royale de Londres [http://data.bnf.fr/ark:/12148/cb12220184b#foaf:Person]
{/ud}
{ud0}
Heinrich Scherer (1628) Jésuite, géographe et professeur de mathématiques à Munich [http://data.bnf.fr/ark:/12148/cb15317471w#foaf:Person]
{/ud}
{ud0}
Johannes Hudde (1628) Mathématicien, élève de Frans Van Schooten. - Bourgmestre de la ville d''Amsterdam [http://data.bnf.fr/ark:/12148/cb13488288n#foaf:Person]
{/ud}
{ud0}
Christiaan Huygens (1629) Mathématicien et astronome. - A vécu aux Pays-Bas et en France. - Élu membre de la "Royal society" de Londres (en 1663) [http://data.bnf.fr/ark:/12148/cb12192922r#foaf:Person]
{/ud}
{ud0}
Allain Manesson-Mallet (Paris (France), 1630) Ingénieur et cartographe. - Maître de mathématiques des pages du roi de France, sergent-major d''artillerie du roi de Portugal [http://data.bnf.fr/ark:/12148/cb153363577#foaf:Person]
{/ud}
{ud0}
Isaac Barrow (1630) Mathématicien et théologien [http://data.bnf.fr/ark:/12148/cb12340135q#foaf:Person]
{/ud}
{ud0}
Jean Richer (1630) Astronome à l''Observatoire de Paris, il figure parmi les premiers membres de l''Académie des sciences (1666). - Chargé d''une mission géodésique à Cayenne (1672-73) [http://data.bnf.fr/ark:/12148/cb14064426q#foaf:Person]
{/ud}
{ud0}
Adam Adamady Kochánski (1631) Mathématicien polonais, auteur de la rectification approchée de la circonférence. Réside en 1677 à Wroclaw [http://data.bnf.fr/ark:/12148/cb16187484g#foaf:Person]
{/ud}
{ud0}
Francesco Lana Terzi (Brescia, Italie, 1631) Jésuite. - Mathématicien, naturaliste. - Pionnier de l''aéronautique [http://data.bnf.fr/ark:/12148/cb10681783j#foaf:Person]
{/ud}
{ud0}
Christopher Wren (East Knoyle, Wiltshire, GB, 1632) Architecte. - Mathématicien et astronome, Sir Christopher Wren fut l''un des membres fondateurs de la Société royale des sciences [http://data.bnf.fr/ark:/12148/cb121401670#foaf:Person]
{/ud}
{ud0}
Alessandro Marchetti (Empoli, Italie, 1633) Poète naturaliste, l''un des principaux animateurs du courant naturaliste toscan de la seconde moitié du XVIIe siècle. - Professeur de philosophie puis de mathématiques à l''Université de Pise [http://data.bnf.fr/ark:/12148/cb12570345j#foaf:Person]
{/ud}
{ud0}
Donato Rossetti (Livourne, Italie, 1633) Mathématicien. - Professeur de philosophie au "Studio" de Pise [http://data.bnf.fr/ark:/12148/cb144820894#foaf:Person]
{/ud}
{ud0}
Geminiano Montanari (Modène, Italie, 1633) Docteur en droit, mathématicien et astronome. - Enseigne à Florence, Modène (1661-1664), Bologne (chaire de mathématiques, 1664-1677) et Padoue (chaire d''astronomie, 1678-1687). - Membre de l''Accademia dei Gelati ("l''Elevato") et de l''Accademia della Treccia de Bologne [http://data.bnf.fr/ark:/12148/cb12309300z#foaf:Person]
{/ud}
{ud0}
Gerhard Wolter Molanus (1633) Théologien luthérien. - Mathématicien [http://data.bnf.fr/ark:/12148/cb12133744h#foaf:Person]
{/ud}
{ud0}
Giovanni Giustino Ciampini (Rome, 1633) Historien, archéologue, mathématicien. - Membre de la Curie pontificale [http://data.bnf.fr/ark:/12148/cb14323561z#foaf:Person]
{/ud}
{ud0}
Vitale Giordano (1633) Mathématicien [http://data.bnf.fr/ark:/12148/cb15520924m#foaf:Person]
{/ud}
{ud0}
Johann Christoph Sturm (Hilpolstein, Allemagne, 1635) Philosophe, mathématicien et physicien. - Professeur à l''université d''Altdorf [http://data.bnf.fr/ark:/12148/cb133240234#foaf:Person]
{/ud}
{ud0}
Ignace-Gaston Pardies (1636) Mathématicien. - Jésuite. - Il a enseigné la philosophie puis les mathématiques au collège Louis-Le-Grand [http://data.bnf.fr/ark:/12148/cb12174258w#foaf:Person]
{/ud}
{ud0}
Elias van Lennep (Borculo, Pays-Bas, 1637) Graveur. - Ingénieur et mathématicien [http://data.bnf.fr/ark:/12148/cb15053499m#foaf:Person]
{/ud}
{ud0}
Julius Reichelt (1637) Mathématicien strasbourgeois [http://data.bnf.fr/ark:/12148/cb15377331m#foaf:Person]
{/ud}
{ud0}
François Barrême (Tarascon, France, 1638) Mathématicien et financier [http://data.bnf.fr/ark:/12148/cb118903320#foaf:Person]
{/ud}
{ud0}
Georg Christoph Eimmart (Ratisbonne (Allemagne), 1638) Peintre d''histoire, portraitiste, graveur, mathématicien et astronome. - Fils et élève du peintre Georg-Christoph Eimmart (1603-1658), dit le vieux [http://data.bnf.fr/ark:/12148/cb12983761h#foaf:Person]
{/ud}
{ud0}
James Gregory (1638) Mathématicien et opticien écossais [http://data.bnf.fr/ark:/12148/cb12459917j#foaf:Person]
{/ud}
{ud0}
Jean Bonfa (Nîmes, 1638) Est admis à la Société de Jésus en 1654. - Dans les années 1670 jusqu''en 1683, il enseigne les mathématiques et la théologie aux collèges jésuites de Grenoble, puis d''Avignon. - De 1680 à 1682, enseigne la géométrie et l''hydrographie. - Effectue des travaux astronomiques. - Devient membre correspondant de l''Académie royale des sciences (en 1699) [http://data.bnf.fr/ark:/12148/cb15130186g#foaf:Person]
{/ud}
{ud0}
Jacques Ozanam (Sainte-Olive (Ain), 1640) Mathématicien. - Professeur de mathématiques à Paris et à Lyon [http://data.bnf.fr/ark:/12148/cb120960958#foaf:Person]
{/ud}
{ud0}
Philippe de La Hire (Paris (France), 1640) Mathématicien. - Géomètre et astronome. - Professeur de mathématiques au Collège de France. - Membre de l''Académie des sciences (1678) [http://data.bnf.fr/ark:/12148/cb121592847#foaf:Person]
{/ud}
{ud0}
Pierre Ango (1640) Jésuite. - Enseigna les humanités, les mathématiques et la philosophie. - Né à Rouen, mort à La Flèche [http://data.bnf.fr/ark:/12148/cb12512101m#foaf:Person]
{/ud}
{ud0}
Denis Papin (1642) Physicien. - Un des précurseurs de l''invention de la machine à vapeur, qui eu l''idée du piston (dés 1690), et inspira la machine que l''Anglais Thomas Newcomen (1664-1729), mis au point ensuite (en 1712). - Quitta définitivement la France, après la révocation de l''Édit de Nantes (1685). - Occupa une chaire de mathématiques à l''Université de Marburg, Allemagne (1687). - Rédige un article (Ars nova ad aquam ignis...) présentant sa machine dans la revue " Acta Eruditorum", Leipzig (en 1707), revue célèbre pour les publications de Leibniz (1646-1716), sur le calcul différentiel et intégral [http://data.bnf.fr/ark:/12148/cb12087889k#foaf:Person]
{/ud}
{ud0}
Isaac Newton (Woolsthorpe, Lincolnshire (GB), 1642) Physicien, mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb119176085#foaf:Person]
{/ud}
{ud0}
Johann Welper (1642) Variante(s) de prénom : Johannes ; Jean. - Imprimeur-libraire. - Fils et apprenti d''Eberhard Welper, imprimeur-libraire et mathématicien à Strasbourg. A été compagnon pendant 6 ans à Ulm, Augsbourg, Munich, Vienne, Leipzig et Nuremberg, avant de succéder à son père. L''enquête de 1700-1701 le dit âgé de 60 ans et "établi à Strasbourg depuis 42 ans". À sa mort, son entreprise est rachetée par Melchior Pauschinger [http://data.bnf.fr/ark:/12148/cb160636269#foaf:Person]
{/ud}
{ud0}
Michel Mourgues (1642) Jésuite. - Enseigna la rhétorique et les mathématiques à l''Université de Toulouse [http://data.bnf.fr/ark:/12148/cb124637183#foaf:Person]
{/ud}
{ud0}
Takakazu Seki (1642) Mathématicien japonais [http://data.bnf.fr/ark:/12148/cb12443516f#foaf:Person]
{/ud}
{ud0}
Jean Jombert (1643) Libraire. - Fils d''un fruitier et marchand de vins parisien. En apprentissage chez le libraire parisien Pierre II Baudouin à partir de janv. 1666, il travaille en 1670-1671 chez Louis Billaine et Pierre Le Petit, puis chez la veuve de Pierre I Baudouin à partir de 1672. Gendre en 1res noces (1671) du libraire Jean d''Houry. Publie sous son propre nom dès 1680, peut-être dès 1678, mais n''est reçu maître que le 17 sept. 1686. Publie de nombreux ouvrages de mathématiques. Dit âgé d''env. 60 ans lors de l''enquête de nov.-déc. 1701. Testaments le 9 août 1704 et le 6 oct. 1705. Décédé au début de nov. 1705. Sa veuve lui succède [http://data.bnf.fr/ark:/12148/cb15074749j#foaf:Person]
{/ud}
{ud0}
Antoine Thomas (Namur, 1644) Jésuite (à partir de 1660). - Mathématicien et astronome de l''empereur de Chine [http://data.bnf.fr/ark:/12148/cb10636254r#foaf:Person]
{/ud}
{ud0}
Johann Jakob Zimmermann (Vaihingen an der Enz, Allemagne, 1644) Théologien, mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb10721479d#foaf:Person]
{/ud}
{ud0}
Ole Rømer (Åarhus, Danemark, 1644) Astronome [http://data.bnf.fr/ark:/12148/cb12324191r#foaf:Person]
{/ud}
{ud0}
Carlos de Sigüenza y Góngora (Mexico, 1645) Astronome, mathématicien, poète, historien. - Sa bibliothèque, comprenant des documents uniques sur l''histoire du Mexique, disparut dans un incendie lors de l''insurrection de 1692 [http://data.bnf.fr/ark:/12148/cb121021638#foaf:Person]
{/ud}
{ud0}
Eusebio Francisco Kino (Taio, Italie, 1645) Mathématicien et géographe de formation. - Jésuite, arrive au Mexique en 1681 [http://data.bnf.fr/ark:/12148/cb122190783#foaf:Person]
{/ud}
{ud0}
Maximilian Rassler (Waldsee (Allemagne), 1645) Jésuite. - Professeur de réthorique, de mathématiques, philosophie et contreverse. - Recteur et chancelier de l''Université de Dillingen, Allemagne [http://data.bnf.fr/ark:/12148/cb158132748#foaf:Person]
{/ud}
{ud0}
Elena Lucrezia Cornaro Piscopia (Venise (Italie), 1646) Philosophe et mathématicienne. - Première femme docteur en philosophie [http://data.bnf.fr/ark:/12148/cb16591183r#foaf:Person]
{/ud}
{ud0}
Francesco Maria Pompeo Colonna (Rome, 1646) Mathématicien, physicien et occultiste. - Vécut à Paris à partir de 1668 [http://data.bnf.fr/ark:/12148/cb118973978#foaf:Person]
{/ud}
{ud0}
Harald Vallerius (1646) Professeur universitaire de mathématiques [http://data.bnf.fr/ark:/12148/cb16032560b#foaf:Person]
{/ud}
{ud0}
John Flamsteed (1646) Astronome. - Fut le premier directeur de l''Observatoire de Greenwich, GB, fondé en 1675 [http://data.bnf.fr/ark:/12148/cb13524243n#foaf:Person]
{/ud}
{ud0}
John Flamsteed (1646) Astronome britannique. Fut le premier directeur de l''observatoire de Greenwich, fondé en 1675 [http://data.bnf.fr/ark:/12148/cb13510391m#foaf:Person]
{/ud}
{ud0}
Niccolò Partenio Giannettasio (1648) Jésuite. - Historien et poète. - Professeur de mathématiques et d''hébreu au Collège des Jésuites de Naples. - Né à Naples, meurt à Massa [http://data.bnf.fr/ark:/12148/cb133256727#foaf:Person]
{/ud}
{ud0}
Tommaso Ceva (1648) Jésuite. - Philosophe, astronome, physicien et poète. - Membre de l''Académie de l''Arcadie sous le pseudonyme : Callimaco Neridio [http://data.bnf.fr/ark:/12148/cb13321850h#foaf:Person]
{/ud}
{ud0}
Jean Le Febvre (Lisieux (Calvados), 1650) Tisserand, puis astronome. - Membre de l''Académie des sciences de 1682 à 1702 [http://data.bnf.fr/ark:/12148/cb16176897g#foaf:Person]
{/ud}
{ud0}
Michelangelo Fardella (1650) Franciscain. - Philosophe, astronome et mathématicien. - Professeur de philosophie, de théologie, de mathématiques, professeur d''astronomie et de physique à l''Université de Padoue (1694-). - Né à Trapani, meurt à Naples [http://data.bnf.fr/ark:/12148/cb12093422f#foaf:Person]
{/ud}
{ud0}
Andreas Cellarius (1651) Mathématicien et géographe hollandais actif de 1656 à 1702. En 1660 il est recteur de l''Ecole latine de Hoorn [http://data.bnf.fr/ark:/12148/cb15338282n#foaf:Person]
{/ud}
{ud0}
Antoine-François Payen (Avignon, 1651) Jurisconsulte et astronome. - Enseigna la jurisprudence civile dès 1642 à Avignon [http://data.bnf.fr/ark:/12148/cb144713316#foaf:Person]
{/ud}
{ud0}
Arent Roggeveen (1651) Mathématicien, navigateur et hydrographe [http://data.bnf.fr/ark:/12148/cb153879695#foaf:Person]
{/ud}
{ud0}
Bingzhen Jiao (1651) Peintre et mathématicien à la cour de l''empereur Kangxi [http://data.bnf.fr/ark:/12148/cb14546684c#foaf:Person]
{/ud}
{ud0}
Caspar Dauthendey (1651) Architecte et mathématicien [http://data.bnf.fr/ark:/12148/cb153778194#foaf:Person]
{/ud}
{ud0}
Claude Bonjour (1651) Augustin du couvent de Pontarlier. Géographe et mathématicien [http://data.bnf.fr/ark:/12148/cb15294805z#foaf:Person]
{/ud}
{ud0}
Claude Comiers (1651) Théologien et mathématicien, né à Embrun. Chanoine d''Embrun, ingénieur des armées, puis prévôt de l''église collégiale de Ternant, professeur de mathématiques à Paris ; protonotaire apostolique et officier du Saint-Office. - Il a laissé des livres et des articles sur des sujets variés : géométrie, astronomie, médecine, occultisme, physique... [http://data.bnf.fr/ark:/12148/cb12250531g#foaf:Person]
{/ud}
{ud0}
Claude Irson (1651) Mathématicien et grammairien. - A été teneur de comptes vers 1678 [http://data.bnf.fr/ark:/12148/cb125155096#foaf:Person]
{/ud}
{ud0}
de La Roche (1651) Mathématicien [http://data.bnf.fr/ark:/12148/cb13009642b#foaf:Person]
{/ud}
{ud0}
Ehrenfried Walter von Tschirnhaus (Kieslingswalde, Allemagne, 1651) Philosophe, mathématicien et biologiste. - Industriel, considéré comme l''inventeur de la porcellaine blanche en Europe [http://data.bnf.fr/ark:/12148/cb12515471b#foaf:Person]
{/ud}
{ud0}
Federico Gualdi (1651) Alchimiste, astronome, mathématicien. - Philosophe hermétique. - Membre de la Rose-croix d''Or. - Serait d''origine allemande ou italienne [http://data.bnf.fr/ark:/12148/cb150904929#foaf:Person]
{/ud}
{ud0}
Francesco Levera (Savoie, 1651) Philosophe, astronome et théologien [http://data.bnf.fr/ark:/12148/cb10442558v#foaf:Person]
{/ud}
{ud0}
François Chevalier (Sainte-Maur, 1651) Elève de l''abbé Galloys. Associé géomètre à l''Académie des sciences en 1707. Pensionnaire mécanicien en 1725. Professeur de mathématiques au Collège de France. Maître de mathématiques du roi et des pages de la Petite Ecurie. Présenta en 1707 à l''Académie une méthode de collecte des informations cartographiques sur des châssis concentriques [http://data.bnf.fr/ark:/12148/cb153045899#foaf:Person]
{/ud}
{ud0}
François Noël (Hestrud, Pays-Bas Méridionaux, 1651) Jésuite (à partir de 1670) ordonné prêtre en 1682. - Missionnaire en Chine, il fut envoyé à Rome à l''occasion de la querelle des rites, et ne put rentrer en Chinê. - Il enseigna ensuite à Prague. - Auteur de poésies et de théâtre, d''un traité d''astronomie, de traductions et d''un ouvrage catéchétique en chinois [http://data.bnf.fr/ark:/12148/cb16653645d#foaf:Person]
{/ud}
{ud0}
Guisnée (1651) Mathématicien. - Membre de l''Académie royale des sciences [http://data.bnf.fr/ark:/12148/cb14618149h#foaf:Person]
{/ud}
{ud0}
Jacques Mengau (1651) Professeur de mathématiques. - Auteur de mazarinades. - Actif de 1648 à 1652 [http://data.bnf.fr/ark:/12148/cb12166762s#foaf:Person]
{/ud}
{ud0}
Jean Bachou (1651) Mathématicien et alchimiste lyonnais. - Avocat au parlement [http://data.bnf.fr/ark:/12148/cb12158814g#foaf:Person]
{/ud}
{ud0}
Jean Glover (1651) Ingénieur et mathématicien originaire d''Écosse et établi en France. - Auteur notamment de plusieurs propositions de loteries et d''une "Nouvelle Manière d''exécuter les loteries..." (Paris, 1705). - Se qualifie d''"esquire, seigneur de Glaideny et de la baronnie de Baltillée en Ecosse" [http://data.bnf.fr/ark:/12148/cb15818830h#foaf:Person]
{/ud}
{ud0}
Jean-Baptiste Delure (1651) Éditeur d''estampes et de cartes géographiques. - Ingénieur pour les instruments de mathématiques et fabricant de cartes et de globes ; éditeur occasionnel [http://data.bnf.fr/ark:/12148/cb153164066#foaf:Person]
{/ud}
{ud0}
Joachim d'' Alencé (1651) Astronome et physicien [http://data.bnf.fr/ark:/12148/cb12397878n#foaf:Person]
{/ud}
{ud0}
Joanne Westenburg (1651) Cartographe, médecin et mathématicien [http://data.bnf.fr/ark:/12148/cb15377993t#foaf:Person]
{/ud}
{ud0}
Johann Andreas Planer (Strelen, Allemagne, 1651) Mathématicien. - Professeur de mathématiques à l''Université de Wittenberg [http://data.bnf.fr/ark:/12148/cb16672375p#foaf:Person]
{/ud}
{ud0}
Le Blanc (1651) Professeur de mathématiques (1692). - Réside rue de Seine à Paris en 1692 [http://data.bnf.fr/ark:/12148/cb16650697x#foaf:Person]
{/ud}
{ud0}
Le Demaine Godalles (1651) Hydrographe, Ingénieur du roi et professeur de Mathématiques, Architecte [http://data.bnf.fr/ark:/12148/cb15375819n#foaf:Person]
{/ud}
{ud0}
Philip Lea (1651) Cartographe, fabricant et éditeur de globes, de cartes, d''instruments de mathématiques, actif de 1666 à 1700 à Londres [http://data.bnf.fr/ark:/12148/cb15328427v#foaf:Person]
{/ud}
{ud0}
René Gaultier de Maignannes (1651) Mathématicien angevin. - Spécialiste de la perspective [http://data.bnf.fr/ark:/12148/cb12536157m#foaf:Person]
{/ud}
{ud0}
David François de Merveilleux (1652) Géographe et cartographe. Connaissances mathématiques étendues (il publie un traîté d''arithmétique et de géométrie). En 1695 il entre au service de Guillaume III qui lui accorde le brevet de Capitaine Ingénieur au service d''Angleterre et des Etats généraux [http://data.bnf.fr/ark:/12148/cb15304894q#foaf:Person]
{/ud}
{ud0}
Michel Rolle (Ambert (Puy-de-Dôme), 1652) Mathématicien [http://data.bnf.fr/ark:/12148/cb130110121#foaf:Person]
{/ud}
{ud0}
Nicolas Bion (1652) Ingénieur du roi pour les instruments de mathématique. - Avait un atelier à Paris, quai de l''Horloge, qui était l''un des mieux achalandés du temps. - Son "Usage des globes" connut 6 éditions entre 1699 et 1751. - Édita en 1694 le globe terrestre de P. Courtin (diam. 25 cm) et en 1712 une paire de globes de même diamètre, un globe céleste antérieur à 1710 atteignit 32 cm de diamètre [http://data.bnf.fr/ark:/12148/cb152909089#foaf:Person]
{/ud}
{ud0}
José Chaffrion (1653) Cartographe et mathématicien de Valence en Espagne [http://data.bnf.fr/ark:/12148/cb15330290b#foaf:Person]
{/ud}
{ud0}
Bernard Nieuwentijt (West Graftdijk, Pays-Bas, 1654) Philosophe, médecin et mathématicien [http://data.bnf.fr/ark:/12148/cb14587835s#foaf:Person]
{/ud}
{ud0}
Jacques Bernoulli (Bâle, Suisse, 1654) Mathématicien et astronome. - Professeur de mathématiques à l''université de Bâle, Suisse [http://data.bnf.fr/ark:/12148/cb120751142#foaf:Person]
{/ud}
{ud0}
Jean Pigeon (Donzy (Nièvre), 1654) Peintre, mathématicien et facteur de globes, géographe du Duc d''Orléans à partir de 1714 [http://data.bnf.fr/ark:/12148/cb15147433m#foaf:Person]
{/ud}
{ud0}
Jean-François Gerbillon (1654) Jésuite. - Mathématicien, fut envoyé en Chine par Louis XIV en 1685. - Écrivit des traités de géométrie et de l''usage de l''astrolabe en chinois et en tartare. - Supérieur général de la Mission française de Chine [http://data.bnf.fr/ark:/12148/cb124622770#foaf:Person]
{/ud}
{ud0}
Philippe Avril (Angoulême (Charente), 1654) Missionnaire. - Voyageur, jésuite dès 1670, il enseigna les mathématiques à Louis-le-Grand. - Chercha un nouveau passage vers la Chine par la Tartarie, le Kurdistan et l''Arménie [http://data.bnf.fr/ark:/12148/cb15327596q#foaf:Person]
{/ud}
{ud0}
Philippe Naudé (Metz, 1654) Théologien et mathématicien. - Se réfugia en Prusse après la révocation de l''Édit de Nantes [http://data.bnf.fr/ark:/12148/cb10366497p#foaf:Person]
{/ud}
{ud0}
Pierre Varignon (Caen (Calvados), 1654) Mathématicien. - Jésuite. - Membre de l''Académie des sciences, il entre au collège de France en 1704 [http://data.bnf.fr/ark:/12148/cb121123302#foaf:Person]
{/ud}
{ud0}
Louis Lecomte (1655) Jésuite. - Mathématicien [http://data.bnf.fr/ark:/12148/cb12151496v#foaf:Person]
{/ud}
{ud0}
Simon Tyssot de Patot (Londres, 1655) Professeur ordinaire de mathématiques à l''École illustre de Deventer (1699-1727 ; professeur extraordinaire dès 1690). - Vécut en France de 1658 environ à 1664, puis aux Pays-Bas [http://data.bnf.fr/ark:/12148/cb11927303t#foaf:Person]
{/ud}
{ud0}
Claude de Visdelou (Erquy (Côtes-d''Armor), 1656) Jésuite. - Mathématicien. - Missionnaire en Chine. - Évèque titulaire de de Claudiopolis-en-Isaurie (à partir de 1708/1709). - Vicaire apostolique du Koueitchéou et du Yunnan, et administrateu du Houkouang (de 1708 à 1709) [http://data.bnf.fr/ark:/12148/cb150791582#foaf:Person]
{/ud}
{ud0}
Edmund Halley (1656) Astronome [http://data.bnf.fr/ark:/12148/cb119960783#foaf:Person]
{/ud}
{ud0}
Nicolaas Hartsoeker (Gouda (Pays-Bas), 1656) Physicien, micrographe et médecin. - Apporta des perfectionnements importants à la fabrication des verres de lunettes astronomiques, découvrit les animalcules spermatiques [http://data.bnf.fr/ark:/12148/cb13010358x#foaf:Person]
{/ud}
{ud0}
William Molyneux (Dublin, 1656) Mathématicien, astronome, physicien et philosophe. - Premier secrétaire de la Société philosophique de Dublin (en 1684) [http://data.bnf.fr/ark:/12148/cb124596616#foaf:Person]
{/ud}
{ud0}
Jean-Mathieu de Chazelles (Lyon, 1657) Cartographe, géographe et astronome associé à l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb106281104#foaf:Person]
{/ud}
{ud0}
Jean-Matthieu de Chazelles (Lyon, 1657) Fit ses études chez les jésuites et devint l''auxiliaire de Cassini I. Fut associé aux travaux géodésiques menés par l''Académie des sciences. Dessina le planisphère de l''Observatoire. Collabora au Neptune françois. Associé astronome de l''Académie des sciences en 1695; associé mécanicien en 1699. Professeur d''hydrographie à Marseille [http://data.bnf.fr/ark:/12148/cb15304334g#foaf:Person]
{/ud}
{ud0}
Joseph Saurin (Courthézon (Vaucluse), 1659) Mathématicien [http://data.bnf.fr/ark:/12148/cb10330722j#foaf:Person]
{/ud}
{ud0}
Philippe Desplaces (1659) Astronome. - Auteur d''éphémérides [http://data.bnf.fr/ark:/12148/cb12223720g#foaf:Person]
{/ud}
{ud0}
Louis Feuillée (Mane (Alpes-de-Haute-Provence), 1660) Astronome et botaniste. - Religieux de l''ordre des Minimes. - Initié à la botanique par le P. Plumier. Correspondant astronome de l''Académie des sciences, il obtient une mission dans le Levant. Revenu à Marseille en 1702, il embarque l''année suivante pour les Antilles et parvient à Carthagène en 1704. Nommé mathématicien du roi, il s''embarque pour l''Amérique du Sud en 1707. En 1724, il est chargé de déterminer la position exacte de l''île de Fer [http://data.bnf.fr/ark:/12148/cb15309142r#foaf:Person]
{/ud}
{ud0}
Thomas Fantet de Lagny (Lyon (Rhône), 1660) Mathématicien. - Professeur [http://data.bnf.fr/ark:/12148/cb14548143w#foaf:Person]
{/ud}
{ud0}
Guillaume-François-Antoine de L''Hospital (1661) Marquis de Sainte-Mesme. - Mathématicien, membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb12000655c#foaf:Person]
{/ud}
{ud0}
Francesco Bianchini (Vérone, Italie, 1662) Théologien, historien, astronome et physicien [http://data.bnf.fr/ark:/12148/cb12452255g#foaf:Person]
{/ud}
{ud0}
Paolo Mattia Doria (1662) Philosophe et mathématicien italien [http://data.bnf.fr/ark:/12148/cb121118306#foaf:Person]
{/ud}
{ud0}
Jean-Pierre de Crousaz (1663) Professeur de philosophie et mathématiques à Lausanne et Groningue. - Conseiller de la légation de Suède en Hollande. - Membre des Académies de Bordeaux et Paris [http://data.bnf.fr/ark:/12148/cb12016566d#foaf:Person]
{/ud}
{ud0}
Johann Balthasar Lauterbach (1663) Mathématicien et architecte allemand [http://data.bnf.fr/ark:/12148/cb137778333#foaf:Person]
{/ud}
{ud0}
John Craig (1663) Mathématicien et théologien écossais [http://data.bnf.fr/ark:/12148/cb114408210#foaf:Person]
{/ud}
{ud0}
Katahiro Takebe (1664) Mathématicien japonais [http://data.bnf.fr/ark:/12148/cb12443517s#foaf:Person]
{/ud}
{ud0}
Lothar Zumbach von Coesfeld (Trèves (Allemagne), 1664) Mathématicien, astronome, médecin, musicien. - Mathématicien et musicien de l''électeur de Trèves (1685-1688). - Lecteur en astronomie à l''université de Leyde. - Professeur de mathématiques au Carolinum de Kassel [http://data.bnf.fr/ark:/12148/cb14853628w#foaf:Person]
{/ud}
{ud0}
Abraham de Moivre (Vitry-le-François (Marne), 1667) Mathématicien. - Émigra en Grande-Bretagne après la révocation de l''Édit de Nantes (en 1686). - Membre de la Royal Society, de l''Académie de Berlin et de l''Académie de Saint-Pétersbourg [http://data.bnf.fr/ark:/12148/cb130110001#foaf:Person]
{/ud}
{ud0}
Girolamo Saccheri (San Remo, Italie, 1667) Jésuite. - Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb13164455b#foaf:Person]
{/ud}
{ud0}
Johann Bernoulli (Bâle, Suisse, 1667) Mathématicien et physicien, maître d''Euler, professeur à l''Université de Groningue puis à l''Université de Bâle. - A travaillé sur le calcul différentiel, intégral et exponentiel. - Également auteur de traités de médecine, fondateur de la théorie mécanico-physique de la fermentation [http://data.bnf.fr/ark:/12148/cb122991692#foaf:Person]
{/ud}
{ud0}
William Whiston (Norton-juxta-Twycross (G. B.), 1667) Théologien et astronome. - Professeur de mathématiques à Cambridge, d''où il fut exclu pour ses écrits théologiques. - Traducteur de Flavius Josèphe [http://data.bnf.fr/ark:/12148/cb11997914k#foaf:Person]
{/ud}
{ud0}
Guillaume Bonjour (Toulouse (Haute-Garonne), 1669) Augustin. - Missionnaire en Chine. - Orientaliste, astronome et cartographe [http://data.bnf.fr/ark:/12148/cb13613529n#foaf:Person]
{/ud}
{ud0}
Leonhard Christoph Sturm (Aldorf, Allemagne, 1669) Mathématicien. - Architecte [http://data.bnf.fr/ark:/12148/cb143383238#foaf:Person]
{/ud}
{ud0}
Jean Terrasson (Lyon, 1670) Oratorien, mathématicien et philosophe. - Professeur de grec et latin au Collège de France. - Membre de l''Institut, Académie Française (élu en 1732) [http://data.bnf.fr/ark:/12148/cb119262217#foaf:Person]
{/ud}
{ud0}
Guido Grandi (Crémone, Italie, 1671) Mathématicien, théologien, biographe, antiquaire et poète. - Soutint Descartes contre l''aristotélisme. - Professeur de philosophie à l''Université de Pise. - Fut en correspondance avec Leibniz, Newton, Bernoulli. - Intendant général des eaux en Toscane [http://data.bnf.fr/ark:/12148/cb121384290#foaf:Person]
{/ud}
{ud0}
Johann Gabriel Doppelmayr (1671) Fils d''un riche négociant qui s''occupait de physique, et destiné d''abord à l''étude du droit, il la quitta pour celle des mathématiques et voyagea jusqu''en 1702. Professeur à Nuremberg et membre de la Royal Society de Londres [http://data.bnf.fr/ark:/12148/cb15327296w#foaf:Person]
{/ud}
{ud0}
Johann Gabriel Doppelmayr (1671) Mathématicien. - Membre de la Royal Society de Londres (1713) [http://data.bnf.fr/ark:/12148/cb12158680q#foaf:Person]
{/ud}
{ud0}
Johann Gabriel Doppelmayr (1671) Astronome et cartographe ayant véçu à Nuremberg, né en 1671 ou 1677 [http://data.bnf.fr/ark:/12148/cb15327296w#foaf:Person]
{/ud}
{ud0}
Johann Heinrich Müller (1671) Physicien, astronome, mathématicien. - Professeur à l''université d''Altdorf (Allemagne) [http://data.bnf.fr/ark:/12148/cb10706008k#foaf:Person]
{/ud}
{ud0}
John Keill (1671) Mathématicien écossais. - Professeur d''astronomie à Oxford [http://data.bnf.fr/ark:/12148/cb123670586#foaf:Person]
{/ud}
{ud0}
Étienne-Simon de Gamaches (1672) Astronome et moraliste. - Chanoine de Sainte Croix de La Bretonnerie. - Membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb12004341t#foaf:Person]
{/ud}
{ud0}
Johann Jacob Scheuchzer (Zürich, 1672) Médecin, naturaliste, historien, archéologue, numismate, astronome et physicien [http://data.bnf.fr/ark:/12148/cb123955592#foaf:Person]
{/ud}
{ud0}
Eustachio Manfredi (1674) Astronome. - Poète. - Fondateur de l''Académie de Bologne [http://data.bnf.fr/ark:/12148/cb12202194q#foaf:Person]
{/ud}
{ud0}
Julien Mahuet (1674) Jésuite. - Né à Reims. Entre au noviciat le 24 août 1692. Enseigne les humanités à Reims, la rhétorique à Metz et les mathématiques à Reims. - Écrit du théâtre pour le Collège de Reims [http://data.bnf.fr/ark:/12148/cb13165624v#foaf:Person]
{/ud}
{ud0}
Guillaume Delisle (1675) Cartographe. - Fils de Claude Delisle, fut l''élève de Jean-Dominique Cassini. Élève astronome à l''Académie des sciences en 1702, il en devint membre en 1718 ; enseigna la géographie au jeune Louis XV et fut nommé premier géographe du roi ; produisit quelque 100 cartes qu''il édita lui-même [http://data.bnf.fr/ark:/12148/cb15238363g#foaf:Person]
{/ud}
{ud0}
Humphry Ditton (Salisbury (G. B.), 1675) Mathématicien et théologien [http://data.bnf.fr/ark:/12148/cb15994181b#foaf:Person]
{/ud}
{ud0}
Yves-Marie André (1675) Jésuite. - Professeur de mathématiques à Caen [http://data.bnf.fr/ark:/12148/cb12180932c#foaf:Person]
{/ud}
{ud0}
Jacopo Francesco Riccati (1676) Mathématicien [http://data.bnf.fr/ark:/12148/cb120689750#foaf:Person]
{/ud}
{ud0}
Gabriel Philippe de La Hire (Paris, 1677) Astronome [http://data.bnf.fr/ark:/12148/cb106522995#foaf:Person]
{/ud}
{ud0}
Jacques Cassini (Paris, 1677) Fils de Jean-Dominique Cassini et père de César-François Cassini de Thury. Associé astronome à l''Académie des sciences en 1699, pensionnaire en 1712. En 1700 participa à la mesure de la méridienne de l''Observatoire et y travailla jusqu''à son achèvement en 1718. En 1706 maître ordinaire à la Chambre des comptes. Etudia les planètes et leurs satellites. Soutint la thèse de l''allongement de la Terre aux pôles. [http://data.bnf.fr/ark:/12148/cb15238366h#foaf:Person]
{/ud}
{ud0}
Joseph Privat de Molières (Tarascon (ouches-du-Rhône), 1677) Physicien et mathématicien. - Oratorien (vers 1709). - Professeur au collège royal (1723). - Adjoint (1721) puis associé (1729) de l''Académie royale des sciences [http://data.bnf.fr/ark:/12148/cb145391041#foaf:Person]
{/ud}
{ud0}
Gerard Keulen (1678) Graveur, cartographe, mathématicien et éditeur. - Fils de Johannes van Keulen [http://data.bnf.fr/ark:/12148/cb15332761m#foaf:Person]
{/ud}
{ud0}
Jacob Hermann (1678) Mathématicien [http://data.bnf.fr/ark:/12148/cb12319998c#foaf:Person]
{/ud}
{ud0}
Jean-Jacques Dortous de Mairan (Béziers, 1678) Physicien et mathématicien. - Membre puis secrétaire perpétuel de l''Académie des sciences. - Membre de l''Académie française (élu en 1743) [http://data.bnf.fr/ark:/12148/cb12395086k#foaf:Person]
{/ud}
{ud0}
Louis Bourguet (Nïmes, 1678) Professeur de philosophie et de mathématiques à Neuchâtel. - Est l''un des fondateurs de la "Bibliothèque italique" (1728-) et du "Mercure suisse" (1732-). - Naturalisé Neuchâtelois en 1710 [http://data.bnf.fr/ark:/12148/cb12797692b#foaf:Person]
{/ud}
{ud0}
Pierre Rémond de Montmort (Paris, 1678) Mathématicien. - Spécialiste de probabilités [http://data.bnf.fr/ark:/12148/cb12391046c#foaf:Person]
{/ud}
{ud0}
Bernardino Zendrini (Saviore, Italie, 1679) Médecin. - Mathématicien. - Hydraulicien [http://data.bnf.fr/ark:/12148/cb13545066d#foaf:Person]
{/ud}
{ud0}
Christian Wolff (Breslau, Silésie (Wrocław, Pologne), 1679) Juriste, mathématicien et philosophe [http://data.bnf.fr/ark:/12148/cb121387859#foaf:Person]
{/ud}
{ud0}
Firmin Abauzit (Uzès, 1679) Mathématicien, philosophe et bibliothécaire. - Fut bibliothécaire à la Bibliothèque de Genève. - Vécut à Genève après la révocation de l''Édit de Nantes [http://data.bnf.fr/ark:/12148/cb121711117#foaf:Person]
{/ud}
{ud0}
Claude Richer (1680) Abbé. - Mathématicien [http://data.bnf.fr/ark:/12148/cb12532604f#foaf:Person]
{/ud}
{ud0}
Pierre Jartoux (1680) Astronome et missionnaire jésuite en Chine [http://data.bnf.fr/ark:/12148/cb15367486z#foaf:Person]
{/ud}
{ud0}
Paolino Chelucci (Lucca, Italie, 1681) Professeur d''éloquence à l''Université de Rome. - Mathématicien [http://data.bnf.fr/ark:/12148/cb104300443#foaf:Person]
{/ud}
{ud0}
Roger Cotes (Burbage (Leicestershire), 1682) Mathématicien. - Professeur d''astronomie et de philosophie expérimentale au Trinity College, Cambridge (1707-). - A édité la seconde édition des "Principia" de Newton [http://data.bnf.fr/ark:/12148/cb123946202#foaf:Person]
{/ud}
{ud0}
Noël Regnault (1683) Jésuite. - Professeur de mathématiques et physique au collège de Paris [http://data.bnf.fr/ark:/12148/cb12218681d#foaf:Person]
{/ud}
{ud0}
Johann Matthias Hase (1684) Géographe et cartographe ; historien. - Mathématicien [http://data.bnf.fr/ark:/12148/cb13007561v#foaf:Person]
{/ud}
{ud0}
Brook Taylor (1685) Mathématicien [http://data.bnf.fr/ark:/12148/cb12315365s#foaf:Person]
{/ud}
{ud0}
Giovanni Poleni (Venise, Italie, 1685) Physicien, mathématicien et archéologue [http://data.bnf.fr/ark:/12148/cb12161210z#foaf:Person]
{/ud}
{ud0}
Jean-Edme Gallimard (Paris, 1685) Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb120827146#foaf:Person]
{/ud}
{ud0}
Jai Singh (Amber (Rajasthan, Inde), 1686) Mahārāja de Jaipur (Rajasthan, Inde) de 1699 à 1743. - Fondateur de la ville de Jaipur (en 1727). - Chef du clan rajput des Kachhwa. - Bâtisseur de cinq observatoires astronomiques (yantra) dans l''Inde du Nord, à Delhi, Jaipur, Mathura, Varanasi et Ujjain. - Publia des tables astronomiques. - Les dates biographiques (1688-1743) sont aussi parfois retenues [http://data.bnf.fr/ark:/12148/cb16578505b#foaf:Person]
{/ud}
{ud0}
Nicolas Bernoulli (1687) Mathématicien et juriste suisse [http://data.bnf.fr/ark:/12148/cb13510346s#foaf:Person]
{/ud}
{ud0}
Robert Simson (1687) Mathématicien. - A été professeur à l''Université de Glasgow, GB [http://data.bnf.fr/ark:/12148/cb12399224j#foaf:Person]
{/ud}
{ud0}
Joseph-Nicolas Delisle (Paris, 1688) Astronome. - Il reçut l''enseignement de Cassini II. - Professeur de mathématiques au Collège de France et géographe de la marine. - Membre de l''Institut, Académie des sciences (1714). - Fondateur de l''École d''astronomie de Saint-Pétersbourg (à partir de 1725), a séjourné en Russie jusqu''en 1747 [http://data.bnf.fr/ark:/12148/cb12150746w#foaf:Person]
{/ud}
{ud0}
Louis-Bertrand Castel (Montpellier, 1688) Jésuite (1703). - Philosophe et mathématicien [http://data.bnf.fr/ark:/12148/cb12462543h#foaf:Person]
{/ud}
{ud0}
Pierre Brumoy (Rouen, 1688) Jésuite en 1704. - Professeur de rhétorique à Caen, précepteur du prince de Talmont, professeur de mathématiques au collège de Louis-le-Grand à Paris. - Collabore au Journal de Trévoux de 1722 à 1739. - Littérateur [http://data.bnf.fr/ark:/12148/cb12069382v#foaf:Person]
{/ud}
{ud0}
Willem Jacob''s Gravesande (1688) Physicien. - Philosophe. - Professeur de mathématique et astronomie à Leyde, Pays-Bas. - Éditeur du "Journal littéraire de la Haye", devenu "Journal de la République des Lettres" [http://data.bnf.fr/ark:/12148/cb12218384m#foaf:Person]
{/ud}
{ud0}
Antoine Gaubil (Gaillac (Aveyron), 1689) Jésuite et missionnaire en Chine. - Établit un observatoire à Pékin, dans la résidence française. - Écrit sur l''astronomie, la géographie, l''histoire et la littérature de la Chine [http://data.bnf.fr/ark:/12148/cb12150997b#foaf:Person]
{/ud}
{ud0}
Giovanni Gaetano Bottari (Rome, 1689) Savant prélat. - A étudié les langues et la littérature de l''Antiquité, les mathématiques, la philosophie et la théologie. - Membre de l''Académie della Crusca. - Conservateur de la bibliothèque du Vatican [http://data.bnf.fr/ark:/12148/cb12516784r#foaf:Person]
{/ud}
{ud0}
Robert Smith (Lea, GB, 1689) Professeur de mathématiques et de philosophie naturelle à Cambridge [http://data.bnf.fr/ark:/12148/cb15075770m#foaf:Person]
{/ud}
{ud0}
Christian Goldbach (1690) Mathématicien allemand [http://data.bnf.fr/ark:/12148/cb124384045#foaf:Person]
{/ud}
{ud0}
Johann Friedrich Weidler (Gros-Neuhausen, Allemagne, 1691) Écrivain, mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb151541516#foaf:Person]
{/ud}
{ud0}
Esprit Pezenas (Avignon, 1692) Jésuite. - Astronome et mathématicien. - Professeur d''hydrographie à Marseille et directeur de l''Observatoire de Marseille (1749) [http://data.bnf.fr/ark:/12148/cb12120600p#foaf:Person]
{/ud}
{ud0}
James Stirling (Garden, GB, 1692) Mathématicien [http://data.bnf.fr/ark:/12148/cb13475586v#foaf:Person]
{/ud}
{ud0}
Petrus Van Musschenbroek (1692) Physicien, docteur en médecine et en philosophie. - Fut l''inventeur de la pyrométrie. - Fut professeur de philosophie naturelle, de mathématiques et d''astronomie à l''Université d''Utrecht, puis professeur à Leiden [http://data.bnf.fr/ark:/12148/cb13475113j#foaf:Person]
{/ud}
{ud0}
Diego de Torres Villarroel (1693) Prêtre catholique. - Homme de lettres. - Professeur de mathématiques à l''université de Salamanque [http://data.bnf.fr/ark:/12148/cb119268467#foaf:Person]
{/ud}
{ud0}
Giovanni Bianchi (Rimini (Italie), 1693) Médecin. - Professeur d''anatomie à l''Université de Sienne (1741-). - Auteur d''ouvrages médicaux, archéologiques, astronomiques, etc. [http://data.bnf.fr/ark:/12148/cb10649342z#foaf:Person]
{/ud}
{ud0}
Christfried Kirch (1694) Astronome allemand. - Il succéda à son père Gottfried (1639-1710) dans la direction de l''Observatoire royal de Prusse (1716-1740). - Membre de l''Académie des sciences de Berlin (1716) et associé de celles de Paris (1723) et de Saint-Pétersbourg [http://data.bnf.fr/ark:/12148/cb12648455m#foaf:Person]
{/ud}
{ud0}
Dominique-François Rivard (1697) Mathématicien. - Philosophe. - Professeur au collège de Beauvais [http://data.bnf.fr/ark:/12148/cb119220838#foaf:Person]
{/ud}
{ud0}
Abbé Deidier (Marseille, 1698) Abbé. - Mathématicien. - Professeur d''artillerie à l''Ecole militaire de La Fère [http://data.bnf.fr/ark:/12148/cb102670411#foaf:Person]
{/ud}
{ud0}
Colin MacLaurin (Kilmodan, GB, 1698) Mathématicien et physicien [http://data.bnf.fr/ark:/12148/cb12534513m#foaf:Person]
{/ud}
{ud0}
Pierre-Louis Moreau de Maupertuis (Saint-Malo, Ille-et-Villaine, 1698) Philosophe, astronome et physicien. - Fut invité par Frédéric II à réorganiser puis présider l''Académie de Berlin. - Ami puis ennemi de Voltaire, qui écrivit contre lui "Micromégas". - Membre de l''Académie française (élu en 1743) [http://data.bnf.fr/ark:/12148/cb11915229j#foaf:Person]
{/ud}
{ud0}
Charles-Étienne-Louis Camus (Crécy-en-Brie (Seine-et-Marne), 1699) Mathématicien. - Astronome. - Participa à l''expédition de 1736 en Laponie. - Membre de l''Académie des sciences (1727) et de l''Académie d''architecture (1739) [http://data.bnf.fr/ark:/12148/cb12181030f#foaf:Person]
{/ud}
{ud0}
Johann Ludwig Levin Gebhardi (Braunschweig, Allemagne, 1699) Historien, professeur de philologie à l''académie équestre de Lüneburg (1723). - Mathématicien [http://data.bnf.fr/ark:/12148/cb143273694#foaf:Person]
{/ud}
{ud0}
Daniel Bernoulli (Groningue (Pays-Bas), 1700) Mathématicien, physicien et astronome. - Fut professeur à Saint-Petersbourg (1725-1733) et à Bâle (1733-) [http://data.bnf.fr/ark:/12148/cb122991859#foaf:Person]
{/ud}
{ud0}
Sámuel Mikoviny (Ábelfalva, aujourd''hui Ábelová, Slovaquie, 1700) Cartographe. - Officier du génie. - Spécialiste en hydraulique. - Mathématicien. - Disciple de Bél Mátyás (1684-1749). - Études à Jena et à Nuremberg, Allemagne [http://data.bnf.fr/ark:/12148/cb103650124#foaf:Person]
{/ud}
{ud0}
Anders Celsius (1701) Astronome et naturaliste. - Professeur d''astronomie à l''université d''Uppsala (1730) [http://data.bnf.fr/ark:/12148/cb14606035v#foaf:Person]
{/ud}
{ud0}
Charles-Marie de La Condamine (Paris, 1701) Savant. - Astronome. - Géographe. Mesura l''arc du Méridien avec Godin et Bouguer. - Membre de l''Académie française (élu en 1760) [http://data.bnf.fr/ark:/12148/cb119102567#foaf:Person]
{/ud}
{ud0}
Georg Wolfgang Krafft (Tuttlingen (Allemagne), 1701) Physicien, professeur de mathématiques et de physique [http://data.bnf.fr/ark:/12148/cb10587905k#foaf:Person]
{/ud}
{ud0}
Johannes Nicolaus Frobesius (Goslar, Allemagne, 1701) Mathématicien et professeur de philosophie [http://data.bnf.fr/ark:/12148/cb12355199c#foaf:Person]
{/ud}
{ud0}
Niccolò de Martino (1701) Mathématicien [http://data.bnf.fr/ark:/12148/cb16265590z#foaf:Person]
{/ud}
{ud0}
Johann Lorenz Schmidt (1702) Fils de pasteur, a étudié la théologie et s''est intéressé à la  philosophie et aux mathématiques. - A publié en 1735 une traduction annotée de la première partie de la Bible, les cinq livres de Moïse (ou Torah ou Pentateuque), connue sous le nom de "Wertheimer Bible", laquelle a été censurée par l''empereur [http://data.bnf.fr/ark:/12148/cb150701237#foaf:Person]
{/ud}
{ud0}
Antoine Deparcieux (1703) Mathématicien et statisticien. - Fut constructeur de cadrans solaires et inventeur de machines pour élever les eaux et de presse pour le tabac. - Membre de l''Académie des sciences (1746) [http://data.bnf.fr/ark:/12148/cb121904326#foaf:Person]
{/ud}
{ud0}
Bernard-Laurent Soumille (1703) Mathématicien, physicien et agronome. - Prêtre-bénéficier du chapitre de Villeneuve-lès-Avignon (à partir de 1736, environ). - Correspondant de l''Académie royale des sciences de Paris [http://data.bnf.fr/ark:/12148/cb130919156#foaf:Person]
{/ud}
{ud0}
Thomas Le Seur (1703) Franciscain. - Professeur de mathématique à l''Université de la Sapience (Rome) [http://data.bnf.fr/ark:/12148/cb155933751#foaf:Person]
{/ud}
{ud0}
Gabriel Cramer (Genève, Suisse, 1704) Professeur de philosophie et de mathématiques des Académies et Sociétés royales de Londres, de Berlin, de Montpellier, de Lyon et de l''Académie de l''Institut de Bologne [http://data.bnf.fr/ark:/12148/cb15006804w#foaf:Person]
{/ud}
{ud0}
Guillaume Le Blond (Paris, 1704) Mathématicien [http://data.bnf.fr/ark:/12148/cb14330967m#foaf:Person]
{/ud}
{ud0}
Henri Michel Sauvage (Verdun, 1704) Jésuite. - Professeur d''humanités, de mathématiques et de philosophie [http://data.bnf.fr/ark:/12148/cb16180102s#foaf:Person]
{/ud}
{ud0}
Jacopo Belgrado (1704) Jésuite. - Physicien, mathématicien et archéologue [http://data.bnf.fr/ark:/12148/cb12161284h#foaf:Person]
{/ud}
{ud0}
Johann Andreas von Segner (1704) Naturaliste, mathématicien, médecin, logicien, philosophe. - Né à Presbourg (l''actuelle Bratislava), il fit toute sa carrière en Allemagne (à Iéna, Göttingen, Halle notamment) [http://data.bnf.fr/ark:/12148/cb12316478n#foaf:Person]
{/ud}
{ud0}
Louis Godin (Paris, 1704) Astronome, membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb15004534h#foaf:Person]
{/ud}
{ud0}
John Nourse (1705) Variante(s) de prénom : Jean. - Libraire ; libraire (ordinaire) de Sa Majesté (1762) ; libraire de la "Society for the Encouragement of learning". - Baptisé à Oxford le 8 juillet 1705 ; fils d''un chirurgien. En apprentissage chez le libraire de Londres John I Osborne d''août 1722 à oct. 1729. Établi vers 1730. Succède au libraire William Mears après lui avoir été associé. Spécialiste des publications scientifiques, particulièrement de mathématiques, et des éditions étrangères, de philosophes notamment. Séjourne à Paris en 1780. Décédé à Kensington en avril 1765. Son frère Charles Nourse puis Francis Wingrave lui succèdent [http://data.bnf.fr/ark:/12148/cb13605346z#foaf:Person]
{/ud}
{ud0}
Edme-Gilles Guyot (Paris, 1706) Les ouvrages "Nouvelles récréations physiques et mathématiques" et "Essai sur la construction des ballons aérostatiques et sur la manière de les diriger" lui sont attribués par Hoefer et Quérard. - DBF et Michaud soulignent la confusion entre lui et Guillaume-Germain Guyot pour l''attribution de ces ouvrages [http://data.bnf.fr/ark:/12148/cb14651894d#foaf:Person]
{/ud}
{ud0}
Girolamo Settimo (1706) Mathématicien [http://data.bnf.fr/ark:/12148/cb162655930#foaf:Person]
{/ud}
{ud0}
Giuseppe Maria Asclepi (1706) Jésuite, enseigna les mathématiques et les humanités [http://data.bnf.fr/ark:/12148/cb12240755t#foaf:Person]
{/ud}
{ud0}
Benjamin Robins (Bath, GB, 1707) Mathématicien et ingénieur militaire. - Pamphlétaire [http://data.bnf.fr/ark:/12148/cb121289860#foaf:Person]
{/ud}
{ud0}
Francesco Ottavio Magnocavalli (Casale, Italie, 1707) Architecte, mathématicien et poète [http://data.bnf.fr/ark:/12148/cb10732099c#foaf:Person]
{/ud}
{ud0}
Jean Paul Grandjean de Fouchy (Paris, 1707) Astronome. - Secrétaire perpétuel de l''Académie des Sciences (1743) [http://data.bnf.fr/ark:/12148/cb10667779b#foaf:Person]
{/ud}
{ud0}
José Quiroga (1707) Jésuite, mathématicien et pilote [http://data.bnf.fr/ark:/12148/cb12570261h#foaf:Person]
{/ud}
{ud0}
Leonhard Euler (Bâle (Suisse), 1707) Mathématicien et physicien. - Philosophe, théologien et orientaliste. - Membre de l''Académie des sciences de Saint-Pétersbourg (à partir de 1733) et de celle de Berlin (à partir de 1741), et membre associé de celle de Paris (à partir de 1755) [http://data.bnf.fr/ark:/12148/cb12157666x#foaf:Person]
{/ud}
{ud0}
Giovanni Francesco Mauro Melchior Salvemini da Castiglione (1708) Professeur de mathématiques à Utrecht (1751) puis directeur de la classe de mathématiques de l''Académie de Berlin. - Découvrit la solution du problème consistant à inscrire dans un cercle un triangle dont les côtés passent par trois points donnés [http://data.bnf.fr/ark:/12148/cb130145422#foaf:Person]
{/ud}
{ud0}
Eustachio Zanotti (Bologne, Italie, 1709) Astronome [http://data.bnf.fr/ark:/12148/cb12202196d#foaf:Person]
{/ud}
{ud0}
Giordano Riccati (Castelfranco Veneto, Italie, 1709) Comte. - Mathématicien, acousticien et théoricien de la musique. - Fut aussi physicien et architecte [http://data.bnf.fr/ark:/12148/cb12252383n#foaf:Person]
{/ud}
{ud0}
Georg Matthias Bose (Leipzig (Allemagne), 1710) Astronome, physicien, mathématicien. - Professeur de physique à l''université de Wittenberg [http://data.bnf.fr/ark:/12148/cb14065311n#foaf:Person]
{/ud}
{ud0}
Jacques Audierne (1710) Auteur comique et mathématicien [http://data.bnf.fr/ark:/12148/cb10425836p#foaf:Person]
{/ud}
{ud0}
Johann Bernoulli (1710) Mathématicien [http://data.bnf.fr/ark:/12148/cb14852857s#foaf:Person]
{/ud}
{ud0}
Thomas Simpson (1710) Membre de la société royale de Londres, professeur de mathématiques à Woolwich (en 1755) [http://data.bnf.fr/ark:/12148/cb103759851#foaf:Person]
{/ud}
{ud0}
Alexandre-Gui Pingré (Paris, 1711) Génovéfain. - Astronome. - Correspondant (à partir de 1753), puis associé libre de l''Académie des sciences. - Géographe de la Marine. - Chancelier de l''Université de Paris (1769-17..). - Bibliothécaire de Sainte-Geneviève (à partir de 1792) [http://data.bnf.fr/ark:/12148/cb12151017m#foaf:Person]
{/ud}
{ud0}
François Jacquier (Vitry-le-François (Marne), 1711) Religieux de l''ordre des Minimes. - Professeur de physique et mathématiques [http://data.bnf.fr/ark:/12148/cb12198105d#foaf:Person]
{/ud}
{ud0}
Laura Bassi (Bologne, Italie, 1711) Mathématicienne et physicienne. - Professeur de biologie et de physique à l''Université de Bologne. - Première femme titulaire d''une chaire universitaire en Europe [http://data.bnf.fr/ark:/12148/cb135103950#foaf:Person]
{/ud}
{ud0}
Ottaviano Cametti (Gattinara, Italie, 1711) Mathématicien, physicien et historien [http://data.bnf.fr/ark:/12148/cb10464765k#foaf:Person]
{/ud}
{ud0}
Pierre Joseph de Rivaz (1711) Mathématicien, inventeur-mécanicien et historien. - Directeur des salines de Moutiers. - Né dans le Valais et mort à Moutiers (Tarentaise) [http://data.bnf.fr/ark:/12148/cb128398731#foaf:Person]
{/ud}
{ud0}
Rugerius Josephus Boscovich (Raguse aujourd''hui Dubrovnik (Croatie), 1711) Jésuite. - Physicien, mathématicien, astronome et philosophe. - Professeur de mathématiques à Rome, Pavie et Milan. - Directeur de l''optique de la Marine royale à Paris et membre de la "Royal Society" à Londres. - Dans son ouvrage majeur "Théorie de la philosophie naturelle" il élabore la théorie initiale des forces et de la structure fondamentale de la matière, dont les concepts ont trouvé écho dans les découvertes de la physique moderne. - Il publie nombre d''ouvrages contenant ses découvertes en mathématiques, en astronomie, en géophysique et en archéologie. - Il mit au point différents instruments optiques, astronomiques et géodésiques et réalisa des expertises et des mesures hydrotechniques, géodésiques, cartographiques et statiques. - Il consolida la coupole de la basilique Saint-Pierre de Rome et de la flèche de la cathédrale de Milan [http://data.bnf.fr/ark:/12148/cb12054879x#foaf:Person]
{/ud}
{ud0}
Jean-Paul de Gua de Malves (Malves (Aude), 1712) Abbé. - Mathématicien, géomètre, économiste politique. - Titulaire de la chaire de philosophie au Collège de France (1742-1749) [http://data.bnf.fr/ark:/12148/cb15325204x#foaf:Person]
{/ud}
{ud0}
Samuel König (1712) Date de mort : 21 août ou 22 juillet 1757. - A également écrit en français. - Mathématicien, philosophe et juriste [http://data.bnf.fr/ark:/12148/cb120941298#foaf:Person]
{/ud}
{ud0}
Alexis Claude Clairaut (Paris (France), 1713) Mathématicien très précoce et astronome. - Ami de Voltaire et de la marquise Du Chatelet [http://data.bnf.fr/ark:/12148/cb124002538#foaf:Person]
{/ud}
{ud0}
Giammaria Ortes (1713) Moine camaldule. - Mathématicien, économiste et philosophe [http://data.bnf.fr/ark:/12148/cb13753557w#foaf:Person]
{/ud}
{ud0}
Nicolas-Louis de La Caille (Rumigny, Ardennes, 1713) Abbé. - Professeur de mathématiques au Collège Mazarin. - Membre de l''Académie royale des sciences [http://data.bnf.fr/ark:/12148/cb12124353d#foaf:Person]
{/ud}
{ud0}
Alessandro Vittorio Papacino d''Antoni (Villafranca, Italie, 1714) Ingénieur, mathématicien. - Membre de l''Académie des sciences de Turin [http://data.bnf.fr/ark:/12148/cb10709482t#foaf:Person]
{/ud}
{ud0}
César-François Cassini de Thury (Thury-sous-Clermont (Oise), 1714) Astronome et géomètre. - Membre de l''Académie des sciences (1736). - Fils de Jacques Cassini (1677-1756) et père de Jean-Dominique Cassini (1748-1845). - Participa avec son père à la mesure de la perpendiculaire de l''Observatoire. - Son oeuvre principale est la carte de France, première carte de base de ce pays, dont la publication commença en 1756 [http://data.bnf.fr/ark:/12148/cb12241101g#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Audiffredi (Saorge, Italie, 1714) Dominicain. - Astronome. - Préfet de la Biblioteca Casanatense, Rome (1759-1794). - Né Giulio Cesare Audiffredi, change de prénom en entrant chez les Dominicains (1730) [http://data.bnf.fr/ark:/12148/cb13595556h#foaf:Person]
{/ud}
{ud0}
John Winthrop (1714) Professeur de Mathématiques et de Philosophie naturelle à Harvard [http://data.bnf.fr/ark:/12148/cb14594660x#foaf:Person]
{/ud}
{ud0}
François-Joachim Duport-Dutertre (Saint-Servan (Ille-et-Vilaine), 1715) Littérateur. - Mathématicien. - Voyageur [http://data.bnf.fr/ark:/12148/cb12533121w#foaf:Person]
{/ud}
{ud0}
Pierre-Charles Le Monnier (Paris, 1715) Astronome. - Membre de l''Académie des sciences (1741). - Professeur de physique au Collège de France (de 1749 à 1793), puis membre de la classe des sciences physiques et mathématiques de l''Institut [http://data.bnf.fr/ark:/12148/cb121064574#foaf:Person]
{/ud}
{ud0}
André-Pierre Le Guay de Prémontval (Charenton (Val-de-Marne), 1716) Professeur de mathématiques. - Membre de l''Académie de Berlin [http://data.bnf.fr/ark:/12148/cb122271303#foaf:Person]
{/ud}
{ud0}
Eugénios Voúlgaris (Corfou (Îles Ioniennes, Grèce), 1716) Métropolite de l''Église orthodoxe grecque. - Théologien, philosophe et mathématicien. - "Éducateur de la Nation" et précurseur des Lumières en Grèce ; traducteur de Voltaire et Virgile. - Nommé évêque en Russie [http://data.bnf.fr/ark:/12148/cb12564304q#foaf:Person]
{/ud}
{ud0}
Gottfried Ploucquet (1716) Philosophe, mathématicien et théologien. - Professeur de philosophie à l''université de Tübingen (1750-1782) [http://data.bnf.fr/ark:/12148/cb13324024g#foaf:Person]
{/ud}
{ud0}
Leonardo Ximenes (Trapani, Italie, 1716) Jésuite. - Geographe, astronome, mathématicien [http://data.bnf.fr/ark:/12148/cb106577403#foaf:Person]
{/ud}
{ud0}
D'' Alembert (Paris, 1717) Mathématicien et philosophe. - Nom patronymique : Jean Le Rond, d̲i̲t̲ d'' Alembert. - Membre de l''Institut, Académie française (élu en 1754) [http://data.bnf.fr/ark:/12148/cb118883708#foaf:Person]
{/ud}
{ud0}
Josef Anton Nagel (1717) Professeur, mathématicien, scientifique allemand [http://data.bnf.fr/ark:/12148/cb12091922b#foaf:Person]
{/ud}
{ud0}
Augustin Darquier de Pellepoix (Toulouse, 1718) Astronome. - Associé non résidant de l''Académie des sciences. - Receveur des tailles de la généralité d''Auch [http://data.bnf.fr/ark:/12148/cb12155190x#foaf:Person]
{/ud}
{ud0}
Claude-François Berthelot (1718) Ingénieur. - Professeur de mathématiques à l''École royale militaire. - Inventeur de l''"affut de Gribeauval" [http://data.bnf.fr/ark:/12148/cb134984423#foaf:Person]
{/ud}
{ud0}
François-César Le Tellier Courtanvaux (1718) Duc de Doudeauville. - Capitaine-colonel des cent-suisses de la garde du roi. - Astronome, membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb121904446#foaf:Person]
{/ud}
{ud0}
Gaspard-François-Anne de Forbin (1718) Né le 8 ou le 18 juillet 1718. - Embrassa d'' abord la carrière militaire. - Chevalier de Malte. - Mathématicien et Physicien [http://data.bnf.fr/ark:/12148/cb12108181n#foaf:Person]
{/ud}
{ud0}
István Hatvani (Rimaszombat, aujourd''hui Rimavská Sobota, Slovaquie, 1718) Mathématicien, physicien. - Médecin. - Pédagogue, professeur à Debrecen,Református Kollégium, Hongrie. - Diplômé de l''Université de Bâle, Suisse [http://data.bnf.fr/ark:/12148/cb10355679v#foaf:Person]
{/ud}
{ud0}
Jean-Philippe Loys de Chéseaux (1718) Astronome et physicien. - Né à Lausanne, mort à Paris [http://data.bnf.fr/ark:/12148/cb133196302#foaf:Person]
{/ud}
{ud0}
Joseph Amiot (Toulon, 1718) Jésuite de 1737 à 1773 (ordonné prêtre en 1749). - Sinologue et astronome. - Missionnaire en Chine (à partir de 1749) [http://data.bnf.fr/ark:/12148/cb12112654w#foaf:Person]
{/ud}
{ud0}
Maria Gaetana Agnesi (Milan, Italie, 1718) Mathématicienne [http://data.bnf.fr/ark:/12148/cb105423187#foaf:Person]
{/ud}
{ud0}
Abraham Gotthelf Kästner (Leipzig, Allemagne, 1719) Mathématicien. - Poète et épigrammatiste. - Critique [http://data.bnf.fr/ark:/12148/cb123392338#foaf:Person]
{/ud}
{ud0}
Giuseppe Toaldo (Pianezze, Italie, 1719) Prêtre. - Physicien. - Professeur d''astronomie, de géographie et de météorologie à l''Université de Padoue [http://data.bnf.fr/ark:/12148/cb10578331h#foaf:Person]
{/ud}
{ud0}
Jens Kraft (1720) Philosophe des lumières danois. - Professeur de mathématiques et de philosophie à Soroe [http://data.bnf.fr/ark:/12148/cb12442689p#foaf:Person]
{/ud}
{ud0}
Charles Walmesley (1722) Évêque de Rama. - Astronome [http://data.bnf.fr/ark:/12148/cb10748264x#foaf:Person]
{/ud}
{ud0}
Jean Chappe d''Auteroche (Mauriac (Cantal), 1722) Astronome. - Explorateur en Sibérie et en Californie [http://data.bnf.fr/ark:/12148/cb12402595h#foaf:Person]
{/ud}
{ud0}
Jean-Louis Dupain-Triel (1722) Homme de lettres, poète. - S''intéressa aux mathématiques, à la géographie et à l''enseignement des arts [http://data.bnf.fr/ark:/12148/cb119011560#foaf:Person]
{/ud}
{ud0}
Louis-Jacques Goussier (1722) Mathématicien et inventeur [http://data.bnf.fr/ark:/12148/cb13485055d#foaf:Person]
{/ud}
{ud0}
Baien Miura (1723) Lettré du milieu de l''époque d''Edo. - A créé son propre système de pensée philosophique appelé "jōrigaku" : méthode de spéculation fondée sur l''éthique, la logique, les mathématiques et la physique, recourant à une pensée dialectique appelée "hankan gōitsu" [http://data.bnf.fr/ark:/12148/cb12293200x#foaf:Person]
{/ud}
{ud0}
Didier Robert de Vaugondy (1723) Géographe ordinaire du roi, professeur de mathématiques et de géographie, fils de Gilles Robert Vaugondy. - Didier signe "Robert de Vaugondy" [http://data.bnf.fr/ark:/12148/cb12380757h#foaf:Person]
{/ud}
{ud0}
Étienne-Nicolas Blondeau (1723) Professeur de mathématiques. - Ingénieur de la marine. - Collaborateur de l''Encyclopédie méthodique (1782-1783?) [http://data.bnf.fr/ark:/12148/cb10737141j#foaf:Person]
{/ud}
{ud0}
Johann Tobias Mayer (1723) Mathématicien et astronome, a travaillé avec Homann Herben de 1746 à 1751, puid pour Kilian à partir de 1752 [http://data.bnf.fr/ark:/12148/cb153509764#foaf:Person]
{/ud}
{ud0}
Johann Tobias Mayer (1723) Astronome allemand [http://data.bnf.fr/ark:/12148/cb11958863x#foaf:Person]
{/ud}
{ud0}
Nicole-Reine Lepaute (Paris, 1723) Née Nicole-Reine Étable de La Brière, épouse de Jean-André Lepaute, horloger du Roi. - Mathématicienne, astronome [http://data.bnf.fr/ark:/12148/cb14555447k#foaf:Person]
{/ud}
{ud0}
Tobias Mayer (Marbach (Allemagne), 1723) Astronome, mathématicien. - Directeur de l''Observatoire de Göttingen, Allemagne [http://data.bnf.fr/ark:/12148/cb121551484#foaf:Person]
{/ud}
{ud0}
Edme-Sébastien Jeaurat (1724) Ingénieur-géographe et astronome. - Professeur à l''école militaire. - Membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb122175393#foaf:Person]
{/ud}
{ud0}
François Para Du Phanjas (Chabottes (Hautes-Alpes), 1724) Philosophe et mathématicien [http://data.bnf.fr/ark:/12148/cb12528863r#foaf:Person]
{/ud}
{ud0}
Georges Louis Lesage (Genève, 1724) Mathématicien et physicien suisse. - Etudie à Genève puis Paris. - Etabli à Genève [http://data.bnf.fr/ark:/12148/cb155857475#foaf:Person]
{/ud}
{ud0}
Guillaume-Germain Guyot (Orléans, 1724) Les ouvrages "Nouvelles récréations physiques et mathématiques" et "Essai sur la construction des ballons aérostatiques et sur la manière de les diriger" lui sont attribués par le DBF et par Samuel Ersch dans "La France littéraire contenant les auteurs français de 1771 à 1796", DBF. - Quérard et Michaud soulignent la confusion entre lui et Edme-Gilles Guyot pour l''attribution de ces ouvrages [http://data.bnf.fr/ark:/12148/cb12214218k#foaf:Person]
{/ud}
{ud0}
Guillaume-Hyacinthe-Joseph-Jean-Baptiste Le Gentil de La Galaisière (1725) Astronome et voyageur. - Entre à l''Observatoire en 1750. - Membre de l''Académie des sciences en 1753 [http://data.bnf.fr/ark:/12148/cb12151459n#foaf:Person]
{/ud}
{ud0}
Jean-Étienne Montucla (1725) Historien des mathématiques [http://data.bnf.fr/ark:/12148/cb12127574n#foaf:Person]
{/ud}
{ud0}
Louis-Charles Desnos (1725) Libraire ; libraire et (ingénieur) géographe (pour les globes et les sphères) du roi de Danemark (ou : de Sa Majesté danoise) (1769-1789). - Fils d''un marchand drapier de Pont-Sainte-Maxence (Oise). Apprenti fondeur de caractères à Paris à partir d''avril 1745 (reçu maître fondeur en 1757).  Ingénieur géographe (de la ville de Paris à partir de 1769), fabricant et marchand de sphères et d''instruments astronomiques établi vers 1753 en succession de Jacques Hardy, après avoir épousé en 1749 la veuve de son fils Nicolas Hardy ; également marchand d''estampes et de cartes géographiques. Un des 12 libraires non jurés reçus le 4 oct. 1767. - Éditeur et auteur de nombreux atlas, almanachs et publications géographiques entre 1756 et 1795 env. Rédige également plusieurs catalogues de son fonds entre 1768 et 1792. Une partie de son fonds est rachetée en 1805 par Jean (17..-1839), marchand de cartes et d''estampes [http://data.bnf.fr/ark:/12148/cb12402252d#foaf:Person]
{/ud}
{ud0}
Rigobert Bonne (Raucourt (Meurthe-et-Moselle), 1727) Ingénieur. - Géographe. - Hydrographe. - Célèbre par la projection qui porte son nom et qui remplacera pour la carte de France la projection de Cassini. D''abord ingénieur géographe et maître de mathématiques. En 1775 ingénieur hydrographe de la Marine. Fut mis à la retraite contre sa volonté en 1789. Collabora au Neptune américo-septentrional [http://data.bnf.fr/ark:/12148/cb12169793s#foaf:Person]
{/ud}
{ud0}
Chrysologue de Gy (Gy (Haute-Saône), 1728) Capucin. - Astronome, cartographe et géologue [http://data.bnf.fr/ark:/12148/cb10728734z#foaf:Person]
{/ud}
{ud0}
Jean-Henri Lambert (Mulhouse, Suisse, 1728) Mathématicien, physicien, astronome et philosophe. - Spécialiste de géometrie. - En poste à l''Académie royale des sciences et belles lettres de Berlin (de 1765 à 1777) [http://data.bnf.fr/ark:/12148/cb12359659g#foaf:Person]
{/ud}
{ud0}
Le P.  Chrysologue (Gy, 1728) Capucin, nom de religion de Noël André. - Attiré par la géographie et l''astronomie, fut l''élève de Lemonnier. Mesura les altitudes des Vosges, du Jura et des Alpes. Se retira dans sa famille au moment de la Révolution.  En 1806 publia un important traité de géologie dont Cuvier fit un rapport élogieux [http://data.bnf.fr/ark:/12148/cb153054042#foaf:Person]
{/ud}
{ud0}
Paolo Frisi (Melegnano, Italie, 1728) Barnabite. - Mathématicien, astronome et écrivain. - Professeur dans les Écoles palatines de Milan (1764-) [http://data.bnf.fr/ark:/12148/cb120849325#foaf:Person]
{/ud}
{ud0}
Antonio Eximeno (1729) Théoricien de la musique et polémiste. - Jésuite, il devient professeur de rhétorique à l''Université de Valence, puis professeur de mathématiques à l''Académie militaire de Ségovie (1764). - Lorsque les jésuites sont expulsés d''Espagne en 1767, il se rend à Rome où il étudie la musique. - Connu aussi sous le pseud. : "Aristosseno Megareo" (BnF, Musique, fichier général auteurs), ou "Aristodemo Megareo" (Fétis) [http://data.bnf.fr/ark:/12148/cb13755053m#foaf:Person]
{/ud}
{ud0}
Charles Bossut (1730) Mathématicien, membre de l''Académie des sciences (1779), il participa à la rédaction de la partie mathématique de l''Encyclopédie [http://data.bnf.fr/ark:/12148/cb11763983g#foaf:Person]
{/ud}
{ud0}
Charles Bossut (1730) Mathématicien et physicien. - Membre de l''Académie des sciences, pensionnaire de la classe de mécanique (1785). - Écrivit plusieurs articles dans l''"Encyclopédie" [http://data.bnf.fr/ark:/12148/cb124599882#foaf:Person]
{/ud}
{ud0}
Charles Messier (Badonviller (Meurthe-et-Moselle), 1730) Astronome de la marine. - Académicien (1770). - Membre de l''Institut [http://data.bnf.fr/ark:/12148/cb124827900#foaf:Person]
{/ud}
{ud0}
Étienne Bezout (Nemours, 1730) Mathématicien. - Membre de l''Académie des sciences [http://data.bnf.fr/ark:/12148/cb12267459g#foaf:Person]
{/ud}
{ud0}
Jean-Baptiste de Laborde (1730) Physicien et mathématicien. - Jésuite [http://data.bnf.fr/ark:/12148/cb13196726p#foaf:Person]
{/ud}
{ud0}
Joseph-Aignan Sigaud de La Fond (Bourges, 1730) Mathématicien, physicien et moraliste. - Professeur de physique à Bourges [http://data.bnf.fr/ark:/12148/cb12401095w#foaf:Person]
{/ud}
{ud0}
Pierre-Thomas Antelmy (Trigance, France, 1730) Mathématicien, professeur de mathématiques à l''École militaire [http://data.bnf.fr/ark:/12148/cb13011110m#foaf:Person]
{/ud}
{ud0}
Benito Bails (1731) Mathématicien [http://data.bnf.fr/ark:/12148/cb162593727#foaf:Person]
{/ud}
{ud0}
Girolamo Francisco Cristiani (Brescia, Italie, 1731) Mathématicien et physicien [http://data.bnf.fr/ark:/12148/cb14065297x#foaf:Person]
{/ud}
{ud0}
Nicolas-Claude Duval-Le Roy (1731) Professeur de mathématiques et d''hydrographie, physicien et astronome. - Membre de l''Académie royale de marine. - Correspondant à l''Académie royale des sciences (1789), associé non résident de l''Institut (1796) [http://data.bnf.fr/ark:/12148/cb12548660k#foaf:Person]
{/ud}
{ud0}
Diderich Christian Fester (1732) Mathématicien et cartographe à Trondheim [http://data.bnf.fr/ark:/12148/cb15384550x#foaf:Person]
{/ud}
{ud0}
Jérôme de La Lande (Bourg-en-Bresse (Ain), 1732) Astronome. - Membre de l''Académie de Berlin. - Membre de l''Académie des sciences (1753). - Professeur d''astronomie au Collège de France (1762). - Directeur de l''Observatoire de Paris de 1768 à sa mort [http://data.bnf.fr/ark:/12148/cb12012398h#foaf:Person]
{/ud}
{ud0}
Maurille-Antoine Moithey (1732) Éditeur et marchand de cartes géographiques ; libraire. - Ingénieur géographe du Roi et professeur de mathématiques des pages du prince et de la princesse de Conti. Auteur de plans, de cartes, d''ouvrages illustrés et d''atlas, qu''il publie et diffuse parfois lui-même de 1776 à 1792 au moins. Auteur notamment d''un "Dictionnaire hydrographique de la France..." (1re éd., l''auteur, 1787 ; rééd., Paris, Blanchon, 1803) et d''une série de "Recherches historiques" sur les villes de France (Angers, Orléans, Reims, 1775-1776). Se qualifie de libraire en 1791-1792. Décédé à Paris le 21 frimaire an XIV (12 déc. 1805, Arch. de Paris) [http://data.bnf.fr/ark:/12148/cb13531657x#foaf:Person]
{/ud}
{ud0}
Nevil Maskelyne (1732) Astronome royal d''Angleterre. - Membre associé de l''Académie des sciences de Paris [http://data.bnf.fr/ark:/12148/cb12155150p#foaf:Person]
{/ud}
{ud0}
Jacques-François Dicquemare (Le Havre, 1733) Astronome. - Hydrographe. - Zoologue marin [http://data.bnf.fr/ark:/12148/cb15317071s#foaf:Person]
{/ud}
{ud0}
János Sajnovics (Tordas, Hongrie, 1733) Astronome. - Linguiste. - Père jésuite [http://data.bnf.fr/ark:/12148/cb12246417w#foaf:Person]
{/ud}
{ud0}
Jean-Charles Borda (Dax (Landes), 1733) Officier de marine. - Membre de l''Académie de Marine (élu en 1769). - Entra dans le Génie militaire et se fit remarquer par ses travaux sur l''hydraulique. - Il détermina la longitude des Canaries (en 1776). - Prit part à la guerre d''indépendance américaine. - Participa avec Delambre et Méchain à la mesure de l''arc de méridien Dunkerque-Barcelone. - En qualité de commissaire de l''Académie des sciences participa à l''étude des montres marines sur la frégate la Flore (en 1771). - Membre de l''Institut, Académie des sciences (élu en 1772). - Membre de la Commission des poids et mesures (en 1791), il travailla à l''établissement du système métrique. - Membre de l''Institut national des sciences et arts, section mathématiques (actuel Institut de France) et du Bureau des longitudes (en 1795). - Co-fondateur de La Société de Borda (créée en 1876), avec Jacques-François de Borda d''Oro (1718-1804) [http://data.bnf.fr/ark:/12148/cb12482831r#foaf:Person]
{/ud}
{ud0}
Samuel Horsley (1733) Evêque; secrétaire de la Royal Society; publia des livres de théologie et de mathématiques [http://data.bnf.fr/ark:/12148/cb120697374#foaf:Person]
{/ud}
{ud0}
Achille Pierre Dionis du Séjour (Paris, 1734) Astronome et mathématicien [http://data.bnf.fr/ark:/12148/cb10680537k#foaf:Person]
{/ud}
{ud0}
Baudouin de Guémadeuc (1734) Homme de loi, homme de lettres, pamphlétaire puis astronome [http://data.bnf.fr/ark:/12148/cb144447840#foaf:Person]
{/ud}
{ud0}
Charles Duvaucel (1734) Astronome, spécialisé dans les éclipses du soleil. [http://data.bnf.fr/ark:/12148/cb15318527x#foaf:Person]
{/ud}
{ud0}
Mathieu Bernard Goudin (Paris, 1734) Magistrat. - Mathématicien et astronome [http://data.bnf.fr/ark:/12148/cb10586154b#foaf:Person]
{/ud}
{ud0}
Alexandre-Théophile Vandermonde (Paris, 1735) Mathématicien [http://data.bnf.fr/ark:/12148/cb12534847r#foaf:Person]
{/ud}
{ud0}
Antonio Maria Lorgna (Cerea, Italie, 1735) Mathématicien [http://data.bnf.fr/ark:/12148/cb12387058m#foaf:Person]
{/ud}
{ud0}
Gregorio Fontana (Villa di Nogaredo, Italie, 1735) Mathématicien et physicien. - Recteur et professeur de calcul sublime à l''Ateneo lombardo. - Bibliothécaire du Collegio Ghisleri, Pavie [http://data.bnf.fr/ark:/12148/cb10601676b#foaf:Person]
{/ud}
{ud0}
Giovanni-Antonio Rizzi-Zannoni (Padoue, Italie, 1736) Géographe de la république de Venise, astronome, il voyage en Amérique du nord en 1757 [http://data.bnf.fr/ark:/12148/cb153024615#foaf:Person]
{/ud}
{ud0}
Jean Sylvain Bailly (Paris, 1736) Mathématicien, astronome et homme politique. - Entre à l''Académie des sciences (en 1763), à l''Académie française (en 1784) puis à l''Académie des inscriptions (en 1785). - Député du Tiers-État aux États-Généraux ; Maire de Paris ; Député à l''Assemblée Nationale Constituante [http://data.bnf.fr/ark:/12148/cb12516744h#foaf:Person]
{/ud}
{ud0}
Johann Nicolai Tetens (Tetenbüll, Allemagne, 1736) Mathématicien, physicien et philosophe [http://data.bnf.fr/ark:/12148/cb12531163b#foaf:Person]
{/ud}
{ud0}
Joseph-Louis Lagrange (1736) Mathématicien. - D''origine italienne. - A été à l''origine de la fondation de l''Académie des sciences de Turin. - Membre de l''Académie des sciences de Paris, Berlin, Turin. - A partir de 1787, enseigne à Paris à l''École normale et à l''École polytechnique [http://data.bnf.fr/ark:/12148/cb12125247f#foaf:Person]
{/ud}
{ud0}
Francesco Venini (Varenna, Italie, 1737) Abbé. - Mathématicien et poète [http://data.bnf.fr/ark:/12148/cb105963005#foaf:Person]
{/ud}
{ud0}
Giuseppe Maria Pagnini (Pistoia, Italie, 1737) Au siècle : Luca Antonio ; en religion, carme : Giuseppe Maria. - Poète. - Mathématicien. - Savant latiniste et helléniste. - Professeur à l'' Université de Parme puis de Pise [http://data.bnf.fr/ark:/12148/cb11996942k#foaf:Person]
{/ud}
{ud0}
Tommaso Valperga di Caluso (Turin, Italie, 1737) Abbé. - Homme de lettres, philosophe et mathématicien. - Chevalier de Malte [http://data.bnf.fr/ark:/12148/cb10748197m#foaf:Person]
{/ud}
{ud0}
William Bayly (1737) Astronome [http://data.bnf.fr/ark:/12148/cb14065321z#foaf:Person]
{/ud}
{ud0}
Charles-Joseph Mathon de La Cour (Lyon (Rhône), 1738) Économiste. - Philanthrope. - Fondateur du "Journal de Lyon". - Rédacteur de "L''Almanach musical" (1775-1778), et au "Journal de musique", Paris (1764-1768). - Fils de : Mathon de La Cour, Jacques (1712-1770), mathématicien [http://data.bnf.fr/ark:/12148/cb121925904#foaf:Person]
{/ud}
{ud0}
Flecheux (1738) Astronome et mécanicien français. - Adresse en 1784 : Paris, rue du Sentier, hôtel de madame la présidente de Meslay, n° 31 [http://data.bnf.fr/ark:/12148/cb15585605z#foaf:Person]
{/ud}
{ud0}
Joseph-François Marie (Rodez, 1738) Abbé. - Fut professeur de mathématiques au Collège Mazarin [http://data.bnf.fr/ark:/12148/cb146364765#foaf:Person]
{/ud}
{ud0}
Thomas Abbt (Ulm, Allemagne, 1738) Écrivain, philosophe, mathématicien, juriste et conseiller aulique [http://data.bnf.fr/ark:/12148/cb125347464#foaf:Person]
{/ud}
{ud0}
William Herschel (Hanovre, Allemagne, 1738) Astronome et compositeur. - A découvert la planète Uranus. - S''installe en Grande-Bretagne en 1757 [http://data.bnf.fr/ark:/12148/cb14064893z#foaf:Person]
{/ud}
{ud0}
Ermenegildo Pini (Milan, Italie, 1739) Barnabite. - Physicien, géologue, architecte. - Professeur de mathématiques, puis d''histoire naturelle au Collège Saint-Alexandre, Milan. - Dans le siècle : Pini, Carlo [http://data.bnf.fr/ark:/12148/cb13013593q#foaf:Person]
{/ud}
{ud0}
Jean-Louis Pictet (1739) Astronome [http://data.bnf.fr/ark:/12148/cb146402484#foaf:Person]
{/ud}
{ud0}
Johann Schultz (1739) A été professeur de mathématiques à l''université de Königsberg, Allemagne [http://data.bnf.fr/ark:/12148/cb121741380#foaf:Person]
{/ud}
{ud0}
José Antonio Alzate y Ramírez (1739) Astronome et géographe [http://data.bnf.fr/ark:/12148/cb15376450x#foaf:Person]
{/ud}
{ud0}
András Dugonics (Szeged (Hongrie), 1740) Écrivain. - Poète. - Piariste. - Professeur de mathématiques. - A fait des études de théologie  à Privigye (aujourd''hui Prievidza, Slovaquie) et à Nyitra (aujourd''hui Nitra, Slovaquie) [http://data.bnf.fr/ark:/12148/cb12246575b#foaf:Person]
{/ud}
{ud0}
Jacques-André Mallet (1740) Astronome [http://data.bnf.fr/ark:/12148/cb10552198c#foaf:Person]
{/ud}
{ud0}
Joseph Anton Slop von Cadenberg (1740) Astronome. - À l''Observatoire de Pise à partir de 1765 [http://data.bnf.fr/ark:/12148/cb12159312n#foaf:Person]
{/ud}
{ud0}
Nicola Spedalieri (Bronte (Italie), 1740) Professeur de philosophie, théologie et mathématique, poète, musicien, historien [http://data.bnf.fr/ark:/12148/cb16219670j#foaf:Person]
{/ud}
{ud0}
Nicolas-Antoine Nouet (1740) Astronome. - Attaché à l''Observatoire en 1785. - Participe à l''expédition d''Égypte en 1798. - Ingénieur au Bureau de la guerre en 1802 [http://data.bnf.fr/ark:/12148/cb12151453k#foaf:Person]
{/ud}
{ud0}
Thomas Bugge (Copenhague, 1740) Astronome et cartographe [http://data.bnf.fr/ark:/12148/cb121931908#foaf:Person]
{/ud}
{ud0}
Vicente Tofiño de San Miguel (1740) Astronome. - Capitaine de vaisseau. - Directeur des compagnies des gardes royales de la marine en 1786. - Membre de l''Académie d''histoire de Madrid. - Correspondant de l''Académie des sciences de Paris [http://data.bnf.fr/ark:/12148/cb12159995t#foaf:Person]
{/ud}
{ud0}
Alexis Rochon (Brest (Finistère), 1741) Prêtre, astronome de la marine, physicien et inventeur. - Bibliothécaire de l''Académie royale de marine à Brest (1765-), astronome opticien de la Marine (1787), membre de la Commission des poids et mesures et des monnaies (1792). - Membre de l''Académie royale des sciences, puis membre de l''Institut. - Clerc tonsuré [http://data.bnf.fr/ark:/12148/cb129983745#foaf:Person]
{/ud}
{ud0}
Stanislaw Wydra (1741) Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb15512813z#foaf:Person]
{/ud}
{ud0}
Vincenzo Chiminello (Marostica, Italie, 1741) Abbé. - Astronome [http://data.bnf.fr/ark:/12148/cb10522164f#foaf:Person]
{/ud}
{ud0}
Georg Jonathan von Holland (1742) Théologien. - Mathématicien. - Précepteur des princes de Wurttemberg [http://data.bnf.fr/ark:/12148/cb119076602#foaf:Person]
{/ud}
{ud0}
Jacques Poitevin (Montpellier, 1742) Savant astronome et agriculteur. - Conseiller de préfecture du département de l''Hérault. - Membre de la Société royale des sciences de Montpellier [http://data.bnf.fr/ark:/12148/cb10644654k#foaf:Person]
{/ud}
{ud0}
Antonio Cagnoli (Zante, Grèce, 1743) Astronome et mathématicien. - Crée un observatoire d''astronomie à Vérone. - Enseigne les mathématiques à l''École militaire de Modène après la prise de Vérone par les Français (1797). - Membre de nombreuses académies d''Europe [http://data.bnf.fr/ark:/12148/cb12562781s#foaf:Person]
{/ud}
{ud0}
Eberhard August Wilhelm von Zimmermann (Uelzen, Allemagne, 1743) Géographe et naturaliste. - Professeur de mathématiques et de sciences naturelles au Collegium Carolinum de Brunswick de 1766 à 1815. - Conseiller aulique en 1786, puis conseiller d''état en 1801 [http://data.bnf.fr/ark:/12148/cb12330956p#foaf:Person]
{/ud}
{ud0}
Jean-Antoine-Nicolas de Caritat Condorcet (1743) Philosophe, mathématicien et  économiste. - Membre de l''Académie française (1782). - Homme politique. - A aussi écrit sous le pseudonyme M. Schwartz, pasteur à Bienne [http://data.bnf.fr/ark:/12148/cb118975118#foaf:Person]
{/ud}
{ud0}
Etienne Lenoir (1744) Ingénieur. - Mit au point plusieurs instruments d''astronomie et de géodésie [http://data.bnf.fr/ark:/12148/cb151423156#foaf:Person]
{/ud}
{ud0}
François Callet (Versailles, 1744) Professeur de mathématiques et d''hydrographie [http://data.bnf.fr/ark:/12148/cb10544471f#foaf:Person]
{/ud}
{ud0}
Jean Bernoulli (Bâle, Suisse, 1744) Mathématicien, astronome. - Membre des Académies des sciences de Berlin, de Petersbourg, de Stockholm, de Bologne, de Lyon, & de Marseille, de la Société pour l''encouragement des arts, de Londres, de celle des physiciens de Bâle, de l''Académie des Arcades de Rome [http://data.bnf.fr/ark:/12148/cb14508854n#foaf:Person]
{/ud}
{ud0}
José Anastácio da Cunha (1744) Poète portugais. - Mathématicien, professeur de géométrie à l''Université de Coimbra. - Officier d''artillerie à Valença do Minho (1764-1778) [http://data.bnf.fr/ark:/12148/cb121612626#foaf:Person]
{/ud}
{ud0}
Pierre Méchain (Laon, 1744) Astronome français. - Prénoms complets : Pierre François André [http://data.bnf.fr/ark:/12148/cb12090251r#foaf:Person]
{/ud}
{ud0}
Caspar Wessel (Vestby, Norvège, 1745) Mathématicien. - Reçut la médaille d''argent de la Royal Danish academy [http://data.bnf.fr/ark:/12148/cb12563002z#foaf:Person]
{/ud}
{ud0}
Claude-François Guillemeau de Fréval (Paris, 1745) Mathématicien [http://data.bnf.fr/ark:/12148/cb10017540p#foaf:Person]
{/ud}
{ud0}
Franz von Paula Triesnecker (1745) Astronome [http://data.bnf.fr/ark:/12148/cb15115995f#foaf:Person]
{/ud}
{ud0}
Fulcrand Jean Joseph Aigrefeuille (1745) Gastronome [http://data.bnf.fr/ark:/12148/cb16296114m#foaf:Person]
{/ud}
{ud0}
Johann Hieronymus Schröter (1745) Magistrat et astronome amateur allemand [http://data.bnf.fr/ark:/12148/cb11973603q#foaf:Person]
{/ud}
{ud0}
Nicolas Charles Romme (Riom, Puy-de-Dôme, 1745) Professeur de mathématiques et de navigation à l''École de Rochefort. - Membre de l''Institut [http://data.bnf.fr/ark:/12148/cb12805333t#foaf:Person]
{/ud}
{ud0}
Gaetano Del Ricco (1746) Piariste (17 mai 1761). - Mathématicien. - Librettiste. - Prénom de baptême : Vincenzo [http://data.bnf.fr/ark:/12148/cb16659347q#foaf:Person]
{/ud}
{ud0}
Gaspard Monge (1746) Mathématicien et géomètre. - Fondateur de l''École polytechnique et de l''École normale. - Président de l''Institut du Caire. - Membre de l''Institut, Académie des sciences. - Député au Conseil des Cinq-Cents, au Conseil des Anciens, ministre de la Marine (1792), sénateur (1799), comte de Péluse (1808) [http://data.bnf.fr/ark:/12148/cb121412336#foaf:Person]
{/ud}
{ud0}
Giovanni Battista Venturi (Bibbiano, Italie, 1746) Physicien et mathématicien. - Homme politique et diplomate [http://data.bnf.fr/ark:/12148/cb127228927#foaf:Person]
{/ud}
{ud0}
Giuseppe Piazzi (Ponte di Valtellina, Italie, 1746) Astronome [http://data.bnf.fr/ark:/12148/cb12920801z#foaf:Person]
{/ud}
{ud0}
Jean-Claude-Gauthier-Louis de Benaben (1746) Oratorien et professeur de mathématiques. - Fut directeur de l''Ecole centrale d''Angers. - Fut président des Amis de la Constitution. - Fut commissaire civil du département de Maine-et-Loire [http://data.bnf.fr/ark:/12148/cb125680474#foaf:Person]
{/ud}
{ud0}
Jean Foucaud (1747) Prédicateur, mathématicien, philologue. - A écrit en patois limousin des fables imitées de La Fontaine, qu''il a aussi traduit dans cette même langue. - Fut l''un des rédacteurs du "Journal du département de la Haute-Vienne". - Fut à Limoges une personalité agissante du Club des jacobins, membre du Comité de salut public, juge de paix et payeur du département de Haute-Vienne. - Défroqué en 1793, il mourut réconcilié avec l''Église [http://data.bnf.fr/ark:/12148/cb119031941#foaf:Person]
{/ud}
{ud0}
Jean-Baptiste Bernard (1747) Libraire ; libraire de l''École polytechnique (1800) ; de l''École des Ponts et Chaussées (1801) ; des Écoles impériales polytechnique et des Ponts et chaussées (1805). - Né à Marseille. Libraire spécialisé dans les "mathématiques, sciences et arts", il travaille jusqu''en 1796 en association avec Régent au bureau du "Journal polytechnique" ou "Bulletin des Travaux publics..." Historien et philologue, éditeur des "Œuvres posthumes" de Montesquieu. Décédé à Saint-Maur-des-Fossés (Val-de-Marne) en oct. 1808. Sa veuve lui succède avant de revendre son fonds en 1810 à Jean Klostermann [http://data.bnf.fr/ark:/12148/cb122388832#foaf:Person]
{/ud}
{ud0}
Johann Elert Bode (Hambourg (Allemagne), 1747) Astronome [http://data.bnf.fr/ark:/12148/cb104634498#foaf:Person]
{/ud}
{ud0}
Andreas Riedel (Vienne, 1748) Jacobin viennois. - Professeur de mathématiques, précepteur des enfants du Grand duc Léopold, futur empereur,  1779-1790, Florence (Italie). - Études de médecine, élève du professeur Franz Anton Mesmer. - Emprisonné à Brno (1806-1809). - Se réfugia en France 1810-1837 [http://data.bnf.fr/ark:/12148/cb14593357z#foaf:Person]
{/ud}
{ud0}
Jean-Dominique Cassini (1748) Astronome. - Membre de l''Académie des sciences (1770). - Fils de l''astronome César-François Cassini (1714-1784), qui était aussi appelé Cassini de Thury, car né à Thury (Oise) en 1714. - Succède à son père comme directeur de l''Observatoire de Paris (en 1784) [http://data.bnf.fr/ark:/12148/cb12157999q#foaf:Person]
{/ud}
{ud0}
Pietro Cossali (Vérone, Italie, 1748) Mathématicien. - A enseigné à l''université de Padoue [http://data.bnf.fr/ark:/12148/cb146340668#foaf:Person]
{/ud}
{ud0}
Pons-Joseph Bernard (1748) Mathématicien. - Directeur adjoint de l''Observatoire de Marseille [http://data.bnf.fr/ark:/12148/cb12306722n#foaf:Person]
{/ud}
{ud0}
Thaddäus Rinderle (1748) Moine bénédictin, mathématicien et horloger [http://data.bnf.fr/ark:/12148/cb15037954k#foaf:Person]
{/ud}
{ud0}
Giuseppe Calandrelli (Zagarolo, Italie, 1749) Astronome. - Directeur du "Collegio romano" [http://data.bnf.fr/ark:/12148/cb10544460s#foaf:Person]
{/ud}
{ud0}
Henri Bouchon-Dubournial (1749) Ingénieur et mathématicien. - Fut professeur à l''Ecole militaire et l''Ecole royale militaire. - Fut le traducteur de Cervantès [http://data.bnf.fr/ark:/12148/cb125620183#foaf:Person]
{/ud}
{ud0}
Jean-Baptiste Delambre (Amiens, 1749) Astronome. - Ses calculs ont servi à  déterminer la longueur du mètre. - Membre de l''Académie des sciences (1792) [http://data.bnf.fr/ark:/12148/cb12096096m#foaf:Person]
{/ud}
{ud0}
Paul-Louis Cirodde (1749) Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb102655606#foaf:Person]
{/ud}
{ud0}
Pierre-Simon de Laplace (Beaumont-en-Auge (Calvados), 1749) Astronome, mathématicien et physicien. - Membre de l''Institut, Académie des sciences (élu en 1795), puis de l''Académie française (élu en 1816). - Obtint le titre de marquis (en 1817) [http://data.bnf.fr/ark:/12148/cb119110516#foaf:Person]
{/ud}
{ud0}
Vincenzo De Filippis (1749) Scientifique, mathématicien. - Ministre de la République parthénopéenne en février 1799, fut probablement victime de la répression au rétablissement des Bourbons en juin de la même année [http://data.bnf.fr/ark:/12148/cb12290835h#foaf:Person]
{/ud}
{ud0}
William Faden (1749) Libraire, éditeur et marchand de cartes et d''estampes ; également géographe ordinaire du roi d''Angleterre (1783-1820) et du prince de Galles (1790-1820). - Fils de l''imprimeur londonien William I Faden (à l''origine Mackfaden, 1711-1783). En apprentissage de juillet 1764 à août 1771. Travaille en association avec la famille du libraire et géographe du Roi Thomas Jefferys (m. 1771) jusqu''en 1776 env. Membre de la "Society of civil engineers". Beau-frère du peintre et astronome John Russell. Se retire en 1823 et cède son affaire à son ancien apprenti James Wyld. Décédé à Shepperton en mars 1836 [http://data.bnf.fr/ark:/12148/cb15615346f#foaf:Person]
{/ud}
{ud0}
Caroline Lucretia Herschel (Hanovre (Basse-Saxe,  Allemagne), 1750) Astronome. - Assistante de son frère, William Herschel (1738-1822), lui aussi astronome [http://data.bnf.fr/ark:/12148/cb16108822m#foaf:Person]
{/ud}
{ud0}
Gilbert Romme (1750) Mathématicien, astronome et géographe. - Député du Puy-de-Dôme à l''Assemblée législative puis à la Convention, représentant en mission près l''armée de Cherbourg, préconise l''essai du télégraphe aérien de Chiappe. - A participé à l''établissement du calendrier révolutionnaire [http://data.bnf.fr/ark:/12148/cb12536106q#foaf:Person]
{/ud}
{ud0}
Lorenzo Mascheroni (Bergame, Italie, 1750) Mathématicien et poète. - Professeur de physique et de mathématique au Séminaire de Bergame, puis d''algèbre et de géométrie à l''Université de Pavie, dont il sera recteur. - Député au Corps législatif de Milan (1799), admirateur de Napoléon, fait partie des 29 qui signent l''appel à régner en Italie au Premier Consul après 1799 [http://data.bnf.fr/ark:/12148/cb119149502#foaf:Person]
{/ud}
{ud0}
Nicolas-Maurice Chompré (Paris (France), 1750) Directeur, entre 1777 et 1786, de la Correspondance générale à la Division des mines et de l''agriculture du Contrôleur général des Finances Bertin. - Diplomate. - Auteur d''ouvrages de physique et de mathématiques [http://data.bnf.fr/ark:/12148/cb122074802#foaf:Person]
{/ud}
{ud0}
Scipione Breislak (Rome, 1750) Géologue. - Professeur de mathématiques à Raguse puis à Rome [http://data.bnf.fr/ark:/12148/cb151306996#foaf:Person]
{/ud}
{ud0}
Simon Lhuilier (1750) Mathématicien et philosophe. - Établi à Varsovie [http://data.bnf.fr/ark:/12148/cb13005974t#foaf:Person]
{/ud}
{ud0}
Alliette (1751) Cartomancien de la fin du 18e siècle. - Marchand d''estampes. - Professeur de mathématiques (vers 1753). - La forme "Etteilla" est l''anagramme d''Alliette [http://data.bnf.fr/ark:/12148/cb118885161#foaf:Person]
{/ud}
{ud0}
André-Charles Brotier (Paris, 1751) Abbé, mathématicien et homme politique. - Enseigna les mathématiques à l''Ecole militaire. - Collabora à l''"Année littéraire" et au "Journal de la France" [http://data.bnf.fr/ark:/12148/cb124621991#foaf:Person]
{/ud}
{ud0}
Antide Janvier (Lavans-lès-Saint-Claude (Jura), 1751) Horloger, astronome [http://data.bnf.fr/ark:/12148/cb12614643k#foaf:Person]
{/ud}
{ud0}
Bazaine (1751) Mathématicien [http://data.bnf.fr/ark:/12148/cb10735226f#foaf:Person]
{/ud}
{ud0}
Bernard Violle (1751) Mathématicien. - Géomètre. - Chevalier de Saint-Louis (1815) [http://data.bnf.fr/ark:/12148/cb13006994p#foaf:Person]
{/ud}
{ud0}
Bonaventure Abat (1751) Mathématicien et théologien, cordelier de l''Observance. - Fut membre associé de l''Académie royale des belles-lettres de Barcelone [http://data.bnf.fr/ark:/12148/cb134813469#foaf:Person]
{/ud}
{ud0}
G.-F. Olivier (1751) Bachelier ès sciences. - Professeur d''humanités et de mathématiques (en 1825). Professeur au collège de Troyes [http://data.bnf.fr/ark:/12148/cb10728006s#foaf:Person]
{/ud}
{ud0}
Guillelmus Beer (1751) Cartographe, géographe et peut-être astronome [http://data.bnf.fr/ark:/12148/cb15332855z#foaf:Person]
{/ud}
{ud0}
Hector-Jean Legros (1751) Adjoint-général pendant les guerres de Vendée et d''Italie. - Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb13484693c#foaf:Person]
{/ud}
{ud0}
Henri Jurain (1751) Abbé. - Professeur de mathématiques à Reims. - Correspondant de l''Académie des Sciences [http://data.bnf.fr/ark:/12148/cb12224993g#foaf:Person]
{/ud}
{ud0}
J.-B.-M. Duprat (1751) Libraire pour les mathématiques. - En activité de mars 1797 à 1803 au moins. Apparenté à Louis (-Alexis) Duprat-Duverger, en activité à partir de 1802, qui a pu se qualifier lui aussi de "libraire pour les mathématiques". Louis Courcier, "imprimeur et libraire pour les mathématiques", lui succède en 1803 à la même adresse (quai des Augustins, n° 71). Une "madame Duprat" est cependant répertoriée, à l''adresse du pont Saint-Michel, par le "Tableau des libraires" de Debray (Paris, janv. 1804) [http://data.bnf.fr/ark:/12148/cb16701987t#foaf:Person]
{/ud}
{ud0}
J.P. Audiffred (1751) Mathématicien [http://data.bnf.fr/ark:/12148/cb125867381#foaf:Person]
{/ud}
{ud0}
Jacques Baradelle (1751) Etabli dès 1740 quai de l''Horloge du Palais, il fabriquait des instruments de navigation, des cadrans solaires, des sphères astronomiques et géographiques [http://data.bnf.fr/ark:/12148/cb15281028g#foaf:Person]
{/ud}
{ud0}
James Dodson (1751) Mathématicien [http://data.bnf.fr/ark:/12148/cb153816258#foaf:Person]
{/ud}
{ud0}
Jean-Louis Gœury (1751) Libraire ; libraire pour les mathématiques et l''architecture ; libraire de l''École des Ponts et chaussées (1802) ; des ingénieurs et de l''École impériale des Ponts et chaussées (1805). - Semble avoir été commis du libraire parisien Charles-Antoine Jombert de 1770 à 1773 au moins. Père du médecin Jean-Louis Gœury-Duvivier, né le 2 mars 1803. En activité dès 1800. Breveté libraire le 1er oct. 1812 (brevet renouvelé le 11 sept. 1818). Décédé peu avant le 28 juin 1827, date à laquelle son fils Jean-Louis Gœury (dit plus tard Gœury-Duvivier) demande à succéder à son brevet [http://data.bnf.fr/ark:/12148/cb12230577c#foaf:Person]
{/ud}
{ud0}
Joseph Mouchet (1751) Professeur de rhétorique et de mathématiques, professeur de physique à l''université de Nantes de 1780 à 1784. - Aéronaute. - Membre de la Congrégation de l''Oratoire [http://data.bnf.fr/ark:/12148/cb16514291q#foaf:Person]
{/ud}
{ud0}
Joseph-Louis Vincens de Mauléon de Causans (Avignon, 1751) Mathématicien. - Colonel d''infanterie du régiment de Conti. - Chevalier de Malte [http://data.bnf.fr/ark:/12148/cb145658189#foaf:Person]
{/ud}
{ud0}
Le Professeur de mathématiques du Collège national de Toul (1751) Professeur de mathématiques du Collège national de Toul [http://data.bnf.fr/ark:/12148/cb125373980#foaf:Person]
{/ud}
{ud0}
Le Ratz de Lanthenée (1751) Gentilhomme liégeois. - Mathématicien et physicien [http://data.bnf.fr/ark:/12148/cb124022694#foaf:Person]
{/ud}
{ud0}
Louis Duprat-Duverger (1751) Variante(s) de prénom : Louis-Alexis. - Libraire pour les mathématiques ; également éditeur de cartes et d''atlas. - Apparenté au "libraire pour les mathématiques" J.-B.-M. Duprat, en activité à Paris entre 1797 et 1803. Établi dès 1802, d''abord en association sous la raison "L. Duprat, Letellier et compagnie" jusqu''en 1804, seul ensuite. Breveté libraire le 1er oct. 1812 ; brevet renouvelé le 15 mars 1817 ; duplicata délivré le 27 avril 1824. Encore en activité en 1829 [http://data.bnf.fr/ark:/12148/cb133399518#foaf:Person]
{/ud}
{ud0}
Madame Bailly (1751) Épouse de Jean-Sylvain Bailly, mathématicien, astronome et homme politique, guillotiné en 1793 [http://data.bnf.fr/ark:/12148/cb16541654h#foaf:Person]
{/ud}
{ud0}
Marie de La Fresnaye (Barfleur (Manche), 1751) Professeur de littérature et de mathématiques [http://data.bnf.fr/ark:/12148/cb100430283#foaf:Person]
{/ud}
{ud0}
Marie-Louise Cartan (1751) Femme d''Elie Cartan, mère du compositeur Jean Cartan et du mathématicien Henri Cartan. - Née Marie-Louise Bianconi [http://data.bnf.fr/ark:/12148/cb148511208#foaf:Person]
{/ud}
{ud0}
Mathurin-Georges Girault de Keroudou (1751) Abbé. - Mathématicien français. - Principal du collège de Quimper. - Professeur de philosophie et de mathématiques au collège de Navarre à Paris. - Professeur au collège de Louis-le-Grand à Paris [http://data.bnf.fr/ark:/12148/cb15085298t#foaf:Person]
{/ud}
{ud0}
Nicolas Leverdé (1751) Astrologue et mathématicien. - Auteur d''almanachs [http://data.bnf.fr/ark:/12148/cb10403809w#foaf:Person]
{/ud}
{ud0}
Olaf Söderberg (1751) Botaniste et mathématicien [http://data.bnf.fr/ark:/12148/cb12563978p#foaf:Person]
{/ud}
{ud0}
Théodore Bouys (1751) Mathématicien favorable à Necker et à la Révolution [http://data.bnf.fr/ark:/12148/cb12240772d#foaf:Person]
{/ud}
{ud0}
Trabaud (1751) Maître de mathématiques [http://data.bnf.fr/ark:/12148/cb134811442#foaf:Person]
{/ud}
{ud0}
Vérologue (1751) "Seul imprimeur d''Apollon pour la satyre en prose". - Pseud. auquel est adjoint le qualificatif "seul imprimeur d''Apollon pour la satyre en prose" et qui, sous la fausse adresse "Sur l''imprimé au Parnasse", dissimule une impression française (parisienne selon Weller et G. Brunet, plutôt provinciale d''après le matériel typographique) de "La Nouvelle Astronomie du Parnasse françois, ou l''Apothéose des écrivains vivans dans la présente année 1740", due au chevalier Jean-Florent-Joseph de Neufville de Brunaubois-Montador [http://data.bnf.fr/ark:/12148/cb165246377#foaf:Person]
{/ud}
{ud0}
Veuve de Louis Courcier (1751) Nom patronymique : Victoire-Félicité Lemaire. - Imprimeur-libraire ; imprimeur-libraire pour les mathématiques, la marine, les sciences et les arts. - Brevetée imprimeur en succession de son mari le 12 août 1811 (brevet renouvelé le 15 oct. 1816) et libraire le 1er oct. 1812 (brevet renouvelé le 15 mars 1817). Deux de ses  gendres lui succèdent : Démophile Huzard (-Courcier) en mars 1820 (brevet du 14 mars 1820) comme imprimeur, et Victor Bachelier le 10 nov. 1821 comme libraire [http://data.bnf.fr/ark:/12148/cb124778683#foaf:Person]
{/ud}
{ud0}
Adrien-Marie Legendre (1752) Mathématicien. - Président de l''Académie des sciences (1806). - A aussi écrit avec Charles-Etienne Coquebert de Montbret et François Gattey sous le pseudonyme collectif "C.-G.-L. Métrophile" [http://data.bnf.fr/ark:/12148/cb12443375d#foaf:Person]
{/ud}
{ud0}
Barnaba Oriani (Carignano, Italie, 1752) Astronome de l''Observatoire de Brera (1777-), puis de Milan. - A découvert qu''Uranus était une planète à partir de son orbite. - Mathématicien [http://data.bnf.fr/ark:/12148/cb12537845s#foaf:Person]
{/ud}
{ud0}
Jean-Baptiste Labey (La Chapelle-Hainfray (Calvados), aujourd''hui Valsemé (Calvados), 1752) Mathématicien. - Professeur à l''École militaire, à l''École centrale du Panthéon, à l''École polytechnique et au Lycée Napoléon de Paris [http://data.bnf.fr/ark:/12148/cb12112257t#foaf:Person]
{/ud}
{ud0}
Jean-Baptiste Pérès (Valence d''Agen (Tarn-et-Garonne), 1752) Oratorien. - Professeur de mathématiques et de physique  à Lyon, membre de la Société des amis de la Constitution de la ville durant la Révolution, puis substitut du procureur général près la cour royale d''Agen et bibliothécaire de cette ville [http://data.bnf.fr/ark:/12148/cb126307361#foaf:Person]
{/ud}
{ud0}
Marc-Auguste Pictet (Genève (Suisse), 1752) Naturaliste genevois, littérateur, chimiste, physicien et astronome. - Membre fondateur de la Société de physique et d''histoire naturelle de Genève, Suisse. - Correspondant de la Société royale de Londres [http://data.bnf.fr/ark:/12148/cb125386742#foaf:Person]
{/ud}
{ud0}
François Gattey (1753) Mathématicien. - Directeur du Bureau des poids et mesures (en 1795). - A aussi écrit avec Charles-Etienne Coquebert de Montbret et Adrien-Marie Legendre sous le pseudonyme collectif "C.-G.-L. Métrophile" [http://data.bnf.fr/ark:/12148/cb12447886d#foaf:Person]
{/ud}
{ud0}
Antoine de La Salle (1754) Philosophe. - Mathématicien [http://data.bnf.fr/ark:/12148/cb12173561c#foaf:Person]
{/ud}
{ud0}
Colin Mackenzie (Stornoway (Lewis, Western isles, Royaume-Uni), 1754) Mathématicien. - Fonctionnaire collonial en Inde (1815-1821). - Chargé du relevé cartographique de l''Inde et de la description de ses régions. - Collectionneur de divers documents (manuscrits, dessins aquarelles...) constituant le fonds d''études indianistes, collection dispersée aujourd''hui entre l''India office library, Londres et : Government oriental manuscripts library, Madras et Calcutta [http://data.bnf.fr/ark:/12148/cb14374770r#foaf:Person]
{/ud}
{ud0}
Franz Xaver von Zach (Bratislava, 1754) Astronome. - Directeur de l''Observatoire du Seeberg (près de Gotha), de 1787 à 1808. - Dirigea les "Allgemeinen geographischen Ephemeriden" (1796-) [http://data.bnf.fr/ark:/12148/cb121732757#foaf:Person]
{/ud}
{ud0}
Jean-Baptiste Meusnier de La Place (Tours (Indre-et-Loire), 1754) Mathématicien et Officier. - Elu à l''Académie des sciences en 1784 pour son étude locale des surfaces. - Prénoms complets : Jean-Baptiste Marie Charles [http://data.bnf.fr/ark:/12148/cb10732160m#foaf:Person]
{/ud}
{ud0}
Nicolas-François Canard (1754) Mathématicien et économiste [http://data.bnf.fr/ark:/12148/cb12519510c#foaf:Person]
{/ud}
{ud0}
Charles-Étienne Coquebert de Montbret (Paris, 1755) Diplomate, mathématicien et géographe. - Nommé responsable de l''organisation du nouveau système de poids et mesures (décret de 1793), professeur de géographie physique et gîtes de minerais à l''École des mines. - A aussi écrit avec François Gattey et Adrien-Marie Legendre sous le pseudonyme collectif "C.-G.-L. Métrophile". - Membre de l''Institut, membre libre de l''Académie des Sciences (en 1816) [http://data.bnf.fr/ark:/12148/cb12447869t#foaf:Person]
{/ud}
{ud0}
Claude Philippe Bertrand Bertrand (Autun (Saône-et-Loire), 1755) Géographe et astronome [http://data.bnf.fr/ark:/12148/cb16506861q#foaf:Person]
{/ud}
{ud0}
Emmanuel-Étienne Duvillard de Durand (Genève, 1755) Mathématicien, statisticien. - A développé la mathématisation de l''économie [http://data.bnf.fr/ark:/12148/cb129987837#foaf:Person]
{/ud}
{ud0}
Gaspard-Clair-François-Marie Riche de Prony (Chamelet (Rhône), 1755) Mathématicien et ingénieur. - Directeur de l''École des Ponts et Chaussées (1799-1830). - Membre de l''Académie des Sciences. - Baron à titre personnel (1828) [http://data.bnf.fr/ark:/12148/cb12535038t#foaf:Person]
{/ud}
{ud0}
Jean Anthelme Brillat-Savarin (Belley, Ain, 1755) Magistrat. - Député aux États Généraux (élu en 1789). - Gastronome [http://data.bnf.fr/ark:/12148/cb12305674c#foaf:Person]
{/ud}
{ud0}
Louis Courcier (1755) Imprimeur-libraire ; imprimeur-libraire pour les mathématiques (1801) ; imprimeur-libraire pour les mathématiques (, les sciences et les arts) (1804-1808). - Exerce l''imprimerie dès l''été 1790. Aurait été auparavant "marchand de peaux de lapin" d''après l''enquête des inspecteurs de la librairie de déc. 1810. Proche des Girondins, il émarge au budget du Bureau de l''Esprit public du ministre Jean-Marie Roland de La Platière en 1792. Dirige le "Courrier du Corps législatif et de la Guerre" (1797). Rachète le fonds du libraire J.-B.-M. Duprat et lui succède en 1803 ; rachète l''imprimerie de Jean-Georges-Antoine Stoupe après la mort de celui-ci (1808). Breveté imprimeur le 1er avril 1811. Dit âgé de 56 ans lors de son décès (30 juillet 1811). Sa veuve est brevetée en sa succession dès le 12 août 1811 [http://data.bnf.fr/ark:/12148/cb12421329b#foaf:Person]
{/ud}
{ud0}
Nicolas B. Halma (1755) Chanoine de Paris. - Astronome et mathématicien. - Professeur [http://data.bnf.fr/ark:/12148/cb11906753t#foaf:Person]
{/ud}
{ud0}
Nikolaus von Fuss (1755) Mathématicien, géomètre. - Né à Bâle, s''intalla à Saint-Pétersbourg en 1773 à la demande d''Euler. - Membre de l''Académie des sciences de Saint-Pétersbourg (1775-), secrétaire perpétuel (1800-). - Meurt à Saint-Pétersbourg le 23 décembre 1825 (style grégorien) [http://data.bnf.fr/ark:/12148/cb12359314p#foaf:Person]
{/ud}
{ud0}
Pierre Tédenat (1755) Docteur en mathématiques. - Recteur de l''académie Nîmes (1809-1818) et professeur de philosophie à la faculté des lettres de Nîmes [http://data.bnf.fr/ark:/12148/cb10379875d#foaf:Person]
{/ud}
{ud0}
Agricol-Joseph-François-Xavier-Pierre-Esprit-Simon-Paul-Antoine Fortia d''Urban (Avignon, 1756) Mathématicien et littérateur. - Chevalier de la Légion d''honneur en 1811, correspondant de l''Académie de Belgique en 1828 et membre libre de l''Académie des Inscriptions et belles-lettres en 1830 [http://data.bnf.fr/ark:/12148/cb121468483#foaf:Person]
{/ud}
{ud0}
Alexandre Ruelle (Blois, 1756) Astronome. - Professeur d''astronomie à l''Observatoire de Paris de 1783 à 1795 [http://data.bnf.fr/ark:/12148/cb121582720#foaf:Person]
{/ud}
{ud0}
Ernst Gottfried Fischer (1756) Physicien et mathématicien [http://data.bnf.fr/ark:/12148/cb124025182#foaf:Person]
{/ud}
{ud0}
Jan Chrzciciel Władysław Śniadecki (1756) Mathématicien et philosophe, un des plus grands savants polonais des Lumières [http://data.bnf.fr/ark:/12148/cb123726267#foaf:Person]
{/ud}
{ud0}
Joseph Mollet (Aix-en-Provence (Bouches-du-Rhône), 1756) Oratorien. - Professeur de physique et de mathématique, École Centrale, Lyon, Rhône. - Doyen de la Faculté des sciences de Lyon (1809-1815) [http://data.bnf.fr/ark:/12148/cb12196474k#foaf:Person]
{/ud}
{ud0}
Carl-Christian von Langsdorf (Nauheim (Allemagne), 1757) Mathématicien. - Ingénieur. - Professeur de mathématiques à Erlangen (Allemagne), de 1798 à 1804, puis à Vilnius (Lituanie) de 1804 à 1806. - Frère de Langsdorf, Johann-Wilhelm (1745-1827) [http://data.bnf.fr/ark:/12148/cb10661030m#foaf:Person]
{/ud}
{ud0}
Dominique Blanqui (1757) Professeur de philosophie et d''astronomie. - Député à la Convention. - Membre du Conseil des Cinq-cents [http://data.bnf.fr/ark:/12148/cb12534874n#foaf:Person]
{/ud}
{ud0}
Alexandre-Balthazar-Laurent Grimod de La Reynière (Paris, 1758) Avocat. - Pamphlétaire. - Gastronome, fondateur et président du "Jury dégustateur" [http://data.bnf.fr/ark:/12148/cb11905936j#foaf:Person]
{/ud}
{ud0}
Johann Christoph Schuster (1759) Mathématicien [http://data.bnf.fr/ark:/12148/cb16505504t#foaf:Person]
{/ud}
{ud0}
Louis-François-Antoine Arbogast (Mutzig, Alsace, 1759) Mathématicien. - Directeur du Collège royal (en 1791). - Député à l''Assemblée législative puis à la Convention nationale [http://data.bnf.fr/ark:/12148/cb12520232w#foaf:Person]
{/ud}
{ud0}
Pierre-René-Auguste Bremond d''Ars (1759) Député de la noblesse. - Fut professeur de mathématiques et de latin [http://data.bnf.fr/ark:/12148/cb12540611f#foaf:Person]
{/ud}
{ud0}
Thomas Keith (Winestead (GB), 1759) Mathématicien. - Professeur [http://data.bnf.fr/ark:/12148/cb10275963j#foaf:Person]
{/ud}
{ud0}
Giovanni Paradisi (Reggio Emilia, Italie, 1760) Comte. - Homme politique. - Mathématicien. - Poète [http://data.bnf.fr/ark:/12148/cb105910991#foaf:Person]
{/ud}
{ud0}
Nicolas Antoine Guillard (Sorbais, Aisne, 1760) Professeur de mathématiques [http://data.bnf.fr/ark:/12148/cb10617134p#foaf:Person]
{/ud}', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1087, 'Philosophe, astronome et théologien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10442558v#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10442558v#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1631, 'Personne qui imprime et vend des livres', NULL, '2015-11-13 17:45:46.72275+01', NULL, NULL, NULL, NULL, NULL, NULL, 4, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1632, 'Propriétaire, directeur d''une imprimerie', NULL, '2015-11-13 17:58:26.832029+01', NULL, NULL, NULL, NULL, NULL, NULL, 4, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1026, 'Mathématicien et théologien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15994181b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15994181b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1633, 'Concepteur et constructeur de machines de guerre, de fortifications, etc.', NULL, '2015-11-13 18:00:15.934578+01', NULL, NULL, NULL, NULL, NULL, NULL, 4, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1261, 'Mathématicien allemand', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb124384045#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb124384045#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1634, 'Personne dont le domaine de recherche ou d''activité est la chimie', NULL, '2015-11-13 18:02:31.108708+01', NULL, NULL, NULL, NULL, NULL, NULL, 4, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1501, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb162655930#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb162655930#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1635, 'Personne qui exerce l''art de l''architecture', NULL, '2015-11-13 18:09:46.344278+01', NULL, NULL, NULL, NULL, NULL, NULL, 4, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1636, 'Spécialiste qui dresse les cartes', NULL, '2015-11-13 18:12:35.512831+01', NULL, NULL, NULL, NULL, NULL, NULL, 4, NULL, NULL, NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (946, 'Jésuite, quitte la Compagnie en 1681 pour entrer chez les Bénédictins. - Professeur de rhétorique, philosophie et mathématiques. - Poète', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11999230c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11999230c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1612, 'Mathématicien. - Chanoine de la Cathédrale de Liège et abbé d''Amay', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12427294z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12427294z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1366, 'Florentin. - Mathématicien. - Membre de l'' "accademia della Crusca"', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12000373g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12000373g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1322, 'Magistrat et astronome amateur allemand', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11973603q#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11973603q#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1587, 'Jésuite, missionnaire en Chine. - Astronome. - Fut placé à la tête du tribunal des mathématiques, chargé de la rédaction des éphémérides et de la direction des fonderies de canons. - A publié en langue chinoise, sous le nom de Nanhoai-jin, un grand nombre d''ouvrages scientifiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12215344n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12215344n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (960, 'Astrologue et mathématicien. - Auteur d''almanachs', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10403809w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10403809w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1560, 'Philosophe, astronome, astrologue, mathématicien et traducteur d''ouvrages scientifiques et de la littérature. - Il vint très jeune en 1135 en France à Paris et à Chartres. - Eut pour maître Thierry de Chartres. - L''abbé de Cluny, Pierre le Vénérable, poussa Herman à traduire à écrire sur la vie et l''oeuvre de Mahomet', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12364029w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12364029w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (924, 'Mathématicien. - Astronome. - Fils de Maheśvara. - Auteur de :  "Siddhāntaśiromanī" (en 1150) ; "Karṇakutūhala"', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14498624v#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14498624v#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (852, 'Mathématicien. - Originaire de Ṭūs, Hamad̲ān, Mosul, Alep, Damas. - Écrivait vers 1209', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb120864072#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb120864072#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1144, 'Mathématicien. - Chanoine prémontré de Holywood (comté de Dumfries, Écosse). - Professeur à l''Université de Paris. - Semble être né à Halifax (Yorkshire, Angleterre). - Mort en 1256 ou 1244', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121284153#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121284153#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1214, 'Franciscain. - Grammairien, mathématicien et poète. - Chanoine de la cathédrale Saint-André d''Avranches', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12536245w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12536245w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1361, 'Mathématicien. - Surnommé Leonardo Pisano', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13092437c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13092437c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1122, 'Provincial des franciscains d''Angleterre. - Archevêque de Cantorbéry (à partir de 1279). - Théologien, mathématicien et physicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12459837w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12459837w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (987, 'Philosophe et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12054316n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12054316n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (846, 'Astronome, médecin, philosophe et théologien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12086388m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12086388m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1369, 'Astronome. - Médecin. - Chancellier de la faculté de médecine de Montpellier', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb165406517#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb165406517#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1110, 'Clerc régulier, théatin. - Architecte du duc de Savoie, philosophe et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12348027r#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12348027r#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1337, 'Théologien. - Professeur de mathématiques et de théologie', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13014027s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13014027s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1268, 'Philosophe. - Professeur de mathématiques, maître de Leibniz et de Pufendorf', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11935908x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11935908x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1130, 'Titulaire de la chaire d''astronomie de Bologne de 1650 à 1669, surintendant des eaux du Bolonais de 1657 à 1669, surintendant des eaux de l''Etat pontifical et titulaire d''autres charges auprès du pape. - Appelé en France an avril 1669 par Louis XIV. - Membre de l''Académie des sciences, directeur de l''Observatoire de Paris (à partir de 1672). - Naturalisé français en 1673', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121019904#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121019904#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1009, 'Homme d''état et mathématicien. - Grand pensionnaire de Hollande', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13598046j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13598046j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1055, 'Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12875545t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12875545t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1370, 'Physicien. - Mathématicien. - Médecin. - Professeur de mathématiques et de médecine à Copenhague. - A découvert la difraction de la lumière. - Fils de Kaspar Bartholin', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11890430k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11890430k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1280, 'Mathématicien et inventeur', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10365749d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10365749d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1289, 'Mathématicien. - Professeur de mécanique (1650-1678) puis titulaire de la chaire de mathématiques et d''astronomie (1678-1686) à l''université de Bologne', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb120851477#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb120851477#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1096, 'Professeur de mathématiques et de lettres. - Naturaliste. - Botaniste. - Membre de la Société royale de Londres', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12220184b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12220184b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1377, 'Jésuite, géographe et professeur de mathématiques à Munich', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15317471w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15317471w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (869, 'Mathématicien, élève de Frans Van Schooten. - Bourgmestre de la ville d''Amsterdam', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13488288n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13488288n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (938, 'Mathématicien et astronome. - A vécu aux Pays-Bas et en France. - Élu membre de la "Royal society" de Londres (en 1663)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12192922r#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12192922r#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1059, 'Ingénieur et cartographe. - Maître de mathématiques des pages du roi de France, sergent-major d''artillerie du roi de Portugal', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb153363577#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb153363577#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1124, 'Mathématicien et théologien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12340135q#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12340135q#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1544, 'Astronome à l''Observatoire de Paris, il figure parmi les premiers membres de l''Académie des sciences (1666). - Chargé d''une mission géodésique à Cayenne (1672-73)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14064426q#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14064426q#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (941, 'Mathématicien polonais, auteur de la rectification approchée de la circonférence. Réside en 1677 à Wroclaw', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16187484g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16187484g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1093, 'Jésuite. - Mathématicien, naturaliste. - Pionnier de l''aéronautique', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10681783j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10681783j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1545, 'Architecte. - Mathématicien et astronome, Sir Christopher Wren fut l''un des membres fondateurs de la Société royale des sciences', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121401670#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121401670#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (933, 'Poète naturaliste, l''un des principaux animateurs du courant naturaliste toscan de la seconde moitié du XVIIe siècle. - Professeur de philosophie puis de mathématiques à l''Université de Pise', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12570345j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12570345j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1475, 'Mathématicien. - Professeur de philosophie au "Studio" de Pise', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb144820894#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb144820894#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1108, 'Docteur en droit, mathématicien et astronome. - Enseigne à Florence, Modène (1661-1664), Bologne (chaire de mathématiques, 1664-1677) et Padoue (chaire d''astronomie, 1678-1687). - Membre de l''Accademia dei Gelati ("l''Elevato") et de l''Accademia della Treccia de Bologne', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12309300z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12309300z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1274, 'Théologien luthérien. - Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12133744h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12133744h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1217, 'Historien, archéologue, mathématicien. - Membre de la Curie pontificale', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14323561z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14323561z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1559, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15520924m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15520924m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1556, 'Philosophe, mathématicien et physicien. - Professeur à l''université d''Altdorf', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb133240234#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb133240234#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (939, 'Mathématicien. - Jésuite. - Il a enseigné la philosophie puis les mathématiques au collège Louis-Le-Grand', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12174258w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12174258w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1053, 'Philosophe, écrivain, mathématicien, astrologue et traducteur croate', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16243624j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16243624j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (833, 'Mathématicien, physicien, écrivain. - Frère de : Pascal, Jacqueline (1625-1661)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11918679x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11918679x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1371, 'Mathématicien. - Professeur de mathématiques à Paris et à Lyon', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb120960958#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb120960958#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1041, 'Graveur. - Ingénieur et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15053499m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15053499m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1000, 'Mathématicien strasbourgeois', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15377331m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15377331m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1143, 'Mathématicien et financier', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb118903320#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb118903320#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1338, 'Peintre d''histoire, portraitiste, graveur, mathématicien et astronome. - Fils et élève du peintre Georg-Christoph Eimmart (1603-1658), dit le vieux', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12983761h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12983761h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1406, 'Mathématicien et opticien écossais', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12459917j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12459917j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1097, 'Professeur ordinaire de mathématiques à l''École illustre de Deventer (1699-1727 ; professeur extraordinaire dès 1690). - Vécut en France de 1658 environ à 1664, puis aux Pays-Bas', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11927303t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11927303t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1581, 'Est admis à la Société de Jésus en 1654. - Dans les années 1670 jusqu''en 1683, il enseigne les mathématiques et la théologie aux collèges jésuites de Grenoble, puis d''Avignon. - De 1680 à 1682, enseigne la géométrie et l''hydrographie. - Effectue des travaux astronomiques. - Devient membre correspondant de l''Académie royale des sciences (en 1699)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15130186g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15130186g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1052, 'Mathématicien. - Géomètre et astronome. - Professeur de mathématiques au Collège de France. - Membre de l''Académie des sciences (1678)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121592847#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121592847#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1290, 'Jésuite. - Enseigna les humanités, les mathématiques et la philosophie. - Né à Rouen, mort à La Flèche', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12512101m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12512101m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1010, 'Physicien. - Un des précurseurs de l''invention de la machine à vapeur, qui eu l''idée du piston (dés 1690), et inspira la machine que l''Anglais Thomas Newcomen (1664-1729), mis au point ensuite (en 1712). - Quitta définitivement la France, après la révocation de l''Édit de Nantes (1685). - Occupa une chaire de mathématiques à l''Université de Marburg, Allemagne (1687). - Rédige un article (Ars nova ad aquam ignis...) présentant sa machine dans la revue " Acta Eruditorum", Leipzig (en 1707), revue célèbre pour les publications de Leibniz (1646-1716), sur le calcul différentiel et intégral', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12087889k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12087889k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1502, 'Physicien, mathématicien et astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb119176085#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb119176085#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1538, 'Variante(s) de prénom : Johannes ; Jean. - Imprimeur-libraire. - Fils et apprenti d''Eberhard Welper, imprimeur-libraire et mathématicien à Strasbourg. A été compagnon pendant 6 ans à Ulm, Augsbourg, Munich, Vienne, Leipzig et Nuremberg, avant de succéder à son père. L''enquête de 1700-1701 le dit âgé de 60 ans et "établi à Strasbourg depuis 42 ans". À sa mort, son entreprise est rachetée par Melchior Pauschinger', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb160636269#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb160636269#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (928, 'Jésuite. - Enseigna la rhétorique et les mathématiques à l''Université de Toulouse', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb124637183#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb124637183#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1445, 'Libraire. - Fils d''un fruitier et marchand de vins parisien. En apprentissage chez le libraire parisien Pierre II Baudouin à partir de janv. 1666, il travaille en 1670-1671 chez Louis Billaine et Pierre Le Petit, puis chez la veuve de Pierre I Baudouin à partir de 1672. Gendre en 1res noces (1671) du libraire Jean d''Houry. Publie sous son propre nom dès 1680, peut-être dès 1678, mais n''est reçu maître que le 17 sept. 1686. Publie de nombreux ouvrages de mathématiques. Dit âgé d''env. 60 ans lors de l''enquête de nov.-déc. 1701. Testaments le 9 août 1704 et le 6 oct. 1705. Décédé au début de nov. 1705. Sa veuve lui succède', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15074749j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15074749j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (893, 'Jésuite (à partir de 1660). - Mathématicien et astronome de l''empereur de Chine', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10636254r#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10636254r#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (975, 'Théologien, mathématicien et astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10721479d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10721479d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1401, 'Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12324191r#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12324191r#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (854, 'Astronome, mathématicien, poète, historien. - Sa bibliothèque, comprenant des documents uniques sur l''histoire du Mexique, disparut dans un incendie lors de l''insurrection de 1692', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121021638#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121021638#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1321, 'Mathématicien et géographe de formation. - Jésuite, arrive au Mexique en 1681', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb122190783#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb122190783#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1613, 'Cartographe, mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15376579x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15376579x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1032, 'Alchimiste, astronome, mathématicien. - Philosophe hermétique. - Membre de la Rose-croix d''Or. - Serait d''origine allemande ou italienne', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb150904929#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb150904929#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (848, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15944052f#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15944052f#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (882, 'Jésuite. - Professeur de réthorique, de mathématiques, philosophie et contreverse. - Recteur et chancelier de l''Université de Dillingen, Allemagne', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb158132748#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb158132748#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1042, 'Philosophe et mathématicienne. - Première femme docteur en philosophie', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16591183r#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16591183r#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1615, 'Mathématicien, physicien et occultiste. - Vécut à Paris à partir de 1668', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb118973978#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb118973978#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1446, 'Professeur universitaire de mathématiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16032560b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16032560b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (841, 'Astronome. - Fut le premier directeur de l''Observatoire de Greenwich, GB, fondé en 1675', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13524243n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13524243n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (927, 'Astronome britannique. Fut le premier directeur de l''observatoire de Greenwich, fondé en 1675', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13510391m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13510391m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1172, 'Jésuite. - Historien et poète. - Professeur de mathématiques et d''hébreu au Collège des Jésuites de Naples. - Né à Naples, meurt à Massa', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb133256727#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb133256727#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1079, 'Jésuite. - Philosophe, astronome, physicien et poète. - Membre de l''Académie de l''Arcadie sous le pseudonyme : Callimaco Neridio', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13321850h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13321850h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1589, 'Traducteur de traités scientifiques et de mathématiques. - Sa période d''activité se situe aux alentours de 1145', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12223624k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12223624k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1603, 'Exégète biblique, mathématicien, astronome, philosophe, physicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12131941j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12131941j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1590, 'Philosophe averroïste et astronome. - A enseigné la philosophie à Bologne vers 1320', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10103512f#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10103512f#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1604, 'Médecin, astronome, mathématicien et philosophe. - Né à Bagnuolo (Royaume de Naples), mort vers 1500', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12537367q#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12537367q#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1608, 'Dominicain. - Mathématicien et astrologue', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb107034397#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb107034397#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1618, 'Géographe et mathématicien à Venise, fabriquant d''un globe avec son frère Giulio en 1561', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb153816227#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb153816227#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1588, 'Philosophe et médecin. - Lecteur de mathématiques au Collège de France. - Médecin du roi', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121323921#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121323921#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1601, 'Mathématicien et médecin. - Régent de la Faculté de médecine de Paris, puis professeur de mathématiques au Collège de France (1574-). - Né à Reims, meurt à Paris', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13006651k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13006651k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1596, 'Mathématicien, philosophe et humaniste. - Titulaire de la chaire de mathématiques au Collège de France (1575-), orateur des rois de France à Rome (1586-), intendant de la Bibliothèque vaticane', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13495175h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13495175h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1378, 'Elève de l''abbé Galloys. Associé géomètre à l''Académie des sciences en 1707. Pensionnaire mécanicien en 1725. Professeur de mathématiques au Collège de France. Maître de mathématiques du roi et des pages de la Petite Ecurie. Présenta en 1707 à l''Académie une méthode de collecte des informations cartographiques sur des châssis concentriques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb153045899#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb153045899#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1419, 'Jésuite (à partir de 1670) ordonné prêtre en 1682. - Missionnaire en Chine, il fut envoyé à Rome à l''occasion de la querelle des rites, et ne put rentrer en Chinê. - Il enseigna ensuite à Prague. - Auteur de poésies et de théâtre, d''un traité d''astronomie, de traductions et d''un ouvrage catéchétique en chinois', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16653645d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16653645d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1088, 'Mathématicien. - Membre de l''Académie royale des sciences', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14618149h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14618149h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1107, 'Professeur de mathématiques. - Auteur de mazarinades. - Actif de 1648 à 1652', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12166762s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12166762s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1013, 'Mathématicien et alchimiste lyonnais. - Avocat au parlement', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12158814g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12158814g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (894, 'Ingénieur et mathématicien originaire d''Écosse et établi en France. - Auteur notamment de plusieurs propositions de loteries et d''une "Nouvelle Manière d''exécuter les loteries..." (Paris, 1705). - Se qualifie d''"esquire, seigneur de Glaideny et de la baronnie de Baltillée en Ecosse"', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15818830h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15818830h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1282, 'Éditeur d''estampes et de cartes géographiques. - Ingénieur pour les instruments de mathématiques et fabricant de cartes et de globes ; éditeur occasionnel', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb153164066#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb153164066#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1319, 'Astronome et physicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12397878n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12397878n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1258, 'Cartographe, médecin et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15377993t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15377993t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1417, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16505504t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16505504t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1508, 'Mathématicien. - Professeur de mathématiques à l''Université de Wittenberg', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16672375p#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16672375p#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1132, 'Professeur de mathématiques (1692). - Réside rue de Seine à Paris en 1692', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16650697x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16650697x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (874, 'Hydrographe, Ingénieur du roi et professeur de Mathématiques, Architecte', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15375819n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15375819n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1385, 'Cartographe, fabricant et éditeur de globes, de cartes, d''instruments de mathématiques, actif de 1666 à 1700 à Londres', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15328427v#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15328427v#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1048, 'Mathématicien angevin. - Spécialiste de la perspective', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12536157m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12536157m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1390, 'Géographe et cartographe. Connaissances mathématiques étendues (il publie un traîté d''arithmétique et de géométrie). En 1695 il entre au service de Guillaume III qui lui accorde le brevet de Capitaine Ingénieur au service d''Angleterre et des Etats généraux', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15304894q#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15304894q#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1292, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb130110121#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb130110121#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1192, 'Ingénieur du roi pour les instruments de mathématique. - Avait un atelier à Paris, quai de l''Horloge, qui était l''un des mieux achalandés du temps. - Son "Usage des globes" connut 6 éditions entre 1699 et 1751. - Édita en 1694 le globe terrestre de P. Courtin (diam. 25 cm) et en 1712 une paire de globes de même diamètre, un globe céleste antérieur à 1710 atteignit 32 cm de diamètre', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb152909089#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb152909089#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1304, 'Cartographe et mathématicien de Valence en Espagne', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15330290b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15330290b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1520, 'Philosophe, médecin et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14587835s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14587835s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1426, 'Mathématicien et astronome. - Professeur de mathématiques à l''université de Bâle, Suisse', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb120751142#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb120751142#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1578, 'Peintre, mathématicien et facteur de globes, géographe du Duc d''Orléans à partir de 1714', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15147433m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15147433m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1089, 'Jésuite. - Mathématicien, fut envoyé en Chine par Louis XIV en 1685. - Écrivit des traités de géométrie et de l''usage de l''astrolabe en chinois et en tartare. - Supérieur général de la Mission française de Chine', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb124622770#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb124622770#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (974, 'Missionnaire. - Voyageur, jésuite dès 1670, il enseigna les mathématiques à Louis-le-Grand. - Chercha un nouveau passage vers la Chine par la Tartarie, le Kurdistan et l''Arménie', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15327596q#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15327596q#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1083, 'Théologien et mathématicien. - Se réfugia en Prusse après la révocation de l''Édit de Nantes', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10366497p#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10366497p#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1045, 'Mathématicien. - Jésuite. - Membre de l''Académie des sciences, il entre au collège de France en 1704', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121123302#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121123302#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1024, 'Jésuite. - Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12151496v#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12151496v#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1462, 'Jésuite. - Mathématicien. - Missionnaire en Chine. - Évèque titulaire de de Claudiopolis-en-Isaurie (à partir de 1708/1709). - Vicaire apostolique du Koueitchéou et du Yunnan, et administrateu du Houkouang (de 1708 à 1709)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb150791582#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb150791582#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (842, 'Physicien, micrographe et médecin. - Apporta des perfectionnements importants à la fabrication des verres de lunettes astronomiques, découvrit les animalcules spermatiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13010358x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13010358x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1521, 'Mathématicien, astronome, physicien et philosophe. - Premier secrétaire de la Société philosophique de Dublin (en 1684)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb124596616#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb124596616#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1049, 'Cartographe, géographe et astronome associé à l''Académie des sciences', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb106281104#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb106281104#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1296, 'Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb119960783#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb119960783#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1018, 'Fit ses études chez les jésuites et devint l''auxiliaire de Cassini I. Fut associé aux travaux géodésiques menés par l''Académie des sciences. Dessina le planisphère de l''Observatoire. Collabora au Neptune françois. Associé astronome de l''Académie des sciences en 1695; associé mécanicien en 1699. Professeur d''hydrographie à Marseille', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15304334g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15304334g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1021, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10330722j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10330722j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (966, 'Astronome. - Auteur d''éphémérides', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12223720g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12223720g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1221, 'Économiste. - Philanthrope. - Fondateur du "Journal de Lyon". - Rédacteur de "L''Almanach musical" (1775-1778), et au "Journal de musique", Paris (1764-1768). - Fils de : Mathon de La Cour, Jacques (1712-1770), mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121925904#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121925904#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1466, 'Astronome et botaniste. - Religieux de l''ordre des Minimes. - Initié à la botanique par le P. Plumier. Correspondant astronome de l''Académie des sciences, il obtient une mission dans le Levant. Revenu à Marseille en 1702, il embarque l''année suivante pour les Antilles et parvient à Carthagène en 1704. Nommé mathématicien du roi, il s''embarque pour l''Amérique du Sud en 1707. En 1724, il est chargé de déterminer la position exacte de l''île de Fer', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15309142r#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15309142r#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (979, 'Mathématicien. - Professeur', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14548143w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14548143w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1380, 'Marquis de Sainte-Mesme. - Mathématicien, membre de l''Académie des sciences', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12000655c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12000655c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1363, 'Théologien, historien, astronome et physicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12452255g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12452255g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (878, 'Philosophe et mathématicien italien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121118306#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121118306#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1029, 'Professeur de philosophie et mathématiques à Lausanne et Groningue. - Conseiller de la légation de Suède en Hollande. - Membre des Académies de Bordeaux et Paris', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12016566d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12016566d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1309, 'Mathématicien et architecte allemand', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb137778333#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb137778333#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1165, 'Mathématicien et théologien écossais', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb114408210#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb114408210#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1260, 'Mathématicien japonais', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12443517s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12443517s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1486, 'Mathématicien, astronome, médecin, musicien. - Mathématicien et musicien de l''électeur de Trèves (1685-1688). - Lecteur en astronomie à l''université de Leyde. - Professeur de mathématiques au Carolinum de Kassel', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14853628w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14853628w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1287, 'Mathématicien. - Émigra en Grande-Bretagne après la révocation de l''Édit de Nantes (en 1686). - Membre de la Royal Society, de l''Académie de Berlin et de l''Académie de Saint-Pétersbourg', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb130110001#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb130110001#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1250, 'Jésuite. - Professeur de mathématiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13164455b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13164455b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1610, 'Mathématicien et physicien, maître d''Euler, professeur à l''Université de Groningue puis à l''Université de Bâle. - A travaillé sur le calcul différentiel, intégral et exponentiel. - Également auteur de traités de médecine, fondateur de la théorie mécanico-physique de la fermentation', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb122991692#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb122991692#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1099, 'Théologien et astronome. - Professeur de mathématiques à Cambridge, d''où il fut exclu pour ses écrits théologiques. - Traducteur de Flavius Josèphe', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11997914k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11997914k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1600, 'Augustin. - Missionnaire en Chine. - Orientaliste, astronome et cartographe', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13613529n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13613529n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (955, 'Mathématicien. - Architecte', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb143383238#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb143383238#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1408, 'Oratorien, mathématicien et philosophe. - Professeur de grec et latin au Collège de France. - Membre de l''Institut, Académie Française (élu en 1732)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb119262217#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb119262217#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1056, 'Mathématicien, théologien, biographe, antiquaire et poète. - Soutint Descartes contre l''aristotélisme. - Professeur de philosophie à l''Université de Pise. - Fut en correspondance avec Leibniz, Newton, Bernoulli. - Intendant général des eaux en Toscane', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121384290#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121384290#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1297, 'Fils d''un riche négociant qui s''occupait de physique, et destiné d''abord à l''étude du droit, il la quitta pour celle des mathématiques et voyagea jusqu''en 1702. Professeur à Nuremberg et membre de la Royal Society de Londres', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15327296w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15327296w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1116, 'Mathématicien. - Membre de la Royal Society de Londres (1713)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12158680q#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12158680q#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1527, 'Physicien, astronome, mathématicien. - Professeur à l''université d''Altdorf (Allemagne)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10706008k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10706008k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (940, 'Mathématicien écossais. - Professeur d''astronomie à Oxford', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb123670586#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb123670586#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (950, 'Astronome et moraliste. - Chanoine de Sainte Croix de La Bretonnerie. - Membre de l''Académie des sciences', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12004341t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12004341t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (879, 'Médecin, naturaliste, historien, archéologue, numismate, astronome et physicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb123955592#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb123955592#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (898, 'Jésuite. - Né à Reims. Entre au noviciat le 24 août 1692. Enseigne les humanités à Reims, la rhétorique à Metz et les mathématiques à Reims. - Écrit du théâtre pour le Collège de Reims', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13165624v#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13165624v#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (858, 'Astronome et mécanicien français. - Adresse en 1784 : Paris, rue du Sentier, hôtel de madame la présidente de Meslay, n° 31', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15585605z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15585605z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1011, 'Cartographe. - Fils de Claude Delisle, fut l''élève de Jean-Dominique Cassini. Élève astronome à l''Académie des sciences en 1702, il en devint membre en 1718 ; enseigna la géographie au jeune Louis XV et fut nommé premier géographe du roi ; produisit quelque 100 cartes qu''il édita lui-même', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15238363g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15238363g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1277, 'Jésuite. - Professeur de mathématiques à Caen', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12180932c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12180932c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1569, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb120689750#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb120689750#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1487, 'Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb106522995#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb106522995#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1243, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12387058m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12387058m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1546, 'Fils de Jean-Dominique Cassini et père de César-François Cassini de Thury. Associé astronome à l''Académie des sciences en 1699, pensionnaire en 1712. En 1700 participa à la mesure de la méridienne de l''Observatoire et y travailla jusqu''à son achèvement en 1718. En 1706 maître ordinaire à la Chambre des comptes. Etudia les planètes et leurs satellites. Soutint la thèse de l''allongement de la Terre aux pôles.', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15238366h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15238366h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1512, 'Physicien et mathématicien. - Oratorien (vers 1709). - Professeur au collège royal (1723). - Adjoint (1721) puis associé (1729) de l''Académie royale des sciences', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb145391041#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb145391041#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (838, 'Graveur, cartographe, mathématicien et éditeur. - Fils de Johannes van Keulen', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15332761m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15332761m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1422, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12319998c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12319998c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (875, 'Physicien et mathématicien. - Membre puis secrétaire perpétuel de l''Académie des sciences. - Membre de l''Académie française (élu en 1743)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12395086k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12395086k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1472, 'Professeur de philosophie et de mathématiques à Neuchâtel. - Est l''un des fondateurs de la "Bibliothèque italique" (1728-) et du "Mercure suisse" (1732-). - Naturalisé Neuchâtelois en 1710', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12797692b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12797692b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1329, 'Mathématicien. - Spécialiste de probabilités', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12391046c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12391046c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1209, 'Médecin. - Mathématicien. - Hydraulicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13545066d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13545066d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (932, 'Juriste, mathématicien et philosophe', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121387859#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121387859#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1138, 'Mathématicien, philosophe et bibliothécaire. - Fut bibliothécaire à la Bibliothèque de Genève. - Vécut à Genève après la révocation de l''Édit de Nantes', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121711117#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121711117#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1068, 'Abbé. - Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12532604f#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12532604f#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1253, 'Astronome et missionnaire jésuite en Chine', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15367486z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15367486z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1023, 'Professeur d''éloquence à l''Université de Rome. - Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb104300443#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb104300443#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1407, 'Mathématicien. - Professeur d''astronomie et de philosophie expérimentale au Trinity College, Cambridge (1707-). - A édité la seconde édition des "Principia" de Newton', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb123946202#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb123946202#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1206, 'Jésuite. - Professeur de mathématiques et physique au collège de Paris', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12218681d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12218681d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1225, 'Géographe et cartographe ; historien. - Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13007561v#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13007561v#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (863, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12315365s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12315365s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1227, 'Physicien, mathématicien et archéologue', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12161210z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12161210z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1444, 'Professeur de mathématiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb120827146#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb120827146#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1251, 'Mahārāja de Jaipur (Rajasthan, Inde) de 1699 à 1743. - Fondateur de la ville de Jaipur (en 1727). - Chef du clan rajput des Kachhwa. - Bâtisseur de cinq observatoires astronomiques (yantra) dans l''Inde du Nord, à Delhi, Jaipur, Mathura, Varanasi et Ujjain. - Publia des tables astronomiques. - Les dates biographiques (1688-1743) sont aussi parfois retenues', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16578505b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16578505b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1034, 'Mathématicien et juriste suisse', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13510346s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13510346s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1503, 'Mathématicien. - A été professeur à l''Université de Glasgow, GB', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12399224j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12399224j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1199, 'Mathématicien, physicien et agronome. - Prêtre-bénéficier du chapitre de Villeneuve-lès-Avignon (à partir de 1736, environ). - Correspondant de l''Académie royale des sciences de Paris', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb130919156#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb130919156#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (884, 'Astronome. - Il reçut l''enseignement de Cassini II. - Professeur de mathématiques au Collège de France et géographe de la marine. - Membre de l''Institut, Académie des sciences (1714). - Fondateur de l''École d''astronomie de Saint-Pétersbourg (à partir de 1725), a séjourné en Russie jusqu''en 1747', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12150746w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12150746w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1228, 'Jésuite (1703). - Philosophe et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12462543h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12462543h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1198, 'Jésuite en 1704. - Professeur de rhétorique à Caen, précepteur du prince de Talmont, professeur de mathématiques au collège de Louis-le-Grand à Paris. - Collabore au Journal de Trévoux de 1722 à 1739. - Littérateur', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12069382v#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12069382v#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (829, 'Physicien. - Philosophe. - Professeur de mathématique et astronomie à Leyde, Pays-Bas. - Éditeur du "Journal littéraire de la Haye", devenu "Journal de la République des Lettres"', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12218384m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12218384m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (972, 'Jésuite et missionnaire en Chine. - Établit un observatoire à Pékin, dans la résidence française. - Écrit sur l''astronomie, la géographie, l''histoire et la littérature de la Chine', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12150997b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12150997b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1479, 'Savant prélat. - A étudié les langues et la littérature de l''Antiquité, les mathématiques, la philosophie et la théologie. - Membre de l''Académie della Crusca. - Conservateur de la bibliothèque du Vatican', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12516784r#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12516784r#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1195, 'Professeur de mathématiques et de philosophie naturelle à Cambridge', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15075770m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15075770m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1592, 'Mathématicien. - Auteur d''un "Art poétique"', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12509709h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12509709h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1433, 'Écrivain, mathématicien et astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb151541516#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb151541516#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1117, 'Jésuite. - Astronome et mathématicien. - Professeur d''hydrographie à Marseille et directeur de l''Observatoire de Marseille (1749)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12120600p#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12120600p#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (913, 'Physicien, docteur en médecine et en philosophie. - Fut l''inventeur de la pyrométrie. - Fut professeur de philosophie naturelle, de mathématiques et d''astronomie à l''Université d''Utrecht, puis professeur à Leiden', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13475113j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13475113j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1558, 'Prêtre catholique. - Homme de lettres. - Professeur de mathématiques à l''université de Salamanque', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb119268467#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb119268467#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (916, 'Médecin. - Professeur d''anatomie à l''Université de Sienne (1741-). - Auteur d''ouvrages médicaux, archéologiques, astronomiques, etc.', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10649342z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10649342z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1226, 'Astronome allemand. - Il succéda à son père Gottfried (1639-1710) dans la direction de l''Observatoire royal de Prusse (1716-1740). - Membre de l''Académie des sciences de Berlin (1716) et associé de celles de Paris (1723) et de Saint-Pétersbourg', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12648455m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12648455m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (880, 'Mathématicien. - Philosophe. - Professeur au collège de Beauvais', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb119220838#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb119220838#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1495, 'Abbé. - Mathématicien. - Professeur d''artillerie à l''Ecole militaire de La Fère', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb102670411#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb102670411#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1492, 'Mathématicien et physicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12534513m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12534513m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1305, 'Philosophe, astronome et physicien. - Fut invité par Frédéric II à réorganiser puis présider l''Académie de Berlin. - Ami puis ennemi de Voltaire, qui écrivit contre lui "Micromégas". - Membre de l''Académie française (élu en 1743)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11915229j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11915229j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1367, 'Mathématicien. - Astronome. - Participa à l''expédition de 1736 en Laponie. - Membre de l''Académie des sciences (1727) et de l''Académie d''architecture (1739)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12181030f#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12181030f#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (903, 'Historien, professeur de philologie à l''académie équestre de Lüneburg (1723). - Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb143273694#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb143273694#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1494, 'Mathématicien, physicien et astronome. - Fut professeur à Saint-Petersbourg (1725-1733) et à Bâle (1733-)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb122991859#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb122991859#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1434, 'Cartographe. - Officier du génie. - Spécialiste en hydraulique. - Mathématicien. - Disciple de Bél Mátyás (1684-1749). - Études à Jena et à Nuremberg, Allemagne', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb103650124#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb103650124#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1146, 'Astronome et naturaliste. - Professeur d''astronomie à l''université d''Uppsala (1730)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14606035v#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14606035v#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (922, 'Savant. - Astronome. - Géographe. Mesura l''arc du Méridien avec Godin et Bouguer. - Membre de l''Académie française (élu en 1760)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb119102567#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb119102567#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (978, 'Physicien, professeur de mathématiques et de physique', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10587905k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10587905k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (836, 'Mathématicien et professeur de philosophie', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12355199c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12355199c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1233, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16265590z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16265590z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1564, 'Fils de pasteur, a étudié la théologie et s''est intéressé à la  philosophie et aux mathématiques. - A publié en 1735 une traduction annotée de la première partie de la Bible, les cinq livres de Moïse (ou Torah ou Pentateuque), connue sous le nom de "Wertheimer Bible", laquelle a été censurée par l''empereur', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb150701237#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb150701237#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1316, 'Mathématicien et statisticien. - Fut constructeur de cadrans solaires et inventeur de machines pour élever les eaux et de presse pour le tabac. - Membre de l''Académie des sciences (1746)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121904326#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121904326#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1435, 'Franciscain. - Professeur de mathématique à l''Université de la Sapience (Rome)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb155933751#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb155933751#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1039, 'Professeur de philosophie et de mathématiques des Académies et Sociétés royales de Londres, de Berlin, de Montpellier, de Lyon et de l''Académie de l''Institut de Bologne', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15006804w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15006804w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1001, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14330967m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14330967m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1537, 'Jésuite. - Professeur d''humanités, de mathématiques et de philosophie', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16180102s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16180102s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (996, 'Jésuite. - Physicien, mathématicien et archéologue', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12161284h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12161284h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1030, 'Naturaliste, mathématicien, médecin, logicien, philosophe. - Né à Presbourg (l''actuelle Bratislava), il fit toute sa carrière en Allemagne (à Iéna, Göttingen, Halle notamment)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12316478n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12316478n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1200, 'Astronome, membre de l''Académie des sciences', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15004534h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15004534h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1014, 'Variante(s) de prénom : Jean. - Libraire ; libraire (ordinaire) de Sa Majesté (1762) ; libraire de la "Society for the Encouragement of learning". - Baptisé à Oxford le 8 juillet 1705 ; fils d''un chirurgien. En apprentissage chez le libraire de Londres John I Osborne d''août 1722 à oct. 1729. Établi vers 1730. Succède au libraire William Mears après lui avoir été associé. Spécialiste des publications scientifiques, particulièrement de mathématiques, et des éditions étrangères, de philosophes notamment. Séjourne à Paris en 1780. Décédé à Kensington en avril 1765. Son frère Charles Nourse puis Francis Wingrave lui succèdent', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13605346z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13605346z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1609, 'Cartographe et mathématicien à Rostock', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb153777849#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb153777849#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (876, 'Les ouvrages "Nouvelles récréations physiques et mathématiques" et "Essai sur la construction des ballons aérostatiques et sur la manière de les diriger" lui sont attribués par Hoefer et Quérard. - DBF et Michaud soulignent la confusion entre lui et Guillaume-Germain Guyot pour l''attribution de ces ouvrages', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14651894d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14651894d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1562, 'Jésuite, enseigna les mathématiques et les humanités', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12240755t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12240755t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1585, 'Mathématicien et ingénieur militaire. - Pamphlétaire', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121289860#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121289860#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1571, 'Astronome. - Secrétaire perpétuel de l''Académie des Sciences (1743)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10667779b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10667779b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1403, 'Jésuite, mathématicien et pilote', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12570261h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12570261h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1186, 'Mathématicien et physicien. - Philosophe, théologien et orientaliste. - Membre de l''Académie des sciences de Saint-Pétersbourg (à partir de 1733) et de celle de Berlin (à partir de 1741), et membre associé de celle de Paris (à partir de 1755)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12157666x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12157666x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (870, 'Professeur de mathématiques à Utrecht (1751) puis directeur de la classe de mathématiques de l''Académie de Berlin. - Découvrit la solution du problème consistant à inscrire dans un cercle un triangle dont les côtés passent par trois points donnés', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb130145422#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb130145422#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1236, 'Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12202196d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12202196d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (985, 'Comte. - Mathématicien, acousticien et théoricien de la musique. - Fut aussi physicien et architecte', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12252383n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12252383n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (832, 'Astronome, physicien, mathématicien. - Professeur de physique à l''université de Wittenberg', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14065311n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14065311n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (990, 'Auteur comique et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10425836p#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10425836p#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1452, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14852857s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14852857s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1616, 'Membre de la société royale de Londres, professeur de mathématiques à Woolwich (en 1755)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb103759851#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb103759851#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1104, 'Génovéfain. - Astronome. - Correspondant (à partir de 1753), puis associé libre de l''Académie des sciences. - Géographe de la Marine. - Chancelier de l''Université de Paris (1769-17..). - Bibliothécaire de Sainte-Geneviève (à partir de 1792)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12151017m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12151017m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (837, 'Religieux de l''ordre des Minimes. - Professeur de physique et mathématiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12198105d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12198105d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (968, 'Mathématicienne et physicienne. - Professeur de biologie et de physique à l''Université de Bologne. - Première femme titulaire d''une chaire universitaire en Europe', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb135103950#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb135103950#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1582, 'Mathématicien, physicien et historien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10464765k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10464765k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (935, 'Mathématicien, inventeur-mécanicien et historien. - Directeur des salines de Moutiers. - Né dans le Valais et mort à Moutiers (Tarentaise)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb128398731#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb128398731#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1388, 'Jésuite. - Physicien, mathématicien, astronome et philosophe. - Professeur de mathématiques à Rome, Pavie et Milan. - Directeur de l''optique de la Marine royale à Paris et membre de la "Royal Society" à Londres. - Dans son ouvrage majeur "Théorie de la philosophie naturelle" il élabore la théorie initiale des forces et de la structure fondamentale de la matière, dont les concepts ont trouvé écho dans les découvertes de la physique moderne. - Il publie nombre d''ouvrages contenant ses découvertes en mathématiques, en astronomie, en géophysique et en archéologie. - Il mit au point différents instruments optiques, astronomiques et géodésiques et réalisa des expertises et des mesures hydrotechniques, géodésiques, cartographiques et statiques. - Il consolida la coupole de la basilique Saint-Pierre de Rome et de la flèche de la cathédrale de Milan', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12054879x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12054879x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1135, 'Abbé. - Mathématicien, géomètre, économiste politique. - Titulaire de la chaire de philosophie au Collège de France (1742-1749)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15325204x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15325204x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1102, 'Date de mort : 21 août ou 22 juillet 1757. - A également écrit en français. - Mathématicien, philosophe et juriste', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb120941298#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb120941298#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (918, 'Mathématicien très précoce et astronome. - Ami de Voltaire et de la marquise Du Chatelet', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb124002538#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb124002538#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (844, 'Moine camaldule. - Mathématicien, économiste et philosophe', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13753557w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13753557w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1591, 'Abbé. - Professeur de mathématiques au Collège Mazarin. - Membre de l''Académie royale des sciences', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12124353d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12124353d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1554, 'Ingénieur, mathématicien. - Membre de l''Académie des sciences de Turin', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10709482t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10709482t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1533, 'Mathématicien et physicien suisse. - Etudie à Genève puis Paris. - Etabli à Genève', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb155857475#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb155857475#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1159, 'Astronome et géomètre. - Membre de l''Académie des sciences (1736). - Fils de Jacques Cassini (1677-1756) et père de Jean-Dominique Cassini (1748-1845). - Participa avec son père à la mesure de la perpendiculaire de l''Observatoire. - Son oeuvre principale est la carte de France, première carte de base de ce pays, dont la publication commença en 1756', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12241101g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12241101g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1349, 'Dominicain. - Astronome. - Préfet de la Biblioteca Casanatense, Rome (1759-1794). - Né Giulio Cesare Audiffredi, change de prénom en entrant chez les Dominicains (1730)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13595556h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13595556h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1350, 'Mathématicienne', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb105423187#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb105423187#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1611, 'Professeur de Mathématiques et de Philosophie naturelle à Harvard', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14594660x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14594660x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (915, 'Littérateur. - Mathématicien. - Voyageur', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12533121w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12533121w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (962, 'Astronome. - Membre de l''Académie des sciences (1741). - Professeur de physique au Collège de France (de 1749 à 1793), puis membre de la classe des sciences physiques et mathématiques de l''Institut', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121064574#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121064574#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1617, 'Professeur de mathématiques. - Membre de l''Académie de Berlin', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb122271303#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb122271303#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1160, 'Métropolite de l''Église orthodoxe grecque. - Théologien, philosophe et mathématicien. - "Éducateur de la Nation" et précurseur des Lumières en Grèce ; traducteur de Voltaire et Virgile. - Nommé évêque en Russie', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12564304q#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12564304q#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1483, 'Philosophe, mathématicien et théologien. - Professeur de philosophie à l''université de Tübingen (1750-1782)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13324024g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13324024g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1549, 'Jésuite. - Geographe, astronome, mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb106577403#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb106577403#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1394, 'Mathématicien et philosophe. - Nom patronymique : Jean Le Rond, d̲i̲t̲ d'' Alembert. - Membre de l''Institut, Académie française (élu en 1754)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb118883708#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb118883708#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1179, 'Professeur, mathématicien, scientifique allemand', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12091922b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12091922b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1525, 'Astronome. - Associé non résidant de l''Académie des sciences. - Receveur des tailles de la généralité d''Auch', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12155190x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12155190x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (906, 'Ingénieur. - Professeur de mathématiques à l''École royale militaire. - Inventeur de l''"affut de Gribeauval"', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb134984423#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb134984423#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1310, 'Duc de Doudeauville. - Capitaine-colonel des cent-suisses de la garde du roi. - Astronome, membre de l''Académie des sciences', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121904446#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121904446#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1427, 'Né le 8 ou le 18 juillet 1718. - Embrassa d'' abord la carrière militaire. - Chevalier de Malte. - Mathématicien et Physicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12108181n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12108181n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1346, 'Mathématicien, physicien. - Médecin. - Pédagogue, professeur à Debrecen,Református Kollégium, Hongrie. - Diplômé de l''Université de Bâle, Suisse', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10355679v#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10355679v#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1500, 'Astronome et physicien. - Né à Lausanne, mort à Paris', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb133196302#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb133196302#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1594, 'Jésuite de 1737 à 1773 (ordonné prêtre en 1749). - Sinologue et astronome. - Missionnaire en Chine (à partir de 1749)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12112654w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12112654w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1168, 'Mathématicien. - Poète et épigrammatiste. - Critique', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb123392338#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb123392338#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1315, 'Prêtre. - Physicien. - Professeur d''astronomie, de géographie et de météorologie à l''Université de Padoue', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10578331h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10578331h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1027, 'Philosophe des lumières danois. - Professeur de mathématiques et de philosophie à Soroe', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12442689p#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12442689p#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (868, 'Évêque de Rama. - Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10748264x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10748264x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (834, 'Astronome. - Explorateur en Sibérie et en Californie', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12402595h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12402595h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1213, 'Homme de lettres, poète. - S''intéressa aux mathématiques, à la géographie et à l''enseignement des arts', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb119011560#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb119011560#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1448, 'Mathématicien et inventeur', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13485055d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13485055d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (881, 'Lettré du milieu de l''époque d''Edo. - A créé son propre système de pensée philosophique appelé "jōrigaku" : méthode de spéculation fondée sur l''éthique, la logique, les mathématiques et la physique, recourant à une pensée dialectique appelée "hankan gōitsu"', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12293200x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12293200x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1163, 'Géographe ordinaire du roi, professeur de mathématiques et de géographie, fils de Gilles Robert Vaugondy. - Didier signe "Robert de Vaugondy"', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12380757h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12380757h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1541, 'Professeur de mathématiques. - Ingénieur de la marine. - Collaborateur de l''Encyclopédie méthodique (1782-1783?)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10737141j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10737141j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (937, 'Mathématicien et astronome, a travaillé avec Homann Herben de 1746 à 1751, puid pour Kilian à partir de 1752', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb153509764#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb153509764#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1229, 'Astronome allemand', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11958863x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11958863x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1035, 'Née Nicole-Reine Étable de La Brière, épouse de Jean-André Lepaute, horloger du Roi. - Mathématicienne, astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14555447k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14555447k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (967, 'Astronome, mathématicien. - Directeur de l''Observatoire de Göttingen, Allemagne', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121551484#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121551484#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1505, 'Ingénieur-géographe et astronome. - Professeur à l''école militaire. - Membre de l''Académie des sciences', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb122175393#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb122175393#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1568, 'Les ouvrages "Nouvelles récréations physiques et mathématiques" et "Essai sur la construction des ballons aérostatiques et sur la manière de les diriger" lui sont attribués par le DBF et par Samuel Ersch dans "La France littéraire contenant les auteurs français de 1771 à 1796", DBF. - Quérard et Michaud soulignent la confusion entre lui et Edme-Gilles Guyot pour l''attribution de ces ouvrages', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12214218k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12214218k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1328, 'Astronome et voyageur. - Entre à l''Observatoire en 1750. - Membre de l''Académie des sciences en 1753', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12151459n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12151459n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1344, 'Historien des mathématiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12127574n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12127574n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (839, 'Abbé. - Fut professeur de mathématiques au Collège Mazarin', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb146364765#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb146364765#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1264, 'Écrivain, philosophe, mathématicien, juriste et conseiller aulique', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125347464#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125347464#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1517, 'Libraire ; libraire et (ingénieur) géographe (pour les globes et les sphères) du roi de Danemark (ou : de Sa Majesté danoise) (1769-1789). - Fils d''un marchand drapier de Pont-Sainte-Maxence (Oise). Apprenti fondeur de caractères à Paris à partir d''avril 1745 (reçu maître fondeur en 1757).  Ingénieur géographe (de la ville de Paris à partir de 1769), fabricant et marchand de sphères et d''instruments astronomiques établi vers 1753 en succession de Jacques Hardy, après avoir épousé en 1749 la veuve de son fils Nicolas Hardy ; également marchand d''estampes et de cartes géographiques. Un des 12 libraires non jurés reçus le 4 oct. 1767. - Éditeur et auteur de nombreux atlas, almanachs et publications géographiques entre 1756 et 1795 env. Rédige également plusieurs catalogues de son fonds entre 1768 et 1792. Une partie de son fonds est rachetée en 1805 par Jean (17..-1839), marchand de cartes et d''estampes', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12402252d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12402252d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1006, 'Mathématicien et physicien. - Recteur et professeur de calcul sublime à l''Ateneo lombardo. - Bibliothécaire du Collegio Ghisleri, Pavie', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10601676b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10601676b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1325, 'Ingénieur. - Géographe. - Hydrographe. - Célèbre par la projection qui porte son nom et qui remplacera pour la carte de France la projection de Cassini. D''abord ingénieur géographe et maître de mathématiques. En 1775 ingénieur hydrographe de la Marine. Fut mis à la retraite contre sa volonté en 1789. Collabora au Neptune américo-septentrional', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12169793s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12169793s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (830, 'Capucin. - Astronome, cartographe et géologue', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10728734z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10728734z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1335, 'Mathématicien, physicien, astronome et philosophe. - Spécialiste de géometrie. - En poste à l''Académie royale des sciences et belles lettres de Berlin (de 1765 à 1777)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12359659g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12359659g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1468, 'Capucin, nom de religion de Noël André. - Attiré par la géographie et l''astronomie, fut l''élève de Lemonnier. Mesura les altitudes des Vosges, du Jura et des Alpes. Se retira dans sa famille au moment de la Révolution.  En 1806 publia un important traité de géologie dont Cuvier fit un rapport élogieux', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb153054042#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb153054042#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1036, 'Barnabite. - Mathématicien, astronome et écrivain. - Professeur dans les Écoles palatines de Milan (1764-)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb120849325#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb120849325#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (952, 'Théoricien de la musique et polémiste. - Jésuite, il devient professeur de rhétorique à l''Université de Valence, puis professeur de mathématiques à l''Académie militaire de Ségovie (1764). - Lorsque les jésuites sont expulsés d''Espagne en 1767, il se rend à Rome où il étudie la musique. - Connu aussi sous le pseud. : "Aristosseno Megareo" (BnF, Musique, fichier général auteurs), ou "Aristodemo Megareo" (Fétis)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13755053m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13755053m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (947, 'Mathématicien, membre de l''Académie des sciences (1779), il participa à la rédaction de la partie mathématique de l''Encyclopédie', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11763983g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11763983g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1184, 'Mathématicien et physicien. - Membre de l''Académie des sciences, pensionnaire de la classe de mécanique (1785). - Écrivit plusieurs articles dans l''"Encyclopédie"', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb124599882#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb124599882#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1157, 'Astronome de la marine. - Académicien (1770). - Membre de l''Institut', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb124827900#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb124827900#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1499, 'Mathématicien. - Membre de l''Académie des sciences', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12267459g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12267459g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1409, 'Physicien et mathématicien. - Jésuite', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13196726p#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13196726p#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1220, 'Mathématicien, physicien et moraliste. - Professeur de physique à Bourges', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12401095w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12401095w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1481, 'Mathématicien, professeur de mathématiques à l''École militaire', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13011110m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13011110m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1607, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb162593727#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb162593727#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (896, 'Mathématicien et physicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14065297x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14065297x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1416, 'Professeur de mathématiques et d''hydrographie, physicien et astronome. - Membre de l''Académie royale de marine. - Correspondant à l''Académie royale des sciences (1789), associé non résident de l''Institut (1796)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12548660k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12548660k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1046, 'Mathématicien et cartographe à Trondheim', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15384550x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15384550x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (885, 'Astronome. - Membre de l''Académie de Berlin. - Membre de l''Académie des sciences (1753). - Professeur d''astronomie au Collège de France (1762). - Directeur de l''Observatoire de Paris de 1768 à sa mort', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12012398h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12012398h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1240, 'Éditeur et marchand de cartes géographiques ; libraire. - Ingénieur géographe du Roi et professeur de mathématiques des pages du prince et de la princesse de Conti. Auteur de plans, de cartes, d''ouvrages illustrés et d''atlas, qu''il publie et diffuse parfois lui-même de 1776 à 1792 au moins. Auteur notamment d''un "Dictionnaire hydrographique de la France..." (1re éd., l''auteur, 1787 ; rééd., Paris, Blanchon, 1803) et d''une série de "Recherches historiques" sur les villes de France (Angers, Orléans, Reims, 1775-1776). Se qualifie de libraire en 1791-1792. Décédé à Paris le 21 frimaire an XIV (12 déc. 1805, Arch. de Paris)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13531657x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13531657x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1573, 'Astronome royal d''Angleterre. - Membre associé de l''Académie des sciences de Paris', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12155150p#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12155150p#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1383, 'Astronome. - Hydrographe. - Zoologue marin', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15317071s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15317071s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1196, 'Astronome. - Linguiste. - Père jésuite', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12246417w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12246417w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1147, 'Officier de marine. - Membre de l''Académie de Marine (élu en 1769). - Entra dans le Génie militaire et se fit remarquer par ses travaux sur l''hydraulique. - Il détermina la longitude des Canaries (en 1776). - Prit part à la guerre d''indépendance américaine. - Participa avec Delambre et Méchain à la mesure de l''arc de méridien Dunkerque-Barcelone. - En qualité de commissaire de l''Académie des sciences participa à l''étude des montres marines sur la frégate la Flore (en 1771). - Membre de l''Institut, Académie des sciences (élu en 1772). - Membre de la Commission des poids et mesures (en 1791), il travailla à l''établissement du système métrique. - Membre de l''Institut national des sciences et arts, section mathématiques (actuel Institut de France) et du Bureau des longitudes (en 1795). - Co-fondateur de La Société de Borda (créée en 1876), avec Jacques-François de Borda d''Oro (1718-1804)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12482831r#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12482831r#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1331, 'Evêque; secrétaire de la Royal Society; publia des livres de théologie et de mathématiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb120697374#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb120697374#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1051, 'Astronome et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10680537k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10680537k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1180, 'Homme de loi, homme de lettres, pamphlétaire puis astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb144447840#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb144447840#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1263, 'Astronome, spécialisé dans les éclipses du soleil.', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15318527x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15318527x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1386, 'Magistrat. - Mathématicien et astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10586154b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10586154b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1341, 'Géographe de la république de Venise, astronome, il voyage en Amérique du nord en 1757', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb153024615#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb153024615#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1420, 'Mathématicien, astronome et homme politique. - Entre à l''Académie des sciences (en 1763), à l''Académie française (en 1784) puis à l''Académie des inscriptions (en 1785). - Député du Tiers-État aux États-Généraux ; Maire de Paris ; Député à l''Assemblée Nationale Constituante', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12516744h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12516744h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1033, 'Mathématicien, physicien et philosophe', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12531163b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12531163b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (998, 'Mathématicien. - D''origine italienne. - A été à l''origine de la fondation de l''Académie des sciences de Turin. - Membre de l''Académie des sciences de Paris, Berlin, Turin. - A partir de 1787, enseigne à Paris à l''École normale et à l''École polytechnique', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12125247f#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12125247f#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1336, 'Barnabite. - Physicien, géologue, architecte. - Professeur de mathématiques, puis d''histoire naturelle au Collège Saint-Alexandre, Milan. - Dans le siècle : Pini, Carlo', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13013593q#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13013593q#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1415, 'Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb146402484#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb146402484#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1162, 'A été professeur de mathématiques à l''université de Königsberg, Allemagne', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121741380#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121741380#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1090, 'Astronome et géographe', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15376450x#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15376450x#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1120, 'Écrivain. - Poète. - Piariste. - Professeur de mathématiques. - A fait des études de théologie  à Privigye (aujourd''hui Prievidza, Slovaquie) et à Nyitra (aujourd''hui Nitra, Slovaquie)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12246575b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12246575b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (986, 'Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10552198c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10552198c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1133, 'Astronome. - À l''Observatoire de Pise à partir de 1765', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12159312n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12159312n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (891, 'Professeur de philosophie, théologie et mathématique, poète, musicien, historien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16219670j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16219670j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (994, 'Astronome. - Attaché à l''Observatoire en 1785. - Participe à l''expédition d''Égypte en 1798. - Ingénieur au Bureau de la guerre en 1802', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12151453k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12151453k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (925, 'Astronome et cartographe', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121931908#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121931908#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1166, 'Astronome. - Capitaine de vaisseau. - Directeur des compagnies des gardes royales de la marine en 1786. - Membre de l''Académie d''histoire de Madrid. - Correspondant de l''Académie des sciences de Paris', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12159995t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12159995t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1428, 'Prêtre, astronome de la marine, physicien et inventeur. - Bibliothécaire de l''Académie royale de marine à Brest (1765-), astronome opticien de la Marine (1787), membre de la Commission des poids et mesures et des monnaies (1792). - Membre de l''Académie royale des sciences, puis membre de l''Institut. - Clerc tonsuré', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb129983745#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb129983745#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (908, 'Professeur de mathématiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15512813z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15512813z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (991, 'Abbé. - Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10522164f#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10522164f#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (931, 'Théologien. - Mathématicien. - Précepteur des princes de Wurttemberg', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb119076602#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb119076602#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (911, 'Savant astronome et agriculteur. - Conseiller de préfecture du département de l''Hérault. - Membre de la Société royale des sciences de Montpellier', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10644654k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10644654k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1238, 'Astronome et mathématicien. - Crée un observatoire d''astronomie à Vérone. - Enseigne les mathématiques à l''École militaire de Modène après la prise de Vérone par les Français (1797). - Membre de nombreuses académies d''Europe', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12562781s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12562781s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1439, 'Géographe et naturaliste. - Professeur de mathématiques et de sciences naturelles au Collegium Carolinum de Brunswick de 1766 à 1815. - Conseiller aulique en 1786, puis conseiller d''état en 1801', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12330956p#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12330956p#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (831, 'Philosophe, mathématicien et  économiste. - Membre de l''Académie française (1782). - Homme politique. - A aussi écrit sous le pseudonyme M. Schwartz, pasteur à Bienne', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb118975118#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb118975118#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1334, 'Ingénieur. - Mit au point plusieurs instruments d''astronomie et de géodésie', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb151423156#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb151423156#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1453, 'Professeur de mathématiques et d''hydrographie', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10544471f#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10544471f#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1234, 'Mathématicien, astronome. - Membre des Académies des sciences de Berlin, de Petersbourg, de Stockholm, de Bologne, de Lyon, & de Marseille, de la Société pour l''encouragement des arts, de Londres, de celle des physiciens de Bâle, de l''Académie des Arcades de Rome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14508854n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14508854n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1474, 'Poète portugais. - Mathématicien, professeur de géométrie à l''Université de Coimbra. - Officier d''artillerie à Valença do Minho (1764-1778)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121612626#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121612626#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (914, 'Astronome français. - Prénoms complets : Pierre François André', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12090251r#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12090251r#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (976, 'Mathématicien. - Reçut la médaille d''argent de la Royal Danish academy', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12563002z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12563002z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (973, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10017540p#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10017540p#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1359, 'Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15115995f#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15115995f#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1347, 'Gastronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16296114m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16296114m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1015, 'Professeur de mathématiques et de navigation à l''École de Rochefort. - Membre de l''Institut', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12805333t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12805333t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1003, 'Piariste (17 mai 1761). - Mathématicien. - Librettiste. - Prénom de baptême : Vincenzo', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16659347q#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16659347q#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1424, 'Mathématicien et géomètre. - Fondateur de l''École polytechnique et de l''École normale. - Président de l''Institut du Caire. - Membre de l''Institut, Académie des sciences. - Député au Conseil des Cinq-Cents, au Conseil des Anciens, ministre de la Marine (1792), sénateur (1799), comte de Péluse (1808)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121412336#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121412336#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1262, 'Physicien et mathématicien. - Homme politique et diplomate', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb127228927#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb127228927#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (997, 'Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12920801z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12920801z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1081, 'Oratorien et professeur de mathématiques. - Fut directeur de l''Ecole centrale d''Angers. - Fut président des Amis de la Constitution. - Fut commissaire civil du département de Maine-et-Loire', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125680474#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125680474#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1301, 'Bachelier ès sciences. - Professeur d''humanités et de mathématiques (en 1825). Professeur au collège de Troyes', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10728006s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10728006s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1387, 'Prédicateur, mathématicien, philologue. - A écrit en patois limousin des fables imitées de La Fontaine, qu''il a aussi traduit dans cette même langue. - Fut l''un des rédacteurs du "Journal du département de la Haute-Vienne". - Fut à Limoges une personalité agissante du Club des jacobins, membre du Comité de salut public, juge de paix et payeur du département de Haute-Vienne. - Défroqué en 1793, il mourut réconcilié avec l''Église', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb119031941#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb119031941#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1397, 'Libraire ; libraire de l''École polytechnique (1800) ; de l''École des Ponts et Chaussées (1801) ; des Écoles impériales polytechnique et des Ponts et chaussées (1805). - Né à Marseille. Libraire spécialisé dans les "mathématiques, sciences et arts", il travaille jusqu''en 1796 en association avec Régent au bureau du "Journal polytechnique" ou "Bulletin des Travaux publics..." Historien et philologue, éditeur des "Œuvres posthumes" de Montesquieu. Décédé à Saint-Maur-des-Fossés (Val-de-Marne) en oct. 1808. Sa veuve lui succède avant de revendre son fonds en 1810 à Jean Klostermann', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb122388832#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb122388832#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1085, 'Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb104634498#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb104634498#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1459, 'Jacobin viennois. - Professeur de mathématiques, précepteur des enfants du Grand duc Léopold, futur empereur,  1779-1790, Florence (Italie). - Études de médecine, élève du professeur Franz Anton Mesmer. - Emprisonné à Brno (1806-1809). - Se réfugia en France 1810-1837', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14593357z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14593357z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1398, 'Astronome. - Directeur de l''Observatoire du Seeberg (près de Gotha), de 1787 à 1808. - Dirigea les "Allgemeinen geographischen Ephemeriden" (1796-)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121732757#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121732757#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1091, 'Astronome. - Membre de l''Académie des sciences (1770). - Fils de l''astronome César-François Cassini (1714-1784), qui était aussi appelé Cassini de Thury, car né à Thury (Oise) en 1714. - Succède à son père comme directeur de l''Observatoire de Paris (en 1784)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12157999q#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12157999q#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1121, 'Mathématicien. - A enseigné à l''université de Padoue', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb146340668#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb146340668#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1460, 'Mathématicien. - Directeur adjoint de l''Observatoire de Marseille', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12306722n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12306722n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1025, 'Moine bénédictin, mathématicien et horloger', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15037954k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15037954k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1218, 'Astronome. - Directeur du "Collegio romano"', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10544460s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10544460s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1105, 'Ingénieur et mathématicien. - Fut professeur à l''Ecole militaire et l''Ecole royale militaire. - Fut le traducteur de Cervantès', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125620183#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125620183#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1266, 'Astronome. - Ses calculs ont servi à  déterminer la longueur du mètre. - Membre de l''Académie des sciences (1792)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12096096m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12096096m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1438, 'Professeur de mathématiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb102655606#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb102655606#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1496, 'Astronome, mathématicien et physicien. - Membre de l''Institut, Académie des sciences (élu en 1795), puis de l''Académie française (élu en 1816). - Obtint le titre de marquis (en 1817)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb119110516#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb119110516#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1161, 'Scientifique, mathématicien. - Ministre de la République parthénopéenne en février 1799, fut probablement victime de la répression au rétablissement des Bourbons en juin de la même année', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12290835h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12290835h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1019, 'Professeur de littérature et de mathématiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb100430283#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb100430283#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1313, 'Mathématicien. - Colonel d''infanterie du régiment de Conti. - Chevalier de Malte', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb145658189#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb145658189#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1442, 'Libraire, éditeur et marchand de cartes et d''estampes ; également géographe ordinaire du roi d''Angleterre (1783-1820) et du prince de Galles (1790-1820). - Fils de l''imprimeur londonien William I Faden (à l''origine Mackfaden, 1711-1783). En apprentissage de juillet 1764 à août 1771. Travaille en association avec la famille du libraire et géographe du Roi Thomas Jefferys (m. 1771) jusqu''en 1776 env. Membre de la "Society of civil engineers". Beau-frère du peintre et astronome John Russell. Se retire en 1823 et cède son affaire à son ancien apprenti James Wyld. Décédé à Shepperton en mars 1836', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15615346f#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15615346f#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1113, 'Astronome. - Assistante de son frère, William Herschel (1738-1822), lui aussi astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16108822m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16108822m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1488, 'Mathématicien, astronome et géographe. - Député du Puy-de-Dôme à l''Assemblée législative puis à la Convention, représentant en mission près l''armée de Cherbourg, préconise l''essai du télégraphe aérien de Chiappe. - A participé à l''établissement du calendrier révolutionnaire', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12536106q#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12536106q#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1273, 'Mathématicien et poète. - Professeur de physique et de mathématique au Séminaire de Bergame, puis d''algèbre et de géométrie à l''Université de Pavie, dont il sera recteur. - Député au Corps législatif de Milan (1799), admirateur de Napoléon, fait partie des 29 qui signent l''appel à régner en Italie au Premier Consul après 1799', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb119149502#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb119149502#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1075, 'Directeur, entre 1777 et 1786, de la Correspondance générale à la Division des mines et de l''agriculture du Contrôleur général des Finances Bertin. - Diplomate. - Auteur d''ouvrages de physique et de mathématiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb122074802#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb122074802#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1368, 'Géologue. - Professeur de mathématiques à Raguse puis à Rome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb151306996#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb151306996#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1204, 'Mathématicien et philosophe. - Établi à Varsovie', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13005974t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13005974t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1504, 'Cartomancien de la fin du 18e siècle. - Marchand d''estampes. - Professeur de mathématiques (vers 1753). - La forme "Etteilla" est l''anagramme d''Alliette', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb118885161#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb118885161#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1519, 'Abbé, mathématicien et homme politique. - Enseigna les mathématiques à l''Ecole militaire. - Collabora à l''"Année littéraire" et au "Journal de la France"', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb124621991#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb124621991#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1332, 'Horloger, astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12614643k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12614643k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1399, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10735226f#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10735226f#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (864, 'Mathématicien. - Géomètre. - Chevalier de Saint-Louis (1815)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13006994p#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13006994p#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1489, 'Mathématicien et théologien, cordelier de l''Observance. - Fut membre associé de l''Académie royale des belles-lettres de Barcelone', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb134813469#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb134813469#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1151, 'Cartographe, géographe et peut-être astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15332855z#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15332855z#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (843, 'Adjoint-général pendant les guerres de Vendée et d''Italie. - Professeur de mathématiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13484693c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13484693c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (871, 'Abbé. - Professeur de mathématiques à Reims. - Correspondant de l''Académie des Sciences', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12224993g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12224993g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (956, 'Libraire pour les mathématiques. - En activité de mars 1797 à 1803 au moins. Apparenté à Louis (-Alexis) Duprat-Duverger, en activité à partir de 1802, qui a pu se qualifier lui aussi de "libraire pour les mathématiques". Louis Courcier, "imprimeur et libraire pour les mathématiques", lui succède en 1803 à la même adresse (quai des Augustins, n° 71). Une "madame Duprat" est cependant répertoriée, à l''adresse du pont Saint-Michel, par le "Tableau des libraires" de Debray (Paris, janv. 1804)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16701987t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16701987t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1031, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125867381#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125867381#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1299, 'Etabli dès 1740 quai de l''Horloge du Palais, il fabriquait des instruments de navigation, des cadrans solaires, des sphères astronomiques et géographiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15281028g#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15281028g#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (980, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb153816258#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb153816258#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1203, 'Mathématicien et grammairien. - A été teneur de comptes vers 1678', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125155096#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125155096#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1542, 'Libraire ; libraire pour les mathématiques et l''architecture ; libraire de l''École des Ponts et chaussées (1802) ; des ingénieurs et de l''École impériale des Ponts et chaussées (1805). - Semble avoir été commis du libraire parisien Charles-Antoine Jombert de 1770 à 1773 au moins. Père du médecin Jean-Louis Gœury-Duvivier, né le 2 mars 1803. En activité dès 1800. Breveté libraire le 1er oct. 1812 (brevet renouvelé le 11 sept. 1818). Décédé peu avant le 28 juin 1827, date à laquelle son fils Jean-Louis Gœury (dit plus tard Gœury-Duvivier) demande à succéder à son brevet', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12230577c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12230577c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1016, 'Professeur de rhétorique et de mathématiques, professeur de physique à l''université de Nantes de 1780 à 1784. - Aéronaute. - Membre de la Congrégation de l''Oratoire', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16514291q#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16514291q#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1534, 'Professeur de mathématiques du Collège national de Toul', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125373980#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125373980#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1480, 'Gentilhomme liégeois. - Mathématicien et physicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb124022694#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb124022694#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1447, 'Variante(s) de prénom : Louis-Alexis. - Libraire pour les mathématiques ; également éditeur de cartes et d''atlas. - Apparenté au "libraire pour les mathématiques" J.-B.-M. Duprat, en activité à Paris entre 1797 et 1803. Établi dès 1802, d''abord en association sous la raison "L. Duprat, Letellier et compagnie" jusqu''en 1804, seul ensuite. Breveté libraire le 1er oct. 1812 ; brevet renouvelé le 15 mars 1817 ; duplicata délivré le 27 avril 1824. Encore en activité en 1829', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb133399518#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb133399518#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1125, 'Épouse de Jean-Sylvain Bailly, mathématicien, astronome et homme politique, guillotiné en 1793', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16541654h#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16541654h#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1065, 'Femme d''Elie Cartan, mère du compositeur Jean Cartan et du mathématicien Henri Cartan. - Née Marie-Louise Bianconi', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb148511208#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb148511208#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1060, 'Abbé. - Mathématicien français. - Principal du collège de Quimper. - Professeur de philosophie et de mathématiques au collège de Navarre à Paris. - Professeur au collège de Louis-le-Grand à Paris', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb15085298t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb15085298t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (958, 'Botaniste et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12563978p#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12563978p#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1109, 'Mathématicien favorable à Necker et à la Révolution', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12240772d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12240772d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1061, 'Maître de mathématiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb134811442#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb134811442#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (929, 'Seul imprimeur d''Apollon pour la satyre en prose". - Pseud. auquel est adjoint le qualificatif "seul imprimeur d''Apollon pour la satyre en prose" et qui, sous la fausse adresse "Sur l''imprimé au Parnasse", dissimule une impression française (parisienne selon Weller et G. Brunet, plutôt provinciale d''après le matériel typographique) de "La Nouvelle Astronomie du Parnasse françois, ou l''Apothéose des écrivains vivans dans la présente année 1740", due au chevalier Jean-Florent-Joseph de Neufville de Brunaubois-Montador', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb165246377#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb165246377#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1614, 'Nom patronymique : Victoire-Félicité Lemaire. - Imprimeur-libraire ; imprimeur-libraire pour les mathématiques, la marine, les sciences et les arts. - Brevetée imprimeur en succession de son mari le 12 août 1811 (brevet renouvelé le 15 oct. 1816) et libraire le 1er oct. 1812 (brevet renouvelé le 15 mars 1817). Deux de ses  gendres lui succèdent : Démophile Huzard (-Courcier) en mars 1820 (brevet du 14 mars 1820) comme imprimeur, et Victor Bachelier le 10 nov. 1821 comme libraire', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb124778683#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb124778683#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1595, 'Mathématicien. - Président de l''Académie des sciences (1806). - A aussi écrit avec Charles-Etienne Coquebert de Montbret et François Gattey sous le pseudonyme collectif "C.-G.-L. Métrophile"', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12443375d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12443375d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1252, 'Astronome de l''Observatoire de Brera (1777-), puis de Milan. - A découvert qu''Uranus était une planète à partir de son orbite. - Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12537845s#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12537845s#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1040, 'Mathématicien. - Professeur à l''École militaire, à l''École centrale du Panthéon, à l''École polytechnique et au Lycée Napoléon de Paris', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12112257t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12112257t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1364, 'Mathématicien. - Directeur du Collège royal (en 1791). - Député à l''Assemblée législative puis à la Convention nationale', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12520232w#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12520232w#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1002, 'Oratorien. - Professeur de mathématiques et de physique  à Lyon, membre de la Société des amis de la Constitution de la ville durant la Révolution, puis substitut du procureur général près la cour royale d''Agen et bibliothécaire de cette ville', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb126307361#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb126307361#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1323, 'Naturaliste genevois, littérateur, chimiste, physicien et astronome. - Membre fondateur de la Société de physique et d''histoire naturelle de Genève, Suisse. - Correspondant de la Société royale de Londres', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb125386742#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb125386742#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (948, 'Mathématicien. - Directeur du Bureau des poids et mesures (en 1795). - A aussi écrit avec Charles-Etienne Coquebert de Montbret et Adrien-Marie Legendre sous le pseudonyme collectif "C.-G.-L. Métrophile"', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12447886d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12447886d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1375, 'Philosophe. - Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12173561c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12173561c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1602, 'Docteur en médecine en 1601. - Professeur de physique en 1608. - Professeur de mathématiques à l''Université de Marbourg en 1621', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121595722#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121595722#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1597, 'Mathématicien français ayant vécu une grande partie de sa vie aux Pays-Bas', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14912871p#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14912871p#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1599, 'Luthiste et compositeur italien de la Renaissance. - Fils du compositeur et théoricien Vincenzo Galilei, et frère de l''astronome Galileo Galilei', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb140013401#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb140013401#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1230, 'Avocat. - Pamphlétaire. - Gastronome, fondateur et président du "Jury dégustateur"', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11905936j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11905936j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1586, 'Jésuite. - Professeur de belles lettres, de philosophie et de théologie, puis recteur de Bourges, Rennes, La Flèche, Tours et Rouen. - Visiteur de la province de France. - Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12155155d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12155155d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1593, 'Astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb162514419#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb162514419#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1606, 'Mathématicien japonais', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12443516f#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12443516f#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1372, 'Mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb13009642b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb13009642b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1082, 'Philosophe, mathématicien et biologiste. - Industriel, considéré comme l''inventeur de la porcellaine blanche en Europe', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12515471b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12515471b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1020, 'Mathématicien. - Fonctionnaire collonial en Inde (1815-1821). - Chargé du relevé cartographique de l''Inde et de la description de ses régions. - Collectionneur de divers documents (manuscrits, dessins aquarelles...) constituant le fonds d''études indianistes, collection dispersée aujourd''hui entre l''India office library, Londres et : Government oriental manuscripts library, Madras et Calcutta', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb14374770r#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb14374770r#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1354, 'Mathématicien et Officier. - Elu à l''Académie des sciences en 1784 pour son étude locale des surfaces. - Prénoms complets : Jean-Baptiste Marie Charles', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10732160m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10732160m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1187, 'Mathématicien et économiste', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12519510c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12519510c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1391, 'Diplomate, mathématicien et géographe. - Nommé responsable de l''organisation du nouveau système de poids et mesures (décret de 1793), professeur de géographie physique et gîtes de minerais à l''École des mines. - A aussi écrit avec François Gattey et Adrien-Marie Legendre sous le pseudonyme collectif "C.-G.-L. Métrophile". - Membre de l''Institut, membre libre de l''Académie des Sciences (en 1816)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12447869t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12447869t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1528, 'Géographe et astronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb16506861q#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb16506861q#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1348, 'Mathématicien, statisticien. - A développé la mathématisation de l''économie', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb129987837#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb129987837#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (899, 'Mathématicien et ingénieur. - Directeur de l''École des Ponts et Chaussées (1799-1830). - Membre de l''Académie des Sciences. - Baron à titre personnel (1828)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12535038t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12535038t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1543, 'Magistrat. - Député aux États Généraux (élu en 1789). - Gastronome', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12305674c#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12305674c#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1119, 'Imprimeur-libraire ; imprimeur-libraire pour les mathématiques (1801) ; imprimeur-libraire pour les mathématiques (, les sciences et les arts) (1804-1808). - Exerce l''imprimerie dès l''été 1790. Aurait été auparavant "marchand de peaux de lapin" d''après l''enquête des inspecteurs de la librairie de déc. 1810. Proche des Girondins, il émarge au budget du Bureau de l''Esprit public du ministre Jean-Marie Roland de La Platière en 1792. Dirige le "Courrier du Corps législatif et de la Guerre" (1797). Rachète le fonds du libraire J.-B.-M. Duprat et lui succède en 1803 ; rachète l''imprimerie de Jean-Georges-Antoine Stoupe après la mort de celui-ci (1808). Breveté imprimeur le 1er avril 1811. Dit âgé de 56 ans lors de son décès (30 juillet 1811). Sa veuve est brevetée en sa succession dès le 12 août 1811', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12421329b#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12421329b#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1098, 'Chanoine de Paris. - Astronome et mathématicien. - Professeur', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb11906753t#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb11906753t#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1605, 'Mathématicien, géomètre. - Né à Bâle, s''intalla à Saint-Pétersbourg en 1773 à la demande d''Euler. - Membre de l''Académie des sciences de Saint-Pétersbourg (1775-), secrétaire perpétuel (1800-). - Meurt à Saint-Pétersbourg le 23 décembre 1825 (style grégorien)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12359314p#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12359314p#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1212, 'Docteur en mathématiques. - Recteur de l''académie Nîmes (1809-1818) et professeur de philosophie à la faculté des lettres de Nîmes', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10379875d#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10379875d#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1396, 'Mathématicien et littérateur. - Chevalier de la Légion d''honneur en 1811, correspondant de l''Académie de Belgique en 1828 et membre libre de l''Académie des Inscriptions et belles-lettres en 1830', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121468483#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121468483#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (862, 'Astronome. - Professeur d''astronomie à l''Observatoire de Paris de 1783 à 1795', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb121582720#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb121582720#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1276, 'Physicien et mathématicien', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb124025182#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb124025182#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1076, 'Mathématicien et philosophe, un des plus grands savants polonais des Lumières', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb123726267#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb123726267#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1054, 'Oratorien. - Professeur de physique et de mathématique, École Centrale, Lyon, Rhône. - Doyen de la Faculté des sciences de Lyon (1809-1815)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12196474k#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12196474k#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (930, 'Mathématicien. - Ingénieur. - Professeur de mathématiques à Erlangen (Allemagne), de 1798 à 1804, puis à Vilnius (Lituanie) de 1804 à 1806. - Frère de Langsdorf, Johann-Wilhelm (1745-1827)', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10661030m#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10661030m#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1579, 'Professeur de philosophie et d''astronomie. - Député à la Convention. - Membre du Conseil des Cinq-cents', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12534874n#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12534874n#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1498, 'Député de la noblesse. - Fut professeur de mathématiques et de latin', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb12540611f#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb12540611f#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1302, 'Mathématicien. - Professeur', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10275963j#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10275963j#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1598, 'Comte. - Homme politique. - Mathématicien. - Poète', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb105910991#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb105910991#foaf:Person', NULL);
INSERT INTO objet (pk_objet, definition, notes, date_creation, date_modification, cle_importation, cle_importation_txt, longitude, latitude, texte_xml, fk_type_objet_param, genre, texte, langue_texte) VALUES (1022, 'Professeur de mathématiques', NULL, '2015-11-06 15:07:57.421147+01', '2015-11-09 14:28:49.740493+01', NULL, 'http://data.bnf.fr/ark:/12148/cb10617134p#foaf:Person', NULL, NULL, NULL, 8, NULL, 'http://data.bnf.fr/ark:/12148/cb10617134p#foaf:Person', NULL);


--
-- TOC entry 2415 (class 0 OID 0)
-- Dependencies: 182
-- Name: objet_cle_objet_seq; Type: SEQUENCE SET; Schema: objets; Owner: -
--

SELECT pg_catalog.setval('objet_cle_objet_seq', 1636, true);


--
-- TOC entry 2251 (class 2606 OID 22785)
-- Name: associer_objets_pkey; Type: CONSTRAINT; Schema: objets; Owner: -; Tablespace: 
--

ALTER TABLE ONLY association_objets
    ADD CONSTRAINT associer_objets_pkey PRIMARY KEY (pk_association_objets);


--
-- TOC entry 2260 (class 2606 OID 22826)
-- Name: date_objet_pkey; Type: CONSTRAINT; Schema: objets; Owner: -; Tablespace: 
--

ALTER TABLE ONLY date_objet
    ADD CONSTRAINT date_objet_pkey PRIMARY KEY (pk_date_objet);


--
-- TOC entry 2256 (class 2606 OID 22787)
-- Name: nom_objet_pkey; Type: CONSTRAINT; Schema: objets; Owner: -; Tablespace: 
--

ALTER TABLE ONLY nom_objet
    ADD CONSTRAINT nom_objet_pkey PRIMARY KEY (pk_nom_objet);


--
-- TOC entry 2258 (class 2606 OID 22789)
-- Name: objet_pkey; Type: CONSTRAINT; Schema: objets; Owner: -; Tablespace: 
--

ALTER TABLE ONLY objet
    ADD CONSTRAINT objet_pkey PRIMARY KEY (pk_objet);


--
-- TOC entry 2252 (class 1259 OID 22794)
-- Name: idx_fk_objet; Type: INDEX; Schema: objets; Owner: -; Tablespace: 
--

CREATE INDEX idx_fk_objet ON nom_objet USING btree (fk_objet);


--
-- TOC entry 2253 (class 1259 OID 22795)
-- Name: nom_objet_langue_idx; Type: INDEX; Schema: objets; Owner: -; Tablespace: 
--

CREATE INDEX nom_objet_langue_idx ON nom_objet USING btree (langue);


--
-- TOC entry 2254 (class 1259 OID 22796)
-- Name: nom_objet_nom_idx; Type: INDEX; Schema: objets; Owner: -; Tablespace: 
--

CREATE INDEX nom_objet_nom_idx ON nom_objet USING btree (nom);


--
-- TOC entry 2263 (class 2620 OID 22797)
-- Name: update_associer_objets_creatime; Type: TRIGGER; Schema: objets; Owner: -
--

CREATE TRIGGER update_associer_objets_creatime BEFORE INSERT ON association_objets FOR EACH ROW EXECUTE PROCEDURE update_created_column();


--
-- TOC entry 2264 (class 2620 OID 22798)
-- Name: update_associer_objets_updatime; Type: TRIGGER; Schema: objets; Owner: -
--

CREATE TRIGGER update_associer_objets_updatime BEFORE UPDATE ON association_objets FOR EACH ROW EXECUTE PROCEDURE update_updated_column();


--
-- TOC entry 2269 (class 2620 OID 22832)
-- Name: update_date_objet_creatime; Type: TRIGGER; Schema: objets; Owner: -
--

CREATE TRIGGER update_date_objet_creatime BEFORE INSERT ON date_objet FOR EACH ROW EXECUTE PROCEDURE update_created_column();


--
-- TOC entry 2270 (class 2620 OID 22833)
-- Name: update_date_objet_updatime; Type: TRIGGER; Schema: objets; Owner: -
--

CREATE TRIGGER update_date_objet_updatime BEFORE UPDATE ON date_objet FOR EACH ROW EXECUTE PROCEDURE update_updated_column();


--
-- TOC entry 2265 (class 2620 OID 22799)
-- Name: update_nom_objet_creatime; Type: TRIGGER; Schema: objets; Owner: -
--

CREATE TRIGGER update_nom_objet_creatime BEFORE INSERT ON nom_objet FOR EACH ROW EXECUTE PROCEDURE update_created_column();


--
-- TOC entry 2266 (class 2620 OID 22800)
-- Name: update_nom_objet_updatime; Type: TRIGGER; Schema: objets; Owner: -
--

CREATE TRIGGER update_nom_objet_updatime BEFORE UPDATE ON nom_objet FOR EACH ROW EXECUTE PROCEDURE update_updated_column();


--
-- TOC entry 2267 (class 2620 OID 22801)
-- Name: update_objet_creatime; Type: TRIGGER; Schema: objets; Owner: -
--

CREATE TRIGGER update_objet_creatime BEFORE INSERT ON objet FOR EACH ROW EXECUTE PROCEDURE update_created_column();


--
-- TOC entry 2268 (class 2620 OID 22802)
-- Name: update_objet_updatime; Type: TRIGGER; Schema: objets; Owner: -
--

CREATE TRIGGER update_objet_updatime BEFORE UPDATE ON objet FOR EACH ROW EXECUTE PROCEDURE update_updated_column();


--
-- TOC entry 2262 (class 2606 OID 22827)
-- Name: date_objet_fk_objet_fkey; Type: FK CONSTRAINT; Schema: objets; Owner: -
--

ALTER TABLE ONLY date_objet
    ADD CONSTRAINT date_objet_fk_objet_fkey FOREIGN KEY (fk_objet) REFERENCES objet(pk_objet) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- TOC entry 2261 (class 2606 OID 22808)
-- Name: nom_objet_fk_objet_fkey; Type: FK CONSTRAINT; Schema: objets; Owner: -
--

ALTER TABLE ONLY nom_objet
    ADD CONSTRAINT nom_objet_fk_objet_fkey FOREIGN KEY (fk_objet) REFERENCES objet(pk_objet) ON UPDATE CASCADE ON DELETE CASCADE;


-- Completed on 2015-12-01 08:47:02 CET

--
-- PostgreSQL database dump complete
--

